#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
static char compilerRevision[] = "653ff9a8a5366672bab39af399602aa02fe18768";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "collectionsPrelude";
Object module_StandardPrelude_init();
static char *originalSourceLines[] = {
  "#pragma NativePrelude",
  "",
  "def BoundsError = ProgrammingError.refine \"BoundsError\"",
  "def IteratorExhausted = ProgrammingError.refine \"IteratorExhausted\"",
  "def SubobjectResponsibility = ProgrammingError.refine \"SubobjectResponsibility\"",
  "def NoSuchObject = ProgrammingError.refine \"NoSuchObject\"",
  "def RequestError = ProgrammingError.refine \"RequestError\"",
  "def ConcurrentModification = ProgrammingError.refine \"ConcurrentModification\"",
  "def SizeUnknown = Exception.refine \"SizeUnknown\"",
  "",
  "method abstract is confidential {",
  "    // copied from StandardPrelude",
  "    SubobjectResponsibility.raise \"abstract method not overriden by subobject\"",
  "}",
  "",
  "type Block0<R> = type {",
  "    apply -> R",
  "}",
  "",
  "type Block1<T,R> = type {",
  "    apply(a:T) -> R",
  "}",
  "",
  "type Block2<S,T,R> = type {",
  "    apply(a:S, b:T) -> R",
  "}",
  "",
  "type SelfType = Unknown     // becuase it's not yet in the language",
  "",
  "type Iterable<T> = Object & type {",
  "    iterator -> Iterator<T>",
  "        // the iterator on which I am based",
  "    isEmpty -> Boolean",
  "        // true if I have no elements",
  "    size -> Number",
  "        // my size (the number of elements that I contain);",
  "        // may raise SizeUnknown.",
  "    sizeIfUnknown(action: Block0<Number>)",
  "        // my size; if not known, then the result of applying action",
  "    first -> T",
  "        // my first element; raises BoundsError if I have none.",
  "    do(block1: Block1<T, Done>) -> Done",
  "        // an internal iterator; applies block1 to each of my elements",
  "    do(body:Block1<T, Done>) separatedBy(separator:Block0<Done>) -> Done",
  "        // an internal iterator; ; applies block1 to each of my elements, and applies separator in between",
  "    ++(other: Iterable<T>) -> Iterable<T>",
  "        // returns a new Iterable over the concatenation of self and other",
  "    fold(binaryFunction:Block2<T, T, T>) startingWith(initial:T) -> Object",
  "        // the left-associative fold of binaryFunction over self, starting with initial",
  "    map<U>(function:Block1<T, U>) -> Iterable<U>",
  "        // returns a new iterator that yields my elements mapped by function",
  "    filter(condition:Block1<T,Boolean>) -> Iterable<T>",
  "        // returns a new iterator that yields those of my elements for which condition holds",
  "}",
  "",
  "type Expandable<T> = Iterable<T> & type {",
  "    add(x: T) -> SelfType",
  "    addAll(xs: Iterable<T>) -> SelfType",
  "}",
  "",
  "type Collection<T> = Iterable<T> & type {",
  "    asList -> List<T>",
  "    asSequence -> Sequence<T>",
  "    asSet -> Set<T>",
  "}",
  "",
  "type Enumerable<T> = Collection<T> & type {",
  "    values -> Collection<T>",
  "    asDictionary -> Dictionary<Number,T>",
  "    keysAndValuesDo(action:Block2<Number,T,Object>) -> Done",
  "    into(existing: Expandable<Unknown>) -> Collection<Unknown>",
  "    sortedBy(comparison:Block2<T,T,Number>) -> SelfType",
  "    sorted -> SelfType",
  "}",
  "",
  "type Sequence<T> = Enumerable<T> & type {",
  "    size -> Number",
  "    at(n:Number) -> T",
  "    indices -> Sequence<Number>",
  "    keys -> Sequence<Number>",
  "    second -> T",
  "    third -> T",
  "    fourth -> T",
  "    fifth -> T",
  "    last -> T",
  "    indexOf<W>(elem:T)ifAbsent(action:Block0<W>) -> Number | W",
  "    indexOf(elem:T) -> Number",
  "    contains(elem:T) -> Boolean",
  "    reversed -> Sequence<T>",
  "}",
  "",
  "type List<T> = Sequence<T> & type {",
  "    add(x: T) -> List<T>",
  "    addAll(xs: Iterable<T>) -> List<T>",
  "    addFirst(x: T) -> List<T>",
  "    addAllFirst(xs: Iterable<T>) -> List<T>",
  "    addLast(x: T) -> List<T>    // same as add",
  "    at(ix:Number) put(v:T) -> List<T>",
  "    removeFirst -> T",
  "    removeAt(n: Number) -> T",
  "    removeLast -> T",
  "    remove(v:T)",
  "    remove(v:T) ifAbsent(action:Block0<Done>)",
  "    removeAll(vs: Iterable<T>)",
  "    removeAll(vs: Iterable<T>) ifAbsent(action:Block0<Unknown>)",
  "    pop -> T",
  "    ++(o: List<T>) -> List<T>",
  "    addAll(l: Iterable<T>) -> List<T>",
  "    copy -> List<T>",
  "    sort -> List<T>",
  "    sortBy(sortBlock:Block2<T,T,Number>) -> List<T>",
  "    reverse -> List<T>",
  "    reversed -> List<T>",
  "}",
  "",
  "type Set<T> = Collection<T> & type {",
  "    size -> Number",
  "    add(x:T) -> SelfType",
  "    addAll(elements: Iterable<T>) -> SelfType",
  "    remove(x: T) -> Set<T>",
  "    remove(x: T) ifAbsent(block: Block0<Done>) -> Set<T>",
  "    includes(booleanBlock: Block1<T,Boolean>) -> Boolean",
  "    find(booleanBlock: Block1<T,Boolean>) ifNone(notFoundBlock: Block0<T>) -> T",
  "    copy -> Set<T>",
  "    contains(elem:T) -> Boolean",
  "    ** (other:Set<T>) -> Set<T>",
  "    -- (other:Set<T>) -> Set<T>",
  "    ++ (other:Set<T>) -> Set<T>",
  "    isSubset(s2: Set<T>) -> Boolean",
  "    isSuperset(s2: Iterable<T>) -> Boolean",
  "    removeAll(elems: Iterable<T>)",
  "    removeAll(elems: Iterable<T>)ifAbsent(action:Block0<Done>) -> Set<T>",
  "    into(existing: Expandable<Unknown>) -> Collection<Unknown>",
  "}",
  "",
  "type Dictionary<K,T> = Collection<T> & type {",
  "    size -> Number",
  "    containsKey(k:K) -> Boolean",
  "    containsValue(v:T) -> Boolean",
  "    contains(elem:T) -> Boolean",
  "    at(key:K)ifAbsent(action:Block0<Unknown>) -> Unknown",
  "    at(key:K)put(value:T) -> Dictionary<K,T>",
  "    at(k:K) -> T",
  "    removeAllKeys(keys: Iterable<K>) -> Dictionary<K,T>",
  "    removeKey(key:K) -> Dictionary<K,T>",
  "    removeAllValues(removals: Iterable<T>) -> Dictionary<K,T>",
  "    removeValue(v:T) -> Dictionary<K,T>",
  "    keys -> Enumerable<K>",
  "    values -> Enumerable<T>",
  "    bindings -> Enumerable<Binding<K,T>>",
  "    keysAndValuesDo(action:Block2<K,T,Done>) -> Done",
  "    keysDo(action:Block1<K,Done>) -> Done",
  "    valuesDo(action:Block1<T,Done>) -> Done",
  "    == (other:Object) -> Boolean",
  "    copy -> Dictionary<K,T>",
  "    ++ (other:Dictionary<K, T>) -> Dictionary<K, T>",
  "    -- (other:Dictionary<K, T>) -> Dictionary<K, T>",
  "    asDictionary -> Dictionary<K, T>",
  "}",
  "",
  "type Iterator<T> = type {",
  "    hasNext -> Boolean",
  "    next -> T",
  "}",
  "",
  "class lazySequenceOver<T,R> (source: Iterable<T>)",
  "        mappedBy (function:Block1<T,R>) -> Enumerable<R> is confidential {",
  "    inherits enumerable.TRAIT<T>",
  "    class iterator {",
  "        def sourceIterator = source.iterator",
  "        method asString { \"an iterator over a lazy map sequence\" }",
  "        method hasNext { sourceIterator.hasNext }",
  "        method next { function.apply(sourceIterator.next) }",
  "    }",
  "    method size { source.size }",
  "    method isEmpty { source.isEmpty }",
  "    method asDebugString { \"a lazy sequence mapping over {source}\" }",
  "}",
  "",
  "class lazySequenceOver<T> (source: Iterable<T>)",
  "        filteredBy(predicate:Block1<T,Boolean>) -> Enumerable<T> is confidential {",
  "    inherits enumerable.TRAIT<T>",
  "    class iterator {",
  "        var cache",
  "        var cacheLoaded := false",
  "        def sourceIterator = source.iterator",
  "        method asString { \"an iterator over filtered {source}\" }",
  "        method hasNext {",
  "        // To determine if this iterator has a next element, we have to find",
  "        // an acceptable element; this is then cached, for the use of next",
  "            if (cacheLoaded) then { return true }",
  "            try {",
  "                cache := nextAcceptableElement",
  "                cacheLoaded := true",
  "            } catch { ex:IteratorExhausted -> return false }",
  "            return true",
  "        }",
  "        method next {",
  "            if (cacheLoaded.not) then { cache := nextAcceptableElement }",
  "            cacheLoaded := false",
  "            return cache",
  "        }",
  "        method nextAcceptableElement is confidential {",
  "        // return the next element of the underlying iterator satisfying",
  "        // predicate; if there is none, raises IteratorExhausted.",
  "            while { true } do {",
  "                def outerNext = sourceIterator.next",
  "                def acceptable = predicate.apply(outerNext)",
  "                if (acceptable) then { return outerNext }",
  "            }",
  "        }",
  "    }",
  "    method asDebugString { \"a lazy sequence filtering {source}\" }",
  "}",
  "",
  "class iteratorConcat<T>(left:Iterator<T>, right:Iterator<T>) {",
  "    method next {",
  "        if (left.hasNext) then {",
  "            left.next",
  "        } else {",
  "            right.next",
  "        }",
  "    }",
  "    method hasNext {",
  "        if (left.hasNext) then { return true }",
  "        return right.hasNext",
  "    }",
  "    method asDebugString { \"iteratorConcat of {left} and {right}\" }",
  "    method asString { \"an iterator over a concatenation\" }",
  "}",
  "class lazyConcatenation<T>(left, right) -> Enumerable<T>{",
  "    inherits enumerable.TRAIT<T>",
  "    method iterator {",
  "        iteratorConcat(left.iterator, right.iterator)",
  "    }",
  "    method asDebugString { \"lazy concatenation of {left} and {right}\" }",
  "    method asString { super.asString }",
  "    method size { left.size + right.size }  // may raise SizeUnknown",
  "}",
  "",
  "class collection.TRAIT<T> {",
  "    ",
  "    method asString { \"a collection TRAIT\" }",
  "    method sizeIfUnknown(action) {",
  "        action.apply",
  "    }",
  "    method size {",
  "        SizeUnknown.raise \"this collection does not know its size\"",
  "    }",
  "    method do { abstract }",
  "    method iterator { abstract }",
  "    method isEmpty {",
  "        // override if size is known",
  "        iterator.hasNext.not",
  "    }",
  "    method first {",
  "        def it = self.iterator",
  "        if (it.hasNext) then { ",
  "            it.next",
  "        } else {",
  "            BoundsError.raise \"no first element in {self}\"",
  "        }",
  "    }",
  "    method do(block1) separatedBy(block0) {",
  "        var firstTime := true",
  "        var i := 0",
  "        self.do { each ->",
  "            if (firstTime) then {",
  "                firstTime := false",
  "            } else {",
  "                block0.apply",
  "            }",
  "            block1.apply(each)",
  "        }",
  "        return self",
  "    }",
  "    method reduce(initial, blk) {",
  "    // deprecated; for compatibility with builtInList",
  "        fold(blk)startingWith(initial)",
  "    }",
  "    method fold(blk)startingWith(initial) {",
  "        var result := initial",
  "        self.do {it ->",
  "            result := blk.apply(result, it)",
  "        }",
  "        return result",
  "    }",
  "    method map<R>(block1:Block1<T,R>) -> Enumerable<R> {",
  "        lazySequenceOver(self) mappedBy(block1)",
  "    }",
  "    method filter(selectionCondition:Block1<T,Boolean>) -> Enumerable<T> {",
  "        lazySequenceOver(self) filteredBy(selectionCondition)",
  "    }",
  "",
  "    method iter { self.iterator }",
  "",
  "    method asSequence {",
  "        sequence.withAll(self)",
  "    }",
  "    method asList {",
  "        list.withAll(self)",
  "    }",
  "    method asSet {",
  "        set.withAll(self)",
  "    }",
  "}",
  "",
  "class enumerable.TRAIT<T> {",
  "    inherits collection.TRAIT<T>",
  "    method iterator { abstract }",
  "    method size {",
  "        // override if size is known",
  "        SizeUnknown.raise \"size requested on {asDebugString}\"",
  "    }",
  "    method asDictionary {",
  "        def result = dictionary.empty",
  "        keysAndValuesDo { k, v ->",
  "            result.at(k) put(v)",
  "        }",
  "        return result",
  "    }",
  "    method into(existing: Expandable<T>) -> Collection<T> {",
  "        def selfIterator = self.iterator",
  "        while {selfIterator.hasNext} do {",
  "            existing.add(selfIterator.next)",
  "        }",
  "        existing",
  "    }",
  "    method ==(other) {",
  "        isEqual (self) toIterable (other)",
  "    }",
  "    method do(block1:Block1<T,Done>) -> Done {",
  "        def selfIterator = self.iterator",
  "        while {selfIterator.hasNext} do {",
  "            block1.apply(selfIterator.next)",
  "        }",
  "    }",
  "    method keysAndValuesDo(block2:Block2<Number,T,Done>) -> Done {",
  "        var ix := 0",
  "        def selfIterator = self.iterator",
  "        while {selfIterator.hasNext} do {",
  "            ix := ix + 1",
  "            block2.apply(ix, selfIterator.next)",
  "        }",
  "    }",
  "    method values -> Collection<T> {",
  "        self",
  "    }",
  "    method fold<R>(block2)startingWith(initial) -> R {",
  "        var res := initial",
  "        def selfIterator = self.iterator",
  "        while { selfIterator.hasNext } do {",
  "            res := block2.apply(res, selfIterator.next)",
  "        }",
  "        return res",
  "    }",
  "    method ++ (other) -> Enumerable<T> {",
  "        lazyConcatenation(self, other)",
  "    }",
  "    method sortedBy(sortBlock:Block2) -> List<T> {",
  "        self.asList.sortBy(sortBlock:Block2)",
  "    }",
  "    method sorted -> List<T> {",
  "        self.asList.sort",
  "    }",
  "    method asString {",
  "        var s := \"⟨\"",
  "        do { each -> s := s ++ each.asString } separatedBy { s := s ++ \", \" }",
  "        s ++ \"⟩\"",
  "    }",
  "}",
  "",
  "class indexable.TRAIT<T> {",
  "    inherits collection.TRAIT<T>",
  "    method at { abstract }",
  "    method size { abstract }",
  "    method isEmpty { size == 0 }",
  "    method keysAndValuesDo(action:Block2<Number,T,Done>) -> Done {",
  "        def curSize = size",
  "        var i := 1",
  "        while {i <= curSize} do {",
  "            action.apply(i, self.at(i))",
  "            i := i + 1",
  "        }",
  "    }",
  "    method first { at(1) }",
  "    method second { at(2) }",
  "    method third { at(3) }",
  "    method fourth { at(4) }",
  "    method fifth { at(5) }",
  "    method last { at(size) }",
  "    method indices { range.from 1 to(size) }",
  "    method indexOf(sought:T)  {",
  "        indexOf(sought) ifAbsent { NoSuchObject.raise \"collection does not contain {sought}\" }",
  "    }",
  "    method indexOf(sought:T) ifAbsent(action:Block0)  {",
  "        keysAndValuesDo { ix, v ->",
  "            if (v == sought) then { return ix }",
  "        }",
  "        action.apply",
  "    }",
  "    method asDictionary {",
  "        def result = dictionary.empty",
  "        keysAndValuesDo { k, v ->",
  "            result.at(k) put(v)",
  "        }",
  "        return result",
  "    }",
  "    method into(existing: Expandable<T>) -> Collection<T> {",
  "        def selfIterator = self.iterator",
  "        while {selfIterator.hasNext} do {",
  "            existing.add(selfIterator.next)",
  "        }",
  "        existing",
  "    }",
  "}",
  "",
  "method max(a,b) is confidential {       // copied from standard prelude",
  "    if (a > b) then { a } else { b }",
  "}",
  "",
  "def emptySequence is confidential = object {",
  "    inherits indexable.TRAIT",
  "    method size { 0 }",
  "    method isEmpty { true }",
  "    method at(n) { BoundsError.raise \"index {n} of empty sequence\" }",
  "    method keys { self }",
  "    method values { self }",
  "    method keysAndValuesDo(block2) { done }",
  "    method reversed { self }",
  "    method ++(other: Iterable) { sequence.withAll(other) }",
  "    method asString { \"⟨⟩\" }",
  "    method contains(element) { false }",
  "    method do(block1) { done }",
  "    method ==(other) {",
  "        match (other)",
  "            case {o: Iterable ->",
  "                o.isEmpty",
  "            }",
  "            case {_ ->",
  "                false",
  "            }",
  "    }",
  "    class iterator {",
  "        method asString { \"emptySequenceIterator\" }",
  "        method hasNext { false }",
  "        method next { IteratorExhausted.raise \"on empty sequence\" }",
  "    }",
  "    method sorted { self }",
  "    method sortedBy(sortBlock:Block2){ self }",
  "}",
  "",
  "class sequence<T> {",
  "",
  "    method asString { \"a sequence factory\" }",
  "",
  "    method empty {",
  "        // this is an optimization: there need be just one empty sequence",
  "        emptySequence",
  "    }",
  "",
  "    method withAll(arg: Iterable<T>) {",
  "        var sizeCertain := true",
  "        // size might be uncertain if arg is a lazy collection.",
  "        def forecastSize = arg.sizeIfUnknown {",
  "            sizeCertain := false",
  "            8",
  "        }",
  "        var inner := _prelude.primitiveArray.new(forecastSize)",
  "        var innerSize := inner.size",
  "        var ix := 0",
  "        if (sizeCertain) then {",
  "            // common, fast path",
  "            for (arg) do { elt ->",
  "                inner.at(ix)put(elt)",
  "                ix := ix + 1",
  "            }",
  "        } else {",
  "            // less-than-optimal path",
  "            for (arg) do { elt ->",
  "                if (innerSize <= ix) then {",
  "                    def newInner = _prelude.primitiveArray.new(innerSize * 2)",
  "                    for (0..(innerSize-1)) do { i ->",
  "                        newInner.at(i)put(inner.at(i))",
  "                    }",
  "                    inner := newInner",
  "                    innerSize := inner.size",
  "                }",
  "                inner.at(ix)put(elt)",
  "                ix := ix + 1",
  "            }",
  "        }",
  "        if (ix == 0) then { return emptySequence }",
  "        self.fromprimitiveArray(inner, ix)",
  "    }",
  "    method fromprimitiveArray(pArray, sz) is confidential {",
  "        // constructs a sequence from the first sz elements of pArray",
  "",
  "        object {",
  "            inherits indexable.TRAIT",
  "            def size is public = sz",
  "            def inner = pArray",
  "",
  "            method boundsCheck(n) is confidential {",
  "                if (!(n >= 1) || !(n <= size)) then {",
  "                    // the condition is written this way because NaN always",
  "                    // compares false",
  "                    BoundsError.raise \"index {n} out of bounds 1..{size}\"",
  "                }",
  "            }",
  "            method at(n) {",
  "                boundsCheck(n)",
  "                inner.at(n-1)",
  "            }",
  "            method keys {",
  "                range.from(1)to(size)",
  "            }",
  "            method values {",
  "                self",
  "            }",
  "            method keysAndValuesDo(block2) {",
  "                var i := 0",
  "                while {i < size} do {",
  "                    block2.apply(i+1, inner.at(i))",
  "                    i := i + 1",
  "                }",
  "            }",
  "            method reversed {",
  "                def freshArray = _prelude.primitiveArray.new(size)",
  "                var ix := size - 1",
  "                do { each ->",
  "                    freshArray.at (ix) put(each)",
  "                    ix := ix - 1",
  "                }",
  "                outer.fromprimitiveArray(freshArray, size)",
  "            }",
  "            method ++(other: Iterable) {",
  "                sequence.withAll(lazyConcatenation(self, other))",
  "            }",
  "            method asString {",
  "                var s := \"⟨\"",
  "                for (0..(size-1)) do {i->",
  "                    s := s ++ inner.at(i).asString",
  "                    if (i < (size-1)) then { s := s ++ \", \" }",
  "                }",
  "                s ++ \"⟩\"",
  "            }",
  "            method contains(element) {",
  "                do { each -> if (each == element) then { return true } }",
  "                return false",
  "            }",
  "            method do(block1) {",
  "                var i := 0",
  "                while {i < size} do {",
  "                    block1.apply(inner.at(i))",
  "                    i := i + 1",
  "                }",
  "            }",
  "            method ==(other) {",
  "                isEqual (self) toIterable (other)",
  "            }",
  "            method iterator {",
  "                object {",
  "                    var idx := 1",
  "                    method asDebugString { \"{asString}⟪{idx}⟫\" }",
  "                    method asString { \"aSequenceIterator\" }",
  "                    method hasNext { idx <= sz }",
  "                    method next {",
  "                        if (idx > sz) then { IteratorExhausted.raise \"on sequence {outer}⟪{idx}⟫\" }",
  "                        def ret = at(idx)",
  "                        idx := idx + 1",
  "                        ret",
  "                    }",
  "                }",
  "            }",
  "            method sorted {",
  "                asList.sortBy { l, r ->",
  "                    if (l == r) then {0}",
  "                        elseif {l < r} then {-1}",
  "                        else {1}",
  "                }.asSequence",
  "            }",
  "            method sortedBy(sortBlock:Block2){",
  "                asList.sortBy(sortBlock:Block2).asSequence",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "type MinimalyIterable = type {",
  "    iterator -> Iterator",
  "}",
  "",
  "method isEqual(left) toIterable(right) {",
  "    if (MinimalyIterable.match(right)) then {",
  "        def leftIter = left.iterator",
  "        def rightIter = right.iterator",
  "        while {leftIter.hasNext && rightIter.hasNext} do {",
  "            if (leftIter.next != rightIter.next) then {",
  "                return false",
  "            }",
  "        }",
  "        leftIter.hasNext == rightIter.hasNext",
  "    } else { ",
  "        false",
  "    }",
  "}",
  "",
  "class list<T> {",
  "    ",
  "    method asString { \"a list factory\" }",
  "    ",
  "    method empty -> List<T> {",
  "        withAll(emptySequence)",
  "    }",
  "",
  "    method withAll(a: Iterable<T>) -> List<T> {",
  "        if (engine == \"js\") then {",
  "          if (native \"js\" code ‹var result = (this === superDepth) ? GraceTrue : GraceFalse›) then {",
  "            return object {",
  "                inherits indexable.TRAIT<T>",
  "",
  "                var mods is readable := 0",
  "                var sz := 0",
  "                var jsArray := native \"js\" code ‹var result = [];›",
  "                a.do { each ->",
  "                    native \"js\" code ‹superDepth.data.jsArray.push(var_each);›",
  "                }",
  "",
  "                method size {",
  "                    native \"js\" code ‹return new GraceNum(superDepth.data.jsArray.length)›",
  "                    sz",
  "                }",
  "",
  "                method at(n) {",
  "                    native \"js\" code ‹var ix = var_n._value;",
  "                        if ( !(ix >= 1) || !(ix <= superDepth.data.jsArray.length)) {",
  "                            var msg = \"index \" + ix + \" out of bounds 1..\" + superDepth.data.jsArray.length;",
  "                            var BoundsError = callmethod(Grace_prelude, \"BoundsError\", [0]);",
  "                            callmethod(BoundsError, \"raise\", [1], new GraceString(msg));",
  "                        }",
  "                        return superDepth.data.jsArray[ix - 1];›",
  "                }",
  "",
  "                method at(n)put(x) {",
  "                    mods := mods + 1",
  "                    native \"js\" code ‹var  ix = var_n._value;",
  "                        if (!(ix >= 1) || !(ix <= superDepth.data.jsArray.length + 1)) {",
  "                            var msg = \"index \" + ix + \" out of bounds 1..\" + superDepth.data.jsArray.length;",
  "                            var BoundsError = callmethod(Grace_prelude, \"BoundsError\", [0]);",
  "                            callmethod(BoundsError, \"raise\", [1], new GraceString(msg));",
  "                        }",
  "                        superDepth.data.jsArray[ix-1] = var_x;",
  "                        return this;›",
  "                }",
  "",
  "                method add(x:T) {",
  "                    mods := mods + 1",
  "                    native \"js\" code ‹superDepth.data.jsArray.push(var_x);",
  "                        return this;›",
  "                }",
  "",
  "                method push(x) {",
  "                    mods := mods + 1",
  "                    native \"js\" code ‹superDepth.data.jsArray.push(var_x);",
  "                        return this;›",
  "                }",
  "",
  "                method removeLast {",
  "                    mods := mods + 1",
  "                    native \"js\" code ‹if (superDepth.data.jsArray.length === 0) {",
  "                        var msg = \"you can't remove an element from an empty list\";",
  "                        var BoundsError = callmethod(Grace_prelude, \"BoundsError\", [0]);",
  "                        callmethod(BoundsError, \"raise\", [1], new GraceString(msg));",
  "                    } else",
  "                        return superDepth.data.jsArray.pop();›",
  "                }",
  "",
  "                method addAllFirst(l) {",
  "                    mods := mods + 1",
  "                    var ix := l.size;",
  "                    while {ix > 0} do {",
  "                        def each = l.at(ix)",
  "                        ix := ix - 1",
  "                        native \"js\" code ‹superDepth.data.jsArray.unshift(var_each);›",
  "                    }",
  "                    self",
  "                }",
  "",
  "                method removeAt(n) {",
  "                    mods := mods + 1",
  "                    def removed = self.at(n)    // does the bounds check",
  "                    native \"js\" code ‹superDepth.data.jsArray.splice(var_n._value - 1, 1);›",
  "                    return removed",
  "                }",
  "",
  "                method sortBy(sortBlock:Block2) {",
  "                    mods := mods + 1",
  "                    native \"js\" code ‹var compareFun = function compareFun(a, b) {",
  "                              var res = callmethod(var_sortBlock, \"apply\", [2], a, b);",
  "                              if (res.className == \"number\") return res._value;",
  "                              throw new GraceExceptionPacket(TypeErrorObject,",
  "                                     new GraceString(\"sort block in list.sortBy method did not return a number\"));",
  "                          }",
  "                          superDepth.data.jsArray.sort(compareFun);›",
  "                    self",
  "                }",
  "                // end of native methods",
  "",
  "",
  "                method addLast(x) { push(x) }    // compatibility",
  "                method addAll(l) {",
  "                    for (l) do { each -> push(each) }",
  "                    self",
  "                }",
  "",
  "                method addFirst(elem) {",
  "                    mods := mods + 1",
  "                    native \"js\" code ‹superDepth.data.jsArray.unshift(var_elem);›",
  "                    self",
  "                }                ",
  "",
  "                method removeFirst {",
  "                    removeAt(1)",
  "                }",
  "",
  "",
  "                method remove(elt:T) {",
  "                    def ix = self.indexOf(elt) ifAbsent {",
  "                        NoSuchObject.raise \"list does not contain object {elt}\"",
  "                    }",
  "                    removeAt(ix)",
  "                    self",
  "                }",
  "",
  "",
  "                method remove(elt:T) ifAbsent(action:Block0<Done>) {",
  "                    def ix = self.indexOf(elt) ifAbsent {",
  "                        return action.apply",
  "                    }",
  "                    removeAt(ix)",
  "                    self",
  "                }",
  "",
  "                method removeAll(vs: Iterable<T>) {",
  "                    removeAll(vs) ifAbsent { NoSuchObject.raise \"list does not contain object\" }",
  "                }",
  "",
  "",
  "                method removeAll(vs: Iterable<T>) ifAbsent(action:Block0<Unknown>)  {",
  "                    for (vs) do { each ->",
  "                        def ix = self.indexOf(each) ifAbsent { 0 }",
  "                        if (ix ≠ 0) then {",
  "                            removeAt(ix)",
  "                        } else {",
  "                            action.apply",
  "                        }",
  "                    }",
  "                    self",
  "                }",
  "",
  "                method pop { removeLast }",
  "",
  "                method reversed {",
  "                    def result = list.empty",
  "                    do { each -> result.addFirst(each) }",
  "                    result",
  "                }",
  "                method reverse {",
  "                    mods := mods + 1",
  "                    var hiIx := size",
  "                    var loIx := 1",
  "                    while {loIx < hiIx} do {",
  "                        def hiVal = self.at(hiIx)",
  "                        self.at(hiIx) put (self.at(loIx))",
  "                        self.at(loIx) put (hiVal)",
  "                        hiIx := hiIx - 1",
  "                        loIx := loIx + 1",
  "                    }",
  "                    self",
  "                }",
  "",
  "                method ++(o) {",
  "                    def l = list.withAll(self)",
  "                    l.addAll(o)",
  "                }",
  "",
  "",
  "                method asString {",
  "                    var s := \"[\"",
  "                    def curSize = self.size",
  "                    for (1..curSize) do { i ->",
  "                        s := s ++ at(i).asString",
  "                        if (i < curSize) then { s := s ++ \", \" }",
  "                    }",
  "                    s ++ \"]\"",
  "                }",
  "",
  "                method asDebugString {",
  "                    var s := \"[\"",
  "                    def curSize = self.size",
  "                    for (1..curSize) do { i ->",
  "                        s := s ++ at(i).asDebugString",
  "                        if (i < curSize) then { s := s ++ \", \" }",
  "                    }",
  "                    s ++ \"]\"",
  "                }",
  "",
  "                method extend(l) { addAll(l); done }    // compatibility",
  "",
  "",
  "                method contains(element) {",
  "                    do { each -> if (each == element) then { return true } }",
  "                    return false",
  "                }",
  "",
  "                method do(block1) {",
  "                    var i := 1",
  "                    def curSize = self.size",
  "                    while {i <= curSize} do {",
  "                        block1.apply(self.at(i))",
  "                        i := i + 1",
  "                    }",
  "                }",
  "",
  "                method ==(other) {",
  "                    isEqual (self) toIterable (other)",
  "                }",
  "",
  "                method iterator {",
  "                    object {",
  "                        var imods := mods",
  "                        var idx := 1",
  "                        method asDebugString { \"{asString}⟪{idx}⟫\" }",
  "                        method asString { \"aListIterator\" }",
  "                        method hasNext { idx <= size }",
  "                        method next {",
  "                            if (imods != mods) then {",
  "                                ConcurrentModification.raise (asDebugString)",
  "                            }",
  "                            if (idx > size) then { IteratorExhausted.raise \"on list\" }",
  "                            def ret = at(idx)",
  "                            idx := idx + 1",
  "                            ret",
  "                        }",
  "                    }",
  "                }",
  "",
  "                method values {",
  "                    self",
  "                }",
  "",
  "                method keys {",
  "                    self.indices",
  "                }",
  "",
  "                method sort {",
  "                    mods := mods + 1",
  "                    sortBy { l, r ->",
  "                        if (l == r) then {0}",
  "                            elseif {l < r} then {-1}",
  "                            else {1}",
  "                    }",
  "                }",
  "                method sortedBy(sortBlock:Block2) {",
  "                    copy.sortBy(sortBlock:Block2)",
  "                }",
  "                method sorted {",
  "                    copy.sort",
  "                }",
  "                method copy {",
  "                    outer.withAll(self)",
  "                }",
  "            }",
  "          }",
  "        }   // end of if (engine == \"js\") then ...",
  "",
  "        object {",
  "            // the new list object without native code",
  "            inherits indexable.TRAIT<T>",
  "",
  "            var mods is readable := 0",
  "            var sizeCertain := true",
  "            // size might be uncertain if a is a lazy collection.",
  "            def initialSize = a.sizeIfUnknown{ sizeCertain := false ; 4 } * 2 + 1",
  "            var inner := _prelude.primitiveArray.new(initialSize)",
  "            var size is readable := 0",
  "            if (sizeCertain) then {",
  "                // common, fast path",
  "                for (a) do { x ->",
  "                    inner.at(size)put(x)",
  "                    size := size + 1",
  "                }",
  "            } else {",
  "                // less-than-optimal path",
  "                var innerSize := initialSize",
  "                for (a) do { x ->",
  "                    if (innerSize <= size) then {",
  "                        def newInner = _prelude.primitiveArray.new(innerSize * 2)",
  "                        for (0..(innerSize-1)) do { i ->",
  "                            newInner.at (i) put (inner.at(i) )",
  "                        }",
  "                        inner := newInner",
  "                        innerSize := inner.size",
  "                    }",
  "                    inner.at(size)put(x)",
  "                    size := size + 1",
  "                }",
  "            }",
  "            method boundsCheck(n) is confidential {",
  "                if ( !(n >= 1) || !(n <= size)) then {",
  "                    BoundsError.raise \"index {n} out of bounds 1..{size}\"",
  "                }",
  "            }",
  "            method at(n) {",
  "                boundsCheck(n)",
  "                inner.at(n-1)",
  "            }",
  "            method at(n)put(x) {",
  "                mods := mods + 1",
  "                if (n == (size+1)) then {",
  "                    addLast(x)",
  "                } else {",
  "                    boundsCheck(n)",
  "                    inner.at(n-1)put(x)",
  "                }",
  "                self",
  "            }",
  "            method add(x) {",
  "                mods := mods + 1",
  "                if (size == inner.size) then { expandTo(inner.size * 2) }",
  "                inner.at(size)put(x)",
  "                size := size + 1",
  "                self",
  "            }",
  "            method addAll(l) {",
  "                mods := mods + 1",
  "                if ((size + l.size) > inner.size) then {",
  "                    expandTo(max(size + l.size, size * 2))",
  "                }",
  "                for (l) do {each ->",
  "                    inner.at(size)put(each)",
  "                    size := size + 1",
  "                }",
  "                self",
  "            }",
  "            method push(x) {",
  "                mods := mods + 1",
  "                if (size == inner.size) then { expandTo(inner.size * 2) }",
  "                inner.at(size)put(x)",
  "                size := size + 1",
  "                self",
  "            }",
  "            method addLast(x) { push(x) }    // compatibility",
  "            method removeLast {",
  "                mods := mods + 1",
  "                def result = inner.at(size - 1)",
  "                size := size - 1",
  "                result",
  "            }",
  "            method addAllFirst(l) {",
  "                mods := mods + 1",
  "                def increase = l.size",
  "                if ((size + increase) > inner.size) then {",
  "                    expandTo(max(size + increase, size * 2))",
  "                }",
  "                for (range.from(size-1)downTo(0)) do {i->",
  "                    inner.at(i+increase)put(inner.at(i))",
  "                }",
  "                var insertionIndex := 0",
  "                for (l) do {each ->",
  "                    inner.at(insertionIndex)put(each)",
  "                    insertionIndex := insertionIndex + 1",
  "                }",
  "                size := size + increase",
  "                self",
  "            }",
  "            method addFirst(elt:T) {",
  "                mods := mods + 1",
  "                if ((size + 1) > inner.size) then {",
  "                    expandTo(size * 2)",
  "                }",
  "                for (range.from (size-1) downTo 0) do {i->",
  "                    inner.at (i+1) put (inner.at(i) )",
  "                }",
  "                inner.at(0)put(elt)",
  "                size := size + 1",
  "                self",
  "            }",
  "            method removeFirst {",
  "                removeAt(1)",
  "            }",
  "            method removeAt(n) {",
  "                mods := mods + 1",
  "                boundsCheck(n)",
  "                def removed = inner.at(n-1)",
  "                for (n..(size-1)) do {i->",
  "                    inner.at(i-1)put(inner.at(i))",
  "                }",
  "                size := size - 1",
  "                return removed",
  "            }",
  "",
  "            method remove(elt:T) {",
  "                def ix = self.indexOf(elt) ifAbsent {",
  "                    NoSuchObject.raise \"list does not contain {elt}\"",
  "                }",
  "                removeAt(ix)",
  "                self",
  "            }",
  "",
  "            method remove(elt:T) ifAbsent(action:Block0<Done>) {",
  "                def ix = self.indexOf(elt) ifAbsent {",
  "                    action.apply",
  "                    return self",
  "                }",
  "                removeAt(ix)",
  "                self",
  "            }",
  "",
  "            method removeAll(vs: Iterable<T>) {",
  "                removeAll(vs) ifAbsent { NoSuchObject.raise \"list does not contain object\" }",
  "                self",
  "            }",
  "            method removeAll(vs: Iterable<T>) ifAbsent(action:Block0<Done>)  {",
  "                for (vs) do { each ->",
  "                    def ix = indexOf(each) ifAbsent { 0 }",
  "                    if (ix ≠ 0) then {",
  "                        removeAt(ix)",
  "                    } else {",
  "                        action.apply",
  "                    }",
  "                }",
  "                self",
  "            }",
  "            method pop { removeLast }",
  "            method reversed {",
  "                def result = list.empty",
  "                do { each -> result.addFirst(each) }",
  "                result",
  "            }",
  "            method reverse {",
  "                mods := mods + 1",
  "                var hiIx := size",
  "                var loIx := 1",
  "                while {loIx < hiIx} do {",
  "                    def hiVal = self.at(hiIx)",
  "                    self.at(hiIx) put (self.at(loIx))",
  "                    self.at(loIx) put (hiVal)",
  "                    hiIx := hiIx - 1",
  "                    loIx := loIx + 1",
  "                }",
  "                self",
  "            }",
  "            method ++(o) {",
  "                def l = list.withAll(self)",
  "                l.addAll(o)",
  "            }",
  "            method asString {",
  "                var s := \"[\"",
  "                for (0..(size-1)) do {i->",
  "                    s := s ++ inner.at(i).asString",
  "                    if (i < (size-1)) then { s := s ++ \", \" }",
  "                }",
  "                s ++ \"]\"",
  "            }",
  "            method asDebugString {",
  "                var s := \"[\"",
  "                for (0..(size-1)) do {i->",
  "                    s := s ++ inner.at(i).asDebugString",
  "                    if (i < (size-1)) then { s := s ++ \", \" }",
  "                }",
  "                s ++ \"]\"",
  "            }",
  "            method contains(element) {",
  "                do { each -> if (each == element) then { return true } }",
  "                return false",
  "            }",
  "            method do(block1) {",
  "                var i := 0",
  "                while {i < size} do {",
  "                    block1.apply(inner.at(i))",
  "                    i := i + 1",
  "                }",
  "            }",
  "",
  "            method ==(other) {",
  "                isEqual (self) toIterable (other)",
  "            }",
  "            method iterator {",
  "                object {",
  "                    var imods := mods",
  "                    var idx := 1",
  "                    method asDebugString { \"{asString}⟪{idx}⟫\" }",
  "                    method asString { \"aListIterator\" }",
  "                    method hasNext { idx <= size }",
  "                    method next {",
  "                        if (imods != mods) then {",
  "                            ConcurrentModification.raise (asDebugString)",
  "                        }",
  "                        if (idx > size) then { IteratorExhausted.raise \"on list\" }",
  "                        def ret = at(idx)",
  "                        idx := idx + 1",
  "                        ret",
  "                    }",
  "                }",
  "            }",
  "            method values {",
  "                self",
  "            }",
  "            method keys {",
  "                self.indices",
  "            }",
  "            method expandTo(newSize) is confidential {",
  "                def newInner = _prelude.primitiveArray.new(newSize)",
  "                for (0..(size-1)) do {i->",
  "                    newInner.at(i)put(inner.at(i))",
  "                }",
  "                inner := newInner",
  "            }",
  "            method sortBy(sortBlock:Block2) {",
  "                mods := mods + 1",
  "                inner.sortInitial(size) by(sortBlock)",
  "                self",
  "            }",
  "            method sort {",
  "                sortBy { l, r ->",
  "                    if (l == r) then {0}",
  "                        elseif {l < r} then {-1}",
  "                        else {1}",
  "                }",
  "            }",
  "            method sortedBy(sortBlock:Block2) {",
  "                copy.sortBy(sortBlock:Block2)",
  "            }",
  "            method sorted {",
  "                copy.sort",
  "            }",
  "            method copy {",
  "                outer.withAll(self)",
  "            }",
  "        }",
  "    }",
  "}",
  "",
  "",
  "def unused = object {",
  "    var unused := true",
  "    def key is public = self",
  "    def value is public = self",
  "    method asString { \"unused\" }",
  "    method == (other) { self.isMe(other) }",
  "}",
  "",
  "def removed = object {",
  "    var removed := true",
  "    def key is public = self",
  "    def value is public = self",
  "    method asString { \"removed\" }",
  "    method == (other) { self.isMe(other) }",
  "}",
  "",
  "class set<T> {",
  "",
  "    method asString { \"a set factory\" }",
  "",
  "    method withAll(a: Iterable<T>) -> Set<T> {",
  "        def cap = max (a.sizeIfUnknown{2} * 3 + 1, 8)",
  "        def result = ofCapacity (cap)",
  "        a.do { x -> result.add(x) }",
  "        result",
  "    }",
  "    ",
  "    method empty -> Set<T> {",
  "        ofCapacity 8",
  "    }",
  "",
  "    class ofCapacity(cap) -> Set<T> is confidential {",
  "        inherits collection.TRAIT",
  "        var mods is readable := 0",
  "        var inner := _prelude.primitiveArray.new(cap)",
  "        var size is readable := 0",
  "        (0..(cap - 1)).do { i ->",
  "            inner.at (i) put (unused)",
  "        }",
  "",
  "        method addAll(elements) {",
  "            mods := mods + 1",
  "            for (elements) do { x ->",
  "                if (! contains(x)) then {",
  "                    def t = findPositionForAdd(x)",
  "                    inner.at(t)put(x)",
  "                    size := size + 1",
  "                    if (size > (inner.size / 2)) then {",
  "                        expand",
  "                    }",
  "                }",
  "            }",
  "            self    // for chaining",
  "        }",
  "",
  "        method add(x:T) {",
  "            if (! contains(x)) then {",
  "                mods := mods + 1",
  "                def t = findPositionForAdd(x)",
  "                inner.at(t)put(x)",
  "                size := size + 1",
  "                if (size > (inner.size / 2)) then {",
  "                    expand",
  "                }",
  "            }",
  "            self    // for chaining",
  "        }",
  "",
  "        method removeAll(elements) {",
  "            for (elements) do { x ->",
  "                remove (x) ifAbsent {",
  "                    NoSuchObject.raise \"set does not contain {x}\"",
  "                }",
  "            }",
  "            self    // for chaining",
  "        }",
  "        method removeAll(elements)ifAbsent(block:Block1<T,Done>) {",
  "            mods := mods + 1",
  "            for (elements) do { x ->",
  "                var t := findPosition(x)",
  "                if (inner.at(t) == x) then {",
  "                    inner.at(t) put (removed)",
  "                    size := size - 1",
  "                } else {",
  "                    block.apply(x)",
  "                }",
  "            }",
  "            self    // for chaining",
  "        }",
  "",
  "        method remove (elt:T) ifAbsent (block) {",
  "            var t := findPosition(elt)",
  "            if (inner.at(t) == elt) then {",
  "                inner.at(t) put (removed)",
  "                mods := mods + 1",
  "                size := size - 1",
  "            } else {",
  "                block.apply",
  "            }",
  "            self    // for chaining",
  "        }",
  "",
  "        method remove(elt:T) {",
  "            remove (elt) ifAbsent {",
  "                NoSuchObject.raise \"set does not contain {elt}\"",
  "            }",
  "            self    // for chaining",
  "        }",
  "",
  "        method contains(x) {",
  "            var t := findPosition(x)",
  "            if (inner.at(t) == x) then {",
  "                return true",
  "            }",
  "            return false",
  "        }",
  "        method includes(booleanBlock) {",
  "            self.do { each ->",
  "                if (booleanBlock.apply(each)) then { return true }",
  "            }",
  "            return false",
  "        }",
  "        method find(booleanBlock)ifNone(notFoundBlock) {",
  "            self.do { each ->",
  "                if (booleanBlock.apply(each)) then { return each }",
  "            }",
  "            return notFoundBlock.apply",
  "        }",
  "        method findPosition(x) is confidential {",
  "            def h = x.hash",
  "            def s = inner.size",
  "            var t := h % s",
  "            var jump := 5",
  "            var candidate",
  "            while {",
  "                candidate := inner.at(t)",
  "                unused ≠ candidate",
  "            } do {",
  "                if (candidate == x) then {",
  "                    return t",
  "                }",
  "                if (jump != 0) then {",
  "                    t := (t * 3 + 1) % s",
  "                    jump := jump - 1",
  "                } else {",
  "                    t := (t + 1) % s",
  "                }",
  "            }",
  "            return t",
  "        }",
  "        method findPositionForAdd(x) is confidential {",
  "            def h = x.hash",
  "            def s = inner.size",
  "            var t := h % s",
  "            var jump := 5",
  "            var candidate",
  "            while {",
  "                candidate := inner.at(t)",
  "                (unused != candidate) && (removed != candidate)",
  "            } do {",
  "                if (candidate == x) then {",
  "                    return t",
  "                }",
  "                if (jump != 0) then {",
  "                    t := (t * 3 + 1) % s",
  "                    jump := jump - 1",
  "                } else {",
  "                    t := (t + 1) % s",
  "                }",
  "            }",
  "            return t",
  "        }",
  "",
  "        method asString {",
  "            var s := \"set\\{\"",
  "            do {each -> s := s ++ each.asString }",
  "                separatedBy { s := s ++ \", \" }",
  "            s ++ \"\\}\"",
  "        }",
  "        method asDebugString {",
  "            var s := \"set\\{\"",
  "            do {each -> s := s ++ each.asDebugString }",
  "                separatedBy { s := s ++ \", \" }",
  "            s ++ \"\\}\"",
  "        }",
  "        method extend(l) {",
  "            for (l) do {i->",
  "                add(i)",
  "            }",
  "        }",
  "        method do(block1) {",
  "            var i := 0",
  "            var found := 0",
  "            var candidate",
  "            while {found < size} do {",
  "                candidate := inner.at(i)",
  "                if ((unused != candidate) && (removed != candidate)) then {",
  "                    found := found + 1",
  "                    block1.apply(candidate)",
  "                }",
  "                i := i + 1",
  "            }",
  "        }",
  "        method iterator {",
  "            object {",
  "                var imods:Number := mods",
  "                var count := 1",
  "                var idx := -1",
  "                method hasNext { size >= count }",
  "                method next {",
  "                    var candidate",
  "                    def innerSize = inner.size",
  "                    while {",
  "                        idx := idx + 1",
  "                        if (imods != mods) then {",
  "                            ConcurrentModification.raise (outer.asString)",
  "                        }",
  "                        if (idx >= innerSize) then {",
  "                            IteratorExhausted.raise \"iterator over {outer.asString}\"",
  "                        }",
  "                        candidate := inner.at(idx)",
  "                        (unused == candidate) || (removed == candidate)",
  "                    } do { }",
  "                    count := count + 1",
  "                    candidate",
  "                }",
  "            }",
  "        }",
  "",
  "        method expand is confidential {",
  "            def c = inner.size",
  "            def n = c * 2",
  "            def oldInner = inner",
  "            size := 0",
  "            inner := _prelude.primitiveArray.new(n)",
  "            for (0..(inner.size-1)) do {i->",
  "                inner.at(i)put(unused)",
  "            }",
  "            for (0..(oldInner.size-1)) do {i->",
  "                if ((unused != oldInner.at(i)) && (removed != oldInner.at(i))) then {",
  "                    add(oldInner.at(i))",
  "                }",
  "            }",
  "        }",
  "        method ==(other) {",
  "            if (Iterable.match(other)) then {",
  "                var otherSize := 0",
  "                other.do { each ->",
  "                    otherSize := otherSize + 1",
  "                    if (! self.contains(each)) then {",
  "                        return false",
  "                    }",
  "                }",
  "                otherSize == self.size",
  "            } else { ",
  "                false",
  "            }",
  "        }",
  "        method copy {",
  "            outer.withAll(self)",
  "        }",
  "        method ++ (other) {",
  "        // set union",
  "            copy.addAll(other)",
  "        }",
  "        method -- (other) {",
  "        // set difference",
  "            def result = set.empty",
  "            for (self) do {v->",
  "                if (!other.contains(v)) then {",
  "                    result.add(v)",
  "                }",
  "            }",
  "            result",
  "        }",
  "        method ** (other) {",
  "        // set intersection",
  "            (filter {each -> other.contains(each)}).asSet",
  "        }",
  "        method isSubset(s2: Set<T>) {",
  "            self.do{ each ->",
  "                if (s2.contains(each).not) then { return false }",
  "            }",
  "            return true",
  "        }",
  "",
  "        method isSuperset(s2: Iterable<T>) {",
  "            s2.do{ each ->",
  "                if (self.contains(each).not) then { return false }",
  "            }",
  "            return true",
  "        }",
  "        method into(existing: Expandable<T>) -> Collection<T> {",
  "            do { each -> existing.add(each) }",
  "            existing",
  "        }",
  "    }",
  "}",
  "",
  "type Binding<K,T> = {",
  "    key -> K",
  "    value -> T",
  "    hash -> Number",
  "    == -> Boolean",
  "}",
  "",
  "def binding = object {",
  "    method asString { \"binding class\" }",
  "",
  "    class key(k)value(v) {",
  "        method key {k}",
  "        method value {v}",
  "        method asString { \"{k}::{v}\" }",
  "        method hashcode { (k.hashcode * 1021) + v.hashcode }",
  "        method hash { (k.hash * 1021) + v.hash }",
  "        method == (other) {",
  "            match (other)",
  "                case {o:Binding -> (k == o.key) && (v == o.value) }",
  "                case {_ -> return false }",
  "        }",
  "    }",
  "}",
  "",
  "type ComparableToDictionary<K,T> = type {",
  "    size -> Number",
  "    at(_:K)ifAbsent(_) -> T",
  "}",
  "",
  "class dictionary<K,T> {",
  "",
  "    method asString { \"a dictionary factory\" }",
  "",
  "    method withAll(initialBindings: Iterable<Binding<K,T>>) -> Dictionary<K,T> {",
  "        def result = empty",
  "        for (initialBindings) do { b -> result.add(b) }",
  "        result",
  "    }",
  "",
  "    class empty -> Dictionary<K,T> {",
  "        inherits collection.TRAIT<T>",
  "        var mods is readable := 0",
  "        var numBindings := 0",
  "        var inner := _prelude.primitiveArray.new(8)",
  "        for (0..(inner.size-1)) do { i ->",
  "            inner.at(i)put(unused)",
  "        }",
  "        method size { numBindings }",
  "        method at(key')put(value') {",
  "            mods := mods + 1",
  "            var t := findPositionForAdd(key')",
  "            if ((unused == inner.at(t)) || (removed == inner.at(t))) then {",
  "                numBindings := numBindings + 1",
  "            }",
  "            inner.at(t)put(binding.key(key')value(value'))",
  "            if ((size * 2) > inner.size) then { expand }",
  "            self    // for chaining",
  "        }",
  "        method add(aBinding) {",
  "            mods := mods + 1",
  "            var t := findPositionForAdd (aBinding.key)",
  "            if ((unused == inner.at(t)) || (removed == inner.at(t))) then {",
  "                numBindings := numBindings + 1",
  "            }",
  "            inner.at(t)put(aBinding)",
  "            if ((size * 2) > inner.size) then { expand }",
  "            self    // for chaining",
  "        }",
  "        method at(k) {",
  "            var b := inner.at(findPosition(k))",
  "            if (b.key == k) then {",
  "                return b.value",
  "            }",
  "            NoSuchObject.raise \"dictionary does not contain entry with key {k}\"",
  "        }",
  "        method at(k) ifAbsent(action) {",
  "            var b := inner.at(findPosition(k))",
  "            if (b.key == k) then {",
  "                return b.value",
  "            }",
  "            action.apply",
  "        }",
  "        method containsKey(k) {",
  "            var t := findPosition(k)",
  "            if (inner.at(t).key == k) then {",
  "                return true",
  "            }",
  "            false",
  "        }",
  "        method removeAllKeys(keys) {",
  "            mods := mods + 1",
  "            for (keys) do { k ->",
  "                var t := findPosition(k)",
  "                if (inner.at(t).key == k) then {",
  "                    inner.at(t)put(removed)",
  "                    numBindings := numBindings - 1",
  "                } else {",
  "                    NoSuchObject.raise \"dictionary does not contain entry with key {k}\"",
  "                }",
  "            }",
  "            self",
  "        }",
  "        method removeKey(k:K) {",
  "            mods := mods + 1",
  "            var t := findPosition(k)",
  "            if (inner.at(t).key == k) then {",
  "                inner.at(t)put(removed)",
  "                numBindings := numBindings - 1",
  "            } else {",
  "                NoSuchObject.raise \"dictionary does not contain entry with key {k}\"",
  "            }",
  "            self",
  "        }",
  "        method removeAllValues(removals) {",
  "            mods := mods + 1",
  "            for (0..(inner.size-1)) do {i->",
  "                def a = inner.at(i)",
  "                if (removals.contains(a.value)) then {",
  "                    inner.at(i)put(removed)",
  "                    numBindings := numBindings - 1",
  "                }",
  "            }",
  "            self",
  "        }",
  "        method removeValue(v) {",
  "            // remove all bindings with value v",
  "            mods := mods + 1",
  "            def initialNumBindings = numBindings",
  "            for (0..(inner.size-1)) do {i->",
  "                def a = inner.at(i)",
  "                if (v == a.value) then {",
  "                    inner.at (i) put (removed)",
  "                    numBindings := numBindings - 1",
  "                }",
  "            }",
  "            if (numBindings == initialNumBindings) then {",
  "                NoSuchObject.raise \"dictionary does not contain entry with value {v}\"",
  "            }",
  "            self",
  "        }",
  "        method removeValue(v) ifAbsent (action:Block0<Unknown>) {",
  "            // remove all bindings with value v",
  "            mods := mods + 1",
  "            def initialNumBindings = numBindings",
  "            for (0..(inner.size-1)) do {i->",
  "                def a = inner.at(i)",
  "                if (v == a.value) then {",
  "                    inner.at (i) put (removed)",
  "                    numBindings := numBindings - 1",
  "                }",
  "            }",
  "            if (numBindings == initialNumBindings) then {",
  "                action.apply",
  "            }",
  "            self",
  "        }",
  "        method containsValue(v) {",
  "            self.valuesDo{ each ->",
  "                if (v == each) then { return true }",
  "            }",
  "            false",
  "        }",
  "        method contains(v) { containsValue(v) }",
  "",
  "        method findPosition(x) is confidential {",
  "            def h = x.hash",
  "            def s = inner.size",
  "            var t := h % s",
  "            var jump := 5",
  "            while { unused ≠ inner.at(t) } do {",
  "                if (inner.at(t).key == x) then {",
  "                    return t",
  "                }",
  "                if (jump != 0) then {",
  "                    t := (t * 3 + 1) % s",
  "                    jump := jump - 1",
  "                } else {",
  "                    t := (t + 1) % s",
  "                }",
  "            }",
  "            return t",
  "        }",
  "        method findPositionForAdd(x) is confidential {",
  "            def h = x.hash",
  "            def s = inner.size",
  "            var t := h % s",
  "            var jump := 5",
  "            while { (unused ≠ inner.at(t)) && (removed ≠ inner.at(t)) } do {",
  "                if (inner.at(t).key == x) then {",
  "                    return t",
  "                }",
  "                if (jump != 0) then {",
  "                    t := (t * 3 + 1) % s",
  "                    jump := jump - 1",
  "                } else {",
  "                    t := (t + 1) % s",
  "                }",
  "            }",
  "            return t",
  "        }",
  "        method asString {",
  "            // do()separatedBy won't work, because it iterates over values,",
  "            // and we need an iterator over bindings.",
  "            var s := \"dict⟬\"",
  "            var firstElement := true",
  "            for (0..(inner.size-1)) do {i->",
  "                def a = inner.at(i)",
  "                if ((unused ≠ a) && (removed ≠ a)) then {",
  "                    if (! firstElement) then {",
  "                        s := s ++ \", \"",
  "                    } else {",
  "                        firstElement := false",
  "                    }",
  "                    s := s ++ \"{a.key}::{a.value}\"",
  "                }",
  "            }",
  "            s ++ \"⟭\"",
  "        }",
  "        method asDebugString {",
  "            var s := \"dict⟬\"",
  "            for (0..(inner.size-1)) do {i->",
  "                if (i > 0) then { s := s ++ \", \" }",
  "                def a = inner.at(i)",
  "                if ((unused ≠ a) && (removed ≠ a)) then {",
  "                    s := s ++ \"{i}→{a.key}::{a.value}\"",
  "                } else {",
  "                    s := s ++ \"{i}→{a.asDebugString}\"",
  "                }",
  "            }",
  "            s ++ \"⟭\"",
  "        }",
  "        method keys -> Enumerable<K> {",
  "            def sourceDictionary = self",
  "            object {",
  "                inherits enumerable.TRAIT<K>",
  "                class iterator {",
  "                    def sourceIterator = sourceDictionary.bindingsIterator",
  "                    method hasNext { sourceIterator.hasNext }",
  "                    method next { sourceIterator.next.key }",
  "                    method asString {",
  "                        \"an iterator over keys of {sourceDictionary}\"",
  "                    }",
  "                }",
  "                def size is public = sourceDictionary.size",
  "                method asDebugString {",
  "                    \"a lazy sequence over keys of {sourceDictionary}\"",
  "                }",
  "            }",
  "        }",
  "        method values -> Enumerable<T> {",
  "            def sourceDictionary = self",
  "            object {",
  "                inherits enumerable.TRAIT<T>",
  "                class iterator {",
  "                    def sourceIterator = sourceDictionary.bindingsIterator",
  "                    // should be request on outer",
  "                    method hasNext { sourceIterator.hasNext }",
  "                    method next { sourceIterator.next.value }",
  "                    method asString {",
  "                        \"an iterator over values of {sourceDictionary}\"",
  "                    }",
  "                }",
  "                def size is public = sourceDictionary.size",
  "                method asDebugString {",
  "                    \"a lazy sequence over values of {sourceDictionary}\"",
  "                }",
  "            }",
  "        }",
  "        method bindings -> Enumerable<T> {",
  "            def sourceDictionary = self",
  "            object {",
  "                inherits enumerable.TRAIT<T>",
  "                method iterator { sourceDictionary.bindingsIterator }",
  "                // should be request on outer",
  "                def size is public = sourceDictionary.size",
  "                method asDebugString {",
  "                    \"a lazy sequence over bindings of {sourceDictionary}\"",
  "                }",
  "            }",
  "        }",
  "        method iterator -> Iterator<T> { values.iterator }",
  "        class bindingsIterator -> Iterator<Binding<K, T>> {",
  "            // this should be confidential, but can't be until `outer` is fixed.",
  "            def imods:Number = mods",
  "            var count := 1",
  "            var idx := 0",
  "            var elt",
  "            method hasNext { size >= count }",
  "            method next {",
  "                if (imods != mods) then {",
  "                    ConcurrentModification.raise (outer.asString)",
  "                }",
  "                if (size < count) then { IteratorExhausted.raise \"over {outer.asString}\" }",
  "                while {",
  "                    elt := inner.at(idx)",
  "                    (unused == elt) || (removed == elt)",
  "                } do {",
  "                    idx := idx + 1",
  "                }",
  "                count := count + 1",
  "                idx := idx + 1",
  "                elt",
  "            }",
  "        }",
  "        method expand is confidential {",
  "            def c = inner.size",
  "            def n = c * 2",
  "            def oldInner = inner",
  "            inner := _prelude.primitiveArray.new(n)",
  "            for (0..(n - 1)) do {i->",
  "                inner.at(i)put(unused)",
  "            }",
  "            numBindings := 0",
  "            for (0..(c - 1)) do {i->",
  "                def a = oldInner.at(i)",
  "                if ((unused ≠ a) && (removed ≠ a)) then {",
  "                    self.at(a.key)put(a.value)",
  "                }",
  "            }",
  "        }",
  "        method keysAndValuesDo(block2) {",
  "            for (0..(inner.size-1)) do {i->",
  "                def a = inner.at(i)",
  "                if ((unused ≠ a) && (removed ≠ a)) then {",
  "                    block2.apply(a.key, a.value)",
  "                }",
  "            }",
  "        }",
  "        method keysDo(block1) {",
  "            for (0..(inner.size-1)) do {i->",
  "                def a = inner.at(i)",
  "                if ((unused ≠ a) && (removed ≠ a)) then {",
  "                    block1.apply(a.key)",
  "                }",
  "            }",
  "        }",
  "        method valuesDo(block1) {",
  "            for (0..(inner.size-1)) do {i->",
  "                def a = inner.at(i)",
  "                if ((unused ≠ a) && (removed ≠ a)) then {",
  "                    block1.apply(a.value)",
  "                }",
  "            }",
  "        }",
  "        method do(block1) { valuesDo(block1) }",
  "",
  "        method ==(other) {",
  "            match (other)",
  "                case {o:ComparableToDictionary<K,V> ->",
  "                    if (self.size != o.size) then {return false}",
  "                    self.keysAndValuesDo { k, v ->",
  "                        if (o.at(k)ifAbsent{return false} != v) then {",
  "                            return false",
  "                        }",
  "                    }",
  "                    return true",
  "                }",
  "                case {_ ->",
  "                    return false",
  "                }",
  "        }",
  "",
  "        method copy {",
  "            def newCopy = dictionary.empty",
  "            self.keysAndValuesDo{ k, v ->",
  "                newCopy.at(k)put(v)",
  "            }",
  "            newCopy",
  "        }",
  "",
  "        method asDictionary {",
  "            self",
  "        }",
  "",
  "        method ++(other) {",
  "            def newDict = self.copy",
  "            other.keysAndValuesDo {k, v ->",
  "                newDict.at(k) put(v)",
  "            }",
  "            return newDict",
  "        }",
  "",
  "        method --(other) {",
  "            def newDict = dictionary.empty",
  "            keysAndValuesDo { k, v ->",
  "                if (! other.containsKey(k)) then {",
  "                    newDict.at(k) put(v)",
  "                }",
  "            }",
  "            return newDict",
  "        }",
  "    }",
  "}",
  "",
  "class range {",
  "    method from(lower)to(upper) -> Sequence<Number> {",
  "        match (lower)",
  "            case {_:Number -> }",
  "            case {_ -> RequestError.raise (\"lower bound {lower}\" ++",
  "                \" in range.from({lower})to({upper}) is not an integer\") }",
  "        def start = lower.truncated",
  "        if (start != lower) then {",
  "            RequestError.raise (\"lower bound {lower}\" ++",
  "                \" in range.from({lower})to({upper}) is not an integer\") }",
  "",
  "        match (upper)",
  "            case {_:Number -> }",
  "            case {_ -> RequestError.raise (\"upper bound {upper}\" ++",
  "                \" in range.from({lower})to({upper}) is not an integer\") }",
  "        def stop = upper.truncated",
  "        if (stop != upper) then {",
  "            RequestError.raise (\"upper bound {upper}\" ++",
  "                \" in range.from()to() is not an integer\")",
  "        }",
  "",
  "        uncheckedFrom (lower) to (upper)",
  "    }",
  "",
  "    method uncheckedFrom (lower) to (upper) -> Sequence<Number> {",
  "        object {",
  "            inherits indexable.TRAIT<Number>",
  "            def start = lower",
  "            def stop = upper",
  "            def size is public =",
  "                if ((upper-lower+1) < 0) then { 0 } else {upper-lower+1}",
  "",
  "            def hash is public = { ((start.hash * 1021) + stop.hash) * 3 }",
  "",
  "            method iterator -> Iterator {",
  "                object {",
  "                    var val := start",
  "                    method hasNext { val <= stop }",
  "                    method next {",
  "                        if (val > stop) then {",
  "                            IteratorExhausted.raise \"over {outer.asString}\"",
  "                        }",
  "                        val := val + 1",
  "                        return (val - 1)",
  "                    }",
  "                    method asString { \"{super.asString} from {upper} to {lower}\" }",
  "                }",
  "            }",
  "            method at(ix:Number) {",
  "                if (!(ix <= self.size)) then {",
  "                    BoundsError.raise \"requested range.at({ix}), but upper bound is {size}\"",
  "                }",
  "                if (!(ix >= 1)) then {",
  "                    BoundsError.raise \"requested range.at({ix}), but lower bound is 1\"",
  "                }",
  "                return start + (ix - 1)",
  "            }",
  "            method contains(elem) -> Boolean {",
  "                try {",
  "                    def intElem = elem.truncated",
  "                    if (intElem != elem) then {return false}",
  "                    if (intElem < start) then {return false}",
  "                    if (intElem > stop) then {return false}",
  "                } catch { ex:_prelude.Exception -> return false }",
  "                return true",
  "            }",
  "            method do(block1) {",
  "                var val := start",
  "                while {val <= stop} do {",
  "                    block1.apply(val)",
  "                    val := val + 1",
  "                }",
  "            }",
  "            method keysAndValuesDo(block2) {",
  "                var key := 1",
  "                var val := start",
  "                while {val <= stop} do {",
  "                    block2.apply(key, val)",
  "                    key := key + 1",
  "                    val := val + 1",
  "                }",
  "            }",
  "            method reversed {",
  "                from(upper)downTo(lower)",
  "            }",
  "            method ++(other) {",
  "                sequence.withAll(lazyConcatenation(self, other))",
  "            }",
  "            method ==(other) {",
  "                isEqual (self) toIterable (other)",
  "            }",
  "            method sorted { self }",
  "",
  "            method sortedBy(c) { self.asList.sortBy(c) }",
  "",
  "            method keys { 1..self.size }",
  "",
  "            method values { self }",
  "",
  "            method asString -> String{",
  "                \"range.from({lower})to({upper})\"",
  "            }",
  "",
  "            method asList{",
  "                var result := list.empty",
  "                for (self) do { each -> result.add(each) }",
  "                result",
  "            }",
  "",
  "            method asSequence {",
  "                self",
  "            }",
  "        }",
  "    }",
  "    method from(upper)downTo(lower) -> Sequence<Number> {",
  "        object {",
  "            inherits indexable.TRAIT",
  "            match (upper)",
  "                case {_:Number -> }",
  "                case {_ -> RequestError.raise (\"upper bound {upper}\" ++",
  "                    \" in range.from({upper})downTo({lower}) is not an integer\") }",
  "            def start = upper.truncated",
  "            if (start != upper) then {",
  "                RequestError.raise (\"upper bound {upper}\" ++",
  "                    \" in range.from({upper})downTo({lower}) is not an integer\")",
  "            }",
  "            match (lower)",
  "                case {_:Number -> }",
  "                case {_ -> RequestError.raise (\"lower bound {lower}\" ++",
  "                    \" in range.from({upper})downTo({lower}) is not an integer\") }",
  "            def stop = lower.truncated",
  "            if (stop != lower) then {",
  "                RequestError.raise (\"lower bound {lower}\" ++",
  "                    \" in range.from({upper})downTo({lower}) is not an integer\")",
  "            }",
  "            def size is public =",
  "                if ((upper-lower+1) < 0) then { 0 } else {upper-lower+1}",
  "            method iterator {",
  "                object {",
  "                    var val := start",
  "                    method hasNext { val >= stop }",
  "                    method next {",
  "                        if (val < stop) then { IteratorExhausted.raise \"over {outer.asString}\" }",
  "                        val := val - 1",
  "                        return (val + 1)",
  "                    }",
  "                    method asString { \"anIterator over {super.asString}\" }",
  "                }",
  "            }",
  "            method at(ix:Number) {",
  "                if (!(ix <= self.size)) then {",
  "                    BoundsError.raise \"requested range.at({ix}) but upper bound is {size}\"",
  "                }",
  "                if (!(ix >= 1)) then {",
  "                    BoundsError.raise \"requested range.at({ix}) but lower bound is 1\"",
  "                }",
  "                return start - (ix - 1)",
  "            }",
  "            method contains(elem) -> Boolean {",
  "                try {",
  "                    def intElem = elem.truncated",
  "                    if (intElem != elem) then {return false}",
  "                    if (intElem > start) then {return false}",
  "                    if (intElem < stop) then {return false}",
  "                } catch { ex:_prelude.Exception -> return false }",
  "                return true",
  "            }",
  "            method do(block1) {",
  "                var val := start",
  "                while {val >= stop} do {",
  "                    block1.apply(val)",
  "                    val := val - 1",
  "                }",
  "            }",
  "            method keysAndValuesDo(block2) {",
  "                var key := 1",
  "                var val := start",
  "                while {val >= stop} do {",
  "                    block2.apply(key, val)",
  "                    key := key + 1",
  "                    val := val - 1",
  "                }",
  "            }",
  "            method reversed {",
  "                from(lower)to(upper)",
  "            }",
  "            method ++(other) {",
  "                sequence.withAll(lazyConcatenation(self, other))",
  "            }",
  "            method ==(other) {",
  "                isEqual (self) toIterable (other)",
  "            }",
  "            method sorted { self.reversed }",
  "",
  "            method sortedBy(c) { self.asList.sortBy(c) }",
  "",
  "            method keys { 1..self.size }",
  "",
  "            method values { self }",
  "",
  "            method asString -> String {",
  "                \"range.from {upper} downTo {lower}\"",
  "            }",
  "            method asSequence {",
  "                self",
  "            }",
  "        }",
  "    }",
  "}",
  NULL
};
Object reader_collectionsPrelude_outer_7(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_10(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_sourceIterator_11(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_outer_49(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_52(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_cache_53(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_cache_53(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_cacheLoaded_54(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_cacheLoaded_54(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_sourceIterator_55(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_outer_145(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_182(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_229(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_317(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_size_318(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_inner_319(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_outer_550(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_idx_551(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_idx_551(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_700(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_716(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_mods_717(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_mods_717(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_sz_718(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_sz_718(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_jsArray_719(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_collectionsPrelude_jsArray_719(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_1079(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_imods_1080(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_imods_1080(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_idx_1081(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_idx_1081(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_1218(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_mods_1219(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_mods_1219(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_sizeCertain_1220(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_sizeCertain_1220(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_initialSize_1221(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_inner_1222(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_collectionsPrelude_inner_1222(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_collectionsPrelude_size_1223(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[5];
}
Object writer_collectionsPrelude_size_1223(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[5] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_1980(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_imods_1981(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_imods_1981(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_idx_1982(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_idx_1982(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_2259(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_2297(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_mods_2298(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_mods_2298(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_inner_2299(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_inner_2299(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_size_2300(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_collectionsPrelude_size_2300(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_2768(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_imods_2769(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_imods_2769(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_count_2770(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_count_2770(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_idx_2771(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_collectionsPrelude_idx_2771(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_3081(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_3096(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_mods_3097(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_mods_3097(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_numBindings_3098(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_numBindings_3098(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_inner_3099(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_collectionsPrelude_inner_3099(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_3868(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_3871(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_sourceIterator_3872(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_size_3897(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_outer_3914(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_3917(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_sourceIterator_3918(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_size_3943(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_outer_3960(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_size_3964(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_outer_3986(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_imods_3987(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_count_3988(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object writer_collectionsPrelude_count_3988(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[2] = args[0];
  return done;
}
Object reader_collectionsPrelude_idx_3989(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object writer_collectionsPrelude_idx_3989(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[3] = args[0];
  return done;
}
Object reader_collectionsPrelude_elt_3990(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object writer_collectionsPrelude_elt_3990(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[4] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_4413(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_4561(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_start_4562(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_stop_4563(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_size_4564(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_hash_4565(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[4];
}
Object reader_collectionsPrelude_outer_4568(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_val_4569(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_val_4569(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_4918(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_start_4919(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_collectionsPrelude_stop_4920(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_size_4921(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_outer_4924(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_val_4925(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_val_4925(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_outer_5488(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5491(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5616(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5619(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5788(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5791(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5942(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_5996(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_6015(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_unused_6016(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_unused_6016(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_key_6017(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_value_6018(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_outer_6027(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_removed_6028(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object writer_collectionsPrelude_removed_6028(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  uo->data[1] = args[0];
  return done;
}
Object reader_collectionsPrelude_key_6029(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
Object reader_collectionsPrelude_value_6030(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[3];
}
Object reader_collectionsPrelude_outer_6042(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_collectionsPrelude_outer_6047(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
static Object strlit3;
static ClassData objclass6;
static ClassData objclass9;
static Object strlit13;
static Object strlit37;
static Object strlit41;
static ClassData objclass48;
static ClassData objclass51;
static Object strlit58;
static Object strlit62;
static Object strlit87;
static Object strlit133;
static Object strlit137;
static ClassData objclass144;
static Object strlit163;
static Object strlit168;
static Object strlit172;
static Object strlit178;
static ClassData objclass181;
static Object strlit194;
static Object strlit199;
static Object strlit203;
static ClassData objclass228;
static Object strlit231;
static ClassData objclass316;
static Object strlit340;
static Object strlit347;
static Object strlit351;
static Object strlit458;
static Object strlit493;
static Object strlit500;
static ClassData objclass549;
static Object strlit554;
static Object strlit561;
static Object strlit567;
static Object strlit573;
static Object strlit589;
static Object strlit596;
static Object strlit602;
static ClassData objclass699;
static Object strlit702;
static Object strlit709;
static ClassData objclass715;
static Object strlit840;
static Object strlit844;
static Object strlit867;
static Object strlit964;
static Object strlit987;
static Object strlit994;
static Object strlit998;
static Object strlit1021;
static Object strlit1028;
static ClassData objclass1078;
static Object strlit1084;
static Object strlit1091;
static Object strlit1097;
static Object strlit1103;
static Object strlit1140;
static ClassData objclass1217;
static Object strlit1244;
static Object strlit1251;
static Object strlit1255;
static Object strlit1718;
static Object strlit1722;
static Object strlit1745;
static Object strlit1842;
static Object strlit1877;
static Object strlit1884;
static Object strlit1888;
static Object strlit1923;
static Object strlit1930;
static ClassData objclass1979;
static Object strlit1985;
static Object strlit1992;
static Object strlit1998;
static Object strlit2004;
static Object strlit2041;
static ClassData objclass2258;
static Object strlit2261;
static ClassData objclass2296;
static Object strlit2403;
static Object strlit2407;
static Object strlit2492;
static Object strlit2496;
static Object strlit2666;
static Object strlit2680;
static Object strlit2687;
static Object strlit2691;
static Object strlit2705;
static Object strlit2712;
static ClassData objclass2767;
static Object strlit2824;
static Object strlit2832;
static ClassData objclass3080;
static Object strlit3083;
static ClassData objclass3095;
static Object strlit3238;
static Object strlit3242;
static Object strlit3316;
static Object strlit3320;
static Object strlit3361;
static Object strlit3365;
static Object strlit3474;
static Object strlit3478;
static Object strlit3698;
static Object strlit3733;
static Object strlit3741;
static Object strlit3748;
static Object strlit3754;
static Object strlit3765;
static Object strlit3769;
static Object strlit3791;
static Object strlit3811;
static Object strlit3818;
static Object strlit3825;
static Object strlit3829;
static Object strlit3841;
static Object strlit3848;
static Object strlit3852;
static Object strlit3863;
static ClassData objclass3867;
static ClassData objclass3870;
static Object strlit3887;
static Object strlit3891;
static Object strlit3900;
static Object strlit3904;
static ClassData objclass3913;
static ClassData objclass3916;
static Object strlit3933;
static Object strlit3937;
static Object strlit3946;
static Object strlit3950;
static ClassData objclass3959;
static Object strlit3967;
static Object strlit3971;
static ClassData objclass3985;
static Object strlit4030;
static Object strlit4038;
static Object strlit4320;
static ClassData objclass4412;
static Object strlit4421;
static Object strlit4433;
static Object strlit4438;
static Object strlit4442;
static Object strlit4449;
static Object strlit4453;
static Object strlit4468;
static Object strlit4473;
static Object strlit4477;
static Object strlit4484;
static Object strlit4488;
static Object strlit4499;
static Object strlit4511;
static Object strlit4516;
static Object strlit4520;
static Object strlit4527;
static Object strlit4531;
static Object strlit4545;
static Object strlit4548;
static Object strlit4552;
static ClassData objclass4560;
static ClassData objclass4567;
static Object strlit4593;
static Object strlit4601;
static Object strlit4621;
static Object strlit4626;
static Object strlit4631;
static Object strlit4637;
static Object strlit4660;
static Object strlit4667;
static Object strlit4671;
static Object strlit4686;
static Object strlit4690;
static Object strlit4735;
static Object strlit4840;
static Object strlit4845;
static Object strlit4849;
static ClassData objclass4917;
static ClassData objclass4923;
static Object strlit4949;
static Object strlit4957;
static Object strlit4977;
static Object strlit4983;
static Object strlit5002;
static Object strlit5009;
static Object strlit5013;
static Object strlit5028;
static Object strlit5032;
static Object strlit5077;
static Object strlit5184;
static Object strlit5189;
static Object strlit5193;
static Object strlit5207;
static Object strlit5219;
static Object strlit5224;
static Object strlit5228;
static Object strlit5235;
static Object strlit5239;
static Object strlit5256;
static Object strlit5261;
static Object strlit5265;
static Object strlit5272;
static Object strlit5276;
static Object strlit5287;
static Object strlit5299;
static Object strlit5304;
static Object strlit5308;
static Object strlit5315;
static Object strlit5319;
static Object strlit5336;
static Object strlit5341;
static Object strlit5345;
static Object strlit5352;
static Object strlit5356;
static Object strlit5384;
static Object strlit5390;
static Object strlit5396;
static Object strlit5402;
static Object strlit5408;
static Object strlit5414;
static Object strlit5420;
static ClassData objclass5487;
static ClassData objclass5490;
static Object strlit5493;
static Object strlit5499;
static Object strlit5532;
static Object strlit5536;
static Object strlit5613;
static ClassData objclass5615;
static ClassData objclass5618;
static Object strlit5630;
static Object strlit5636;
static Object strlit5757;
static Object strlit5771;
static Object strlit5778;
static Object strlit5785;
static ClassData objclass5787;
static ClassData objclass5790;
static Object strlit5880;
static Object strlit5884;
static Object strlit5939;
static ClassData objclass5941;
static Object strlit5950;
static Object strlit5954;
static Object strlit5970;
static Object strlit5983;
static ClassData objclass5995;
static Object strlit5998;
static Object strlit6003;
static ClassData objclass6014;
static Object strlit6020;
static ClassData objclass6026;
static Object strlit6032;
static ClassData objclass6041;
static Object strlit6044;
static ClassData objclass6046;
static Object strlit6052;
static Object strlit6057;
static Object strlit6061;
static Object strlit6110;
Object meth_collectionsPrelude_abstract1(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "abstract");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SubobjectResponsibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for abstract (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for abstract");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit3 == NULL) {
    strlit3 = alloc_String("abstract method not overriden by subobject");
    gc_root(strlit3);
  }
// compiled string node returning strlit3 (depth = 3)
  gc_frame_newslot(strlit3);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SubobjectResponsibility (depth = 3)
  params[0] = strlit3;
  partcv[0] = 1;
  Object call4 = callmethod(*var_SubobjectResponsibility, "raise",
    1, partcv, params);
  gc_frame_end(callframe2);
// compiled call node returning call4 (depth = 2)
  gc_frame_end(frame);
  return call4;
}
Object meth_collectionsPrelude_asString12(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 171
  setline(171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit13 == NULL) {
    strlit13 = alloc_String("an iterator over a lazy map sequence");
    gc_root(strlit13);
  }
// compiled string node returning strlit13 (depth = 2)
  gc_frame_end(frame);
  return strlit13;
}
Object meth_collectionsPrelude_hasNext14(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 172
  setline(172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe15 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe16 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call17 = callmethodflags(self, "sourceIterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe16);
// compiled call node returning call17 (depth = 5)
// compiled member node returning call17 (depth = 4)
  partcv[0] = 0;
  Object call18 = callmethod(call17, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe15);
// compiled call node returning call18 (depth = 3)
// compiled member node returning call18 (depth = 2)
  gc_frame_end(frame);
  return call18;
}
Object meth_collectionsPrelude_next19(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_function = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 173
  setline(173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe20 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe21 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe22 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call23 = callmethodflags(self, "sourceIterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe22);
// compiled call node returning call23 (depth = 6)
// compiled member node returning call23 (depth = 5)
  partcv[0] = 0;
  Object call24 = callmethod(call23, "next",
    1, partcv, params);
  gc_frame_end(callframe21);
// compiled call node returning call24 (depth = 4)
// compiled member node returning call24 (depth = 3)
  gc_frame_newslot(call24);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_function (depth = 3)
  params[0] = call24;
  partcv[0] = 1;
  Object call25 = callmethod(*var_function, "apply",
    1, partcv, params);
  gc_frame_end(callframe20);
// compiled call node returning call25 (depth = 2)
  gc_frame_end(frame);
  return call25;
}
Object meth_collectionsPrelude_iterator8(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_function = getfromclosure(closure, 0);
  Object *var_source = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9 = alloc_userobj2(4,5, objclass9);
  gc_frame_newslot(obj9);
if (objclass9 == NULL) {
  glfree(obj9->class->name);
  obj9->class->name = "collectionsPrelude.lazySequenceOver()mappedBy.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9, self, 0);
  addmethodreal(obj9,"outer", &reader_collectionsPrelude_outer_10);
  Object oldself9 = self;
  struct StackFrameObject *oldstackframe9 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9);
  gc_frame_newslot((Object)stackframe);
  self = obj9;
  Object *oldselfslot9 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9 = (*(struct UserObject *)self).data[0], lowerouter9 = thisouter9;
  if (inheritingObject9) {
    struct UserObject *inho9 = (struct UserObject *)inheritingObject9;
    while (inho9->super != GraceDefaultObject) inho9 = (struct UserObject *)inho9->super;
    inho9->super = obj9;
    self = inheritingObject9;
    *selfslot = self;
    lowerouter9 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9;
  }
if (objclass9 == NULL) {
  Method *reader11 = addmethodrealflags(obj9, "sourceIterator",&reader_collectionsPrelude_sourceIterator_11, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader11->definitionModule = modulename;
  reader11->definitionLine = 170;
}
adddatum2(obj9, alloc_Undefined(), 1);
// method "asString"
  struct UserObject *uo12 = (struct UserObject*)obj9;
  uo12->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString12 = addmethod2pos(obj9, "asString", &meth_collectionsPrelude_asString12, 2);
  int argcv_meth_collectionsPrelude_asString12[] = {0};
  meth_meth_collectionsPrelude_asString12->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString12);
  meth_meth_collectionsPrelude_asString12->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString12->definitionLine = 171;
// method "hasNext"
  struct UserObject *uo14 = (struct UserObject*)obj9;
  uo14->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext14 = addmethod2pos(obj9, "hasNext", &meth_collectionsPrelude_hasNext14, 3);
  int argcv_meth_collectionsPrelude_hasNext14[] = {0};
  meth_meth_collectionsPrelude_hasNext14->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext14);
  meth_meth_collectionsPrelude_hasNext14->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext14->definitionLine = 172;
// method "next"
  block_savedest(obj9);
  Object closure19 = createclosure(1, "next");
  setclosureframe(closure19, stackframe);
  addtoclosure(closure19, var_function);
  struct UserObject *uo19 = (struct UserObject*)obj9;
  uo19->data[4] = (Object)closure19;
  Method *meth_meth_collectionsPrelude_next19 = addmethod2pos(obj9, "next", &meth_collectionsPrelude_next19, 4);
  int argcv_meth_collectionsPrelude_next19[] = {0};
  meth_meth_collectionsPrelude_next19->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next19);
  meth_meth_collectionsPrelude_next19->definitionModule = modulename;
  meth_meth_collectionsPrelude_next19->definitionLine = 173;
  sourceObject = obj9;
// Begin line 170
  setline(170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe26 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  partcv[0] = 0;
  Object call27 = callmethod(*var_source, "iterator",
    1, partcv, params);
  gc_frame_end(callframe26);
// compiled call node returning call27 (depth = 3)
// compiled member node returning call27 (depth = 2)
  adddatum2(obj9, call27, 1);
  sourceObject = obj9;
  sourceObject = obj9;
  sourceObject = obj9;
  objclass9 = obj9->class;
  objclass9->definitionModule = modulename;
  objclass9->definitionLine = 169;
  (*(struct UserObject *)self).data[0] = lowerouter9;
  self = oldself9;
  selfslot = oldselfslot9;
  stackframe = oldstackframe9;
  gc_frame_end(frame);
  return obj9;
}
Object meth_collectionsPrelude_iterator8_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_function = getfromclosure(closure, 0);
  Object *var_source = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject9 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj9 = alloc_userobj2(4,5, objclass9);
  gc_frame_newslot(obj9);
if (objclass9 == NULL) {
  glfree(obj9->class->name);
  obj9->class->name = "collectionsPrelude.lazySequenceOver()mappedBy.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj9, self, 0);
  addmethodreal(obj9,"outer", &reader_collectionsPrelude_outer_10);
  Object oldself9 = self;
  struct StackFrameObject *oldstackframe9 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe9);
  gc_frame_newslot((Object)stackframe);
  self = obj9;
  Object *oldselfslot9 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter9 = (*(struct UserObject *)self).data[0], lowerouter9 = thisouter9;
  if (inheritingObject9) {
    struct UserObject *inho9 = (struct UserObject *)inheritingObject9;
    while (inho9->super != GraceDefaultObject) inho9 = (struct UserObject *)inho9->super;
    inho9->super = obj9;
    self = inheritingObject9;
    *selfslot = self;
    lowerouter9 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter9;
  }
if (objclass9 == NULL) {
  Method *reader11 = addmethodrealflags(obj9, "sourceIterator",&reader_collectionsPrelude_sourceIterator_11, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader11->definitionModule = modulename;
  reader11->definitionLine = 170;
}
adddatum2(obj9, alloc_Undefined(), 1);
// method "asString"
  struct UserObject *uo12 = (struct UserObject*)obj9;
  uo12->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString12 = addmethod2pos(obj9, "asString", &meth_collectionsPrelude_asString12, 2);
  int argcv_meth_collectionsPrelude_asString12[] = {0};
  meth_meth_collectionsPrelude_asString12->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString12);
  meth_meth_collectionsPrelude_asString12->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString12->definitionLine = 171;
// method "hasNext"
  struct UserObject *uo14 = (struct UserObject*)obj9;
  uo14->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext14 = addmethod2pos(obj9, "hasNext", &meth_collectionsPrelude_hasNext14, 3);
  int argcv_meth_collectionsPrelude_hasNext14[] = {0};
  meth_meth_collectionsPrelude_hasNext14->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext14);
  meth_meth_collectionsPrelude_hasNext14->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext14->definitionLine = 172;
// method "next"
  block_savedest(obj9);
  Object closure19 = createclosure(1, "next");
  setclosureframe(closure19, stackframe);
  addtoclosure(closure19, var_function);
  struct UserObject *uo19 = (struct UserObject*)obj9;
  uo19->data[4] = (Object)closure19;
  Method *meth_meth_collectionsPrelude_next19 = addmethod2pos(obj9, "next", &meth_collectionsPrelude_next19, 4);
  int argcv_meth_collectionsPrelude_next19[] = {0};
  meth_meth_collectionsPrelude_next19->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next19);
  meth_meth_collectionsPrelude_next19->definitionModule = modulename;
  meth_meth_collectionsPrelude_next19->definitionLine = 173;
  sourceObject = obj9;
// Begin line 170
  setline(170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe26 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  partcv[0] = 0;
  Object call27 = callmethod(*var_source, "iterator",
    1, partcv, params);
  gc_frame_end(callframe26);
// compiled call node returning call27 (depth = 3)
// compiled member node returning call27 (depth = 2)
  adddatum2(obj9, call27, 1);
  sourceObject = obj9;
  sourceObject = obj9;
  sourceObject = obj9;
  objclass9 = obj9->class;
  objclass9->definitionModule = modulename;
  objclass9->definitionLine = 169;
  (*(struct UserObject *)self).data[0] = lowerouter9;
  self = oldself9;
  selfslot = oldselfslot9;
  stackframe = oldstackframe9;
  gc_frame_end(frame);
  return obj9;
}
Object meth_collectionsPrelude_size29(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for size (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for size");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 175
  setline(175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe30 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  partcv[0] = 0;
  Object call31 = callmethod(*var_source, "size",
    1, partcv, params);
  gc_frame_end(callframe30);
// compiled call node returning call31 (depth = 3)
// compiled member node returning call31 (depth = 2)
  gc_frame_end(frame);
  return call31;
}
Object meth_collectionsPrelude_isEmpty32(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isEmpty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isEmpty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 176
  setline(176);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe33 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  partcv[0] = 0;
  Object call34 = callmethod(*var_source, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe33);
// compiled call node returning call34 (depth = 3)
// compiled member node returning call34 (depth = 2)
  gc_frame_end(frame);
  return call34;
}
Object meth_collectionsPrelude_asDebugString35(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 177
  setline(177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit37 == NULL) {
    strlit37 = alloc_String("");
    gc_root(strlit37);
  }
// compiled string node returning strlit37 (depth = 3)
  int op_slot_right_36 = gc_frame_newslot(strlit37);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  int op_slot_right_39 = gc_frame_newslot(*var_source);
// starting to compile string node (depth = 4)
  if (strlit41 == NULL) {
    strlit41 = alloc_String("a lazy sequence mapping over ");
    gc_root(strlit41);
  }
// compiled string node returning strlit41 (depth = 4)
  int op_slot_left_39 = gc_frame_newslot(strlit41);
  params[0] = *var_source;
  partcv[0] = 1;
  Object opresult42 = callmethod(strlit41, "++", 1, partcv, params);
// compiled op node returning opresult42 (depth = 3)
  int op_slot_left_36 = gc_frame_newslot(opresult42);
  params[0] = strlit37;
  partcv[0] = 1;
  Object opresult43 = callmethod(opresult42, "++", 1, partcv, params);
// compiled op node returning opresult43 (depth = 2)
  gc_frame_end(frame);
  return opresult43;
}
Object meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy5(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lazySequenceOver()mappedBy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lazySequenceOver()mappedBy");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lazySequenceOver()mappedBy");
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for lazySequenceOver()mappedBy (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_source = &(stackframe->slots[0]);
  *var_source = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for lazySequenceOver");
  Object *var_function = &(stackframe->slots[1]);
  *var_function = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for mappedBy");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  Object *var_R = &(stackframe->slots[4]);
  if (nparts == 1 + 2 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 2) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
    *var_R = args[curarg++];
  } else {
    *var_T = Unknown;
    *var_R = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6 = alloc_userobj2(5,6, objclass6);
  gc_frame_newslot(obj6);
if (objclass6 == NULL) {
  glfree(obj6->class->name);
  obj6->class->name = "collectionsPrelude.lazySequenceOver()mappedBy";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6, self, 0);
  addmethodreal(obj6,"outer", &reader_collectionsPrelude_outer_7);
  Object oldself6 = self;
  struct StackFrameObject *oldstackframe6 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6);
  gc_frame_newslot((Object)stackframe);
  self = obj6;
  Object *oldselfslot6 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6 = (*(struct UserObject *)self).data[0], lowerouter6 = thisouter6;
  if (inheritingObject6) {
    struct UserObject *inho6 = (struct UserObject *)inheritingObject6;
    while (inho6->super != GraceDefaultObject) inho6 = (struct UserObject *)inho6->super;
    inho6->super = obj6;
    self = inheritingObject6;
    *selfslot = self;
    lowerouter6 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6;
  }
// method "iterator"
  block_savedest(obj6);
  Object closure8 = createclosure(2, "iterator");
  setclosureframe(closure8, stackframe);
  addtoclosure(closure8, var_function);
  addtoclosure(closure8, var_source);
  struct UserObject *uo8 = (struct UserObject*)obj6;
  uo8->data[1] = (Object)closure8;
  Method *meth_meth_collectionsPrelude_iterator8 = addmethod2pos(obj6, "iterator", &meth_collectionsPrelude_iterator8, 1);
  int argcv_meth_collectionsPrelude_iterator8[] = {0};
  meth_meth_collectionsPrelude_iterator8->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator8);
  meth_meth_collectionsPrelude_iterator8->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator8->definitionLine = 169;
  block_savedest(obj6);
  Object closure28 = createclosure(2, "iterator()object");
  setclosureframe(closure28, stackframe);
  addtoclosure(closure28, var_function);
  addtoclosure(closure28, var_source);
  Method *meth_meth_collectionsPrelude_iterator8_object = addmethod2pos(obj6, "iterator()object", &meth_collectionsPrelude_iterator8_object, 1);
  meth_meth_collectionsPrelude_iterator8_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator8_object->definitionLine = 169;
// method "size"
  block_savedest(obj6);
  Object closure29 = createclosure(1, "size");
  setclosureframe(closure29, stackframe);
  addtoclosure(closure29, var_source);
  struct UserObject *uo29 = (struct UserObject*)obj6;
  uo29->data[2] = (Object)closure29;
  Method *meth_meth_collectionsPrelude_size29 = addmethod2pos(obj6, "size", &meth_collectionsPrelude_size29, 2);
  int argcv_meth_collectionsPrelude_size29[] = {0};
  meth_meth_collectionsPrelude_size29->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size29);
  meth_meth_collectionsPrelude_size29->definitionModule = modulename;
  meth_meth_collectionsPrelude_size29->definitionLine = 175;
// method "isEmpty"
  block_savedest(obj6);
  Object closure32 = createclosure(1, "isEmpty");
  setclosureframe(closure32, stackframe);
  addtoclosure(closure32, var_source);
  struct UserObject *uo32 = (struct UserObject*)obj6;
  uo32->data[3] = (Object)closure32;
  Method *meth_meth_collectionsPrelude_isEmpty32 = addmethod2pos(obj6, "isEmpty", &meth_collectionsPrelude_isEmpty32, 3);
  int argcv_meth_collectionsPrelude_isEmpty32[] = {0};
  meth_meth_collectionsPrelude_isEmpty32->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty32);
  meth_meth_collectionsPrelude_isEmpty32->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty32->definitionLine = 176;
// method "asDebugString"
  block_savedest(obj6);
  Object closure35 = createclosure(1, "asDebugString");
  setclosureframe(closure35, stackframe);
  addtoclosure(closure35, var_source);
  struct UserObject *uo35 = (struct UserObject*)obj6;
  uo35->data[4] = (Object)closure35;
  Method *meth_meth_collectionsPrelude_asDebugString35 = addmethod2pos(obj6, "asDebugString", &meth_collectionsPrelude_asDebugString35, 4);
  int argcv_meth_collectionsPrelude_asDebugString35[] = {0};
  meth_meth_collectionsPrelude_asDebugString35->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString35);
  meth_meth_collectionsPrelude_asDebugString35->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString35->definitionLine = 177;
  sourceObject = obj6;
// Begin line 168
  setline(168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe44 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call45 = callmethod(*var_enumerable, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe44);
// compiled call node returning call45 (depth = 2)
  struct UserObject *obj6_uo = (struct UserObject *)obj6;
  obj6_uo->super = call45;
  sourceObject = obj6;
  sourceObject = obj6;
  sourceObject = obj6;
  sourceObject = obj6;
  objclass6 = obj6->class;
  objclass6->definitionModule = modulename;
  objclass6->definitionLine = 166;
  (*(struct UserObject *)self).data[0] = lowerouter6;
  self = oldself6;
  selfslot = oldselfslot6;
  stackframe = oldstackframe6;
  gc_frame_end(frame);
  return obj6;
}
Object meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy5_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lazySequenceOver()mappedBy()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lazySequenceOver()mappedBy()object");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lazySequenceOver()mappedBy()object");
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for lazySequenceOver()mappedBy (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_source = &(stackframe->slots[0]);
  *var_source = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for lazySequenceOver");
  Object *var_function = &(stackframe->slots[1]);
  *var_function = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for mappedBy");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  Object *var_R = &(stackframe->slots[4]);
  if (nparts == 1 + 2 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 2) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
    *var_R = args[curarg++];
  } else {
    *var_T = Unknown;
    *var_R = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6 = alloc_userobj2(5,6, objclass6);
  gc_frame_newslot(obj6);
if (objclass6 == NULL) {
  glfree(obj6->class->name);
  obj6->class->name = "collectionsPrelude.lazySequenceOver()mappedBy";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6, self, 0);
  addmethodreal(obj6,"outer", &reader_collectionsPrelude_outer_7);
  Object oldself6 = self;
  struct StackFrameObject *oldstackframe6 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6);
  gc_frame_newslot((Object)stackframe);
  self = obj6;
  Object *oldselfslot6 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6 = (*(struct UserObject *)self).data[0], lowerouter6 = thisouter6;
  if (inheritingObject6) {
    struct UserObject *inho6 = (struct UserObject *)inheritingObject6;
    while (inho6->super != GraceDefaultObject) inho6 = (struct UserObject *)inho6->super;
    inho6->super = obj6;
    self = inheritingObject6;
    *selfslot = self;
    lowerouter6 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6;
  }
// method "iterator"
  block_savedest(obj6);
  Object closure8 = createclosure(2, "iterator");
  setclosureframe(closure8, stackframe);
  addtoclosure(closure8, var_function);
  addtoclosure(closure8, var_source);
  struct UserObject *uo8 = (struct UserObject*)obj6;
  uo8->data[1] = (Object)closure8;
  Method *meth_meth_collectionsPrelude_iterator8 = addmethod2pos(obj6, "iterator", &meth_collectionsPrelude_iterator8, 1);
  int argcv_meth_collectionsPrelude_iterator8[] = {0};
  meth_meth_collectionsPrelude_iterator8->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator8);
  meth_meth_collectionsPrelude_iterator8->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator8->definitionLine = 169;
  block_savedest(obj6);
  Object closure28 = createclosure(2, "iterator()object");
  setclosureframe(closure28, stackframe);
  addtoclosure(closure28, var_function);
  addtoclosure(closure28, var_source);
  Method *meth_meth_collectionsPrelude_iterator8_object = addmethod2pos(obj6, "iterator()object", &meth_collectionsPrelude_iterator8_object, 1);
  meth_meth_collectionsPrelude_iterator8_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator8_object->definitionLine = 169;
// method "size"
  block_savedest(obj6);
  Object closure29 = createclosure(1, "size");
  setclosureframe(closure29, stackframe);
  addtoclosure(closure29, var_source);
  struct UserObject *uo29 = (struct UserObject*)obj6;
  uo29->data[2] = (Object)closure29;
  Method *meth_meth_collectionsPrelude_size29 = addmethod2pos(obj6, "size", &meth_collectionsPrelude_size29, 2);
  int argcv_meth_collectionsPrelude_size29[] = {0};
  meth_meth_collectionsPrelude_size29->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size29);
  meth_meth_collectionsPrelude_size29->definitionModule = modulename;
  meth_meth_collectionsPrelude_size29->definitionLine = 175;
// method "isEmpty"
  block_savedest(obj6);
  Object closure32 = createclosure(1, "isEmpty");
  setclosureframe(closure32, stackframe);
  addtoclosure(closure32, var_source);
  struct UserObject *uo32 = (struct UserObject*)obj6;
  uo32->data[3] = (Object)closure32;
  Method *meth_meth_collectionsPrelude_isEmpty32 = addmethod2pos(obj6, "isEmpty", &meth_collectionsPrelude_isEmpty32, 3);
  int argcv_meth_collectionsPrelude_isEmpty32[] = {0};
  meth_meth_collectionsPrelude_isEmpty32->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty32);
  meth_meth_collectionsPrelude_isEmpty32->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty32->definitionLine = 176;
// method "asDebugString"
  block_savedest(obj6);
  Object closure35 = createclosure(1, "asDebugString");
  setclosureframe(closure35, stackframe);
  addtoclosure(closure35, var_source);
  struct UserObject *uo35 = (struct UserObject*)obj6;
  uo35->data[4] = (Object)closure35;
  Method *meth_meth_collectionsPrelude_asDebugString35 = addmethod2pos(obj6, "asDebugString", &meth_collectionsPrelude_asDebugString35, 4);
  int argcv_meth_collectionsPrelude_asDebugString35[] = {0};
  meth_meth_collectionsPrelude_asDebugString35->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString35);
  meth_meth_collectionsPrelude_asDebugString35->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString35->definitionLine = 177;
  sourceObject = obj6;
// Begin line 168
  setline(168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe44 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call45 = callmethod(*var_enumerable, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe44);
// compiled call node returning call45 (depth = 2)
  struct UserObject *obj6_uo = (struct UserObject *)obj6;
  obj6_uo->super = call45;
  sourceObject = obj6;
  sourceObject = obj6;
  sourceObject = obj6;
  sourceObject = obj6;
  objclass6 = obj6->class;
  objclass6->definitionModule = modulename;
  objclass6->definitionLine = 166;
  (*(struct UserObject *)self).data[0] = lowerouter6;
  self = oldself6;
  selfslot = oldselfslot6;
  stackframe = oldstackframe6;
  gc_frame_end(frame);
  return obj6;
}
Object meth_collectionsPrelude_asString56(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 187
  setline(187);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit58 == NULL) {
    strlit58 = alloc_String("");
    gc_root(strlit58);
  }
// compiled string node returning strlit58 (depth = 3)
  int op_slot_right_57 = gc_frame_newslot(strlit58);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  int op_slot_right_60 = gc_frame_newslot(*var_source);
// starting to compile string node (depth = 4)
  if (strlit62 == NULL) {
    strlit62 = alloc_String("an iterator over filtered ");
    gc_root(strlit62);
  }
// compiled string node returning strlit62 (depth = 4)
  int op_slot_left_60 = gc_frame_newslot(strlit62);
  params[0] = *var_source;
  partcv[0] = 1;
  Object opresult63 = callmethod(strlit62, "++", 1, partcv, params);
// compiled op node returning opresult63 (depth = 3)
  int op_slot_left_57 = gc_frame_newslot(opresult63);
  params[0] = strlit58;
  partcv[0] = 1;
  Object opresult64 = callmethod(opresult63, "++", 1, partcv, params);
// compiled op node returning opresult64 (depth = 2)
  gc_frame_end(frame);
  return opresult64;
}
Object meth_collectionsPrelude__apply72(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 193
  setline(193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe73 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe74 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call75 = callmethodflags(self, "nextAcceptableElement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe74);
// compiled call node returning call75 (depth = 6)
// compiled member node returning call75 (depth = 5)
  gc_frame_newslot(call75);
// call case 4: self request
  params[0] = call75;
  partcv[0] = 1;
  Object call76 = callmethodflags(self, "cache:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe73);
// compiled call node returning call76 (depth = 4)
// Begin line 194
  setline(194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe77 = gc_frame_new();
// starting to compile identifier node (depth = 5)
  Object bool78 = alloc_Boolean(1);
// compiled identifier node returning bool78 (depth = 5)
  gc_frame_newslot(bool78);
// call case 4: self request
  params[0] = bool78;
  partcv[0] = 1;
  Object call79 = callmethodflags(self, "cacheLoaded:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe77);
// compiled call node returning call79 (depth = 4)
  gc_frame_end(frame);
  return call79;
}
Object meth_collectionsPrelude__apply82(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ex = &(stackframe->slots[0]);
  *var_ex = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool83 = alloc_Boolean(0);
// compiled identifier node returning bool83 (depth = 5)
  block_return(realself, bool83);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_hasNext65(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 191
  setline(191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe67 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call68 = callmethodflags(self, "cacheLoaded", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe67);
// compiled call node returning call68 (depth = 4)
// compiled member node returning call68 (depth = 3)
  Object if66 = done;
  if (istrue(call68)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool69 = alloc_Boolean(1);
// compiled identifier node returning bool69 (depth = 4)
  return bool69;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if66 = undefined;
  } else {
  }
// compiled if node returning if66 (depth = 2)
// Begin line 192
  setline(192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile trycatch node (depth = 2)
// starting to compile block node (depth = 3)
  Object block71 = alloc_Block(NULL, NULL, "collectionsPrelude", 192);
  gc_frame_newslot(block71);
// method "_apply"
  block_savedest(block71);
  Object closure72 = createclosure(1, "_apply");
  setclosureframe(closure72, stackframe);
  addtoclosure(closure72, selfslot);
  struct UserObject *uo72 = (struct UserObject*)block71;
  uo72->data[0] = (Object)closure72;
  Method *meth_meth_collectionsPrelude__apply72 = addmethod2pos(block71, "_apply", &meth_collectionsPrelude__apply72, 0);
  int argcv_meth_collectionsPrelude__apply72[] = {0};
  meth_meth_collectionsPrelude__apply72->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply72);
  meth_meth_collectionsPrelude__apply72->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply72->definitionLine = 191;
// compiled block node returning block71 (depth = 3)
  int frame70 = gc_frame_new();
  gc_frame_newslot(block71);
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block81 = alloc_Block(NULL, NULL, "collectionsPrelude", 195);
  gc_frame_newslot(block81);
// method "_apply"
  block_savedest(block81);
  Object closure82 = createclosure(1, "_apply");
  setclosureframe(closure82, stackframe);
  addtoclosure(closure82, selfslot);
  struct UserObject *uo82 = (struct UserObject*)block81;
  uo82->data[0] = (Object)closure82;
  Method *meth_meth_collectionsPrelude__apply82 = addmethod2pos(block81, "_apply", &meth_collectionsPrelude__apply82, 0);
  int argcv_meth_collectionsPrelude__apply82[] = {1};
  meth_meth_collectionsPrelude__apply82->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply82);
  meth_meth_collectionsPrelude__apply82->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply82->definitionLine = 193;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe85 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe86 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit87 == NULL) {
    strlit87 = alloc_String("ex");
    gc_root(strlit87);
  }
// compiled string node returning strlit87 (depth = 6)
  gc_frame_newslot(strlit87);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe88 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call89 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe88);
// compiled call node returning call89 (depth = 7)
// compiled member node returning call89 (depth = 6)
  params[0] = strlit87;
  partcv[0] = 1;
  Object call90 = callmethod(call89, "new",
    1, partcv, params);
  gc_frame_end(callframe86);
// compiled call node returning call90 (depth = 5)
  gc_frame_newslot(call90);
// Begin line 195
  setline(195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_IteratorExhausted (depth = 5)
  gc_frame_newslot(*var_IteratorExhausted);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe91 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call92 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe91);
// compiled call node returning call92 (depth = 6)
// compiled member node returning call92 (depth = 5)
  params[0] = call90;
  params[1] = *var_IteratorExhausted;
  partcv[0] = 2;
  Object call93 = callmethod(call92, "new",
    1, partcv, params);
  gc_frame_end(callframe85);
// compiled call node returning call93 (depth = 4)
((struct UserObject *)block81)->data[1] = call93;
// compiled block node returning block81 (depth = 3)
  gc_frame_newslot(block81);
  params[0] = block81;
  setline(192);
  Object catchres70 = tryCatch(block71, params, 1,NULL);
  gc_frame_end(frame70);
// compiled trycatch node returning catchres70 (depth = 2)
// Begin line 196
  setline(196);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool94 = alloc_Boolean(1);
// compiled identifier node returning bool94 (depth = 3)
  return bool94;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_next95(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 199
  setline(199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe97 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe98 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call99 = callmethodflags(self, "cacheLoaded", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe98);
// compiled call node returning call99 (depth = 6)
// compiled member node returning call99 (depth = 5)
  partcv[0] = 0;
  Object call100 = callmethod(call99, "not",
    1, partcv, params);
  gc_frame_end(callframe97);
// compiled call node returning call100 (depth = 4)
// compiled member node returning call100 (depth = 3)
  Object if96 = done;
  if (istrue(call100)) {
// starting to compile call node (depth = 3)
  int callframe101 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe102 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call103 = callmethodflags(self, "nextAcceptableElement", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe102);
// compiled call node returning call103 (depth = 5)
// compiled member node returning call103 (depth = 4)
  gc_frame_newslot(call103);
// call case 4: self request
  params[0] = call103;
  partcv[0] = 1;
  Object call104 = callmethodflags(self, "cache:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe101);
// compiled call node returning call104 (depth = 3)
    gc_frame_newslot(call104);
    if96 = call104;
  } else {
  }
// compiled if node returning if96 (depth = 2)
// Begin line 200
  setline(200);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe105 = gc_frame_new();
// starting to compile identifier node (depth = 3)
  Object bool106 = alloc_Boolean(0);
// compiled identifier node returning bool106 (depth = 3)
  gc_frame_newslot(bool106);
// call case 4: self request
  params[0] = bool106;
  partcv[0] = 1;
  Object call107 = callmethodflags(self, "cacheLoaded:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe105);
// compiled call node returning call107 (depth = 2)
// Begin line 201
  setline(201);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe108 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call109 = callmethodflags(self, "cache", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe108);
// compiled call node returning call109 (depth = 4)
// compiled member node returning call109 (depth = 3)
  return call109;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply113(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 4)
  Object bool114 = alloc_Boolean(1);
// compiled identifier node returning bool114 (depth = 4)
  gc_frame_end(frame);
  return bool114;
}
Object meth_collectionsPrelude__apply117(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_predicate = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_outerNext = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "outerNext");
  Object *var_acceptable = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "acceptable");
// Begin line 207
  setline(207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe118 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe119 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call120 = callmethodflags(self, "sourceIterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe119);
// compiled call node returning call120 (depth = 8)
// compiled member node returning call120 (depth = 7)
  partcv[0] = 0;
  Object call121 = callmethod(call120, "next",
    1, partcv, params);
  gc_frame_end(callframe118);
// compiled call node returning call121 (depth = 6)
// compiled member node returning call121 (depth = 5)
  *var_outerNext = call121;
  if (call121 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 208
  setline(208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe122 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_outerNext (depth = 6)
  gc_frame_newslot(*var_outerNext);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_predicate (depth = 6)
  params[0] = *var_outerNext;
  partcv[0] = 1;
  Object call123 = callmethod(*var_predicate, "apply",
    1, partcv, params);
  gc_frame_end(callframe122);
// compiled call node returning call123 (depth = 5)
  *var_acceptable = call123;
  if (call123 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 209
  setline(209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_acceptable (depth = 5)
  Object if124 = done;
  if (istrue(*var_acceptable)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_outerNext (depth = 6)
  block_return(realself, *var_outerNext);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if124 = undefined;
  } else {
  }
// compiled if node returning if124 (depth = 4)
  gc_frame_end(frame);
  return if124;
}
Object meth_collectionsPrelude_nextAcceptableElement110(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "nextAcceptableElement");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_predicate = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for nextAcceptableElement (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for nextAcceptableElement");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe111 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block112 = alloc_Block(NULL, NULL, "collectionsPrelude", 206);
  gc_frame_newslot(block112);
// method "_apply"
  block_savedest(block112);
  Object closure113 = createclosure(1, "_apply");
  setclosureframe(closure113, stackframe);
  addtoclosure(closure113, selfslot);
  struct UserObject *uo113 = (struct UserObject*)block112;
  uo113->data[0] = (Object)closure113;
  Method *meth_meth_collectionsPrelude__apply113 = addmethod2pos(block112, "_apply", &meth_collectionsPrelude__apply113, 0);
  int argcv_meth_collectionsPrelude__apply113[] = {0};
  meth_meth_collectionsPrelude__apply113->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply113);
  meth_meth_collectionsPrelude__apply113->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply113->definitionLine = 201;
// compiled block node returning block112 (depth = 3)
  gc_frame_newslot(block112);
// starting to compile block node (depth = 3)
  Object block116 = alloc_Block(NULL, NULL, "collectionsPrelude", 206);
  gc_frame_newslot(block116);
// method "_apply"
  block_savedest(block116);
  Object closure117 = createclosure(2, "_apply");
  setclosureframe(closure117, stackframe);
  addtoclosure(closure117, var_predicate);
  addtoclosure(closure117, selfslot);
  struct UserObject *uo117 = (struct UserObject*)block116;
  uo117->data[0] = (Object)closure117;
  Method *meth_meth_collectionsPrelude__apply117 = addmethod2pos(block116, "_apply", &meth_collectionsPrelude__apply117, 0);
  int argcv_meth_collectionsPrelude__apply117[] = {0};
  meth_meth_collectionsPrelude__apply117->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply117);
  meth_meth_collectionsPrelude__apply117->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply117->definitionLine = 201;
// compiled block node returning block116 (depth = 3)
  gc_frame_newslot(block116);
// call case 5: prelude request
  params[0] = block112;
  params[1] = block116;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call126 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe111);
// compiled call node returning call126 (depth = 2)
  gc_frame_end(frame);
  return call126;
}
Object meth_collectionsPrelude_iterator50(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  Object *var_predicate = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject51 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj51 = alloc_userobj2(9,8, objclass51);
  gc_frame_newslot(obj51);
if (objclass51 == NULL) {
  glfree(obj51->class->name);
  obj51->class->name = "collectionsPrelude.lazySequenceOver()filteredBy.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj51, self, 0);
  addmethodreal(obj51,"outer", &reader_collectionsPrelude_outer_52);
  Object oldself51 = self;
  struct StackFrameObject *oldstackframe51 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe51);
  gc_frame_newslot((Object)stackframe);
  self = obj51;
  Object *oldselfslot51 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter51 = (*(struct UserObject *)self).data[0], lowerouter51 = thisouter51;
  if (inheritingObject51) {
    struct UserObject *inho51 = (struct UserObject *)inheritingObject51;
    while (inho51->super != GraceDefaultObject) inho51 = (struct UserObject *)inho51->super;
    inho51->super = obj51;
    self = inheritingObject51;
    *selfslot = self;
    lowerouter51 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter51;
  }
if (objclass51 == NULL) {
  Method *reader53 = addmethodrealflags(obj51, "cache",&reader_collectionsPrelude_cache_53, MFLAG_CONFIDENTIAL);
  Method *writer53 = addmethodrealflags(obj51, "cache:=",&writer_collectionsPrelude_cache_53, MFLAG_CONFIDENTIAL);
  reader53->definitionModule = modulename;
  writer53->definitionModule = modulename;
  reader53->definitionLine = 184;
  writer53->definitionLine = 184;
}
obj51->flags |= OFLAG_MUTABLE;
adddatum2(obj51, alloc_Undefined(), 1);
if (objclass51 == NULL) {
  Method *reader54 = addmethodrealflags(obj51, "cacheLoaded",&reader_collectionsPrelude_cacheLoaded_54, MFLAG_CONFIDENTIAL);
  Method *writer54 = addmethodrealflags(obj51, "cacheLoaded:=",&writer_collectionsPrelude_cacheLoaded_54, MFLAG_CONFIDENTIAL);
  reader54->definitionModule = modulename;
  writer54->definitionModule = modulename;
  reader54->definitionLine = 185;
  writer54->definitionLine = 185;
}
obj51->flags |= OFLAG_MUTABLE;
adddatum2(obj51, alloc_Undefined(), 2);
if (objclass51 == NULL) {
  Method *reader55 = addmethodrealflags(obj51, "sourceIterator",&reader_collectionsPrelude_sourceIterator_55, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader55->definitionModule = modulename;
  reader55->definitionLine = 186;
}
adddatum2(obj51, alloc_Undefined(), 3);
// method "asString"
  block_savedest(obj51);
  Object closure56 = createclosure(1, "asString");
  setclosureframe(closure56, stackframe);
  addtoclosure(closure56, var_source);
  struct UserObject *uo56 = (struct UserObject*)obj51;
  uo56->data[4] = (Object)closure56;
  Method *meth_meth_collectionsPrelude_asString56 = addmethod2pos(obj51, "asString", &meth_collectionsPrelude_asString56, 4);
  int argcv_meth_collectionsPrelude_asString56[] = {0};
  meth_meth_collectionsPrelude_asString56->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString56);
  meth_meth_collectionsPrelude_asString56->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString56->definitionLine = 187;
// method "hasNext"
  block_savedest(obj51);
  Object closure65 = createclosure(1, "hasNext");
  setclosureframe(closure65, stackframe);
  addtoclosure(closure65, var_IteratorExhausted);
  struct UserObject *uo65 = (struct UserObject*)obj51;
  uo65->data[5] = (Object)closure65;
  Method *meth_meth_collectionsPrelude_hasNext65 = addmethod2pos(obj51, "hasNext", &meth_collectionsPrelude_hasNext65, 5);
  int argcv_meth_collectionsPrelude_hasNext65[] = {0};
  meth_meth_collectionsPrelude_hasNext65->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext65);
  meth_meth_collectionsPrelude_hasNext65->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext65->definitionLine = 188;
// method "next"
  struct UserObject *uo95 = (struct UserObject*)obj51;
  uo95->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_next95 = addmethod2pos(obj51, "next", &meth_collectionsPrelude_next95, 6);
  int argcv_meth_collectionsPrelude_next95[] = {0};
  meth_meth_collectionsPrelude_next95->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next95);
  meth_meth_collectionsPrelude_next95->definitionModule = modulename;
  meth_meth_collectionsPrelude_next95->definitionLine = 198;
// method "nextAcceptableElement"
  block_savedest(obj51);
  Object closure110 = createclosure(1, "nextAcceptableElement");
  setclosureframe(closure110, stackframe);
  addtoclosure(closure110, var_predicate);
  struct UserObject *uo110 = (struct UserObject*)obj51;
  uo110->data[7] = (Object)closure110;
  Method *meth_meth_collectionsPrelude_nextAcceptableElement110 = addmethod2pos(obj51, "nextAcceptableElement", &meth_collectionsPrelude_nextAcceptableElement110, 7);
  int argcv_meth_collectionsPrelude_nextAcceptableElement110[] = {0};
  meth_meth_collectionsPrelude_nextAcceptableElement110->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_nextAcceptableElement110);
  meth_meth_collectionsPrelude_nextAcceptableElement110->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_nextAcceptableElement110->definitionModule = modulename;
  meth_meth_collectionsPrelude_nextAcceptableElement110->definitionLine = 203;
  sourceObject = obj51;
  adddatum2(obj51, undefined, 1);
  sourceObject = obj51;
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool127 = alloc_Boolean(0);
// compiled identifier node returning bool127 (depth = 2)
  adddatum2(obj51, bool127, 2);
  sourceObject = obj51;
// Begin line 186
  setline(186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe128 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  partcv[0] = 0;
  Object call129 = callmethod(*var_source, "iterator",
    1, partcv, params);
  gc_frame_end(callframe128);
// compiled call node returning call129 (depth = 3)
// compiled member node returning call129 (depth = 2)
  adddatum2(obj51, call129, 3);
  sourceObject = obj51;
  sourceObject = obj51;
  sourceObject = obj51;
  sourceObject = obj51;
  objclass51 = obj51->class;
  objclass51->definitionModule = modulename;
  objclass51->definitionLine = 183;
  (*(struct UserObject *)self).data[0] = lowerouter51;
  self = oldself51;
  selfslot = oldselfslot51;
  stackframe = oldstackframe51;
  gc_frame_end(frame);
  return obj51;
}
Object meth_collectionsPrelude_iterator50_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  Object *var_predicate = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject51 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj51 = alloc_userobj2(9,8, objclass51);
  gc_frame_newslot(obj51);
if (objclass51 == NULL) {
  glfree(obj51->class->name);
  obj51->class->name = "collectionsPrelude.lazySequenceOver()filteredBy.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj51, self, 0);
  addmethodreal(obj51,"outer", &reader_collectionsPrelude_outer_52);
  Object oldself51 = self;
  struct StackFrameObject *oldstackframe51 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe51);
  gc_frame_newslot((Object)stackframe);
  self = obj51;
  Object *oldselfslot51 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter51 = (*(struct UserObject *)self).data[0], lowerouter51 = thisouter51;
  if (inheritingObject51) {
    struct UserObject *inho51 = (struct UserObject *)inheritingObject51;
    while (inho51->super != GraceDefaultObject) inho51 = (struct UserObject *)inho51->super;
    inho51->super = obj51;
    self = inheritingObject51;
    *selfslot = self;
    lowerouter51 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter51;
  }
if (objclass51 == NULL) {
  Method *reader53 = addmethodrealflags(obj51, "cache",&reader_collectionsPrelude_cache_53, MFLAG_CONFIDENTIAL);
  Method *writer53 = addmethodrealflags(obj51, "cache:=",&writer_collectionsPrelude_cache_53, MFLAG_CONFIDENTIAL);
  reader53->definitionModule = modulename;
  writer53->definitionModule = modulename;
  reader53->definitionLine = 184;
  writer53->definitionLine = 184;
}
obj51->flags |= OFLAG_MUTABLE;
adddatum2(obj51, alloc_Undefined(), 1);
if (objclass51 == NULL) {
  Method *reader54 = addmethodrealflags(obj51, "cacheLoaded",&reader_collectionsPrelude_cacheLoaded_54, MFLAG_CONFIDENTIAL);
  Method *writer54 = addmethodrealflags(obj51, "cacheLoaded:=",&writer_collectionsPrelude_cacheLoaded_54, MFLAG_CONFIDENTIAL);
  reader54->definitionModule = modulename;
  writer54->definitionModule = modulename;
  reader54->definitionLine = 185;
  writer54->definitionLine = 185;
}
obj51->flags |= OFLAG_MUTABLE;
adddatum2(obj51, alloc_Undefined(), 2);
if (objclass51 == NULL) {
  Method *reader55 = addmethodrealflags(obj51, "sourceIterator",&reader_collectionsPrelude_sourceIterator_55, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader55->definitionModule = modulename;
  reader55->definitionLine = 186;
}
adddatum2(obj51, alloc_Undefined(), 3);
// method "asString"
  block_savedest(obj51);
  Object closure56 = createclosure(1, "asString");
  setclosureframe(closure56, stackframe);
  addtoclosure(closure56, var_source);
  struct UserObject *uo56 = (struct UserObject*)obj51;
  uo56->data[4] = (Object)closure56;
  Method *meth_meth_collectionsPrelude_asString56 = addmethod2pos(obj51, "asString", &meth_collectionsPrelude_asString56, 4);
  int argcv_meth_collectionsPrelude_asString56[] = {0};
  meth_meth_collectionsPrelude_asString56->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString56);
  meth_meth_collectionsPrelude_asString56->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString56->definitionLine = 187;
// method "hasNext"
  block_savedest(obj51);
  Object closure65 = createclosure(1, "hasNext");
  setclosureframe(closure65, stackframe);
  addtoclosure(closure65, var_IteratorExhausted);
  struct UserObject *uo65 = (struct UserObject*)obj51;
  uo65->data[5] = (Object)closure65;
  Method *meth_meth_collectionsPrelude_hasNext65 = addmethod2pos(obj51, "hasNext", &meth_collectionsPrelude_hasNext65, 5);
  int argcv_meth_collectionsPrelude_hasNext65[] = {0};
  meth_meth_collectionsPrelude_hasNext65->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext65);
  meth_meth_collectionsPrelude_hasNext65->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext65->definitionLine = 188;
// method "next"
  struct UserObject *uo95 = (struct UserObject*)obj51;
  uo95->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_next95 = addmethod2pos(obj51, "next", &meth_collectionsPrelude_next95, 6);
  int argcv_meth_collectionsPrelude_next95[] = {0};
  meth_meth_collectionsPrelude_next95->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next95);
  meth_meth_collectionsPrelude_next95->definitionModule = modulename;
  meth_meth_collectionsPrelude_next95->definitionLine = 198;
// method "nextAcceptableElement"
  block_savedest(obj51);
  Object closure110 = createclosure(1, "nextAcceptableElement");
  setclosureframe(closure110, stackframe);
  addtoclosure(closure110, var_predicate);
  struct UserObject *uo110 = (struct UserObject*)obj51;
  uo110->data[7] = (Object)closure110;
  Method *meth_meth_collectionsPrelude_nextAcceptableElement110 = addmethod2pos(obj51, "nextAcceptableElement", &meth_collectionsPrelude_nextAcceptableElement110, 7);
  int argcv_meth_collectionsPrelude_nextAcceptableElement110[] = {0};
  meth_meth_collectionsPrelude_nextAcceptableElement110->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_nextAcceptableElement110);
  meth_meth_collectionsPrelude_nextAcceptableElement110->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_nextAcceptableElement110->definitionModule = modulename;
  meth_meth_collectionsPrelude_nextAcceptableElement110->definitionLine = 203;
  sourceObject = obj51;
  adddatum2(obj51, undefined, 1);
  sourceObject = obj51;
// Begin line 185
  setline(185);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool127 = alloc_Boolean(0);
// compiled identifier node returning bool127 (depth = 2)
  adddatum2(obj51, bool127, 2);
  sourceObject = obj51;
// Begin line 186
  setline(186);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe128 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  partcv[0] = 0;
  Object call129 = callmethod(*var_source, "iterator",
    1, partcv, params);
  gc_frame_end(callframe128);
// compiled call node returning call129 (depth = 3)
// compiled member node returning call129 (depth = 2)
  adddatum2(obj51, call129, 3);
  sourceObject = obj51;
  sourceObject = obj51;
  sourceObject = obj51;
  sourceObject = obj51;
  objclass51 = obj51->class;
  objclass51->definitionModule = modulename;
  objclass51->definitionLine = 183;
  (*(struct UserObject *)self).data[0] = lowerouter51;
  self = oldself51;
  selfslot = oldselfslot51;
  stackframe = oldstackframe51;
  gc_frame_end(frame);
  return obj51;
}
Object meth_collectionsPrelude_asDebugString131(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_source = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 213
  setline(213);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit133 == NULL) {
    strlit133 = alloc_String("");
    gc_root(strlit133);
  }
// compiled string node returning strlit133 (depth = 3)
  int op_slot_right_132 = gc_frame_newslot(strlit133);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_source (depth = 4)
  int op_slot_right_135 = gc_frame_newslot(*var_source);
// starting to compile string node (depth = 4)
  if (strlit137 == NULL) {
    strlit137 = alloc_String("a lazy sequence filtering ");
    gc_root(strlit137);
  }
// compiled string node returning strlit137 (depth = 4)
  int op_slot_left_135 = gc_frame_newslot(strlit137);
  params[0] = *var_source;
  partcv[0] = 1;
  Object opresult138 = callmethod(strlit137, "++", 1, partcv, params);
// compiled op node returning opresult138 (depth = 3)
  int op_slot_left_132 = gc_frame_newslot(opresult138);
  params[0] = strlit133;
  partcv[0] = 1;
  Object opresult139 = callmethod(opresult138, "++", 1, partcv, params);
// compiled op node returning opresult139 (depth = 2)
  gc_frame_end(frame);
  return opresult139;
}
Object meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy47(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lazySequenceOver()filteredBy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lazySequenceOver()filteredBy");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lazySequenceOver()filteredBy");
  Object params[1];
  int partcv[2];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  Object *var_enumerable = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for lazySequenceOver()filteredBy (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_source = &(stackframe->slots[0]);
  *var_source = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for lazySequenceOver");
  Object *var_predicate = &(stackframe->slots[1]);
  *var_predicate = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for filteredBy");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 2 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject48 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj48 = alloc_userobj2(3,4, objclass48);
  gc_frame_newslot(obj48);
if (objclass48 == NULL) {
  glfree(obj48->class->name);
  obj48->class->name = "collectionsPrelude.lazySequenceOver()filteredBy";
}
// OBJECT OUTER DEC outer
  adddatum2(obj48, self, 0);
  addmethodreal(obj48,"outer", &reader_collectionsPrelude_outer_49);
  Object oldself48 = self;
  struct StackFrameObject *oldstackframe48 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe48);
  gc_frame_newslot((Object)stackframe);
  self = obj48;
  Object *oldselfslot48 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter48 = (*(struct UserObject *)self).data[0], lowerouter48 = thisouter48;
  if (inheritingObject48) {
    struct UserObject *inho48 = (struct UserObject *)inheritingObject48;
    while (inho48->super != GraceDefaultObject) inho48 = (struct UserObject *)inho48->super;
    inho48->super = obj48;
    self = inheritingObject48;
    *selfslot = self;
    lowerouter48 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter48;
  }
// method "iterator"
  block_savedest(obj48);
  Object closure50 = createclosure(3, "iterator");
  setclosureframe(closure50, stackframe);
  addtoclosure(closure50, var_source);
  addtoclosure(closure50, var_IteratorExhausted);
  addtoclosure(closure50, var_predicate);
  struct UserObject *uo50 = (struct UserObject*)obj48;
  uo50->data[1] = (Object)closure50;
  Method *meth_meth_collectionsPrelude_iterator50 = addmethod2pos(obj48, "iterator", &meth_collectionsPrelude_iterator50, 1);
  int argcv_meth_collectionsPrelude_iterator50[] = {0};
  meth_meth_collectionsPrelude_iterator50->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator50);
  meth_meth_collectionsPrelude_iterator50->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator50->definitionLine = 183;
  block_savedest(obj48);
  Object closure130 = createclosure(3, "iterator()object");
  setclosureframe(closure130, stackframe);
  addtoclosure(closure130, var_source);
  addtoclosure(closure130, var_IteratorExhausted);
  addtoclosure(closure130, var_predicate);
  Method *meth_meth_collectionsPrelude_iterator50_object = addmethod2pos(obj48, "iterator()object", &meth_collectionsPrelude_iterator50_object, 1);
  meth_meth_collectionsPrelude_iterator50_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator50_object->definitionLine = 183;
// method "asDebugString"
  block_savedest(obj48);
  Object closure131 = createclosure(1, "asDebugString");
  setclosureframe(closure131, stackframe);
  addtoclosure(closure131, var_source);
  struct UserObject *uo131 = (struct UserObject*)obj48;
  uo131->data[2] = (Object)closure131;
  Method *meth_meth_collectionsPrelude_asDebugString131 = addmethod2pos(obj48, "asDebugString", &meth_collectionsPrelude_asDebugString131, 2);
  int argcv_meth_collectionsPrelude_asDebugString131[] = {0};
  meth_meth_collectionsPrelude_asDebugString131->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString131);
  meth_meth_collectionsPrelude_asDebugString131->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString131->definitionLine = 213;
  sourceObject = obj48;
// Begin line 182
  setline(182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe140 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call141 = callmethod(*var_enumerable, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe140);
// compiled call node returning call141 (depth = 2)
  struct UserObject *obj48_uo = (struct UserObject *)obj48;
  obj48_uo->super = call141;
  sourceObject = obj48;
  sourceObject = obj48;
  objclass48 = obj48->class;
  objclass48->definitionModule = modulename;
  objclass48->definitionLine = 180;
  (*(struct UserObject *)self).data[0] = lowerouter48;
  self = oldself48;
  selfslot = oldselfslot48;
  stackframe = oldstackframe48;
  gc_frame_end(frame);
  return obj48;
}
Object meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy47_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lazySequenceOver()filteredBy()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lazySequenceOver()filteredBy()object");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method lazySequenceOver()filteredBy()object");
  Object params[1];
  int partcv[2];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  Object *var_enumerable = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for lazySequenceOver()filteredBy (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_source = &(stackframe->slots[0]);
  *var_source = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for lazySequenceOver");
  Object *var_predicate = &(stackframe->slots[1]);
  *var_predicate = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for filteredBy");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 2 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject48 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj48 = alloc_userobj2(3,4, objclass48);
  gc_frame_newslot(obj48);
if (objclass48 == NULL) {
  glfree(obj48->class->name);
  obj48->class->name = "collectionsPrelude.lazySequenceOver()filteredBy";
}
// OBJECT OUTER DEC outer
  adddatum2(obj48, self, 0);
  addmethodreal(obj48,"outer", &reader_collectionsPrelude_outer_49);
  Object oldself48 = self;
  struct StackFrameObject *oldstackframe48 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe48);
  gc_frame_newslot((Object)stackframe);
  self = obj48;
  Object *oldselfslot48 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter48 = (*(struct UserObject *)self).data[0], lowerouter48 = thisouter48;
  if (inheritingObject48) {
    struct UserObject *inho48 = (struct UserObject *)inheritingObject48;
    while (inho48->super != GraceDefaultObject) inho48 = (struct UserObject *)inho48->super;
    inho48->super = obj48;
    self = inheritingObject48;
    *selfslot = self;
    lowerouter48 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter48;
  }
// method "iterator"
  block_savedest(obj48);
  Object closure50 = createclosure(3, "iterator");
  setclosureframe(closure50, stackframe);
  addtoclosure(closure50, var_source);
  addtoclosure(closure50, var_IteratorExhausted);
  addtoclosure(closure50, var_predicate);
  struct UserObject *uo50 = (struct UserObject*)obj48;
  uo50->data[1] = (Object)closure50;
  Method *meth_meth_collectionsPrelude_iterator50 = addmethod2pos(obj48, "iterator", &meth_collectionsPrelude_iterator50, 1);
  int argcv_meth_collectionsPrelude_iterator50[] = {0};
  meth_meth_collectionsPrelude_iterator50->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator50);
  meth_meth_collectionsPrelude_iterator50->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator50->definitionLine = 183;
  block_savedest(obj48);
  Object closure130 = createclosure(3, "iterator()object");
  setclosureframe(closure130, stackframe);
  addtoclosure(closure130, var_source);
  addtoclosure(closure130, var_IteratorExhausted);
  addtoclosure(closure130, var_predicate);
  Method *meth_meth_collectionsPrelude_iterator50_object = addmethod2pos(obj48, "iterator()object", &meth_collectionsPrelude_iterator50_object, 1);
  meth_meth_collectionsPrelude_iterator50_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator50_object->definitionLine = 183;
// method "asDebugString"
  block_savedest(obj48);
  Object closure131 = createclosure(1, "asDebugString");
  setclosureframe(closure131, stackframe);
  addtoclosure(closure131, var_source);
  struct UserObject *uo131 = (struct UserObject*)obj48;
  uo131->data[2] = (Object)closure131;
  Method *meth_meth_collectionsPrelude_asDebugString131 = addmethod2pos(obj48, "asDebugString", &meth_collectionsPrelude_asDebugString131, 2);
  int argcv_meth_collectionsPrelude_asDebugString131[] = {0};
  meth_meth_collectionsPrelude_asDebugString131->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString131);
  meth_meth_collectionsPrelude_asDebugString131->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString131->definitionLine = 213;
  sourceObject = obj48;
// Begin line 182
  setline(182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe140 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call141 = callmethod(*var_enumerable, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe140);
// compiled call node returning call141 (depth = 2)
  struct UserObject *obj48_uo = (struct UserObject *)obj48;
  obj48_uo->super = call141;
  sourceObject = obj48;
  sourceObject = obj48;
  objclass48 = obj48->class;
  objclass48->definitionModule = modulename;
  objclass48->definitionLine = 180;
  (*(struct UserObject *)self).data[0] = lowerouter48;
  self = oldself48;
  selfslot = oldselfslot48;
  stackframe = oldstackframe48;
  gc_frame_end(frame);
  return obj48;
}
Object meth_collectionsPrelude_next146(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_left = getfromclosure(closure, 0);
  Object *var_right = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe148 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_left (depth = 5)
  partcv[0] = 0;
  Object call149 = callmethod(*var_left, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe148);
// compiled call node returning call149 (depth = 4)
// compiled member node returning call149 (depth = 3)
  Object if147 = done;
  if (istrue(call149)) {
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe150 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_left (depth = 5)
  partcv[0] = 0;
  Object call151 = callmethod(*var_left, "next",
    1, partcv, params);
  gc_frame_end(callframe150);
// compiled call node returning call151 (depth = 4)
// compiled member node returning call151 (depth = 3)
    gc_frame_newslot(call151);
    if147 = call151;
  } else {
// Begin line 221
  setline(221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe152 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_right (depth = 5)
  partcv[0] = 0;
  Object call153 = callmethod(*var_right, "next",
    1, partcv, params);
  gc_frame_end(callframe152);
// compiled call node returning call153 (depth = 4)
// compiled member node returning call153 (depth = 3)
    gc_frame_newslot(call153);
    if147 = call153;
  }
// compiled if node returning if147 (depth = 2)
  gc_frame_end(frame);
  return if147;
}
Object meth_collectionsPrelude_hasNext154(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_left = getfromclosure(closure, 0);
  Object *var_right = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 225
  setline(225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe156 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_left (depth = 5)
  partcv[0] = 0;
  Object call157 = callmethod(*var_left, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe156);
// compiled call node returning call157 (depth = 4)
// compiled member node returning call157 (depth = 3)
  Object if155 = done;
  if (istrue(call157)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool158 = alloc_Boolean(1);
// compiled identifier node returning bool158 (depth = 4)
  return bool158;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if155 = undefined;
  } else {
  }
// compiled if node returning if155 (depth = 2)
// Begin line 226
  setline(226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe159 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_right (depth = 5)
  partcv[0] = 0;
  Object call160 = callmethod(*var_right, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe159);
// compiled call node returning call160 (depth = 4)
// compiled member node returning call160 (depth = 3)
  return call160;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_asDebugString161(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_right = getfromclosure(closure, 0);
  Object *var_left = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 228
  setline(228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit163 == NULL) {
    strlit163 = alloc_String("");
    gc_root(strlit163);
  }
// compiled string node returning strlit163 (depth = 3)
  int op_slot_right_162 = gc_frame_newslot(strlit163);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_right (depth = 4)
  int op_slot_right_165 = gc_frame_newslot(*var_right);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit168 == NULL) {
    strlit168 = alloc_String(" and ");
    gc_root(strlit168);
  }
// compiled string node returning strlit168 (depth = 5)
  int op_slot_right_167 = gc_frame_newslot(strlit168);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_left (depth = 6)
  int op_slot_right_170 = gc_frame_newslot(*var_left);
// starting to compile string node (depth = 6)
  if (strlit172 == NULL) {
    strlit172 = alloc_String("iteratorConcat of ");
    gc_root(strlit172);
  }
// compiled string node returning strlit172 (depth = 6)
  int op_slot_left_170 = gc_frame_newslot(strlit172);
  params[0] = *var_left;
  partcv[0] = 1;
  Object opresult173 = callmethod(strlit172, "++", 1, partcv, params);
// compiled op node returning opresult173 (depth = 5)
  int op_slot_left_167 = gc_frame_newslot(opresult173);
  params[0] = strlit168;
  partcv[0] = 1;
  Object opresult174 = callmethod(opresult173, "++", 1, partcv, params);
// compiled op node returning opresult174 (depth = 4)
  int op_slot_left_165 = gc_frame_newslot(opresult174);
  params[0] = *var_right;
  partcv[0] = 1;
  Object opresult175 = callmethod(opresult174, "++", 1, partcv, params);
// compiled op node returning opresult175 (depth = 3)
  int op_slot_left_162 = gc_frame_newslot(opresult175);
  params[0] = strlit163;
  partcv[0] = 1;
  Object opresult176 = callmethod(opresult175, "++", 1, partcv, params);
// compiled op node returning opresult176 (depth = 2)
  gc_frame_end(frame);
  return opresult176;
}
Object meth_collectionsPrelude_asString177(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit178 == NULL) {
    strlit178 = alloc_String("an iterator over a concatenation");
    gc_root(strlit178);
  }
// compiled string node returning strlit178 (depth = 2)
  gc_frame_end(frame);
  return strlit178;
}
Object meth_collectionsPrelude_iteratorConcat143(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iteratorConcat");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method iteratorConcat");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iteratorConcat (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_left = &(stackframe->slots[0]);
  *var_left = args[curarg];
  curarg++;
  Object *var_right = &(stackframe->slots[1]);
  *var_right = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for iteratorConcat");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject144 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj144 = alloc_userobj2(4,5, objclass144);
  gc_frame_newslot(obj144);
if (objclass144 == NULL) {
  glfree(obj144->class->name);
  obj144->class->name = "collectionsPrelude.iteratorConcat";
}
// OBJECT OUTER DEC outer
  adddatum2(obj144, self, 0);
  addmethodreal(obj144,"outer", &reader_collectionsPrelude_outer_145);
  Object oldself144 = self;
  struct StackFrameObject *oldstackframe144 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe144);
  gc_frame_newslot((Object)stackframe);
  self = obj144;
  Object *oldselfslot144 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter144 = (*(struct UserObject *)self).data[0], lowerouter144 = thisouter144;
  if (inheritingObject144) {
    struct UserObject *inho144 = (struct UserObject *)inheritingObject144;
    while (inho144->super != GraceDefaultObject) inho144 = (struct UserObject *)inho144->super;
    inho144->super = obj144;
    self = inheritingObject144;
    *selfslot = self;
    lowerouter144 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter144;
  }
// method "next"
  block_savedest(obj144);
  Object closure146 = createclosure(2, "next");
  setclosureframe(closure146, stackframe);
  addtoclosure(closure146, var_left);
  addtoclosure(closure146, var_right);
  struct UserObject *uo146 = (struct UserObject*)obj144;
  uo146->data[1] = (Object)closure146;
  Method *meth_meth_collectionsPrelude_next146 = addmethod2pos(obj144, "next", &meth_collectionsPrelude_next146, 1);
  int argcv_meth_collectionsPrelude_next146[] = {0};
  meth_meth_collectionsPrelude_next146->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next146);
  meth_meth_collectionsPrelude_next146->definitionModule = modulename;
  meth_meth_collectionsPrelude_next146->definitionLine = 217;
// method "hasNext"
  block_savedest(obj144);
  Object closure154 = createclosure(2, "hasNext");
  setclosureframe(closure154, stackframe);
  addtoclosure(closure154, var_left);
  addtoclosure(closure154, var_right);
  struct UserObject *uo154 = (struct UserObject*)obj144;
  uo154->data[2] = (Object)closure154;
  Method *meth_meth_collectionsPrelude_hasNext154 = addmethod2pos(obj144, "hasNext", &meth_collectionsPrelude_hasNext154, 2);
  int argcv_meth_collectionsPrelude_hasNext154[] = {0};
  meth_meth_collectionsPrelude_hasNext154->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext154);
  meth_meth_collectionsPrelude_hasNext154->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext154->definitionLine = 224;
// method "asDebugString"
  block_savedest(obj144);
  Object closure161 = createclosure(2, "asDebugString");
  setclosureframe(closure161, stackframe);
  addtoclosure(closure161, var_right);
  addtoclosure(closure161, var_left);
  struct UserObject *uo161 = (struct UserObject*)obj144;
  uo161->data[3] = (Object)closure161;
  Method *meth_meth_collectionsPrelude_asDebugString161 = addmethod2pos(obj144, "asDebugString", &meth_collectionsPrelude_asDebugString161, 3);
  int argcv_meth_collectionsPrelude_asDebugString161[] = {0};
  meth_meth_collectionsPrelude_asDebugString161->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString161);
  meth_meth_collectionsPrelude_asDebugString161->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString161->definitionLine = 228;
// method "asString"
  struct UserObject *uo177 = (struct UserObject*)obj144;
  uo177->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString177 = addmethod2pos(obj144, "asString", &meth_collectionsPrelude_asString177, 4);
  int argcv_meth_collectionsPrelude_asString177[] = {0};
  meth_meth_collectionsPrelude_asString177->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString177);
  meth_meth_collectionsPrelude_asString177->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString177->definitionLine = 229;
  sourceObject = obj144;
  sourceObject = obj144;
  sourceObject = obj144;
  sourceObject = obj144;
  objclass144 = obj144->class;
  objclass144->definitionModule = modulename;
  objclass144->definitionLine = 216;
  (*(struct UserObject *)self).data[0] = lowerouter144;
  self = oldself144;
  selfslot = oldselfslot144;
  stackframe = oldstackframe144;
  gc_frame_end(frame);
  return obj144;
}
Object meth_collectionsPrelude_iteratorConcat143_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iteratorConcat()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method iteratorConcat()object");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iteratorConcat (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_left = &(stackframe->slots[0]);
  *var_left = args[curarg];
  curarg++;
  Object *var_right = &(stackframe->slots[1]);
  *var_right = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for iteratorConcat");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject144 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj144 = alloc_userobj2(4,5, objclass144);
  gc_frame_newslot(obj144);
if (objclass144 == NULL) {
  glfree(obj144->class->name);
  obj144->class->name = "collectionsPrelude.iteratorConcat";
}
// OBJECT OUTER DEC outer
  adddatum2(obj144, self, 0);
  addmethodreal(obj144,"outer", &reader_collectionsPrelude_outer_145);
  Object oldself144 = self;
  struct StackFrameObject *oldstackframe144 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe144);
  gc_frame_newslot((Object)stackframe);
  self = obj144;
  Object *oldselfslot144 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter144 = (*(struct UserObject *)self).data[0], lowerouter144 = thisouter144;
  if (inheritingObject144) {
    struct UserObject *inho144 = (struct UserObject *)inheritingObject144;
    while (inho144->super != GraceDefaultObject) inho144 = (struct UserObject *)inho144->super;
    inho144->super = obj144;
    self = inheritingObject144;
    *selfslot = self;
    lowerouter144 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter144;
  }
// method "next"
  block_savedest(obj144);
  Object closure146 = createclosure(2, "next");
  setclosureframe(closure146, stackframe);
  addtoclosure(closure146, var_left);
  addtoclosure(closure146, var_right);
  struct UserObject *uo146 = (struct UserObject*)obj144;
  uo146->data[1] = (Object)closure146;
  Method *meth_meth_collectionsPrelude_next146 = addmethod2pos(obj144, "next", &meth_collectionsPrelude_next146, 1);
  int argcv_meth_collectionsPrelude_next146[] = {0};
  meth_meth_collectionsPrelude_next146->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next146);
  meth_meth_collectionsPrelude_next146->definitionModule = modulename;
  meth_meth_collectionsPrelude_next146->definitionLine = 217;
// method "hasNext"
  block_savedest(obj144);
  Object closure154 = createclosure(2, "hasNext");
  setclosureframe(closure154, stackframe);
  addtoclosure(closure154, var_left);
  addtoclosure(closure154, var_right);
  struct UserObject *uo154 = (struct UserObject*)obj144;
  uo154->data[2] = (Object)closure154;
  Method *meth_meth_collectionsPrelude_hasNext154 = addmethod2pos(obj144, "hasNext", &meth_collectionsPrelude_hasNext154, 2);
  int argcv_meth_collectionsPrelude_hasNext154[] = {0};
  meth_meth_collectionsPrelude_hasNext154->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext154);
  meth_meth_collectionsPrelude_hasNext154->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext154->definitionLine = 224;
// method "asDebugString"
  block_savedest(obj144);
  Object closure161 = createclosure(2, "asDebugString");
  setclosureframe(closure161, stackframe);
  addtoclosure(closure161, var_right);
  addtoclosure(closure161, var_left);
  struct UserObject *uo161 = (struct UserObject*)obj144;
  uo161->data[3] = (Object)closure161;
  Method *meth_meth_collectionsPrelude_asDebugString161 = addmethod2pos(obj144, "asDebugString", &meth_collectionsPrelude_asDebugString161, 3);
  int argcv_meth_collectionsPrelude_asDebugString161[] = {0};
  meth_meth_collectionsPrelude_asDebugString161->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString161);
  meth_meth_collectionsPrelude_asDebugString161->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString161->definitionLine = 228;
// method "asString"
  struct UserObject *uo177 = (struct UserObject*)obj144;
  uo177->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString177 = addmethod2pos(obj144, "asString", &meth_collectionsPrelude_asString177, 4);
  int argcv_meth_collectionsPrelude_asString177[] = {0};
  meth_meth_collectionsPrelude_asString177->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString177);
  meth_meth_collectionsPrelude_asString177->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString177->definitionLine = 229;
  sourceObject = obj144;
  sourceObject = obj144;
  sourceObject = obj144;
  sourceObject = obj144;
  objclass144 = obj144->class;
  objclass144->definitionModule = modulename;
  objclass144->definitionLine = 216;
  (*(struct UserObject *)self).data[0] = lowerouter144;
  self = oldself144;
  selfslot = oldselfslot144;
  stackframe = oldstackframe144;
  gc_frame_end(frame);
  return obj144;
}
Object meth_collectionsPrelude_iterator183(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_left = getfromclosure(closure, 0);
  Object *var_right = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 234
  setline(234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe184 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe185 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_left (depth = 5)
  partcv[0] = 0;
  Object call186 = callmethod(*var_left, "iterator",
    1, partcv, params);
  gc_frame_end(callframe185);
// compiled call node returning call186 (depth = 4)
// compiled member node returning call186 (depth = 3)
  gc_frame_newslot(call186);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe187 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_right (depth = 5)
  partcv[0] = 0;
  Object call188 = callmethod(*var_right, "iterator",
    1, partcv, params);
  gc_frame_end(callframe187);
// compiled call node returning call188 (depth = 4)
// compiled member node returning call188 (depth = 3)
  gc_frame_newslot(call188);
// call case 2: outer request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe189 = gc_frame_new();
// call case 3: self.outer request
  Object call190 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe189);
// compiled call node returning call190 (depth = 4)
// compiled member node returning call190 (depth = 3)
  params[0] = call186;
  params[1] = call188;
  partcv[0] = 2;
  Object call191 = callmethodflags(call190, "iteratorConcat", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe184);
// compiled call node returning call191 (depth = 2)
  gc_frame_end(frame);
  return call191;
}
Object meth_collectionsPrelude_asDebugString192(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_right = getfromclosure(closure, 0);
  Object *var_left = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 236
  setline(236);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit194 == NULL) {
    strlit194 = alloc_String("");
    gc_root(strlit194);
  }
// compiled string node returning strlit194 (depth = 3)
  int op_slot_right_193 = gc_frame_newslot(strlit194);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_right (depth = 4)
  int op_slot_right_196 = gc_frame_newslot(*var_right);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit199 == NULL) {
    strlit199 = alloc_String(" and ");
    gc_root(strlit199);
  }
// compiled string node returning strlit199 (depth = 5)
  int op_slot_right_198 = gc_frame_newslot(strlit199);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_left (depth = 6)
  int op_slot_right_201 = gc_frame_newslot(*var_left);
// starting to compile string node (depth = 6)
  if (strlit203 == NULL) {
    strlit203 = alloc_String("lazy concatenation of ");
    gc_root(strlit203);
  }
// compiled string node returning strlit203 (depth = 6)
  int op_slot_left_201 = gc_frame_newslot(strlit203);
  params[0] = *var_left;
  partcv[0] = 1;
  Object opresult204 = callmethod(strlit203, "++", 1, partcv, params);
// compiled op node returning opresult204 (depth = 5)
  int op_slot_left_198 = gc_frame_newslot(opresult204);
  params[0] = strlit199;
  partcv[0] = 1;
  Object opresult205 = callmethod(opresult204, "++", 1, partcv, params);
// compiled op node returning opresult205 (depth = 4)
  int op_slot_left_196 = gc_frame_newslot(opresult205);
  params[0] = *var_right;
  partcv[0] = 1;
  Object opresult206 = callmethod(opresult205, "++", 1, partcv, params);
// compiled op node returning opresult206 (depth = 3)
  int op_slot_left_193 = gc_frame_newslot(opresult206);
  params[0] = strlit194;
  partcv[0] = 1;
  Object opresult207 = callmethod(opresult206, "++", 1, partcv, params);
// compiled op node returning opresult207 (depth = 2)
  gc_frame_end(frame);
  return opresult207;
}
Object meth_collectionsPrelude_asString208(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 237
  setline(237);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe209 = gc_frame_new();
// call case 1: super request
  partcv[0] = 0;
  Object call210 = callmethod4(self, "asString", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe209);
// compiled call node returning call210 (depth = 3)
// compiled member node returning call210 (depth = 2)
  gc_frame_end(frame);
  return call210;
}
Object meth_collectionsPrelude_size211(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_right = getfromclosure(closure, 0);
  Object *var_left = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for size (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for size");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 238
  setline(238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe213 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_right (depth = 5)
  partcv[0] = 0;
  Object call214 = callmethod(*var_right, "size",
    1, partcv, params);
  gc_frame_end(callframe213);
// compiled call node returning call214 (depth = 4)
// compiled member node returning call214 (depth = 3)
  int op_slot_right_212 = gc_frame_newslot(call214);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe216 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_left (depth = 5)
  partcv[0] = 0;
  Object call217 = callmethod(*var_left, "size",
    1, partcv, params);
  gc_frame_end(callframe216);
// compiled call node returning call217 (depth = 4)
// compiled member node returning call217 (depth = 3)
  int op_slot_left_212 = gc_frame_newslot(call217);
  params[0] = call214;
  partcv[0] = 1;
  Object sum218 = callmethod(call217, "+", 1, partcv, params);
// compiled op node returning sum218 (depth = 2)
  gc_frame_end(frame);
  return sum218;
}
Object meth_collectionsPrelude_lazyConcatenation180(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lazyConcatenation");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method lazyConcatenation");
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lazyConcatenation (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_left = &(stackframe->slots[0]);
  *var_left = args[curarg];
  curarg++;
  Object *var_right = &(stackframe->slots[1]);
  *var_right = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for lazyConcatenation");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject181 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj181 = alloc_userobj2(4,5, objclass181);
  gc_frame_newslot(obj181);
if (objclass181 == NULL) {
  glfree(obj181->class->name);
  obj181->class->name = "collectionsPrelude.lazyConcatenation";
}
// OBJECT OUTER DEC outer
  adddatum2(obj181, self, 0);
  addmethodreal(obj181,"outer", &reader_collectionsPrelude_outer_182);
  Object oldself181 = self;
  struct StackFrameObject *oldstackframe181 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe181);
  gc_frame_newslot((Object)stackframe);
  self = obj181;
  Object *oldselfslot181 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter181 = (*(struct UserObject *)self).data[0], lowerouter181 = thisouter181;
  if (inheritingObject181) {
    struct UserObject *inho181 = (struct UserObject *)inheritingObject181;
    while (inho181->super != GraceDefaultObject) inho181 = (struct UserObject *)inho181->super;
    inho181->super = obj181;
    self = inheritingObject181;
    *selfslot = self;
    lowerouter181 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter181;
  }
// method "iterator"
  block_savedest(obj181);
  Object closure183 = createclosure(2, "iterator");
  setclosureframe(closure183, stackframe);
  addtoclosure(closure183, var_left);
  addtoclosure(closure183, var_right);
  struct UserObject *uo183 = (struct UserObject*)obj181;
  uo183->data[1] = (Object)closure183;
  Method *meth_meth_collectionsPrelude_iterator183 = addmethod2pos(obj181, "iterator", &meth_collectionsPrelude_iterator183, 1);
  int argcv_meth_collectionsPrelude_iterator183[] = {0};
  meth_meth_collectionsPrelude_iterator183->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator183);
  meth_meth_collectionsPrelude_iterator183->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator183->definitionLine = 233;
// method "asDebugString"
  block_savedest(obj181);
  Object closure192 = createclosure(2, "asDebugString");
  setclosureframe(closure192, stackframe);
  addtoclosure(closure192, var_right);
  addtoclosure(closure192, var_left);
  struct UserObject *uo192 = (struct UserObject*)obj181;
  uo192->data[2] = (Object)closure192;
  Method *meth_meth_collectionsPrelude_asDebugString192 = addmethod2pos(obj181, "asDebugString", &meth_collectionsPrelude_asDebugString192, 2);
  int argcv_meth_collectionsPrelude_asDebugString192[] = {0};
  meth_meth_collectionsPrelude_asDebugString192->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString192);
  meth_meth_collectionsPrelude_asDebugString192->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString192->definitionLine = 236;
// method "asString"
  struct UserObject *uo208 = (struct UserObject*)obj181;
  uo208->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString208 = addmethod2pos(obj181, "asString", &meth_collectionsPrelude_asString208, 3);
  int argcv_meth_collectionsPrelude_asString208[] = {0};
  meth_meth_collectionsPrelude_asString208->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString208);
  meth_meth_collectionsPrelude_asString208->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString208->definitionLine = 237;
// method "size"
  block_savedest(obj181);
  Object closure211 = createclosure(2, "size");
  setclosureframe(closure211, stackframe);
  addtoclosure(closure211, var_right);
  addtoclosure(closure211, var_left);
  struct UserObject *uo211 = (struct UserObject*)obj181;
  uo211->data[4] = (Object)closure211;
  Method *meth_meth_collectionsPrelude_size211 = addmethod2pos(obj181, "size", &meth_collectionsPrelude_size211, 4);
  int argcv_meth_collectionsPrelude_size211[] = {0};
  meth_meth_collectionsPrelude_size211->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size211);
  meth_meth_collectionsPrelude_size211->definitionModule = modulename;
  meth_meth_collectionsPrelude_size211->definitionLine = 238;
  sourceObject = obj181;
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe219 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call220 = callmethod(*var_enumerable, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe219);
// compiled call node returning call220 (depth = 2)
  struct UserObject *obj181_uo = (struct UserObject *)obj181;
  obj181_uo->super = call220;
  sourceObject = obj181;
  sourceObject = obj181;
  sourceObject = obj181;
  sourceObject = obj181;
  objclass181 = obj181->class;
  objclass181->definitionModule = modulename;
  objclass181->definitionLine = 231;
  (*(struct UserObject *)self).data[0] = lowerouter181;
  self = oldself181;
  selfslot = oldselfslot181;
  stackframe = oldstackframe181;
  gc_frame_end(frame);
  return obj181;
}
Object meth_collectionsPrelude_lazyConcatenation180_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "lazyConcatenation()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method lazyConcatenation()object");
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for lazyConcatenation (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_left = &(stackframe->slots[0]);
  *var_left = args[curarg];
  curarg++;
  Object *var_right = &(stackframe->slots[1]);
  *var_right = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for lazyConcatenation");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[3]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject181 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj181 = alloc_userobj2(4,5, objclass181);
  gc_frame_newslot(obj181);
if (objclass181 == NULL) {
  glfree(obj181->class->name);
  obj181->class->name = "collectionsPrelude.lazyConcatenation";
}
// OBJECT OUTER DEC outer
  adddatum2(obj181, self, 0);
  addmethodreal(obj181,"outer", &reader_collectionsPrelude_outer_182);
  Object oldself181 = self;
  struct StackFrameObject *oldstackframe181 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe181);
  gc_frame_newslot((Object)stackframe);
  self = obj181;
  Object *oldselfslot181 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter181 = (*(struct UserObject *)self).data[0], lowerouter181 = thisouter181;
  if (inheritingObject181) {
    struct UserObject *inho181 = (struct UserObject *)inheritingObject181;
    while (inho181->super != GraceDefaultObject) inho181 = (struct UserObject *)inho181->super;
    inho181->super = obj181;
    self = inheritingObject181;
    *selfslot = self;
    lowerouter181 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter181;
  }
// method "iterator"
  block_savedest(obj181);
  Object closure183 = createclosure(2, "iterator");
  setclosureframe(closure183, stackframe);
  addtoclosure(closure183, var_left);
  addtoclosure(closure183, var_right);
  struct UserObject *uo183 = (struct UserObject*)obj181;
  uo183->data[1] = (Object)closure183;
  Method *meth_meth_collectionsPrelude_iterator183 = addmethod2pos(obj181, "iterator", &meth_collectionsPrelude_iterator183, 1);
  int argcv_meth_collectionsPrelude_iterator183[] = {0};
  meth_meth_collectionsPrelude_iterator183->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator183);
  meth_meth_collectionsPrelude_iterator183->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator183->definitionLine = 233;
// method "asDebugString"
  block_savedest(obj181);
  Object closure192 = createclosure(2, "asDebugString");
  setclosureframe(closure192, stackframe);
  addtoclosure(closure192, var_right);
  addtoclosure(closure192, var_left);
  struct UserObject *uo192 = (struct UserObject*)obj181;
  uo192->data[2] = (Object)closure192;
  Method *meth_meth_collectionsPrelude_asDebugString192 = addmethod2pos(obj181, "asDebugString", &meth_collectionsPrelude_asDebugString192, 2);
  int argcv_meth_collectionsPrelude_asDebugString192[] = {0};
  meth_meth_collectionsPrelude_asDebugString192->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString192);
  meth_meth_collectionsPrelude_asDebugString192->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString192->definitionLine = 236;
// method "asString"
  struct UserObject *uo208 = (struct UserObject*)obj181;
  uo208->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString208 = addmethod2pos(obj181, "asString", &meth_collectionsPrelude_asString208, 3);
  int argcv_meth_collectionsPrelude_asString208[] = {0};
  meth_meth_collectionsPrelude_asString208->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString208);
  meth_meth_collectionsPrelude_asString208->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString208->definitionLine = 237;
// method "size"
  block_savedest(obj181);
  Object closure211 = createclosure(2, "size");
  setclosureframe(closure211, stackframe);
  addtoclosure(closure211, var_right);
  addtoclosure(closure211, var_left);
  struct UserObject *uo211 = (struct UserObject*)obj181;
  uo211->data[4] = (Object)closure211;
  Method *meth_meth_collectionsPrelude_size211 = addmethod2pos(obj181, "size", &meth_collectionsPrelude_size211, 4);
  int argcv_meth_collectionsPrelude_size211[] = {0};
  meth_meth_collectionsPrelude_size211->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size211);
  meth_meth_collectionsPrelude_size211->definitionModule = modulename;
  meth_meth_collectionsPrelude_size211->definitionLine = 238;
  sourceObject = obj181;
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe219 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call220 = callmethod(*var_enumerable, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe219);
// compiled call node returning call220 (depth = 2)
  struct UserObject *obj181_uo = (struct UserObject *)obj181;
  obj181_uo->super = call220;
  sourceObject = obj181;
  sourceObject = obj181;
  sourceObject = obj181;
  sourceObject = obj181;
  objclass181 = obj181->class;
  objclass181->definitionModule = modulename;
  objclass181->definitionLine = 231;
  (*(struct UserObject *)self).data[0] = lowerouter181;
  self = oldself181;
  selfslot = oldselfslot181;
  stackframe = oldstackframe181;
  gc_frame_end(frame);
  return obj181;
}
Object meth_collectionsPrelude_max222(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "max");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method max");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for max (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for max");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 419
  setline(419);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
  int op_slot_right_224 = gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_a (depth = 4)
  int op_slot_left_224 = gc_frame_newslot(*var_a);
  params[0] = *var_b;
  partcv[0] = 1;
  Object opresult226 = callmethod(*var_a, ">", 1, partcv, params);
// compiled op node returning opresult226 (depth = 3)
  Object if223 = done;
  if (istrue(opresult226)) {
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_a (depth = 3)
    gc_frame_newslot(*var_a);
    if223 = *var_a;
  } else {
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_b (depth = 3)
    gc_frame_newslot(*var_b);
    if223 = *var_b;
  }
// compiled if node returning if223 (depth = 2)
  gc_frame_end(frame);
  return if223;
}
Object meth_collectionsPrelude_asString230(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 455
  setline(455);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit231 == NULL) {
    strlit231 = alloc_String("a sequence factory");
    gc_root(strlit231);
  }
// compiled string node returning strlit231 (depth = 2)
  gc_frame_end(frame);
  return strlit231;
}
Object meth_collectionsPrelude_empty232(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "empty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for empty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for empty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 459
  setline(459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_emptySequence (depth = 2)
  gc_frame_end(frame);
  return *var_emptySequence;
}
Object meth_collectionsPrelude__apply237(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sizeCertain = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 466
  setline(466);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
  Object bool238 = alloc_Boolean(0);
// compiled identifier node returning bool238 (depth = 6)
  *var_sizeCertain = bool238;
  if (bool238 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 467
  setline(467);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 5)
  Object num240 = alloc_Float64(8);
// compiled num node returning num240 (depth = 5)
  gc_frame_end(frame);
  return num240;
}
Object meth_collectionsPrelude__apply253(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_inner = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 475
  setline(475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe254 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  gc_frame_newslot(*var_ix);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elt (depth = 6)
  gc_frame_newslot(*var_elt);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inner (depth = 6)
  params[0] = *var_ix;
  params[1] = *var_elt;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call255 = callmethod(*var_inner, "at()put",
    2, partcv, params);
  gc_frame_end(callframe254);
// compiled call node returning call255 (depth = 5)
// Begin line 476
  setline(476);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num257 = alloc_Float64(1);
// compiled num node returning num257 (depth = 7)
  int op_slot_right_256 = gc_frame_newslot(num257);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  int op_slot_left_256 = gc_frame_newslot(*var_ix);
  params[0] = num257;
  partcv[0] = 1;
  Object sum259 = callmethod(*var_ix, "+", 1, partcv, params);
// compiled op node returning sum259 (depth = 6)
  *var_ix = sum259;
  if (sum259 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply288(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_inner = getfromclosure(closure, 0);
  Object *var_newInner = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 484
  setline(484);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe289 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  gc_frame_newslot(*var_i);
// starting to compile call node (depth = 9)
  int callframe290 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_inner (depth = 10)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call291 = callmethod(*var_inner, "at",
    1, partcv, params);
  gc_frame_end(callframe290);
// compiled call node returning call291 (depth = 9)
  gc_frame_newslot(call291);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_newInner (depth = 9)
  params[0] = *var_i;
  params[1] = call291;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call292 = callmethod(*var_newInner, "at()put",
    2, partcv, params);
  gc_frame_end(callframe289);
// compiled call node returning call292 (depth = 8)
  gc_frame_end(frame);
  return call292;
}
Object meth_collectionsPrelude__apply265(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_innerSize = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_inner = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newInner = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newInner");
// Begin line 481
  setline(481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  int op_slot_right_267 = gc_frame_newslot(*var_ix);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_innerSize (depth = 7)
  int op_slot_left_267 = gc_frame_newslot(*var_innerSize);
  params[0] = *var_ix;
  partcv[0] = 1;
  Object opresult269 = callmethod(*var_innerSize, "≤", 1, partcv, params);
// compiled op node returning opresult269 (depth = 6)
  Object if266 = done;
  if (istrue(opresult269)) {
// Begin line 482
  setline(482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe270 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num272 = alloc_Float64(2);
// compiled num node returning num272 (depth = 9)
  int op_slot_right_271 = gc_frame_newslot(num272);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_innerSize (depth = 9)
  int op_slot_left_271 = gc_frame_newslot(*var_innerSize);
  params[0] = num272;
  partcv[0] = 1;
  Object prod274 = callmethod(*var_innerSize, "*", 1, partcv, params);
// compiled op node returning prod274 (depth = 8)
  gc_frame_newslot(prod274);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe275 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var__prelude (depth = 10)
  partcv[0] = 0;
  Object call276 = callmethod(*var__prelude, "primitiveArray",
    1, partcv, params);
  gc_frame_end(callframe275);
// compiled call node returning call276 (depth = 9)
// compiled member node returning call276 (depth = 8)
  params[0] = prod274;
  partcv[0] = 1;
  Object call277 = callmethod(call276, "new",
    1, partcv, params);
  gc_frame_end(callframe270);
// compiled call node returning call277 (depth = 7)
  *var_newInner = call277;
  if (call277 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 483
  setline(483);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe278 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num281 = alloc_Float64(1);
// compiled num node returning num281 (depth = 9)
  int op_slot_right_280 = gc_frame_newslot(num281);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_innerSize (depth = 9)
  int op_slot_left_280 = gc_frame_newslot(*var_innerSize);
  params[0] = num281;
  partcv[0] = 1;
  Object diff283 = callmethod(*var_innerSize, "-", 1, partcv, params);
// compiled op node returning diff283 (depth = 8)
  int op_slot_right_279 = gc_frame_newslot(diff283);
// starting to compile num node (depth = 8)
  Object num285 = alloc_Float64(0);
// compiled num node returning num285 (depth = 8)
  int op_slot_left_279 = gc_frame_newslot(num285);
  params[0] = diff283;
  partcv[0] = 1;
  Object opresult286 = callmethod(num285, "..", 1, partcv, params);
// compiled op node returning opresult286 (depth = 7)
  gc_frame_newslot(opresult286);
// starting to compile block node (depth = 7)
  Object block287 = alloc_Block(NULL, NULL, "collectionsPrelude", 483);
  gc_frame_newslot(block287);
// method "_apply"
  block_savedest(block287);
  Object closure288 = createclosure(3, "_apply");
  setclosureframe(closure288, stackframe);
  addtoclosure(closure288, var_inner);
  addtoclosure(closure288, var_newInner);
  addtoclosure(closure288, selfslot);
  struct UserObject *uo288 = (struct UserObject*)block287;
  uo288->data[0] = (Object)closure288;
  Method *meth_meth_collectionsPrelude__apply288 = addmethod2pos(block287, "_apply", &meth_collectionsPrelude__apply288, 0);
  int argcv_meth_collectionsPrelude__apply288[] = {1};
  meth_meth_collectionsPrelude__apply288->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply288);
  meth_meth_collectionsPrelude__apply288->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply288->definitionLine = 482;
// compiled block node returning block287 (depth = 7)
  gc_frame_newslot(block287);
// call case 5: prelude request
  params[0] = opresult286;
  params[1] = block287;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call294 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe278);
// compiled call node returning call294 (depth = 6)
// Begin line 486
  setline(486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newInner (depth = 7)
  *var_inner = *var_newInner;
  if (*var_newInner == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 487
  setline(487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe296 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_inner (depth = 9)
  partcv[0] = 0;
  Object call297 = callmethod(*var_inner, "size",
    1, partcv, params);
  gc_frame_end(callframe296);
// compiled call node returning call297 (depth = 8)
// compiled member node returning call297 (depth = 7)
  *var_innerSize = call297;
  if (call297 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if266 = done;
  } else {
  }
// compiled if node returning if266 (depth = 5)
// Begin line 489
  setline(489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe299 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  gc_frame_newslot(*var_ix);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elt (depth = 6)
  gc_frame_newslot(*var_elt);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_inner (depth = 6)
  params[0] = *var_ix;
  params[1] = *var_elt;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call300 = callmethod(*var_inner, "at()put",
    2, partcv, params);
  gc_frame_end(callframe299);
// compiled call node returning call300 (depth = 5)
// Begin line 490
  setline(490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num302 = alloc_Float64(1);
// compiled num node returning num302 (depth = 7)
  int op_slot_right_301 = gc_frame_newslot(num302);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  int op_slot_left_301 = gc_frame_newslot(*var_ix);
  params[0] = num302;
  partcv[0] = 1;
  Object sum304 = callmethod(*var_ix, "+", 1, partcv, params);
// compiled op node returning sum304 (depth = 6)
  *var_ix = sum304;
  if (sum304 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_withAll233(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "withAll");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method withAll");
  Object params[2];
  int partcv[2];
  Object *var__prelude = getfromclosure(closure, 0);
  Object *var_emptySequence = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for withAll (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_arg = &(stackframe->slots[0]);
  *var_arg = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for withAll");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sizeCertain = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "sizeCertain");
  Object *var_forecastSize = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "forecastSize");
  Object *var_inner = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "inner");
  Object *var_innerSize = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "innerSize");
  Object *var_ix = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "ix");
// Begin line 463
  setline(463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool234 = alloc_Boolean(1);
// compiled identifier node returning bool234 (depth = 3)
  *var_sizeCertain = bool234;
  if (bool234 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 465
  setline(465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe235 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block236 = alloc_Block(NULL, NULL, "collectionsPrelude", 465);
  gc_frame_newslot(block236);
// method "_apply"
  block_savedest(block236);
  Object closure237 = createclosure(2, "_apply");
  setclosureframe(closure237, stackframe);
  addtoclosure(closure237, var_sizeCertain);
  addtoclosure(closure237, selfslot);
  struct UserObject *uo237 = (struct UserObject*)block236;
  uo237->data[0] = (Object)closure237;
  Method *meth_meth_collectionsPrelude__apply237 = addmethod2pos(block236, "_apply", &meth_collectionsPrelude__apply237, 0);
  int argcv_meth_collectionsPrelude__apply237[] = {0};
  meth_meth_collectionsPrelude__apply237->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply237);
  meth_meth_collectionsPrelude__apply237->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply237->definitionLine = 238;
// compiled block node returning block236 (depth = 4)
  gc_frame_newslot(block236);
// call case 6: other member request
// Begin line 465
  setline(465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_arg (depth = 4)
  params[0] = block236;
  partcv[0] = 1;
  Object call242 = callmethod(*var_arg, "sizeIfUnknown",
    1, partcv, params);
  gc_frame_end(callframe235);
// compiled call node returning call242 (depth = 3)
  *var_forecastSize = call242;
  if (call242 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 469
  setline(469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe243 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_forecastSize (depth = 4)
  gc_frame_newslot(*var_forecastSize);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe244 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var__prelude (depth = 6)
  partcv[0] = 0;
  Object call245 = callmethod(*var__prelude, "primitiveArray",
    1, partcv, params);
  gc_frame_end(callframe244);
// compiled call node returning call245 (depth = 5)
// compiled member node returning call245 (depth = 4)
  params[0] = *var_forecastSize;
  partcv[0] = 1;
  Object call246 = callmethod(call245, "new",
    1, partcv, params);
  gc_frame_end(callframe243);
// compiled call node returning call246 (depth = 3)
  *var_inner = call246;
  if (call246 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 470
  setline(470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe247 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_inner (depth = 5)
  partcv[0] = 0;
  Object call248 = callmethod(*var_inner, "size",
    1, partcv, params);
  gc_frame_end(callframe247);
// compiled call node returning call248 (depth = 4)
// compiled member node returning call248 (depth = 3)
  *var_innerSize = call248;
  if (call248 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 471
  setline(471);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num249 = alloc_Float64(0);
// compiled num node returning num249 (depth = 3)
  *var_ix = num249;
  if (num249 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 472
  setline(472);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sizeCertain (depth = 3)
  Object if250 = done;
  if (istrue(*var_sizeCertain)) {
// Begin line 474
  setline(474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe251 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_arg (depth = 4)
  gc_frame_newslot(*var_arg);
// starting to compile block node (depth = 4)
  Object block252 = alloc_Block(NULL, NULL, "collectionsPrelude", 474);
  gc_frame_newslot(block252);
// method "_apply"
  block_savedest(block252);
  Object closure253 = createclosure(3, "_apply");
  setclosureframe(closure253, stackframe);
  addtoclosure(closure253, var_ix);
  addtoclosure(closure253, var_inner);
  addtoclosure(closure253, selfslot);
  struct UserObject *uo253 = (struct UserObject*)block252;
  uo253->data[0] = (Object)closure253;
  Method *meth_meth_collectionsPrelude__apply253 = addmethod2pos(block252, "_apply", &meth_collectionsPrelude__apply253, 0);
  int argcv_meth_collectionsPrelude__apply253[] = {1};
  meth_meth_collectionsPrelude__apply253->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply253);
  meth_meth_collectionsPrelude__apply253->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply253->definitionLine = 470;
// compiled block node returning block252 (depth = 4)
  gc_frame_newslot(block252);
// call case 5: prelude request
  params[0] = *var_arg;
  params[1] = block252;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call262 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe251);
// compiled call node returning call262 (depth = 3)
    gc_frame_newslot(call262);
    if250 = call262;
  } else {
// Begin line 480
  setline(480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe263 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_arg (depth = 4)
  gc_frame_newslot(*var_arg);
// starting to compile block node (depth = 4)
  Object block264 = alloc_Block(NULL, NULL, "collectionsPrelude", 480);
  gc_frame_newslot(block264);
// method "_apply"
  block_savedest(block264);
  Object closure265 = createclosure(5, "_apply");
  setclosureframe(closure265, stackframe);
  addtoclosure(closure265, var_ix);
  addtoclosure(closure265, var_innerSize);
  addtoclosure(closure265, var__prelude);
  addtoclosure(closure265, var_inner);
  addtoclosure(closure265, selfslot);
  struct UserObject *uo265 = (struct UserObject*)block264;
  uo265->data[0] = (Object)closure265;
  Method *meth_meth_collectionsPrelude__apply265 = addmethod2pos(block264, "_apply", &meth_collectionsPrelude__apply265, 0);
  int argcv_meth_collectionsPrelude__apply265[] = {1};
  meth_meth_collectionsPrelude__apply265->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply265);
  meth_meth_collectionsPrelude__apply265->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply265->definitionLine = 470;
// compiled block node returning block264 (depth = 4)
  gc_frame_newslot(block264);
// call case 5: prelude request
  params[0] = *var_arg;
  params[1] = block264;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call307 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe263);
// compiled call node returning call307 (depth = 3)
    gc_frame_newslot(call307);
    if250 = call307;
  }
// compiled if node returning if250 (depth = 2)
// Begin line 493
  setline(493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num310 = alloc_Float64(0);
// compiled num node returning num310 (depth = 4)
  int op_slot_right_309 = gc_frame_newslot(num310);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ix (depth = 4)
  int op_slot_left_309 = gc_frame_newslot(*var_ix);
  params[0] = num310;
  partcv[0] = 1;
  Object opresult312 = callmethod(*var_ix, "==", 1, partcv, params);
// compiled op node returning opresult312 (depth = 3)
  Object if308 = done;
  if (istrue(opresult312)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_emptySequence (depth = 4)
  return *var_emptySequence;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if308 = undefined;
  } else {
  }
// compiled if node returning if308 (depth = 2)
// Begin line 494
  setline(494);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe313 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_inner (depth = 3)
  gc_frame_newslot(*var_inner);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ix (depth = 3)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_inner;
  params[1] = *var_ix;
  partcv[0] = 2;
  Object call314 = callmethodflags(self, "fromprimitiveArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe313);
// compiled call node returning call314 (depth = 2)
  gc_frame_end(frame);
  return call314;
}
Object meth_collectionsPrelude_boundsCheck320(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "boundsCheck");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method boundsCheck");
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for boundsCheck (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for boundsCheck");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 505
  setline(505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe323 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe325 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call326 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe325);
// compiled call node returning call326 (depth = 7)
// compiled member node returning call326 (depth = 6)
  int op_slot_right_324 = gc_frame_newslot(call326);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_324 = gc_frame_newslot(*var_n);
  params[0] = call326;
  partcv[0] = 1;
  Object opresult328 = callmethod(*var_n, "≤", 1, partcv, params);
// compiled op node returning opresult328 (depth = 5)
  partcv[0] = 0;
  Object call329 = callmethod(opresult328, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe323);
// compiled call node returning call329 (depth = 4)
  int op_slot_right_322 = gc_frame_newslot(call329);
// starting to compile call node (depth = 4)
  int callframe331 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num333 = alloc_Float64(1);
// compiled num node returning num333 (depth = 6)
  int op_slot_right_332 = gc_frame_newslot(num333);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_332 = gc_frame_newslot(*var_n);
  params[0] = num333;
  partcv[0] = 1;
  Object opresult335 = callmethod(*var_n, "≥", 1, partcv, params);
// compiled op node returning opresult335 (depth = 5)
  partcv[0] = 0;
  Object call336 = callmethod(opresult335, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe331);
// compiled call node returning call336 (depth = 4)
  int op_slot_left_322 = gc_frame_newslot(call336);
  params[0] = call329;
  partcv[0] = 1;
  Object opresult337 = callmethod(call336, "||", 1, partcv, params);
// compiled op node returning opresult337 (depth = 3)
  Object if321 = done;
  if (istrue(opresult337)) {
// Begin line 508
  setline(508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe338 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit340 == NULL) {
    strlit340 = alloc_String("");
    gc_root(strlit340);
  }
// compiled string node returning strlit340 (depth = 5)
  int op_slot_right_339 = gc_frame_newslot(strlit340);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe343 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call344 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe343);
// compiled call node returning call344 (depth = 7)
// compiled member node returning call344 (depth = 6)
  int op_slot_right_342 = gc_frame_newslot(call344);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit347 == NULL) {
    strlit347 = alloc_String(" out of bounds 1..");
    gc_root(strlit347);
  }
// compiled string node returning strlit347 (depth = 7)
  int op_slot_right_346 = gc_frame_newslot(strlit347);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_right_349 = gc_frame_newslot(*var_n);
// starting to compile string node (depth = 8)
  if (strlit351 == NULL) {
    strlit351 = alloc_String("index ");
    gc_root(strlit351);
  }
// compiled string node returning strlit351 (depth = 8)
  int op_slot_left_349 = gc_frame_newslot(strlit351);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult352 = callmethod(strlit351, "++", 1, partcv, params);
// compiled op node returning opresult352 (depth = 7)
  int op_slot_left_346 = gc_frame_newslot(opresult352);
  params[0] = strlit347;
  partcv[0] = 1;
  Object opresult353 = callmethod(opresult352, "++", 1, partcv, params);
// compiled op node returning opresult353 (depth = 6)
  int op_slot_left_342 = gc_frame_newslot(opresult353);
  params[0] = call344;
  partcv[0] = 1;
  Object opresult354 = callmethod(opresult353, "++", 1, partcv, params);
// compiled op node returning opresult354 (depth = 5)
  int op_slot_left_339 = gc_frame_newslot(opresult354);
  params[0] = strlit340;
  partcv[0] = 1;
  Object opresult355 = callmethod(opresult354, "++", 1, partcv, params);
// compiled op node returning opresult355 (depth = 4)
  gc_frame_newslot(opresult355);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult355;
  partcv[0] = 1;
  Object call356 = callmethod(*var_BoundsError, "raise",
    1, partcv, params);
  gc_frame_end(callframe338);
// compiled call node returning call356 (depth = 3)
    gc_frame_newslot(call356);
    if321 = call356;
  } else {
  }
// compiled if node returning if321 (depth = 2)
  gc_frame_end(frame);
  return if321;
}
Object meth_collectionsPrelude_at357(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for at");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 512
  setline(512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe358 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call359 = callmethodflags(self, "boundsCheck", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe358);
// compiled call node returning call359 (depth = 2)
// Begin line 513
  setline(513);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe360 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num362 = alloc_Float64(1);
// compiled num node returning num362 (depth = 4)
  int op_slot_right_361 = gc_frame_newslot(num362);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_361 = gc_frame_newslot(*var_n);
  params[0] = num362;
  partcv[0] = 1;
  Object diff364 = callmethod(*var_n, "-", 1, partcv, params);
// compiled op node returning diff364 (depth = 3)
  gc_frame_newslot(diff364);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe365 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call366 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe365);
// compiled call node returning call366 (depth = 4)
// compiled member node returning call366 (depth = 3)
  params[0] = diff364;
  partcv[0] = 1;
  Object call367 = callmethod(call366, "at",
    1, partcv, params);
  gc_frame_end(callframe360);
// compiled call node returning call367 (depth = 2)
  gc_frame_end(frame);
  return call367;
}
Object meth_collectionsPrelude_keys368(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keys (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for keys");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 516
  setline(516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe369 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num370 = alloc_Float64(1);
// compiled num node returning num370 (depth = 3)
  gc_frame_newslot(num370);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe371 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call372 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe371);
// compiled call node returning call372 (depth = 4)
// compiled member node returning call372 (depth = 3)
  gc_frame_newslot(call372);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe373 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe374 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe375 = gc_frame_new();
// call case 3: self.outer request
  Object call376 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe375);
// compiled call node returning call376 (depth = 8)
// compiled member node returning call376 (depth = 7)
  partcv[0] = 0;
  Object call377 = callmethodflags(call376, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe374);
// compiled call node returning call377 (depth = 6)
// compiled member node returning call377 (depth = 5)
  partcv[0] = 0;
  Object call378 = callmethodflags(call377, "range", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe373);
// compiled call node returning call378 (depth = 4)
// compiled member node returning call378 (depth = 3)
  params[0] = num370;
  params[1] = call372;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call379 = callmethod(call378, "from()to",
    2, partcv, params);
  gc_frame_end(callframe369);
// compiled call node returning call379 (depth = 2)
  gc_frame_end(frame);
  return call379;
}
Object meth_collectionsPrelude_values380(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for values (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for values");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 519
  setline(519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply385(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe387 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call388 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe387);
// compiled call node returning call388 (depth = 6)
// compiled member node returning call388 (depth = 5)
  int op_slot_right_386 = gc_frame_newslot(call388);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  int op_slot_left_386 = gc_frame_newslot(*var_i);
  params[0] = call388;
  partcv[0] = 1;
  Object opresult390 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult390 (depth = 4)
  gc_frame_end(frame);
  return opresult390;
}
Object meth_collectionsPrelude__apply393(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_block2 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 524
  setline(524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe394 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num396 = alloc_Float64(1);
// compiled num node returning num396 (depth = 6)
  int op_slot_right_395 = gc_frame_newslot(num396);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_395 = gc_frame_newslot(*var_i);
  params[0] = num396;
  partcv[0] = 1;
  Object sum398 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum398 (depth = 5)
  gc_frame_newslot(sum398);
// starting to compile call node (depth = 5)
  int callframe399 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe400 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call401 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe400);
// compiled call node returning call401 (depth = 7)
// compiled member node returning call401 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call402 = callmethod(call401, "at",
    1, partcv, params);
  gc_frame_end(callframe399);
// compiled call node returning call402 (depth = 5)
  gc_frame_newslot(call402);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block2 (depth = 5)
  params[0] = sum398;
  params[1] = call402;
  partcv[0] = 2;
  Object call403 = callmethod(*var_block2, "apply",
    1, partcv, params);
  gc_frame_end(callframe394);
// compiled call node returning call403 (depth = 4)
// Begin line 525
  setline(525);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num405 = alloc_Float64(1);
// compiled num node returning num405 (depth = 6)
  int op_slot_right_404 = gc_frame_newslot(num405);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_404 = gc_frame_newslot(*var_i);
  params[0] = num405;
  partcv[0] = 1;
  Object sum407 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum407 (depth = 5)
  *var_i = sum407;
  if (sum407 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_keysAndValuesDo381(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysAndValuesDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for keysAndValuesDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_i = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "i");
// Begin line 522
  setline(522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num382 = alloc_Float64(0);
// compiled num node returning num382 (depth = 3)
  *var_i = num382;
  if (num382 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 523
  setline(523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe383 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block384 = alloc_Block(NULL, NULL, "collectionsPrelude", 523);
  gc_frame_newslot(block384);
// method "_apply"
  block_savedest(block384);
  Object closure385 = createclosure(2, "_apply");
  setclosureframe(closure385, stackframe);
  addtoclosure(closure385, var_i);
  addtoclosure(closure385, selfslot);
  struct UserObject *uo385 = (struct UserObject*)block384;
  uo385->data[0] = (Object)closure385;
  Method *meth_meth_collectionsPrelude__apply385 = addmethod2pos(block384, "_apply", &meth_collectionsPrelude__apply385, 0);
  int argcv_meth_collectionsPrelude__apply385[] = {0};
  meth_meth_collectionsPrelude__apply385->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply385);
  meth_meth_collectionsPrelude__apply385->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply385->definitionLine = 516;
// compiled block node returning block384 (depth = 3)
  gc_frame_newslot(block384);
// starting to compile block node (depth = 3)
  Object block392 = alloc_Block(NULL, NULL, "collectionsPrelude", 523);
  gc_frame_newslot(block392);
// method "_apply"
  block_savedest(block392);
  Object closure393 = createclosure(3, "_apply");
  setclosureframe(closure393, stackframe);
  addtoclosure(closure393, var_i);
  addtoclosure(closure393, var_block2);
  addtoclosure(closure393, selfslot);
  struct UserObject *uo393 = (struct UserObject*)block392;
  uo393->data[0] = (Object)closure393;
  Method *meth_meth_collectionsPrelude__apply393 = addmethod2pos(block392, "_apply", &meth_collectionsPrelude__apply393, 0);
  int argcv_meth_collectionsPrelude__apply393[] = {0};
  meth_meth_collectionsPrelude__apply393->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply393);
  meth_meth_collectionsPrelude__apply393->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply393->definitionLine = 523;
// compiled block node returning block392 (depth = 3)
  gc_frame_newslot(block392);
// call case 5: prelude request
  params[0] = block384;
  params[1] = block392;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call410 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe383);
// compiled call node returning call410 (depth = 2)
  gc_frame_end(frame);
  return call410;
}
Object meth_collectionsPrelude__apply426(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_freshArray = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 532
  setline(532);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe427 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  gc_frame_newslot(*var_ix);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_freshArray (depth = 5)
  params[0] = *var_ix;
  params[1] = *var_each;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call428 = callmethod(*var_freshArray, "at()put",
    2, partcv, params);
  gc_frame_end(callframe427);
// compiled call node returning call428 (depth = 4)
// Begin line 533
  setline(533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num430 = alloc_Float64(1);
// compiled num node returning num430 (depth = 6)
  int op_slot_right_429 = gc_frame_newslot(num430);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_left_429 = gc_frame_newslot(*var_ix);
  params[0] = num430;
  partcv[0] = 1;
  Object diff432 = callmethod(*var_ix, "-", 1, partcv, params);
// compiled op node returning diff432 (depth = 5)
  *var_ix = diff432;
  if (diff432 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_reversed411(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var__prelude = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for reversed (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for reversed");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_freshArray = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "freshArray");
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
// Begin line 529
  setline(529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe412 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe413 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call414 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe413);
// compiled call node returning call414 (depth = 5)
// compiled member node returning call414 (depth = 4)
  gc_frame_newslot(call414);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe415 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var__prelude (depth = 6)
  partcv[0] = 0;
  Object call416 = callmethod(*var__prelude, "primitiveArray",
    1, partcv, params);
  gc_frame_end(callframe415);
// compiled call node returning call416 (depth = 5)
// compiled member node returning call416 (depth = 4)
  params[0] = call414;
  partcv[0] = 1;
  Object call417 = callmethod(call416, "new",
    1, partcv, params);
  gc_frame_end(callframe412);
// compiled call node returning call417 (depth = 3)
  *var_freshArray = call417;
  if (call417 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 530
  setline(530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num419 = alloc_Float64(1);
// compiled num node returning num419 (depth = 4)
  int op_slot_right_418 = gc_frame_newslot(num419);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe421 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call422 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe421);
// compiled call node returning call422 (depth = 5)
// compiled member node returning call422 (depth = 4)
  int op_slot_left_418 = gc_frame_newslot(call422);
  params[0] = num419;
  partcv[0] = 1;
  Object diff423 = callmethod(call422, "-", 1, partcv, params);
// compiled op node returning diff423 (depth = 3)
  *var_ix = diff423;
  if (diff423 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 531
  setline(531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe424 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block425 = alloc_Block(NULL, NULL, "collectionsPrelude", 531);
  gc_frame_newslot(block425);
// method "_apply"
  block_savedest(block425);
  Object closure426 = createclosure(3, "_apply");
  setclosureframe(closure426, stackframe);
  addtoclosure(closure426, var_ix);
  addtoclosure(closure426, var_freshArray);
  addtoclosure(closure426, selfslot);
  struct UserObject *uo426 = (struct UserObject*)block425;
  uo426->data[0] = (Object)closure426;
  Method *meth_meth_collectionsPrelude__apply426 = addmethod2pos(block425, "_apply", &meth_collectionsPrelude__apply426, 0);
  int argcv_meth_collectionsPrelude__apply426[] = {1};
  meth_meth_collectionsPrelude__apply426->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply426);
  meth_meth_collectionsPrelude__apply426->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply426->definitionLine = 530;
// compiled block node returning block425 (depth = 3)
  gc_frame_newslot(block425);
// call case 4: self request
  params[0] = block425;
  partcv[0] = 1;
  Object call435 = callmethodflags(self, "do", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe424);
// compiled call node returning call435 (depth = 2)
// Begin line 535
  setline(535);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe436 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_freshArray (depth = 3)
  gc_frame_newslot(*var_freshArray);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe437 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call438 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe437);
// compiled call node returning call438 (depth = 4)
// compiled member node returning call438 (depth = 3)
  gc_frame_newslot(call438);
// call case 2: outer request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe439 = gc_frame_new();
// call case 3: self.outer request
  Object call440 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe439);
// compiled call node returning call440 (depth = 4)
// compiled member node returning call440 (depth = 3)
  params[0] = *var_freshArray;
  params[1] = call438;
  partcv[0] = 2;
  Object call441 = callmethodflags(call440, "fromprimitiveArray", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe436);
// compiled call node returning call441 (depth = 2)
  gc_frame_end(frame);
  return call441;
}
Object meth_collectionsPrelude__43__43_442(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++ (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ++");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 538
  setline(538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe443 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe444 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe445 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe446 = gc_frame_new();
// call case 3: self.outer request
  Object call447 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe446);
// compiled call node returning call447 (depth = 7)
// compiled member node returning call447 (depth = 6)
  partcv[0] = 0;
  Object call448 = callmethodflags(call447, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe445);
// compiled call node returning call448 (depth = 5)
// compiled member node returning call448 (depth = 4)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 2;
  Object call449 = callmethodflags(call448, "lazyConcatenation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe444);
// compiled call node returning call449 (depth = 3)
  gc_frame_newslot(call449);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe450 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe451 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe452 = gc_frame_new();
// call case 3: self.outer request
  Object call453 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe452);
// compiled call node returning call453 (depth = 8)
// compiled member node returning call453 (depth = 7)
  partcv[0] = 0;
  Object call454 = callmethodflags(call453, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe451);
// compiled call node returning call454 (depth = 6)
// compiled member node returning call454 (depth = 5)
  partcv[0] = 0;
  Object call455 = callmethodflags(call454, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe450);
// compiled call node returning call455 (depth = 4)
// compiled member node returning call455 (depth = 3)
  params[0] = call449;
  partcv[0] = 1;
  Object call456 = callmethod(call455, "withAll",
    1, partcv, params);
  gc_frame_end(callframe443);
// compiled call node returning call456 (depth = 2)
  gc_frame_end(frame);
  return call456;
}
Object meth_collectionsPrelude__apply471(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 543
  setline(543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe473 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe474 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe475 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call476 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe475);
// compiled call node returning call476 (depth = 10)
// compiled member node returning call476 (depth = 9)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call477 = callmethod(call476, "at",
    1, partcv, params);
  gc_frame_end(callframe474);
// compiled call node returning call477 (depth = 8)
  partcv[0] = 0;
  Object call478 = callmethod(call477, "asString",
    1, partcv, params);
  gc_frame_end(callframe473);
// compiled call node returning call478 (depth = 7)
// compiled member node returning call478 (depth = 6)
  int op_slot_right_472 = gc_frame_newslot(call478);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_472 = gc_frame_newslot(*var_s);
  params[0] = call478;
  partcv[0] = 1;
  Object opresult480 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult480 (depth = 5)
  *var_s = opresult480;
  if (opresult480 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 544
  setline(544);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num485 = alloc_Float64(1);
// compiled num node returning num485 (depth = 7)
  int op_slot_right_484 = gc_frame_newslot(num485);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe487 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call488 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe487);
// compiled call node returning call488 (depth = 8)
// compiled member node returning call488 (depth = 7)
  int op_slot_left_484 = gc_frame_newslot(call488);
  params[0] = num485;
  partcv[0] = 1;
  Object diff489 = callmethod(call488, "-", 1, partcv, params);
// compiled op node returning diff489 (depth = 6)
  int op_slot_right_483 = gc_frame_newslot(diff489);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_483 = gc_frame_newslot(*var_i);
  params[0] = diff489;
  partcv[0] = 1;
  Object opresult491 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult491 (depth = 5)
  Object if482 = done;
  if (istrue(opresult491)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit493 == NULL) {
    strlit493 = alloc_String(", ");
    gc_root(strlit493);
  }
// compiled string node returning strlit493 (depth = 7)
  int op_slot_right_492 = gc_frame_newslot(strlit493);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_492 = gc_frame_newslot(*var_s);
  params[0] = strlit493;
  partcv[0] = 1;
  Object opresult495 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult495 (depth = 6)
  *var_s = opresult495;
  if (opresult495 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if482 = done;
  } else {
  }
// compiled if node returning if482 (depth = 4)
  gc_frame_end(frame);
  return if482;
}
Object meth_collectionsPrelude_asString457(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 541
  setline(541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit458 == NULL) {
    strlit458 = alloc_String("""\xe2""""\x9f""""\xa8""");
    gc_root(strlit458);
  }
// compiled string node returning strlit458 (depth = 3)
  *var_s = strlit458;
  if (strlit458 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 542
  setline(542);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe459 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num462 = alloc_Float64(1);
// compiled num node returning num462 (depth = 5)
  int op_slot_right_461 = gc_frame_newslot(num462);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe464 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call465 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe464);
// compiled call node returning call465 (depth = 6)
// compiled member node returning call465 (depth = 5)
  int op_slot_left_461 = gc_frame_newslot(call465);
  params[0] = num462;
  partcv[0] = 1;
  Object diff466 = callmethod(call465, "-", 1, partcv, params);
// compiled op node returning diff466 (depth = 4)
  int op_slot_right_460 = gc_frame_newslot(diff466);
// starting to compile num node (depth = 4)
  Object num468 = alloc_Float64(0);
// compiled num node returning num468 (depth = 4)
  int op_slot_left_460 = gc_frame_newslot(num468);
  params[0] = diff466;
  partcv[0] = 1;
  Object opresult469 = callmethod(num468, "..", 1, partcv, params);
// compiled op node returning opresult469 (depth = 3)
  gc_frame_newslot(opresult469);
// starting to compile block node (depth = 3)
  Object block470 = alloc_Block(NULL, NULL, "collectionsPrelude", 542);
  gc_frame_newslot(block470);
// method "_apply"
  block_savedest(block470);
  Object closure471 = createclosure(2, "_apply");
  setclosureframe(closure471, stackframe);
  addtoclosure(closure471, var_s);
  addtoclosure(closure471, selfslot);
  struct UserObject *uo471 = (struct UserObject*)block470;
  uo471->data[0] = (Object)closure471;
  Method *meth_meth_collectionsPrelude__apply471 = addmethod2pos(block470, "_apply", &meth_collectionsPrelude__apply471, 0);
  int argcv_meth_collectionsPrelude__apply471[] = {1};
  meth_meth_collectionsPrelude__apply471->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply471);
  meth_meth_collectionsPrelude__apply471->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply471->definitionLine = 542;
// compiled block node returning block470 (depth = 3)
  gc_frame_newslot(block470);
// call case 5: prelude request
  params[0] = opresult469;
  params[1] = block470;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call498 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe459);
// compiled call node returning call498 (depth = 2)
// Begin line 546
  setline(546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit500 == NULL) {
    strlit500 = alloc_String("""\xe2""""\x9f""""\xa9""");
    gc_root(strlit500);
  }
// compiled string node returning strlit500 (depth = 3)
  int op_slot_right_499 = gc_frame_newslot(strlit500);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_499 = gc_frame_newslot(*var_s);
  params[0] = strlit500;
  partcv[0] = 1;
  Object opresult502 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult502 (depth = 2)
  gc_frame_end(frame);
  return opresult502;
}
Object meth_collectionsPrelude__apply506(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_element = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_element (depth = 6)
  int op_slot_right_508 = gc_frame_newslot(*var_element);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  int op_slot_left_508 = gc_frame_newslot(*var_each);
  params[0] = *var_element;
  partcv[0] = 1;
  Object opresult510 = callmethod(*var_each, "==", 1, partcv, params);
// compiled op node returning opresult510 (depth = 5)
  Object if507 = done;
  if (istrue(opresult510)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool511 = alloc_Boolean(1);
// compiled identifier node returning bool511 (depth = 6)
  block_return(realself, bool511);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if507 = undefined;
  } else {
  }
// compiled if node returning if507 (depth = 4)
  gc_frame_end(frame);
  return if507;
}
Object meth_collectionsPrelude_contains503(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_element = &(stackframe->slots[0]);
  *var_element = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for contains");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 549
  setline(549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe504 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block505 = alloc_Block(NULL, NULL, "collectionsPrelude", 549);
  gc_frame_newslot(block505);
// method "_apply"
  block_savedest(block505);
  Object closure506 = createclosure(2, "_apply");
  setclosureframe(closure506, stackframe);
  addtoclosure(closure506, var_element);
  addtoclosure(closure506, selfslot);
  struct UserObject *uo506 = (struct UserObject*)block505;
  uo506->data[0] = (Object)closure506;
  Method *meth_meth_collectionsPrelude__apply506 = addmethod2pos(block505, "_apply", &meth_collectionsPrelude__apply506, 0);
  int argcv_meth_collectionsPrelude__apply506[] = {1};
  meth_meth_collectionsPrelude__apply506->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply506);
  meth_meth_collectionsPrelude__apply506->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply506->definitionLine = 544;
// compiled block node returning block505 (depth = 3)
  gc_frame_newslot(block505);
// call case 4: self request
  params[0] = block505;
  partcv[0] = 1;
  Object call513 = callmethodflags(self, "do", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe504);
// compiled call node returning call513 (depth = 2)
// Begin line 550
  setline(550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool514 = alloc_Boolean(0);
// compiled identifier node returning bool514 (depth = 3)
  return bool514;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply519(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe521 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call522 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe521);
// compiled call node returning call522 (depth = 6)
// compiled member node returning call522 (depth = 5)
  int op_slot_right_520 = gc_frame_newslot(call522);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  int op_slot_left_520 = gc_frame_newslot(*var_i);
  params[0] = call522;
  partcv[0] = 1;
  Object opresult524 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult524 (depth = 4)
  gc_frame_end(frame);
  return opresult524;
}
Object meth_collectionsPrelude__apply527(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 555
  setline(555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe528 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe529 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe530 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call531 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe530);
// compiled call node returning call531 (depth = 7)
// compiled member node returning call531 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call532 = callmethod(call531, "at",
    1, partcv, params);
  gc_frame_end(callframe529);
// compiled call node returning call532 (depth = 5)
  gc_frame_newslot(call532);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block1 (depth = 5)
  params[0] = call532;
  partcv[0] = 1;
  Object call533 = callmethod(*var_block1, "apply",
    1, partcv, params);
  gc_frame_end(callframe528);
// compiled call node returning call533 (depth = 4)
// Begin line 556
  setline(556);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num535 = alloc_Float64(1);
// compiled num node returning num535 (depth = 6)
  int op_slot_right_534 = gc_frame_newslot(num535);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_534 = gc_frame_newslot(*var_i);
  params[0] = num535;
  partcv[0] = 1;
  Object sum537 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum537 (depth = 5)
  *var_i = sum537;
  if (sum537 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_do515(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for do");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_i = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "i");
// Begin line 553
  setline(553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num516 = alloc_Float64(0);
// compiled num node returning num516 (depth = 3)
  *var_i = num516;
  if (num516 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 554
  setline(554);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe517 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block518 = alloc_Block(NULL, NULL, "collectionsPrelude", 554);
  gc_frame_newslot(block518);
// method "_apply"
  block_savedest(block518);
  Object closure519 = createclosure(2, "_apply");
  setclosureframe(closure519, stackframe);
  addtoclosure(closure519, var_i);
  addtoclosure(closure519, selfslot);
  struct UserObject *uo519 = (struct UserObject*)block518;
  uo519->data[0] = (Object)closure519;
  Method *meth_meth_collectionsPrelude__apply519 = addmethod2pos(block518, "_apply", &meth_collectionsPrelude__apply519, 0);
  int argcv_meth_collectionsPrelude__apply519[] = {0};
  meth_meth_collectionsPrelude__apply519->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply519);
  meth_meth_collectionsPrelude__apply519->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply519->definitionLine = 544;
// compiled block node returning block518 (depth = 3)
  gc_frame_newslot(block518);
// starting to compile block node (depth = 3)
  Object block526 = alloc_Block(NULL, NULL, "collectionsPrelude", 554);
  gc_frame_newslot(block526);
// method "_apply"
  block_savedest(block526);
  Object closure527 = createclosure(3, "_apply");
  setclosureframe(closure527, stackframe);
  addtoclosure(closure527, var_i);
  addtoclosure(closure527, var_block1);
  addtoclosure(closure527, selfslot);
  struct UserObject *uo527 = (struct UserObject*)block526;
  uo527->data[0] = (Object)closure527;
  Method *meth_meth_collectionsPrelude__apply527 = addmethod2pos(block526, "_apply", &meth_collectionsPrelude__apply527, 0);
  int argcv_meth_collectionsPrelude__apply527[] = {0};
  meth_meth_collectionsPrelude__apply527->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply527);
  meth_meth_collectionsPrelude__apply527->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply527->definitionLine = 554;
// compiled block node returning block526 (depth = 3)
  gc_frame_newslot(block526);
// call case 5: prelude request
  params[0] = block518;
  params[1] = block526;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call540 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe517);
// compiled call node returning call540 (depth = 2)
  gc_frame_end(frame);
  return call540;
}
Object meth_collectionsPrelude__61__61_541(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 560
  setline(560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe542 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 2: outer request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe543 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe544 = gc_frame_new();
// call case 3: self.outer request
  Object call545 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe544);
// compiled call node returning call545 (depth = 6)
// compiled member node returning call545 (depth = 5)
  partcv[0] = 0;
  Object call546 = callmethodflags(call545, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe543);
// compiled call node returning call546 (depth = 4)
// compiled member node returning call546 (depth = 3)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call547 = callmethodflags(call546, "isEqual()toIterable", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe542);
// compiled call node returning call547 (depth = 2)
  gc_frame_end(frame);
  return call547;
}
Object meth_collectionsPrelude_asDebugString552(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 565
  setline(565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit554 == NULL) {
    strlit554 = alloc_String("""\xe2""""\x9f""""\xab""");
    gc_root(strlit554);
  }
// compiled string node returning strlit554 (depth = 3)
  int op_slot_right_553 = gc_frame_newslot(strlit554);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe557 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call558 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe557);
// compiled call node returning call558 (depth = 5)
// compiled member node returning call558 (depth = 4)
  int op_slot_right_556 = gc_frame_newslot(call558);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit561 == NULL) {
    strlit561 = alloc_String("""\xe2""""\x9f""""\xaa""");
    gc_root(strlit561);
  }
// compiled string node returning strlit561 (depth = 5)
  int op_slot_right_560 = gc_frame_newslot(strlit561);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe564 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call565 = callmethodflags(self, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe564);
// compiled call node returning call565 (depth = 7)
// compiled member node returning call565 (depth = 6)
  int op_slot_right_563 = gc_frame_newslot(call565);
// starting to compile string node (depth = 6)
  if (strlit567 == NULL) {
    strlit567 = alloc_String("");
    gc_root(strlit567);
  }
// compiled string node returning strlit567 (depth = 6)
  int op_slot_left_563 = gc_frame_newslot(strlit567);
  params[0] = call565;
  partcv[0] = 1;
  Object opresult568 = callmethod(strlit567, "++", 1, partcv, params);
// compiled op node returning opresult568 (depth = 5)
  int op_slot_left_560 = gc_frame_newslot(opresult568);
  params[0] = strlit561;
  partcv[0] = 1;
  Object opresult569 = callmethod(opresult568, "++", 1, partcv, params);
// compiled op node returning opresult569 (depth = 4)
  int op_slot_left_556 = gc_frame_newslot(opresult569);
  params[0] = call558;
  partcv[0] = 1;
  Object opresult570 = callmethod(opresult569, "++", 1, partcv, params);
// compiled op node returning opresult570 (depth = 3)
  int op_slot_left_553 = gc_frame_newslot(opresult570);
  params[0] = strlit554;
  partcv[0] = 1;
  Object opresult571 = callmethod(opresult570, "++", 1, partcv, params);
// compiled op node returning opresult571 (depth = 2)
  gc_frame_end(frame);
  return opresult571;
}
Object meth_collectionsPrelude_asString572(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 566
  setline(566);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit573 == NULL) {
    strlit573 = alloc_String("aSequenceIterator");
    gc_root(strlit573);
  }
// compiled string node returning strlit573 (depth = 2)
  gc_frame_end(frame);
  return strlit573;
}
Object meth_collectionsPrelude_hasNext574(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sz = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 567
  setline(567);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sz (depth = 3)
  int op_slot_right_575 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe577 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call578 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe577);
// compiled call node returning call578 (depth = 4)
// compiled member node returning call578 (depth = 3)
  int op_slot_left_575 = gc_frame_newslot(call578);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult579 = callmethod(call578, "≤", 1, partcv, params);
// compiled op node returning opresult579 (depth = 2)
  gc_frame_end(frame);
  return opresult579;
}
Object meth_collectionsPrelude_next580(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sz = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ret = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "ret");
// Begin line 569
  setline(569);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sz (depth = 4)
  int op_slot_right_582 = gc_frame_newslot(*var_sz);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe584 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call585 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe584);
// compiled call node returning call585 (depth = 5)
// compiled member node returning call585 (depth = 4)
  int op_slot_left_582 = gc_frame_newslot(call585);
  params[0] = *var_sz;
  partcv[0] = 1;
  Object opresult586 = callmethod(call585, ">", 1, partcv, params);
// compiled op node returning opresult586 (depth = 3)
  Object if581 = done;
  if (istrue(opresult586)) {
// starting to compile call node (depth = 3)
  int callframe587 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit589 == NULL) {
    strlit589 = alloc_String("""\xe2""""\x9f""""\xab""");
    gc_root(strlit589);
  }
// compiled string node returning strlit589 (depth = 5)
  int op_slot_right_588 = gc_frame_newslot(strlit589);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe592 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call593 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe592);
// compiled call node returning call593 (depth = 7)
// compiled member node returning call593 (depth = 6)
  int op_slot_right_591 = gc_frame_newslot(call593);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit596 == NULL) {
    strlit596 = alloc_String("""\xe2""""\x9f""""\xaa""");
    gc_root(strlit596);
  }
// compiled string node returning strlit596 (depth = 7)
  int op_slot_right_595 = gc_frame_newslot(strlit596);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe599 = gc_frame_new();
// call case 3: self.outer request
  Object call600 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe599);
// compiled call node returning call600 (depth = 9)
// compiled member node returning call600 (depth = 8)
  int op_slot_right_598 = gc_frame_newslot(call600);
// starting to compile string node (depth = 8)
  if (strlit602 == NULL) {
    strlit602 = alloc_String("on sequence ");
    gc_root(strlit602);
  }
// compiled string node returning strlit602 (depth = 8)
  int op_slot_left_598 = gc_frame_newslot(strlit602);
  params[0] = call600;
  partcv[0] = 1;
  Object opresult603 = callmethod(strlit602, "++", 1, partcv, params);
// compiled op node returning opresult603 (depth = 7)
  int op_slot_left_595 = gc_frame_newslot(opresult603);
  params[0] = strlit596;
  partcv[0] = 1;
  Object opresult604 = callmethod(opresult603, "++", 1, partcv, params);
// compiled op node returning opresult604 (depth = 6)
  int op_slot_left_591 = gc_frame_newslot(opresult604);
  params[0] = call593;
  partcv[0] = 1;
  Object opresult605 = callmethod(opresult604, "++", 1, partcv, params);
// compiled op node returning opresult605 (depth = 5)
  int op_slot_left_588 = gc_frame_newslot(opresult605);
  params[0] = strlit589;
  partcv[0] = 1;
  Object opresult606 = callmethod(opresult605, "++", 1, partcv, params);
// compiled op node returning opresult606 (depth = 4)
  gc_frame_newslot(opresult606);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_IteratorExhausted (depth = 4)
  params[0] = opresult606;
  partcv[0] = 1;
  Object call607 = callmethod(*var_IteratorExhausted, "raise",
    1, partcv, params);
  gc_frame_end(callframe587);
// compiled call node returning call607 (depth = 3)
    gc_frame_newslot(call607);
    if581 = call607;
  } else {
  }
// compiled if node returning if581 (depth = 2)
// Begin line 570
  setline(570);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe608 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe609 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call610 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe609);
// compiled call node returning call610 (depth = 5)
// compiled member node returning call610 (depth = 4)
  gc_frame_newslot(call610);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe611 = gc_frame_new();
// call case 3: self.outer request
  Object call612 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe611);
// compiled call node returning call612 (depth = 5)
// compiled member node returning call612 (depth = 4)
  params[0] = call610;
  partcv[0] = 1;
  Object call613 = callmethodflags(call612, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe608);
// compiled call node returning call613 (depth = 3)
  *var_ret = call613;
  if (call613 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 571
  setline(571);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe614 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num616 = alloc_Float64(1);
// compiled num node returning num616 (depth = 4)
  int op_slot_right_615 = gc_frame_newslot(num616);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe618 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call619 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe618);
// compiled call node returning call619 (depth = 5)
// compiled member node returning call619 (depth = 4)
  int op_slot_left_615 = gc_frame_newslot(call619);
  params[0] = num616;
  partcv[0] = 1;
  Object sum620 = callmethod(call619, "+", 1, partcv, params);
// compiled op node returning sum620 (depth = 3)
  gc_frame_newslot(sum620);
// call case 4: self request
  params[0] = sum620;
  partcv[0] = 1;
  Object call621 = callmethodflags(self, "idx:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe614);
// compiled call node returning call621 (depth = 2)
// Begin line 572
  setline(572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_ret (depth = 2)
  gc_frame_end(frame);
  return *var_ret;
}
Object meth_collectionsPrelude_iterator548(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sz = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject549 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj549 = alloc_userobj2(6,6, objclass549);
  gc_frame_newslot(obj549);
if (objclass549 == NULL) {
  glfree(obj549->class->name);
  obj549->class->name = "collectionsPrelude.sequence.object.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj549, self, 0);
  addmethodreal(obj549,"outer", &reader_collectionsPrelude_outer_550);
  Object oldself549 = self;
  struct StackFrameObject *oldstackframe549 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe549);
  gc_frame_newslot((Object)stackframe);
  self = obj549;
  Object *oldselfslot549 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter549 = (*(struct UserObject *)self).data[0], lowerouter549 = thisouter549;
  if (inheritingObject549) {
    struct UserObject *inho549 = (struct UserObject *)inheritingObject549;
    while (inho549->super != GraceDefaultObject) inho549 = (struct UserObject *)inho549->super;
    inho549->super = obj549;
    self = inheritingObject549;
    *selfslot = self;
    lowerouter549 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter549;
  }
if (objclass549 == NULL) {
  Method *reader551 = addmethodrealflags(obj549, "idx",&reader_collectionsPrelude_idx_551, MFLAG_CONFIDENTIAL);
  Method *writer551 = addmethodrealflags(obj549, "idx:=",&writer_collectionsPrelude_idx_551, MFLAG_CONFIDENTIAL);
  reader551->definitionModule = modulename;
  writer551->definitionModule = modulename;
  reader551->definitionLine = 564;
  writer551->definitionLine = 564;
}
obj549->flags |= OFLAG_MUTABLE;
adddatum2(obj549, alloc_Undefined(), 1);
// method "asDebugString"
  struct UserObject *uo552 = (struct UserObject*)obj549;
  uo552->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString552 = addmethod2pos(obj549, "asDebugString", &meth_collectionsPrelude_asDebugString552, 2);
  int argcv_meth_collectionsPrelude_asDebugString552[] = {0};
  meth_meth_collectionsPrelude_asDebugString552->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString552);
  meth_meth_collectionsPrelude_asDebugString552->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString552->definitionLine = 565;
// method "asString"
  struct UserObject *uo572 = (struct UserObject*)obj549;
  uo572->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString572 = addmethod2pos(obj549, "asString", &meth_collectionsPrelude_asString572, 3);
  int argcv_meth_collectionsPrelude_asString572[] = {0};
  meth_meth_collectionsPrelude_asString572->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString572);
  meth_meth_collectionsPrelude_asString572->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString572->definitionLine = 566;
// method "hasNext"
  block_savedest(obj549);
  Object closure574 = createclosure(1, "hasNext");
  setclosureframe(closure574, stackframe);
  addtoclosure(closure574, var_sz);
  struct UserObject *uo574 = (struct UserObject*)obj549;
  uo574->data[4] = (Object)closure574;
  Method *meth_meth_collectionsPrelude_hasNext574 = addmethod2pos(obj549, "hasNext", &meth_collectionsPrelude_hasNext574, 4);
  int argcv_meth_collectionsPrelude_hasNext574[] = {0};
  meth_meth_collectionsPrelude_hasNext574->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext574);
  meth_meth_collectionsPrelude_hasNext574->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext574->definitionLine = 567;
// method "next"
  block_savedest(obj549);
  Object closure580 = createclosure(2, "next");
  setclosureframe(closure580, stackframe);
  addtoclosure(closure580, var_sz);
  addtoclosure(closure580, var_IteratorExhausted);
  struct UserObject *uo580 = (struct UserObject*)obj549;
  uo580->data[5] = (Object)closure580;
  Method *meth_meth_collectionsPrelude_next580 = addmethod2pos(obj549, "next", &meth_collectionsPrelude_next580, 5);
  int argcv_meth_collectionsPrelude_next580[] = {0};
  meth_meth_collectionsPrelude_next580->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next580);
  meth_meth_collectionsPrelude_next580->definitionModule = modulename;
  meth_meth_collectionsPrelude_next580->definitionLine = 568;
  sourceObject = obj549;
// Begin line 564
  setline(564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num622 = alloc_Float64(1);
// compiled num node returning num622 (depth = 2)
  adddatum2(obj549, num622, 1);
  sourceObject = obj549;
  sourceObject = obj549;
  sourceObject = obj549;
  sourceObject = obj549;
  objclass549 = obj549->class;
  objclass549->definitionModule = modulename;
  objclass549->definitionLine = 563;
  (*(struct UserObject *)self).data[0] = lowerouter549;
  self = oldself549;
  selfslot = oldselfslot549;
  stackframe = oldstackframe549;
  gc_frame_end(frame);
  return obj549;
}
Object meth_collectionsPrelude_iterator548_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_sz = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject549 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj549 = alloc_userobj2(6,6, objclass549);
  gc_frame_newslot(obj549);
if (objclass549 == NULL) {
  glfree(obj549->class->name);
  obj549->class->name = "collectionsPrelude.sequence.object.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj549, self, 0);
  addmethodreal(obj549,"outer", &reader_collectionsPrelude_outer_550);
  Object oldself549 = self;
  struct StackFrameObject *oldstackframe549 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe549);
  gc_frame_newslot((Object)stackframe);
  self = obj549;
  Object *oldselfslot549 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter549 = (*(struct UserObject *)self).data[0], lowerouter549 = thisouter549;
  if (inheritingObject549) {
    struct UserObject *inho549 = (struct UserObject *)inheritingObject549;
    while (inho549->super != GraceDefaultObject) inho549 = (struct UserObject *)inho549->super;
    inho549->super = obj549;
    self = inheritingObject549;
    *selfslot = self;
    lowerouter549 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter549;
  }
if (objclass549 == NULL) {
  Method *reader551 = addmethodrealflags(obj549, "idx",&reader_collectionsPrelude_idx_551, MFLAG_CONFIDENTIAL);
  Method *writer551 = addmethodrealflags(obj549, "idx:=",&writer_collectionsPrelude_idx_551, MFLAG_CONFIDENTIAL);
  reader551->definitionModule = modulename;
  writer551->definitionModule = modulename;
  reader551->definitionLine = 564;
  writer551->definitionLine = 564;
}
obj549->flags |= OFLAG_MUTABLE;
adddatum2(obj549, alloc_Undefined(), 1);
// method "asDebugString"
  struct UserObject *uo552 = (struct UserObject*)obj549;
  uo552->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString552 = addmethod2pos(obj549, "asDebugString", &meth_collectionsPrelude_asDebugString552, 2);
  int argcv_meth_collectionsPrelude_asDebugString552[] = {0};
  meth_meth_collectionsPrelude_asDebugString552->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString552);
  meth_meth_collectionsPrelude_asDebugString552->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString552->definitionLine = 565;
// method "asString"
  struct UserObject *uo572 = (struct UserObject*)obj549;
  uo572->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString572 = addmethod2pos(obj549, "asString", &meth_collectionsPrelude_asString572, 3);
  int argcv_meth_collectionsPrelude_asString572[] = {0};
  meth_meth_collectionsPrelude_asString572->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString572);
  meth_meth_collectionsPrelude_asString572->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString572->definitionLine = 566;
// method "hasNext"
  block_savedest(obj549);
  Object closure574 = createclosure(1, "hasNext");
  setclosureframe(closure574, stackframe);
  addtoclosure(closure574, var_sz);
  struct UserObject *uo574 = (struct UserObject*)obj549;
  uo574->data[4] = (Object)closure574;
  Method *meth_meth_collectionsPrelude_hasNext574 = addmethod2pos(obj549, "hasNext", &meth_collectionsPrelude_hasNext574, 4);
  int argcv_meth_collectionsPrelude_hasNext574[] = {0};
  meth_meth_collectionsPrelude_hasNext574->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext574);
  meth_meth_collectionsPrelude_hasNext574->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext574->definitionLine = 567;
// method "next"
  block_savedest(obj549);
  Object closure580 = createclosure(2, "next");
  setclosureframe(closure580, stackframe);
  addtoclosure(closure580, var_sz);
  addtoclosure(closure580, var_IteratorExhausted);
  struct UserObject *uo580 = (struct UserObject*)obj549;
  uo580->data[5] = (Object)closure580;
  Method *meth_meth_collectionsPrelude_next580 = addmethod2pos(obj549, "next", &meth_collectionsPrelude_next580, 5);
  int argcv_meth_collectionsPrelude_next580[] = {0};
  meth_meth_collectionsPrelude_next580->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next580);
  meth_meth_collectionsPrelude_next580->definitionModule = modulename;
  meth_meth_collectionsPrelude_next580->definitionLine = 568;
  sourceObject = obj549;
// Begin line 564
  setline(564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num622 = alloc_Float64(1);
// compiled num node returning num622 (depth = 2)
  adddatum2(obj549, num622, 1);
  sourceObject = obj549;
  sourceObject = obj549;
  sourceObject = obj549;
  sourceObject = obj549;
  objclass549 = obj549->class;
  objclass549->definitionModule = modulename;
  objclass549->definitionLine = 563;
  (*(struct UserObject *)self).data[0] = lowerouter549;
  self = oldself549;
  selfslot = oldselfslot549;
  stackframe = oldstackframe549;
  gc_frame_end(frame);
  return obj549;
}
Object meth_collectionsPrelude__apply628(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[1]);
  *var_r = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 578
  setline(578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_r (depth = 8)
  int op_slot_right_630 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_l (depth = 8)
  int op_slot_left_630 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult632 = callmethod(*var_l, "==", 1, partcv, params);
// compiled op node returning opresult632 (depth = 7)
  Object if629 = done;
  if (istrue(opresult632)) {
// starting to compile num node (depth = 7)
  Object num633 = alloc_Float64(0);
// compiled num node returning num633 (depth = 7)
    gc_frame_newslot(num633);
    if629 = num633;
  } else {
// Begin line 580
  setline(580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 7)
// Begin line 579
  setline(579);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_r (depth = 9)
  int op_slot_right_635 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_l (depth = 9)
  int op_slot_left_635 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult637 = callmethod(*var_l, "<", 1, partcv, params);
// compiled op node returning opresult637 (depth = 8)
  Object if634 = done;
  if (istrue(opresult637)) {
// starting to compile call node (depth = 8)
  int callframe638 = gc_frame_new();
// call case 6: other member request
// starting to compile num node (depth = 9)
  Object num639 = alloc_Float64(1);
// compiled num node returning num639 (depth = 9)
  partcv[0] = 0;
  Object call640 = callmethod(num639, "prefix-",
    1, partcv, params);
  gc_frame_end(callframe638);
// compiled call node returning call640 (depth = 8)
    gc_frame_newslot(call640);
    if634 = call640;
  } else {
// Begin line 580
  setline(580);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 8)
  Object num641 = alloc_Float64(1);
// compiled num node returning num641 (depth = 8)
    gc_frame_newslot(num641);
    if634 = num641;
  }
// compiled if node returning if634 (depth = 7)
    gc_frame_newslot(if634);
    if629 = if634;
  }
// compiled if node returning if629 (depth = 6)
  gc_frame_end(frame);
  return if629;
}
Object meth_collectionsPrelude_sorted624(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sorted (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for sorted");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 581
  setline(581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe625 = gc_frame_new();
// call case 6: other member request
// Begin line 577
  setline(577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe626 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block627 = alloc_Block(NULL, NULL, "collectionsPrelude", 577);
  gc_frame_newslot(block627);
// method "_apply"
  block_savedest(block627);
  Object closure628 = createclosure(1, "_apply");
  setclosureframe(closure628, stackframe);
  addtoclosure(closure628, selfslot);
  struct UserObject *uo628 = (struct UserObject*)block627;
  uo628->data[0] = (Object)closure628;
  Method *meth_meth_collectionsPrelude__apply628 = addmethod2pos(block627, "_apply", &meth_collectionsPrelude__apply628, 0);
  int argcv_meth_collectionsPrelude__apply628[] = {2};
  meth_meth_collectionsPrelude__apply628->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply628);
  meth_meth_collectionsPrelude__apply628->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply628->definitionLine = 581;
// compiled block node returning block627 (depth = 5)
  gc_frame_newslot(block627);
// call case 6: other member request
// Begin line 577
  setline(577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe643 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call644 = callmethodflags(self, "asList", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe643);
// compiled call node returning call644 (depth = 6)
// compiled member node returning call644 (depth = 5)
  params[0] = block627;
  partcv[0] = 1;
  Object call645 = callmethod(call644, "sortBy",
    1, partcv, params);
  gc_frame_end(callframe626);
// compiled call node returning call645 (depth = 4)
  partcv[0] = 0;
  Object call646 = callmethod(call645, "asSequence",
    1, partcv, params);
  gc_frame_end(callframe625);
// compiled call node returning call646 (depth = 3)
// compiled member node returning call646 (depth = 2)
  gc_frame_end(frame);
  return call646;
}
Object meth_collectionsPrelude_sortedBy647(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for sortedBy");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 584
  setline(584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe648 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe649 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_sortBlock (depth = 5)
  gc_frame_newslot(*var_sortBlock);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe650 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call651 = callmethodflags(self, "asList", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe650);
// compiled call node returning call651 (depth = 6)
// compiled member node returning call651 (depth = 5)
  params[0] = *var_sortBlock;
  partcv[0] = 1;
  Object call652 = callmethod(call651, "sortBy",
    1, partcv, params);
  gc_frame_end(callframe649);
// compiled call node returning call652 (depth = 4)
  partcv[0] = 0;
  Object call653 = callmethod(call652, "asSequence",
    1, partcv, params);
  gc_frame_end(callframe648);
// compiled call node returning call653 (depth = 3)
// compiled member node returning call653 (depth = 2)
  gc_frame_end(frame);
  return call653;
}
Object meth_collectionsPrelude_fromprimitiveArray315(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "fromprimitiveArray");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method fromprimitiveArray");
  Object params[1];
  int partcv[2];
  Object *var_BoundsError = getfromclosure(closure, 0);
  Object *var__prelude = getfromclosure(closure, 1);
  Object *var_IteratorExhausted = getfromclosure(closure, 2);
  Object *var_indexable = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for fromprimitiveArray (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_pArray = &(stackframe->slots[0]);
  *var_pArray = args[curarg];
  curarg++;
  Object *var_sz = &(stackframe->slots[1]);
  *var_sz = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for fromprimitiveArray");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject316 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj316 = alloc_userobj2(17,18, objclass316);
  gc_frame_newslot(obj316);
if (objclass316 == NULL) {
  glfree(obj316->class->name);
  obj316->class->name = "collectionsPrelude.sequence.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj316, self, 0);
  addmethodreal(obj316,"outer", &reader_collectionsPrelude_outer_317);
  Object oldself316 = self;
  struct StackFrameObject *oldstackframe316 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe316);
  gc_frame_newslot((Object)stackframe);
  self = obj316;
  Object *oldselfslot316 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter316 = (*(struct UserObject *)self).data[0], lowerouter316 = thisouter316;
  if (inheritingObject316) {
    struct UserObject *inho316 = (struct UserObject *)inheritingObject316;
    while (inho316->super != GraceDefaultObject) inho316 = (struct UserObject *)inho316->super;
    inho316->super = obj316;
    self = inheritingObject316;
    *selfslot = self;
    lowerouter316 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter316;
  }
if (objclass316 == NULL) {
  Method *reader318 = addmethodrealflags(obj316, "size",&reader_collectionsPrelude_size_318, MFLAG_DEF);
  reader318->definitionModule = modulename;
  reader318->definitionLine = 501;
}
adddatum2(obj316, alloc_Undefined(), 1);
if (objclass316 == NULL) {
  Method *reader319 = addmethodrealflags(obj316, "inner",&reader_collectionsPrelude_inner_319, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader319->definitionModule = modulename;
  reader319->definitionLine = 502;
}
adddatum2(obj316, alloc_Undefined(), 2);
// method "boundsCheck"
  block_savedest(obj316);
  Object closure320 = createclosure(1, "boundsCheck");
  setclosureframe(closure320, stackframe);
  addtoclosure(closure320, var_BoundsError);
  struct UserObject *uo320 = (struct UserObject*)obj316;
  uo320->data[3] = (Object)closure320;
  Method *meth_meth_collectionsPrelude_boundsCheck320 = addmethod2pos(obj316, "boundsCheck", &meth_collectionsPrelude_boundsCheck320, 3);
  int argcv_meth_collectionsPrelude_boundsCheck320[] = {1};
  meth_meth_collectionsPrelude_boundsCheck320->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_boundsCheck320);
  meth_meth_collectionsPrelude_boundsCheck320->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_boundsCheck320->definitionModule = modulename;
  meth_meth_collectionsPrelude_boundsCheck320->definitionLine = 504;
// method "at"
  struct UserObject *uo357 = (struct UserObject*)obj316;
  uo357->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at357 = addmethod2pos(obj316, "at", &meth_collectionsPrelude_at357, 4);
  int argcv_meth_collectionsPrelude_at357[] = {1};
  meth_meth_collectionsPrelude_at357->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at357);
  meth_meth_collectionsPrelude_at357->definitionModule = modulename;
  meth_meth_collectionsPrelude_at357->definitionLine = 511;
// method "keys"
  struct UserObject *uo368 = (struct UserObject*)obj316;
  uo368->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys368 = addmethod2pos(obj316, "keys", &meth_collectionsPrelude_keys368, 5);
  int argcv_meth_collectionsPrelude_keys368[] = {0};
  meth_meth_collectionsPrelude_keys368->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys368);
  meth_meth_collectionsPrelude_keys368->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys368->definitionLine = 515;
// method "values"
  struct UserObject *uo380 = (struct UserObject*)obj316;
  uo380->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values380 = addmethod2pos(obj316, "values", &meth_collectionsPrelude_values380, 6);
  int argcv_meth_collectionsPrelude_values380[] = {0};
  meth_meth_collectionsPrelude_values380->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values380);
  meth_meth_collectionsPrelude_values380->definitionModule = modulename;
  meth_meth_collectionsPrelude_values380->definitionLine = 518;
// method "keysAndValuesDo"
  struct UserObject *uo381 = (struct UserObject*)obj316;
  uo381->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo381 = addmethod2pos(obj316, "keysAndValuesDo", &meth_collectionsPrelude_keysAndValuesDo381, 7);
  int argcv_meth_collectionsPrelude_keysAndValuesDo381[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo381->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo381);
  meth_meth_collectionsPrelude_keysAndValuesDo381->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo381->definitionLine = 521;
// method "reversed"
  block_savedest(obj316);
  Object closure411 = createclosure(1, "reversed");
  setclosureframe(closure411, stackframe);
  addtoclosure(closure411, var__prelude);
  struct UserObject *uo411 = (struct UserObject*)obj316;
  uo411->data[8] = (Object)closure411;
  Method *meth_meth_collectionsPrelude_reversed411 = addmethod2pos(obj316, "reversed", &meth_collectionsPrelude_reversed411, 8);
  int argcv_meth_collectionsPrelude_reversed411[] = {0};
  meth_meth_collectionsPrelude_reversed411->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed411);
  meth_meth_collectionsPrelude_reversed411->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed411->definitionLine = 528;
// method "++"
  struct UserObject *uo442 = (struct UserObject*)obj316;
  uo442->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_442 = addmethod2pos(obj316, "++", &meth_collectionsPrelude__43__43_442, 9);
  int argcv_meth_collectionsPrelude__43__43_442[] = {1};
  meth_meth_collectionsPrelude__43__43_442->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_442);
  meth_meth_collectionsPrelude__43__43_442->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_442->definitionLine = 537;
// method "asString"
  struct UserObject *uo457 = (struct UserObject*)obj316;
  uo457->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString457 = addmethod2pos(obj316, "asString", &meth_collectionsPrelude_asString457, 10);
  int argcv_meth_collectionsPrelude_asString457[] = {0};
  meth_meth_collectionsPrelude_asString457->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString457);
  meth_meth_collectionsPrelude_asString457->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString457->definitionLine = 540;
// method "contains"
  struct UserObject *uo503 = (struct UserObject*)obj316;
  uo503->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains503 = addmethod2pos(obj316, "contains", &meth_collectionsPrelude_contains503, 11);
  int argcv_meth_collectionsPrelude_contains503[] = {1};
  meth_meth_collectionsPrelude_contains503->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains503);
  meth_meth_collectionsPrelude_contains503->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains503->definitionLine = 548;
// method "do"
  struct UserObject *uo515 = (struct UserObject*)obj316;
  uo515->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do515 = addmethod2pos(obj316, "do", &meth_collectionsPrelude_do515, 12);
  int argcv_meth_collectionsPrelude_do515[] = {1};
  meth_meth_collectionsPrelude_do515->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do515);
  meth_meth_collectionsPrelude_do515->definitionModule = modulename;
  meth_meth_collectionsPrelude_do515->definitionLine = 552;
// method "=="
  struct UserObject *uo541 = (struct UserObject*)obj316;
  uo541->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61_541 = addmethod2pos(obj316, "==", &meth_collectionsPrelude__61__61_541, 13);
  int argcv_meth_collectionsPrelude__61__61_541[] = {1};
  meth_meth_collectionsPrelude__61__61_541->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_541);
  meth_meth_collectionsPrelude__61__61_541->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_541->definitionLine = 559;
// method "iterator"
  block_savedest(obj316);
  Object closure548 = createclosure(2, "iterator");
  setclosureframe(closure548, stackframe);
  addtoclosure(closure548, var_sz);
  addtoclosure(closure548, var_IteratorExhausted);
  struct UserObject *uo548 = (struct UserObject*)obj316;
  uo548->data[14] = (Object)closure548;
  Method *meth_meth_collectionsPrelude_iterator548 = addmethod2pos(obj316, "iterator", &meth_collectionsPrelude_iterator548, 14);
  int argcv_meth_collectionsPrelude_iterator548[] = {0};
  meth_meth_collectionsPrelude_iterator548->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator548);
  meth_meth_collectionsPrelude_iterator548->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator548->definitionLine = 562;
  block_savedest(obj316);
  Object closure623 = createclosure(2, "iterator()object");
  setclosureframe(closure623, stackframe);
  addtoclosure(closure623, var_sz);
  addtoclosure(closure623, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator548_object = addmethod2pos(obj316, "iterator()object", &meth_collectionsPrelude_iterator548_object, 14);
  meth_meth_collectionsPrelude_iterator548_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator548_object->definitionLine = 562;
// method "sorted"
  struct UserObject *uo624 = (struct UserObject*)obj316;
  uo624->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted624 = addmethod2pos(obj316, "sorted", &meth_collectionsPrelude_sorted624, 15);
  int argcv_meth_collectionsPrelude_sorted624[] = {0};
  meth_meth_collectionsPrelude_sorted624->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted624);
  meth_meth_collectionsPrelude_sorted624->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted624->definitionLine = 576;
// method "sortedBy"
  struct UserObject *uo647 = (struct UserObject*)obj316;
  uo647->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy647 = addmethod2pos(obj316, "sortedBy", &meth_collectionsPrelude_sortedBy647, 16);
  int argcv_meth_collectionsPrelude_sortedBy647[] = {1};
  meth_meth_collectionsPrelude_sortedBy647->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy647);
  meth_meth_collectionsPrelude_sortedBy647->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy647->definitionLine = 583;
  sourceObject = obj316;
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe654 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call655 = callmethod(*var_indexable, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe654);
// compiled call node returning call655 (depth = 2)
  struct UserObject *obj316_uo = (struct UserObject *)obj316;
  obj316_uo->super = call655;
  sourceObject = obj316;
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_sz (depth = 2)
  adddatum2(obj316, *var_sz, 1);
  sourceObject = obj316;
// Begin line 502
  setline(502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_pArray (depth = 2)
  adddatum2(obj316, *var_pArray, 2);
  sourceObject = obj316;
  sourceObject = obj316;
  sourceObject = obj316;
  sourceObject = obj316;
  sourceObject = obj316;
  sourceObject = obj316;
  sourceObject = obj316;
  sourceObject = obj316;
  sourceObject = obj316;
  sourceObject = obj316;
  sourceObject = obj316;
  sourceObject = obj316;
  sourceObject = obj316;
  sourceObject = obj316;
  objclass316 = obj316->class;
  objclass316->definitionModule = modulename;
  objclass316->definitionLine = 499;
  (*(struct UserObject *)self).data[0] = lowerouter316;
  self = oldself316;
  selfslot = oldselfslot316;
  stackframe = oldstackframe316;
  gc_frame_end(frame);
  return obj316;
}
Object meth_collectionsPrelude_fromprimitiveArray315_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "fromprimitiveArray()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method fromprimitiveArray()object");
  Object params[1];
  int partcv[2];
  Object *var_BoundsError = getfromclosure(closure, 0);
  Object *var__prelude = getfromclosure(closure, 1);
  Object *var_IteratorExhausted = getfromclosure(closure, 2);
  Object *var_indexable = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for fromprimitiveArray (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_pArray = &(stackframe->slots[0]);
  *var_pArray = args[curarg];
  curarg++;
  Object *var_sz = &(stackframe->slots[1]);
  *var_sz = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for fromprimitiveArray");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject316 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj316 = alloc_userobj2(17,18, objclass316);
  gc_frame_newslot(obj316);
if (objclass316 == NULL) {
  glfree(obj316->class->name);
  obj316->class->name = "collectionsPrelude.sequence.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj316, self, 0);
  addmethodreal(obj316,"outer", &reader_collectionsPrelude_outer_317);
  Object oldself316 = self;
  struct StackFrameObject *oldstackframe316 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe316);
  gc_frame_newslot((Object)stackframe);
  self = obj316;
  Object *oldselfslot316 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter316 = (*(struct UserObject *)self).data[0], lowerouter316 = thisouter316;
  if (inheritingObject316) {
    struct UserObject *inho316 = (struct UserObject *)inheritingObject316;
    while (inho316->super != GraceDefaultObject) inho316 = (struct UserObject *)inho316->super;
    inho316->super = obj316;
    self = inheritingObject316;
    *selfslot = self;
    lowerouter316 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter316;
  }
if (objclass316 == NULL) {
  Method *reader318 = addmethodrealflags(obj316, "size",&reader_collectionsPrelude_size_318, MFLAG_DEF);
  reader318->definitionModule = modulename;
  reader318->definitionLine = 501;
}
adddatum2(obj316, alloc_Undefined(), 1);
if (objclass316 == NULL) {
  Method *reader319 = addmethodrealflags(obj316, "inner",&reader_collectionsPrelude_inner_319, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader319->definitionModule = modulename;
  reader319->definitionLine = 502;
}
adddatum2(obj316, alloc_Undefined(), 2);
// method "boundsCheck"
  block_savedest(obj316);
  Object closure320 = createclosure(1, "boundsCheck");
  setclosureframe(closure320, stackframe);
  addtoclosure(closure320, var_BoundsError);
  struct UserObject *uo320 = (struct UserObject*)obj316;
  uo320->data[3] = (Object)closure320;
  Method *meth_meth_collectionsPrelude_boundsCheck320 = addmethod2pos(obj316, "boundsCheck", &meth_collectionsPrelude_boundsCheck320, 3);
  int argcv_meth_collectionsPrelude_boundsCheck320[] = {1};
  meth_meth_collectionsPrelude_boundsCheck320->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_boundsCheck320);
  meth_meth_collectionsPrelude_boundsCheck320->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_boundsCheck320->definitionModule = modulename;
  meth_meth_collectionsPrelude_boundsCheck320->definitionLine = 504;
// method "at"
  struct UserObject *uo357 = (struct UserObject*)obj316;
  uo357->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at357 = addmethod2pos(obj316, "at", &meth_collectionsPrelude_at357, 4);
  int argcv_meth_collectionsPrelude_at357[] = {1};
  meth_meth_collectionsPrelude_at357->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at357);
  meth_meth_collectionsPrelude_at357->definitionModule = modulename;
  meth_meth_collectionsPrelude_at357->definitionLine = 511;
// method "keys"
  struct UserObject *uo368 = (struct UserObject*)obj316;
  uo368->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys368 = addmethod2pos(obj316, "keys", &meth_collectionsPrelude_keys368, 5);
  int argcv_meth_collectionsPrelude_keys368[] = {0};
  meth_meth_collectionsPrelude_keys368->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys368);
  meth_meth_collectionsPrelude_keys368->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys368->definitionLine = 515;
// method "values"
  struct UserObject *uo380 = (struct UserObject*)obj316;
  uo380->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values380 = addmethod2pos(obj316, "values", &meth_collectionsPrelude_values380, 6);
  int argcv_meth_collectionsPrelude_values380[] = {0};
  meth_meth_collectionsPrelude_values380->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values380);
  meth_meth_collectionsPrelude_values380->definitionModule = modulename;
  meth_meth_collectionsPrelude_values380->definitionLine = 518;
// method "keysAndValuesDo"
  struct UserObject *uo381 = (struct UserObject*)obj316;
  uo381->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo381 = addmethod2pos(obj316, "keysAndValuesDo", &meth_collectionsPrelude_keysAndValuesDo381, 7);
  int argcv_meth_collectionsPrelude_keysAndValuesDo381[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo381->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo381);
  meth_meth_collectionsPrelude_keysAndValuesDo381->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo381->definitionLine = 521;
// method "reversed"
  block_savedest(obj316);
  Object closure411 = createclosure(1, "reversed");
  setclosureframe(closure411, stackframe);
  addtoclosure(closure411, var__prelude);
  struct UserObject *uo411 = (struct UserObject*)obj316;
  uo411->data[8] = (Object)closure411;
  Method *meth_meth_collectionsPrelude_reversed411 = addmethod2pos(obj316, "reversed", &meth_collectionsPrelude_reversed411, 8);
  int argcv_meth_collectionsPrelude_reversed411[] = {0};
  meth_meth_collectionsPrelude_reversed411->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed411);
  meth_meth_collectionsPrelude_reversed411->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed411->definitionLine = 528;
// method "++"
  struct UserObject *uo442 = (struct UserObject*)obj316;
  uo442->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_442 = addmethod2pos(obj316, "++", &meth_collectionsPrelude__43__43_442, 9);
  int argcv_meth_collectionsPrelude__43__43_442[] = {1};
  meth_meth_collectionsPrelude__43__43_442->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_442);
  meth_meth_collectionsPrelude__43__43_442->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_442->definitionLine = 537;
// method "asString"
  struct UserObject *uo457 = (struct UserObject*)obj316;
  uo457->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString457 = addmethod2pos(obj316, "asString", &meth_collectionsPrelude_asString457, 10);
  int argcv_meth_collectionsPrelude_asString457[] = {0};
  meth_meth_collectionsPrelude_asString457->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString457);
  meth_meth_collectionsPrelude_asString457->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString457->definitionLine = 540;
// method "contains"
  struct UserObject *uo503 = (struct UserObject*)obj316;
  uo503->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains503 = addmethod2pos(obj316, "contains", &meth_collectionsPrelude_contains503, 11);
  int argcv_meth_collectionsPrelude_contains503[] = {1};
  meth_meth_collectionsPrelude_contains503->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains503);
  meth_meth_collectionsPrelude_contains503->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains503->definitionLine = 548;
// method "do"
  struct UserObject *uo515 = (struct UserObject*)obj316;
  uo515->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do515 = addmethod2pos(obj316, "do", &meth_collectionsPrelude_do515, 12);
  int argcv_meth_collectionsPrelude_do515[] = {1};
  meth_meth_collectionsPrelude_do515->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do515);
  meth_meth_collectionsPrelude_do515->definitionModule = modulename;
  meth_meth_collectionsPrelude_do515->definitionLine = 552;
// method "=="
  struct UserObject *uo541 = (struct UserObject*)obj316;
  uo541->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61_541 = addmethod2pos(obj316, "==", &meth_collectionsPrelude__61__61_541, 13);
  int argcv_meth_collectionsPrelude__61__61_541[] = {1};
  meth_meth_collectionsPrelude__61__61_541->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_541);
  meth_meth_collectionsPrelude__61__61_541->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_541->definitionLine = 559;
// method "iterator"
  block_savedest(obj316);
  Object closure548 = createclosure(2, "iterator");
  setclosureframe(closure548, stackframe);
  addtoclosure(closure548, var_sz);
  addtoclosure(closure548, var_IteratorExhausted);
  struct UserObject *uo548 = (struct UserObject*)obj316;
  uo548->data[14] = (Object)closure548;
  Method *meth_meth_collectionsPrelude_iterator548 = addmethod2pos(obj316, "iterator", &meth_collectionsPrelude_iterator548, 14);
  int argcv_meth_collectionsPrelude_iterator548[] = {0};
  meth_meth_collectionsPrelude_iterator548->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator548);
  meth_meth_collectionsPrelude_iterator548->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator548->definitionLine = 562;
  block_savedest(obj316);
  Object closure623 = createclosure(2, "iterator()object");
  setclosureframe(closure623, stackframe);
  addtoclosure(closure623, var_sz);
  addtoclosure(closure623, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator548_object = addmethod2pos(obj316, "iterator()object", &meth_collectionsPrelude_iterator548_object, 14);
  meth_meth_collectionsPrelude_iterator548_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator548_object->definitionLine = 562;
// method "sorted"
  struct UserObject *uo624 = (struct UserObject*)obj316;
  uo624->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted624 = addmethod2pos(obj316, "sorted", &meth_collectionsPrelude_sorted624, 15);
  int argcv_meth_collectionsPrelude_sorted624[] = {0};
  meth_meth_collectionsPrelude_sorted624->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted624);
  meth_meth_collectionsPrelude_sorted624->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted624->definitionLine = 576;
// method "sortedBy"
  struct UserObject *uo647 = (struct UserObject*)obj316;
  uo647->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy647 = addmethod2pos(obj316, "sortedBy", &meth_collectionsPrelude_sortedBy647, 16);
  int argcv_meth_collectionsPrelude_sortedBy647[] = {1};
  meth_meth_collectionsPrelude_sortedBy647->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy647);
  meth_meth_collectionsPrelude_sortedBy647->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy647->definitionLine = 583;
  sourceObject = obj316;
// Begin line 500
  setline(500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe654 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call655 = callmethod(*var_indexable, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe654);
// compiled call node returning call655 (depth = 2)
  struct UserObject *obj316_uo = (struct UserObject *)obj316;
  obj316_uo->super = call655;
  sourceObject = obj316;
// Begin line 501
  setline(501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_sz (depth = 2)
  adddatum2(obj316, *var_sz, 1);
  sourceObject = obj316;
// Begin line 502
  setline(502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_pArray (depth = 2)
  adddatum2(obj316, *var_pArray, 2);
  sourceObject = obj316;
  sourceObject = obj316;
  sourceObject = obj316;
  sourceObject = obj316;
  sourceObject = obj316;
  sourceObject = obj316;
  sourceObject = obj316;
  sourceObject = obj316;
  sourceObject = obj316;
  sourceObject = obj316;
  sourceObject = obj316;
  sourceObject = obj316;
  sourceObject = obj316;
  sourceObject = obj316;
  objclass316 = obj316->class;
  objclass316->definitionModule = modulename;
  objclass316->definitionLine = 499;
  (*(struct UserObject *)self).data[0] = lowerouter316;
  self = oldself316;
  selfslot = oldselfslot316;
  stackframe = oldstackframe316;
  gc_frame_end(frame);
  return obj316;
}
Object meth_collectionsPrelude_sequence227(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "sequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  Object *var__prelude = getfromclosure(closure, 1);
  Object *var_BoundsError = getfromclosure(closure, 2);
  Object *var_IteratorExhausted = getfromclosure(closure, 3);
  Object *var_indexable = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sequence (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for sequence");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject228 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj228 = alloc_userobj2(5,6, objclass228);
  gc_frame_newslot(obj228);
if (objclass228 == NULL) {
  glfree(obj228->class->name);
  obj228->class->name = "collectionsPrelude.sequence";
}
// OBJECT OUTER DEC outer
  adddatum2(obj228, self, 0);
  addmethodreal(obj228,"outer", &reader_collectionsPrelude_outer_229);
  Object oldself228 = self;
  struct StackFrameObject *oldstackframe228 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe228);
  gc_frame_newslot((Object)stackframe);
  self = obj228;
  Object *oldselfslot228 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter228 = (*(struct UserObject *)self).data[0], lowerouter228 = thisouter228;
  if (inheritingObject228) {
    struct UserObject *inho228 = (struct UserObject *)inheritingObject228;
    while (inho228->super != GraceDefaultObject) inho228 = (struct UserObject *)inho228->super;
    inho228->super = obj228;
    self = inheritingObject228;
    *selfslot = self;
    lowerouter228 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter228;
  }
// method "asString"
  struct UserObject *uo230 = (struct UserObject*)obj228;
  uo230->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString230 = addmethod2pos(obj228, "asString", &meth_collectionsPrelude_asString230, 1);
  int argcv_meth_collectionsPrelude_asString230[] = {0};
  meth_meth_collectionsPrelude_asString230->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString230);
  meth_meth_collectionsPrelude_asString230->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString230->definitionLine = 455;
// method "empty"
  block_savedest(obj228);
  Object closure232 = createclosure(1, "empty");
  setclosureframe(closure232, stackframe);
  addtoclosure(closure232, var_emptySequence);
  struct UserObject *uo232 = (struct UserObject*)obj228;
  uo232->data[2] = (Object)closure232;
  Method *meth_meth_collectionsPrelude_empty232 = addmethod2pos(obj228, "empty", &meth_collectionsPrelude_empty232, 2);
  int argcv_meth_collectionsPrelude_empty232[] = {0};
  meth_meth_collectionsPrelude_empty232->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_empty232);
  meth_meth_collectionsPrelude_empty232->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty232->definitionLine = 457;
// method "withAll"
  block_savedest(obj228);
  Object closure233 = createclosure(2, "withAll");
  setclosureframe(closure233, stackframe);
  addtoclosure(closure233, var__prelude);
  addtoclosure(closure233, var_emptySequence);
  struct UserObject *uo233 = (struct UserObject*)obj228;
  uo233->data[3] = (Object)closure233;
  Method *meth_meth_collectionsPrelude_withAll233 = addmethod2pos(obj228, "withAll", &meth_collectionsPrelude_withAll233, 3);
  int argcv_meth_collectionsPrelude_withAll233[] = {1};
  meth_meth_collectionsPrelude_withAll233->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll233);
  meth_meth_collectionsPrelude_withAll233->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll233->definitionLine = 462;
// method "fromprimitiveArray"
  block_savedest(obj228);
  Object closure315 = createclosure(4, "fromprimitiveArray");
  setclosureframe(closure315, stackframe);
  addtoclosure(closure315, var_BoundsError);
  addtoclosure(closure315, var__prelude);
  addtoclosure(closure315, var_IteratorExhausted);
  addtoclosure(closure315, var_indexable);
  struct UserObject *uo315 = (struct UserObject*)obj228;
  uo315->data[4] = (Object)closure315;
  Method *meth_meth_collectionsPrelude_fromprimitiveArray315 = addmethod2pos(obj228, "fromprimitiveArray", &meth_collectionsPrelude_fromprimitiveArray315, 4);
  int argcv_meth_collectionsPrelude_fromprimitiveArray315[] = {2};
  meth_meth_collectionsPrelude_fromprimitiveArray315->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_fromprimitiveArray315);
  meth_meth_collectionsPrelude_fromprimitiveArray315->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_fromprimitiveArray315->definitionModule = modulename;
  meth_meth_collectionsPrelude_fromprimitiveArray315->definitionLine = 496;
  block_savedest(obj228);
  Object closure656 = createclosure(4, "fromprimitiveArray()object");
  setclosureframe(closure656, stackframe);
  addtoclosure(closure656, var_BoundsError);
  addtoclosure(closure656, var__prelude);
  addtoclosure(closure656, var_IteratorExhausted);
  addtoclosure(closure656, var_indexable);
  Method *meth_meth_collectionsPrelude_fromprimitiveArray315_object = addmethod2pos(obj228, "fromprimitiveArray()object", &meth_collectionsPrelude_fromprimitiveArray315_object, 4);
  meth_meth_collectionsPrelude_fromprimitiveArray315_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_fromprimitiveArray315_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_fromprimitiveArray315_object->definitionLine = 496;
  sourceObject = obj228;
  sourceObject = obj228;
  sourceObject = obj228;
  sourceObject = obj228;
  objclass228 = obj228->class;
  objclass228->definitionModule = modulename;
  objclass228->definitionLine = 453;
  (*(struct UserObject *)self).data[0] = lowerouter228;
  self = oldself228;
  selfslot = oldselfslot228;
  stackframe = oldstackframe228;
  gc_frame_end(frame);
  return obj228;
}
Object meth_collectionsPrelude_sequence227_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "sequence()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  Object *var__prelude = getfromclosure(closure, 1);
  Object *var_BoundsError = getfromclosure(closure, 2);
  Object *var_IteratorExhausted = getfromclosure(closure, 3);
  Object *var_indexable = getfromclosure(closure, 4);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sequence (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for sequence");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject228 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj228 = alloc_userobj2(5,6, objclass228);
  gc_frame_newslot(obj228);
if (objclass228 == NULL) {
  glfree(obj228->class->name);
  obj228->class->name = "collectionsPrelude.sequence";
}
// OBJECT OUTER DEC outer
  adddatum2(obj228, self, 0);
  addmethodreal(obj228,"outer", &reader_collectionsPrelude_outer_229);
  Object oldself228 = self;
  struct StackFrameObject *oldstackframe228 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe228);
  gc_frame_newslot((Object)stackframe);
  self = obj228;
  Object *oldselfslot228 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter228 = (*(struct UserObject *)self).data[0], lowerouter228 = thisouter228;
  if (inheritingObject228) {
    struct UserObject *inho228 = (struct UserObject *)inheritingObject228;
    while (inho228->super != GraceDefaultObject) inho228 = (struct UserObject *)inho228->super;
    inho228->super = obj228;
    self = inheritingObject228;
    *selfslot = self;
    lowerouter228 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter228;
  }
// method "asString"
  struct UserObject *uo230 = (struct UserObject*)obj228;
  uo230->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString230 = addmethod2pos(obj228, "asString", &meth_collectionsPrelude_asString230, 1);
  int argcv_meth_collectionsPrelude_asString230[] = {0};
  meth_meth_collectionsPrelude_asString230->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString230);
  meth_meth_collectionsPrelude_asString230->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString230->definitionLine = 455;
// method "empty"
  block_savedest(obj228);
  Object closure232 = createclosure(1, "empty");
  setclosureframe(closure232, stackframe);
  addtoclosure(closure232, var_emptySequence);
  struct UserObject *uo232 = (struct UserObject*)obj228;
  uo232->data[2] = (Object)closure232;
  Method *meth_meth_collectionsPrelude_empty232 = addmethod2pos(obj228, "empty", &meth_collectionsPrelude_empty232, 2);
  int argcv_meth_collectionsPrelude_empty232[] = {0};
  meth_meth_collectionsPrelude_empty232->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_empty232);
  meth_meth_collectionsPrelude_empty232->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty232->definitionLine = 457;
// method "withAll"
  block_savedest(obj228);
  Object closure233 = createclosure(2, "withAll");
  setclosureframe(closure233, stackframe);
  addtoclosure(closure233, var__prelude);
  addtoclosure(closure233, var_emptySequence);
  struct UserObject *uo233 = (struct UserObject*)obj228;
  uo233->data[3] = (Object)closure233;
  Method *meth_meth_collectionsPrelude_withAll233 = addmethod2pos(obj228, "withAll", &meth_collectionsPrelude_withAll233, 3);
  int argcv_meth_collectionsPrelude_withAll233[] = {1};
  meth_meth_collectionsPrelude_withAll233->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll233);
  meth_meth_collectionsPrelude_withAll233->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll233->definitionLine = 462;
// method "fromprimitiveArray"
  block_savedest(obj228);
  Object closure315 = createclosure(4, "fromprimitiveArray");
  setclosureframe(closure315, stackframe);
  addtoclosure(closure315, var_BoundsError);
  addtoclosure(closure315, var__prelude);
  addtoclosure(closure315, var_IteratorExhausted);
  addtoclosure(closure315, var_indexable);
  struct UserObject *uo315 = (struct UserObject*)obj228;
  uo315->data[4] = (Object)closure315;
  Method *meth_meth_collectionsPrelude_fromprimitiveArray315 = addmethod2pos(obj228, "fromprimitiveArray", &meth_collectionsPrelude_fromprimitiveArray315, 4);
  int argcv_meth_collectionsPrelude_fromprimitiveArray315[] = {2};
  meth_meth_collectionsPrelude_fromprimitiveArray315->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_fromprimitiveArray315);
  meth_meth_collectionsPrelude_fromprimitiveArray315->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_fromprimitiveArray315->definitionModule = modulename;
  meth_meth_collectionsPrelude_fromprimitiveArray315->definitionLine = 496;
  block_savedest(obj228);
  Object closure656 = createclosure(4, "fromprimitiveArray()object");
  setclosureframe(closure656, stackframe);
  addtoclosure(closure656, var_BoundsError);
  addtoclosure(closure656, var__prelude);
  addtoclosure(closure656, var_IteratorExhausted);
  addtoclosure(closure656, var_indexable);
  Method *meth_meth_collectionsPrelude_fromprimitiveArray315_object = addmethod2pos(obj228, "fromprimitiveArray()object", &meth_collectionsPrelude_fromprimitiveArray315_object, 4);
  meth_meth_collectionsPrelude_fromprimitiveArray315_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_fromprimitiveArray315_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_fromprimitiveArray315_object->definitionLine = 496;
  sourceObject = obj228;
  sourceObject = obj228;
  sourceObject = obj228;
  sourceObject = obj228;
  objclass228 = obj228->class;
  objclass228->definitionModule = modulename;
  objclass228->definitionLine = 453;
  (*(struct UserObject *)self).data[0] = lowerouter228;
  self = oldself228;
  selfslot = oldselfslot228;
  stackframe = oldstackframe228;
  gc_frame_end(frame);
  return obj228;
}
Object meth_collectionsPrelude__apply668(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_rightIter = getfromclosure(closure, 0);
  Object *var_leftIter = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe670 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_rightIter (depth = 8)
  partcv[0] = 0;
  Object call671 = callmethod(*var_rightIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe670);
// compiled call node returning call671 (depth = 7)
// compiled member node returning call671 (depth = 6)
  int op_slot_right_669 = gc_frame_newslot(call671);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe673 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_leftIter (depth = 8)
  partcv[0] = 0;
  Object call674 = callmethod(*var_leftIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe673);
// compiled call node returning call674 (depth = 7)
// compiled member node returning call674 (depth = 6)
  int op_slot_left_669 = gc_frame_newslot(call674);
  params[0] = call671;
  partcv[0] = 1;
  Object opresult675 = callmethod(call674, "&&", 1, partcv, params);
// compiled op node returning opresult675 (depth = 5)
  gc_frame_end(frame);
  return opresult675;
}
Object meth_collectionsPrelude__apply678(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_rightIter = getfromclosure(closure, 0);
  Object *var_leftIter = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 599
  setline(599);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe681 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_rightIter (depth = 9)
  partcv[0] = 0;
  Object call682 = callmethod(*var_rightIter, "next",
    1, partcv, params);
  gc_frame_end(callframe681);
// compiled call node returning call682 (depth = 8)
// compiled member node returning call682 (depth = 7)
  int op_slot_right_680 = gc_frame_newslot(call682);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe684 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_leftIter (depth = 9)
  partcv[0] = 0;
  Object call685 = callmethod(*var_leftIter, "next",
    1, partcv, params);
  gc_frame_end(callframe684);
// compiled call node returning call685 (depth = 8)
// compiled member node returning call685 (depth = 7)
  int op_slot_left_680 = gc_frame_newslot(call685);
  params[0] = call682;
  partcv[0] = 1;
  Object opresult686 = callmethod(call685, "≠", 1, partcv, params);
// compiled op node returning opresult686 (depth = 6)
  Object if679 = done;
  if (istrue(opresult686)) {
// Begin line 600
  setline(600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool687 = alloc_Boolean(0);
// compiled identifier node returning bool687 (depth = 7)
  block_return(realself, bool687);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if679 = undefined;
  } else {
  }
// compiled if node returning if679 (depth = 5)
  gc_frame_end(frame);
  return if679;
}
Object meth_collectionsPrelude_isEqual_40__41_toIterable658(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "isEqual()toIterable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method isEqual()toIterable");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method isEqual()toIterable");
  Object params[2];
  int partcv[2];
  Object *var_MinimalyIterable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for isEqual()toIterable (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_left = &(stackframe->slots[0]);
  *var_left = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for isEqual");
  Object *var_right = &(stackframe->slots[1]);
  *var_right = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for toIterable");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_leftIter = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "leftIter");
  Object *var_rightIter = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "rightIter");
// Begin line 595
  setline(595);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe660 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_right (depth = 4)
  gc_frame_newslot(*var_right);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_MinimalyIterable (depth = 4)
  params[0] = *var_right;
  partcv[0] = 1;
  Object call661 = callmethod(*var_MinimalyIterable, "match",
    1, partcv, params);
  gc_frame_end(callframe660);
// compiled call node returning call661 (depth = 3)
  Object if659 = done;
  if (istrue(call661)) {
// Begin line 596
  setline(596);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe662 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_left (depth = 6)
  partcv[0] = 0;
  Object call663 = callmethod(*var_left, "iterator",
    1, partcv, params);
  gc_frame_end(callframe662);
// compiled call node returning call663 (depth = 5)
// compiled member node returning call663 (depth = 4)
  *var_leftIter = call663;
  if (call663 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 597
  setline(597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe664 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_right (depth = 6)
  partcv[0] = 0;
  Object call665 = callmethod(*var_right, "iterator",
    1, partcv, params);
  gc_frame_end(callframe664);
// compiled call node returning call665 (depth = 5)
// compiled member node returning call665 (depth = 4)
  *var_rightIter = call665;
  if (call665 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 598
  setline(598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe666 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block667 = alloc_Block(NULL, NULL, "collectionsPrelude", 598);
  gc_frame_newslot(block667);
// method "_apply"
  block_savedest(block667);
  Object closure668 = createclosure(3, "_apply");
  setclosureframe(closure668, stackframe);
  addtoclosure(closure668, var_rightIter);
  addtoclosure(closure668, var_leftIter);
  addtoclosure(closure668, selfslot);
  struct UserObject *uo668 = (struct UserObject*)block667;
  uo668->data[0] = (Object)closure668;
  Method *meth_meth_collectionsPrelude__apply668 = addmethod2pos(block667, "_apply", &meth_collectionsPrelude__apply668, 0);
  int argcv_meth_collectionsPrelude__apply668[] = {0};
  meth_meth_collectionsPrelude__apply668->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply668);
  meth_meth_collectionsPrelude__apply668->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply668->definitionLine = 597;
// compiled block node returning block667 (depth = 4)
  gc_frame_newslot(block667);
// starting to compile block node (depth = 4)
  Object block677 = alloc_Block(NULL, NULL, "collectionsPrelude", 598);
  gc_frame_newslot(block677);
// method "_apply"
  block_savedest(block677);
  Object closure678 = createclosure(3, "_apply");
  setclosureframe(closure678, stackframe);
  addtoclosure(closure678, var_rightIter);
  addtoclosure(closure678, var_leftIter);
  addtoclosure(closure678, selfslot);
  struct UserObject *uo678 = (struct UserObject*)block677;
  uo678->data[0] = (Object)closure678;
  Method *meth_meth_collectionsPrelude__apply678 = addmethod2pos(block677, "_apply", &meth_collectionsPrelude__apply678, 0);
  int argcv_meth_collectionsPrelude__apply678[] = {0};
  meth_meth_collectionsPrelude__apply678->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply678);
  meth_meth_collectionsPrelude__apply678->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply678->definitionLine = 598;
// compiled block node returning block677 (depth = 4)
  gc_frame_newslot(block677);
// call case 5: prelude request
  params[0] = block667;
  params[1] = block677;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call689 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe666);
// compiled call node returning call689 (depth = 3)
// Begin line 603
  setline(603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe691 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_rightIter (depth = 6)
  partcv[0] = 0;
  Object call692 = callmethod(*var_rightIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe691);
// compiled call node returning call692 (depth = 5)
// compiled member node returning call692 (depth = 4)
  int op_slot_right_690 = gc_frame_newslot(call692);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe694 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_leftIter (depth = 6)
  partcv[0] = 0;
  Object call695 = callmethod(*var_leftIter, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe694);
// compiled call node returning call695 (depth = 5)
// compiled member node returning call695 (depth = 4)
  int op_slot_left_690 = gc_frame_newslot(call695);
  params[0] = call692;
  partcv[0] = 1;
  Object opresult696 = callmethod(call695, "==", 1, partcv, params);
// compiled op node returning opresult696 (depth = 3)
    gc_frame_newslot(opresult696);
    if659 = opresult696;
  } else {
// Begin line 605
  setline(605);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool697 = alloc_Boolean(0);
// compiled identifier node returning bool697 (depth = 3)
    gc_frame_newslot(bool697);
    if659 = bool697;
  }
// compiled if node returning if659 (depth = 2)
  gc_frame_end(frame);
  return if659;
}
Object meth_collectionsPrelude_asString701(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 611
  setline(611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit702 == NULL) {
    strlit702 = alloc_String("a list factory");
    gc_root(strlit702);
  }
// compiled string node returning strlit702 (depth = 2)
  gc_frame_end(frame);
  return strlit702;
}
Object meth_collectionsPrelude_empty703(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "empty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for empty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for empty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 614
  setline(614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe704 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySequence (depth = 3)
  gc_frame_newslot(*var_emptySequence);
// call case 4: self request
  params[0] = *var_emptySequence;
  partcv[0] = 1;
  Object call705 = callmethodflags(self, "withAll", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe704);
// compiled call node returning call705 (depth = 2)
  gc_frame_end(frame);
  return call705;
}
Object meth_collectionsPrelude_size720(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for size (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for size");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 631
  setline(631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
// Begin line 632
  setline(632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe721 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call722 = callmethodflags(self, "sz", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe721);
// compiled call node returning call722 (depth = 7)
// compiled member node returning call722 (depth = 6)
  gc_frame_end(frame);
  return call722;
}
Object meth_collectionsPrelude_at723(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for at");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 636
  setline(636);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_at_40__41_put724(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at()put");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at()put");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at()put");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for at()put (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for at");
  Object *var_x = &(stackframe->slots[1]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for put");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 646
  setline(646);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe725 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num727 = alloc_Float64(1);
// compiled num node returning num727 (depth = 8)
  int op_slot_right_726 = gc_frame_newslot(num727);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe729 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call730 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe729);
// compiled call node returning call730 (depth = 9)
// compiled member node returning call730 (depth = 8)
  int op_slot_left_726 = gc_frame_newslot(call730);
  params[0] = num727;
  partcv[0] = 1;
  Object sum731 = callmethod(call730, "+", 1, partcv, params);
// compiled op node returning sum731 (depth = 7)
  gc_frame_newslot(sum731);
// call case 4: self request
  params[0] = sum731;
  partcv[0] = 1;
  Object call732 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe725);
// compiled call node returning call732 (depth = 6)
// Begin line 647
  setline(647);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_add733(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "add");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method add");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for add (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for add");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 658
  setline(658);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe734 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num736 = alloc_Float64(1);
// compiled num node returning num736 (depth = 8)
  int op_slot_right_735 = gc_frame_newslot(num736);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe738 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call739 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe738);
// compiled call node returning call739 (depth = 9)
// compiled member node returning call739 (depth = 8)
  int op_slot_left_735 = gc_frame_newslot(call739);
  params[0] = num736;
  partcv[0] = 1;
  Object sum740 = callmethod(call739, "+", 1, partcv, params);
// compiled op node returning sum740 (depth = 7)
  gc_frame_newslot(sum740);
// call case 4: self request
  params[0] = sum740;
  partcv[0] = 1;
  Object call741 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe734);
// compiled call node returning call741 (depth = 6)
// Begin line 659
  setline(659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_push742(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "push");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method push");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for push (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for push");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 664
  setline(664);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe743 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num745 = alloc_Float64(1);
// compiled num node returning num745 (depth = 8)
  int op_slot_right_744 = gc_frame_newslot(num745);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe747 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call748 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe747);
// compiled call node returning call748 (depth = 9)
// compiled member node returning call748 (depth = 8)
  int op_slot_left_744 = gc_frame_newslot(call748);
  params[0] = num745;
  partcv[0] = 1;
  Object sum749 = callmethod(call748, "+", 1, partcv, params);
// compiled op node returning sum749 (depth = 7)
  gc_frame_newslot(sum749);
// call case 4: self request
  params[0] = sum749;
  partcv[0] = 1;
  Object call750 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe743);
// compiled call node returning call750 (depth = 6)
// Begin line 665
  setline(665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_removeLast751(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeLast");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeLast (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for removeLast");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 670
  setline(670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe752 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num754 = alloc_Float64(1);
// compiled num node returning num754 (depth = 8)
  int op_slot_right_753 = gc_frame_newslot(num754);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe756 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call757 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe756);
// compiled call node returning call757 (depth = 9)
// compiled member node returning call757 (depth = 8)
  int op_slot_left_753 = gc_frame_newslot(call757);
  params[0] = num754;
  partcv[0] = 1;
  Object sum758 = callmethod(call757, "+", 1, partcv, params);
// compiled op node returning sum758 (depth = 7)
  gc_frame_newslot(sum758);
// call case 4: self request
  params[0] = sum758;
  partcv[0] = 1;
  Object call759 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe752);
// compiled call node returning call759 (depth = 6)
// Begin line 671
  setline(671);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply773(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num775 = alloc_Float64(0);
// compiled num node returning num775 (depth = 9)
  int op_slot_right_774 = gc_frame_newslot(num775);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_ix (depth = 9)
  int op_slot_left_774 = gc_frame_newslot(*var_ix);
  params[0] = num775;
  partcv[0] = 1;
  Object opresult777 = callmethod(*var_ix, ">", 1, partcv, params);
// compiled op node returning opresult777 (depth = 8)
  gc_frame_end(frame);
  return opresult777;
}
Object meth_collectionsPrelude__apply780(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_l = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_each = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "each");
// Begin line 683
  setline(683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe781 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  gc_frame_newslot(*var_ix);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_l (depth = 10)
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call782 = callmethod(*var_l, "at",
    1, partcv, params);
  gc_frame_end(callframe781);
// compiled call node returning call782 (depth = 9)
  *var_each = call782;
  if (call782 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 684
  setline(684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num784 = alloc_Float64(1);
// compiled num node returning num784 (depth = 10)
  int op_slot_right_783 = gc_frame_newslot(num784);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  int op_slot_left_783 = gc_frame_newslot(*var_ix);
  params[0] = num784;
  partcv[0] = 1;
  Object diff786 = callmethod(*var_ix, "-", 1, partcv, params);
// compiled op node returning diff786 (depth = 9)
  *var_ix = diff786;
  if (diff786 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 685
  setline(685);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
// compiled call node returning done (depth = 8)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_addAllFirst760(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAllFirst");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAllFirst");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addAllFirst (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for addAllFirst");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
// Begin line 680
  setline(680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe761 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num763 = alloc_Float64(1);
// compiled num node returning num763 (depth = 8)
  int op_slot_right_762 = gc_frame_newslot(num763);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe765 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call766 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe765);
// compiled call node returning call766 (depth = 9)
// compiled member node returning call766 (depth = 8)
  int op_slot_left_762 = gc_frame_newslot(call766);
  params[0] = num763;
  partcv[0] = 1;
  Object sum767 = callmethod(call766, "+", 1, partcv, params);
// compiled op node returning sum767 (depth = 7)
  gc_frame_newslot(sum767);
// call case 4: self request
  params[0] = sum767;
  partcv[0] = 1;
  Object call768 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe761);
// compiled call node returning call768 (depth = 6)
// Begin line 681
  setline(681);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe769 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_l (depth = 9)
  partcv[0] = 0;
  Object call770 = callmethod(*var_l, "size",
    1, partcv, params);
  gc_frame_end(callframe769);
// compiled call node returning call770 (depth = 8)
// compiled member node returning call770 (depth = 7)
  *var_ix = call770;
  if (call770 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 682
  setline(682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe771 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block772 = alloc_Block(NULL, NULL, "collectionsPrelude", 682);
  gc_frame_newslot(block772);
// method "_apply"
  block_savedest(block772);
  Object closure773 = createclosure(2, "_apply");
  setclosureframe(closure773, stackframe);
  addtoclosure(closure773, var_ix);
  addtoclosure(closure773, selfslot);
  struct UserObject *uo773 = (struct UserObject*)block772;
  uo773->data[0] = (Object)closure773;
  Method *meth_meth_collectionsPrelude__apply773 = addmethod2pos(block772, "_apply", &meth_collectionsPrelude__apply773, 0);
  int argcv_meth_collectionsPrelude__apply773[] = {0};
  meth_meth_collectionsPrelude__apply773->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply773);
  meth_meth_collectionsPrelude__apply773->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply773->definitionLine = 681;
// compiled block node returning block772 (depth = 7)
  gc_frame_newslot(block772);
// starting to compile block node (depth = 7)
  Object block779 = alloc_Block(NULL, NULL, "collectionsPrelude", 682);
  gc_frame_newslot(block779);
// method "_apply"
  block_savedest(block779);
  Object closure780 = createclosure(3, "_apply");
  setclosureframe(closure780, stackframe);
  addtoclosure(closure780, var_ix);
  addtoclosure(closure780, var_l);
  addtoclosure(closure780, selfslot);
  struct UserObject *uo780 = (struct UserObject*)block779;
  uo780->data[0] = (Object)closure780;
  Method *meth_meth_collectionsPrelude__apply780 = addmethod2pos(block779, "_apply", &meth_collectionsPrelude__apply780, 0);
  int argcv_meth_collectionsPrelude__apply780[] = {0};
  meth_meth_collectionsPrelude__apply780->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply780);
  meth_meth_collectionsPrelude__apply780->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply780->definitionLine = 681;
// compiled block node returning block779 (depth = 7)
  gc_frame_newslot(block779);
// call case 5: prelude request
  params[0] = block772;
  params[1] = block779;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call789 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe771);
// compiled call node returning call789 (depth = 6)
// Begin line 687
  setline(687);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_removeAt790(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeAt");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAt");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeAt (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for removeAt");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_removed = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "removed");
// Begin line 691
  setline(691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe791 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num793 = alloc_Float64(1);
// compiled num node returning num793 (depth = 8)
  int op_slot_right_792 = gc_frame_newslot(num793);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe795 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call796 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe795);
// compiled call node returning call796 (depth = 9)
// compiled member node returning call796 (depth = 8)
  int op_slot_left_792 = gc_frame_newslot(call796);
  params[0] = num793;
  partcv[0] = 1;
  Object sum797 = callmethod(call796, "+", 1, partcv, params);
// compiled op node returning sum797 (depth = 7)
  gc_frame_newslot(sum797);
// call case 4: self request
  params[0] = sum797;
  partcv[0] = 1;
  Object call798 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe791);
// compiled call node returning call798 (depth = 6)
// Begin line 692
  setline(692);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe799 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call800 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe799);
// compiled call node returning call800 (depth = 7)
  *var_removed = call800;
  if (call800 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 693
  setline(693);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
// Begin line 694
  setline(694);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  return *var_removed;
// compiled return node returning undefined (depth = 6)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_sortBy801(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortBy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortBy");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortBy (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for sortBy");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 698
  setline(698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe802 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num804 = alloc_Float64(1);
// compiled num node returning num804 (depth = 8)
  int op_slot_right_803 = gc_frame_newslot(num804);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe806 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call807 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe806);
// compiled call node returning call807 (depth = 9)
// compiled member node returning call807 (depth = 8)
  int op_slot_left_803 = gc_frame_newslot(call807);
  params[0] = num804;
  partcv[0] = 1;
  Object sum808 = callmethod(call807, "+", 1, partcv, params);
// compiled op node returning sum808 (depth = 7)
  gc_frame_newslot(sum808);
// call case 4: self request
  params[0] = sum808;
  partcv[0] = 1;
  Object call809 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe802);
// compiled call node returning call809 (depth = 6)
// Begin line 699
  setline(699);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
// Begin line 706
  setline(706);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_addLast810(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addLast");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addLast");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addLast (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for addLast");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 711
  setline(711);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe811 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_x (depth = 7)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call812 = callmethodflags(self, "push", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe811);
// compiled call node returning call812 (depth = 6)
  gc_frame_end(frame);
  return call812;
}
Object meth_collectionsPrelude__apply816(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe817 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  gc_frame_newslot(*var_each);
// call case 4: self request
  params[0] = *var_each;
  partcv[0] = 1;
  Object call818 = callmethodflags(self, "push", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe817);
// compiled call node returning call818 (depth = 8)
  gc_frame_end(frame);
  return call818;
}
Object meth_collectionsPrelude_addAll813(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAll");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAll");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addAll (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for addAll");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 713
  setline(713);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe814 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_l (depth = 7)
  gc_frame_newslot(*var_l);
// starting to compile block node (depth = 7)
  Object block815 = alloc_Block(NULL, NULL, "collectionsPrelude", 713);
  gc_frame_newslot(block815);
// method "_apply"
  block_savedest(block815);
  Object closure816 = createclosure(1, "_apply");
  setclosureframe(closure816, stackframe);
  addtoclosure(closure816, selfslot);
  struct UserObject *uo816 = (struct UserObject*)block815;
  uo816->data[0] = (Object)closure816;
  Method *meth_meth_collectionsPrelude__apply816 = addmethod2pos(block815, "_apply", &meth_collectionsPrelude__apply816, 0);
  int argcv_meth_collectionsPrelude__apply816[] = {1};
  meth_meth_collectionsPrelude__apply816->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply816);
  meth_meth_collectionsPrelude__apply816->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply816->definitionLine = 698;
// compiled block node returning block815 (depth = 7)
  gc_frame_newslot(block815);
// call case 5: prelude request
  params[0] = *var_l;
  params[1] = block815;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call820 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe814);
// compiled call node returning call820 (depth = 6)
// Begin line 714
  setline(714);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_addFirst821(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addFirst");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addFirst");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addFirst (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elem = &(stackframe->slots[0]);
  *var_elem = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for addFirst");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 718
  setline(718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe822 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num824 = alloc_Float64(1);
// compiled num node returning num824 (depth = 8)
  int op_slot_right_823 = gc_frame_newslot(num824);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe826 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call827 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe826);
// compiled call node returning call827 (depth = 9)
// compiled member node returning call827 (depth = 8)
  int op_slot_left_823 = gc_frame_newslot(call827);
  params[0] = num824;
  partcv[0] = 1;
  Object sum828 = callmethod(call827, "+", 1, partcv, params);
// compiled op node returning sum828 (depth = 7)
  gc_frame_newslot(sum828);
// call case 4: self request
  params[0] = sum828;
  partcv[0] = 1;
  Object call829 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe822);
// compiled call node returning call829 (depth = 6)
// Begin line 719
  setline(719);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
// Begin line 720
  setline(720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_removeFirst830(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeFirst");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeFirst (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for removeFirst");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 724
  setline(724);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe831 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num832 = alloc_Float64(1);
// compiled num node returning num832 (depth = 7)
  gc_frame_newslot(num832);
// call case 4: self request
  params[0] = num832;
  partcv[0] = 1;
  Object call833 = callmethodflags(self, "removeAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe831);
// compiled call node returning call833 (depth = 6)
  gc_frame_end(frame);
  return call833;
}
Object meth_collectionsPrelude__apply837(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_elt = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 730
  setline(730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe838 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit840 == NULL) {
    strlit840 = alloc_String("");
    gc_root(strlit840);
  }
// compiled string node returning strlit840 (depth = 11)
  int op_slot_right_839 = gc_frame_newslot(strlit840);
// starting to compile op node (depth = 11)
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_elt (depth = 12)
  int op_slot_right_842 = gc_frame_newslot(*var_elt);
// starting to compile string node (depth = 12)
  if (strlit844 == NULL) {
    strlit844 = alloc_String("list does not contain object ");
    gc_root(strlit844);
  }
// compiled string node returning strlit844 (depth = 12)
  int op_slot_left_842 = gc_frame_newslot(strlit844);
  params[0] = *var_elt;
  partcv[0] = 1;
  Object opresult845 = callmethod(strlit844, "++", 1, partcv, params);
// compiled op node returning opresult845 (depth = 11)
  int op_slot_left_839 = gc_frame_newslot(opresult845);
  params[0] = strlit840;
  partcv[0] = 1;
  Object opresult846 = callmethod(opresult845, "++", 1, partcv, params);
// compiled op node returning opresult846 (depth = 10)
  gc_frame_newslot(opresult846);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_NoSuchObject (depth = 10)
  params[0] = opresult846;
  partcv[0] = 1;
  Object call847 = callmethod(*var_NoSuchObject, "raise",
    1, partcv, params);
  gc_frame_end(callframe838);
// compiled call node returning call847 (depth = 9)
  gc_frame_end(frame);
  return call847;
}
Object meth_collectionsPrelude_remove834(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "remove");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for remove (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for remove");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
// Begin line 729
  setline(729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe835 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_elt (depth = 8)
  gc_frame_newslot(*var_elt);
// starting to compile block node (depth = 8)
  Object block836 = alloc_Block(NULL, NULL, "collectionsPrelude", 729);
  gc_frame_newslot(block836);
// method "_apply"
  block_savedest(block836);
  Object closure837 = createclosure(3, "_apply");
  setclosureframe(closure837, stackframe);
  addtoclosure(closure837, var_elt);
  addtoclosure(closure837, var_NoSuchObject);
  addtoclosure(closure837, selfslot);
  struct UserObject *uo837 = (struct UserObject*)block836;
  uo837->data[0] = (Object)closure837;
  Method *meth_meth_collectionsPrelude__apply837 = addmethod2pos(block836, "_apply", &meth_collectionsPrelude__apply837, 0);
  int argcv_meth_collectionsPrelude__apply837[] = {0};
  meth_meth_collectionsPrelude__apply837->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply837);
  meth_meth_collectionsPrelude__apply837->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply837->definitionLine = 718;
// compiled block node returning block836 (depth = 8)
  gc_frame_newslot(block836);
// call case 4: self request
  params[0] = *var_elt;
  params[1] = block836;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call849 = callmethodflags(self, "indexOf()ifAbsent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe835);
// compiled call node returning call849 (depth = 7)
  *var_ix = call849;
  if (call849 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 732
  setline(732);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe850 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call851 = callmethodflags(self, "removeAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe850);
// compiled call node returning call851 (depth = 6)
// Begin line 733
  setline(733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply855(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 739
  setline(739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe856 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_action (depth = 12)
  partcv[0] = 0;
  Object call857 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe856);
// compiled call node returning call857 (depth = 11)
// compiled member node returning call857 (depth = 10)
  block_return(realself, call857);
// compiled return node returning undefined (depth = 9)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_remove_40__41_ifAbsent852(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "remove()ifAbsent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove()ifAbsent");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove()ifAbsent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for remove()ifAbsent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for remove");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ifAbsent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "ix");
// Begin line 738
  setline(738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe853 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_elt (depth = 8)
  gc_frame_newslot(*var_elt);
// starting to compile block node (depth = 8)
  Object block854 = alloc_Block(NULL, NULL, "collectionsPrelude", 738);
  gc_frame_newslot(block854);
// method "_apply"
  block_savedest(block854);
  Object closure855 = createclosure(2, "_apply");
  setclosureframe(closure855, stackframe);
  addtoclosure(closure855, var_action);
  addtoclosure(closure855, selfslot);
  struct UserObject *uo855 = (struct UserObject*)block854;
  uo855->data[0] = (Object)closure855;
  Method *meth_meth_collectionsPrelude__apply855 = addmethod2pos(block854, "_apply", &meth_collectionsPrelude__apply855, 0);
  int argcv_meth_collectionsPrelude__apply855[] = {0};
  meth_meth_collectionsPrelude__apply855->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply855);
  meth_meth_collectionsPrelude__apply855->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply855->definitionLine = 718;
// compiled block node returning block854 (depth = 8)
  gc_frame_newslot(block854);
// call case 4: self request
  params[0] = *var_elt;
  params[1] = block854;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call859 = callmethodflags(self, "indexOf()ifAbsent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe853);
// compiled call node returning call859 (depth = 7)
  *var_ix = call859;
  if (call859 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 741
  setline(741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe860 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call861 = callmethodflags(self, "removeAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe860);
// compiled call node returning call861 (depth = 6)
// Begin line 742
  setline(742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply865(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe866 = gc_frame_new();
// starting to compile string node (depth = 9)
  if (strlit867 == NULL) {
    strlit867 = alloc_String("list does not contain object");
    gc_root(strlit867);
  }
// compiled string node returning strlit867 (depth = 9)
  gc_frame_newslot(strlit867);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_NoSuchObject (depth = 9)
  params[0] = strlit867;
  partcv[0] = 1;
  Object call868 = callmethod(*var_NoSuchObject, "raise",
    1, partcv, params);
  gc_frame_end(callframe866);
// compiled call node returning call868 (depth = 8)
  gc_frame_end(frame);
  return call868;
}
Object meth_collectionsPrelude_removeAll862(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAll");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeAll (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_vs = &(stackframe->slots[0]);
  *var_vs = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for removeAll");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 746
  setline(746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe863 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_vs (depth = 7)
  gc_frame_newslot(*var_vs);
// starting to compile block node (depth = 7)
  Object block864 = alloc_Block(NULL, NULL, "collectionsPrelude", 746);
  gc_frame_newslot(block864);
// method "_apply"
  block_savedest(block864);
  Object closure865 = createclosure(2, "_apply");
  setclosureframe(closure865, stackframe);
  addtoclosure(closure865, var_NoSuchObject);
  addtoclosure(closure865, selfslot);
  struct UserObject *uo865 = (struct UserObject*)block864;
  uo865->data[0] = (Object)closure865;
  Method *meth_meth_collectionsPrelude__apply865 = addmethod2pos(block864, "_apply", &meth_collectionsPrelude__apply865, 0);
  int argcv_meth_collectionsPrelude__apply865[] = {0};
  meth_meth_collectionsPrelude__apply865->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply865);
  meth_meth_collectionsPrelude__apply865->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply865->definitionLine = 739;
// compiled block node returning block864 (depth = 7)
  gc_frame_newslot(block864);
// call case 4: self request
  params[0] = *var_vs;
  params[1] = block864;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call870 = callmethodflags(self, "removeAll()ifAbsent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe863);
// compiled call node returning call870 (depth = 6)
  gc_frame_end(frame);
  return call870;
}
Object meth_collectionsPrelude__apply877(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile num node (depth = 11)
  Object num878 = alloc_Float64(0);
// compiled num node returning num878 (depth = 11)
  gc_frame_end(frame);
  return num878;
}
Object meth_collectionsPrelude__apply874(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
// Begin line 752
  setline(752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe875 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_each (depth = 10)
  gc_frame_newslot(*var_each);
// starting to compile block node (depth = 10)
  Object block876 = alloc_Block(NULL, NULL, "collectionsPrelude", 752);
  gc_frame_newslot(block876);
// method "_apply"
  block_savedest(block876);
  Object closure877 = createclosure(1, "_apply");
  setclosureframe(closure877, stackframe);
  addtoclosure(closure877, selfslot);
  struct UserObject *uo877 = (struct UserObject*)block876;
  uo877->data[0] = (Object)closure877;
  Method *meth_meth_collectionsPrelude__apply877 = addmethod2pos(block876, "_apply", &meth_collectionsPrelude__apply877, 0);
  int argcv_meth_collectionsPrelude__apply877[] = {0};
  meth_meth_collectionsPrelude__apply877->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply877);
  meth_meth_collectionsPrelude__apply877->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply877->definitionLine = 739;
// compiled block node returning block876 (depth = 10)
  gc_frame_newslot(block876);
// call case 4: self request
  params[0] = *var_each;
  params[1] = block876;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call880 = callmethodflags(self, "indexOf()ifAbsent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe875);
// compiled call node returning call880 (depth = 9)
  *var_ix = call880;
  if (call880 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 753
  setline(753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num883 = alloc_Float64(0);
// compiled num node returning num883 (depth = 10)
  int op_slot_right_882 = gc_frame_newslot(num883);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  int op_slot_left_882 = gc_frame_newslot(*var_ix);
  params[0] = num883;
  partcv[0] = 1;
  Object opresult885 = callmethod(*var_ix, "≠", 1, partcv, params);
// compiled op node returning opresult885 (depth = 9)
  Object if881 = done;
  if (istrue(opresult885)) {
// Begin line 754
  setline(754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 9)
  int callframe886 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_ix (depth = 10)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call887 = callmethodflags(self, "removeAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe886);
// compiled call node returning call887 (depth = 9)
    gc_frame_newslot(call887);
    if881 = call887;
  } else {
// Begin line 756
  setline(756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe888 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_action (depth = 11)
  partcv[0] = 0;
  Object call889 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe888);
// compiled call node returning call889 (depth = 10)
// compiled member node returning call889 (depth = 9)
    gc_frame_newslot(call889);
    if881 = call889;
  }
// compiled if node returning if881 (depth = 8)
  gc_frame_end(frame);
  return if881;
}
Object meth_collectionsPrelude_removeAll_40__41_ifAbsent871(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeAll()ifAbsent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll()ifAbsent");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll()ifAbsent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for removeAll()ifAbsent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_vs = &(stackframe->slots[0]);
  *var_vs = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for removeAll");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ifAbsent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 751
  setline(751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe872 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_vs (depth = 7)
  gc_frame_newslot(*var_vs);
// starting to compile block node (depth = 7)
  Object block873 = alloc_Block(NULL, NULL, "collectionsPrelude", 751);
  gc_frame_newslot(block873);
// method "_apply"
  block_savedest(block873);
  Object closure874 = createclosure(2, "_apply");
  setclosureframe(closure874, stackframe);
  addtoclosure(closure874, var_action);
  addtoclosure(closure874, selfslot);
  struct UserObject *uo874 = (struct UserObject*)block873;
  uo874->data[0] = (Object)closure874;
  Method *meth_meth_collectionsPrelude__apply874 = addmethod2pos(block873, "_apply", &meth_collectionsPrelude__apply874, 0);
  int argcv_meth_collectionsPrelude__apply874[] = {1};
  meth_meth_collectionsPrelude__apply874->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply874);
  meth_meth_collectionsPrelude__apply874->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply874->definitionLine = 739;
// compiled block node returning block873 (depth = 7)
  gc_frame_newslot(block873);
// call case 5: prelude request
  params[0] = *var_vs;
  params[1] = block873;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call891 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe872);
// compiled call node returning call891 (depth = 6)
// Begin line 759
  setline(759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_pop892(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pop");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pop (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for pop");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 762
  setline(762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe893 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call894 = callmethodflags(self, "removeLast", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe893);
// compiled call node returning call894 (depth = 7)
// compiled member node returning call894 (depth = 6)
  gc_frame_end(frame);
  return call894;
}
Object meth_collectionsPrelude__apply906(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 8)
  int callframe907 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_result (depth = 9)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call908 = callmethod(*var_result, "addFirst",
    1, partcv, params);
  gc_frame_end(callframe907);
// compiled call node returning call908 (depth = 8)
  gc_frame_end(frame);
  return call908;
}
Object meth_collectionsPrelude_reversed895(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for reversed (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for reversed");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 765
  setline(765);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe896 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe897 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe898 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe899 = gc_frame_new();
// call case 3: self.outer request
  Object call900 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe899);
// compiled call node returning call900 (depth = 14)
// compiled member node returning call900 (depth = 13)
  partcv[0] = 0;
  Object call901 = callmethodflags(call900, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe898);
// compiled call node returning call901 (depth = 12)
// compiled member node returning call901 (depth = 11)
  partcv[0] = 0;
  Object call902 = callmethodflags(call901, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe897);
// compiled call node returning call902 (depth = 10)
// compiled member node returning call902 (depth = 9)
  partcv[0] = 0;
  Object call903 = callmethod(call902, "empty",
    1, partcv, params);
  gc_frame_end(callframe896);
// compiled call node returning call903 (depth = 8)
// compiled member node returning call903 (depth = 7)
  *var_result = call903;
  if (call903 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 766
  setline(766);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe904 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block905 = alloc_Block(NULL, NULL, "collectionsPrelude", 766);
  gc_frame_newslot(block905);
// method "_apply"
  block_savedest(block905);
  Object closure906 = createclosure(2, "_apply");
  setclosureframe(closure906, stackframe);
  addtoclosure(closure906, var_result);
  addtoclosure(closure906, selfslot);
  struct UserObject *uo906 = (struct UserObject*)block905;
  uo906->data[0] = (Object)closure906;
  Method *meth_meth_collectionsPrelude__apply906 = addmethod2pos(block905, "_apply", &meth_collectionsPrelude__apply906, 0);
  int argcv_meth_collectionsPrelude__apply906[] = {1};
  meth_meth_collectionsPrelude__apply906->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply906);
  meth_meth_collectionsPrelude__apply906->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply906->definitionLine = 765;
// compiled block node returning block905 (depth = 7)
  gc_frame_newslot(block905);
// call case 4: self request
  params[0] = block905;
  partcv[0] = 1;
  Object call910 = callmethodflags(self, "do", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe904);
// compiled call node returning call910 (depth = 6)
// Begin line 767
  setline(767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_result (depth = 6)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude__apply925(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_hiIx = getfromclosure(closure, 0);
  Object *var_loIx = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_hiIx (depth = 9)
  int op_slot_right_926 = gc_frame_newslot(*var_hiIx);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_loIx (depth = 9)
  int op_slot_left_926 = gc_frame_newslot(*var_loIx);
  params[0] = *var_hiIx;
  partcv[0] = 1;
  Object opresult928 = callmethod(*var_loIx, "<", 1, partcv, params);
// compiled op node returning opresult928 (depth = 8)
  gc_frame_end(frame);
  return opresult928;
}
Object meth_collectionsPrelude__apply931(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_hiIx = getfromclosure(closure, 0);
  Object *var_loIx = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_hiVal = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "hiVal");
// Begin line 774
  setline(774);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe932 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_hiIx (depth = 10)
  gc_frame_newslot(*var_hiIx);
// call case 4: self request
  params[0] = *var_hiIx;
  partcv[0] = 1;
  Object call933 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe932);
// compiled call node returning call933 (depth = 9)
  *var_hiVal = call933;
  if (call933 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 775
  setline(775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe934 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_hiIx (depth = 9)
  gc_frame_newslot(*var_hiIx);
// starting to compile call node (depth = 9)
  int callframe935 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_loIx (depth = 10)
  gc_frame_newslot(*var_loIx);
// call case 4: self request
  params[0] = *var_loIx;
  partcv[0] = 1;
  Object call936 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe935);
// compiled call node returning call936 (depth = 9)
  gc_frame_newslot(call936);
// call case 4: self request
  params[0] = *var_hiIx;
  params[1] = call936;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call937 = callmethodflags(self, "at()put", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe934);
// compiled call node returning call937 (depth = 8)
// Begin line 776
  setline(776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe938 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_loIx (depth = 9)
  gc_frame_newslot(*var_loIx);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_hiVal (depth = 9)
  gc_frame_newslot(*var_hiVal);
// call case 4: self request
  params[0] = *var_loIx;
  params[1] = *var_hiVal;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call939 = callmethodflags(self, "at()put", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe938);
// compiled call node returning call939 (depth = 8)
// Begin line 777
  setline(777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num941 = alloc_Float64(1);
// compiled num node returning num941 (depth = 10)
  int op_slot_right_940 = gc_frame_newslot(num941);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_hiIx (depth = 10)
  int op_slot_left_940 = gc_frame_newslot(*var_hiIx);
  params[0] = num941;
  partcv[0] = 1;
  Object diff943 = callmethod(*var_hiIx, "-", 1, partcv, params);
// compiled op node returning diff943 (depth = 9)
  *var_hiIx = diff943;
  if (diff943 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 778
  setline(778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num946 = alloc_Float64(1);
// compiled num node returning num946 (depth = 10)
  int op_slot_right_945 = gc_frame_newslot(num946);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_loIx (depth = 10)
  int op_slot_left_945 = gc_frame_newslot(*var_loIx);
  params[0] = num946;
  partcv[0] = 1;
  Object sum948 = callmethod(*var_loIx, "+", 1, partcv, params);
// compiled op node returning sum948 (depth = 9)
  *var_loIx = sum948;
  if (sum948 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_reverse911(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reverse");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for reverse (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for reverse");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_hiIx = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "hiIx");
  Object *var_loIx = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "loIx");
// Begin line 770
  setline(770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe912 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num914 = alloc_Float64(1);
// compiled num node returning num914 (depth = 8)
  int op_slot_right_913 = gc_frame_newslot(num914);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe916 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call917 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe916);
// compiled call node returning call917 (depth = 9)
// compiled member node returning call917 (depth = 8)
  int op_slot_left_913 = gc_frame_newslot(call917);
  params[0] = num914;
  partcv[0] = 1;
  Object sum918 = callmethod(call917, "+", 1, partcv, params);
// compiled op node returning sum918 (depth = 7)
  gc_frame_newslot(sum918);
// call case 4: self request
  params[0] = sum918;
  partcv[0] = 1;
  Object call919 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe912);
// compiled call node returning call919 (depth = 6)
// Begin line 771
  setline(771);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe920 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call921 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe920);
// compiled call node returning call921 (depth = 8)
// compiled member node returning call921 (depth = 7)
  *var_hiIx = call921;
  if (call921 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 772
  setline(772);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile num node (depth = 7)
  Object num922 = alloc_Float64(1);
// compiled num node returning num922 (depth = 7)
  *var_loIx = num922;
  if (num922 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 773
  setline(773);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe923 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block924 = alloc_Block(NULL, NULL, "collectionsPrelude", 773);
  gc_frame_newslot(block924);
// method "_apply"
  block_savedest(block924);
  Object closure925 = createclosure(3, "_apply");
  setclosureframe(closure925, stackframe);
  addtoclosure(closure925, var_hiIx);
  addtoclosure(closure925, var_loIx);
  addtoclosure(closure925, selfslot);
  struct UserObject *uo925 = (struct UserObject*)block924;
  uo925->data[0] = (Object)closure925;
  Method *meth_meth_collectionsPrelude__apply925 = addmethod2pos(block924, "_apply", &meth_collectionsPrelude__apply925, 0);
  int argcv_meth_collectionsPrelude__apply925[] = {0};
  meth_meth_collectionsPrelude__apply925->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply925);
  meth_meth_collectionsPrelude__apply925->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply925->definitionLine = 771;
// compiled block node returning block924 (depth = 7)
  gc_frame_newslot(block924);
// starting to compile block node (depth = 7)
  Object block930 = alloc_Block(NULL, NULL, "collectionsPrelude", 773);
  gc_frame_newslot(block930);
// method "_apply"
  block_savedest(block930);
  Object closure931 = createclosure(3, "_apply");
  setclosureframe(closure931, stackframe);
  addtoclosure(closure931, var_hiIx);
  addtoclosure(closure931, var_loIx);
  addtoclosure(closure931, selfslot);
  struct UserObject *uo931 = (struct UserObject*)block930;
  uo931->data[0] = (Object)closure931;
  Method *meth_meth_collectionsPrelude__apply931 = addmethod2pos(block930, "_apply", &meth_collectionsPrelude__apply931, 0);
  int argcv_meth_collectionsPrelude__apply931[] = {0};
  meth_meth_collectionsPrelude__apply931->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply931);
  meth_meth_collectionsPrelude__apply931->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply931->definitionLine = 771;
// compiled block node returning block930 (depth = 7)
  gc_frame_newslot(block930);
// call case 5: prelude request
  params[0] = block924;
  params[1] = block930;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call951 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe923);
// compiled call node returning call951 (depth = 6)
// Begin line 780
  setline(780);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__43__43_952(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++ (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ++");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_l = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "l");
// Begin line 784
  setline(784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe953 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning self (depth = 8)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe954 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe955 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe956 = gc_frame_new();
// call case 3: self.outer request
  Object call957 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe956);
// compiled call node returning call957 (depth = 13)
// compiled member node returning call957 (depth = 12)
  partcv[0] = 0;
  Object call958 = callmethodflags(call957, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe955);
// compiled call node returning call958 (depth = 11)
// compiled member node returning call958 (depth = 10)
  partcv[0] = 0;
  Object call959 = callmethodflags(call958, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe954);
// compiled call node returning call959 (depth = 9)
// compiled member node returning call959 (depth = 8)
  params[0] = self;
  partcv[0] = 1;
  Object call960 = callmethod(call959, "withAll",
    1, partcv, params);
  gc_frame_end(callframe953);
// compiled call node returning call960 (depth = 7)
  *var_l = call960;
  if (call960 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 785
  setline(785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe961 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_l (depth = 7)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call962 = callmethod(*var_l, "addAll",
    1, partcv, params);
  gc_frame_end(callframe961);
// compiled call node returning call962 (depth = 6)
  gc_frame_end(frame);
  return call962;
}
Object meth_collectionsPrelude__apply973(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_curSize = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 793
  setline(793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe975 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 12)
  int callframe976 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_i (depth = 13)
  gc_frame_newslot(*var_i);
// call case 4: self request
  params[0] = *var_i;
  partcv[0] = 1;
  Object call977 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe976);
// compiled call node returning call977 (depth = 12)
  partcv[0] = 0;
  Object call978 = callmethod(call977, "asString",
    1, partcv, params);
  gc_frame_end(callframe975);
// compiled call node returning call978 (depth = 11)
// compiled member node returning call978 (depth = 10)
  int op_slot_right_974 = gc_frame_newslot(call978);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_974 = gc_frame_newslot(*var_s);
  params[0] = call978;
  partcv[0] = 1;
  Object opresult980 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult980 (depth = 9)
  *var_s = opresult980;
  if (opresult980 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 794
  setline(794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_curSize (depth = 10)
  int op_slot_right_983 = gc_frame_newslot(*var_curSize);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  int op_slot_left_983 = gc_frame_newslot(*var_i);
  params[0] = *var_curSize;
  partcv[0] = 1;
  Object opresult985 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult985 (depth = 9)
  Object if982 = done;
  if (istrue(opresult985)) {
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit987 == NULL) {
    strlit987 = alloc_String(", ");
    gc_root(strlit987);
  }
// compiled string node returning strlit987 (depth = 11)
  int op_slot_right_986 = gc_frame_newslot(strlit987);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_986 = gc_frame_newslot(*var_s);
  params[0] = strlit987;
  partcv[0] = 1;
  Object opresult989 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult989 (depth = 10)
  *var_s = opresult989;
  if (opresult989 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if982 = done;
  } else {
  }
// compiled if node returning if982 (depth = 8)
  gc_frame_end(frame);
  return if982;
}
Object meth_collectionsPrelude_asString963(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
  Object *var_curSize = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "curSize");
// Begin line 790
  setline(790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit964 == NULL) {
    strlit964 = alloc_String("[");
    gc_root(strlit964);
  }
// compiled string node returning strlit964 (depth = 7)
  *var_s = strlit964;
  if (strlit964 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 791
  setline(791);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe965 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call966 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe965);
// compiled call node returning call966 (depth = 8)
// compiled member node returning call966 (depth = 7)
  *var_curSize = call966;
  if (call966 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 792
  setline(792);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe967 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_curSize (depth = 8)
  int op_slot_right_968 = gc_frame_newslot(*var_curSize);
// starting to compile num node (depth = 8)
  Object num970 = alloc_Float64(1);
// compiled num node returning num970 (depth = 8)
  int op_slot_left_968 = gc_frame_newslot(num970);
  params[0] = *var_curSize;
  partcv[0] = 1;
  Object opresult971 = callmethod(num970, "..", 1, partcv, params);
// compiled op node returning opresult971 (depth = 7)
  gc_frame_newslot(opresult971);
// starting to compile block node (depth = 7)
  Object block972 = alloc_Block(NULL, NULL, "collectionsPrelude", 792);
  gc_frame_newslot(block972);
// method "_apply"
  block_savedest(block972);
  Object closure973 = createclosure(3, "_apply");
  setclosureframe(closure973, stackframe);
  addtoclosure(closure973, var_s);
  addtoclosure(closure973, var_curSize);
  addtoclosure(closure973, selfslot);
  struct UserObject *uo973 = (struct UserObject*)block972;
  uo973->data[0] = (Object)closure973;
  Method *meth_meth_collectionsPrelude__apply973 = addmethod2pos(block972, "_apply", &meth_collectionsPrelude__apply973, 0);
  int argcv_meth_collectionsPrelude__apply973[] = {1};
  meth_meth_collectionsPrelude__apply973->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply973);
  meth_meth_collectionsPrelude__apply973->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply973->definitionLine = 791;
// compiled block node returning block972 (depth = 7)
  gc_frame_newslot(block972);
// call case 5: prelude request
  params[0] = opresult971;
  params[1] = block972;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call992 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe967);
// compiled call node returning call992 (depth = 6)
// Begin line 796
  setline(796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit994 == NULL) {
    strlit994 = alloc_String("]");
    gc_root(strlit994);
  }
// compiled string node returning strlit994 (depth = 7)
  int op_slot_right_993 = gc_frame_newslot(strlit994);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_993 = gc_frame_newslot(*var_s);
  params[0] = strlit994;
  partcv[0] = 1;
  Object opresult996 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult996 (depth = 6)
  gc_frame_end(frame);
  return opresult996;
}
Object meth_collectionsPrelude__apply1007(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_curSize = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 803
  setline(803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1009 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 12)
  int callframe1010 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_i (depth = 13)
  gc_frame_newslot(*var_i);
// call case 4: self request
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1011 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1010);
// compiled call node returning call1011 (depth = 12)
  partcv[0] = 0;
  Object call1012 = callmethod(call1011, "asDebugString",
    1, partcv, params);
  gc_frame_end(callframe1009);
// compiled call node returning call1012 (depth = 11)
// compiled member node returning call1012 (depth = 10)
  int op_slot_right_1008 = gc_frame_newslot(call1012);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1008 = gc_frame_newslot(*var_s);
  params[0] = call1012;
  partcv[0] = 1;
  Object opresult1014 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1014 (depth = 9)
  *var_s = opresult1014;
  if (opresult1014 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 804
  setline(804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_curSize (depth = 10)
  int op_slot_right_1017 = gc_frame_newslot(*var_curSize);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  int op_slot_left_1017 = gc_frame_newslot(*var_i);
  params[0] = *var_curSize;
  partcv[0] = 1;
  Object opresult1019 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult1019 (depth = 9)
  Object if1016 = done;
  if (istrue(opresult1019)) {
// starting to compile bind node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile string node (depth = 11)
  if (strlit1021 == NULL) {
    strlit1021 = alloc_String(", ");
    gc_root(strlit1021);
  }
// compiled string node returning strlit1021 (depth = 11)
  int op_slot_right_1020 = gc_frame_newslot(strlit1021);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_s (depth = 11)
  int op_slot_left_1020 = gc_frame_newslot(*var_s);
  params[0] = strlit1021;
  partcv[0] = 1;
  Object opresult1023 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1023 (depth = 10)
  *var_s = opresult1023;
  if (opresult1023 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 9)
    gc_frame_newslot(done);
    if1016 = done;
  } else {
  }
// compiled if node returning if1016 (depth = 8)
  gc_frame_end(frame);
  return if1016;
}
Object meth_collectionsPrelude_asDebugString997(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
  Object *var_curSize = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "curSize");
// Begin line 800
  setline(800);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit998 == NULL) {
    strlit998 = alloc_String("[");
    gc_root(strlit998);
  }
// compiled string node returning strlit998 (depth = 7)
  *var_s = strlit998;
  if (strlit998 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 801
  setline(801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe999 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1000 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe999);
// compiled call node returning call1000 (depth = 8)
// compiled member node returning call1000 (depth = 7)
  *var_curSize = call1000;
  if (call1000 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 802
  setline(802);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1001 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_curSize (depth = 8)
  int op_slot_right_1002 = gc_frame_newslot(*var_curSize);
// starting to compile num node (depth = 8)
  Object num1004 = alloc_Float64(1);
// compiled num node returning num1004 (depth = 8)
  int op_slot_left_1002 = gc_frame_newslot(num1004);
  params[0] = *var_curSize;
  partcv[0] = 1;
  Object opresult1005 = callmethod(num1004, "..", 1, partcv, params);
// compiled op node returning opresult1005 (depth = 7)
  gc_frame_newslot(opresult1005);
// starting to compile block node (depth = 7)
  Object block1006 = alloc_Block(NULL, NULL, "collectionsPrelude", 802);
  gc_frame_newslot(block1006);
// method "_apply"
  block_savedest(block1006);
  Object closure1007 = createclosure(3, "_apply");
  setclosureframe(closure1007, stackframe);
  addtoclosure(closure1007, var_s);
  addtoclosure(closure1007, var_curSize);
  addtoclosure(closure1007, selfslot);
  struct UserObject *uo1007 = (struct UserObject*)block1006;
  uo1007->data[0] = (Object)closure1007;
  Method *meth_meth_collectionsPrelude__apply1007 = addmethod2pos(block1006, "_apply", &meth_collectionsPrelude__apply1007, 0);
  int argcv_meth_collectionsPrelude__apply1007[] = {1};
  meth_meth_collectionsPrelude__apply1007->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1007);
  meth_meth_collectionsPrelude__apply1007->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1007->definitionLine = 801;
// compiled block node returning block1006 (depth = 7)
  gc_frame_newslot(block1006);
// call case 5: prelude request
  params[0] = opresult1005;
  params[1] = block1006;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1026 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1001);
// compiled call node returning call1026 (depth = 6)
// Begin line 806
  setline(806);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1028 == NULL) {
    strlit1028 = alloc_String("]");
    gc_root(strlit1028);
  }
// compiled string node returning strlit1028 (depth = 7)
  int op_slot_right_1027 = gc_frame_newslot(strlit1028);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1027 = gc_frame_newslot(*var_s);
  params[0] = strlit1028;
  partcv[0] = 1;
  Object opresult1030 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1030 (depth = 6)
  gc_frame_end(frame);
  return opresult1030;
}
Object meth_collectionsPrelude_extend1031(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "extend");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method extend");
  Object params[1];
  int partcv[1];
  Object *var_done = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for extend (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for extend");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 809
  setline(809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1032 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_l (depth = 7)
  gc_frame_newslot(*var_l);
// call case 4: self request
  params[0] = *var_l;
  partcv[0] = 1;
  Object call1033 = callmethodflags(self, "addAll", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1032);
// compiled call node returning call1033 (depth = 6)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_done (depth = 6)
  gc_frame_end(frame);
  return *var_done;
}
Object meth_collectionsPrelude__apply1037(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_element = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_element (depth = 10)
  int op_slot_right_1039 = gc_frame_newslot(*var_element);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_each (depth = 10)
  int op_slot_left_1039 = gc_frame_newslot(*var_each);
  params[0] = *var_element;
  partcv[0] = 1;
  Object opresult1041 = callmethod(*var_each, "==", 1, partcv, params);
// compiled op node returning opresult1041 (depth = 9)
  Object if1038 = done;
  if (istrue(opresult1041)) {
// starting to compile return node (depth = 9)
// starting to compile identifier node (depth = 10)
  Object bool1042 = alloc_Boolean(1);
// compiled identifier node returning bool1042 (depth = 10)
  block_return(realself, bool1042);
// compiled return node returning undefined (depth = 9)
    gc_frame_newslot(undefined);
    if1038 = undefined;
  } else {
  }
// compiled if node returning if1038 (depth = 8)
  gc_frame_end(frame);
  return if1038;
}
Object meth_collectionsPrelude_contains1034(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_element = &(stackframe->slots[0]);
  *var_element = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for contains");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 813
  setline(813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1035 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1036 = alloc_Block(NULL, NULL, "collectionsPrelude", 813);
  gc_frame_newslot(block1036);
// method "_apply"
  block_savedest(block1036);
  Object closure1037 = createclosure(2, "_apply");
  setclosureframe(closure1037, stackframe);
  addtoclosure(closure1037, var_element);
  addtoclosure(closure1037, selfslot);
  struct UserObject *uo1037 = (struct UserObject*)block1036;
  uo1037->data[0] = (Object)closure1037;
  Method *meth_meth_collectionsPrelude__apply1037 = addmethod2pos(block1036, "_apply", &meth_collectionsPrelude__apply1037, 0);
  int argcv_meth_collectionsPrelude__apply1037[] = {1};
  meth_meth_collectionsPrelude__apply1037->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1037);
  meth_meth_collectionsPrelude__apply1037->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1037->definitionLine = 803;
// compiled block node returning block1036 (depth = 7)
  gc_frame_newslot(block1036);
// call case 4: self request
  params[0] = block1036;
  partcv[0] = 1;
  Object call1044 = callmethodflags(self, "do", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1035);
// compiled call node returning call1044 (depth = 6)
// Begin line 814
  setline(814);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool1045 = alloc_Boolean(0);
// compiled identifier node returning bool1045 (depth = 7)
  return bool1045;
// compiled return node returning undefined (depth = 6)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply1052(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_curSize = getfromclosure(closure, 0);
  Object *var_i = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_curSize (depth = 9)
  int op_slot_right_1053 = gc_frame_newslot(*var_curSize);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_left_1053 = gc_frame_newslot(*var_i);
  params[0] = *var_curSize;
  partcv[0] = 1;
  Object opresult1055 = callmethod(*var_i, "≤", 1, partcv, params);
// compiled op node returning opresult1055 (depth = 8)
  gc_frame_end(frame);
  return opresult1055;
}
Object meth_collectionsPrelude__apply1058(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 821
  setline(821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe1059 = gc_frame_new();
// starting to compile call node (depth = 9)
  int callframe1060 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  gc_frame_newslot(*var_i);
// call case 4: self request
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1061 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1060);
// compiled call node returning call1061 (depth = 9)
  gc_frame_newslot(call1061);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_block1 (depth = 9)
  params[0] = call1061;
  partcv[0] = 1;
  Object call1062 = callmethod(*var_block1, "apply",
    1, partcv, params);
  gc_frame_end(callframe1059);
// compiled call node returning call1062 (depth = 8)
// Begin line 822
  setline(822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1064 = alloc_Float64(1);
// compiled num node returning num1064 (depth = 10)
  int op_slot_right_1063 = gc_frame_newslot(num1064);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  int op_slot_left_1063 = gc_frame_newslot(*var_i);
  params[0] = num1064;
  partcv[0] = 1;
  Object sum1066 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum1066 (depth = 9)
  *var_i = sum1066;
  if (sum1066 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_do1046(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for do");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_i = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "i");
  Object *var_curSize = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "curSize");
// Begin line 818
  setline(818);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1047 = alloc_Float64(1);
// compiled num node returning num1047 (depth = 7)
  *var_i = num1047;
  if (num1047 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 819
  setline(819);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1048 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1049 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1048);
// compiled call node returning call1049 (depth = 8)
// compiled member node returning call1049 (depth = 7)
  *var_curSize = call1049;
  if (call1049 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 820
  setline(820);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1050 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1051 = alloc_Block(NULL, NULL, "collectionsPrelude", 820);
  gc_frame_newslot(block1051);
// method "_apply"
  block_savedest(block1051);
  Object closure1052 = createclosure(3, "_apply");
  setclosureframe(closure1052, stackframe);
  addtoclosure(closure1052, var_curSize);
  addtoclosure(closure1052, var_i);
  addtoclosure(closure1052, selfslot);
  struct UserObject *uo1052 = (struct UserObject*)block1051;
  uo1052->data[0] = (Object)closure1052;
  Method *meth_meth_collectionsPrelude__apply1052 = addmethod2pos(block1051, "_apply", &meth_collectionsPrelude__apply1052, 0);
  int argcv_meth_collectionsPrelude__apply1052[] = {0};
  meth_meth_collectionsPrelude__apply1052->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1052);
  meth_meth_collectionsPrelude__apply1052->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1052->definitionLine = 819;
// compiled block node returning block1051 (depth = 7)
  gc_frame_newslot(block1051);
// starting to compile block node (depth = 7)
  Object block1057 = alloc_Block(NULL, NULL, "collectionsPrelude", 820);
  gc_frame_newslot(block1057);
// method "_apply"
  block_savedest(block1057);
  Object closure1058 = createclosure(3, "_apply");
  setclosureframe(closure1058, stackframe);
  addtoclosure(closure1058, var_i);
  addtoclosure(closure1058, var_block1);
  addtoclosure(closure1058, selfslot);
  struct UserObject *uo1058 = (struct UserObject*)block1057;
  uo1058->data[0] = (Object)closure1058;
  Method *meth_meth_collectionsPrelude__apply1058 = addmethod2pos(block1057, "_apply", &meth_collectionsPrelude__apply1058, 0);
  int argcv_meth_collectionsPrelude__apply1058[] = {0};
  meth_meth_collectionsPrelude__apply1058->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1058);
  meth_meth_collectionsPrelude__apply1058->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1058->definitionLine = 819;
// compiled block node returning block1057 (depth = 7)
  gc_frame_newslot(block1057);
// call case 5: prelude request
  params[0] = block1051;
  params[1] = block1057;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1069 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1050);
// compiled call node returning call1069 (depth = 6)
  gc_frame_end(frame);
  return call1069;
}
Object meth_collectionsPrelude__61__61_1070(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 827
  setline(827);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1071 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  gc_frame_newslot(*var_other);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1072 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1073 = gc_frame_new();
// call case 3: self.outer request
  Object call1074 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1073);
// compiled call node returning call1074 (depth = 10)
// compiled member node returning call1074 (depth = 9)
  partcv[0] = 0;
  Object call1075 = callmethodflags(call1074, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1072);
// compiled call node returning call1075 (depth = 8)
// compiled member node returning call1075 (depth = 7)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1076 = callmethodflags(call1075, "isEqual()toIterable", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1071);
// compiled call node returning call1076 (depth = 6)
  gc_frame_end(frame);
  return call1076;
}
Object meth_collectionsPrelude_asDebugString1082(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 834
  setline(834);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1084 == NULL) {
    strlit1084 = alloc_String("""\xe2""""\x9f""""\xab""");
    gc_root(strlit1084);
  }
// compiled string node returning strlit1084 (depth = 7)
  int op_slot_right_1083 = gc_frame_newslot(strlit1084);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1087 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1088 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1087);
// compiled call node returning call1088 (depth = 9)
// compiled member node returning call1088 (depth = 8)
  int op_slot_right_1086 = gc_frame_newslot(call1088);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit1091 == NULL) {
    strlit1091 = alloc_String("""\xe2""""\x9f""""\xaa""");
    gc_root(strlit1091);
  }
// compiled string node returning strlit1091 (depth = 9)
  int op_slot_right_1090 = gc_frame_newslot(strlit1091);
// starting to compile op node (depth = 9)
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1094 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1095 = callmethodflags(self, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1094);
// compiled call node returning call1095 (depth = 11)
// compiled member node returning call1095 (depth = 10)
  int op_slot_right_1093 = gc_frame_newslot(call1095);
// starting to compile string node (depth = 10)
  if (strlit1097 == NULL) {
    strlit1097 = alloc_String("");
    gc_root(strlit1097);
  }
// compiled string node returning strlit1097 (depth = 10)
  int op_slot_left_1093 = gc_frame_newslot(strlit1097);
  params[0] = call1095;
  partcv[0] = 1;
  Object opresult1098 = callmethod(strlit1097, "++", 1, partcv, params);
// compiled op node returning opresult1098 (depth = 9)
  int op_slot_left_1090 = gc_frame_newslot(opresult1098);
  params[0] = strlit1091;
  partcv[0] = 1;
  Object opresult1099 = callmethod(opresult1098, "++", 1, partcv, params);
// compiled op node returning opresult1099 (depth = 8)
  int op_slot_left_1086 = gc_frame_newslot(opresult1099);
  params[0] = call1088;
  partcv[0] = 1;
  Object opresult1100 = callmethod(opresult1099, "++", 1, partcv, params);
// compiled op node returning opresult1100 (depth = 7)
  int op_slot_left_1083 = gc_frame_newslot(opresult1100);
  params[0] = strlit1084;
  partcv[0] = 1;
  Object opresult1101 = callmethod(opresult1100, "++", 1, partcv, params);
// compiled op node returning opresult1101 (depth = 6)
  gc_frame_end(frame);
  return opresult1101;
}
Object meth_collectionsPrelude_asString1102(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 835
  setline(835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 6)
  if (strlit1103 == NULL) {
    strlit1103 = alloc_String("aListIterator");
    gc_root(strlit1103);
  }
// compiled string node returning strlit1103 (depth = 6)
  gc_frame_end(frame);
  return strlit1103;
}
Object meth_collectionsPrelude_hasNext1104(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 836
  setline(836);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1106 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1107 = gc_frame_new();
// call case 3: self.outer request
  Object call1108 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1107);
// compiled call node returning call1108 (depth = 10)
// compiled member node returning call1108 (depth = 9)
  partcv[0] = 0;
  Object call1109 = callmethodflags(call1108, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1106);
// compiled call node returning call1109 (depth = 8)
// compiled member node returning call1109 (depth = 7)
  int op_slot_right_1105 = gc_frame_newslot(call1109);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1111 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1112 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1111);
// compiled call node returning call1112 (depth = 8)
// compiled member node returning call1112 (depth = 7)
  int op_slot_left_1105 = gc_frame_newslot(call1112);
  params[0] = call1109;
  partcv[0] = 1;
  Object opresult1113 = callmethod(call1112, "≤", 1, partcv, params);
// compiled op node returning opresult1113 (depth = 6)
  gc_frame_end(frame);
  return opresult1113;
}
Object meth_collectionsPrelude_next1114(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ret = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "ret");
// Begin line 838
  setline(838);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1117 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1118 = gc_frame_new();
// call case 3: self.outer request
  Object call1119 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1118);
// compiled call node returning call1119 (depth = 11)
// compiled member node returning call1119 (depth = 10)
  partcv[0] = 0;
  Object call1120 = callmethodflags(call1119, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1117);
// compiled call node returning call1120 (depth = 9)
// compiled member node returning call1120 (depth = 8)
  int op_slot_right_1116 = gc_frame_newslot(call1120);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1122 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1123 = callmethodflags(self, "imods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1122);
// compiled call node returning call1123 (depth = 9)
// compiled member node returning call1123 (depth = 8)
  int op_slot_left_1116 = gc_frame_newslot(call1123);
  params[0] = call1120;
  partcv[0] = 1;
  Object opresult1124 = callmethod(call1123, "≠", 1, partcv, params);
// compiled op node returning opresult1124 (depth = 7)
  Object if1115 = done;
  if (istrue(opresult1124)) {
// Begin line 839
  setline(839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1125 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1126 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1127 = callmethodflags(self, "asDebugString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1126);
// compiled call node returning call1127 (depth = 9)
// compiled member node returning call1127 (depth = 8)
  gc_frame_newslot(call1127);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ConcurrentModification (depth = 8)
  params[0] = call1127;
  partcv[0] = 1;
  Object call1128 = callmethod(*var_ConcurrentModification, "raise",
    1, partcv, params);
  gc_frame_end(callframe1125);
// compiled call node returning call1128 (depth = 7)
    gc_frame_newslot(call1128);
    if1115 = call1128;
  } else {
  }
// compiled if node returning if1115 (depth = 6)
// Begin line 841
  setline(841);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1131 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1132 = gc_frame_new();
// call case 3: self.outer request
  Object call1133 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1132);
// compiled call node returning call1133 (depth = 11)
// compiled member node returning call1133 (depth = 10)
  partcv[0] = 0;
  Object call1134 = callmethodflags(call1133, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1131);
// compiled call node returning call1134 (depth = 9)
// compiled member node returning call1134 (depth = 8)
  int op_slot_right_1130 = gc_frame_newslot(call1134);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1136 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1137 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1136);
// compiled call node returning call1137 (depth = 9)
// compiled member node returning call1137 (depth = 8)
  int op_slot_left_1130 = gc_frame_newslot(call1137);
  params[0] = call1134;
  partcv[0] = 1;
  Object opresult1138 = callmethod(call1137, ">", 1, partcv, params);
// compiled op node returning opresult1138 (depth = 7)
  Object if1129 = done;
  if (istrue(opresult1138)) {
// starting to compile call node (depth = 7)
  int callframe1139 = gc_frame_new();
// starting to compile string node (depth = 8)
  if (strlit1140 == NULL) {
    strlit1140 = alloc_String("on list");
    gc_root(strlit1140);
  }
// compiled string node returning strlit1140 (depth = 8)
  gc_frame_newslot(strlit1140);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_IteratorExhausted (depth = 8)
  params[0] = strlit1140;
  partcv[0] = 1;
  Object call1141 = callmethod(*var_IteratorExhausted, "raise",
    1, partcv, params);
  gc_frame_end(callframe1139);
// compiled call node returning call1141 (depth = 7)
    gc_frame_newslot(call1141);
    if1129 = call1141;
  } else {
  }
// compiled if node returning if1129 (depth = 6)
// Begin line 842
  setline(842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1142 = gc_frame_new();
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1143 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1144 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1143);
// compiled call node returning call1144 (depth = 9)
// compiled member node returning call1144 (depth = 8)
  gc_frame_newslot(call1144);
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1145 = gc_frame_new();
// call case 3: self.outer request
  Object call1146 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1145);
// compiled call node returning call1146 (depth = 9)
// compiled member node returning call1146 (depth = 8)
  params[0] = call1144;
  partcv[0] = 1;
  Object call1147 = callmethodflags(call1146, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1142);
// compiled call node returning call1147 (depth = 7)
  *var_ret = call1147;
  if (call1147 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 843
  setline(843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1148 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1150 = alloc_Float64(1);
// compiled num node returning num1150 (depth = 8)
  int op_slot_right_1149 = gc_frame_newslot(num1150);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1152 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1153 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1152);
// compiled call node returning call1153 (depth = 9)
// compiled member node returning call1153 (depth = 8)
  int op_slot_left_1149 = gc_frame_newslot(call1153);
  params[0] = num1150;
  partcv[0] = 1;
  Object sum1154 = callmethod(call1153, "+", 1, partcv, params);
// compiled op node returning sum1154 (depth = 7)
  gc_frame_newslot(sum1154);
// call case 4: self request
  params[0] = sum1154;
  partcv[0] = 1;
  Object call1155 = callmethodflags(self, "idx:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1148);
// compiled call node returning call1155 (depth = 6)
// Begin line 844
  setline(844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ret (depth = 6)
  gc_frame_end(frame);
  return *var_ret;
}
Object meth_collectionsPrelude_iterator1077(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1078 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1078 = alloc_userobj2(8,7, objclass1078);
  gc_frame_newslot(obj1078);
if (objclass1078 == NULL) {
  glfree(obj1078->class->name);
  obj1078->class->name = "obj715.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1078, self, 0);
  addmethodreal(obj1078,"outer", &reader_collectionsPrelude_outer_1079);
  Object oldself1078 = self;
  struct StackFrameObject *oldstackframe1078 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1078);
  gc_frame_newslot((Object)stackframe);
  self = obj1078;
  Object *oldselfslot1078 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1078 = (*(struct UserObject *)self).data[0], lowerouter1078 = thisouter1078;
  if (inheritingObject1078) {
    struct UserObject *inho1078 = (struct UserObject *)inheritingObject1078;
    while (inho1078->super != GraceDefaultObject) inho1078 = (struct UserObject *)inho1078->super;
    inho1078->super = obj1078;
    self = inheritingObject1078;
    *selfslot = self;
    lowerouter1078 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1078;
  }
if (objclass1078 == NULL) {
  Method *reader1080 = addmethodrealflags(obj1078, "imods",&reader_collectionsPrelude_imods_1080, MFLAG_CONFIDENTIAL);
  Method *writer1080 = addmethodrealflags(obj1078, "imods:=",&writer_collectionsPrelude_imods_1080, MFLAG_CONFIDENTIAL);
  reader1080->definitionModule = modulename;
  writer1080->definitionModule = modulename;
  reader1080->definitionLine = 832;
  writer1080->definitionLine = 832;
}
obj1078->flags |= OFLAG_MUTABLE;
adddatum2(obj1078, alloc_Undefined(), 1);
if (objclass1078 == NULL) {
  Method *reader1081 = addmethodrealflags(obj1078, "idx",&reader_collectionsPrelude_idx_1081, MFLAG_CONFIDENTIAL);
  Method *writer1081 = addmethodrealflags(obj1078, "idx:=",&writer_collectionsPrelude_idx_1081, MFLAG_CONFIDENTIAL);
  reader1081->definitionModule = modulename;
  writer1081->definitionModule = modulename;
  reader1081->definitionLine = 833;
  writer1081->definitionLine = 833;
}
obj1078->flags |= OFLAG_MUTABLE;
adddatum2(obj1078, alloc_Undefined(), 2);
// method "asDebugString"
  struct UserObject *uo1082 = (struct UserObject*)obj1078;
  uo1082->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString1082 = addmethod2pos(obj1078, "asDebugString", &meth_collectionsPrelude_asDebugString1082, 3);
  int argcv_meth_collectionsPrelude_asDebugString1082[] = {0};
  meth_meth_collectionsPrelude_asDebugString1082->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString1082);
  meth_meth_collectionsPrelude_asDebugString1082->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString1082->definitionLine = 834;
// method "asString"
  struct UserObject *uo1102 = (struct UserObject*)obj1078;
  uo1102->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString1102 = addmethod2pos(obj1078, "asString", &meth_collectionsPrelude_asString1102, 4);
  int argcv_meth_collectionsPrelude_asString1102[] = {0};
  meth_meth_collectionsPrelude_asString1102->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString1102);
  meth_meth_collectionsPrelude_asString1102->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString1102->definitionLine = 835;
// method "hasNext"
  struct UserObject *uo1104 = (struct UserObject*)obj1078;
  uo1104->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext1104 = addmethod2pos(obj1078, "hasNext", &meth_collectionsPrelude_hasNext1104, 5);
  int argcv_meth_collectionsPrelude_hasNext1104[] = {0};
  meth_meth_collectionsPrelude_hasNext1104->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext1104);
  meth_meth_collectionsPrelude_hasNext1104->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext1104->definitionLine = 836;
// method "next"
  block_savedest(obj1078);
  Object closure1114 = createclosure(2, "next");
  setclosureframe(closure1114, stackframe);
  addtoclosure(closure1114, var_ConcurrentModification);
  addtoclosure(closure1114, var_IteratorExhausted);
  struct UserObject *uo1114 = (struct UserObject*)obj1078;
  uo1114->data[6] = (Object)closure1114;
  Method *meth_meth_collectionsPrelude_next1114 = addmethod2pos(obj1078, "next", &meth_collectionsPrelude_next1114, 6);
  int argcv_meth_collectionsPrelude_next1114[] = {0};
  meth_meth_collectionsPrelude_next1114->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next1114);
  meth_meth_collectionsPrelude_next1114->definitionModule = modulename;
  meth_meth_collectionsPrelude_next1114->definitionLine = 837;
  sourceObject = obj1078;
// Begin line 832
  setline(832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1156 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1157 = gc_frame_new();
// call case 3: self.outer request
  Object call1158 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1157);
// compiled call node returning call1158 (depth = 9)
// compiled member node returning call1158 (depth = 8)
  partcv[0] = 0;
  Object call1159 = callmethodflags(call1158, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1156);
// compiled call node returning call1159 (depth = 7)
// compiled member node returning call1159 (depth = 6)
  adddatum2(obj1078, call1159, 1);
  sourceObject = obj1078;
// Begin line 833
  setline(833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num1160 = alloc_Float64(1);
// compiled num node returning num1160 (depth = 6)
  adddatum2(obj1078, num1160, 2);
  sourceObject = obj1078;
  sourceObject = obj1078;
  sourceObject = obj1078;
  sourceObject = obj1078;
  objclass1078 = obj1078->class;
  objclass1078->definitionModule = modulename;
  objclass1078->definitionLine = 831;
  (*(struct UserObject *)self).data[0] = lowerouter1078;
  self = oldself1078;
  selfslot = oldselfslot1078;
  stackframe = oldstackframe1078;
  gc_frame_end(frame);
  return obj1078;
}
Object meth_collectionsPrelude_iterator1077_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1078 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1078 = alloc_userobj2(8,7, objclass1078);
  gc_frame_newslot(obj1078);
if (objclass1078 == NULL) {
  glfree(obj1078->class->name);
  obj1078->class->name = "obj715.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1078, self, 0);
  addmethodreal(obj1078,"outer", &reader_collectionsPrelude_outer_1079);
  Object oldself1078 = self;
  struct StackFrameObject *oldstackframe1078 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1078);
  gc_frame_newslot((Object)stackframe);
  self = obj1078;
  Object *oldselfslot1078 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1078 = (*(struct UserObject *)self).data[0], lowerouter1078 = thisouter1078;
  if (inheritingObject1078) {
    struct UserObject *inho1078 = (struct UserObject *)inheritingObject1078;
    while (inho1078->super != GraceDefaultObject) inho1078 = (struct UserObject *)inho1078->super;
    inho1078->super = obj1078;
    self = inheritingObject1078;
    *selfslot = self;
    lowerouter1078 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1078;
  }
if (objclass1078 == NULL) {
  Method *reader1080 = addmethodrealflags(obj1078, "imods",&reader_collectionsPrelude_imods_1080, MFLAG_CONFIDENTIAL);
  Method *writer1080 = addmethodrealflags(obj1078, "imods:=",&writer_collectionsPrelude_imods_1080, MFLAG_CONFIDENTIAL);
  reader1080->definitionModule = modulename;
  writer1080->definitionModule = modulename;
  reader1080->definitionLine = 832;
  writer1080->definitionLine = 832;
}
obj1078->flags |= OFLAG_MUTABLE;
adddatum2(obj1078, alloc_Undefined(), 1);
if (objclass1078 == NULL) {
  Method *reader1081 = addmethodrealflags(obj1078, "idx",&reader_collectionsPrelude_idx_1081, MFLAG_CONFIDENTIAL);
  Method *writer1081 = addmethodrealflags(obj1078, "idx:=",&writer_collectionsPrelude_idx_1081, MFLAG_CONFIDENTIAL);
  reader1081->definitionModule = modulename;
  writer1081->definitionModule = modulename;
  reader1081->definitionLine = 833;
  writer1081->definitionLine = 833;
}
obj1078->flags |= OFLAG_MUTABLE;
adddatum2(obj1078, alloc_Undefined(), 2);
// method "asDebugString"
  struct UserObject *uo1082 = (struct UserObject*)obj1078;
  uo1082->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString1082 = addmethod2pos(obj1078, "asDebugString", &meth_collectionsPrelude_asDebugString1082, 3);
  int argcv_meth_collectionsPrelude_asDebugString1082[] = {0};
  meth_meth_collectionsPrelude_asDebugString1082->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString1082);
  meth_meth_collectionsPrelude_asDebugString1082->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString1082->definitionLine = 834;
// method "asString"
  struct UserObject *uo1102 = (struct UserObject*)obj1078;
  uo1102->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString1102 = addmethod2pos(obj1078, "asString", &meth_collectionsPrelude_asString1102, 4);
  int argcv_meth_collectionsPrelude_asString1102[] = {0};
  meth_meth_collectionsPrelude_asString1102->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString1102);
  meth_meth_collectionsPrelude_asString1102->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString1102->definitionLine = 835;
// method "hasNext"
  struct UserObject *uo1104 = (struct UserObject*)obj1078;
  uo1104->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext1104 = addmethod2pos(obj1078, "hasNext", &meth_collectionsPrelude_hasNext1104, 5);
  int argcv_meth_collectionsPrelude_hasNext1104[] = {0};
  meth_meth_collectionsPrelude_hasNext1104->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext1104);
  meth_meth_collectionsPrelude_hasNext1104->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext1104->definitionLine = 836;
// method "next"
  block_savedest(obj1078);
  Object closure1114 = createclosure(2, "next");
  setclosureframe(closure1114, stackframe);
  addtoclosure(closure1114, var_ConcurrentModification);
  addtoclosure(closure1114, var_IteratorExhausted);
  struct UserObject *uo1114 = (struct UserObject*)obj1078;
  uo1114->data[6] = (Object)closure1114;
  Method *meth_meth_collectionsPrelude_next1114 = addmethod2pos(obj1078, "next", &meth_collectionsPrelude_next1114, 6);
  int argcv_meth_collectionsPrelude_next1114[] = {0};
  meth_meth_collectionsPrelude_next1114->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next1114);
  meth_meth_collectionsPrelude_next1114->definitionModule = modulename;
  meth_meth_collectionsPrelude_next1114->definitionLine = 837;
  sourceObject = obj1078;
// Begin line 832
  setline(832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1156 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1157 = gc_frame_new();
// call case 3: self.outer request
  Object call1158 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1157);
// compiled call node returning call1158 (depth = 9)
// compiled member node returning call1158 (depth = 8)
  partcv[0] = 0;
  Object call1159 = callmethodflags(call1158, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1156);
// compiled call node returning call1159 (depth = 7)
// compiled member node returning call1159 (depth = 6)
  adddatum2(obj1078, call1159, 1);
  sourceObject = obj1078;
// Begin line 833
  setline(833);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num1160 = alloc_Float64(1);
// compiled num node returning num1160 (depth = 6)
  adddatum2(obj1078, num1160, 2);
  sourceObject = obj1078;
  sourceObject = obj1078;
  sourceObject = obj1078;
  sourceObject = obj1078;
  objclass1078 = obj1078->class;
  objclass1078->definitionModule = modulename;
  objclass1078->definitionLine = 831;
  (*(struct UserObject *)self).data[0] = lowerouter1078;
  self = oldself1078;
  selfslot = oldselfslot1078;
  stackframe = oldstackframe1078;
  gc_frame_end(frame);
  return obj1078;
}
Object meth_collectionsPrelude_values1162(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for values (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for values");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 850
  setline(850);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_keys1163(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keys (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for keys");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 854
  setline(854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1164 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1165 = callmethodflags(self, "indices", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1164);
// compiled call node returning call1165 (depth = 7)
// compiled member node returning call1165 (depth = 6)
  gc_frame_end(frame);
  return call1165;
}
Object meth_collectionsPrelude__apply1177(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[1]);
  *var_r = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 860
  setline(860);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_r (depth = 10)
  int op_slot_right_1179 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_l (depth = 10)
  int op_slot_left_1179 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult1181 = callmethod(*var_l, "==", 1, partcv, params);
// compiled op node returning opresult1181 (depth = 9)
  Object if1178 = done;
  if (istrue(opresult1181)) {
// starting to compile num node (depth = 9)
  Object num1182 = alloc_Float64(0);
// compiled num node returning num1182 (depth = 9)
    gc_frame_newslot(num1182);
    if1178 = num1182;
  } else {
// Begin line 862
  setline(862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 9)
// Begin line 861
  setline(861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_r (depth = 11)
  int op_slot_right_1184 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_l (depth = 11)
  int op_slot_left_1184 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult1186 = callmethod(*var_l, "<", 1, partcv, params);
// compiled op node returning opresult1186 (depth = 10)
  Object if1183 = done;
  if (istrue(opresult1186)) {
// starting to compile call node (depth = 10)
  int callframe1187 = gc_frame_new();
// call case 6: other member request
// starting to compile num node (depth = 11)
  Object num1188 = alloc_Float64(1);
// compiled num node returning num1188 (depth = 11)
  partcv[0] = 0;
  Object call1189 = callmethod(num1188, "prefix-",
    1, partcv, params);
  gc_frame_end(callframe1187);
// compiled call node returning call1189 (depth = 10)
    gc_frame_newslot(call1189);
    if1183 = call1189;
  } else {
// Begin line 862
  setline(862);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 10)
  Object num1190 = alloc_Float64(1);
// compiled num node returning num1190 (depth = 10)
    gc_frame_newslot(num1190);
    if1183 = num1190;
  }
// compiled if node returning if1183 (depth = 9)
    gc_frame_newslot(if1183);
    if1178 = if1183;
  }
// compiled if node returning if1178 (depth = 8)
  gc_frame_end(frame);
  return if1178;
}
Object meth_collectionsPrelude_sort1166(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sort");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sort (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for sort");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 858
  setline(858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1167 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1169 = alloc_Float64(1);
// compiled num node returning num1169 (depth = 8)
  int op_slot_right_1168 = gc_frame_newslot(num1169);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1171 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1172 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1171);
// compiled call node returning call1172 (depth = 9)
// compiled member node returning call1172 (depth = 8)
  int op_slot_left_1168 = gc_frame_newslot(call1172);
  params[0] = num1169;
  partcv[0] = 1;
  Object sum1173 = callmethod(call1172, "+", 1, partcv, params);
// compiled op node returning sum1173 (depth = 7)
  gc_frame_newslot(sum1173);
// call case 4: self request
  params[0] = sum1173;
  partcv[0] = 1;
  Object call1174 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1167);
// compiled call node returning call1174 (depth = 6)
// Begin line 859
  setline(859);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1175 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1176 = alloc_Block(NULL, NULL, "collectionsPrelude", 859);
  gc_frame_newslot(block1176);
// method "_apply"
  block_savedest(block1176);
  Object closure1177 = createclosure(1, "_apply");
  setclosureframe(closure1177, stackframe);
  addtoclosure(closure1177, selfslot);
  struct UserObject *uo1177 = (struct UserObject*)block1176;
  uo1177->data[0] = (Object)closure1177;
  Method *meth_meth_collectionsPrelude__apply1177 = addmethod2pos(block1176, "_apply", &meth_collectionsPrelude__apply1177, 0);
  int argcv_meth_collectionsPrelude__apply1177[] = {2};
  meth_meth_collectionsPrelude__apply1177->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1177);
  meth_meth_collectionsPrelude__apply1177->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1177->definitionLine = 858;
// compiled block node returning block1176 (depth = 7)
  gc_frame_newslot(block1176);
// call case 4: self request
  params[0] = block1176;
  partcv[0] = 1;
  Object call1192 = callmethodflags(self, "sortBy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1175);
// compiled call node returning call1192 (depth = 6)
  gc_frame_end(frame);
  return call1192;
}
Object meth_collectionsPrelude_sortedBy1193(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for sortedBy");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 866
  setline(866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1194 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sortBlock (depth = 7)
  gc_frame_newslot(*var_sortBlock);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1195 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1196 = callmethodflags(self, "copy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1195);
// compiled call node returning call1196 (depth = 8)
// compiled member node returning call1196 (depth = 7)
  params[0] = *var_sortBlock;
  partcv[0] = 1;
  Object call1197 = callmethod(call1196, "sortBy",
    1, partcv, params);
  gc_frame_end(callframe1194);
// compiled call node returning call1197 (depth = 6)
  gc_frame_end(frame);
  return call1197;
}
Object meth_collectionsPrelude_sorted1198(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sorted (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for sorted");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 869
  setline(869);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1199 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1200 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1201 = callmethodflags(self, "copy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1200);
// compiled call node returning call1201 (depth = 9)
// compiled member node returning call1201 (depth = 8)
  partcv[0] = 0;
  Object call1202 = callmethod(call1201, "sort",
    1, partcv, params);
  gc_frame_end(callframe1199);
// compiled call node returning call1202 (depth = 7)
// compiled member node returning call1202 (depth = 6)
  gc_frame_end(frame);
  return call1202;
}
Object meth_collectionsPrelude_copy1203(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "copy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for copy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for copy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 872
  setline(872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1204 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1205 = gc_frame_new();
// call case 3: self.outer request
  Object call1206 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1205);
// compiled call node returning call1206 (depth = 8)
// compiled member node returning call1206 (depth = 7)
  params[0] = self;
  partcv[0] = 1;
  Object call1207 = callmethodflags(call1206, "withAll", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1204);
// compiled call node returning call1207 (depth = 6)
  gc_frame_end(frame);
  return call1207;
}
Object meth_collectionsPrelude__apply1214(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 627
  setline(627);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
// compiled call node returning done (depth = 8)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_boundsCheck1224(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "boundsCheck");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method boundsCheck");
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for boundsCheck (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for boundsCheck");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 911
  setline(911);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1227 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1229 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1230 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1229);
// compiled call node returning call1230 (depth = 7)
// compiled member node returning call1230 (depth = 6)
  int op_slot_right_1228 = gc_frame_newslot(call1230);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_1228 = gc_frame_newslot(*var_n);
  params[0] = call1230;
  partcv[0] = 1;
  Object opresult1232 = callmethod(*var_n, "≤", 1, partcv, params);
// compiled op node returning opresult1232 (depth = 5)
  partcv[0] = 0;
  Object call1233 = callmethod(opresult1232, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe1227);
// compiled call node returning call1233 (depth = 4)
  int op_slot_right_1226 = gc_frame_newslot(call1233);
// starting to compile call node (depth = 4)
  int callframe1235 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1237 = alloc_Float64(1);
// compiled num node returning num1237 (depth = 6)
  int op_slot_right_1236 = gc_frame_newslot(num1237);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_left_1236 = gc_frame_newslot(*var_n);
  params[0] = num1237;
  partcv[0] = 1;
  Object opresult1239 = callmethod(*var_n, "≥", 1, partcv, params);
// compiled op node returning opresult1239 (depth = 5)
  partcv[0] = 0;
  Object call1240 = callmethod(opresult1239, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe1235);
// compiled call node returning call1240 (depth = 4)
  int op_slot_left_1226 = gc_frame_newslot(call1240);
  params[0] = call1233;
  partcv[0] = 1;
  Object opresult1241 = callmethod(call1240, "||", 1, partcv, params);
// compiled op node returning opresult1241 (depth = 3)
  Object if1225 = done;
  if (istrue(opresult1241)) {
// Begin line 912
  setline(912);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1242 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1244 == NULL) {
    strlit1244 = alloc_String("");
    gc_root(strlit1244);
  }
// compiled string node returning strlit1244 (depth = 5)
  int op_slot_right_1243 = gc_frame_newslot(strlit1244);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1247 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1248 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1247);
// compiled call node returning call1248 (depth = 7)
// compiled member node returning call1248 (depth = 6)
  int op_slot_right_1246 = gc_frame_newslot(call1248);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1251 == NULL) {
    strlit1251 = alloc_String(" out of bounds 1..");
    gc_root(strlit1251);
  }
// compiled string node returning strlit1251 (depth = 7)
  int op_slot_right_1250 = gc_frame_newslot(strlit1251);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_n (depth = 8)
  int op_slot_right_1253 = gc_frame_newslot(*var_n);
// starting to compile string node (depth = 8)
  if (strlit1255 == NULL) {
    strlit1255 = alloc_String("index ");
    gc_root(strlit1255);
  }
// compiled string node returning strlit1255 (depth = 8)
  int op_slot_left_1253 = gc_frame_newslot(strlit1255);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult1256 = callmethod(strlit1255, "++", 1, partcv, params);
// compiled op node returning opresult1256 (depth = 7)
  int op_slot_left_1250 = gc_frame_newslot(opresult1256);
  params[0] = strlit1251;
  partcv[0] = 1;
  Object opresult1257 = callmethod(opresult1256, "++", 1, partcv, params);
// compiled op node returning opresult1257 (depth = 6)
  int op_slot_left_1246 = gc_frame_newslot(opresult1257);
  params[0] = call1248;
  partcv[0] = 1;
  Object opresult1258 = callmethod(opresult1257, "++", 1, partcv, params);
// compiled op node returning opresult1258 (depth = 5)
  int op_slot_left_1243 = gc_frame_newslot(opresult1258);
  params[0] = strlit1244;
  partcv[0] = 1;
  Object opresult1259 = callmethod(opresult1258, "++", 1, partcv, params);
// compiled op node returning opresult1259 (depth = 4)
  gc_frame_newslot(opresult1259);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult1259;
  partcv[0] = 1;
  Object call1260 = callmethod(*var_BoundsError, "raise",
    1, partcv, params);
  gc_frame_end(callframe1242);
// compiled call node returning call1260 (depth = 3)
    gc_frame_newslot(call1260);
    if1225 = call1260;
  } else {
  }
// compiled if node returning if1225 (depth = 2)
  gc_frame_end(frame);
  return if1225;
}
Object meth_collectionsPrelude_at1261(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for at");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 916
  setline(916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1262 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1263 = callmethodflags(self, "boundsCheck", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1262);
// compiled call node returning call1263 (depth = 2)
// Begin line 917
  setline(917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1264 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1266 = alloc_Float64(1);
// compiled num node returning num1266 (depth = 4)
  int op_slot_right_1265 = gc_frame_newslot(num1266);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_1265 = gc_frame_newslot(*var_n);
  params[0] = num1266;
  partcv[0] = 1;
  Object diff1268 = callmethod(*var_n, "-", 1, partcv, params);
// compiled op node returning diff1268 (depth = 3)
  gc_frame_newslot(diff1268);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1269 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1270 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1269);
// compiled call node returning call1270 (depth = 4)
// compiled member node returning call1270 (depth = 3)
  params[0] = diff1268;
  partcv[0] = 1;
  Object call1271 = callmethod(call1270, "at",
    1, partcv, params);
  gc_frame_end(callframe1264);
// compiled call node returning call1271 (depth = 2)
  gc_frame_end(frame);
  return call1271;
}
Object meth_collectionsPrelude_at_40__41_put1272(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at()put");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at()put");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at()put");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for at()put (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for at");
  Object *var_x = &(stackframe->slots[1]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for put");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 920
  setline(920);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1273 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1275 = alloc_Float64(1);
// compiled num node returning num1275 (depth = 4)
  int op_slot_right_1274 = gc_frame_newslot(num1275);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1277 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1278 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1277);
// compiled call node returning call1278 (depth = 5)
// compiled member node returning call1278 (depth = 4)
  int op_slot_left_1274 = gc_frame_newslot(call1278);
  params[0] = num1275;
  partcv[0] = 1;
  Object sum1279 = callmethod(call1278, "+", 1, partcv, params);
// compiled op node returning sum1279 (depth = 3)
  gc_frame_newslot(sum1279);
// call case 4: self request
  params[0] = sum1279;
  partcv[0] = 1;
  Object call1280 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1273);
// compiled call node returning call1280 (depth = 2)
// Begin line 921
  setline(921);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1284 = alloc_Float64(1);
// compiled num node returning num1284 (depth = 5)
  int op_slot_right_1283 = gc_frame_newslot(num1284);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1286 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1287 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1286);
// compiled call node returning call1287 (depth = 6)
// compiled member node returning call1287 (depth = 5)
  int op_slot_left_1283 = gc_frame_newslot(call1287);
  params[0] = num1284;
  partcv[0] = 1;
  Object sum1288 = callmethod(call1287, "+", 1, partcv, params);
// compiled op node returning sum1288 (depth = 4)
  int op_slot_right_1282 = gc_frame_newslot(sum1288);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_1282 = gc_frame_newslot(*var_n);
  params[0] = sum1288;
  partcv[0] = 1;
  Object opresult1290 = callmethod(*var_n, "==", 1, partcv, params);
// compiled op node returning opresult1290 (depth = 3)
  Object if1281 = done;
  if (istrue(opresult1290)) {
// Begin line 922
  setline(922);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1291 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call1292 = callmethodflags(self, "addLast", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1291);
// compiled call node returning call1292 (depth = 3)
    gc_frame_newslot(call1292);
    if1281 = call1292;
  } else {
// Begin line 924
  setline(924);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1293 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1294 = callmethodflags(self, "boundsCheck", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1293);
// compiled call node returning call1294 (depth = 3)
// Begin line 925
  setline(925);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1295 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1297 = alloc_Float64(1);
// compiled num node returning num1297 (depth = 5)
  int op_slot_right_1296 = gc_frame_newslot(num1297);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  int op_slot_left_1296 = gc_frame_newslot(*var_n);
  params[0] = num1297;
  partcv[0] = 1;
  Object diff1299 = callmethod(*var_n, "-", 1, partcv, params);
// compiled op node returning diff1299 (depth = 4)
  gc_frame_newslot(diff1299);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  gc_frame_newslot(*var_x);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1300 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1301 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1300);
// compiled call node returning call1301 (depth = 5)
// compiled member node returning call1301 (depth = 4)
  params[0] = diff1299;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1302 = callmethod(call1301, "at()put",
    2, partcv, params);
  gc_frame_end(callframe1295);
// compiled call node returning call1302 (depth = 3)
    gc_frame_newslot(call1302);
    if1281 = call1302;
  }
// compiled if node returning if1281 (depth = 2)
// Begin line 927
  setline(927);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_add1303(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "add");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method add");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for add (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for add");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 930
  setline(930);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1304 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1306 = alloc_Float64(1);
// compiled num node returning num1306 (depth = 4)
  int op_slot_right_1305 = gc_frame_newslot(num1306);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1308 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1309 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1308);
// compiled call node returning call1309 (depth = 5)
// compiled member node returning call1309 (depth = 4)
  int op_slot_left_1305 = gc_frame_newslot(call1309);
  params[0] = num1306;
  partcv[0] = 1;
  Object sum1310 = callmethod(call1309, "+", 1, partcv, params);
// compiled op node returning sum1310 (depth = 3)
  gc_frame_newslot(sum1310);
// call case 4: self request
  params[0] = sum1310;
  partcv[0] = 1;
  Object call1311 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1304);
// compiled call node returning call1311 (depth = 2)
// Begin line 931
  setline(931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1314 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1315 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1316 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1315);
// compiled call node returning call1316 (depth = 7)
// compiled member node returning call1316 (depth = 6)
  partcv[0] = 0;
  Object call1317 = callmethod(call1316, "size",
    1, partcv, params);
  gc_frame_end(callframe1314);
// compiled call node returning call1317 (depth = 5)
// compiled member node returning call1317 (depth = 4)
  int op_slot_right_1313 = gc_frame_newslot(call1317);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1319 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1320 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1319);
// compiled call node returning call1320 (depth = 5)
// compiled member node returning call1320 (depth = 4)
  int op_slot_left_1313 = gc_frame_newslot(call1320);
  params[0] = call1317;
  partcv[0] = 1;
  Object opresult1321 = callmethod(call1320, "==", 1, partcv, params);
// compiled op node returning opresult1321 (depth = 3)
  Object if1312 = done;
  if (istrue(opresult1321)) {
// starting to compile call node (depth = 3)
  int callframe1322 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1324 = alloc_Float64(2);
// compiled num node returning num1324 (depth = 5)
  int op_slot_right_1323 = gc_frame_newslot(num1324);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1326 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1327 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1328 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1327);
// compiled call node returning call1328 (depth = 8)
// compiled member node returning call1328 (depth = 7)
  partcv[0] = 0;
  Object call1329 = callmethod(call1328, "size",
    1, partcv, params);
  gc_frame_end(callframe1326);
// compiled call node returning call1329 (depth = 6)
// compiled member node returning call1329 (depth = 5)
  int op_slot_left_1323 = gc_frame_newslot(call1329);
  params[0] = num1324;
  partcv[0] = 1;
  Object prod1330 = callmethod(call1329, "*", 1, partcv, params);
// compiled op node returning prod1330 (depth = 4)
  gc_frame_newslot(prod1330);
// call case 4: self request
  params[0] = prod1330;
  partcv[0] = 1;
  Object call1331 = callmethodflags(self, "expandTo", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1322);
// compiled call node returning call1331 (depth = 3)
    gc_frame_newslot(call1331);
    if1312 = call1331;
  } else {
  }
// compiled if node returning if1312 (depth = 2)
// Begin line 932
  setline(932);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1332 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1333 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1334 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1333);
// compiled call node returning call1334 (depth = 4)
// compiled member node returning call1334 (depth = 3)
  gc_frame_newslot(call1334);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_x (depth = 3)
  gc_frame_newslot(*var_x);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1335 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1336 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1335);
// compiled call node returning call1336 (depth = 4)
// compiled member node returning call1336 (depth = 3)
  params[0] = call1334;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1337 = callmethod(call1336, "at()put",
    2, partcv, params);
  gc_frame_end(callframe1332);
// compiled call node returning call1337 (depth = 2)
// Begin line 933
  setline(933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1338 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1340 = alloc_Float64(1);
// compiled num node returning num1340 (depth = 4)
  int op_slot_right_1339 = gc_frame_newslot(num1340);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1342 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1343 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1342);
// compiled call node returning call1343 (depth = 5)
// compiled member node returning call1343 (depth = 4)
  int op_slot_left_1339 = gc_frame_newslot(call1343);
  params[0] = num1340;
  partcv[0] = 1;
  Object sum1344 = callmethod(call1343, "+", 1, partcv, params);
// compiled op node returning sum1344 (depth = 3)
  gc_frame_newslot(sum1344);
// call case 4: self request
  params[0] = sum1344;
  partcv[0] = 1;
  Object call1345 = callmethodflags(self, "size:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1338);
// compiled call node returning call1345 (depth = 2)
// Begin line 934
  setline(934);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply1393(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 942
  setline(942);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1394 = gc_frame_new();
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1395 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1396 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1395);
// compiled call node returning call1396 (depth = 6)
// compiled member node returning call1396 (depth = 5)
  gc_frame_newslot(call1396);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1397 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1398 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1397);
// compiled call node returning call1398 (depth = 6)
// compiled member node returning call1398 (depth = 5)
  params[0] = call1396;
  params[1] = *var_each;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1399 = callmethod(call1398, "at()put",
    2, partcv, params);
  gc_frame_end(callframe1394);
// compiled call node returning call1399 (depth = 4)
// Begin line 943
  setline(943);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1400 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1402 = alloc_Float64(1);
// compiled num node returning num1402 (depth = 6)
  int op_slot_right_1401 = gc_frame_newslot(num1402);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1404 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1405 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1404);
// compiled call node returning call1405 (depth = 7)
// compiled member node returning call1405 (depth = 6)
  int op_slot_left_1401 = gc_frame_newslot(call1405);
  params[0] = num1402;
  partcv[0] = 1;
  Object sum1406 = callmethod(call1405, "+", 1, partcv, params);
// compiled op node returning sum1406 (depth = 5)
  gc_frame_newslot(sum1406);
// call case 4: self request
  params[0] = sum1406;
  partcv[0] = 1;
  Object call1407 = callmethodflags(self, "size:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1400);
// compiled call node returning call1407 (depth = 4)
  gc_frame_end(frame);
  return call1407;
}
Object meth_collectionsPrelude_addAll1346(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAll");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAll");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addAll (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for addAll");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 937
  setline(937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1347 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1349 = alloc_Float64(1);
// compiled num node returning num1349 (depth = 4)
  int op_slot_right_1348 = gc_frame_newslot(num1349);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1351 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1352 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1351);
// compiled call node returning call1352 (depth = 5)
// compiled member node returning call1352 (depth = 4)
  int op_slot_left_1348 = gc_frame_newslot(call1352);
  params[0] = num1349;
  partcv[0] = 1;
  Object sum1353 = callmethod(call1352, "+", 1, partcv, params);
// compiled op node returning sum1353 (depth = 3)
  gc_frame_newslot(sum1353);
// call case 4: self request
  params[0] = sum1353;
  partcv[0] = 1;
  Object call1354 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1347);
// compiled call node returning call1354 (depth = 2)
// Begin line 938
  setline(938);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1357 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1358 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1359 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1358);
// compiled call node returning call1359 (depth = 7)
// compiled member node returning call1359 (depth = 6)
  partcv[0] = 0;
  Object call1360 = callmethod(call1359, "size",
    1, partcv, params);
  gc_frame_end(callframe1357);
// compiled call node returning call1360 (depth = 5)
// compiled member node returning call1360 (depth = 4)
  int op_slot_right_1356 = gc_frame_newslot(call1360);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1363 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_l (depth = 7)
  partcv[0] = 0;
  Object call1364 = callmethod(*var_l, "size",
    1, partcv, params);
  gc_frame_end(callframe1363);
// compiled call node returning call1364 (depth = 6)
// compiled member node returning call1364 (depth = 5)
  int op_slot_right_1362 = gc_frame_newslot(call1364);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1366 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1367 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1366);
// compiled call node returning call1367 (depth = 6)
// compiled member node returning call1367 (depth = 5)
  int op_slot_left_1362 = gc_frame_newslot(call1367);
  params[0] = call1364;
  partcv[0] = 1;
  Object sum1368 = callmethod(call1367, "+", 1, partcv, params);
// compiled op node returning sum1368 (depth = 4)
  int op_slot_left_1356 = gc_frame_newslot(sum1368);
  params[0] = call1360;
  partcv[0] = 1;
  Object opresult1369 = callmethod(sum1368, ">", 1, partcv, params);
// compiled op node returning opresult1369 (depth = 3)
  Object if1355 = done;
  if (istrue(opresult1369)) {
// Begin line 939
  setline(939);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1370 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1371 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1373 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_l (depth = 8)
  partcv[0] = 0;
  Object call1374 = callmethod(*var_l, "size",
    1, partcv, params);
  gc_frame_end(callframe1373);
// compiled call node returning call1374 (depth = 7)
// compiled member node returning call1374 (depth = 6)
  int op_slot_right_1372 = gc_frame_newslot(call1374);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1376 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1377 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1376);
// compiled call node returning call1377 (depth = 7)
// compiled member node returning call1377 (depth = 6)
  int op_slot_left_1372 = gc_frame_newslot(call1377);
  params[0] = call1374;
  partcv[0] = 1;
  Object sum1378 = callmethod(call1377, "+", 1, partcv, params);
// compiled op node returning sum1378 (depth = 5)
  gc_frame_newslot(sum1378);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1380 = alloc_Float64(2);
// compiled num node returning num1380 (depth = 6)
  int op_slot_right_1379 = gc_frame_newslot(num1380);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1382 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1383 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1382);
// compiled call node returning call1383 (depth = 7)
// compiled member node returning call1383 (depth = 6)
  int op_slot_left_1379 = gc_frame_newslot(call1383);
  params[0] = num1380;
  partcv[0] = 1;
  Object prod1384 = callmethod(call1383, "*", 1, partcv, params);
// compiled op node returning prod1384 (depth = 5)
  gc_frame_newslot(prod1384);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1385 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1386 = gc_frame_new();
// call case 3: self.outer request
  Object call1387 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1386);
// compiled call node returning call1387 (depth = 8)
// compiled member node returning call1387 (depth = 7)
  partcv[0] = 0;
  Object call1388 = callmethodflags(call1387, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1385);
// compiled call node returning call1388 (depth = 6)
// compiled member node returning call1388 (depth = 5)
  params[0] = sum1378;
  params[1] = prod1384;
  partcv[0] = 2;
  Object call1389 = callmethodflags(call1388, "max", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1371);
// compiled call node returning call1389 (depth = 4)
  gc_frame_newslot(call1389);
// call case 4: self request
  params[0] = call1389;
  partcv[0] = 1;
  Object call1390 = callmethodflags(self, "expandTo", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1370);
// compiled call node returning call1390 (depth = 3)
    gc_frame_newslot(call1390);
    if1355 = call1390;
  } else {
  }
// compiled if node returning if1355 (depth = 2)
// Begin line 941
  setline(941);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1391 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  gc_frame_newslot(*var_l);
// starting to compile block node (depth = 3)
  Object block1392 = alloc_Block(NULL, NULL, "collectionsPrelude", 941);
  gc_frame_newslot(block1392);
// method "_apply"
  block_savedest(block1392);
  Object closure1393 = createclosure(1, "_apply");
  setclosureframe(closure1393, stackframe);
  addtoclosure(closure1393, selfslot);
  struct UserObject *uo1393 = (struct UserObject*)block1392;
  uo1393->data[0] = (Object)closure1393;
  Method *meth_meth_collectionsPrelude__apply1393 = addmethod2pos(block1392, "_apply", &meth_collectionsPrelude__apply1393, 0);
  int argcv_meth_collectionsPrelude__apply1393[] = {1};
  meth_meth_collectionsPrelude__apply1393->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1393);
  meth_meth_collectionsPrelude__apply1393->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1393->definitionLine = 939;
// compiled block node returning block1392 (depth = 3)
  gc_frame_newslot(block1392);
// call case 5: prelude request
  params[0] = *var_l;
  params[1] = block1392;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1409 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1391);
// compiled call node returning call1409 (depth = 2)
// Begin line 945
  setline(945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_push1410(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "push");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method push");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for push (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for push");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 948
  setline(948);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1411 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1413 = alloc_Float64(1);
// compiled num node returning num1413 (depth = 4)
  int op_slot_right_1412 = gc_frame_newslot(num1413);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1415 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1416 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1415);
// compiled call node returning call1416 (depth = 5)
// compiled member node returning call1416 (depth = 4)
  int op_slot_left_1412 = gc_frame_newslot(call1416);
  params[0] = num1413;
  partcv[0] = 1;
  Object sum1417 = callmethod(call1416, "+", 1, partcv, params);
// compiled op node returning sum1417 (depth = 3)
  gc_frame_newslot(sum1417);
// call case 4: self request
  params[0] = sum1417;
  partcv[0] = 1;
  Object call1418 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1411);
// compiled call node returning call1418 (depth = 2)
// Begin line 949
  setline(949);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1421 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1422 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1423 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1422);
// compiled call node returning call1423 (depth = 7)
// compiled member node returning call1423 (depth = 6)
  partcv[0] = 0;
  Object call1424 = callmethod(call1423, "size",
    1, partcv, params);
  gc_frame_end(callframe1421);
// compiled call node returning call1424 (depth = 5)
// compiled member node returning call1424 (depth = 4)
  int op_slot_right_1420 = gc_frame_newslot(call1424);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1426 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1427 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1426);
// compiled call node returning call1427 (depth = 5)
// compiled member node returning call1427 (depth = 4)
  int op_slot_left_1420 = gc_frame_newslot(call1427);
  params[0] = call1424;
  partcv[0] = 1;
  Object opresult1428 = callmethod(call1427, "==", 1, partcv, params);
// compiled op node returning opresult1428 (depth = 3)
  Object if1419 = done;
  if (istrue(opresult1428)) {
// starting to compile call node (depth = 3)
  int callframe1429 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1431 = alloc_Float64(2);
// compiled num node returning num1431 (depth = 5)
  int op_slot_right_1430 = gc_frame_newslot(num1431);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1433 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1434 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1435 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1434);
// compiled call node returning call1435 (depth = 8)
// compiled member node returning call1435 (depth = 7)
  partcv[0] = 0;
  Object call1436 = callmethod(call1435, "size",
    1, partcv, params);
  gc_frame_end(callframe1433);
// compiled call node returning call1436 (depth = 6)
// compiled member node returning call1436 (depth = 5)
  int op_slot_left_1430 = gc_frame_newslot(call1436);
  params[0] = num1431;
  partcv[0] = 1;
  Object prod1437 = callmethod(call1436, "*", 1, partcv, params);
// compiled op node returning prod1437 (depth = 4)
  gc_frame_newslot(prod1437);
// call case 4: self request
  params[0] = prod1437;
  partcv[0] = 1;
  Object call1438 = callmethodflags(self, "expandTo", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1429);
// compiled call node returning call1438 (depth = 3)
    gc_frame_newslot(call1438);
    if1419 = call1438;
  } else {
  }
// compiled if node returning if1419 (depth = 2)
// Begin line 950
  setline(950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1439 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1440 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1441 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1440);
// compiled call node returning call1441 (depth = 4)
// compiled member node returning call1441 (depth = 3)
  gc_frame_newslot(call1441);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_x (depth = 3)
  gc_frame_newslot(*var_x);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1442 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1443 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1442);
// compiled call node returning call1443 (depth = 4)
// compiled member node returning call1443 (depth = 3)
  params[0] = call1441;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1444 = callmethod(call1443, "at()put",
    2, partcv, params);
  gc_frame_end(callframe1439);
// compiled call node returning call1444 (depth = 2)
// Begin line 951
  setline(951);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1445 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1447 = alloc_Float64(1);
// compiled num node returning num1447 (depth = 4)
  int op_slot_right_1446 = gc_frame_newslot(num1447);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1449 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1450 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1449);
// compiled call node returning call1450 (depth = 5)
// compiled member node returning call1450 (depth = 4)
  int op_slot_left_1446 = gc_frame_newslot(call1450);
  params[0] = num1447;
  partcv[0] = 1;
  Object sum1451 = callmethod(call1450, "+", 1, partcv, params);
// compiled op node returning sum1451 (depth = 3)
  gc_frame_newslot(sum1451);
// call case 4: self request
  params[0] = sum1451;
  partcv[0] = 1;
  Object call1452 = callmethodflags(self, "size:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1445);
// compiled call node returning call1452 (depth = 2)
// Begin line 952
  setline(952);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_addLast1453(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addLast");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addLast");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addLast (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for addLast");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 954
  setline(954);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1454 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_x (depth = 3)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call1455 = callmethodflags(self, "push", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1454);
// compiled call node returning call1455 (depth = 2)
  gc_frame_end(frame);
  return call1455;
}
Object meth_collectionsPrelude_removeLast1456(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeLast");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeLast (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for removeLast");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 956
  setline(956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1457 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1459 = alloc_Float64(1);
// compiled num node returning num1459 (depth = 4)
  int op_slot_right_1458 = gc_frame_newslot(num1459);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1461 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1462 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1461);
// compiled call node returning call1462 (depth = 5)
// compiled member node returning call1462 (depth = 4)
  int op_slot_left_1458 = gc_frame_newslot(call1462);
  params[0] = num1459;
  partcv[0] = 1;
  Object sum1463 = callmethod(call1462, "+", 1, partcv, params);
// compiled op node returning sum1463 (depth = 3)
  gc_frame_newslot(sum1463);
// call case 4: self request
  params[0] = sum1463;
  partcv[0] = 1;
  Object call1464 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1457);
// compiled call node returning call1464 (depth = 2)
// Begin line 957
  setline(957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1465 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1467 = alloc_Float64(1);
// compiled num node returning num1467 (depth = 5)
  int op_slot_right_1466 = gc_frame_newslot(num1467);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1469 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1470 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1469);
// compiled call node returning call1470 (depth = 6)
// compiled member node returning call1470 (depth = 5)
  int op_slot_left_1466 = gc_frame_newslot(call1470);
  params[0] = num1467;
  partcv[0] = 1;
  Object diff1471 = callmethod(call1470, "-", 1, partcv, params);
// compiled op node returning diff1471 (depth = 4)
  gc_frame_newslot(diff1471);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1472 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1473 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1472);
// compiled call node returning call1473 (depth = 5)
// compiled member node returning call1473 (depth = 4)
  params[0] = diff1471;
  partcv[0] = 1;
  Object call1474 = callmethod(call1473, "at",
    1, partcv, params);
  gc_frame_end(callframe1465);
// compiled call node returning call1474 (depth = 3)
  *var_result = call1474;
  if (call1474 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 958
  setline(958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1475 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1477 = alloc_Float64(1);
// compiled num node returning num1477 (depth = 4)
  int op_slot_right_1476 = gc_frame_newslot(num1477);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1479 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1480 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1479);
// compiled call node returning call1480 (depth = 5)
// compiled member node returning call1480 (depth = 4)
  int op_slot_left_1476 = gc_frame_newslot(call1480);
  params[0] = num1477;
  partcv[0] = 1;
  Object diff1481 = callmethod(call1480, "-", 1, partcv, params);
// compiled op node returning diff1481 (depth = 3)
  gc_frame_newslot(diff1481);
// call case 4: self request
  params[0] = diff1481;
  partcv[0] = 1;
  Object call1482 = callmethodflags(self, "size:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1475);
// compiled call node returning call1482 (depth = 2)
// Begin line 959
  setline(959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude__apply1543(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_increase = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 968
  setline(968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1544 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_increase (depth = 6)
  int op_slot_right_1545 = gc_frame_newslot(*var_increase);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1545 = gc_frame_newslot(*var_i);
  params[0] = *var_increase;
  partcv[0] = 1;
  Object sum1547 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum1547 (depth = 5)
  gc_frame_newslot(sum1547);
// starting to compile call node (depth = 5)
  int callframe1548 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1549 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1550 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1549);
// compiled call node returning call1550 (depth = 7)
// compiled member node returning call1550 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1551 = callmethod(call1550, "at",
    1, partcv, params);
  gc_frame_end(callframe1548);
// compiled call node returning call1551 (depth = 5)
  gc_frame_newslot(call1551);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1552 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1553 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1552);
// compiled call node returning call1553 (depth = 6)
// compiled member node returning call1553 (depth = 5)
  params[0] = sum1547;
  params[1] = call1551;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1554 = callmethod(call1553, "at()put",
    2, partcv, params);
  gc_frame_end(callframe1544);
// compiled call node returning call1554 (depth = 4)
  gc_frame_end(frame);
  return call1554;
}
Object meth_collectionsPrelude__apply1560(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_insertionIndex = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 972
  setline(972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1561 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_insertionIndex (depth = 5)
  gc_frame_newslot(*var_insertionIndex);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1562 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1563 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1562);
// compiled call node returning call1563 (depth = 6)
// compiled member node returning call1563 (depth = 5)
  params[0] = *var_insertionIndex;
  params[1] = *var_each;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1564 = callmethod(call1563, "at()put",
    2, partcv, params);
  gc_frame_end(callframe1561);
// compiled call node returning call1564 (depth = 4)
// Begin line 973
  setline(973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1566 = alloc_Float64(1);
// compiled num node returning num1566 (depth = 6)
  int op_slot_right_1565 = gc_frame_newslot(num1566);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_insertionIndex (depth = 6)
  int op_slot_left_1565 = gc_frame_newslot(*var_insertionIndex);
  params[0] = num1566;
  partcv[0] = 1;
  Object sum1568 = callmethod(*var_insertionIndex, "+", 1, partcv, params);
// compiled op node returning sum1568 (depth = 5)
  *var_insertionIndex = sum1568;
  if (sum1568 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_addAllFirst1483(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAllFirst");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAllFirst");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addAllFirst (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for addAllFirst");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_increase = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "increase");
  Object *var_insertionIndex = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "insertionIndex");
// Begin line 962
  setline(962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1484 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1486 = alloc_Float64(1);
// compiled num node returning num1486 (depth = 4)
  int op_slot_right_1485 = gc_frame_newslot(num1486);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1488 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1489 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1488);
// compiled call node returning call1489 (depth = 5)
// compiled member node returning call1489 (depth = 4)
  int op_slot_left_1485 = gc_frame_newslot(call1489);
  params[0] = num1486;
  partcv[0] = 1;
  Object sum1490 = callmethod(call1489, "+", 1, partcv, params);
// compiled op node returning sum1490 (depth = 3)
  gc_frame_newslot(sum1490);
// call case 4: self request
  params[0] = sum1490;
  partcv[0] = 1;
  Object call1491 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1484);
// compiled call node returning call1491 (depth = 2)
// Begin line 963
  setline(963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1492 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_l (depth = 5)
  partcv[0] = 0;
  Object call1493 = callmethod(*var_l, "size",
    1, partcv, params);
  gc_frame_end(callframe1492);
// compiled call node returning call1493 (depth = 4)
// compiled member node returning call1493 (depth = 3)
  *var_increase = call1493;
  if (call1493 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 964
  setline(964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1496 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1497 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1498 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1497);
// compiled call node returning call1498 (depth = 7)
// compiled member node returning call1498 (depth = 6)
  partcv[0] = 0;
  Object call1499 = callmethod(call1498, "size",
    1, partcv, params);
  gc_frame_end(callframe1496);
// compiled call node returning call1499 (depth = 5)
// compiled member node returning call1499 (depth = 4)
  int op_slot_right_1495 = gc_frame_newslot(call1499);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_increase (depth = 5)
  int op_slot_right_1501 = gc_frame_newslot(*var_increase);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1503 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1504 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1503);
// compiled call node returning call1504 (depth = 6)
// compiled member node returning call1504 (depth = 5)
  int op_slot_left_1501 = gc_frame_newslot(call1504);
  params[0] = *var_increase;
  partcv[0] = 1;
  Object sum1505 = callmethod(call1504, "+", 1, partcv, params);
// compiled op node returning sum1505 (depth = 4)
  int op_slot_left_1495 = gc_frame_newslot(sum1505);
  params[0] = call1499;
  partcv[0] = 1;
  Object opresult1506 = callmethod(sum1505, ">", 1, partcv, params);
// compiled op node returning opresult1506 (depth = 3)
  Object if1494 = done;
  if (istrue(opresult1506)) {
// Begin line 965
  setline(965);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1507 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe1508 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_increase (depth = 6)
  int op_slot_right_1509 = gc_frame_newslot(*var_increase);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1511 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1512 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1511);
// compiled call node returning call1512 (depth = 7)
// compiled member node returning call1512 (depth = 6)
  int op_slot_left_1509 = gc_frame_newslot(call1512);
  params[0] = *var_increase;
  partcv[0] = 1;
  Object sum1513 = callmethod(call1512, "+", 1, partcv, params);
// compiled op node returning sum1513 (depth = 5)
  gc_frame_newslot(sum1513);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1515 = alloc_Float64(2);
// compiled num node returning num1515 (depth = 6)
  int op_slot_right_1514 = gc_frame_newslot(num1515);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1517 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1518 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1517);
// compiled call node returning call1518 (depth = 7)
// compiled member node returning call1518 (depth = 6)
  int op_slot_left_1514 = gc_frame_newslot(call1518);
  params[0] = num1515;
  partcv[0] = 1;
  Object prod1519 = callmethod(call1518, "*", 1, partcv, params);
// compiled op node returning prod1519 (depth = 5)
  gc_frame_newslot(prod1519);
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1520 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1521 = gc_frame_new();
// call case 3: self.outer request
  Object call1522 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1521);
// compiled call node returning call1522 (depth = 8)
// compiled member node returning call1522 (depth = 7)
  partcv[0] = 0;
  Object call1523 = callmethodflags(call1522, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1520);
// compiled call node returning call1523 (depth = 6)
// compiled member node returning call1523 (depth = 5)
  params[0] = sum1513;
  params[1] = prod1519;
  partcv[0] = 2;
  Object call1524 = callmethodflags(call1523, "max", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1508);
// compiled call node returning call1524 (depth = 4)
  gc_frame_newslot(call1524);
// call case 4: self request
  params[0] = call1524;
  partcv[0] = 1;
  Object call1525 = callmethodflags(self, "expandTo", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1507);
// compiled call node returning call1525 (depth = 3)
    gc_frame_newslot(call1525);
    if1494 = call1525;
  } else {
  }
// compiled if node returning if1494 (depth = 2)
// Begin line 967
  setline(967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1526 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe1527 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1529 = alloc_Float64(1);
// compiled num node returning num1529 (depth = 5)
  int op_slot_right_1528 = gc_frame_newslot(num1529);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1531 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1532 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1531);
// compiled call node returning call1532 (depth = 6)
// compiled member node returning call1532 (depth = 5)
  int op_slot_left_1528 = gc_frame_newslot(call1532);
  params[0] = num1529;
  partcv[0] = 1;
  Object diff1533 = callmethod(call1532, "-", 1, partcv, params);
// compiled op node returning diff1533 (depth = 4)
  gc_frame_newslot(diff1533);
// starting to compile num node (depth = 4)
  Object num1534 = alloc_Float64(0);
// compiled num node returning num1534 (depth = 4)
  gc_frame_newslot(num1534);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1535 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1536 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1537 = gc_frame_new();
// call case 3: self.outer request
  Object call1538 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1537);
// compiled call node returning call1538 (depth = 9)
// compiled member node returning call1538 (depth = 8)
  partcv[0] = 0;
  Object call1539 = callmethodflags(call1538, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1536);
// compiled call node returning call1539 (depth = 7)
// compiled member node returning call1539 (depth = 6)
  partcv[0] = 0;
  Object call1540 = callmethodflags(call1539, "range", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1535);
// compiled call node returning call1540 (depth = 5)
// compiled member node returning call1540 (depth = 4)
  params[0] = diff1533;
  params[1] = num1534;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1541 = callmethod(call1540, "from()downTo",
    2, partcv, params);
  gc_frame_end(callframe1527);
// compiled call node returning call1541 (depth = 3)
  gc_frame_newslot(call1541);
// starting to compile block node (depth = 3)
  Object block1542 = alloc_Block(NULL, NULL, "collectionsPrelude", 967);
  gc_frame_newslot(block1542);
// method "_apply"
  block_savedest(block1542);
  Object closure1543 = createclosure(2, "_apply");
  setclosureframe(closure1543, stackframe);
  addtoclosure(closure1543, var_increase);
  addtoclosure(closure1543, selfslot);
  struct UserObject *uo1543 = (struct UserObject*)block1542;
  uo1543->data[0] = (Object)closure1543;
  Method *meth_meth_collectionsPrelude__apply1543 = addmethod2pos(block1542, "_apply", &meth_collectionsPrelude__apply1543, 0);
  int argcv_meth_collectionsPrelude__apply1543[] = {1};
  meth_meth_collectionsPrelude__apply1543->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1543);
  meth_meth_collectionsPrelude__apply1543->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1543->definitionLine = 967;
// compiled block node returning block1542 (depth = 3)
  gc_frame_newslot(block1542);
// call case 5: prelude request
  params[0] = call1541;
  params[1] = block1542;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1556 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1526);
// compiled call node returning call1556 (depth = 2)
// Begin line 970
  setline(970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num1557 = alloc_Float64(0);
// compiled num node returning num1557 (depth = 3)
  *var_insertionIndex = num1557;
  if (num1557 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 971
  setline(971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1558 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  gc_frame_newslot(*var_l);
// starting to compile block node (depth = 3)
  Object block1559 = alloc_Block(NULL, NULL, "collectionsPrelude", 971);
  gc_frame_newslot(block1559);
// method "_apply"
  block_savedest(block1559);
  Object closure1560 = createclosure(2, "_apply");
  setclosureframe(closure1560, stackframe);
  addtoclosure(closure1560, var_insertionIndex);
  addtoclosure(closure1560, selfslot);
  struct UserObject *uo1560 = (struct UserObject*)block1559;
  uo1560->data[0] = (Object)closure1560;
  Method *meth_meth_collectionsPrelude__apply1560 = addmethod2pos(block1559, "_apply", &meth_collectionsPrelude__apply1560, 0);
  int argcv_meth_collectionsPrelude__apply1560[] = {1};
  meth_meth_collectionsPrelude__apply1560->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1560);
  meth_meth_collectionsPrelude__apply1560->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1560->definitionLine = 968;
// compiled block node returning block1559 (depth = 3)
  gc_frame_newslot(block1559);
// call case 5: prelude request
  params[0] = *var_l;
  params[1] = block1559;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1571 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1558);
// compiled call node returning call1571 (depth = 2)
// Begin line 975
  setline(975);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1572 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_increase (depth = 4)
  int op_slot_right_1573 = gc_frame_newslot(*var_increase);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1575 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1576 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1575);
// compiled call node returning call1576 (depth = 5)
// compiled member node returning call1576 (depth = 4)
  int op_slot_left_1573 = gc_frame_newslot(call1576);
  params[0] = *var_increase;
  partcv[0] = 1;
  Object sum1577 = callmethod(call1576, "+", 1, partcv, params);
// compiled op node returning sum1577 (depth = 3)
  gc_frame_newslot(sum1577);
// call case 4: self request
  params[0] = sum1577;
  partcv[0] = 1;
  Object call1578 = callmethodflags(self, "size:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1572);
// compiled call node returning call1578 (depth = 2)
// Begin line 976
  setline(976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply1627(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 984
  setline(984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1628 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1630 = alloc_Float64(1);
// compiled num node returning num1630 (depth = 6)
  int op_slot_right_1629 = gc_frame_newslot(num1630);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1629 = gc_frame_newslot(*var_i);
  params[0] = num1630;
  partcv[0] = 1;
  Object sum1632 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum1632 (depth = 5)
  gc_frame_newslot(sum1632);
// starting to compile call node (depth = 5)
  int callframe1633 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1634 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1635 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1634);
// compiled call node returning call1635 (depth = 7)
// compiled member node returning call1635 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1636 = callmethod(call1635, "at",
    1, partcv, params);
  gc_frame_end(callframe1633);
// compiled call node returning call1636 (depth = 5)
  gc_frame_newslot(call1636);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1637 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1638 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1637);
// compiled call node returning call1638 (depth = 6)
// compiled member node returning call1638 (depth = 5)
  params[0] = sum1632;
  params[1] = call1636;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1639 = callmethod(call1638, "at()put",
    2, partcv, params);
  gc_frame_end(callframe1628);
// compiled call node returning call1639 (depth = 4)
  gc_frame_end(frame);
  return call1639;
}
Object meth_collectionsPrelude_addFirst1579(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addFirst");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addFirst");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addFirst (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for addFirst");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 979
  setline(979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1580 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1582 = alloc_Float64(1);
// compiled num node returning num1582 (depth = 4)
  int op_slot_right_1581 = gc_frame_newslot(num1582);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1584 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1585 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1584);
// compiled call node returning call1585 (depth = 5)
// compiled member node returning call1585 (depth = 4)
  int op_slot_left_1581 = gc_frame_newslot(call1585);
  params[0] = num1582;
  partcv[0] = 1;
  Object sum1586 = callmethod(call1585, "+", 1, partcv, params);
// compiled op node returning sum1586 (depth = 3)
  gc_frame_newslot(sum1586);
// call case 4: self request
  params[0] = sum1586;
  partcv[0] = 1;
  Object call1587 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1580);
// compiled call node returning call1587 (depth = 2)
// Begin line 980
  setline(980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1590 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1591 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1592 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1591);
// compiled call node returning call1592 (depth = 7)
// compiled member node returning call1592 (depth = 6)
  partcv[0] = 0;
  Object call1593 = callmethod(call1592, "size",
    1, partcv, params);
  gc_frame_end(callframe1590);
// compiled call node returning call1593 (depth = 5)
// compiled member node returning call1593 (depth = 4)
  int op_slot_right_1589 = gc_frame_newslot(call1593);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1596 = alloc_Float64(1);
// compiled num node returning num1596 (depth = 5)
  int op_slot_right_1595 = gc_frame_newslot(num1596);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1598 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1599 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1598);
// compiled call node returning call1599 (depth = 6)
// compiled member node returning call1599 (depth = 5)
  int op_slot_left_1595 = gc_frame_newslot(call1599);
  params[0] = num1596;
  partcv[0] = 1;
  Object sum1600 = callmethod(call1599, "+", 1, partcv, params);
// compiled op node returning sum1600 (depth = 4)
  int op_slot_left_1589 = gc_frame_newslot(sum1600);
  params[0] = call1593;
  partcv[0] = 1;
  Object opresult1601 = callmethod(sum1600, ">", 1, partcv, params);
// compiled op node returning opresult1601 (depth = 3)
  Object if1588 = done;
  if (istrue(opresult1601)) {
// Begin line 981
  setline(981);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1602 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1604 = alloc_Float64(2);
// compiled num node returning num1604 (depth = 5)
  int op_slot_right_1603 = gc_frame_newslot(num1604);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1606 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1607 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1606);
// compiled call node returning call1607 (depth = 6)
// compiled member node returning call1607 (depth = 5)
  int op_slot_left_1603 = gc_frame_newslot(call1607);
  params[0] = num1604;
  partcv[0] = 1;
  Object prod1608 = callmethod(call1607, "*", 1, partcv, params);
// compiled op node returning prod1608 (depth = 4)
  gc_frame_newslot(prod1608);
// call case 4: self request
  params[0] = prod1608;
  partcv[0] = 1;
  Object call1609 = callmethodflags(self, "expandTo", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1602);
// compiled call node returning call1609 (depth = 3)
    gc_frame_newslot(call1609);
    if1588 = call1609;
  } else {
  }
// compiled if node returning if1588 (depth = 2)
// Begin line 983
  setline(983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1610 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe1611 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1613 = alloc_Float64(1);
// compiled num node returning num1613 (depth = 5)
  int op_slot_right_1612 = gc_frame_newslot(num1613);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1615 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1616 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1615);
// compiled call node returning call1616 (depth = 6)
// compiled member node returning call1616 (depth = 5)
  int op_slot_left_1612 = gc_frame_newslot(call1616);
  params[0] = num1613;
  partcv[0] = 1;
  Object diff1617 = callmethod(call1616, "-", 1, partcv, params);
// compiled op node returning diff1617 (depth = 4)
  gc_frame_newslot(diff1617);
// starting to compile num node (depth = 4)
  Object num1618 = alloc_Float64(0);
// compiled num node returning num1618 (depth = 4)
  gc_frame_newslot(num1618);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1619 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1620 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1621 = gc_frame_new();
// call case 3: self.outer request
  Object call1622 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1621);
// compiled call node returning call1622 (depth = 9)
// compiled member node returning call1622 (depth = 8)
  partcv[0] = 0;
  Object call1623 = callmethodflags(call1622, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1620);
// compiled call node returning call1623 (depth = 7)
// compiled member node returning call1623 (depth = 6)
  partcv[0] = 0;
  Object call1624 = callmethodflags(call1623, "range", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1619);
// compiled call node returning call1624 (depth = 5)
// compiled member node returning call1624 (depth = 4)
  params[0] = diff1617;
  params[1] = num1618;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1625 = callmethod(call1624, "from()downTo",
    2, partcv, params);
  gc_frame_end(callframe1611);
// compiled call node returning call1625 (depth = 3)
  gc_frame_newslot(call1625);
// starting to compile block node (depth = 3)
  Object block1626 = alloc_Block(NULL, NULL, "collectionsPrelude", 983);
  gc_frame_newslot(block1626);
// method "_apply"
  block_savedest(block1626);
  Object closure1627 = createclosure(1, "_apply");
  setclosureframe(closure1627, stackframe);
  addtoclosure(closure1627, selfslot);
  struct UserObject *uo1627 = (struct UserObject*)block1626;
  uo1627->data[0] = (Object)closure1627;
  Method *meth_meth_collectionsPrelude__apply1627 = addmethod2pos(block1626, "_apply", &meth_collectionsPrelude__apply1627, 0);
  int argcv_meth_collectionsPrelude__apply1627[] = {1};
  meth_meth_collectionsPrelude__apply1627->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1627);
  meth_meth_collectionsPrelude__apply1627->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1627->definitionLine = 983;
// compiled block node returning block1626 (depth = 3)
  gc_frame_newslot(block1626);
// call case 5: prelude request
  params[0] = call1625;
  params[1] = block1626;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1641 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1610);
// compiled call node returning call1641 (depth = 2)
// Begin line 986
  setline(986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1642 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num1643 = alloc_Float64(0);
// compiled num node returning num1643 (depth = 3)
  gc_frame_newslot(num1643);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elt (depth = 3)
  gc_frame_newslot(*var_elt);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1644 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1645 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1644);
// compiled call node returning call1645 (depth = 4)
// compiled member node returning call1645 (depth = 3)
  params[0] = num1643;
  params[1] = *var_elt;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1646 = callmethod(call1645, "at()put",
    2, partcv, params);
  gc_frame_end(callframe1642);
// compiled call node returning call1646 (depth = 2)
// Begin line 987
  setline(987);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1647 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1649 = alloc_Float64(1);
// compiled num node returning num1649 (depth = 4)
  int op_slot_right_1648 = gc_frame_newslot(num1649);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1651 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1652 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1651);
// compiled call node returning call1652 (depth = 5)
// compiled member node returning call1652 (depth = 4)
  int op_slot_left_1648 = gc_frame_newslot(call1652);
  params[0] = num1649;
  partcv[0] = 1;
  Object sum1653 = callmethod(call1652, "+", 1, partcv, params);
// compiled op node returning sum1653 (depth = 3)
  gc_frame_newslot(sum1653);
// call case 4: self request
  params[0] = sum1653;
  partcv[0] = 1;
  Object call1654 = callmethodflags(self, "size:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1647);
// compiled call node returning call1654 (depth = 2)
// Begin line 988
  setline(988);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_removeFirst1655(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeFirst");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeFirst (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for removeFirst");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 991
  setline(991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1656 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num1657 = alloc_Float64(1);
// compiled num node returning num1657 (depth = 3)
  gc_frame_newslot(num1657);
// call case 4: self request
  params[0] = num1657;
  partcv[0] = 1;
  Object call1658 = callmethodflags(self, "removeAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1656);
// compiled call node returning call1658 (depth = 2)
  gc_frame_end(frame);
  return call1658;
}
Object meth_collectionsPrelude__apply1689(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 998
  setline(998);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1690 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1692 = alloc_Float64(1);
// compiled num node returning num1692 (depth = 6)
  int op_slot_right_1691 = gc_frame_newslot(num1692);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1691 = gc_frame_newslot(*var_i);
  params[0] = num1692;
  partcv[0] = 1;
  Object diff1694 = callmethod(*var_i, "-", 1, partcv, params);
// compiled op node returning diff1694 (depth = 5)
  gc_frame_newslot(diff1694);
// starting to compile call node (depth = 5)
  int callframe1695 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1696 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1697 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1696);
// compiled call node returning call1697 (depth = 7)
// compiled member node returning call1697 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1698 = callmethod(call1697, "at",
    1, partcv, params);
  gc_frame_end(callframe1695);
// compiled call node returning call1698 (depth = 5)
  gc_frame_newslot(call1698);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1699 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1700 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1699);
// compiled call node returning call1700 (depth = 6)
// compiled member node returning call1700 (depth = 5)
  params[0] = diff1694;
  params[1] = call1698;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1701 = callmethod(call1700, "at()put",
    2, partcv, params);
  gc_frame_end(callframe1690);
// compiled call node returning call1701 (depth = 4)
  gc_frame_end(frame);
  return call1701;
}
Object meth_collectionsPrelude_removeAt1659(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeAt");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAt");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeAt (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for removeAt");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_removed = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "removed");
// Begin line 994
  setline(994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1660 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1662 = alloc_Float64(1);
// compiled num node returning num1662 (depth = 4)
  int op_slot_right_1661 = gc_frame_newslot(num1662);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1664 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1665 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1664);
// compiled call node returning call1665 (depth = 5)
// compiled member node returning call1665 (depth = 4)
  int op_slot_left_1661 = gc_frame_newslot(call1665);
  params[0] = num1662;
  partcv[0] = 1;
  Object sum1666 = callmethod(call1665, "+", 1, partcv, params);
// compiled op node returning sum1666 (depth = 3)
  gc_frame_newslot(sum1666);
// call case 4: self request
  params[0] = sum1666;
  partcv[0] = 1;
  Object call1667 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1660);
// compiled call node returning call1667 (depth = 2)
// Begin line 995
  setline(995);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1668 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_n (depth = 3)
  gc_frame_newslot(*var_n);
// call case 4: self request
  params[0] = *var_n;
  partcv[0] = 1;
  Object call1669 = callmethodflags(self, "boundsCheck", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1668);
// compiled call node returning call1669 (depth = 2)
// Begin line 996
  setline(996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1670 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1672 = alloc_Float64(1);
// compiled num node returning num1672 (depth = 5)
  int op_slot_right_1671 = gc_frame_newslot(num1672);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  int op_slot_left_1671 = gc_frame_newslot(*var_n);
  params[0] = num1672;
  partcv[0] = 1;
  Object diff1674 = callmethod(*var_n, "-", 1, partcv, params);
// compiled op node returning diff1674 (depth = 4)
  gc_frame_newslot(diff1674);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1675 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1676 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1675);
// compiled call node returning call1676 (depth = 5)
// compiled member node returning call1676 (depth = 4)
  params[0] = diff1674;
  partcv[0] = 1;
  Object call1677 = callmethod(call1676, "at",
    1, partcv, params);
  gc_frame_end(callframe1670);
// compiled call node returning call1677 (depth = 3)
  *var_removed = call1677;
  if (call1677 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 997
  setline(997);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1678 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1681 = alloc_Float64(1);
// compiled num node returning num1681 (depth = 5)
  int op_slot_right_1680 = gc_frame_newslot(num1681);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1683 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1684 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1683);
// compiled call node returning call1684 (depth = 6)
// compiled member node returning call1684 (depth = 5)
  int op_slot_left_1680 = gc_frame_newslot(call1684);
  params[0] = num1681;
  partcv[0] = 1;
  Object diff1685 = callmethod(call1684, "-", 1, partcv, params);
// compiled op node returning diff1685 (depth = 4)
  int op_slot_right_1679 = gc_frame_newslot(diff1685);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  int op_slot_left_1679 = gc_frame_newslot(*var_n);
  params[0] = diff1685;
  partcv[0] = 1;
  Object opresult1687 = callmethod(*var_n, "..", 1, partcv, params);
// compiled op node returning opresult1687 (depth = 3)
  gc_frame_newslot(opresult1687);
// starting to compile block node (depth = 3)
  Object block1688 = alloc_Block(NULL, NULL, "collectionsPrelude", 997);
  gc_frame_newslot(block1688);
// method "_apply"
  block_savedest(block1688);
  Object closure1689 = createclosure(1, "_apply");
  setclosureframe(closure1689, stackframe);
  addtoclosure(closure1689, selfslot);
  struct UserObject *uo1689 = (struct UserObject*)block1688;
  uo1689->data[0] = (Object)closure1689;
  Method *meth_meth_collectionsPrelude__apply1689 = addmethod2pos(block1688, "_apply", &meth_collectionsPrelude__apply1689, 0);
  int argcv_meth_collectionsPrelude__apply1689[] = {1};
  meth_meth_collectionsPrelude__apply1689->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1689);
  meth_meth_collectionsPrelude__apply1689->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1689->definitionLine = 997;
// compiled block node returning block1688 (depth = 3)
  gc_frame_newslot(block1688);
// call case 5: prelude request
  params[0] = opresult1687;
  params[1] = block1688;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1703 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1678);
// compiled call node returning call1703 (depth = 2)
// Begin line 1000
  setline(1000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1704 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1706 = alloc_Float64(1);
// compiled num node returning num1706 (depth = 4)
  int op_slot_right_1705 = gc_frame_newslot(num1706);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1708 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1709 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1708);
// compiled call node returning call1709 (depth = 5)
// compiled member node returning call1709 (depth = 4)
  int op_slot_left_1705 = gc_frame_newslot(call1709);
  params[0] = num1706;
  partcv[0] = 1;
  Object diff1710 = callmethod(call1709, "-", 1, partcv, params);
// compiled op node returning diff1710 (depth = 3)
  gc_frame_newslot(diff1710);
// call case 4: self request
  params[0] = diff1710;
  partcv[0] = 1;
  Object call1711 = callmethodflags(self, "size:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1704);
// compiled call node returning call1711 (depth = 2)
// Begin line 1001
  setline(1001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_removed (depth = 3)
  return *var_removed;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply1715(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_elt = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1006
  setline(1006);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1716 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1718 == NULL) {
    strlit1718 = alloc_String("");
    gc_root(strlit1718);
  }
// compiled string node returning strlit1718 (depth = 7)
  int op_slot_right_1717 = gc_frame_newslot(strlit1718);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_elt (depth = 8)
  int op_slot_right_1720 = gc_frame_newslot(*var_elt);
// starting to compile string node (depth = 8)
  if (strlit1722 == NULL) {
    strlit1722 = alloc_String("list does not contain ");
    gc_root(strlit1722);
  }
// compiled string node returning strlit1722 (depth = 8)
  int op_slot_left_1720 = gc_frame_newslot(strlit1722);
  params[0] = *var_elt;
  partcv[0] = 1;
  Object opresult1723 = callmethod(strlit1722, "++", 1, partcv, params);
// compiled op node returning opresult1723 (depth = 7)
  int op_slot_left_1717 = gc_frame_newslot(opresult1723);
  params[0] = strlit1718;
  partcv[0] = 1;
  Object opresult1724 = callmethod(opresult1723, "++", 1, partcv, params);
// compiled op node returning opresult1724 (depth = 6)
  gc_frame_newslot(opresult1724);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_NoSuchObject (depth = 6)
  params[0] = opresult1724;
  partcv[0] = 1;
  Object call1725 = callmethod(*var_NoSuchObject, "raise",
    1, partcv, params);
  gc_frame_end(callframe1716);
// compiled call node returning call1725 (depth = 5)
  gc_frame_end(frame);
  return call1725;
}
Object meth_collectionsPrelude_remove1712(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "remove");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for remove (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for remove");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
// Begin line 1005
  setline(1005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1713 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elt (depth = 4)
  gc_frame_newslot(*var_elt);
// starting to compile block node (depth = 4)
  Object block1714 = alloc_Block(NULL, NULL, "collectionsPrelude", 1005);
  gc_frame_newslot(block1714);
// method "_apply"
  block_savedest(block1714);
  Object closure1715 = createclosure(3, "_apply");
  setclosureframe(closure1715, stackframe);
  addtoclosure(closure1715, var_elt);
  addtoclosure(closure1715, var_NoSuchObject);
  addtoclosure(closure1715, selfslot);
  struct UserObject *uo1715 = (struct UserObject*)block1714;
  uo1715->data[0] = (Object)closure1715;
  Method *meth_meth_collectionsPrelude__apply1715 = addmethod2pos(block1714, "_apply", &meth_collectionsPrelude__apply1715, 0);
  int argcv_meth_collectionsPrelude__apply1715[] = {0};
  meth_meth_collectionsPrelude__apply1715->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1715);
  meth_meth_collectionsPrelude__apply1715->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1715->definitionLine = 1000;
// compiled block node returning block1714 (depth = 4)
  gc_frame_newslot(block1714);
// call case 4: self request
  params[0] = *var_elt;
  params[1] = block1714;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1727 = callmethodflags(self, "indexOf()ifAbsent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1713);
// compiled call node returning call1727 (depth = 3)
  *var_ix = call1727;
  if (call1727 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1008
  setline(1008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1728 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ix (depth = 3)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call1729 = callmethodflags(self, "removeAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1728);
// compiled call node returning call1729 (depth = 2)
// Begin line 1009
  setline(1009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply1733(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1014
  setline(1014);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1734 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_action (depth = 7)
  partcv[0] = 0;
  Object call1735 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe1734);
// compiled call node returning call1735 (depth = 6)
// compiled member node returning call1735 (depth = 5)
// Begin line 1015
  setline(1015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning self (depth = 6)
  block_return(realself, self);
// compiled return node returning undefined (depth = 5)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_remove_40__41_ifAbsent1730(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "remove()ifAbsent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove()ifAbsent");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove()ifAbsent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for remove()ifAbsent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for remove");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ifAbsent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "ix");
// Begin line 1013
  setline(1013);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1731 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elt (depth = 4)
  gc_frame_newslot(*var_elt);
// starting to compile block node (depth = 4)
  Object block1732 = alloc_Block(NULL, NULL, "collectionsPrelude", 1013);
  gc_frame_newslot(block1732);
// method "_apply"
  block_savedest(block1732);
  Object closure1733 = createclosure(2, "_apply");
  setclosureframe(closure1733, stackframe);
  addtoclosure(closure1733, var_action);
  addtoclosure(closure1733, selfslot);
  struct UserObject *uo1733 = (struct UserObject*)block1732;
  uo1733->data[0] = (Object)closure1733;
  Method *meth_meth_collectionsPrelude__apply1733 = addmethod2pos(block1732, "_apply", &meth_collectionsPrelude__apply1733, 0);
  int argcv_meth_collectionsPrelude__apply1733[] = {0};
  meth_meth_collectionsPrelude__apply1733->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1733);
  meth_meth_collectionsPrelude__apply1733->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1733->definitionLine = 1000;
// compiled block node returning block1732 (depth = 4)
  gc_frame_newslot(block1732);
// call case 4: self request
  params[0] = *var_elt;
  params[1] = block1732;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1737 = callmethodflags(self, "indexOf()ifAbsent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1731);
// compiled call node returning call1737 (depth = 3)
  *var_ix = call1737;
  if (call1737 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1017
  setline(1017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1738 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ix (depth = 3)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call1739 = callmethodflags(self, "removeAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1738);
// compiled call node returning call1739 (depth = 2)
// Begin line 1018
  setline(1018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply1743(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe1744 = gc_frame_new();
// starting to compile string node (depth = 5)
  if (strlit1745 == NULL) {
    strlit1745 = alloc_String("list does not contain object");
    gc_root(strlit1745);
  }
// compiled string node returning strlit1745 (depth = 5)
  gc_frame_newslot(strlit1745);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_NoSuchObject (depth = 5)
  params[0] = strlit1745;
  partcv[0] = 1;
  Object call1746 = callmethod(*var_NoSuchObject, "raise",
    1, partcv, params);
  gc_frame_end(callframe1744);
// compiled call node returning call1746 (depth = 4)
  gc_frame_end(frame);
  return call1746;
}
Object meth_collectionsPrelude_removeAll1740(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAll");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeAll (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_vs = &(stackframe->slots[0]);
  *var_vs = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for removeAll");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1022
  setline(1022);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1741 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_vs (depth = 3)
  gc_frame_newslot(*var_vs);
// starting to compile block node (depth = 3)
  Object block1742 = alloc_Block(NULL, NULL, "collectionsPrelude", 1022);
  gc_frame_newslot(block1742);
// method "_apply"
  block_savedest(block1742);
  Object closure1743 = createclosure(2, "_apply");
  setclosureframe(closure1743, stackframe);
  addtoclosure(closure1743, var_NoSuchObject);
  addtoclosure(closure1743, selfslot);
  struct UserObject *uo1743 = (struct UserObject*)block1742;
  uo1743->data[0] = (Object)closure1743;
  Method *meth_meth_collectionsPrelude__apply1743 = addmethod2pos(block1742, "_apply", &meth_collectionsPrelude__apply1743, 0);
  int argcv_meth_collectionsPrelude__apply1743[] = {0};
  meth_meth_collectionsPrelude__apply1743->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1743);
  meth_meth_collectionsPrelude__apply1743->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1743->definitionLine = 1014;
// compiled block node returning block1742 (depth = 3)
  gc_frame_newslot(block1742);
// call case 4: self request
  params[0] = *var_vs;
  params[1] = block1742;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1748 = callmethodflags(self, "removeAll()ifAbsent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1741);
// compiled call node returning call1748 (depth = 2)
// Begin line 1023
  setline(1023);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply1755(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile num node (depth = 7)
  Object num1756 = alloc_Float64(0);
// compiled num node returning num1756 (depth = 7)
  gc_frame_end(frame);
  return num1756;
}
Object meth_collectionsPrelude__apply1752(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_action = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
// Begin line 1027
  setline(1027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1753 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  gc_frame_newslot(*var_each);
// starting to compile block node (depth = 6)
  Object block1754 = alloc_Block(NULL, NULL, "collectionsPrelude", 1027);
  gc_frame_newslot(block1754);
// method "_apply"
  block_savedest(block1754);
  Object closure1755 = createclosure(1, "_apply");
  setclosureframe(closure1755, stackframe);
  addtoclosure(closure1755, selfslot);
  struct UserObject *uo1755 = (struct UserObject*)block1754;
  uo1755->data[0] = (Object)closure1755;
  Method *meth_meth_collectionsPrelude__apply1755 = addmethod2pos(block1754, "_apply", &meth_collectionsPrelude__apply1755, 0);
  int argcv_meth_collectionsPrelude__apply1755[] = {0};
  meth_meth_collectionsPrelude__apply1755->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1755);
  meth_meth_collectionsPrelude__apply1755->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1755->definitionLine = 1014;
// compiled block node returning block1754 (depth = 6)
  gc_frame_newslot(block1754);
// call case 4: self request
  params[0] = *var_each;
  params[1] = block1754;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1758 = callmethodflags(self, "indexOf()ifAbsent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1753);
// compiled call node returning call1758 (depth = 5)
  *var_ix = call1758;
  if (call1758 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1028
  setline(1028);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1761 = alloc_Float64(0);
// compiled num node returning num1761 (depth = 6)
  int op_slot_right_1760 = gc_frame_newslot(num1761);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_left_1760 = gc_frame_newslot(*var_ix);
  params[0] = num1761;
  partcv[0] = 1;
  Object opresult1763 = callmethod(*var_ix, "≠", 1, partcv, params);
// compiled op node returning opresult1763 (depth = 5)
  Object if1759 = done;
  if (istrue(opresult1763)) {
// Begin line 1029
  setline(1029);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1764 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  gc_frame_newslot(*var_ix);
// call case 4: self request
  params[0] = *var_ix;
  partcv[0] = 1;
  Object call1765 = callmethodflags(self, "removeAt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1764);
// compiled call node returning call1765 (depth = 5)
    gc_frame_newslot(call1765);
    if1759 = call1765;
  } else {
// Begin line 1031
  setline(1031);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1766 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_action (depth = 7)
  partcv[0] = 0;
  Object call1767 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe1766);
// compiled call node returning call1767 (depth = 6)
// compiled member node returning call1767 (depth = 5)
    gc_frame_newslot(call1767);
    if1759 = call1767;
  }
// compiled if node returning if1759 (depth = 4)
  gc_frame_end(frame);
  return if1759;
}
Object meth_collectionsPrelude_removeAll_40__41_ifAbsent1749(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "removeAll()ifAbsent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll()ifAbsent");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll()ifAbsent");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for removeAll()ifAbsent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_vs = &(stackframe->slots[0]);
  *var_vs = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for removeAll");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ifAbsent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1026
  setline(1026);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1750 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_vs (depth = 3)
  gc_frame_newslot(*var_vs);
// starting to compile block node (depth = 3)
  Object block1751 = alloc_Block(NULL, NULL, "collectionsPrelude", 1026);
  gc_frame_newslot(block1751);
// method "_apply"
  block_savedest(block1751);
  Object closure1752 = createclosure(2, "_apply");
  setclosureframe(closure1752, stackframe);
  addtoclosure(closure1752, var_action);
  addtoclosure(closure1752, selfslot);
  struct UserObject *uo1752 = (struct UserObject*)block1751;
  uo1752->data[0] = (Object)closure1752;
  Method *meth_meth_collectionsPrelude__apply1752 = addmethod2pos(block1751, "_apply", &meth_collectionsPrelude__apply1752, 0);
  int argcv_meth_collectionsPrelude__apply1752[] = {1};
  meth_meth_collectionsPrelude__apply1752->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1752);
  meth_meth_collectionsPrelude__apply1752->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1752->definitionLine = 1014;
// compiled block node returning block1751 (depth = 3)
  gc_frame_newslot(block1751);
// call case 5: prelude request
  params[0] = *var_vs;
  params[1] = block1751;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1769 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1750);
// compiled call node returning call1769 (depth = 2)
// Begin line 1034
  setline(1034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_pop1770(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "pop");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for pop (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for pop");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1036
  setline(1036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1771 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1772 = callmethodflags(self, "removeLast", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1771);
// compiled call node returning call1772 (depth = 3)
// compiled member node returning call1772 (depth = 2)
  gc_frame_end(frame);
  return call1772;
}
Object meth_collectionsPrelude__apply1784(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe1785 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call1786 = callmethod(*var_result, "addFirst",
    1, partcv, params);
  gc_frame_end(callframe1785);
// compiled call node returning call1786 (depth = 4)
  gc_frame_end(frame);
  return call1786;
}
Object meth_collectionsPrelude_reversed1773(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for reversed (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for reversed");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 1038
  setline(1038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1774 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1775 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1776 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1777 = gc_frame_new();
// call case 3: self.outer request
  Object call1778 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1777);
// compiled call node returning call1778 (depth = 10)
// compiled member node returning call1778 (depth = 9)
  partcv[0] = 0;
  Object call1779 = callmethodflags(call1778, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1776);
// compiled call node returning call1779 (depth = 8)
// compiled member node returning call1779 (depth = 7)
  partcv[0] = 0;
  Object call1780 = callmethodflags(call1779, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1775);
// compiled call node returning call1780 (depth = 6)
// compiled member node returning call1780 (depth = 5)
  partcv[0] = 0;
  Object call1781 = callmethod(call1780, "empty",
    1, partcv, params);
  gc_frame_end(callframe1774);
// compiled call node returning call1781 (depth = 4)
// compiled member node returning call1781 (depth = 3)
  *var_result = call1781;
  if (call1781 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1039
  setline(1039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1782 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block1783 = alloc_Block(NULL, NULL, "collectionsPrelude", 1039);
  gc_frame_newslot(block1783);
// method "_apply"
  block_savedest(block1783);
  Object closure1784 = createclosure(2, "_apply");
  setclosureframe(closure1784, stackframe);
  addtoclosure(closure1784, var_result);
  addtoclosure(closure1784, selfslot);
  struct UserObject *uo1784 = (struct UserObject*)block1783;
  uo1784->data[0] = (Object)closure1784;
  Method *meth_meth_collectionsPrelude__apply1784 = addmethod2pos(block1783, "_apply", &meth_collectionsPrelude__apply1784, 0);
  int argcv_meth_collectionsPrelude__apply1784[] = {1};
  meth_meth_collectionsPrelude__apply1784->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1784);
  meth_meth_collectionsPrelude__apply1784->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1784->definitionLine = 1038;
// compiled block node returning block1783 (depth = 3)
  gc_frame_newslot(block1783);
// call case 4: self request
  params[0] = block1783;
  partcv[0] = 1;
  Object call1788 = callmethodflags(self, "do", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1782);
// compiled call node returning call1788 (depth = 2)
// Begin line 1040
  setline(1040);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude__apply1803(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_hiIx = getfromclosure(closure, 0);
  Object *var_loIx = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_hiIx (depth = 5)
  int op_slot_right_1804 = gc_frame_newslot(*var_hiIx);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_loIx (depth = 5)
  int op_slot_left_1804 = gc_frame_newslot(*var_loIx);
  params[0] = *var_hiIx;
  partcv[0] = 1;
  Object opresult1806 = callmethod(*var_loIx, "<", 1, partcv, params);
// compiled op node returning opresult1806 (depth = 4)
  gc_frame_end(frame);
  return opresult1806;
}
Object meth_collectionsPrelude__apply1809(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_hiIx = getfromclosure(closure, 0);
  Object *var_loIx = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_hiVal = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "hiVal");
// Begin line 1047
  setline(1047);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1810 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_hiIx (depth = 6)
  gc_frame_newslot(*var_hiIx);
// call case 4: self request
  params[0] = *var_hiIx;
  partcv[0] = 1;
  Object call1811 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1810);
// compiled call node returning call1811 (depth = 5)
  *var_hiVal = call1811;
  if (call1811 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1048
  setline(1048);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1812 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_hiIx (depth = 5)
  gc_frame_newslot(*var_hiIx);
// starting to compile call node (depth = 5)
  int callframe1813 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_loIx (depth = 6)
  gc_frame_newslot(*var_loIx);
// call case 4: self request
  params[0] = *var_loIx;
  partcv[0] = 1;
  Object call1814 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1813);
// compiled call node returning call1814 (depth = 5)
  gc_frame_newslot(call1814);
// call case 4: self request
  params[0] = *var_hiIx;
  params[1] = call1814;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1815 = callmethodflags(self, "at()put", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1812);
// compiled call node returning call1815 (depth = 4)
// Begin line 1049
  setline(1049);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1816 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_loIx (depth = 5)
  gc_frame_newslot(*var_loIx);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_hiVal (depth = 5)
  gc_frame_newslot(*var_hiVal);
// call case 4: self request
  params[0] = *var_loIx;
  params[1] = *var_hiVal;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1817 = callmethodflags(self, "at()put", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1816);
// compiled call node returning call1817 (depth = 4)
// Begin line 1050
  setline(1050);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1819 = alloc_Float64(1);
// compiled num node returning num1819 (depth = 6)
  int op_slot_right_1818 = gc_frame_newslot(num1819);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_hiIx (depth = 6)
  int op_slot_left_1818 = gc_frame_newslot(*var_hiIx);
  params[0] = num1819;
  partcv[0] = 1;
  Object diff1821 = callmethod(*var_hiIx, "-", 1, partcv, params);
// compiled op node returning diff1821 (depth = 5)
  *var_hiIx = diff1821;
  if (diff1821 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1051
  setline(1051);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1824 = alloc_Float64(1);
// compiled num node returning num1824 (depth = 6)
  int op_slot_right_1823 = gc_frame_newslot(num1824);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_loIx (depth = 6)
  int op_slot_left_1823 = gc_frame_newslot(*var_loIx);
  params[0] = num1824;
  partcv[0] = 1;
  Object sum1826 = callmethod(*var_loIx, "+", 1, partcv, params);
// compiled op node returning sum1826 (depth = 5)
  *var_loIx = sum1826;
  if (sum1826 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_reverse1789(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reverse");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for reverse (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for reverse");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_hiIx = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "hiIx");
  Object *var_loIx = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "loIx");
// Begin line 1043
  setline(1043);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1790 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num1792 = alloc_Float64(1);
// compiled num node returning num1792 (depth = 4)
  int op_slot_right_1791 = gc_frame_newslot(num1792);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1794 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1795 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1794);
// compiled call node returning call1795 (depth = 5)
// compiled member node returning call1795 (depth = 4)
  int op_slot_left_1791 = gc_frame_newslot(call1795);
  params[0] = num1792;
  partcv[0] = 1;
  Object sum1796 = callmethod(call1795, "+", 1, partcv, params);
// compiled op node returning sum1796 (depth = 3)
  gc_frame_newslot(sum1796);
// call case 4: self request
  params[0] = sum1796;
  partcv[0] = 1;
  Object call1797 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1790);
// compiled call node returning call1797 (depth = 2)
// Begin line 1044
  setline(1044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1798 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1799 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1798);
// compiled call node returning call1799 (depth = 4)
// compiled member node returning call1799 (depth = 3)
  *var_hiIx = call1799;
  if (call1799 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1045
  setline(1045);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num1800 = alloc_Float64(1);
// compiled num node returning num1800 (depth = 3)
  *var_loIx = num1800;
  if (num1800 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1046
  setline(1046);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1801 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block1802 = alloc_Block(NULL, NULL, "collectionsPrelude", 1046);
  gc_frame_newslot(block1802);
// method "_apply"
  block_savedest(block1802);
  Object closure1803 = createclosure(3, "_apply");
  setclosureframe(closure1803, stackframe);
  addtoclosure(closure1803, var_hiIx);
  addtoclosure(closure1803, var_loIx);
  addtoclosure(closure1803, selfslot);
  struct UserObject *uo1803 = (struct UserObject*)block1802;
  uo1803->data[0] = (Object)closure1803;
  Method *meth_meth_collectionsPrelude__apply1803 = addmethod2pos(block1802, "_apply", &meth_collectionsPrelude__apply1803, 0);
  int argcv_meth_collectionsPrelude__apply1803[] = {0};
  meth_meth_collectionsPrelude__apply1803->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1803);
  meth_meth_collectionsPrelude__apply1803->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1803->definitionLine = 1044;
// compiled block node returning block1802 (depth = 3)
  gc_frame_newslot(block1802);
// starting to compile block node (depth = 3)
  Object block1808 = alloc_Block(NULL, NULL, "collectionsPrelude", 1046);
  gc_frame_newslot(block1808);
// method "_apply"
  block_savedest(block1808);
  Object closure1809 = createclosure(3, "_apply");
  setclosureframe(closure1809, stackframe);
  addtoclosure(closure1809, var_hiIx);
  addtoclosure(closure1809, var_loIx);
  addtoclosure(closure1809, selfslot);
  struct UserObject *uo1809 = (struct UserObject*)block1808;
  uo1809->data[0] = (Object)closure1809;
  Method *meth_meth_collectionsPrelude__apply1809 = addmethod2pos(block1808, "_apply", &meth_collectionsPrelude__apply1809, 0);
  int argcv_meth_collectionsPrelude__apply1809[] = {0};
  meth_meth_collectionsPrelude__apply1809->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1809);
  meth_meth_collectionsPrelude__apply1809->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1809->definitionLine = 1044;
// compiled block node returning block1808 (depth = 3)
  gc_frame_newslot(block1808);
// call case 5: prelude request
  params[0] = block1802;
  params[1] = block1808;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1829 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1801);
// compiled call node returning call1829 (depth = 2)
// Begin line 1053
  setline(1053);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__43__43_1830(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++ (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ++");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_l = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "l");
// Begin line 1056
  setline(1056);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe1831 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1832 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1833 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1834 = gc_frame_new();
// call case 3: self.outer request
  Object call1835 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1834);
// compiled call node returning call1835 (depth = 9)
// compiled member node returning call1835 (depth = 8)
  partcv[0] = 0;
  Object call1836 = callmethodflags(call1835, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1833);
// compiled call node returning call1836 (depth = 7)
// compiled member node returning call1836 (depth = 6)
  partcv[0] = 0;
  Object call1837 = callmethodflags(call1836, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1832);
// compiled call node returning call1837 (depth = 5)
// compiled member node returning call1837 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call1838 = callmethod(call1837, "withAll",
    1, partcv, params);
  gc_frame_end(callframe1831);
// compiled call node returning call1838 (depth = 3)
  *var_l = call1838;
  if (call1838 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1057
  setline(1057);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1839 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_o (depth = 3)
  gc_frame_newslot(*var_o);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  params[0] = *var_o;
  partcv[0] = 1;
  Object call1840 = callmethod(*var_l, "addAll",
    1, partcv, params);
  gc_frame_end(callframe1839);
// compiled call node returning call1840 (depth = 2)
  gc_frame_end(frame);
  return call1840;
}
Object meth_collectionsPrelude__apply1855(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1062
  setline(1062);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1857 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe1858 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1859 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1860 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1859);
// compiled call node returning call1860 (depth = 10)
// compiled member node returning call1860 (depth = 9)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1861 = callmethod(call1860, "at",
    1, partcv, params);
  gc_frame_end(callframe1858);
// compiled call node returning call1861 (depth = 8)
  partcv[0] = 0;
  Object call1862 = callmethod(call1861, "asString",
    1, partcv, params);
  gc_frame_end(callframe1857);
// compiled call node returning call1862 (depth = 7)
// compiled member node returning call1862 (depth = 6)
  int op_slot_right_1856 = gc_frame_newslot(call1862);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1856 = gc_frame_newslot(*var_s);
  params[0] = call1862;
  partcv[0] = 1;
  Object opresult1864 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1864 (depth = 5)
  *var_s = opresult1864;
  if (opresult1864 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1063
  setline(1063);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1869 = alloc_Float64(1);
// compiled num node returning num1869 (depth = 7)
  int op_slot_right_1868 = gc_frame_newslot(num1869);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1871 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1872 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1871);
// compiled call node returning call1872 (depth = 8)
// compiled member node returning call1872 (depth = 7)
  int op_slot_left_1868 = gc_frame_newslot(call1872);
  params[0] = num1869;
  partcv[0] = 1;
  Object diff1873 = callmethod(call1872, "-", 1, partcv, params);
// compiled op node returning diff1873 (depth = 6)
  int op_slot_right_1867 = gc_frame_newslot(diff1873);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1867 = gc_frame_newslot(*var_i);
  params[0] = diff1873;
  partcv[0] = 1;
  Object opresult1875 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult1875 (depth = 5)
  Object if1866 = done;
  if (istrue(opresult1875)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1877 == NULL) {
    strlit1877 = alloc_String(", ");
    gc_root(strlit1877);
  }
// compiled string node returning strlit1877 (depth = 7)
  int op_slot_right_1876 = gc_frame_newslot(strlit1877);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1876 = gc_frame_newslot(*var_s);
  params[0] = strlit1877;
  partcv[0] = 1;
  Object opresult1879 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1879 (depth = 6)
  *var_s = opresult1879;
  if (opresult1879 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1866 = done;
  } else {
  }
// compiled if node returning if1866 (depth = 4)
  gc_frame_end(frame);
  return if1866;
}
Object meth_collectionsPrelude_asString1841(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 1060
  setline(1060);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1842 == NULL) {
    strlit1842 = alloc_String("[");
    gc_root(strlit1842);
  }
// compiled string node returning strlit1842 (depth = 3)
  *var_s = strlit1842;
  if (strlit1842 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1061
  setline(1061);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1843 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1846 = alloc_Float64(1);
// compiled num node returning num1846 (depth = 5)
  int op_slot_right_1845 = gc_frame_newslot(num1846);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1848 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1849 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1848);
// compiled call node returning call1849 (depth = 6)
// compiled member node returning call1849 (depth = 5)
  int op_slot_left_1845 = gc_frame_newslot(call1849);
  params[0] = num1846;
  partcv[0] = 1;
  Object diff1850 = callmethod(call1849, "-", 1, partcv, params);
// compiled op node returning diff1850 (depth = 4)
  int op_slot_right_1844 = gc_frame_newslot(diff1850);
// starting to compile num node (depth = 4)
  Object num1852 = alloc_Float64(0);
// compiled num node returning num1852 (depth = 4)
  int op_slot_left_1844 = gc_frame_newslot(num1852);
  params[0] = diff1850;
  partcv[0] = 1;
  Object opresult1853 = callmethod(num1852, "..", 1, partcv, params);
// compiled op node returning opresult1853 (depth = 3)
  gc_frame_newslot(opresult1853);
// starting to compile block node (depth = 3)
  Object block1854 = alloc_Block(NULL, NULL, "collectionsPrelude", 1061);
  gc_frame_newslot(block1854);
// method "_apply"
  block_savedest(block1854);
  Object closure1855 = createclosure(2, "_apply");
  setclosureframe(closure1855, stackframe);
  addtoclosure(closure1855, var_s);
  addtoclosure(closure1855, selfslot);
  struct UserObject *uo1855 = (struct UserObject*)block1854;
  uo1855->data[0] = (Object)closure1855;
  Method *meth_meth_collectionsPrelude__apply1855 = addmethod2pos(block1854, "_apply", &meth_collectionsPrelude__apply1855, 0);
  int argcv_meth_collectionsPrelude__apply1855[] = {1};
  meth_meth_collectionsPrelude__apply1855->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1855);
  meth_meth_collectionsPrelude__apply1855->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1855->definitionLine = 1061;
// compiled block node returning block1854 (depth = 3)
  gc_frame_newslot(block1854);
// call case 5: prelude request
  params[0] = opresult1853;
  params[1] = block1854;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1882 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1843);
// compiled call node returning call1882 (depth = 2)
// Begin line 1065
  setline(1065);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1884 == NULL) {
    strlit1884 = alloc_String("]");
    gc_root(strlit1884);
  }
// compiled string node returning strlit1884 (depth = 3)
  int op_slot_right_1883 = gc_frame_newslot(strlit1884);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_1883 = gc_frame_newslot(*var_s);
  params[0] = strlit1884;
  partcv[0] = 1;
  Object opresult1886 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1886 (depth = 2)
  gc_frame_end(frame);
  return opresult1886;
}
Object meth_collectionsPrelude__apply1901(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1070
  setline(1070);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1903 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe1904 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1905 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1906 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1905);
// compiled call node returning call1906 (depth = 10)
// compiled member node returning call1906 (depth = 9)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1907 = callmethod(call1906, "at",
    1, partcv, params);
  gc_frame_end(callframe1904);
// compiled call node returning call1907 (depth = 8)
  partcv[0] = 0;
  Object call1908 = callmethod(call1907, "asDebugString",
    1, partcv, params);
  gc_frame_end(callframe1903);
// compiled call node returning call1908 (depth = 7)
// compiled member node returning call1908 (depth = 6)
  int op_slot_right_1902 = gc_frame_newslot(call1908);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_1902 = gc_frame_newslot(*var_s);
  params[0] = call1908;
  partcv[0] = 1;
  Object opresult1910 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1910 (depth = 5)
  *var_s = opresult1910;
  if (opresult1910 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1071
  setline(1071);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num1915 = alloc_Float64(1);
// compiled num node returning num1915 (depth = 7)
  int op_slot_right_1914 = gc_frame_newslot(num1915);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1917 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1918 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1917);
// compiled call node returning call1918 (depth = 8)
// compiled member node returning call1918 (depth = 7)
  int op_slot_left_1914 = gc_frame_newslot(call1918);
  params[0] = num1915;
  partcv[0] = 1;
  Object diff1919 = callmethod(call1918, "-", 1, partcv, params);
// compiled op node returning diff1919 (depth = 6)
  int op_slot_right_1913 = gc_frame_newslot(diff1919);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1913 = gc_frame_newslot(*var_i);
  params[0] = diff1919;
  partcv[0] = 1;
  Object opresult1921 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult1921 (depth = 5)
  Object if1912 = done;
  if (istrue(opresult1921)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1923 == NULL) {
    strlit1923 = alloc_String(", ");
    gc_root(strlit1923);
  }
// compiled string node returning strlit1923 (depth = 7)
  int op_slot_right_1922 = gc_frame_newslot(strlit1923);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_1922 = gc_frame_newslot(*var_s);
  params[0] = strlit1923;
  partcv[0] = 1;
  Object opresult1925 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1925 (depth = 6)
  *var_s = opresult1925;
  if (opresult1925 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if1912 = done;
  } else {
  }
// compiled if node returning if1912 (depth = 4)
  gc_frame_end(frame);
  return if1912;
}
Object meth_collectionsPrelude_asDebugString1887(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 1068
  setline(1068);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1888 == NULL) {
    strlit1888 = alloc_String("[");
    gc_root(strlit1888);
  }
// compiled string node returning strlit1888 (depth = 3)
  *var_s = strlit1888;
  if (strlit1888 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1069
  setline(1069);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1889 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num1892 = alloc_Float64(1);
// compiled num node returning num1892 (depth = 5)
  int op_slot_right_1891 = gc_frame_newslot(num1892);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1894 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1895 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1894);
// compiled call node returning call1895 (depth = 6)
// compiled member node returning call1895 (depth = 5)
  int op_slot_left_1891 = gc_frame_newslot(call1895);
  params[0] = num1892;
  partcv[0] = 1;
  Object diff1896 = callmethod(call1895, "-", 1, partcv, params);
// compiled op node returning diff1896 (depth = 4)
  int op_slot_right_1890 = gc_frame_newslot(diff1896);
// starting to compile num node (depth = 4)
  Object num1898 = alloc_Float64(0);
// compiled num node returning num1898 (depth = 4)
  int op_slot_left_1890 = gc_frame_newslot(num1898);
  params[0] = diff1896;
  partcv[0] = 1;
  Object opresult1899 = callmethod(num1898, "..", 1, partcv, params);
// compiled op node returning opresult1899 (depth = 3)
  gc_frame_newslot(opresult1899);
// starting to compile block node (depth = 3)
  Object block1900 = alloc_Block(NULL, NULL, "collectionsPrelude", 1069);
  gc_frame_newslot(block1900);
// method "_apply"
  block_savedest(block1900);
  Object closure1901 = createclosure(2, "_apply");
  setclosureframe(closure1901, stackframe);
  addtoclosure(closure1901, var_s);
  addtoclosure(closure1901, selfslot);
  struct UserObject *uo1901 = (struct UserObject*)block1900;
  uo1901->data[0] = (Object)closure1901;
  Method *meth_meth_collectionsPrelude__apply1901 = addmethod2pos(block1900, "_apply", &meth_collectionsPrelude__apply1901, 0);
  int argcv_meth_collectionsPrelude__apply1901[] = {1};
  meth_meth_collectionsPrelude__apply1901->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1901);
  meth_meth_collectionsPrelude__apply1901->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1901->definitionLine = 1069;
// compiled block node returning block1900 (depth = 3)
  gc_frame_newslot(block1900);
// call case 5: prelude request
  params[0] = opresult1899;
  params[1] = block1900;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1928 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1889);
// compiled call node returning call1928 (depth = 2)
// Begin line 1073
  setline(1073);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1930 == NULL) {
    strlit1930 = alloc_String("]");
    gc_root(strlit1930);
  }
// compiled string node returning strlit1930 (depth = 3)
  int op_slot_right_1929 = gc_frame_newslot(strlit1930);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_1929 = gc_frame_newslot(*var_s);
  params[0] = strlit1930;
  partcv[0] = 1;
  Object opresult1932 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1932 (depth = 2)
  gc_frame_end(frame);
  return opresult1932;
}
Object meth_collectionsPrelude__apply1936(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_element = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_element (depth = 6)
  int op_slot_right_1938 = gc_frame_newslot(*var_element);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  int op_slot_left_1938 = gc_frame_newslot(*var_each);
  params[0] = *var_element;
  partcv[0] = 1;
  Object opresult1940 = callmethod(*var_each, "==", 1, partcv, params);
// compiled op node returning opresult1940 (depth = 5)
  Object if1937 = done;
  if (istrue(opresult1940)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool1941 = alloc_Boolean(1);
// compiled identifier node returning bool1941 (depth = 6)
  block_return(realself, bool1941);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if1937 = undefined;
  } else {
  }
// compiled if node returning if1937 (depth = 4)
  gc_frame_end(frame);
  return if1937;
}
Object meth_collectionsPrelude_contains1933(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_element = &(stackframe->slots[0]);
  *var_element = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for contains");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1076
  setline(1076);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1934 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block1935 = alloc_Block(NULL, NULL, "collectionsPrelude", 1076);
  gc_frame_newslot(block1935);
// method "_apply"
  block_savedest(block1935);
  Object closure1936 = createclosure(2, "_apply");
  setclosureframe(closure1936, stackframe);
  addtoclosure(closure1936, var_element);
  addtoclosure(closure1936, selfslot);
  struct UserObject *uo1936 = (struct UserObject*)block1935;
  uo1936->data[0] = (Object)closure1936;
  Method *meth_meth_collectionsPrelude__apply1936 = addmethod2pos(block1935, "_apply", &meth_collectionsPrelude__apply1936, 0);
  int argcv_meth_collectionsPrelude__apply1936[] = {1};
  meth_meth_collectionsPrelude__apply1936->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1936);
  meth_meth_collectionsPrelude__apply1936->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1936->definitionLine = 1071;
// compiled block node returning block1935 (depth = 3)
  gc_frame_newslot(block1935);
// call case 4: self request
  params[0] = block1935;
  partcv[0] = 1;
  Object call1943 = callmethodflags(self, "do", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1934);
// compiled call node returning call1943 (depth = 2)
// Begin line 1077
  setline(1077);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool1944 = alloc_Boolean(0);
// compiled identifier node returning bool1944 (depth = 3)
  return bool1944;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply1949(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1951 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1952 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1951);
// compiled call node returning call1952 (depth = 6)
// compiled member node returning call1952 (depth = 5)
  int op_slot_right_1950 = gc_frame_newslot(call1952);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  int op_slot_left_1950 = gc_frame_newslot(*var_i);
  params[0] = call1952;
  partcv[0] = 1;
  Object opresult1954 = callmethod(*var_i, "<", 1, partcv, params);
// compiled op node returning opresult1954 (depth = 4)
  gc_frame_end(frame);
  return opresult1954;
}
Object meth_collectionsPrelude__apply1957(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1082
  setline(1082);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1958 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe1959 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1960 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1961 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1960);
// compiled call node returning call1961 (depth = 7)
// compiled member node returning call1961 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1962 = callmethod(call1961, "at",
    1, partcv, params);
  gc_frame_end(callframe1959);
// compiled call node returning call1962 (depth = 5)
  gc_frame_newslot(call1962);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block1 (depth = 5)
  params[0] = call1962;
  partcv[0] = 1;
  Object call1963 = callmethod(*var_block1, "apply",
    1, partcv, params);
  gc_frame_end(callframe1958);
// compiled call node returning call1963 (depth = 4)
// Begin line 1083
  setline(1083);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1965 = alloc_Float64(1);
// compiled num node returning num1965 (depth = 6)
  int op_slot_right_1964 = gc_frame_newslot(num1965);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_1964 = gc_frame_newslot(*var_i);
  params[0] = num1965;
  partcv[0] = 1;
  Object sum1967 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum1967 (depth = 5)
  *var_i = sum1967;
  if (sum1967 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_do1945(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for do");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_i = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "i");
// Begin line 1080
  setline(1080);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num1946 = alloc_Float64(0);
// compiled num node returning num1946 (depth = 3)
  *var_i = num1946;
  if (num1946 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1081
  setline(1081);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1947 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block1948 = alloc_Block(NULL, NULL, "collectionsPrelude", 1081);
  gc_frame_newslot(block1948);
// method "_apply"
  block_savedest(block1948);
  Object closure1949 = createclosure(2, "_apply");
  setclosureframe(closure1949, stackframe);
  addtoclosure(closure1949, var_i);
  addtoclosure(closure1949, selfslot);
  struct UserObject *uo1949 = (struct UserObject*)block1948;
  uo1949->data[0] = (Object)closure1949;
  Method *meth_meth_collectionsPrelude__apply1949 = addmethod2pos(block1948, "_apply", &meth_collectionsPrelude__apply1949, 0);
  int argcv_meth_collectionsPrelude__apply1949[] = {0};
  meth_meth_collectionsPrelude__apply1949->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1949);
  meth_meth_collectionsPrelude__apply1949->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1949->definitionLine = 1071;
// compiled block node returning block1948 (depth = 3)
  gc_frame_newslot(block1948);
// starting to compile block node (depth = 3)
  Object block1956 = alloc_Block(NULL, NULL, "collectionsPrelude", 1081);
  gc_frame_newslot(block1956);
// method "_apply"
  block_savedest(block1956);
  Object closure1957 = createclosure(3, "_apply");
  setclosureframe(closure1957, stackframe);
  addtoclosure(closure1957, var_i);
  addtoclosure(closure1957, var_block1);
  addtoclosure(closure1957, selfslot);
  struct UserObject *uo1957 = (struct UserObject*)block1956;
  uo1957->data[0] = (Object)closure1957;
  Method *meth_meth_collectionsPrelude__apply1957 = addmethod2pos(block1956, "_apply", &meth_collectionsPrelude__apply1957, 0);
  int argcv_meth_collectionsPrelude__apply1957[] = {0};
  meth_meth_collectionsPrelude__apply1957->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1957);
  meth_meth_collectionsPrelude__apply1957->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1957->definitionLine = 1081;
// compiled block node returning block1956 (depth = 3)
  gc_frame_newslot(block1956);
// call case 5: prelude request
  params[0] = block1948;
  params[1] = block1956;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1970 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1947);
// compiled call node returning call1970 (depth = 2)
  gc_frame_end(frame);
  return call1970;
}
Object meth_collectionsPrelude__61__61_1971(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1088
  setline(1088);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe1972 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 2: outer request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1973 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1974 = gc_frame_new();
// call case 3: self.outer request
  Object call1975 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe1974);
// compiled call node returning call1975 (depth = 6)
// compiled member node returning call1975 (depth = 5)
  partcv[0] = 0;
  Object call1976 = callmethodflags(call1975, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1973);
// compiled call node returning call1976 (depth = 4)
// compiled member node returning call1976 (depth = 3)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1977 = callmethodflags(call1976, "isEqual()toIterable", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1972);
// compiled call node returning call1977 (depth = 2)
  gc_frame_end(frame);
  return call1977;
}
Object meth_collectionsPrelude_asDebugString1983(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1094
  setline(1094);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit1985 == NULL) {
    strlit1985 = alloc_String("""\xe2""""\x9f""""\xab""");
    gc_root(strlit1985);
  }
// compiled string node returning strlit1985 (depth = 3)
  int op_slot_right_1984 = gc_frame_newslot(strlit1985);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1988 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1989 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1988);
// compiled call node returning call1989 (depth = 5)
// compiled member node returning call1989 (depth = 4)
  int op_slot_right_1987 = gc_frame_newslot(call1989);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit1992 == NULL) {
    strlit1992 = alloc_String("""\xe2""""\x9f""""\xaa""");
    gc_root(strlit1992);
  }
// compiled string node returning strlit1992 (depth = 5)
  int op_slot_right_1991 = gc_frame_newslot(strlit1992);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1995 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1996 = callmethodflags(self, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1995);
// compiled call node returning call1996 (depth = 7)
// compiled member node returning call1996 (depth = 6)
  int op_slot_right_1994 = gc_frame_newslot(call1996);
// starting to compile string node (depth = 6)
  if (strlit1998 == NULL) {
    strlit1998 = alloc_String("");
    gc_root(strlit1998);
  }
// compiled string node returning strlit1998 (depth = 6)
  int op_slot_left_1994 = gc_frame_newslot(strlit1998);
  params[0] = call1996;
  partcv[0] = 1;
  Object opresult1999 = callmethod(strlit1998, "++", 1, partcv, params);
// compiled op node returning opresult1999 (depth = 5)
  int op_slot_left_1991 = gc_frame_newslot(opresult1999);
  params[0] = strlit1992;
  partcv[0] = 1;
  Object opresult2000 = callmethod(opresult1999, "++", 1, partcv, params);
// compiled op node returning opresult2000 (depth = 4)
  int op_slot_left_1987 = gc_frame_newslot(opresult2000);
  params[0] = call1989;
  partcv[0] = 1;
  Object opresult2001 = callmethod(opresult2000, "++", 1, partcv, params);
// compiled op node returning opresult2001 (depth = 3)
  int op_slot_left_1984 = gc_frame_newslot(opresult2001);
  params[0] = strlit1985;
  partcv[0] = 1;
  Object opresult2002 = callmethod(opresult2001, "++", 1, partcv, params);
// compiled op node returning opresult2002 (depth = 2)
  gc_frame_end(frame);
  return opresult2002;
}
Object meth_collectionsPrelude_asString2003(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1095
  setline(1095);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit2004 == NULL) {
    strlit2004 = alloc_String("aListIterator");
    gc_root(strlit2004);
  }
// compiled string node returning strlit2004 (depth = 2)
  gc_frame_end(frame);
  return strlit2004;
}
Object meth_collectionsPrelude_hasNext2005(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1096
  setline(1096);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2007 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2008 = gc_frame_new();
// call case 3: self.outer request
  Object call2009 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2008);
// compiled call node returning call2009 (depth = 6)
// compiled member node returning call2009 (depth = 5)
  partcv[0] = 0;
  Object call2010 = callmethodflags(call2009, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2007);
// compiled call node returning call2010 (depth = 4)
// compiled member node returning call2010 (depth = 3)
  int op_slot_right_2006 = gc_frame_newslot(call2010);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2012 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2013 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2012);
// compiled call node returning call2013 (depth = 4)
// compiled member node returning call2013 (depth = 3)
  int op_slot_left_2006 = gc_frame_newslot(call2013);
  params[0] = call2010;
  partcv[0] = 1;
  Object opresult2014 = callmethod(call2013, "≤", 1, partcv, params);
// compiled op node returning opresult2014 (depth = 2)
  gc_frame_end(frame);
  return opresult2014;
}
Object meth_collectionsPrelude_next2015(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ret = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "ret");
// Begin line 1098
  setline(1098);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2018 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2019 = gc_frame_new();
// call case 3: self.outer request
  Object call2020 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2019);
// compiled call node returning call2020 (depth = 7)
// compiled member node returning call2020 (depth = 6)
  partcv[0] = 0;
  Object call2021 = callmethodflags(call2020, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2018);
// compiled call node returning call2021 (depth = 5)
// compiled member node returning call2021 (depth = 4)
  int op_slot_right_2017 = gc_frame_newslot(call2021);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2023 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2024 = callmethodflags(self, "imods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2023);
// compiled call node returning call2024 (depth = 5)
// compiled member node returning call2024 (depth = 4)
  int op_slot_left_2017 = gc_frame_newslot(call2024);
  params[0] = call2021;
  partcv[0] = 1;
  Object opresult2025 = callmethod(call2024, "≠", 1, partcv, params);
// compiled op node returning opresult2025 (depth = 3)
  Object if2016 = done;
  if (istrue(opresult2025)) {
// Begin line 1099
  setline(1099);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2026 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2027 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2028 = callmethodflags(self, "asDebugString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2027);
// compiled call node returning call2028 (depth = 5)
// compiled member node returning call2028 (depth = 4)
  gc_frame_newslot(call2028);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ConcurrentModification (depth = 4)
  params[0] = call2028;
  partcv[0] = 1;
  Object call2029 = callmethod(*var_ConcurrentModification, "raise",
    1, partcv, params);
  gc_frame_end(callframe2026);
// compiled call node returning call2029 (depth = 3)
    gc_frame_newslot(call2029);
    if2016 = call2029;
  } else {
  }
// compiled if node returning if2016 (depth = 2)
// Begin line 1101
  setline(1101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2032 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2033 = gc_frame_new();
// call case 3: self.outer request
  Object call2034 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2033);
// compiled call node returning call2034 (depth = 7)
// compiled member node returning call2034 (depth = 6)
  partcv[0] = 0;
  Object call2035 = callmethodflags(call2034, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2032);
// compiled call node returning call2035 (depth = 5)
// compiled member node returning call2035 (depth = 4)
  int op_slot_right_2031 = gc_frame_newslot(call2035);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2037 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2038 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2037);
// compiled call node returning call2038 (depth = 5)
// compiled member node returning call2038 (depth = 4)
  int op_slot_left_2031 = gc_frame_newslot(call2038);
  params[0] = call2035;
  partcv[0] = 1;
  Object opresult2039 = callmethod(call2038, ">", 1, partcv, params);
// compiled op node returning opresult2039 (depth = 3)
  Object if2030 = done;
  if (istrue(opresult2039)) {
// starting to compile call node (depth = 3)
  int callframe2040 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit2041 == NULL) {
    strlit2041 = alloc_String("on list");
    gc_root(strlit2041);
  }
// compiled string node returning strlit2041 (depth = 4)
  gc_frame_newslot(strlit2041);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_IteratorExhausted (depth = 4)
  params[0] = strlit2041;
  partcv[0] = 1;
  Object call2042 = callmethod(*var_IteratorExhausted, "raise",
    1, partcv, params);
  gc_frame_end(callframe2040);
// compiled call node returning call2042 (depth = 3)
    gc_frame_newslot(call2042);
    if2030 = call2042;
  } else {
  }
// compiled if node returning if2030 (depth = 2)
// Begin line 1102
  setline(1102);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2043 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2044 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2045 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2044);
// compiled call node returning call2045 (depth = 5)
// compiled member node returning call2045 (depth = 4)
  gc_frame_newslot(call2045);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2046 = gc_frame_new();
// call case 3: self.outer request
  Object call2047 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2046);
// compiled call node returning call2047 (depth = 5)
// compiled member node returning call2047 (depth = 4)
  params[0] = call2045;
  partcv[0] = 1;
  Object call2048 = callmethodflags(call2047, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2043);
// compiled call node returning call2048 (depth = 3)
  *var_ret = call2048;
  if (call2048 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1103
  setline(1103);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2049 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2051 = alloc_Float64(1);
// compiled num node returning num2051 (depth = 4)
  int op_slot_right_2050 = gc_frame_newslot(num2051);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2053 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2054 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2053);
// compiled call node returning call2054 (depth = 5)
// compiled member node returning call2054 (depth = 4)
  int op_slot_left_2050 = gc_frame_newslot(call2054);
  params[0] = num2051;
  partcv[0] = 1;
  Object sum2055 = callmethod(call2054, "+", 1, partcv, params);
// compiled op node returning sum2055 (depth = 3)
  gc_frame_newslot(sum2055);
// call case 4: self request
  params[0] = sum2055;
  partcv[0] = 1;
  Object call2056 = callmethodflags(self, "idx:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2049);
// compiled call node returning call2056 (depth = 2)
// Begin line 1104
  setline(1104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_ret (depth = 2)
  gc_frame_end(frame);
  return *var_ret;
}
Object meth_collectionsPrelude_iterator1978(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1979 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1979 = alloc_userobj2(8,7, objclass1979);
  gc_frame_newslot(obj1979);
if (objclass1979 == NULL) {
  glfree(obj1979->class->name);
  obj1979->class->name = "collectionsPrelude.list.object.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1979, self, 0);
  addmethodreal(obj1979,"outer", &reader_collectionsPrelude_outer_1980);
  Object oldself1979 = self;
  struct StackFrameObject *oldstackframe1979 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1979);
  gc_frame_newslot((Object)stackframe);
  self = obj1979;
  Object *oldselfslot1979 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1979 = (*(struct UserObject *)self).data[0], lowerouter1979 = thisouter1979;
  if (inheritingObject1979) {
    struct UserObject *inho1979 = (struct UserObject *)inheritingObject1979;
    while (inho1979->super != GraceDefaultObject) inho1979 = (struct UserObject *)inho1979->super;
    inho1979->super = obj1979;
    self = inheritingObject1979;
    *selfslot = self;
    lowerouter1979 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1979;
  }
if (objclass1979 == NULL) {
  Method *reader1981 = addmethodrealflags(obj1979, "imods",&reader_collectionsPrelude_imods_1981, MFLAG_CONFIDENTIAL);
  Method *writer1981 = addmethodrealflags(obj1979, "imods:=",&writer_collectionsPrelude_imods_1981, MFLAG_CONFIDENTIAL);
  reader1981->definitionModule = modulename;
  writer1981->definitionModule = modulename;
  reader1981->definitionLine = 1092;
  writer1981->definitionLine = 1092;
}
obj1979->flags |= OFLAG_MUTABLE;
adddatum2(obj1979, alloc_Undefined(), 1);
if (objclass1979 == NULL) {
  Method *reader1982 = addmethodrealflags(obj1979, "idx",&reader_collectionsPrelude_idx_1982, MFLAG_CONFIDENTIAL);
  Method *writer1982 = addmethodrealflags(obj1979, "idx:=",&writer_collectionsPrelude_idx_1982, MFLAG_CONFIDENTIAL);
  reader1982->definitionModule = modulename;
  writer1982->definitionModule = modulename;
  reader1982->definitionLine = 1093;
  writer1982->definitionLine = 1093;
}
obj1979->flags |= OFLAG_MUTABLE;
adddatum2(obj1979, alloc_Undefined(), 2);
// method "asDebugString"
  struct UserObject *uo1983 = (struct UserObject*)obj1979;
  uo1983->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString1983 = addmethod2pos(obj1979, "asDebugString", &meth_collectionsPrelude_asDebugString1983, 3);
  int argcv_meth_collectionsPrelude_asDebugString1983[] = {0};
  meth_meth_collectionsPrelude_asDebugString1983->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString1983);
  meth_meth_collectionsPrelude_asDebugString1983->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString1983->definitionLine = 1094;
// method "asString"
  struct UserObject *uo2003 = (struct UserObject*)obj1979;
  uo2003->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString2003 = addmethod2pos(obj1979, "asString", &meth_collectionsPrelude_asString2003, 4);
  int argcv_meth_collectionsPrelude_asString2003[] = {0};
  meth_meth_collectionsPrelude_asString2003->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString2003);
  meth_meth_collectionsPrelude_asString2003->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString2003->definitionLine = 1095;
// method "hasNext"
  struct UserObject *uo2005 = (struct UserObject*)obj1979;
  uo2005->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext2005 = addmethod2pos(obj1979, "hasNext", &meth_collectionsPrelude_hasNext2005, 5);
  int argcv_meth_collectionsPrelude_hasNext2005[] = {0};
  meth_meth_collectionsPrelude_hasNext2005->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext2005);
  meth_meth_collectionsPrelude_hasNext2005->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext2005->definitionLine = 1096;
// method "next"
  block_savedest(obj1979);
  Object closure2015 = createclosure(2, "next");
  setclosureframe(closure2015, stackframe);
  addtoclosure(closure2015, var_ConcurrentModification);
  addtoclosure(closure2015, var_IteratorExhausted);
  struct UserObject *uo2015 = (struct UserObject*)obj1979;
  uo2015->data[6] = (Object)closure2015;
  Method *meth_meth_collectionsPrelude_next2015 = addmethod2pos(obj1979, "next", &meth_collectionsPrelude_next2015, 6);
  int argcv_meth_collectionsPrelude_next2015[] = {0};
  meth_meth_collectionsPrelude_next2015->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next2015);
  meth_meth_collectionsPrelude_next2015->definitionModule = modulename;
  meth_meth_collectionsPrelude_next2015->definitionLine = 1097;
  sourceObject = obj1979;
// Begin line 1092
  setline(1092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2057 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2058 = gc_frame_new();
// call case 3: self.outer request
  Object call2059 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2058);
// compiled call node returning call2059 (depth = 5)
// compiled member node returning call2059 (depth = 4)
  partcv[0] = 0;
  Object call2060 = callmethodflags(call2059, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2057);
// compiled call node returning call2060 (depth = 3)
// compiled member node returning call2060 (depth = 2)
  adddatum2(obj1979, call2060, 1);
  sourceObject = obj1979;
// Begin line 1093
  setline(1093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2061 = alloc_Float64(1);
// compiled num node returning num2061 (depth = 2)
  adddatum2(obj1979, num2061, 2);
  sourceObject = obj1979;
  sourceObject = obj1979;
  sourceObject = obj1979;
  sourceObject = obj1979;
  objclass1979 = obj1979->class;
  objclass1979->definitionModule = modulename;
  objclass1979->definitionLine = 1091;
  (*(struct UserObject *)self).data[0] = lowerouter1979;
  self = oldself1979;
  selfslot = oldselfslot1979;
  stackframe = oldstackframe1979;
  gc_frame_end(frame);
  return obj1979;
}
Object meth_collectionsPrelude_iterator1978_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1979 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1979 = alloc_userobj2(8,7, objclass1979);
  gc_frame_newslot(obj1979);
if (objclass1979 == NULL) {
  glfree(obj1979->class->name);
  obj1979->class->name = "collectionsPrelude.list.object.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1979, self, 0);
  addmethodreal(obj1979,"outer", &reader_collectionsPrelude_outer_1980);
  Object oldself1979 = self;
  struct StackFrameObject *oldstackframe1979 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1979);
  gc_frame_newslot((Object)stackframe);
  self = obj1979;
  Object *oldselfslot1979 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1979 = (*(struct UserObject *)self).data[0], lowerouter1979 = thisouter1979;
  if (inheritingObject1979) {
    struct UserObject *inho1979 = (struct UserObject *)inheritingObject1979;
    while (inho1979->super != GraceDefaultObject) inho1979 = (struct UserObject *)inho1979->super;
    inho1979->super = obj1979;
    self = inheritingObject1979;
    *selfslot = self;
    lowerouter1979 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1979;
  }
if (objclass1979 == NULL) {
  Method *reader1981 = addmethodrealflags(obj1979, "imods",&reader_collectionsPrelude_imods_1981, MFLAG_CONFIDENTIAL);
  Method *writer1981 = addmethodrealflags(obj1979, "imods:=",&writer_collectionsPrelude_imods_1981, MFLAG_CONFIDENTIAL);
  reader1981->definitionModule = modulename;
  writer1981->definitionModule = modulename;
  reader1981->definitionLine = 1092;
  writer1981->definitionLine = 1092;
}
obj1979->flags |= OFLAG_MUTABLE;
adddatum2(obj1979, alloc_Undefined(), 1);
if (objclass1979 == NULL) {
  Method *reader1982 = addmethodrealflags(obj1979, "idx",&reader_collectionsPrelude_idx_1982, MFLAG_CONFIDENTIAL);
  Method *writer1982 = addmethodrealflags(obj1979, "idx:=",&writer_collectionsPrelude_idx_1982, MFLAG_CONFIDENTIAL);
  reader1982->definitionModule = modulename;
  writer1982->definitionModule = modulename;
  reader1982->definitionLine = 1093;
  writer1982->definitionLine = 1093;
}
obj1979->flags |= OFLAG_MUTABLE;
adddatum2(obj1979, alloc_Undefined(), 2);
// method "asDebugString"
  struct UserObject *uo1983 = (struct UserObject*)obj1979;
  uo1983->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString1983 = addmethod2pos(obj1979, "asDebugString", &meth_collectionsPrelude_asDebugString1983, 3);
  int argcv_meth_collectionsPrelude_asDebugString1983[] = {0};
  meth_meth_collectionsPrelude_asDebugString1983->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString1983);
  meth_meth_collectionsPrelude_asDebugString1983->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString1983->definitionLine = 1094;
// method "asString"
  struct UserObject *uo2003 = (struct UserObject*)obj1979;
  uo2003->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString2003 = addmethod2pos(obj1979, "asString", &meth_collectionsPrelude_asString2003, 4);
  int argcv_meth_collectionsPrelude_asString2003[] = {0};
  meth_meth_collectionsPrelude_asString2003->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString2003);
  meth_meth_collectionsPrelude_asString2003->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString2003->definitionLine = 1095;
// method "hasNext"
  struct UserObject *uo2005 = (struct UserObject*)obj1979;
  uo2005->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext2005 = addmethod2pos(obj1979, "hasNext", &meth_collectionsPrelude_hasNext2005, 5);
  int argcv_meth_collectionsPrelude_hasNext2005[] = {0};
  meth_meth_collectionsPrelude_hasNext2005->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext2005);
  meth_meth_collectionsPrelude_hasNext2005->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext2005->definitionLine = 1096;
// method "next"
  block_savedest(obj1979);
  Object closure2015 = createclosure(2, "next");
  setclosureframe(closure2015, stackframe);
  addtoclosure(closure2015, var_ConcurrentModification);
  addtoclosure(closure2015, var_IteratorExhausted);
  struct UserObject *uo2015 = (struct UserObject*)obj1979;
  uo2015->data[6] = (Object)closure2015;
  Method *meth_meth_collectionsPrelude_next2015 = addmethod2pos(obj1979, "next", &meth_collectionsPrelude_next2015, 6);
  int argcv_meth_collectionsPrelude_next2015[] = {0};
  meth_meth_collectionsPrelude_next2015->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next2015);
  meth_meth_collectionsPrelude_next2015->definitionModule = modulename;
  meth_meth_collectionsPrelude_next2015->definitionLine = 1097;
  sourceObject = obj1979;
// Begin line 1092
  setline(1092);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2057 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2058 = gc_frame_new();
// call case 3: self.outer request
  Object call2059 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2058);
// compiled call node returning call2059 (depth = 5)
// compiled member node returning call2059 (depth = 4)
  partcv[0] = 0;
  Object call2060 = callmethodflags(call2059, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2057);
// compiled call node returning call2060 (depth = 3)
// compiled member node returning call2060 (depth = 2)
  adddatum2(obj1979, call2060, 1);
  sourceObject = obj1979;
// Begin line 1093
  setline(1093);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2061 = alloc_Float64(1);
// compiled num node returning num2061 (depth = 2)
  adddatum2(obj1979, num2061, 2);
  sourceObject = obj1979;
  sourceObject = obj1979;
  sourceObject = obj1979;
  sourceObject = obj1979;
  objclass1979 = obj1979->class;
  objclass1979->definitionModule = modulename;
  objclass1979->definitionLine = 1091;
  (*(struct UserObject *)self).data[0] = lowerouter1979;
  self = oldself1979;
  selfslot = oldselfslot1979;
  stackframe = oldstackframe1979;
  gc_frame_end(frame);
  return obj1979;
}
Object meth_collectionsPrelude_values2063(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for values (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for values");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1109
  setline(1109);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_keys2064(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keys (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for keys");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1112
  setline(1112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2065 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2066 = callmethodflags(self, "indices", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2065);
// compiled call node returning call2066 (depth = 3)
// compiled member node returning call2066 (depth = 2)
  gc_frame_end(frame);
  return call2066;
}
Object meth_collectionsPrelude__apply2084(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_newInner = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1117
  setline(1117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2085 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile call node (depth = 5)
  int callframe2086 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2087 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2088 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2087);
// compiled call node returning call2088 (depth = 7)
// compiled member node returning call2088 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2089 = callmethod(call2088, "at",
    1, partcv, params);
  gc_frame_end(callframe2086);
// compiled call node returning call2089 (depth = 5)
  gc_frame_newslot(call2089);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newInner (depth = 5)
  params[0] = *var_i;
  params[1] = call2089;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2090 = callmethod(*var_newInner, "at()put",
    2, partcv, params);
  gc_frame_end(callframe2085);
// compiled call node returning call2090 (depth = 4)
  gc_frame_end(frame);
  return call2090;
}
Object meth_collectionsPrelude_expandTo2067(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 34, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expandTo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method expandTo");
  Object params[2];
  int partcv[2];
  Object *var__prelude = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for expandTo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_newSize = &(stackframe->slots[0]);
  *var_newSize = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for expandTo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newInner = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newInner");
// Begin line 1115
  setline(1115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2068 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_newSize (depth = 4)
  gc_frame_newslot(*var_newSize);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2069 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var__prelude (depth = 6)
  partcv[0] = 0;
  Object call2070 = callmethod(*var__prelude, "primitiveArray",
    1, partcv, params);
  gc_frame_end(callframe2069);
// compiled call node returning call2070 (depth = 5)
// compiled member node returning call2070 (depth = 4)
  params[0] = *var_newSize;
  partcv[0] = 1;
  Object call2071 = callmethod(call2070, "new",
    1, partcv, params);
  gc_frame_end(callframe2068);
// compiled call node returning call2071 (depth = 3)
  *var_newInner = call2071;
  if (call2071 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1116
  setline(1116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2072 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2075 = alloc_Float64(1);
// compiled num node returning num2075 (depth = 5)
  int op_slot_right_2074 = gc_frame_newslot(num2075);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2077 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2078 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2077);
// compiled call node returning call2078 (depth = 6)
// compiled member node returning call2078 (depth = 5)
  int op_slot_left_2074 = gc_frame_newslot(call2078);
  params[0] = num2075;
  partcv[0] = 1;
  Object diff2079 = callmethod(call2078, "-", 1, partcv, params);
// compiled op node returning diff2079 (depth = 4)
  int op_slot_right_2073 = gc_frame_newslot(diff2079);
// starting to compile num node (depth = 4)
  Object num2081 = alloc_Float64(0);
// compiled num node returning num2081 (depth = 4)
  int op_slot_left_2073 = gc_frame_newslot(num2081);
  params[0] = diff2079;
  partcv[0] = 1;
  Object opresult2082 = callmethod(num2081, "..", 1, partcv, params);
// compiled op node returning opresult2082 (depth = 3)
  gc_frame_newslot(opresult2082);
// starting to compile block node (depth = 3)
  Object block2083 = alloc_Block(NULL, NULL, "collectionsPrelude", 1116);
  gc_frame_newslot(block2083);
// method "_apply"
  block_savedest(block2083);
  Object closure2084 = createclosure(2, "_apply");
  setclosureframe(closure2084, stackframe);
  addtoclosure(closure2084, var_newInner);
  addtoclosure(closure2084, selfslot);
  struct UserObject *uo2084 = (struct UserObject*)block2083;
  uo2084->data[0] = (Object)closure2084;
  Method *meth_meth_collectionsPrelude__apply2084 = addmethod2pos(block2083, "_apply", &meth_collectionsPrelude__apply2084, 0);
  int argcv_meth_collectionsPrelude__apply2084[] = {1};
  meth_meth_collectionsPrelude__apply2084->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2084);
  meth_meth_collectionsPrelude__apply2084->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2084->definitionLine = 1116;
// compiled block node returning block2083 (depth = 3)
  gc_frame_newslot(block2083);
// call case 5: prelude request
  params[0] = opresult2082;
  params[1] = block2083;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2092 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2072);
// compiled call node returning call2092 (depth = 2)
// Begin line 1119
  setline(1119);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2093 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_newInner (depth = 3)
  gc_frame_newslot(*var_newInner);
// call case 4: self request
  params[0] = *var_newInner;
  partcv[0] = 1;
  Object call2094 = callmethodflags(self, "inner:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2093);
// compiled call node returning call2094 (depth = 2)
  gc_frame_end(frame);
  return call2094;
}
Object meth_collectionsPrelude_sortBy2095(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortBy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortBy");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortBy (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for sortBy");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1122
  setline(1122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2096 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2098 = alloc_Float64(1);
// compiled num node returning num2098 (depth = 4)
  int op_slot_right_2097 = gc_frame_newslot(num2098);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2100 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2101 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2100);
// compiled call node returning call2101 (depth = 5)
// compiled member node returning call2101 (depth = 4)
  int op_slot_left_2097 = gc_frame_newslot(call2101);
  params[0] = num2098;
  partcv[0] = 1;
  Object sum2102 = callmethod(call2101, "+", 1, partcv, params);
// compiled op node returning sum2102 (depth = 3)
  gc_frame_newslot(sum2102);
// call case 4: self request
  params[0] = sum2102;
  partcv[0] = 1;
  Object call2103 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2096);
// compiled call node returning call2103 (depth = 2)
// Begin line 1123
  setline(1123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2104 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2105 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2106 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2105);
// compiled call node returning call2106 (depth = 4)
// compiled member node returning call2106 (depth = 3)
  gc_frame_newslot(call2106);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sortBlock (depth = 3)
  gc_frame_newslot(*var_sortBlock);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2107 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2108 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2107);
// compiled call node returning call2108 (depth = 4)
// compiled member node returning call2108 (depth = 3)
  params[0] = call2106;
  params[1] = *var_sortBlock;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2109 = callmethod(call2108, "sortInitial()by",
    2, partcv, params);
  gc_frame_end(callframe2104);
// compiled call node returning call2109 (depth = 2)
// Begin line 1124
  setline(1124);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply2113(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  Object *var_r = &(stackframe->slots[1]);
  *var_r = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1128
  setline(1128);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_r (depth = 6)
  int op_slot_right_2115 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_l (depth = 6)
  int op_slot_left_2115 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult2117 = callmethod(*var_l, "==", 1, partcv, params);
// compiled op node returning opresult2117 (depth = 5)
  Object if2114 = done;
  if (istrue(opresult2117)) {
// starting to compile num node (depth = 5)
  Object num2118 = alloc_Float64(0);
// compiled num node returning num2118 (depth = 5)
    gc_frame_newslot(num2118);
    if2114 = num2118;
  } else {
// Begin line 1130
  setline(1130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// Begin line 1129
  setline(1129);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_r (depth = 7)
  int op_slot_right_2120 = gc_frame_newslot(*var_r);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_l (depth = 7)
  int op_slot_left_2120 = gc_frame_newslot(*var_l);
  params[0] = *var_r;
  partcv[0] = 1;
  Object opresult2122 = callmethod(*var_l, "<", 1, partcv, params);
// compiled op node returning opresult2122 (depth = 6)
  Object if2119 = done;
  if (istrue(opresult2122)) {
// starting to compile call node (depth = 6)
  int callframe2123 = gc_frame_new();
// call case 6: other member request
// starting to compile num node (depth = 7)
  Object num2124 = alloc_Float64(1);
// compiled num node returning num2124 (depth = 7)
  partcv[0] = 0;
  Object call2125 = callmethod(num2124, "prefix-",
    1, partcv, params);
  gc_frame_end(callframe2123);
// compiled call node returning call2125 (depth = 6)
    gc_frame_newslot(call2125);
    if2119 = call2125;
  } else {
// Begin line 1130
  setline(1130);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num2126 = alloc_Float64(1);
// compiled num node returning num2126 (depth = 6)
    gc_frame_newslot(num2126);
    if2119 = num2126;
  }
// compiled if node returning if2119 (depth = 5)
    gc_frame_newslot(if2119);
    if2114 = if2119;
  }
// compiled if node returning if2114 (depth = 4)
  gc_frame_end(frame);
  return if2114;
}
Object meth_collectionsPrelude_sort2110(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sort");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sort (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for sort");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1127
  setline(1127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2111 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2112 = alloc_Block(NULL, NULL, "collectionsPrelude", 1127);
  gc_frame_newslot(block2112);
// method "_apply"
  block_savedest(block2112);
  Object closure2113 = createclosure(1, "_apply");
  setclosureframe(closure2113, stackframe);
  addtoclosure(closure2113, selfslot);
  struct UserObject *uo2113 = (struct UserObject*)block2112;
  uo2113->data[0] = (Object)closure2113;
  Method *meth_meth_collectionsPrelude__apply2113 = addmethod2pos(block2112, "_apply", &meth_collectionsPrelude__apply2113, 0);
  int argcv_meth_collectionsPrelude__apply2113[] = {2};
  meth_meth_collectionsPrelude__apply2113->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2113);
  meth_meth_collectionsPrelude__apply2113->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2113->definitionLine = 1123;
// compiled block node returning block2112 (depth = 3)
  gc_frame_newslot(block2112);
// call case 4: self request
  params[0] = block2112;
  partcv[0] = 1;
  Object call2128 = callmethodflags(self, "sortBy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2111);
// compiled call node returning call2128 (depth = 2)
  gc_frame_end(frame);
  return call2128;
}
Object meth_collectionsPrelude_sortedBy2129(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for sortedBy");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1134
  setline(1134);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2130 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sortBlock (depth = 3)
  gc_frame_newslot(*var_sortBlock);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2131 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2132 = callmethodflags(self, "copy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2131);
// compiled call node returning call2132 (depth = 4)
// compiled member node returning call2132 (depth = 3)
  params[0] = *var_sortBlock;
  partcv[0] = 1;
  Object call2133 = callmethod(call2132, "sortBy",
    1, partcv, params);
  gc_frame_end(callframe2130);
// compiled call node returning call2133 (depth = 2)
  gc_frame_end(frame);
  return call2133;
}
Object meth_collectionsPrelude_sorted2134(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sorted (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for sorted");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1137
  setline(1137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2135 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2136 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2137 = callmethodflags(self, "copy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2136);
// compiled call node returning call2137 (depth = 5)
// compiled member node returning call2137 (depth = 4)
  partcv[0] = 0;
  Object call2138 = callmethod(call2137, "sort",
    1, partcv, params);
  gc_frame_end(callframe2135);
// compiled call node returning call2138 (depth = 3)
// compiled member node returning call2138 (depth = 2)
  gc_frame_end(frame);
  return call2138;
}
Object meth_collectionsPrelude_copy2139(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "copy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for copy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for copy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1140
  setline(1140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2140 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2141 = gc_frame_new();
// call case 3: self.outer request
  Object call2142 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2141);
// compiled call node returning call2142 (depth = 4)
// compiled member node returning call2142 (depth = 3)
  params[0] = self;
  partcv[0] = 1;
  Object call2143 = callmethodflags(call2142, "withAll", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2140);
// compiled call node returning call2143 (depth = 2)
  gc_frame_end(frame);
  return call2143;
}
Object meth_collectionsPrelude__apply2156(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe2157 = gc_frame_new();
// starting to compile identifier node (depth = 7)
  Object bool2158 = alloc_Boolean(0);
// compiled identifier node returning bool2158 (depth = 7)
  gc_frame_newslot(bool2158);
// call case 4: self request
  params[0] = bool2158;
  partcv[0] = 1;
  Object call2159 = callmethodflags(self, "sizeCertain:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2157);
// compiled call node returning call2159 (depth = 6)
// starting to compile num node (depth = 6)
  Object num2160 = alloc_Float64(4);
// compiled num node returning num2160 (depth = 6)
  gc_frame_end(frame);
  return num2160;
}
Object meth_collectionsPrelude__apply2177(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 891
  setline(891);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2178 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2179 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2180 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2179);
// compiled call node returning call2180 (depth = 7)
// compiled member node returning call2180 (depth = 6)
  gc_frame_newslot(call2180);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  gc_frame_newslot(*var_x);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2181 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2182 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2181);
// compiled call node returning call2182 (depth = 7)
// compiled member node returning call2182 (depth = 6)
  params[0] = call2180;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2183 = callmethod(call2182, "at()put",
    2, partcv, params);
  gc_frame_end(callframe2178);
// compiled call node returning call2183 (depth = 5)
// Begin line 892
  setline(892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2184 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2186 = alloc_Float64(1);
// compiled num node returning num2186 (depth = 7)
  int op_slot_right_2185 = gc_frame_newslot(num2186);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2188 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2189 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2188);
// compiled call node returning call2189 (depth = 8)
// compiled member node returning call2189 (depth = 7)
  int op_slot_left_2185 = gc_frame_newslot(call2189);
  params[0] = num2186;
  partcv[0] = 1;
  Object sum2190 = callmethod(call2189, "+", 1, partcv, params);
// compiled op node returning sum2190 (depth = 6)
  gc_frame_newslot(sum2190);
// call case 4: self request
  params[0] = sum2190;
  partcv[0] = 1;
  Object call2191 = callmethodflags(self, "size:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2184);
// compiled call node returning call2191 (depth = 5)
  gc_frame_end(frame);
  return call2191;
}
Object meth_collectionsPrelude__apply2223(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_newInner = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 901
  setline(901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe2224 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  gc_frame_newslot(*var_i);
// starting to compile call node (depth = 9)
  int callframe2225 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2226 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2227 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2226);
// compiled call node returning call2227 (depth = 11)
// compiled member node returning call2227 (depth = 10)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2228 = callmethod(call2227, "at",
    1, partcv, params);
  gc_frame_end(callframe2225);
// compiled call node returning call2228 (depth = 9)
  gc_frame_newslot(call2228);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_newInner (depth = 9)
  params[0] = *var_i;
  params[1] = call2228;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2229 = callmethod(*var_newInner, "at()put",
    2, partcv, params);
  gc_frame_end(callframe2224);
// compiled call node returning call2229 (depth = 8)
  gc_frame_end(frame);
  return call2229;
}
Object meth_collectionsPrelude__apply2198(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_innerSize = getfromclosure(closure, 0);
  Object *var__prelude = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newInner = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newInner");
// Begin line 898
  setline(898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2201 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2202 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2201);
// compiled call node returning call2202 (depth = 8)
// compiled member node returning call2202 (depth = 7)
  int op_slot_right_2200 = gc_frame_newslot(call2202);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_innerSize (depth = 7)
  int op_slot_left_2200 = gc_frame_newslot(*var_innerSize);
  params[0] = call2202;
  partcv[0] = 1;
  Object opresult2204 = callmethod(*var_innerSize, "≤", 1, partcv, params);
// compiled op node returning opresult2204 (depth = 6)
  Object if2199 = done;
  if (istrue(opresult2204)) {
// Begin line 899
  setline(899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2205 = gc_frame_new();
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2207 = alloc_Float64(2);
// compiled num node returning num2207 (depth = 9)
  int op_slot_right_2206 = gc_frame_newslot(num2207);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_innerSize (depth = 9)
  int op_slot_left_2206 = gc_frame_newslot(*var_innerSize);
  params[0] = num2207;
  partcv[0] = 1;
  Object prod2209 = callmethod(*var_innerSize, "*", 1, partcv, params);
// compiled op node returning prod2209 (depth = 8)
  gc_frame_newslot(prod2209);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2210 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var__prelude (depth = 10)
  partcv[0] = 0;
  Object call2211 = callmethod(*var__prelude, "primitiveArray",
    1, partcv, params);
  gc_frame_end(callframe2210);
// compiled call node returning call2211 (depth = 9)
// compiled member node returning call2211 (depth = 8)
  params[0] = prod2209;
  partcv[0] = 1;
  Object call2212 = callmethod(call2211, "new",
    1, partcv, params);
  gc_frame_end(callframe2205);
// compiled call node returning call2212 (depth = 7)
  *var_newInner = call2212;
  if (call2212 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 6)
// Begin line 900
  setline(900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2213 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2216 = alloc_Float64(1);
// compiled num node returning num2216 (depth = 9)
  int op_slot_right_2215 = gc_frame_newslot(num2216);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_innerSize (depth = 9)
  int op_slot_left_2215 = gc_frame_newslot(*var_innerSize);
  params[0] = num2216;
  partcv[0] = 1;
  Object diff2218 = callmethod(*var_innerSize, "-", 1, partcv, params);
// compiled op node returning diff2218 (depth = 8)
  int op_slot_right_2214 = gc_frame_newslot(diff2218);
// starting to compile num node (depth = 8)
  Object num2220 = alloc_Float64(0);
// compiled num node returning num2220 (depth = 8)
  int op_slot_left_2214 = gc_frame_newslot(num2220);
  params[0] = diff2218;
  partcv[0] = 1;
  Object opresult2221 = callmethod(num2220, "..", 1, partcv, params);
// compiled op node returning opresult2221 (depth = 7)
  gc_frame_newslot(opresult2221);
// starting to compile block node (depth = 7)
  Object block2222 = alloc_Block(NULL, NULL, "collectionsPrelude", 900);
  gc_frame_newslot(block2222);
// method "_apply"
  block_savedest(block2222);
  Object closure2223 = createclosure(2, "_apply");
  setclosureframe(closure2223, stackframe);
  addtoclosure(closure2223, var_newInner);
  addtoclosure(closure2223, selfslot);
  struct UserObject *uo2223 = (struct UserObject*)block2222;
  uo2223->data[0] = (Object)closure2223;
  Method *meth_meth_collectionsPrelude__apply2223 = addmethod2pos(block2222, "_apply", &meth_collectionsPrelude__apply2223, 0);
  int argcv_meth_collectionsPrelude__apply2223[] = {1};
  meth_meth_collectionsPrelude__apply2223->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2223);
  meth_meth_collectionsPrelude__apply2223->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2223->definitionLine = 899;
// compiled block node returning block2222 (depth = 7)
  gc_frame_newslot(block2222);
// call case 5: prelude request
  params[0] = opresult2221;
  params[1] = block2222;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2231 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2213);
// compiled call node returning call2231 (depth = 6)
// Begin line 903
  setline(903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2232 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_newInner (depth = 7)
  gc_frame_newslot(*var_newInner);
// call case 4: self request
  params[0] = *var_newInner;
  partcv[0] = 1;
  Object call2233 = callmethodflags(self, "inner:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2232);
// compiled call node returning call2233 (depth = 6)
// Begin line 904
  setline(904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2234 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2235 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2236 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2235);
// compiled call node returning call2236 (depth = 10)
// compiled member node returning call2236 (depth = 9)
  partcv[0] = 0;
  Object call2237 = callmethod(call2236, "size",
    1, partcv, params);
  gc_frame_end(callframe2234);
// compiled call node returning call2237 (depth = 8)
// compiled member node returning call2237 (depth = 7)
  *var_innerSize = call2237;
  if (call2237 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if2199 = done;
  } else {
  }
// compiled if node returning if2199 (depth = 5)
// Begin line 906
  setline(906);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2239 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2240 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2241 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2240);
// compiled call node returning call2241 (depth = 7)
// compiled member node returning call2241 (depth = 6)
  gc_frame_newslot(call2241);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  gc_frame_newslot(*var_x);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2242 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2243 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2242);
// compiled call node returning call2243 (depth = 7)
// compiled member node returning call2243 (depth = 6)
  params[0] = call2241;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2244 = callmethod(call2243, "at()put",
    2, partcv, params);
  gc_frame_end(callframe2239);
// compiled call node returning call2244 (depth = 5)
// Begin line 907
  setline(907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2245 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2247 = alloc_Float64(1);
// compiled num node returning num2247 (depth = 7)
  int op_slot_right_2246 = gc_frame_newslot(num2247);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2249 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2250 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2249);
// compiled call node returning call2250 (depth = 8)
// compiled member node returning call2250 (depth = 7)
  int op_slot_left_2246 = gc_frame_newslot(call2250);
  params[0] = num2247;
  partcv[0] = 1;
  Object sum2251 = callmethod(call2250, "+", 1, partcv, params);
// compiled op node returning sum2251 (depth = 6)
  gc_frame_newslot(sum2251);
// call case 4: self request
  params[0] = sum2251;
  partcv[0] = 1;
  Object call2252 = callmethodflags(self, "size:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2245);
// compiled call node returning call2252 (depth = 5)
  gc_frame_end(frame);
  return call2252;
}
Object meth_collectionsPrelude_withAll706(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "withAll");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method withAll");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_done = getfromclosure(closure, 1);
  Object *var_ConcurrentModification = getfromclosure(closure, 2);
  Object *var_IteratorExhausted = getfromclosure(closure, 3);
  Object *var_indexable = getfromclosure(closure, 4);
  Object *var_BoundsError = getfromclosure(closure, 5);
  Object *var__prelude = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for withAll (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for withAll");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 618
  setline(618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit709 == NULL) {
    strlit709 = alloc_String("js");
    gc_root(strlit709);
  }
// compiled string node returning strlit709 (depth = 4)
  int op_slot_right_708 = gc_frame_newslot(strlit709);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe711 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call712 = callmethodflags(prelude, "engine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe711);
// compiled call node returning call712 (depth = 5)
// compiled member node returning call712 (depth = 4)
  int op_slot_left_708 = gc_frame_newslot(call712);
  params[0] = strlit709;
  partcv[0] = 1;
  Object opresult713 = callmethod(call712, "==", 1, partcv, params);
// compiled op node returning opresult713 (depth = 3)
  Object if707 = done;
  if (istrue(opresult713)) {
// Begin line 619
  setline(619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
// compiled call node returning done (depth = 4)
  Object if714 = done;
  if (istrue(done)) {
// Begin line 620
  setline(620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject715 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj715 = alloc_userobj2(42,40, objclass715);
  gc_frame_newslot(obj715);
// OBJECT OUTER DEC outer
  adddatum2(obj715, self, 0);
  addmethodreal(obj715,"outer", &reader_collectionsPrelude_outer_716);
  Object oldself715 = self;
  struct StackFrameObject *oldstackframe715 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe715);
  gc_frame_newslot((Object)stackframe);
  self = obj715;
  Object *oldselfslot715 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter715 = (*(struct UserObject *)self).data[0], lowerouter715 = thisouter715;
  if (inheritingObject715) {
    struct UserObject *inho715 = (struct UserObject *)inheritingObject715;
    while (inho715->super != GraceDefaultObject) inho715 = (struct UserObject *)inho715->super;
    inho715->super = obj715;
    self = inheritingObject715;
    *selfslot = self;
    lowerouter715 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter715;
  }
if (objclass715 == NULL) {
  Method *reader717 = addmethodrealflags(obj715, "mods",&reader_collectionsPrelude_mods_717, 0);
  Method *writer717 = addmethodrealflags(obj715, "mods:=",&writer_collectionsPrelude_mods_717, MFLAG_CONFIDENTIAL);
  reader717->definitionModule = modulename;
  writer717->definitionModule = modulename;
  reader717->definitionLine = 623;
  writer717->definitionLine = 623;
}
obj715->flags |= OFLAG_MUTABLE;
adddatum2(obj715, alloc_Undefined(), 1);
if (objclass715 == NULL) {
  Method *reader718 = addmethodrealflags(obj715, "sz",&reader_collectionsPrelude_sz_718, MFLAG_CONFIDENTIAL);
  Method *writer718 = addmethodrealflags(obj715, "sz:=",&writer_collectionsPrelude_sz_718, MFLAG_CONFIDENTIAL);
  reader718->definitionModule = modulename;
  writer718->definitionModule = modulename;
  reader718->definitionLine = 624;
  writer718->definitionLine = 624;
}
obj715->flags |= OFLAG_MUTABLE;
adddatum2(obj715, alloc_Undefined(), 2);
if (objclass715 == NULL) {
  Method *reader719 = addmethodrealflags(obj715, "jsArray",&reader_collectionsPrelude_jsArray_719, MFLAG_CONFIDENTIAL);
  Method *writer719 = addmethodrealflags(obj715, "jsArray:=",&writer_collectionsPrelude_jsArray_719, MFLAG_CONFIDENTIAL);
  reader719->definitionModule = modulename;
  writer719->definitionModule = modulename;
  reader719->definitionLine = 625;
  writer719->definitionLine = 625;
}
obj715->flags |= OFLAG_MUTABLE;
adddatum2(obj715, alloc_Undefined(), 3);
// method "size"
  struct UserObject *uo720 = (struct UserObject*)obj715;
  uo720->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size720 = addmethod2pos(obj715, "size", &meth_collectionsPrelude_size720, 4);
  int argcv_meth_collectionsPrelude_size720[] = {0};
  meth_meth_collectionsPrelude_size720->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size720);
  meth_meth_collectionsPrelude_size720->definitionModule = modulename;
  meth_meth_collectionsPrelude_size720->definitionLine = 630;
// method "at"
  struct UserObject *uo723 = (struct UserObject*)obj715;
  uo723->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at723 = addmethod2pos(obj715, "at", &meth_collectionsPrelude_at723, 5);
  int argcv_meth_collectionsPrelude_at723[] = {1};
  meth_meth_collectionsPrelude_at723->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at723);
  meth_meth_collectionsPrelude_at723->definitionModule = modulename;
  meth_meth_collectionsPrelude_at723->definitionLine = 635;
// method "at()put"
  struct UserObject *uo724 = (struct UserObject*)obj715;
  uo724->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40__41_put724 = addmethod2pos(obj715, "at()put", &meth_collectionsPrelude_at_40__41_put724, 6);
  int argcv_meth_collectionsPrelude_at_40__41_put724[] = {1, 1};
  meth_meth_collectionsPrelude_at_40__41_put724->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40__41_put724);
  meth_meth_collectionsPrelude_at_40__41_put724->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40__41_put724->definitionLine = 645;
// method "add"
  struct UserObject *uo733 = (struct UserObject*)obj715;
  uo733->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_add733 = addmethod2pos(obj715, "add", &meth_collectionsPrelude_add733, 7);
  int argcv_meth_collectionsPrelude_add733[] = {1};
  meth_meth_collectionsPrelude_add733->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add733);
  meth_meth_collectionsPrelude_add733->definitionModule = modulename;
  meth_meth_collectionsPrelude_add733->definitionLine = 657;
// method "push"
  struct UserObject *uo742 = (struct UserObject*)obj715;
  uo742->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_push742 = addmethod2pos(obj715, "push", &meth_collectionsPrelude_push742, 8);
  int argcv_meth_collectionsPrelude_push742[] = {1};
  meth_meth_collectionsPrelude_push742->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_push742);
  meth_meth_collectionsPrelude_push742->definitionModule = modulename;
  meth_meth_collectionsPrelude_push742->definitionLine = 663;
// method "removeLast"
  struct UserObject *uo751 = (struct UserObject*)obj715;
  uo751->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeLast751 = addmethod2pos(obj715, "removeLast", &meth_collectionsPrelude_removeLast751, 9);
  int argcv_meth_collectionsPrelude_removeLast751[] = {0};
  meth_meth_collectionsPrelude_removeLast751->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeLast751);
  meth_meth_collectionsPrelude_removeLast751->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeLast751->definitionLine = 669;
// method "addAllFirst"
  struct UserObject *uo760 = (struct UserObject*)obj715;
  uo760->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAllFirst760 = addmethod2pos(obj715, "addAllFirst", &meth_collectionsPrelude_addAllFirst760, 10);
  int argcv_meth_collectionsPrelude_addAllFirst760[] = {1};
  meth_meth_collectionsPrelude_addAllFirst760->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAllFirst760);
  meth_meth_collectionsPrelude_addAllFirst760->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAllFirst760->definitionLine = 679;
// method "removeAt"
  struct UserObject *uo790 = (struct UserObject*)obj715;
  uo790->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAt790 = addmethod2pos(obj715, "removeAt", &meth_collectionsPrelude_removeAt790, 11);
  int argcv_meth_collectionsPrelude_removeAt790[] = {1};
  meth_meth_collectionsPrelude_removeAt790->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAt790);
  meth_meth_collectionsPrelude_removeAt790->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAt790->definitionLine = 690;
// method "sortBy"
  struct UserObject *uo801 = (struct UserObject*)obj715;
  uo801->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortBy801 = addmethod2pos(obj715, "sortBy", &meth_collectionsPrelude_sortBy801, 12);
  int argcv_meth_collectionsPrelude_sortBy801[] = {1};
  meth_meth_collectionsPrelude_sortBy801->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortBy801);
  meth_meth_collectionsPrelude_sortBy801->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortBy801->definitionLine = 697;
// method "addLast"
  struct UserObject *uo810 = (struct UserObject*)obj715;
  uo810->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addLast810 = addmethod2pos(obj715, "addLast", &meth_collectionsPrelude_addLast810, 13);
  int argcv_meth_collectionsPrelude_addLast810[] = {1};
  meth_meth_collectionsPrelude_addLast810->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addLast810);
  meth_meth_collectionsPrelude_addLast810->definitionModule = modulename;
  meth_meth_collectionsPrelude_addLast810->definitionLine = 711;
// method "addAll"
  struct UserObject *uo813 = (struct UserObject*)obj715;
  uo813->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAll813 = addmethod2pos(obj715, "addAll", &meth_collectionsPrelude_addAll813, 14);
  int argcv_meth_collectionsPrelude_addAll813[] = {1};
  meth_meth_collectionsPrelude_addAll813->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAll813);
  meth_meth_collectionsPrelude_addAll813->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAll813->definitionLine = 712;
// method "addFirst"
  struct UserObject *uo821 = (struct UserObject*)obj715;
  uo821->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addFirst821 = addmethod2pos(obj715, "addFirst", &meth_collectionsPrelude_addFirst821, 15);
  int argcv_meth_collectionsPrelude_addFirst821[] = {1};
  meth_meth_collectionsPrelude_addFirst821->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addFirst821);
  meth_meth_collectionsPrelude_addFirst821->definitionModule = modulename;
  meth_meth_collectionsPrelude_addFirst821->definitionLine = 717;
// method "removeFirst"
  struct UserObject *uo830 = (struct UserObject*)obj715;
  uo830->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeFirst830 = addmethod2pos(obj715, "removeFirst", &meth_collectionsPrelude_removeFirst830, 16);
  int argcv_meth_collectionsPrelude_removeFirst830[] = {0};
  meth_meth_collectionsPrelude_removeFirst830->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeFirst830);
  meth_meth_collectionsPrelude_removeFirst830->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeFirst830->definitionLine = 723;
// method "remove"
  block_savedest(obj715);
  Object closure834 = createclosure(1, "remove");
  setclosureframe(closure834, stackframe);
  addtoclosure(closure834, var_NoSuchObject);
  struct UserObject *uo834 = (struct UserObject*)obj715;
  uo834->data[17] = (Object)closure834;
  Method *meth_meth_collectionsPrelude_remove834 = addmethod2pos(obj715, "remove", &meth_collectionsPrelude_remove834, 17);
  int argcv_meth_collectionsPrelude_remove834[] = {1};
  meth_meth_collectionsPrelude_remove834->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_remove834);
  meth_meth_collectionsPrelude_remove834->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove834->definitionLine = 728;
// method "remove()ifAbsent"
  struct UserObject *uo852 = (struct UserObject*)obj715;
  uo852->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_remove_40__41_ifAbsent852 = addmethod2pos(obj715, "remove()ifAbsent", &meth_collectionsPrelude_remove_40__41_ifAbsent852, 18);
  int argcv_meth_collectionsPrelude_remove_40__41_ifAbsent852[] = {1, 1};
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent852->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_remove_40__41_ifAbsent852);
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent852->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent852->definitionLine = 737;
// method "removeAll"
  block_savedest(obj715);
  Object closure862 = createclosure(1, "removeAll");
  setclosureframe(closure862, stackframe);
  addtoclosure(closure862, var_NoSuchObject);
  struct UserObject *uo862 = (struct UserObject*)obj715;
  uo862->data[19] = (Object)closure862;
  Method *meth_meth_collectionsPrelude_removeAll862 = addmethod2pos(obj715, "removeAll", &meth_collectionsPrelude_removeAll862, 19);
  int argcv_meth_collectionsPrelude_removeAll862[] = {1};
  meth_meth_collectionsPrelude_removeAll862->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAll862);
  meth_meth_collectionsPrelude_removeAll862->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll862->definitionLine = 745;
// method "removeAll()ifAbsent"
  struct UserObject *uo871 = (struct UserObject*)obj715;
  uo871->data[20] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent871 = addmethod2pos(obj715, "removeAll()ifAbsent", &meth_collectionsPrelude_removeAll_40__41_ifAbsent871, 20);
  int argcv_meth_collectionsPrelude_removeAll_40__41_ifAbsent871[] = {1, 1};
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent871->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeAll_40__41_ifAbsent871);
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent871->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent871->definitionLine = 750;
// method "pop"
  struct UserObject *uo892 = (struct UserObject*)obj715;
  uo892->data[21] = emptyclosure;
  Method *meth_meth_collectionsPrelude_pop892 = addmethod2pos(obj715, "pop", &meth_collectionsPrelude_pop892, 21);
  int argcv_meth_collectionsPrelude_pop892[] = {0};
  meth_meth_collectionsPrelude_pop892->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_pop892);
  meth_meth_collectionsPrelude_pop892->definitionModule = modulename;
  meth_meth_collectionsPrelude_pop892->definitionLine = 762;
// method "reversed"
  struct UserObject *uo895 = (struct UserObject*)obj715;
  uo895->data[22] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reversed895 = addmethod2pos(obj715, "reversed", &meth_collectionsPrelude_reversed895, 22);
  int argcv_meth_collectionsPrelude_reversed895[] = {0};
  meth_meth_collectionsPrelude_reversed895->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed895);
  meth_meth_collectionsPrelude_reversed895->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed895->definitionLine = 764;
// method "reverse"
  struct UserObject *uo911 = (struct UserObject*)obj715;
  uo911->data[23] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reverse911 = addmethod2pos(obj715, "reverse", &meth_collectionsPrelude_reverse911, 23);
  int argcv_meth_collectionsPrelude_reverse911[] = {0};
  meth_meth_collectionsPrelude_reverse911->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reverse911);
  meth_meth_collectionsPrelude_reverse911->definitionModule = modulename;
  meth_meth_collectionsPrelude_reverse911->definitionLine = 769;
// method "++"
  struct UserObject *uo952 = (struct UserObject*)obj715;
  uo952->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_952 = addmethod2pos(obj715, "++", &meth_collectionsPrelude__43__43_952, 24);
  int argcv_meth_collectionsPrelude__43__43_952[] = {1};
  meth_meth_collectionsPrelude__43__43_952->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_952);
  meth_meth_collectionsPrelude__43__43_952->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_952->definitionLine = 783;
// method "asString"
  struct UserObject *uo963 = (struct UserObject*)obj715;
  uo963->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString963 = addmethod2pos(obj715, "asString", &meth_collectionsPrelude_asString963, 25);
  int argcv_meth_collectionsPrelude_asString963[] = {0};
  meth_meth_collectionsPrelude_asString963->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString963);
  meth_meth_collectionsPrelude_asString963->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString963->definitionLine = 789;
// method "asDebugString"
  struct UserObject *uo997 = (struct UserObject*)obj715;
  uo997->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString997 = addmethod2pos(obj715, "asDebugString", &meth_collectionsPrelude_asDebugString997, 26);
  int argcv_meth_collectionsPrelude_asDebugString997[] = {0};
  meth_meth_collectionsPrelude_asDebugString997->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString997);
  meth_meth_collectionsPrelude_asDebugString997->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString997->definitionLine = 799;
// method "extend"
  block_savedest(obj715);
  Object closure1031 = createclosure(1, "extend");
  setclosureframe(closure1031, stackframe);
  addtoclosure(closure1031, var_done);
  struct UserObject *uo1031 = (struct UserObject*)obj715;
  uo1031->data[27] = (Object)closure1031;
  Method *meth_meth_collectionsPrelude_extend1031 = addmethod2pos(obj715, "extend", &meth_collectionsPrelude_extend1031, 27);
  int argcv_meth_collectionsPrelude_extend1031[] = {1};
  meth_meth_collectionsPrelude_extend1031->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_extend1031);
  meth_meth_collectionsPrelude_extend1031->definitionModule = modulename;
  meth_meth_collectionsPrelude_extend1031->definitionLine = 809;
// method "contains"
  struct UserObject *uo1034 = (struct UserObject*)obj715;
  uo1034->data[28] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains1034 = addmethod2pos(obj715, "contains", &meth_collectionsPrelude_contains1034, 28);
  int argcv_meth_collectionsPrelude_contains1034[] = {1};
  meth_meth_collectionsPrelude_contains1034->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains1034);
  meth_meth_collectionsPrelude_contains1034->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains1034->definitionLine = 812;
// method "do"
  struct UserObject *uo1046 = (struct UserObject*)obj715;
  uo1046->data[29] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do1046 = addmethod2pos(obj715, "do", &meth_collectionsPrelude_do1046, 29);
  int argcv_meth_collectionsPrelude_do1046[] = {1};
  meth_meth_collectionsPrelude_do1046->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do1046);
  meth_meth_collectionsPrelude_do1046->definitionModule = modulename;
  meth_meth_collectionsPrelude_do1046->definitionLine = 817;
// method "=="
  struct UserObject *uo1070 = (struct UserObject*)obj715;
  uo1070->data[30] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61_1070 = addmethod2pos(obj715, "==", &meth_collectionsPrelude__61__61_1070, 30);
  int argcv_meth_collectionsPrelude__61__61_1070[] = {1};
  meth_meth_collectionsPrelude__61__61_1070->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_1070);
  meth_meth_collectionsPrelude__61__61_1070->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_1070->definitionLine = 826;
// method "iterator"
  block_savedest(obj715);
  Object closure1077 = createclosure(2, "iterator");
  setclosureframe(closure1077, stackframe);
  addtoclosure(closure1077, var_ConcurrentModification);
  addtoclosure(closure1077, var_IteratorExhausted);
  struct UserObject *uo1077 = (struct UserObject*)obj715;
  uo1077->data[31] = (Object)closure1077;
  Method *meth_meth_collectionsPrelude_iterator1077 = addmethod2pos(obj715, "iterator", &meth_collectionsPrelude_iterator1077, 31);
  int argcv_meth_collectionsPrelude_iterator1077[] = {0};
  meth_meth_collectionsPrelude_iterator1077->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator1077);
  meth_meth_collectionsPrelude_iterator1077->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1077->definitionLine = 830;
  block_savedest(obj715);
  Object closure1161 = createclosure(2, "iterator()object");
  setclosureframe(closure1161, stackframe);
  addtoclosure(closure1161, var_ConcurrentModification);
  addtoclosure(closure1161, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator1077_object = addmethod2pos(obj715, "iterator()object", &meth_collectionsPrelude_iterator1077_object, 31);
  meth_meth_collectionsPrelude_iterator1077_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1077_object->definitionLine = 830;
// method "values"
  struct UserObject *uo1162 = (struct UserObject*)obj715;
  uo1162->data[32] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values1162 = addmethod2pos(obj715, "values", &meth_collectionsPrelude_values1162, 32);
  int argcv_meth_collectionsPrelude_values1162[] = {0};
  meth_meth_collectionsPrelude_values1162->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values1162);
  meth_meth_collectionsPrelude_values1162->definitionModule = modulename;
  meth_meth_collectionsPrelude_values1162->definitionLine = 849;
// method "keys"
  struct UserObject *uo1163 = (struct UserObject*)obj715;
  uo1163->data[33] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys1163 = addmethod2pos(obj715, "keys", &meth_collectionsPrelude_keys1163, 33);
  int argcv_meth_collectionsPrelude_keys1163[] = {0};
  meth_meth_collectionsPrelude_keys1163->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys1163);
  meth_meth_collectionsPrelude_keys1163->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys1163->definitionLine = 853;
// method "sort"
  struct UserObject *uo1166 = (struct UserObject*)obj715;
  uo1166->data[34] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sort1166 = addmethod2pos(obj715, "sort", &meth_collectionsPrelude_sort1166, 34);
  int argcv_meth_collectionsPrelude_sort1166[] = {0};
  meth_meth_collectionsPrelude_sort1166->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sort1166);
  meth_meth_collectionsPrelude_sort1166->definitionModule = modulename;
  meth_meth_collectionsPrelude_sort1166->definitionLine = 857;
// method "sortedBy"
  struct UserObject *uo1193 = (struct UserObject*)obj715;
  uo1193->data[35] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy1193 = addmethod2pos(obj715, "sortedBy", &meth_collectionsPrelude_sortedBy1193, 35);
  int argcv_meth_collectionsPrelude_sortedBy1193[] = {1};
  meth_meth_collectionsPrelude_sortedBy1193->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy1193);
  meth_meth_collectionsPrelude_sortedBy1193->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy1193->definitionLine = 865;
// method "sorted"
  struct UserObject *uo1198 = (struct UserObject*)obj715;
  uo1198->data[36] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted1198 = addmethod2pos(obj715, "sorted", &meth_collectionsPrelude_sorted1198, 36);
  int argcv_meth_collectionsPrelude_sorted1198[] = {0};
  meth_meth_collectionsPrelude_sorted1198->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted1198);
  meth_meth_collectionsPrelude_sorted1198->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted1198->definitionLine = 868;
// method "copy"
  struct UserObject *uo1203 = (struct UserObject*)obj715;
  uo1203->data[37] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy1203 = addmethod2pos(obj715, "copy", &meth_collectionsPrelude_copy1203, 37);
  int argcv_meth_collectionsPrelude_copy1203[] = {0};
  meth_meth_collectionsPrelude_copy1203->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy1203);
  meth_meth_collectionsPrelude_copy1203->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy1203->definitionLine = 871;
  sourceObject = obj715;
// Begin line 621
  setline(621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1208 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_indexable (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1209 = callmethod(*var_indexable, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe1208);
// compiled call node returning call1209 (depth = 6)
  struct UserObject *obj715_uo = (struct UserObject *)obj715;
  obj715_uo->super = call1209;
  sourceObject = obj715;
// Begin line 623
  setline(623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num1210 = alloc_Float64(0);
// compiled num node returning num1210 (depth = 6)
  adddatum2(obj715, num1210, 1);
  sourceObject = obj715;
// Begin line 624
  setline(624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num1211 = alloc_Float64(0);
// compiled num node returning num1211 (depth = 6)
  adddatum2(obj715, num1211, 2);
  sourceObject = obj715;
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
  adddatum2(obj715, done, 3);
  sourceObject = obj715;
// Begin line 626
  setline(626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1212 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1213 = alloc_Block(NULL, NULL, "collectionsPrelude", 626);
  gc_frame_newslot(block1213);
// method "_apply"
  block_savedest(block1213);
  Object closure1214 = createclosure(1, "_apply");
  setclosureframe(closure1214, stackframe);
  addtoclosure(closure1214, selfslot);
  struct UserObject *uo1214 = (struct UserObject*)block1213;
  uo1214->data[0] = (Object)closure1214;
  Method *meth_meth_collectionsPrelude__apply1214 = addmethod2pos(block1213, "_apply", &meth_collectionsPrelude__apply1214, 0);
  int argcv_meth_collectionsPrelude__apply1214[] = {1};
  meth_meth_collectionsPrelude__apply1214->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1214);
  meth_meth_collectionsPrelude__apply1214->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1214->definitionLine = 872;
// compiled block node returning block1213 (depth = 7)
  gc_frame_newslot(block1213);
// call case 6: other member request
// Begin line 626
  setline(626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  params[0] = block1213;
  partcv[0] = 1;
  Object call1216 = callmethod(*var_a, "do",
    1, partcv, params);
  gc_frame_end(callframe1212);
// compiled call node returning call1216 (depth = 6)
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  objclass715 = obj715->class;
  objclass715->definitionModule = modulename;
  objclass715->definitionLine = 620;
  (*(struct UserObject *)self).data[0] = lowerouter715;
  self = oldself715;
  selfslot = oldselfslot715;
  stackframe = oldstackframe715;
// compiled object node returning obj715 (depth = 5)
  return obj715;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if714 = undefined;
  } else {
  }
// compiled if node returning if714 (depth = 3)
    gc_frame_newslot(if714);
    if707 = if714;
  } else {
  }
// compiled if node returning if707 (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1217 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1217 = alloc_userobj2(45,42, objclass1217);
  gc_frame_newslot(obj1217);
if (objclass1217 == NULL) {
  glfree(obj1217->class->name);
  obj1217->class->name = "collectionsPrelude.list.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1217, self, 0);
  addmethodreal(obj1217,"outer", &reader_collectionsPrelude_outer_1218);
  Object oldself1217 = self;
  struct StackFrameObject *oldstackframe1217 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1217);
  gc_frame_newslot((Object)stackframe);
  self = obj1217;
  Object *oldselfslot1217 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1217 = (*(struct UserObject *)self).data[0], lowerouter1217 = thisouter1217;
  if (inheritingObject1217) {
    struct UserObject *inho1217 = (struct UserObject *)inheritingObject1217;
    while (inho1217->super != GraceDefaultObject) inho1217 = (struct UserObject *)inho1217->super;
    inho1217->super = obj1217;
    self = inheritingObject1217;
    *selfslot = self;
    lowerouter1217 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1217;
  }
if (objclass1217 == NULL) {
  Method *reader1219 = addmethodrealflags(obj1217, "mods",&reader_collectionsPrelude_mods_1219, 0);
  Method *writer1219 = addmethodrealflags(obj1217, "mods:=",&writer_collectionsPrelude_mods_1219, MFLAG_CONFIDENTIAL);
  reader1219->definitionModule = modulename;
  writer1219->definitionModule = modulename;
  reader1219->definitionLine = 882;
  writer1219->definitionLine = 882;
}
obj1217->flags |= OFLAG_MUTABLE;
adddatum2(obj1217, alloc_Undefined(), 1);
if (objclass1217 == NULL) {
  Method *reader1220 = addmethodrealflags(obj1217, "sizeCertain",&reader_collectionsPrelude_sizeCertain_1220, MFLAG_CONFIDENTIAL);
  Method *writer1220 = addmethodrealflags(obj1217, "sizeCertain:=",&writer_collectionsPrelude_sizeCertain_1220, MFLAG_CONFIDENTIAL);
  reader1220->definitionModule = modulename;
  writer1220->definitionModule = modulename;
  reader1220->definitionLine = 883;
  writer1220->definitionLine = 883;
}
obj1217->flags |= OFLAG_MUTABLE;
adddatum2(obj1217, alloc_Undefined(), 2);
if (objclass1217 == NULL) {
  Method *reader1221 = addmethodrealflags(obj1217, "initialSize",&reader_collectionsPrelude_initialSize_1221, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader1221->definitionModule = modulename;
  reader1221->definitionLine = 885;
}
adddatum2(obj1217, alloc_Undefined(), 3);
if (objclass1217 == NULL) {
  Method *reader1222 = addmethodrealflags(obj1217, "inner",&reader_collectionsPrelude_inner_1222, MFLAG_CONFIDENTIAL);
  Method *writer1222 = addmethodrealflags(obj1217, "inner:=",&writer_collectionsPrelude_inner_1222, MFLAG_CONFIDENTIAL);
  reader1222->definitionModule = modulename;
  writer1222->definitionModule = modulename;
  reader1222->definitionLine = 886;
  writer1222->definitionLine = 886;
}
obj1217->flags |= OFLAG_MUTABLE;
adddatum2(obj1217, alloc_Undefined(), 4);
if (objclass1217 == NULL) {
  Method *reader1223 = addmethodrealflags(obj1217, "size",&reader_collectionsPrelude_size_1223, 0);
  Method *writer1223 = addmethodrealflags(obj1217, "size:=",&writer_collectionsPrelude_size_1223, MFLAG_CONFIDENTIAL);
  reader1223->definitionModule = modulename;
  writer1223->definitionModule = modulename;
  reader1223->definitionLine = 887;
  writer1223->definitionLine = 887;
}
obj1217->flags |= OFLAG_MUTABLE;
adddatum2(obj1217, alloc_Undefined(), 5);
// method "boundsCheck"
  block_savedest(obj1217);
  Object closure1224 = createclosure(1, "boundsCheck");
  setclosureframe(closure1224, stackframe);
  addtoclosure(closure1224, var_BoundsError);
  struct UserObject *uo1224 = (struct UserObject*)obj1217;
  uo1224->data[6] = (Object)closure1224;
  Method *meth_meth_collectionsPrelude_boundsCheck1224 = addmethod2pos(obj1217, "boundsCheck", &meth_collectionsPrelude_boundsCheck1224, 6);
  int argcv_meth_collectionsPrelude_boundsCheck1224[] = {1};
  meth_meth_collectionsPrelude_boundsCheck1224->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_boundsCheck1224);
  meth_meth_collectionsPrelude_boundsCheck1224->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_boundsCheck1224->definitionModule = modulename;
  meth_meth_collectionsPrelude_boundsCheck1224->definitionLine = 910;
// method "at"
  struct UserObject *uo1261 = (struct UserObject*)obj1217;
  uo1261->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at1261 = addmethod2pos(obj1217, "at", &meth_collectionsPrelude_at1261, 7);
  int argcv_meth_collectionsPrelude_at1261[] = {1};
  meth_meth_collectionsPrelude_at1261->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at1261);
  meth_meth_collectionsPrelude_at1261->definitionModule = modulename;
  meth_meth_collectionsPrelude_at1261->definitionLine = 915;
// method "at()put"
  struct UserObject *uo1272 = (struct UserObject*)obj1217;
  uo1272->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40__41_put1272 = addmethod2pos(obj1217, "at()put", &meth_collectionsPrelude_at_40__41_put1272, 8);
  int argcv_meth_collectionsPrelude_at_40__41_put1272[] = {1, 1};
  meth_meth_collectionsPrelude_at_40__41_put1272->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40__41_put1272);
  meth_meth_collectionsPrelude_at_40__41_put1272->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40__41_put1272->definitionLine = 919;
// method "add"
  struct UserObject *uo1303 = (struct UserObject*)obj1217;
  uo1303->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_add1303 = addmethod2pos(obj1217, "add", &meth_collectionsPrelude_add1303, 9);
  int argcv_meth_collectionsPrelude_add1303[] = {1};
  meth_meth_collectionsPrelude_add1303->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add1303);
  meth_meth_collectionsPrelude_add1303->definitionModule = modulename;
  meth_meth_collectionsPrelude_add1303->definitionLine = 929;
// method "addAll"
  struct UserObject *uo1346 = (struct UserObject*)obj1217;
  uo1346->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAll1346 = addmethod2pos(obj1217, "addAll", &meth_collectionsPrelude_addAll1346, 10);
  int argcv_meth_collectionsPrelude_addAll1346[] = {1};
  meth_meth_collectionsPrelude_addAll1346->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAll1346);
  meth_meth_collectionsPrelude_addAll1346->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAll1346->definitionLine = 936;
// method "push"
  struct UserObject *uo1410 = (struct UserObject*)obj1217;
  uo1410->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_push1410 = addmethod2pos(obj1217, "push", &meth_collectionsPrelude_push1410, 11);
  int argcv_meth_collectionsPrelude_push1410[] = {1};
  meth_meth_collectionsPrelude_push1410->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_push1410);
  meth_meth_collectionsPrelude_push1410->definitionModule = modulename;
  meth_meth_collectionsPrelude_push1410->definitionLine = 947;
// method "addLast"
  struct UserObject *uo1453 = (struct UserObject*)obj1217;
  uo1453->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addLast1453 = addmethod2pos(obj1217, "addLast", &meth_collectionsPrelude_addLast1453, 12);
  int argcv_meth_collectionsPrelude_addLast1453[] = {1};
  meth_meth_collectionsPrelude_addLast1453->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addLast1453);
  meth_meth_collectionsPrelude_addLast1453->definitionModule = modulename;
  meth_meth_collectionsPrelude_addLast1453->definitionLine = 954;
// method "removeLast"
  struct UserObject *uo1456 = (struct UserObject*)obj1217;
  uo1456->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeLast1456 = addmethod2pos(obj1217, "removeLast", &meth_collectionsPrelude_removeLast1456, 13);
  int argcv_meth_collectionsPrelude_removeLast1456[] = {0};
  meth_meth_collectionsPrelude_removeLast1456->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeLast1456);
  meth_meth_collectionsPrelude_removeLast1456->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeLast1456->definitionLine = 955;
// method "addAllFirst"
  struct UserObject *uo1483 = (struct UserObject*)obj1217;
  uo1483->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAllFirst1483 = addmethod2pos(obj1217, "addAllFirst", &meth_collectionsPrelude_addAllFirst1483, 14);
  int argcv_meth_collectionsPrelude_addAllFirst1483[] = {1};
  meth_meth_collectionsPrelude_addAllFirst1483->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAllFirst1483);
  meth_meth_collectionsPrelude_addAllFirst1483->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAllFirst1483->definitionLine = 961;
// method "addFirst"
  struct UserObject *uo1579 = (struct UserObject*)obj1217;
  uo1579->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addFirst1579 = addmethod2pos(obj1217, "addFirst", &meth_collectionsPrelude_addFirst1579, 15);
  int argcv_meth_collectionsPrelude_addFirst1579[] = {1};
  meth_meth_collectionsPrelude_addFirst1579->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addFirst1579);
  meth_meth_collectionsPrelude_addFirst1579->definitionModule = modulename;
  meth_meth_collectionsPrelude_addFirst1579->definitionLine = 978;
// method "removeFirst"
  struct UserObject *uo1655 = (struct UserObject*)obj1217;
  uo1655->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeFirst1655 = addmethod2pos(obj1217, "removeFirst", &meth_collectionsPrelude_removeFirst1655, 16);
  int argcv_meth_collectionsPrelude_removeFirst1655[] = {0};
  meth_meth_collectionsPrelude_removeFirst1655->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeFirst1655);
  meth_meth_collectionsPrelude_removeFirst1655->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeFirst1655->definitionLine = 990;
// method "removeAt"
  struct UserObject *uo1659 = (struct UserObject*)obj1217;
  uo1659->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAt1659 = addmethod2pos(obj1217, "removeAt", &meth_collectionsPrelude_removeAt1659, 17);
  int argcv_meth_collectionsPrelude_removeAt1659[] = {1};
  meth_meth_collectionsPrelude_removeAt1659->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAt1659);
  meth_meth_collectionsPrelude_removeAt1659->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAt1659->definitionLine = 993;
// method "remove"
  block_savedest(obj1217);
  Object closure1712 = createclosure(1, "remove");
  setclosureframe(closure1712, stackframe);
  addtoclosure(closure1712, var_NoSuchObject);
  struct UserObject *uo1712 = (struct UserObject*)obj1217;
  uo1712->data[18] = (Object)closure1712;
  Method *meth_meth_collectionsPrelude_remove1712 = addmethod2pos(obj1217, "remove", &meth_collectionsPrelude_remove1712, 18);
  int argcv_meth_collectionsPrelude_remove1712[] = {1};
  meth_meth_collectionsPrelude_remove1712->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_remove1712);
  meth_meth_collectionsPrelude_remove1712->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove1712->definitionLine = 1004;
// method "remove()ifAbsent"
  struct UserObject *uo1730 = (struct UserObject*)obj1217;
  uo1730->data[19] = emptyclosure;
  Method *meth_meth_collectionsPrelude_remove_40__41_ifAbsent1730 = addmethod2pos(obj1217, "remove()ifAbsent", &meth_collectionsPrelude_remove_40__41_ifAbsent1730, 19);
  int argcv_meth_collectionsPrelude_remove_40__41_ifAbsent1730[] = {1, 1};
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent1730->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_remove_40__41_ifAbsent1730);
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent1730->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent1730->definitionLine = 1012;
// method "removeAll"
  block_savedest(obj1217);
  Object closure1740 = createclosure(1, "removeAll");
  setclosureframe(closure1740, stackframe);
  addtoclosure(closure1740, var_NoSuchObject);
  struct UserObject *uo1740 = (struct UserObject*)obj1217;
  uo1740->data[20] = (Object)closure1740;
  Method *meth_meth_collectionsPrelude_removeAll1740 = addmethod2pos(obj1217, "removeAll", &meth_collectionsPrelude_removeAll1740, 20);
  int argcv_meth_collectionsPrelude_removeAll1740[] = {1};
  meth_meth_collectionsPrelude_removeAll1740->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAll1740);
  meth_meth_collectionsPrelude_removeAll1740->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll1740->definitionLine = 1021;
// method "removeAll()ifAbsent"
  struct UserObject *uo1749 = (struct UserObject*)obj1217;
  uo1749->data[21] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent1749 = addmethod2pos(obj1217, "removeAll()ifAbsent", &meth_collectionsPrelude_removeAll_40__41_ifAbsent1749, 21);
  int argcv_meth_collectionsPrelude_removeAll_40__41_ifAbsent1749[] = {1, 1};
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent1749->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeAll_40__41_ifAbsent1749);
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent1749->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent1749->definitionLine = 1025;
// method "pop"
  struct UserObject *uo1770 = (struct UserObject*)obj1217;
  uo1770->data[22] = emptyclosure;
  Method *meth_meth_collectionsPrelude_pop1770 = addmethod2pos(obj1217, "pop", &meth_collectionsPrelude_pop1770, 22);
  int argcv_meth_collectionsPrelude_pop1770[] = {0};
  meth_meth_collectionsPrelude_pop1770->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_pop1770);
  meth_meth_collectionsPrelude_pop1770->definitionModule = modulename;
  meth_meth_collectionsPrelude_pop1770->definitionLine = 1036;
// method "reversed"
  struct UserObject *uo1773 = (struct UserObject*)obj1217;
  uo1773->data[23] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reversed1773 = addmethod2pos(obj1217, "reversed", &meth_collectionsPrelude_reversed1773, 23);
  int argcv_meth_collectionsPrelude_reversed1773[] = {0};
  meth_meth_collectionsPrelude_reversed1773->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed1773);
  meth_meth_collectionsPrelude_reversed1773->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed1773->definitionLine = 1037;
// method "reverse"
  struct UserObject *uo1789 = (struct UserObject*)obj1217;
  uo1789->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reverse1789 = addmethod2pos(obj1217, "reverse", &meth_collectionsPrelude_reverse1789, 24);
  int argcv_meth_collectionsPrelude_reverse1789[] = {0};
  meth_meth_collectionsPrelude_reverse1789->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reverse1789);
  meth_meth_collectionsPrelude_reverse1789->definitionModule = modulename;
  meth_meth_collectionsPrelude_reverse1789->definitionLine = 1042;
// method "++"
  struct UserObject *uo1830 = (struct UserObject*)obj1217;
  uo1830->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_1830 = addmethod2pos(obj1217, "++", &meth_collectionsPrelude__43__43_1830, 25);
  int argcv_meth_collectionsPrelude__43__43_1830[] = {1};
  meth_meth_collectionsPrelude__43__43_1830->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_1830);
  meth_meth_collectionsPrelude__43__43_1830->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_1830->definitionLine = 1055;
// method "asString"
  struct UserObject *uo1841 = (struct UserObject*)obj1217;
  uo1841->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString1841 = addmethod2pos(obj1217, "asString", &meth_collectionsPrelude_asString1841, 26);
  int argcv_meth_collectionsPrelude_asString1841[] = {0};
  meth_meth_collectionsPrelude_asString1841->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString1841);
  meth_meth_collectionsPrelude_asString1841->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString1841->definitionLine = 1059;
// method "asDebugString"
  struct UserObject *uo1887 = (struct UserObject*)obj1217;
  uo1887->data[27] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString1887 = addmethod2pos(obj1217, "asDebugString", &meth_collectionsPrelude_asDebugString1887, 27);
  int argcv_meth_collectionsPrelude_asDebugString1887[] = {0};
  meth_meth_collectionsPrelude_asDebugString1887->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString1887);
  meth_meth_collectionsPrelude_asDebugString1887->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString1887->definitionLine = 1067;
// method "contains"
  struct UserObject *uo1933 = (struct UserObject*)obj1217;
  uo1933->data[28] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains1933 = addmethod2pos(obj1217, "contains", &meth_collectionsPrelude_contains1933, 28);
  int argcv_meth_collectionsPrelude_contains1933[] = {1};
  meth_meth_collectionsPrelude_contains1933->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains1933);
  meth_meth_collectionsPrelude_contains1933->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains1933->definitionLine = 1075;
// method "do"
  struct UserObject *uo1945 = (struct UserObject*)obj1217;
  uo1945->data[29] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do1945 = addmethod2pos(obj1217, "do", &meth_collectionsPrelude_do1945, 29);
  int argcv_meth_collectionsPrelude_do1945[] = {1};
  meth_meth_collectionsPrelude_do1945->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do1945);
  meth_meth_collectionsPrelude_do1945->definitionModule = modulename;
  meth_meth_collectionsPrelude_do1945->definitionLine = 1079;
// method "=="
  struct UserObject *uo1971 = (struct UserObject*)obj1217;
  uo1971->data[30] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61_1971 = addmethod2pos(obj1217, "==", &meth_collectionsPrelude__61__61_1971, 30);
  int argcv_meth_collectionsPrelude__61__61_1971[] = {1};
  meth_meth_collectionsPrelude__61__61_1971->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_1971);
  meth_meth_collectionsPrelude__61__61_1971->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_1971->definitionLine = 1087;
// method "iterator"
  block_savedest(obj1217);
  Object closure1978 = createclosure(2, "iterator");
  setclosureframe(closure1978, stackframe);
  addtoclosure(closure1978, var_ConcurrentModification);
  addtoclosure(closure1978, var_IteratorExhausted);
  struct UserObject *uo1978 = (struct UserObject*)obj1217;
  uo1978->data[31] = (Object)closure1978;
  Method *meth_meth_collectionsPrelude_iterator1978 = addmethod2pos(obj1217, "iterator", &meth_collectionsPrelude_iterator1978, 31);
  int argcv_meth_collectionsPrelude_iterator1978[] = {0};
  meth_meth_collectionsPrelude_iterator1978->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator1978);
  meth_meth_collectionsPrelude_iterator1978->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1978->definitionLine = 1090;
  block_savedest(obj1217);
  Object closure2062 = createclosure(2, "iterator()object");
  setclosureframe(closure2062, stackframe);
  addtoclosure(closure2062, var_ConcurrentModification);
  addtoclosure(closure2062, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator1978_object = addmethod2pos(obj1217, "iterator()object", &meth_collectionsPrelude_iterator1978_object, 31);
  meth_meth_collectionsPrelude_iterator1978_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1978_object->definitionLine = 1090;
// method "values"
  struct UserObject *uo2063 = (struct UserObject*)obj1217;
  uo2063->data[32] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values2063 = addmethod2pos(obj1217, "values", &meth_collectionsPrelude_values2063, 32);
  int argcv_meth_collectionsPrelude_values2063[] = {0};
  meth_meth_collectionsPrelude_values2063->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values2063);
  meth_meth_collectionsPrelude_values2063->definitionModule = modulename;
  meth_meth_collectionsPrelude_values2063->definitionLine = 1108;
// method "keys"
  struct UserObject *uo2064 = (struct UserObject*)obj1217;
  uo2064->data[33] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys2064 = addmethod2pos(obj1217, "keys", &meth_collectionsPrelude_keys2064, 33);
  int argcv_meth_collectionsPrelude_keys2064[] = {0};
  meth_meth_collectionsPrelude_keys2064->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys2064);
  meth_meth_collectionsPrelude_keys2064->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys2064->definitionLine = 1111;
// method "expandTo"
  block_savedest(obj1217);
  Object closure2067 = createclosure(1, "expandTo");
  setclosureframe(closure2067, stackframe);
  addtoclosure(closure2067, var__prelude);
  struct UserObject *uo2067 = (struct UserObject*)obj1217;
  uo2067->data[34] = (Object)closure2067;
  Method *meth_meth_collectionsPrelude_expandTo2067 = addmethod2pos(obj1217, "expandTo", &meth_collectionsPrelude_expandTo2067, 34);
  int argcv_meth_collectionsPrelude_expandTo2067[] = {1};
  meth_meth_collectionsPrelude_expandTo2067->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_expandTo2067);
  meth_meth_collectionsPrelude_expandTo2067->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_expandTo2067->definitionModule = modulename;
  meth_meth_collectionsPrelude_expandTo2067->definitionLine = 1114;
// method "sortBy"
  struct UserObject *uo2095 = (struct UserObject*)obj1217;
  uo2095->data[35] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortBy2095 = addmethod2pos(obj1217, "sortBy", &meth_collectionsPrelude_sortBy2095, 35);
  int argcv_meth_collectionsPrelude_sortBy2095[] = {1};
  meth_meth_collectionsPrelude_sortBy2095->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortBy2095);
  meth_meth_collectionsPrelude_sortBy2095->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortBy2095->definitionLine = 1121;
// method "sort"
  struct UserObject *uo2110 = (struct UserObject*)obj1217;
  uo2110->data[36] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sort2110 = addmethod2pos(obj1217, "sort", &meth_collectionsPrelude_sort2110, 36);
  int argcv_meth_collectionsPrelude_sort2110[] = {0};
  meth_meth_collectionsPrelude_sort2110->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sort2110);
  meth_meth_collectionsPrelude_sort2110->definitionModule = modulename;
  meth_meth_collectionsPrelude_sort2110->definitionLine = 1126;
// method "sortedBy"
  struct UserObject *uo2129 = (struct UserObject*)obj1217;
  uo2129->data[37] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy2129 = addmethod2pos(obj1217, "sortedBy", &meth_collectionsPrelude_sortedBy2129, 37);
  int argcv_meth_collectionsPrelude_sortedBy2129[] = {1};
  meth_meth_collectionsPrelude_sortedBy2129->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy2129);
  meth_meth_collectionsPrelude_sortedBy2129->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy2129->definitionLine = 1133;
// method "sorted"
  struct UserObject *uo2134 = (struct UserObject*)obj1217;
  uo2134->data[38] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted2134 = addmethod2pos(obj1217, "sorted", &meth_collectionsPrelude_sorted2134, 38);
  int argcv_meth_collectionsPrelude_sorted2134[] = {0};
  meth_meth_collectionsPrelude_sorted2134->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted2134);
  meth_meth_collectionsPrelude_sorted2134->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted2134->definitionLine = 1136;
// method "copy"
  struct UserObject *uo2139 = (struct UserObject*)obj1217;
  uo2139->data[39] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy2139 = addmethod2pos(obj1217, "copy", &meth_collectionsPrelude_copy2139, 39);
  int argcv_meth_collectionsPrelude_copy2139[] = {0};
  meth_meth_collectionsPrelude_copy2139->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy2139);
  meth_meth_collectionsPrelude_copy2139->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy2139->definitionLine = 1139;
  sourceObject = obj1217;
// Begin line 880
  setline(880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2144 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2145 = callmethod(*var_indexable, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe2144);
// compiled call node returning call2145 (depth = 2)
  struct UserObject *obj1217_uo = (struct UserObject *)obj1217;
  obj1217_uo->super = call2145;
  sourceObject = obj1217;
// Begin line 882
  setline(882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2146 = alloc_Float64(0);
// compiled num node returning num2146 (depth = 2)
  adddatum2(obj1217, num2146, 1);
  sourceObject = obj1217;
// Begin line 883
  setline(883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool2147 = alloc_Boolean(1);
// compiled identifier node returning bool2147 (depth = 2)
  adddatum2(obj1217, bool2147, 2);
  sourceObject = obj1217;
// Begin line 885
  setline(885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2149 = alloc_Float64(1);
// compiled num node returning num2149 (depth = 3)
  int op_slot_right_2148 = gc_frame_newslot(num2149);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2152 = alloc_Float64(2);
// compiled num node returning num2152 (depth = 4)
  int op_slot_right_2151 = gc_frame_newslot(num2152);
// starting to compile call node (depth = 4)
  int callframe2154 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block2155 = alloc_Block(NULL, NULL, "collectionsPrelude", 885);
  gc_frame_newslot(block2155);
// method "_apply"
  block_savedest(block2155);
  Object closure2156 = createclosure(1, "_apply");
  setclosureframe(closure2156, stackframe);
  addtoclosure(closure2156, selfslot);
  struct UserObject *uo2156 = (struct UserObject*)block2155;
  uo2156->data[0] = (Object)closure2156;
  Method *meth_meth_collectionsPrelude__apply2156 = addmethod2pos(block2155, "_apply", &meth_collectionsPrelude__apply2156, 0);
  int argcv_meth_collectionsPrelude__apply2156[] = {0};
  meth_meth_collectionsPrelude__apply2156->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2156);
  meth_meth_collectionsPrelude__apply2156->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2156->definitionLine = 1140;
// compiled block node returning block2155 (depth = 5)
  gc_frame_newslot(block2155);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_a (depth = 5)
  params[0] = block2155;
  partcv[0] = 1;
  Object call2162 = callmethod(*var_a, "sizeIfUnknown",
    1, partcv, params);
  gc_frame_end(callframe2154);
// compiled call node returning call2162 (depth = 4)
  int op_slot_left_2151 = gc_frame_newslot(call2162);
  params[0] = num2152;
  partcv[0] = 1;
  Object prod2163 = callmethod(call2162, "*", 1, partcv, params);
// compiled op node returning prod2163 (depth = 3)
  int op_slot_left_2148 = gc_frame_newslot(prod2163);
  params[0] = num2149;
  partcv[0] = 1;
  Object sum2164 = callmethod(prod2163, "+", 1, partcv, params);
// compiled op node returning sum2164 (depth = 2)
  adddatum2(obj1217, sum2164, 3);
  sourceObject = obj1217;
// Begin line 886
  setline(886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2165 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2166 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2167 = callmethodflags(self, "initialSize", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2166);
// compiled call node returning call2167 (depth = 4)
// compiled member node returning call2167 (depth = 3)
  gc_frame_newslot(call2167);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2168 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var__prelude (depth = 5)
  partcv[0] = 0;
  Object call2169 = callmethod(*var__prelude, "primitiveArray",
    1, partcv, params);
  gc_frame_end(callframe2168);
// compiled call node returning call2169 (depth = 4)
// compiled member node returning call2169 (depth = 3)
  params[0] = call2167;
  partcv[0] = 1;
  Object call2170 = callmethod(call2169, "new",
    1, partcv, params);
  gc_frame_end(callframe2165);
// compiled call node returning call2170 (depth = 2)
  adddatum2(obj1217, call2170, 4);
  sourceObject = obj1217;
// Begin line 887
  setline(887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2171 = alloc_Float64(0);
// compiled num node returning num2171 (depth = 2)
  adddatum2(obj1217, num2171, 5);
  sourceObject = obj1217;
// Begin line 888
  setline(888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2173 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2174 = callmethodflags(self, "sizeCertain", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2173);
// compiled call node returning call2174 (depth = 4)
// compiled member node returning call2174 (depth = 3)
  Object if2172 = done;
struct StackFrameObject *iftmpstackframe2172 = stackframe;
  if (istrue(call2174)) {
stackframe = alloc_StackFrame(0, iftmpstackframe2172);
gc_frame_newslot((Object)stackframe);
// Begin line 890
  setline(890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2175 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_a (depth = 4)
  gc_frame_newslot(*var_a);
// starting to compile block node (depth = 4)
  Object block2176 = alloc_Block(NULL, NULL, "collectionsPrelude", 890);
  gc_frame_newslot(block2176);
// method "_apply"
  block_savedest(block2176);
  Object closure2177 = createclosure(1, "_apply");
  setclosureframe(closure2177, stackframe);
  addtoclosure(closure2177, selfslot);
  struct UserObject *uo2177 = (struct UserObject*)block2176;
  uo2177->data[0] = (Object)closure2177;
  Method *meth_meth_collectionsPrelude__apply2177 = addmethod2pos(block2176, "_apply", &meth_collectionsPrelude__apply2177, 0);
  int argcv_meth_collectionsPrelude__apply2177[] = {1};
  meth_meth_collectionsPrelude__apply2177->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2177);
  meth_meth_collectionsPrelude__apply2177->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2177->definitionLine = 888;
// compiled block node returning block2176 (depth = 4)
  gc_frame_newslot(block2176);
// call case 5: prelude request
  params[0] = *var_a;
  params[1] = block2176;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2193 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2175);
// compiled call node returning call2193 (depth = 3)
    gc_frame_newslot(call2193);
    if2172 = call2193;
  } else {
  stackframe = alloc_StackFrame(1, iftmpstackframe2172);
  gc_frame_newslot((Object)stackframe);
  Object *var_innerSize = &(stackframe->slots[0]);
  setframeelementname(stackframe, 0, "innerSize");
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2194 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2195 = callmethodflags(self, "initialSize", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2194);
// compiled call node returning call2195 (depth = 5)
// compiled member node returning call2195 (depth = 4)
  *var_innerSize = call2195;
  if (call2195 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 897
  setline(897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2196 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_a (depth = 4)
  gc_frame_newslot(*var_a);
// starting to compile block node (depth = 4)
  Object block2197 = alloc_Block(NULL, NULL, "collectionsPrelude", 897);
  gc_frame_newslot(block2197);
// method "_apply"
  block_savedest(block2197);
  Object closure2198 = createclosure(3, "_apply");
  setclosureframe(closure2198, stackframe);
  addtoclosure(closure2198, var_innerSize);
  addtoclosure(closure2198, var__prelude);
  addtoclosure(closure2198, selfslot);
  struct UserObject *uo2198 = (struct UserObject*)block2197;
  uo2198->data[0] = (Object)closure2198;
  Method *meth_meth_collectionsPrelude__apply2198 = addmethod2pos(block2197, "_apply", &meth_collectionsPrelude__apply2198, 0);
  int argcv_meth_collectionsPrelude__apply2198[] = {1};
  meth_meth_collectionsPrelude__apply2198->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2198);
  meth_meth_collectionsPrelude__apply2198->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2198->definitionLine = 896;
// compiled block node returning block2197 (depth = 4)
  gc_frame_newslot(block2197);
// call case 5: prelude request
  params[0] = *var_a;
  params[1] = block2197;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2254 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2196);
// compiled call node returning call2254 (depth = 3)
    gc_frame_newslot(call2254);
    if2172 = call2254;
  }
stackframe = iftmpstackframe2172;
// compiled if node returning if2172 (depth = 2)
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  objclass1217 = obj1217->class;
  objclass1217->definitionModule = modulename;
  objclass1217->definitionLine = 878;
  (*(struct UserObject *)self).data[0] = lowerouter1217;
  self = oldself1217;
  selfslot = oldselfslot1217;
  stackframe = oldstackframe1217;
  gc_frame_end(frame);
  return obj1217;
}
Object meth_collectionsPrelude_withAll706_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "withAll()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method withAll()object");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_done = getfromclosure(closure, 1);
  Object *var_ConcurrentModification = getfromclosure(closure, 2);
  Object *var_IteratorExhausted = getfromclosure(closure, 3);
  Object *var_indexable = getfromclosure(closure, 4);
  Object *var_BoundsError = getfromclosure(closure, 5);
  Object *var__prelude = getfromclosure(closure, 6);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for withAll (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for withAll");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 618
  setline(618);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit709 == NULL) {
    strlit709 = alloc_String("js");
    gc_root(strlit709);
  }
// compiled string node returning strlit709 (depth = 4)
  int op_slot_right_708 = gc_frame_newslot(strlit709);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe711 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call712 = callmethodflags(prelude, "engine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe711);
// compiled call node returning call712 (depth = 5)
// compiled member node returning call712 (depth = 4)
  int op_slot_left_708 = gc_frame_newslot(call712);
  params[0] = strlit709;
  partcv[0] = 1;
  Object opresult713 = callmethod(call712, "==", 1, partcv, params);
// compiled op node returning opresult713 (depth = 3)
  Object if707 = done;
  if (istrue(opresult713)) {
// Begin line 619
  setline(619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile call node (depth = 4)
// compiled call node returning done (depth = 4)
  Object if714 = done;
  if (istrue(done)) {
// Begin line 620
  setline(620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile object node (depth = 5)
  Object inheritingObject715 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj715 = alloc_userobj2(42,40, objclass715);
  gc_frame_newslot(obj715);
// OBJECT OUTER DEC outer
  adddatum2(obj715, self, 0);
  addmethodreal(obj715,"outer", &reader_collectionsPrelude_outer_716);
  Object oldself715 = self;
  struct StackFrameObject *oldstackframe715 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe715);
  gc_frame_newslot((Object)stackframe);
  self = obj715;
  Object *oldselfslot715 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter715 = (*(struct UserObject *)self).data[0], lowerouter715 = thisouter715;
  if (inheritingObject715) {
    struct UserObject *inho715 = (struct UserObject *)inheritingObject715;
    while (inho715->super != GraceDefaultObject) inho715 = (struct UserObject *)inho715->super;
    inho715->super = obj715;
    self = inheritingObject715;
    *selfslot = self;
    lowerouter715 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter715;
  }
if (objclass715 == NULL) {
  Method *reader717 = addmethodrealflags(obj715, "mods",&reader_collectionsPrelude_mods_717, 0);
  Method *writer717 = addmethodrealflags(obj715, "mods:=",&writer_collectionsPrelude_mods_717, MFLAG_CONFIDENTIAL);
  reader717->definitionModule = modulename;
  writer717->definitionModule = modulename;
  reader717->definitionLine = 623;
  writer717->definitionLine = 623;
}
obj715->flags |= OFLAG_MUTABLE;
adddatum2(obj715, alloc_Undefined(), 1);
if (objclass715 == NULL) {
  Method *reader718 = addmethodrealflags(obj715, "sz",&reader_collectionsPrelude_sz_718, MFLAG_CONFIDENTIAL);
  Method *writer718 = addmethodrealflags(obj715, "sz:=",&writer_collectionsPrelude_sz_718, MFLAG_CONFIDENTIAL);
  reader718->definitionModule = modulename;
  writer718->definitionModule = modulename;
  reader718->definitionLine = 624;
  writer718->definitionLine = 624;
}
obj715->flags |= OFLAG_MUTABLE;
adddatum2(obj715, alloc_Undefined(), 2);
if (objclass715 == NULL) {
  Method *reader719 = addmethodrealflags(obj715, "jsArray",&reader_collectionsPrelude_jsArray_719, MFLAG_CONFIDENTIAL);
  Method *writer719 = addmethodrealflags(obj715, "jsArray:=",&writer_collectionsPrelude_jsArray_719, MFLAG_CONFIDENTIAL);
  reader719->definitionModule = modulename;
  writer719->definitionModule = modulename;
  reader719->definitionLine = 625;
  writer719->definitionLine = 625;
}
obj715->flags |= OFLAG_MUTABLE;
adddatum2(obj715, alloc_Undefined(), 3);
// method "size"
  struct UserObject *uo720 = (struct UserObject*)obj715;
  uo720->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size720 = addmethod2pos(obj715, "size", &meth_collectionsPrelude_size720, 4);
  int argcv_meth_collectionsPrelude_size720[] = {0};
  meth_meth_collectionsPrelude_size720->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size720);
  meth_meth_collectionsPrelude_size720->definitionModule = modulename;
  meth_meth_collectionsPrelude_size720->definitionLine = 630;
// method "at"
  struct UserObject *uo723 = (struct UserObject*)obj715;
  uo723->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at723 = addmethod2pos(obj715, "at", &meth_collectionsPrelude_at723, 5);
  int argcv_meth_collectionsPrelude_at723[] = {1};
  meth_meth_collectionsPrelude_at723->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at723);
  meth_meth_collectionsPrelude_at723->definitionModule = modulename;
  meth_meth_collectionsPrelude_at723->definitionLine = 635;
// method "at()put"
  struct UserObject *uo724 = (struct UserObject*)obj715;
  uo724->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40__41_put724 = addmethod2pos(obj715, "at()put", &meth_collectionsPrelude_at_40__41_put724, 6);
  int argcv_meth_collectionsPrelude_at_40__41_put724[] = {1, 1};
  meth_meth_collectionsPrelude_at_40__41_put724->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40__41_put724);
  meth_meth_collectionsPrelude_at_40__41_put724->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40__41_put724->definitionLine = 645;
// method "add"
  struct UserObject *uo733 = (struct UserObject*)obj715;
  uo733->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_add733 = addmethod2pos(obj715, "add", &meth_collectionsPrelude_add733, 7);
  int argcv_meth_collectionsPrelude_add733[] = {1};
  meth_meth_collectionsPrelude_add733->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add733);
  meth_meth_collectionsPrelude_add733->definitionModule = modulename;
  meth_meth_collectionsPrelude_add733->definitionLine = 657;
// method "push"
  struct UserObject *uo742 = (struct UserObject*)obj715;
  uo742->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_push742 = addmethod2pos(obj715, "push", &meth_collectionsPrelude_push742, 8);
  int argcv_meth_collectionsPrelude_push742[] = {1};
  meth_meth_collectionsPrelude_push742->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_push742);
  meth_meth_collectionsPrelude_push742->definitionModule = modulename;
  meth_meth_collectionsPrelude_push742->definitionLine = 663;
// method "removeLast"
  struct UserObject *uo751 = (struct UserObject*)obj715;
  uo751->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeLast751 = addmethod2pos(obj715, "removeLast", &meth_collectionsPrelude_removeLast751, 9);
  int argcv_meth_collectionsPrelude_removeLast751[] = {0};
  meth_meth_collectionsPrelude_removeLast751->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeLast751);
  meth_meth_collectionsPrelude_removeLast751->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeLast751->definitionLine = 669;
// method "addAllFirst"
  struct UserObject *uo760 = (struct UserObject*)obj715;
  uo760->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAllFirst760 = addmethod2pos(obj715, "addAllFirst", &meth_collectionsPrelude_addAllFirst760, 10);
  int argcv_meth_collectionsPrelude_addAllFirst760[] = {1};
  meth_meth_collectionsPrelude_addAllFirst760->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAllFirst760);
  meth_meth_collectionsPrelude_addAllFirst760->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAllFirst760->definitionLine = 679;
// method "removeAt"
  struct UserObject *uo790 = (struct UserObject*)obj715;
  uo790->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAt790 = addmethod2pos(obj715, "removeAt", &meth_collectionsPrelude_removeAt790, 11);
  int argcv_meth_collectionsPrelude_removeAt790[] = {1};
  meth_meth_collectionsPrelude_removeAt790->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAt790);
  meth_meth_collectionsPrelude_removeAt790->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAt790->definitionLine = 690;
// method "sortBy"
  struct UserObject *uo801 = (struct UserObject*)obj715;
  uo801->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortBy801 = addmethod2pos(obj715, "sortBy", &meth_collectionsPrelude_sortBy801, 12);
  int argcv_meth_collectionsPrelude_sortBy801[] = {1};
  meth_meth_collectionsPrelude_sortBy801->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortBy801);
  meth_meth_collectionsPrelude_sortBy801->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortBy801->definitionLine = 697;
// method "addLast"
  struct UserObject *uo810 = (struct UserObject*)obj715;
  uo810->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addLast810 = addmethod2pos(obj715, "addLast", &meth_collectionsPrelude_addLast810, 13);
  int argcv_meth_collectionsPrelude_addLast810[] = {1};
  meth_meth_collectionsPrelude_addLast810->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addLast810);
  meth_meth_collectionsPrelude_addLast810->definitionModule = modulename;
  meth_meth_collectionsPrelude_addLast810->definitionLine = 711;
// method "addAll"
  struct UserObject *uo813 = (struct UserObject*)obj715;
  uo813->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAll813 = addmethod2pos(obj715, "addAll", &meth_collectionsPrelude_addAll813, 14);
  int argcv_meth_collectionsPrelude_addAll813[] = {1};
  meth_meth_collectionsPrelude_addAll813->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAll813);
  meth_meth_collectionsPrelude_addAll813->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAll813->definitionLine = 712;
// method "addFirst"
  struct UserObject *uo821 = (struct UserObject*)obj715;
  uo821->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addFirst821 = addmethod2pos(obj715, "addFirst", &meth_collectionsPrelude_addFirst821, 15);
  int argcv_meth_collectionsPrelude_addFirst821[] = {1};
  meth_meth_collectionsPrelude_addFirst821->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addFirst821);
  meth_meth_collectionsPrelude_addFirst821->definitionModule = modulename;
  meth_meth_collectionsPrelude_addFirst821->definitionLine = 717;
// method "removeFirst"
  struct UserObject *uo830 = (struct UserObject*)obj715;
  uo830->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeFirst830 = addmethod2pos(obj715, "removeFirst", &meth_collectionsPrelude_removeFirst830, 16);
  int argcv_meth_collectionsPrelude_removeFirst830[] = {0};
  meth_meth_collectionsPrelude_removeFirst830->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeFirst830);
  meth_meth_collectionsPrelude_removeFirst830->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeFirst830->definitionLine = 723;
// method "remove"
  block_savedest(obj715);
  Object closure834 = createclosure(1, "remove");
  setclosureframe(closure834, stackframe);
  addtoclosure(closure834, var_NoSuchObject);
  struct UserObject *uo834 = (struct UserObject*)obj715;
  uo834->data[17] = (Object)closure834;
  Method *meth_meth_collectionsPrelude_remove834 = addmethod2pos(obj715, "remove", &meth_collectionsPrelude_remove834, 17);
  int argcv_meth_collectionsPrelude_remove834[] = {1};
  meth_meth_collectionsPrelude_remove834->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_remove834);
  meth_meth_collectionsPrelude_remove834->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove834->definitionLine = 728;
// method "remove()ifAbsent"
  struct UserObject *uo852 = (struct UserObject*)obj715;
  uo852->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_remove_40__41_ifAbsent852 = addmethod2pos(obj715, "remove()ifAbsent", &meth_collectionsPrelude_remove_40__41_ifAbsent852, 18);
  int argcv_meth_collectionsPrelude_remove_40__41_ifAbsent852[] = {1, 1};
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent852->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_remove_40__41_ifAbsent852);
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent852->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent852->definitionLine = 737;
// method "removeAll"
  block_savedest(obj715);
  Object closure862 = createclosure(1, "removeAll");
  setclosureframe(closure862, stackframe);
  addtoclosure(closure862, var_NoSuchObject);
  struct UserObject *uo862 = (struct UserObject*)obj715;
  uo862->data[19] = (Object)closure862;
  Method *meth_meth_collectionsPrelude_removeAll862 = addmethod2pos(obj715, "removeAll", &meth_collectionsPrelude_removeAll862, 19);
  int argcv_meth_collectionsPrelude_removeAll862[] = {1};
  meth_meth_collectionsPrelude_removeAll862->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAll862);
  meth_meth_collectionsPrelude_removeAll862->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll862->definitionLine = 745;
// method "removeAll()ifAbsent"
  struct UserObject *uo871 = (struct UserObject*)obj715;
  uo871->data[20] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent871 = addmethod2pos(obj715, "removeAll()ifAbsent", &meth_collectionsPrelude_removeAll_40__41_ifAbsent871, 20);
  int argcv_meth_collectionsPrelude_removeAll_40__41_ifAbsent871[] = {1, 1};
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent871->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeAll_40__41_ifAbsent871);
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent871->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent871->definitionLine = 750;
// method "pop"
  struct UserObject *uo892 = (struct UserObject*)obj715;
  uo892->data[21] = emptyclosure;
  Method *meth_meth_collectionsPrelude_pop892 = addmethod2pos(obj715, "pop", &meth_collectionsPrelude_pop892, 21);
  int argcv_meth_collectionsPrelude_pop892[] = {0};
  meth_meth_collectionsPrelude_pop892->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_pop892);
  meth_meth_collectionsPrelude_pop892->definitionModule = modulename;
  meth_meth_collectionsPrelude_pop892->definitionLine = 762;
// method "reversed"
  struct UserObject *uo895 = (struct UserObject*)obj715;
  uo895->data[22] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reversed895 = addmethod2pos(obj715, "reversed", &meth_collectionsPrelude_reversed895, 22);
  int argcv_meth_collectionsPrelude_reversed895[] = {0};
  meth_meth_collectionsPrelude_reversed895->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed895);
  meth_meth_collectionsPrelude_reversed895->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed895->definitionLine = 764;
// method "reverse"
  struct UserObject *uo911 = (struct UserObject*)obj715;
  uo911->data[23] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reverse911 = addmethod2pos(obj715, "reverse", &meth_collectionsPrelude_reverse911, 23);
  int argcv_meth_collectionsPrelude_reverse911[] = {0};
  meth_meth_collectionsPrelude_reverse911->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reverse911);
  meth_meth_collectionsPrelude_reverse911->definitionModule = modulename;
  meth_meth_collectionsPrelude_reverse911->definitionLine = 769;
// method "++"
  struct UserObject *uo952 = (struct UserObject*)obj715;
  uo952->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_952 = addmethod2pos(obj715, "++", &meth_collectionsPrelude__43__43_952, 24);
  int argcv_meth_collectionsPrelude__43__43_952[] = {1};
  meth_meth_collectionsPrelude__43__43_952->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_952);
  meth_meth_collectionsPrelude__43__43_952->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_952->definitionLine = 783;
// method "asString"
  struct UserObject *uo963 = (struct UserObject*)obj715;
  uo963->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString963 = addmethod2pos(obj715, "asString", &meth_collectionsPrelude_asString963, 25);
  int argcv_meth_collectionsPrelude_asString963[] = {0};
  meth_meth_collectionsPrelude_asString963->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString963);
  meth_meth_collectionsPrelude_asString963->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString963->definitionLine = 789;
// method "asDebugString"
  struct UserObject *uo997 = (struct UserObject*)obj715;
  uo997->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString997 = addmethod2pos(obj715, "asDebugString", &meth_collectionsPrelude_asDebugString997, 26);
  int argcv_meth_collectionsPrelude_asDebugString997[] = {0};
  meth_meth_collectionsPrelude_asDebugString997->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString997);
  meth_meth_collectionsPrelude_asDebugString997->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString997->definitionLine = 799;
// method "extend"
  block_savedest(obj715);
  Object closure1031 = createclosure(1, "extend");
  setclosureframe(closure1031, stackframe);
  addtoclosure(closure1031, var_done);
  struct UserObject *uo1031 = (struct UserObject*)obj715;
  uo1031->data[27] = (Object)closure1031;
  Method *meth_meth_collectionsPrelude_extend1031 = addmethod2pos(obj715, "extend", &meth_collectionsPrelude_extend1031, 27);
  int argcv_meth_collectionsPrelude_extend1031[] = {1};
  meth_meth_collectionsPrelude_extend1031->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_extend1031);
  meth_meth_collectionsPrelude_extend1031->definitionModule = modulename;
  meth_meth_collectionsPrelude_extend1031->definitionLine = 809;
// method "contains"
  struct UserObject *uo1034 = (struct UserObject*)obj715;
  uo1034->data[28] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains1034 = addmethod2pos(obj715, "contains", &meth_collectionsPrelude_contains1034, 28);
  int argcv_meth_collectionsPrelude_contains1034[] = {1};
  meth_meth_collectionsPrelude_contains1034->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains1034);
  meth_meth_collectionsPrelude_contains1034->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains1034->definitionLine = 812;
// method "do"
  struct UserObject *uo1046 = (struct UserObject*)obj715;
  uo1046->data[29] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do1046 = addmethod2pos(obj715, "do", &meth_collectionsPrelude_do1046, 29);
  int argcv_meth_collectionsPrelude_do1046[] = {1};
  meth_meth_collectionsPrelude_do1046->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do1046);
  meth_meth_collectionsPrelude_do1046->definitionModule = modulename;
  meth_meth_collectionsPrelude_do1046->definitionLine = 817;
// method "=="
  struct UserObject *uo1070 = (struct UserObject*)obj715;
  uo1070->data[30] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61_1070 = addmethod2pos(obj715, "==", &meth_collectionsPrelude__61__61_1070, 30);
  int argcv_meth_collectionsPrelude__61__61_1070[] = {1};
  meth_meth_collectionsPrelude__61__61_1070->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_1070);
  meth_meth_collectionsPrelude__61__61_1070->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_1070->definitionLine = 826;
// method "iterator"
  block_savedest(obj715);
  Object closure1077 = createclosure(2, "iterator");
  setclosureframe(closure1077, stackframe);
  addtoclosure(closure1077, var_ConcurrentModification);
  addtoclosure(closure1077, var_IteratorExhausted);
  struct UserObject *uo1077 = (struct UserObject*)obj715;
  uo1077->data[31] = (Object)closure1077;
  Method *meth_meth_collectionsPrelude_iterator1077 = addmethod2pos(obj715, "iterator", &meth_collectionsPrelude_iterator1077, 31);
  int argcv_meth_collectionsPrelude_iterator1077[] = {0};
  meth_meth_collectionsPrelude_iterator1077->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator1077);
  meth_meth_collectionsPrelude_iterator1077->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1077->definitionLine = 830;
  block_savedest(obj715);
  Object closure1161 = createclosure(2, "iterator()object");
  setclosureframe(closure1161, stackframe);
  addtoclosure(closure1161, var_ConcurrentModification);
  addtoclosure(closure1161, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator1077_object = addmethod2pos(obj715, "iterator()object", &meth_collectionsPrelude_iterator1077_object, 31);
  meth_meth_collectionsPrelude_iterator1077_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1077_object->definitionLine = 830;
// method "values"
  struct UserObject *uo1162 = (struct UserObject*)obj715;
  uo1162->data[32] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values1162 = addmethod2pos(obj715, "values", &meth_collectionsPrelude_values1162, 32);
  int argcv_meth_collectionsPrelude_values1162[] = {0};
  meth_meth_collectionsPrelude_values1162->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values1162);
  meth_meth_collectionsPrelude_values1162->definitionModule = modulename;
  meth_meth_collectionsPrelude_values1162->definitionLine = 849;
// method "keys"
  struct UserObject *uo1163 = (struct UserObject*)obj715;
  uo1163->data[33] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys1163 = addmethod2pos(obj715, "keys", &meth_collectionsPrelude_keys1163, 33);
  int argcv_meth_collectionsPrelude_keys1163[] = {0};
  meth_meth_collectionsPrelude_keys1163->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys1163);
  meth_meth_collectionsPrelude_keys1163->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys1163->definitionLine = 853;
// method "sort"
  struct UserObject *uo1166 = (struct UserObject*)obj715;
  uo1166->data[34] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sort1166 = addmethod2pos(obj715, "sort", &meth_collectionsPrelude_sort1166, 34);
  int argcv_meth_collectionsPrelude_sort1166[] = {0};
  meth_meth_collectionsPrelude_sort1166->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sort1166);
  meth_meth_collectionsPrelude_sort1166->definitionModule = modulename;
  meth_meth_collectionsPrelude_sort1166->definitionLine = 857;
// method "sortedBy"
  struct UserObject *uo1193 = (struct UserObject*)obj715;
  uo1193->data[35] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy1193 = addmethod2pos(obj715, "sortedBy", &meth_collectionsPrelude_sortedBy1193, 35);
  int argcv_meth_collectionsPrelude_sortedBy1193[] = {1};
  meth_meth_collectionsPrelude_sortedBy1193->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy1193);
  meth_meth_collectionsPrelude_sortedBy1193->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy1193->definitionLine = 865;
// method "sorted"
  struct UserObject *uo1198 = (struct UserObject*)obj715;
  uo1198->data[36] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted1198 = addmethod2pos(obj715, "sorted", &meth_collectionsPrelude_sorted1198, 36);
  int argcv_meth_collectionsPrelude_sorted1198[] = {0};
  meth_meth_collectionsPrelude_sorted1198->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted1198);
  meth_meth_collectionsPrelude_sorted1198->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted1198->definitionLine = 868;
// method "copy"
  struct UserObject *uo1203 = (struct UserObject*)obj715;
  uo1203->data[37] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy1203 = addmethod2pos(obj715, "copy", &meth_collectionsPrelude_copy1203, 37);
  int argcv_meth_collectionsPrelude_copy1203[] = {0};
  meth_meth_collectionsPrelude_copy1203->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy1203);
  meth_meth_collectionsPrelude_copy1203->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy1203->definitionLine = 871;
  sourceObject = obj715;
// Begin line 621
  setline(621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1208 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_indexable (depth = 7)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call1209 = callmethod(*var_indexable, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe1208);
// compiled call node returning call1209 (depth = 6)
  struct UserObject *obj715_uo = (struct UserObject *)obj715;
  obj715_uo->super = call1209;
  sourceObject = obj715;
// Begin line 623
  setline(623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num1210 = alloc_Float64(0);
// compiled num node returning num1210 (depth = 6)
  adddatum2(obj715, num1210, 1);
  sourceObject = obj715;
// Begin line 624
  setline(624);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 6)
  Object num1211 = alloc_Float64(0);
// compiled num node returning num1211 (depth = 6)
  adddatum2(obj715, num1211, 2);
  sourceObject = obj715;
// Begin line 625
  setline(625);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
// compiled call node returning done (depth = 6)
  adddatum2(obj715, done, 3);
  sourceObject = obj715;
// Begin line 626
  setline(626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1212 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block1213 = alloc_Block(NULL, NULL, "collectionsPrelude", 626);
  gc_frame_newslot(block1213);
// method "_apply"
  block_savedest(block1213);
  Object closure1214 = createclosure(1, "_apply");
  setclosureframe(closure1214, stackframe);
  addtoclosure(closure1214, selfslot);
  struct UserObject *uo1214 = (struct UserObject*)block1213;
  uo1214->data[0] = (Object)closure1214;
  Method *meth_meth_collectionsPrelude__apply1214 = addmethod2pos(block1213, "_apply", &meth_collectionsPrelude__apply1214, 0);
  int argcv_meth_collectionsPrelude__apply1214[] = {1};
  meth_meth_collectionsPrelude__apply1214->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply1214);
  meth_meth_collectionsPrelude__apply1214->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply1214->definitionLine = 872;
// compiled block node returning block1213 (depth = 7)
  gc_frame_newslot(block1213);
// call case 6: other member request
// Begin line 626
  setline(626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  params[0] = block1213;
  partcv[0] = 1;
  Object call1216 = callmethod(*var_a, "do",
    1, partcv, params);
  gc_frame_end(callframe1212);
// compiled call node returning call1216 (depth = 6)
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  sourceObject = obj715;
  objclass715 = obj715->class;
  objclass715->definitionModule = modulename;
  objclass715->definitionLine = 620;
  (*(struct UserObject *)self).data[0] = lowerouter715;
  self = oldself715;
  selfslot = oldselfslot715;
  stackframe = oldstackframe715;
// compiled object node returning obj715 (depth = 5)
  return obj715;
// compiled return node returning undefined (depth = 4)
    gc_frame_newslot(undefined);
    if714 = undefined;
  } else {
  }
// compiled if node returning if714 (depth = 3)
    gc_frame_newslot(if714);
    if707 = if714;
  } else {
  }
// compiled if node returning if707 (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject1217 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj1217 = alloc_userobj2(45,42, objclass1217);
  gc_frame_newslot(obj1217);
if (objclass1217 == NULL) {
  glfree(obj1217->class->name);
  obj1217->class->name = "collectionsPrelude.list.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj1217, self, 0);
  addmethodreal(obj1217,"outer", &reader_collectionsPrelude_outer_1218);
  Object oldself1217 = self;
  struct StackFrameObject *oldstackframe1217 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe1217);
  gc_frame_newslot((Object)stackframe);
  self = obj1217;
  Object *oldselfslot1217 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter1217 = (*(struct UserObject *)self).data[0], lowerouter1217 = thisouter1217;
  if (inheritingObject1217) {
    struct UserObject *inho1217 = (struct UserObject *)inheritingObject1217;
    while (inho1217->super != GraceDefaultObject) inho1217 = (struct UserObject *)inho1217->super;
    inho1217->super = obj1217;
    self = inheritingObject1217;
    *selfslot = self;
    lowerouter1217 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter1217;
  }
if (objclass1217 == NULL) {
  Method *reader1219 = addmethodrealflags(obj1217, "mods",&reader_collectionsPrelude_mods_1219, 0);
  Method *writer1219 = addmethodrealflags(obj1217, "mods:=",&writer_collectionsPrelude_mods_1219, MFLAG_CONFIDENTIAL);
  reader1219->definitionModule = modulename;
  writer1219->definitionModule = modulename;
  reader1219->definitionLine = 882;
  writer1219->definitionLine = 882;
}
obj1217->flags |= OFLAG_MUTABLE;
adddatum2(obj1217, alloc_Undefined(), 1);
if (objclass1217 == NULL) {
  Method *reader1220 = addmethodrealflags(obj1217, "sizeCertain",&reader_collectionsPrelude_sizeCertain_1220, MFLAG_CONFIDENTIAL);
  Method *writer1220 = addmethodrealflags(obj1217, "sizeCertain:=",&writer_collectionsPrelude_sizeCertain_1220, MFLAG_CONFIDENTIAL);
  reader1220->definitionModule = modulename;
  writer1220->definitionModule = modulename;
  reader1220->definitionLine = 883;
  writer1220->definitionLine = 883;
}
obj1217->flags |= OFLAG_MUTABLE;
adddatum2(obj1217, alloc_Undefined(), 2);
if (objclass1217 == NULL) {
  Method *reader1221 = addmethodrealflags(obj1217, "initialSize",&reader_collectionsPrelude_initialSize_1221, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader1221->definitionModule = modulename;
  reader1221->definitionLine = 885;
}
adddatum2(obj1217, alloc_Undefined(), 3);
if (objclass1217 == NULL) {
  Method *reader1222 = addmethodrealflags(obj1217, "inner",&reader_collectionsPrelude_inner_1222, MFLAG_CONFIDENTIAL);
  Method *writer1222 = addmethodrealflags(obj1217, "inner:=",&writer_collectionsPrelude_inner_1222, MFLAG_CONFIDENTIAL);
  reader1222->definitionModule = modulename;
  writer1222->definitionModule = modulename;
  reader1222->definitionLine = 886;
  writer1222->definitionLine = 886;
}
obj1217->flags |= OFLAG_MUTABLE;
adddatum2(obj1217, alloc_Undefined(), 4);
if (objclass1217 == NULL) {
  Method *reader1223 = addmethodrealflags(obj1217, "size",&reader_collectionsPrelude_size_1223, 0);
  Method *writer1223 = addmethodrealflags(obj1217, "size:=",&writer_collectionsPrelude_size_1223, MFLAG_CONFIDENTIAL);
  reader1223->definitionModule = modulename;
  writer1223->definitionModule = modulename;
  reader1223->definitionLine = 887;
  writer1223->definitionLine = 887;
}
obj1217->flags |= OFLAG_MUTABLE;
adddatum2(obj1217, alloc_Undefined(), 5);
// method "boundsCheck"
  block_savedest(obj1217);
  Object closure1224 = createclosure(1, "boundsCheck");
  setclosureframe(closure1224, stackframe);
  addtoclosure(closure1224, var_BoundsError);
  struct UserObject *uo1224 = (struct UserObject*)obj1217;
  uo1224->data[6] = (Object)closure1224;
  Method *meth_meth_collectionsPrelude_boundsCheck1224 = addmethod2pos(obj1217, "boundsCheck", &meth_collectionsPrelude_boundsCheck1224, 6);
  int argcv_meth_collectionsPrelude_boundsCheck1224[] = {1};
  meth_meth_collectionsPrelude_boundsCheck1224->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_boundsCheck1224);
  meth_meth_collectionsPrelude_boundsCheck1224->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_boundsCheck1224->definitionModule = modulename;
  meth_meth_collectionsPrelude_boundsCheck1224->definitionLine = 910;
// method "at"
  struct UserObject *uo1261 = (struct UserObject*)obj1217;
  uo1261->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at1261 = addmethod2pos(obj1217, "at", &meth_collectionsPrelude_at1261, 7);
  int argcv_meth_collectionsPrelude_at1261[] = {1};
  meth_meth_collectionsPrelude_at1261->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at1261);
  meth_meth_collectionsPrelude_at1261->definitionModule = modulename;
  meth_meth_collectionsPrelude_at1261->definitionLine = 915;
// method "at()put"
  struct UserObject *uo1272 = (struct UserObject*)obj1217;
  uo1272->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40__41_put1272 = addmethod2pos(obj1217, "at()put", &meth_collectionsPrelude_at_40__41_put1272, 8);
  int argcv_meth_collectionsPrelude_at_40__41_put1272[] = {1, 1};
  meth_meth_collectionsPrelude_at_40__41_put1272->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40__41_put1272);
  meth_meth_collectionsPrelude_at_40__41_put1272->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40__41_put1272->definitionLine = 919;
// method "add"
  struct UserObject *uo1303 = (struct UserObject*)obj1217;
  uo1303->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_add1303 = addmethod2pos(obj1217, "add", &meth_collectionsPrelude_add1303, 9);
  int argcv_meth_collectionsPrelude_add1303[] = {1};
  meth_meth_collectionsPrelude_add1303->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add1303);
  meth_meth_collectionsPrelude_add1303->definitionModule = modulename;
  meth_meth_collectionsPrelude_add1303->definitionLine = 929;
// method "addAll"
  struct UserObject *uo1346 = (struct UserObject*)obj1217;
  uo1346->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAll1346 = addmethod2pos(obj1217, "addAll", &meth_collectionsPrelude_addAll1346, 10);
  int argcv_meth_collectionsPrelude_addAll1346[] = {1};
  meth_meth_collectionsPrelude_addAll1346->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAll1346);
  meth_meth_collectionsPrelude_addAll1346->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAll1346->definitionLine = 936;
// method "push"
  struct UserObject *uo1410 = (struct UserObject*)obj1217;
  uo1410->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_push1410 = addmethod2pos(obj1217, "push", &meth_collectionsPrelude_push1410, 11);
  int argcv_meth_collectionsPrelude_push1410[] = {1};
  meth_meth_collectionsPrelude_push1410->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_push1410);
  meth_meth_collectionsPrelude_push1410->definitionModule = modulename;
  meth_meth_collectionsPrelude_push1410->definitionLine = 947;
// method "addLast"
  struct UserObject *uo1453 = (struct UserObject*)obj1217;
  uo1453->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addLast1453 = addmethod2pos(obj1217, "addLast", &meth_collectionsPrelude_addLast1453, 12);
  int argcv_meth_collectionsPrelude_addLast1453[] = {1};
  meth_meth_collectionsPrelude_addLast1453->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addLast1453);
  meth_meth_collectionsPrelude_addLast1453->definitionModule = modulename;
  meth_meth_collectionsPrelude_addLast1453->definitionLine = 954;
// method "removeLast"
  struct UserObject *uo1456 = (struct UserObject*)obj1217;
  uo1456->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeLast1456 = addmethod2pos(obj1217, "removeLast", &meth_collectionsPrelude_removeLast1456, 13);
  int argcv_meth_collectionsPrelude_removeLast1456[] = {0};
  meth_meth_collectionsPrelude_removeLast1456->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeLast1456);
  meth_meth_collectionsPrelude_removeLast1456->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeLast1456->definitionLine = 955;
// method "addAllFirst"
  struct UserObject *uo1483 = (struct UserObject*)obj1217;
  uo1483->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAllFirst1483 = addmethod2pos(obj1217, "addAllFirst", &meth_collectionsPrelude_addAllFirst1483, 14);
  int argcv_meth_collectionsPrelude_addAllFirst1483[] = {1};
  meth_meth_collectionsPrelude_addAllFirst1483->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAllFirst1483);
  meth_meth_collectionsPrelude_addAllFirst1483->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAllFirst1483->definitionLine = 961;
// method "addFirst"
  struct UserObject *uo1579 = (struct UserObject*)obj1217;
  uo1579->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addFirst1579 = addmethod2pos(obj1217, "addFirst", &meth_collectionsPrelude_addFirst1579, 15);
  int argcv_meth_collectionsPrelude_addFirst1579[] = {1};
  meth_meth_collectionsPrelude_addFirst1579->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addFirst1579);
  meth_meth_collectionsPrelude_addFirst1579->definitionModule = modulename;
  meth_meth_collectionsPrelude_addFirst1579->definitionLine = 978;
// method "removeFirst"
  struct UserObject *uo1655 = (struct UserObject*)obj1217;
  uo1655->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeFirst1655 = addmethod2pos(obj1217, "removeFirst", &meth_collectionsPrelude_removeFirst1655, 16);
  int argcv_meth_collectionsPrelude_removeFirst1655[] = {0};
  meth_meth_collectionsPrelude_removeFirst1655->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeFirst1655);
  meth_meth_collectionsPrelude_removeFirst1655->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeFirst1655->definitionLine = 990;
// method "removeAt"
  struct UserObject *uo1659 = (struct UserObject*)obj1217;
  uo1659->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAt1659 = addmethod2pos(obj1217, "removeAt", &meth_collectionsPrelude_removeAt1659, 17);
  int argcv_meth_collectionsPrelude_removeAt1659[] = {1};
  meth_meth_collectionsPrelude_removeAt1659->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAt1659);
  meth_meth_collectionsPrelude_removeAt1659->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAt1659->definitionLine = 993;
// method "remove"
  block_savedest(obj1217);
  Object closure1712 = createclosure(1, "remove");
  setclosureframe(closure1712, stackframe);
  addtoclosure(closure1712, var_NoSuchObject);
  struct UserObject *uo1712 = (struct UserObject*)obj1217;
  uo1712->data[18] = (Object)closure1712;
  Method *meth_meth_collectionsPrelude_remove1712 = addmethod2pos(obj1217, "remove", &meth_collectionsPrelude_remove1712, 18);
  int argcv_meth_collectionsPrelude_remove1712[] = {1};
  meth_meth_collectionsPrelude_remove1712->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_remove1712);
  meth_meth_collectionsPrelude_remove1712->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove1712->definitionLine = 1004;
// method "remove()ifAbsent"
  struct UserObject *uo1730 = (struct UserObject*)obj1217;
  uo1730->data[19] = emptyclosure;
  Method *meth_meth_collectionsPrelude_remove_40__41_ifAbsent1730 = addmethod2pos(obj1217, "remove()ifAbsent", &meth_collectionsPrelude_remove_40__41_ifAbsent1730, 19);
  int argcv_meth_collectionsPrelude_remove_40__41_ifAbsent1730[] = {1, 1};
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent1730->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_remove_40__41_ifAbsent1730);
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent1730->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent1730->definitionLine = 1012;
// method "removeAll"
  block_savedest(obj1217);
  Object closure1740 = createclosure(1, "removeAll");
  setclosureframe(closure1740, stackframe);
  addtoclosure(closure1740, var_NoSuchObject);
  struct UserObject *uo1740 = (struct UserObject*)obj1217;
  uo1740->data[20] = (Object)closure1740;
  Method *meth_meth_collectionsPrelude_removeAll1740 = addmethod2pos(obj1217, "removeAll", &meth_collectionsPrelude_removeAll1740, 20);
  int argcv_meth_collectionsPrelude_removeAll1740[] = {1};
  meth_meth_collectionsPrelude_removeAll1740->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAll1740);
  meth_meth_collectionsPrelude_removeAll1740->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll1740->definitionLine = 1021;
// method "removeAll()ifAbsent"
  struct UserObject *uo1749 = (struct UserObject*)obj1217;
  uo1749->data[21] = emptyclosure;
  Method *meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent1749 = addmethod2pos(obj1217, "removeAll()ifAbsent", &meth_collectionsPrelude_removeAll_40__41_ifAbsent1749, 21);
  int argcv_meth_collectionsPrelude_removeAll_40__41_ifAbsent1749[] = {1, 1};
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent1749->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeAll_40__41_ifAbsent1749);
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent1749->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent1749->definitionLine = 1025;
// method "pop"
  struct UserObject *uo1770 = (struct UserObject*)obj1217;
  uo1770->data[22] = emptyclosure;
  Method *meth_meth_collectionsPrelude_pop1770 = addmethod2pos(obj1217, "pop", &meth_collectionsPrelude_pop1770, 22);
  int argcv_meth_collectionsPrelude_pop1770[] = {0};
  meth_meth_collectionsPrelude_pop1770->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_pop1770);
  meth_meth_collectionsPrelude_pop1770->definitionModule = modulename;
  meth_meth_collectionsPrelude_pop1770->definitionLine = 1036;
// method "reversed"
  struct UserObject *uo1773 = (struct UserObject*)obj1217;
  uo1773->data[23] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reversed1773 = addmethod2pos(obj1217, "reversed", &meth_collectionsPrelude_reversed1773, 23);
  int argcv_meth_collectionsPrelude_reversed1773[] = {0};
  meth_meth_collectionsPrelude_reversed1773->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed1773);
  meth_meth_collectionsPrelude_reversed1773->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed1773->definitionLine = 1037;
// method "reverse"
  struct UserObject *uo1789 = (struct UserObject*)obj1217;
  uo1789->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reverse1789 = addmethod2pos(obj1217, "reverse", &meth_collectionsPrelude_reverse1789, 24);
  int argcv_meth_collectionsPrelude_reverse1789[] = {0};
  meth_meth_collectionsPrelude_reverse1789->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reverse1789);
  meth_meth_collectionsPrelude_reverse1789->definitionModule = modulename;
  meth_meth_collectionsPrelude_reverse1789->definitionLine = 1042;
// method "++"
  struct UserObject *uo1830 = (struct UserObject*)obj1217;
  uo1830->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_1830 = addmethod2pos(obj1217, "++", &meth_collectionsPrelude__43__43_1830, 25);
  int argcv_meth_collectionsPrelude__43__43_1830[] = {1};
  meth_meth_collectionsPrelude__43__43_1830->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_1830);
  meth_meth_collectionsPrelude__43__43_1830->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_1830->definitionLine = 1055;
// method "asString"
  struct UserObject *uo1841 = (struct UserObject*)obj1217;
  uo1841->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString1841 = addmethod2pos(obj1217, "asString", &meth_collectionsPrelude_asString1841, 26);
  int argcv_meth_collectionsPrelude_asString1841[] = {0};
  meth_meth_collectionsPrelude_asString1841->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString1841);
  meth_meth_collectionsPrelude_asString1841->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString1841->definitionLine = 1059;
// method "asDebugString"
  struct UserObject *uo1887 = (struct UserObject*)obj1217;
  uo1887->data[27] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString1887 = addmethod2pos(obj1217, "asDebugString", &meth_collectionsPrelude_asDebugString1887, 27);
  int argcv_meth_collectionsPrelude_asDebugString1887[] = {0};
  meth_meth_collectionsPrelude_asDebugString1887->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString1887);
  meth_meth_collectionsPrelude_asDebugString1887->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString1887->definitionLine = 1067;
// method "contains"
  struct UserObject *uo1933 = (struct UserObject*)obj1217;
  uo1933->data[28] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains1933 = addmethod2pos(obj1217, "contains", &meth_collectionsPrelude_contains1933, 28);
  int argcv_meth_collectionsPrelude_contains1933[] = {1};
  meth_meth_collectionsPrelude_contains1933->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains1933);
  meth_meth_collectionsPrelude_contains1933->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains1933->definitionLine = 1075;
// method "do"
  struct UserObject *uo1945 = (struct UserObject*)obj1217;
  uo1945->data[29] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do1945 = addmethod2pos(obj1217, "do", &meth_collectionsPrelude_do1945, 29);
  int argcv_meth_collectionsPrelude_do1945[] = {1};
  meth_meth_collectionsPrelude_do1945->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do1945);
  meth_meth_collectionsPrelude_do1945->definitionModule = modulename;
  meth_meth_collectionsPrelude_do1945->definitionLine = 1079;
// method "=="
  struct UserObject *uo1971 = (struct UserObject*)obj1217;
  uo1971->data[30] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61_1971 = addmethod2pos(obj1217, "==", &meth_collectionsPrelude__61__61_1971, 30);
  int argcv_meth_collectionsPrelude__61__61_1971[] = {1};
  meth_meth_collectionsPrelude__61__61_1971->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_1971);
  meth_meth_collectionsPrelude__61__61_1971->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_1971->definitionLine = 1087;
// method "iterator"
  block_savedest(obj1217);
  Object closure1978 = createclosure(2, "iterator");
  setclosureframe(closure1978, stackframe);
  addtoclosure(closure1978, var_ConcurrentModification);
  addtoclosure(closure1978, var_IteratorExhausted);
  struct UserObject *uo1978 = (struct UserObject*)obj1217;
  uo1978->data[31] = (Object)closure1978;
  Method *meth_meth_collectionsPrelude_iterator1978 = addmethod2pos(obj1217, "iterator", &meth_collectionsPrelude_iterator1978, 31);
  int argcv_meth_collectionsPrelude_iterator1978[] = {0};
  meth_meth_collectionsPrelude_iterator1978->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator1978);
  meth_meth_collectionsPrelude_iterator1978->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1978->definitionLine = 1090;
  block_savedest(obj1217);
  Object closure2062 = createclosure(2, "iterator()object");
  setclosureframe(closure2062, stackframe);
  addtoclosure(closure2062, var_ConcurrentModification);
  addtoclosure(closure2062, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator1978_object = addmethod2pos(obj1217, "iterator()object", &meth_collectionsPrelude_iterator1978_object, 31);
  meth_meth_collectionsPrelude_iterator1978_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator1978_object->definitionLine = 1090;
// method "values"
  struct UserObject *uo2063 = (struct UserObject*)obj1217;
  uo2063->data[32] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values2063 = addmethod2pos(obj1217, "values", &meth_collectionsPrelude_values2063, 32);
  int argcv_meth_collectionsPrelude_values2063[] = {0};
  meth_meth_collectionsPrelude_values2063->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values2063);
  meth_meth_collectionsPrelude_values2063->definitionModule = modulename;
  meth_meth_collectionsPrelude_values2063->definitionLine = 1108;
// method "keys"
  struct UserObject *uo2064 = (struct UserObject*)obj1217;
  uo2064->data[33] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys2064 = addmethod2pos(obj1217, "keys", &meth_collectionsPrelude_keys2064, 33);
  int argcv_meth_collectionsPrelude_keys2064[] = {0};
  meth_meth_collectionsPrelude_keys2064->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys2064);
  meth_meth_collectionsPrelude_keys2064->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys2064->definitionLine = 1111;
// method "expandTo"
  block_savedest(obj1217);
  Object closure2067 = createclosure(1, "expandTo");
  setclosureframe(closure2067, stackframe);
  addtoclosure(closure2067, var__prelude);
  struct UserObject *uo2067 = (struct UserObject*)obj1217;
  uo2067->data[34] = (Object)closure2067;
  Method *meth_meth_collectionsPrelude_expandTo2067 = addmethod2pos(obj1217, "expandTo", &meth_collectionsPrelude_expandTo2067, 34);
  int argcv_meth_collectionsPrelude_expandTo2067[] = {1};
  meth_meth_collectionsPrelude_expandTo2067->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_expandTo2067);
  meth_meth_collectionsPrelude_expandTo2067->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_expandTo2067->definitionModule = modulename;
  meth_meth_collectionsPrelude_expandTo2067->definitionLine = 1114;
// method "sortBy"
  struct UserObject *uo2095 = (struct UserObject*)obj1217;
  uo2095->data[35] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortBy2095 = addmethod2pos(obj1217, "sortBy", &meth_collectionsPrelude_sortBy2095, 35);
  int argcv_meth_collectionsPrelude_sortBy2095[] = {1};
  meth_meth_collectionsPrelude_sortBy2095->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortBy2095);
  meth_meth_collectionsPrelude_sortBy2095->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortBy2095->definitionLine = 1121;
// method "sort"
  struct UserObject *uo2110 = (struct UserObject*)obj1217;
  uo2110->data[36] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sort2110 = addmethod2pos(obj1217, "sort", &meth_collectionsPrelude_sort2110, 36);
  int argcv_meth_collectionsPrelude_sort2110[] = {0};
  meth_meth_collectionsPrelude_sort2110->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sort2110);
  meth_meth_collectionsPrelude_sort2110->definitionModule = modulename;
  meth_meth_collectionsPrelude_sort2110->definitionLine = 1126;
// method "sortedBy"
  struct UserObject *uo2129 = (struct UserObject*)obj1217;
  uo2129->data[37] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy2129 = addmethod2pos(obj1217, "sortedBy", &meth_collectionsPrelude_sortedBy2129, 37);
  int argcv_meth_collectionsPrelude_sortedBy2129[] = {1};
  meth_meth_collectionsPrelude_sortedBy2129->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy2129);
  meth_meth_collectionsPrelude_sortedBy2129->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy2129->definitionLine = 1133;
// method "sorted"
  struct UserObject *uo2134 = (struct UserObject*)obj1217;
  uo2134->data[38] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted2134 = addmethod2pos(obj1217, "sorted", &meth_collectionsPrelude_sorted2134, 38);
  int argcv_meth_collectionsPrelude_sorted2134[] = {0};
  meth_meth_collectionsPrelude_sorted2134->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted2134);
  meth_meth_collectionsPrelude_sorted2134->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted2134->definitionLine = 1136;
// method "copy"
  struct UserObject *uo2139 = (struct UserObject*)obj1217;
  uo2139->data[39] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy2139 = addmethod2pos(obj1217, "copy", &meth_collectionsPrelude_copy2139, 39);
  int argcv_meth_collectionsPrelude_copy2139[] = {0};
  meth_meth_collectionsPrelude_copy2139->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy2139);
  meth_meth_collectionsPrelude_copy2139->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy2139->definitionLine = 1139;
  sourceObject = obj1217;
// Begin line 880
  setline(880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2144 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call2145 = callmethod(*var_indexable, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe2144);
// compiled call node returning call2145 (depth = 2)
  struct UserObject *obj1217_uo = (struct UserObject *)obj1217;
  obj1217_uo->super = call2145;
  sourceObject = obj1217;
// Begin line 882
  setline(882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2146 = alloc_Float64(0);
// compiled num node returning num2146 (depth = 2)
  adddatum2(obj1217, num2146, 1);
  sourceObject = obj1217;
// Begin line 883
  setline(883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool2147 = alloc_Boolean(1);
// compiled identifier node returning bool2147 (depth = 2)
  adddatum2(obj1217, bool2147, 2);
  sourceObject = obj1217;
// Begin line 885
  setline(885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2149 = alloc_Float64(1);
// compiled num node returning num2149 (depth = 3)
  int op_slot_right_2148 = gc_frame_newslot(num2149);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2152 = alloc_Float64(2);
// compiled num node returning num2152 (depth = 4)
  int op_slot_right_2151 = gc_frame_newslot(num2152);
// starting to compile call node (depth = 4)
  int callframe2154 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block2155 = alloc_Block(NULL, NULL, "collectionsPrelude", 885);
  gc_frame_newslot(block2155);
// method "_apply"
  block_savedest(block2155);
  Object closure2156 = createclosure(1, "_apply");
  setclosureframe(closure2156, stackframe);
  addtoclosure(closure2156, selfslot);
  struct UserObject *uo2156 = (struct UserObject*)block2155;
  uo2156->data[0] = (Object)closure2156;
  Method *meth_meth_collectionsPrelude__apply2156 = addmethod2pos(block2155, "_apply", &meth_collectionsPrelude__apply2156, 0);
  int argcv_meth_collectionsPrelude__apply2156[] = {0};
  meth_meth_collectionsPrelude__apply2156->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2156);
  meth_meth_collectionsPrelude__apply2156->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2156->definitionLine = 1140;
// compiled block node returning block2155 (depth = 5)
  gc_frame_newslot(block2155);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_a (depth = 5)
  params[0] = block2155;
  partcv[0] = 1;
  Object call2162 = callmethod(*var_a, "sizeIfUnknown",
    1, partcv, params);
  gc_frame_end(callframe2154);
// compiled call node returning call2162 (depth = 4)
  int op_slot_left_2151 = gc_frame_newslot(call2162);
  params[0] = num2152;
  partcv[0] = 1;
  Object prod2163 = callmethod(call2162, "*", 1, partcv, params);
// compiled op node returning prod2163 (depth = 3)
  int op_slot_left_2148 = gc_frame_newslot(prod2163);
  params[0] = num2149;
  partcv[0] = 1;
  Object sum2164 = callmethod(prod2163, "+", 1, partcv, params);
// compiled op node returning sum2164 (depth = 2)
  adddatum2(obj1217, sum2164, 3);
  sourceObject = obj1217;
// Begin line 886
  setline(886);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2165 = gc_frame_new();
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2166 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2167 = callmethodflags(self, "initialSize", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2166);
// compiled call node returning call2167 (depth = 4)
// compiled member node returning call2167 (depth = 3)
  gc_frame_newslot(call2167);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2168 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var__prelude (depth = 5)
  partcv[0] = 0;
  Object call2169 = callmethod(*var__prelude, "primitiveArray",
    1, partcv, params);
  gc_frame_end(callframe2168);
// compiled call node returning call2169 (depth = 4)
// compiled member node returning call2169 (depth = 3)
  params[0] = call2167;
  partcv[0] = 1;
  Object call2170 = callmethod(call2169, "new",
    1, partcv, params);
  gc_frame_end(callframe2165);
// compiled call node returning call2170 (depth = 2)
  adddatum2(obj1217, call2170, 4);
  sourceObject = obj1217;
// Begin line 887
  setline(887);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2171 = alloc_Float64(0);
// compiled num node returning num2171 (depth = 2)
  adddatum2(obj1217, num2171, 5);
  sourceObject = obj1217;
// Begin line 888
  setline(888);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2173 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2174 = callmethodflags(self, "sizeCertain", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2173);
// compiled call node returning call2174 (depth = 4)
// compiled member node returning call2174 (depth = 3)
  Object if2172 = done;
struct StackFrameObject *iftmpstackframe2172 = stackframe;
  if (istrue(call2174)) {
stackframe = alloc_StackFrame(0, iftmpstackframe2172);
gc_frame_newslot((Object)stackframe);
// Begin line 890
  setline(890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2175 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_a (depth = 4)
  gc_frame_newslot(*var_a);
// starting to compile block node (depth = 4)
  Object block2176 = alloc_Block(NULL, NULL, "collectionsPrelude", 890);
  gc_frame_newslot(block2176);
// method "_apply"
  block_savedest(block2176);
  Object closure2177 = createclosure(1, "_apply");
  setclosureframe(closure2177, stackframe);
  addtoclosure(closure2177, selfslot);
  struct UserObject *uo2177 = (struct UserObject*)block2176;
  uo2177->data[0] = (Object)closure2177;
  Method *meth_meth_collectionsPrelude__apply2177 = addmethod2pos(block2176, "_apply", &meth_collectionsPrelude__apply2177, 0);
  int argcv_meth_collectionsPrelude__apply2177[] = {1};
  meth_meth_collectionsPrelude__apply2177->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2177);
  meth_meth_collectionsPrelude__apply2177->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2177->definitionLine = 888;
// compiled block node returning block2176 (depth = 4)
  gc_frame_newslot(block2176);
// call case 5: prelude request
  params[0] = *var_a;
  params[1] = block2176;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2193 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2175);
// compiled call node returning call2193 (depth = 3)
    gc_frame_newslot(call2193);
    if2172 = call2193;
  } else {
  stackframe = alloc_StackFrame(1, iftmpstackframe2172);
  gc_frame_newslot((Object)stackframe);
  Object *var_innerSize = &(stackframe->slots[0]);
  setframeelementname(stackframe, 0, "innerSize");
// Begin line 896
  setline(896);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2194 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2195 = callmethodflags(self, "initialSize", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2194);
// compiled call node returning call2195 (depth = 5)
// compiled member node returning call2195 (depth = 4)
  *var_innerSize = call2195;
  if (call2195 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 897
  setline(897);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2196 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_a (depth = 4)
  gc_frame_newslot(*var_a);
// starting to compile block node (depth = 4)
  Object block2197 = alloc_Block(NULL, NULL, "collectionsPrelude", 897);
  gc_frame_newslot(block2197);
// method "_apply"
  block_savedest(block2197);
  Object closure2198 = createclosure(3, "_apply");
  setclosureframe(closure2198, stackframe);
  addtoclosure(closure2198, var_innerSize);
  addtoclosure(closure2198, var__prelude);
  addtoclosure(closure2198, selfslot);
  struct UserObject *uo2198 = (struct UserObject*)block2197;
  uo2198->data[0] = (Object)closure2198;
  Method *meth_meth_collectionsPrelude__apply2198 = addmethod2pos(block2197, "_apply", &meth_collectionsPrelude__apply2198, 0);
  int argcv_meth_collectionsPrelude__apply2198[] = {1};
  meth_meth_collectionsPrelude__apply2198->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2198);
  meth_meth_collectionsPrelude__apply2198->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2198->definitionLine = 896;
// compiled block node returning block2197 (depth = 4)
  gc_frame_newslot(block2197);
// call case 5: prelude request
  params[0] = *var_a;
  params[1] = block2197;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2254 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2196);
// compiled call node returning call2254 (depth = 3)
    gc_frame_newslot(call2254);
    if2172 = call2254;
  }
stackframe = iftmpstackframe2172;
// compiled if node returning if2172 (depth = 2)
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  sourceObject = obj1217;
  objclass1217 = obj1217->class;
  objclass1217->definitionModule = modulename;
  objclass1217->definitionLine = 878;
  (*(struct UserObject *)self).data[0] = lowerouter1217;
  self = oldself1217;
  selfslot = oldselfslot1217;
  stackframe = oldstackframe1217;
  gc_frame_end(frame);
  return obj1217;
}
Object meth_collectionsPrelude_list698(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "list");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object *var_done = getfromclosure(closure, 2);
  Object *var_ConcurrentModification = getfromclosure(closure, 3);
  Object *var_IteratorExhausted = getfromclosure(closure, 4);
  Object *var_indexable = getfromclosure(closure, 5);
  Object *var_BoundsError = getfromclosure(closure, 6);
  Object *var__prelude = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for list (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for list");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject699 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj699 = alloc_userobj2(4,5, objclass699);
  gc_frame_newslot(obj699);
if (objclass699 == NULL) {
  glfree(obj699->class->name);
  obj699->class->name = "collectionsPrelude.list";
}
// OBJECT OUTER DEC outer
  adddatum2(obj699, self, 0);
  addmethodreal(obj699,"outer", &reader_collectionsPrelude_outer_700);
  Object oldself699 = self;
  struct StackFrameObject *oldstackframe699 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe699);
  gc_frame_newslot((Object)stackframe);
  self = obj699;
  Object *oldselfslot699 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter699 = (*(struct UserObject *)self).data[0], lowerouter699 = thisouter699;
  if (inheritingObject699) {
    struct UserObject *inho699 = (struct UserObject *)inheritingObject699;
    while (inho699->super != GraceDefaultObject) inho699 = (struct UserObject *)inho699->super;
    inho699->super = obj699;
    self = inheritingObject699;
    *selfslot = self;
    lowerouter699 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter699;
  }
// method "asString"
  struct UserObject *uo701 = (struct UserObject*)obj699;
  uo701->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString701 = addmethod2pos(obj699, "asString", &meth_collectionsPrelude_asString701, 1);
  int argcv_meth_collectionsPrelude_asString701[] = {0};
  meth_meth_collectionsPrelude_asString701->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString701);
  meth_meth_collectionsPrelude_asString701->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString701->definitionLine = 611;
// method "empty"
  block_savedest(obj699);
  Object closure703 = createclosure(1, "empty");
  setclosureframe(closure703, stackframe);
  addtoclosure(closure703, var_emptySequence);
  struct UserObject *uo703 = (struct UserObject*)obj699;
  uo703->data[2] = (Object)closure703;
  Method *meth_meth_collectionsPrelude_empty703 = addmethod2pos(obj699, "empty", &meth_collectionsPrelude_empty703, 2);
  int argcv_meth_collectionsPrelude_empty703[] = {0};
  meth_meth_collectionsPrelude_empty703->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_empty703);
  meth_meth_collectionsPrelude_empty703->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty703->definitionLine = 613;
// method "withAll"
  block_savedest(obj699);
  Object closure706 = createclosure(7, "withAll");
  setclosureframe(closure706, stackframe);
  addtoclosure(closure706, var_NoSuchObject);
  addtoclosure(closure706, var_done);
  addtoclosure(closure706, var_ConcurrentModification);
  addtoclosure(closure706, var_IteratorExhausted);
  addtoclosure(closure706, var_indexable);
  addtoclosure(closure706, var_BoundsError);
  addtoclosure(closure706, var__prelude);
  struct UserObject *uo706 = (struct UserObject*)obj699;
  uo706->data[3] = (Object)closure706;
  Method *meth_meth_collectionsPrelude_withAll706 = addmethod2pos(obj699, "withAll", &meth_collectionsPrelude_withAll706, 3);
  int argcv_meth_collectionsPrelude_withAll706[] = {1};
  meth_meth_collectionsPrelude_withAll706->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll706);
  meth_meth_collectionsPrelude_withAll706->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll706->definitionLine = 617;
  block_savedest(obj699);
  Object closure2255 = createclosure(7, "withAll()object");
  setclosureframe(closure2255, stackframe);
  addtoclosure(closure2255, var_NoSuchObject);
  addtoclosure(closure2255, var_done);
  addtoclosure(closure2255, var_ConcurrentModification);
  addtoclosure(closure2255, var_IteratorExhausted);
  addtoclosure(closure2255, var_indexable);
  addtoclosure(closure2255, var_BoundsError);
  addtoclosure(closure2255, var__prelude);
  Method *meth_meth_collectionsPrelude_withAll706_object = addmethod2pos(obj699, "withAll()object", &meth_collectionsPrelude_withAll706_object, 3);
  meth_meth_collectionsPrelude_withAll706_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll706_object->definitionLine = 617;
  sourceObject = obj699;
  sourceObject = obj699;
  sourceObject = obj699;
  objclass699 = obj699->class;
  objclass699->definitionModule = modulename;
  objclass699->definitionLine = 609;
  (*(struct UserObject *)self).data[0] = lowerouter699;
  self = oldself699;
  selfslot = oldselfslot699;
  stackframe = oldstackframe699;
  gc_frame_end(frame);
  return obj699;
}
Object meth_collectionsPrelude_list698_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "list()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object *var_done = getfromclosure(closure, 2);
  Object *var_ConcurrentModification = getfromclosure(closure, 3);
  Object *var_IteratorExhausted = getfromclosure(closure, 4);
  Object *var_indexable = getfromclosure(closure, 5);
  Object *var_BoundsError = getfromclosure(closure, 6);
  Object *var__prelude = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for list (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for list");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject699 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj699 = alloc_userobj2(4,5, objclass699);
  gc_frame_newslot(obj699);
if (objclass699 == NULL) {
  glfree(obj699->class->name);
  obj699->class->name = "collectionsPrelude.list";
}
// OBJECT OUTER DEC outer
  adddatum2(obj699, self, 0);
  addmethodreal(obj699,"outer", &reader_collectionsPrelude_outer_700);
  Object oldself699 = self;
  struct StackFrameObject *oldstackframe699 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe699);
  gc_frame_newslot((Object)stackframe);
  self = obj699;
  Object *oldselfslot699 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter699 = (*(struct UserObject *)self).data[0], lowerouter699 = thisouter699;
  if (inheritingObject699) {
    struct UserObject *inho699 = (struct UserObject *)inheritingObject699;
    while (inho699->super != GraceDefaultObject) inho699 = (struct UserObject *)inho699->super;
    inho699->super = obj699;
    self = inheritingObject699;
    *selfslot = self;
    lowerouter699 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter699;
  }
// method "asString"
  struct UserObject *uo701 = (struct UserObject*)obj699;
  uo701->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString701 = addmethod2pos(obj699, "asString", &meth_collectionsPrelude_asString701, 1);
  int argcv_meth_collectionsPrelude_asString701[] = {0};
  meth_meth_collectionsPrelude_asString701->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString701);
  meth_meth_collectionsPrelude_asString701->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString701->definitionLine = 611;
// method "empty"
  block_savedest(obj699);
  Object closure703 = createclosure(1, "empty");
  setclosureframe(closure703, stackframe);
  addtoclosure(closure703, var_emptySequence);
  struct UserObject *uo703 = (struct UserObject*)obj699;
  uo703->data[2] = (Object)closure703;
  Method *meth_meth_collectionsPrelude_empty703 = addmethod2pos(obj699, "empty", &meth_collectionsPrelude_empty703, 2);
  int argcv_meth_collectionsPrelude_empty703[] = {0};
  meth_meth_collectionsPrelude_empty703->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_empty703);
  meth_meth_collectionsPrelude_empty703->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty703->definitionLine = 613;
// method "withAll"
  block_savedest(obj699);
  Object closure706 = createclosure(7, "withAll");
  setclosureframe(closure706, stackframe);
  addtoclosure(closure706, var_NoSuchObject);
  addtoclosure(closure706, var_done);
  addtoclosure(closure706, var_ConcurrentModification);
  addtoclosure(closure706, var_IteratorExhausted);
  addtoclosure(closure706, var_indexable);
  addtoclosure(closure706, var_BoundsError);
  addtoclosure(closure706, var__prelude);
  struct UserObject *uo706 = (struct UserObject*)obj699;
  uo706->data[3] = (Object)closure706;
  Method *meth_meth_collectionsPrelude_withAll706 = addmethod2pos(obj699, "withAll", &meth_collectionsPrelude_withAll706, 3);
  int argcv_meth_collectionsPrelude_withAll706[] = {1};
  meth_meth_collectionsPrelude_withAll706->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll706);
  meth_meth_collectionsPrelude_withAll706->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll706->definitionLine = 617;
  block_savedest(obj699);
  Object closure2255 = createclosure(7, "withAll()object");
  setclosureframe(closure2255, stackframe);
  addtoclosure(closure2255, var_NoSuchObject);
  addtoclosure(closure2255, var_done);
  addtoclosure(closure2255, var_ConcurrentModification);
  addtoclosure(closure2255, var_IteratorExhausted);
  addtoclosure(closure2255, var_indexable);
  addtoclosure(closure2255, var_BoundsError);
  addtoclosure(closure2255, var__prelude);
  Method *meth_meth_collectionsPrelude_withAll706_object = addmethod2pos(obj699, "withAll()object", &meth_collectionsPrelude_withAll706_object, 3);
  meth_meth_collectionsPrelude_withAll706_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll706_object->definitionLine = 617;
  sourceObject = obj699;
  sourceObject = obj699;
  sourceObject = obj699;
  objclass699 = obj699->class;
  objclass699->definitionModule = modulename;
  objclass699->definitionLine = 609;
  (*(struct UserObject *)self).data[0] = lowerouter699;
  self = oldself699;
  selfslot = oldselfslot699;
  stackframe = oldstackframe699;
  gc_frame_end(frame);
  return obj699;
}
Object meth_collectionsPrelude_asString2260(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1165
  setline(1165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit2261 == NULL) {
    strlit2261 = alloc_String("a set factory");
    gc_root(strlit2261);
  }
// compiled string node returning strlit2261 (depth = 2)
  gc_frame_end(frame);
  return strlit2261;
}
Object meth_collectionsPrelude__apply2272(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile num node (depth = 8)
  Object num2273 = alloc_Float64(2);
// compiled num node returning num2273 (depth = 8)
  gc_frame_end(frame);
  return num2273;
}
Object meth_collectionsPrelude__apply2286(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe2287 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  gc_frame_newslot(*var_x);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2288 = callmethod(*var_result, "add",
    1, partcv, params);
  gc_frame_end(callframe2287);
// compiled call node returning call2288 (depth = 4)
  gc_frame_end(frame);
  return call2288;
}
Object meth_collectionsPrelude_withAll2262(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "withAll");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method withAll");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for withAll (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for withAll");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_cap = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "cap");
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 1168
  setline(1168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2263 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2265 = alloc_Float64(1);
// compiled num node returning num2265 (depth = 5)
  int op_slot_right_2264 = gc_frame_newslot(num2265);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2268 = alloc_Float64(3);
// compiled num node returning num2268 (depth = 6)
  int op_slot_right_2267 = gc_frame_newslot(num2268);
// starting to compile call node (depth = 6)
  int callframe2270 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block2271 = alloc_Block(NULL, NULL, "collectionsPrelude", 1168);
  gc_frame_newslot(block2271);
// method "_apply"
  block_savedest(block2271);
  Object closure2272 = createclosure(1, "_apply");
  setclosureframe(closure2272, stackframe);
  addtoclosure(closure2272, selfslot);
  struct UserObject *uo2272 = (struct UserObject*)block2271;
  uo2272->data[0] = (Object)closure2272;
  Method *meth_meth_collectionsPrelude__apply2272 = addmethod2pos(block2271, "_apply", &meth_collectionsPrelude__apply2272, 0);
  int argcv_meth_collectionsPrelude__apply2272[] = {0};
  meth_meth_collectionsPrelude__apply2272->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2272);
  meth_meth_collectionsPrelude__apply2272->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2272->definitionLine = 907;
// compiled block node returning block2271 (depth = 7)
  gc_frame_newslot(block2271);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  params[0] = block2271;
  partcv[0] = 1;
  Object call2275 = callmethod(*var_a, "sizeIfUnknown",
    1, partcv, params);
  gc_frame_end(callframe2270);
// compiled call node returning call2275 (depth = 6)
  int op_slot_left_2267 = gc_frame_newslot(call2275);
  params[0] = num2268;
  partcv[0] = 1;
  Object prod2276 = callmethod(call2275, "*", 1, partcv, params);
// compiled op node returning prod2276 (depth = 5)
  int op_slot_left_2264 = gc_frame_newslot(prod2276);
  params[0] = num2265;
  partcv[0] = 1;
  Object sum2277 = callmethod(prod2276, "+", 1, partcv, params);
// compiled op node returning sum2277 (depth = 4)
  gc_frame_newslot(sum2277);
// starting to compile num node (depth = 4)
  Object num2278 = alloc_Float64(8);
// compiled num node returning num2278 (depth = 4)
  gc_frame_newslot(num2278);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2279 = gc_frame_new();
// call case 3: self.outer request
  Object call2280 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2279);
// compiled call node returning call2280 (depth = 5)
// compiled member node returning call2280 (depth = 4)
  params[0] = sum2277;
  params[1] = num2278;
  partcv[0] = 2;
  Object call2281 = callmethodflags(call2280, "max", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2263);
// compiled call node returning call2281 (depth = 3)
  *var_cap = call2281;
  if (call2281 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1169
  setline(1169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2282 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_cap (depth = 4)
  gc_frame_newslot(*var_cap);
// call case 4: self request
  params[0] = *var_cap;
  partcv[0] = 1;
  Object call2283 = callmethodflags(self, "ofCapacity", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2282);
// compiled call node returning call2283 (depth = 3)
  *var_result = call2283;
  if (call2283 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1170
  setline(1170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2284 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2285 = alloc_Block(NULL, NULL, "collectionsPrelude", 1170);
  gc_frame_newslot(block2285);
// method "_apply"
  block_savedest(block2285);
  Object closure2286 = createclosure(2, "_apply");
  setclosureframe(closure2286, stackframe);
  addtoclosure(closure2286, var_result);
  addtoclosure(closure2286, selfslot);
  struct UserObject *uo2286 = (struct UserObject*)block2285;
  uo2286->data[0] = (Object)closure2286;
  Method *meth_meth_collectionsPrelude__apply2286 = addmethod2pos(block2285, "_apply", &meth_collectionsPrelude__apply2286, 0);
  int argcv_meth_collectionsPrelude__apply2286[] = {1};
  meth_meth_collectionsPrelude__apply2286->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2286);
  meth_meth_collectionsPrelude__apply2286->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2286->definitionLine = 1168;
// compiled block node returning block2285 (depth = 3)
  gc_frame_newslot(block2285);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_a (depth = 3)
  params[0] = block2285;
  partcv[0] = 1;
  Object call2290 = callmethod(*var_a, "do",
    1, partcv, params);
  gc_frame_end(callframe2284);
// compiled call node returning call2290 (depth = 2)
// Begin line 1171
  setline(1171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude_empty2291(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "empty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for empty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for empty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1175
  setline(1175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2292 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num2293 = alloc_Float64(8);
// compiled num node returning num2293 (depth = 3)
  gc_frame_newslot(num2293);
// call case 4: self request
  params[0] = num2293;
  partcv[0] = 1;
  Object call2294 = callmethodflags(self, "ofCapacity", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2292);
// compiled call node returning call2294 (depth = 2)
  gc_frame_end(frame);
  return call2294;
}
Object meth_collectionsPrelude__apply2312(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1190
  setline(1190);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2314 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe2315 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_x (depth = 7)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2316 = callmethodflags(self, "contains", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2315);
// compiled call node returning call2316 (depth = 6)
  partcv[0] = 0;
  Object call2317 = callmethod(call2316, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe2314);
// compiled call node returning call2317 (depth = 5)
  Object if2313 = done;
  if (istrue(call2317)) {
// Begin line 1191
  setline(1191);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2318 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_x (depth = 7)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2319 = callmethodflags(self, "findPositionForAdd", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2318);
// compiled call node returning call2319 (depth = 6)
  *var_t = call2319;
  if (call2319 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 5)
// Begin line 1192
  setline(1192);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2320 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  gc_frame_newslot(*var_x);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2321 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2322 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2321);
// compiled call node returning call2322 (depth = 7)
// compiled member node returning call2322 (depth = 6)
  params[0] = *var_t;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2323 = callmethod(call2322, "at()put",
    2, partcv, params);
  gc_frame_end(callframe2320);
// compiled call node returning call2323 (depth = 5)
// Begin line 1193
  setline(1193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2324 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2326 = alloc_Float64(1);
// compiled num node returning num2326 (depth = 7)
  int op_slot_right_2325 = gc_frame_newslot(num2326);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2328 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2329 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2328);
// compiled call node returning call2329 (depth = 8)
// compiled member node returning call2329 (depth = 7)
  int op_slot_left_2325 = gc_frame_newslot(call2329);
  params[0] = num2326;
  partcv[0] = 1;
  Object sum2330 = callmethod(call2329, "+", 1, partcv, params);
// compiled op node returning sum2330 (depth = 6)
  gc_frame_newslot(sum2330);
// call case 4: self request
  params[0] = sum2330;
  partcv[0] = 1;
  Object call2331 = callmethodflags(self, "size:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2324);
// compiled call node returning call2331 (depth = 5)
// Begin line 1194
  setline(1194);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2335 = alloc_Float64(2);
// compiled num node returning num2335 (depth = 8)
  int op_slot_right_2334 = gc_frame_newslot(num2335);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2337 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2338 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2339 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2338);
// compiled call node returning call2339 (depth = 11)
// compiled member node returning call2339 (depth = 10)
  partcv[0] = 0;
  Object call2340 = callmethod(call2339, "size",
    1, partcv, params);
  gc_frame_end(callframe2337);
// compiled call node returning call2340 (depth = 9)
// compiled member node returning call2340 (depth = 8)
  int op_slot_left_2334 = gc_frame_newslot(call2340);
  params[0] = num2335;
  partcv[0] = 1;
  Object quotient2341 = callmethod(call2340, "/", 1, partcv, params);
// compiled op node returning quotient2341 (depth = 7)
  int op_slot_right_2333 = gc_frame_newslot(quotient2341);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2343 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2344 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2343);
// compiled call node returning call2344 (depth = 8)
// compiled member node returning call2344 (depth = 7)
  int op_slot_left_2333 = gc_frame_newslot(call2344);
  params[0] = quotient2341;
  partcv[0] = 1;
  Object opresult2345 = callmethod(call2344, ">", 1, partcv, params);
// compiled op node returning opresult2345 (depth = 6)
  Object if2332 = done;
  if (istrue(opresult2345)) {
// Begin line 1195
  setline(1195);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2346 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2347 = callmethodflags(self, "expand", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2346);
// compiled call node returning call2347 (depth = 7)
// compiled member node returning call2347 (depth = 6)
    gc_frame_newslot(call2347);
    if2332 = call2347;
  } else {
  }
// compiled if node returning if2332 (depth = 5)
    gc_frame_newslot(if2332);
    if2313 = if2332;
  } else {
  }
// compiled if node returning if2313 (depth = 4)
  gc_frame_end(frame);
  return if2313;
}
Object meth_collectionsPrelude_addAll2301(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addAll");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method addAll");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addAll (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elements = &(stackframe->slots[0]);
  *var_elements = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for addAll");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1188
  setline(1188);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2302 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2304 = alloc_Float64(1);
// compiled num node returning num2304 (depth = 4)
  int op_slot_right_2303 = gc_frame_newslot(num2304);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2306 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2307 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2306);
// compiled call node returning call2307 (depth = 5)
// compiled member node returning call2307 (depth = 4)
  int op_slot_left_2303 = gc_frame_newslot(call2307);
  params[0] = num2304;
  partcv[0] = 1;
  Object sum2308 = callmethod(call2307, "+", 1, partcv, params);
// compiled op node returning sum2308 (depth = 3)
  gc_frame_newslot(sum2308);
// call case 4: self request
  params[0] = sum2308;
  partcv[0] = 1;
  Object call2309 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2302);
// compiled call node returning call2309 (depth = 2)
// Begin line 1189
  setline(1189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2310 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elements (depth = 3)
  gc_frame_newslot(*var_elements);
// starting to compile block node (depth = 3)
  Object block2311 = alloc_Block(NULL, NULL, "collectionsPrelude", 1189);
  gc_frame_newslot(block2311);
// method "_apply"
  block_savedest(block2311);
  Object closure2312 = createclosure(1, "_apply");
  setclosureframe(closure2312, stackframe);
  addtoclosure(closure2312, selfslot);
  struct UserObject *uo2312 = (struct UserObject*)block2311;
  uo2312->data[0] = (Object)closure2312;
  Method *meth_meth_collectionsPrelude__apply2312 = addmethod2pos(block2311, "_apply", &meth_collectionsPrelude__apply2312, 0);
  int argcv_meth_collectionsPrelude__apply2312[] = {1};
  meth_meth_collectionsPrelude__apply2312->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2312);
  meth_meth_collectionsPrelude__apply2312->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2312->definitionLine = 1188;
// compiled block node returning block2311 (depth = 3)
  gc_frame_newslot(block2311);
// call case 5: prelude request
  params[0] = *var_elements;
  params[1] = block2311;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2349 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2310);
// compiled call node returning call2349 (depth = 2)
// Begin line 1199
  setline(1199);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_add2350(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "add");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method add");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for add (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for add");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1203
  setline(1203);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2352 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe2353 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2354 = callmethodflags(self, "contains", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2353);
// compiled call node returning call2354 (depth = 4)
  partcv[0] = 0;
  Object call2355 = callmethod(call2354, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe2352);
// compiled call node returning call2355 (depth = 3)
  Object if2351 = done;
  if (istrue(call2355)) {
// Begin line 1204
  setline(1204);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2356 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2358 = alloc_Float64(1);
// compiled num node returning num2358 (depth = 5)
  int op_slot_right_2357 = gc_frame_newslot(num2358);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2360 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2361 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2360);
// compiled call node returning call2361 (depth = 6)
// compiled member node returning call2361 (depth = 5)
  int op_slot_left_2357 = gc_frame_newslot(call2361);
  params[0] = num2358;
  partcv[0] = 1;
  Object sum2362 = callmethod(call2361, "+", 1, partcv, params);
// compiled op node returning sum2362 (depth = 4)
  gc_frame_newslot(sum2362);
// call case 4: self request
  params[0] = sum2362;
  partcv[0] = 1;
  Object call2363 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2356);
// compiled call node returning call2363 (depth = 3)
// Begin line 1205
  setline(1205);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2364 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2365 = callmethodflags(self, "findPositionForAdd", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2364);
// compiled call node returning call2365 (depth = 4)
  *var_t = call2365;
  if (call2365 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 1206
  setline(1206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2366 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  gc_frame_newslot(*var_x);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2367 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2368 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2367);
// compiled call node returning call2368 (depth = 5)
// compiled member node returning call2368 (depth = 4)
  params[0] = *var_t;
  params[1] = *var_x;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2369 = callmethod(call2368, "at()put",
    2, partcv, params);
  gc_frame_end(callframe2366);
// compiled call node returning call2369 (depth = 3)
// Begin line 1207
  setline(1207);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2370 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2372 = alloc_Float64(1);
// compiled num node returning num2372 (depth = 5)
  int op_slot_right_2371 = gc_frame_newslot(num2372);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2374 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2375 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2374);
// compiled call node returning call2375 (depth = 6)
// compiled member node returning call2375 (depth = 5)
  int op_slot_left_2371 = gc_frame_newslot(call2375);
  params[0] = num2372;
  partcv[0] = 1;
  Object sum2376 = callmethod(call2375, "+", 1, partcv, params);
// compiled op node returning sum2376 (depth = 4)
  gc_frame_newslot(sum2376);
// call case 4: self request
  params[0] = sum2376;
  partcv[0] = 1;
  Object call2377 = callmethodflags(self, "size:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2370);
// compiled call node returning call2377 (depth = 3)
// Begin line 1208
  setline(1208);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2381 = alloc_Float64(2);
// compiled num node returning num2381 (depth = 6)
  int op_slot_right_2380 = gc_frame_newslot(num2381);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2383 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2384 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2385 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2384);
// compiled call node returning call2385 (depth = 9)
// compiled member node returning call2385 (depth = 8)
  partcv[0] = 0;
  Object call2386 = callmethod(call2385, "size",
    1, partcv, params);
  gc_frame_end(callframe2383);
// compiled call node returning call2386 (depth = 7)
// compiled member node returning call2386 (depth = 6)
  int op_slot_left_2380 = gc_frame_newslot(call2386);
  params[0] = num2381;
  partcv[0] = 1;
  Object quotient2387 = callmethod(call2386, "/", 1, partcv, params);
// compiled op node returning quotient2387 (depth = 5)
  int op_slot_right_2379 = gc_frame_newslot(quotient2387);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2389 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2390 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2389);
// compiled call node returning call2390 (depth = 6)
// compiled member node returning call2390 (depth = 5)
  int op_slot_left_2379 = gc_frame_newslot(call2390);
  params[0] = quotient2387;
  partcv[0] = 1;
  Object opresult2391 = callmethod(call2390, ">", 1, partcv, params);
// compiled op node returning opresult2391 (depth = 4)
  Object if2378 = done;
  if (istrue(opresult2391)) {
// Begin line 1209
  setline(1209);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2392 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2393 = callmethodflags(self, "expand", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2392);
// compiled call node returning call2393 (depth = 5)
// compiled member node returning call2393 (depth = 4)
    gc_frame_newslot(call2393);
    if2378 = call2393;
  } else {
  }
// compiled if node returning if2378 (depth = 3)
    gc_frame_newslot(if2378);
    if2351 = if2378;
  } else {
  }
// compiled if node returning if2351 (depth = 2)
// Begin line 1212
  setline(1212);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply2400(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_x = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1218
  setline(1218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe2401 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit2403 == NULL) {
    strlit2403 = alloc_String("");
    gc_root(strlit2403);
  }
// compiled string node returning strlit2403 (depth = 8)
  int op_slot_right_2402 = gc_frame_newslot(strlit2403);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_x (depth = 9)
  int op_slot_right_2405 = gc_frame_newslot(*var_x);
// starting to compile string node (depth = 9)
  if (strlit2407 == NULL) {
    strlit2407 = alloc_String("set does not contain ");
    gc_root(strlit2407);
  }
// compiled string node returning strlit2407 (depth = 9)
  int op_slot_left_2405 = gc_frame_newslot(strlit2407);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult2408 = callmethod(strlit2407, "++", 1, partcv, params);
// compiled op node returning opresult2408 (depth = 8)
  int op_slot_left_2402 = gc_frame_newslot(opresult2408);
  params[0] = strlit2403;
  partcv[0] = 1;
  Object opresult2409 = callmethod(opresult2408, "++", 1, partcv, params);
// compiled op node returning opresult2409 (depth = 7)
  gc_frame_newslot(opresult2409);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_NoSuchObject (depth = 7)
  params[0] = opresult2409;
  partcv[0] = 1;
  Object call2410 = callmethod(*var_NoSuchObject, "raise",
    1, partcv, params);
  gc_frame_end(callframe2401);
// compiled call node returning call2410 (depth = 6)
  gc_frame_end(frame);
  return call2410;
}
Object meth_collectionsPrelude__apply2397(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1217
  setline(1217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2398 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  gc_frame_newslot(*var_x);
// starting to compile block node (depth = 5)
  Object block2399 = alloc_Block(NULL, NULL, "collectionsPrelude", 1217);
  gc_frame_newslot(block2399);
// method "_apply"
  block_savedest(block2399);
  Object closure2400 = createclosure(3, "_apply");
  setclosureframe(closure2400, stackframe);
  addtoclosure(closure2400, var_x);
  addtoclosure(closure2400, var_NoSuchObject);
  addtoclosure(closure2400, selfslot);
  struct UserObject *uo2400 = (struct UserObject*)block2399;
  uo2400->data[0] = (Object)closure2400;
  Method *meth_meth_collectionsPrelude__apply2400 = addmethod2pos(block2399, "_apply", &meth_collectionsPrelude__apply2400, 0);
  int argcv_meth_collectionsPrelude__apply2400[] = {0};
  meth_meth_collectionsPrelude__apply2400->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2400);
  meth_meth_collectionsPrelude__apply2400->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2400->definitionLine = 1209;
// compiled block node returning block2399 (depth = 5)
  gc_frame_newslot(block2399);
// call case 4: self request
  params[0] = *var_x;
  params[1] = block2399;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2412 = callmethodflags(self, "remove()ifAbsent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2398);
// compiled call node returning call2412 (depth = 4)
  gc_frame_end(frame);
  return call2412;
}
Object meth_collectionsPrelude_removeAll2394(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAll");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeAll (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elements = &(stackframe->slots[0]);
  *var_elements = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for removeAll");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1216
  setline(1216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2395 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elements (depth = 3)
  gc_frame_newslot(*var_elements);
// starting to compile block node (depth = 3)
  Object block2396 = alloc_Block(NULL, NULL, "collectionsPrelude", 1216);
  gc_frame_newslot(block2396);
// method "_apply"
  block_savedest(block2396);
  Object closure2397 = createclosure(2, "_apply");
  setclosureframe(closure2397, stackframe);
  addtoclosure(closure2397, var_NoSuchObject);
  addtoclosure(closure2397, selfslot);
  struct UserObject *uo2397 = (struct UserObject*)block2396;
  uo2397->data[0] = (Object)closure2397;
  Method *meth_meth_collectionsPrelude__apply2397 = addmethod2pos(block2396, "_apply", &meth_collectionsPrelude__apply2397, 0);
  int argcv_meth_collectionsPrelude__apply2397[] = {1};
  meth_meth_collectionsPrelude__apply2397->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2397);
  meth_meth_collectionsPrelude__apply2397->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2397->definitionLine = 1209;
// compiled block node returning block2396 (depth = 3)
  gc_frame_newslot(block2396);
// call case 5: prelude request
  params[0] = *var_elements;
  params[1] = block2396;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2414 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2395);
// compiled call node returning call2414 (depth = 2)
// Begin line 1221
  setline(1221);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply2426(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_block = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1226
  setline(1226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2427 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2428 = callmethodflags(self, "findPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2427);
// compiled call node returning call2428 (depth = 5)
  *var_t = call2428;
  if (call2428 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1227
  setline(1227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  int op_slot_right_2430 = gc_frame_newslot(*var_x);
// starting to compile call node (depth = 6)
  int callframe2432 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2433 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2434 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2433);
// compiled call node returning call2434 (depth = 8)
// compiled member node returning call2434 (depth = 7)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call2435 = callmethod(call2434, "at",
    1, partcv, params);
  gc_frame_end(callframe2432);
// compiled call node returning call2435 (depth = 6)
  int op_slot_left_2430 = gc_frame_newslot(call2435);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult2436 = callmethod(call2435, "==", 1, partcv, params);
// compiled op node returning opresult2436 (depth = 5)
  Object if2429 = done;
  if (istrue(opresult2436)) {
// Begin line 1228
  setline(1228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2437 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  gc_frame_newslot(*var_removed);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2438 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2439 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2438);
// compiled call node returning call2439 (depth = 7)
// compiled member node returning call2439 (depth = 6)
  params[0] = *var_t;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2440 = callmethod(call2439, "at()put",
    2, partcv, params);
  gc_frame_end(callframe2437);
// compiled call node returning call2440 (depth = 5)
// Begin line 1229
  setline(1229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2441 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2443 = alloc_Float64(1);
// compiled num node returning num2443 (depth = 7)
  int op_slot_right_2442 = gc_frame_newslot(num2443);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2445 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2446 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2445);
// compiled call node returning call2446 (depth = 8)
// compiled member node returning call2446 (depth = 7)
  int op_slot_left_2442 = gc_frame_newslot(call2446);
  params[0] = num2443;
  partcv[0] = 1;
  Object diff2447 = callmethod(call2446, "-", 1, partcv, params);
// compiled op node returning diff2447 (depth = 6)
  gc_frame_newslot(diff2447);
// call case 4: self request
  params[0] = diff2447;
  partcv[0] = 1;
  Object call2448 = callmethodflags(self, "size:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2441);
// compiled call node returning call2448 (depth = 5)
    gc_frame_newslot(call2448);
    if2429 = call2448;
  } else {
// Begin line 1231
  setline(1231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2449 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  gc_frame_newslot(*var_x);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block (depth = 6)
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2450 = callmethod(*var_block, "apply",
    1, partcv, params);
  gc_frame_end(callframe2449);
// compiled call node returning call2450 (depth = 5)
    gc_frame_newslot(call2450);
    if2429 = call2450;
  }
// compiled if node returning if2429 (depth = 4)
  gc_frame_end(frame);
  return if2429;
}
Object meth_collectionsPrelude_removeAll_40__41_ifAbsent2415(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAll()ifAbsent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll()ifAbsent");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAll()ifAbsent");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for removeAll()ifAbsent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_elements = &(stackframe->slots[0]);
  *var_elements = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for removeAll");
  Object *var_block = &(stackframe->slots[1]);
  *var_block = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ifAbsent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1224
  setline(1224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2416 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2418 = alloc_Float64(1);
// compiled num node returning num2418 (depth = 4)
  int op_slot_right_2417 = gc_frame_newslot(num2418);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2420 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2421 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2420);
// compiled call node returning call2421 (depth = 5)
// compiled member node returning call2421 (depth = 4)
  int op_slot_left_2417 = gc_frame_newslot(call2421);
  params[0] = num2418;
  partcv[0] = 1;
  Object sum2422 = callmethod(call2421, "+", 1, partcv, params);
// compiled op node returning sum2422 (depth = 3)
  gc_frame_newslot(sum2422);
// call case 4: self request
  params[0] = sum2422;
  partcv[0] = 1;
  Object call2423 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2416);
// compiled call node returning call2423 (depth = 2)
// Begin line 1225
  setline(1225);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2424 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elements (depth = 3)
  gc_frame_newslot(*var_elements);
// starting to compile block node (depth = 3)
  Object block2425 = alloc_Block(NULL, NULL, "collectionsPrelude", 1225);
  gc_frame_newslot(block2425);
// method "_apply"
  block_savedest(block2425);
  Object closure2426 = createclosure(3, "_apply");
  setclosureframe(closure2426, stackframe);
  addtoclosure(closure2426, var_removed);
  addtoclosure(closure2426, var_block);
  addtoclosure(closure2426, selfslot);
  struct UserObject *uo2426 = (struct UserObject*)block2425;
  uo2426->data[0] = (Object)closure2426;
  Method *meth_meth_collectionsPrelude__apply2426 = addmethod2pos(block2425, "_apply", &meth_collectionsPrelude__apply2426, 0);
  int argcv_meth_collectionsPrelude__apply2426[] = {1};
  meth_meth_collectionsPrelude__apply2426->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2426);
  meth_meth_collectionsPrelude__apply2426->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2426->definitionLine = 1224;
// compiled block node returning block2425 (depth = 3)
  gc_frame_newslot(block2425);
// call case 5: prelude request
  params[0] = *var_elements;
  params[1] = block2425;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2452 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2424);
// compiled call node returning call2452 (depth = 2)
// Begin line 1234
  setline(1234);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_remove_40__41_ifAbsent2453(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 8, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "remove()ifAbsent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove()ifAbsent");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove()ifAbsent");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for remove()ifAbsent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for remove");
  Object *var_block = &(stackframe->slots[1]);
  *var_block = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ifAbsent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "t");
// Begin line 1238
  setline(1238);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2454 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elt (depth = 4)
  gc_frame_newslot(*var_elt);
// call case 4: self request
  params[0] = *var_elt;
  partcv[0] = 1;
  Object call2455 = callmethodflags(self, "findPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2454);
// compiled call node returning call2455 (depth = 3)
  *var_t = call2455;
  if (call2455 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1239
  setline(1239);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_elt (depth = 4)
  int op_slot_right_2457 = gc_frame_newslot(*var_elt);
// starting to compile call node (depth = 4)
  int callframe2459 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_t (depth = 5)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2460 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2461 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2460);
// compiled call node returning call2461 (depth = 6)
// compiled member node returning call2461 (depth = 5)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call2462 = callmethod(call2461, "at",
    1, partcv, params);
  gc_frame_end(callframe2459);
// compiled call node returning call2462 (depth = 4)
  int op_slot_left_2457 = gc_frame_newslot(call2462);
  params[0] = *var_elt;
  partcv[0] = 1;
  Object opresult2463 = callmethod(call2462, "==", 1, partcv, params);
// compiled op node returning opresult2463 (depth = 3)
  Object if2456 = done;
  if (istrue(opresult2463)) {
// Begin line 1240
  setline(1240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2464 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_removed (depth = 4)
  gc_frame_newslot(*var_removed);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2465 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2466 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2465);
// compiled call node returning call2466 (depth = 5)
// compiled member node returning call2466 (depth = 4)
  params[0] = *var_t;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2467 = callmethod(call2466, "at()put",
    2, partcv, params);
  gc_frame_end(callframe2464);
// compiled call node returning call2467 (depth = 3)
// Begin line 1241
  setline(1241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2468 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2470 = alloc_Float64(1);
// compiled num node returning num2470 (depth = 5)
  int op_slot_right_2469 = gc_frame_newslot(num2470);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2472 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2473 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2472);
// compiled call node returning call2473 (depth = 6)
// compiled member node returning call2473 (depth = 5)
  int op_slot_left_2469 = gc_frame_newslot(call2473);
  params[0] = num2470;
  partcv[0] = 1;
  Object sum2474 = callmethod(call2473, "+", 1, partcv, params);
// compiled op node returning sum2474 (depth = 4)
  gc_frame_newslot(sum2474);
// call case 4: self request
  params[0] = sum2474;
  partcv[0] = 1;
  Object call2475 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2468);
// compiled call node returning call2475 (depth = 3)
// Begin line 1242
  setline(1242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2476 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2478 = alloc_Float64(1);
// compiled num node returning num2478 (depth = 5)
  int op_slot_right_2477 = gc_frame_newslot(num2478);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2480 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2481 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2480);
// compiled call node returning call2481 (depth = 6)
// compiled member node returning call2481 (depth = 5)
  int op_slot_left_2477 = gc_frame_newslot(call2481);
  params[0] = num2478;
  partcv[0] = 1;
  Object diff2482 = callmethod(call2481, "-", 1, partcv, params);
// compiled op node returning diff2482 (depth = 4)
  gc_frame_newslot(diff2482);
// call case 4: self request
  params[0] = diff2482;
  partcv[0] = 1;
  Object call2483 = callmethodflags(self, "size:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2476);
// compiled call node returning call2483 (depth = 3)
    gc_frame_newslot(call2483);
    if2456 = call2483;
  } else {
// Begin line 1244
  setline(1244);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2484 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block (depth = 5)
  partcv[0] = 0;
  Object call2485 = callmethod(*var_block, "apply",
    1, partcv, params);
  gc_frame_end(callframe2484);
// compiled call node returning call2485 (depth = 4)
// compiled member node returning call2485 (depth = 3)
    gc_frame_newslot(call2485);
    if2456 = call2485;
  }
// compiled if node returning if2456 (depth = 2)
// Begin line 1246
  setline(1246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply2489(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_elt = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1251
  setline(1251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2490 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2492 == NULL) {
    strlit2492 = alloc_String("");
    gc_root(strlit2492);
  }
// compiled string node returning strlit2492 (depth = 6)
  int op_slot_right_2491 = gc_frame_newslot(strlit2492);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_elt (depth = 7)
  int op_slot_right_2494 = gc_frame_newslot(*var_elt);
// starting to compile string node (depth = 7)
  if (strlit2496 == NULL) {
    strlit2496 = alloc_String("set does not contain ");
    gc_root(strlit2496);
  }
// compiled string node returning strlit2496 (depth = 7)
  int op_slot_left_2494 = gc_frame_newslot(strlit2496);
  params[0] = *var_elt;
  partcv[0] = 1;
  Object opresult2497 = callmethod(strlit2496, "++", 1, partcv, params);
// compiled op node returning opresult2497 (depth = 6)
  int op_slot_left_2491 = gc_frame_newslot(opresult2497);
  params[0] = strlit2492;
  partcv[0] = 1;
  Object opresult2498 = callmethod(opresult2497, "++", 1, partcv, params);
// compiled op node returning opresult2498 (depth = 5)
  gc_frame_newslot(opresult2498);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_NoSuchObject (depth = 5)
  params[0] = opresult2498;
  partcv[0] = 1;
  Object call2499 = callmethod(*var_NoSuchObject, "raise",
    1, partcv, params);
  gc_frame_end(callframe2490);
// compiled call node returning call2499 (depth = 4)
  gc_frame_end(frame);
  return call2499;
}
Object meth_collectionsPrelude_remove2486(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "remove");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method remove");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for remove (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elt = &(stackframe->slots[0]);
  *var_elt = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for remove");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1250
  setline(1250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2487 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_elt (depth = 3)
  gc_frame_newslot(*var_elt);
// starting to compile block node (depth = 3)
  Object block2488 = alloc_Block(NULL, NULL, "collectionsPrelude", 1250);
  gc_frame_newslot(block2488);
// method "_apply"
  block_savedest(block2488);
  Object closure2489 = createclosure(3, "_apply");
  setclosureframe(closure2489, stackframe);
  addtoclosure(closure2489, var_elt);
  addtoclosure(closure2489, var_NoSuchObject);
  addtoclosure(closure2489, selfslot);
  struct UserObject *uo2489 = (struct UserObject*)block2488;
  uo2489->data[0] = (Object)closure2489;
  Method *meth_meth_collectionsPrelude__apply2489 = addmethod2pos(block2488, "_apply", &meth_collectionsPrelude__apply2489, 0);
  int argcv_meth_collectionsPrelude__apply2489[] = {0};
  meth_meth_collectionsPrelude__apply2489->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2489);
  meth_meth_collectionsPrelude__apply2489->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2489->definitionLine = 1244;
// compiled block node returning block2488 (depth = 3)
  gc_frame_newslot(block2488);
// call case 4: self request
  params[0] = *var_elt;
  params[1] = block2488;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2501 = callmethodflags(self, "remove()ifAbsent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2487);
// compiled call node returning call2501 (depth = 2)
// Begin line 1253
  setline(1253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_contains2502(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for contains");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1257
  setline(1257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2503 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  gc_frame_newslot(*var_x);
// call case 4: self request
  params[0] = *var_x;
  partcv[0] = 1;
  Object call2504 = callmethodflags(self, "findPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2503);
// compiled call node returning call2504 (depth = 3)
  *var_t = call2504;
  if (call2504 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1258
  setline(1258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_x (depth = 4)
  int op_slot_right_2506 = gc_frame_newslot(*var_x);
// starting to compile call node (depth = 4)
  int callframe2508 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_t (depth = 5)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2509 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2510 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2509);
// compiled call node returning call2510 (depth = 6)
// compiled member node returning call2510 (depth = 5)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call2511 = callmethod(call2510, "at",
    1, partcv, params);
  gc_frame_end(callframe2508);
// compiled call node returning call2511 (depth = 4)
  int op_slot_left_2506 = gc_frame_newslot(call2511);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult2512 = callmethod(call2511, "==", 1, partcv, params);
// compiled op node returning opresult2512 (depth = 3)
  Object if2505 = done;
  if (istrue(opresult2512)) {
// Begin line 1259
  setline(1259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool2513 = alloc_Boolean(1);
// compiled identifier node returning bool2513 (depth = 4)
  return bool2513;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if2505 = undefined;
  } else {
  }
// compiled if node returning if2505 (depth = 2)
// Begin line 1261
  setline(1261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool2514 = alloc_Boolean(0);
// compiled identifier node returning bool2514 (depth = 3)
  return bool2514;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply2518(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_booleanBlock = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1265
  setline(1265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2520 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_booleanBlock (depth = 6)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2521 = callmethod(*var_booleanBlock, "apply",
    1, partcv, params);
  gc_frame_end(callframe2520);
// compiled call node returning call2521 (depth = 5)
  Object if2519 = done;
  if (istrue(call2521)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool2522 = alloc_Boolean(1);
// compiled identifier node returning bool2522 (depth = 6)
  block_return(realself, bool2522);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if2519 = undefined;
  } else {
  }
// compiled if node returning if2519 (depth = 4)
  gc_frame_end(frame);
  return if2519;
}
Object meth_collectionsPrelude_includes2515(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "includes");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method includes");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for includes (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_booleanBlock = &(stackframe->slots[0]);
  *var_booleanBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for includes");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1264
  setline(1264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2516 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2517 = alloc_Block(NULL, NULL, "collectionsPrelude", 1264);
  gc_frame_newslot(block2517);
// method "_apply"
  block_savedest(block2517);
  Object closure2518 = createclosure(2, "_apply");
  setclosureframe(closure2518, stackframe);
  addtoclosure(closure2518, var_booleanBlock);
  addtoclosure(closure2518, selfslot);
  struct UserObject *uo2518 = (struct UserObject*)block2517;
  uo2518->data[0] = (Object)closure2518;
  Method *meth_meth_collectionsPrelude__apply2518 = addmethod2pos(block2517, "_apply", &meth_collectionsPrelude__apply2518, 0);
  int argcv_meth_collectionsPrelude__apply2518[] = {1};
  meth_meth_collectionsPrelude__apply2518->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2518);
  meth_meth_collectionsPrelude__apply2518->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2518->definitionLine = 1258;
// compiled block node returning block2517 (depth = 3)
  gc_frame_newslot(block2517);
// call case 4: self request
  params[0] = block2517;
  partcv[0] = 1;
  Object call2524 = callmethodflags(self, "do", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2516);
// compiled call node returning call2524 (depth = 2)
// Begin line 1267
  setline(1267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool2525 = alloc_Boolean(0);
// compiled identifier node returning bool2525 (depth = 3)
  return bool2525;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply2529(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_booleanBlock = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1271
  setline(1271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2531 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_booleanBlock (depth = 6)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2532 = callmethod(*var_booleanBlock, "apply",
    1, partcv, params);
  gc_frame_end(callframe2531);
// compiled call node returning call2532 (depth = 5)
  Object if2530 = done;
  if (istrue(call2532)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  block_return(realself, *var_each);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if2530 = undefined;
  } else {
  }
// compiled if node returning if2530 (depth = 4)
  gc_frame_end(frame);
  return if2530;
}
Object meth_collectionsPrelude_find_40__41_ifNone2526(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "find()ifNone");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method find()ifNone");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method find()ifNone");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for find()ifNone (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_booleanBlock = &(stackframe->slots[0]);
  *var_booleanBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for find");
  Object *var_notFoundBlock = &(stackframe->slots[1]);
  *var_notFoundBlock = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ifNone");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1270
  setline(1270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2527 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2528 = alloc_Block(NULL, NULL, "collectionsPrelude", 1270);
  gc_frame_newslot(block2528);
// method "_apply"
  block_savedest(block2528);
  Object closure2529 = createclosure(2, "_apply");
  setclosureframe(closure2529, stackframe);
  addtoclosure(closure2529, var_booleanBlock);
  addtoclosure(closure2529, selfslot);
  struct UserObject *uo2529 = (struct UserObject*)block2528;
  uo2529->data[0] = (Object)closure2529;
  Method *meth_meth_collectionsPrelude__apply2529 = addmethod2pos(block2528, "_apply", &meth_collectionsPrelude__apply2529, 0);
  int argcv_meth_collectionsPrelude__apply2529[] = {1};
  meth_meth_collectionsPrelude__apply2529->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2529);
  meth_meth_collectionsPrelude__apply2529->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2529->definitionLine = 1258;
// compiled block node returning block2528 (depth = 3)
  gc_frame_newslot(block2528);
// call case 4: self request
  params[0] = block2528;
  partcv[0] = 1;
  Object call2534 = callmethodflags(self, "do", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2527);
// compiled call node returning call2534 (depth = 2)
// Begin line 1273
  setline(1273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2535 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_notFoundBlock (depth = 5)
  partcv[0] = 0;
  Object call2536 = callmethod(*var_notFoundBlock, "apply",
    1, partcv, params);
  gc_frame_end(callframe2535);
// compiled call node returning call2536 (depth = 4)
// compiled member node returning call2536 (depth = 3)
  return call2536;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply2550(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_t = getfromclosure(closure, 0);
  Object *var_candidate = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 1282
  setline(1282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2551 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2552 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2553 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2552);
// compiled call node returning call2553 (depth = 7)
// compiled member node returning call2553 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call2554 = callmethod(call2553, "at",
    1, partcv, params);
  gc_frame_end(callframe2551);
// compiled call node returning call2554 (depth = 5)
  *var_candidate = call2554;
  if (call2554 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1283
  setline(1283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_candidate (depth = 5)
  int op_slot_right_2556 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  int op_slot_left_2556 = gc_frame_newslot(*var_unused);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2558 = callmethod(*var_unused, "≠", 1, partcv, params);
// compiled op node returning opresult2558 (depth = 4)
  gc_frame_end(frame);
  return opresult2558;
}
Object meth_collectionsPrelude__apply2561(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_x = getfromclosure(closure, 0);
  Object *var_candidate = getfromclosure(closure, 1);
  Object *var_t = getfromclosure(closure, 2);
  Object *var_jump = getfromclosure(closure, 3);
  Object *var_s = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1285
  setline(1285);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  int op_slot_right_2563 = gc_frame_newslot(*var_x);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_left_2563 = gc_frame_newslot(*var_candidate);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult2565 = callmethod(*var_candidate, "==", 1, partcv, params);
// compiled op node returning opresult2565 (depth = 5)
  Object if2562 = done;
  if (istrue(opresult2565)) {
// Begin line 1286
  setline(1286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  block_return(realself, *var_t);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if2562 = undefined;
  } else {
  }
// compiled if node returning if2562 (depth = 4)
// Begin line 1288
  setline(1288);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2568 = alloc_Float64(0);
// compiled num node returning num2568 (depth = 6)
  int op_slot_right_2567 = gc_frame_newslot(num2568);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_jump (depth = 6)
  int op_slot_left_2567 = gc_frame_newslot(*var_jump);
  params[0] = num2568;
  partcv[0] = 1;
  Object opresult2570 = callmethod(*var_jump, "≠", 1, partcv, params);
// compiled op node returning opresult2570 (depth = 5)
  Object if2566 = done;
  if (istrue(opresult2570)) {
// Begin line 1289
  setline(1289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_2571 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2574 = alloc_Float64(1);
// compiled num node returning num2574 (depth = 8)
  int op_slot_right_2573 = gc_frame_newslot(num2574);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2577 = alloc_Float64(3);
// compiled num node returning num2577 (depth = 9)
  int op_slot_right_2576 = gc_frame_newslot(num2577);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  int op_slot_left_2576 = gc_frame_newslot(*var_t);
  params[0] = num2577;
  partcv[0] = 1;
  Object prod2579 = callmethod(*var_t, "*", 1, partcv, params);
// compiled op node returning prod2579 (depth = 8)
  int op_slot_left_2573 = gc_frame_newslot(prod2579);
  params[0] = num2574;
  partcv[0] = 1;
  Object sum2580 = callmethod(prod2579, "+", 1, partcv, params);
// compiled op node returning sum2580 (depth = 7)
  int op_slot_left_2571 = gc_frame_newslot(sum2580);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2581 = callmethod(sum2580, "%", 1, partcv, params);
// compiled op node returning modulus2581 (depth = 6)
  *var_t = modulus2581;
  if (modulus2581 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1290
  setline(1290);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2584 = alloc_Float64(1);
// compiled num node returning num2584 (depth = 7)
  int op_slot_right_2583 = gc_frame_newslot(num2584);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_jump (depth = 7)
  int op_slot_left_2583 = gc_frame_newslot(*var_jump);
  params[0] = num2584;
  partcv[0] = 1;
  Object diff2586 = callmethod(*var_jump, "-", 1, partcv, params);
// compiled op node returning diff2586 (depth = 6)
  *var_jump = diff2586;
  if (diff2586 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2566 = done;
  } else {
// Begin line 1292
  setline(1292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_2588 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2591 = alloc_Float64(1);
// compiled num node returning num2591 (depth = 8)
  int op_slot_right_2590 = gc_frame_newslot(num2591);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  int op_slot_left_2590 = gc_frame_newslot(*var_t);
  params[0] = num2591;
  partcv[0] = 1;
  Object sum2593 = callmethod(*var_t, "+", 1, partcv, params);
// compiled op node returning sum2593 (depth = 7)
  int op_slot_left_2588 = gc_frame_newslot(sum2593);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2594 = callmethod(sum2593, "%", 1, partcv, params);
// compiled op node returning modulus2594 (depth = 6)
  *var_t = modulus2594;
  if (modulus2594 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2566 = done;
  }
// compiled if node returning if2566 (depth = 4)
  gc_frame_end(frame);
  return if2566;
}
Object meth_collectionsPrelude_findPosition2537(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findPosition");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findPosition");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findPosition (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for findPosition");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_h = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "h");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_t = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "t");
  Object *var_jump = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "jump");
  Object *var_candidate = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "candidate");
// Begin line 1276
  setline(1276);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2538 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  partcv[0] = 0;
  Object call2539 = callmethod(*var_x, "hash",
    1, partcv, params);
  gc_frame_end(callframe2538);
// compiled call node returning call2539 (depth = 4)
// compiled member node returning call2539 (depth = 3)
  *var_h = call2539;
  if (call2539 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1277
  setline(1277);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2540 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2541 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2542 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2541);
// compiled call node returning call2542 (depth = 6)
// compiled member node returning call2542 (depth = 5)
  partcv[0] = 0;
  Object call2543 = callmethod(call2542, "size",
    1, partcv, params);
  gc_frame_end(callframe2540);
// compiled call node returning call2543 (depth = 4)
// compiled member node returning call2543 (depth = 3)
  *var_s = call2543;
  if (call2543 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1278
  setline(1278);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_right_2544 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_h (depth = 4)
  int op_slot_left_2544 = gc_frame_newslot(*var_h);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2546 = callmethod(*var_h, "%", 1, partcv, params);
// compiled op node returning modulus2546 (depth = 3)
  *var_t = modulus2546;
  if (modulus2546 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1279
  setline(1279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2547 = alloc_Float64(5);
// compiled num node returning num2547 (depth = 3)
  *var_jump = num2547;
  if (num2547 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1280
  setline(1280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_candidate = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1281
  setline(1281);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2548 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2549 = alloc_Block(NULL, NULL, "collectionsPrelude", 1281);
  gc_frame_newslot(block2549);
// method "_apply"
  block_savedest(block2549);
  Object closure2550 = createclosure(4, "_apply");
  setclosureframe(closure2550, stackframe);
  addtoclosure(closure2550, var_t);
  addtoclosure(closure2550, var_candidate);
  addtoclosure(closure2550, var_unused);
  addtoclosure(closure2550, selfslot);
  struct UserObject *uo2550 = (struct UserObject*)block2549;
  uo2550->data[0] = (Object)closure2550;
  Method *meth_meth_collectionsPrelude__apply2550 = addmethod2pos(block2549, "_apply", &meth_collectionsPrelude__apply2550, 0);
  int argcv_meth_collectionsPrelude__apply2550[] = {0};
  meth_meth_collectionsPrelude__apply2550->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2550);
  meth_meth_collectionsPrelude__apply2550->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2550->definitionLine = 1277;
// compiled block node returning block2549 (depth = 3)
  gc_frame_newslot(block2549);
// Begin line 1284
  setline(1284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2560 = alloc_Block(NULL, NULL, "collectionsPrelude", 1284);
  gc_frame_newslot(block2560);
// method "_apply"
  block_savedest(block2560);
  Object closure2561 = createclosure(6, "_apply");
  setclosureframe(closure2561, stackframe);
  addtoclosure(closure2561, var_x);
  addtoclosure(closure2561, var_candidate);
  addtoclosure(closure2561, var_t);
  addtoclosure(closure2561, var_jump);
  addtoclosure(closure2561, var_s);
  addtoclosure(closure2561, selfslot);
  struct UserObject *uo2561 = (struct UserObject*)block2560;
  uo2561->data[0] = (Object)closure2561;
  Method *meth_meth_collectionsPrelude__apply2561 = addmethod2pos(block2560, "_apply", &meth_collectionsPrelude__apply2561, 0);
  int argcv_meth_collectionsPrelude__apply2561[] = {0};
  meth_meth_collectionsPrelude__apply2561->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2561);
  meth_meth_collectionsPrelude__apply2561->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2561->definitionLine = 1282;
// compiled block node returning block2560 (depth = 3)
  gc_frame_newslot(block2560);
// call case 5: prelude request
  params[0] = block2549;
  params[1] = block2560;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2597 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2548);
// compiled call node returning call2597 (depth = 2)
// Begin line 1295
  setline(1295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  return *var_t;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply2611(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_t = getfromclosure(closure, 0);
  Object *var_candidate = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 1304
  setline(1304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2612 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2613 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2614 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2613);
// compiled call node returning call2614 (depth = 7)
// compiled member node returning call2614 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call2615 = callmethod(call2614, "at",
    1, partcv, params);
  gc_frame_end(callframe2612);
// compiled call node returning call2615 (depth = 5)
  *var_candidate = call2615;
  if (call2615 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1305
  setline(1305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_right_2618 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  int op_slot_left_2618 = gc_frame_newslot(*var_removed);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2620 = callmethod(*var_removed, "≠", 1, partcv, params);
// compiled op node returning opresult2620 (depth = 5)
  int op_slot_right_2617 = gc_frame_newslot(opresult2620);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_right_2622 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_unused (depth = 6)
  int op_slot_left_2622 = gc_frame_newslot(*var_unused);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2624 = callmethod(*var_unused, "≠", 1, partcv, params);
// compiled op node returning opresult2624 (depth = 5)
  int op_slot_left_2617 = gc_frame_newslot(opresult2624);
  params[0] = opresult2620;
  partcv[0] = 1;
  Object opresult2625 = callmethod(opresult2624, "&&", 1, partcv, params);
// compiled op node returning opresult2625 (depth = 4)
  gc_frame_end(frame);
  return opresult2625;
}
Object meth_collectionsPrelude__apply2628(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_x = getfromclosure(closure, 0);
  Object *var_candidate = getfromclosure(closure, 1);
  Object *var_t = getfromclosure(closure, 2);
  Object *var_jump = getfromclosure(closure, 3);
  Object *var_s = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1307
  setline(1307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  int op_slot_right_2630 = gc_frame_newslot(*var_x);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_left_2630 = gc_frame_newslot(*var_candidate);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult2632 = callmethod(*var_candidate, "==", 1, partcv, params);
// compiled op node returning opresult2632 (depth = 5)
  Object if2629 = done;
  if (istrue(opresult2632)) {
// Begin line 1308
  setline(1308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  block_return(realself, *var_t);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if2629 = undefined;
  } else {
  }
// compiled if node returning if2629 (depth = 4)
// Begin line 1310
  setline(1310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2635 = alloc_Float64(0);
// compiled num node returning num2635 (depth = 6)
  int op_slot_right_2634 = gc_frame_newslot(num2635);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_jump (depth = 6)
  int op_slot_left_2634 = gc_frame_newslot(*var_jump);
  params[0] = num2635;
  partcv[0] = 1;
  Object opresult2637 = callmethod(*var_jump, "≠", 1, partcv, params);
// compiled op node returning opresult2637 (depth = 5)
  Object if2633 = done;
  if (istrue(opresult2637)) {
// Begin line 1311
  setline(1311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_2638 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2641 = alloc_Float64(1);
// compiled num node returning num2641 (depth = 8)
  int op_slot_right_2640 = gc_frame_newslot(num2641);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num2644 = alloc_Float64(3);
// compiled num node returning num2644 (depth = 9)
  int op_slot_right_2643 = gc_frame_newslot(num2644);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  int op_slot_left_2643 = gc_frame_newslot(*var_t);
  params[0] = num2644;
  partcv[0] = 1;
  Object prod2646 = callmethod(*var_t, "*", 1, partcv, params);
// compiled op node returning prod2646 (depth = 8)
  int op_slot_left_2640 = gc_frame_newslot(prod2646);
  params[0] = num2641;
  partcv[0] = 1;
  Object sum2647 = callmethod(prod2646, "+", 1, partcv, params);
// compiled op node returning sum2647 (depth = 7)
  int op_slot_left_2638 = gc_frame_newslot(sum2647);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2648 = callmethod(sum2647, "%", 1, partcv, params);
// compiled op node returning modulus2648 (depth = 6)
  *var_t = modulus2648;
  if (modulus2648 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1312
  setline(1312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2651 = alloc_Float64(1);
// compiled num node returning num2651 (depth = 7)
  int op_slot_right_2650 = gc_frame_newslot(num2651);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_jump (depth = 7)
  int op_slot_left_2650 = gc_frame_newslot(*var_jump);
  params[0] = num2651;
  partcv[0] = 1;
  Object diff2653 = callmethod(*var_jump, "-", 1, partcv, params);
// compiled op node returning diff2653 (depth = 6)
  *var_jump = diff2653;
  if (diff2653 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2633 = done;
  } else {
// Begin line 1314
  setline(1314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_2655 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num2658 = alloc_Float64(1);
// compiled num node returning num2658 (depth = 8)
  int op_slot_right_2657 = gc_frame_newslot(num2658);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  int op_slot_left_2657 = gc_frame_newslot(*var_t);
  params[0] = num2658;
  partcv[0] = 1;
  Object sum2660 = callmethod(*var_t, "+", 1, partcv, params);
// compiled op node returning sum2660 (depth = 7)
  int op_slot_left_2655 = gc_frame_newslot(sum2660);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2661 = callmethod(sum2660, "%", 1, partcv, params);
// compiled op node returning modulus2661 (depth = 6)
  *var_t = modulus2661;
  if (modulus2661 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if2633 = done;
  }
// compiled if node returning if2633 (depth = 4)
  gc_frame_end(frame);
  return if2633;
}
Object meth_collectionsPrelude_findPositionForAdd2598(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(7, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findPositionForAdd");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findPositionForAdd");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findPositionForAdd (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for findPositionForAdd");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_h = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "h");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_t = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "t");
  Object *var_jump = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "jump");
  Object *var_candidate = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "candidate");
// Begin line 1298
  setline(1298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2599 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  partcv[0] = 0;
  Object call2600 = callmethod(*var_x, "hash",
    1, partcv, params);
  gc_frame_end(callframe2599);
// compiled call node returning call2600 (depth = 4)
// compiled member node returning call2600 (depth = 3)
  *var_h = call2600;
  if (call2600 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1299
  setline(1299);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2601 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2602 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2603 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2602);
// compiled call node returning call2603 (depth = 6)
// compiled member node returning call2603 (depth = 5)
  partcv[0] = 0;
  Object call2604 = callmethod(call2603, "size",
    1, partcv, params);
  gc_frame_end(callframe2601);
// compiled call node returning call2604 (depth = 4)
// compiled member node returning call2604 (depth = 3)
  *var_s = call2604;
  if (call2604 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1300
  setline(1300);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_right_2605 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_h (depth = 4)
  int op_slot_left_2605 = gc_frame_newslot(*var_h);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus2607 = callmethod(*var_h, "%", 1, partcv, params);
// compiled op node returning modulus2607 (depth = 3)
  *var_t = modulus2607;
  if (modulus2607 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1301
  setline(1301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2608 = alloc_Float64(5);
// compiled num node returning num2608 (depth = 3)
  *var_jump = num2608;
  if (num2608 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1302
  setline(1302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_candidate = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1303
  setline(1303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2609 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2610 = alloc_Block(NULL, NULL, "collectionsPrelude", 1303);
  gc_frame_newslot(block2610);
// method "_apply"
  block_savedest(block2610);
  Object closure2611 = createclosure(5, "_apply");
  setclosureframe(closure2611, stackframe);
  addtoclosure(closure2611, var_t);
  addtoclosure(closure2611, var_candidate);
  addtoclosure(closure2611, var_removed);
  addtoclosure(closure2611, var_unused);
  addtoclosure(closure2611, selfslot);
  struct UserObject *uo2611 = (struct UserObject*)block2610;
  uo2611->data[0] = (Object)closure2611;
  Method *meth_meth_collectionsPrelude__apply2611 = addmethod2pos(block2610, "_apply", &meth_collectionsPrelude__apply2611, 0);
  int argcv_meth_collectionsPrelude__apply2611[] = {0};
  meth_meth_collectionsPrelude__apply2611->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2611);
  meth_meth_collectionsPrelude__apply2611->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2611->definitionLine = 1299;
// compiled block node returning block2610 (depth = 3)
  gc_frame_newslot(block2610);
// Begin line 1306
  setline(1306);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2627 = alloc_Block(NULL, NULL, "collectionsPrelude", 1306);
  gc_frame_newslot(block2627);
// method "_apply"
  block_savedest(block2627);
  Object closure2628 = createclosure(6, "_apply");
  setclosureframe(closure2628, stackframe);
  addtoclosure(closure2628, var_x);
  addtoclosure(closure2628, var_candidate);
  addtoclosure(closure2628, var_t);
  addtoclosure(closure2628, var_jump);
  addtoclosure(closure2628, var_s);
  addtoclosure(closure2628, selfslot);
  struct UserObject *uo2628 = (struct UserObject*)block2627;
  uo2628->data[0] = (Object)closure2628;
  Method *meth_meth_collectionsPrelude__apply2628 = addmethod2pos(block2627, "_apply", &meth_collectionsPrelude__apply2628, 0);
  int argcv_meth_collectionsPrelude__apply2628[] = {0};
  meth_meth_collectionsPrelude__apply2628->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2628);
  meth_meth_collectionsPrelude__apply2628->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2628->definitionLine = 1304;
// compiled block node returning block2627 (depth = 3)
  gc_frame_newslot(block2627);
// call case 5: prelude request
  params[0] = block2610;
  params[1] = block2627;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2664 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2609);
// compiled call node returning call2664 (depth = 2)
// Begin line 1317
  setline(1317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  return *var_t;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply2669(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2671 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  partcv[0] = 0;
  Object call2672 = callmethod(*var_each, "asString",
    1, partcv, params);
  gc_frame_end(callframe2671);
// compiled call node returning call2672 (depth = 7)
// compiled member node returning call2672 (depth = 6)
  int op_slot_right_2670 = gc_frame_newslot(call2672);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2670 = gc_frame_newslot(*var_s);
  params[0] = call2672;
  partcv[0] = 1;
  Object opresult2674 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2674 (depth = 5)
  *var_s = opresult2674;
  if (opresult2674 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply2678(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2680 == NULL) {
    strlit2680 = alloc_String(", ");
    gc_root(strlit2680);
  }
// compiled string node returning strlit2680 (depth = 6)
  int op_slot_right_2679 = gc_frame_newslot(strlit2680);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2679 = gc_frame_newslot(*var_s);
  params[0] = strlit2680;
  partcv[0] = 1;
  Object opresult2682 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2682 (depth = 5)
  *var_s = opresult2682;
  if (opresult2682 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_asString2665(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 1321
  setline(1321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit2666 == NULL) {
    strlit2666 = alloc_String("set{");
    gc_root(strlit2666);
  }
// compiled string node returning strlit2666 (depth = 3)
  *var_s = strlit2666;
  if (strlit2666 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1322
  setline(1322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2667 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2668 = alloc_Block(NULL, NULL, "collectionsPrelude", 1322);
  gc_frame_newslot(block2668);
// method "_apply"
  block_savedest(block2668);
  Object closure2669 = createclosure(2, "_apply");
  setclosureframe(closure2669, stackframe);
  addtoclosure(closure2669, var_s);
  addtoclosure(closure2669, selfslot);
  struct UserObject *uo2669 = (struct UserObject*)block2668;
  uo2669->data[0] = (Object)closure2669;
  Method *meth_meth_collectionsPrelude__apply2669 = addmethod2pos(block2668, "_apply", &meth_collectionsPrelude__apply2669, 0);
  int argcv_meth_collectionsPrelude__apply2669[] = {1};
  meth_meth_collectionsPrelude__apply2669->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2669);
  meth_meth_collectionsPrelude__apply2669->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2669->definitionLine = 1304;
// compiled block node returning block2668 (depth = 3)
  gc_frame_newslot(block2668);
// Begin line 1323
  setline(1323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2677 = alloc_Block(NULL, NULL, "collectionsPrelude", 1323);
  gc_frame_newslot(block2677);
// method "_apply"
  block_savedest(block2677);
  Object closure2678 = createclosure(2, "_apply");
  setclosureframe(closure2678, stackframe);
  addtoclosure(closure2678, var_s);
  addtoclosure(closure2678, selfslot);
  struct UserObject *uo2678 = (struct UserObject*)block2677;
  uo2678->data[0] = (Object)closure2678;
  Method *meth_meth_collectionsPrelude__apply2678 = addmethod2pos(block2677, "_apply", &meth_collectionsPrelude__apply2678, 0);
  int argcv_meth_collectionsPrelude__apply2678[] = {0};
  meth_meth_collectionsPrelude__apply2678->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2678);
  meth_meth_collectionsPrelude__apply2678->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2678->definitionLine = 1322;
// compiled block node returning block2677 (depth = 3)
  gc_frame_newslot(block2677);
// call case 4: self request
  params[0] = block2668;
  params[1] = block2677;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2685 = callmethodflags(self, "do()separatedBy", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2667);
// compiled call node returning call2685 (depth = 2)
// Begin line 1324
  setline(1324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit2687 == NULL) {
    strlit2687 = alloc_String("}");
    gc_root(strlit2687);
  }
// compiled string node returning strlit2687 (depth = 3)
  int op_slot_right_2686 = gc_frame_newslot(strlit2687);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_2686 = gc_frame_newslot(*var_s);
  params[0] = strlit2687;
  partcv[0] = 1;
  Object opresult2689 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2689 (depth = 2)
  gc_frame_end(frame);
  return opresult2689;
}
Object meth_collectionsPrelude__apply2694(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2696 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  partcv[0] = 0;
  Object call2697 = callmethod(*var_each, "asDebugString",
    1, partcv, params);
  gc_frame_end(callframe2696);
// compiled call node returning call2697 (depth = 7)
// compiled member node returning call2697 (depth = 6)
  int op_slot_right_2695 = gc_frame_newslot(call2697);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2695 = gc_frame_newslot(*var_s);
  params[0] = call2697;
  partcv[0] = 1;
  Object opresult2699 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2699 (depth = 5)
  *var_s = opresult2699;
  if (opresult2699 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply2703(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit2705 == NULL) {
    strlit2705 = alloc_String(", ");
    gc_root(strlit2705);
  }
// compiled string node returning strlit2705 (depth = 6)
  int op_slot_right_2704 = gc_frame_newslot(strlit2705);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_2704 = gc_frame_newslot(*var_s);
  params[0] = strlit2705;
  partcv[0] = 1;
  Object opresult2707 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2707 (depth = 5)
  *var_s = opresult2707;
  if (opresult2707 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_asDebugString2690(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 1327
  setline(1327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit2691 == NULL) {
    strlit2691 = alloc_String("set{");
    gc_root(strlit2691);
  }
// compiled string node returning strlit2691 (depth = 3)
  *var_s = strlit2691;
  if (strlit2691 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1328
  setline(1328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2692 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2693 = alloc_Block(NULL, NULL, "collectionsPrelude", 1328);
  gc_frame_newslot(block2693);
// method "_apply"
  block_savedest(block2693);
  Object closure2694 = createclosure(2, "_apply");
  setclosureframe(closure2694, stackframe);
  addtoclosure(closure2694, var_s);
  addtoclosure(closure2694, selfslot);
  struct UserObject *uo2694 = (struct UserObject*)block2693;
  uo2694->data[0] = (Object)closure2694;
  Method *meth_meth_collectionsPrelude__apply2694 = addmethod2pos(block2693, "_apply", &meth_collectionsPrelude__apply2694, 0);
  int argcv_meth_collectionsPrelude__apply2694[] = {1};
  meth_meth_collectionsPrelude__apply2694->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2694);
  meth_meth_collectionsPrelude__apply2694->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2694->definitionLine = 1322;
// compiled block node returning block2693 (depth = 3)
  gc_frame_newslot(block2693);
// Begin line 1329
  setline(1329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2702 = alloc_Block(NULL, NULL, "collectionsPrelude", 1329);
  gc_frame_newslot(block2702);
// method "_apply"
  block_savedest(block2702);
  Object closure2703 = createclosure(2, "_apply");
  setclosureframe(closure2703, stackframe);
  addtoclosure(closure2703, var_s);
  addtoclosure(closure2703, selfslot);
  struct UserObject *uo2703 = (struct UserObject*)block2702;
  uo2703->data[0] = (Object)closure2703;
  Method *meth_meth_collectionsPrelude__apply2703 = addmethod2pos(block2702, "_apply", &meth_collectionsPrelude__apply2703, 0);
  int argcv_meth_collectionsPrelude__apply2703[] = {0};
  meth_meth_collectionsPrelude__apply2703->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2703);
  meth_meth_collectionsPrelude__apply2703->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2703->definitionLine = 1328;
// compiled block node returning block2702 (depth = 3)
  gc_frame_newslot(block2702);
// call case 4: self request
  params[0] = block2693;
  params[1] = block2702;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2710 = callmethodflags(self, "do()separatedBy", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2692);
// compiled call node returning call2710 (depth = 2)
// Begin line 1330
  setline(1330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit2712 == NULL) {
    strlit2712 = alloc_String("}");
    gc_root(strlit2712);
  }
// compiled string node returning strlit2712 (depth = 3)
  int op_slot_right_2711 = gc_frame_newslot(strlit2712);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_2711 = gc_frame_newslot(*var_s);
  params[0] = strlit2712;
  partcv[0] = 1;
  Object opresult2714 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult2714 (depth = 2)
  gc_frame_end(frame);
  return opresult2714;
}
Object meth_collectionsPrelude__apply2718(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1334
  setline(1334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2719 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// call case 4: self request
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2720 = callmethodflags(self, "add", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2719);
// compiled call node returning call2720 (depth = 4)
  gc_frame_end(frame);
  return call2720;
}
Object meth_collectionsPrelude_extend2715(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "extend");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method extend");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for extend (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_l = &(stackframe->slots[0]);
  *var_l = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for extend");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1333
  setline(1333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2716 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_l (depth = 3)
  gc_frame_newslot(*var_l);
// starting to compile block node (depth = 3)
  Object block2717 = alloc_Block(NULL, NULL, "collectionsPrelude", 1333);
  gc_frame_newslot(block2717);
// method "_apply"
  block_savedest(block2717);
  Object closure2718 = createclosure(1, "_apply");
  setclosureframe(closure2718, stackframe);
  addtoclosure(closure2718, selfslot);
  struct UserObject *uo2718 = (struct UserObject*)block2717;
  uo2718->data[0] = (Object)closure2718;
  Method *meth_meth_collectionsPrelude__apply2718 = addmethod2pos(block2717, "_apply", &meth_collectionsPrelude__apply2718, 0);
  int argcv_meth_collectionsPrelude__apply2718[] = {1};
  meth_meth_collectionsPrelude__apply2718->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2718);
  meth_meth_collectionsPrelude__apply2718->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2718->definitionLine = 1328;
// compiled block node returning block2717 (depth = 3)
  gc_frame_newslot(block2717);
// call case 5: prelude request
  params[0] = *var_l;
  params[1] = block2717;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2722 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2716);
// compiled call node returning call2722 (depth = 2)
  gc_frame_end(frame);
  return call2722;
}
Object meth_collectionsPrelude__apply2728(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_found = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2730 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2731 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2730);
// compiled call node returning call2731 (depth = 6)
// compiled member node returning call2731 (depth = 5)
  int op_slot_right_2729 = gc_frame_newslot(call2731);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_found (depth = 5)
  int op_slot_left_2729 = gc_frame_newslot(*var_found);
  params[0] = call2731;
  partcv[0] = 1;
  Object opresult2733 = callmethod(*var_found, "<", 1, partcv, params);
// compiled op node returning opresult2733 (depth = 4)
  gc_frame_end(frame);
  return opresult2733;
}
Object meth_collectionsPrelude__apply2736(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_candidate = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  Object *var_found = getfromclosure(closure, 4);
  Object *var_block1 = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 4)
// Begin line 1342
  setline(1342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2737 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2738 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2739 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2738);
// compiled call node returning call2739 (depth = 7)
// compiled member node returning call2739 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2740 = callmethod(call2739, "at",
    1, partcv, params);
  gc_frame_end(callframe2737);
// compiled call node returning call2740 (depth = 5)
  *var_candidate = call2740;
  if (call2740 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1343
  setline(1343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_candidate (depth = 7)
  int op_slot_right_2744 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_2744 = gc_frame_newslot(*var_removed);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2746 = callmethod(*var_removed, "≠", 1, partcv, params);
// compiled op node returning opresult2746 (depth = 6)
  int op_slot_right_2743 = gc_frame_newslot(opresult2746);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_candidate (depth = 7)
  int op_slot_right_2748 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_2748 = gc_frame_newslot(*var_unused);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2750 = callmethod(*var_unused, "≠", 1, partcv, params);
// compiled op node returning opresult2750 (depth = 6)
  int op_slot_left_2743 = gc_frame_newslot(opresult2750);
  params[0] = opresult2746;
  partcv[0] = 1;
  Object opresult2751 = callmethod(opresult2750, "&&", 1, partcv, params);
// compiled op node returning opresult2751 (depth = 5)
  Object if2742 = done;
  if (istrue(opresult2751)) {
// Begin line 1344
  setline(1344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2753 = alloc_Float64(1);
// compiled num node returning num2753 (depth = 7)
  int op_slot_right_2752 = gc_frame_newslot(num2753);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_found (depth = 7)
  int op_slot_left_2752 = gc_frame_newslot(*var_found);
  params[0] = num2753;
  partcv[0] = 1;
  Object sum2755 = callmethod(*var_found, "+", 1, partcv, params);
// compiled op node returning sum2755 (depth = 6)
  *var_found = sum2755;
  if (sum2755 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1345
  setline(1345);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2757 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  gc_frame_newslot(*var_candidate);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block1 (depth = 6)
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object call2758 = callmethod(*var_block1, "apply",
    1, partcv, params);
  gc_frame_end(callframe2757);
// compiled call node returning call2758 (depth = 5)
    gc_frame_newslot(call2758);
    if2742 = call2758;
  } else {
  }
// compiled if node returning if2742 (depth = 4)
// Begin line 1347
  setline(1347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2760 = alloc_Float64(1);
// compiled num node returning num2760 (depth = 6)
  int op_slot_right_2759 = gc_frame_newslot(num2760);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_2759 = gc_frame_newslot(*var_i);
  params[0] = num2760;
  partcv[0] = 1;
  Object sum2762 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum2762 (depth = 5)
  *var_i = sum2762;
  if (sum2762 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_do2723(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "do");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for do");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_i = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "i");
  Object *var_found = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "found");
  Object *var_candidate = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "candidate");
// Begin line 1338
  setline(1338);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2724 = alloc_Float64(0);
// compiled num node returning num2724 (depth = 3)
  *var_i = num2724;
  if (num2724 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1339
  setline(1339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num2725 = alloc_Float64(0);
// compiled num node returning num2725 (depth = 3)
  *var_found = num2725;
  if (num2725 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1340
  setline(1340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_candidate = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1341
  setline(1341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2726 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2727 = alloc_Block(NULL, NULL, "collectionsPrelude", 1341);
  gc_frame_newslot(block2727);
// method "_apply"
  block_savedest(block2727);
  Object closure2728 = createclosure(2, "_apply");
  setclosureframe(closure2728, stackframe);
  addtoclosure(closure2728, var_found);
  addtoclosure(closure2728, selfslot);
  struct UserObject *uo2728 = (struct UserObject*)block2727;
  uo2728->data[0] = (Object)closure2728;
  Method *meth_meth_collectionsPrelude__apply2728 = addmethod2pos(block2727, "_apply", &meth_collectionsPrelude__apply2728, 0);
  int argcv_meth_collectionsPrelude__apply2728[] = {0};
  meth_meth_collectionsPrelude__apply2728->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2728);
  meth_meth_collectionsPrelude__apply2728->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2728->definitionLine = 1328;
// compiled block node returning block2727 (depth = 3)
  gc_frame_newslot(block2727);
// starting to compile block node (depth = 3)
  Object block2735 = alloc_Block(NULL, NULL, "collectionsPrelude", 1341);
  gc_frame_newslot(block2735);
// method "_apply"
  block_savedest(block2735);
  Object closure2736 = createclosure(7, "_apply");
  setclosureframe(closure2736, stackframe);
  addtoclosure(closure2736, var_i);
  addtoclosure(closure2736, var_candidate);
  addtoclosure(closure2736, var_removed);
  addtoclosure(closure2736, var_unused);
  addtoclosure(closure2736, var_found);
  addtoclosure(closure2736, var_block1);
  addtoclosure(closure2736, selfslot);
  struct UserObject *uo2736 = (struct UserObject*)block2735;
  uo2736->data[0] = (Object)closure2736;
  Method *meth_meth_collectionsPrelude__apply2736 = addmethod2pos(block2735, "_apply", &meth_collectionsPrelude__apply2736, 0);
  int argcv_meth_collectionsPrelude__apply2736[] = {0};
  meth_meth_collectionsPrelude__apply2736->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2736);
  meth_meth_collectionsPrelude__apply2736->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2736->definitionLine = 1341;
// compiled block node returning block2735 (depth = 3)
  gc_frame_newslot(block2735);
// call case 5: prelude request
  params[0] = block2727;
  params[1] = block2735;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2765 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2726);
// compiled call node returning call2765 (depth = 2)
  gc_frame_end(frame);
  return call2765;
}
Object meth_collectionsPrelude_hasNext2772(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2774 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2775 = callmethodflags(self, "count", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2774);
// compiled call node returning call2775 (depth = 4)
// compiled member node returning call2775 (depth = 3)
  int op_slot_right_2773 = gc_frame_newslot(call2775);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2777 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2778 = gc_frame_new();
// call case 3: self.outer request
  Object call2779 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2778);
// compiled call node returning call2779 (depth = 6)
// compiled member node returning call2779 (depth = 5)
  partcv[0] = 0;
  Object call2780 = callmethodflags(call2779, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2777);
// compiled call node returning call2780 (depth = 4)
// compiled member node returning call2780 (depth = 3)
  int op_slot_left_2773 = gc_frame_newslot(call2780);
  params[0] = call2775;
  partcv[0] = 1;
  Object opresult2781 = callmethod(call2780, "≥", 1, partcv, params);
// compiled op node returning opresult2781 (depth = 2)
  gc_frame_end(frame);
  return opresult2781;
}
Object meth_collectionsPrelude__apply2791(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_innerSize = getfromclosure(closure, 1);
  Object *var_IteratorExhausted = getfromclosure(closure, 2);
  Object *var_candidate = getfromclosure(closure, 3);
  Object *var_removed = getfromclosure(closure, 4);
  Object *var_unused = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1360
  setline(1360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2792 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num2794 = alloc_Float64(1);
// compiled num node returning num2794 (depth = 6)
  int op_slot_right_2793 = gc_frame_newslot(num2794);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2796 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2797 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2796);
// compiled call node returning call2797 (depth = 7)
// compiled member node returning call2797 (depth = 6)
  int op_slot_left_2793 = gc_frame_newslot(call2797);
  params[0] = num2794;
  partcv[0] = 1;
  Object sum2798 = callmethod(call2797, "+", 1, partcv, params);
// compiled op node returning sum2798 (depth = 5)
  gc_frame_newslot(sum2798);
// call case 4: self request
  params[0] = sum2798;
  partcv[0] = 1;
  Object call2799 = callmethodflags(self, "idx:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2792);
// compiled call node returning call2799 (depth = 4)
// Begin line 1361
  setline(1361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2802 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2803 = gc_frame_new();
// call case 3: self.outer request
  Object call2804 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2803);
// compiled call node returning call2804 (depth = 9)
// compiled member node returning call2804 (depth = 8)
  partcv[0] = 0;
  Object call2805 = callmethodflags(call2804, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2802);
// compiled call node returning call2805 (depth = 7)
// compiled member node returning call2805 (depth = 6)
  int op_slot_right_2801 = gc_frame_newslot(call2805);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2807 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2808 = callmethodflags(self, "imods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2807);
// compiled call node returning call2808 (depth = 7)
// compiled member node returning call2808 (depth = 6)
  int op_slot_left_2801 = gc_frame_newslot(call2808);
  params[0] = call2805;
  partcv[0] = 1;
  Object opresult2809 = callmethod(call2808, "≠", 1, partcv, params);
// compiled op node returning opresult2809 (depth = 5)
  Object if2800 = done;
  if (istrue(opresult2809)) {
// Begin line 1362
  setline(1362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2810 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2811 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2812 = gc_frame_new();
// call case 3: self.outer request
  Object call2813 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2812);
// compiled call node returning call2813 (depth = 9)
// compiled member node returning call2813 (depth = 8)
  partcv[0] = 0;
  Object call2814 = callmethodflags(call2813, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2811);
// compiled call node returning call2814 (depth = 7)
// compiled member node returning call2814 (depth = 6)
  gc_frame_newslot(call2814);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ConcurrentModification (depth = 6)
  params[0] = call2814;
  partcv[0] = 1;
  Object call2815 = callmethod(*var_ConcurrentModification, "raise",
    1, partcv, params);
  gc_frame_end(callframe2810);
// compiled call node returning call2815 (depth = 5)
    gc_frame_newslot(call2815);
    if2800 = call2815;
  } else {
  }
// compiled if node returning if2800 (depth = 4)
// Begin line 1364
  setline(1364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_innerSize (depth = 6)
  int op_slot_right_2817 = gc_frame_newslot(*var_innerSize);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2819 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2820 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2819);
// compiled call node returning call2820 (depth = 7)
// compiled member node returning call2820 (depth = 6)
  int op_slot_left_2817 = gc_frame_newslot(call2820);
  params[0] = *var_innerSize;
  partcv[0] = 1;
  Object opresult2821 = callmethod(call2820, "≥", 1, partcv, params);
// compiled op node returning opresult2821 (depth = 5)
  Object if2816 = done;
  if (istrue(opresult2821)) {
// Begin line 1365
  setline(1365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2822 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit2824 == NULL) {
    strlit2824 = alloc_String("");
    gc_root(strlit2824);
  }
// compiled string node returning strlit2824 (depth = 7)
  int op_slot_right_2823 = gc_frame_newslot(strlit2824);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2827 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe2828 = gc_frame_new();
// call case 3: self.outer request
  Object call2829 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2828);
// compiled call node returning call2829 (depth = 11)
// compiled member node returning call2829 (depth = 10)
  partcv[0] = 0;
  Object call2830 = callmethodflags(call2829, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2827);
// compiled call node returning call2830 (depth = 9)
// compiled member node returning call2830 (depth = 8)
  int op_slot_right_2826 = gc_frame_newslot(call2830);
// starting to compile string node (depth = 8)
  if (strlit2832 == NULL) {
    strlit2832 = alloc_String("iterator over ");
    gc_root(strlit2832);
  }
// compiled string node returning strlit2832 (depth = 8)
  int op_slot_left_2826 = gc_frame_newslot(strlit2832);
  params[0] = call2830;
  partcv[0] = 1;
  Object opresult2833 = callmethod(strlit2832, "++", 1, partcv, params);
// compiled op node returning opresult2833 (depth = 7)
  int op_slot_left_2823 = gc_frame_newslot(opresult2833);
  params[0] = strlit2824;
  partcv[0] = 1;
  Object opresult2834 = callmethod(opresult2833, "++", 1, partcv, params);
// compiled op node returning opresult2834 (depth = 6)
  gc_frame_newslot(opresult2834);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_IteratorExhausted (depth = 6)
  params[0] = opresult2834;
  partcv[0] = 1;
  Object call2835 = callmethod(*var_IteratorExhausted, "raise",
    1, partcv, params);
  gc_frame_end(callframe2822);
// compiled call node returning call2835 (depth = 5)
    gc_frame_newslot(call2835);
    if2816 = call2835;
  } else {
  }
// compiled if node returning if2816 (depth = 4)
// Begin line 1367
  setline(1367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2836 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2837 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2838 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2837);
// compiled call node returning call2838 (depth = 7)
// compiled member node returning call2838 (depth = 6)
  gc_frame_newslot(call2838);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2839 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe2840 = gc_frame_new();
// call case 3: self.outer request
  Object call2841 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2840);
// compiled call node returning call2841 (depth = 9)
// compiled member node returning call2841 (depth = 8)
  partcv[0] = 0;
  Object call2842 = callmethodflags(call2841, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2839);
// compiled call node returning call2842 (depth = 7)
// compiled member node returning call2842 (depth = 6)
  params[0] = call2838;
  partcv[0] = 1;
  Object call2843 = callmethod(call2842, "at",
    1, partcv, params);
  gc_frame_end(callframe2836);
// compiled call node returning call2843 (depth = 5)
  *var_candidate = call2843;
  if (call2843 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1368
  setline(1368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_right_2846 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  int op_slot_left_2846 = gc_frame_newslot(*var_removed);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2848 = callmethod(*var_removed, "==", 1, partcv, params);
// compiled op node returning opresult2848 (depth = 5)
  int op_slot_right_2845 = gc_frame_newslot(opresult2848);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_candidate (depth = 6)
  int op_slot_right_2850 = gc_frame_newslot(*var_candidate);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_unused (depth = 6)
  int op_slot_left_2850 = gc_frame_newslot(*var_unused);
  params[0] = *var_candidate;
  partcv[0] = 1;
  Object opresult2852 = callmethod(*var_unused, "==", 1, partcv, params);
// compiled op node returning opresult2852 (depth = 5)
  int op_slot_left_2845 = gc_frame_newslot(opresult2852);
  params[0] = opresult2848;
  partcv[0] = 1;
  Object opresult2853 = callmethod(opresult2852, "||", 1, partcv, params);
// compiled op node returning opresult2853 (depth = 4)
  gc_frame_end(frame);
  return opresult2853;
}
Object meth_collectionsPrelude__apply2856(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_next2782(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_candidate = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "candidate");
  Object *var_innerSize = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "innerSize");
// Begin line 1357
  setline(1357);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
  *var_candidate = undefined;
// compiled vardec node returning done (depth = 2)
// Begin line 1358
  setline(1358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2783 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2784 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2785 = gc_frame_new();
// call case 3: self.outer request
  Object call2786 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2785);
// compiled call node returning call2786 (depth = 8)
// compiled member node returning call2786 (depth = 7)
  partcv[0] = 0;
  Object call2787 = callmethodflags(call2786, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2784);
// compiled call node returning call2787 (depth = 6)
// compiled member node returning call2787 (depth = 5)
  partcv[0] = 0;
  Object call2788 = callmethod(call2787, "size",
    1, partcv, params);
  gc_frame_end(callframe2783);
// compiled call node returning call2788 (depth = 4)
// compiled member node returning call2788 (depth = 3)
  *var_innerSize = call2788;
  if (call2788 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1359
  setline(1359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2789 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block2790 = alloc_Block(NULL, NULL, "collectionsPrelude", 1359);
  gc_frame_newslot(block2790);
// method "_apply"
  block_savedest(block2790);
  Object closure2791 = createclosure(7, "_apply");
  setclosureframe(closure2791, stackframe);
  addtoclosure(closure2791, var_ConcurrentModification);
  addtoclosure(closure2791, var_innerSize);
  addtoclosure(closure2791, var_IteratorExhausted);
  addtoclosure(closure2791, var_candidate);
  addtoclosure(closure2791, var_removed);
  addtoclosure(closure2791, var_unused);
  addtoclosure(closure2791, selfslot);
  struct UserObject *uo2791 = (struct UserObject*)block2790;
  uo2791->data[0] = (Object)closure2791;
  Method *meth_meth_collectionsPrelude__apply2791 = addmethod2pos(block2790, "_apply", &meth_collectionsPrelude__apply2791, 0);
  int argcv_meth_collectionsPrelude__apply2791[] = {0};
  meth_meth_collectionsPrelude__apply2791->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2791);
  meth_meth_collectionsPrelude__apply2791->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2791->definitionLine = 1358;
// compiled block node returning block2790 (depth = 3)
  gc_frame_newslot(block2790);
// Begin line 1369
  setline(1369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block2855 = alloc_Block(NULL, NULL, "collectionsPrelude", 1369);
  gc_frame_newslot(block2855);
// method "_apply"
  block_savedest(block2855);
  Object closure2856 = createclosure(1, "_apply");
  setclosureframe(closure2856, stackframe);
  addtoclosure(closure2856, selfslot);
  struct UserObject *uo2856 = (struct UserObject*)block2855;
  uo2856->data[0] = (Object)closure2856;
  Method *meth_meth_collectionsPrelude__apply2856 = addmethod2pos(block2855, "_apply", &meth_collectionsPrelude__apply2856, 0);
  int argcv_meth_collectionsPrelude__apply2856[] = {0};
  meth_meth_collectionsPrelude__apply2856->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2856);
  meth_meth_collectionsPrelude__apply2856->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2856->definitionLine = 1367;
// compiled block node returning block2855 (depth = 3)
  gc_frame_newslot(block2855);
// call case 5: prelude request
  params[0] = block2790;
  params[1] = block2855;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2858 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2789);
// compiled call node returning call2858 (depth = 2)
// Begin line 1370
  setline(1370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2859 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2861 = alloc_Float64(1);
// compiled num node returning num2861 (depth = 4)
  int op_slot_right_2860 = gc_frame_newslot(num2861);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2863 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2864 = callmethodflags(self, "count", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2863);
// compiled call node returning call2864 (depth = 5)
// compiled member node returning call2864 (depth = 4)
  int op_slot_left_2860 = gc_frame_newslot(call2864);
  params[0] = num2861;
  partcv[0] = 1;
  Object sum2865 = callmethod(call2864, "+", 1, partcv, params);
// compiled op node returning sum2865 (depth = 3)
  gc_frame_newslot(sum2865);
// call case 4: self request
  params[0] = sum2865;
  partcv[0] = 1;
  Object call2866 = callmethodflags(self, "count:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2859);
// compiled call node returning call2866 (depth = 2)
// Begin line 1371
  setline(1371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_candidate (depth = 2)
  gc_frame_end(frame);
  return *var_candidate;
}
Object meth_collectionsPrelude_iterator2766(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2767 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2767 = alloc_userobj2(8,6, objclass2767);
  gc_frame_newslot(obj2767);
if (objclass2767 == NULL) {
  glfree(obj2767->class->name);
  obj2767->class->name = "collectionsPrelude.set.ofCapacity.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2767, self, 0);
  addmethodreal(obj2767,"outer", &reader_collectionsPrelude_outer_2768);
  Object oldself2767 = self;
  struct StackFrameObject *oldstackframe2767 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2767);
  gc_frame_newslot((Object)stackframe);
  self = obj2767;
  Object *oldselfslot2767 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2767 = (*(struct UserObject *)self).data[0], lowerouter2767 = thisouter2767;
  if (inheritingObject2767) {
    struct UserObject *inho2767 = (struct UserObject *)inheritingObject2767;
    while (inho2767->super != GraceDefaultObject) inho2767 = (struct UserObject *)inho2767->super;
    inho2767->super = obj2767;
    self = inheritingObject2767;
    *selfslot = self;
    lowerouter2767 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2767;
  }
if (objclass2767 == NULL) {
  Method *reader2769 = addmethodrealflags(obj2767, "imods",&reader_collectionsPrelude_imods_2769, MFLAG_CONFIDENTIAL);
  Method *writer2769 = addmethodrealflags(obj2767, "imods:=",&writer_collectionsPrelude_imods_2769, MFLAG_CONFIDENTIAL);
  reader2769->definitionModule = modulename;
  writer2769->definitionModule = modulename;
  reader2769->definitionLine = 1352;
  writer2769->definitionLine = 1352;
}
obj2767->flags |= OFLAG_MUTABLE;
adddatum2(obj2767, alloc_Undefined(), 1);
if (objclass2767 == NULL) {
  Method *reader2770 = addmethodrealflags(obj2767, "count",&reader_collectionsPrelude_count_2770, MFLAG_CONFIDENTIAL);
  Method *writer2770 = addmethodrealflags(obj2767, "count:=",&writer_collectionsPrelude_count_2770, MFLAG_CONFIDENTIAL);
  reader2770->definitionModule = modulename;
  writer2770->definitionModule = modulename;
  reader2770->definitionLine = 1353;
  writer2770->definitionLine = 1353;
}
obj2767->flags |= OFLAG_MUTABLE;
adddatum2(obj2767, alloc_Undefined(), 2);
if (objclass2767 == NULL) {
  Method *reader2771 = addmethodrealflags(obj2767, "idx",&reader_collectionsPrelude_idx_2771, MFLAG_CONFIDENTIAL);
  Method *writer2771 = addmethodrealflags(obj2767, "idx:=",&writer_collectionsPrelude_idx_2771, MFLAG_CONFIDENTIAL);
  reader2771->definitionModule = modulename;
  writer2771->definitionModule = modulename;
  reader2771->definitionLine = 1354;
  writer2771->definitionLine = 1354;
}
obj2767->flags |= OFLAG_MUTABLE;
adddatum2(obj2767, alloc_Undefined(), 3);
// method "hasNext"
  struct UserObject *uo2772 = (struct UserObject*)obj2767;
  uo2772->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext2772 = addmethod2pos(obj2767, "hasNext", &meth_collectionsPrelude_hasNext2772, 4);
  int argcv_meth_collectionsPrelude_hasNext2772[] = {0};
  meth_meth_collectionsPrelude_hasNext2772->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext2772);
  meth_meth_collectionsPrelude_hasNext2772->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext2772->definitionLine = 1355;
// method "next"
  block_savedest(obj2767);
  Object closure2782 = createclosure(4, "next");
  setclosureframe(closure2782, stackframe);
  addtoclosure(closure2782, var_ConcurrentModification);
  addtoclosure(closure2782, var_IteratorExhausted);
  addtoclosure(closure2782, var_removed);
  addtoclosure(closure2782, var_unused);
  struct UserObject *uo2782 = (struct UserObject*)obj2767;
  uo2782->data[5] = (Object)closure2782;
  Method *meth_meth_collectionsPrelude_next2782 = addmethod2pos(obj2767, "next", &meth_collectionsPrelude_next2782, 5);
  int argcv_meth_collectionsPrelude_next2782[] = {0};
  meth_meth_collectionsPrelude_next2782->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next2782);
  meth_meth_collectionsPrelude_next2782->definitionModule = modulename;
  meth_meth_collectionsPrelude_next2782->definitionLine = 1356;
  sourceObject = obj2767;
// Begin line 1352
  setline(1352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2867 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2868 = gc_frame_new();
// call case 3: self.outer request
  Object call2869 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2868);
// compiled call node returning call2869 (depth = 5)
// compiled member node returning call2869 (depth = 4)
  partcv[0] = 0;
  Object call2870 = callmethodflags(call2869, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2867);
// compiled call node returning call2870 (depth = 3)
// compiled member node returning call2870 (depth = 2)
  adddatum2(obj2767, call2870, 1);
  sourceObject = obj2767;
// Begin line 1353
  setline(1353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2871 = alloc_Float64(1);
// compiled num node returning num2871 (depth = 2)
  adddatum2(obj2767, num2871, 2);
  sourceObject = obj2767;
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2872 = gc_frame_new();
// call case 6: other member request
// Begin line 1354
  setline(1354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num2873 = alloc_Float64(1);
// compiled num node returning num2873 (depth = 3)
  partcv[0] = 0;
  Object call2874 = callmethod(num2873, "prefix-",
    1, partcv, params);
  gc_frame_end(callframe2872);
// compiled call node returning call2874 (depth = 2)
  adddatum2(obj2767, call2874, 3);
  sourceObject = obj2767;
  sourceObject = obj2767;
  objclass2767 = obj2767->class;
  objclass2767->definitionModule = modulename;
  objclass2767->definitionLine = 1351;
  (*(struct UserObject *)self).data[0] = lowerouter2767;
  self = oldself2767;
  selfslot = oldselfslot2767;
  stackframe = oldstackframe2767;
  gc_frame_end(frame);
  return obj2767;
}
Object meth_collectionsPrelude_iterator2766_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2767 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2767 = alloc_userobj2(8,6, objclass2767);
  gc_frame_newslot(obj2767);
if (objclass2767 == NULL) {
  glfree(obj2767->class->name);
  obj2767->class->name = "collectionsPrelude.set.ofCapacity.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2767, self, 0);
  addmethodreal(obj2767,"outer", &reader_collectionsPrelude_outer_2768);
  Object oldself2767 = self;
  struct StackFrameObject *oldstackframe2767 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2767);
  gc_frame_newslot((Object)stackframe);
  self = obj2767;
  Object *oldselfslot2767 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2767 = (*(struct UserObject *)self).data[0], lowerouter2767 = thisouter2767;
  if (inheritingObject2767) {
    struct UserObject *inho2767 = (struct UserObject *)inheritingObject2767;
    while (inho2767->super != GraceDefaultObject) inho2767 = (struct UserObject *)inho2767->super;
    inho2767->super = obj2767;
    self = inheritingObject2767;
    *selfslot = self;
    lowerouter2767 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2767;
  }
if (objclass2767 == NULL) {
  Method *reader2769 = addmethodrealflags(obj2767, "imods",&reader_collectionsPrelude_imods_2769, MFLAG_CONFIDENTIAL);
  Method *writer2769 = addmethodrealflags(obj2767, "imods:=",&writer_collectionsPrelude_imods_2769, MFLAG_CONFIDENTIAL);
  reader2769->definitionModule = modulename;
  writer2769->definitionModule = modulename;
  reader2769->definitionLine = 1352;
  writer2769->definitionLine = 1352;
}
obj2767->flags |= OFLAG_MUTABLE;
adddatum2(obj2767, alloc_Undefined(), 1);
if (objclass2767 == NULL) {
  Method *reader2770 = addmethodrealflags(obj2767, "count",&reader_collectionsPrelude_count_2770, MFLAG_CONFIDENTIAL);
  Method *writer2770 = addmethodrealflags(obj2767, "count:=",&writer_collectionsPrelude_count_2770, MFLAG_CONFIDENTIAL);
  reader2770->definitionModule = modulename;
  writer2770->definitionModule = modulename;
  reader2770->definitionLine = 1353;
  writer2770->definitionLine = 1353;
}
obj2767->flags |= OFLAG_MUTABLE;
adddatum2(obj2767, alloc_Undefined(), 2);
if (objclass2767 == NULL) {
  Method *reader2771 = addmethodrealflags(obj2767, "idx",&reader_collectionsPrelude_idx_2771, MFLAG_CONFIDENTIAL);
  Method *writer2771 = addmethodrealflags(obj2767, "idx:=",&writer_collectionsPrelude_idx_2771, MFLAG_CONFIDENTIAL);
  reader2771->definitionModule = modulename;
  writer2771->definitionModule = modulename;
  reader2771->definitionLine = 1354;
  writer2771->definitionLine = 1354;
}
obj2767->flags |= OFLAG_MUTABLE;
adddatum2(obj2767, alloc_Undefined(), 3);
// method "hasNext"
  struct UserObject *uo2772 = (struct UserObject*)obj2767;
  uo2772->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext2772 = addmethod2pos(obj2767, "hasNext", &meth_collectionsPrelude_hasNext2772, 4);
  int argcv_meth_collectionsPrelude_hasNext2772[] = {0};
  meth_meth_collectionsPrelude_hasNext2772->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext2772);
  meth_meth_collectionsPrelude_hasNext2772->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext2772->definitionLine = 1355;
// method "next"
  block_savedest(obj2767);
  Object closure2782 = createclosure(4, "next");
  setclosureframe(closure2782, stackframe);
  addtoclosure(closure2782, var_ConcurrentModification);
  addtoclosure(closure2782, var_IteratorExhausted);
  addtoclosure(closure2782, var_removed);
  addtoclosure(closure2782, var_unused);
  struct UserObject *uo2782 = (struct UserObject*)obj2767;
  uo2782->data[5] = (Object)closure2782;
  Method *meth_meth_collectionsPrelude_next2782 = addmethod2pos(obj2767, "next", &meth_collectionsPrelude_next2782, 5);
  int argcv_meth_collectionsPrelude_next2782[] = {0};
  meth_meth_collectionsPrelude_next2782->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next2782);
  meth_meth_collectionsPrelude_next2782->definitionModule = modulename;
  meth_meth_collectionsPrelude_next2782->definitionLine = 1356;
  sourceObject = obj2767;
// Begin line 1352
  setline(1352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2867 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2868 = gc_frame_new();
// call case 3: self.outer request
  Object call2869 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2868);
// compiled call node returning call2869 (depth = 5)
// compiled member node returning call2869 (depth = 4)
  partcv[0] = 0;
  Object call2870 = callmethodflags(call2869, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2867);
// compiled call node returning call2870 (depth = 3)
// compiled member node returning call2870 (depth = 2)
  adddatum2(obj2767, call2870, 1);
  sourceObject = obj2767;
// Begin line 1353
  setline(1353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num2871 = alloc_Float64(1);
// compiled num node returning num2871 (depth = 2)
  adddatum2(obj2767, num2871, 2);
  sourceObject = obj2767;
// Begin line 1355
  setline(1355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2872 = gc_frame_new();
// call case 6: other member request
// Begin line 1354
  setline(1354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num2873 = alloc_Float64(1);
// compiled num node returning num2873 (depth = 3)
  partcv[0] = 0;
  Object call2874 = callmethod(num2873, "prefix-",
    1, partcv, params);
  gc_frame_end(callframe2872);
// compiled call node returning call2874 (depth = 2)
  adddatum2(obj2767, call2874, 3);
  sourceObject = obj2767;
  sourceObject = obj2767;
  objclass2767 = obj2767->class;
  objclass2767->definitionModule = modulename;
  objclass2767->definitionLine = 1351;
  (*(struct UserObject *)self).data[0] = lowerouter2767;
  self = oldself2767;
  selfslot = oldselfslot2767;
  stackframe = oldstackframe2767;
  gc_frame_end(frame);
  return obj2767;
}
Object meth_collectionsPrelude__apply2910(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1383
  setline(1383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe2911 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  gc_frame_newslot(*var_unused);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2912 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2913 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2912);
// compiled call node returning call2913 (depth = 6)
// compiled member node returning call2913 (depth = 5)
  params[0] = *var_i;
  params[1] = *var_unused;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2914 = callmethod(call2913, "at()put",
    2, partcv, params);
  gc_frame_end(callframe2911);
// compiled call node returning call2914 (depth = 4)
  gc_frame_end(frame);
  return call2914;
}
Object meth_collectionsPrelude__apply2929(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_oldInner = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1386
  setline(1386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2933 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_oldInner (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2934 = callmethod(*var_oldInner, "at",
    1, partcv, params);
  gc_frame_end(callframe2933);
// compiled call node returning call2934 (depth = 7)
  int op_slot_right_2932 = gc_frame_newslot(call2934);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_2932 = gc_frame_newslot(*var_removed);
  params[0] = call2934;
  partcv[0] = 1;
  Object opresult2936 = callmethod(*var_removed, "≠", 1, partcv, params);
// compiled op node returning opresult2936 (depth = 6)
  int op_slot_right_2931 = gc_frame_newslot(opresult2936);
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe2939 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_oldInner (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2940 = callmethod(*var_oldInner, "at",
    1, partcv, params);
  gc_frame_end(callframe2939);
// compiled call node returning call2940 (depth = 7)
  int op_slot_right_2938 = gc_frame_newslot(call2940);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_2938 = gc_frame_newslot(*var_unused);
  params[0] = call2940;
  partcv[0] = 1;
  Object opresult2942 = callmethod(*var_unused, "≠", 1, partcv, params);
// compiled op node returning opresult2942 (depth = 6)
  int op_slot_left_2931 = gc_frame_newslot(opresult2942);
  params[0] = opresult2936;
  partcv[0] = 1;
  Object opresult2943 = callmethod(opresult2942, "&&", 1, partcv, params);
// compiled op node returning opresult2943 (depth = 5)
  Object if2930 = done;
  if (istrue(opresult2943)) {
// Begin line 1387
  setline(1387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe2944 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe2945 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_oldInner (depth = 7)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call2946 = callmethod(*var_oldInner, "at",
    1, partcv, params);
  gc_frame_end(callframe2945);
// compiled call node returning call2946 (depth = 6)
  gc_frame_newslot(call2946);
// call case 4: self request
  params[0] = call2946;
  partcv[0] = 1;
  Object call2947 = callmethodflags(self, "add", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2944);
// compiled call node returning call2947 (depth = 5)
    gc_frame_newslot(call2947);
    if2930 = call2947;
  } else {
  }
// compiled if node returning if2930 (depth = 4)
  gc_frame_end(frame);
  return if2930;
}
Object meth_collectionsPrelude_expand2876(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expand");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var__prelude = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for expand (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for expand");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_c = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "c");
  Object *var_n = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "n");
  Object *var_oldInner = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "oldInner");
// Begin line 1377
  setline(1377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2877 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2878 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2879 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2878);
// compiled call node returning call2879 (depth = 6)
// compiled member node returning call2879 (depth = 5)
  partcv[0] = 0;
  Object call2880 = callmethod(call2879, "size",
    1, partcv, params);
  gc_frame_end(callframe2877);
// compiled call node returning call2880 (depth = 4)
// compiled member node returning call2880 (depth = 3)
  *var_c = call2880;
  if (call2880 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1378
  setline(1378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2882 = alloc_Float64(2);
// compiled num node returning num2882 (depth = 4)
  int op_slot_right_2881 = gc_frame_newslot(num2882);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  int op_slot_left_2881 = gc_frame_newslot(*var_c);
  params[0] = num2882;
  partcv[0] = 1;
  Object prod2884 = callmethod(*var_c, "*", 1, partcv, params);
// compiled op node returning prod2884 (depth = 3)
  *var_n = prod2884;
  if (prod2884 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1379
  setline(1379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2885 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2886 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2885);
// compiled call node returning call2886 (depth = 4)
// compiled member node returning call2886 (depth = 3)
  *var_oldInner = call2886;
  if (call2886 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1380
  setline(1380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2887 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num2888 = alloc_Float64(0);
// compiled num node returning num2888 (depth = 3)
  gc_frame_newslot(num2888);
// call case 4: self request
  params[0] = num2888;
  partcv[0] = 1;
  Object call2889 = callmethodflags(self, "size:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2887);
// compiled call node returning call2889 (depth = 2)
// Begin line 1381
  setline(1381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2890 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe2891 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2892 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var__prelude (depth = 6)
  partcv[0] = 0;
  Object call2893 = callmethod(*var__prelude, "primitiveArray",
    1, partcv, params);
  gc_frame_end(callframe2892);
// compiled call node returning call2893 (depth = 5)
// compiled member node returning call2893 (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call2894 = callmethod(call2893, "new",
    1, partcv, params);
  gc_frame_end(callframe2891);
// compiled call node returning call2894 (depth = 3)
  gc_frame_newslot(call2894);
// call case 4: self request
  params[0] = call2894;
  partcv[0] = 1;
  Object call2895 = callmethodflags(self, "inner:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2890);
// compiled call node returning call2895 (depth = 2)
// Begin line 1382
  setline(1382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2896 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2899 = alloc_Float64(1);
// compiled num node returning num2899 (depth = 5)
  int op_slot_right_2898 = gc_frame_newslot(num2899);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2901 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2902 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2903 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2902);
// compiled call node returning call2903 (depth = 8)
// compiled member node returning call2903 (depth = 7)
  partcv[0] = 0;
  Object call2904 = callmethod(call2903, "size",
    1, partcv, params);
  gc_frame_end(callframe2901);
// compiled call node returning call2904 (depth = 6)
// compiled member node returning call2904 (depth = 5)
  int op_slot_left_2898 = gc_frame_newslot(call2904);
  params[0] = num2899;
  partcv[0] = 1;
  Object diff2905 = callmethod(call2904, "-", 1, partcv, params);
// compiled op node returning diff2905 (depth = 4)
  int op_slot_right_2897 = gc_frame_newslot(diff2905);
// starting to compile num node (depth = 4)
  Object num2907 = alloc_Float64(0);
// compiled num node returning num2907 (depth = 4)
  int op_slot_left_2897 = gc_frame_newslot(num2907);
  params[0] = diff2905;
  partcv[0] = 1;
  Object opresult2908 = callmethod(num2907, "..", 1, partcv, params);
// compiled op node returning opresult2908 (depth = 3)
  gc_frame_newslot(opresult2908);
// starting to compile block node (depth = 3)
  Object block2909 = alloc_Block(NULL, NULL, "collectionsPrelude", 1382);
  gc_frame_newslot(block2909);
// method "_apply"
  block_savedest(block2909);
  Object closure2910 = createclosure(2, "_apply");
  setclosureframe(closure2910, stackframe);
  addtoclosure(closure2910, var_unused);
  addtoclosure(closure2910, selfslot);
  struct UserObject *uo2910 = (struct UserObject*)block2909;
  uo2910->data[0] = (Object)closure2910;
  Method *meth_meth_collectionsPrelude__apply2910 = addmethod2pos(block2909, "_apply", &meth_collectionsPrelude__apply2910, 0);
  int argcv_meth_collectionsPrelude__apply2910[] = {1};
  meth_meth_collectionsPrelude__apply2910->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2910);
  meth_meth_collectionsPrelude__apply2910->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2910->definitionLine = 1382;
// compiled block node returning block2909 (depth = 3)
  gc_frame_newslot(block2909);
// call case 5: prelude request
  params[0] = opresult2908;
  params[1] = block2909;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2916 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2896);
// compiled call node returning call2916 (depth = 2)
// Begin line 1385
  setline(1385);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2917 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num2920 = alloc_Float64(1);
// compiled num node returning num2920 (depth = 5)
  int op_slot_right_2919 = gc_frame_newslot(num2920);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2922 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_oldInner (depth = 7)
  partcv[0] = 0;
  Object call2923 = callmethod(*var_oldInner, "size",
    1, partcv, params);
  gc_frame_end(callframe2922);
// compiled call node returning call2923 (depth = 6)
// compiled member node returning call2923 (depth = 5)
  int op_slot_left_2919 = gc_frame_newslot(call2923);
  params[0] = num2920;
  partcv[0] = 1;
  Object diff2924 = callmethod(call2923, "-", 1, partcv, params);
// compiled op node returning diff2924 (depth = 4)
  int op_slot_right_2918 = gc_frame_newslot(diff2924);
// starting to compile num node (depth = 4)
  Object num2926 = alloc_Float64(0);
// compiled num node returning num2926 (depth = 4)
  int op_slot_left_2918 = gc_frame_newslot(num2926);
  params[0] = diff2924;
  partcv[0] = 1;
  Object opresult2927 = callmethod(num2926, "..", 1, partcv, params);
// compiled op node returning opresult2927 (depth = 3)
  gc_frame_newslot(opresult2927);
// starting to compile block node (depth = 3)
  Object block2928 = alloc_Block(NULL, NULL, "collectionsPrelude", 1385);
  gc_frame_newslot(block2928);
// method "_apply"
  block_savedest(block2928);
  Object closure2929 = createclosure(4, "_apply");
  setclosureframe(closure2929, stackframe);
  addtoclosure(closure2929, var_oldInner);
  addtoclosure(closure2929, var_removed);
  addtoclosure(closure2929, var_unused);
  addtoclosure(closure2929, selfslot);
  struct UserObject *uo2929 = (struct UserObject*)block2928;
  uo2929->data[0] = (Object)closure2929;
  Method *meth_meth_collectionsPrelude__apply2929 = addmethod2pos(block2928, "_apply", &meth_collectionsPrelude__apply2929, 0);
  int argcv_meth_collectionsPrelude__apply2929[] = {1};
  meth_meth_collectionsPrelude__apply2929->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2929);
  meth_meth_collectionsPrelude__apply2929->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2929->definitionLine = 1385;
// compiled block node returning block2928 (depth = 3)
  gc_frame_newslot(block2928);
// call case 5: prelude request
  params[0] = opresult2927;
  params[1] = block2928;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call2949 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2917);
// compiled call node returning call2949 (depth = 2)
  gc_frame_end(frame);
  return call2949;
}
Object meth_collectionsPrelude__apply2957(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_otherSize = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1395
  setline(1395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num2959 = alloc_Float64(1);
// compiled num node returning num2959 (depth = 7)
  int op_slot_right_2958 = gc_frame_newslot(num2959);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_otherSize (depth = 7)
  int op_slot_left_2958 = gc_frame_newslot(*var_otherSize);
  params[0] = num2959;
  partcv[0] = 1;
  Object sum2961 = callmethod(*var_otherSize, "+", 1, partcv, params);
// compiled op node returning sum2961 (depth = 6)
  *var_otherSize = sum2961;
  if (sum2961 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1396
  setline(1396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2964 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe2965 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  gc_frame_newslot(*var_each);
// call case 4: self request
  params[0] = *var_each;
  partcv[0] = 1;
  Object call2966 = callmethodflags(self, "contains", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2965);
// compiled call node returning call2966 (depth = 7)
  partcv[0] = 0;
  Object call2967 = callmethod(call2966, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe2964);
// compiled call node returning call2967 (depth = 6)
  Object if2963 = done;
  if (istrue(call2967)) {
// Begin line 1397
  setline(1397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool2968 = alloc_Boolean(0);
// compiled identifier node returning bool2968 (depth = 7)
  block_return(realself, bool2968);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if2963 = undefined;
  } else {
  }
// compiled if node returning if2963 (depth = 5)
  gc_frame_end(frame);
  return if2963;
}
Object meth_collectionsPrelude__61__61_2950(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==");
  Object params[1];
  int partcv[1];
  Object *var_Iterable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_otherSize = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "otherSize");
// Begin line 1392
  setline(1392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe2952 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_Iterable (depth = 4)
  params[0] = *var_other;
  partcv[0] = 1;
  Object call2953 = callmethod(*var_Iterable, "match",
    1, partcv, params);
  gc_frame_end(callframe2952);
// compiled call node returning call2953 (depth = 3)
  Object if2951 = done;
  if (istrue(call2953)) {
// Begin line 1393
  setline(1393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile num node (depth = 4)
  Object num2954 = alloc_Float64(0);
// compiled num node returning num2954 (depth = 4)
  *var_otherSize = num2954;
  if (num2954 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 1394
  setline(1394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe2955 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block2956 = alloc_Block(NULL, NULL, "collectionsPrelude", 1394);
  gc_frame_newslot(block2956);
// method "_apply"
  block_savedest(block2956);
  Object closure2957 = createclosure(2, "_apply");
  setclosureframe(closure2957, stackframe);
  addtoclosure(closure2957, var_otherSize);
  addtoclosure(closure2957, selfslot);
  struct UserObject *uo2957 = (struct UserObject*)block2956;
  uo2957->data[0] = (Object)closure2957;
  Method *meth_meth_collectionsPrelude__apply2957 = addmethod2pos(block2956, "_apply", &meth_collectionsPrelude__apply2957, 0);
  int argcv_meth_collectionsPrelude__apply2957[] = {1};
  meth_meth_collectionsPrelude__apply2957->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2957);
  meth_meth_collectionsPrelude__apply2957->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2957->definitionLine = 1385;
// compiled block node returning block2956 (depth = 4)
  gc_frame_newslot(block2956);
// call case 6: other member request
// Begin line 1394
  setline(1394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  params[0] = block2956;
  partcv[0] = 1;
  Object call2970 = callmethod(*var_other, "do",
    1, partcv, params);
  gc_frame_end(callframe2955);
// compiled call node returning call2970 (depth = 3)
// Begin line 1400
  setline(1400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe2972 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2973 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2972);
// compiled call node returning call2973 (depth = 5)
// compiled member node returning call2973 (depth = 4)
  int op_slot_right_2971 = gc_frame_newslot(call2973);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_otherSize (depth = 4)
  int op_slot_left_2971 = gc_frame_newslot(*var_otherSize);
  params[0] = call2973;
  partcv[0] = 1;
  Object opresult2975 = callmethod(*var_otherSize, "==", 1, partcv, params);
// compiled op node returning opresult2975 (depth = 3)
    gc_frame_newslot(opresult2975);
    if2951 = opresult2975;
  } else {
// Begin line 1402
  setline(1402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool2976 = alloc_Boolean(0);
// compiled identifier node returning bool2976 (depth = 3)
    gc_frame_newslot(bool2976);
    if2951 = bool2976;
  }
// compiled if node returning if2951 (depth = 2)
  gc_frame_end(frame);
  return if2951;
}
Object meth_collectionsPrelude_copy2977(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "copy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for copy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for copy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1406
  setline(1406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2978 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 2: outer request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2979 = gc_frame_new();
// call case 3: self.outer request
  Object call2980 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2979);
// compiled call node returning call2980 (depth = 4)
// compiled member node returning call2980 (depth = 3)
  params[0] = self;
  partcv[0] = 1;
  Object call2981 = callmethodflags(call2980, "withAll", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2978);
// compiled call node returning call2981 (depth = 2)
  gc_frame_end(frame);
  return call2981;
}
Object meth_collectionsPrelude__43__43_2982(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++ (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ++");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1410
  setline(1410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2983 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2984 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call2985 = callmethodflags(self, "copy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2984);
// compiled call node returning call2985 (depth = 4)
// compiled member node returning call2985 (depth = 3)
  params[0] = *var_other;
  partcv[0] = 1;
  Object call2986 = callmethod(call2985, "addAll",
    1, partcv, params);
  gc_frame_end(callframe2983);
// compiled call node returning call2986 (depth = 2)
  gc_frame_end(frame);
  return call2986;
}
Object meth_collectionsPrelude__apply2998(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_other = getfromclosure(closure, 0);
  Object *var_result = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1416
  setline(1416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3000 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe3001 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call3002 = callmethod(*var_other, "contains",
    1, partcv, params);
  gc_frame_end(callframe3001);
// compiled call node returning call3002 (depth = 6)
  partcv[0] = 0;
  Object call3003 = callmethod(call3002, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe3000);
// compiled call node returning call3003 (depth = 5)
  Object if2999 = done;
  if (istrue(call3003)) {
// Begin line 1417
  setline(1417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3004 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_result (depth = 6)
  params[0] = *var_v;
  partcv[0] = 1;
  Object call3005 = callmethod(*var_result, "add",
    1, partcv, params);
  gc_frame_end(callframe3004);
// compiled call node returning call3005 (depth = 5)
    gc_frame_newslot(call3005);
    if2999 = call3005;
  } else {
  }
// compiled if node returning if2999 (depth = 4)
  gc_frame_end(frame);
  return if2999;
}
Object meth_collectionsPrelude__45__45_2987(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "--");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method --");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for -- (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for --");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "result");
// Begin line 1414
  setline(1414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2988 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe2989 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe2990 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe2991 = gc_frame_new();
// call case 3: self.outer request
  Object call2992 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe2991);
// compiled call node returning call2992 (depth = 10)
// compiled member node returning call2992 (depth = 9)
  partcv[0] = 0;
  Object call2993 = callmethodflags(call2992, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2990);
// compiled call node returning call2993 (depth = 8)
// compiled member node returning call2993 (depth = 7)
  partcv[0] = 0;
  Object call2994 = callmethodflags(call2993, "set", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2989);
// compiled call node returning call2994 (depth = 6)
// compiled member node returning call2994 (depth = 5)
  partcv[0] = 0;
  Object call2995 = callmethod(call2994, "empty",
    1, partcv, params);
  gc_frame_end(callframe2988);
// compiled call node returning call2995 (depth = 4)
// compiled member node returning call2995 (depth = 3)
  *var_result = call2995;
  if (call2995 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1415
  setline(1415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe2996 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile block node (depth = 3)
  Object block2997 = alloc_Block(NULL, NULL, "collectionsPrelude", 1415);
  gc_frame_newslot(block2997);
// method "_apply"
  block_savedest(block2997);
  Object closure2998 = createclosure(3, "_apply");
  setclosureframe(closure2998, stackframe);
  addtoclosure(closure2998, var_other);
  addtoclosure(closure2998, var_result);
  addtoclosure(closure2998, selfslot);
  struct UserObject *uo2998 = (struct UserObject*)block2997;
  uo2998->data[0] = (Object)closure2998;
  Method *meth_meth_collectionsPrelude__apply2998 = addmethod2pos(block2997, "_apply", &meth_collectionsPrelude__apply2998, 0);
  int argcv_meth_collectionsPrelude__apply2998[] = {1};
  meth_meth_collectionsPrelude__apply2998->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply2998);
  meth_meth_collectionsPrelude__apply2998->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply2998->definitionLine = 1414;
// compiled block node returning block2997 (depth = 3)
  gc_frame_newslot(block2997);
// call case 5: prelude request
  params[0] = self;
  params[1] = block2997;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3007 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe2996);
// compiled call node returning call3007 (depth = 2)
// Begin line 1420
  setline(1420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude__apply3012(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_other = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 6)
  int callframe3013 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_each (depth = 7)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call3014 = callmethod(*var_other, "contains",
    1, partcv, params);
  gc_frame_end(callframe3013);
// compiled call node returning call3014 (depth = 6)
  gc_frame_end(frame);
  return call3014;
}
Object meth_collectionsPrelude__42__42_3008(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "**");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method **");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ** (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for **");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1424
  setline(1424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3009 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 4)
  int callframe3010 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block3011 = alloc_Block(NULL, NULL, "collectionsPrelude", 1424);
  gc_frame_newslot(block3011);
// method "_apply"
  block_savedest(block3011);
  Object closure3012 = createclosure(2, "_apply");
  setclosureframe(closure3012, stackframe);
  addtoclosure(closure3012, var_other);
  addtoclosure(closure3012, selfslot);
  struct UserObject *uo3012 = (struct UserObject*)block3011;
  uo3012->data[0] = (Object)closure3012;
  Method *meth_meth_collectionsPrelude__apply3012 = addmethod2pos(block3011, "_apply", &meth_collectionsPrelude__apply3012, 0);
  int argcv_meth_collectionsPrelude__apply3012[] = {1};
  meth_meth_collectionsPrelude__apply3012->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3012);
  meth_meth_collectionsPrelude__apply3012->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3012->definitionLine = 1424;
// compiled block node returning block3011 (depth = 5)
  gc_frame_newslot(block3011);
// call case 4: self request
  params[0] = block3011;
  partcv[0] = 1;
  Object call3016 = callmethodflags(self, "filter", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3010);
// compiled call node returning call3016 (depth = 4)
  partcv[0] = 0;
  Object call3017 = callmethod(call3016, "asSet",
    1, partcv, params);
  gc_frame_end(callframe3009);
// compiled call node returning call3017 (depth = 3)
// compiled member node returning call3017 (depth = 2)
  gc_frame_end(frame);
  return call3017;
}
Object meth_collectionsPrelude__apply3021(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s2 = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1428
  setline(1428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3023 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe3024 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s2 (depth = 8)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call3025 = callmethod(*var_s2, "contains",
    1, partcv, params);
  gc_frame_end(callframe3024);
// compiled call node returning call3025 (depth = 7)
  partcv[0] = 0;
  Object call3026 = callmethod(call3025, "not",
    1, partcv, params);
  gc_frame_end(callframe3023);
// compiled call node returning call3026 (depth = 6)
// compiled member node returning call3026 (depth = 5)
  Object if3022 = done;
  if (istrue(call3026)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool3027 = alloc_Boolean(0);
// compiled identifier node returning bool3027 (depth = 6)
  block_return(realself, bool3027);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if3022 = undefined;
  } else {
  }
// compiled if node returning if3022 (depth = 4)
  gc_frame_end(frame);
  return if3022;
}
Object meth_collectionsPrelude_isSubset3018(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSubset");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method isSubset");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isSubset (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s2 = &(stackframe->slots[0]);
  *var_s2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for isSubset");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1427
  setline(1427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3019 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3020 = alloc_Block(NULL, NULL, "collectionsPrelude", 1427);
  gc_frame_newslot(block3020);
// method "_apply"
  block_savedest(block3020);
  Object closure3021 = createclosure(2, "_apply");
  setclosureframe(closure3021, stackframe);
  addtoclosure(closure3021, var_s2);
  addtoclosure(closure3021, selfslot);
  struct UserObject *uo3021 = (struct UserObject*)block3020;
  uo3021->data[0] = (Object)closure3021;
  Method *meth_meth_collectionsPrelude__apply3021 = addmethod2pos(block3020, "_apply", &meth_collectionsPrelude__apply3021, 0);
  int argcv_meth_collectionsPrelude__apply3021[] = {1};
  meth_meth_collectionsPrelude__apply3021->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3021);
  meth_meth_collectionsPrelude__apply3021->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3021->definitionLine = 1424;
// compiled block node returning block3020 (depth = 3)
  gc_frame_newslot(block3020);
// call case 4: self request
  params[0] = block3020;
  partcv[0] = 1;
  Object call3029 = callmethodflags(self, "do", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3019);
// compiled call node returning call3029 (depth = 2)
// Begin line 1430
  setline(1430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool3030 = alloc_Boolean(1);
// compiled identifier node returning bool3030 (depth = 3)
  return bool3030;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply3034(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1435
  setline(1435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3036 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 7)
  int callframe3037 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_each (depth = 8)
  gc_frame_newslot(*var_each);
// call case 4: self request
  params[0] = *var_each;
  partcv[0] = 1;
  Object call3038 = callmethodflags(self, "contains", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3037);
// compiled call node returning call3038 (depth = 7)
  partcv[0] = 0;
  Object call3039 = callmethod(call3038, "not",
    1, partcv, params);
  gc_frame_end(callframe3036);
// compiled call node returning call3039 (depth = 6)
// compiled member node returning call3039 (depth = 5)
  Object if3035 = done;
  if (istrue(call3039)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool3040 = alloc_Boolean(0);
// compiled identifier node returning bool3040 (depth = 6)
  block_return(realself, bool3040);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if3035 = undefined;
  } else {
  }
// compiled if node returning if3035 (depth = 4)
  gc_frame_end(frame);
  return if3035;
}
Object meth_collectionsPrelude_isSuperset3031(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isSuperset");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method isSuperset");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isSuperset (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_s2 = &(stackframe->slots[0]);
  *var_s2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for isSuperset");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1434
  setline(1434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3032 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3033 = alloc_Block(NULL, NULL, "collectionsPrelude", 1434);
  gc_frame_newslot(block3033);
// method "_apply"
  block_savedest(block3033);
  Object closure3034 = createclosure(1, "_apply");
  setclosureframe(closure3034, stackframe);
  addtoclosure(closure3034, selfslot);
  struct UserObject *uo3034 = (struct UserObject*)block3033;
  uo3034->data[0] = (Object)closure3034;
  Method *meth_meth_collectionsPrelude__apply3034 = addmethod2pos(block3033, "_apply", &meth_collectionsPrelude__apply3034, 0);
  int argcv_meth_collectionsPrelude__apply3034[] = {1};
  meth_meth_collectionsPrelude__apply3034->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3034);
  meth_meth_collectionsPrelude__apply3034->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3034->definitionLine = 1428;
// compiled block node returning block3033 (depth = 3)
  gc_frame_newslot(block3033);
// call case 6: other member request
// Begin line 1434
  setline(1434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s2 (depth = 3)
  params[0] = block3033;
  partcv[0] = 1;
  Object call3042 = callmethod(*var_s2, "do",
    1, partcv, params);
  gc_frame_end(callframe3032);
// compiled call node returning call3042 (depth = 2)
// Begin line 1437
  setline(1437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool3043 = alloc_Boolean(1);
// compiled identifier node returning bool3043 (depth = 3)
  return bool3043;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply3047(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_existing = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe3048 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_existing (depth = 5)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call3049 = callmethod(*var_existing, "add",
    1, partcv, params);
  gc_frame_end(callframe3048);
// compiled call node returning call3049 (depth = 4)
  gc_frame_end(frame);
  return call3049;
}
Object meth_collectionsPrelude_into3044(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "into");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method into");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for into (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_existing = &(stackframe->slots[0]);
  *var_existing = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for into");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1440
  setline(1440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3045 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3046 = alloc_Block(NULL, NULL, "collectionsPrelude", 1440);
  gc_frame_newslot(block3046);
// method "_apply"
  block_savedest(block3046);
  Object closure3047 = createclosure(2, "_apply");
  setclosureframe(closure3047, stackframe);
  addtoclosure(closure3047, var_existing);
  addtoclosure(closure3047, selfslot);
  struct UserObject *uo3047 = (struct UserObject*)block3046;
  uo3047->data[0] = (Object)closure3047;
  Method *meth_meth_collectionsPrelude__apply3047 = addmethod2pos(block3046, "_apply", &meth_collectionsPrelude__apply3047, 0);
  int argcv_meth_collectionsPrelude__apply3047[] = {1};
  meth_meth_collectionsPrelude__apply3047->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3047);
  meth_meth_collectionsPrelude__apply3047->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3047->definitionLine = 1435;
// compiled block node returning block3046 (depth = 3)
  gc_frame_newslot(block3046);
// call case 4: self request
  params[0] = block3046;
  partcv[0] = 1;
  Object call3051 = callmethodflags(self, "do", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3045);
// compiled call node returning call3051 (depth = 2)
// Begin line 1441
  setline(1441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_existing (depth = 2)
  gc_frame_end(frame);
  return *var_existing;
}
Object meth_collectionsPrelude__apply3062(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1184
  setline(1184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe3063 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  gc_frame_newslot(*var_unused);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3064 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3065 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3064);
// compiled call node returning call3065 (depth = 6)
// compiled member node returning call3065 (depth = 5)
  params[0] = *var_i;
  params[1] = *var_unused;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3066 = callmethod(call3065, "at()put",
    2, partcv, params);
  gc_frame_end(callframe3063);
// compiled call node returning call3066 (depth = 4)
  gc_frame_end(frame);
  return call3066;
}
Object meth_collectionsPrelude_ofCapacity2295(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ofCapacity");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ofCapacity");
  Object params[1];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object *var_ConcurrentModification = getfromclosure(closure, 3);
  Object *var_IteratorExhausted = getfromclosure(closure, 4);
  Object *var__prelude = getfromclosure(closure, 5);
  Object *var_Iterable = getfromclosure(closure, 6);
  Object *var_collection = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ofCapacity (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cap = &(stackframe->slots[0]);
  *var_cap = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ofCapacity");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2296 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2296 = alloc_userobj2(33,31, objclass2296);
  gc_frame_newslot(obj2296);
if (objclass2296 == NULL) {
  glfree(obj2296->class->name);
  obj2296->class->name = "collectionsPrelude.set.ofCapacity";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2296, self, 0);
  addmethodreal(obj2296,"outer", &reader_collectionsPrelude_outer_2297);
  Object oldself2296 = self;
  struct StackFrameObject *oldstackframe2296 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2296);
  gc_frame_newslot((Object)stackframe);
  self = obj2296;
  Object *oldselfslot2296 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2296 = (*(struct UserObject *)self).data[0], lowerouter2296 = thisouter2296;
  if (inheritingObject2296) {
    struct UserObject *inho2296 = (struct UserObject *)inheritingObject2296;
    while (inho2296->super != GraceDefaultObject) inho2296 = (struct UserObject *)inho2296->super;
    inho2296->super = obj2296;
    self = inheritingObject2296;
    *selfslot = self;
    lowerouter2296 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2296;
  }
if (objclass2296 == NULL) {
  Method *reader2298 = addmethodrealflags(obj2296, "mods",&reader_collectionsPrelude_mods_2298, 0);
  Method *writer2298 = addmethodrealflags(obj2296, "mods:=",&writer_collectionsPrelude_mods_2298, MFLAG_CONFIDENTIAL);
  reader2298->definitionModule = modulename;
  writer2298->definitionModule = modulename;
  reader2298->definitionLine = 1180;
  writer2298->definitionLine = 1180;
}
obj2296->flags |= OFLAG_MUTABLE;
adddatum2(obj2296, alloc_Undefined(), 1);
if (objclass2296 == NULL) {
  Method *reader2299 = addmethodrealflags(obj2296, "inner",&reader_collectionsPrelude_inner_2299, MFLAG_CONFIDENTIAL);
  Method *writer2299 = addmethodrealflags(obj2296, "inner:=",&writer_collectionsPrelude_inner_2299, MFLAG_CONFIDENTIAL);
  reader2299->definitionModule = modulename;
  writer2299->definitionModule = modulename;
  reader2299->definitionLine = 1181;
  writer2299->definitionLine = 1181;
}
obj2296->flags |= OFLAG_MUTABLE;
adddatum2(obj2296, alloc_Undefined(), 2);
if (objclass2296 == NULL) {
  Method *reader2300 = addmethodrealflags(obj2296, "size",&reader_collectionsPrelude_size_2300, 0);
  Method *writer2300 = addmethodrealflags(obj2296, "size:=",&writer_collectionsPrelude_size_2300, MFLAG_CONFIDENTIAL);
  reader2300->definitionModule = modulename;
  writer2300->definitionModule = modulename;
  reader2300->definitionLine = 1182;
  writer2300->definitionLine = 1182;
}
obj2296->flags |= OFLAG_MUTABLE;
adddatum2(obj2296, alloc_Undefined(), 3);
// method "addAll"
  struct UserObject *uo2301 = (struct UserObject*)obj2296;
  uo2301->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAll2301 = addmethod2pos(obj2296, "addAll", &meth_collectionsPrelude_addAll2301, 4);
  int argcv_meth_collectionsPrelude_addAll2301[] = {1};
  meth_meth_collectionsPrelude_addAll2301->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAll2301);
  meth_meth_collectionsPrelude_addAll2301->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAll2301->definitionLine = 1187;
// method "add"
  struct UserObject *uo2350 = (struct UserObject*)obj2296;
  uo2350->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_add2350 = addmethod2pos(obj2296, "add", &meth_collectionsPrelude_add2350, 5);
  int argcv_meth_collectionsPrelude_add2350[] = {1};
  meth_meth_collectionsPrelude_add2350->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add2350);
  meth_meth_collectionsPrelude_add2350->definitionModule = modulename;
  meth_meth_collectionsPrelude_add2350->definitionLine = 1202;
// method "removeAll"
  block_savedest(obj2296);
  Object closure2394 = createclosure(1, "removeAll");
  setclosureframe(closure2394, stackframe);
  addtoclosure(closure2394, var_NoSuchObject);
  struct UserObject *uo2394 = (struct UserObject*)obj2296;
  uo2394->data[6] = (Object)closure2394;
  Method *meth_meth_collectionsPrelude_removeAll2394 = addmethod2pos(obj2296, "removeAll", &meth_collectionsPrelude_removeAll2394, 6);
  int argcv_meth_collectionsPrelude_removeAll2394[] = {1};
  meth_meth_collectionsPrelude_removeAll2394->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAll2394);
  meth_meth_collectionsPrelude_removeAll2394->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll2394->definitionLine = 1215;
// method "removeAll()ifAbsent"
  block_savedest(obj2296);
  Object closure2415 = createclosure(1, "removeAll()ifAbsent");
  setclosureframe(closure2415, stackframe);
  addtoclosure(closure2415, var_removed);
  struct UserObject *uo2415 = (struct UserObject*)obj2296;
  uo2415->data[7] = (Object)closure2415;
  Method *meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent2415 = addmethod2pos(obj2296, "removeAll()ifAbsent", &meth_collectionsPrelude_removeAll_40__41_ifAbsent2415, 7);
  int argcv_meth_collectionsPrelude_removeAll_40__41_ifAbsent2415[] = {1, 1};
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent2415->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeAll_40__41_ifAbsent2415);
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent2415->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent2415->definitionLine = 1223;
// method "remove()ifAbsent"
  block_savedest(obj2296);
  Object closure2453 = createclosure(1, "remove()ifAbsent");
  setclosureframe(closure2453, stackframe);
  addtoclosure(closure2453, var_removed);
  struct UserObject *uo2453 = (struct UserObject*)obj2296;
  uo2453->data[8] = (Object)closure2453;
  Method *meth_meth_collectionsPrelude_remove_40__41_ifAbsent2453 = addmethod2pos(obj2296, "remove()ifAbsent", &meth_collectionsPrelude_remove_40__41_ifAbsent2453, 8);
  int argcv_meth_collectionsPrelude_remove_40__41_ifAbsent2453[] = {1, 1};
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent2453->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_remove_40__41_ifAbsent2453);
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent2453->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent2453->definitionLine = 1237;
// method "remove"
  block_savedest(obj2296);
  Object closure2486 = createclosure(1, "remove");
  setclosureframe(closure2486, stackframe);
  addtoclosure(closure2486, var_NoSuchObject);
  struct UserObject *uo2486 = (struct UserObject*)obj2296;
  uo2486->data[9] = (Object)closure2486;
  Method *meth_meth_collectionsPrelude_remove2486 = addmethod2pos(obj2296, "remove", &meth_collectionsPrelude_remove2486, 9);
  int argcv_meth_collectionsPrelude_remove2486[] = {1};
  meth_meth_collectionsPrelude_remove2486->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_remove2486);
  meth_meth_collectionsPrelude_remove2486->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove2486->definitionLine = 1249;
// method "contains"
  struct UserObject *uo2502 = (struct UserObject*)obj2296;
  uo2502->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains2502 = addmethod2pos(obj2296, "contains", &meth_collectionsPrelude_contains2502, 10);
  int argcv_meth_collectionsPrelude_contains2502[] = {1};
  meth_meth_collectionsPrelude_contains2502->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains2502);
  meth_meth_collectionsPrelude_contains2502->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains2502->definitionLine = 1256;
// method "includes"
  struct UserObject *uo2515 = (struct UserObject*)obj2296;
  uo2515->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_includes2515 = addmethod2pos(obj2296, "includes", &meth_collectionsPrelude_includes2515, 11);
  int argcv_meth_collectionsPrelude_includes2515[] = {1};
  meth_meth_collectionsPrelude_includes2515->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_includes2515);
  meth_meth_collectionsPrelude_includes2515->definitionModule = modulename;
  meth_meth_collectionsPrelude_includes2515->definitionLine = 1263;
// method "find()ifNone"
  struct UserObject *uo2526 = (struct UserObject*)obj2296;
  uo2526->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_find_40__41_ifNone2526 = addmethod2pos(obj2296, "find()ifNone", &meth_collectionsPrelude_find_40__41_ifNone2526, 12);
  int argcv_meth_collectionsPrelude_find_40__41_ifNone2526[] = {1, 1};
  meth_meth_collectionsPrelude_find_40__41_ifNone2526->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_find_40__41_ifNone2526);
  meth_meth_collectionsPrelude_find_40__41_ifNone2526->definitionModule = modulename;
  meth_meth_collectionsPrelude_find_40__41_ifNone2526->definitionLine = 1269;
// method "findPosition"
  block_savedest(obj2296);
  Object closure2537 = createclosure(1, "findPosition");
  setclosureframe(closure2537, stackframe);
  addtoclosure(closure2537, var_unused);
  struct UserObject *uo2537 = (struct UserObject*)obj2296;
  uo2537->data[13] = (Object)closure2537;
  Method *meth_meth_collectionsPrelude_findPosition2537 = addmethod2pos(obj2296, "findPosition", &meth_collectionsPrelude_findPosition2537, 13);
  int argcv_meth_collectionsPrelude_findPosition2537[] = {1};
  meth_meth_collectionsPrelude_findPosition2537->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPosition2537);
  meth_meth_collectionsPrelude_findPosition2537->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPosition2537->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPosition2537->definitionLine = 1275;
// method "findPositionForAdd"
  block_savedest(obj2296);
  Object closure2598 = createclosure(2, "findPositionForAdd");
  setclosureframe(closure2598, stackframe);
  addtoclosure(closure2598, var_removed);
  addtoclosure(closure2598, var_unused);
  struct UserObject *uo2598 = (struct UserObject*)obj2296;
  uo2598->data[14] = (Object)closure2598;
  Method *meth_meth_collectionsPrelude_findPositionForAdd2598 = addmethod2pos(obj2296, "findPositionForAdd", &meth_collectionsPrelude_findPositionForAdd2598, 14);
  int argcv_meth_collectionsPrelude_findPositionForAdd2598[] = {1};
  meth_meth_collectionsPrelude_findPositionForAdd2598->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPositionForAdd2598);
  meth_meth_collectionsPrelude_findPositionForAdd2598->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPositionForAdd2598->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPositionForAdd2598->definitionLine = 1297;
// method "asString"
  struct UserObject *uo2665 = (struct UserObject*)obj2296;
  uo2665->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString2665 = addmethod2pos(obj2296, "asString", &meth_collectionsPrelude_asString2665, 15);
  int argcv_meth_collectionsPrelude_asString2665[] = {0};
  meth_meth_collectionsPrelude_asString2665->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString2665);
  meth_meth_collectionsPrelude_asString2665->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString2665->definitionLine = 1320;
// method "asDebugString"
  struct UserObject *uo2690 = (struct UserObject*)obj2296;
  uo2690->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString2690 = addmethod2pos(obj2296, "asDebugString", &meth_collectionsPrelude_asDebugString2690, 16);
  int argcv_meth_collectionsPrelude_asDebugString2690[] = {0};
  meth_meth_collectionsPrelude_asDebugString2690->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString2690);
  meth_meth_collectionsPrelude_asDebugString2690->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString2690->definitionLine = 1326;
// method "extend"
  struct UserObject *uo2715 = (struct UserObject*)obj2296;
  uo2715->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_extend2715 = addmethod2pos(obj2296, "extend", &meth_collectionsPrelude_extend2715, 17);
  int argcv_meth_collectionsPrelude_extend2715[] = {1};
  meth_meth_collectionsPrelude_extend2715->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_extend2715);
  meth_meth_collectionsPrelude_extend2715->definitionModule = modulename;
  meth_meth_collectionsPrelude_extend2715->definitionLine = 1332;
// method "do"
  block_savedest(obj2296);
  Object closure2723 = createclosure(2, "do");
  setclosureframe(closure2723, stackframe);
  addtoclosure(closure2723, var_removed);
  addtoclosure(closure2723, var_unused);
  struct UserObject *uo2723 = (struct UserObject*)obj2296;
  uo2723->data[18] = (Object)closure2723;
  Method *meth_meth_collectionsPrelude_do2723 = addmethod2pos(obj2296, "do", &meth_collectionsPrelude_do2723, 18);
  int argcv_meth_collectionsPrelude_do2723[] = {1};
  meth_meth_collectionsPrelude_do2723->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do2723);
  meth_meth_collectionsPrelude_do2723->definitionModule = modulename;
  meth_meth_collectionsPrelude_do2723->definitionLine = 1337;
// method "iterator"
  block_savedest(obj2296);
  Object closure2766 = createclosure(4, "iterator");
  setclosureframe(closure2766, stackframe);
  addtoclosure(closure2766, var_ConcurrentModification);
  addtoclosure(closure2766, var_IteratorExhausted);
  addtoclosure(closure2766, var_removed);
  addtoclosure(closure2766, var_unused);
  struct UserObject *uo2766 = (struct UserObject*)obj2296;
  uo2766->data[19] = (Object)closure2766;
  Method *meth_meth_collectionsPrelude_iterator2766 = addmethod2pos(obj2296, "iterator", &meth_collectionsPrelude_iterator2766, 19);
  int argcv_meth_collectionsPrelude_iterator2766[] = {0};
  meth_meth_collectionsPrelude_iterator2766->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator2766);
  meth_meth_collectionsPrelude_iterator2766->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator2766->definitionLine = 1350;
  block_savedest(obj2296);
  Object closure2875 = createclosure(4, "iterator()object");
  setclosureframe(closure2875, stackframe);
  addtoclosure(closure2875, var_ConcurrentModification);
  addtoclosure(closure2875, var_IteratorExhausted);
  addtoclosure(closure2875, var_removed);
  addtoclosure(closure2875, var_unused);
  Method *meth_meth_collectionsPrelude_iterator2766_object = addmethod2pos(obj2296, "iterator()object", &meth_collectionsPrelude_iterator2766_object, 19);
  meth_meth_collectionsPrelude_iterator2766_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator2766_object->definitionLine = 1350;
// method "expand"
  block_savedest(obj2296);
  Object closure2876 = createclosure(3, "expand");
  setclosureframe(closure2876, stackframe);
  addtoclosure(closure2876, var__prelude);
  addtoclosure(closure2876, var_unused);
  addtoclosure(closure2876, var_removed);
  struct UserObject *uo2876 = (struct UserObject*)obj2296;
  uo2876->data[20] = (Object)closure2876;
  Method *meth_meth_collectionsPrelude_expand2876 = addmethod2pos(obj2296, "expand", &meth_collectionsPrelude_expand2876, 20);
  int argcv_meth_collectionsPrelude_expand2876[] = {0};
  meth_meth_collectionsPrelude_expand2876->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_expand2876);
  meth_meth_collectionsPrelude_expand2876->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_expand2876->definitionModule = modulename;
  meth_meth_collectionsPrelude_expand2876->definitionLine = 1376;
// method "=="
  block_savedest(obj2296);
  Object closure2950 = createclosure(1, "==");
  setclosureframe(closure2950, stackframe);
  addtoclosure(closure2950, var_Iterable);
  struct UserObject *uo2950 = (struct UserObject*)obj2296;
  uo2950->data[21] = (Object)closure2950;
  Method *meth_meth_collectionsPrelude__61__61_2950 = addmethod2pos(obj2296, "==", &meth_collectionsPrelude__61__61_2950, 21);
  int argcv_meth_collectionsPrelude__61__61_2950[] = {1};
  meth_meth_collectionsPrelude__61__61_2950->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_2950);
  meth_meth_collectionsPrelude__61__61_2950->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_2950->definitionLine = 1391;
// method "copy"
  struct UserObject *uo2977 = (struct UserObject*)obj2296;
  uo2977->data[22] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy2977 = addmethod2pos(obj2296, "copy", &meth_collectionsPrelude_copy2977, 22);
  int argcv_meth_collectionsPrelude_copy2977[] = {0};
  meth_meth_collectionsPrelude_copy2977->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy2977);
  meth_meth_collectionsPrelude_copy2977->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy2977->definitionLine = 1405;
// method "++"
  struct UserObject *uo2982 = (struct UserObject*)obj2296;
  uo2982->data[23] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_2982 = addmethod2pos(obj2296, "++", &meth_collectionsPrelude__43__43_2982, 23);
  int argcv_meth_collectionsPrelude__43__43_2982[] = {1};
  meth_meth_collectionsPrelude__43__43_2982->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_2982);
  meth_meth_collectionsPrelude__43__43_2982->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_2982->definitionLine = 1408;
// method "--"
  struct UserObject *uo2987 = (struct UserObject*)obj2296;
  uo2987->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude__45__45_2987 = addmethod2pos(obj2296, "--", &meth_collectionsPrelude__45__45_2987, 24);
  int argcv_meth_collectionsPrelude__45__45_2987[] = {1};
  meth_meth_collectionsPrelude__45__45_2987->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__45__45_2987);
  meth_meth_collectionsPrelude__45__45_2987->definitionModule = modulename;
  meth_meth_collectionsPrelude__45__45_2987->definitionLine = 1412;
// method "**"
  struct UserObject *uo3008 = (struct UserObject*)obj2296;
  uo3008->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude__42__42_3008 = addmethod2pos(obj2296, "**", &meth_collectionsPrelude__42__42_3008, 25);
  int argcv_meth_collectionsPrelude__42__42_3008[] = {1};
  meth_meth_collectionsPrelude__42__42_3008->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__42__42_3008);
  meth_meth_collectionsPrelude__42__42_3008->definitionModule = modulename;
  meth_meth_collectionsPrelude__42__42_3008->definitionLine = 1422;
// method "isSubset"
  struct UserObject *uo3018 = (struct UserObject*)obj2296;
  uo3018->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isSubset3018 = addmethod2pos(obj2296, "isSubset", &meth_collectionsPrelude_isSubset3018, 26);
  int argcv_meth_collectionsPrelude_isSubset3018[] = {1};
  meth_meth_collectionsPrelude_isSubset3018->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isSubset3018);
  meth_meth_collectionsPrelude_isSubset3018->definitionModule = modulename;
  meth_meth_collectionsPrelude_isSubset3018->definitionLine = 1426;
// method "isSuperset"
  struct UserObject *uo3031 = (struct UserObject*)obj2296;
  uo3031->data[27] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isSuperset3031 = addmethod2pos(obj2296, "isSuperset", &meth_collectionsPrelude_isSuperset3031, 27);
  int argcv_meth_collectionsPrelude_isSuperset3031[] = {1};
  meth_meth_collectionsPrelude_isSuperset3031->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isSuperset3031);
  meth_meth_collectionsPrelude_isSuperset3031->definitionModule = modulename;
  meth_meth_collectionsPrelude_isSuperset3031->definitionLine = 1433;
// method "into"
  struct UserObject *uo3044 = (struct UserObject*)obj2296;
  uo3044->data[28] = emptyclosure;
  Method *meth_meth_collectionsPrelude_into3044 = addmethod2pos(obj2296, "into", &meth_collectionsPrelude_into3044, 28);
  int argcv_meth_collectionsPrelude_into3044[] = {1};
  meth_meth_collectionsPrelude_into3044->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_into3044);
  meth_meth_collectionsPrelude_into3044->definitionModule = modulename;
  meth_meth_collectionsPrelude_into3044->definitionLine = 1439;
  sourceObject = obj2296;
// Begin line 1179
  setline(1179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3052 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collection (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3053 = callmethod(*var_collection, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe3052);
// compiled call node returning call3053 (depth = 2)
  struct UserObject *obj2296_uo = (struct UserObject *)obj2296;
  obj2296_uo->super = call3053;
  sourceObject = obj2296;
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num3054 = alloc_Float64(0);
// compiled num node returning num3054 (depth = 2)
  adddatum2(obj2296, num3054, 1);
  sourceObject = obj2296;
// Begin line 1181
  setline(1181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3055 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cap (depth = 3)
  gc_frame_newslot(*var_cap);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3056 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var__prelude (depth = 5)
  partcv[0] = 0;
  Object call3057 = callmethod(*var__prelude, "primitiveArray",
    1, partcv, params);
  gc_frame_end(callframe3056);
// compiled call node returning call3057 (depth = 4)
// compiled member node returning call3057 (depth = 3)
  params[0] = *var_cap;
  partcv[0] = 1;
  Object call3058 = callmethod(call3057, "new",
    1, partcv, params);
  gc_frame_end(callframe3055);
// compiled call node returning call3058 (depth = 2)
  adddatum2(obj2296, call3058, 2);
  sourceObject = obj2296;
// Begin line 1182
  setline(1182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num3059 = alloc_Float64(0);
// compiled num node returning num3059 (depth = 2)
  adddatum2(obj2296, num3059, 3);
  sourceObject = obj2296;
// Begin line 1183
  setline(1183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3060 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3061 = alloc_Block(NULL, NULL, "collectionsPrelude", 1183);
  gc_frame_newslot(block3061);
// method "_apply"
  block_savedest(block3061);
  Object closure3062 = createclosure(2, "_apply");
  setclosureframe(closure3062, stackframe);
  addtoclosure(closure3062, var_unused);
  addtoclosure(closure3062, selfslot);
  struct UserObject *uo3062 = (struct UserObject*)block3061;
  uo3062->data[0] = (Object)closure3062;
  Method *meth_meth_collectionsPrelude__apply3062 = addmethod2pos(block3061, "_apply", &meth_collectionsPrelude__apply3062, 0);
  int argcv_meth_collectionsPrelude__apply3062[] = {1};
  meth_meth_collectionsPrelude__apply3062->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3062);
  meth_meth_collectionsPrelude__apply3062->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3062->definitionLine = 1181;
// compiled block node returning block3061 (depth = 3)
  gc_frame_newslot(block3061);
// call case 6: other member request
// Begin line 1183
  setline(1183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3070 = alloc_Float64(1);
// compiled num node returning num3070 (depth = 5)
  int op_slot_right_3069 = gc_frame_newslot(num3070);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cap (depth = 5)
  int op_slot_left_3069 = gc_frame_newslot(*var_cap);
  params[0] = num3070;
  partcv[0] = 1;
  Object diff3072 = callmethod(*var_cap, "-", 1, partcv, params);
// compiled op node returning diff3072 (depth = 4)
  int op_slot_right_3068 = gc_frame_newslot(diff3072);
// starting to compile num node (depth = 4)
  Object num3074 = alloc_Float64(0);
// compiled num node returning num3074 (depth = 4)
  int op_slot_left_3068 = gc_frame_newslot(num3074);
  params[0] = diff3072;
  partcv[0] = 1;
  Object opresult3075 = callmethod(num3074, "..", 1, partcv, params);
// compiled op node returning opresult3075 (depth = 3)
  params[0] = block3061;
  partcv[0] = 1;
  Object call3076 = callmethod(opresult3075, "do",
    1, partcv, params);
  gc_frame_end(callframe3060);
// compiled call node returning call3076 (depth = 2)
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  objclass2296 = obj2296->class;
  objclass2296->definitionModule = modulename;
  objclass2296->definitionLine = 1178;
  (*(struct UserObject *)self).data[0] = lowerouter2296;
  self = oldself2296;
  selfslot = oldselfslot2296;
  stackframe = oldstackframe2296;
  gc_frame_end(frame);
  return obj2296;
}
Object meth_collectionsPrelude_ofCapacity2295_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ofCapacity()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ofCapacity()object");
  Object params[1];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object *var_ConcurrentModification = getfromclosure(closure, 3);
  Object *var_IteratorExhausted = getfromclosure(closure, 4);
  Object *var__prelude = getfromclosure(closure, 5);
  Object *var_Iterable = getfromclosure(closure, 6);
  Object *var_collection = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ofCapacity (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_cap = &(stackframe->slots[0]);
  *var_cap = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ofCapacity");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2296 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2296 = alloc_userobj2(33,31, objclass2296);
  gc_frame_newslot(obj2296);
if (objclass2296 == NULL) {
  glfree(obj2296->class->name);
  obj2296->class->name = "collectionsPrelude.set.ofCapacity";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2296, self, 0);
  addmethodreal(obj2296,"outer", &reader_collectionsPrelude_outer_2297);
  Object oldself2296 = self;
  struct StackFrameObject *oldstackframe2296 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2296);
  gc_frame_newslot((Object)stackframe);
  self = obj2296;
  Object *oldselfslot2296 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2296 = (*(struct UserObject *)self).data[0], lowerouter2296 = thisouter2296;
  if (inheritingObject2296) {
    struct UserObject *inho2296 = (struct UserObject *)inheritingObject2296;
    while (inho2296->super != GraceDefaultObject) inho2296 = (struct UserObject *)inho2296->super;
    inho2296->super = obj2296;
    self = inheritingObject2296;
    *selfslot = self;
    lowerouter2296 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2296;
  }
if (objclass2296 == NULL) {
  Method *reader2298 = addmethodrealflags(obj2296, "mods",&reader_collectionsPrelude_mods_2298, 0);
  Method *writer2298 = addmethodrealflags(obj2296, "mods:=",&writer_collectionsPrelude_mods_2298, MFLAG_CONFIDENTIAL);
  reader2298->definitionModule = modulename;
  writer2298->definitionModule = modulename;
  reader2298->definitionLine = 1180;
  writer2298->definitionLine = 1180;
}
obj2296->flags |= OFLAG_MUTABLE;
adddatum2(obj2296, alloc_Undefined(), 1);
if (objclass2296 == NULL) {
  Method *reader2299 = addmethodrealflags(obj2296, "inner",&reader_collectionsPrelude_inner_2299, MFLAG_CONFIDENTIAL);
  Method *writer2299 = addmethodrealflags(obj2296, "inner:=",&writer_collectionsPrelude_inner_2299, MFLAG_CONFIDENTIAL);
  reader2299->definitionModule = modulename;
  writer2299->definitionModule = modulename;
  reader2299->definitionLine = 1181;
  writer2299->definitionLine = 1181;
}
obj2296->flags |= OFLAG_MUTABLE;
adddatum2(obj2296, alloc_Undefined(), 2);
if (objclass2296 == NULL) {
  Method *reader2300 = addmethodrealflags(obj2296, "size",&reader_collectionsPrelude_size_2300, 0);
  Method *writer2300 = addmethodrealflags(obj2296, "size:=",&writer_collectionsPrelude_size_2300, MFLAG_CONFIDENTIAL);
  reader2300->definitionModule = modulename;
  writer2300->definitionModule = modulename;
  reader2300->definitionLine = 1182;
  writer2300->definitionLine = 1182;
}
obj2296->flags |= OFLAG_MUTABLE;
adddatum2(obj2296, alloc_Undefined(), 3);
// method "addAll"
  struct UserObject *uo2301 = (struct UserObject*)obj2296;
  uo2301->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_addAll2301 = addmethod2pos(obj2296, "addAll", &meth_collectionsPrelude_addAll2301, 4);
  int argcv_meth_collectionsPrelude_addAll2301[] = {1};
  meth_meth_collectionsPrelude_addAll2301->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_addAll2301);
  meth_meth_collectionsPrelude_addAll2301->definitionModule = modulename;
  meth_meth_collectionsPrelude_addAll2301->definitionLine = 1187;
// method "add"
  struct UserObject *uo2350 = (struct UserObject*)obj2296;
  uo2350->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_add2350 = addmethod2pos(obj2296, "add", &meth_collectionsPrelude_add2350, 5);
  int argcv_meth_collectionsPrelude_add2350[] = {1};
  meth_meth_collectionsPrelude_add2350->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add2350);
  meth_meth_collectionsPrelude_add2350->definitionModule = modulename;
  meth_meth_collectionsPrelude_add2350->definitionLine = 1202;
// method "removeAll"
  block_savedest(obj2296);
  Object closure2394 = createclosure(1, "removeAll");
  setclosureframe(closure2394, stackframe);
  addtoclosure(closure2394, var_NoSuchObject);
  struct UserObject *uo2394 = (struct UserObject*)obj2296;
  uo2394->data[6] = (Object)closure2394;
  Method *meth_meth_collectionsPrelude_removeAll2394 = addmethod2pos(obj2296, "removeAll", &meth_collectionsPrelude_removeAll2394, 6);
  int argcv_meth_collectionsPrelude_removeAll2394[] = {1};
  meth_meth_collectionsPrelude_removeAll2394->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAll2394);
  meth_meth_collectionsPrelude_removeAll2394->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll2394->definitionLine = 1215;
// method "removeAll()ifAbsent"
  block_savedest(obj2296);
  Object closure2415 = createclosure(1, "removeAll()ifAbsent");
  setclosureframe(closure2415, stackframe);
  addtoclosure(closure2415, var_removed);
  struct UserObject *uo2415 = (struct UserObject*)obj2296;
  uo2415->data[7] = (Object)closure2415;
  Method *meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent2415 = addmethod2pos(obj2296, "removeAll()ifAbsent", &meth_collectionsPrelude_removeAll_40__41_ifAbsent2415, 7);
  int argcv_meth_collectionsPrelude_removeAll_40__41_ifAbsent2415[] = {1, 1};
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent2415->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeAll_40__41_ifAbsent2415);
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent2415->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAll_40__41_ifAbsent2415->definitionLine = 1223;
// method "remove()ifAbsent"
  block_savedest(obj2296);
  Object closure2453 = createclosure(1, "remove()ifAbsent");
  setclosureframe(closure2453, stackframe);
  addtoclosure(closure2453, var_removed);
  struct UserObject *uo2453 = (struct UserObject*)obj2296;
  uo2453->data[8] = (Object)closure2453;
  Method *meth_meth_collectionsPrelude_remove_40__41_ifAbsent2453 = addmethod2pos(obj2296, "remove()ifAbsent", &meth_collectionsPrelude_remove_40__41_ifAbsent2453, 8);
  int argcv_meth_collectionsPrelude_remove_40__41_ifAbsent2453[] = {1, 1};
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent2453->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_remove_40__41_ifAbsent2453);
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent2453->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove_40__41_ifAbsent2453->definitionLine = 1237;
// method "remove"
  block_savedest(obj2296);
  Object closure2486 = createclosure(1, "remove");
  setclosureframe(closure2486, stackframe);
  addtoclosure(closure2486, var_NoSuchObject);
  struct UserObject *uo2486 = (struct UserObject*)obj2296;
  uo2486->data[9] = (Object)closure2486;
  Method *meth_meth_collectionsPrelude_remove2486 = addmethod2pos(obj2296, "remove", &meth_collectionsPrelude_remove2486, 9);
  int argcv_meth_collectionsPrelude_remove2486[] = {1};
  meth_meth_collectionsPrelude_remove2486->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_remove2486);
  meth_meth_collectionsPrelude_remove2486->definitionModule = modulename;
  meth_meth_collectionsPrelude_remove2486->definitionLine = 1249;
// method "contains"
  struct UserObject *uo2502 = (struct UserObject*)obj2296;
  uo2502->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains2502 = addmethod2pos(obj2296, "contains", &meth_collectionsPrelude_contains2502, 10);
  int argcv_meth_collectionsPrelude_contains2502[] = {1};
  meth_meth_collectionsPrelude_contains2502->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains2502);
  meth_meth_collectionsPrelude_contains2502->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains2502->definitionLine = 1256;
// method "includes"
  struct UserObject *uo2515 = (struct UserObject*)obj2296;
  uo2515->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_includes2515 = addmethod2pos(obj2296, "includes", &meth_collectionsPrelude_includes2515, 11);
  int argcv_meth_collectionsPrelude_includes2515[] = {1};
  meth_meth_collectionsPrelude_includes2515->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_includes2515);
  meth_meth_collectionsPrelude_includes2515->definitionModule = modulename;
  meth_meth_collectionsPrelude_includes2515->definitionLine = 1263;
// method "find()ifNone"
  struct UserObject *uo2526 = (struct UserObject*)obj2296;
  uo2526->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_find_40__41_ifNone2526 = addmethod2pos(obj2296, "find()ifNone", &meth_collectionsPrelude_find_40__41_ifNone2526, 12);
  int argcv_meth_collectionsPrelude_find_40__41_ifNone2526[] = {1, 1};
  meth_meth_collectionsPrelude_find_40__41_ifNone2526->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_find_40__41_ifNone2526);
  meth_meth_collectionsPrelude_find_40__41_ifNone2526->definitionModule = modulename;
  meth_meth_collectionsPrelude_find_40__41_ifNone2526->definitionLine = 1269;
// method "findPosition"
  block_savedest(obj2296);
  Object closure2537 = createclosure(1, "findPosition");
  setclosureframe(closure2537, stackframe);
  addtoclosure(closure2537, var_unused);
  struct UserObject *uo2537 = (struct UserObject*)obj2296;
  uo2537->data[13] = (Object)closure2537;
  Method *meth_meth_collectionsPrelude_findPosition2537 = addmethod2pos(obj2296, "findPosition", &meth_collectionsPrelude_findPosition2537, 13);
  int argcv_meth_collectionsPrelude_findPosition2537[] = {1};
  meth_meth_collectionsPrelude_findPosition2537->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPosition2537);
  meth_meth_collectionsPrelude_findPosition2537->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPosition2537->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPosition2537->definitionLine = 1275;
// method "findPositionForAdd"
  block_savedest(obj2296);
  Object closure2598 = createclosure(2, "findPositionForAdd");
  setclosureframe(closure2598, stackframe);
  addtoclosure(closure2598, var_removed);
  addtoclosure(closure2598, var_unused);
  struct UserObject *uo2598 = (struct UserObject*)obj2296;
  uo2598->data[14] = (Object)closure2598;
  Method *meth_meth_collectionsPrelude_findPositionForAdd2598 = addmethod2pos(obj2296, "findPositionForAdd", &meth_collectionsPrelude_findPositionForAdd2598, 14);
  int argcv_meth_collectionsPrelude_findPositionForAdd2598[] = {1};
  meth_meth_collectionsPrelude_findPositionForAdd2598->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPositionForAdd2598);
  meth_meth_collectionsPrelude_findPositionForAdd2598->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPositionForAdd2598->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPositionForAdd2598->definitionLine = 1297;
// method "asString"
  struct UserObject *uo2665 = (struct UserObject*)obj2296;
  uo2665->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString2665 = addmethod2pos(obj2296, "asString", &meth_collectionsPrelude_asString2665, 15);
  int argcv_meth_collectionsPrelude_asString2665[] = {0};
  meth_meth_collectionsPrelude_asString2665->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString2665);
  meth_meth_collectionsPrelude_asString2665->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString2665->definitionLine = 1320;
// method "asDebugString"
  struct UserObject *uo2690 = (struct UserObject*)obj2296;
  uo2690->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDebugString2690 = addmethod2pos(obj2296, "asDebugString", &meth_collectionsPrelude_asDebugString2690, 16);
  int argcv_meth_collectionsPrelude_asDebugString2690[] = {0};
  meth_meth_collectionsPrelude_asDebugString2690->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString2690);
  meth_meth_collectionsPrelude_asDebugString2690->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString2690->definitionLine = 1326;
// method "extend"
  struct UserObject *uo2715 = (struct UserObject*)obj2296;
  uo2715->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_extend2715 = addmethod2pos(obj2296, "extend", &meth_collectionsPrelude_extend2715, 17);
  int argcv_meth_collectionsPrelude_extend2715[] = {1};
  meth_meth_collectionsPrelude_extend2715->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_extend2715);
  meth_meth_collectionsPrelude_extend2715->definitionModule = modulename;
  meth_meth_collectionsPrelude_extend2715->definitionLine = 1332;
// method "do"
  block_savedest(obj2296);
  Object closure2723 = createclosure(2, "do");
  setclosureframe(closure2723, stackframe);
  addtoclosure(closure2723, var_removed);
  addtoclosure(closure2723, var_unused);
  struct UserObject *uo2723 = (struct UserObject*)obj2296;
  uo2723->data[18] = (Object)closure2723;
  Method *meth_meth_collectionsPrelude_do2723 = addmethod2pos(obj2296, "do", &meth_collectionsPrelude_do2723, 18);
  int argcv_meth_collectionsPrelude_do2723[] = {1};
  meth_meth_collectionsPrelude_do2723->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do2723);
  meth_meth_collectionsPrelude_do2723->definitionModule = modulename;
  meth_meth_collectionsPrelude_do2723->definitionLine = 1337;
// method "iterator"
  block_savedest(obj2296);
  Object closure2766 = createclosure(4, "iterator");
  setclosureframe(closure2766, stackframe);
  addtoclosure(closure2766, var_ConcurrentModification);
  addtoclosure(closure2766, var_IteratorExhausted);
  addtoclosure(closure2766, var_removed);
  addtoclosure(closure2766, var_unused);
  struct UserObject *uo2766 = (struct UserObject*)obj2296;
  uo2766->data[19] = (Object)closure2766;
  Method *meth_meth_collectionsPrelude_iterator2766 = addmethod2pos(obj2296, "iterator", &meth_collectionsPrelude_iterator2766, 19);
  int argcv_meth_collectionsPrelude_iterator2766[] = {0};
  meth_meth_collectionsPrelude_iterator2766->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator2766);
  meth_meth_collectionsPrelude_iterator2766->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator2766->definitionLine = 1350;
  block_savedest(obj2296);
  Object closure2875 = createclosure(4, "iterator()object");
  setclosureframe(closure2875, stackframe);
  addtoclosure(closure2875, var_ConcurrentModification);
  addtoclosure(closure2875, var_IteratorExhausted);
  addtoclosure(closure2875, var_removed);
  addtoclosure(closure2875, var_unused);
  Method *meth_meth_collectionsPrelude_iterator2766_object = addmethod2pos(obj2296, "iterator()object", &meth_collectionsPrelude_iterator2766_object, 19);
  meth_meth_collectionsPrelude_iterator2766_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator2766_object->definitionLine = 1350;
// method "expand"
  block_savedest(obj2296);
  Object closure2876 = createclosure(3, "expand");
  setclosureframe(closure2876, stackframe);
  addtoclosure(closure2876, var__prelude);
  addtoclosure(closure2876, var_unused);
  addtoclosure(closure2876, var_removed);
  struct UserObject *uo2876 = (struct UserObject*)obj2296;
  uo2876->data[20] = (Object)closure2876;
  Method *meth_meth_collectionsPrelude_expand2876 = addmethod2pos(obj2296, "expand", &meth_collectionsPrelude_expand2876, 20);
  int argcv_meth_collectionsPrelude_expand2876[] = {0};
  meth_meth_collectionsPrelude_expand2876->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_expand2876);
  meth_meth_collectionsPrelude_expand2876->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_expand2876->definitionModule = modulename;
  meth_meth_collectionsPrelude_expand2876->definitionLine = 1376;
// method "=="
  block_savedest(obj2296);
  Object closure2950 = createclosure(1, "==");
  setclosureframe(closure2950, stackframe);
  addtoclosure(closure2950, var_Iterable);
  struct UserObject *uo2950 = (struct UserObject*)obj2296;
  uo2950->data[21] = (Object)closure2950;
  Method *meth_meth_collectionsPrelude__61__61_2950 = addmethod2pos(obj2296, "==", &meth_collectionsPrelude__61__61_2950, 21);
  int argcv_meth_collectionsPrelude__61__61_2950[] = {1};
  meth_meth_collectionsPrelude__61__61_2950->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_2950);
  meth_meth_collectionsPrelude__61__61_2950->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_2950->definitionLine = 1391;
// method "copy"
  struct UserObject *uo2977 = (struct UserObject*)obj2296;
  uo2977->data[22] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy2977 = addmethod2pos(obj2296, "copy", &meth_collectionsPrelude_copy2977, 22);
  int argcv_meth_collectionsPrelude_copy2977[] = {0};
  meth_meth_collectionsPrelude_copy2977->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy2977);
  meth_meth_collectionsPrelude_copy2977->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy2977->definitionLine = 1405;
// method "++"
  struct UserObject *uo2982 = (struct UserObject*)obj2296;
  uo2982->data[23] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_2982 = addmethod2pos(obj2296, "++", &meth_collectionsPrelude__43__43_2982, 23);
  int argcv_meth_collectionsPrelude__43__43_2982[] = {1};
  meth_meth_collectionsPrelude__43__43_2982->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_2982);
  meth_meth_collectionsPrelude__43__43_2982->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_2982->definitionLine = 1408;
// method "--"
  struct UserObject *uo2987 = (struct UserObject*)obj2296;
  uo2987->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude__45__45_2987 = addmethod2pos(obj2296, "--", &meth_collectionsPrelude__45__45_2987, 24);
  int argcv_meth_collectionsPrelude__45__45_2987[] = {1};
  meth_meth_collectionsPrelude__45__45_2987->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__45__45_2987);
  meth_meth_collectionsPrelude__45__45_2987->definitionModule = modulename;
  meth_meth_collectionsPrelude__45__45_2987->definitionLine = 1412;
// method "**"
  struct UserObject *uo3008 = (struct UserObject*)obj2296;
  uo3008->data[25] = emptyclosure;
  Method *meth_meth_collectionsPrelude__42__42_3008 = addmethod2pos(obj2296, "**", &meth_collectionsPrelude__42__42_3008, 25);
  int argcv_meth_collectionsPrelude__42__42_3008[] = {1};
  meth_meth_collectionsPrelude__42__42_3008->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__42__42_3008);
  meth_meth_collectionsPrelude__42__42_3008->definitionModule = modulename;
  meth_meth_collectionsPrelude__42__42_3008->definitionLine = 1422;
// method "isSubset"
  struct UserObject *uo3018 = (struct UserObject*)obj2296;
  uo3018->data[26] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isSubset3018 = addmethod2pos(obj2296, "isSubset", &meth_collectionsPrelude_isSubset3018, 26);
  int argcv_meth_collectionsPrelude_isSubset3018[] = {1};
  meth_meth_collectionsPrelude_isSubset3018->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isSubset3018);
  meth_meth_collectionsPrelude_isSubset3018->definitionModule = modulename;
  meth_meth_collectionsPrelude_isSubset3018->definitionLine = 1426;
// method "isSuperset"
  struct UserObject *uo3031 = (struct UserObject*)obj2296;
  uo3031->data[27] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isSuperset3031 = addmethod2pos(obj2296, "isSuperset", &meth_collectionsPrelude_isSuperset3031, 27);
  int argcv_meth_collectionsPrelude_isSuperset3031[] = {1};
  meth_meth_collectionsPrelude_isSuperset3031->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isSuperset3031);
  meth_meth_collectionsPrelude_isSuperset3031->definitionModule = modulename;
  meth_meth_collectionsPrelude_isSuperset3031->definitionLine = 1433;
// method "into"
  struct UserObject *uo3044 = (struct UserObject*)obj2296;
  uo3044->data[28] = emptyclosure;
  Method *meth_meth_collectionsPrelude_into3044 = addmethod2pos(obj2296, "into", &meth_collectionsPrelude_into3044, 28);
  int argcv_meth_collectionsPrelude_into3044[] = {1};
  meth_meth_collectionsPrelude_into3044->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_into3044);
  meth_meth_collectionsPrelude_into3044->definitionModule = modulename;
  meth_meth_collectionsPrelude_into3044->definitionLine = 1439;
  sourceObject = obj2296;
// Begin line 1179
  setline(1179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3052 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collection (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3053 = callmethod(*var_collection, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe3052);
// compiled call node returning call3053 (depth = 2)
  struct UserObject *obj2296_uo = (struct UserObject *)obj2296;
  obj2296_uo->super = call3053;
  sourceObject = obj2296;
// Begin line 1180
  setline(1180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num3054 = alloc_Float64(0);
// compiled num node returning num3054 (depth = 2)
  adddatum2(obj2296, num3054, 1);
  sourceObject = obj2296;
// Begin line 1181
  setline(1181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3055 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_cap (depth = 3)
  gc_frame_newslot(*var_cap);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3056 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var__prelude (depth = 5)
  partcv[0] = 0;
  Object call3057 = callmethod(*var__prelude, "primitiveArray",
    1, partcv, params);
  gc_frame_end(callframe3056);
// compiled call node returning call3057 (depth = 4)
// compiled member node returning call3057 (depth = 3)
  params[0] = *var_cap;
  partcv[0] = 1;
  Object call3058 = callmethod(call3057, "new",
    1, partcv, params);
  gc_frame_end(callframe3055);
// compiled call node returning call3058 (depth = 2)
  adddatum2(obj2296, call3058, 2);
  sourceObject = obj2296;
// Begin line 1182
  setline(1182);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num3059 = alloc_Float64(0);
// compiled num node returning num3059 (depth = 2)
  adddatum2(obj2296, num3059, 3);
  sourceObject = obj2296;
// Begin line 1183
  setline(1183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3060 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3061 = alloc_Block(NULL, NULL, "collectionsPrelude", 1183);
  gc_frame_newslot(block3061);
// method "_apply"
  block_savedest(block3061);
  Object closure3062 = createclosure(2, "_apply");
  setclosureframe(closure3062, stackframe);
  addtoclosure(closure3062, var_unused);
  addtoclosure(closure3062, selfslot);
  struct UserObject *uo3062 = (struct UserObject*)block3061;
  uo3062->data[0] = (Object)closure3062;
  Method *meth_meth_collectionsPrelude__apply3062 = addmethod2pos(block3061, "_apply", &meth_collectionsPrelude__apply3062, 0);
  int argcv_meth_collectionsPrelude__apply3062[] = {1};
  meth_meth_collectionsPrelude__apply3062->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3062);
  meth_meth_collectionsPrelude__apply3062->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3062->definitionLine = 1181;
// compiled block node returning block3061 (depth = 3)
  gc_frame_newslot(block3061);
// call case 6: other member request
// Begin line 1183
  setline(1183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3070 = alloc_Float64(1);
// compiled num node returning num3070 (depth = 5)
  int op_slot_right_3069 = gc_frame_newslot(num3070);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_cap (depth = 5)
  int op_slot_left_3069 = gc_frame_newslot(*var_cap);
  params[0] = num3070;
  partcv[0] = 1;
  Object diff3072 = callmethod(*var_cap, "-", 1, partcv, params);
// compiled op node returning diff3072 (depth = 4)
  int op_slot_right_3068 = gc_frame_newslot(diff3072);
// starting to compile num node (depth = 4)
  Object num3074 = alloc_Float64(0);
// compiled num node returning num3074 (depth = 4)
  int op_slot_left_3068 = gc_frame_newslot(num3074);
  params[0] = diff3072;
  partcv[0] = 1;
  Object opresult3075 = callmethod(num3074, "..", 1, partcv, params);
// compiled op node returning opresult3075 (depth = 3)
  params[0] = block3061;
  partcv[0] = 1;
  Object call3076 = callmethod(opresult3075, "do",
    1, partcv, params);
  gc_frame_end(callframe3060);
// compiled call node returning call3076 (depth = 2)
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  sourceObject = obj2296;
  objclass2296 = obj2296->class;
  objclass2296->definitionModule = modulename;
  objclass2296->definitionLine = 1178;
  (*(struct UserObject *)self).data[0] = lowerouter2296;
  self = oldself2296;
  selfslot = oldselfslot2296;
  stackframe = oldstackframe2296;
  gc_frame_end(frame);
  return obj2296;
}
Object meth_collectionsPrelude_set2257(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "set");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object *var_ConcurrentModification = getfromclosure(closure, 3);
  Object *var_IteratorExhausted = getfromclosure(closure, 4);
  Object *var__prelude = getfromclosure(closure, 5);
  Object *var_Iterable = getfromclosure(closure, 6);
  Object *var_collection = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for set (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for set");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2258 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2258 = alloc_userobj2(5,6, objclass2258);
  gc_frame_newslot(obj2258);
if (objclass2258 == NULL) {
  glfree(obj2258->class->name);
  obj2258->class->name = "collectionsPrelude.set";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2258, self, 0);
  addmethodreal(obj2258,"outer", &reader_collectionsPrelude_outer_2259);
  Object oldself2258 = self;
  struct StackFrameObject *oldstackframe2258 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2258);
  gc_frame_newslot((Object)stackframe);
  self = obj2258;
  Object *oldselfslot2258 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2258 = (*(struct UserObject *)self).data[0], lowerouter2258 = thisouter2258;
  if (inheritingObject2258) {
    struct UserObject *inho2258 = (struct UserObject *)inheritingObject2258;
    while (inho2258->super != GraceDefaultObject) inho2258 = (struct UserObject *)inho2258->super;
    inho2258->super = obj2258;
    self = inheritingObject2258;
    *selfslot = self;
    lowerouter2258 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2258;
  }
// method "asString"
  struct UserObject *uo2260 = (struct UserObject*)obj2258;
  uo2260->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString2260 = addmethod2pos(obj2258, "asString", &meth_collectionsPrelude_asString2260, 1);
  int argcv_meth_collectionsPrelude_asString2260[] = {0};
  meth_meth_collectionsPrelude_asString2260->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString2260);
  meth_meth_collectionsPrelude_asString2260->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString2260->definitionLine = 1165;
// method "withAll"
  struct UserObject *uo2262 = (struct UserObject*)obj2258;
  uo2262->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_withAll2262 = addmethod2pos(obj2258, "withAll", &meth_collectionsPrelude_withAll2262, 2);
  int argcv_meth_collectionsPrelude_withAll2262[] = {1};
  meth_meth_collectionsPrelude_withAll2262->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll2262);
  meth_meth_collectionsPrelude_withAll2262->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll2262->definitionLine = 1167;
// method "empty"
  struct UserObject *uo2291 = (struct UserObject*)obj2258;
  uo2291->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_empty2291 = addmethod2pos(obj2258, "empty", &meth_collectionsPrelude_empty2291, 3);
  int argcv_meth_collectionsPrelude_empty2291[] = {0};
  meth_meth_collectionsPrelude_empty2291->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_empty2291);
  meth_meth_collectionsPrelude_empty2291->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty2291->definitionLine = 1174;
// method "ofCapacity"
  block_savedest(obj2258);
  Object closure2295 = createclosure(8, "ofCapacity");
  setclosureframe(closure2295, stackframe);
  addtoclosure(closure2295, var_NoSuchObject);
  addtoclosure(closure2295, var_removed);
  addtoclosure(closure2295, var_unused);
  addtoclosure(closure2295, var_ConcurrentModification);
  addtoclosure(closure2295, var_IteratorExhausted);
  addtoclosure(closure2295, var__prelude);
  addtoclosure(closure2295, var_Iterable);
  addtoclosure(closure2295, var_collection);
  struct UserObject *uo2295 = (struct UserObject*)obj2258;
  uo2295->data[4] = (Object)closure2295;
  Method *meth_meth_collectionsPrelude_ofCapacity2295 = addmethod2pos(obj2258, "ofCapacity", &meth_collectionsPrelude_ofCapacity2295, 4);
  int argcv_meth_collectionsPrelude_ofCapacity2295[] = {1};
  meth_meth_collectionsPrelude_ofCapacity2295->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_ofCapacity2295);
  meth_meth_collectionsPrelude_ofCapacity2295->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_ofCapacity2295->definitionModule = modulename;
  meth_meth_collectionsPrelude_ofCapacity2295->definitionLine = 1178;
  block_savedest(obj2258);
  Object closure3077 = createclosure(8, "ofCapacity()object");
  setclosureframe(closure3077, stackframe);
  addtoclosure(closure3077, var_NoSuchObject);
  addtoclosure(closure3077, var_removed);
  addtoclosure(closure3077, var_unused);
  addtoclosure(closure3077, var_ConcurrentModification);
  addtoclosure(closure3077, var_IteratorExhausted);
  addtoclosure(closure3077, var__prelude);
  addtoclosure(closure3077, var_Iterable);
  addtoclosure(closure3077, var_collection);
  Method *meth_meth_collectionsPrelude_ofCapacity2295_object = addmethod2pos(obj2258, "ofCapacity()object", &meth_collectionsPrelude_ofCapacity2295_object, 4);
  meth_meth_collectionsPrelude_ofCapacity2295_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_ofCapacity2295_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_ofCapacity2295_object->definitionLine = 1178;
  sourceObject = obj2258;
  sourceObject = obj2258;
  sourceObject = obj2258;
  sourceObject = obj2258;
  objclass2258 = obj2258->class;
  objclass2258->definitionModule = modulename;
  objclass2258->definitionLine = 1163;
  (*(struct UserObject *)self).data[0] = lowerouter2258;
  self = oldself2258;
  selfslot = oldselfslot2258;
  stackframe = oldstackframe2258;
  gc_frame_end(frame);
  return obj2258;
}
Object meth_collectionsPrelude_set2257_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "set()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object *var_ConcurrentModification = getfromclosure(closure, 3);
  Object *var_IteratorExhausted = getfromclosure(closure, 4);
  Object *var__prelude = getfromclosure(closure, 5);
  Object *var_Iterable = getfromclosure(closure, 6);
  Object *var_collection = getfromclosure(closure, 7);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for set (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for set");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject2258 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj2258 = alloc_userobj2(5,6, objclass2258);
  gc_frame_newslot(obj2258);
if (objclass2258 == NULL) {
  glfree(obj2258->class->name);
  obj2258->class->name = "collectionsPrelude.set";
}
// OBJECT OUTER DEC outer
  adddatum2(obj2258, self, 0);
  addmethodreal(obj2258,"outer", &reader_collectionsPrelude_outer_2259);
  Object oldself2258 = self;
  struct StackFrameObject *oldstackframe2258 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe2258);
  gc_frame_newslot((Object)stackframe);
  self = obj2258;
  Object *oldselfslot2258 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter2258 = (*(struct UserObject *)self).data[0], lowerouter2258 = thisouter2258;
  if (inheritingObject2258) {
    struct UserObject *inho2258 = (struct UserObject *)inheritingObject2258;
    while (inho2258->super != GraceDefaultObject) inho2258 = (struct UserObject *)inho2258->super;
    inho2258->super = obj2258;
    self = inheritingObject2258;
    *selfslot = self;
    lowerouter2258 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter2258;
  }
// method "asString"
  struct UserObject *uo2260 = (struct UserObject*)obj2258;
  uo2260->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString2260 = addmethod2pos(obj2258, "asString", &meth_collectionsPrelude_asString2260, 1);
  int argcv_meth_collectionsPrelude_asString2260[] = {0};
  meth_meth_collectionsPrelude_asString2260->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString2260);
  meth_meth_collectionsPrelude_asString2260->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString2260->definitionLine = 1165;
// method "withAll"
  struct UserObject *uo2262 = (struct UserObject*)obj2258;
  uo2262->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_withAll2262 = addmethod2pos(obj2258, "withAll", &meth_collectionsPrelude_withAll2262, 2);
  int argcv_meth_collectionsPrelude_withAll2262[] = {1};
  meth_meth_collectionsPrelude_withAll2262->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll2262);
  meth_meth_collectionsPrelude_withAll2262->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll2262->definitionLine = 1167;
// method "empty"
  struct UserObject *uo2291 = (struct UserObject*)obj2258;
  uo2291->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_empty2291 = addmethod2pos(obj2258, "empty", &meth_collectionsPrelude_empty2291, 3);
  int argcv_meth_collectionsPrelude_empty2291[] = {0};
  meth_meth_collectionsPrelude_empty2291->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_empty2291);
  meth_meth_collectionsPrelude_empty2291->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty2291->definitionLine = 1174;
// method "ofCapacity"
  block_savedest(obj2258);
  Object closure2295 = createclosure(8, "ofCapacity");
  setclosureframe(closure2295, stackframe);
  addtoclosure(closure2295, var_NoSuchObject);
  addtoclosure(closure2295, var_removed);
  addtoclosure(closure2295, var_unused);
  addtoclosure(closure2295, var_ConcurrentModification);
  addtoclosure(closure2295, var_IteratorExhausted);
  addtoclosure(closure2295, var__prelude);
  addtoclosure(closure2295, var_Iterable);
  addtoclosure(closure2295, var_collection);
  struct UserObject *uo2295 = (struct UserObject*)obj2258;
  uo2295->data[4] = (Object)closure2295;
  Method *meth_meth_collectionsPrelude_ofCapacity2295 = addmethod2pos(obj2258, "ofCapacity", &meth_collectionsPrelude_ofCapacity2295, 4);
  int argcv_meth_collectionsPrelude_ofCapacity2295[] = {1};
  meth_meth_collectionsPrelude_ofCapacity2295->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_ofCapacity2295);
  meth_meth_collectionsPrelude_ofCapacity2295->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_ofCapacity2295->definitionModule = modulename;
  meth_meth_collectionsPrelude_ofCapacity2295->definitionLine = 1178;
  block_savedest(obj2258);
  Object closure3077 = createclosure(8, "ofCapacity()object");
  setclosureframe(closure3077, stackframe);
  addtoclosure(closure3077, var_NoSuchObject);
  addtoclosure(closure3077, var_removed);
  addtoclosure(closure3077, var_unused);
  addtoclosure(closure3077, var_ConcurrentModification);
  addtoclosure(closure3077, var_IteratorExhausted);
  addtoclosure(closure3077, var__prelude);
  addtoclosure(closure3077, var_Iterable);
  addtoclosure(closure3077, var_collection);
  Method *meth_meth_collectionsPrelude_ofCapacity2295_object = addmethod2pos(obj2258, "ofCapacity()object", &meth_collectionsPrelude_ofCapacity2295_object, 4);
  meth_meth_collectionsPrelude_ofCapacity2295_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_ofCapacity2295_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_ofCapacity2295_object->definitionLine = 1178;
  sourceObject = obj2258;
  sourceObject = obj2258;
  sourceObject = obj2258;
  sourceObject = obj2258;
  objclass2258 = obj2258->class;
  objclass2258->definitionModule = modulename;
  objclass2258->definitionLine = 1163;
  (*(struct UserObject *)self).data[0] = lowerouter2258;
  self = oldself2258;
  selfslot = oldselfslot2258;
  stackframe = oldstackframe2258;
  gc_frame_end(frame);
  return obj2258;
}
Object meth_collectionsPrelude_asString3082(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1477
  setline(1477);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 2)
  if (strlit3083 == NULL) {
    strlit3083 = alloc_String("a dictionary factory");
    gc_root(strlit3083);
  }
// compiled string node returning strlit3083 (depth = 2)
  gc_frame_end(frame);
  return strlit3083;
}
Object meth_collectionsPrelude__apply3089(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_b = &(stackframe->slots[0]);
  *var_b = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe3090 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  gc_frame_newslot(*var_b);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_b;
  partcv[0] = 1;
  Object call3091 = callmethod(*var_result, "add",
    1, partcv, params);
  gc_frame_end(callframe3090);
// compiled call node returning call3091 (depth = 4)
  gc_frame_end(frame);
  return call3091;
}
Object meth_collectionsPrelude_withAll3084(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "withAll");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method withAll");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for withAll (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_initialBindings = &(stackframe->slots[0]);
  *var_initialBindings = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for withAll");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "result");
// Begin line 1480
  setline(1480);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3085 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3086 = callmethodflags(self, "empty", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3085);
// compiled call node returning call3086 (depth = 4)
// compiled member node returning call3086 (depth = 3)
  *var_result = call3086;
  if (call3086 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1481
  setline(1481);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3087 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_initialBindings (depth = 3)
  gc_frame_newslot(*var_initialBindings);
// starting to compile block node (depth = 3)
  Object block3088 = alloc_Block(NULL, NULL, "collectionsPrelude", 1481);
  gc_frame_newslot(block3088);
// method "_apply"
  block_savedest(block3088);
  Object closure3089 = createclosure(2, "_apply");
  setclosureframe(closure3089, stackframe);
  addtoclosure(closure3089, var_result);
  addtoclosure(closure3089, selfslot);
  struct UserObject *uo3089 = (struct UserObject*)block3088;
  uo3089->data[0] = (Object)closure3089;
  Method *meth_meth_collectionsPrelude__apply3089 = addmethod2pos(block3088, "_apply", &meth_collectionsPrelude__apply3089, 0);
  int argcv_meth_collectionsPrelude__apply3089[] = {1};
  meth_meth_collectionsPrelude__apply3089->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3089);
  meth_meth_collectionsPrelude__apply3089->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3089->definitionLine = 1480;
// compiled block node returning block3088 (depth = 3)
  gc_frame_newslot(block3088);
// call case 5: prelude request
  params[0] = *var_initialBindings;
  params[1] = block3088;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3093 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3087);
// compiled call node returning call3093 (depth = 2)
// Begin line 1482
  setline(1482);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude_size3100(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for size (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for size");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1493
  setline(1493);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3101 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3102 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3101);
// compiled call node returning call3102 (depth = 3)
// compiled member node returning call3102 (depth = 2)
  gc_frame_end(frame);
  return call3102;
}
Object meth_collectionsPrelude_at_40__41_put3103(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "at()put");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at()put");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at()put");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_binding = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for at()put (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_key_39_ = &(stackframe->slots[0]);
  *var_key_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for at");
  Object *var_value_39_ = &(stackframe->slots[1]);
  *var_value_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for put");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "t");
// Begin line 1495
  setline(1495);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3104 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3106 = alloc_Float64(1);
// compiled num node returning num3106 (depth = 4)
  int op_slot_right_3105 = gc_frame_newslot(num3106);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3108 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3109 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3108);
// compiled call node returning call3109 (depth = 5)
// compiled member node returning call3109 (depth = 4)
  int op_slot_left_3105 = gc_frame_newslot(call3109);
  params[0] = num3106;
  partcv[0] = 1;
  Object sum3110 = callmethod(call3109, "+", 1, partcv, params);
// compiled op node returning sum3110 (depth = 3)
  gc_frame_newslot(sum3110);
// call case 4: self request
  params[0] = sum3110;
  partcv[0] = 1;
  Object call3111 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3104);
// compiled call node returning call3111 (depth = 2)
// Begin line 1496
  setline(1496);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3112 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_key_39_ (depth = 4)
  gc_frame_newslot(*var_key_39_);
// call case 4: self request
  params[0] = *var_key_39_;
  partcv[0] = 1;
  Object call3113 = callmethodflags(self, "findPositionForAdd", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3112);
// compiled call node returning call3113 (depth = 3)
  *var_t = call3113;
  if (call3113 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1497
  setline(1497);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3117 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3118 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3119 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3118);
// compiled call node returning call3119 (depth = 7)
// compiled member node returning call3119 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3120 = callmethod(call3119, "at",
    1, partcv, params);
  gc_frame_end(callframe3117);
// compiled call node returning call3120 (depth = 5)
  int op_slot_right_3116 = gc_frame_newslot(call3120);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_removed (depth = 5)
  int op_slot_left_3116 = gc_frame_newslot(*var_removed);
  params[0] = call3120;
  partcv[0] = 1;
  Object opresult3122 = callmethod(*var_removed, "==", 1, partcv, params);
// compiled op node returning opresult3122 (depth = 4)
  int op_slot_right_3115 = gc_frame_newslot(opresult3122);
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3125 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3126 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3127 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3126);
// compiled call node returning call3127 (depth = 7)
// compiled member node returning call3127 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3128 = callmethod(call3127, "at",
    1, partcv, params);
  gc_frame_end(callframe3125);
// compiled call node returning call3128 (depth = 5)
  int op_slot_right_3124 = gc_frame_newslot(call3128);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  int op_slot_left_3124 = gc_frame_newslot(*var_unused);
  params[0] = call3128;
  partcv[0] = 1;
  Object opresult3130 = callmethod(*var_unused, "==", 1, partcv, params);
// compiled op node returning opresult3130 (depth = 4)
  int op_slot_left_3115 = gc_frame_newslot(opresult3130);
  params[0] = opresult3122;
  partcv[0] = 1;
  Object opresult3131 = callmethod(opresult3130, "||", 1, partcv, params);
// compiled op node returning opresult3131 (depth = 3)
  Object if3114 = done;
  if (istrue(opresult3131)) {
// Begin line 1498
  setline(1498);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3132 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3134 = alloc_Float64(1);
// compiled num node returning num3134 (depth = 5)
  int op_slot_right_3133 = gc_frame_newslot(num3134);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3136 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3137 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3136);
// compiled call node returning call3137 (depth = 6)
// compiled member node returning call3137 (depth = 5)
  int op_slot_left_3133 = gc_frame_newslot(call3137);
  params[0] = num3134;
  partcv[0] = 1;
  Object sum3138 = callmethod(call3137, "+", 1, partcv, params);
// compiled op node returning sum3138 (depth = 4)
  gc_frame_newslot(sum3138);
// call case 4: self request
  params[0] = sum3138;
  partcv[0] = 1;
  Object call3139 = callmethodflags(self, "numBindings:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3132);
// compiled call node returning call3139 (depth = 3)
    gc_frame_newslot(call3139);
    if3114 = call3139;
  } else {
  }
// compiled if node returning if3114 (depth = 2)
// Begin line 1500
  setline(1500);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3140 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  gc_frame_newslot(*var_t);
// starting to compile call node (depth = 3)
  int callframe3141 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_key_39_ (depth = 4)
  gc_frame_newslot(*var_key_39_);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_value_39_ (depth = 4)
  gc_frame_newslot(*var_value_39_);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_binding (depth = 4)
  params[0] = *var_key_39_;
  params[1] = *var_value_39_;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3142 = callmethod(*var_binding, "key()value",
    2, partcv, params);
  gc_frame_end(callframe3141);
// compiled call node returning call3142 (depth = 3)
  gc_frame_newslot(call3142);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3143 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3144 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3143);
// compiled call node returning call3144 (depth = 4)
// compiled member node returning call3144 (depth = 3)
  params[0] = *var_t;
  params[1] = call3142;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3145 = callmethod(call3144, "at()put",
    2, partcv, params);
  gc_frame_end(callframe3140);
// compiled call node returning call3145 (depth = 2)
// Begin line 1501
  setline(1501);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3148 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3149 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3150 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3149);
// compiled call node returning call3150 (depth = 7)
// compiled member node returning call3150 (depth = 6)
  partcv[0] = 0;
  Object call3151 = callmethod(call3150, "size",
    1, partcv, params);
  gc_frame_end(callframe3148);
// compiled call node returning call3151 (depth = 5)
// compiled member node returning call3151 (depth = 4)
  int op_slot_right_3147 = gc_frame_newslot(call3151);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3154 = alloc_Float64(2);
// compiled num node returning num3154 (depth = 5)
  int op_slot_right_3153 = gc_frame_newslot(num3154);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3156 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3157 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3156);
// compiled call node returning call3157 (depth = 6)
// compiled member node returning call3157 (depth = 5)
  int op_slot_left_3153 = gc_frame_newslot(call3157);
  params[0] = num3154;
  partcv[0] = 1;
  Object prod3158 = callmethod(call3157, "*", 1, partcv, params);
// compiled op node returning prod3158 (depth = 4)
  int op_slot_left_3147 = gc_frame_newslot(prod3158);
  params[0] = call3151;
  partcv[0] = 1;
  Object opresult3159 = callmethod(prod3158, ">", 1, partcv, params);
// compiled op node returning opresult3159 (depth = 3)
  Object if3146 = done;
  if (istrue(opresult3159)) {
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3160 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3161 = callmethodflags(self, "expand", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3160);
// compiled call node returning call3161 (depth = 4)
// compiled member node returning call3161 (depth = 3)
    gc_frame_newslot(call3161);
    if3146 = call3161;
  } else {
  }
// compiled if node returning if3146 (depth = 2)
// Begin line 1502
  setline(1502);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_add3162(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "add");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method add");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for add (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_aBinding = &(stackframe->slots[0]);
  *var_aBinding = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for add");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1505
  setline(1505);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3163 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3165 = alloc_Float64(1);
// compiled num node returning num3165 (depth = 4)
  int op_slot_right_3164 = gc_frame_newslot(num3165);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3167 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3168 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3167);
// compiled call node returning call3168 (depth = 5)
// compiled member node returning call3168 (depth = 4)
  int op_slot_left_3164 = gc_frame_newslot(call3168);
  params[0] = num3165;
  partcv[0] = 1;
  Object sum3169 = callmethod(call3168, "+", 1, partcv, params);
// compiled op node returning sum3169 (depth = 3)
  gc_frame_newslot(sum3169);
// call case 4: self request
  params[0] = sum3169;
  partcv[0] = 1;
  Object call3170 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3163);
// compiled call node returning call3170 (depth = 2)
// Begin line 1506
  setline(1506);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3171 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3172 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_aBinding (depth = 6)
  partcv[0] = 0;
  Object call3173 = callmethod(*var_aBinding, "key",
    1, partcv, params);
  gc_frame_end(callframe3172);
// compiled call node returning call3173 (depth = 5)
// compiled member node returning call3173 (depth = 4)
  gc_frame_newslot(call3173);
// call case 4: self request
  params[0] = call3173;
  partcv[0] = 1;
  Object call3174 = callmethodflags(self, "findPositionForAdd", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3171);
// compiled call node returning call3174 (depth = 3)
  *var_t = call3174;
  if (call3174 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1507
  setline(1507);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3178 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3179 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3180 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3179);
// compiled call node returning call3180 (depth = 7)
// compiled member node returning call3180 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3181 = callmethod(call3180, "at",
    1, partcv, params);
  gc_frame_end(callframe3178);
// compiled call node returning call3181 (depth = 5)
  int op_slot_right_3177 = gc_frame_newslot(call3181);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_removed (depth = 5)
  int op_slot_left_3177 = gc_frame_newslot(*var_removed);
  params[0] = call3181;
  partcv[0] = 1;
  Object opresult3183 = callmethod(*var_removed, "==", 1, partcv, params);
// compiled op node returning opresult3183 (depth = 4)
  int op_slot_right_3176 = gc_frame_newslot(opresult3183);
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3186 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3187 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3188 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3187);
// compiled call node returning call3188 (depth = 7)
// compiled member node returning call3188 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3189 = callmethod(call3188, "at",
    1, partcv, params);
  gc_frame_end(callframe3186);
// compiled call node returning call3189 (depth = 5)
  int op_slot_right_3185 = gc_frame_newslot(call3189);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  int op_slot_left_3185 = gc_frame_newslot(*var_unused);
  params[0] = call3189;
  partcv[0] = 1;
  Object opresult3191 = callmethod(*var_unused, "==", 1, partcv, params);
// compiled op node returning opresult3191 (depth = 4)
  int op_slot_left_3176 = gc_frame_newslot(opresult3191);
  params[0] = opresult3183;
  partcv[0] = 1;
  Object opresult3192 = callmethod(opresult3191, "||", 1, partcv, params);
// compiled op node returning opresult3192 (depth = 3)
  Object if3175 = done;
  if (istrue(opresult3192)) {
// Begin line 1508
  setline(1508);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3193 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3195 = alloc_Float64(1);
// compiled num node returning num3195 (depth = 5)
  int op_slot_right_3194 = gc_frame_newslot(num3195);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3197 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3198 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3197);
// compiled call node returning call3198 (depth = 6)
// compiled member node returning call3198 (depth = 5)
  int op_slot_left_3194 = gc_frame_newslot(call3198);
  params[0] = num3195;
  partcv[0] = 1;
  Object sum3199 = callmethod(call3198, "+", 1, partcv, params);
// compiled op node returning sum3199 (depth = 4)
  gc_frame_newslot(sum3199);
// call case 4: self request
  params[0] = sum3199;
  partcv[0] = 1;
  Object call3200 = callmethodflags(self, "numBindings:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3193);
// compiled call node returning call3200 (depth = 3)
    gc_frame_newslot(call3200);
    if3175 = call3200;
  } else {
  }
// compiled if node returning if3175 (depth = 2)
// Begin line 1510
  setline(1510);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3201 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_aBinding (depth = 3)
  gc_frame_newslot(*var_aBinding);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3202 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3203 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3202);
// compiled call node returning call3203 (depth = 4)
// compiled member node returning call3203 (depth = 3)
  params[0] = *var_t;
  params[1] = *var_aBinding;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3204 = callmethod(call3203, "at()put",
    2, partcv, params);
  gc_frame_end(callframe3201);
// compiled call node returning call3204 (depth = 2)
// Begin line 1511
  setline(1511);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3207 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3208 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3209 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3208);
// compiled call node returning call3209 (depth = 7)
// compiled member node returning call3209 (depth = 6)
  partcv[0] = 0;
  Object call3210 = callmethod(call3209, "size",
    1, partcv, params);
  gc_frame_end(callframe3207);
// compiled call node returning call3210 (depth = 5)
// compiled member node returning call3210 (depth = 4)
  int op_slot_right_3206 = gc_frame_newslot(call3210);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3213 = alloc_Float64(2);
// compiled num node returning num3213 (depth = 5)
  int op_slot_right_3212 = gc_frame_newslot(num3213);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3215 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3216 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3215);
// compiled call node returning call3216 (depth = 6)
// compiled member node returning call3216 (depth = 5)
  int op_slot_left_3212 = gc_frame_newslot(call3216);
  params[0] = num3213;
  partcv[0] = 1;
  Object prod3217 = callmethod(call3216, "*", 1, partcv, params);
// compiled op node returning prod3217 (depth = 4)
  int op_slot_left_3206 = gc_frame_newslot(prod3217);
  params[0] = call3210;
  partcv[0] = 1;
  Object opresult3218 = callmethod(prod3217, ">", 1, partcv, params);
// compiled op node returning opresult3218 (depth = 3)
  Object if3205 = done;
  if (istrue(opresult3218)) {
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3219 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3220 = callmethodflags(self, "expand", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3219);
// compiled call node returning call3220 (depth = 4)
// compiled member node returning call3220 (depth = 3)
    gc_frame_newslot(call3220);
    if3205 = call3220;
  } else {
  }
// compiled if node returning if3205 (depth = 2)
// Begin line 1512
  setline(1512);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_at3221(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "at");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at");
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for at");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_b = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "b");
// Begin line 1515
  setline(1515);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3222 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3223 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call3224 = callmethodflags(self, "findPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3223);
// compiled call node returning call3224 (depth = 4)
  gc_frame_newslot(call3224);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3225 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3226 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3225);
// compiled call node returning call3226 (depth = 5)
// compiled member node returning call3226 (depth = 4)
  params[0] = call3224;
  partcv[0] = 1;
  Object call3227 = callmethod(call3226, "at",
    1, partcv, params);
  gc_frame_end(callframe3222);
// compiled call node returning call3227 (depth = 3)
  *var_b = call3227;
  if (call3227 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1516
  setline(1516);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  int op_slot_right_3229 = gc_frame_newslot(*var_k);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3231 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_b (depth = 6)
  partcv[0] = 0;
  Object call3232 = callmethod(*var_b, "key",
    1, partcv, params);
  gc_frame_end(callframe3231);
// compiled call node returning call3232 (depth = 5)
// compiled member node returning call3232 (depth = 4)
  int op_slot_left_3229 = gc_frame_newslot(call3232);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3233 = callmethod(call3232, "==", 1, partcv, params);
// compiled op node returning opresult3233 (depth = 3)
  Object if3228 = done;
  if (istrue(opresult3233)) {
// Begin line 1517
  setline(1517);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3234 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_b (depth = 6)
  partcv[0] = 0;
  Object call3235 = callmethod(*var_b, "value",
    1, partcv, params);
  gc_frame_end(callframe3234);
// compiled call node returning call3235 (depth = 5)
// compiled member node returning call3235 (depth = 4)
  return call3235;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if3228 = undefined;
  } else {
  }
// compiled if node returning if3228 (depth = 2)
// Begin line 1519
  setline(1519);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3236 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit3238 == NULL) {
    strlit3238 = alloc_String("");
    gc_root(strlit3238);
  }
// compiled string node returning strlit3238 (depth = 4)
  int op_slot_right_3237 = gc_frame_newslot(strlit3238);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  int op_slot_right_3240 = gc_frame_newslot(*var_k);
// starting to compile string node (depth = 5)
  if (strlit3242 == NULL) {
    strlit3242 = alloc_String("dictionary does not contain entry with key ");
    gc_root(strlit3242);
  }
// compiled string node returning strlit3242 (depth = 5)
  int op_slot_left_3240 = gc_frame_newslot(strlit3242);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3243 = callmethod(strlit3242, "++", 1, partcv, params);
// compiled op node returning opresult3243 (depth = 4)
  int op_slot_left_3237 = gc_frame_newslot(opresult3243);
  params[0] = strlit3238;
  partcv[0] = 1;
  Object opresult3244 = callmethod(opresult3243, "++", 1, partcv, params);
// compiled op node returning opresult3244 (depth = 3)
  gc_frame_newslot(opresult3244);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_NoSuchObject (depth = 3)
  params[0] = opresult3244;
  partcv[0] = 1;
  Object call3245 = callmethod(*var_NoSuchObject, "raise",
    1, partcv, params);
  gc_frame_end(callframe3236);
// compiled call node returning call3245 (depth = 2)
  gc_frame_end(frame);
  return call3245;
}
Object meth_collectionsPrelude_at_40__41_ifAbsent3246(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at()ifAbsent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at()ifAbsent");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at()ifAbsent");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for at()ifAbsent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for at");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ifAbsent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_b = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "b");
// Begin line 1522
  setline(1522);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3247 = gc_frame_new();
// starting to compile call node (depth = 4)
  int callframe3248 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call3249 = callmethodflags(self, "findPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3248);
// compiled call node returning call3249 (depth = 4)
  gc_frame_newslot(call3249);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3250 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3251 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3250);
// compiled call node returning call3251 (depth = 5)
// compiled member node returning call3251 (depth = 4)
  params[0] = call3249;
  partcv[0] = 1;
  Object call3252 = callmethod(call3251, "at",
    1, partcv, params);
  gc_frame_end(callframe3247);
// compiled call node returning call3252 (depth = 3)
  *var_b = call3252;
  if (call3252 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1523
  setline(1523);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  int op_slot_right_3254 = gc_frame_newslot(*var_k);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3256 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_b (depth = 6)
  partcv[0] = 0;
  Object call3257 = callmethod(*var_b, "key",
    1, partcv, params);
  gc_frame_end(callframe3256);
// compiled call node returning call3257 (depth = 5)
// compiled member node returning call3257 (depth = 4)
  int op_slot_left_3254 = gc_frame_newslot(call3257);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3258 = callmethod(call3257, "==", 1, partcv, params);
// compiled op node returning opresult3258 (depth = 3)
  Object if3253 = done;
  if (istrue(opresult3258)) {
// Begin line 1524
  setline(1524);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3259 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_b (depth = 6)
  partcv[0] = 0;
  Object call3260 = callmethod(*var_b, "value",
    1, partcv, params);
  gc_frame_end(callframe3259);
// compiled call node returning call3260 (depth = 5)
// compiled member node returning call3260 (depth = 4)
  return call3260;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if3253 = undefined;
  } else {
  }
// compiled if node returning if3253 (depth = 2)
// Begin line 1526
  setline(1526);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3261 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_action (depth = 4)
  partcv[0] = 0;
  Object call3262 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe3261);
// compiled call node returning call3262 (depth = 3)
// compiled member node returning call3262 (depth = 2)
  gc_frame_end(frame);
  return call3262;
}
Object meth_collectionsPrelude_containsKey3263(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "containsKey");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method containsKey");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for containsKey (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for containsKey");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1529
  setline(1529);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3264 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call3265 = callmethodflags(self, "findPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3264);
// compiled call node returning call3265 (depth = 3)
  *var_t = call3265;
  if (call3265 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1530
  setline(1530);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  int op_slot_right_3267 = gc_frame_newslot(*var_k);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3269 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe3270 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3271 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3272 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3271);
// compiled call node returning call3272 (depth = 8)
// compiled member node returning call3272 (depth = 7)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3273 = callmethod(call3272, "at",
    1, partcv, params);
  gc_frame_end(callframe3270);
// compiled call node returning call3273 (depth = 6)
  partcv[0] = 0;
  Object call3274 = callmethod(call3273, "key",
    1, partcv, params);
  gc_frame_end(callframe3269);
// compiled call node returning call3274 (depth = 5)
// compiled member node returning call3274 (depth = 4)
  int op_slot_left_3267 = gc_frame_newslot(call3274);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3275 = callmethod(call3274, "==", 1, partcv, params);
// compiled op node returning opresult3275 (depth = 3)
  Object if3266 = done;
  if (istrue(opresult3275)) {
// Begin line 1531
  setline(1531);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool3276 = alloc_Boolean(1);
// compiled identifier node returning bool3276 (depth = 4)
  return bool3276;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if3266 = undefined;
  } else {
  }
// compiled if node returning if3266 (depth = 2)
// Begin line 1533
  setline(1533);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool3277 = alloc_Boolean(0);
// compiled identifier node returning bool3277 (depth = 2)
  gc_frame_end(frame);
  return bool3277;
}
Object meth_collectionsPrelude__apply3289(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1538
  setline(1538);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3290 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call3291 = callmethodflags(self, "findPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3290);
// compiled call node returning call3291 (depth = 5)
  *var_t = call3291;
  if (call3291 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 1539
  setline(1539);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  int op_slot_right_3293 = gc_frame_newslot(*var_k);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3295 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe3296 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3297 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3298 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3297);
// compiled call node returning call3298 (depth = 10)
// compiled member node returning call3298 (depth = 9)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3299 = callmethod(call3298, "at",
    1, partcv, params);
  gc_frame_end(callframe3296);
// compiled call node returning call3299 (depth = 8)
  partcv[0] = 0;
  Object call3300 = callmethod(call3299, "key",
    1, partcv, params);
  gc_frame_end(callframe3295);
// compiled call node returning call3300 (depth = 7)
// compiled member node returning call3300 (depth = 6)
  int op_slot_left_3293 = gc_frame_newslot(call3300);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3301 = callmethod(call3300, "==", 1, partcv, params);
// compiled op node returning opresult3301 (depth = 5)
  Object if3292 = done;
  if (istrue(opresult3301)) {
// Begin line 1540
  setline(1540);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3302 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  gc_frame_newslot(*var_removed);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3303 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3304 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3303);
// compiled call node returning call3304 (depth = 7)
// compiled member node returning call3304 (depth = 6)
  params[0] = *var_t;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3305 = callmethod(call3304, "at()put",
    2, partcv, params);
  gc_frame_end(callframe3302);
// compiled call node returning call3305 (depth = 5)
// Begin line 1541
  setline(1541);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3306 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3308 = alloc_Float64(1);
// compiled num node returning num3308 (depth = 7)
  int op_slot_right_3307 = gc_frame_newslot(num3308);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3310 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3311 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3310);
// compiled call node returning call3311 (depth = 8)
// compiled member node returning call3311 (depth = 7)
  int op_slot_left_3307 = gc_frame_newslot(call3311);
  params[0] = num3308;
  partcv[0] = 1;
  Object diff3312 = callmethod(call3311, "-", 1, partcv, params);
// compiled op node returning diff3312 (depth = 6)
  gc_frame_newslot(diff3312);
// call case 4: self request
  params[0] = diff3312;
  partcv[0] = 1;
  Object call3313 = callmethodflags(self, "numBindings:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3306);
// compiled call node returning call3313 (depth = 5)
    gc_frame_newslot(call3313);
    if3292 = call3313;
  } else {
// Begin line 1543
  setline(1543);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3314 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3316 == NULL) {
    strlit3316 = alloc_String("");
    gc_root(strlit3316);
  }
// compiled string node returning strlit3316 (depth = 7)
  int op_slot_right_3315 = gc_frame_newslot(strlit3316);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_k (depth = 8)
  int op_slot_right_3318 = gc_frame_newslot(*var_k);
// starting to compile string node (depth = 8)
  if (strlit3320 == NULL) {
    strlit3320 = alloc_String("dictionary does not contain entry with key ");
    gc_root(strlit3320);
  }
// compiled string node returning strlit3320 (depth = 8)
  int op_slot_left_3318 = gc_frame_newslot(strlit3320);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3321 = callmethod(strlit3320, "++", 1, partcv, params);
// compiled op node returning opresult3321 (depth = 7)
  int op_slot_left_3315 = gc_frame_newslot(opresult3321);
  params[0] = strlit3316;
  partcv[0] = 1;
  Object opresult3322 = callmethod(opresult3321, "++", 1, partcv, params);
// compiled op node returning opresult3322 (depth = 6)
  gc_frame_newslot(opresult3322);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_NoSuchObject (depth = 6)
  params[0] = opresult3322;
  partcv[0] = 1;
  Object call3323 = callmethod(*var_NoSuchObject, "raise",
    1, partcv, params);
  gc_frame_end(callframe3314);
// compiled call node returning call3323 (depth = 5)
    gc_frame_newslot(call3323);
    if3292 = call3323;
  }
// compiled if node returning if3292 (depth = 4)
  gc_frame_end(frame);
  return if3292;
}
Object meth_collectionsPrelude_removeAllKeys3278(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAllKeys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAllKeys");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeAllKeys (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_keys = &(stackframe->slots[0]);
  *var_keys = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for removeAllKeys");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1536
  setline(1536);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3279 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3281 = alloc_Float64(1);
// compiled num node returning num3281 (depth = 4)
  int op_slot_right_3280 = gc_frame_newslot(num3281);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3283 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3284 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3283);
// compiled call node returning call3284 (depth = 5)
// compiled member node returning call3284 (depth = 4)
  int op_slot_left_3280 = gc_frame_newslot(call3284);
  params[0] = num3281;
  partcv[0] = 1;
  Object sum3285 = callmethod(call3284, "+", 1, partcv, params);
// compiled op node returning sum3285 (depth = 3)
  gc_frame_newslot(sum3285);
// call case 4: self request
  params[0] = sum3285;
  partcv[0] = 1;
  Object call3286 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3279);
// compiled call node returning call3286 (depth = 2)
// Begin line 1537
  setline(1537);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3287 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_keys (depth = 3)
  gc_frame_newslot(*var_keys);
// starting to compile block node (depth = 3)
  Object block3288 = alloc_Block(NULL, NULL, "collectionsPrelude", 1537);
  gc_frame_newslot(block3288);
// method "_apply"
  block_savedest(block3288);
  Object closure3289 = createclosure(3, "_apply");
  setclosureframe(closure3289, stackframe);
  addtoclosure(closure3289, var_removed);
  addtoclosure(closure3289, var_NoSuchObject);
  addtoclosure(closure3289, selfslot);
  struct UserObject *uo3289 = (struct UserObject*)block3288;
  uo3289->data[0] = (Object)closure3289;
  Method *meth_meth_collectionsPrelude__apply3289 = addmethod2pos(block3288, "_apply", &meth_collectionsPrelude__apply3289, 0);
  int argcv_meth_collectionsPrelude__apply3289[] = {1};
  meth_meth_collectionsPrelude__apply3289->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3289);
  meth_meth_collectionsPrelude__apply3289->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3289->definitionLine = 1536;
// compiled block node returning block3288 (depth = 3)
  gc_frame_newslot(block3288);
// call case 5: prelude request
  params[0] = *var_keys;
  params[1] = block3288;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3325 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3287);
// compiled call node returning call3325 (depth = 2)
// Begin line 1546
  setline(1546);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_removeKey3326(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeKey");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeKey");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeKey (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for removeKey");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_t = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "t");
// Begin line 1549
  setline(1549);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3327 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3329 = alloc_Float64(1);
// compiled num node returning num3329 (depth = 4)
  int op_slot_right_3328 = gc_frame_newslot(num3329);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3331 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3332 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3331);
// compiled call node returning call3332 (depth = 5)
// compiled member node returning call3332 (depth = 4)
  int op_slot_left_3328 = gc_frame_newslot(call3332);
  params[0] = num3329;
  partcv[0] = 1;
  Object sum3333 = callmethod(call3332, "+", 1, partcv, params);
// compiled op node returning sum3333 (depth = 3)
  gc_frame_newslot(sum3333);
// call case 4: self request
  params[0] = sum3333;
  partcv[0] = 1;
  Object call3334 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3327);
// compiled call node returning call3334 (depth = 2)
// Begin line 1550
  setline(1550);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3335 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  gc_frame_newslot(*var_k);
// call case 4: self request
  params[0] = *var_k;
  partcv[0] = 1;
  Object call3336 = callmethodflags(self, "findPosition", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3335);
// compiled call node returning call3336 (depth = 3)
  *var_t = call3336;
  if (call3336 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1551
  setline(1551);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  int op_slot_right_3338 = gc_frame_newslot(*var_k);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3340 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe3341 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3342 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3343 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3342);
// compiled call node returning call3343 (depth = 8)
// compiled member node returning call3343 (depth = 7)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3344 = callmethod(call3343, "at",
    1, partcv, params);
  gc_frame_end(callframe3341);
// compiled call node returning call3344 (depth = 6)
  partcv[0] = 0;
  Object call3345 = callmethod(call3344, "key",
    1, partcv, params);
  gc_frame_end(callframe3340);
// compiled call node returning call3345 (depth = 5)
// compiled member node returning call3345 (depth = 4)
  int op_slot_left_3338 = gc_frame_newslot(call3345);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3346 = callmethod(call3345, "==", 1, partcv, params);
// compiled op node returning opresult3346 (depth = 3)
  Object if3337 = done;
  if (istrue(opresult3346)) {
// Begin line 1552
  setline(1552);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3347 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_t (depth = 4)
  gc_frame_newslot(*var_t);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_removed (depth = 4)
  gc_frame_newslot(*var_removed);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3348 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3349 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3348);
// compiled call node returning call3349 (depth = 5)
// compiled member node returning call3349 (depth = 4)
  params[0] = *var_t;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3350 = callmethod(call3349, "at()put",
    2, partcv, params);
  gc_frame_end(callframe3347);
// compiled call node returning call3350 (depth = 3)
// Begin line 1553
  setline(1553);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3351 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3353 = alloc_Float64(1);
// compiled num node returning num3353 (depth = 5)
  int op_slot_right_3352 = gc_frame_newslot(num3353);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3355 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3356 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3355);
// compiled call node returning call3356 (depth = 6)
// compiled member node returning call3356 (depth = 5)
  int op_slot_left_3352 = gc_frame_newslot(call3356);
  params[0] = num3353;
  partcv[0] = 1;
  Object diff3357 = callmethod(call3356, "-", 1, partcv, params);
// compiled op node returning diff3357 (depth = 4)
  gc_frame_newslot(diff3357);
// call case 4: self request
  params[0] = diff3357;
  partcv[0] = 1;
  Object call3358 = callmethodflags(self, "numBindings:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3351);
// compiled call node returning call3358 (depth = 3)
    gc_frame_newslot(call3358);
    if3337 = call3358;
  } else {
// Begin line 1555
  setline(1555);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3359 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3361 == NULL) {
    strlit3361 = alloc_String("");
    gc_root(strlit3361);
  }
// compiled string node returning strlit3361 (depth = 5)
  int op_slot_right_3360 = gc_frame_newslot(strlit3361);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  int op_slot_right_3363 = gc_frame_newslot(*var_k);
// starting to compile string node (depth = 6)
  if (strlit3365 == NULL) {
    strlit3365 = alloc_String("dictionary does not contain entry with key ");
    gc_root(strlit3365);
  }
// compiled string node returning strlit3365 (depth = 6)
  int op_slot_left_3363 = gc_frame_newslot(strlit3365);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult3366 = callmethod(strlit3365, "++", 1, partcv, params);
// compiled op node returning opresult3366 (depth = 5)
  int op_slot_left_3360 = gc_frame_newslot(opresult3366);
  params[0] = strlit3361;
  partcv[0] = 1;
  Object opresult3367 = callmethod(opresult3366, "++", 1, partcv, params);
// compiled op node returning opresult3367 (depth = 4)
  gc_frame_newslot(opresult3367);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_NoSuchObject (depth = 4)
  params[0] = opresult3367;
  partcv[0] = 1;
  Object call3368 = callmethod(*var_NoSuchObject, "raise",
    1, partcv, params);
  gc_frame_end(callframe3359);
// compiled call node returning call3368 (depth = 3)
    gc_frame_newslot(call3368);
    if3337 = call3368;
  }
// compiled if node returning if3337 (depth = 2)
// Begin line 1557
  setline(1557);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply3392(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_removals = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1562
  setline(1562);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3393 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3394 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3395 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3394);
// compiled call node returning call3395 (depth = 7)
// compiled member node returning call3395 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3396 = callmethod(call3395, "at",
    1, partcv, params);
  gc_frame_end(callframe3393);
// compiled call node returning call3396 (depth = 5)
  *var_a = call3396;
  if (call3396 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1563
  setline(1563);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3398 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3399 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call3400 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe3399);
// compiled call node returning call3400 (depth = 7)
// compiled member node returning call3400 (depth = 6)
  gc_frame_newslot(call3400);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removals (depth = 6)
  params[0] = call3400;
  partcv[0] = 1;
  Object call3401 = callmethod(*var_removals, "contains",
    1, partcv, params);
  gc_frame_end(callframe3398);
// compiled call node returning call3401 (depth = 5)
  Object if3397 = done;
  if (istrue(call3401)) {
// Begin line 1564
  setline(1564);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3402 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  gc_frame_newslot(*var_removed);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3403 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3404 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3403);
// compiled call node returning call3404 (depth = 7)
// compiled member node returning call3404 (depth = 6)
  params[0] = *var_i;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3405 = callmethod(call3404, "at()put",
    2, partcv, params);
  gc_frame_end(callframe3402);
// compiled call node returning call3405 (depth = 5)
// Begin line 1565
  setline(1565);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3406 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3408 = alloc_Float64(1);
// compiled num node returning num3408 (depth = 7)
  int op_slot_right_3407 = gc_frame_newslot(num3408);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3410 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3411 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3410);
// compiled call node returning call3411 (depth = 8)
// compiled member node returning call3411 (depth = 7)
  int op_slot_left_3407 = gc_frame_newslot(call3411);
  params[0] = num3408;
  partcv[0] = 1;
  Object diff3412 = callmethod(call3411, "-", 1, partcv, params);
// compiled op node returning diff3412 (depth = 6)
  gc_frame_newslot(diff3412);
// call case 4: self request
  params[0] = diff3412;
  partcv[0] = 1;
  Object call3413 = callmethodflags(self, "numBindings:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3406);
// compiled call node returning call3413 (depth = 5)
    gc_frame_newslot(call3413);
    if3397 = call3413;
  } else {
  }
// compiled if node returning if3397 (depth = 4)
  gc_frame_end(frame);
  return if3397;
}
Object meth_collectionsPrelude_removeAllValues3369(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeAllValues");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeAllValues");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeAllValues (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_removals = &(stackframe->slots[0]);
  *var_removals = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for removeAllValues");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1560
  setline(1560);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3370 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3372 = alloc_Float64(1);
// compiled num node returning num3372 (depth = 4)
  int op_slot_right_3371 = gc_frame_newslot(num3372);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3374 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3375 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3374);
// compiled call node returning call3375 (depth = 5)
// compiled member node returning call3375 (depth = 4)
  int op_slot_left_3371 = gc_frame_newslot(call3375);
  params[0] = num3372;
  partcv[0] = 1;
  Object sum3376 = callmethod(call3375, "+", 1, partcv, params);
// compiled op node returning sum3376 (depth = 3)
  gc_frame_newslot(sum3376);
// call case 4: self request
  params[0] = sum3376;
  partcv[0] = 1;
  Object call3377 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3370);
// compiled call node returning call3377 (depth = 2)
// Begin line 1561
  setline(1561);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3378 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3381 = alloc_Float64(1);
// compiled num node returning num3381 (depth = 5)
  int op_slot_right_3380 = gc_frame_newslot(num3381);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3383 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3384 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3385 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3384);
// compiled call node returning call3385 (depth = 8)
// compiled member node returning call3385 (depth = 7)
  partcv[0] = 0;
  Object call3386 = callmethod(call3385, "size",
    1, partcv, params);
  gc_frame_end(callframe3383);
// compiled call node returning call3386 (depth = 6)
// compiled member node returning call3386 (depth = 5)
  int op_slot_left_3380 = gc_frame_newslot(call3386);
  params[0] = num3381;
  partcv[0] = 1;
  Object diff3387 = callmethod(call3386, "-", 1, partcv, params);
// compiled op node returning diff3387 (depth = 4)
  int op_slot_right_3379 = gc_frame_newslot(diff3387);
// starting to compile num node (depth = 4)
  Object num3389 = alloc_Float64(0);
// compiled num node returning num3389 (depth = 4)
  int op_slot_left_3379 = gc_frame_newslot(num3389);
  params[0] = diff3387;
  partcv[0] = 1;
  Object opresult3390 = callmethod(num3389, "..", 1, partcv, params);
// compiled op node returning opresult3390 (depth = 3)
  gc_frame_newslot(opresult3390);
// starting to compile block node (depth = 3)
  Object block3391 = alloc_Block(NULL, NULL, "collectionsPrelude", 1561);
  gc_frame_newslot(block3391);
// method "_apply"
  block_savedest(block3391);
  Object closure3392 = createclosure(3, "_apply");
  setclosureframe(closure3392, stackframe);
  addtoclosure(closure3392, var_removals);
  addtoclosure(closure3392, var_removed);
  addtoclosure(closure3392, selfslot);
  struct UserObject *uo3392 = (struct UserObject*)block3391;
  uo3392->data[0] = (Object)closure3392;
  Method *meth_meth_collectionsPrelude__apply3392 = addmethod2pos(block3391, "_apply", &meth_collectionsPrelude__apply3392, 0);
  int argcv_meth_collectionsPrelude__apply3392[] = {1};
  meth_meth_collectionsPrelude__apply3392->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3392);
  meth_meth_collectionsPrelude__apply3392->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3392->definitionLine = 1561;
// compiled block node returning block3391 (depth = 3)
  gc_frame_newslot(block3391);
// call case 5: prelude request
  params[0] = opresult3390;
  params[1] = block3391;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3415 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3378);
// compiled call node returning call3415 (depth = 2)
// Begin line 1568
  setline(1568);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply3441(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1575
  setline(1575);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3442 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3443 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3444 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3443);
// compiled call node returning call3444 (depth = 7)
// compiled member node returning call3444 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3445 = callmethod(call3444, "at",
    1, partcv, params);
  gc_frame_end(callframe3442);
// compiled call node returning call3445 (depth = 5)
  *var_a = call3445;
  if (call3445 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1576
  setline(1576);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3448 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call3449 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe3448);
// compiled call node returning call3449 (depth = 7)
// compiled member node returning call3449 (depth = 6)
  int op_slot_right_3447 = gc_frame_newslot(call3449);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  int op_slot_left_3447 = gc_frame_newslot(*var_v);
  params[0] = call3449;
  partcv[0] = 1;
  Object opresult3451 = callmethod(*var_v, "==", 1, partcv, params);
// compiled op node returning opresult3451 (depth = 5)
  Object if3446 = done;
  if (istrue(opresult3451)) {
// Begin line 1577
  setline(1577);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3452 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  gc_frame_newslot(*var_removed);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3453 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3454 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3453);
// compiled call node returning call3454 (depth = 7)
// compiled member node returning call3454 (depth = 6)
  params[0] = *var_i;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3455 = callmethod(call3454, "at()put",
    2, partcv, params);
  gc_frame_end(callframe3452);
// compiled call node returning call3455 (depth = 5)
// Begin line 1578
  setline(1578);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3456 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3458 = alloc_Float64(1);
// compiled num node returning num3458 (depth = 7)
  int op_slot_right_3457 = gc_frame_newslot(num3458);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3460 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3461 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3460);
// compiled call node returning call3461 (depth = 8)
// compiled member node returning call3461 (depth = 7)
  int op_slot_left_3457 = gc_frame_newslot(call3461);
  params[0] = num3458;
  partcv[0] = 1;
  Object diff3462 = callmethod(call3461, "-", 1, partcv, params);
// compiled op node returning diff3462 (depth = 6)
  gc_frame_newslot(diff3462);
// call case 4: self request
  params[0] = diff3462;
  partcv[0] = 1;
  Object call3463 = callmethodflags(self, "numBindings:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3456);
// compiled call node returning call3463 (depth = 5)
    gc_frame_newslot(call3463);
    if3446 = call3463;
  } else {
  }
// compiled if node returning if3446 (depth = 4)
  gc_frame_end(frame);
  return if3446;
}
Object meth_collectionsPrelude_removeValue3416(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeValue");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeValue");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removeValue (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for removeValue");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_initialNumBindings = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "initialNumBindings");
// Begin line 1572
  setline(1572);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3417 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3419 = alloc_Float64(1);
// compiled num node returning num3419 (depth = 4)
  int op_slot_right_3418 = gc_frame_newslot(num3419);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3421 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3422 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3421);
// compiled call node returning call3422 (depth = 5)
// compiled member node returning call3422 (depth = 4)
  int op_slot_left_3418 = gc_frame_newslot(call3422);
  params[0] = num3419;
  partcv[0] = 1;
  Object sum3423 = callmethod(call3422, "+", 1, partcv, params);
// compiled op node returning sum3423 (depth = 3)
  gc_frame_newslot(sum3423);
// call case 4: self request
  params[0] = sum3423;
  partcv[0] = 1;
  Object call3424 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3417);
// compiled call node returning call3424 (depth = 2)
// Begin line 1573
  setline(1573);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3425 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3426 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3425);
// compiled call node returning call3426 (depth = 4)
// compiled member node returning call3426 (depth = 3)
  *var_initialNumBindings = call3426;
  if (call3426 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1574
  setline(1574);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3427 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3430 = alloc_Float64(1);
// compiled num node returning num3430 (depth = 5)
  int op_slot_right_3429 = gc_frame_newslot(num3430);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3432 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3433 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3434 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3433);
// compiled call node returning call3434 (depth = 8)
// compiled member node returning call3434 (depth = 7)
  partcv[0] = 0;
  Object call3435 = callmethod(call3434, "size",
    1, partcv, params);
  gc_frame_end(callframe3432);
// compiled call node returning call3435 (depth = 6)
// compiled member node returning call3435 (depth = 5)
  int op_slot_left_3429 = gc_frame_newslot(call3435);
  params[0] = num3430;
  partcv[0] = 1;
  Object diff3436 = callmethod(call3435, "-", 1, partcv, params);
// compiled op node returning diff3436 (depth = 4)
  int op_slot_right_3428 = gc_frame_newslot(diff3436);
// starting to compile num node (depth = 4)
  Object num3438 = alloc_Float64(0);
// compiled num node returning num3438 (depth = 4)
  int op_slot_left_3428 = gc_frame_newslot(num3438);
  params[0] = diff3436;
  partcv[0] = 1;
  Object opresult3439 = callmethod(num3438, "..", 1, partcv, params);
// compiled op node returning opresult3439 (depth = 3)
  gc_frame_newslot(opresult3439);
// starting to compile block node (depth = 3)
  Object block3440 = alloc_Block(NULL, NULL, "collectionsPrelude", 1574);
  gc_frame_newslot(block3440);
// method "_apply"
  block_savedest(block3440);
  Object closure3441 = createclosure(3, "_apply");
  setclosureframe(closure3441, stackframe);
  addtoclosure(closure3441, var_v);
  addtoclosure(closure3441, var_removed);
  addtoclosure(closure3441, selfslot);
  struct UserObject *uo3441 = (struct UserObject*)block3440;
  uo3441->data[0] = (Object)closure3441;
  Method *meth_meth_collectionsPrelude__apply3441 = addmethod2pos(block3440, "_apply", &meth_collectionsPrelude__apply3441, 0);
  int argcv_meth_collectionsPrelude__apply3441[] = {1};
  meth_meth_collectionsPrelude__apply3441->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3441);
  meth_meth_collectionsPrelude__apply3441->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3441->definitionLine = 1574;
// compiled block node returning block3440 (depth = 3)
  gc_frame_newslot(block3440);
// call case 5: prelude request
  params[0] = opresult3439;
  params[1] = block3440;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3465 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3427);
// compiled call node returning call3465 (depth = 2)
// Begin line 1581
  setline(1581);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_initialNumBindings (depth = 4)
  int op_slot_right_3467 = gc_frame_newslot(*var_initialNumBindings);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3469 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3470 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3469);
// compiled call node returning call3470 (depth = 5)
// compiled member node returning call3470 (depth = 4)
  int op_slot_left_3467 = gc_frame_newslot(call3470);
  params[0] = *var_initialNumBindings;
  partcv[0] = 1;
  Object opresult3471 = callmethod(call3470, "==", 1, partcv, params);
// compiled op node returning opresult3471 (depth = 3)
  Object if3466 = done;
  if (istrue(opresult3471)) {
// Begin line 1582
  setline(1582);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe3472 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit3474 == NULL) {
    strlit3474 = alloc_String("");
    gc_root(strlit3474);
  }
// compiled string node returning strlit3474 (depth = 5)
  int op_slot_right_3473 = gc_frame_newslot(strlit3474);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  int op_slot_right_3476 = gc_frame_newslot(*var_v);
// starting to compile string node (depth = 6)
  if (strlit3478 == NULL) {
    strlit3478 = alloc_String("dictionary does not contain entry with value ");
    gc_root(strlit3478);
  }
// compiled string node returning strlit3478 (depth = 6)
  int op_slot_left_3476 = gc_frame_newslot(strlit3478);
  params[0] = *var_v;
  partcv[0] = 1;
  Object opresult3479 = callmethod(strlit3478, "++", 1, partcv, params);
// compiled op node returning opresult3479 (depth = 5)
  int op_slot_left_3473 = gc_frame_newslot(opresult3479);
  params[0] = strlit3474;
  partcv[0] = 1;
  Object opresult3480 = callmethod(opresult3479, "++", 1, partcv, params);
// compiled op node returning opresult3480 (depth = 4)
  gc_frame_newslot(opresult3480);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_NoSuchObject (depth = 4)
  params[0] = opresult3480;
  partcv[0] = 1;
  Object call3481 = callmethod(*var_NoSuchObject, "raise",
    1, partcv, params);
  gc_frame_end(callframe3472);
// compiled call node returning call3481 (depth = 3)
    gc_frame_newslot(call3481);
    if3466 = call3481;
  } else {
  }
// compiled if node returning if3466 (depth = 2)
// Begin line 1584
  setline(1584);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply3507(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1591
  setline(1591);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3508 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3509 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3510 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3509);
// compiled call node returning call3510 (depth = 7)
// compiled member node returning call3510 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3511 = callmethod(call3510, "at",
    1, partcv, params);
  gc_frame_end(callframe3508);
// compiled call node returning call3511 (depth = 5)
  *var_a = call3511;
  if (call3511 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1592
  setline(1592);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3514 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call3515 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe3514);
// compiled call node returning call3515 (depth = 7)
// compiled member node returning call3515 (depth = 6)
  int op_slot_right_3513 = gc_frame_newslot(call3515);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  int op_slot_left_3513 = gc_frame_newslot(*var_v);
  params[0] = call3515;
  partcv[0] = 1;
  Object opresult3517 = callmethod(*var_v, "==", 1, partcv, params);
// compiled op node returning opresult3517 (depth = 5)
  Object if3512 = done;
  if (istrue(opresult3517)) {
// Begin line 1593
  setline(1593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3518 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  gc_frame_newslot(*var_removed);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3519 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3520 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3519);
// compiled call node returning call3520 (depth = 7)
// compiled member node returning call3520 (depth = 6)
  params[0] = *var_i;
  params[1] = *var_removed;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3521 = callmethod(call3520, "at()put",
    2, partcv, params);
  gc_frame_end(callframe3518);
// compiled call node returning call3521 (depth = 5)
// Begin line 1594
  setline(1594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe3522 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3524 = alloc_Float64(1);
// compiled num node returning num3524 (depth = 7)
  int op_slot_right_3523 = gc_frame_newslot(num3524);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3526 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3527 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3526);
// compiled call node returning call3527 (depth = 8)
// compiled member node returning call3527 (depth = 7)
  int op_slot_left_3523 = gc_frame_newslot(call3527);
  params[0] = num3524;
  partcv[0] = 1;
  Object diff3528 = callmethod(call3527, "-", 1, partcv, params);
// compiled op node returning diff3528 (depth = 6)
  gc_frame_newslot(diff3528);
// call case 4: self request
  params[0] = diff3528;
  partcv[0] = 1;
  Object call3529 = callmethodflags(self, "numBindings:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3522);
// compiled call node returning call3529 (depth = 5)
    gc_frame_newslot(call3529);
    if3512 = call3529;
  } else {
  }
// compiled if node returning if3512 (depth = 4)
  gc_frame_end(frame);
  return if3512;
}
Object meth_collectionsPrelude_removeValue_40__41_ifAbsent3482(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removeValue()ifAbsent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeValue()ifAbsent");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method removeValue()ifAbsent");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for removeValue()ifAbsent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for removeValue");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ifAbsent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_initialNumBindings = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "initialNumBindings");
// Begin line 1588
  setline(1588);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3483 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num3485 = alloc_Float64(1);
// compiled num node returning num3485 (depth = 4)
  int op_slot_right_3484 = gc_frame_newslot(num3485);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3487 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3488 = callmethodflags(self, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3487);
// compiled call node returning call3488 (depth = 5)
// compiled member node returning call3488 (depth = 4)
  int op_slot_left_3484 = gc_frame_newslot(call3488);
  params[0] = num3485;
  partcv[0] = 1;
  Object sum3489 = callmethod(call3488, "+", 1, partcv, params);
// compiled op node returning sum3489 (depth = 3)
  gc_frame_newslot(sum3489);
// call case 4: self request
  params[0] = sum3489;
  partcv[0] = 1;
  Object call3490 = callmethodflags(self, "mods:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3483);
// compiled call node returning call3490 (depth = 2)
// Begin line 1589
  setline(1589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3491 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3492 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3491);
// compiled call node returning call3492 (depth = 4)
// compiled member node returning call3492 (depth = 3)
  *var_initialNumBindings = call3492;
  if (call3492 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1590
  setline(1590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3493 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3496 = alloc_Float64(1);
// compiled num node returning num3496 (depth = 5)
  int op_slot_right_3495 = gc_frame_newslot(num3496);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3498 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3499 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3500 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3499);
// compiled call node returning call3500 (depth = 8)
// compiled member node returning call3500 (depth = 7)
  partcv[0] = 0;
  Object call3501 = callmethod(call3500, "size",
    1, partcv, params);
  gc_frame_end(callframe3498);
// compiled call node returning call3501 (depth = 6)
// compiled member node returning call3501 (depth = 5)
  int op_slot_left_3495 = gc_frame_newslot(call3501);
  params[0] = num3496;
  partcv[0] = 1;
  Object diff3502 = callmethod(call3501, "-", 1, partcv, params);
// compiled op node returning diff3502 (depth = 4)
  int op_slot_right_3494 = gc_frame_newslot(diff3502);
// starting to compile num node (depth = 4)
  Object num3504 = alloc_Float64(0);
// compiled num node returning num3504 (depth = 4)
  int op_slot_left_3494 = gc_frame_newslot(num3504);
  params[0] = diff3502;
  partcv[0] = 1;
  Object opresult3505 = callmethod(num3504, "..", 1, partcv, params);
// compiled op node returning opresult3505 (depth = 3)
  gc_frame_newslot(opresult3505);
// starting to compile block node (depth = 3)
  Object block3506 = alloc_Block(NULL, NULL, "collectionsPrelude", 1590);
  gc_frame_newslot(block3506);
// method "_apply"
  block_savedest(block3506);
  Object closure3507 = createclosure(3, "_apply");
  setclosureframe(closure3507, stackframe);
  addtoclosure(closure3507, var_v);
  addtoclosure(closure3507, var_removed);
  addtoclosure(closure3507, selfslot);
  struct UserObject *uo3507 = (struct UserObject*)block3506;
  uo3507->data[0] = (Object)closure3507;
  Method *meth_meth_collectionsPrelude__apply3507 = addmethod2pos(block3506, "_apply", &meth_collectionsPrelude__apply3507, 0);
  int argcv_meth_collectionsPrelude__apply3507[] = {1};
  meth_meth_collectionsPrelude__apply3507->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3507);
  meth_meth_collectionsPrelude__apply3507->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3507->definitionLine = 1590;
// compiled block node returning block3506 (depth = 3)
  gc_frame_newslot(block3506);
// call case 5: prelude request
  params[0] = opresult3505;
  params[1] = block3506;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3531 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3493);
// compiled call node returning call3531 (depth = 2)
// Begin line 1597
  setline(1597);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_initialNumBindings (depth = 4)
  int op_slot_right_3533 = gc_frame_newslot(*var_initialNumBindings);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3535 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3536 = callmethodflags(self, "numBindings", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3535);
// compiled call node returning call3536 (depth = 5)
// compiled member node returning call3536 (depth = 4)
  int op_slot_left_3533 = gc_frame_newslot(call3536);
  params[0] = *var_initialNumBindings;
  partcv[0] = 1;
  Object opresult3537 = callmethod(call3536, "==", 1, partcv, params);
// compiled op node returning opresult3537 (depth = 3)
  Object if3532 = done;
  if (istrue(opresult3537)) {
// Begin line 1598
  setline(1598);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3538 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_action (depth = 5)
  partcv[0] = 0;
  Object call3539 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe3538);
// compiled call node returning call3539 (depth = 4)
// compiled member node returning call3539 (depth = 3)
    gc_frame_newslot(call3539);
    if3532 = call3539;
  } else {
  }
// compiled if node returning if3532 (depth = 2)
// Begin line 1600
  setline(1600);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply3543(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1604
  setline(1604);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  int op_slot_right_3545 = gc_frame_newslot(*var_each);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  int op_slot_left_3545 = gc_frame_newslot(*var_v);
  params[0] = *var_each;
  partcv[0] = 1;
  Object opresult3547 = callmethod(*var_v, "==", 1, partcv, params);
// compiled op node returning opresult3547 (depth = 5)
  Object if3544 = done;
  if (istrue(opresult3547)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool3548 = alloc_Boolean(1);
// compiled identifier node returning bool3548 (depth = 6)
  block_return(realself, bool3548);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if3544 = undefined;
  } else {
  }
// compiled if node returning if3544 (depth = 4)
  gc_frame_end(frame);
  return if3544;
}
Object meth_collectionsPrelude_containsValue3540(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "containsValue");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method containsValue");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for containsValue (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for containsValue");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1603
  setline(1603);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3541 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3542 = alloc_Block(NULL, NULL, "collectionsPrelude", 1603);
  gc_frame_newslot(block3542);
// method "_apply"
  block_savedest(block3542);
  Object closure3543 = createclosure(2, "_apply");
  setclosureframe(closure3543, stackframe);
  addtoclosure(closure3543, var_v);
  addtoclosure(closure3543, selfslot);
  struct UserObject *uo3543 = (struct UserObject*)block3542;
  uo3543->data[0] = (Object)closure3543;
  Method *meth_meth_collectionsPrelude__apply3543 = addmethod2pos(block3542, "_apply", &meth_collectionsPrelude__apply3543, 0);
  int argcv_meth_collectionsPrelude__apply3543[] = {1};
  meth_meth_collectionsPrelude__apply3543->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3543);
  meth_meth_collectionsPrelude__apply3543->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3543->definitionLine = 1598;
// compiled block node returning block3542 (depth = 3)
  gc_frame_newslot(block3542);
// call case 4: self request
  params[0] = block3542;
  partcv[0] = 1;
  Object call3550 = callmethodflags(self, "valuesDo", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3541);
// compiled call node returning call3550 (depth = 2)
// Begin line 1606
  setline(1606);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
  Object bool3551 = alloc_Boolean(0);
// compiled identifier node returning bool3551 (depth = 2)
  gc_frame_end(frame);
  return bool3551;
}
Object meth_collectionsPrelude_contains3552(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_v = &(stackframe->slots[0]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for contains");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1608
  setline(1608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3553 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  gc_frame_newslot(*var_v);
// call case 4: self request
  params[0] = *var_v;
  partcv[0] = 1;
  Object call3554 = callmethodflags(self, "containsValue", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3553);
// compiled call node returning call3554 (depth = 2)
  gc_frame_end(frame);
  return call3554;
}
Object meth_collectionsPrelude__apply3568(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_t = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3570 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3571 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3572 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3571);
// compiled call node returning call3572 (depth = 7)
// compiled member node returning call3572 (depth = 6)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3573 = callmethod(call3572, "at",
    1, partcv, params);
  gc_frame_end(callframe3570);
// compiled call node returning call3573 (depth = 5)
  int op_slot_right_3569 = gc_frame_newslot(call3573);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  int op_slot_left_3569 = gc_frame_newslot(*var_unused);
  params[0] = call3573;
  partcv[0] = 1;
  Object opresult3575 = callmethod(*var_unused, "≠", 1, partcv, params);
// compiled op node returning opresult3575 (depth = 4)
  gc_frame_end(frame);
  return opresult3575;
}
Object meth_collectionsPrelude__apply3578(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_x = getfromclosure(closure, 0);
  Object *var_t = getfromclosure(closure, 1);
  Object *var_jump = getfromclosure(closure, 2);
  Object *var_s = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1616
  setline(1616);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  int op_slot_right_3580 = gc_frame_newslot(*var_x);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3582 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe3583 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3584 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3585 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3584);
// compiled call node returning call3585 (depth = 10)
// compiled member node returning call3585 (depth = 9)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3586 = callmethod(call3585, "at",
    1, partcv, params);
  gc_frame_end(callframe3583);
// compiled call node returning call3586 (depth = 8)
  partcv[0] = 0;
  Object call3587 = callmethod(call3586, "key",
    1, partcv, params);
  gc_frame_end(callframe3582);
// compiled call node returning call3587 (depth = 7)
// compiled member node returning call3587 (depth = 6)
  int op_slot_left_3580 = gc_frame_newslot(call3587);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult3588 = callmethod(call3587, "==", 1, partcv, params);
// compiled op node returning opresult3588 (depth = 5)
  Object if3579 = done;
  if (istrue(opresult3588)) {
// Begin line 1617
  setline(1617);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  block_return(realself, *var_t);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if3579 = undefined;
  } else {
  }
// compiled if node returning if3579 (depth = 4)
// Begin line 1619
  setline(1619);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3591 = alloc_Float64(0);
// compiled num node returning num3591 (depth = 6)
  int op_slot_right_3590 = gc_frame_newslot(num3591);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_jump (depth = 6)
  int op_slot_left_3590 = gc_frame_newslot(*var_jump);
  params[0] = num3591;
  partcv[0] = 1;
  Object opresult3593 = callmethod(*var_jump, "≠", 1, partcv, params);
// compiled op node returning opresult3593 (depth = 5)
  Object if3589 = done;
  if (istrue(opresult3593)) {
// Begin line 1620
  setline(1620);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_3594 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3597 = alloc_Float64(1);
// compiled num node returning num3597 (depth = 8)
  int op_slot_right_3596 = gc_frame_newslot(num3597);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3600 = alloc_Float64(3);
// compiled num node returning num3600 (depth = 9)
  int op_slot_right_3599 = gc_frame_newslot(num3600);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  int op_slot_left_3599 = gc_frame_newslot(*var_t);
  params[0] = num3600;
  partcv[0] = 1;
  Object prod3602 = callmethod(*var_t, "*", 1, partcv, params);
// compiled op node returning prod3602 (depth = 8)
  int op_slot_left_3596 = gc_frame_newslot(prod3602);
  params[0] = num3597;
  partcv[0] = 1;
  Object sum3603 = callmethod(prod3602, "+", 1, partcv, params);
// compiled op node returning sum3603 (depth = 7)
  int op_slot_left_3594 = gc_frame_newslot(sum3603);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3604 = callmethod(sum3603, "%", 1, partcv, params);
// compiled op node returning modulus3604 (depth = 6)
  *var_t = modulus3604;
  if (modulus3604 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1621
  setline(1621);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3607 = alloc_Float64(1);
// compiled num node returning num3607 (depth = 7)
  int op_slot_right_3606 = gc_frame_newslot(num3607);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_jump (depth = 7)
  int op_slot_left_3606 = gc_frame_newslot(*var_jump);
  params[0] = num3607;
  partcv[0] = 1;
  Object diff3609 = callmethod(*var_jump, "-", 1, partcv, params);
// compiled op node returning diff3609 (depth = 6)
  *var_jump = diff3609;
  if (diff3609 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3589 = done;
  } else {
// Begin line 1623
  setline(1623);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_3611 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3614 = alloc_Float64(1);
// compiled num node returning num3614 (depth = 8)
  int op_slot_right_3613 = gc_frame_newslot(num3614);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  int op_slot_left_3613 = gc_frame_newslot(*var_t);
  params[0] = num3614;
  partcv[0] = 1;
  Object sum3616 = callmethod(*var_t, "+", 1, partcv, params);
// compiled op node returning sum3616 (depth = 7)
  int op_slot_left_3611 = gc_frame_newslot(sum3616);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3617 = callmethod(sum3616, "%", 1, partcv, params);
// compiled op node returning modulus3617 (depth = 6)
  *var_t = modulus3617;
  if (modulus3617 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3589 = done;
  }
// compiled if node returning if3589 (depth = 4)
  gc_frame_end(frame);
  return if3589;
}
Object meth_collectionsPrelude_findPosition3555(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findPosition");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findPosition");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findPosition (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for findPosition");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_h = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "h");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_t = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "t");
  Object *var_jump = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "jump");
// Begin line 1611
  setline(1611);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3556 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  partcv[0] = 0;
  Object call3557 = callmethod(*var_x, "hash",
    1, partcv, params);
  gc_frame_end(callframe3556);
// compiled call node returning call3557 (depth = 4)
// compiled member node returning call3557 (depth = 3)
  *var_h = call3557;
  if (call3557 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1612
  setline(1612);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3558 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3559 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3560 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3559);
// compiled call node returning call3560 (depth = 6)
// compiled member node returning call3560 (depth = 5)
  partcv[0] = 0;
  Object call3561 = callmethod(call3560, "size",
    1, partcv, params);
  gc_frame_end(callframe3558);
// compiled call node returning call3561 (depth = 4)
// compiled member node returning call3561 (depth = 3)
  *var_s = call3561;
  if (call3561 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1613
  setline(1613);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_right_3562 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_h (depth = 4)
  int op_slot_left_3562 = gc_frame_newslot(*var_h);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3564 = callmethod(*var_h, "%", 1, partcv, params);
// compiled op node returning modulus3564 (depth = 3)
  *var_t = modulus3564;
  if (modulus3564 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1614
  setline(1614);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num3565 = alloc_Float64(5);
// compiled num node returning num3565 (depth = 3)
  *var_jump = num3565;
  if (num3565 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1615
  setline(1615);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3566 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3567 = alloc_Block(NULL, NULL, "collectionsPrelude", 1615);
  gc_frame_newslot(block3567);
// method "_apply"
  block_savedest(block3567);
  Object closure3568 = createclosure(3, "_apply");
  setclosureframe(closure3568, stackframe);
  addtoclosure(closure3568, var_t);
  addtoclosure(closure3568, var_unused);
  addtoclosure(closure3568, selfslot);
  struct UserObject *uo3568 = (struct UserObject*)block3567;
  uo3568->data[0] = (Object)closure3568;
  Method *meth_meth_collectionsPrelude__apply3568 = addmethod2pos(block3567, "_apply", &meth_collectionsPrelude__apply3568, 0);
  int argcv_meth_collectionsPrelude__apply3568[] = {0};
  meth_meth_collectionsPrelude__apply3568->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3568);
  meth_meth_collectionsPrelude__apply3568->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3568->definitionLine = 1612;
// compiled block node returning block3567 (depth = 3)
  gc_frame_newslot(block3567);
// starting to compile block node (depth = 3)
  Object block3577 = alloc_Block(NULL, NULL, "collectionsPrelude", 1615);
  gc_frame_newslot(block3577);
// method "_apply"
  block_savedest(block3577);
  Object closure3578 = createclosure(5, "_apply");
  setclosureframe(closure3578, stackframe);
  addtoclosure(closure3578, var_x);
  addtoclosure(closure3578, var_t);
  addtoclosure(closure3578, var_jump);
  addtoclosure(closure3578, var_s);
  addtoclosure(closure3578, selfslot);
  struct UserObject *uo3578 = (struct UserObject*)block3577;
  uo3578->data[0] = (Object)closure3578;
  Method *meth_meth_collectionsPrelude__apply3578 = addmethod2pos(block3577, "_apply", &meth_collectionsPrelude__apply3578, 0);
  int argcv_meth_collectionsPrelude__apply3578[] = {0};
  meth_meth_collectionsPrelude__apply3578->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3578);
  meth_meth_collectionsPrelude__apply3578->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3578->definitionLine = 1615;
// compiled block node returning block3577 (depth = 3)
  gc_frame_newslot(block3577);
// call case 5: prelude request
  params[0] = block3567;
  params[1] = block3577;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3620 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3566);
// compiled call node returning call3620 (depth = 2)
// Begin line 1626
  setline(1626);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  return *var_t;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply3634(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_t = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3637 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3638 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3639 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3638);
// compiled call node returning call3639 (depth = 8)
// compiled member node returning call3639 (depth = 7)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3640 = callmethod(call3639, "at",
    1, partcv, params);
  gc_frame_end(callframe3637);
// compiled call node returning call3640 (depth = 6)
  int op_slot_right_3636 = gc_frame_newslot(call3640);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  int op_slot_left_3636 = gc_frame_newslot(*var_removed);
  params[0] = call3640;
  partcv[0] = 1;
  Object opresult3642 = callmethod(*var_removed, "≠", 1, partcv, params);
// compiled op node returning opresult3642 (depth = 5)
  int op_slot_right_3635 = gc_frame_newslot(opresult3642);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3645 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_t (depth = 7)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3646 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3647 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3646);
// compiled call node returning call3647 (depth = 8)
// compiled member node returning call3647 (depth = 7)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3648 = callmethod(call3647, "at",
    1, partcv, params);
  gc_frame_end(callframe3645);
// compiled call node returning call3648 (depth = 6)
  int op_slot_right_3644 = gc_frame_newslot(call3648);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_unused (depth = 6)
  int op_slot_left_3644 = gc_frame_newslot(*var_unused);
  params[0] = call3648;
  partcv[0] = 1;
  Object opresult3650 = callmethod(*var_unused, "≠", 1, partcv, params);
// compiled op node returning opresult3650 (depth = 5)
  int op_slot_left_3635 = gc_frame_newslot(opresult3650);
  params[0] = opresult3642;
  partcv[0] = 1;
  Object opresult3651 = callmethod(opresult3650, "&&", 1, partcv, params);
// compiled op node returning opresult3651 (depth = 4)
  gc_frame_end(frame);
  return opresult3651;
}
Object meth_collectionsPrelude__apply3654(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_x = getfromclosure(closure, 0);
  Object *var_t = getfromclosure(closure, 1);
  Object *var_jump = getfromclosure(closure, 2);
  Object *var_s = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1634
  setline(1634);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_x (depth = 6)
  int op_slot_right_3656 = gc_frame_newslot(*var_x);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3658 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe3659 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  gc_frame_newslot(*var_t);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3660 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3661 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3660);
// compiled call node returning call3661 (depth = 10)
// compiled member node returning call3661 (depth = 9)
  params[0] = *var_t;
  partcv[0] = 1;
  Object call3662 = callmethod(call3661, "at",
    1, partcv, params);
  gc_frame_end(callframe3659);
// compiled call node returning call3662 (depth = 8)
  partcv[0] = 0;
  Object call3663 = callmethod(call3662, "key",
    1, partcv, params);
  gc_frame_end(callframe3658);
// compiled call node returning call3663 (depth = 7)
// compiled member node returning call3663 (depth = 6)
  int op_slot_left_3656 = gc_frame_newslot(call3663);
  params[0] = *var_x;
  partcv[0] = 1;
  Object opresult3664 = callmethod(call3663, "==", 1, partcv, params);
// compiled op node returning opresult3664 (depth = 5)
  Object if3655 = done;
  if (istrue(opresult3664)) {
// Begin line 1635
  setline(1635);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_t (depth = 6)
  block_return(realself, *var_t);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if3655 = undefined;
  } else {
  }
// compiled if node returning if3655 (depth = 4)
// Begin line 1637
  setline(1637);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3667 = alloc_Float64(0);
// compiled num node returning num3667 (depth = 6)
  int op_slot_right_3666 = gc_frame_newslot(num3667);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_jump (depth = 6)
  int op_slot_left_3666 = gc_frame_newslot(*var_jump);
  params[0] = num3667;
  partcv[0] = 1;
  Object opresult3669 = callmethod(*var_jump, "≠", 1, partcv, params);
// compiled op node returning opresult3669 (depth = 5)
  Object if3665 = done;
  if (istrue(opresult3669)) {
// Begin line 1638
  setline(1638);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_3670 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3673 = alloc_Float64(1);
// compiled num node returning num3673 (depth = 8)
  int op_slot_right_3672 = gc_frame_newslot(num3673);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num3676 = alloc_Float64(3);
// compiled num node returning num3676 (depth = 9)
  int op_slot_right_3675 = gc_frame_newslot(num3676);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_t (depth = 9)
  int op_slot_left_3675 = gc_frame_newslot(*var_t);
  params[0] = num3676;
  partcv[0] = 1;
  Object prod3678 = callmethod(*var_t, "*", 1, partcv, params);
// compiled op node returning prod3678 (depth = 8)
  int op_slot_left_3672 = gc_frame_newslot(prod3678);
  params[0] = num3673;
  partcv[0] = 1;
  Object sum3679 = callmethod(prod3678, "+", 1, partcv, params);
// compiled op node returning sum3679 (depth = 7)
  int op_slot_left_3670 = gc_frame_newslot(sum3679);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3680 = callmethod(sum3679, "%", 1, partcv, params);
// compiled op node returning modulus3680 (depth = 6)
  *var_t = modulus3680;
  if (modulus3680 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 1639
  setline(1639);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num3683 = alloc_Float64(1);
// compiled num node returning num3683 (depth = 7)
  int op_slot_right_3682 = gc_frame_newslot(num3683);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_jump (depth = 7)
  int op_slot_left_3682 = gc_frame_newslot(*var_jump);
  params[0] = num3683;
  partcv[0] = 1;
  Object diff3685 = callmethod(*var_jump, "-", 1, partcv, params);
// compiled op node returning diff3685 (depth = 6)
  *var_jump = diff3685;
  if (diff3685 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3665 = done;
  } else {
// Begin line 1641
  setline(1641);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_3687 = gc_frame_newslot(*var_s);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num3690 = alloc_Float64(1);
// compiled num node returning num3690 (depth = 8)
  int op_slot_right_3689 = gc_frame_newslot(num3690);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_t (depth = 8)
  int op_slot_left_3689 = gc_frame_newslot(*var_t);
  params[0] = num3690;
  partcv[0] = 1;
  Object sum3692 = callmethod(*var_t, "+", 1, partcv, params);
// compiled op node returning sum3692 (depth = 7)
  int op_slot_left_3687 = gc_frame_newslot(sum3692);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3693 = callmethod(sum3692, "%", 1, partcv, params);
// compiled op node returning modulus3693 (depth = 6)
  *var_t = modulus3693;
  if (modulus3693 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3665 = done;
  }
// compiled if node returning if3665 (depth = 4)
  gc_frame_end(frame);
  return if3665;
}
Object meth_collectionsPrelude_findPositionForAdd3621(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "findPositionForAdd");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findPositionForAdd");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findPositionForAdd (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_x = &(stackframe->slots[0]);
  *var_x = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for findPositionForAdd");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_h = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "h");
  Object *var_s = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "s");
  Object *var_t = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "t");
  Object *var_jump = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "jump");
// Begin line 1629
  setline(1629);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3622 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_x (depth = 5)
  partcv[0] = 0;
  Object call3623 = callmethod(*var_x, "hash",
    1, partcv, params);
  gc_frame_end(callframe3622);
// compiled call node returning call3623 (depth = 4)
// compiled member node returning call3623 (depth = 3)
  *var_h = call3623;
  if (call3623 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1630
  setline(1630);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3624 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3625 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3626 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3625);
// compiled call node returning call3626 (depth = 6)
// compiled member node returning call3626 (depth = 5)
  partcv[0] = 0;
  Object call3627 = callmethod(call3626, "size",
    1, partcv, params);
  gc_frame_end(callframe3624);
// compiled call node returning call3627 (depth = 4)
// compiled member node returning call3627 (depth = 3)
  *var_s = call3627;
  if (call3627 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1631
  setline(1631);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_right_3628 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_h (depth = 4)
  int op_slot_left_3628 = gc_frame_newslot(*var_h);
  params[0] = *var_s;
  partcv[0] = 1;
  Object modulus3630 = callmethod(*var_h, "%", 1, partcv, params);
// compiled op node returning modulus3630 (depth = 3)
  *var_t = modulus3630;
  if (modulus3630 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1632
  setline(1632);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num3631 = alloc_Float64(5);
// compiled num node returning num3631 (depth = 3)
  *var_jump = num3631;
  if (num3631 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1633
  setline(1633);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3632 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block3633 = alloc_Block(NULL, NULL, "collectionsPrelude", 1633);
  gc_frame_newslot(block3633);
// method "_apply"
  block_savedest(block3633);
  Object closure3634 = createclosure(4, "_apply");
  setclosureframe(closure3634, stackframe);
  addtoclosure(closure3634, var_t);
  addtoclosure(closure3634, var_removed);
  addtoclosure(closure3634, var_unused);
  addtoclosure(closure3634, selfslot);
  struct UserObject *uo3634 = (struct UserObject*)block3633;
  uo3634->data[0] = (Object)closure3634;
  Method *meth_meth_collectionsPrelude__apply3634 = addmethod2pos(block3633, "_apply", &meth_collectionsPrelude__apply3634, 0);
  int argcv_meth_collectionsPrelude__apply3634[] = {0};
  meth_meth_collectionsPrelude__apply3634->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3634);
  meth_meth_collectionsPrelude__apply3634->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3634->definitionLine = 1630;
// compiled block node returning block3633 (depth = 3)
  gc_frame_newslot(block3633);
// starting to compile block node (depth = 3)
  Object block3653 = alloc_Block(NULL, NULL, "collectionsPrelude", 1633);
  gc_frame_newslot(block3653);
// method "_apply"
  block_savedest(block3653);
  Object closure3654 = createclosure(5, "_apply");
  setclosureframe(closure3654, stackframe);
  addtoclosure(closure3654, var_x);
  addtoclosure(closure3654, var_t);
  addtoclosure(closure3654, var_jump);
  addtoclosure(closure3654, var_s);
  addtoclosure(closure3654, selfslot);
  struct UserObject *uo3654 = (struct UserObject*)block3653;
  uo3654->data[0] = (Object)closure3654;
  Method *meth_meth_collectionsPrelude__apply3654 = addmethod2pos(block3653, "_apply", &meth_collectionsPrelude__apply3654, 0);
  int argcv_meth_collectionsPrelude__apply3654[] = {0};
  meth_meth_collectionsPrelude__apply3654->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3654);
  meth_meth_collectionsPrelude__apply3654->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3654->definitionLine = 1633;
// compiled block node returning block3653 (depth = 3)
  gc_frame_newslot(block3653);
// call case 5: prelude request
  params[0] = block3633;
  params[1] = block3653;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3696 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3632);
// compiled call node returning call3696 (depth = 2)
// Begin line 1644
  setline(1644);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_t (depth = 3)
  return *var_t;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply3714(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_firstElement = getfromclosure(closure, 2);
  Object *var_s = getfromclosure(closure, 3);
  Object self = *(getfromclosure(closure, 4));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1652
  setline(1652);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3715 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3716 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3717 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3716);
// compiled call node returning call3717 (depth = 7)
// compiled member node returning call3717 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3718 = callmethod(call3717, "at",
    1, partcv, params);
  gc_frame_end(callframe3715);
// compiled call node returning call3718 (depth = 5)
  *var_a = call3718;
  if (call3718 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1653
  setline(1653);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_3721 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_3721 = gc_frame_newslot(*var_removed);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult3723 = callmethod(*var_removed, "≠", 1, partcv, params);
// compiled op node returning opresult3723 (depth = 6)
  int op_slot_right_3720 = gc_frame_newslot(opresult3723);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_3725 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_3725 = gc_frame_newslot(*var_unused);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult3727 = callmethod(*var_unused, "≠", 1, partcv, params);
// compiled op node returning opresult3727 (depth = 6)
  int op_slot_left_3720 = gc_frame_newslot(opresult3727);
  params[0] = opresult3723;
  partcv[0] = 1;
  Object opresult3728 = callmethod(opresult3727, "&&", 1, partcv, params);
// compiled op node returning opresult3728 (depth = 5)
  Object if3719 = done;
  if (istrue(opresult3728)) {
// Begin line 1654
  setline(1654);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3730 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_firstElement (depth = 7)
  partcv[0] = 0;
  Object call3731 = callmethod(*var_firstElement, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe3730);
// compiled call node returning call3731 (depth = 6)
  Object if3729 = done;
  if (istrue(call3731)) {
// Begin line 1655
  setline(1655);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3733 == NULL) {
    strlit3733 = alloc_String(", ");
    gc_root(strlit3733);
  }
// compiled string node returning strlit3733 (depth = 8)
  int op_slot_right_3732 = gc_frame_newslot(strlit3733);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_s (depth = 8)
  int op_slot_left_3732 = gc_frame_newslot(*var_s);
  params[0] = strlit3733;
  partcv[0] = 1;
  Object opresult3735 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3735 (depth = 7)
  *var_s = opresult3735;
  if (opresult3735 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if3729 = done;
  } else {
// Begin line 1657
  setline(1657);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool3737 = alloc_Boolean(0);
// compiled identifier node returning bool3737 (depth = 7)
  *var_firstElement = bool3737;
  if (bool3737 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if3729 = done;
  }
// compiled if node returning if3729 (depth = 5)
// Begin line 1659
  setline(1659);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3741 == NULL) {
    strlit3741 = alloc_String("");
    gc_root(strlit3741);
  }
// compiled string node returning strlit3741 (depth = 8)
  int op_slot_right_3740 = gc_frame_newslot(strlit3741);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3744 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  partcv[0] = 0;
  Object call3745 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe3744);
// compiled call node returning call3745 (depth = 10)
// compiled member node returning call3745 (depth = 9)
  int op_slot_right_3743 = gc_frame_newslot(call3745);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3748 == NULL) {
    strlit3748 = alloc_String("::");
    gc_root(strlit3748);
  }
// compiled string node returning strlit3748 (depth = 10)
  int op_slot_right_3747 = gc_frame_newslot(strlit3748);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3751 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_a (depth = 13)
  partcv[0] = 0;
  Object call3752 = callmethod(*var_a, "key",
    1, partcv, params);
  gc_frame_end(callframe3751);
// compiled call node returning call3752 (depth = 12)
// compiled member node returning call3752 (depth = 11)
  int op_slot_right_3750 = gc_frame_newslot(call3752);
// starting to compile string node (depth = 11)
  if (strlit3754 == NULL) {
    strlit3754 = alloc_String("");
    gc_root(strlit3754);
  }
// compiled string node returning strlit3754 (depth = 11)
  int op_slot_left_3750 = gc_frame_newslot(strlit3754);
  params[0] = call3752;
  partcv[0] = 1;
  Object opresult3755 = callmethod(strlit3754, "++", 1, partcv, params);
// compiled op node returning opresult3755 (depth = 10)
  int op_slot_left_3747 = gc_frame_newslot(opresult3755);
  params[0] = strlit3748;
  partcv[0] = 1;
  Object opresult3756 = callmethod(opresult3755, "++", 1, partcv, params);
// compiled op node returning opresult3756 (depth = 9)
  int op_slot_left_3743 = gc_frame_newslot(opresult3756);
  params[0] = call3745;
  partcv[0] = 1;
  Object opresult3757 = callmethod(opresult3756, "++", 1, partcv, params);
// compiled op node returning opresult3757 (depth = 8)
  int op_slot_left_3740 = gc_frame_newslot(opresult3757);
  params[0] = strlit3741;
  partcv[0] = 1;
  Object opresult3758 = callmethod(opresult3757, "++", 1, partcv, params);
// compiled op node returning opresult3758 (depth = 7)
  int op_slot_right_3739 = gc_frame_newslot(opresult3758);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3739 = gc_frame_newslot(*var_s);
  params[0] = opresult3758;
  partcv[0] = 1;
  Object opresult3760 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3760 (depth = 6)
  *var_s = opresult3760;
  if (opresult3760 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3719 = done;
  } else {
  }
// compiled if node returning if3719 (depth = 4)
  gc_frame_end(frame);
  return if3719;
}
Object meth_collectionsPrelude_asString3697(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
  Object *var_firstElement = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "firstElement");
// Begin line 1649
  setline(1649);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3698 == NULL) {
    strlit3698 = alloc_String("dict""\xe2""""\x9f""""\xac""");
    gc_root(strlit3698);
  }
// compiled string node returning strlit3698 (depth = 3)
  *var_s = strlit3698;
  if (strlit3698 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1650
  setline(1650);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool3699 = alloc_Boolean(1);
// compiled identifier node returning bool3699 (depth = 3)
  *var_firstElement = bool3699;
  if (bool3699 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1651
  setline(1651);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3700 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3703 = alloc_Float64(1);
// compiled num node returning num3703 (depth = 5)
  int op_slot_right_3702 = gc_frame_newslot(num3703);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3705 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3706 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3707 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3706);
// compiled call node returning call3707 (depth = 8)
// compiled member node returning call3707 (depth = 7)
  partcv[0] = 0;
  Object call3708 = callmethod(call3707, "size",
    1, partcv, params);
  gc_frame_end(callframe3705);
// compiled call node returning call3708 (depth = 6)
// compiled member node returning call3708 (depth = 5)
  int op_slot_left_3702 = gc_frame_newslot(call3708);
  params[0] = num3703;
  partcv[0] = 1;
  Object diff3709 = callmethod(call3708, "-", 1, partcv, params);
// compiled op node returning diff3709 (depth = 4)
  int op_slot_right_3701 = gc_frame_newslot(diff3709);
// starting to compile num node (depth = 4)
  Object num3711 = alloc_Float64(0);
// compiled num node returning num3711 (depth = 4)
  int op_slot_left_3701 = gc_frame_newslot(num3711);
  params[0] = diff3709;
  partcv[0] = 1;
  Object opresult3712 = callmethod(num3711, "..", 1, partcv, params);
// compiled op node returning opresult3712 (depth = 3)
  gc_frame_newslot(opresult3712);
// starting to compile block node (depth = 3)
  Object block3713 = alloc_Block(NULL, NULL, "collectionsPrelude", 1651);
  gc_frame_newslot(block3713);
// method "_apply"
  block_savedest(block3713);
  Object closure3714 = createclosure(5, "_apply");
  setclosureframe(closure3714, stackframe);
  addtoclosure(closure3714, var_removed);
  addtoclosure(closure3714, var_unused);
  addtoclosure(closure3714, var_firstElement);
  addtoclosure(closure3714, var_s);
  addtoclosure(closure3714, selfslot);
  struct UserObject *uo3714 = (struct UserObject*)block3713;
  uo3714->data[0] = (Object)closure3714;
  Method *meth_meth_collectionsPrelude__apply3714 = addmethod2pos(block3713, "_apply", &meth_collectionsPrelude__apply3714, 0);
  int argcv_meth_collectionsPrelude__apply3714[] = {1};
  meth_meth_collectionsPrelude__apply3714->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3714);
  meth_meth_collectionsPrelude__apply3714->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3714->definitionLine = 1651;
// compiled block node returning block3713 (depth = 3)
  gc_frame_newslot(block3713);
// call case 5: prelude request
  params[0] = opresult3712;
  params[1] = block3713;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3763 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3700);
// compiled call node returning call3763 (depth = 2)
// Begin line 1662
  setline(1662);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3765 == NULL) {
    strlit3765 = alloc_String("""\xe2""""\x9f""""\xad""");
    gc_root(strlit3765);
  }
// compiled string node returning strlit3765 (depth = 3)
  int op_slot_right_3764 = gc_frame_newslot(strlit3765);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_3764 = gc_frame_newslot(*var_s);
  params[0] = strlit3765;
  partcv[0] = 1;
  Object opresult3767 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3767 (depth = 2)
  gc_frame_end(frame);
  return opresult3767;
}
Object meth_collectionsPrelude__apply3784(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1667
  setline(1667);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num3787 = alloc_Float64(0);
// compiled num node returning num3787 (depth = 6)
  int op_slot_right_3786 = gc_frame_newslot(num3787);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_3786 = gc_frame_newslot(*var_i);
  params[0] = num3787;
  partcv[0] = 1;
  Object opresult3789 = callmethod(*var_i, ">", 1, partcv, params);
// compiled op node returning opresult3789 (depth = 5)
  Object if3785 = done;
  if (istrue(opresult3789)) {
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit3791 == NULL) {
    strlit3791 = alloc_String(", ");
    gc_root(strlit3791);
  }
// compiled string node returning strlit3791 (depth = 7)
  int op_slot_right_3790 = gc_frame_newslot(strlit3791);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3790 = gc_frame_newslot(*var_s);
  params[0] = strlit3791;
  partcv[0] = 1;
  Object opresult3793 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3793 (depth = 6)
  *var_s = opresult3793;
  if (opresult3793 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3785 = done;
  } else {
  }
// compiled if node returning if3785 (depth = 4)
// Begin line 1668
  setline(1668);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3795 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3796 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3797 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3796);
// compiled call node returning call3797 (depth = 7)
// compiled member node returning call3797 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call3798 = callmethod(call3797, "at",
    1, partcv, params);
  gc_frame_end(callframe3795);
// compiled call node returning call3798 (depth = 5)
  *var_a = call3798;
  if (call3798 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1669
  setline(1669);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_3801 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_3801 = gc_frame_newslot(*var_removed);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult3803 = callmethod(*var_removed, "≠", 1, partcv, params);
// compiled op node returning opresult3803 (depth = 6)
  int op_slot_right_3800 = gc_frame_newslot(opresult3803);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_3805 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_3805 = gc_frame_newslot(*var_unused);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult3807 = callmethod(*var_unused, "≠", 1, partcv, params);
// compiled op node returning opresult3807 (depth = 6)
  int op_slot_left_3800 = gc_frame_newslot(opresult3807);
  params[0] = opresult3803;
  partcv[0] = 1;
  Object opresult3808 = callmethod(opresult3807, "&&", 1, partcv, params);
// compiled op node returning opresult3808 (depth = 5)
  Object if3799 = done;
  if (istrue(opresult3808)) {
// Begin line 1670
  setline(1670);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3811 == NULL) {
    strlit3811 = alloc_String("");
    gc_root(strlit3811);
  }
// compiled string node returning strlit3811 (depth = 8)
  int op_slot_right_3810 = gc_frame_newslot(strlit3811);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3814 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  partcv[0] = 0;
  Object call3815 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe3814);
// compiled call node returning call3815 (depth = 10)
// compiled member node returning call3815 (depth = 9)
  int op_slot_right_3813 = gc_frame_newslot(call3815);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3818 == NULL) {
    strlit3818 = alloc_String("::");
    gc_root(strlit3818);
  }
// compiled string node returning strlit3818 (depth = 10)
  int op_slot_right_3817 = gc_frame_newslot(strlit3818);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe3821 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_a (depth = 13)
  partcv[0] = 0;
  Object call3822 = callmethod(*var_a, "key",
    1, partcv, params);
  gc_frame_end(callframe3821);
// compiled call node returning call3822 (depth = 12)
// compiled member node returning call3822 (depth = 11)
  int op_slot_right_3820 = gc_frame_newslot(call3822);
// starting to compile op node (depth = 11)
// starting to compile string node (depth = 12)
  if (strlit3825 == NULL) {
    strlit3825 = alloc_String("""\xe2""""\x86""""\x92""");
    gc_root(strlit3825);
  }
// compiled string node returning strlit3825 (depth = 12)
  int op_slot_right_3824 = gc_frame_newslot(strlit3825);
// starting to compile op node (depth = 12)
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_i (depth = 13)
  int op_slot_right_3827 = gc_frame_newslot(*var_i);
// starting to compile string node (depth = 13)
  if (strlit3829 == NULL) {
    strlit3829 = alloc_String("");
    gc_root(strlit3829);
  }
// compiled string node returning strlit3829 (depth = 13)
  int op_slot_left_3827 = gc_frame_newslot(strlit3829);
  params[0] = *var_i;
  partcv[0] = 1;
  Object opresult3830 = callmethod(strlit3829, "++", 1, partcv, params);
// compiled op node returning opresult3830 (depth = 12)
  int op_slot_left_3824 = gc_frame_newslot(opresult3830);
  params[0] = strlit3825;
  partcv[0] = 1;
  Object opresult3831 = callmethod(opresult3830, "++", 1, partcv, params);
// compiled op node returning opresult3831 (depth = 11)
  int op_slot_left_3820 = gc_frame_newslot(opresult3831);
  params[0] = call3822;
  partcv[0] = 1;
  Object opresult3832 = callmethod(opresult3831, "++", 1, partcv, params);
// compiled op node returning opresult3832 (depth = 10)
  int op_slot_left_3817 = gc_frame_newslot(opresult3832);
  params[0] = strlit3818;
  partcv[0] = 1;
  Object opresult3833 = callmethod(opresult3832, "++", 1, partcv, params);
// compiled op node returning opresult3833 (depth = 9)
  int op_slot_left_3813 = gc_frame_newslot(opresult3833);
  params[0] = call3815;
  partcv[0] = 1;
  Object opresult3834 = callmethod(opresult3833, "++", 1, partcv, params);
// compiled op node returning opresult3834 (depth = 8)
  int op_slot_left_3810 = gc_frame_newslot(opresult3834);
  params[0] = strlit3811;
  partcv[0] = 1;
  Object opresult3835 = callmethod(opresult3834, "++", 1, partcv, params);
// compiled op node returning opresult3835 (depth = 7)
  int op_slot_right_3809 = gc_frame_newslot(opresult3835);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3809 = gc_frame_newslot(*var_s);
  params[0] = opresult3835;
  partcv[0] = 1;
  Object opresult3837 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3837 (depth = 6)
  *var_s = opresult3837;
  if (opresult3837 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3799 = done;
  } else {
// Begin line 1672
  setline(1672);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit3841 == NULL) {
    strlit3841 = alloc_String("");
    gc_root(strlit3841);
  }
// compiled string node returning strlit3841 (depth = 8)
  int op_slot_right_3840 = gc_frame_newslot(strlit3841);
// starting to compile op node (depth = 8)
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe3844 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_a (depth = 11)
  partcv[0] = 0;
  Object call3845 = callmethod(*var_a, "asDebugString",
    1, partcv, params);
  gc_frame_end(callframe3844);
// compiled call node returning call3845 (depth = 10)
// compiled member node returning call3845 (depth = 9)
  int op_slot_right_3843 = gc_frame_newslot(call3845);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit3848 == NULL) {
    strlit3848 = alloc_String("""\xe2""""\x86""""\x92""");
    gc_root(strlit3848);
  }
// compiled string node returning strlit3848 (depth = 10)
  int op_slot_right_3847 = gc_frame_newslot(strlit3848);
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_i (depth = 11)
  int op_slot_right_3850 = gc_frame_newslot(*var_i);
// starting to compile string node (depth = 11)
  if (strlit3852 == NULL) {
    strlit3852 = alloc_String("");
    gc_root(strlit3852);
  }
// compiled string node returning strlit3852 (depth = 11)
  int op_slot_left_3850 = gc_frame_newslot(strlit3852);
  params[0] = *var_i;
  partcv[0] = 1;
  Object opresult3853 = callmethod(strlit3852, "++", 1, partcv, params);
// compiled op node returning opresult3853 (depth = 10)
  int op_slot_left_3847 = gc_frame_newslot(opresult3853);
  params[0] = strlit3848;
  partcv[0] = 1;
  Object opresult3854 = callmethod(opresult3853, "++", 1, partcv, params);
// compiled op node returning opresult3854 (depth = 9)
  int op_slot_left_3843 = gc_frame_newslot(opresult3854);
  params[0] = call3845;
  partcv[0] = 1;
  Object opresult3855 = callmethod(opresult3854, "++", 1, partcv, params);
// compiled op node returning opresult3855 (depth = 8)
  int op_slot_left_3840 = gc_frame_newslot(opresult3855);
  params[0] = strlit3841;
  partcv[0] = 1;
  Object opresult3856 = callmethod(opresult3855, "++", 1, partcv, params);
// compiled op node returning opresult3856 (depth = 7)
  int op_slot_right_3839 = gc_frame_newslot(opresult3856);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_3839 = gc_frame_newslot(*var_s);
  params[0] = opresult3856;
  partcv[0] = 1;
  Object opresult3858 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3858 (depth = 6)
  *var_s = opresult3858;
  if (opresult3858 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if3799 = done;
  }
// compiled if node returning if3799 (depth = 4)
  gc_frame_end(frame);
  return if3799;
}
Object meth_collectionsPrelude_asDebugString3768(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 1665
  setline(1665);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3769 == NULL) {
    strlit3769 = alloc_String("dict""\xe2""""\x9f""""\xac""");
    gc_root(strlit3769);
  }
// compiled string node returning strlit3769 (depth = 3)
  *var_s = strlit3769;
  if (strlit3769 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1666
  setline(1666);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3770 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num3773 = alloc_Float64(1);
// compiled num node returning num3773 (depth = 5)
  int op_slot_right_3772 = gc_frame_newslot(num3773);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3775 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe3776 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3777 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3776);
// compiled call node returning call3777 (depth = 8)
// compiled member node returning call3777 (depth = 7)
  partcv[0] = 0;
  Object call3778 = callmethod(call3777, "size",
    1, partcv, params);
  gc_frame_end(callframe3775);
// compiled call node returning call3778 (depth = 6)
// compiled member node returning call3778 (depth = 5)
  int op_slot_left_3772 = gc_frame_newslot(call3778);
  params[0] = num3773;
  partcv[0] = 1;
  Object diff3779 = callmethod(call3778, "-", 1, partcv, params);
// compiled op node returning diff3779 (depth = 4)
  int op_slot_right_3771 = gc_frame_newslot(diff3779);
// starting to compile num node (depth = 4)
  Object num3781 = alloc_Float64(0);
// compiled num node returning num3781 (depth = 4)
  int op_slot_left_3771 = gc_frame_newslot(num3781);
  params[0] = diff3779;
  partcv[0] = 1;
  Object opresult3782 = callmethod(num3781, "..", 1, partcv, params);
// compiled op node returning opresult3782 (depth = 3)
  gc_frame_newslot(opresult3782);
// starting to compile block node (depth = 3)
  Object block3783 = alloc_Block(NULL, NULL, "collectionsPrelude", 1666);
  gc_frame_newslot(block3783);
// method "_apply"
  block_savedest(block3783);
  Object closure3784 = createclosure(4, "_apply");
  setclosureframe(closure3784, stackframe);
  addtoclosure(closure3784, var_s);
  addtoclosure(closure3784, var_removed);
  addtoclosure(closure3784, var_unused);
  addtoclosure(closure3784, selfslot);
  struct UserObject *uo3784 = (struct UserObject*)block3783;
  uo3784->data[0] = (Object)closure3784;
  Method *meth_meth_collectionsPrelude__apply3784 = addmethod2pos(block3783, "_apply", &meth_collectionsPrelude__apply3784, 0);
  int argcv_meth_collectionsPrelude__apply3784[] = {1};
  meth_meth_collectionsPrelude__apply3784->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply3784);
  meth_meth_collectionsPrelude__apply3784->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply3784->definitionLine = 1666;
// compiled block node returning block3783 (depth = 3)
  gc_frame_newslot(block3783);
// call case 5: prelude request
  params[0] = opresult3782;
  params[1] = block3783;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call3861 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3770);
// compiled call node returning call3861 (depth = 2)
// Begin line 1675
  setline(1675);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3863 == NULL) {
    strlit3863 = alloc_String("""\xe2""""\x9f""""\xad""");
    gc_root(strlit3863);
  }
// compiled string node returning strlit3863 (depth = 3)
  int op_slot_right_3862 = gc_frame_newslot(strlit3863);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_s (depth = 3)
  int op_slot_left_3862 = gc_frame_newslot(*var_s);
  params[0] = strlit3863;
  partcv[0] = 1;
  Object opresult3865 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult3865 (depth = 2)
  gc_frame_end(frame);
  return opresult3865;
}
Object meth_collectionsPrelude_hasNext3873(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1683
  setline(1683);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3874 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3875 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3876 = callmethodflags(self, "sourceIterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3875);
// compiled call node returning call3876 (depth = 5)
// compiled member node returning call3876 (depth = 4)
  partcv[0] = 0;
  Object call3877 = callmethod(call3876, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe3874);
// compiled call node returning call3877 (depth = 3)
// compiled member node returning call3877 (depth = 2)
  gc_frame_end(frame);
  return call3877;
}
Object meth_collectionsPrelude_next3878(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1684
  setline(1684);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3879 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3880 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3881 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3882 = callmethodflags(self, "sourceIterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3881);
// compiled call node returning call3882 (depth = 7)
// compiled member node returning call3882 (depth = 6)
  partcv[0] = 0;
  Object call3883 = callmethod(call3882, "next",
    1, partcv, params);
  gc_frame_end(callframe3880);
// compiled call node returning call3883 (depth = 5)
// compiled member node returning call3883 (depth = 4)
  partcv[0] = 0;
  Object call3884 = callmethod(call3883, "key",
    1, partcv, params);
  gc_frame_end(callframe3879);
// compiled call node returning call3884 (depth = 3)
// compiled member node returning call3884 (depth = 2)
  gc_frame_end(frame);
  return call3884;
}
Object meth_collectionsPrelude_asString3885(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1686
  setline(1686);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3887 == NULL) {
    strlit3887 = alloc_String("");
    gc_root(strlit3887);
  }
// compiled string node returning strlit3887 (depth = 3)
  int op_slot_right_3886 = gc_frame_newslot(strlit3887);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  int op_slot_right_3889 = gc_frame_newslot(*var_sourceDictionary);
// starting to compile string node (depth = 4)
  if (strlit3891 == NULL) {
    strlit3891 = alloc_String("an iterator over keys of ");
    gc_root(strlit3891);
  }
// compiled string node returning strlit3891 (depth = 4)
  int op_slot_left_3889 = gc_frame_newslot(strlit3891);
  params[0] = *var_sourceDictionary;
  partcv[0] = 1;
  Object opresult3892 = callmethod(strlit3891, "++", 1, partcv, params);
// compiled op node returning opresult3892 (depth = 3)
  int op_slot_left_3886 = gc_frame_newslot(opresult3892);
  params[0] = strlit3887;
  partcv[0] = 1;
  Object opresult3893 = callmethod(opresult3892, "++", 1, partcv, params);
// compiled op node returning opresult3893 (depth = 2)
  gc_frame_end(frame);
  return opresult3893;
}
Object meth_collectionsPrelude_iterator3869(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3870 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3870 = alloc_userobj2(4,5, objclass3870);
  gc_frame_newslot(obj3870);
if (objclass3870 == NULL) {
  glfree(obj3870->class->name);
  obj3870->class->name = "collectionsPrelude.dictionary.empty.object.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3870, self, 0);
  addmethodreal(obj3870,"outer", &reader_collectionsPrelude_outer_3871);
  Object oldself3870 = self;
  struct StackFrameObject *oldstackframe3870 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3870);
  gc_frame_newslot((Object)stackframe);
  self = obj3870;
  Object *oldselfslot3870 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3870 = (*(struct UserObject *)self).data[0], lowerouter3870 = thisouter3870;
  if (inheritingObject3870) {
    struct UserObject *inho3870 = (struct UserObject *)inheritingObject3870;
    while (inho3870->super != GraceDefaultObject) inho3870 = (struct UserObject *)inho3870->super;
    inho3870->super = obj3870;
    self = inheritingObject3870;
    *selfslot = self;
    lowerouter3870 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3870;
  }
if (objclass3870 == NULL) {
  Method *reader3872 = addmethodrealflags(obj3870, "sourceIterator",&reader_collectionsPrelude_sourceIterator_3872, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader3872->definitionModule = modulename;
  reader3872->definitionLine = 1682;
}
adddatum2(obj3870, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo3873 = (struct UserObject*)obj3870;
  uo3873->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext3873 = addmethod2pos(obj3870, "hasNext", &meth_collectionsPrelude_hasNext3873, 2);
  int argcv_meth_collectionsPrelude_hasNext3873[] = {0};
  meth_meth_collectionsPrelude_hasNext3873->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext3873);
  meth_meth_collectionsPrelude_hasNext3873->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext3873->definitionLine = 1683;
// method "next"
  struct UserObject *uo3878 = (struct UserObject*)obj3870;
  uo3878->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_next3878 = addmethod2pos(obj3870, "next", &meth_collectionsPrelude_next3878, 3);
  int argcv_meth_collectionsPrelude_next3878[] = {0};
  meth_meth_collectionsPrelude_next3878->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next3878);
  meth_meth_collectionsPrelude_next3878->definitionModule = modulename;
  meth_meth_collectionsPrelude_next3878->definitionLine = 1684;
// method "asString"
  block_savedest(obj3870);
  Object closure3885 = createclosure(1, "asString");
  setclosureframe(closure3885, stackframe);
  addtoclosure(closure3885, var_sourceDictionary);
  struct UserObject *uo3885 = (struct UserObject*)obj3870;
  uo3885->data[4] = (Object)closure3885;
  Method *meth_meth_collectionsPrelude_asString3885 = addmethod2pos(obj3870, "asString", &meth_collectionsPrelude_asString3885, 4);
  int argcv_meth_collectionsPrelude_asString3885[] = {0};
  meth_meth_collectionsPrelude_asString3885->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3885);
  meth_meth_collectionsPrelude_asString3885->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3885->definitionLine = 1685;
  sourceObject = obj3870;
// Begin line 1682
  setline(1682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3894 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  partcv[0] = 0;
  Object call3895 = callmethod(*var_sourceDictionary, "bindingsIterator",
    1, partcv, params);
  gc_frame_end(callframe3894);
// compiled call node returning call3895 (depth = 3)
// compiled member node returning call3895 (depth = 2)
  adddatum2(obj3870, call3895, 1);
  sourceObject = obj3870;
  sourceObject = obj3870;
  sourceObject = obj3870;
  objclass3870 = obj3870->class;
  objclass3870->definitionModule = modulename;
  objclass3870->definitionLine = 1681;
  (*(struct UserObject *)self).data[0] = lowerouter3870;
  self = oldself3870;
  selfslot = oldselfslot3870;
  stackframe = oldstackframe3870;
  gc_frame_end(frame);
  return obj3870;
}
Object meth_collectionsPrelude_iterator3869_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3870 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3870 = alloc_userobj2(4,5, objclass3870);
  gc_frame_newslot(obj3870);
if (objclass3870 == NULL) {
  glfree(obj3870->class->name);
  obj3870->class->name = "collectionsPrelude.dictionary.empty.object.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3870, self, 0);
  addmethodreal(obj3870,"outer", &reader_collectionsPrelude_outer_3871);
  Object oldself3870 = self;
  struct StackFrameObject *oldstackframe3870 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3870);
  gc_frame_newslot((Object)stackframe);
  self = obj3870;
  Object *oldselfslot3870 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3870 = (*(struct UserObject *)self).data[0], lowerouter3870 = thisouter3870;
  if (inheritingObject3870) {
    struct UserObject *inho3870 = (struct UserObject *)inheritingObject3870;
    while (inho3870->super != GraceDefaultObject) inho3870 = (struct UserObject *)inho3870->super;
    inho3870->super = obj3870;
    self = inheritingObject3870;
    *selfslot = self;
    lowerouter3870 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3870;
  }
if (objclass3870 == NULL) {
  Method *reader3872 = addmethodrealflags(obj3870, "sourceIterator",&reader_collectionsPrelude_sourceIterator_3872, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader3872->definitionModule = modulename;
  reader3872->definitionLine = 1682;
}
adddatum2(obj3870, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo3873 = (struct UserObject*)obj3870;
  uo3873->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext3873 = addmethod2pos(obj3870, "hasNext", &meth_collectionsPrelude_hasNext3873, 2);
  int argcv_meth_collectionsPrelude_hasNext3873[] = {0};
  meth_meth_collectionsPrelude_hasNext3873->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext3873);
  meth_meth_collectionsPrelude_hasNext3873->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext3873->definitionLine = 1683;
// method "next"
  struct UserObject *uo3878 = (struct UserObject*)obj3870;
  uo3878->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_next3878 = addmethod2pos(obj3870, "next", &meth_collectionsPrelude_next3878, 3);
  int argcv_meth_collectionsPrelude_next3878[] = {0};
  meth_meth_collectionsPrelude_next3878->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next3878);
  meth_meth_collectionsPrelude_next3878->definitionModule = modulename;
  meth_meth_collectionsPrelude_next3878->definitionLine = 1684;
// method "asString"
  block_savedest(obj3870);
  Object closure3885 = createclosure(1, "asString");
  setclosureframe(closure3885, stackframe);
  addtoclosure(closure3885, var_sourceDictionary);
  struct UserObject *uo3885 = (struct UserObject*)obj3870;
  uo3885->data[4] = (Object)closure3885;
  Method *meth_meth_collectionsPrelude_asString3885 = addmethod2pos(obj3870, "asString", &meth_collectionsPrelude_asString3885, 4);
  int argcv_meth_collectionsPrelude_asString3885[] = {0};
  meth_meth_collectionsPrelude_asString3885->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3885);
  meth_meth_collectionsPrelude_asString3885->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3885->definitionLine = 1685;
  sourceObject = obj3870;
// Begin line 1682
  setline(1682);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3894 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  partcv[0] = 0;
  Object call3895 = callmethod(*var_sourceDictionary, "bindingsIterator",
    1, partcv, params);
  gc_frame_end(callframe3894);
// compiled call node returning call3895 (depth = 3)
// compiled member node returning call3895 (depth = 2)
  adddatum2(obj3870, call3895, 1);
  sourceObject = obj3870;
  sourceObject = obj3870;
  sourceObject = obj3870;
  objclass3870 = obj3870->class;
  objclass3870->definitionModule = modulename;
  objclass3870->definitionLine = 1681;
  (*(struct UserObject *)self).data[0] = lowerouter3870;
  self = oldself3870;
  selfslot = oldselfslot3870;
  stackframe = oldstackframe3870;
  gc_frame_end(frame);
  return obj3870;
}
Object meth_collectionsPrelude_asDebugString3898(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1691
  setline(1691);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3900 == NULL) {
    strlit3900 = alloc_String("");
    gc_root(strlit3900);
  }
// compiled string node returning strlit3900 (depth = 3)
  int op_slot_right_3899 = gc_frame_newslot(strlit3900);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  int op_slot_right_3902 = gc_frame_newslot(*var_sourceDictionary);
// starting to compile string node (depth = 4)
  if (strlit3904 == NULL) {
    strlit3904 = alloc_String("a lazy sequence over keys of ");
    gc_root(strlit3904);
  }
// compiled string node returning strlit3904 (depth = 4)
  int op_slot_left_3902 = gc_frame_newslot(strlit3904);
  params[0] = *var_sourceDictionary;
  partcv[0] = 1;
  Object opresult3905 = callmethod(strlit3904, "++", 1, partcv, params);
// compiled op node returning opresult3905 (depth = 3)
  int op_slot_left_3899 = gc_frame_newslot(opresult3905);
  params[0] = strlit3900;
  partcv[0] = 1;
  Object opresult3906 = callmethod(opresult3905, "++", 1, partcv, params);
// compiled op node returning opresult3906 (depth = 2)
  gc_frame_end(frame);
  return opresult3906;
}
Object meth_collectionsPrelude_keys3866(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keys (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for keys");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1678
  setline(1678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3867 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3867 = alloc_userobj2(4,5, objclass3867);
  gc_frame_newslot(obj3867);
if (objclass3867 == NULL) {
  glfree(obj3867->class->name);
  obj3867->class->name = "collectionsPrelude.dictionary.empty.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3867, self, 0);
  addmethodreal(obj3867,"outer", &reader_collectionsPrelude_outer_3868);
  Object oldself3867 = self;
  struct StackFrameObject *oldstackframe3867 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3867);
  gc_frame_newslot((Object)stackframe);
  self = obj3867;
  Object *oldselfslot3867 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3867 = (*(struct UserObject *)self).data[0], lowerouter3867 = thisouter3867;
  if (inheritingObject3867) {
    struct UserObject *inho3867 = (struct UserObject *)inheritingObject3867;
    while (inho3867->super != GraceDefaultObject) inho3867 = (struct UserObject *)inho3867->super;
    inho3867->super = obj3867;
    self = inheritingObject3867;
    *selfslot = self;
    lowerouter3867 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3867;
  }
// method "iterator"
  block_savedest(obj3867);
  Object closure3869 = createclosure(1, "iterator");
  setclosureframe(closure3869, stackframe);
  addtoclosure(closure3869, var_sourceDictionary);
  struct UserObject *uo3869 = (struct UserObject*)obj3867;
  uo3869->data[1] = (Object)closure3869;
  Method *meth_meth_collectionsPrelude_iterator3869 = addmethod2pos(obj3867, "iterator", &meth_collectionsPrelude_iterator3869, 1);
  int argcv_meth_collectionsPrelude_iterator3869[] = {0};
  meth_meth_collectionsPrelude_iterator3869->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator3869);
  meth_meth_collectionsPrelude_iterator3869->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3869->definitionLine = 1681;
  block_savedest(obj3867);
  Object closure3896 = createclosure(1, "iterator()object");
  setclosureframe(closure3896, stackframe);
  addtoclosure(closure3896, var_sourceDictionary);
  Method *meth_meth_collectionsPrelude_iterator3869_object = addmethod2pos(obj3867, "iterator()object", &meth_collectionsPrelude_iterator3869_object, 1);
  meth_meth_collectionsPrelude_iterator3869_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3869_object->definitionLine = 1681;
if (objclass3867 == NULL) {
  Method *reader3897 = addmethodrealflags(obj3867, "size",&reader_collectionsPrelude_size_3897, MFLAG_DEF);
  reader3897->definitionModule = modulename;
  reader3897->definitionLine = 1689;
}
adddatum2(obj3867, alloc_Undefined(), 2);
// method "asDebugString"
  block_savedest(obj3867);
  Object closure3898 = createclosure(1, "asDebugString");
  setclosureframe(closure3898, stackframe);
  addtoclosure(closure3898, var_sourceDictionary);
  struct UserObject *uo3898 = (struct UserObject*)obj3867;
  uo3898->data[3] = (Object)closure3898;
  Method *meth_meth_collectionsPrelude_asDebugString3898 = addmethod2pos(obj3867, "asDebugString", &meth_collectionsPrelude_asDebugString3898, 3);
  int argcv_meth_collectionsPrelude_asDebugString3898[] = {0};
  meth_meth_collectionsPrelude_asDebugString3898->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3898);
  meth_meth_collectionsPrelude_asDebugString3898->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3898->definitionLine = 1690;
  sourceObject = obj3867;
// Begin line 1680
  setline(1680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3907 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3908 = callmethod(*var_enumerable, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe3907);
// compiled call node returning call3908 (depth = 2)
  struct UserObject *obj3867_uo = (struct UserObject *)obj3867;
  obj3867_uo->super = call3908;
  sourceObject = obj3867;
  sourceObject = obj3867;
// Begin line 1689
  setline(1689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3909 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  partcv[0] = 0;
  Object call3910 = callmethod(*var_sourceDictionary, "size",
    1, partcv, params);
  gc_frame_end(callframe3909);
// compiled call node returning call3910 (depth = 3)
// compiled member node returning call3910 (depth = 2)
  adddatum2(obj3867, call3910, 2);
  sourceObject = obj3867;
  objclass3867 = obj3867->class;
  objclass3867->definitionModule = modulename;
  objclass3867->definitionLine = 1679;
  (*(struct UserObject *)self).data[0] = lowerouter3867;
  self = oldself3867;
  selfslot = oldselfslot3867;
  stackframe = oldstackframe3867;
  gc_frame_end(frame);
  return obj3867;
}
Object meth_collectionsPrelude_keys3866_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "keys()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keys (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for keys");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1678
  setline(1678);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3867 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3867 = alloc_userobj2(4,5, objclass3867);
  gc_frame_newslot(obj3867);
if (objclass3867 == NULL) {
  glfree(obj3867->class->name);
  obj3867->class->name = "collectionsPrelude.dictionary.empty.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3867, self, 0);
  addmethodreal(obj3867,"outer", &reader_collectionsPrelude_outer_3868);
  Object oldself3867 = self;
  struct StackFrameObject *oldstackframe3867 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3867);
  gc_frame_newslot((Object)stackframe);
  self = obj3867;
  Object *oldselfslot3867 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3867 = (*(struct UserObject *)self).data[0], lowerouter3867 = thisouter3867;
  if (inheritingObject3867) {
    struct UserObject *inho3867 = (struct UserObject *)inheritingObject3867;
    while (inho3867->super != GraceDefaultObject) inho3867 = (struct UserObject *)inho3867->super;
    inho3867->super = obj3867;
    self = inheritingObject3867;
    *selfslot = self;
    lowerouter3867 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3867;
  }
// method "iterator"
  block_savedest(obj3867);
  Object closure3869 = createclosure(1, "iterator");
  setclosureframe(closure3869, stackframe);
  addtoclosure(closure3869, var_sourceDictionary);
  struct UserObject *uo3869 = (struct UserObject*)obj3867;
  uo3869->data[1] = (Object)closure3869;
  Method *meth_meth_collectionsPrelude_iterator3869 = addmethod2pos(obj3867, "iterator", &meth_collectionsPrelude_iterator3869, 1);
  int argcv_meth_collectionsPrelude_iterator3869[] = {0};
  meth_meth_collectionsPrelude_iterator3869->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator3869);
  meth_meth_collectionsPrelude_iterator3869->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3869->definitionLine = 1681;
  block_savedest(obj3867);
  Object closure3896 = createclosure(1, "iterator()object");
  setclosureframe(closure3896, stackframe);
  addtoclosure(closure3896, var_sourceDictionary);
  Method *meth_meth_collectionsPrelude_iterator3869_object = addmethod2pos(obj3867, "iterator()object", &meth_collectionsPrelude_iterator3869_object, 1);
  meth_meth_collectionsPrelude_iterator3869_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3869_object->definitionLine = 1681;
if (objclass3867 == NULL) {
  Method *reader3897 = addmethodrealflags(obj3867, "size",&reader_collectionsPrelude_size_3897, MFLAG_DEF);
  reader3897->definitionModule = modulename;
  reader3897->definitionLine = 1689;
}
adddatum2(obj3867, alloc_Undefined(), 2);
// method "asDebugString"
  block_savedest(obj3867);
  Object closure3898 = createclosure(1, "asDebugString");
  setclosureframe(closure3898, stackframe);
  addtoclosure(closure3898, var_sourceDictionary);
  struct UserObject *uo3898 = (struct UserObject*)obj3867;
  uo3898->data[3] = (Object)closure3898;
  Method *meth_meth_collectionsPrelude_asDebugString3898 = addmethod2pos(obj3867, "asDebugString", &meth_collectionsPrelude_asDebugString3898, 3);
  int argcv_meth_collectionsPrelude_asDebugString3898[] = {0};
  meth_meth_collectionsPrelude_asDebugString3898->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3898);
  meth_meth_collectionsPrelude_asDebugString3898->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3898->definitionLine = 1690;
  sourceObject = obj3867;
// Begin line 1680
  setline(1680);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3907 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3908 = callmethod(*var_enumerable, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe3907);
// compiled call node returning call3908 (depth = 2)
  struct UserObject *obj3867_uo = (struct UserObject *)obj3867;
  obj3867_uo->super = call3908;
  sourceObject = obj3867;
  sourceObject = obj3867;
// Begin line 1689
  setline(1689);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3909 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  partcv[0] = 0;
  Object call3910 = callmethod(*var_sourceDictionary, "size",
    1, partcv, params);
  gc_frame_end(callframe3909);
// compiled call node returning call3910 (depth = 3)
// compiled member node returning call3910 (depth = 2)
  adddatum2(obj3867, call3910, 2);
  sourceObject = obj3867;
  objclass3867 = obj3867->class;
  objclass3867->definitionModule = modulename;
  objclass3867->definitionLine = 1679;
  (*(struct UserObject *)self).data[0] = lowerouter3867;
  self = oldself3867;
  selfslot = oldselfslot3867;
  stackframe = oldstackframe3867;
  gc_frame_end(frame);
  return obj3867;
}
Object meth_collectionsPrelude_hasNext3919(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1702
  setline(1702);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3920 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3921 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3922 = callmethodflags(self, "sourceIterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3921);
// compiled call node returning call3922 (depth = 5)
// compiled member node returning call3922 (depth = 4)
  partcv[0] = 0;
  Object call3923 = callmethod(call3922, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe3920);
// compiled call node returning call3923 (depth = 3)
// compiled member node returning call3923 (depth = 2)
  gc_frame_end(frame);
  return call3923;
}
Object meth_collectionsPrelude_next3924(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1703
  setline(1703);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3925 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3926 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe3927 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3928 = callmethodflags(self, "sourceIterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3927);
// compiled call node returning call3928 (depth = 7)
// compiled member node returning call3928 (depth = 6)
  partcv[0] = 0;
  Object call3929 = callmethod(call3928, "next",
    1, partcv, params);
  gc_frame_end(callframe3926);
// compiled call node returning call3929 (depth = 5)
// compiled member node returning call3929 (depth = 4)
  partcv[0] = 0;
  Object call3930 = callmethod(call3929, "value",
    1, partcv, params);
  gc_frame_end(callframe3925);
// compiled call node returning call3930 (depth = 3)
// compiled member node returning call3930 (depth = 2)
  gc_frame_end(frame);
  return call3930;
}
Object meth_collectionsPrelude_asString3931(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1705
  setline(1705);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3933 == NULL) {
    strlit3933 = alloc_String("");
    gc_root(strlit3933);
  }
// compiled string node returning strlit3933 (depth = 3)
  int op_slot_right_3932 = gc_frame_newslot(strlit3933);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  int op_slot_right_3935 = gc_frame_newslot(*var_sourceDictionary);
// starting to compile string node (depth = 4)
  if (strlit3937 == NULL) {
    strlit3937 = alloc_String("an iterator over values of ");
    gc_root(strlit3937);
  }
// compiled string node returning strlit3937 (depth = 4)
  int op_slot_left_3935 = gc_frame_newslot(strlit3937);
  params[0] = *var_sourceDictionary;
  partcv[0] = 1;
  Object opresult3938 = callmethod(strlit3937, "++", 1, partcv, params);
// compiled op node returning opresult3938 (depth = 3)
  int op_slot_left_3932 = gc_frame_newslot(opresult3938);
  params[0] = strlit3933;
  partcv[0] = 1;
  Object opresult3939 = callmethod(opresult3938, "++", 1, partcv, params);
// compiled op node returning opresult3939 (depth = 2)
  gc_frame_end(frame);
  return opresult3939;
}
Object meth_collectionsPrelude_iterator3915(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3916 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3916 = alloc_userobj2(4,5, objclass3916);
  gc_frame_newslot(obj3916);
if (objclass3916 == NULL) {
  glfree(obj3916->class->name);
  obj3916->class->name = "collectionsPrelude.dictionary.empty.object.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3916, self, 0);
  addmethodreal(obj3916,"outer", &reader_collectionsPrelude_outer_3917);
  Object oldself3916 = self;
  struct StackFrameObject *oldstackframe3916 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3916);
  gc_frame_newslot((Object)stackframe);
  self = obj3916;
  Object *oldselfslot3916 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3916 = (*(struct UserObject *)self).data[0], lowerouter3916 = thisouter3916;
  if (inheritingObject3916) {
    struct UserObject *inho3916 = (struct UserObject *)inheritingObject3916;
    while (inho3916->super != GraceDefaultObject) inho3916 = (struct UserObject *)inho3916->super;
    inho3916->super = obj3916;
    self = inheritingObject3916;
    *selfslot = self;
    lowerouter3916 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3916;
  }
if (objclass3916 == NULL) {
  Method *reader3918 = addmethodrealflags(obj3916, "sourceIterator",&reader_collectionsPrelude_sourceIterator_3918, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader3918->definitionModule = modulename;
  reader3918->definitionLine = 1700;
}
adddatum2(obj3916, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo3919 = (struct UserObject*)obj3916;
  uo3919->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext3919 = addmethod2pos(obj3916, "hasNext", &meth_collectionsPrelude_hasNext3919, 2);
  int argcv_meth_collectionsPrelude_hasNext3919[] = {0};
  meth_meth_collectionsPrelude_hasNext3919->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext3919);
  meth_meth_collectionsPrelude_hasNext3919->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext3919->definitionLine = 1702;
// method "next"
  struct UserObject *uo3924 = (struct UserObject*)obj3916;
  uo3924->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_next3924 = addmethod2pos(obj3916, "next", &meth_collectionsPrelude_next3924, 3);
  int argcv_meth_collectionsPrelude_next3924[] = {0};
  meth_meth_collectionsPrelude_next3924->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next3924);
  meth_meth_collectionsPrelude_next3924->definitionModule = modulename;
  meth_meth_collectionsPrelude_next3924->definitionLine = 1703;
// method "asString"
  block_savedest(obj3916);
  Object closure3931 = createclosure(1, "asString");
  setclosureframe(closure3931, stackframe);
  addtoclosure(closure3931, var_sourceDictionary);
  struct UserObject *uo3931 = (struct UserObject*)obj3916;
  uo3931->data[4] = (Object)closure3931;
  Method *meth_meth_collectionsPrelude_asString3931 = addmethod2pos(obj3916, "asString", &meth_collectionsPrelude_asString3931, 4);
  int argcv_meth_collectionsPrelude_asString3931[] = {0};
  meth_meth_collectionsPrelude_asString3931->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3931);
  meth_meth_collectionsPrelude_asString3931->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3931->definitionLine = 1704;
  sourceObject = obj3916;
// Begin line 1700
  setline(1700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3940 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  partcv[0] = 0;
  Object call3941 = callmethod(*var_sourceDictionary, "bindingsIterator",
    1, partcv, params);
  gc_frame_end(callframe3940);
// compiled call node returning call3941 (depth = 3)
// compiled member node returning call3941 (depth = 2)
  adddatum2(obj3916, call3941, 1);
  sourceObject = obj3916;
  sourceObject = obj3916;
  sourceObject = obj3916;
  objclass3916 = obj3916->class;
  objclass3916->definitionModule = modulename;
  objclass3916->definitionLine = 1699;
  (*(struct UserObject *)self).data[0] = lowerouter3916;
  self = oldself3916;
  selfslot = oldselfslot3916;
  stackframe = oldstackframe3916;
  gc_frame_end(frame);
  return obj3916;
}
Object meth_collectionsPrelude_iterator3915_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3916 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3916 = alloc_userobj2(4,5, objclass3916);
  gc_frame_newslot(obj3916);
if (objclass3916 == NULL) {
  glfree(obj3916->class->name);
  obj3916->class->name = "collectionsPrelude.dictionary.empty.object.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3916, self, 0);
  addmethodreal(obj3916,"outer", &reader_collectionsPrelude_outer_3917);
  Object oldself3916 = self;
  struct StackFrameObject *oldstackframe3916 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3916);
  gc_frame_newslot((Object)stackframe);
  self = obj3916;
  Object *oldselfslot3916 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3916 = (*(struct UserObject *)self).data[0], lowerouter3916 = thisouter3916;
  if (inheritingObject3916) {
    struct UserObject *inho3916 = (struct UserObject *)inheritingObject3916;
    while (inho3916->super != GraceDefaultObject) inho3916 = (struct UserObject *)inho3916->super;
    inho3916->super = obj3916;
    self = inheritingObject3916;
    *selfslot = self;
    lowerouter3916 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3916;
  }
if (objclass3916 == NULL) {
  Method *reader3918 = addmethodrealflags(obj3916, "sourceIterator",&reader_collectionsPrelude_sourceIterator_3918, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader3918->definitionModule = modulename;
  reader3918->definitionLine = 1700;
}
adddatum2(obj3916, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo3919 = (struct UserObject*)obj3916;
  uo3919->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext3919 = addmethod2pos(obj3916, "hasNext", &meth_collectionsPrelude_hasNext3919, 2);
  int argcv_meth_collectionsPrelude_hasNext3919[] = {0};
  meth_meth_collectionsPrelude_hasNext3919->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext3919);
  meth_meth_collectionsPrelude_hasNext3919->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext3919->definitionLine = 1702;
// method "next"
  struct UserObject *uo3924 = (struct UserObject*)obj3916;
  uo3924->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_next3924 = addmethod2pos(obj3916, "next", &meth_collectionsPrelude_next3924, 3);
  int argcv_meth_collectionsPrelude_next3924[] = {0};
  meth_meth_collectionsPrelude_next3924->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next3924);
  meth_meth_collectionsPrelude_next3924->definitionModule = modulename;
  meth_meth_collectionsPrelude_next3924->definitionLine = 1703;
// method "asString"
  block_savedest(obj3916);
  Object closure3931 = createclosure(1, "asString");
  setclosureframe(closure3931, stackframe);
  addtoclosure(closure3931, var_sourceDictionary);
  struct UserObject *uo3931 = (struct UserObject*)obj3916;
  uo3931->data[4] = (Object)closure3931;
  Method *meth_meth_collectionsPrelude_asString3931 = addmethod2pos(obj3916, "asString", &meth_collectionsPrelude_asString3931, 4);
  int argcv_meth_collectionsPrelude_asString3931[] = {0};
  meth_meth_collectionsPrelude_asString3931->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3931);
  meth_meth_collectionsPrelude_asString3931->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3931->definitionLine = 1704;
  sourceObject = obj3916;
// Begin line 1700
  setline(1700);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3940 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  partcv[0] = 0;
  Object call3941 = callmethod(*var_sourceDictionary, "bindingsIterator",
    1, partcv, params);
  gc_frame_end(callframe3940);
// compiled call node returning call3941 (depth = 3)
// compiled member node returning call3941 (depth = 2)
  adddatum2(obj3916, call3941, 1);
  sourceObject = obj3916;
  sourceObject = obj3916;
  sourceObject = obj3916;
  objclass3916 = obj3916->class;
  objclass3916->definitionModule = modulename;
  objclass3916->definitionLine = 1699;
  (*(struct UserObject *)self).data[0] = lowerouter3916;
  self = oldself3916;
  selfslot = oldselfslot3916;
  stackframe = oldstackframe3916;
  gc_frame_end(frame);
  return obj3916;
}
Object meth_collectionsPrelude_asDebugString3944(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1710
  setline(1710);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3946 == NULL) {
    strlit3946 = alloc_String("");
    gc_root(strlit3946);
  }
// compiled string node returning strlit3946 (depth = 3)
  int op_slot_right_3945 = gc_frame_newslot(strlit3946);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  int op_slot_right_3948 = gc_frame_newslot(*var_sourceDictionary);
// starting to compile string node (depth = 4)
  if (strlit3950 == NULL) {
    strlit3950 = alloc_String("a lazy sequence over values of ");
    gc_root(strlit3950);
  }
// compiled string node returning strlit3950 (depth = 4)
  int op_slot_left_3948 = gc_frame_newslot(strlit3950);
  params[0] = *var_sourceDictionary;
  partcv[0] = 1;
  Object opresult3951 = callmethod(strlit3950, "++", 1, partcv, params);
// compiled op node returning opresult3951 (depth = 3)
  int op_slot_left_3945 = gc_frame_newslot(opresult3951);
  params[0] = strlit3946;
  partcv[0] = 1;
  Object opresult3952 = callmethod(opresult3951, "++", 1, partcv, params);
// compiled op node returning opresult3952 (depth = 2)
  gc_frame_end(frame);
  return opresult3952;
}
Object meth_collectionsPrelude_values3912(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for values (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for values");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1696
  setline(1696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3913 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3913 = alloc_userobj2(4,5, objclass3913);
  gc_frame_newslot(obj3913);
if (objclass3913 == NULL) {
  glfree(obj3913->class->name);
  obj3913->class->name = "collectionsPrelude.dictionary.empty.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3913, self, 0);
  addmethodreal(obj3913,"outer", &reader_collectionsPrelude_outer_3914);
  Object oldself3913 = self;
  struct StackFrameObject *oldstackframe3913 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3913);
  gc_frame_newslot((Object)stackframe);
  self = obj3913;
  Object *oldselfslot3913 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3913 = (*(struct UserObject *)self).data[0], lowerouter3913 = thisouter3913;
  if (inheritingObject3913) {
    struct UserObject *inho3913 = (struct UserObject *)inheritingObject3913;
    while (inho3913->super != GraceDefaultObject) inho3913 = (struct UserObject *)inho3913->super;
    inho3913->super = obj3913;
    self = inheritingObject3913;
    *selfslot = self;
    lowerouter3913 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3913;
  }
// method "iterator"
  block_savedest(obj3913);
  Object closure3915 = createclosure(1, "iterator");
  setclosureframe(closure3915, stackframe);
  addtoclosure(closure3915, var_sourceDictionary);
  struct UserObject *uo3915 = (struct UserObject*)obj3913;
  uo3915->data[1] = (Object)closure3915;
  Method *meth_meth_collectionsPrelude_iterator3915 = addmethod2pos(obj3913, "iterator", &meth_collectionsPrelude_iterator3915, 1);
  int argcv_meth_collectionsPrelude_iterator3915[] = {0};
  meth_meth_collectionsPrelude_iterator3915->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator3915);
  meth_meth_collectionsPrelude_iterator3915->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3915->definitionLine = 1699;
  block_savedest(obj3913);
  Object closure3942 = createclosure(1, "iterator()object");
  setclosureframe(closure3942, stackframe);
  addtoclosure(closure3942, var_sourceDictionary);
  Method *meth_meth_collectionsPrelude_iterator3915_object = addmethod2pos(obj3913, "iterator()object", &meth_collectionsPrelude_iterator3915_object, 1);
  meth_meth_collectionsPrelude_iterator3915_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3915_object->definitionLine = 1699;
if (objclass3913 == NULL) {
  Method *reader3943 = addmethodrealflags(obj3913, "size",&reader_collectionsPrelude_size_3943, MFLAG_DEF);
  reader3943->definitionModule = modulename;
  reader3943->definitionLine = 1708;
}
adddatum2(obj3913, alloc_Undefined(), 2);
// method "asDebugString"
  block_savedest(obj3913);
  Object closure3944 = createclosure(1, "asDebugString");
  setclosureframe(closure3944, stackframe);
  addtoclosure(closure3944, var_sourceDictionary);
  struct UserObject *uo3944 = (struct UserObject*)obj3913;
  uo3944->data[3] = (Object)closure3944;
  Method *meth_meth_collectionsPrelude_asDebugString3944 = addmethod2pos(obj3913, "asDebugString", &meth_collectionsPrelude_asDebugString3944, 3);
  int argcv_meth_collectionsPrelude_asDebugString3944[] = {0};
  meth_meth_collectionsPrelude_asDebugString3944->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3944);
  meth_meth_collectionsPrelude_asDebugString3944->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3944->definitionLine = 1709;
  sourceObject = obj3913;
// Begin line 1698
  setline(1698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3953 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3954 = callmethod(*var_enumerable, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe3953);
// compiled call node returning call3954 (depth = 2)
  struct UserObject *obj3913_uo = (struct UserObject *)obj3913;
  obj3913_uo->super = call3954;
  sourceObject = obj3913;
  sourceObject = obj3913;
// Begin line 1708
  setline(1708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3955 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  partcv[0] = 0;
  Object call3956 = callmethod(*var_sourceDictionary, "size",
    1, partcv, params);
  gc_frame_end(callframe3955);
// compiled call node returning call3956 (depth = 3)
// compiled member node returning call3956 (depth = 2)
  adddatum2(obj3913, call3956, 2);
  sourceObject = obj3913;
  objclass3913 = obj3913->class;
  objclass3913->definitionModule = modulename;
  objclass3913->definitionLine = 1697;
  (*(struct UserObject *)self).data[0] = lowerouter3913;
  self = oldself3913;
  selfslot = oldselfslot3913;
  stackframe = oldstackframe3913;
  gc_frame_end(frame);
  return obj3913;
}
Object meth_collectionsPrelude_values3912_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "values()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for values (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for values");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1696
  setline(1696);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3913 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3913 = alloc_userobj2(4,5, objclass3913);
  gc_frame_newslot(obj3913);
if (objclass3913 == NULL) {
  glfree(obj3913->class->name);
  obj3913->class->name = "collectionsPrelude.dictionary.empty.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3913, self, 0);
  addmethodreal(obj3913,"outer", &reader_collectionsPrelude_outer_3914);
  Object oldself3913 = self;
  struct StackFrameObject *oldstackframe3913 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3913);
  gc_frame_newslot((Object)stackframe);
  self = obj3913;
  Object *oldselfslot3913 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3913 = (*(struct UserObject *)self).data[0], lowerouter3913 = thisouter3913;
  if (inheritingObject3913) {
    struct UserObject *inho3913 = (struct UserObject *)inheritingObject3913;
    while (inho3913->super != GraceDefaultObject) inho3913 = (struct UserObject *)inho3913->super;
    inho3913->super = obj3913;
    self = inheritingObject3913;
    *selfslot = self;
    lowerouter3913 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3913;
  }
// method "iterator"
  block_savedest(obj3913);
  Object closure3915 = createclosure(1, "iterator");
  setclosureframe(closure3915, stackframe);
  addtoclosure(closure3915, var_sourceDictionary);
  struct UserObject *uo3915 = (struct UserObject*)obj3913;
  uo3915->data[1] = (Object)closure3915;
  Method *meth_meth_collectionsPrelude_iterator3915 = addmethod2pos(obj3913, "iterator", &meth_collectionsPrelude_iterator3915, 1);
  int argcv_meth_collectionsPrelude_iterator3915[] = {0};
  meth_meth_collectionsPrelude_iterator3915->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator3915);
  meth_meth_collectionsPrelude_iterator3915->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3915->definitionLine = 1699;
  block_savedest(obj3913);
  Object closure3942 = createclosure(1, "iterator()object");
  setclosureframe(closure3942, stackframe);
  addtoclosure(closure3942, var_sourceDictionary);
  Method *meth_meth_collectionsPrelude_iterator3915_object = addmethod2pos(obj3913, "iterator()object", &meth_collectionsPrelude_iterator3915_object, 1);
  meth_meth_collectionsPrelude_iterator3915_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3915_object->definitionLine = 1699;
if (objclass3913 == NULL) {
  Method *reader3943 = addmethodrealflags(obj3913, "size",&reader_collectionsPrelude_size_3943, MFLAG_DEF);
  reader3943->definitionModule = modulename;
  reader3943->definitionLine = 1708;
}
adddatum2(obj3913, alloc_Undefined(), 2);
// method "asDebugString"
  block_savedest(obj3913);
  Object closure3944 = createclosure(1, "asDebugString");
  setclosureframe(closure3944, stackframe);
  addtoclosure(closure3944, var_sourceDictionary);
  struct UserObject *uo3944 = (struct UserObject*)obj3913;
  uo3944->data[3] = (Object)closure3944;
  Method *meth_meth_collectionsPrelude_asDebugString3944 = addmethod2pos(obj3913, "asDebugString", &meth_collectionsPrelude_asDebugString3944, 3);
  int argcv_meth_collectionsPrelude_asDebugString3944[] = {0};
  meth_meth_collectionsPrelude_asDebugString3944->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3944);
  meth_meth_collectionsPrelude_asDebugString3944->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3944->definitionLine = 1709;
  sourceObject = obj3913;
// Begin line 1698
  setline(1698);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3953 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3954 = callmethod(*var_enumerable, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe3953);
// compiled call node returning call3954 (depth = 2)
  struct UserObject *obj3913_uo = (struct UserObject *)obj3913;
  obj3913_uo->super = call3954;
  sourceObject = obj3913;
  sourceObject = obj3913;
// Begin line 1708
  setline(1708);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3955 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  partcv[0] = 0;
  Object call3956 = callmethod(*var_sourceDictionary, "size",
    1, partcv, params);
  gc_frame_end(callframe3955);
// compiled call node returning call3956 (depth = 3)
// compiled member node returning call3956 (depth = 2)
  adddatum2(obj3913, call3956, 2);
  sourceObject = obj3913;
  objclass3913 = obj3913->class;
  objclass3913->definitionModule = modulename;
  objclass3913->definitionLine = 1697;
  (*(struct UserObject *)self).data[0] = lowerouter3913;
  self = oldself3913;
  selfslot = oldselfslot3913;
  stackframe = oldstackframe3913;
  gc_frame_end(frame);
  return obj3913;
}
Object meth_collectionsPrelude_iterator3961(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1718
  setline(1718);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3962 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  partcv[0] = 0;
  Object call3963 = callmethod(*var_sourceDictionary, "bindingsIterator",
    1, partcv, params);
  gc_frame_end(callframe3962);
// compiled call node returning call3963 (depth = 3)
// compiled member node returning call3963 (depth = 2)
  gc_frame_end(frame);
  return call3963;
}
Object meth_collectionsPrelude_asDebugString3965(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asDebugString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sourceDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asDebugString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asDebugString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1722
  setline(1722);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit3967 == NULL) {
    strlit3967 = alloc_String("");
    gc_root(strlit3967);
  }
// compiled string node returning strlit3967 (depth = 3)
  int op_slot_right_3966 = gc_frame_newslot(strlit3967);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  int op_slot_right_3969 = gc_frame_newslot(*var_sourceDictionary);
// starting to compile string node (depth = 4)
  if (strlit3971 == NULL) {
    strlit3971 = alloc_String("a lazy sequence over bindings of ");
    gc_root(strlit3971);
  }
// compiled string node returning strlit3971 (depth = 4)
  int op_slot_left_3969 = gc_frame_newslot(strlit3971);
  params[0] = *var_sourceDictionary;
  partcv[0] = 1;
  Object opresult3972 = callmethod(strlit3971, "++", 1, partcv, params);
// compiled op node returning opresult3972 (depth = 3)
  int op_slot_left_3966 = gc_frame_newslot(opresult3972);
  params[0] = strlit3967;
  partcv[0] = 1;
  Object opresult3973 = callmethod(opresult3972, "++", 1, partcv, params);
// compiled op node returning opresult3973 (depth = 2)
  gc_frame_end(frame);
  return opresult3973;
}
Object meth_collectionsPrelude_bindings3958(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindings");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for bindings (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for bindings");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1715
  setline(1715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3959 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3959 = alloc_userobj2(3,4, objclass3959);
  gc_frame_newslot(obj3959);
if (objclass3959 == NULL) {
  glfree(obj3959->class->name);
  obj3959->class->name = "collectionsPrelude.dictionary.empty.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3959, self, 0);
  addmethodreal(obj3959,"outer", &reader_collectionsPrelude_outer_3960);
  Object oldself3959 = self;
  struct StackFrameObject *oldstackframe3959 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3959);
  gc_frame_newslot((Object)stackframe);
  self = obj3959;
  Object *oldselfslot3959 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3959 = (*(struct UserObject *)self).data[0], lowerouter3959 = thisouter3959;
  if (inheritingObject3959) {
    struct UserObject *inho3959 = (struct UserObject *)inheritingObject3959;
    while (inho3959->super != GraceDefaultObject) inho3959 = (struct UserObject *)inho3959->super;
    inho3959->super = obj3959;
    self = inheritingObject3959;
    *selfslot = self;
    lowerouter3959 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3959;
  }
// method "iterator"
  block_savedest(obj3959);
  Object closure3961 = createclosure(1, "iterator");
  setclosureframe(closure3961, stackframe);
  addtoclosure(closure3961, var_sourceDictionary);
  struct UserObject *uo3961 = (struct UserObject*)obj3959;
  uo3961->data[1] = (Object)closure3961;
  Method *meth_meth_collectionsPrelude_iterator3961 = addmethod2pos(obj3959, "iterator", &meth_collectionsPrelude_iterator3961, 1);
  int argcv_meth_collectionsPrelude_iterator3961[] = {0};
  meth_meth_collectionsPrelude_iterator3961->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator3961);
  meth_meth_collectionsPrelude_iterator3961->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3961->definitionLine = 1718;
if (objclass3959 == NULL) {
  Method *reader3964 = addmethodrealflags(obj3959, "size",&reader_collectionsPrelude_size_3964, MFLAG_DEF);
  reader3964->definitionModule = modulename;
  reader3964->definitionLine = 1720;
}
adddatum2(obj3959, alloc_Undefined(), 2);
// method "asDebugString"
  block_savedest(obj3959);
  Object closure3965 = createclosure(1, "asDebugString");
  setclosureframe(closure3965, stackframe);
  addtoclosure(closure3965, var_sourceDictionary);
  struct UserObject *uo3965 = (struct UserObject*)obj3959;
  uo3965->data[3] = (Object)closure3965;
  Method *meth_meth_collectionsPrelude_asDebugString3965 = addmethod2pos(obj3959, "asDebugString", &meth_collectionsPrelude_asDebugString3965, 3);
  int argcv_meth_collectionsPrelude_asDebugString3965[] = {0};
  meth_meth_collectionsPrelude_asDebugString3965->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3965);
  meth_meth_collectionsPrelude_asDebugString3965->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3965->definitionLine = 1721;
  sourceObject = obj3959;
// Begin line 1717
  setline(1717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3974 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3975 = callmethod(*var_enumerable, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe3974);
// compiled call node returning call3975 (depth = 2)
  struct UserObject *obj3959_uo = (struct UserObject *)obj3959;
  obj3959_uo->super = call3975;
  sourceObject = obj3959;
  sourceObject = obj3959;
// Begin line 1720
  setline(1720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3976 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  partcv[0] = 0;
  Object call3977 = callmethod(*var_sourceDictionary, "size",
    1, partcv, params);
  gc_frame_end(callframe3976);
// compiled call node returning call3977 (depth = 3)
// compiled member node returning call3977 (depth = 2)
  adddatum2(obj3959, call3977, 2);
  sourceObject = obj3959;
  objclass3959 = obj3959->class;
  objclass3959->definitionModule = modulename;
  objclass3959->definitionLine = 1716;
  (*(struct UserObject *)self).data[0] = lowerouter3959;
  self = oldself3959;
  selfslot = oldselfslot3959;
  stackframe = oldstackframe3959;
  gc_frame_end(frame);
  return obj3959;
}
Object meth_collectionsPrelude_bindings3958_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindings()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for bindings (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for bindings");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sourceDictionary = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "sourceDictionary");
// Begin line 1715
  setline(1715);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  *var_sourceDictionary = self;
  if (self == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3959 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3959 = alloc_userobj2(3,4, objclass3959);
  gc_frame_newslot(obj3959);
if (objclass3959 == NULL) {
  glfree(obj3959->class->name);
  obj3959->class->name = "collectionsPrelude.dictionary.empty.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3959, self, 0);
  addmethodreal(obj3959,"outer", &reader_collectionsPrelude_outer_3960);
  Object oldself3959 = self;
  struct StackFrameObject *oldstackframe3959 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3959);
  gc_frame_newslot((Object)stackframe);
  self = obj3959;
  Object *oldselfslot3959 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3959 = (*(struct UserObject *)self).data[0], lowerouter3959 = thisouter3959;
  if (inheritingObject3959) {
    struct UserObject *inho3959 = (struct UserObject *)inheritingObject3959;
    while (inho3959->super != GraceDefaultObject) inho3959 = (struct UserObject *)inho3959->super;
    inho3959->super = obj3959;
    self = inheritingObject3959;
    *selfslot = self;
    lowerouter3959 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3959;
  }
// method "iterator"
  block_savedest(obj3959);
  Object closure3961 = createclosure(1, "iterator");
  setclosureframe(closure3961, stackframe);
  addtoclosure(closure3961, var_sourceDictionary);
  struct UserObject *uo3961 = (struct UserObject*)obj3959;
  uo3961->data[1] = (Object)closure3961;
  Method *meth_meth_collectionsPrelude_iterator3961 = addmethod2pos(obj3959, "iterator", &meth_collectionsPrelude_iterator3961, 1);
  int argcv_meth_collectionsPrelude_iterator3961[] = {0};
  meth_meth_collectionsPrelude_iterator3961->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator3961);
  meth_meth_collectionsPrelude_iterator3961->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3961->definitionLine = 1718;
if (objclass3959 == NULL) {
  Method *reader3964 = addmethodrealflags(obj3959, "size",&reader_collectionsPrelude_size_3964, MFLAG_DEF);
  reader3964->definitionModule = modulename;
  reader3964->definitionLine = 1720;
}
adddatum2(obj3959, alloc_Undefined(), 2);
// method "asDebugString"
  block_savedest(obj3959);
  Object closure3965 = createclosure(1, "asDebugString");
  setclosureframe(closure3965, stackframe);
  addtoclosure(closure3965, var_sourceDictionary);
  struct UserObject *uo3965 = (struct UserObject*)obj3959;
  uo3965->data[3] = (Object)closure3965;
  Method *meth_meth_collectionsPrelude_asDebugString3965 = addmethod2pos(obj3959, "asDebugString", &meth_collectionsPrelude_asDebugString3965, 3);
  int argcv_meth_collectionsPrelude_asDebugString3965[] = {0};
  meth_meth_collectionsPrelude_asDebugString3965->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3965);
  meth_meth_collectionsPrelude_asDebugString3965->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3965->definitionLine = 1721;
  sourceObject = obj3959;
// Begin line 1717
  setline(1717);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe3974 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call3975 = callmethod(*var_enumerable, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe3974);
// compiled call node returning call3975 (depth = 2)
  struct UserObject *obj3959_uo = (struct UserObject *)obj3959;
  obj3959_uo->super = call3975;
  sourceObject = obj3959;
  sourceObject = obj3959;
// Begin line 1720
  setline(1720);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3976 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sourceDictionary (depth = 4)
  partcv[0] = 0;
  Object call3977 = callmethod(*var_sourceDictionary, "size",
    1, partcv, params);
  gc_frame_end(callframe3976);
// compiled call node returning call3977 (depth = 3)
// compiled member node returning call3977 (depth = 2)
  adddatum2(obj3959, call3977, 2);
  sourceObject = obj3959;
  objclass3959 = obj3959->class;
  objclass3959->definitionModule = modulename;
  objclass3959->definitionLine = 1716;
  (*(struct UserObject *)self).data[0] = lowerouter3959;
  self = oldself3959;
  selfslot = oldselfslot3959;
  stackframe = oldstackframe3959;
  gc_frame_end(frame);
  return obj3959;
}
Object meth_collectionsPrelude_iterator3979(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1726
  setline(1726);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe3980 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe3981 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3982 = callmethodflags(self, "values", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3981);
// compiled call node returning call3982 (depth = 5)
// compiled member node returning call3982 (depth = 4)
  partcv[0] = 0;
  Object call3983 = callmethod(call3982, "iterator",
    1, partcv, params);
  gc_frame_end(callframe3980);
// compiled call node returning call3983 (depth = 3)
// compiled member node returning call3983 (depth = 2)
  gc_frame_end(frame);
  return call3983;
}
Object meth_collectionsPrelude_hasNext3991(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1733
  setline(1733);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3993 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call3994 = callmethodflags(self, "count", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3993);
// compiled call node returning call3994 (depth = 4)
// compiled member node returning call3994 (depth = 3)
  int op_slot_right_3992 = gc_frame_newslot(call3994);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe3996 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe3997 = gc_frame_new();
// call case 3: self.outer request
  Object call3998 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe3997);
// compiled call node returning call3998 (depth = 6)
// compiled member node returning call3998 (depth = 5)
  partcv[0] = 0;
  Object call3999 = callmethodflags(call3998, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe3996);
// compiled call node returning call3999 (depth = 4)
// compiled member node returning call3999 (depth = 3)
  int op_slot_left_3992 = gc_frame_newslot(call3999);
  params[0] = call3994;
  partcv[0] = 1;
  Object opresult4000 = callmethod(call3999, "≥", 1, partcv, params);
// compiled op node returning opresult4000 (depth = 2)
  gc_frame_end(frame);
  return opresult4000;
}
Object meth_collectionsPrelude__apply4044(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1740
  setline(1740);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4045 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe4046 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4047 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4048 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4047);
// compiled call node returning call4048 (depth = 7)
// compiled member node returning call4048 (depth = 6)
  gc_frame_newslot(call4048);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4049 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4050 = gc_frame_new();
// call case 3: self.outer request
  Object call4051 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4050);
// compiled call node returning call4051 (depth = 9)
// compiled member node returning call4051 (depth = 8)
  partcv[0] = 0;
  Object call4052 = callmethodflags(call4051, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4049);
// compiled call node returning call4052 (depth = 7)
// compiled member node returning call4052 (depth = 6)
  params[0] = call4048;
  partcv[0] = 1;
  Object call4053 = callmethod(call4052, "at",
    1, partcv, params);
  gc_frame_end(callframe4046);
// compiled call node returning call4053 (depth = 5)
  gc_frame_newslot(call4053);
// call case 4: self request
  params[0] = call4053;
  partcv[0] = 1;
  Object call4054 = callmethodflags(self, "elt:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4045);
// compiled call node returning call4054 (depth = 4)
// Begin line 1741
  setline(1741);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4057 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4058 = callmethodflags(self, "elt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4057);
// compiled call node returning call4058 (depth = 7)
// compiled member node returning call4058 (depth = 6)
  int op_slot_right_4056 = gc_frame_newslot(call4058);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_removed (depth = 6)
  int op_slot_left_4056 = gc_frame_newslot(*var_removed);
  params[0] = call4058;
  partcv[0] = 1;
  Object opresult4060 = callmethod(*var_removed, "==", 1, partcv, params);
// compiled op node returning opresult4060 (depth = 5)
  int op_slot_right_4055 = gc_frame_newslot(opresult4060);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4063 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4064 = callmethodflags(self, "elt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4063);
// compiled call node returning call4064 (depth = 7)
// compiled member node returning call4064 (depth = 6)
  int op_slot_right_4062 = gc_frame_newslot(call4064);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_unused (depth = 6)
  int op_slot_left_4062 = gc_frame_newslot(*var_unused);
  params[0] = call4064;
  partcv[0] = 1;
  Object opresult4066 = callmethod(*var_unused, "==", 1, partcv, params);
// compiled op node returning opresult4066 (depth = 5)
  int op_slot_left_4055 = gc_frame_newslot(opresult4066);
  params[0] = opresult4060;
  partcv[0] = 1;
  Object opresult4067 = callmethod(opresult4066, "||", 1, partcv, params);
// compiled op node returning opresult4067 (depth = 4)
  gc_frame_end(frame);
  return opresult4067;
}
Object meth_collectionsPrelude__apply4070(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1743
  setline(1743);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4071 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4073 = alloc_Float64(1);
// compiled num node returning num4073 (depth = 6)
  int op_slot_right_4072 = gc_frame_newslot(num4073);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4075 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4076 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4075);
// compiled call node returning call4076 (depth = 7)
// compiled member node returning call4076 (depth = 6)
  int op_slot_left_4072 = gc_frame_newslot(call4076);
  params[0] = num4073;
  partcv[0] = 1;
  Object sum4077 = callmethod(call4076, "+", 1, partcv, params);
// compiled op node returning sum4077 (depth = 5)
  gc_frame_newslot(sum4077);
// call case 4: self request
  params[0] = sum4077;
  partcv[0] = 1;
  Object call4078 = callmethodflags(self, "idx:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4071);
// compiled call node returning call4078 (depth = 4)
  gc_frame_end(frame);
  return call4078;
}
Object meth_collectionsPrelude_next4001(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1735
  setline(1735);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4004 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4005 = gc_frame_new();
// call case 3: self.outer request
  Object call4006 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4005);
// compiled call node returning call4006 (depth = 7)
// compiled member node returning call4006 (depth = 6)
  partcv[0] = 0;
  Object call4007 = callmethodflags(call4006, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4004);
// compiled call node returning call4007 (depth = 5)
// compiled member node returning call4007 (depth = 4)
  int op_slot_right_4003 = gc_frame_newslot(call4007);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4009 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4010 = callmethodflags(self, "imods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4009);
// compiled call node returning call4010 (depth = 5)
// compiled member node returning call4010 (depth = 4)
  int op_slot_left_4003 = gc_frame_newslot(call4010);
  params[0] = call4007;
  partcv[0] = 1;
  Object opresult4011 = callmethod(call4010, "≠", 1, partcv, params);
// compiled op node returning opresult4011 (depth = 3)
  Object if4002 = done;
  if (istrue(opresult4011)) {
// Begin line 1736
  setline(1736);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4012 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4013 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4014 = gc_frame_new();
// call case 3: self.outer request
  Object call4015 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4014);
// compiled call node returning call4015 (depth = 7)
// compiled member node returning call4015 (depth = 6)
  partcv[0] = 0;
  Object call4016 = callmethodflags(call4015, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4013);
// compiled call node returning call4016 (depth = 5)
// compiled member node returning call4016 (depth = 4)
  gc_frame_newslot(call4016);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_ConcurrentModification (depth = 4)
  params[0] = call4016;
  partcv[0] = 1;
  Object call4017 = callmethod(*var_ConcurrentModification, "raise",
    1, partcv, params);
  gc_frame_end(callframe4012);
// compiled call node returning call4017 (depth = 3)
    gc_frame_newslot(call4017);
    if4002 = call4017;
  } else {
  }
// compiled if node returning if4002 (depth = 2)
// Begin line 1738
  setline(1738);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4020 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4021 = callmethodflags(self, "count", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4020);
// compiled call node returning call4021 (depth = 5)
// compiled member node returning call4021 (depth = 4)
  int op_slot_right_4019 = gc_frame_newslot(call4021);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4023 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4024 = gc_frame_new();
// call case 3: self.outer request
  Object call4025 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4024);
// compiled call node returning call4025 (depth = 7)
// compiled member node returning call4025 (depth = 6)
  partcv[0] = 0;
  Object call4026 = callmethodflags(call4025, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4023);
// compiled call node returning call4026 (depth = 5)
// compiled member node returning call4026 (depth = 4)
  int op_slot_left_4019 = gc_frame_newslot(call4026);
  params[0] = call4021;
  partcv[0] = 1;
  Object opresult4027 = callmethod(call4026, "<", 1, partcv, params);
// compiled op node returning opresult4027 (depth = 3)
  Object if4018 = done;
  if (istrue(opresult4027)) {
// starting to compile call node (depth = 3)
  int callframe4028 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4030 == NULL) {
    strlit4030 = alloc_String("");
    gc_root(strlit4030);
  }
// compiled string node returning strlit4030 (depth = 5)
  int op_slot_right_4029 = gc_frame_newslot(strlit4030);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4033 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4034 = gc_frame_new();
// call case 3: self.outer request
  Object call4035 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4034);
// compiled call node returning call4035 (depth = 9)
// compiled member node returning call4035 (depth = 8)
  partcv[0] = 0;
  Object call4036 = callmethodflags(call4035, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4033);
// compiled call node returning call4036 (depth = 7)
// compiled member node returning call4036 (depth = 6)
  int op_slot_right_4032 = gc_frame_newslot(call4036);
// starting to compile string node (depth = 6)
  if (strlit4038 == NULL) {
    strlit4038 = alloc_String("over ");
    gc_root(strlit4038);
  }
// compiled string node returning strlit4038 (depth = 6)
  int op_slot_left_4032 = gc_frame_newslot(strlit4038);
  params[0] = call4036;
  partcv[0] = 1;
  Object opresult4039 = callmethod(strlit4038, "++", 1, partcv, params);
// compiled op node returning opresult4039 (depth = 5)
  int op_slot_left_4029 = gc_frame_newslot(opresult4039);
  params[0] = strlit4030;
  partcv[0] = 1;
  Object opresult4040 = callmethod(opresult4039, "++", 1, partcv, params);
// compiled op node returning opresult4040 (depth = 4)
  gc_frame_newslot(opresult4040);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_IteratorExhausted (depth = 4)
  params[0] = opresult4040;
  partcv[0] = 1;
  Object call4041 = callmethod(*var_IteratorExhausted, "raise",
    1, partcv, params);
  gc_frame_end(callframe4028);
// compiled call node returning call4041 (depth = 3)
    gc_frame_newslot(call4041);
    if4018 = call4041;
  } else {
  }
// compiled if node returning if4018 (depth = 2)
// Begin line 1739
  setline(1739);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4042 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4043 = alloc_Block(NULL, NULL, "collectionsPrelude", 1739);
  gc_frame_newslot(block4043);
// method "_apply"
  block_savedest(block4043);
  Object closure4044 = createclosure(3, "_apply");
  setclosureframe(closure4044, stackframe);
  addtoclosure(closure4044, var_removed);
  addtoclosure(closure4044, var_unused);
  addtoclosure(closure4044, selfslot);
  struct UserObject *uo4044 = (struct UserObject*)block4043;
  uo4044->data[0] = (Object)closure4044;
  Method *meth_meth_collectionsPrelude__apply4044 = addmethod2pos(block4043, "_apply", &meth_collectionsPrelude__apply4044, 0);
  int argcv_meth_collectionsPrelude__apply4044[] = {0};
  meth_meth_collectionsPrelude__apply4044->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4044);
  meth_meth_collectionsPrelude__apply4044->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4044->definitionLine = 1738;
// compiled block node returning block4043 (depth = 3)
  gc_frame_newslot(block4043);
// Begin line 1742
  setline(1742);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4069 = alloc_Block(NULL, NULL, "collectionsPrelude", 1742);
  gc_frame_newslot(block4069);
// method "_apply"
  block_savedest(block4069);
  Object closure4070 = createclosure(1, "_apply");
  setclosureframe(closure4070, stackframe);
  addtoclosure(closure4070, selfslot);
  struct UserObject *uo4070 = (struct UserObject*)block4069;
  uo4070->data[0] = (Object)closure4070;
  Method *meth_meth_collectionsPrelude__apply4070 = addmethod2pos(block4069, "_apply", &meth_collectionsPrelude__apply4070, 0);
  int argcv_meth_collectionsPrelude__apply4070[] = {0};
  meth_meth_collectionsPrelude__apply4070->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4070);
  meth_meth_collectionsPrelude__apply4070->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4070->definitionLine = 1741;
// compiled block node returning block4069 (depth = 3)
  gc_frame_newslot(block4069);
// call case 5: prelude request
  params[0] = block4043;
  params[1] = block4069;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4080 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4042);
// compiled call node returning call4080 (depth = 2)
// Begin line 1745
  setline(1745);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4081 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4083 = alloc_Float64(1);
// compiled num node returning num4083 (depth = 4)
  int op_slot_right_4082 = gc_frame_newslot(num4083);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4085 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4086 = callmethodflags(self, "count", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4085);
// compiled call node returning call4086 (depth = 5)
// compiled member node returning call4086 (depth = 4)
  int op_slot_left_4082 = gc_frame_newslot(call4086);
  params[0] = num4083;
  partcv[0] = 1;
  Object sum4087 = callmethod(call4086, "+", 1, partcv, params);
// compiled op node returning sum4087 (depth = 3)
  gc_frame_newslot(sum4087);
// call case 4: self request
  params[0] = sum4087;
  partcv[0] = 1;
  Object call4088 = callmethodflags(self, "count:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4081);
// compiled call node returning call4088 (depth = 2)
// Begin line 1746
  setline(1746);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4089 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4091 = alloc_Float64(1);
// compiled num node returning num4091 (depth = 4)
  int op_slot_right_4090 = gc_frame_newslot(num4091);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4093 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4094 = callmethodflags(self, "idx", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4093);
// compiled call node returning call4094 (depth = 5)
// compiled member node returning call4094 (depth = 4)
  int op_slot_left_4090 = gc_frame_newslot(call4094);
  params[0] = num4091;
  partcv[0] = 1;
  Object sum4095 = callmethod(call4094, "+", 1, partcv, params);
// compiled op node returning sum4095 (depth = 3)
  gc_frame_newslot(sum4095);
// call case 4: self request
  params[0] = sum4095;
  partcv[0] = 1;
  Object call4096 = callmethodflags(self, "idx:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4089);
// compiled call node returning call4096 (depth = 2)
// Begin line 1747
  setline(1747);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4097 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4098 = callmethodflags(self, "elt", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4097);
// compiled call node returning call4098 (depth = 3)
// compiled member node returning call4098 (depth = 2)
  gc_frame_end(frame);
  return call4098;
}
Object meth_collectionsPrelude_bindingsIterator3984(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindingsIterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for bindingsIterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for bindingsIterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3985 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3985 = alloc_userobj2(9,7, objclass3985);
  gc_frame_newslot(obj3985);
if (objclass3985 == NULL) {
  glfree(obj3985->class->name);
  obj3985->class->name = "collectionsPrelude.dictionary.empty.bindingsIterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3985, self, 0);
  addmethodreal(obj3985,"outer", &reader_collectionsPrelude_outer_3986);
  Object oldself3985 = self;
  struct StackFrameObject *oldstackframe3985 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3985);
  gc_frame_newslot((Object)stackframe);
  self = obj3985;
  Object *oldselfslot3985 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3985 = (*(struct UserObject *)self).data[0], lowerouter3985 = thisouter3985;
  if (inheritingObject3985) {
    struct UserObject *inho3985 = (struct UserObject *)inheritingObject3985;
    while (inho3985->super != GraceDefaultObject) inho3985 = (struct UserObject *)inho3985->super;
    inho3985->super = obj3985;
    self = inheritingObject3985;
    *selfslot = self;
    lowerouter3985 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3985;
  }
if (objclass3985 == NULL) {
  Method *reader3987 = addmethodrealflags(obj3985, "imods",&reader_collectionsPrelude_imods_3987, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader3987->definitionModule = modulename;
  reader3987->definitionLine = 1729;
}
adddatum2(obj3985, alloc_Undefined(), 1);
if (objclass3985 == NULL) {
  Method *reader3988 = addmethodrealflags(obj3985, "count",&reader_collectionsPrelude_count_3988, MFLAG_CONFIDENTIAL);
  Method *writer3988 = addmethodrealflags(obj3985, "count:=",&writer_collectionsPrelude_count_3988, MFLAG_CONFIDENTIAL);
  reader3988->definitionModule = modulename;
  writer3988->definitionModule = modulename;
  reader3988->definitionLine = 1730;
  writer3988->definitionLine = 1730;
}
obj3985->flags |= OFLAG_MUTABLE;
adddatum2(obj3985, alloc_Undefined(), 2);
if (objclass3985 == NULL) {
  Method *reader3989 = addmethodrealflags(obj3985, "idx",&reader_collectionsPrelude_idx_3989, MFLAG_CONFIDENTIAL);
  Method *writer3989 = addmethodrealflags(obj3985, "idx:=",&writer_collectionsPrelude_idx_3989, MFLAG_CONFIDENTIAL);
  reader3989->definitionModule = modulename;
  writer3989->definitionModule = modulename;
  reader3989->definitionLine = 1731;
  writer3989->definitionLine = 1731;
}
obj3985->flags |= OFLAG_MUTABLE;
adddatum2(obj3985, alloc_Undefined(), 3);
if (objclass3985 == NULL) {
  Method *reader3990 = addmethodrealflags(obj3985, "elt",&reader_collectionsPrelude_elt_3990, MFLAG_CONFIDENTIAL);
  Method *writer3990 = addmethodrealflags(obj3985, "elt:=",&writer_collectionsPrelude_elt_3990, MFLAG_CONFIDENTIAL);
  reader3990->definitionModule = modulename;
  writer3990->definitionModule = modulename;
  reader3990->definitionLine = 1732;
  writer3990->definitionLine = 1732;
}
obj3985->flags |= OFLAG_MUTABLE;
adddatum2(obj3985, alloc_Undefined(), 4);
// method "hasNext"
  struct UserObject *uo3991 = (struct UserObject*)obj3985;
  uo3991->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext3991 = addmethod2pos(obj3985, "hasNext", &meth_collectionsPrelude_hasNext3991, 5);
  int argcv_meth_collectionsPrelude_hasNext3991[] = {0};
  meth_meth_collectionsPrelude_hasNext3991->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext3991);
  meth_meth_collectionsPrelude_hasNext3991->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext3991->definitionLine = 1733;
// method "next"
  block_savedest(obj3985);
  Object closure4001 = createclosure(4, "next");
  setclosureframe(closure4001, stackframe);
  addtoclosure(closure4001, var_ConcurrentModification);
  addtoclosure(closure4001, var_IteratorExhausted);
  addtoclosure(closure4001, var_removed);
  addtoclosure(closure4001, var_unused);
  struct UserObject *uo4001 = (struct UserObject*)obj3985;
  uo4001->data[6] = (Object)closure4001;
  Method *meth_meth_collectionsPrelude_next4001 = addmethod2pos(obj3985, "next", &meth_collectionsPrelude_next4001, 6);
  int argcv_meth_collectionsPrelude_next4001[] = {0};
  meth_meth_collectionsPrelude_next4001->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next4001);
  meth_meth_collectionsPrelude_next4001->definitionModule = modulename;
  meth_meth_collectionsPrelude_next4001->definitionLine = 1734;
  sourceObject = obj3985;
// Begin line 1729
  setline(1729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4099 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4100 = gc_frame_new();
// call case 3: self.outer request
  Object call4101 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4100);
// compiled call node returning call4101 (depth = 5)
// compiled member node returning call4101 (depth = 4)
  partcv[0] = 0;
  Object call4102 = callmethodflags(call4101, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4099);
// compiled call node returning call4102 (depth = 3)
// compiled member node returning call4102 (depth = 2)
  adddatum2(obj3985, call4102, 1);
  sourceObject = obj3985;
// Begin line 1730
  setline(1730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4103 = alloc_Float64(1);
// compiled num node returning num4103 (depth = 2)
  adddatum2(obj3985, num4103, 2);
  sourceObject = obj3985;
// Begin line 1731
  setline(1731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4104 = alloc_Float64(0);
// compiled num node returning num4104 (depth = 2)
  adddatum2(obj3985, num4104, 3);
  sourceObject = obj3985;
  adddatum2(obj3985, undefined, 4);
  sourceObject = obj3985;
  sourceObject = obj3985;
  objclass3985 = obj3985->class;
  objclass3985->definitionModule = modulename;
  objclass3985->definitionLine = 1727;
  (*(struct UserObject *)self).data[0] = lowerouter3985;
  self = oldself3985;
  selfslot = oldselfslot3985;
  stackframe = oldstackframe3985;
  gc_frame_end(frame);
  return obj3985;
}
Object meth_collectionsPrelude_bindingsIterator3984_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "bindingsIterator()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  Object *var_IteratorExhausted = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  Object *var_unused = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for bindingsIterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for bindingsIterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3985 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3985 = alloc_userobj2(9,7, objclass3985);
  gc_frame_newslot(obj3985);
if (objclass3985 == NULL) {
  glfree(obj3985->class->name);
  obj3985->class->name = "collectionsPrelude.dictionary.empty.bindingsIterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3985, self, 0);
  addmethodreal(obj3985,"outer", &reader_collectionsPrelude_outer_3986);
  Object oldself3985 = self;
  struct StackFrameObject *oldstackframe3985 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3985);
  gc_frame_newslot((Object)stackframe);
  self = obj3985;
  Object *oldselfslot3985 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3985 = (*(struct UserObject *)self).data[0], lowerouter3985 = thisouter3985;
  if (inheritingObject3985) {
    struct UserObject *inho3985 = (struct UserObject *)inheritingObject3985;
    while (inho3985->super != GraceDefaultObject) inho3985 = (struct UserObject *)inho3985->super;
    inho3985->super = obj3985;
    self = inheritingObject3985;
    *selfslot = self;
    lowerouter3985 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3985;
  }
if (objclass3985 == NULL) {
  Method *reader3987 = addmethodrealflags(obj3985, "imods",&reader_collectionsPrelude_imods_3987, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader3987->definitionModule = modulename;
  reader3987->definitionLine = 1729;
}
adddatum2(obj3985, alloc_Undefined(), 1);
if (objclass3985 == NULL) {
  Method *reader3988 = addmethodrealflags(obj3985, "count",&reader_collectionsPrelude_count_3988, MFLAG_CONFIDENTIAL);
  Method *writer3988 = addmethodrealflags(obj3985, "count:=",&writer_collectionsPrelude_count_3988, MFLAG_CONFIDENTIAL);
  reader3988->definitionModule = modulename;
  writer3988->definitionModule = modulename;
  reader3988->definitionLine = 1730;
  writer3988->definitionLine = 1730;
}
obj3985->flags |= OFLAG_MUTABLE;
adddatum2(obj3985, alloc_Undefined(), 2);
if (objclass3985 == NULL) {
  Method *reader3989 = addmethodrealflags(obj3985, "idx",&reader_collectionsPrelude_idx_3989, MFLAG_CONFIDENTIAL);
  Method *writer3989 = addmethodrealflags(obj3985, "idx:=",&writer_collectionsPrelude_idx_3989, MFLAG_CONFIDENTIAL);
  reader3989->definitionModule = modulename;
  writer3989->definitionModule = modulename;
  reader3989->definitionLine = 1731;
  writer3989->definitionLine = 1731;
}
obj3985->flags |= OFLAG_MUTABLE;
adddatum2(obj3985, alloc_Undefined(), 3);
if (objclass3985 == NULL) {
  Method *reader3990 = addmethodrealflags(obj3985, "elt",&reader_collectionsPrelude_elt_3990, MFLAG_CONFIDENTIAL);
  Method *writer3990 = addmethodrealflags(obj3985, "elt:=",&writer_collectionsPrelude_elt_3990, MFLAG_CONFIDENTIAL);
  reader3990->definitionModule = modulename;
  writer3990->definitionModule = modulename;
  reader3990->definitionLine = 1732;
  writer3990->definitionLine = 1732;
}
obj3985->flags |= OFLAG_MUTABLE;
adddatum2(obj3985, alloc_Undefined(), 4);
// method "hasNext"
  struct UserObject *uo3991 = (struct UserObject*)obj3985;
  uo3991->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext3991 = addmethod2pos(obj3985, "hasNext", &meth_collectionsPrelude_hasNext3991, 5);
  int argcv_meth_collectionsPrelude_hasNext3991[] = {0};
  meth_meth_collectionsPrelude_hasNext3991->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext3991);
  meth_meth_collectionsPrelude_hasNext3991->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext3991->definitionLine = 1733;
// method "next"
  block_savedest(obj3985);
  Object closure4001 = createclosure(4, "next");
  setclosureframe(closure4001, stackframe);
  addtoclosure(closure4001, var_ConcurrentModification);
  addtoclosure(closure4001, var_IteratorExhausted);
  addtoclosure(closure4001, var_removed);
  addtoclosure(closure4001, var_unused);
  struct UserObject *uo4001 = (struct UserObject*)obj3985;
  uo4001->data[6] = (Object)closure4001;
  Method *meth_meth_collectionsPrelude_next4001 = addmethod2pos(obj3985, "next", &meth_collectionsPrelude_next4001, 6);
  int argcv_meth_collectionsPrelude_next4001[] = {0};
  meth_meth_collectionsPrelude_next4001->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next4001);
  meth_meth_collectionsPrelude_next4001->definitionModule = modulename;
  meth_meth_collectionsPrelude_next4001->definitionLine = 1734;
  sourceObject = obj3985;
// Begin line 1729
  setline(1729);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4099 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4100 = gc_frame_new();
// call case 3: self.outer request
  Object call4101 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4100);
// compiled call node returning call4101 (depth = 5)
// compiled member node returning call4101 (depth = 4)
  partcv[0] = 0;
  Object call4102 = callmethodflags(call4101, "mods", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4099);
// compiled call node returning call4102 (depth = 3)
// compiled member node returning call4102 (depth = 2)
  adddatum2(obj3985, call4102, 1);
  sourceObject = obj3985;
// Begin line 1730
  setline(1730);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4103 = alloc_Float64(1);
// compiled num node returning num4103 (depth = 2)
  adddatum2(obj3985, num4103, 2);
  sourceObject = obj3985;
// Begin line 1731
  setline(1731);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4104 = alloc_Float64(0);
// compiled num node returning num4104 (depth = 2)
  adddatum2(obj3985, num4104, 3);
  sourceObject = obj3985;
  adddatum2(obj3985, undefined, 4);
  sourceObject = obj3985;
  sourceObject = obj3985;
  objclass3985 = obj3985->class;
  objclass3985->definitionModule = modulename;
  objclass3985->definitionLine = 1727;
  (*(struct UserObject *)self).data[0] = lowerouter3985;
  self = oldself3985;
  selfslot = oldselfslot3985;
  stackframe = oldstackframe3985;
  gc_frame_end(frame);
  return obj3985;
}
Object meth_collectionsPrelude__apply4133(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1756
  setline(1756);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4134 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  gc_frame_newslot(*var_unused);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4135 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4136 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4135);
// compiled call node returning call4136 (depth = 6)
// compiled member node returning call4136 (depth = 5)
  params[0] = *var_i;
  params[1] = *var_unused;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4137 = callmethod(call4136, "at()put",
    2, partcv, params);
  gc_frame_end(callframe4134);
// compiled call node returning call4137 (depth = 4)
  gc_frame_end(frame);
  return call4137;
}
Object meth_collectionsPrelude__apply4153(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_oldInner = getfromclosure(closure, 0);
  Object *var_removed = getfromclosure(closure, 1);
  Object *var_unused = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1760
  setline(1760);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4154 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_oldInner (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call4155 = callmethod(*var_oldInner, "at",
    1, partcv, params);
  gc_frame_end(callframe4154);
// compiled call node returning call4155 (depth = 5)
  *var_a = call4155;
  if (call4155 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1761
  setline(1761);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4158 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_4158 = gc_frame_newslot(*var_removed);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4160 = callmethod(*var_removed, "≠", 1, partcv, params);
// compiled op node returning opresult4160 (depth = 6)
  int op_slot_right_4157 = gc_frame_newslot(opresult4160);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4162 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_4162 = gc_frame_newslot(*var_unused);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4164 = callmethod(*var_unused, "≠", 1, partcv, params);
// compiled op node returning opresult4164 (depth = 6)
  int op_slot_left_4157 = gc_frame_newslot(opresult4164);
  params[0] = opresult4160;
  partcv[0] = 1;
  Object opresult4165 = callmethod(opresult4164, "&&", 1, partcv, params);
// compiled op node returning opresult4165 (depth = 5)
  Object if4156 = done;
  if (istrue(opresult4165)) {
// Begin line 1762
  setline(1762);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4166 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4167 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call4168 = callmethod(*var_a, "key",
    1, partcv, params);
  gc_frame_end(callframe4167);
// compiled call node returning call4168 (depth = 7)
// compiled member node returning call4168 (depth = 6)
  gc_frame_newslot(call4168);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4169 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call4170 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe4169);
// compiled call node returning call4170 (depth = 7)
// compiled member node returning call4170 (depth = 6)
  gc_frame_newslot(call4170);
// call case 4: self request
  params[0] = call4168;
  params[1] = call4170;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4171 = callmethodflags(self, "at()put", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4166);
// compiled call node returning call4171 (depth = 5)
    gc_frame_newslot(call4171);
    if4156 = call4171;
  } else {
  }
// compiled if node returning if4156 (depth = 4)
  gc_frame_end(frame);
  return if4156;
}
Object meth_collectionsPrelude_expand4106(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(4, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "expand");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var__prelude = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_removed = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for expand (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for expand");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_c = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "c");
  Object *var_n = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "n");
  Object *var_oldInner = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "oldInner");
// Begin line 1751
  setline(1751);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4107 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4108 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4109 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4108);
// compiled call node returning call4109 (depth = 6)
// compiled member node returning call4109 (depth = 5)
  partcv[0] = 0;
  Object call4110 = callmethod(call4109, "size",
    1, partcv, params);
  gc_frame_end(callframe4107);
// compiled call node returning call4110 (depth = 4)
// compiled member node returning call4110 (depth = 3)
  *var_c = call4110;
  if (call4110 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1752
  setline(1752);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4112 = alloc_Float64(2);
// compiled num node returning num4112 (depth = 4)
  int op_slot_right_4111 = gc_frame_newslot(num4112);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  int op_slot_left_4111 = gc_frame_newslot(*var_c);
  params[0] = num4112;
  partcv[0] = 1;
  Object prod4114 = callmethod(*var_c, "*", 1, partcv, params);
// compiled op node returning prod4114 (depth = 3)
  *var_n = prod4114;
  if (prod4114 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1753
  setline(1753);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4115 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4116 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4115);
// compiled call node returning call4116 (depth = 4)
// compiled member node returning call4116 (depth = 3)
  *var_oldInner = call4116;
  if (call4116 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1754
  setline(1754);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4117 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe4118 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_n (depth = 4)
  gc_frame_newslot(*var_n);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4119 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var__prelude (depth = 6)
  partcv[0] = 0;
  Object call4120 = callmethod(*var__prelude, "primitiveArray",
    1, partcv, params);
  gc_frame_end(callframe4119);
// compiled call node returning call4120 (depth = 5)
// compiled member node returning call4120 (depth = 4)
  params[0] = *var_n;
  partcv[0] = 1;
  Object call4121 = callmethod(call4120, "new",
    1, partcv, params);
  gc_frame_end(callframe4118);
// compiled call node returning call4121 (depth = 3)
  gc_frame_newslot(call4121);
// call case 4: self request
  params[0] = call4121;
  partcv[0] = 1;
  Object call4122 = callmethodflags(self, "inner:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4117);
// compiled call node returning call4122 (depth = 2)
// Begin line 1755
  setline(1755);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4123 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4126 = alloc_Float64(1);
// compiled num node returning num4126 (depth = 5)
  int op_slot_right_4125 = gc_frame_newslot(num4126);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  int op_slot_left_4125 = gc_frame_newslot(*var_n);
  params[0] = num4126;
  partcv[0] = 1;
  Object diff4128 = callmethod(*var_n, "-", 1, partcv, params);
// compiled op node returning diff4128 (depth = 4)
  int op_slot_right_4124 = gc_frame_newslot(diff4128);
// starting to compile num node (depth = 4)
  Object num4130 = alloc_Float64(0);
// compiled num node returning num4130 (depth = 4)
  int op_slot_left_4124 = gc_frame_newslot(num4130);
  params[0] = diff4128;
  partcv[0] = 1;
  Object opresult4131 = callmethod(num4130, "..", 1, partcv, params);
// compiled op node returning opresult4131 (depth = 3)
  gc_frame_newslot(opresult4131);
// starting to compile block node (depth = 3)
  Object block4132 = alloc_Block(NULL, NULL, "collectionsPrelude", 1755);
  gc_frame_newslot(block4132);
// method "_apply"
  block_savedest(block4132);
  Object closure4133 = createclosure(2, "_apply");
  setclosureframe(closure4133, stackframe);
  addtoclosure(closure4133, var_unused);
  addtoclosure(closure4133, selfslot);
  struct UserObject *uo4133 = (struct UserObject*)block4132;
  uo4133->data[0] = (Object)closure4133;
  Method *meth_meth_collectionsPrelude__apply4133 = addmethod2pos(block4132, "_apply", &meth_collectionsPrelude__apply4133, 0);
  int argcv_meth_collectionsPrelude__apply4133[] = {1};
  meth_meth_collectionsPrelude__apply4133->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4133);
  meth_meth_collectionsPrelude__apply4133->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4133->definitionLine = 1754;
// compiled block node returning block4132 (depth = 3)
  gc_frame_newslot(block4132);
// call case 5: prelude request
  params[0] = opresult4131;
  params[1] = block4132;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4139 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4123);
// compiled call node returning call4139 (depth = 2)
// Begin line 1758
  setline(1758);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4140 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num4141 = alloc_Float64(0);
// compiled num node returning num4141 (depth = 3)
  gc_frame_newslot(num4141);
// call case 4: self request
  params[0] = num4141;
  partcv[0] = 1;
  Object call4142 = callmethodflags(self, "numBindings:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4140);
// compiled call node returning call4142 (depth = 2)
// Begin line 1759
  setline(1759);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4143 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4146 = alloc_Float64(1);
// compiled num node returning num4146 (depth = 5)
  int op_slot_right_4145 = gc_frame_newslot(num4146);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_c (depth = 5)
  int op_slot_left_4145 = gc_frame_newslot(*var_c);
  params[0] = num4146;
  partcv[0] = 1;
  Object diff4148 = callmethod(*var_c, "-", 1, partcv, params);
// compiled op node returning diff4148 (depth = 4)
  int op_slot_right_4144 = gc_frame_newslot(diff4148);
// starting to compile num node (depth = 4)
  Object num4150 = alloc_Float64(0);
// compiled num node returning num4150 (depth = 4)
  int op_slot_left_4144 = gc_frame_newslot(num4150);
  params[0] = diff4148;
  partcv[0] = 1;
  Object opresult4151 = callmethod(num4150, "..", 1, partcv, params);
// compiled op node returning opresult4151 (depth = 3)
  gc_frame_newslot(opresult4151);
// starting to compile block node (depth = 3)
  Object block4152 = alloc_Block(NULL, NULL, "collectionsPrelude", 1759);
  gc_frame_newslot(block4152);
// method "_apply"
  block_savedest(block4152);
  Object closure4153 = createclosure(4, "_apply");
  setclosureframe(closure4153, stackframe);
  addtoclosure(closure4153, var_oldInner);
  addtoclosure(closure4153, var_removed);
  addtoclosure(closure4153, var_unused);
  addtoclosure(closure4153, selfslot);
  struct UserObject *uo4153 = (struct UserObject*)block4152;
  uo4153->data[0] = (Object)closure4153;
  Method *meth_meth_collectionsPrelude__apply4153 = addmethod2pos(block4152, "_apply", &meth_collectionsPrelude__apply4153, 0);
  int argcv_meth_collectionsPrelude__apply4153[] = {1};
  meth_meth_collectionsPrelude__apply4153->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4153);
  meth_meth_collectionsPrelude__apply4153->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4153->definitionLine = 1756;
// compiled block node returning block4152 (depth = 3)
  gc_frame_newslot(block4152);
// call case 5: prelude request
  params[0] = opresult4151;
  params[1] = block4152;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4173 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4143);
// compiled call node returning call4173 (depth = 2)
  gc_frame_end(frame);
  return call4173;
}
Object meth_collectionsPrelude__apply4189(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_block2 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1768
  setline(1768);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4190 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4191 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4192 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4191);
// compiled call node returning call4192 (depth = 7)
// compiled member node returning call4192 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call4193 = callmethod(call4192, "at",
    1, partcv, params);
  gc_frame_end(callframe4190);
// compiled call node returning call4193 (depth = 5)
  *var_a = call4193;
  if (call4193 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1769
  setline(1769);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4196 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_4196 = gc_frame_newslot(*var_removed);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4198 = callmethod(*var_removed, "≠", 1, partcv, params);
// compiled op node returning opresult4198 (depth = 6)
  int op_slot_right_4195 = gc_frame_newslot(opresult4198);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4200 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_4200 = gc_frame_newslot(*var_unused);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4202 = callmethod(*var_unused, "≠", 1, partcv, params);
// compiled op node returning opresult4202 (depth = 6)
  int op_slot_left_4195 = gc_frame_newslot(opresult4202);
  params[0] = opresult4198;
  partcv[0] = 1;
  Object opresult4203 = callmethod(opresult4202, "&&", 1, partcv, params);
// compiled op node returning opresult4203 (depth = 5)
  Object if4194 = done;
  if (istrue(opresult4203)) {
// Begin line 1770
  setline(1770);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4204 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4205 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call4206 = callmethod(*var_a, "key",
    1, partcv, params);
  gc_frame_end(callframe4205);
// compiled call node returning call4206 (depth = 7)
// compiled member node returning call4206 (depth = 6)
  gc_frame_newslot(call4206);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4207 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call4208 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe4207);
// compiled call node returning call4208 (depth = 7)
// compiled member node returning call4208 (depth = 6)
  gc_frame_newslot(call4208);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block2 (depth = 6)
  params[0] = call4206;
  params[1] = call4208;
  partcv[0] = 2;
  Object call4209 = callmethod(*var_block2, "apply",
    1, partcv, params);
  gc_frame_end(callframe4204);
// compiled call node returning call4209 (depth = 5)
    gc_frame_newslot(call4209);
    if4194 = call4209;
  } else {
  }
// compiled if node returning if4194 (depth = 4)
  gc_frame_end(frame);
  return if4194;
}
Object meth_collectionsPrelude_keysAndValuesDo4174(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "keysAndValuesDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for keysAndValuesDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1767
  setline(1767);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4175 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4178 = alloc_Float64(1);
// compiled num node returning num4178 (depth = 5)
  int op_slot_right_4177 = gc_frame_newslot(num4178);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4180 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4181 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4182 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4181);
// compiled call node returning call4182 (depth = 8)
// compiled member node returning call4182 (depth = 7)
  partcv[0] = 0;
  Object call4183 = callmethod(call4182, "size",
    1, partcv, params);
  gc_frame_end(callframe4180);
// compiled call node returning call4183 (depth = 6)
// compiled member node returning call4183 (depth = 5)
  int op_slot_left_4177 = gc_frame_newslot(call4183);
  params[0] = num4178;
  partcv[0] = 1;
  Object diff4184 = callmethod(call4183, "-", 1, partcv, params);
// compiled op node returning diff4184 (depth = 4)
  int op_slot_right_4176 = gc_frame_newslot(diff4184);
// starting to compile num node (depth = 4)
  Object num4186 = alloc_Float64(0);
// compiled num node returning num4186 (depth = 4)
  int op_slot_left_4176 = gc_frame_newslot(num4186);
  params[0] = diff4184;
  partcv[0] = 1;
  Object opresult4187 = callmethod(num4186, "..", 1, partcv, params);
// compiled op node returning opresult4187 (depth = 3)
  gc_frame_newslot(opresult4187);
// starting to compile block node (depth = 3)
  Object block4188 = alloc_Block(NULL, NULL, "collectionsPrelude", 1767);
  gc_frame_newslot(block4188);
// method "_apply"
  block_savedest(block4188);
  Object closure4189 = createclosure(4, "_apply");
  setclosureframe(closure4189, stackframe);
  addtoclosure(closure4189, var_removed);
  addtoclosure(closure4189, var_unused);
  addtoclosure(closure4189, var_block2);
  addtoclosure(closure4189, selfslot);
  struct UserObject *uo4189 = (struct UserObject*)block4188;
  uo4189->data[0] = (Object)closure4189;
  Method *meth_meth_collectionsPrelude__apply4189 = addmethod2pos(block4188, "_apply", &meth_collectionsPrelude__apply4189, 0);
  int argcv_meth_collectionsPrelude__apply4189[] = {1};
  meth_meth_collectionsPrelude__apply4189->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4189);
  meth_meth_collectionsPrelude__apply4189->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4189->definitionLine = 1767;
// compiled block node returning block4188 (depth = 3)
  gc_frame_newslot(block4188);
// call case 5: prelude request
  params[0] = opresult4187;
  params[1] = block4188;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4211 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4175);
// compiled call node returning call4211 (depth = 2)
  gc_frame_end(frame);
  return call4211;
}
Object meth_collectionsPrelude__apply4227(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_block1 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1776
  setline(1776);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4228 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4229 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4230 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4229);
// compiled call node returning call4230 (depth = 7)
// compiled member node returning call4230 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call4231 = callmethod(call4230, "at",
    1, partcv, params);
  gc_frame_end(callframe4228);
// compiled call node returning call4231 (depth = 5)
  *var_a = call4231;
  if (call4231 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1777
  setline(1777);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4234 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_4234 = gc_frame_newslot(*var_removed);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4236 = callmethod(*var_removed, "≠", 1, partcv, params);
// compiled op node returning opresult4236 (depth = 6)
  int op_slot_right_4233 = gc_frame_newslot(opresult4236);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4238 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_4238 = gc_frame_newslot(*var_unused);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4240 = callmethod(*var_unused, "≠", 1, partcv, params);
// compiled op node returning opresult4240 (depth = 6)
  int op_slot_left_4233 = gc_frame_newslot(opresult4240);
  params[0] = opresult4236;
  partcv[0] = 1;
  Object opresult4241 = callmethod(opresult4240, "&&", 1, partcv, params);
// compiled op node returning opresult4241 (depth = 5)
  Object if4232 = done;
  if (istrue(opresult4241)) {
// Begin line 1778
  setline(1778);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4242 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4243 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call4244 = callmethod(*var_a, "key",
    1, partcv, params);
  gc_frame_end(callframe4243);
// compiled call node returning call4244 (depth = 7)
// compiled member node returning call4244 (depth = 6)
  gc_frame_newslot(call4244);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block1 (depth = 6)
  params[0] = call4244;
  partcv[0] = 1;
  Object call4245 = callmethod(*var_block1, "apply",
    1, partcv, params);
  gc_frame_end(callframe4242);
// compiled call node returning call4245 (depth = 5)
    gc_frame_newslot(call4245);
    if4232 = call4245;
  } else {
  }
// compiled if node returning if4232 (depth = 4)
  gc_frame_end(frame);
  return if4232;
}
Object meth_collectionsPrelude_keysDo4212(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "keysDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysDo");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for keysDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1775
  setline(1775);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4213 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4216 = alloc_Float64(1);
// compiled num node returning num4216 (depth = 5)
  int op_slot_right_4215 = gc_frame_newslot(num4216);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4218 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4219 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4220 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4219);
// compiled call node returning call4220 (depth = 8)
// compiled member node returning call4220 (depth = 7)
  partcv[0] = 0;
  Object call4221 = callmethod(call4220, "size",
    1, partcv, params);
  gc_frame_end(callframe4218);
// compiled call node returning call4221 (depth = 6)
// compiled member node returning call4221 (depth = 5)
  int op_slot_left_4215 = gc_frame_newslot(call4221);
  params[0] = num4216;
  partcv[0] = 1;
  Object diff4222 = callmethod(call4221, "-", 1, partcv, params);
// compiled op node returning diff4222 (depth = 4)
  int op_slot_right_4214 = gc_frame_newslot(diff4222);
// starting to compile num node (depth = 4)
  Object num4224 = alloc_Float64(0);
// compiled num node returning num4224 (depth = 4)
  int op_slot_left_4214 = gc_frame_newslot(num4224);
  params[0] = diff4222;
  partcv[0] = 1;
  Object opresult4225 = callmethod(num4224, "..", 1, partcv, params);
// compiled op node returning opresult4225 (depth = 3)
  gc_frame_newslot(opresult4225);
// starting to compile block node (depth = 3)
  Object block4226 = alloc_Block(NULL, NULL, "collectionsPrelude", 1775);
  gc_frame_newslot(block4226);
// method "_apply"
  block_savedest(block4226);
  Object closure4227 = createclosure(4, "_apply");
  setclosureframe(closure4227, stackframe);
  addtoclosure(closure4227, var_removed);
  addtoclosure(closure4227, var_unused);
  addtoclosure(closure4227, var_block1);
  addtoclosure(closure4227, selfslot);
  struct UserObject *uo4227 = (struct UserObject*)block4226;
  uo4227->data[0] = (Object)closure4227;
  Method *meth_meth_collectionsPrelude__apply4227 = addmethod2pos(block4226, "_apply", &meth_collectionsPrelude__apply4227, 0);
  int argcv_meth_collectionsPrelude__apply4227[] = {1};
  meth_meth_collectionsPrelude__apply4227->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4227);
  meth_meth_collectionsPrelude__apply4227->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4227->definitionLine = 1775;
// compiled block node returning block4226 (depth = 3)
  gc_frame_newslot(block4226);
// call case 5: prelude request
  params[0] = opresult4225;
  params[1] = block4226;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4247 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4213);
// compiled call node returning call4247 (depth = 2)
  gc_frame_end(frame);
  return call4247;
}
Object meth_collectionsPrelude__apply4263(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_block1 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_a = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "a");
// Begin line 1784
  setline(1784);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4264 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4265 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4266 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4265);
// compiled call node returning call4266 (depth = 7)
// compiled member node returning call4266 (depth = 6)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call4267 = callmethod(call4266, "at",
    1, partcv, params);
  gc_frame_end(callframe4264);
// compiled call node returning call4267 (depth = 5)
  *var_a = call4267;
  if (call4267 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1785
  setline(1785);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4270 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_removed (depth = 7)
  int op_slot_left_4270 = gc_frame_newslot(*var_removed);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4272 = callmethod(*var_removed, "≠", 1, partcv, params);
// compiled op node returning opresult4272 (depth = 6)
  int op_slot_right_4269 = gc_frame_newslot(opresult4272);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_a (depth = 7)
  int op_slot_right_4274 = gc_frame_newslot(*var_a);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_unused (depth = 7)
  int op_slot_left_4274 = gc_frame_newslot(*var_unused);
  params[0] = *var_a;
  partcv[0] = 1;
  Object opresult4276 = callmethod(*var_unused, "≠", 1, partcv, params);
// compiled op node returning opresult4276 (depth = 6)
  int op_slot_left_4269 = gc_frame_newslot(opresult4276);
  params[0] = opresult4272;
  partcv[0] = 1;
  Object opresult4277 = callmethod(opresult4276, "&&", 1, partcv, params);
// compiled op node returning opresult4277 (depth = 5)
  Object if4268 = done;
  if (istrue(opresult4277)) {
// Begin line 1786
  setline(1786);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4278 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4279 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_a (depth = 8)
  partcv[0] = 0;
  Object call4280 = callmethod(*var_a, "value",
    1, partcv, params);
  gc_frame_end(callframe4279);
// compiled call node returning call4280 (depth = 7)
// compiled member node returning call4280 (depth = 6)
  gc_frame_newslot(call4280);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block1 (depth = 6)
  params[0] = call4280;
  partcv[0] = 1;
  Object call4281 = callmethod(*var_block1, "apply",
    1, partcv, params);
  gc_frame_end(callframe4278);
// compiled call node returning call4281 (depth = 5)
    gc_frame_newslot(call4281);
    if4268 = call4281;
  } else {
  }
// compiled if node returning if4268 (depth = 4)
  gc_frame_end(frame);
  return if4268;
}
Object meth_collectionsPrelude_valuesDo4248(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "valuesDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method valuesDo");
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for valuesDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for valuesDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1783
  setline(1783);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4249 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4252 = alloc_Float64(1);
// compiled num node returning num4252 (depth = 5)
  int op_slot_right_4251 = gc_frame_newslot(num4252);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4254 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4255 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4256 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4255);
// compiled call node returning call4256 (depth = 8)
// compiled member node returning call4256 (depth = 7)
  partcv[0] = 0;
  Object call4257 = callmethod(call4256, "size",
    1, partcv, params);
  gc_frame_end(callframe4254);
// compiled call node returning call4257 (depth = 6)
// compiled member node returning call4257 (depth = 5)
  int op_slot_left_4251 = gc_frame_newslot(call4257);
  params[0] = num4252;
  partcv[0] = 1;
  Object diff4258 = callmethod(call4257, "-", 1, partcv, params);
// compiled op node returning diff4258 (depth = 4)
  int op_slot_right_4250 = gc_frame_newslot(diff4258);
// starting to compile num node (depth = 4)
  Object num4260 = alloc_Float64(0);
// compiled num node returning num4260 (depth = 4)
  int op_slot_left_4250 = gc_frame_newslot(num4260);
  params[0] = diff4258;
  partcv[0] = 1;
  Object opresult4261 = callmethod(num4260, "..", 1, partcv, params);
// compiled op node returning opresult4261 (depth = 3)
  gc_frame_newslot(opresult4261);
// starting to compile block node (depth = 3)
  Object block4262 = alloc_Block(NULL, NULL, "collectionsPrelude", 1783);
  gc_frame_newslot(block4262);
// method "_apply"
  block_savedest(block4262);
  Object closure4263 = createclosure(4, "_apply");
  setclosureframe(closure4263, stackframe);
  addtoclosure(closure4263, var_removed);
  addtoclosure(closure4263, var_unused);
  addtoclosure(closure4263, var_block1);
  addtoclosure(closure4263, selfslot);
  struct UserObject *uo4263 = (struct UserObject*)block4262;
  uo4263->data[0] = (Object)closure4263;
  Method *meth_meth_collectionsPrelude__apply4263 = addmethod2pos(block4262, "_apply", &meth_collectionsPrelude__apply4263, 0);
  int argcv_meth_collectionsPrelude__apply4263[] = {1};
  meth_meth_collectionsPrelude__apply4263->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4263);
  meth_meth_collectionsPrelude__apply4263->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4263->definitionLine = 1783;
// compiled block node returning block4262 (depth = 3)
  gc_frame_newslot(block4262);
// call case 5: prelude request
  params[0] = opresult4261;
  params[1] = block4262;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4283 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4249);
// compiled call node returning call4283 (depth = 2)
  gc_frame_end(frame);
  return call4283;
}
Object meth_collectionsPrelude_do4284(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for do");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1790
  setline(1790);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4285 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_block1 (depth = 3)
  gc_frame_newslot(*var_block1);
// call case 4: self request
  params[0] = *var_block1;
  partcv[0] = 1;
  Object call4286 = callmethodflags(self, "valuesDo", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4285);
// compiled call node returning call4286 (depth = 2)
  gc_frame_end(frame);
  return call4286;
}
Object meth_collectionsPrelude__apply4308(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile return node (depth = 10)
// starting to compile identifier node (depth = 11)
  Object bool4309 = alloc_Boolean(0);
// compiled identifier node returning bool4309 (depth = 11)
  block_return(realself, bool4309);
// compiled return node returning undefined (depth = 10)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply4302(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_o = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1797
  setline(1797);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_v (depth = 8)
  int op_slot_right_4304 = gc_frame_newslot(*var_v);
// starting to compile call node (depth = 8)
  int callframe4306 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_k (depth = 9)
  gc_frame_newslot(*var_k);
// starting to compile block node (depth = 9)
  Object block4307 = alloc_Block(NULL, NULL, "collectionsPrelude", 1797);
  gc_frame_newslot(block4307);
// method "_apply"
  block_savedest(block4307);
  Object closure4308 = createclosure(1, "_apply");
  setclosureframe(closure4308, stackframe);
  addtoclosure(closure4308, selfslot);
  struct UserObject *uo4308 = (struct UserObject*)block4307;
  uo4308->data[0] = (Object)closure4308;
  Method *meth_meth_collectionsPrelude__apply4308 = addmethod2pos(block4307, "_apply", &meth_collectionsPrelude__apply4308, 0);
  int argcv_meth_collectionsPrelude__apply4308[] = {0};
  meth_meth_collectionsPrelude__apply4308->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4308);
  meth_meth_collectionsPrelude__apply4308->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4308->definitionLine = 1795;
// compiled block node returning block4307 (depth = 9)
  gc_frame_newslot(block4307);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_o (depth = 9)
  params[0] = *var_k;
  params[1] = block4307;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4311 = callmethod(*var_o, "at()ifAbsent",
    2, partcv, params);
  gc_frame_end(callframe4306);
// compiled call node returning call4311 (depth = 8)
  int op_slot_left_4304 = gc_frame_newslot(call4311);
  params[0] = *var_v;
  partcv[0] = 1;
  Object opresult4312 = callmethod(call4311, "≠", 1, partcv, params);
// compiled op node returning opresult4312 (depth = 7)
  Object if4303 = done;
  if (istrue(opresult4312)) {
// Begin line 1798
  setline(1798);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool4313 = alloc_Boolean(0);
// compiled identifier node returning bool4313 (depth = 8)
  block_return(realself, bool4313);
// compiled return node returning undefined (depth = 7)
    gc_frame_newslot(undefined);
    if4303 = undefined;
  } else {
  }
// compiled if node returning if4303 (depth = 6)
  gc_frame_end(frame);
  return if4303;
}
Object meth_collectionsPrelude__apply4290(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1795
  setline(1795);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4293 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_o (depth = 8)
  partcv[0] = 0;
  Object call4294 = callmethod(*var_o, "size",
    1, partcv, params);
  gc_frame_end(callframe4293);
// compiled call node returning call4294 (depth = 7)
// compiled member node returning call4294 (depth = 6)
  int op_slot_right_4292 = gc_frame_newslot(call4294);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4296 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4297 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4296);
// compiled call node returning call4297 (depth = 7)
// compiled member node returning call4297 (depth = 6)
  int op_slot_left_4292 = gc_frame_newslot(call4297);
  params[0] = call4294;
  partcv[0] = 1;
  Object opresult4298 = callmethod(call4297, "≠", 1, partcv, params);
// compiled op node returning opresult4298 (depth = 5)
  Object if4291 = done;
  if (istrue(opresult4298)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4299 = alloc_Boolean(0);
// compiled identifier node returning bool4299 (depth = 6)
  block_return(realself, bool4299);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4291 = undefined;
  } else {
  }
// compiled if node returning if4291 (depth = 4)
// Begin line 1796
  setline(1796);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4300 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block4301 = alloc_Block(NULL, NULL, "collectionsPrelude", 1796);
  gc_frame_newslot(block4301);
// method "_apply"
  block_savedest(block4301);
  Object closure4302 = createclosure(2, "_apply");
  setclosureframe(closure4302, stackframe);
  addtoclosure(closure4302, var_o);
  addtoclosure(closure4302, selfslot);
  struct UserObject *uo4302 = (struct UserObject*)block4301;
  uo4302->data[0] = (Object)closure4302;
  Method *meth_meth_collectionsPrelude__apply4302 = addmethod2pos(block4301, "_apply", &meth_collectionsPrelude__apply4302, 0);
  int argcv_meth_collectionsPrelude__apply4302[] = {2};
  meth_meth_collectionsPrelude__apply4302->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4302);
  meth_meth_collectionsPrelude__apply4302->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4302->definitionLine = 1795;
// compiled block node returning block4301 (depth = 5)
  gc_frame_newslot(block4301);
// call case 4: self request
  params[0] = block4301;
  partcv[0] = 1;
  Object call4315 = callmethodflags(self, "keysAndValuesDo", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4300);
// compiled call node returning call4315 (depth = 4)
// Begin line 1801
  setline(1801);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4316 = alloc_Boolean(1);
// compiled identifier node returning bool4316 (depth = 5)
  block_return(realself, bool4316);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply4328(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___19 = &(stackframe->slots[0]);
  *var___19 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1804
  setline(1804);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4329 = alloc_Boolean(0);
// compiled identifier node returning bool4329 (depth = 5)
  block_return(realself, bool4329);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__61__61_4287(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==");
  Object params[2];
  int partcv[1];
  Object *var_ComparableToDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1793
  setline(1793);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  int frame4288 = gc_frame_new();
  gc_frame_newslot(*var_other);
// Begin line 1794
  setline(1794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4289 = alloc_Block(NULL, NULL, "collectionsPrelude", 1794);
  gc_frame_newslot(block4289);
// method "_apply"
  block_savedest(block4289);
  Object closure4290 = createclosure(1, "_apply");
  setclosureframe(closure4290, stackframe);
  addtoclosure(closure4290, selfslot);
  struct UserObject *uo4290 = (struct UserObject*)block4289;
  uo4290->data[0] = (Object)closure4290;
  Method *meth_meth_collectionsPrelude__apply4290 = addmethod2pos(block4289, "_apply", &meth_collectionsPrelude__apply4290, 0);
  int argcv_meth_collectionsPrelude__apply4290[] = {1};
  meth_meth_collectionsPrelude__apply4290->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4290);
  meth_meth_collectionsPrelude__apply4290->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4290->definitionLine = 1786;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4318 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe4319 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4320 == NULL) {
    strlit4320 = alloc_String("o");
    gc_root(strlit4320);
  }
// compiled string node returning strlit4320 (depth = 6)
  gc_frame_newslot(strlit4320);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4321 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4322 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4321);
// compiled call node returning call4322 (depth = 7)
// compiled member node returning call4322 (depth = 6)
  params[0] = strlit4320;
  partcv[0] = 1;
  Object call4323 = callmethod(call4322, "new",
    1, partcv, params);
  gc_frame_end(callframe4319);
// compiled call node returning call4323 (depth = 5)
  gc_frame_newslot(call4323);
// Begin line 1794
  setline(1794);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ComparableToDictionary (depth = 5)
  gc_frame_newslot(*var_ComparableToDictionary);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4324 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4325 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4324);
// compiled call node returning call4325 (depth = 6)
// compiled member node returning call4325 (depth = 5)
  params[0] = call4323;
  params[1] = *var_ComparableToDictionary;
  partcv[0] = 2;
  Object call4326 = callmethod(call4325, "new",
    1, partcv, params);
  gc_frame_end(callframe4318);
// compiled call node returning call4326 (depth = 4)
((struct UserObject *)block4289)->data[1] = call4326;
// compiled block node returning block4289 (depth = 3)
  gc_frame_newslot(block4289);
// Begin line 1803
  setline(1803);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4327 = alloc_Block(NULL, NULL, "collectionsPrelude", 1803);
  gc_frame_newslot(block4327);
// method "_apply"
  block_savedest(block4327);
  Object closure4328 = createclosure(1, "_apply");
  setclosureframe(closure4328, stackframe);
  addtoclosure(closure4328, selfslot);
  struct UserObject *uo4328 = (struct UserObject*)block4327;
  uo4328->data[0] = (Object)closure4328;
  Method *meth_meth_collectionsPrelude__apply4328 = addmethod2pos(block4327, "_apply", &meth_collectionsPrelude__apply4328, 0);
  int argcv_meth_collectionsPrelude__apply4328[] = {1};
  meth_meth_collectionsPrelude__apply4328->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4328);
  meth_meth_collectionsPrelude__apply4328->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4328->definitionLine = 0;
// compiled block node returning block4327 (depth = 3)
  gc_frame_newslot(block4327);
  params[0] = block4289;
  params[1] = block4327;
  Object matchres4288 = matchCase(*var_other, params, 2,NULL);
  gc_frame_end(frame4288);
// compiled matchcase node returning matchres4288 (depth = 2)
  gc_frame_end(frame);
  return matchres4288;
}
Object meth_collectionsPrelude__apply4342(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_newCopy = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1811
  setline(1811);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4343 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newCopy (depth = 5)
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4344 = callmethod(*var_newCopy, "at()put",
    2, partcv, params);
  gc_frame_end(callframe4343);
// compiled call node returning call4344 (depth = 4)
  gc_frame_end(frame);
  return call4344;
}
Object meth_collectionsPrelude_copy4331(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "copy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for copy (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for copy");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newCopy = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "newCopy");
// Begin line 1809
  setline(1809);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4332 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4333 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4334 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4335 = gc_frame_new();
// call case 3: self.outer request
  Object call4336 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4335);
// compiled call node returning call4336 (depth = 10)
// compiled member node returning call4336 (depth = 9)
  partcv[0] = 0;
  Object call4337 = callmethodflags(call4336, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4334);
// compiled call node returning call4337 (depth = 8)
// compiled member node returning call4337 (depth = 7)
  partcv[0] = 0;
  Object call4338 = callmethodflags(call4337, "dictionary", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4333);
// compiled call node returning call4338 (depth = 6)
// compiled member node returning call4338 (depth = 5)
  partcv[0] = 0;
  Object call4339 = callmethod(call4338, "empty",
    1, partcv, params);
  gc_frame_end(callframe4332);
// compiled call node returning call4339 (depth = 4)
// compiled member node returning call4339 (depth = 3)
  *var_newCopy = call4339;
  if (call4339 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1810
  setline(1810);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4340 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4341 = alloc_Block(NULL, NULL, "collectionsPrelude", 1810);
  gc_frame_newslot(block4341);
// method "_apply"
  block_savedest(block4341);
  Object closure4342 = createclosure(2, "_apply");
  setclosureframe(closure4342, stackframe);
  addtoclosure(closure4342, var_newCopy);
  addtoclosure(closure4342, selfslot);
  struct UserObject *uo4342 = (struct UserObject*)block4341;
  uo4342->data[0] = (Object)closure4342;
  Method *meth_meth_collectionsPrelude__apply4342 = addmethod2pos(block4341, "_apply", &meth_collectionsPrelude__apply4342, 0);
  int argcv_meth_collectionsPrelude__apply4342[] = {2};
  meth_meth_collectionsPrelude__apply4342->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4342);
  meth_meth_collectionsPrelude__apply4342->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4342->definitionLine = 1809;
// compiled block node returning block4341 (depth = 3)
  gc_frame_newslot(block4341);
// call case 4: self request
  params[0] = block4341;
  partcv[0] = 1;
  Object call4346 = callmethodflags(self, "keysAndValuesDo", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4340);
// compiled call node returning call4346 (depth = 2)
// Begin line 1813
  setline(1813);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_newCopy (depth = 2)
  gc_frame_end(frame);
  return *var_newCopy;
}
Object meth_collectionsPrelude_asDictionary4347(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asDictionary (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asDictionary");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1817
  setline(1817);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply4353(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_newDict = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1823
  setline(1823);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4354 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_k (depth = 5)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_newDict (depth = 5)
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4355 = callmethod(*var_newDict, "at()put",
    2, partcv, params);
  gc_frame_end(callframe4354);
// compiled call node returning call4355 (depth = 4)
  gc_frame_end(frame);
  return call4355;
}
Object meth_collectionsPrelude__43__43_4348(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++ (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ++");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newDict = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newDict");
// Begin line 1821
  setline(1821);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4349 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4350 = callmethodflags(self, "copy", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4349);
// compiled call node returning call4350 (depth = 4)
// compiled member node returning call4350 (depth = 3)
  *var_newDict = call4350;
  if (call4350 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1822
  setline(1822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4351 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4352 = alloc_Block(NULL, NULL, "collectionsPrelude", 1822);
  gc_frame_newslot(block4352);
// method "_apply"
  block_savedest(block4352);
  Object closure4353 = createclosure(2, "_apply");
  setclosureframe(closure4353, stackframe);
  addtoclosure(closure4353, var_newDict);
  addtoclosure(closure4353, selfslot);
  struct UserObject *uo4353 = (struct UserObject*)block4352;
  uo4353->data[0] = (Object)closure4353;
  Method *meth_meth_collectionsPrelude__apply4353 = addmethod2pos(block4352, "_apply", &meth_collectionsPrelude__apply4353, 0);
  int argcv_meth_collectionsPrelude__apply4353[] = {2};
  meth_meth_collectionsPrelude__apply4353->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4353);
  meth_meth_collectionsPrelude__apply4353->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4353->definitionLine = 1821;
// compiled block node returning block4352 (depth = 3)
  gc_frame_newslot(block4352);
// call case 6: other member request
// Begin line 1822
  setline(1822);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  params[0] = block4352;
  partcv[0] = 1;
  Object call4357 = callmethod(*var_other, "keysAndValuesDo",
    1, partcv, params);
  gc_frame_end(callframe4351);
// compiled call node returning call4357 (depth = 2)
// Begin line 1825
  setline(1825);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_newDict (depth = 3)
  return *var_newDict;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply4369(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_other = getfromclosure(closure, 0);
  Object *var_newDict = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1831
  setline(1831);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4371 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe4372 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_k (depth = 7)
  gc_frame_newslot(*var_k);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_other (depth = 7)
  params[0] = *var_k;
  partcv[0] = 1;
  Object call4373 = callmethod(*var_other, "containsKey",
    1, partcv, params);
  gc_frame_end(callframe4372);
// compiled call node returning call4373 (depth = 6)
  partcv[0] = 0;
  Object call4374 = callmethod(call4373, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe4371);
// compiled call node returning call4374 (depth = 5)
  Object if4370 = done;
  if (istrue(call4374)) {
// Begin line 1832
  setline(1832);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4375 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_newDict (depth = 6)
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4376 = callmethod(*var_newDict, "at()put",
    2, partcv, params);
  gc_frame_end(callframe4375);
// compiled call node returning call4376 (depth = 5)
    gc_frame_newslot(call4376);
    if4370 = call4376;
  } else {
  }
// compiled if node returning if4370 (depth = 4)
  gc_frame_end(frame);
  return if4370;
}
Object meth_collectionsPrelude__45__45_4358(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "--");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method --");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for -- (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for --");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_newDict = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "newDict");
// Begin line 1829
  setline(1829);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4359 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4360 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4361 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4362 = gc_frame_new();
// call case 3: self.outer request
  Object call4363 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4362);
// compiled call node returning call4363 (depth = 10)
// compiled member node returning call4363 (depth = 9)
  partcv[0] = 0;
  Object call4364 = callmethodflags(call4363, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4361);
// compiled call node returning call4364 (depth = 8)
// compiled member node returning call4364 (depth = 7)
  partcv[0] = 0;
  Object call4365 = callmethodflags(call4364, "dictionary", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4360);
// compiled call node returning call4365 (depth = 6)
// compiled member node returning call4365 (depth = 5)
  partcv[0] = 0;
  Object call4366 = callmethod(call4365, "empty",
    1, partcv, params);
  gc_frame_end(callframe4359);
// compiled call node returning call4366 (depth = 4)
// compiled member node returning call4366 (depth = 3)
  *var_newDict = call4366;
  if (call4366 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1830
  setline(1830);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4367 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4368 = alloc_Block(NULL, NULL, "collectionsPrelude", 1830);
  gc_frame_newslot(block4368);
// method "_apply"
  block_savedest(block4368);
  Object closure4369 = createclosure(3, "_apply");
  setclosureframe(closure4369, stackframe);
  addtoclosure(closure4369, var_other);
  addtoclosure(closure4369, var_newDict);
  addtoclosure(closure4369, selfslot);
  struct UserObject *uo4369 = (struct UserObject*)block4368;
  uo4369->data[0] = (Object)closure4369;
  Method *meth_meth_collectionsPrelude__apply4369 = addmethod2pos(block4368, "_apply", &meth_collectionsPrelude__apply4369, 0);
  int argcv_meth_collectionsPrelude__apply4369[] = {2};
  meth_meth_collectionsPrelude__apply4369->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4369);
  meth_meth_collectionsPrelude__apply4369->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4369->definitionLine = 1829;
// compiled block node returning block4368 (depth = 3)
  gc_frame_newslot(block4368);
// call case 4: self request
  params[0] = block4368;
  partcv[0] = 1;
  Object call4378 = callmethodflags(self, "keysAndValuesDo", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4367);
// compiled call node returning call4378 (depth = 2)
// Begin line 1835
  setline(1835);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_newDict (depth = 3)
  return *var_newDict;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply4402(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_unused = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1491
  setline(1491);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4403 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_unused (depth = 5)
  gc_frame_newslot(*var_unused);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4404 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4405 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4404);
// compiled call node returning call4405 (depth = 6)
// compiled member node returning call4405 (depth = 5)
  params[0] = *var_i;
  params[1] = *var_unused;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4406 = callmethod(call4405, "at()put",
    2, partcv, params);
  gc_frame_end(callframe4403);
// compiled call node returning call4406 (depth = 4)
  gc_frame_end(frame);
  return call4406;
}
Object meth_collectionsPrelude_empty3094(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "empty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_binding = getfromclosure(closure, 2);
  Object *var_NoSuchObject = getfromclosure(closure, 3);
  Object *var_enumerable = getfromclosure(closure, 4);
  Object *var_ConcurrentModification = getfromclosure(closure, 5);
  Object *var_IteratorExhausted = getfromclosure(closure, 6);
  Object *var__prelude = getfromclosure(closure, 7);
  Object *var_ComparableToDictionary = getfromclosure(closure, 8);
  Object *var_collection = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for empty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for empty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3095 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3095 = alloc_userobj2(43,41, objclass3095);
  gc_frame_newslot(obj3095);
if (objclass3095 == NULL) {
  glfree(obj3095->class->name);
  obj3095->class->name = "collectionsPrelude.dictionary.empty";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3095, self, 0);
  addmethodreal(obj3095,"outer", &reader_collectionsPrelude_outer_3096);
  Object oldself3095 = self;
  struct StackFrameObject *oldstackframe3095 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3095);
  gc_frame_newslot((Object)stackframe);
  self = obj3095;
  Object *oldselfslot3095 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3095 = (*(struct UserObject *)self).data[0], lowerouter3095 = thisouter3095;
  if (inheritingObject3095) {
    struct UserObject *inho3095 = (struct UserObject *)inheritingObject3095;
    while (inho3095->super != GraceDefaultObject) inho3095 = (struct UserObject *)inho3095->super;
    inho3095->super = obj3095;
    self = inheritingObject3095;
    *selfslot = self;
    lowerouter3095 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3095;
  }
if (objclass3095 == NULL) {
  Method *reader3097 = addmethodrealflags(obj3095, "mods",&reader_collectionsPrelude_mods_3097, 0);
  Method *writer3097 = addmethodrealflags(obj3095, "mods:=",&writer_collectionsPrelude_mods_3097, MFLAG_CONFIDENTIAL);
  reader3097->definitionModule = modulename;
  writer3097->definitionModule = modulename;
  reader3097->definitionLine = 1487;
  writer3097->definitionLine = 1487;
}
obj3095->flags |= OFLAG_MUTABLE;
adddatum2(obj3095, alloc_Undefined(), 1);
if (objclass3095 == NULL) {
  Method *reader3098 = addmethodrealflags(obj3095, "numBindings",&reader_collectionsPrelude_numBindings_3098, MFLAG_CONFIDENTIAL);
  Method *writer3098 = addmethodrealflags(obj3095, "numBindings:=",&writer_collectionsPrelude_numBindings_3098, MFLAG_CONFIDENTIAL);
  reader3098->definitionModule = modulename;
  writer3098->definitionModule = modulename;
  reader3098->definitionLine = 1488;
  writer3098->definitionLine = 1488;
}
obj3095->flags |= OFLAG_MUTABLE;
adddatum2(obj3095, alloc_Undefined(), 2);
if (objclass3095 == NULL) {
  Method *reader3099 = addmethodrealflags(obj3095, "inner",&reader_collectionsPrelude_inner_3099, MFLAG_CONFIDENTIAL);
  Method *writer3099 = addmethodrealflags(obj3095, "inner:=",&writer_collectionsPrelude_inner_3099, MFLAG_CONFIDENTIAL);
  reader3099->definitionModule = modulename;
  writer3099->definitionModule = modulename;
  reader3099->definitionLine = 1489;
  writer3099->definitionLine = 1489;
}
obj3095->flags |= OFLAG_MUTABLE;
adddatum2(obj3095, alloc_Undefined(), 3);
// method "size"
  struct UserObject *uo3100 = (struct UserObject*)obj3095;
  uo3100->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size3100 = addmethod2pos(obj3095, "size", &meth_collectionsPrelude_size3100, 4);
  int argcv_meth_collectionsPrelude_size3100[] = {0};
  meth_meth_collectionsPrelude_size3100->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size3100);
  meth_meth_collectionsPrelude_size3100->definitionModule = modulename;
  meth_meth_collectionsPrelude_size3100->definitionLine = 1493;
// method "at()put"
  block_savedest(obj3095);
  Object closure3103 = createclosure(3, "at()put");
  setclosureframe(closure3103, stackframe);
  addtoclosure(closure3103, var_removed);
  addtoclosure(closure3103, var_unused);
  addtoclosure(closure3103, var_binding);
  struct UserObject *uo3103 = (struct UserObject*)obj3095;
  uo3103->data[5] = (Object)closure3103;
  Method *meth_meth_collectionsPrelude_at_40__41_put3103 = addmethod2pos(obj3095, "at()put", &meth_collectionsPrelude_at_40__41_put3103, 5);
  int argcv_meth_collectionsPrelude_at_40__41_put3103[] = {1, 1};
  meth_meth_collectionsPrelude_at_40__41_put3103->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40__41_put3103);
  meth_meth_collectionsPrelude_at_40__41_put3103->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40__41_put3103->definitionLine = 1494;
// method "add"
  block_savedest(obj3095);
  Object closure3162 = createclosure(2, "add");
  setclosureframe(closure3162, stackframe);
  addtoclosure(closure3162, var_removed);
  addtoclosure(closure3162, var_unused);
  struct UserObject *uo3162 = (struct UserObject*)obj3095;
  uo3162->data[6] = (Object)closure3162;
  Method *meth_meth_collectionsPrelude_add3162 = addmethod2pos(obj3095, "add", &meth_collectionsPrelude_add3162, 6);
  int argcv_meth_collectionsPrelude_add3162[] = {1};
  meth_meth_collectionsPrelude_add3162->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add3162);
  meth_meth_collectionsPrelude_add3162->definitionModule = modulename;
  meth_meth_collectionsPrelude_add3162->definitionLine = 1504;
// method "at"
  block_savedest(obj3095);
  Object closure3221 = createclosure(1, "at");
  setclosureframe(closure3221, stackframe);
  addtoclosure(closure3221, var_NoSuchObject);
  struct UserObject *uo3221 = (struct UserObject*)obj3095;
  uo3221->data[7] = (Object)closure3221;
  Method *meth_meth_collectionsPrelude_at3221 = addmethod2pos(obj3095, "at", &meth_collectionsPrelude_at3221, 7);
  int argcv_meth_collectionsPrelude_at3221[] = {1};
  meth_meth_collectionsPrelude_at3221->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at3221);
  meth_meth_collectionsPrelude_at3221->definitionModule = modulename;
  meth_meth_collectionsPrelude_at3221->definitionLine = 1514;
// method "at()ifAbsent"
  struct UserObject *uo3246 = (struct UserObject*)obj3095;
  uo3246->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40__41_ifAbsent3246 = addmethod2pos(obj3095, "at()ifAbsent", &meth_collectionsPrelude_at_40__41_ifAbsent3246, 8);
  int argcv_meth_collectionsPrelude_at_40__41_ifAbsent3246[] = {1, 1};
  meth_meth_collectionsPrelude_at_40__41_ifAbsent3246->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40__41_ifAbsent3246);
  meth_meth_collectionsPrelude_at_40__41_ifAbsent3246->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40__41_ifAbsent3246->definitionLine = 1521;
// method "containsKey"
  struct UserObject *uo3263 = (struct UserObject*)obj3095;
  uo3263->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_containsKey3263 = addmethod2pos(obj3095, "containsKey", &meth_collectionsPrelude_containsKey3263, 9);
  int argcv_meth_collectionsPrelude_containsKey3263[] = {1};
  meth_meth_collectionsPrelude_containsKey3263->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_containsKey3263);
  meth_meth_collectionsPrelude_containsKey3263->definitionModule = modulename;
  meth_meth_collectionsPrelude_containsKey3263->definitionLine = 1528;
// method "removeAllKeys"
  block_savedest(obj3095);
  Object closure3278 = createclosure(2, "removeAllKeys");
  setclosureframe(closure3278, stackframe);
  addtoclosure(closure3278, var_removed);
  addtoclosure(closure3278, var_NoSuchObject);
  struct UserObject *uo3278 = (struct UserObject*)obj3095;
  uo3278->data[10] = (Object)closure3278;
  Method *meth_meth_collectionsPrelude_removeAllKeys3278 = addmethod2pos(obj3095, "removeAllKeys", &meth_collectionsPrelude_removeAllKeys3278, 10);
  int argcv_meth_collectionsPrelude_removeAllKeys3278[] = {1};
  meth_meth_collectionsPrelude_removeAllKeys3278->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAllKeys3278);
  meth_meth_collectionsPrelude_removeAllKeys3278->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAllKeys3278->definitionLine = 1535;
// method "removeKey"
  block_savedest(obj3095);
  Object closure3326 = createclosure(2, "removeKey");
  setclosureframe(closure3326, stackframe);
  addtoclosure(closure3326, var_removed);
  addtoclosure(closure3326, var_NoSuchObject);
  struct UserObject *uo3326 = (struct UserObject*)obj3095;
  uo3326->data[11] = (Object)closure3326;
  Method *meth_meth_collectionsPrelude_removeKey3326 = addmethod2pos(obj3095, "removeKey", &meth_collectionsPrelude_removeKey3326, 11);
  int argcv_meth_collectionsPrelude_removeKey3326[] = {1};
  meth_meth_collectionsPrelude_removeKey3326->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeKey3326);
  meth_meth_collectionsPrelude_removeKey3326->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeKey3326->definitionLine = 1548;
// method "removeAllValues"
  block_savedest(obj3095);
  Object closure3369 = createclosure(1, "removeAllValues");
  setclosureframe(closure3369, stackframe);
  addtoclosure(closure3369, var_removed);
  struct UserObject *uo3369 = (struct UserObject*)obj3095;
  uo3369->data[12] = (Object)closure3369;
  Method *meth_meth_collectionsPrelude_removeAllValues3369 = addmethod2pos(obj3095, "removeAllValues", &meth_collectionsPrelude_removeAllValues3369, 12);
  int argcv_meth_collectionsPrelude_removeAllValues3369[] = {1};
  meth_meth_collectionsPrelude_removeAllValues3369->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAllValues3369);
  meth_meth_collectionsPrelude_removeAllValues3369->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAllValues3369->definitionLine = 1559;
// method "removeValue"
  block_savedest(obj3095);
  Object closure3416 = createclosure(2, "removeValue");
  setclosureframe(closure3416, stackframe);
  addtoclosure(closure3416, var_removed);
  addtoclosure(closure3416, var_NoSuchObject);
  struct UserObject *uo3416 = (struct UserObject*)obj3095;
  uo3416->data[13] = (Object)closure3416;
  Method *meth_meth_collectionsPrelude_removeValue3416 = addmethod2pos(obj3095, "removeValue", &meth_collectionsPrelude_removeValue3416, 13);
  int argcv_meth_collectionsPrelude_removeValue3416[] = {1};
  meth_meth_collectionsPrelude_removeValue3416->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeValue3416);
  meth_meth_collectionsPrelude_removeValue3416->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeValue3416->definitionLine = 1570;
// method "removeValue()ifAbsent"
  block_savedest(obj3095);
  Object closure3482 = createclosure(1, "removeValue()ifAbsent");
  setclosureframe(closure3482, stackframe);
  addtoclosure(closure3482, var_removed);
  struct UserObject *uo3482 = (struct UserObject*)obj3095;
  uo3482->data[14] = (Object)closure3482;
  Method *meth_meth_collectionsPrelude_removeValue_40__41_ifAbsent3482 = addmethod2pos(obj3095, "removeValue()ifAbsent", &meth_collectionsPrelude_removeValue_40__41_ifAbsent3482, 14);
  int argcv_meth_collectionsPrelude_removeValue_40__41_ifAbsent3482[] = {1, 1};
  meth_meth_collectionsPrelude_removeValue_40__41_ifAbsent3482->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeValue_40__41_ifAbsent3482);
  meth_meth_collectionsPrelude_removeValue_40__41_ifAbsent3482->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeValue_40__41_ifAbsent3482->definitionLine = 1586;
// method "containsValue"
  struct UserObject *uo3540 = (struct UserObject*)obj3095;
  uo3540->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_containsValue3540 = addmethod2pos(obj3095, "containsValue", &meth_collectionsPrelude_containsValue3540, 15);
  int argcv_meth_collectionsPrelude_containsValue3540[] = {1};
  meth_meth_collectionsPrelude_containsValue3540->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_containsValue3540);
  meth_meth_collectionsPrelude_containsValue3540->definitionModule = modulename;
  meth_meth_collectionsPrelude_containsValue3540->definitionLine = 1602;
// method "contains"
  struct UserObject *uo3552 = (struct UserObject*)obj3095;
  uo3552->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains3552 = addmethod2pos(obj3095, "contains", &meth_collectionsPrelude_contains3552, 16);
  int argcv_meth_collectionsPrelude_contains3552[] = {1};
  meth_meth_collectionsPrelude_contains3552->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains3552);
  meth_meth_collectionsPrelude_contains3552->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains3552->definitionLine = 1608;
// method "findPosition"
  block_savedest(obj3095);
  Object closure3555 = createclosure(1, "findPosition");
  setclosureframe(closure3555, stackframe);
  addtoclosure(closure3555, var_unused);
  struct UserObject *uo3555 = (struct UserObject*)obj3095;
  uo3555->data[17] = (Object)closure3555;
  Method *meth_meth_collectionsPrelude_findPosition3555 = addmethod2pos(obj3095, "findPosition", &meth_collectionsPrelude_findPosition3555, 17);
  int argcv_meth_collectionsPrelude_findPosition3555[] = {1};
  meth_meth_collectionsPrelude_findPosition3555->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPosition3555);
  meth_meth_collectionsPrelude_findPosition3555->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPosition3555->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPosition3555->definitionLine = 1610;
// method "findPositionForAdd"
  block_savedest(obj3095);
  Object closure3621 = createclosure(2, "findPositionForAdd");
  setclosureframe(closure3621, stackframe);
  addtoclosure(closure3621, var_removed);
  addtoclosure(closure3621, var_unused);
  struct UserObject *uo3621 = (struct UserObject*)obj3095;
  uo3621->data[18] = (Object)closure3621;
  Method *meth_meth_collectionsPrelude_findPositionForAdd3621 = addmethod2pos(obj3095, "findPositionForAdd", &meth_collectionsPrelude_findPositionForAdd3621, 18);
  int argcv_meth_collectionsPrelude_findPositionForAdd3621[] = {1};
  meth_meth_collectionsPrelude_findPositionForAdd3621->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPositionForAdd3621);
  meth_meth_collectionsPrelude_findPositionForAdd3621->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPositionForAdd3621->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPositionForAdd3621->definitionLine = 1628;
// method "asString"
  block_savedest(obj3095);
  Object closure3697 = createclosure(2, "asString");
  setclosureframe(closure3697, stackframe);
  addtoclosure(closure3697, var_removed);
  addtoclosure(closure3697, var_unused);
  struct UserObject *uo3697 = (struct UserObject*)obj3095;
  uo3697->data[19] = (Object)closure3697;
  Method *meth_meth_collectionsPrelude_asString3697 = addmethod2pos(obj3095, "asString", &meth_collectionsPrelude_asString3697, 19);
  int argcv_meth_collectionsPrelude_asString3697[] = {0};
  meth_meth_collectionsPrelude_asString3697->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3697);
  meth_meth_collectionsPrelude_asString3697->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3697->definitionLine = 1646;
// method "asDebugString"
  block_savedest(obj3095);
  Object closure3768 = createclosure(2, "asDebugString");
  setclosureframe(closure3768, stackframe);
  addtoclosure(closure3768, var_removed);
  addtoclosure(closure3768, var_unused);
  struct UserObject *uo3768 = (struct UserObject*)obj3095;
  uo3768->data[20] = (Object)closure3768;
  Method *meth_meth_collectionsPrelude_asDebugString3768 = addmethod2pos(obj3095, "asDebugString", &meth_collectionsPrelude_asDebugString3768, 20);
  int argcv_meth_collectionsPrelude_asDebugString3768[] = {0};
  meth_meth_collectionsPrelude_asDebugString3768->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3768);
  meth_meth_collectionsPrelude_asDebugString3768->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3768->definitionLine = 1664;
// method "keys"
  block_savedest(obj3095);
  Object closure3866 = createclosure(1, "keys");
  setclosureframe(closure3866, stackframe);
  addtoclosure(closure3866, var_enumerable);
  struct UserObject *uo3866 = (struct UserObject*)obj3095;
  uo3866->data[21] = (Object)closure3866;
  Method *meth_meth_collectionsPrelude_keys3866 = addmethod2pos(obj3095, "keys", &meth_collectionsPrelude_keys3866, 21);
  int argcv_meth_collectionsPrelude_keys3866[] = {0};
  meth_meth_collectionsPrelude_keys3866->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys3866);
  meth_meth_collectionsPrelude_keys3866->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys3866->definitionLine = 1677;
  block_savedest(obj3095);
  Object closure3911 = createclosure(1, "keys()object");
  setclosureframe(closure3911, stackframe);
  addtoclosure(closure3911, var_enumerable);
  Method *meth_meth_collectionsPrelude_keys3866_object = addmethod2pos(obj3095, "keys()object", &meth_collectionsPrelude_keys3866_object, 21);
  meth_meth_collectionsPrelude_keys3866_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys3866_object->definitionLine = 1677;
// method "values"
  block_savedest(obj3095);
  Object closure3912 = createclosure(1, "values");
  setclosureframe(closure3912, stackframe);
  addtoclosure(closure3912, var_enumerable);
  struct UserObject *uo3912 = (struct UserObject*)obj3095;
  uo3912->data[22] = (Object)closure3912;
  Method *meth_meth_collectionsPrelude_values3912 = addmethod2pos(obj3095, "values", &meth_collectionsPrelude_values3912, 22);
  int argcv_meth_collectionsPrelude_values3912[] = {0};
  meth_meth_collectionsPrelude_values3912->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values3912);
  meth_meth_collectionsPrelude_values3912->definitionModule = modulename;
  meth_meth_collectionsPrelude_values3912->definitionLine = 1695;
  block_savedest(obj3095);
  Object closure3957 = createclosure(1, "values()object");
  setclosureframe(closure3957, stackframe);
  addtoclosure(closure3957, var_enumerable);
  Method *meth_meth_collectionsPrelude_values3912_object = addmethod2pos(obj3095, "values()object", &meth_collectionsPrelude_values3912_object, 22);
  meth_meth_collectionsPrelude_values3912_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_values3912_object->definitionLine = 1695;
// method "bindings"
  block_savedest(obj3095);
  Object closure3958 = createclosure(1, "bindings");
  setclosureframe(closure3958, stackframe);
  addtoclosure(closure3958, var_enumerable);
  struct UserObject *uo3958 = (struct UserObject*)obj3095;
  uo3958->data[23] = (Object)closure3958;
  Method *meth_meth_collectionsPrelude_bindings3958 = addmethod2pos(obj3095, "bindings", &meth_collectionsPrelude_bindings3958, 23);
  int argcv_meth_collectionsPrelude_bindings3958[] = {0};
  meth_meth_collectionsPrelude_bindings3958->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_bindings3958);
  meth_meth_collectionsPrelude_bindings3958->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindings3958->definitionLine = 1714;
  block_savedest(obj3095);
  Object closure3978 = createclosure(1, "bindings()object");
  setclosureframe(closure3978, stackframe);
  addtoclosure(closure3978, var_enumerable);
  Method *meth_meth_collectionsPrelude_bindings3958_object = addmethod2pos(obj3095, "bindings()object", &meth_collectionsPrelude_bindings3958_object, 23);
  meth_meth_collectionsPrelude_bindings3958_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindings3958_object->definitionLine = 1714;
// method "iterator"
  struct UserObject *uo3979 = (struct UserObject*)obj3095;
  uo3979->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iterator3979 = addmethod2pos(obj3095, "iterator", &meth_collectionsPrelude_iterator3979, 24);
  int argcv_meth_collectionsPrelude_iterator3979[] = {0};
  meth_meth_collectionsPrelude_iterator3979->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator3979);
  meth_meth_collectionsPrelude_iterator3979->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3979->definitionLine = 1726;
// method "bindingsIterator"
  block_savedest(obj3095);
  Object closure3984 = createclosure(4, "bindingsIterator");
  setclosureframe(closure3984, stackframe);
  addtoclosure(closure3984, var_ConcurrentModification);
  addtoclosure(closure3984, var_IteratorExhausted);
  addtoclosure(closure3984, var_removed);
  addtoclosure(closure3984, var_unused);
  struct UserObject *uo3984 = (struct UserObject*)obj3095;
  uo3984->data[25] = (Object)closure3984;
  Method *meth_meth_collectionsPrelude_bindingsIterator3984 = addmethod2pos(obj3095, "bindingsIterator", &meth_collectionsPrelude_bindingsIterator3984, 25);
  int argcv_meth_collectionsPrelude_bindingsIterator3984[] = {0};
  meth_meth_collectionsPrelude_bindingsIterator3984->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_bindingsIterator3984);
  meth_meth_collectionsPrelude_bindingsIterator3984->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindingsIterator3984->definitionLine = 1727;
  block_savedest(obj3095);
  Object closure4105 = createclosure(4, "bindingsIterator()object");
  setclosureframe(closure4105, stackframe);
  addtoclosure(closure4105, var_ConcurrentModification);
  addtoclosure(closure4105, var_IteratorExhausted);
  addtoclosure(closure4105, var_removed);
  addtoclosure(closure4105, var_unused);
  Method *meth_meth_collectionsPrelude_bindingsIterator3984_object = addmethod2pos(obj3095, "bindingsIterator()object", &meth_collectionsPrelude_bindingsIterator3984_object, 25);
  meth_meth_collectionsPrelude_bindingsIterator3984_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindingsIterator3984_object->definitionLine = 1727;
// method "expand"
  block_savedest(obj3095);
  Object closure4106 = createclosure(3, "expand");
  setclosureframe(closure4106, stackframe);
  addtoclosure(closure4106, var__prelude);
  addtoclosure(closure4106, var_unused);
  addtoclosure(closure4106, var_removed);
  struct UserObject *uo4106 = (struct UserObject*)obj3095;
  uo4106->data[26] = (Object)closure4106;
  Method *meth_meth_collectionsPrelude_expand4106 = addmethod2pos(obj3095, "expand", &meth_collectionsPrelude_expand4106, 26);
  int argcv_meth_collectionsPrelude_expand4106[] = {0};
  meth_meth_collectionsPrelude_expand4106->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_expand4106);
  meth_meth_collectionsPrelude_expand4106->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_expand4106->definitionModule = modulename;
  meth_meth_collectionsPrelude_expand4106->definitionLine = 1750;
// method "keysAndValuesDo"
  block_savedest(obj3095);
  Object closure4174 = createclosure(2, "keysAndValuesDo");
  setclosureframe(closure4174, stackframe);
  addtoclosure(closure4174, var_removed);
  addtoclosure(closure4174, var_unused);
  struct UserObject *uo4174 = (struct UserObject*)obj3095;
  uo4174->data[27] = (Object)closure4174;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo4174 = addmethod2pos(obj3095, "keysAndValuesDo", &meth_collectionsPrelude_keysAndValuesDo4174, 27);
  int argcv_meth_collectionsPrelude_keysAndValuesDo4174[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo4174->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo4174);
  meth_meth_collectionsPrelude_keysAndValuesDo4174->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo4174->definitionLine = 1766;
// method "keysDo"
  block_savedest(obj3095);
  Object closure4212 = createclosure(2, "keysDo");
  setclosureframe(closure4212, stackframe);
  addtoclosure(closure4212, var_removed);
  addtoclosure(closure4212, var_unused);
  struct UserObject *uo4212 = (struct UserObject*)obj3095;
  uo4212->data[28] = (Object)closure4212;
  Method *meth_meth_collectionsPrelude_keysDo4212 = addmethod2pos(obj3095, "keysDo", &meth_collectionsPrelude_keysDo4212, 28);
  int argcv_meth_collectionsPrelude_keysDo4212[] = {1};
  meth_meth_collectionsPrelude_keysDo4212->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysDo4212);
  meth_meth_collectionsPrelude_keysDo4212->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysDo4212->definitionLine = 1774;
// method "valuesDo"
  block_savedest(obj3095);
  Object closure4248 = createclosure(2, "valuesDo");
  setclosureframe(closure4248, stackframe);
  addtoclosure(closure4248, var_removed);
  addtoclosure(closure4248, var_unused);
  struct UserObject *uo4248 = (struct UserObject*)obj3095;
  uo4248->data[29] = (Object)closure4248;
  Method *meth_meth_collectionsPrelude_valuesDo4248 = addmethod2pos(obj3095, "valuesDo", &meth_collectionsPrelude_valuesDo4248, 29);
  int argcv_meth_collectionsPrelude_valuesDo4248[] = {1};
  meth_meth_collectionsPrelude_valuesDo4248->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_valuesDo4248);
  meth_meth_collectionsPrelude_valuesDo4248->definitionModule = modulename;
  meth_meth_collectionsPrelude_valuesDo4248->definitionLine = 1782;
// method "do"
  struct UserObject *uo4284 = (struct UserObject*)obj3095;
  uo4284->data[30] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do4284 = addmethod2pos(obj3095, "do", &meth_collectionsPrelude_do4284, 30);
  int argcv_meth_collectionsPrelude_do4284[] = {1};
  meth_meth_collectionsPrelude_do4284->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do4284);
  meth_meth_collectionsPrelude_do4284->definitionModule = modulename;
  meth_meth_collectionsPrelude_do4284->definitionLine = 1790;
// method "=="
  block_savedest(obj3095);
  Object closure4287 = createclosure(1, "==");
  setclosureframe(closure4287, stackframe);
  addtoclosure(closure4287, var_ComparableToDictionary);
  struct UserObject *uo4287 = (struct UserObject*)obj3095;
  uo4287->data[31] = (Object)closure4287;
  Method *meth_meth_collectionsPrelude__61__61_4287 = addmethod2pos(obj3095, "==", &meth_collectionsPrelude__61__61_4287, 31);
  int argcv_meth_collectionsPrelude__61__61_4287[] = {1};
  meth_meth_collectionsPrelude__61__61_4287->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_4287);
  meth_meth_collectionsPrelude__61__61_4287->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_4287->definitionLine = 1792;
// method "copy"
  struct UserObject *uo4331 = (struct UserObject*)obj3095;
  uo4331->data[32] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy4331 = addmethod2pos(obj3095, "copy", &meth_collectionsPrelude_copy4331, 32);
  int argcv_meth_collectionsPrelude_copy4331[] = {0};
  meth_meth_collectionsPrelude_copy4331->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy4331);
  meth_meth_collectionsPrelude_copy4331->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy4331->definitionLine = 1808;
// method "asDictionary"
  struct UserObject *uo4347 = (struct UserObject*)obj3095;
  uo4347->data[33] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDictionary4347 = addmethod2pos(obj3095, "asDictionary", &meth_collectionsPrelude_asDictionary4347, 33);
  int argcv_meth_collectionsPrelude_asDictionary4347[] = {0};
  meth_meth_collectionsPrelude_asDictionary4347->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDictionary4347);
  meth_meth_collectionsPrelude_asDictionary4347->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDictionary4347->definitionLine = 1816;
// method "++"
  struct UserObject *uo4348 = (struct UserObject*)obj3095;
  uo4348->data[34] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_4348 = addmethod2pos(obj3095, "++", &meth_collectionsPrelude__43__43_4348, 34);
  int argcv_meth_collectionsPrelude__43__43_4348[] = {1};
  meth_meth_collectionsPrelude__43__43_4348->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_4348);
  meth_meth_collectionsPrelude__43__43_4348->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_4348->definitionLine = 1820;
// method "--"
  struct UserObject *uo4358 = (struct UserObject*)obj3095;
  uo4358->data[35] = emptyclosure;
  Method *meth_meth_collectionsPrelude__45__45_4358 = addmethod2pos(obj3095, "--", &meth_collectionsPrelude__45__45_4358, 35);
  int argcv_meth_collectionsPrelude__45__45_4358[] = {1};
  meth_meth_collectionsPrelude__45__45_4358->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__45__45_4358);
  meth_meth_collectionsPrelude__45__45_4358->definitionModule = modulename;
  meth_meth_collectionsPrelude__45__45_4358->definitionLine = 1828;
  sourceObject = obj3095;
// Begin line 1486
  setline(1486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4379 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collection (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4380 = callmethod(*var_collection, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe4379);
// compiled call node returning call4380 (depth = 2)
  struct UserObject *obj3095_uo = (struct UserObject *)obj3095;
  obj3095_uo->super = call4380;
  sourceObject = obj3095;
// Begin line 1487
  setline(1487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4381 = alloc_Float64(0);
// compiled num node returning num4381 (depth = 2)
  adddatum2(obj3095, num4381, 1);
  sourceObject = obj3095;
// Begin line 1488
  setline(1488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4382 = alloc_Float64(0);
// compiled num node returning num4382 (depth = 2)
  adddatum2(obj3095, num4382, 2);
  sourceObject = obj3095;
// Begin line 1489
  setline(1489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4383 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num4384 = alloc_Float64(8);
// compiled num node returning num4384 (depth = 3)
  gc_frame_newslot(num4384);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4385 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var__prelude (depth = 5)
  partcv[0] = 0;
  Object call4386 = callmethod(*var__prelude, "primitiveArray",
    1, partcv, params);
  gc_frame_end(callframe4385);
// compiled call node returning call4386 (depth = 4)
// compiled member node returning call4386 (depth = 3)
  params[0] = num4384;
  partcv[0] = 1;
  Object call4387 = callmethod(call4386, "new",
    1, partcv, params);
  gc_frame_end(callframe4383);
// compiled call node returning call4387 (depth = 2)
  adddatum2(obj3095, call4387, 3);
  sourceObject = obj3095;
// Begin line 1490
  setline(1490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4388 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4391 = alloc_Float64(1);
// compiled num node returning num4391 (depth = 5)
  int op_slot_right_4390 = gc_frame_newslot(num4391);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4393 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4394 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4395 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4394);
// compiled call node returning call4395 (depth = 8)
// compiled member node returning call4395 (depth = 7)
  partcv[0] = 0;
  Object call4396 = callmethod(call4395, "size",
    1, partcv, params);
  gc_frame_end(callframe4393);
// compiled call node returning call4396 (depth = 6)
// compiled member node returning call4396 (depth = 5)
  int op_slot_left_4390 = gc_frame_newslot(call4396);
  params[0] = num4391;
  partcv[0] = 1;
  Object diff4397 = callmethod(call4396, "-", 1, partcv, params);
// compiled op node returning diff4397 (depth = 4)
  int op_slot_right_4389 = gc_frame_newslot(diff4397);
// starting to compile num node (depth = 4)
  Object num4399 = alloc_Float64(0);
// compiled num node returning num4399 (depth = 4)
  int op_slot_left_4389 = gc_frame_newslot(num4399);
  params[0] = diff4397;
  partcv[0] = 1;
  Object opresult4400 = callmethod(num4399, "..", 1, partcv, params);
// compiled op node returning opresult4400 (depth = 3)
  gc_frame_newslot(opresult4400);
// starting to compile block node (depth = 3)
  Object block4401 = alloc_Block(NULL, NULL, "collectionsPrelude", 1490);
  gc_frame_newslot(block4401);
// method "_apply"
  block_savedest(block4401);
  Object closure4402 = createclosure(2, "_apply");
  setclosureframe(closure4402, stackframe);
  addtoclosure(closure4402, var_unused);
  addtoclosure(closure4402, selfslot);
  struct UserObject *uo4402 = (struct UserObject*)block4401;
  uo4402->data[0] = (Object)closure4402;
  Method *meth_meth_collectionsPrelude__apply4402 = addmethod2pos(block4401, "_apply", &meth_collectionsPrelude__apply4402, 0);
  int argcv_meth_collectionsPrelude__apply4402[] = {1};
  meth_meth_collectionsPrelude__apply4402->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4402);
  meth_meth_collectionsPrelude__apply4402->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4402->definitionLine = 1490;
// compiled block node returning block4401 (depth = 3)
  gc_frame_newslot(block4401);
// call case 5: prelude request
  params[0] = opresult4400;
  params[1] = block4401;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4408 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4388);
// compiled call node returning call4408 (depth = 2)
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  objclass3095 = obj3095->class;
  objclass3095->definitionModule = modulename;
  objclass3095->definitionLine = 1485;
  (*(struct UserObject *)self).data[0] = lowerouter3095;
  self = oldself3095;
  selfslot = oldselfslot3095;
  stackframe = oldstackframe3095;
  gc_frame_end(frame);
  return obj3095;
}
Object meth_collectionsPrelude_empty3094_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "empty()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[2];
  int partcv[2];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_binding = getfromclosure(closure, 2);
  Object *var_NoSuchObject = getfromclosure(closure, 3);
  Object *var_enumerable = getfromclosure(closure, 4);
  Object *var_ConcurrentModification = getfromclosure(closure, 5);
  Object *var_IteratorExhausted = getfromclosure(closure, 6);
  Object *var__prelude = getfromclosure(closure, 7);
  Object *var_ComparableToDictionary = getfromclosure(closure, 8);
  Object *var_collection = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for empty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for empty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3095 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3095 = alloc_userobj2(43,41, objclass3095);
  gc_frame_newslot(obj3095);
if (objclass3095 == NULL) {
  glfree(obj3095->class->name);
  obj3095->class->name = "collectionsPrelude.dictionary.empty";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3095, self, 0);
  addmethodreal(obj3095,"outer", &reader_collectionsPrelude_outer_3096);
  Object oldself3095 = self;
  struct StackFrameObject *oldstackframe3095 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3095);
  gc_frame_newslot((Object)stackframe);
  self = obj3095;
  Object *oldselfslot3095 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3095 = (*(struct UserObject *)self).data[0], lowerouter3095 = thisouter3095;
  if (inheritingObject3095) {
    struct UserObject *inho3095 = (struct UserObject *)inheritingObject3095;
    while (inho3095->super != GraceDefaultObject) inho3095 = (struct UserObject *)inho3095->super;
    inho3095->super = obj3095;
    self = inheritingObject3095;
    *selfslot = self;
    lowerouter3095 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3095;
  }
if (objclass3095 == NULL) {
  Method *reader3097 = addmethodrealflags(obj3095, "mods",&reader_collectionsPrelude_mods_3097, 0);
  Method *writer3097 = addmethodrealflags(obj3095, "mods:=",&writer_collectionsPrelude_mods_3097, MFLAG_CONFIDENTIAL);
  reader3097->definitionModule = modulename;
  writer3097->definitionModule = modulename;
  reader3097->definitionLine = 1487;
  writer3097->definitionLine = 1487;
}
obj3095->flags |= OFLAG_MUTABLE;
adddatum2(obj3095, alloc_Undefined(), 1);
if (objclass3095 == NULL) {
  Method *reader3098 = addmethodrealflags(obj3095, "numBindings",&reader_collectionsPrelude_numBindings_3098, MFLAG_CONFIDENTIAL);
  Method *writer3098 = addmethodrealflags(obj3095, "numBindings:=",&writer_collectionsPrelude_numBindings_3098, MFLAG_CONFIDENTIAL);
  reader3098->definitionModule = modulename;
  writer3098->definitionModule = modulename;
  reader3098->definitionLine = 1488;
  writer3098->definitionLine = 1488;
}
obj3095->flags |= OFLAG_MUTABLE;
adddatum2(obj3095, alloc_Undefined(), 2);
if (objclass3095 == NULL) {
  Method *reader3099 = addmethodrealflags(obj3095, "inner",&reader_collectionsPrelude_inner_3099, MFLAG_CONFIDENTIAL);
  Method *writer3099 = addmethodrealflags(obj3095, "inner:=",&writer_collectionsPrelude_inner_3099, MFLAG_CONFIDENTIAL);
  reader3099->definitionModule = modulename;
  writer3099->definitionModule = modulename;
  reader3099->definitionLine = 1489;
  writer3099->definitionLine = 1489;
}
obj3095->flags |= OFLAG_MUTABLE;
adddatum2(obj3095, alloc_Undefined(), 3);
// method "size"
  struct UserObject *uo3100 = (struct UserObject*)obj3095;
  uo3100->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size3100 = addmethod2pos(obj3095, "size", &meth_collectionsPrelude_size3100, 4);
  int argcv_meth_collectionsPrelude_size3100[] = {0};
  meth_meth_collectionsPrelude_size3100->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size3100);
  meth_meth_collectionsPrelude_size3100->definitionModule = modulename;
  meth_meth_collectionsPrelude_size3100->definitionLine = 1493;
// method "at()put"
  block_savedest(obj3095);
  Object closure3103 = createclosure(3, "at()put");
  setclosureframe(closure3103, stackframe);
  addtoclosure(closure3103, var_removed);
  addtoclosure(closure3103, var_unused);
  addtoclosure(closure3103, var_binding);
  struct UserObject *uo3103 = (struct UserObject*)obj3095;
  uo3103->data[5] = (Object)closure3103;
  Method *meth_meth_collectionsPrelude_at_40__41_put3103 = addmethod2pos(obj3095, "at()put", &meth_collectionsPrelude_at_40__41_put3103, 5);
  int argcv_meth_collectionsPrelude_at_40__41_put3103[] = {1, 1};
  meth_meth_collectionsPrelude_at_40__41_put3103->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40__41_put3103);
  meth_meth_collectionsPrelude_at_40__41_put3103->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40__41_put3103->definitionLine = 1494;
// method "add"
  block_savedest(obj3095);
  Object closure3162 = createclosure(2, "add");
  setclosureframe(closure3162, stackframe);
  addtoclosure(closure3162, var_removed);
  addtoclosure(closure3162, var_unused);
  struct UserObject *uo3162 = (struct UserObject*)obj3095;
  uo3162->data[6] = (Object)closure3162;
  Method *meth_meth_collectionsPrelude_add3162 = addmethod2pos(obj3095, "add", &meth_collectionsPrelude_add3162, 6);
  int argcv_meth_collectionsPrelude_add3162[] = {1};
  meth_meth_collectionsPrelude_add3162->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_add3162);
  meth_meth_collectionsPrelude_add3162->definitionModule = modulename;
  meth_meth_collectionsPrelude_add3162->definitionLine = 1504;
// method "at"
  block_savedest(obj3095);
  Object closure3221 = createclosure(1, "at");
  setclosureframe(closure3221, stackframe);
  addtoclosure(closure3221, var_NoSuchObject);
  struct UserObject *uo3221 = (struct UserObject*)obj3095;
  uo3221->data[7] = (Object)closure3221;
  Method *meth_meth_collectionsPrelude_at3221 = addmethod2pos(obj3095, "at", &meth_collectionsPrelude_at3221, 7);
  int argcv_meth_collectionsPrelude_at3221[] = {1};
  meth_meth_collectionsPrelude_at3221->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at3221);
  meth_meth_collectionsPrelude_at3221->definitionModule = modulename;
  meth_meth_collectionsPrelude_at3221->definitionLine = 1514;
// method "at()ifAbsent"
  struct UserObject *uo3246 = (struct UserObject*)obj3095;
  uo3246->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at_40__41_ifAbsent3246 = addmethod2pos(obj3095, "at()ifAbsent", &meth_collectionsPrelude_at_40__41_ifAbsent3246, 8);
  int argcv_meth_collectionsPrelude_at_40__41_ifAbsent3246[] = {1, 1};
  meth_meth_collectionsPrelude_at_40__41_ifAbsent3246->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_at_40__41_ifAbsent3246);
  meth_meth_collectionsPrelude_at_40__41_ifAbsent3246->definitionModule = modulename;
  meth_meth_collectionsPrelude_at_40__41_ifAbsent3246->definitionLine = 1521;
// method "containsKey"
  struct UserObject *uo3263 = (struct UserObject*)obj3095;
  uo3263->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_containsKey3263 = addmethod2pos(obj3095, "containsKey", &meth_collectionsPrelude_containsKey3263, 9);
  int argcv_meth_collectionsPrelude_containsKey3263[] = {1};
  meth_meth_collectionsPrelude_containsKey3263->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_containsKey3263);
  meth_meth_collectionsPrelude_containsKey3263->definitionModule = modulename;
  meth_meth_collectionsPrelude_containsKey3263->definitionLine = 1528;
// method "removeAllKeys"
  block_savedest(obj3095);
  Object closure3278 = createclosure(2, "removeAllKeys");
  setclosureframe(closure3278, stackframe);
  addtoclosure(closure3278, var_removed);
  addtoclosure(closure3278, var_NoSuchObject);
  struct UserObject *uo3278 = (struct UserObject*)obj3095;
  uo3278->data[10] = (Object)closure3278;
  Method *meth_meth_collectionsPrelude_removeAllKeys3278 = addmethod2pos(obj3095, "removeAllKeys", &meth_collectionsPrelude_removeAllKeys3278, 10);
  int argcv_meth_collectionsPrelude_removeAllKeys3278[] = {1};
  meth_meth_collectionsPrelude_removeAllKeys3278->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAllKeys3278);
  meth_meth_collectionsPrelude_removeAllKeys3278->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAllKeys3278->definitionLine = 1535;
// method "removeKey"
  block_savedest(obj3095);
  Object closure3326 = createclosure(2, "removeKey");
  setclosureframe(closure3326, stackframe);
  addtoclosure(closure3326, var_removed);
  addtoclosure(closure3326, var_NoSuchObject);
  struct UserObject *uo3326 = (struct UserObject*)obj3095;
  uo3326->data[11] = (Object)closure3326;
  Method *meth_meth_collectionsPrelude_removeKey3326 = addmethod2pos(obj3095, "removeKey", &meth_collectionsPrelude_removeKey3326, 11);
  int argcv_meth_collectionsPrelude_removeKey3326[] = {1};
  meth_meth_collectionsPrelude_removeKey3326->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeKey3326);
  meth_meth_collectionsPrelude_removeKey3326->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeKey3326->definitionLine = 1548;
// method "removeAllValues"
  block_savedest(obj3095);
  Object closure3369 = createclosure(1, "removeAllValues");
  setclosureframe(closure3369, stackframe);
  addtoclosure(closure3369, var_removed);
  struct UserObject *uo3369 = (struct UserObject*)obj3095;
  uo3369->data[12] = (Object)closure3369;
  Method *meth_meth_collectionsPrelude_removeAllValues3369 = addmethod2pos(obj3095, "removeAllValues", &meth_collectionsPrelude_removeAllValues3369, 12);
  int argcv_meth_collectionsPrelude_removeAllValues3369[] = {1};
  meth_meth_collectionsPrelude_removeAllValues3369->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeAllValues3369);
  meth_meth_collectionsPrelude_removeAllValues3369->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeAllValues3369->definitionLine = 1559;
// method "removeValue"
  block_savedest(obj3095);
  Object closure3416 = createclosure(2, "removeValue");
  setclosureframe(closure3416, stackframe);
  addtoclosure(closure3416, var_removed);
  addtoclosure(closure3416, var_NoSuchObject);
  struct UserObject *uo3416 = (struct UserObject*)obj3095;
  uo3416->data[13] = (Object)closure3416;
  Method *meth_meth_collectionsPrelude_removeValue3416 = addmethod2pos(obj3095, "removeValue", &meth_collectionsPrelude_removeValue3416, 13);
  int argcv_meth_collectionsPrelude_removeValue3416[] = {1};
  meth_meth_collectionsPrelude_removeValue3416->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removeValue3416);
  meth_meth_collectionsPrelude_removeValue3416->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeValue3416->definitionLine = 1570;
// method "removeValue()ifAbsent"
  block_savedest(obj3095);
  Object closure3482 = createclosure(1, "removeValue()ifAbsent");
  setclosureframe(closure3482, stackframe);
  addtoclosure(closure3482, var_removed);
  struct UserObject *uo3482 = (struct UserObject*)obj3095;
  uo3482->data[14] = (Object)closure3482;
  Method *meth_meth_collectionsPrelude_removeValue_40__41_ifAbsent3482 = addmethod2pos(obj3095, "removeValue()ifAbsent", &meth_collectionsPrelude_removeValue_40__41_ifAbsent3482, 14);
  int argcv_meth_collectionsPrelude_removeValue_40__41_ifAbsent3482[] = {1, 1};
  meth_meth_collectionsPrelude_removeValue_40__41_ifAbsent3482->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_removeValue_40__41_ifAbsent3482);
  meth_meth_collectionsPrelude_removeValue_40__41_ifAbsent3482->definitionModule = modulename;
  meth_meth_collectionsPrelude_removeValue_40__41_ifAbsent3482->definitionLine = 1586;
// method "containsValue"
  struct UserObject *uo3540 = (struct UserObject*)obj3095;
  uo3540->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_containsValue3540 = addmethod2pos(obj3095, "containsValue", &meth_collectionsPrelude_containsValue3540, 15);
  int argcv_meth_collectionsPrelude_containsValue3540[] = {1};
  meth_meth_collectionsPrelude_containsValue3540->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_containsValue3540);
  meth_meth_collectionsPrelude_containsValue3540->definitionModule = modulename;
  meth_meth_collectionsPrelude_containsValue3540->definitionLine = 1602;
// method "contains"
  struct UserObject *uo3552 = (struct UserObject*)obj3095;
  uo3552->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains3552 = addmethod2pos(obj3095, "contains", &meth_collectionsPrelude_contains3552, 16);
  int argcv_meth_collectionsPrelude_contains3552[] = {1};
  meth_meth_collectionsPrelude_contains3552->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains3552);
  meth_meth_collectionsPrelude_contains3552->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains3552->definitionLine = 1608;
// method "findPosition"
  block_savedest(obj3095);
  Object closure3555 = createclosure(1, "findPosition");
  setclosureframe(closure3555, stackframe);
  addtoclosure(closure3555, var_unused);
  struct UserObject *uo3555 = (struct UserObject*)obj3095;
  uo3555->data[17] = (Object)closure3555;
  Method *meth_meth_collectionsPrelude_findPosition3555 = addmethod2pos(obj3095, "findPosition", &meth_collectionsPrelude_findPosition3555, 17);
  int argcv_meth_collectionsPrelude_findPosition3555[] = {1};
  meth_meth_collectionsPrelude_findPosition3555->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPosition3555);
  meth_meth_collectionsPrelude_findPosition3555->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPosition3555->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPosition3555->definitionLine = 1610;
// method "findPositionForAdd"
  block_savedest(obj3095);
  Object closure3621 = createclosure(2, "findPositionForAdd");
  setclosureframe(closure3621, stackframe);
  addtoclosure(closure3621, var_removed);
  addtoclosure(closure3621, var_unused);
  struct UserObject *uo3621 = (struct UserObject*)obj3095;
  uo3621->data[18] = (Object)closure3621;
  Method *meth_meth_collectionsPrelude_findPositionForAdd3621 = addmethod2pos(obj3095, "findPositionForAdd", &meth_collectionsPrelude_findPositionForAdd3621, 18);
  int argcv_meth_collectionsPrelude_findPositionForAdd3621[] = {1};
  meth_meth_collectionsPrelude_findPositionForAdd3621->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_findPositionForAdd3621);
  meth_meth_collectionsPrelude_findPositionForAdd3621->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_findPositionForAdd3621->definitionModule = modulename;
  meth_meth_collectionsPrelude_findPositionForAdd3621->definitionLine = 1628;
// method "asString"
  block_savedest(obj3095);
  Object closure3697 = createclosure(2, "asString");
  setclosureframe(closure3697, stackframe);
  addtoclosure(closure3697, var_removed);
  addtoclosure(closure3697, var_unused);
  struct UserObject *uo3697 = (struct UserObject*)obj3095;
  uo3697->data[19] = (Object)closure3697;
  Method *meth_meth_collectionsPrelude_asString3697 = addmethod2pos(obj3095, "asString", &meth_collectionsPrelude_asString3697, 19);
  int argcv_meth_collectionsPrelude_asString3697[] = {0};
  meth_meth_collectionsPrelude_asString3697->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3697);
  meth_meth_collectionsPrelude_asString3697->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3697->definitionLine = 1646;
// method "asDebugString"
  block_savedest(obj3095);
  Object closure3768 = createclosure(2, "asDebugString");
  setclosureframe(closure3768, stackframe);
  addtoclosure(closure3768, var_removed);
  addtoclosure(closure3768, var_unused);
  struct UserObject *uo3768 = (struct UserObject*)obj3095;
  uo3768->data[20] = (Object)closure3768;
  Method *meth_meth_collectionsPrelude_asDebugString3768 = addmethod2pos(obj3095, "asDebugString", &meth_collectionsPrelude_asDebugString3768, 20);
  int argcv_meth_collectionsPrelude_asDebugString3768[] = {0};
  meth_meth_collectionsPrelude_asDebugString3768->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDebugString3768);
  meth_meth_collectionsPrelude_asDebugString3768->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDebugString3768->definitionLine = 1664;
// method "keys"
  block_savedest(obj3095);
  Object closure3866 = createclosure(1, "keys");
  setclosureframe(closure3866, stackframe);
  addtoclosure(closure3866, var_enumerable);
  struct UserObject *uo3866 = (struct UserObject*)obj3095;
  uo3866->data[21] = (Object)closure3866;
  Method *meth_meth_collectionsPrelude_keys3866 = addmethod2pos(obj3095, "keys", &meth_collectionsPrelude_keys3866, 21);
  int argcv_meth_collectionsPrelude_keys3866[] = {0};
  meth_meth_collectionsPrelude_keys3866->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys3866);
  meth_meth_collectionsPrelude_keys3866->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys3866->definitionLine = 1677;
  block_savedest(obj3095);
  Object closure3911 = createclosure(1, "keys()object");
  setclosureframe(closure3911, stackframe);
  addtoclosure(closure3911, var_enumerable);
  Method *meth_meth_collectionsPrelude_keys3866_object = addmethod2pos(obj3095, "keys()object", &meth_collectionsPrelude_keys3866_object, 21);
  meth_meth_collectionsPrelude_keys3866_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys3866_object->definitionLine = 1677;
// method "values"
  block_savedest(obj3095);
  Object closure3912 = createclosure(1, "values");
  setclosureframe(closure3912, stackframe);
  addtoclosure(closure3912, var_enumerable);
  struct UserObject *uo3912 = (struct UserObject*)obj3095;
  uo3912->data[22] = (Object)closure3912;
  Method *meth_meth_collectionsPrelude_values3912 = addmethod2pos(obj3095, "values", &meth_collectionsPrelude_values3912, 22);
  int argcv_meth_collectionsPrelude_values3912[] = {0};
  meth_meth_collectionsPrelude_values3912->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values3912);
  meth_meth_collectionsPrelude_values3912->definitionModule = modulename;
  meth_meth_collectionsPrelude_values3912->definitionLine = 1695;
  block_savedest(obj3095);
  Object closure3957 = createclosure(1, "values()object");
  setclosureframe(closure3957, stackframe);
  addtoclosure(closure3957, var_enumerable);
  Method *meth_meth_collectionsPrelude_values3912_object = addmethod2pos(obj3095, "values()object", &meth_collectionsPrelude_values3912_object, 22);
  meth_meth_collectionsPrelude_values3912_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_values3912_object->definitionLine = 1695;
// method "bindings"
  block_savedest(obj3095);
  Object closure3958 = createclosure(1, "bindings");
  setclosureframe(closure3958, stackframe);
  addtoclosure(closure3958, var_enumerable);
  struct UserObject *uo3958 = (struct UserObject*)obj3095;
  uo3958->data[23] = (Object)closure3958;
  Method *meth_meth_collectionsPrelude_bindings3958 = addmethod2pos(obj3095, "bindings", &meth_collectionsPrelude_bindings3958, 23);
  int argcv_meth_collectionsPrelude_bindings3958[] = {0};
  meth_meth_collectionsPrelude_bindings3958->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_bindings3958);
  meth_meth_collectionsPrelude_bindings3958->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindings3958->definitionLine = 1714;
  block_savedest(obj3095);
  Object closure3978 = createclosure(1, "bindings()object");
  setclosureframe(closure3978, stackframe);
  addtoclosure(closure3978, var_enumerable);
  Method *meth_meth_collectionsPrelude_bindings3958_object = addmethod2pos(obj3095, "bindings()object", &meth_collectionsPrelude_bindings3958_object, 23);
  meth_meth_collectionsPrelude_bindings3958_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindings3958_object->definitionLine = 1714;
// method "iterator"
  struct UserObject *uo3979 = (struct UserObject*)obj3095;
  uo3979->data[24] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iterator3979 = addmethod2pos(obj3095, "iterator", &meth_collectionsPrelude_iterator3979, 24);
  int argcv_meth_collectionsPrelude_iterator3979[] = {0};
  meth_meth_collectionsPrelude_iterator3979->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator3979);
  meth_meth_collectionsPrelude_iterator3979->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator3979->definitionLine = 1726;
// method "bindingsIterator"
  block_savedest(obj3095);
  Object closure3984 = createclosure(4, "bindingsIterator");
  setclosureframe(closure3984, stackframe);
  addtoclosure(closure3984, var_ConcurrentModification);
  addtoclosure(closure3984, var_IteratorExhausted);
  addtoclosure(closure3984, var_removed);
  addtoclosure(closure3984, var_unused);
  struct UserObject *uo3984 = (struct UserObject*)obj3095;
  uo3984->data[25] = (Object)closure3984;
  Method *meth_meth_collectionsPrelude_bindingsIterator3984 = addmethod2pos(obj3095, "bindingsIterator", &meth_collectionsPrelude_bindingsIterator3984, 25);
  int argcv_meth_collectionsPrelude_bindingsIterator3984[] = {0};
  meth_meth_collectionsPrelude_bindingsIterator3984->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_bindingsIterator3984);
  meth_meth_collectionsPrelude_bindingsIterator3984->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindingsIterator3984->definitionLine = 1727;
  block_savedest(obj3095);
  Object closure4105 = createclosure(4, "bindingsIterator()object");
  setclosureframe(closure4105, stackframe);
  addtoclosure(closure4105, var_ConcurrentModification);
  addtoclosure(closure4105, var_IteratorExhausted);
  addtoclosure(closure4105, var_removed);
  addtoclosure(closure4105, var_unused);
  Method *meth_meth_collectionsPrelude_bindingsIterator3984_object = addmethod2pos(obj3095, "bindingsIterator()object", &meth_collectionsPrelude_bindingsIterator3984_object, 25);
  meth_meth_collectionsPrelude_bindingsIterator3984_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_bindingsIterator3984_object->definitionLine = 1727;
// method "expand"
  block_savedest(obj3095);
  Object closure4106 = createclosure(3, "expand");
  setclosureframe(closure4106, stackframe);
  addtoclosure(closure4106, var__prelude);
  addtoclosure(closure4106, var_unused);
  addtoclosure(closure4106, var_removed);
  struct UserObject *uo4106 = (struct UserObject*)obj3095;
  uo4106->data[26] = (Object)closure4106;
  Method *meth_meth_collectionsPrelude_expand4106 = addmethod2pos(obj3095, "expand", &meth_collectionsPrelude_expand4106, 26);
  int argcv_meth_collectionsPrelude_expand4106[] = {0};
  meth_meth_collectionsPrelude_expand4106->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_expand4106);
  meth_meth_collectionsPrelude_expand4106->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_expand4106->definitionModule = modulename;
  meth_meth_collectionsPrelude_expand4106->definitionLine = 1750;
// method "keysAndValuesDo"
  block_savedest(obj3095);
  Object closure4174 = createclosure(2, "keysAndValuesDo");
  setclosureframe(closure4174, stackframe);
  addtoclosure(closure4174, var_removed);
  addtoclosure(closure4174, var_unused);
  struct UserObject *uo4174 = (struct UserObject*)obj3095;
  uo4174->data[27] = (Object)closure4174;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo4174 = addmethod2pos(obj3095, "keysAndValuesDo", &meth_collectionsPrelude_keysAndValuesDo4174, 27);
  int argcv_meth_collectionsPrelude_keysAndValuesDo4174[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo4174->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo4174);
  meth_meth_collectionsPrelude_keysAndValuesDo4174->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo4174->definitionLine = 1766;
// method "keysDo"
  block_savedest(obj3095);
  Object closure4212 = createclosure(2, "keysDo");
  setclosureframe(closure4212, stackframe);
  addtoclosure(closure4212, var_removed);
  addtoclosure(closure4212, var_unused);
  struct UserObject *uo4212 = (struct UserObject*)obj3095;
  uo4212->data[28] = (Object)closure4212;
  Method *meth_meth_collectionsPrelude_keysDo4212 = addmethod2pos(obj3095, "keysDo", &meth_collectionsPrelude_keysDo4212, 28);
  int argcv_meth_collectionsPrelude_keysDo4212[] = {1};
  meth_meth_collectionsPrelude_keysDo4212->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysDo4212);
  meth_meth_collectionsPrelude_keysDo4212->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysDo4212->definitionLine = 1774;
// method "valuesDo"
  block_savedest(obj3095);
  Object closure4248 = createclosure(2, "valuesDo");
  setclosureframe(closure4248, stackframe);
  addtoclosure(closure4248, var_removed);
  addtoclosure(closure4248, var_unused);
  struct UserObject *uo4248 = (struct UserObject*)obj3095;
  uo4248->data[29] = (Object)closure4248;
  Method *meth_meth_collectionsPrelude_valuesDo4248 = addmethod2pos(obj3095, "valuesDo", &meth_collectionsPrelude_valuesDo4248, 29);
  int argcv_meth_collectionsPrelude_valuesDo4248[] = {1};
  meth_meth_collectionsPrelude_valuesDo4248->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_valuesDo4248);
  meth_meth_collectionsPrelude_valuesDo4248->definitionModule = modulename;
  meth_meth_collectionsPrelude_valuesDo4248->definitionLine = 1782;
// method "do"
  struct UserObject *uo4284 = (struct UserObject*)obj3095;
  uo4284->data[30] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do4284 = addmethod2pos(obj3095, "do", &meth_collectionsPrelude_do4284, 30);
  int argcv_meth_collectionsPrelude_do4284[] = {1};
  meth_meth_collectionsPrelude_do4284->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do4284);
  meth_meth_collectionsPrelude_do4284->definitionModule = modulename;
  meth_meth_collectionsPrelude_do4284->definitionLine = 1790;
// method "=="
  block_savedest(obj3095);
  Object closure4287 = createclosure(1, "==");
  setclosureframe(closure4287, stackframe);
  addtoclosure(closure4287, var_ComparableToDictionary);
  struct UserObject *uo4287 = (struct UserObject*)obj3095;
  uo4287->data[31] = (Object)closure4287;
  Method *meth_meth_collectionsPrelude__61__61_4287 = addmethod2pos(obj3095, "==", &meth_collectionsPrelude__61__61_4287, 31);
  int argcv_meth_collectionsPrelude__61__61_4287[] = {1};
  meth_meth_collectionsPrelude__61__61_4287->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_4287);
  meth_meth_collectionsPrelude__61__61_4287->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_4287->definitionLine = 1792;
// method "copy"
  struct UserObject *uo4331 = (struct UserObject*)obj3095;
  uo4331->data[32] = emptyclosure;
  Method *meth_meth_collectionsPrelude_copy4331 = addmethod2pos(obj3095, "copy", &meth_collectionsPrelude_copy4331, 32);
  int argcv_meth_collectionsPrelude_copy4331[] = {0};
  meth_meth_collectionsPrelude_copy4331->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_copy4331);
  meth_meth_collectionsPrelude_copy4331->definitionModule = modulename;
  meth_meth_collectionsPrelude_copy4331->definitionLine = 1808;
// method "asDictionary"
  struct UserObject *uo4347 = (struct UserObject*)obj3095;
  uo4347->data[33] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDictionary4347 = addmethod2pos(obj3095, "asDictionary", &meth_collectionsPrelude_asDictionary4347, 33);
  int argcv_meth_collectionsPrelude_asDictionary4347[] = {0};
  meth_meth_collectionsPrelude_asDictionary4347->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDictionary4347);
  meth_meth_collectionsPrelude_asDictionary4347->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDictionary4347->definitionLine = 1816;
// method "++"
  struct UserObject *uo4348 = (struct UserObject*)obj3095;
  uo4348->data[34] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_4348 = addmethod2pos(obj3095, "++", &meth_collectionsPrelude__43__43_4348, 34);
  int argcv_meth_collectionsPrelude__43__43_4348[] = {1};
  meth_meth_collectionsPrelude__43__43_4348->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_4348);
  meth_meth_collectionsPrelude__43__43_4348->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_4348->definitionLine = 1820;
// method "--"
  struct UserObject *uo4358 = (struct UserObject*)obj3095;
  uo4358->data[35] = emptyclosure;
  Method *meth_meth_collectionsPrelude__45__45_4358 = addmethod2pos(obj3095, "--", &meth_collectionsPrelude__45__45_4358, 35);
  int argcv_meth_collectionsPrelude__45__45_4358[] = {1};
  meth_meth_collectionsPrelude__45__45_4358->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__45__45_4358);
  meth_meth_collectionsPrelude__45__45_4358->definitionModule = modulename;
  meth_meth_collectionsPrelude__45__45_4358->definitionLine = 1828;
  sourceObject = obj3095;
// Begin line 1486
  setline(1486);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4379 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collection (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4380 = callmethod(*var_collection, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe4379);
// compiled call node returning call4380 (depth = 2)
  struct UserObject *obj3095_uo = (struct UserObject *)obj3095;
  obj3095_uo->super = call4380;
  sourceObject = obj3095;
// Begin line 1487
  setline(1487);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4381 = alloc_Float64(0);
// compiled num node returning num4381 (depth = 2)
  adddatum2(obj3095, num4381, 1);
  sourceObject = obj3095;
// Begin line 1488
  setline(1488);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 2)
  Object num4382 = alloc_Float64(0);
// compiled num node returning num4382 (depth = 2)
  adddatum2(obj3095, num4382, 2);
  sourceObject = obj3095;
// Begin line 1489
  setline(1489);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4383 = gc_frame_new();
// starting to compile num node (depth = 3)
  Object num4384 = alloc_Float64(8);
// compiled num node returning num4384 (depth = 3)
  gc_frame_newslot(num4384);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4385 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var__prelude (depth = 5)
  partcv[0] = 0;
  Object call4386 = callmethod(*var__prelude, "primitiveArray",
    1, partcv, params);
  gc_frame_end(callframe4385);
// compiled call node returning call4386 (depth = 4)
// compiled member node returning call4386 (depth = 3)
  params[0] = num4384;
  partcv[0] = 1;
  Object call4387 = callmethod(call4386, "new",
    1, partcv, params);
  gc_frame_end(callframe4383);
// compiled call node returning call4387 (depth = 2)
  adddatum2(obj3095, call4387, 3);
  sourceObject = obj3095;
// Begin line 1490
  setline(1490);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4388 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4391 = alloc_Float64(1);
// compiled num node returning num4391 (depth = 5)
  int op_slot_right_4390 = gc_frame_newslot(num4391);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4393 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4394 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4395 = callmethodflags(self, "inner", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4394);
// compiled call node returning call4395 (depth = 8)
// compiled member node returning call4395 (depth = 7)
  partcv[0] = 0;
  Object call4396 = callmethod(call4395, "size",
    1, partcv, params);
  gc_frame_end(callframe4393);
// compiled call node returning call4396 (depth = 6)
// compiled member node returning call4396 (depth = 5)
  int op_slot_left_4390 = gc_frame_newslot(call4396);
  params[0] = num4391;
  partcv[0] = 1;
  Object diff4397 = callmethod(call4396, "-", 1, partcv, params);
// compiled op node returning diff4397 (depth = 4)
  int op_slot_right_4389 = gc_frame_newslot(diff4397);
// starting to compile num node (depth = 4)
  Object num4399 = alloc_Float64(0);
// compiled num node returning num4399 (depth = 4)
  int op_slot_left_4389 = gc_frame_newslot(num4399);
  params[0] = diff4397;
  partcv[0] = 1;
  Object opresult4400 = callmethod(num4399, "..", 1, partcv, params);
// compiled op node returning opresult4400 (depth = 3)
  gc_frame_newslot(opresult4400);
// starting to compile block node (depth = 3)
  Object block4401 = alloc_Block(NULL, NULL, "collectionsPrelude", 1490);
  gc_frame_newslot(block4401);
// method "_apply"
  block_savedest(block4401);
  Object closure4402 = createclosure(2, "_apply");
  setclosureframe(closure4402, stackframe);
  addtoclosure(closure4402, var_unused);
  addtoclosure(closure4402, selfslot);
  struct UserObject *uo4402 = (struct UserObject*)block4401;
  uo4402->data[0] = (Object)closure4402;
  Method *meth_meth_collectionsPrelude__apply4402 = addmethod2pos(block4401, "_apply", &meth_collectionsPrelude__apply4402, 0);
  int argcv_meth_collectionsPrelude__apply4402[] = {1};
  meth_meth_collectionsPrelude__apply4402->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4402);
  meth_meth_collectionsPrelude__apply4402->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4402->definitionLine = 1490;
// compiled block node returning block4401 (depth = 3)
  gc_frame_newslot(block4401);
// call case 5: prelude request
  params[0] = opresult4400;
  params[1] = block4401;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4408 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4388);
// compiled call node returning call4408 (depth = 2)
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  sourceObject = obj3095;
  objclass3095 = obj3095->class;
  objclass3095->definitionModule = modulename;
  objclass3095->definitionLine = 1485;
  (*(struct UserObject *)self).data[0] = lowerouter3095;
  self = oldself3095;
  selfslot = oldselfslot3095;
  stackframe = oldstackframe3095;
  gc_frame_end(frame);
  return obj3095;
}
Object meth_collectionsPrelude_dictionary3079(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_binding = getfromclosure(closure, 2);
  Object *var_NoSuchObject = getfromclosure(closure, 3);
  Object *var_enumerable = getfromclosure(closure, 4);
  Object *var_ConcurrentModification = getfromclosure(closure, 5);
  Object *var_IteratorExhausted = getfromclosure(closure, 6);
  Object *var__prelude = getfromclosure(closure, 7);
  Object *var_ComparableToDictionary = getfromclosure(closure, 8);
  Object *var_collection = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for dictionary (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for dictionary");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_K = &(stackframe->slots[1]);
  Object *var_T = &(stackframe->slots[2]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 2) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_K = args[curarg++];
    *var_T = args[curarg++];
  } else {
    *var_K = Unknown;
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3080 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3080 = alloc_userobj2(4,5, objclass3080);
  gc_frame_newslot(obj3080);
if (objclass3080 == NULL) {
  glfree(obj3080->class->name);
  obj3080->class->name = "collectionsPrelude.dictionary";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3080, self, 0);
  addmethodreal(obj3080,"outer", &reader_collectionsPrelude_outer_3081);
  Object oldself3080 = self;
  struct StackFrameObject *oldstackframe3080 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3080);
  gc_frame_newslot((Object)stackframe);
  self = obj3080;
  Object *oldselfslot3080 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3080 = (*(struct UserObject *)self).data[0], lowerouter3080 = thisouter3080;
  if (inheritingObject3080) {
    struct UserObject *inho3080 = (struct UserObject *)inheritingObject3080;
    while (inho3080->super != GraceDefaultObject) inho3080 = (struct UserObject *)inho3080->super;
    inho3080->super = obj3080;
    self = inheritingObject3080;
    *selfslot = self;
    lowerouter3080 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3080;
  }
// method "asString"
  struct UserObject *uo3082 = (struct UserObject*)obj3080;
  uo3082->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString3082 = addmethod2pos(obj3080, "asString", &meth_collectionsPrelude_asString3082, 1);
  int argcv_meth_collectionsPrelude_asString3082[] = {0};
  meth_meth_collectionsPrelude_asString3082->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3082);
  meth_meth_collectionsPrelude_asString3082->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3082->definitionLine = 1477;
// method "withAll"
  struct UserObject *uo3084 = (struct UserObject*)obj3080;
  uo3084->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_withAll3084 = addmethod2pos(obj3080, "withAll", &meth_collectionsPrelude_withAll3084, 2);
  int argcv_meth_collectionsPrelude_withAll3084[] = {1};
  meth_meth_collectionsPrelude_withAll3084->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll3084);
  meth_meth_collectionsPrelude_withAll3084->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll3084->definitionLine = 1479;
// method "empty"
  block_savedest(obj3080);
  Object closure3094 = createclosure(10, "empty");
  setclosureframe(closure3094, stackframe);
  addtoclosure(closure3094, var_removed);
  addtoclosure(closure3094, var_unused);
  addtoclosure(closure3094, var_binding);
  addtoclosure(closure3094, var_NoSuchObject);
  addtoclosure(closure3094, var_enumerable);
  addtoclosure(closure3094, var_ConcurrentModification);
  addtoclosure(closure3094, var_IteratorExhausted);
  addtoclosure(closure3094, var__prelude);
  addtoclosure(closure3094, var_ComparableToDictionary);
  addtoclosure(closure3094, var_collection);
  struct UserObject *uo3094 = (struct UserObject*)obj3080;
  uo3094->data[3] = (Object)closure3094;
  Method *meth_meth_collectionsPrelude_empty3094 = addmethod2pos(obj3080, "empty", &meth_collectionsPrelude_empty3094, 3);
  int argcv_meth_collectionsPrelude_empty3094[] = {0};
  meth_meth_collectionsPrelude_empty3094->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_empty3094);
  meth_meth_collectionsPrelude_empty3094->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty3094->definitionLine = 1485;
  block_savedest(obj3080);
  Object closure4409 = createclosure(10, "empty()object");
  setclosureframe(closure4409, stackframe);
  addtoclosure(closure4409, var_removed);
  addtoclosure(closure4409, var_unused);
  addtoclosure(closure4409, var_binding);
  addtoclosure(closure4409, var_NoSuchObject);
  addtoclosure(closure4409, var_enumerable);
  addtoclosure(closure4409, var_ConcurrentModification);
  addtoclosure(closure4409, var_IteratorExhausted);
  addtoclosure(closure4409, var__prelude);
  addtoclosure(closure4409, var_ComparableToDictionary);
  addtoclosure(closure4409, var_collection);
  Method *meth_meth_collectionsPrelude_empty3094_object = addmethod2pos(obj3080, "empty()object", &meth_collectionsPrelude_empty3094_object, 3);
  meth_meth_collectionsPrelude_empty3094_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty3094_object->definitionLine = 1485;
  sourceObject = obj3080;
  sourceObject = obj3080;
  sourceObject = obj3080;
  objclass3080 = obj3080->class;
  objclass3080->definitionModule = modulename;
  objclass3080->definitionLine = 1475;
  (*(struct UserObject *)self).data[0] = lowerouter3080;
  self = oldself3080;
  selfslot = oldselfslot3080;
  stackframe = oldstackframe3080;
  gc_frame_end(frame);
  return obj3080;
}
Object meth_collectionsPrelude_dictionary3079_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "dictionary()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  Object *var_unused = getfromclosure(closure, 1);
  Object *var_binding = getfromclosure(closure, 2);
  Object *var_NoSuchObject = getfromclosure(closure, 3);
  Object *var_enumerable = getfromclosure(closure, 4);
  Object *var_ConcurrentModification = getfromclosure(closure, 5);
  Object *var_IteratorExhausted = getfromclosure(closure, 6);
  Object *var__prelude = getfromclosure(closure, 7);
  Object *var_ComparableToDictionary = getfromclosure(closure, 8);
  Object *var_collection = getfromclosure(closure, 9);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for dictionary (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for dictionary");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_K = &(stackframe->slots[1]);
  Object *var_T = &(stackframe->slots[2]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 2) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_K = args[curarg++];
    *var_T = args[curarg++];
  } else {
    *var_K = Unknown;
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject3080 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj3080 = alloc_userobj2(4,5, objclass3080);
  gc_frame_newslot(obj3080);
if (objclass3080 == NULL) {
  glfree(obj3080->class->name);
  obj3080->class->name = "collectionsPrelude.dictionary";
}
// OBJECT OUTER DEC outer
  adddatum2(obj3080, self, 0);
  addmethodreal(obj3080,"outer", &reader_collectionsPrelude_outer_3081);
  Object oldself3080 = self;
  struct StackFrameObject *oldstackframe3080 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe3080);
  gc_frame_newslot((Object)stackframe);
  self = obj3080;
  Object *oldselfslot3080 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter3080 = (*(struct UserObject *)self).data[0], lowerouter3080 = thisouter3080;
  if (inheritingObject3080) {
    struct UserObject *inho3080 = (struct UserObject *)inheritingObject3080;
    while (inho3080->super != GraceDefaultObject) inho3080 = (struct UserObject *)inho3080->super;
    inho3080->super = obj3080;
    self = inheritingObject3080;
    *selfslot = self;
    lowerouter3080 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter3080;
  }
// method "asString"
  struct UserObject *uo3082 = (struct UserObject*)obj3080;
  uo3082->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString3082 = addmethod2pos(obj3080, "asString", &meth_collectionsPrelude_asString3082, 1);
  int argcv_meth_collectionsPrelude_asString3082[] = {0};
  meth_meth_collectionsPrelude_asString3082->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString3082);
  meth_meth_collectionsPrelude_asString3082->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString3082->definitionLine = 1477;
// method "withAll"
  struct UserObject *uo3084 = (struct UserObject*)obj3080;
  uo3084->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_withAll3084 = addmethod2pos(obj3080, "withAll", &meth_collectionsPrelude_withAll3084, 2);
  int argcv_meth_collectionsPrelude_withAll3084[] = {1};
  meth_meth_collectionsPrelude_withAll3084->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_withAll3084);
  meth_meth_collectionsPrelude_withAll3084->definitionModule = modulename;
  meth_meth_collectionsPrelude_withAll3084->definitionLine = 1479;
// method "empty"
  block_savedest(obj3080);
  Object closure3094 = createclosure(10, "empty");
  setclosureframe(closure3094, stackframe);
  addtoclosure(closure3094, var_removed);
  addtoclosure(closure3094, var_unused);
  addtoclosure(closure3094, var_binding);
  addtoclosure(closure3094, var_NoSuchObject);
  addtoclosure(closure3094, var_enumerable);
  addtoclosure(closure3094, var_ConcurrentModification);
  addtoclosure(closure3094, var_IteratorExhausted);
  addtoclosure(closure3094, var__prelude);
  addtoclosure(closure3094, var_ComparableToDictionary);
  addtoclosure(closure3094, var_collection);
  struct UserObject *uo3094 = (struct UserObject*)obj3080;
  uo3094->data[3] = (Object)closure3094;
  Method *meth_meth_collectionsPrelude_empty3094 = addmethod2pos(obj3080, "empty", &meth_collectionsPrelude_empty3094, 3);
  int argcv_meth_collectionsPrelude_empty3094[] = {0};
  meth_meth_collectionsPrelude_empty3094->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_empty3094);
  meth_meth_collectionsPrelude_empty3094->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty3094->definitionLine = 1485;
  block_savedest(obj3080);
  Object closure4409 = createclosure(10, "empty()object");
  setclosureframe(closure4409, stackframe);
  addtoclosure(closure4409, var_removed);
  addtoclosure(closure4409, var_unused);
  addtoclosure(closure4409, var_binding);
  addtoclosure(closure4409, var_NoSuchObject);
  addtoclosure(closure4409, var_enumerable);
  addtoclosure(closure4409, var_ConcurrentModification);
  addtoclosure(closure4409, var_IteratorExhausted);
  addtoclosure(closure4409, var__prelude);
  addtoclosure(closure4409, var_ComparableToDictionary);
  addtoclosure(closure4409, var_collection);
  Method *meth_meth_collectionsPrelude_empty3094_object = addmethod2pos(obj3080, "empty()object", &meth_collectionsPrelude_empty3094_object, 3);
  meth_meth_collectionsPrelude_empty3094_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_empty3094_object->definitionLine = 1485;
  sourceObject = obj3080;
  sourceObject = obj3080;
  sourceObject = obj3080;
  objclass3080 = obj3080->class;
  objclass3080->definitionModule = modulename;
  objclass3080->definitionLine = 1475;
  (*(struct UserObject *)self).data[0] = lowerouter3080;
  self = oldself3080;
  selfslot = oldselfslot3080;
  stackframe = oldstackframe3080;
  gc_frame_end(frame);
  return obj3080;
}
Object meth_collectionsPrelude__apply4417(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___20 = &(stackframe->slots[0]);
  *var___20 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply4429(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_upper = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  Object *var_RequestError = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___21 = &(stackframe->slots[0]);
  *var___21 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe4430 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 1845
  setline(1845);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4433 == NULL) {
    strlit4433 = alloc_String(") is not an integer");
    gc_root(strlit4433);
  }
// compiled string node returning strlit4433 (depth = 7)
  int op_slot_right_4432 = gc_frame_newslot(strlit4433);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_upper (depth = 8)
  int op_slot_right_4435 = gc_frame_newslot(*var_upper);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4438 == NULL) {
    strlit4438 = alloc_String(")to(");
    gc_root(strlit4438);
  }
// compiled string node returning strlit4438 (depth = 9)
  int op_slot_right_4437 = gc_frame_newslot(strlit4438);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lower (depth = 10)
  int op_slot_right_4440 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 10)
  if (strlit4442 == NULL) {
    strlit4442 = alloc_String(" in range.from(");
    gc_root(strlit4442);
  }
// compiled string node returning strlit4442 (depth = 10)
  int op_slot_left_4440 = gc_frame_newslot(strlit4442);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4443 = callmethod(strlit4442, "++", 1, partcv, params);
// compiled op node returning opresult4443 (depth = 9)
  int op_slot_left_4437 = gc_frame_newslot(opresult4443);
  params[0] = strlit4438;
  partcv[0] = 1;
  Object opresult4444 = callmethod(opresult4443, "++", 1, partcv, params);
// compiled op node returning opresult4444 (depth = 8)
  int op_slot_left_4435 = gc_frame_newslot(opresult4444);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4445 = callmethod(opresult4444, "++", 1, partcv, params);
// compiled op node returning opresult4445 (depth = 7)
  int op_slot_left_4432 = gc_frame_newslot(opresult4445);
  params[0] = strlit4433;
  partcv[0] = 1;
  Object opresult4446 = callmethod(opresult4445, "++", 1, partcv, params);
// compiled op node returning opresult4446 (depth = 6)
  int op_slot_right_4431 = gc_frame_newslot(opresult4446);
// Begin line 1844
  setline(1844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4449 == NULL) {
    strlit4449 = alloc_String("");
    gc_root(strlit4449);
  }
// compiled string node returning strlit4449 (depth = 7)
  int op_slot_right_4448 = gc_frame_newslot(strlit4449);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lower (depth = 8)
  int op_slot_right_4451 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 8)
  if (strlit4453 == NULL) {
    strlit4453 = alloc_String("lower bound ");
    gc_root(strlit4453);
  }
// compiled string node returning strlit4453 (depth = 8)
  int op_slot_left_4451 = gc_frame_newslot(strlit4453);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4454 = callmethod(strlit4453, "++", 1, partcv, params);
// compiled op node returning opresult4454 (depth = 7)
  int op_slot_left_4448 = gc_frame_newslot(opresult4454);
  params[0] = strlit4449;
  partcv[0] = 1;
  Object opresult4455 = callmethod(opresult4454, "++", 1, partcv, params);
// compiled op node returning opresult4455 (depth = 6)
  int op_slot_left_4431 = gc_frame_newslot(opresult4455);
  params[0] = opresult4446;
  partcv[0] = 1;
  Object opresult4456 = callmethod(opresult4455, "++", 1, partcv, params);
// compiled op node returning opresult4456 (depth = 5)
  gc_frame_newslot(opresult4456);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_RequestError (depth = 5)
  params[0] = opresult4456;
  partcv[0] = 1;
  Object call4457 = callmethod(*var_RequestError, "raise",
    1, partcv, params);
  gc_frame_end(callframe4430);
// compiled call node returning call4457 (depth = 4)
  gc_frame_end(frame);
  return call4457;
}
Object meth_collectionsPrelude__apply4495(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___22 = &(stackframe->slots[0]);
  *var___22 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply4507(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_upper = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  Object *var_RequestError = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___23 = &(stackframe->slots[0]);
  *var___23 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe4508 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 1854
  setline(1854);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4511 == NULL) {
    strlit4511 = alloc_String(") is not an integer");
    gc_root(strlit4511);
  }
// compiled string node returning strlit4511 (depth = 7)
  int op_slot_right_4510 = gc_frame_newslot(strlit4511);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_upper (depth = 8)
  int op_slot_right_4513 = gc_frame_newslot(*var_upper);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit4516 == NULL) {
    strlit4516 = alloc_String(")to(");
    gc_root(strlit4516);
  }
// compiled string node returning strlit4516 (depth = 9)
  int op_slot_right_4515 = gc_frame_newslot(strlit4516);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lower (depth = 10)
  int op_slot_right_4518 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 10)
  if (strlit4520 == NULL) {
    strlit4520 = alloc_String(" in range.from(");
    gc_root(strlit4520);
  }
// compiled string node returning strlit4520 (depth = 10)
  int op_slot_left_4518 = gc_frame_newslot(strlit4520);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4521 = callmethod(strlit4520, "++", 1, partcv, params);
// compiled op node returning opresult4521 (depth = 9)
  int op_slot_left_4515 = gc_frame_newslot(opresult4521);
  params[0] = strlit4516;
  partcv[0] = 1;
  Object opresult4522 = callmethod(opresult4521, "++", 1, partcv, params);
// compiled op node returning opresult4522 (depth = 8)
  int op_slot_left_4513 = gc_frame_newslot(opresult4522);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4523 = callmethod(opresult4522, "++", 1, partcv, params);
// compiled op node returning opresult4523 (depth = 7)
  int op_slot_left_4510 = gc_frame_newslot(opresult4523);
  params[0] = strlit4511;
  partcv[0] = 1;
  Object opresult4524 = callmethod(opresult4523, "++", 1, partcv, params);
// compiled op node returning opresult4524 (depth = 6)
  int op_slot_right_4509 = gc_frame_newslot(opresult4524);
// Begin line 1853
  setline(1853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4527 == NULL) {
    strlit4527 = alloc_String("");
    gc_root(strlit4527);
  }
// compiled string node returning strlit4527 (depth = 7)
  int op_slot_right_4526 = gc_frame_newslot(strlit4527);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_upper (depth = 8)
  int op_slot_right_4529 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 8)
  if (strlit4531 == NULL) {
    strlit4531 = alloc_String("upper bound ");
    gc_root(strlit4531);
  }
// compiled string node returning strlit4531 (depth = 8)
  int op_slot_left_4529 = gc_frame_newslot(strlit4531);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4532 = callmethod(strlit4531, "++", 1, partcv, params);
// compiled op node returning opresult4532 (depth = 7)
  int op_slot_left_4526 = gc_frame_newslot(opresult4532);
  params[0] = strlit4527;
  partcv[0] = 1;
  Object opresult4533 = callmethod(opresult4532, "++", 1, partcv, params);
// compiled op node returning opresult4533 (depth = 6)
  int op_slot_left_4509 = gc_frame_newslot(opresult4533);
  params[0] = opresult4524;
  partcv[0] = 1;
  Object opresult4534 = callmethod(opresult4533, "++", 1, partcv, params);
// compiled op node returning opresult4534 (depth = 5)
  gc_frame_newslot(opresult4534);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_RequestError (depth = 5)
  params[0] = opresult4534;
  partcv[0] = 1;
  Object call4535 = callmethod(*var_RequestError, "raise",
    1, partcv, params);
  gc_frame_end(callframe4508);
// compiled call node returning call4535 (depth = 4)
  gc_frame_end(frame);
  return call4535;
}
Object meth_collectionsPrelude_from_40__41_to4414(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "from()to");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method from()to");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method from()to");
  Object params[2];
  int partcv[2];
  Object *var_Number = getfromclosure(closure, 0);
  Object *var_RequestError = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for from()to (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_lower = &(stackframe->slots[0]);
  *var_lower = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *var_upper = &(stackframe->slots[1]);
  *var_upper = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for to");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_start = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "start");
  Object *var_stop = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "stop");
// Begin line 1842
  setline(1842);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  int frame4415 = gc_frame_new();
  gc_frame_newslot(*var_lower);
// Begin line 1843
  setline(1843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4416 = alloc_Block(NULL, NULL, "collectionsPrelude", 1843);
  gc_frame_newslot(block4416);
// method "_apply"
  block_savedest(block4416);
  Object closure4417 = createclosure(1, "_apply");
  setclosureframe(closure4417, stackframe);
  addtoclosure(closure4417, selfslot);
  struct UserObject *uo4417 = (struct UserObject*)block4416;
  uo4417->data[0] = (Object)closure4417;
  Method *meth_meth_collectionsPrelude__apply4417 = addmethod2pos(block4416, "_apply", &meth_collectionsPrelude__apply4417, 0);
  int argcv_meth_collectionsPrelude__apply4417[] = {1};
  meth_meth_collectionsPrelude__apply4417->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4417);
meth_meth_collectionsPrelude__apply4417->type->types[0] = type_Number;
meth_meth_collectionsPrelude__apply4417->type->names[0] = "__20";
  meth_meth_collectionsPrelude__apply4417->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4417->definitionLine = 1491;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4419 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe4420 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4421 == NULL) {
    strlit4421 = alloc_String("__20");
    gc_root(strlit4421);
  }
// compiled string node returning strlit4421 (depth = 6)
  gc_frame_newslot(strlit4421);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4422 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4423 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4422);
// compiled call node returning call4423 (depth = 7)
// compiled member node returning call4423 (depth = 6)
  params[0] = strlit4421;
  partcv[0] = 1;
  Object call4424 = callmethod(call4423, "new",
    1, partcv, params);
  gc_frame_end(callframe4420);
// compiled call node returning call4424 (depth = 5)
  gc_frame_newslot(call4424);
// Begin line 1843
  setline(1843);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4425 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4426 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4425);
// compiled call node returning call4426 (depth = 6)
// compiled member node returning call4426 (depth = 5)
  params[0] = call4424;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call4427 = callmethod(call4426, "new",
    1, partcv, params);
  gc_frame_end(callframe4419);
// compiled call node returning call4427 (depth = 4)
((struct UserObject *)block4416)->data[1] = call4427;
// compiled block node returning block4416 (depth = 3)
  gc_frame_newslot(block4416);
// Begin line 1844
  setline(1844);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4428 = alloc_Block(NULL, NULL, "collectionsPrelude", 1844);
  gc_frame_newslot(block4428);
// method "_apply"
  block_savedest(block4428);
  Object closure4429 = createclosure(4, "_apply");
  setclosureframe(closure4429, stackframe);
  addtoclosure(closure4429, var_upper);
  addtoclosure(closure4429, var_lower);
  addtoclosure(closure4429, var_RequestError);
  addtoclosure(closure4429, selfslot);
  struct UserObject *uo4429 = (struct UserObject*)block4428;
  uo4429->data[0] = (Object)closure4429;
  Method *meth_meth_collectionsPrelude__apply4429 = addmethod2pos(block4428, "_apply", &meth_collectionsPrelude__apply4429, 0);
  int argcv_meth_collectionsPrelude__apply4429[] = {1};
  meth_meth_collectionsPrelude__apply4429->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4429);
  meth_meth_collectionsPrelude__apply4429->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4429->definitionLine = 0;
// compiled block node returning block4428 (depth = 3)
  gc_frame_newslot(block4428);
  params[0] = block4416;
  params[1] = block4428;
  Object matchres4415 = matchCase(*var_lower, params, 2,NULL);
  gc_frame_end(frame4415);
// compiled matchcase node returning matchres4415 (depth = 2)
// Begin line 1846
  setline(1846);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4459 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lower (depth = 5)
  partcv[0] = 0;
  Object call4460 = callmethod(*var_lower, "truncated",
    1, partcv, params);
  gc_frame_end(callframe4459);
// compiled call node returning call4460 (depth = 4)
// compiled member node returning call4460 (depth = 3)
  *var_start = call4460;
  if (call4460 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1847
  setline(1847);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  int op_slot_right_4462 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_start (depth = 4)
  int op_slot_left_4462 = gc_frame_newslot(*var_start);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4464 = callmethod(*var_start, "≠", 1, partcv, params);
// compiled op node returning opresult4464 (depth = 3)
  Object if4461 = done;
  if (istrue(opresult4464)) {
// Begin line 1848
  setline(1848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4465 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1849
  setline(1849);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4468 == NULL) {
    strlit4468 = alloc_String(") is not an integer");
    gc_root(strlit4468);
  }
// compiled string node returning strlit4468 (depth = 6)
  int op_slot_right_4467 = gc_frame_newslot(strlit4468);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_upper (depth = 7)
  int op_slot_right_4470 = gc_frame_newslot(*var_upper);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit4473 == NULL) {
    strlit4473 = alloc_String(")to(");
    gc_root(strlit4473);
  }
// compiled string node returning strlit4473 (depth = 8)
  int op_slot_right_4472 = gc_frame_newslot(strlit4473);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_lower (depth = 9)
  int op_slot_right_4475 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 9)
  if (strlit4477 == NULL) {
    strlit4477 = alloc_String(" in range.from(");
    gc_root(strlit4477);
  }
// compiled string node returning strlit4477 (depth = 9)
  int op_slot_left_4475 = gc_frame_newslot(strlit4477);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4478 = callmethod(strlit4477, "++", 1, partcv, params);
// compiled op node returning opresult4478 (depth = 8)
  int op_slot_left_4472 = gc_frame_newslot(opresult4478);
  params[0] = strlit4473;
  partcv[0] = 1;
  Object opresult4479 = callmethod(opresult4478, "++", 1, partcv, params);
// compiled op node returning opresult4479 (depth = 7)
  int op_slot_left_4470 = gc_frame_newslot(opresult4479);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4480 = callmethod(opresult4479, "++", 1, partcv, params);
// compiled op node returning opresult4480 (depth = 6)
  int op_slot_left_4467 = gc_frame_newslot(opresult4480);
  params[0] = strlit4468;
  partcv[0] = 1;
  Object opresult4481 = callmethod(opresult4480, "++", 1, partcv, params);
// compiled op node returning opresult4481 (depth = 5)
  int op_slot_right_4466 = gc_frame_newslot(opresult4481);
// Begin line 1848
  setline(1848);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4484 == NULL) {
    strlit4484 = alloc_String("");
    gc_root(strlit4484);
  }
// compiled string node returning strlit4484 (depth = 6)
  int op_slot_right_4483 = gc_frame_newslot(strlit4484);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_4486 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 7)
  if (strlit4488 == NULL) {
    strlit4488 = alloc_String("lower bound ");
    gc_root(strlit4488);
  }
// compiled string node returning strlit4488 (depth = 7)
  int op_slot_left_4486 = gc_frame_newslot(strlit4488);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4489 = callmethod(strlit4488, "++", 1, partcv, params);
// compiled op node returning opresult4489 (depth = 6)
  int op_slot_left_4483 = gc_frame_newslot(opresult4489);
  params[0] = strlit4484;
  partcv[0] = 1;
  Object opresult4490 = callmethod(opresult4489, "++", 1, partcv, params);
// compiled op node returning opresult4490 (depth = 5)
  int op_slot_left_4466 = gc_frame_newslot(opresult4490);
  params[0] = opresult4481;
  partcv[0] = 1;
  Object opresult4491 = callmethod(opresult4490, "++", 1, partcv, params);
// compiled op node returning opresult4491 (depth = 4)
  gc_frame_newslot(opresult4491);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_RequestError (depth = 4)
  params[0] = opresult4491;
  partcv[0] = 1;
  Object call4492 = callmethod(*var_RequestError, "raise",
    1, partcv, params);
  gc_frame_end(callframe4465);
// compiled call node returning call4492 (depth = 3)
    gc_frame_newslot(call4492);
    if4461 = call4492;
  } else {
  }
// compiled if node returning if4461 (depth = 2)
// Begin line 1851
  setline(1851);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  int frame4493 = gc_frame_new();
  gc_frame_newslot(*var_upper);
// Begin line 1852
  setline(1852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4494 = alloc_Block(NULL, NULL, "collectionsPrelude", 1852);
  gc_frame_newslot(block4494);
// method "_apply"
  block_savedest(block4494);
  Object closure4495 = createclosure(1, "_apply");
  setclosureframe(closure4495, stackframe);
  addtoclosure(closure4495, selfslot);
  struct UserObject *uo4495 = (struct UserObject*)block4494;
  uo4495->data[0] = (Object)closure4495;
  Method *meth_meth_collectionsPrelude__apply4495 = addmethod2pos(block4494, "_apply", &meth_collectionsPrelude__apply4495, 0);
  int argcv_meth_collectionsPrelude__apply4495[] = {1};
  meth_meth_collectionsPrelude__apply4495->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4495);
meth_meth_collectionsPrelude__apply4495->type->types[0] = type_Number;
meth_meth_collectionsPrelude__apply4495->type->names[0] = "__22";
  meth_meth_collectionsPrelude__apply4495->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4495->definitionLine = 1846;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4497 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe4498 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4499 == NULL) {
    strlit4499 = alloc_String("__22");
    gc_root(strlit4499);
  }
// compiled string node returning strlit4499 (depth = 6)
  gc_frame_newslot(strlit4499);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4500 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4501 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4500);
// compiled call node returning call4501 (depth = 7)
// compiled member node returning call4501 (depth = 6)
  params[0] = strlit4499;
  partcv[0] = 1;
  Object call4502 = callmethod(call4501, "new",
    1, partcv, params);
  gc_frame_end(callframe4498);
// compiled call node returning call4502 (depth = 5)
  gc_frame_newslot(call4502);
// Begin line 1852
  setline(1852);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4503 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4504 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4503);
// compiled call node returning call4504 (depth = 6)
// compiled member node returning call4504 (depth = 5)
  params[0] = call4502;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call4505 = callmethod(call4504, "new",
    1, partcv, params);
  gc_frame_end(callframe4497);
// compiled call node returning call4505 (depth = 4)
((struct UserObject *)block4494)->data[1] = call4505;
// compiled block node returning block4494 (depth = 3)
  gc_frame_newslot(block4494);
// Begin line 1853
  setline(1853);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4506 = alloc_Block(NULL, NULL, "collectionsPrelude", 1853);
  gc_frame_newslot(block4506);
// method "_apply"
  block_savedest(block4506);
  Object closure4507 = createclosure(4, "_apply");
  setclosureframe(closure4507, stackframe);
  addtoclosure(closure4507, var_upper);
  addtoclosure(closure4507, var_lower);
  addtoclosure(closure4507, var_RequestError);
  addtoclosure(closure4507, selfslot);
  struct UserObject *uo4507 = (struct UserObject*)block4506;
  uo4507->data[0] = (Object)closure4507;
  Method *meth_meth_collectionsPrelude__apply4507 = addmethod2pos(block4506, "_apply", &meth_collectionsPrelude__apply4507, 0);
  int argcv_meth_collectionsPrelude__apply4507[] = {1};
  meth_meth_collectionsPrelude__apply4507->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4507);
  meth_meth_collectionsPrelude__apply4507->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4507->definitionLine = 0;
// compiled block node returning block4506 (depth = 3)
  gc_frame_newslot(block4506);
  params[0] = block4494;
  params[1] = block4506;
  Object matchres4493 = matchCase(*var_upper, params, 2,NULL);
  gc_frame_end(frame4493);
// compiled matchcase node returning matchres4493 (depth = 2)
// Begin line 1855
  setline(1855);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4537 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_upper (depth = 5)
  partcv[0] = 0;
  Object call4538 = callmethod(*var_upper, "truncated",
    1, partcv, params);
  gc_frame_end(callframe4537);
// compiled call node returning call4538 (depth = 4)
// compiled member node returning call4538 (depth = 3)
  *var_stop = call4538;
  if (call4538 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 1856
  setline(1856);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  int op_slot_right_4540 = gc_frame_newslot(*var_upper);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_stop (depth = 4)
  int op_slot_left_4540 = gc_frame_newslot(*var_stop);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4542 = callmethod(*var_stop, "≠", 1, partcv, params);
// compiled op node returning opresult4542 (depth = 3)
  Object if4539 = done;
  if (istrue(opresult4542)) {
// Begin line 1857
  setline(1857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4543 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1858
  setline(1858);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 5)
  if (strlit4545 == NULL) {
    strlit4545 = alloc_String(" in range.from()to() is not an integer");
    gc_root(strlit4545);
  }
// compiled string node returning strlit4545 (depth = 5)
  int op_slot_right_4544 = gc_frame_newslot(strlit4545);
// Begin line 1857
  setline(1857);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit4548 == NULL) {
    strlit4548 = alloc_String("");
    gc_root(strlit4548);
  }
// compiled string node returning strlit4548 (depth = 6)
  int op_slot_right_4547 = gc_frame_newslot(strlit4548);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_upper (depth = 7)
  int op_slot_right_4550 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 7)
  if (strlit4552 == NULL) {
    strlit4552 = alloc_String("upper bound ");
    gc_root(strlit4552);
  }
// compiled string node returning strlit4552 (depth = 7)
  int op_slot_left_4550 = gc_frame_newslot(strlit4552);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4553 = callmethod(strlit4552, "++", 1, partcv, params);
// compiled op node returning opresult4553 (depth = 6)
  int op_slot_left_4547 = gc_frame_newslot(opresult4553);
  params[0] = strlit4548;
  partcv[0] = 1;
  Object opresult4554 = callmethod(opresult4553, "++", 1, partcv, params);
// compiled op node returning opresult4554 (depth = 5)
  int op_slot_left_4544 = gc_frame_newslot(opresult4554);
  params[0] = strlit4545;
  partcv[0] = 1;
  Object opresult4555 = callmethod(opresult4554, "++", 1, partcv, params);
// compiled op node returning opresult4555 (depth = 4)
  gc_frame_newslot(opresult4555);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_RequestError (depth = 4)
  params[0] = opresult4555;
  partcv[0] = 1;
  Object call4556 = callmethod(*var_RequestError, "raise",
    1, partcv, params);
  gc_frame_end(callframe4543);
// compiled call node returning call4556 (depth = 3)
    gc_frame_newslot(call4556);
    if4539 = call4556;
  } else {
  }
// compiled if node returning if4539 (depth = 2)
// Begin line 1861
  setline(1861);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4557 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  gc_frame_newslot(*var_upper);
// call case 4: self request
  params[0] = *var_lower;
  params[1] = *var_upper;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4558 = callmethodflags(self, "uncheckedFrom()to", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4557);
// compiled call node returning call4558 (depth = 2)
  gc_frame_end(frame);
  return call4558;
}
Object meth_collectionsPrelude_hasNext4570(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1877
  setline(1877);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4572 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4573 = gc_frame_new();
// call case 3: self.outer request
  Object call4574 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4573);
// compiled call node returning call4574 (depth = 6)
// compiled member node returning call4574 (depth = 5)
  partcv[0] = 0;
  Object call4575 = callmethodflags(call4574, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4572);
// compiled call node returning call4575 (depth = 4)
// compiled member node returning call4575 (depth = 3)
  int op_slot_right_4571 = gc_frame_newslot(call4575);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4577 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4578 = callmethodflags(self, "val", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4577);
// compiled call node returning call4578 (depth = 4)
// compiled member node returning call4578 (depth = 3)
  int op_slot_left_4571 = gc_frame_newslot(call4578);
  params[0] = call4575;
  partcv[0] = 1;
  Object opresult4579 = callmethod(call4578, "≤", 1, partcv, params);
// compiled op node returning opresult4579 (depth = 2)
  gc_frame_end(frame);
  return opresult4579;
}
Object meth_collectionsPrelude_next4580(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1879
  setline(1879);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4583 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4584 = gc_frame_new();
// call case 3: self.outer request
  Object call4585 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4584);
// compiled call node returning call4585 (depth = 7)
// compiled member node returning call4585 (depth = 6)
  partcv[0] = 0;
  Object call4586 = callmethodflags(call4585, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4583);
// compiled call node returning call4586 (depth = 5)
// compiled member node returning call4586 (depth = 4)
  int op_slot_right_4582 = gc_frame_newslot(call4586);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4588 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4589 = callmethodflags(self, "val", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4588);
// compiled call node returning call4589 (depth = 5)
// compiled member node returning call4589 (depth = 4)
  int op_slot_left_4582 = gc_frame_newslot(call4589);
  params[0] = call4586;
  partcv[0] = 1;
  Object opresult4590 = callmethod(call4589, ">", 1, partcv, params);
// compiled op node returning opresult4590 (depth = 3)
  Object if4581 = done;
  if (istrue(opresult4590)) {
// Begin line 1880
  setline(1880);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4591 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4593 == NULL) {
    strlit4593 = alloc_String("");
    gc_root(strlit4593);
  }
// compiled string node returning strlit4593 (depth = 5)
  int op_slot_right_4592 = gc_frame_newslot(strlit4593);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4596 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4597 = gc_frame_new();
// call case 3: self.outer request
  Object call4598 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4597);
// compiled call node returning call4598 (depth = 9)
// compiled member node returning call4598 (depth = 8)
  partcv[0] = 0;
  Object call4599 = callmethodflags(call4598, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4596);
// compiled call node returning call4599 (depth = 7)
// compiled member node returning call4599 (depth = 6)
  int op_slot_right_4595 = gc_frame_newslot(call4599);
// starting to compile string node (depth = 6)
  if (strlit4601 == NULL) {
    strlit4601 = alloc_String("over ");
    gc_root(strlit4601);
  }
// compiled string node returning strlit4601 (depth = 6)
  int op_slot_left_4595 = gc_frame_newslot(strlit4601);
  params[0] = call4599;
  partcv[0] = 1;
  Object opresult4602 = callmethod(strlit4601, "++", 1, partcv, params);
// compiled op node returning opresult4602 (depth = 5)
  int op_slot_left_4592 = gc_frame_newslot(opresult4602);
  params[0] = strlit4593;
  partcv[0] = 1;
  Object opresult4603 = callmethod(opresult4602, "++", 1, partcv, params);
// compiled op node returning opresult4603 (depth = 4)
  gc_frame_newslot(opresult4603);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_IteratorExhausted (depth = 4)
  params[0] = opresult4603;
  partcv[0] = 1;
  Object call4604 = callmethod(*var_IteratorExhausted, "raise",
    1, partcv, params);
  gc_frame_end(callframe4591);
// compiled call node returning call4604 (depth = 3)
    gc_frame_newslot(call4604);
    if4581 = call4604;
  } else {
  }
// compiled if node returning if4581 (depth = 2)
// Begin line 1882
  setline(1882);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4605 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4607 = alloc_Float64(1);
// compiled num node returning num4607 (depth = 4)
  int op_slot_right_4606 = gc_frame_newslot(num4607);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4609 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4610 = callmethodflags(self, "val", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4609);
// compiled call node returning call4610 (depth = 5)
// compiled member node returning call4610 (depth = 4)
  int op_slot_left_4606 = gc_frame_newslot(call4610);
  params[0] = num4607;
  partcv[0] = 1;
  Object sum4611 = callmethod(call4610, "+", 1, partcv, params);
// compiled op node returning sum4611 (depth = 3)
  gc_frame_newslot(sum4611);
// call case 4: self request
  params[0] = sum4611;
  partcv[0] = 1;
  Object call4612 = callmethodflags(self, "val:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4605);
// compiled call node returning call4612 (depth = 2)
// Begin line 1883
  setline(1883);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4614 = alloc_Float64(1);
// compiled num node returning num4614 (depth = 4)
  int op_slot_right_4613 = gc_frame_newslot(num4614);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4616 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4617 = callmethodflags(self, "val", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4616);
// compiled call node returning call4617 (depth = 5)
// compiled member node returning call4617 (depth = 4)
  int op_slot_left_4613 = gc_frame_newslot(call4617);
  params[0] = num4614;
  partcv[0] = 1;
  Object diff4618 = callmethod(call4617, "-", 1, partcv, params);
// compiled op node returning diff4618 (depth = 3)
  return diff4618;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_asString4619(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lower = getfromclosure(closure, 0);
  Object *var_upper = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1885
  setline(1885);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit4621 == NULL) {
    strlit4621 = alloc_String("");
    gc_root(strlit4621);
  }
// compiled string node returning strlit4621 (depth = 3)
  int op_slot_right_4620 = gc_frame_newslot(strlit4621);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  int op_slot_right_4623 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4626 == NULL) {
    strlit4626 = alloc_String(" to ");
    gc_root(strlit4626);
  }
// compiled string node returning strlit4626 (depth = 5)
  int op_slot_right_4625 = gc_frame_newslot(strlit4626);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_right_4628 = gc_frame_newslot(*var_upper);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4631 == NULL) {
    strlit4631 = alloc_String(" from ");
    gc_root(strlit4631);
  }
// compiled string node returning strlit4631 (depth = 7)
  int op_slot_right_4630 = gc_frame_newslot(strlit4631);
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4634 = gc_frame_new();
// call case 1: super request
  partcv[0] = 0;
  Object call4635 = callmethod4(self, "asString", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe4634);
// compiled call node returning call4635 (depth = 9)
// compiled member node returning call4635 (depth = 8)
  int op_slot_right_4633 = gc_frame_newslot(call4635);
// starting to compile string node (depth = 8)
  if (strlit4637 == NULL) {
    strlit4637 = alloc_String("");
    gc_root(strlit4637);
  }
// compiled string node returning strlit4637 (depth = 8)
  int op_slot_left_4633 = gc_frame_newslot(strlit4637);
  params[0] = call4635;
  partcv[0] = 1;
  Object opresult4638 = callmethod(strlit4637, "++", 1, partcv, params);
// compiled op node returning opresult4638 (depth = 7)
  int op_slot_left_4630 = gc_frame_newslot(opresult4638);
  params[0] = strlit4631;
  partcv[0] = 1;
  Object opresult4639 = callmethod(opresult4638, "++", 1, partcv, params);
// compiled op node returning opresult4639 (depth = 6)
  int op_slot_left_4628 = gc_frame_newslot(opresult4639);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4640 = callmethod(opresult4639, "++", 1, partcv, params);
// compiled op node returning opresult4640 (depth = 5)
  int op_slot_left_4625 = gc_frame_newslot(opresult4640);
  params[0] = strlit4626;
  partcv[0] = 1;
  Object opresult4641 = callmethod(opresult4640, "++", 1, partcv, params);
// compiled op node returning opresult4641 (depth = 4)
  int op_slot_left_4623 = gc_frame_newslot(opresult4641);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4642 = callmethod(opresult4641, "++", 1, partcv, params);
// compiled op node returning opresult4642 (depth = 3)
  int op_slot_left_4620 = gc_frame_newslot(opresult4642);
  params[0] = strlit4621;
  partcv[0] = 1;
  Object opresult4643 = callmethod(opresult4642, "++", 1, partcv, params);
// compiled op node returning opresult4643 (depth = 2)
  gc_frame_end(frame);
  return opresult4643;
}
Object meth_collectionsPrelude_iterator4566(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  Object *var_upper = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4567 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4567 = alloc_userobj2(5,5, objclass4567);
  gc_frame_newslot(obj4567);
if (objclass4567 == NULL) {
  glfree(obj4567->class->name);
  obj4567->class->name = "collectionsPrelude.range.object.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4567, self, 0);
  addmethodreal(obj4567,"outer", &reader_collectionsPrelude_outer_4568);
  Object oldself4567 = self;
  struct StackFrameObject *oldstackframe4567 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4567);
  gc_frame_newslot((Object)stackframe);
  self = obj4567;
  Object *oldselfslot4567 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4567 = (*(struct UserObject *)self).data[0], lowerouter4567 = thisouter4567;
  if (inheritingObject4567) {
    struct UserObject *inho4567 = (struct UserObject *)inheritingObject4567;
    while (inho4567->super != GraceDefaultObject) inho4567 = (struct UserObject *)inho4567->super;
    inho4567->super = obj4567;
    self = inheritingObject4567;
    *selfslot = self;
    lowerouter4567 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4567;
  }
if (objclass4567 == NULL) {
  Method *reader4569 = addmethodrealflags(obj4567, "val",&reader_collectionsPrelude_val_4569, MFLAG_CONFIDENTIAL);
  Method *writer4569 = addmethodrealflags(obj4567, "val:=",&writer_collectionsPrelude_val_4569, MFLAG_CONFIDENTIAL);
  reader4569->definitionModule = modulename;
  writer4569->definitionModule = modulename;
  reader4569->definitionLine = 1876;
  writer4569->definitionLine = 1876;
}
obj4567->flags |= OFLAG_MUTABLE;
adddatum2(obj4567, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo4570 = (struct UserObject*)obj4567;
  uo4570->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext4570 = addmethod2pos(obj4567, "hasNext", &meth_collectionsPrelude_hasNext4570, 2);
  int argcv_meth_collectionsPrelude_hasNext4570[] = {0};
  meth_meth_collectionsPrelude_hasNext4570->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext4570);
  meth_meth_collectionsPrelude_hasNext4570->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext4570->definitionLine = 1877;
// method "next"
  block_savedest(obj4567);
  Object closure4580 = createclosure(1, "next");
  setclosureframe(closure4580, stackframe);
  addtoclosure(closure4580, var_IteratorExhausted);
  struct UserObject *uo4580 = (struct UserObject*)obj4567;
  uo4580->data[3] = (Object)closure4580;
  Method *meth_meth_collectionsPrelude_next4580 = addmethod2pos(obj4567, "next", &meth_collectionsPrelude_next4580, 3);
  int argcv_meth_collectionsPrelude_next4580[] = {0};
  meth_meth_collectionsPrelude_next4580->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next4580);
  meth_meth_collectionsPrelude_next4580->definitionModule = modulename;
  meth_meth_collectionsPrelude_next4580->definitionLine = 1878;
// method "asString"
  block_savedest(obj4567);
  Object closure4619 = createclosure(2, "asString");
  setclosureframe(closure4619, stackframe);
  addtoclosure(closure4619, var_lower);
  addtoclosure(closure4619, var_upper);
  struct UserObject *uo4619 = (struct UserObject*)obj4567;
  uo4619->data[4] = (Object)closure4619;
  Method *meth_meth_collectionsPrelude_asString4619 = addmethod2pos(obj4567, "asString", &meth_collectionsPrelude_asString4619, 4);
  int argcv_meth_collectionsPrelude_asString4619[] = {0};
  meth_meth_collectionsPrelude_asString4619->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4619);
  meth_meth_collectionsPrelude_asString4619->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4619->definitionLine = 1885;
  sourceObject = obj4567;
// Begin line 1876
  setline(1876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4644 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4645 = gc_frame_new();
// call case 3: self.outer request
  Object call4646 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4645);
// compiled call node returning call4646 (depth = 5)
// compiled member node returning call4646 (depth = 4)
  partcv[0] = 0;
  Object call4647 = callmethodflags(call4646, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4644);
// compiled call node returning call4647 (depth = 3)
// compiled member node returning call4647 (depth = 2)
  adddatum2(obj4567, call4647, 1);
  sourceObject = obj4567;
  sourceObject = obj4567;
  sourceObject = obj4567;
  objclass4567 = obj4567->class;
  objclass4567->definitionModule = modulename;
  objclass4567->definitionLine = 1875;
  (*(struct UserObject *)self).data[0] = lowerouter4567;
  self = oldself4567;
  selfslot = oldselfslot4567;
  stackframe = oldstackframe4567;
  gc_frame_end(frame);
  return obj4567;
}
Object meth_collectionsPrelude_iterator4566_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  Object *var_upper = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4567 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4567 = alloc_userobj2(5,5, objclass4567);
  gc_frame_newslot(obj4567);
if (objclass4567 == NULL) {
  glfree(obj4567->class->name);
  obj4567->class->name = "collectionsPrelude.range.object.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4567, self, 0);
  addmethodreal(obj4567,"outer", &reader_collectionsPrelude_outer_4568);
  Object oldself4567 = self;
  struct StackFrameObject *oldstackframe4567 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4567);
  gc_frame_newslot((Object)stackframe);
  self = obj4567;
  Object *oldselfslot4567 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4567 = (*(struct UserObject *)self).data[0], lowerouter4567 = thisouter4567;
  if (inheritingObject4567) {
    struct UserObject *inho4567 = (struct UserObject *)inheritingObject4567;
    while (inho4567->super != GraceDefaultObject) inho4567 = (struct UserObject *)inho4567->super;
    inho4567->super = obj4567;
    self = inheritingObject4567;
    *selfslot = self;
    lowerouter4567 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4567;
  }
if (objclass4567 == NULL) {
  Method *reader4569 = addmethodrealflags(obj4567, "val",&reader_collectionsPrelude_val_4569, MFLAG_CONFIDENTIAL);
  Method *writer4569 = addmethodrealflags(obj4567, "val:=",&writer_collectionsPrelude_val_4569, MFLAG_CONFIDENTIAL);
  reader4569->definitionModule = modulename;
  writer4569->definitionModule = modulename;
  reader4569->definitionLine = 1876;
  writer4569->definitionLine = 1876;
}
obj4567->flags |= OFLAG_MUTABLE;
adddatum2(obj4567, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo4570 = (struct UserObject*)obj4567;
  uo4570->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext4570 = addmethod2pos(obj4567, "hasNext", &meth_collectionsPrelude_hasNext4570, 2);
  int argcv_meth_collectionsPrelude_hasNext4570[] = {0};
  meth_meth_collectionsPrelude_hasNext4570->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext4570);
  meth_meth_collectionsPrelude_hasNext4570->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext4570->definitionLine = 1877;
// method "next"
  block_savedest(obj4567);
  Object closure4580 = createclosure(1, "next");
  setclosureframe(closure4580, stackframe);
  addtoclosure(closure4580, var_IteratorExhausted);
  struct UserObject *uo4580 = (struct UserObject*)obj4567;
  uo4580->data[3] = (Object)closure4580;
  Method *meth_meth_collectionsPrelude_next4580 = addmethod2pos(obj4567, "next", &meth_collectionsPrelude_next4580, 3);
  int argcv_meth_collectionsPrelude_next4580[] = {0};
  meth_meth_collectionsPrelude_next4580->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next4580);
  meth_meth_collectionsPrelude_next4580->definitionModule = modulename;
  meth_meth_collectionsPrelude_next4580->definitionLine = 1878;
// method "asString"
  block_savedest(obj4567);
  Object closure4619 = createclosure(2, "asString");
  setclosureframe(closure4619, stackframe);
  addtoclosure(closure4619, var_lower);
  addtoclosure(closure4619, var_upper);
  struct UserObject *uo4619 = (struct UserObject*)obj4567;
  uo4619->data[4] = (Object)closure4619;
  Method *meth_meth_collectionsPrelude_asString4619 = addmethod2pos(obj4567, "asString", &meth_collectionsPrelude_asString4619, 4);
  int argcv_meth_collectionsPrelude_asString4619[] = {0};
  meth_meth_collectionsPrelude_asString4619->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4619);
  meth_meth_collectionsPrelude_asString4619->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4619->definitionLine = 1885;
  sourceObject = obj4567;
// Begin line 1876
  setline(1876);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4644 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4645 = gc_frame_new();
// call case 3: self.outer request
  Object call4646 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4645);
// compiled call node returning call4646 (depth = 5)
// compiled member node returning call4646 (depth = 4)
  partcv[0] = 0;
  Object call4647 = callmethodflags(call4646, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4644);
// compiled call node returning call4647 (depth = 3)
// compiled member node returning call4647 (depth = 2)
  adddatum2(obj4567, call4647, 1);
  sourceObject = obj4567;
  sourceObject = obj4567;
  sourceObject = obj4567;
  objclass4567 = obj4567->class;
  objclass4567->definitionModule = modulename;
  objclass4567->definitionLine = 1875;
  (*(struct UserObject *)self).data[0] = lowerouter4567;
  self = oldself4567;
  selfslot = oldselfslot4567;
  stackframe = oldstackframe4567;
  gc_frame_end(frame);
  return obj4567;
}
Object meth_collectionsPrelude_at4649(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "at");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at");
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for at");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1889
  setline(1889);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4651 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4653 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4654 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4653);
// compiled call node returning call4654 (depth = 6)
// compiled member node returning call4654 (depth = 5)
  int op_slot_right_4652 = gc_frame_newslot(call4654);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_4652 = gc_frame_newslot(*var_ix);
  params[0] = call4654;
  partcv[0] = 1;
  Object opresult4656 = callmethod(*var_ix, "≤", 1, partcv, params);
// compiled op node returning opresult4656 (depth = 4)
  partcv[0] = 0;
  Object call4657 = callmethod(opresult4656, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe4651);
// compiled call node returning call4657 (depth = 3)
  Object if4650 = done;
  if (istrue(call4657)) {
// Begin line 1890
  setline(1890);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4658 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4660 == NULL) {
    strlit4660 = alloc_String("");
    gc_root(strlit4660);
  }
// compiled string node returning strlit4660 (depth = 5)
  int op_slot_right_4659 = gc_frame_newslot(strlit4660);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4663 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4664 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4663);
// compiled call node returning call4664 (depth = 7)
// compiled member node returning call4664 (depth = 6)
  int op_slot_right_4662 = gc_frame_newslot(call4664);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit4667 == NULL) {
    strlit4667 = alloc_String("), but upper bound is ");
    gc_root(strlit4667);
  }
// compiled string node returning strlit4667 (depth = 7)
  int op_slot_right_4666 = gc_frame_newslot(strlit4667);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  int op_slot_right_4669 = gc_frame_newslot(*var_ix);
// starting to compile string node (depth = 8)
  if (strlit4671 == NULL) {
    strlit4671 = alloc_String("requested range.at(");
    gc_root(strlit4671);
  }
// compiled string node returning strlit4671 (depth = 8)
  int op_slot_left_4669 = gc_frame_newslot(strlit4671);
  params[0] = *var_ix;
  partcv[0] = 1;
  Object opresult4672 = callmethod(strlit4671, "++", 1, partcv, params);
// compiled op node returning opresult4672 (depth = 7)
  int op_slot_left_4666 = gc_frame_newslot(opresult4672);
  params[0] = strlit4667;
  partcv[0] = 1;
  Object opresult4673 = callmethod(opresult4672, "++", 1, partcv, params);
// compiled op node returning opresult4673 (depth = 6)
  int op_slot_left_4662 = gc_frame_newslot(opresult4673);
  params[0] = call4664;
  partcv[0] = 1;
  Object opresult4674 = callmethod(opresult4673, "++", 1, partcv, params);
// compiled op node returning opresult4674 (depth = 5)
  int op_slot_left_4659 = gc_frame_newslot(opresult4674);
  params[0] = strlit4660;
  partcv[0] = 1;
  Object opresult4675 = callmethod(opresult4674, "++", 1, partcv, params);
// compiled op node returning opresult4675 (depth = 4)
  gc_frame_newslot(opresult4675);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult4675;
  partcv[0] = 1;
  Object call4676 = callmethod(*var_BoundsError, "raise",
    1, partcv, params);
  gc_frame_end(callframe4658);
// compiled call node returning call4676 (depth = 3)
    gc_frame_newslot(call4676);
    if4650 = call4676;
  } else {
  }
// compiled if node returning if4650 (depth = 2)
// Begin line 1892
  setline(1892);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4678 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4680 = alloc_Float64(1);
// compiled num node returning num4680 (depth = 5)
  int op_slot_right_4679 = gc_frame_newslot(num4680);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_4679 = gc_frame_newslot(*var_ix);
  params[0] = num4680;
  partcv[0] = 1;
  Object opresult4682 = callmethod(*var_ix, "≥", 1, partcv, params);
// compiled op node returning opresult4682 (depth = 4)
  partcv[0] = 0;
  Object call4683 = callmethod(opresult4682, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe4678);
// compiled call node returning call4683 (depth = 3)
  Object if4677 = done;
  if (istrue(call4683)) {
// Begin line 1893
  setline(1893);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe4684 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4686 == NULL) {
    strlit4686 = alloc_String("), but lower bound is 1");
    gc_root(strlit4686);
  }
// compiled string node returning strlit4686 (depth = 5)
  int op_slot_right_4685 = gc_frame_newslot(strlit4686);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_right_4688 = gc_frame_newslot(*var_ix);
// starting to compile string node (depth = 6)
  if (strlit4690 == NULL) {
    strlit4690 = alloc_String("requested range.at(");
    gc_root(strlit4690);
  }
// compiled string node returning strlit4690 (depth = 6)
  int op_slot_left_4688 = gc_frame_newslot(strlit4690);
  params[0] = *var_ix;
  partcv[0] = 1;
  Object opresult4691 = callmethod(strlit4690, "++", 1, partcv, params);
// compiled op node returning opresult4691 (depth = 5)
  int op_slot_left_4685 = gc_frame_newslot(opresult4691);
  params[0] = strlit4686;
  partcv[0] = 1;
  Object opresult4692 = callmethod(opresult4691, "++", 1, partcv, params);
// compiled op node returning opresult4692 (depth = 4)
  gc_frame_newslot(opresult4692);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult4692;
  partcv[0] = 1;
  Object call4693 = callmethod(*var_BoundsError, "raise",
    1, partcv, params);
  gc_frame_end(callframe4684);
// compiled call node returning call4693 (depth = 3)
    gc_frame_newslot(call4693);
    if4677 = call4693;
  } else {
  }
// compiled if node returning if4677 (depth = 2)
// Begin line 1895
  setline(1895);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4696 = alloc_Float64(1);
// compiled num node returning num4696 (depth = 5)
  int op_slot_right_4695 = gc_frame_newslot(num4696);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_4695 = gc_frame_newslot(*var_ix);
  params[0] = num4696;
  partcv[0] = 1;
  Object diff4698 = callmethod(*var_ix, "-", 1, partcv, params);
// compiled op node returning diff4698 (depth = 4)
  int op_slot_right_4694 = gc_frame_newslot(diff4698);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4700 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4701 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4700);
// compiled call node returning call4701 (depth = 5)
// compiled member node returning call4701 (depth = 4)
  int op_slot_left_4694 = gc_frame_newslot(call4701);
  params[0] = diff4698;
  partcv[0] = 1;
  Object sum4702 = callmethod(call4701, "+", 1, partcv, params);
// compiled op node returning sum4702 (depth = 3)
  return sum4702;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply4706(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_elem = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_intElem = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "intElem");
// Begin line 1899
  setline(1899);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4707 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_elem (depth = 7)
  partcv[0] = 0;
  Object call4708 = callmethod(*var_elem, "truncated",
    1, partcv, params);
  gc_frame_end(callframe4707);
// compiled call node returning call4708 (depth = 6)
// compiled member node returning call4708 (depth = 5)
  *var_intElem = call4708;
  if (call4708 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 1900
  setline(1900);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elem (depth = 6)
  int op_slot_right_4710 = gc_frame_newslot(*var_elem);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_4710 = gc_frame_newslot(*var_intElem);
  params[0] = *var_elem;
  partcv[0] = 1;
  Object opresult4712 = callmethod(*var_intElem, "≠", 1, partcv, params);
// compiled op node returning opresult4712 (depth = 5)
  Object if4709 = done;
  if (istrue(opresult4712)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4713 = alloc_Boolean(0);
// compiled identifier node returning bool4713 (depth = 6)
  block_return(realself, bool4713);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4709 = undefined;
  } else {
  }
// compiled if node returning if4709 (depth = 4)
// Begin line 1901
  setline(1901);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4716 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4717 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4716);
// compiled call node returning call4717 (depth = 7)
// compiled member node returning call4717 (depth = 6)
  int op_slot_right_4715 = gc_frame_newslot(call4717);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_4715 = gc_frame_newslot(*var_intElem);
  params[0] = call4717;
  partcv[0] = 1;
  Object opresult4719 = callmethod(*var_intElem, "<", 1, partcv, params);
// compiled op node returning opresult4719 (depth = 5)
  Object if4714 = done;
  if (istrue(opresult4719)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4720 = alloc_Boolean(0);
// compiled identifier node returning bool4720 (depth = 6)
  block_return(realself, bool4720);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4714 = undefined;
  } else {
  }
// compiled if node returning if4714 (depth = 4)
// Begin line 1902
  setline(1902);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4723 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4724 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4723);
// compiled call node returning call4724 (depth = 7)
// compiled member node returning call4724 (depth = 6)
  int op_slot_right_4722 = gc_frame_newslot(call4724);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_4722 = gc_frame_newslot(*var_intElem);
  params[0] = call4724;
  partcv[0] = 1;
  Object opresult4726 = callmethod(*var_intElem, ">", 1, partcv, params);
// compiled op node returning opresult4726 (depth = 5)
  Object if4721 = done;
  if (istrue(opresult4726)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool4727 = alloc_Boolean(0);
// compiled identifier node returning bool4727 (depth = 6)
  block_return(realself, bool4727);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if4721 = undefined;
  } else {
  }
// compiled if node returning if4721 (depth = 4)
  gc_frame_end(frame);
  return if4721;
}
Object meth_collectionsPrelude__apply4730(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ex = &(stackframe->slots[0]);
  *var_ex = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool4731 = alloc_Boolean(0);
// compiled identifier node returning bool4731 (depth = 5)
  block_return(realself, bool4731);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_contains4703(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "contains");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains");
  Object params[2];
  int partcv[1];
  Object *var__prelude = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elem = &(stackframe->slots[0]);
  *var_elem = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for contains");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1898
  setline(1898);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile trycatch node (depth = 2)
// starting to compile block node (depth = 3)
  Object block4705 = alloc_Block(NULL, NULL, "collectionsPrelude", 1898);
  gc_frame_newslot(block4705);
// method "_apply"
  block_savedest(block4705);
  Object closure4706 = createclosure(2, "_apply");
  setclosureframe(closure4706, stackframe);
  addtoclosure(closure4706, var_elem);
  addtoclosure(closure4706, selfslot);
  struct UserObject *uo4706 = (struct UserObject*)block4705;
  uo4706->data[0] = (Object)closure4706;
  Method *meth_meth_collectionsPrelude__apply4706 = addmethod2pos(block4705, "_apply", &meth_collectionsPrelude__apply4706, 0);
  int argcv_meth_collectionsPrelude__apply4706[] = {0};
  meth_meth_collectionsPrelude__apply4706->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4706);
  meth_meth_collectionsPrelude__apply4706->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4706->definitionLine = 1895;
// compiled block node returning block4705 (depth = 3)
  int frame4704 = gc_frame_new();
  gc_frame_newslot(block4705);
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block4729 = alloc_Block(NULL, NULL, "collectionsPrelude", 1903);
  gc_frame_newslot(block4729);
// method "_apply"
  block_savedest(block4729);
  Object closure4730 = createclosure(1, "_apply");
  setclosureframe(closure4730, stackframe);
  addtoclosure(closure4730, selfslot);
  struct UserObject *uo4730 = (struct UserObject*)block4729;
  uo4730->data[0] = (Object)closure4730;
  Method *meth_meth_collectionsPrelude__apply4730 = addmethod2pos(block4729, "_apply", &meth_collectionsPrelude__apply4730, 0);
  int argcv_meth_collectionsPrelude__apply4730[] = {1};
  meth_meth_collectionsPrelude__apply4730->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4730);
  meth_meth_collectionsPrelude__apply4730->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4730->definitionLine = 1902;
// starting to compile call node (depth = 4)
  int callframe4733 = gc_frame_new();
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe4734 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit4735 == NULL) {
    strlit4735 = alloc_String("ex");
    gc_root(strlit4735);
  }
// compiled string node returning strlit4735 (depth = 6)
  gc_frame_newslot(strlit4735);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4736 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4737 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4736);
// compiled call node returning call4737 (depth = 7)
// compiled member node returning call4737 (depth = 6)
  params[0] = strlit4735;
  partcv[0] = 1;
  Object call4738 = callmethod(call4737, "new",
    1, partcv, params);
  gc_frame_end(callframe4734);
// compiled call node returning call4738 (depth = 5)
  gc_frame_newslot(call4738);
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4739 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var__prelude (depth = 7)
  partcv[0] = 0;
  Object call4740 = callmethod(*var__prelude, "Exception",
    1, partcv, params);
  gc_frame_end(callframe4739);
// compiled call node returning call4740 (depth = 6)
// compiled member node returning call4740 (depth = 5)
  gc_frame_newslot(call4740);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4741 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call4742 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4741);
// compiled call node returning call4742 (depth = 6)
// compiled member node returning call4742 (depth = 5)
  params[0] = call4738;
  params[1] = call4740;
  partcv[0] = 2;
  Object call4743 = callmethod(call4742, "new",
    1, partcv, params);
  gc_frame_end(callframe4733);
// compiled call node returning call4743 (depth = 4)
((struct UserObject *)block4729)->data[1] = call4743;
// compiled block node returning block4729 (depth = 3)
  gc_frame_newslot(block4729);
  params[0] = block4729;
  setline(1898);
  Object catchres4704 = tryCatch(block4705, params, 1,NULL);
  gc_frame_end(frame4704);
// compiled trycatch node returning catchres4704 (depth = 2)
// Begin line 1904
  setline(1904);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool4744 = alloc_Boolean(1);
// compiled identifier node returning bool4744 (depth = 3)
  return bool4744;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply4750(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4752 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4753 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4752);
// compiled call node returning call4753 (depth = 6)
// compiled member node returning call4753 (depth = 5)
  int op_slot_right_4751 = gc_frame_newslot(call4753);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  int op_slot_left_4751 = gc_frame_newslot(*var_val);
  params[0] = call4753;
  partcv[0] = 1;
  Object opresult4755 = callmethod(*var_val, "≤", 1, partcv, params);
// compiled op node returning opresult4755 (depth = 4)
  gc_frame_end(frame);
  return opresult4755;
}
Object meth_collectionsPrelude__apply4758(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1909
  setline(1909);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4759 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block1 (depth = 5)
  params[0] = *var_val;
  partcv[0] = 1;
  Object call4760 = callmethod(*var_block1, "apply",
    1, partcv, params);
  gc_frame_end(callframe4759);
// compiled call node returning call4760 (depth = 4)
// Begin line 1910
  setline(1910);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4762 = alloc_Float64(1);
// compiled num node returning num4762 (depth = 6)
  int op_slot_right_4761 = gc_frame_newslot(num4762);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_val (depth = 6)
  int op_slot_left_4761 = gc_frame_newslot(*var_val);
  params[0] = num4762;
  partcv[0] = 1;
  Object sum4764 = callmethod(*var_val, "+", 1, partcv, params);
// compiled op node returning sum4764 (depth = 5)
  *var_val = sum4764;
  if (sum4764 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_do4745(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for do");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_val = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "val");
// Begin line 1907
  setline(1907);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4746 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4747 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4746);
// compiled call node returning call4747 (depth = 4)
// compiled member node returning call4747 (depth = 3)
  *var_val = call4747;
  if (call4747 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1908
  setline(1908);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4748 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4749 = alloc_Block(NULL, NULL, "collectionsPrelude", 1908);
  gc_frame_newslot(block4749);
// method "_apply"
  block_savedest(block4749);
  Object closure4750 = createclosure(2, "_apply");
  setclosureframe(closure4750, stackframe);
  addtoclosure(closure4750, var_val);
  addtoclosure(closure4750, selfslot);
  struct UserObject *uo4750 = (struct UserObject*)block4749;
  uo4750->data[0] = (Object)closure4750;
  Method *meth_meth_collectionsPrelude__apply4750 = addmethod2pos(block4749, "_apply", &meth_collectionsPrelude__apply4750, 0);
  int argcv_meth_collectionsPrelude__apply4750[] = {0};
  meth_meth_collectionsPrelude__apply4750->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4750);
  meth_meth_collectionsPrelude__apply4750->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4750->definitionLine = 1907;
// compiled block node returning block4749 (depth = 3)
  gc_frame_newslot(block4749);
// starting to compile block node (depth = 3)
  Object block4757 = alloc_Block(NULL, NULL, "collectionsPrelude", 1908);
  gc_frame_newslot(block4757);
// method "_apply"
  block_savedest(block4757);
  Object closure4758 = createclosure(3, "_apply");
  setclosureframe(closure4758, stackframe);
  addtoclosure(closure4758, var_val);
  addtoclosure(closure4758, var_block1);
  addtoclosure(closure4758, selfslot);
  struct UserObject *uo4758 = (struct UserObject*)block4757;
  uo4758->data[0] = (Object)closure4758;
  Method *meth_meth_collectionsPrelude__apply4758 = addmethod2pos(block4757, "_apply", &meth_collectionsPrelude__apply4758, 0);
  int argcv_meth_collectionsPrelude__apply4758[] = {0};
  meth_meth_collectionsPrelude__apply4758->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4758);
  meth_meth_collectionsPrelude__apply4758->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4758->definitionLine = 1908;
// compiled block node returning block4757 (depth = 3)
  gc_frame_newslot(block4757);
// call case 5: prelude request
  params[0] = block4749;
  params[1] = block4757;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4767 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4748);
// compiled call node returning call4767 (depth = 2)
  gc_frame_end(frame);
  return call4767;
}
Object meth_collectionsPrelude__apply4774(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4776 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4777 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4776);
// compiled call node returning call4777 (depth = 6)
// compiled member node returning call4777 (depth = 5)
  int op_slot_right_4775 = gc_frame_newslot(call4777);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  int op_slot_left_4775 = gc_frame_newslot(*var_val);
  params[0] = call4777;
  partcv[0] = 1;
  Object opresult4779 = callmethod(*var_val, "≤", 1, partcv, params);
// compiled op node returning opresult4779 (depth = 4)
  gc_frame_end(frame);
  return opresult4779;
}
Object meth_collectionsPrelude__apply4782(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_key = getfromclosure(closure, 0);
  Object *var_val = getfromclosure(closure, 1);
  Object *var_block2 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1917
  setline(1917);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe4783 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_key (depth = 5)
  gc_frame_newslot(*var_key);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block2 (depth = 5)
  params[0] = *var_key;
  params[1] = *var_val;
  partcv[0] = 2;
  Object call4784 = callmethod(*var_block2, "apply",
    1, partcv, params);
  gc_frame_end(callframe4783);
// compiled call node returning call4784 (depth = 4)
// Begin line 1918
  setline(1918);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4786 = alloc_Float64(1);
// compiled num node returning num4786 (depth = 6)
  int op_slot_right_4785 = gc_frame_newslot(num4786);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_key (depth = 6)
  int op_slot_left_4785 = gc_frame_newslot(*var_key);
  params[0] = num4786;
  partcv[0] = 1;
  Object sum4788 = callmethod(*var_key, "+", 1, partcv, params);
// compiled op node returning sum4788 (depth = 5)
  *var_key = sum4788;
  if (sum4788 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 1919
  setline(1919);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4791 = alloc_Float64(1);
// compiled num node returning num4791 (depth = 6)
  int op_slot_right_4790 = gc_frame_newslot(num4791);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_val (depth = 6)
  int op_slot_left_4790 = gc_frame_newslot(*var_val);
  params[0] = num4791;
  partcv[0] = 1;
  Object sum4793 = callmethod(*var_val, "+", 1, partcv, params);
// compiled op node returning sum4793 (depth = 5)
  *var_val = sum4793;
  if (sum4793 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_keysAndValuesDo4768(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysAndValuesDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for keysAndValuesDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_key = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "key");
  Object *var_val = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "val");
// Begin line 1914
  setline(1914);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num4769 = alloc_Float64(1);
// compiled num node returning num4769 (depth = 3)
  *var_key = num4769;
  if (num4769 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1915
  setline(1915);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4770 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4771 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4770);
// compiled call node returning call4771 (depth = 4)
// compiled member node returning call4771 (depth = 3)
  *var_val = call4771;
  if (call4771 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1916
  setline(1916);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4772 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block4773 = alloc_Block(NULL, NULL, "collectionsPrelude", 1916);
  gc_frame_newslot(block4773);
// method "_apply"
  block_savedest(block4773);
  Object closure4774 = createclosure(2, "_apply");
  setclosureframe(closure4774, stackframe);
  addtoclosure(closure4774, var_val);
  addtoclosure(closure4774, selfslot);
  struct UserObject *uo4774 = (struct UserObject*)block4773;
  uo4774->data[0] = (Object)closure4774;
  Method *meth_meth_collectionsPrelude__apply4774 = addmethod2pos(block4773, "_apply", &meth_collectionsPrelude__apply4774, 0);
  int argcv_meth_collectionsPrelude__apply4774[] = {0};
  meth_meth_collectionsPrelude__apply4774->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4774);
  meth_meth_collectionsPrelude__apply4774->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4774->definitionLine = 1915;
// compiled block node returning block4773 (depth = 3)
  gc_frame_newslot(block4773);
// starting to compile block node (depth = 3)
  Object block4781 = alloc_Block(NULL, NULL, "collectionsPrelude", 1916);
  gc_frame_newslot(block4781);
// method "_apply"
  block_savedest(block4781);
  Object closure4782 = createclosure(4, "_apply");
  setclosureframe(closure4782, stackframe);
  addtoclosure(closure4782, var_key);
  addtoclosure(closure4782, var_val);
  addtoclosure(closure4782, var_block2);
  addtoclosure(closure4782, selfslot);
  struct UserObject *uo4782 = (struct UserObject*)block4781;
  uo4782->data[0] = (Object)closure4782;
  Method *meth_meth_collectionsPrelude__apply4782 = addmethod2pos(block4781, "_apply", &meth_collectionsPrelude__apply4782, 0);
  int argcv_meth_collectionsPrelude__apply4782[] = {0};
  meth_meth_collectionsPrelude__apply4782->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4782);
  meth_meth_collectionsPrelude__apply4782->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4782->definitionLine = 1916;
// compiled block node returning block4781 (depth = 3)
  gc_frame_newslot(block4781);
// call case 5: prelude request
  params[0] = block4773;
  params[1] = block4781;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4796 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4772);
// compiled call node returning call4796 (depth = 2)
  gc_frame_end(frame);
  return call4796;
}
Object meth_collectionsPrelude_reversed4797(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 10, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_upper = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for reversed (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for reversed");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1923
  setline(1923);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4798 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  gc_frame_newslot(*var_upper);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  gc_frame_newslot(*var_lower);
// call case 2: outer request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4799 = gc_frame_new();
// call case 3: self.outer request
  Object call4800 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4799);
// compiled call node returning call4800 (depth = 4)
// compiled member node returning call4800 (depth = 3)
  params[0] = *var_upper;
  params[1] = *var_lower;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4801 = callmethodflags(call4800, "from()downTo", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4798);
// compiled call node returning call4801 (depth = 2)
  gc_frame_end(frame);
  return call4801;
}
Object meth_collectionsPrelude__43__43_4802(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++ (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ++");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1926
  setline(1926);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4803 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe4804 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4805 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4806 = gc_frame_new();
// call case 3: self.outer request
  Object call4807 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4806);
// compiled call node returning call4807 (depth = 7)
// compiled member node returning call4807 (depth = 6)
  partcv[0] = 0;
  Object call4808 = callmethodflags(call4807, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4805);
// compiled call node returning call4808 (depth = 5)
// compiled member node returning call4808 (depth = 4)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 2;
  Object call4809 = callmethodflags(call4808, "lazyConcatenation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4804);
// compiled call node returning call4809 (depth = 3)
  gc_frame_newslot(call4809);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4810 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4811 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4812 = gc_frame_new();
// call case 3: self.outer request
  Object call4813 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4812);
// compiled call node returning call4813 (depth = 8)
// compiled member node returning call4813 (depth = 7)
  partcv[0] = 0;
  Object call4814 = callmethodflags(call4813, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4811);
// compiled call node returning call4814 (depth = 6)
// compiled member node returning call4814 (depth = 5)
  partcv[0] = 0;
  Object call4815 = callmethodflags(call4814, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4810);
// compiled call node returning call4815 (depth = 4)
// compiled member node returning call4815 (depth = 3)
  params[0] = call4809;
  partcv[0] = 1;
  Object call4816 = callmethod(call4815, "withAll",
    1, partcv, params);
  gc_frame_end(callframe4803);
// compiled call node returning call4816 (depth = 2)
  gc_frame_end(frame);
  return call4816;
}
Object meth_collectionsPrelude__61__61_4817(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1929
  setline(1929);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4818 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 2: outer request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4819 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4820 = gc_frame_new();
// call case 3: self.outer request
  Object call4821 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4820);
// compiled call node returning call4821 (depth = 6)
// compiled member node returning call4821 (depth = 5)
  partcv[0] = 0;
  Object call4822 = callmethodflags(call4821, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4819);
// compiled call node returning call4822 (depth = 4)
// compiled member node returning call4822 (depth = 3)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4823 = callmethodflags(call4822, "isEqual()toIterable", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4818);
// compiled call node returning call4823 (depth = 2)
  gc_frame_end(frame);
  return call4823;
}
Object meth_collectionsPrelude_sorted4824(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sorted (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for sorted");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1931
  setline(1931);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_sortedBy4825(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for sortedBy");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1933
  setline(1933);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4826 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4827 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4828 = callmethodflags(self, "asList", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4827);
// compiled call node returning call4828 (depth = 4)
// compiled member node returning call4828 (depth = 3)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call4829 = callmethod(call4828, "sortBy",
    1, partcv, params);
  gc_frame_end(callframe4826);
// compiled call node returning call4829 (depth = 2)
  gc_frame_end(frame);
  return call4829;
}
Object meth_collectionsPrelude_keys4830(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keys (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for keys");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1935
  setline(1935);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4832 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4833 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4832);
// compiled call node returning call4833 (depth = 4)
// compiled member node returning call4833 (depth = 3)
  int op_slot_right_4831 = gc_frame_newslot(call4833);
// starting to compile num node (depth = 3)
  Object num4835 = alloc_Float64(1);
// compiled num node returning num4835 (depth = 3)
  int op_slot_left_4831 = gc_frame_newslot(num4835);
  params[0] = call4833;
  partcv[0] = 1;
  Object opresult4836 = callmethod(num4835, "..", 1, partcv, params);
// compiled op node returning opresult4836 (depth = 2)
  gc_frame_end(frame);
  return opresult4836;
}
Object meth_collectionsPrelude_values4837(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for values (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for values");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1937
  setline(1937);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_asString4838(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_upper = getfromclosure(closure, 0);
  Object *var_lower = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1940
  setline(1940);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit4840 == NULL) {
    strlit4840 = alloc_String(")");
    gc_root(strlit4840);
  }
// compiled string node returning strlit4840 (depth = 3)
  int op_slot_right_4839 = gc_frame_newslot(strlit4840);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  int op_slot_right_4842 = gc_frame_newslot(*var_upper);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4845 == NULL) {
    strlit4845 = alloc_String(")to(");
    gc_root(strlit4845);
  }
// compiled string node returning strlit4845 (depth = 5)
  int op_slot_right_4844 = gc_frame_newslot(strlit4845);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_4847 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 6)
  if (strlit4849 == NULL) {
    strlit4849 = alloc_String("range.from(");
    gc_root(strlit4849);
  }
// compiled string node returning strlit4849 (depth = 6)
  int op_slot_left_4847 = gc_frame_newslot(strlit4849);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult4850 = callmethod(strlit4849, "++", 1, partcv, params);
// compiled op node returning opresult4850 (depth = 5)
  int op_slot_left_4844 = gc_frame_newslot(opresult4850);
  params[0] = strlit4845;
  partcv[0] = 1;
  Object opresult4851 = callmethod(opresult4850, "++", 1, partcv, params);
// compiled op node returning opresult4851 (depth = 4)
  int op_slot_left_4842 = gc_frame_newslot(opresult4851);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult4852 = callmethod(opresult4851, "++", 1, partcv, params);
// compiled op node returning opresult4852 (depth = 3)
  int op_slot_left_4839 = gc_frame_newslot(opresult4852);
  params[0] = strlit4840;
  partcv[0] = 1;
  Object opresult4853 = callmethod(opresult4852, "++", 1, partcv, params);
// compiled op node returning opresult4853 (depth = 2)
  gc_frame_end(frame);
  return opresult4853;
}
Object meth_collectionsPrelude__apply4865(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe4866 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_each (depth = 5)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_result (depth = 5)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call4867 = callmethod(*var_result, "add",
    1, partcv, params);
  gc_frame_end(callframe4866);
// compiled call node returning call4867 (depth = 4)
  gc_frame_end(frame);
  return call4867;
}
Object meth_collectionsPrelude_asList4854(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asList");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asList (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asList");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 1944
  setline(1944);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4855 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4856 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4857 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe4858 = gc_frame_new();
// call case 3: self.outer request
  Object call4859 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4858);
// compiled call node returning call4859 (depth = 10)
// compiled member node returning call4859 (depth = 9)
  partcv[0] = 0;
  Object call4860 = callmethodflags(call4859, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4857);
// compiled call node returning call4860 (depth = 8)
// compiled member node returning call4860 (depth = 7)
  partcv[0] = 0;
  Object call4861 = callmethodflags(call4860, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4856);
// compiled call node returning call4861 (depth = 6)
// compiled member node returning call4861 (depth = 5)
  partcv[0] = 0;
  Object call4862 = callmethod(call4861, "empty",
    1, partcv, params);
  gc_frame_end(callframe4855);
// compiled call node returning call4862 (depth = 4)
// compiled member node returning call4862 (depth = 3)
  *var_result = call4862;
  if (call4862 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 1945
  setline(1945);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4863 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile block node (depth = 3)
  Object block4864 = alloc_Block(NULL, NULL, "collectionsPrelude", 1945);
  gc_frame_newslot(block4864);
// method "_apply"
  block_savedest(block4864);
  Object closure4865 = createclosure(2, "_apply");
  setclosureframe(closure4865, stackframe);
  addtoclosure(closure4865, var_result);
  addtoclosure(closure4865, selfslot);
  struct UserObject *uo4865 = (struct UserObject*)block4864;
  uo4865->data[0] = (Object)closure4865;
  Method *meth_meth_collectionsPrelude__apply4865 = addmethod2pos(block4864, "_apply", &meth_collectionsPrelude__apply4865, 0);
  int argcv_meth_collectionsPrelude__apply4865[] = {1};
  meth_meth_collectionsPrelude__apply4865->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4865);
  meth_meth_collectionsPrelude__apply4865->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4865->definitionLine = 1944;
// compiled block node returning block4864 (depth = 3)
  gc_frame_newslot(block4864);
// call case 5: prelude request
  params[0] = self;
  params[1] = block4864;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call4869 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4863);
// compiled call node returning call4869 (depth = 2)
// Begin line 1946
  setline(1946);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_result (depth = 2)
  gc_frame_end(frame);
  return *var_result;
}
Object meth_collectionsPrelude_asSequence4870(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asSequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asSequence (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asSequence");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1950
  setline(1950);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply4894(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4896 = alloc_Float64(3);
// compiled num node returning num4896 (depth = 4)
  int op_slot_right_4895 = gc_frame_newslot(num4896);
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4899 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe4900 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4901 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4900);
// compiled call node returning call4901 (depth = 8)
// compiled member node returning call4901 (depth = 7)
  partcv[0] = 0;
  Object call4902 = callmethod(call4901, "hash",
    1, partcv, params);
  gc_frame_end(callframe4899);
// compiled call node returning call4902 (depth = 6)
// compiled member node returning call4902 (depth = 5)
  int op_slot_right_4898 = gc_frame_newslot(call4902);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num4905 = alloc_Float64(1021);
// compiled num node returning num4905 (depth = 6)
  int op_slot_right_4904 = gc_frame_newslot(num4905);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4907 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4908 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4909 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4908);
// compiled call node returning call4909 (depth = 9)
// compiled member node returning call4909 (depth = 8)
  partcv[0] = 0;
  Object call4910 = callmethod(call4909, "hash",
    1, partcv, params);
  gc_frame_end(callframe4907);
// compiled call node returning call4910 (depth = 7)
// compiled member node returning call4910 (depth = 6)
  int op_slot_left_4904 = gc_frame_newslot(call4910);
  params[0] = num4905;
  partcv[0] = 1;
  Object prod4911 = callmethod(call4910, "*", 1, partcv, params);
// compiled op node returning prod4911 (depth = 5)
  int op_slot_left_4898 = gc_frame_newslot(prod4911);
  params[0] = call4902;
  partcv[0] = 1;
  Object sum4912 = callmethod(prod4911, "+", 1, partcv, params);
// compiled op node returning sum4912 (depth = 4)
  int op_slot_left_4895 = gc_frame_newslot(sum4912);
  params[0] = num4896;
  partcv[0] = 1;
  Object prod4913 = callmethod(sum4912, "*", 1, partcv, params);
// compiled op node returning prod4913 (depth = 3)
  gc_frame_end(frame);
  return prod4913;
}
Object meth_collectionsPrelude_uncheckedFrom_40__41_to4559(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "uncheckedFrom()to");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method uncheckedFrom()to");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method uncheckedFrom()to");
  Object params[1];
  int partcv[2];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_indexable = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for uncheckedFrom()to (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_lower = &(stackframe->slots[0]);
  *var_lower = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for uncheckedFrom");
  Object *var_upper = &(stackframe->slots[1]);
  *var_upper = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for to");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4560 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4560 = alloc_userobj2(20,21, objclass4560);
  gc_frame_newslot(obj4560);
if (objclass4560 == NULL) {
  glfree(obj4560->class->name);
  obj4560->class->name = "collectionsPrelude.range.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4560, self, 0);
  addmethodreal(obj4560,"outer", &reader_collectionsPrelude_outer_4561);
  Object oldself4560 = self;
  struct StackFrameObject *oldstackframe4560 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4560);
  gc_frame_newslot((Object)stackframe);
  self = obj4560;
  Object *oldselfslot4560 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4560 = (*(struct UserObject *)self).data[0], lowerouter4560 = thisouter4560;
  if (inheritingObject4560) {
    struct UserObject *inho4560 = (struct UserObject *)inheritingObject4560;
    while (inho4560->super != GraceDefaultObject) inho4560 = (struct UserObject *)inho4560->super;
    inho4560->super = obj4560;
    self = inheritingObject4560;
    *selfslot = self;
    lowerouter4560 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4560;
  }
if (objclass4560 == NULL) {
  Method *reader4562 = addmethodrealflags(obj4560, "start",&reader_collectionsPrelude_start_4562, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4562->definitionModule = modulename;
  reader4562->definitionLine = 1867;
}
adddatum2(obj4560, alloc_Undefined(), 1);
if (objclass4560 == NULL) {
  Method *reader4563 = addmethodrealflags(obj4560, "stop",&reader_collectionsPrelude_stop_4563, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4563->definitionModule = modulename;
  reader4563->definitionLine = 1868;
}
adddatum2(obj4560, alloc_Undefined(), 2);
if (objclass4560 == NULL) {
  Method *reader4564 = addmethodrealflags(obj4560, "size",&reader_collectionsPrelude_size_4564, MFLAG_DEF);
  reader4564->definitionModule = modulename;
  reader4564->definitionLine = 1869;
}
adddatum2(obj4560, alloc_Undefined(), 3);
if (objclass4560 == NULL) {
  Method *reader4565 = addmethodrealflags(obj4560, "hash",&reader_collectionsPrelude_hash_4565, MFLAG_DEF);
  reader4565->definitionModule = modulename;
  reader4565->definitionLine = 1872;
}
adddatum2(obj4560, alloc_Undefined(), 4);
// method "iterator"
  block_savedest(obj4560);
  Object closure4566 = createclosure(3, "iterator");
  setclosureframe(closure4566, stackframe);
  addtoclosure(closure4566, var_IteratorExhausted);
  addtoclosure(closure4566, var_lower);
  addtoclosure(closure4566, var_upper);
  struct UserObject *uo4566 = (struct UserObject*)obj4560;
  uo4566->data[5] = (Object)closure4566;
  Method *meth_meth_collectionsPrelude_iterator4566 = addmethod2pos(obj4560, "iterator", &meth_collectionsPrelude_iterator4566, 5);
  int argcv_meth_collectionsPrelude_iterator4566[] = {0};
  meth_meth_collectionsPrelude_iterator4566->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator4566);
  meth_meth_collectionsPrelude_iterator4566->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4566->definitionLine = 1874;
  block_savedest(obj4560);
  Object closure4648 = createclosure(3, "iterator()object");
  setclosureframe(closure4648, stackframe);
  addtoclosure(closure4648, var_IteratorExhausted);
  addtoclosure(closure4648, var_lower);
  addtoclosure(closure4648, var_upper);
  Method *meth_meth_collectionsPrelude_iterator4566_object = addmethod2pos(obj4560, "iterator()object", &meth_collectionsPrelude_iterator4566_object, 5);
  meth_meth_collectionsPrelude_iterator4566_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4566_object->definitionLine = 1874;
// method "at"
  block_savedest(obj4560);
  Object closure4649 = createclosure(1, "at");
  setclosureframe(closure4649, stackframe);
  addtoclosure(closure4649, var_BoundsError);
  struct UserObject *uo4649 = (struct UserObject*)obj4560;
  uo4649->data[6] = (Object)closure4649;
  Method *meth_meth_collectionsPrelude_at4649 = addmethod2pos(obj4560, "at", &meth_collectionsPrelude_at4649, 6);
  int argcv_meth_collectionsPrelude_at4649[] = {1};
  meth_meth_collectionsPrelude_at4649->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at4649);
meth_meth_collectionsPrelude_at4649->type->types[0] = type_Number;
meth_meth_collectionsPrelude_at4649->type->names[0] = "ix";
  meth_meth_collectionsPrelude_at4649->definitionModule = modulename;
  meth_meth_collectionsPrelude_at4649->definitionLine = 1888;
// method "contains"
  block_savedest(obj4560);
  Object closure4703 = createclosure(1, "contains");
  setclosureframe(closure4703, stackframe);
  addtoclosure(closure4703, var__prelude);
  struct UserObject *uo4703 = (struct UserObject*)obj4560;
  uo4703->data[7] = (Object)closure4703;
  Method *meth_meth_collectionsPrelude_contains4703 = addmethod2pos(obj4560, "contains", &meth_collectionsPrelude_contains4703, 7);
  int argcv_meth_collectionsPrelude_contains4703[] = {1};
  meth_meth_collectionsPrelude_contains4703->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains4703);
  meth_meth_collectionsPrelude_contains4703->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains4703->definitionLine = 1897;
// method "do"
  struct UserObject *uo4745 = (struct UserObject*)obj4560;
  uo4745->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do4745 = addmethod2pos(obj4560, "do", &meth_collectionsPrelude_do4745, 8);
  int argcv_meth_collectionsPrelude_do4745[] = {1};
  meth_meth_collectionsPrelude_do4745->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do4745);
  meth_meth_collectionsPrelude_do4745->definitionModule = modulename;
  meth_meth_collectionsPrelude_do4745->definitionLine = 1906;
// method "keysAndValuesDo"
  struct UserObject *uo4768 = (struct UserObject*)obj4560;
  uo4768->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo4768 = addmethod2pos(obj4560, "keysAndValuesDo", &meth_collectionsPrelude_keysAndValuesDo4768, 9);
  int argcv_meth_collectionsPrelude_keysAndValuesDo4768[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo4768->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo4768);
  meth_meth_collectionsPrelude_keysAndValuesDo4768->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo4768->definitionLine = 1913;
// method "reversed"
  block_savedest(obj4560);
  Object closure4797 = createclosure(2, "reversed");
  setclosureframe(closure4797, stackframe);
  addtoclosure(closure4797, var_upper);
  addtoclosure(closure4797, var_lower);
  struct UserObject *uo4797 = (struct UserObject*)obj4560;
  uo4797->data[10] = (Object)closure4797;
  Method *meth_meth_collectionsPrelude_reversed4797 = addmethod2pos(obj4560, "reversed", &meth_collectionsPrelude_reversed4797, 10);
  int argcv_meth_collectionsPrelude_reversed4797[] = {0};
  meth_meth_collectionsPrelude_reversed4797->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed4797);
  meth_meth_collectionsPrelude_reversed4797->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed4797->definitionLine = 1922;
// method "++"
  struct UserObject *uo4802 = (struct UserObject*)obj4560;
  uo4802->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_4802 = addmethod2pos(obj4560, "++", &meth_collectionsPrelude__43__43_4802, 11);
  int argcv_meth_collectionsPrelude__43__43_4802[] = {1};
  meth_meth_collectionsPrelude__43__43_4802->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_4802);
  meth_meth_collectionsPrelude__43__43_4802->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_4802->definitionLine = 1925;
// method "=="
  struct UserObject *uo4817 = (struct UserObject*)obj4560;
  uo4817->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61_4817 = addmethod2pos(obj4560, "==", &meth_collectionsPrelude__61__61_4817, 12);
  int argcv_meth_collectionsPrelude__61__61_4817[] = {1};
  meth_meth_collectionsPrelude__61__61_4817->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_4817);
  meth_meth_collectionsPrelude__61__61_4817->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_4817->definitionLine = 1928;
// method "sorted"
  struct UserObject *uo4824 = (struct UserObject*)obj4560;
  uo4824->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted4824 = addmethod2pos(obj4560, "sorted", &meth_collectionsPrelude_sorted4824, 13);
  int argcv_meth_collectionsPrelude_sorted4824[] = {0};
  meth_meth_collectionsPrelude_sorted4824->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted4824);
  meth_meth_collectionsPrelude_sorted4824->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted4824->definitionLine = 1931;
// method "sortedBy"
  struct UserObject *uo4825 = (struct UserObject*)obj4560;
  uo4825->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy4825 = addmethod2pos(obj4560, "sortedBy", &meth_collectionsPrelude_sortedBy4825, 14);
  int argcv_meth_collectionsPrelude_sortedBy4825[] = {1};
  meth_meth_collectionsPrelude_sortedBy4825->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy4825);
  meth_meth_collectionsPrelude_sortedBy4825->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy4825->definitionLine = 1933;
// method "keys"
  struct UserObject *uo4830 = (struct UserObject*)obj4560;
  uo4830->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys4830 = addmethod2pos(obj4560, "keys", &meth_collectionsPrelude_keys4830, 15);
  int argcv_meth_collectionsPrelude_keys4830[] = {0};
  meth_meth_collectionsPrelude_keys4830->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys4830);
  meth_meth_collectionsPrelude_keys4830->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys4830->definitionLine = 1935;
// method "values"
  struct UserObject *uo4837 = (struct UserObject*)obj4560;
  uo4837->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values4837 = addmethod2pos(obj4560, "values", &meth_collectionsPrelude_values4837, 16);
  int argcv_meth_collectionsPrelude_values4837[] = {0};
  meth_meth_collectionsPrelude_values4837->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values4837);
  meth_meth_collectionsPrelude_values4837->definitionModule = modulename;
  meth_meth_collectionsPrelude_values4837->definitionLine = 1937;
// method "asString"
  block_savedest(obj4560);
  Object closure4838 = createclosure(2, "asString");
  setclosureframe(closure4838, stackframe);
  addtoclosure(closure4838, var_upper);
  addtoclosure(closure4838, var_lower);
  struct UserObject *uo4838 = (struct UserObject*)obj4560;
  uo4838->data[17] = (Object)closure4838;
  Method *meth_meth_collectionsPrelude_asString4838 = addmethod2pos(obj4560, "asString", &meth_collectionsPrelude_asString4838, 17);
  int argcv_meth_collectionsPrelude_asString4838[] = {0};
  meth_meth_collectionsPrelude_asString4838->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4838);
  meth_meth_collectionsPrelude_asString4838->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4838->definitionLine = 1939;
// method "asList"
  struct UserObject *uo4854 = (struct UserObject*)obj4560;
  uo4854->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asList4854 = addmethod2pos(obj4560, "asList", &meth_collectionsPrelude_asList4854, 18);
  int argcv_meth_collectionsPrelude_asList4854[] = {0};
  meth_meth_collectionsPrelude_asList4854->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asList4854);
  meth_meth_collectionsPrelude_asList4854->definitionModule = modulename;
  meth_meth_collectionsPrelude_asList4854->definitionLine = 1943;
// method "asSequence"
  struct UserObject *uo4870 = (struct UserObject*)obj4560;
  uo4870->data[19] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSequence4870 = addmethod2pos(obj4560, "asSequence", &meth_collectionsPrelude_asSequence4870, 19);
  int argcv_meth_collectionsPrelude_asSequence4870[] = {0};
  meth_meth_collectionsPrelude_asSequence4870->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSequence4870);
  meth_meth_collectionsPrelude_asSequence4870->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSequence4870->definitionLine = 1949;
  sourceObject = obj4560;
// Begin line 1866
  setline(1866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4871 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4872 = callmethod(*var_indexable, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe4871);
// compiled call node returning call4872 (depth = 2)
  struct UserObject *obj4560_uo = (struct UserObject *)obj4560;
  obj4560_uo->super = call4872;
  sourceObject = obj4560;
// Begin line 1867
  setline(1867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_lower (depth = 2)
  adddatum2(obj4560, *var_lower, 1);
  sourceObject = obj4560;
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_upper (depth = 2)
  adddatum2(obj4560, *var_upper, 2);
  sourceObject = obj4560;
// Begin line 1870
  setline(1870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4875 = alloc_Float64(0);
// compiled num node returning num4875 (depth = 4)
  int op_slot_right_4874 = gc_frame_newslot(num4875);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4878 = alloc_Float64(1);
// compiled num node returning num4878 (depth = 5)
  int op_slot_right_4877 = gc_frame_newslot(num4878);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_4880 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_left_4880 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff4882 = callmethod(*var_upper, "-", 1, partcv, params);
// compiled op node returning diff4882 (depth = 5)
  int op_slot_left_4877 = gc_frame_newslot(diff4882);
  params[0] = num4878;
  partcv[0] = 1;
  Object sum4883 = callmethod(diff4882, "+", 1, partcv, params);
// compiled op node returning sum4883 (depth = 4)
  int op_slot_left_4874 = gc_frame_newslot(sum4883);
  params[0] = num4875;
  partcv[0] = 1;
  Object opresult4884 = callmethod(sum4883, "<", 1, partcv, params);
// compiled op node returning opresult4884 (depth = 3)
  Object if4873 = done;
struct StackFrameObject *iftmpstackframe4873 = stackframe;
  if (istrue(opresult4884)) {
stackframe = alloc_StackFrame(0, iftmpstackframe4873);
gc_frame_newslot((Object)stackframe);
// starting to compile num node (depth = 3)
  Object num4885 = alloc_Float64(0);
// compiled num node returning num4885 (depth = 3)
    gc_frame_newslot(num4885);
    if4873 = num4885;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe4873);
  gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4887 = alloc_Float64(1);
// compiled num node returning num4887 (depth = 4)
  int op_slot_right_4886 = gc_frame_newslot(num4887);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lower (depth = 5)
  int op_slot_right_4889 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_upper (depth = 5)
  int op_slot_left_4889 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff4891 = callmethod(*var_upper, "-", 1, partcv, params);
// compiled op node returning diff4891 (depth = 4)
  int op_slot_left_4886 = gc_frame_newslot(diff4891);
  params[0] = num4887;
  partcv[0] = 1;
  Object sum4892 = callmethod(diff4891, "+", 1, partcv, params);
// compiled op node returning sum4892 (depth = 3)
    gc_frame_newslot(sum4892);
    if4873 = sum4892;
  }
stackframe = iftmpstackframe4873;
// compiled if node returning if4873 (depth = 2)
  adddatum2(obj4560, if4873, 3);
  sourceObject = obj4560;
// Begin line 1872
  setline(1872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 2)
  Object block4893 = alloc_Block(NULL, NULL, "collectionsPrelude", 1872);
  gc_frame_newslot(block4893);
// method "_apply"
  block_savedest(block4893);
  Object closure4894 = createclosure(1, "_apply");
  setclosureframe(closure4894, stackframe);
  addtoclosure(closure4894, selfslot);
  struct UserObject *uo4894 = (struct UserObject*)block4893;
  uo4894->data[0] = (Object)closure4894;
  Method *meth_meth_collectionsPrelude__apply4894 = addmethod2pos(block4893, "_apply", &meth_collectionsPrelude__apply4894, 0);
  int argcv_meth_collectionsPrelude__apply4894[] = {0};
  meth_meth_collectionsPrelude__apply4894->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4894);
  meth_meth_collectionsPrelude__apply4894->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4894->definitionLine = 1944;
// compiled block node returning block4893 (depth = 2)
  adddatum2(obj4560, block4893, 4);
  sourceObject = obj4560;
  sourceObject = obj4560;
  sourceObject = obj4560;
  sourceObject = obj4560;
  sourceObject = obj4560;
  sourceObject = obj4560;
  sourceObject = obj4560;
  sourceObject = obj4560;
  sourceObject = obj4560;
  sourceObject = obj4560;
  sourceObject = obj4560;
  sourceObject = obj4560;
  sourceObject = obj4560;
  sourceObject = obj4560;
  sourceObject = obj4560;
  objclass4560 = obj4560->class;
  objclass4560->definitionModule = modulename;
  objclass4560->definitionLine = 1865;
  (*(struct UserObject *)self).data[0] = lowerouter4560;
  self = oldself4560;
  selfslot = oldselfslot4560;
  stackframe = oldstackframe4560;
  gc_frame_end(frame);
  return obj4560;
}
Object meth_collectionsPrelude_uncheckedFrom_40__41_to4559_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "uncheckedFrom()to()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method uncheckedFrom()to()object");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method uncheckedFrom()to()object");
  Object params[1];
  int partcv[2];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_indexable = getfromclosure(closure, 3);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for uncheckedFrom()to (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_lower = &(stackframe->slots[0]);
  *var_lower = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for uncheckedFrom");
  Object *var_upper = &(stackframe->slots[1]);
  *var_upper = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for to");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4560 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4560 = alloc_userobj2(20,21, objclass4560);
  gc_frame_newslot(obj4560);
if (objclass4560 == NULL) {
  glfree(obj4560->class->name);
  obj4560->class->name = "collectionsPrelude.range.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4560, self, 0);
  addmethodreal(obj4560,"outer", &reader_collectionsPrelude_outer_4561);
  Object oldself4560 = self;
  struct StackFrameObject *oldstackframe4560 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4560);
  gc_frame_newslot((Object)stackframe);
  self = obj4560;
  Object *oldselfslot4560 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4560 = (*(struct UserObject *)self).data[0], lowerouter4560 = thisouter4560;
  if (inheritingObject4560) {
    struct UserObject *inho4560 = (struct UserObject *)inheritingObject4560;
    while (inho4560->super != GraceDefaultObject) inho4560 = (struct UserObject *)inho4560->super;
    inho4560->super = obj4560;
    self = inheritingObject4560;
    *selfslot = self;
    lowerouter4560 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4560;
  }
if (objclass4560 == NULL) {
  Method *reader4562 = addmethodrealflags(obj4560, "start",&reader_collectionsPrelude_start_4562, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4562->definitionModule = modulename;
  reader4562->definitionLine = 1867;
}
adddatum2(obj4560, alloc_Undefined(), 1);
if (objclass4560 == NULL) {
  Method *reader4563 = addmethodrealflags(obj4560, "stop",&reader_collectionsPrelude_stop_4563, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4563->definitionModule = modulename;
  reader4563->definitionLine = 1868;
}
adddatum2(obj4560, alloc_Undefined(), 2);
if (objclass4560 == NULL) {
  Method *reader4564 = addmethodrealflags(obj4560, "size",&reader_collectionsPrelude_size_4564, MFLAG_DEF);
  reader4564->definitionModule = modulename;
  reader4564->definitionLine = 1869;
}
adddatum2(obj4560, alloc_Undefined(), 3);
if (objclass4560 == NULL) {
  Method *reader4565 = addmethodrealflags(obj4560, "hash",&reader_collectionsPrelude_hash_4565, MFLAG_DEF);
  reader4565->definitionModule = modulename;
  reader4565->definitionLine = 1872;
}
adddatum2(obj4560, alloc_Undefined(), 4);
// method "iterator"
  block_savedest(obj4560);
  Object closure4566 = createclosure(3, "iterator");
  setclosureframe(closure4566, stackframe);
  addtoclosure(closure4566, var_IteratorExhausted);
  addtoclosure(closure4566, var_lower);
  addtoclosure(closure4566, var_upper);
  struct UserObject *uo4566 = (struct UserObject*)obj4560;
  uo4566->data[5] = (Object)closure4566;
  Method *meth_meth_collectionsPrelude_iterator4566 = addmethod2pos(obj4560, "iterator", &meth_collectionsPrelude_iterator4566, 5);
  int argcv_meth_collectionsPrelude_iterator4566[] = {0};
  meth_meth_collectionsPrelude_iterator4566->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator4566);
  meth_meth_collectionsPrelude_iterator4566->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4566->definitionLine = 1874;
  block_savedest(obj4560);
  Object closure4648 = createclosure(3, "iterator()object");
  setclosureframe(closure4648, stackframe);
  addtoclosure(closure4648, var_IteratorExhausted);
  addtoclosure(closure4648, var_lower);
  addtoclosure(closure4648, var_upper);
  Method *meth_meth_collectionsPrelude_iterator4566_object = addmethod2pos(obj4560, "iterator()object", &meth_collectionsPrelude_iterator4566_object, 5);
  meth_meth_collectionsPrelude_iterator4566_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4566_object->definitionLine = 1874;
// method "at"
  block_savedest(obj4560);
  Object closure4649 = createclosure(1, "at");
  setclosureframe(closure4649, stackframe);
  addtoclosure(closure4649, var_BoundsError);
  struct UserObject *uo4649 = (struct UserObject*)obj4560;
  uo4649->data[6] = (Object)closure4649;
  Method *meth_meth_collectionsPrelude_at4649 = addmethod2pos(obj4560, "at", &meth_collectionsPrelude_at4649, 6);
  int argcv_meth_collectionsPrelude_at4649[] = {1};
  meth_meth_collectionsPrelude_at4649->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at4649);
meth_meth_collectionsPrelude_at4649->type->types[0] = type_Number;
meth_meth_collectionsPrelude_at4649->type->names[0] = "ix";
  meth_meth_collectionsPrelude_at4649->definitionModule = modulename;
  meth_meth_collectionsPrelude_at4649->definitionLine = 1888;
// method "contains"
  block_savedest(obj4560);
  Object closure4703 = createclosure(1, "contains");
  setclosureframe(closure4703, stackframe);
  addtoclosure(closure4703, var__prelude);
  struct UserObject *uo4703 = (struct UserObject*)obj4560;
  uo4703->data[7] = (Object)closure4703;
  Method *meth_meth_collectionsPrelude_contains4703 = addmethod2pos(obj4560, "contains", &meth_collectionsPrelude_contains4703, 7);
  int argcv_meth_collectionsPrelude_contains4703[] = {1};
  meth_meth_collectionsPrelude_contains4703->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains4703);
  meth_meth_collectionsPrelude_contains4703->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains4703->definitionLine = 1897;
// method "do"
  struct UserObject *uo4745 = (struct UserObject*)obj4560;
  uo4745->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do4745 = addmethod2pos(obj4560, "do", &meth_collectionsPrelude_do4745, 8);
  int argcv_meth_collectionsPrelude_do4745[] = {1};
  meth_meth_collectionsPrelude_do4745->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do4745);
  meth_meth_collectionsPrelude_do4745->definitionModule = modulename;
  meth_meth_collectionsPrelude_do4745->definitionLine = 1906;
// method "keysAndValuesDo"
  struct UserObject *uo4768 = (struct UserObject*)obj4560;
  uo4768->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo4768 = addmethod2pos(obj4560, "keysAndValuesDo", &meth_collectionsPrelude_keysAndValuesDo4768, 9);
  int argcv_meth_collectionsPrelude_keysAndValuesDo4768[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo4768->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo4768);
  meth_meth_collectionsPrelude_keysAndValuesDo4768->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo4768->definitionLine = 1913;
// method "reversed"
  block_savedest(obj4560);
  Object closure4797 = createclosure(2, "reversed");
  setclosureframe(closure4797, stackframe);
  addtoclosure(closure4797, var_upper);
  addtoclosure(closure4797, var_lower);
  struct UserObject *uo4797 = (struct UserObject*)obj4560;
  uo4797->data[10] = (Object)closure4797;
  Method *meth_meth_collectionsPrelude_reversed4797 = addmethod2pos(obj4560, "reversed", &meth_collectionsPrelude_reversed4797, 10);
  int argcv_meth_collectionsPrelude_reversed4797[] = {0};
  meth_meth_collectionsPrelude_reversed4797->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed4797);
  meth_meth_collectionsPrelude_reversed4797->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed4797->definitionLine = 1922;
// method "++"
  struct UserObject *uo4802 = (struct UserObject*)obj4560;
  uo4802->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_4802 = addmethod2pos(obj4560, "++", &meth_collectionsPrelude__43__43_4802, 11);
  int argcv_meth_collectionsPrelude__43__43_4802[] = {1};
  meth_meth_collectionsPrelude__43__43_4802->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_4802);
  meth_meth_collectionsPrelude__43__43_4802->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_4802->definitionLine = 1925;
// method "=="
  struct UserObject *uo4817 = (struct UserObject*)obj4560;
  uo4817->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61_4817 = addmethod2pos(obj4560, "==", &meth_collectionsPrelude__61__61_4817, 12);
  int argcv_meth_collectionsPrelude__61__61_4817[] = {1};
  meth_meth_collectionsPrelude__61__61_4817->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_4817);
  meth_meth_collectionsPrelude__61__61_4817->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_4817->definitionLine = 1928;
// method "sorted"
  struct UserObject *uo4824 = (struct UserObject*)obj4560;
  uo4824->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted4824 = addmethod2pos(obj4560, "sorted", &meth_collectionsPrelude_sorted4824, 13);
  int argcv_meth_collectionsPrelude_sorted4824[] = {0};
  meth_meth_collectionsPrelude_sorted4824->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted4824);
  meth_meth_collectionsPrelude_sorted4824->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted4824->definitionLine = 1931;
// method "sortedBy"
  struct UserObject *uo4825 = (struct UserObject*)obj4560;
  uo4825->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy4825 = addmethod2pos(obj4560, "sortedBy", &meth_collectionsPrelude_sortedBy4825, 14);
  int argcv_meth_collectionsPrelude_sortedBy4825[] = {1};
  meth_meth_collectionsPrelude_sortedBy4825->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy4825);
  meth_meth_collectionsPrelude_sortedBy4825->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy4825->definitionLine = 1933;
// method "keys"
  struct UserObject *uo4830 = (struct UserObject*)obj4560;
  uo4830->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys4830 = addmethod2pos(obj4560, "keys", &meth_collectionsPrelude_keys4830, 15);
  int argcv_meth_collectionsPrelude_keys4830[] = {0};
  meth_meth_collectionsPrelude_keys4830->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys4830);
  meth_meth_collectionsPrelude_keys4830->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys4830->definitionLine = 1935;
// method "values"
  struct UserObject *uo4837 = (struct UserObject*)obj4560;
  uo4837->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values4837 = addmethod2pos(obj4560, "values", &meth_collectionsPrelude_values4837, 16);
  int argcv_meth_collectionsPrelude_values4837[] = {0};
  meth_meth_collectionsPrelude_values4837->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values4837);
  meth_meth_collectionsPrelude_values4837->definitionModule = modulename;
  meth_meth_collectionsPrelude_values4837->definitionLine = 1937;
// method "asString"
  block_savedest(obj4560);
  Object closure4838 = createclosure(2, "asString");
  setclosureframe(closure4838, stackframe);
  addtoclosure(closure4838, var_upper);
  addtoclosure(closure4838, var_lower);
  struct UserObject *uo4838 = (struct UserObject*)obj4560;
  uo4838->data[17] = (Object)closure4838;
  Method *meth_meth_collectionsPrelude_asString4838 = addmethod2pos(obj4560, "asString", &meth_collectionsPrelude_asString4838, 17);
  int argcv_meth_collectionsPrelude_asString4838[] = {0};
  meth_meth_collectionsPrelude_asString4838->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4838);
  meth_meth_collectionsPrelude_asString4838->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4838->definitionLine = 1939;
// method "asList"
  struct UserObject *uo4854 = (struct UserObject*)obj4560;
  uo4854->data[18] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asList4854 = addmethod2pos(obj4560, "asList", &meth_collectionsPrelude_asList4854, 18);
  int argcv_meth_collectionsPrelude_asList4854[] = {0};
  meth_meth_collectionsPrelude_asList4854->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asList4854);
  meth_meth_collectionsPrelude_asList4854->definitionModule = modulename;
  meth_meth_collectionsPrelude_asList4854->definitionLine = 1943;
// method "asSequence"
  struct UserObject *uo4870 = (struct UserObject*)obj4560;
  uo4870->data[19] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSequence4870 = addmethod2pos(obj4560, "asSequence", &meth_collectionsPrelude_asSequence4870, 19);
  int argcv_meth_collectionsPrelude_asSequence4870[] = {0};
  meth_meth_collectionsPrelude_asSequence4870->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSequence4870);
  meth_meth_collectionsPrelude_asSequence4870->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSequence4870->definitionLine = 1949;
  sourceObject = obj4560;
// Begin line 1866
  setline(1866);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4871 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call4872 = callmethod(*var_indexable, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe4871);
// compiled call node returning call4872 (depth = 2)
  struct UserObject *obj4560_uo = (struct UserObject *)obj4560;
  obj4560_uo->super = call4872;
  sourceObject = obj4560;
// Begin line 1867
  setline(1867);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_lower (depth = 2)
  adddatum2(obj4560, *var_lower, 1);
  sourceObject = obj4560;
// Begin line 1868
  setline(1868);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_upper (depth = 2)
  adddatum2(obj4560, *var_upper, 2);
  sourceObject = obj4560;
// Begin line 1870
  setline(1870);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4875 = alloc_Float64(0);
// compiled num node returning num4875 (depth = 4)
  int op_slot_right_4874 = gc_frame_newslot(num4875);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num4878 = alloc_Float64(1);
// compiled num node returning num4878 (depth = 5)
  int op_slot_right_4877 = gc_frame_newslot(num4878);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_4880 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_left_4880 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff4882 = callmethod(*var_upper, "-", 1, partcv, params);
// compiled op node returning diff4882 (depth = 5)
  int op_slot_left_4877 = gc_frame_newslot(diff4882);
  params[0] = num4878;
  partcv[0] = 1;
  Object sum4883 = callmethod(diff4882, "+", 1, partcv, params);
// compiled op node returning sum4883 (depth = 4)
  int op_slot_left_4874 = gc_frame_newslot(sum4883);
  params[0] = num4875;
  partcv[0] = 1;
  Object opresult4884 = callmethod(sum4883, "<", 1, partcv, params);
// compiled op node returning opresult4884 (depth = 3)
  Object if4873 = done;
struct StackFrameObject *iftmpstackframe4873 = stackframe;
  if (istrue(opresult4884)) {
stackframe = alloc_StackFrame(0, iftmpstackframe4873);
gc_frame_newslot((Object)stackframe);
// starting to compile num node (depth = 3)
  Object num4885 = alloc_Float64(0);
// compiled num node returning num4885 (depth = 3)
    gc_frame_newslot(num4885);
    if4873 = num4885;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe4873);
  gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4887 = alloc_Float64(1);
// compiled num node returning num4887 (depth = 4)
  int op_slot_right_4886 = gc_frame_newslot(num4887);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lower (depth = 5)
  int op_slot_right_4889 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_upper (depth = 5)
  int op_slot_left_4889 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff4891 = callmethod(*var_upper, "-", 1, partcv, params);
// compiled op node returning diff4891 (depth = 4)
  int op_slot_left_4886 = gc_frame_newslot(diff4891);
  params[0] = num4887;
  partcv[0] = 1;
  Object sum4892 = callmethod(diff4891, "+", 1, partcv, params);
// compiled op node returning sum4892 (depth = 3)
    gc_frame_newslot(sum4892);
    if4873 = sum4892;
  }
stackframe = iftmpstackframe4873;
// compiled if node returning if4873 (depth = 2)
  adddatum2(obj4560, if4873, 3);
  sourceObject = obj4560;
// Begin line 1872
  setline(1872);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 2)
  Object block4893 = alloc_Block(NULL, NULL, "collectionsPrelude", 1872);
  gc_frame_newslot(block4893);
// method "_apply"
  block_savedest(block4893);
  Object closure4894 = createclosure(1, "_apply");
  setclosureframe(closure4894, stackframe);
  addtoclosure(closure4894, selfslot);
  struct UserObject *uo4894 = (struct UserObject*)block4893;
  uo4894->data[0] = (Object)closure4894;
  Method *meth_meth_collectionsPrelude__apply4894 = addmethod2pos(block4893, "_apply", &meth_collectionsPrelude__apply4894, 0);
  int argcv_meth_collectionsPrelude__apply4894[] = {0};
  meth_meth_collectionsPrelude__apply4894->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply4894);
  meth_meth_collectionsPrelude__apply4894->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply4894->definitionLine = 1944;
// compiled block node returning block4893 (depth = 2)
  adddatum2(obj4560, block4893, 4);
  sourceObject = obj4560;
  sourceObject = obj4560;
  sourceObject = obj4560;
  sourceObject = obj4560;
  sourceObject = obj4560;
  sourceObject = obj4560;
  sourceObject = obj4560;
  sourceObject = obj4560;
  sourceObject = obj4560;
  sourceObject = obj4560;
  sourceObject = obj4560;
  sourceObject = obj4560;
  sourceObject = obj4560;
  sourceObject = obj4560;
  sourceObject = obj4560;
  objclass4560 = obj4560->class;
  objclass4560->definitionModule = modulename;
  objclass4560->definitionLine = 1865;
  (*(struct UserObject *)self).data[0] = lowerouter4560;
  self = oldself4560;
  selfslot = oldselfslot4560;
  stackframe = oldstackframe4560;
  gc_frame_end(frame);
  return obj4560;
}
Object meth_collectionsPrelude_hasNext4926(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1980
  setline(1980);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4928 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4929 = gc_frame_new();
// call case 3: self.outer request
  Object call4930 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4929);
// compiled call node returning call4930 (depth = 6)
// compiled member node returning call4930 (depth = 5)
  partcv[0] = 0;
  Object call4931 = callmethodflags(call4930, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4928);
// compiled call node returning call4931 (depth = 4)
// compiled member node returning call4931 (depth = 3)
  int op_slot_right_4927 = gc_frame_newslot(call4931);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4933 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4934 = callmethodflags(self, "val", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4933);
// compiled call node returning call4934 (depth = 4)
// compiled member node returning call4934 (depth = 3)
  int op_slot_left_4927 = gc_frame_newslot(call4934);
  params[0] = call4931;
  partcv[0] = 1;
  Object opresult4935 = callmethod(call4934, "≥", 1, partcv, params);
// compiled op node returning opresult4935 (depth = 2)
  gc_frame_end(frame);
  return opresult4935;
}
Object meth_collectionsPrelude_next4936(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1982
  setline(1982);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4939 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4940 = gc_frame_new();
// call case 3: self.outer request
  Object call4941 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4940);
// compiled call node returning call4941 (depth = 7)
// compiled member node returning call4941 (depth = 6)
  partcv[0] = 0;
  Object call4942 = callmethodflags(call4941, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4939);
// compiled call node returning call4942 (depth = 5)
// compiled member node returning call4942 (depth = 4)
  int op_slot_right_4938 = gc_frame_newslot(call4942);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4944 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4945 = callmethodflags(self, "val", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4944);
// compiled call node returning call4945 (depth = 5)
// compiled member node returning call4945 (depth = 4)
  int op_slot_left_4938 = gc_frame_newslot(call4945);
  params[0] = call4942;
  partcv[0] = 1;
  Object opresult4946 = callmethod(call4945, "<", 1, partcv, params);
// compiled op node returning opresult4946 (depth = 3)
  Object if4937 = done;
  if (istrue(opresult4946)) {
// starting to compile call node (depth = 3)
  int callframe4947 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit4949 == NULL) {
    strlit4949 = alloc_String("");
    gc_root(strlit4949);
  }
// compiled string node returning strlit4949 (depth = 5)
  int op_slot_right_4948 = gc_frame_newslot(strlit4949);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe4952 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe4953 = gc_frame_new();
// call case 3: self.outer request
  Object call4954 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4953);
// compiled call node returning call4954 (depth = 9)
// compiled member node returning call4954 (depth = 8)
  partcv[0] = 0;
  Object call4955 = callmethodflags(call4954, "asString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4952);
// compiled call node returning call4955 (depth = 7)
// compiled member node returning call4955 (depth = 6)
  int op_slot_right_4951 = gc_frame_newslot(call4955);
// starting to compile string node (depth = 6)
  if (strlit4957 == NULL) {
    strlit4957 = alloc_String("over ");
    gc_root(strlit4957);
  }
// compiled string node returning strlit4957 (depth = 6)
  int op_slot_left_4951 = gc_frame_newslot(strlit4957);
  params[0] = call4955;
  partcv[0] = 1;
  Object opresult4958 = callmethod(strlit4957, "++", 1, partcv, params);
// compiled op node returning opresult4958 (depth = 5)
  int op_slot_left_4948 = gc_frame_newslot(opresult4958);
  params[0] = strlit4949;
  partcv[0] = 1;
  Object opresult4959 = callmethod(opresult4958, "++", 1, partcv, params);
// compiled op node returning opresult4959 (depth = 4)
  gc_frame_newslot(opresult4959);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_IteratorExhausted (depth = 4)
  params[0] = opresult4959;
  partcv[0] = 1;
  Object call4960 = callmethod(*var_IteratorExhausted, "raise",
    1, partcv, params);
  gc_frame_end(callframe4947);
// compiled call node returning call4960 (depth = 3)
    gc_frame_newslot(call4960);
    if4937 = call4960;
  } else {
  }
// compiled if node returning if4937 (depth = 2)
// Begin line 1983
  setline(1983);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe4961 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4963 = alloc_Float64(1);
// compiled num node returning num4963 (depth = 4)
  int op_slot_right_4962 = gc_frame_newslot(num4963);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4965 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4966 = callmethodflags(self, "val", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4965);
// compiled call node returning call4966 (depth = 5)
// compiled member node returning call4966 (depth = 4)
  int op_slot_left_4962 = gc_frame_newslot(call4966);
  params[0] = num4963;
  partcv[0] = 1;
  Object diff4967 = callmethod(call4966, "-", 1, partcv, params);
// compiled op node returning diff4967 (depth = 3)
  gc_frame_newslot(diff4967);
// call case 4: self request
  params[0] = diff4967;
  partcv[0] = 1;
  Object call4968 = callmethodflags(self, "val:=", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4961);
// compiled call node returning call4968 (depth = 2)
// Begin line 1984
  setline(1984);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num4970 = alloc_Float64(1);
// compiled num node returning num4970 (depth = 4)
  int op_slot_right_4969 = gc_frame_newslot(num4970);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4972 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4973 = callmethodflags(self, "val", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4972);
// compiled call node returning call4973 (depth = 5)
// compiled member node returning call4973 (depth = 4)
  int op_slot_left_4969 = gc_frame_newslot(call4973);
  params[0] = num4970;
  partcv[0] = 1;
  Object sum4974 = callmethod(call4973, "+", 1, partcv, params);
// compiled op node returning sum4974 (depth = 3)
  return sum4974;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_asString4975(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1986
  setline(1986);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit4977 == NULL) {
    strlit4977 = alloc_String("");
    gc_root(strlit4977);
  }
// compiled string node returning strlit4977 (depth = 3)
  int op_slot_right_4976 = gc_frame_newslot(strlit4977);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4980 = gc_frame_new();
// call case 1: super request
  partcv[0] = 0;
  Object call4981 = callmethod4(self, "asString", 1, partcv, params, ((flags >> 24) & 0xff) + 1, CFLAG_SELF);
  gc_frame_end(callframe4980);
// compiled call node returning call4981 (depth = 5)
// compiled member node returning call4981 (depth = 4)
  int op_slot_right_4979 = gc_frame_newslot(call4981);
// starting to compile string node (depth = 4)
  if (strlit4983 == NULL) {
    strlit4983 = alloc_String("anIterator over ");
    gc_root(strlit4983);
  }
// compiled string node returning strlit4983 (depth = 4)
  int op_slot_left_4979 = gc_frame_newslot(strlit4983);
  params[0] = call4981;
  partcv[0] = 1;
  Object opresult4984 = callmethod(strlit4983, "++", 1, partcv, params);
// compiled op node returning opresult4984 (depth = 3)
  int op_slot_left_4976 = gc_frame_newslot(opresult4984);
  params[0] = strlit4977;
  partcv[0] = 1;
  Object opresult4985 = callmethod(opresult4984, "++", 1, partcv, params);
// compiled op node returning opresult4985 (depth = 2)
  gc_frame_end(frame);
  return opresult4985;
}
Object meth_collectionsPrelude_iterator4922(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4923 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4923 = alloc_userobj2(5,5, objclass4923);
  gc_frame_newslot(obj4923);
if (objclass4923 == NULL) {
  glfree(obj4923->class->name);
  obj4923->class->name = "collectionsPrelude.range.object.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4923, self, 0);
  addmethodreal(obj4923,"outer", &reader_collectionsPrelude_outer_4924);
  Object oldself4923 = self;
  struct StackFrameObject *oldstackframe4923 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4923);
  gc_frame_newslot((Object)stackframe);
  self = obj4923;
  Object *oldselfslot4923 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4923 = (*(struct UserObject *)self).data[0], lowerouter4923 = thisouter4923;
  if (inheritingObject4923) {
    struct UserObject *inho4923 = (struct UserObject *)inheritingObject4923;
    while (inho4923->super != GraceDefaultObject) inho4923 = (struct UserObject *)inho4923->super;
    inho4923->super = obj4923;
    self = inheritingObject4923;
    *selfslot = self;
    lowerouter4923 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4923;
  }
if (objclass4923 == NULL) {
  Method *reader4925 = addmethodrealflags(obj4923, "val",&reader_collectionsPrelude_val_4925, MFLAG_CONFIDENTIAL);
  Method *writer4925 = addmethodrealflags(obj4923, "val:=",&writer_collectionsPrelude_val_4925, MFLAG_CONFIDENTIAL);
  reader4925->definitionModule = modulename;
  writer4925->definitionModule = modulename;
  reader4925->definitionLine = 1979;
  writer4925->definitionLine = 1979;
}
obj4923->flags |= OFLAG_MUTABLE;
adddatum2(obj4923, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo4926 = (struct UserObject*)obj4923;
  uo4926->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext4926 = addmethod2pos(obj4923, "hasNext", &meth_collectionsPrelude_hasNext4926, 2);
  int argcv_meth_collectionsPrelude_hasNext4926[] = {0};
  meth_meth_collectionsPrelude_hasNext4926->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext4926);
  meth_meth_collectionsPrelude_hasNext4926->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext4926->definitionLine = 1980;
// method "next"
  block_savedest(obj4923);
  Object closure4936 = createclosure(1, "next");
  setclosureframe(closure4936, stackframe);
  addtoclosure(closure4936, var_IteratorExhausted);
  struct UserObject *uo4936 = (struct UserObject*)obj4923;
  uo4936->data[3] = (Object)closure4936;
  Method *meth_meth_collectionsPrelude_next4936 = addmethod2pos(obj4923, "next", &meth_collectionsPrelude_next4936, 3);
  int argcv_meth_collectionsPrelude_next4936[] = {0};
  meth_meth_collectionsPrelude_next4936->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next4936);
  meth_meth_collectionsPrelude_next4936->definitionModule = modulename;
  meth_meth_collectionsPrelude_next4936->definitionLine = 1981;
// method "asString"
  struct UserObject *uo4975 = (struct UserObject*)obj4923;
  uo4975->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString4975 = addmethod2pos(obj4923, "asString", &meth_collectionsPrelude_asString4975, 4);
  int argcv_meth_collectionsPrelude_asString4975[] = {0};
  meth_meth_collectionsPrelude_asString4975->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4975);
  meth_meth_collectionsPrelude_asString4975->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4975->definitionLine = 1986;
  sourceObject = obj4923;
// Begin line 1979
  setline(1979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4986 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4987 = gc_frame_new();
// call case 3: self.outer request
  Object call4988 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4987);
// compiled call node returning call4988 (depth = 5)
// compiled member node returning call4988 (depth = 4)
  partcv[0] = 0;
  Object call4989 = callmethodflags(call4988, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4986);
// compiled call node returning call4989 (depth = 3)
// compiled member node returning call4989 (depth = 2)
  adddatum2(obj4923, call4989, 1);
  sourceObject = obj4923;
  sourceObject = obj4923;
  sourceObject = obj4923;
  objclass4923 = obj4923->class;
  objclass4923->definitionModule = modulename;
  objclass4923->definitionLine = 1978;
  (*(struct UserObject *)self).data[0] = lowerouter4923;
  self = oldself4923;
  selfslot = oldselfslot4923;
  stackframe = oldstackframe4923;
  gc_frame_end(frame);
  return obj4923;
}
Object meth_collectionsPrelude_iterator4922_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4923 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4923 = alloc_userobj2(5,5, objclass4923);
  gc_frame_newslot(obj4923);
if (objclass4923 == NULL) {
  glfree(obj4923->class->name);
  obj4923->class->name = "collectionsPrelude.range.object.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4923, self, 0);
  addmethodreal(obj4923,"outer", &reader_collectionsPrelude_outer_4924);
  Object oldself4923 = self;
  struct StackFrameObject *oldstackframe4923 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4923);
  gc_frame_newslot((Object)stackframe);
  self = obj4923;
  Object *oldselfslot4923 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4923 = (*(struct UserObject *)self).data[0], lowerouter4923 = thisouter4923;
  if (inheritingObject4923) {
    struct UserObject *inho4923 = (struct UserObject *)inheritingObject4923;
    while (inho4923->super != GraceDefaultObject) inho4923 = (struct UserObject *)inho4923->super;
    inho4923->super = obj4923;
    self = inheritingObject4923;
    *selfslot = self;
    lowerouter4923 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4923;
  }
if (objclass4923 == NULL) {
  Method *reader4925 = addmethodrealflags(obj4923, "val",&reader_collectionsPrelude_val_4925, MFLAG_CONFIDENTIAL);
  Method *writer4925 = addmethodrealflags(obj4923, "val:=",&writer_collectionsPrelude_val_4925, MFLAG_CONFIDENTIAL);
  reader4925->definitionModule = modulename;
  writer4925->definitionModule = modulename;
  reader4925->definitionLine = 1979;
  writer4925->definitionLine = 1979;
}
obj4923->flags |= OFLAG_MUTABLE;
adddatum2(obj4923, alloc_Undefined(), 1);
// method "hasNext"
  struct UserObject *uo4926 = (struct UserObject*)obj4923;
  uo4926->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext4926 = addmethod2pos(obj4923, "hasNext", &meth_collectionsPrelude_hasNext4926, 2);
  int argcv_meth_collectionsPrelude_hasNext4926[] = {0};
  meth_meth_collectionsPrelude_hasNext4926->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext4926);
  meth_meth_collectionsPrelude_hasNext4926->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext4926->definitionLine = 1980;
// method "next"
  block_savedest(obj4923);
  Object closure4936 = createclosure(1, "next");
  setclosureframe(closure4936, stackframe);
  addtoclosure(closure4936, var_IteratorExhausted);
  struct UserObject *uo4936 = (struct UserObject*)obj4923;
  uo4936->data[3] = (Object)closure4936;
  Method *meth_meth_collectionsPrelude_next4936 = addmethod2pos(obj4923, "next", &meth_collectionsPrelude_next4936, 3);
  int argcv_meth_collectionsPrelude_next4936[] = {0};
  meth_meth_collectionsPrelude_next4936->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next4936);
  meth_meth_collectionsPrelude_next4936->definitionModule = modulename;
  meth_meth_collectionsPrelude_next4936->definitionLine = 1981;
// method "asString"
  struct UserObject *uo4975 = (struct UserObject*)obj4923;
  uo4975->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString4975 = addmethod2pos(obj4923, "asString", &meth_collectionsPrelude_asString4975, 4);
  int argcv_meth_collectionsPrelude_asString4975[] = {0};
  meth_meth_collectionsPrelude_asString4975->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString4975);
  meth_meth_collectionsPrelude_asString4975->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString4975->definitionLine = 1986;
  sourceObject = obj4923;
// Begin line 1979
  setline(1979);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4986 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe4987 = gc_frame_new();
// call case 3: self.outer request
  Object call4988 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe4987);
// compiled call node returning call4988 (depth = 5)
// compiled member node returning call4988 (depth = 4)
  partcv[0] = 0;
  Object call4989 = callmethodflags(call4988, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4986);
// compiled call node returning call4989 (depth = 3)
// compiled member node returning call4989 (depth = 2)
  adddatum2(obj4923, call4989, 1);
  sourceObject = obj4923;
  sourceObject = obj4923;
  sourceObject = obj4923;
  objclass4923 = obj4923->class;
  objclass4923->definitionModule = modulename;
  objclass4923->definitionLine = 1978;
  (*(struct UserObject *)self).data[0] = lowerouter4923;
  self = oldself4923;
  selfslot = oldselfslot4923;
  stackframe = oldstackframe4923;
  gc_frame_end(frame);
  return obj4923;
}
Object meth_collectionsPrelude_at4991(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "at");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at");
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for at");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1990
  setline(1990);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe4993 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe4995 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call4996 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe4995);
// compiled call node returning call4996 (depth = 6)
// compiled member node returning call4996 (depth = 5)
  int op_slot_right_4994 = gc_frame_newslot(call4996);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_4994 = gc_frame_newslot(*var_ix);
  params[0] = call4996;
  partcv[0] = 1;
  Object opresult4998 = callmethod(*var_ix, "≤", 1, partcv, params);
// compiled op node returning opresult4998 (depth = 4)
  partcv[0] = 0;
  Object call4999 = callmethod(opresult4998, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe4993);
// compiled call node returning call4999 (depth = 3)
  Object if4992 = done;
  if (istrue(call4999)) {
// Begin line 1991
  setline(1991);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5000 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5002 == NULL) {
    strlit5002 = alloc_String("");
    gc_root(strlit5002);
  }
// compiled string node returning strlit5002 (depth = 5)
  int op_slot_right_5001 = gc_frame_newslot(strlit5002);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5005 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5006 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5005);
// compiled call node returning call5006 (depth = 7)
// compiled member node returning call5006 (depth = 6)
  int op_slot_right_5004 = gc_frame_newslot(call5006);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5009 == NULL) {
    strlit5009 = alloc_String(") but upper bound is ");
    gc_root(strlit5009);
  }
// compiled string node returning strlit5009 (depth = 7)
  int op_slot_right_5008 = gc_frame_newslot(strlit5009);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_ix (depth = 8)
  int op_slot_right_5011 = gc_frame_newslot(*var_ix);
// starting to compile string node (depth = 8)
  if (strlit5013 == NULL) {
    strlit5013 = alloc_String("requested range.at(");
    gc_root(strlit5013);
  }
// compiled string node returning strlit5013 (depth = 8)
  int op_slot_left_5011 = gc_frame_newslot(strlit5013);
  params[0] = *var_ix;
  partcv[0] = 1;
  Object opresult5014 = callmethod(strlit5013, "++", 1, partcv, params);
// compiled op node returning opresult5014 (depth = 7)
  int op_slot_left_5008 = gc_frame_newslot(opresult5014);
  params[0] = strlit5009;
  partcv[0] = 1;
  Object opresult5015 = callmethod(opresult5014, "++", 1, partcv, params);
// compiled op node returning opresult5015 (depth = 6)
  int op_slot_left_5004 = gc_frame_newslot(opresult5015);
  params[0] = call5006;
  partcv[0] = 1;
  Object opresult5016 = callmethod(opresult5015, "++", 1, partcv, params);
// compiled op node returning opresult5016 (depth = 5)
  int op_slot_left_5001 = gc_frame_newslot(opresult5016);
  params[0] = strlit5002;
  partcv[0] = 1;
  Object opresult5017 = callmethod(opresult5016, "++", 1, partcv, params);
// compiled op node returning opresult5017 (depth = 4)
  gc_frame_newslot(opresult5017);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult5017;
  partcv[0] = 1;
  Object call5018 = callmethod(*var_BoundsError, "raise",
    1, partcv, params);
  gc_frame_end(callframe5000);
// compiled call node returning call5018 (depth = 3)
    gc_frame_newslot(call5018);
    if4992 = call5018;
  } else {
  }
// compiled if node returning if4992 (depth = 2)
// Begin line 1993
  setline(1993);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5020 = gc_frame_new();
// call case 6: other member request
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5022 = alloc_Float64(1);
// compiled num node returning num5022 (depth = 5)
  int op_slot_right_5021 = gc_frame_newslot(num5022);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_5021 = gc_frame_newslot(*var_ix);
  params[0] = num5022;
  partcv[0] = 1;
  Object opresult5024 = callmethod(*var_ix, "≥", 1, partcv, params);
// compiled op node returning opresult5024 (depth = 4)
  partcv[0] = 0;
  Object call5025 = callmethod(opresult5024, "prefix!",
    1, partcv, params);
  gc_frame_end(callframe5020);
// compiled call node returning call5025 (depth = 3)
  Object if5019 = done;
  if (istrue(call5025)) {
// Begin line 1994
  setline(1994);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5026 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5028 == NULL) {
    strlit5028 = alloc_String(") but lower bound is 1");
    gc_root(strlit5028);
  }
// compiled string node returning strlit5028 (depth = 5)
  int op_slot_right_5027 = gc_frame_newslot(strlit5028);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  int op_slot_right_5030 = gc_frame_newslot(*var_ix);
// starting to compile string node (depth = 6)
  if (strlit5032 == NULL) {
    strlit5032 = alloc_String("requested range.at(");
    gc_root(strlit5032);
  }
// compiled string node returning strlit5032 (depth = 6)
  int op_slot_left_5030 = gc_frame_newslot(strlit5032);
  params[0] = *var_ix;
  partcv[0] = 1;
  Object opresult5033 = callmethod(strlit5032, "++", 1, partcv, params);
// compiled op node returning opresult5033 (depth = 5)
  int op_slot_left_5027 = gc_frame_newslot(opresult5033);
  params[0] = strlit5028;
  partcv[0] = 1;
  Object opresult5034 = callmethod(opresult5033, "++", 1, partcv, params);
// compiled op node returning opresult5034 (depth = 4)
  gc_frame_newslot(opresult5034);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult5034;
  partcv[0] = 1;
  Object call5035 = callmethod(*var_BoundsError, "raise",
    1, partcv, params);
  gc_frame_end(callframe5026);
// compiled call node returning call5035 (depth = 3)
    gc_frame_newslot(call5035);
    if5019 = call5035;
  } else {
  }
// compiled if node returning if5019 (depth = 2)
// Begin line 1996
  setline(1996);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5038 = alloc_Float64(1);
// compiled num node returning num5038 (depth = 5)
  int op_slot_right_5037 = gc_frame_newslot(num5038);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_ix (depth = 5)
  int op_slot_left_5037 = gc_frame_newslot(*var_ix);
  params[0] = num5038;
  partcv[0] = 1;
  Object diff5040 = callmethod(*var_ix, "-", 1, partcv, params);
// compiled op node returning diff5040 (depth = 4)
  int op_slot_right_5036 = gc_frame_newslot(diff5040);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5042 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5043 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5042);
// compiled call node returning call5043 (depth = 5)
// compiled member node returning call5043 (depth = 4)
  int op_slot_left_5036 = gc_frame_newslot(call5043);
  params[0] = diff5040;
  partcv[0] = 1;
  Object diff5044 = callmethod(call5043, "-", 1, partcv, params);
// compiled op node returning diff5044 (depth = 3)
  return diff5044;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply5048(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_elem = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_intElem = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "intElem");
// Begin line 2000
  setline(2000);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5049 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_elem (depth = 7)
  partcv[0] = 0;
  Object call5050 = callmethod(*var_elem, "truncated",
    1, partcv, params);
  gc_frame_end(callframe5049);
// compiled call node returning call5050 (depth = 6)
// compiled member node returning call5050 (depth = 5)
  *var_intElem = call5050;
  if (call5050 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 2001
  setline(2001);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_elem (depth = 6)
  int op_slot_right_5052 = gc_frame_newslot(*var_elem);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_5052 = gc_frame_newslot(*var_intElem);
  params[0] = *var_elem;
  partcv[0] = 1;
  Object opresult5054 = callmethod(*var_intElem, "≠", 1, partcv, params);
// compiled op node returning opresult5054 (depth = 5)
  Object if5051 = done;
  if (istrue(opresult5054)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5055 = alloc_Boolean(0);
// compiled identifier node returning bool5055 (depth = 6)
  block_return(realself, bool5055);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if5051 = undefined;
  } else {
  }
// compiled if node returning if5051 (depth = 4)
// Begin line 2002
  setline(2002);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5058 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5059 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5058);
// compiled call node returning call5059 (depth = 7)
// compiled member node returning call5059 (depth = 6)
  int op_slot_right_5057 = gc_frame_newslot(call5059);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_5057 = gc_frame_newslot(*var_intElem);
  params[0] = call5059;
  partcv[0] = 1;
  Object opresult5061 = callmethod(*var_intElem, ">", 1, partcv, params);
// compiled op node returning opresult5061 (depth = 5)
  Object if5056 = done;
  if (istrue(opresult5061)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5062 = alloc_Boolean(0);
// compiled identifier node returning bool5062 (depth = 6)
  block_return(realself, bool5062);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if5056 = undefined;
  } else {
  }
// compiled if node returning if5056 (depth = 4)
// Begin line 2003
  setline(2003);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5065 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5066 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5065);
// compiled call node returning call5066 (depth = 7)
// compiled member node returning call5066 (depth = 6)
  int op_slot_right_5064 = gc_frame_newslot(call5066);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_intElem (depth = 6)
  int op_slot_left_5064 = gc_frame_newslot(*var_intElem);
  params[0] = call5066;
  partcv[0] = 1;
  Object opresult5068 = callmethod(*var_intElem, "<", 1, partcv, params);
// compiled op node returning opresult5068 (depth = 5)
  Object if5063 = done;
  if (istrue(opresult5068)) {
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool5069 = alloc_Boolean(0);
// compiled identifier node returning bool5069 (depth = 6)
  block_return(realself, bool5069);
// compiled return node returning undefined (depth = 5)
    gc_frame_newslot(undefined);
    if5063 = undefined;
  } else {
  }
// compiled if node returning if5063 (depth = 4)
  gc_frame_end(frame);
  return if5063;
}
Object meth_collectionsPrelude__apply5072(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ex = &(stackframe->slots[0]);
  *var_ex = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile return node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool5073 = alloc_Boolean(0);
// compiled identifier node returning bool5073 (depth = 5)
  block_return(realself, bool5073);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_contains5045(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "contains");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains");
  Object params[2];
  int partcv[1];
  Object *var__prelude = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_elem = &(stackframe->slots[0]);
  *var_elem = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for contains");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1999
  setline(1999);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile trycatch node (depth = 2)
// starting to compile block node (depth = 3)
  Object block5047 = alloc_Block(NULL, NULL, "collectionsPrelude", 1999);
  gc_frame_newslot(block5047);
// method "_apply"
  block_savedest(block5047);
  Object closure5048 = createclosure(2, "_apply");
  setclosureframe(closure5048, stackframe);
  addtoclosure(closure5048, var_elem);
  addtoclosure(closure5048, selfslot);
  struct UserObject *uo5048 = (struct UserObject*)block5047;
  uo5048->data[0] = (Object)closure5048;
  Method *meth_meth_collectionsPrelude__apply5048 = addmethod2pos(block5047, "_apply", &meth_collectionsPrelude__apply5048, 0);
  int argcv_meth_collectionsPrelude__apply5048[] = {0};
  meth_meth_collectionsPrelude__apply5048->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5048);
  meth_meth_collectionsPrelude__apply5048->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5048->definitionLine = 1996;
// compiled block node returning block5047 (depth = 3)
  int frame5046 = gc_frame_new();
  gc_frame_newslot(block5047);
// Begin line 2004
  setline(2004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5071 = alloc_Block(NULL, NULL, "collectionsPrelude", 2004);
  gc_frame_newslot(block5071);
// method "_apply"
  block_savedest(block5071);
  Object closure5072 = createclosure(1, "_apply");
  setclosureframe(closure5072, stackframe);
  addtoclosure(closure5072, selfslot);
  struct UserObject *uo5072 = (struct UserObject*)block5071;
  uo5072->data[0] = (Object)closure5072;
  Method *meth_meth_collectionsPrelude__apply5072 = addmethod2pos(block5071, "_apply", &meth_collectionsPrelude__apply5072, 0);
  int argcv_meth_collectionsPrelude__apply5072[] = {1};
  meth_meth_collectionsPrelude__apply5072->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5072);
  meth_meth_collectionsPrelude__apply5072->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5072->definitionLine = 2003;
// starting to compile call node (depth = 4)
  int callframe5075 = gc_frame_new();
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5076 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5077 == NULL) {
    strlit5077 = alloc_String("ex");
    gc_root(strlit5077);
  }
// compiled string node returning strlit5077 (depth = 6)
  gc_frame_newslot(strlit5077);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5078 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5079 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5078);
// compiled call node returning call5079 (depth = 7)
// compiled member node returning call5079 (depth = 6)
  params[0] = strlit5077;
  partcv[0] = 1;
  Object call5080 = callmethod(call5079, "new",
    1, partcv, params);
  gc_frame_end(callframe5076);
// compiled call node returning call5080 (depth = 5)
  gc_frame_newslot(call5080);
// Begin line 2004
  setline(2004);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5081 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var__prelude (depth = 7)
  partcv[0] = 0;
  Object call5082 = callmethod(*var__prelude, "Exception",
    1, partcv, params);
  gc_frame_end(callframe5081);
// compiled call node returning call5082 (depth = 6)
// compiled member node returning call5082 (depth = 5)
  gc_frame_newslot(call5082);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5083 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5084 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5083);
// compiled call node returning call5084 (depth = 6)
// compiled member node returning call5084 (depth = 5)
  params[0] = call5080;
  params[1] = call5082;
  partcv[0] = 2;
  Object call5085 = callmethod(call5084, "new",
    1, partcv, params);
  gc_frame_end(callframe5075);
// compiled call node returning call5085 (depth = 4)
((struct UserObject *)block5071)->data[1] = call5085;
// compiled block node returning block5071 (depth = 3)
  gc_frame_newslot(block5071);
  params[0] = block5071;
  setline(1999);
  Object catchres5046 = tryCatch(block5047, params, 1,NULL);
  gc_frame_end(frame5046);
// compiled trycatch node returning catchres5046 (depth = 2)
// Begin line 2005
  setline(2005);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile identifier node (depth = 3)
  Object bool5086 = alloc_Boolean(1);
// compiled identifier node returning bool5086 (depth = 3)
  return bool5086;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply5092(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5094 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5095 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5094);
// compiled call node returning call5095 (depth = 6)
// compiled member node returning call5095 (depth = 5)
  int op_slot_right_5093 = gc_frame_newslot(call5095);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  int op_slot_left_5093 = gc_frame_newslot(*var_val);
  params[0] = call5095;
  partcv[0] = 1;
  Object opresult5097 = callmethod(*var_val, "≥", 1, partcv, params);
// compiled op node returning opresult5097 (depth = 4)
  gc_frame_end(frame);
  return opresult5097;
}
Object meth_collectionsPrelude__apply5100(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2010
  setline(2010);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5101 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block1 (depth = 5)
  params[0] = *var_val;
  partcv[0] = 1;
  Object call5102 = callmethod(*var_block1, "apply",
    1, partcv, params);
  gc_frame_end(callframe5101);
// compiled call node returning call5102 (depth = 4)
// Begin line 2011
  setline(2011);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num5104 = alloc_Float64(1);
// compiled num node returning num5104 (depth = 6)
  int op_slot_right_5103 = gc_frame_newslot(num5104);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_val (depth = 6)
  int op_slot_left_5103 = gc_frame_newslot(*var_val);
  params[0] = num5104;
  partcv[0] = 1;
  Object diff5106 = callmethod(*var_val, "-", 1, partcv, params);
// compiled op node returning diff5106 (depth = 5)
  *var_val = diff5106;
  if (diff5106 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_do5087(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for do");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_val = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "val");
// Begin line 2008
  setline(2008);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5088 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5089 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5088);
// compiled call node returning call5089 (depth = 4)
// compiled member node returning call5089 (depth = 3)
  *var_val = call5089;
  if (call5089 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2009
  setline(2009);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5090 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block5091 = alloc_Block(NULL, NULL, "collectionsPrelude", 2009);
  gc_frame_newslot(block5091);
// method "_apply"
  block_savedest(block5091);
  Object closure5092 = createclosure(2, "_apply");
  setclosureframe(closure5092, stackframe);
  addtoclosure(closure5092, var_val);
  addtoclosure(closure5092, selfslot);
  struct UserObject *uo5092 = (struct UserObject*)block5091;
  uo5092->data[0] = (Object)closure5092;
  Method *meth_meth_collectionsPrelude__apply5092 = addmethod2pos(block5091, "_apply", &meth_collectionsPrelude__apply5092, 0);
  int argcv_meth_collectionsPrelude__apply5092[] = {0};
  meth_meth_collectionsPrelude__apply5092->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5092);
  meth_meth_collectionsPrelude__apply5092->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5092->definitionLine = 2008;
// compiled block node returning block5091 (depth = 3)
  gc_frame_newslot(block5091);
// starting to compile block node (depth = 3)
  Object block5099 = alloc_Block(NULL, NULL, "collectionsPrelude", 2009);
  gc_frame_newslot(block5099);
// method "_apply"
  block_savedest(block5099);
  Object closure5100 = createclosure(3, "_apply");
  setclosureframe(closure5100, stackframe);
  addtoclosure(closure5100, var_val);
  addtoclosure(closure5100, var_block1);
  addtoclosure(closure5100, selfslot);
  struct UserObject *uo5100 = (struct UserObject*)block5099;
  uo5100->data[0] = (Object)closure5100;
  Method *meth_meth_collectionsPrelude__apply5100 = addmethod2pos(block5099, "_apply", &meth_collectionsPrelude__apply5100, 0);
  int argcv_meth_collectionsPrelude__apply5100[] = {0};
  meth_meth_collectionsPrelude__apply5100->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5100);
  meth_meth_collectionsPrelude__apply5100->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5100->definitionLine = 2009;
// compiled block node returning block5099 (depth = 3)
  gc_frame_newslot(block5099);
// call case 5: prelude request
  params[0] = block5091;
  params[1] = block5099;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5109 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5090);
// compiled call node returning call5109 (depth = 2)
  gc_frame_end(frame);
  return call5109;
}
Object meth_collectionsPrelude__apply5116(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_val = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5118 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5119 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5118);
// compiled call node returning call5119 (depth = 6)
// compiled member node returning call5119 (depth = 5)
  int op_slot_right_5117 = gc_frame_newslot(call5119);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  int op_slot_left_5117 = gc_frame_newslot(*var_val);
  params[0] = call5119;
  partcv[0] = 1;
  Object opresult5121 = callmethod(*var_val, "≥", 1, partcv, params);
// compiled op node returning opresult5121 (depth = 4)
  gc_frame_end(frame);
  return opresult5121;
}
Object meth_collectionsPrelude__apply5124(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_key = getfromclosure(closure, 0);
  Object *var_val = getfromclosure(closure, 1);
  Object *var_block2 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2018
  setline(2018);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5125 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_key (depth = 5)
  gc_frame_newslot(*var_key);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_val (depth = 5)
  gc_frame_newslot(*var_val);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_block2 (depth = 5)
  params[0] = *var_key;
  params[1] = *var_val;
  partcv[0] = 2;
  Object call5126 = callmethod(*var_block2, "apply",
    1, partcv, params);
  gc_frame_end(callframe5125);
// compiled call node returning call5126 (depth = 4)
// Begin line 2019
  setline(2019);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num5128 = alloc_Float64(1);
// compiled num node returning num5128 (depth = 6)
  int op_slot_right_5127 = gc_frame_newslot(num5128);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_key (depth = 6)
  int op_slot_left_5127 = gc_frame_newslot(*var_key);
  params[0] = num5128;
  partcv[0] = 1;
  Object sum5130 = callmethod(*var_key, "+", 1, partcv, params);
// compiled op node returning sum5130 (depth = 5)
  *var_key = sum5130;
  if (sum5130 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 2020
  setline(2020);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num5133 = alloc_Float64(1);
// compiled num node returning num5133 (depth = 6)
  int op_slot_right_5132 = gc_frame_newslot(num5133);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_val (depth = 6)
  int op_slot_left_5132 = gc_frame_newslot(*var_val);
  params[0] = num5133;
  partcv[0] = 1;
  Object diff5135 = callmethod(*var_val, "-", 1, partcv, params);
// compiled op node returning diff5135 (depth = 5)
  *var_val = diff5135;
  if (diff5135 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_keysAndValuesDo5110(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysAndValuesDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for keysAndValuesDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_key = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "key");
  Object *var_val = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "val");
// Begin line 2015
  setline(2015);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile num node (depth = 3)
  Object num5111 = alloc_Float64(1);
// compiled num node returning num5111 (depth = 3)
  *var_key = num5111;
  if (num5111 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2016
  setline(2016);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5112 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5113 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5112);
// compiled call node returning call5113 (depth = 4)
// compiled member node returning call5113 (depth = 3)
  *var_val = call5113;
  if (call5113 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 2017
  setline(2017);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5114 = gc_frame_new();
// starting to compile block node (depth = 3)
  Object block5115 = alloc_Block(NULL, NULL, "collectionsPrelude", 2017);
  gc_frame_newslot(block5115);
// method "_apply"
  block_savedest(block5115);
  Object closure5116 = createclosure(2, "_apply");
  setclosureframe(closure5116, stackframe);
  addtoclosure(closure5116, var_val);
  addtoclosure(closure5116, selfslot);
  struct UserObject *uo5116 = (struct UserObject*)block5115;
  uo5116->data[0] = (Object)closure5116;
  Method *meth_meth_collectionsPrelude__apply5116 = addmethod2pos(block5115, "_apply", &meth_collectionsPrelude__apply5116, 0);
  int argcv_meth_collectionsPrelude__apply5116[] = {0};
  meth_meth_collectionsPrelude__apply5116->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5116);
  meth_meth_collectionsPrelude__apply5116->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5116->definitionLine = 2016;
// compiled block node returning block5115 (depth = 3)
  gc_frame_newslot(block5115);
// starting to compile block node (depth = 3)
  Object block5123 = alloc_Block(NULL, NULL, "collectionsPrelude", 2017);
  gc_frame_newslot(block5123);
// method "_apply"
  block_savedest(block5123);
  Object closure5124 = createclosure(4, "_apply");
  setclosureframe(closure5124, stackframe);
  addtoclosure(closure5124, var_key);
  addtoclosure(closure5124, var_val);
  addtoclosure(closure5124, var_block2);
  addtoclosure(closure5124, selfslot);
  struct UserObject *uo5124 = (struct UserObject*)block5123;
  uo5124->data[0] = (Object)closure5124;
  Method *meth_meth_collectionsPrelude__apply5124 = addmethod2pos(block5123, "_apply", &meth_collectionsPrelude__apply5124, 0);
  int argcv_meth_collectionsPrelude__apply5124[] = {0};
  meth_meth_collectionsPrelude__apply5124->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5124);
  meth_meth_collectionsPrelude__apply5124->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5124->definitionLine = 2017;
// compiled block node returning block5123 (depth = 3)
  gc_frame_newslot(block5123);
// call case 5: prelude request
  params[0] = block5115;
  params[1] = block5123;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5138 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5114);
// compiled call node returning call5138 (depth = 2)
  gc_frame_end(frame);
  return call5138;
}
Object meth_collectionsPrelude_reversed5139(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 9, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_lower = getfromclosure(closure, 0);
  Object *var_upper = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for reversed (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for reversed");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2024
  setline(2024);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5140 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  gc_frame_newslot(*var_upper);
// call case 2: outer request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5141 = gc_frame_new();
// call case 3: self.outer request
  Object call5142 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5141);
// compiled call node returning call5142 (depth = 4)
// compiled member node returning call5142 (depth = 3)
  params[0] = *var_lower;
  params[1] = *var_upper;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5143 = callmethodflags(call5142, "from()to", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5140);
// compiled call node returning call5143 (depth = 2)
  gc_frame_end(frame);
  return call5143;
}
Object meth_collectionsPrelude__43__43_5144(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++ (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ++");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2027
  setline(2027);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5145 = gc_frame_new();
// starting to compile call node (depth = 3)
  int callframe5146 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5147 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5148 = gc_frame_new();
// call case 3: self.outer request
  Object call5149 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5148);
// compiled call node returning call5149 (depth = 7)
// compiled member node returning call5149 (depth = 6)
  partcv[0] = 0;
  Object call5150 = callmethodflags(call5149, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5147);
// compiled call node returning call5150 (depth = 5)
// compiled member node returning call5150 (depth = 4)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 2;
  Object call5151 = callmethodflags(call5150, "lazyConcatenation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5146);
// compiled call node returning call5151 (depth = 3)
  gc_frame_newslot(call5151);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5152 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5153 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5154 = gc_frame_new();
// call case 3: self.outer request
  Object call5155 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5154);
// compiled call node returning call5155 (depth = 8)
// compiled member node returning call5155 (depth = 7)
  partcv[0] = 0;
  Object call5156 = callmethodflags(call5155, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5153);
// compiled call node returning call5156 (depth = 6)
// compiled member node returning call5156 (depth = 5)
  partcv[0] = 0;
  Object call5157 = callmethodflags(call5156, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5152);
// compiled call node returning call5157 (depth = 4)
// compiled member node returning call5157 (depth = 3)
  params[0] = call5151;
  partcv[0] = 1;
  Object call5158 = callmethod(call5157, "withAll",
    1, partcv, params);
  gc_frame_end(callframe5145);
// compiled call node returning call5158 (depth = 2)
  gc_frame_end(frame);
  return call5158;
}
Object meth_collectionsPrelude__61__61_5159(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2030
  setline(2030);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5160 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_other (depth = 3)
  gc_frame_newslot(*var_other);
// call case 2: outer request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5161 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5162 = gc_frame_new();
// call case 3: self.outer request
  Object call5163 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5162);
// compiled call node returning call5163 (depth = 6)
// compiled member node returning call5163 (depth = 5)
  partcv[0] = 0;
  Object call5164 = callmethodflags(call5163, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5161);
// compiled call node returning call5164 (depth = 4)
// compiled member node returning call5164 (depth = 3)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5165 = callmethodflags(call5164, "isEqual()toIterable", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5160);
// compiled call node returning call5165 (depth = 2)
  gc_frame_end(frame);
  return call5165;
}
Object meth_collectionsPrelude_sorted5166(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sorted (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for sorted");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2032
  setline(2032);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5167 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5168 = callmethodflags(self, "reversed", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5167);
// compiled call node returning call5168 (depth = 3)
// compiled member node returning call5168 (depth = 2)
  gc_frame_end(frame);
  return call5168;
}
Object meth_collectionsPrelude_sortedBy5169(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_c = &(stackframe->slots[0]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for sortedBy");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2034
  setline(2034);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5170 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
  gc_frame_newslot(*var_c);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5171 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5172 = callmethodflags(self, "asList", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5171);
// compiled call node returning call5172 (depth = 4)
// compiled member node returning call5172 (depth = 3)
  params[0] = *var_c;
  partcv[0] = 1;
  Object call5173 = callmethod(call5172, "sortBy",
    1, partcv, params);
  gc_frame_end(callframe5170);
// compiled call node returning call5173 (depth = 2)
  gc_frame_end(frame);
  return call5173;
}
Object meth_collectionsPrelude_keys5174(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keys (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for keys");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2036
  setline(2036);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5176 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5177 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5176);
// compiled call node returning call5177 (depth = 4)
// compiled member node returning call5177 (depth = 3)
  int op_slot_right_5175 = gc_frame_newslot(call5177);
// starting to compile num node (depth = 3)
  Object num5179 = alloc_Float64(1);
// compiled num node returning num5179 (depth = 3)
  int op_slot_left_5175 = gc_frame_newslot(num5179);
  params[0] = call5177;
  partcv[0] = 1;
  Object opresult5180 = callmethod(num5179, "..", 1, partcv, params);
// compiled op node returning opresult5180 (depth = 2)
  gc_frame_end(frame);
  return opresult5180;
}
Object meth_collectionsPrelude_values5181(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for values (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for values");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2038
  setline(2038);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_asString5182(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_lower = getfromclosure(closure, 0);
  Object *var_upper = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2041
  setline(2041);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit5184 == NULL) {
    strlit5184 = alloc_String("");
    gc_root(strlit5184);
  }
// compiled string node returning strlit5184 (depth = 3)
  int op_slot_right_5183 = gc_frame_newslot(strlit5184);
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  int op_slot_right_5186 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5189 == NULL) {
    strlit5189 = alloc_String(" downTo ");
    gc_root(strlit5189);
  }
// compiled string node returning strlit5189 (depth = 5)
  int op_slot_right_5188 = gc_frame_newslot(strlit5189);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_right_5191 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 6)
  if (strlit5193 == NULL) {
    strlit5193 = alloc_String("range.from ");
    gc_root(strlit5193);
  }
// compiled string node returning strlit5193 (depth = 6)
  int op_slot_left_5191 = gc_frame_newslot(strlit5193);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5194 = callmethod(strlit5193, "++", 1, partcv, params);
// compiled op node returning opresult5194 (depth = 5)
  int op_slot_left_5188 = gc_frame_newslot(opresult5194);
  params[0] = strlit5189;
  partcv[0] = 1;
  Object opresult5195 = callmethod(opresult5194, "++", 1, partcv, params);
// compiled op node returning opresult5195 (depth = 4)
  int op_slot_left_5186 = gc_frame_newslot(opresult5195);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5196 = callmethod(opresult5195, "++", 1, partcv, params);
// compiled op node returning opresult5196 (depth = 3)
  int op_slot_left_5183 = gc_frame_newslot(opresult5196);
  params[0] = strlit5184;
  partcv[0] = 1;
  Object opresult5197 = callmethod(opresult5196, "++", 1, partcv, params);
// compiled op node returning opresult5197 (depth = 2)
  gc_frame_end(frame);
  return opresult5197;
}
Object meth_collectionsPrelude_asSequence5198(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asSequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asSequence (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asSequence");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 2044
  setline(2044);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 2)
// compiled identifier node returning self (depth = 2)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply5203(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___24 = &(stackframe->slots[0]);
  *var___24 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply5215(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_lower = getfromclosure(closure, 0);
  Object *var_upper = getfromclosure(closure, 1);
  Object *var_RequestError = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___25 = &(stackframe->slots[0]);
  *var___25 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe5216 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 1960
  setline(1960);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5219 == NULL) {
    strlit5219 = alloc_String(") is not an integer");
    gc_root(strlit5219);
  }
// compiled string node returning strlit5219 (depth = 7)
  int op_slot_right_5218 = gc_frame_newslot(strlit5219);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lower (depth = 8)
  int op_slot_right_5221 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5224 == NULL) {
    strlit5224 = alloc_String(")downTo(");
    gc_root(strlit5224);
  }
// compiled string node returning strlit5224 (depth = 9)
  int op_slot_right_5223 = gc_frame_newslot(strlit5224);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_upper (depth = 10)
  int op_slot_right_5226 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 10)
  if (strlit5228 == NULL) {
    strlit5228 = alloc_String(" in range.from(");
    gc_root(strlit5228);
  }
// compiled string node returning strlit5228 (depth = 10)
  int op_slot_left_5226 = gc_frame_newslot(strlit5228);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5229 = callmethod(strlit5228, "++", 1, partcv, params);
// compiled op node returning opresult5229 (depth = 9)
  int op_slot_left_5223 = gc_frame_newslot(opresult5229);
  params[0] = strlit5224;
  partcv[0] = 1;
  Object opresult5230 = callmethod(opresult5229, "++", 1, partcv, params);
// compiled op node returning opresult5230 (depth = 8)
  int op_slot_left_5221 = gc_frame_newslot(opresult5230);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5231 = callmethod(opresult5230, "++", 1, partcv, params);
// compiled op node returning opresult5231 (depth = 7)
  int op_slot_left_5218 = gc_frame_newslot(opresult5231);
  params[0] = strlit5219;
  partcv[0] = 1;
  Object opresult5232 = callmethod(opresult5231, "++", 1, partcv, params);
// compiled op node returning opresult5232 (depth = 6)
  int op_slot_right_5217 = gc_frame_newslot(opresult5232);
// Begin line 1959
  setline(1959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5235 == NULL) {
    strlit5235 = alloc_String("");
    gc_root(strlit5235);
  }
// compiled string node returning strlit5235 (depth = 7)
  int op_slot_right_5234 = gc_frame_newslot(strlit5235);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_upper (depth = 8)
  int op_slot_right_5237 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 8)
  if (strlit5239 == NULL) {
    strlit5239 = alloc_String("upper bound ");
    gc_root(strlit5239);
  }
// compiled string node returning strlit5239 (depth = 8)
  int op_slot_left_5237 = gc_frame_newslot(strlit5239);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5240 = callmethod(strlit5239, "++", 1, partcv, params);
// compiled op node returning opresult5240 (depth = 7)
  int op_slot_left_5234 = gc_frame_newslot(opresult5240);
  params[0] = strlit5235;
  partcv[0] = 1;
  Object opresult5241 = callmethod(opresult5240, "++", 1, partcv, params);
// compiled op node returning opresult5241 (depth = 6)
  int op_slot_left_5217 = gc_frame_newslot(opresult5241);
  params[0] = opresult5232;
  partcv[0] = 1;
  Object opresult5242 = callmethod(opresult5241, "++", 1, partcv, params);
// compiled op node returning opresult5242 (depth = 5)
  gc_frame_newslot(opresult5242);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_RequestError (depth = 5)
  params[0] = opresult5242;
  partcv[0] = 1;
  Object call5243 = callmethod(*var_RequestError, "raise",
    1, partcv, params);
  gc_frame_end(callframe5216);
// compiled call node returning call5243 (depth = 4)
  gc_frame_end(frame);
  return call5243;
}
Object meth_collectionsPrelude__apply5283(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___26 = &(stackframe->slots[0]);
  *var___26 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply5295(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_lower = getfromclosure(closure, 0);
  Object *var_upper = getfromclosure(closure, 1);
  Object *var_RequestError = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___27 = &(stackframe->slots[0]);
  *var___27 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe5296 = gc_frame_new();
// starting to compile op node (depth = 5)
// Begin line 1969
  setline(1969);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5299 == NULL) {
    strlit5299 = alloc_String(") is not an integer");
    gc_root(strlit5299);
  }
// compiled string node returning strlit5299 (depth = 7)
  int op_slot_right_5298 = gc_frame_newslot(strlit5299);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lower (depth = 8)
  int op_slot_right_5301 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 8)
// starting to compile string node (depth = 9)
  if (strlit5304 == NULL) {
    strlit5304 = alloc_String(")downTo(");
    gc_root(strlit5304);
  }
// compiled string node returning strlit5304 (depth = 9)
  int op_slot_right_5303 = gc_frame_newslot(strlit5304);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_upper (depth = 10)
  int op_slot_right_5306 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 10)
  if (strlit5308 == NULL) {
    strlit5308 = alloc_String(" in range.from(");
    gc_root(strlit5308);
  }
// compiled string node returning strlit5308 (depth = 10)
  int op_slot_left_5306 = gc_frame_newslot(strlit5308);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5309 = callmethod(strlit5308, "++", 1, partcv, params);
// compiled op node returning opresult5309 (depth = 9)
  int op_slot_left_5303 = gc_frame_newslot(opresult5309);
  params[0] = strlit5304;
  partcv[0] = 1;
  Object opresult5310 = callmethod(opresult5309, "++", 1, partcv, params);
// compiled op node returning opresult5310 (depth = 8)
  int op_slot_left_5301 = gc_frame_newslot(opresult5310);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5311 = callmethod(opresult5310, "++", 1, partcv, params);
// compiled op node returning opresult5311 (depth = 7)
  int op_slot_left_5298 = gc_frame_newslot(opresult5311);
  params[0] = strlit5299;
  partcv[0] = 1;
  Object opresult5312 = callmethod(opresult5311, "++", 1, partcv, params);
// compiled op node returning opresult5312 (depth = 6)
  int op_slot_right_5297 = gc_frame_newslot(opresult5312);
// Begin line 1968
  setline(1968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5315 == NULL) {
    strlit5315 = alloc_String("");
    gc_root(strlit5315);
  }
// compiled string node returning strlit5315 (depth = 7)
  int op_slot_right_5314 = gc_frame_newslot(strlit5315);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_lower (depth = 8)
  int op_slot_right_5317 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 8)
  if (strlit5319 == NULL) {
    strlit5319 = alloc_String("lower bound ");
    gc_root(strlit5319);
  }
// compiled string node returning strlit5319 (depth = 8)
  int op_slot_left_5317 = gc_frame_newslot(strlit5319);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5320 = callmethod(strlit5319, "++", 1, partcv, params);
// compiled op node returning opresult5320 (depth = 7)
  int op_slot_left_5314 = gc_frame_newslot(opresult5320);
  params[0] = strlit5315;
  partcv[0] = 1;
  Object opresult5321 = callmethod(opresult5320, "++", 1, partcv, params);
// compiled op node returning opresult5321 (depth = 6)
  int op_slot_left_5297 = gc_frame_newslot(opresult5321);
  params[0] = opresult5312;
  partcv[0] = 1;
  Object opresult5322 = callmethod(opresult5321, "++", 1, partcv, params);
// compiled op node returning opresult5322 (depth = 5)
  gc_frame_newslot(opresult5322);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_RequestError (depth = 5)
  params[0] = opresult5322;
  partcv[0] = 1;
  Object call5323 = callmethod(*var_RequestError, "raise",
    1, partcv, params);
  gc_frame_end(callframe5296);
// compiled call node returning call5323 (depth = 4)
  gc_frame_end(frame);
  return call5323;
}
Object meth_collectionsPrelude_from_40__41_downTo4916(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "from()downTo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method from()downTo");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method from()downTo");
  Object params[2];
  int partcv[2];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_indexable = getfromclosure(closure, 3);
  Object *var_Number = getfromclosure(closure, 4);
  Object *var_RequestError = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for from()downTo (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_upper = &(stackframe->slots[0]);
  *var_upper = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *var_lower = &(stackframe->slots[1]);
  *var_lower = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for downTo");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4917 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4917 = alloc_userobj2(22,23, objclass4917);
  gc_frame_newslot(obj4917);
if (objclass4917 == NULL) {
  glfree(obj4917->class->name);
  obj4917->class->name = "collectionsPrelude.range.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4917, self, 0);
  addmethodreal(obj4917,"outer", &reader_collectionsPrelude_outer_4918);
  Object oldself4917 = self;
  struct StackFrameObject *oldstackframe4917 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4917);
  gc_frame_newslot((Object)stackframe);
  self = obj4917;
  Object *oldselfslot4917 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4917 = (*(struct UserObject *)self).data[0], lowerouter4917 = thisouter4917;
  if (inheritingObject4917) {
    struct UserObject *inho4917 = (struct UserObject *)inheritingObject4917;
    while (inho4917->super != GraceDefaultObject) inho4917 = (struct UserObject *)inho4917->super;
    inho4917->super = obj4917;
    self = inheritingObject4917;
    *selfslot = self;
    lowerouter4917 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4917;
  }
if (objclass4917 == NULL) {
  Method *reader4919 = addmethodrealflags(obj4917, "start",&reader_collectionsPrelude_start_4919, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4919->definitionModule = modulename;
  reader4919->definitionLine = 1961;
}
adddatum2(obj4917, alloc_Undefined(), 1);
if (objclass4917 == NULL) {
  Method *reader4920 = addmethodrealflags(obj4917, "stop",&reader_collectionsPrelude_stop_4920, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4920->definitionModule = modulename;
  reader4920->definitionLine = 1970;
}
adddatum2(obj4917, alloc_Undefined(), 2);
if (objclass4917 == NULL) {
  Method *reader4921 = addmethodrealflags(obj4917, "size",&reader_collectionsPrelude_size_4921, MFLAG_DEF);
  reader4921->definitionModule = modulename;
  reader4921->definitionLine = 1975;
}
adddatum2(obj4917, alloc_Undefined(), 3);
// method "iterator"
  block_savedest(obj4917);
  Object closure4922 = createclosure(1, "iterator");
  setclosureframe(closure4922, stackframe);
  addtoclosure(closure4922, var_IteratorExhausted);
  struct UserObject *uo4922 = (struct UserObject*)obj4917;
  uo4922->data[4] = (Object)closure4922;
  Method *meth_meth_collectionsPrelude_iterator4922 = addmethod2pos(obj4917, "iterator", &meth_collectionsPrelude_iterator4922, 4);
  int argcv_meth_collectionsPrelude_iterator4922[] = {0};
  meth_meth_collectionsPrelude_iterator4922->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator4922);
  meth_meth_collectionsPrelude_iterator4922->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4922->definitionLine = 1977;
  block_savedest(obj4917);
  Object closure4990 = createclosure(1, "iterator()object");
  setclosureframe(closure4990, stackframe);
  addtoclosure(closure4990, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator4922_object = addmethod2pos(obj4917, "iterator()object", &meth_collectionsPrelude_iterator4922_object, 4);
  meth_meth_collectionsPrelude_iterator4922_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4922_object->definitionLine = 1977;
// method "at"
  block_savedest(obj4917);
  Object closure4991 = createclosure(1, "at");
  setclosureframe(closure4991, stackframe);
  addtoclosure(closure4991, var_BoundsError);
  struct UserObject *uo4991 = (struct UserObject*)obj4917;
  uo4991->data[5] = (Object)closure4991;
  Method *meth_meth_collectionsPrelude_at4991 = addmethod2pos(obj4917, "at", &meth_collectionsPrelude_at4991, 5);
  int argcv_meth_collectionsPrelude_at4991[] = {1};
  meth_meth_collectionsPrelude_at4991->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at4991);
meth_meth_collectionsPrelude_at4991->type->types[0] = type_Number;
meth_meth_collectionsPrelude_at4991->type->names[0] = "ix";
  meth_meth_collectionsPrelude_at4991->definitionModule = modulename;
  meth_meth_collectionsPrelude_at4991->definitionLine = 1989;
// method "contains"
  block_savedest(obj4917);
  Object closure5045 = createclosure(1, "contains");
  setclosureframe(closure5045, stackframe);
  addtoclosure(closure5045, var__prelude);
  struct UserObject *uo5045 = (struct UserObject*)obj4917;
  uo5045->data[6] = (Object)closure5045;
  Method *meth_meth_collectionsPrelude_contains5045 = addmethod2pos(obj4917, "contains", &meth_collectionsPrelude_contains5045, 6);
  int argcv_meth_collectionsPrelude_contains5045[] = {1};
  meth_meth_collectionsPrelude_contains5045->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains5045);
  meth_meth_collectionsPrelude_contains5045->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains5045->definitionLine = 1998;
// method "do"
  struct UserObject *uo5087 = (struct UserObject*)obj4917;
  uo5087->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do5087 = addmethod2pos(obj4917, "do", &meth_collectionsPrelude_do5087, 7);
  int argcv_meth_collectionsPrelude_do5087[] = {1};
  meth_meth_collectionsPrelude_do5087->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do5087);
  meth_meth_collectionsPrelude_do5087->definitionModule = modulename;
  meth_meth_collectionsPrelude_do5087->definitionLine = 2007;
// method "keysAndValuesDo"
  struct UserObject *uo5110 = (struct UserObject*)obj4917;
  uo5110->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo5110 = addmethod2pos(obj4917, "keysAndValuesDo", &meth_collectionsPrelude_keysAndValuesDo5110, 8);
  int argcv_meth_collectionsPrelude_keysAndValuesDo5110[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo5110->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo5110);
  meth_meth_collectionsPrelude_keysAndValuesDo5110->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo5110->definitionLine = 2014;
// method "reversed"
  block_savedest(obj4917);
  Object closure5139 = createclosure(2, "reversed");
  setclosureframe(closure5139, stackframe);
  addtoclosure(closure5139, var_lower);
  addtoclosure(closure5139, var_upper);
  struct UserObject *uo5139 = (struct UserObject*)obj4917;
  uo5139->data[9] = (Object)closure5139;
  Method *meth_meth_collectionsPrelude_reversed5139 = addmethod2pos(obj4917, "reversed", &meth_collectionsPrelude_reversed5139, 9);
  int argcv_meth_collectionsPrelude_reversed5139[] = {0};
  meth_meth_collectionsPrelude_reversed5139->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed5139);
  meth_meth_collectionsPrelude_reversed5139->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed5139->definitionLine = 2023;
// method "++"
  struct UserObject *uo5144 = (struct UserObject*)obj4917;
  uo5144->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_5144 = addmethod2pos(obj4917, "++", &meth_collectionsPrelude__43__43_5144, 10);
  int argcv_meth_collectionsPrelude__43__43_5144[] = {1};
  meth_meth_collectionsPrelude__43__43_5144->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_5144);
  meth_meth_collectionsPrelude__43__43_5144->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_5144->definitionLine = 2026;
// method "=="
  struct UserObject *uo5159 = (struct UserObject*)obj4917;
  uo5159->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61_5159 = addmethod2pos(obj4917, "==", &meth_collectionsPrelude__61__61_5159, 11);
  int argcv_meth_collectionsPrelude__61__61_5159[] = {1};
  meth_meth_collectionsPrelude__61__61_5159->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_5159);
  meth_meth_collectionsPrelude__61__61_5159->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_5159->definitionLine = 2029;
// method "sorted"
  struct UserObject *uo5166 = (struct UserObject*)obj4917;
  uo5166->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted5166 = addmethod2pos(obj4917, "sorted", &meth_collectionsPrelude_sorted5166, 12);
  int argcv_meth_collectionsPrelude_sorted5166[] = {0};
  meth_meth_collectionsPrelude_sorted5166->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted5166);
  meth_meth_collectionsPrelude_sorted5166->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted5166->definitionLine = 2032;
// method "sortedBy"
  struct UserObject *uo5169 = (struct UserObject*)obj4917;
  uo5169->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy5169 = addmethod2pos(obj4917, "sortedBy", &meth_collectionsPrelude_sortedBy5169, 13);
  int argcv_meth_collectionsPrelude_sortedBy5169[] = {1};
  meth_meth_collectionsPrelude_sortedBy5169->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy5169);
  meth_meth_collectionsPrelude_sortedBy5169->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy5169->definitionLine = 2034;
// method "keys"
  struct UserObject *uo5174 = (struct UserObject*)obj4917;
  uo5174->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys5174 = addmethod2pos(obj4917, "keys", &meth_collectionsPrelude_keys5174, 14);
  int argcv_meth_collectionsPrelude_keys5174[] = {0};
  meth_meth_collectionsPrelude_keys5174->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys5174);
  meth_meth_collectionsPrelude_keys5174->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys5174->definitionLine = 2036;
// method "values"
  struct UserObject *uo5181 = (struct UserObject*)obj4917;
  uo5181->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values5181 = addmethod2pos(obj4917, "values", &meth_collectionsPrelude_values5181, 15);
  int argcv_meth_collectionsPrelude_values5181[] = {0};
  meth_meth_collectionsPrelude_values5181->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values5181);
  meth_meth_collectionsPrelude_values5181->definitionModule = modulename;
  meth_meth_collectionsPrelude_values5181->definitionLine = 2038;
// method "asString"
  block_savedest(obj4917);
  Object closure5182 = createclosure(2, "asString");
  setclosureframe(closure5182, stackframe);
  addtoclosure(closure5182, var_lower);
  addtoclosure(closure5182, var_upper);
  struct UserObject *uo5182 = (struct UserObject*)obj4917;
  uo5182->data[16] = (Object)closure5182;
  Method *meth_meth_collectionsPrelude_asString5182 = addmethod2pos(obj4917, "asString", &meth_collectionsPrelude_asString5182, 16);
  int argcv_meth_collectionsPrelude_asString5182[] = {0};
  meth_meth_collectionsPrelude_asString5182->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5182);
  meth_meth_collectionsPrelude_asString5182->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5182->definitionLine = 2040;
// method "asSequence"
  struct UserObject *uo5198 = (struct UserObject*)obj4917;
  uo5198->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSequence5198 = addmethod2pos(obj4917, "asSequence", &meth_collectionsPrelude_asSequence5198, 17);
  int argcv_meth_collectionsPrelude_asSequence5198[] = {0};
  meth_meth_collectionsPrelude_asSequence5198->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSequence5198);
  meth_meth_collectionsPrelude_asSequence5198->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSequence5198->definitionLine = 2043;
  sourceObject = obj4917;
// Begin line 1956
  setline(1956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5199 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5200 = callmethod(*var_indexable, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe5199);
// compiled call node returning call5200 (depth = 2)
  struct UserObject *obj4917_uo = (struct UserObject *)obj4917;
  obj4917_uo->super = call5200;
  sourceObject = obj4917;
// Begin line 1957
  setline(1957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  int frame5201 = gc_frame_new();
  gc_frame_newslot(*var_upper);
// Begin line 1958
  setline(1958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5202 = alloc_Block(NULL, NULL, "collectionsPrelude", 1958);
  gc_frame_newslot(block5202);
// method "_apply"
  block_savedest(block5202);
  Object closure5203 = createclosure(1, "_apply");
  setclosureframe(closure5203, stackframe);
  addtoclosure(closure5203, selfslot);
  struct UserObject *uo5203 = (struct UserObject*)block5202;
  uo5203->data[0] = (Object)closure5203;
  Method *meth_meth_collectionsPrelude__apply5203 = addmethod2pos(block5202, "_apply", &meth_collectionsPrelude__apply5203, 0);
  int argcv_meth_collectionsPrelude__apply5203[] = {1};
  meth_meth_collectionsPrelude__apply5203->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5203);
meth_meth_collectionsPrelude__apply5203->type->types[0] = type_Number;
meth_meth_collectionsPrelude__apply5203->type->names[0] = "__24";
  meth_meth_collectionsPrelude__apply5203->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5203->definitionLine = 2036;
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5205 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe5206 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5207 == NULL) {
    strlit5207 = alloc_String("__24");
    gc_root(strlit5207);
  }
// compiled string node returning strlit5207 (depth = 6)
  gc_frame_newslot(strlit5207);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5208 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5209 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5208);
// compiled call node returning call5209 (depth = 7)
// compiled member node returning call5209 (depth = 6)
  params[0] = strlit5207;
  partcv[0] = 1;
  Object call5210 = callmethod(call5209, "new",
    1, partcv, params);
  gc_frame_end(callframe5206);
// compiled call node returning call5210 (depth = 5)
  gc_frame_newslot(call5210);
// Begin line 1958
  setline(1958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other member request
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5211 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5212 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5211);
// compiled call node returning call5212 (depth = 6)
// compiled member node returning call5212 (depth = 5)
  params[0] = call5210;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call5213 = callmethod(call5212, "new",
    1, partcv, params);
  gc_frame_end(callframe5205);
// compiled call node returning call5213 (depth = 4)
((struct UserObject *)block5202)->data[1] = call5213;
// compiled block node returning block5202 (depth = 3)
  gc_frame_newslot(block5202);
// Begin line 1959
  setline(1959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5214 = alloc_Block(NULL, NULL, "collectionsPrelude", 1959);
  gc_frame_newslot(block5214);
// method "_apply"
  block_savedest(block5214);
  Object closure5215 = createclosure(4, "_apply");
  setclosureframe(closure5215, stackframe);
  addtoclosure(closure5215, var_lower);
  addtoclosure(closure5215, var_upper);
  addtoclosure(closure5215, var_RequestError);
  addtoclosure(closure5215, selfslot);
  struct UserObject *uo5215 = (struct UserObject*)block5214;
  uo5215->data[0] = (Object)closure5215;
  Method *meth_meth_collectionsPrelude__apply5215 = addmethod2pos(block5214, "_apply", &meth_collectionsPrelude__apply5215, 0);
  int argcv_meth_collectionsPrelude__apply5215[] = {1};
  meth_meth_collectionsPrelude__apply5215->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5215);
  meth_meth_collectionsPrelude__apply5215->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5215->definitionLine = 1903;
// compiled block node returning block5214 (depth = 3)
  gc_frame_newslot(block5214);
  params[0] = block5202;
  params[1] = block5214;
  Object matchres5201 = matchCase(*var_upper, params, 2,NULL);
  gc_frame_end(frame5201);
// compiled matchcase node returning matchres5201 (depth = 2)
  sourceObject = obj4917;
// Begin line 1961
  setline(1961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5245 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  partcv[0] = 0;
  Object call5246 = callmethod(*var_upper, "truncated",
    1, partcv, params);
  gc_frame_end(callframe5245);
// compiled call node returning call5246 (depth = 3)
// compiled member node returning call5246 (depth = 2)
  adddatum2(obj4917, call5246, 1);
  sourceObject = obj4917;
// Begin line 1962
  setline(1962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  int op_slot_right_5248 = gc_frame_newslot(*var_upper);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5250 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5251 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5250);
// compiled call node returning call5251 (depth = 5)
// compiled member node returning call5251 (depth = 4)
  int op_slot_left_5248 = gc_frame_newslot(call5251);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5252 = callmethod(call5251, "≠", 1, partcv, params);
// compiled op node returning opresult5252 (depth = 3)
  Object if5247 = done;
struct StackFrameObject *iftmpstackframe5247 = stackframe;
  if (istrue(opresult5252)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5247);
gc_frame_newslot((Object)stackframe);
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5253 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1964
  setline(1964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5256 == NULL) {
    strlit5256 = alloc_String(") is not an integer");
    gc_root(strlit5256);
  }
// compiled string node returning strlit5256 (depth = 6)
  int op_slot_right_5255 = gc_frame_newslot(strlit5256);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5258 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5261 == NULL) {
    strlit5261 = alloc_String(")downTo(");
    gc_root(strlit5261);
  }
// compiled string node returning strlit5261 (depth = 8)
  int op_slot_right_5260 = gc_frame_newslot(strlit5261);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_upper (depth = 9)
  int op_slot_right_5263 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 9)
  if (strlit5265 == NULL) {
    strlit5265 = alloc_String(" in range.from(");
    gc_root(strlit5265);
  }
// compiled string node returning strlit5265 (depth = 9)
  int op_slot_left_5263 = gc_frame_newslot(strlit5265);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5266 = callmethod(strlit5265, "++", 1, partcv, params);
// compiled op node returning opresult5266 (depth = 8)
  int op_slot_left_5260 = gc_frame_newslot(opresult5266);
  params[0] = strlit5261;
  partcv[0] = 1;
  Object opresult5267 = callmethod(opresult5266, "++", 1, partcv, params);
// compiled op node returning opresult5267 (depth = 7)
  int op_slot_left_5258 = gc_frame_newslot(opresult5267);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5268 = callmethod(opresult5267, "++", 1, partcv, params);
// compiled op node returning opresult5268 (depth = 6)
  int op_slot_left_5255 = gc_frame_newslot(opresult5268);
  params[0] = strlit5256;
  partcv[0] = 1;
  Object opresult5269 = callmethod(opresult5268, "++", 1, partcv, params);
// compiled op node returning opresult5269 (depth = 5)
  int op_slot_right_5254 = gc_frame_newslot(opresult5269);
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5272 == NULL) {
    strlit5272 = alloc_String("");
    gc_root(strlit5272);
  }
// compiled string node returning strlit5272 (depth = 6)
  int op_slot_right_5271 = gc_frame_newslot(strlit5272);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_upper (depth = 7)
  int op_slot_right_5274 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 7)
  if (strlit5276 == NULL) {
    strlit5276 = alloc_String("upper bound ");
    gc_root(strlit5276);
  }
// compiled string node returning strlit5276 (depth = 7)
  int op_slot_left_5274 = gc_frame_newslot(strlit5276);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5277 = callmethod(strlit5276, "++", 1, partcv, params);
// compiled op node returning opresult5277 (depth = 6)
  int op_slot_left_5271 = gc_frame_newslot(opresult5277);
  params[0] = strlit5272;
  partcv[0] = 1;
  Object opresult5278 = callmethod(opresult5277, "++", 1, partcv, params);
// compiled op node returning opresult5278 (depth = 5)
  int op_slot_left_5254 = gc_frame_newslot(opresult5278);
  params[0] = opresult5269;
  partcv[0] = 1;
  Object opresult5279 = callmethod(opresult5278, "++", 1, partcv, params);
// compiled op node returning opresult5279 (depth = 4)
  gc_frame_newslot(opresult5279);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_RequestError (depth = 4)
  params[0] = opresult5279;
  partcv[0] = 1;
  Object call5280 = callmethod(*var_RequestError, "raise",
    1, partcv, params);
  gc_frame_end(callframe5253);
// compiled call node returning call5280 (depth = 3)
    gc_frame_newslot(call5280);
    if5247 = call5280;
  } else {
  }
stackframe = iftmpstackframe5247;
// compiled if node returning if5247 (depth = 2)
  sourceObject = obj4917;
// Begin line 1966
  setline(1966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  int frame5281 = gc_frame_new();
  gc_frame_newslot(*var_lower);
// Begin line 1967
  setline(1967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5282 = alloc_Block(NULL, NULL, "collectionsPrelude", 1967);
  gc_frame_newslot(block5282);
// method "_apply"
  block_savedest(block5282);
  Object closure5283 = createclosure(1, "_apply");
  setclosureframe(closure5283, stackframe);
  addtoclosure(closure5283, selfslot);
  struct UserObject *uo5283 = (struct UserObject*)block5282;
  uo5283->data[0] = (Object)closure5283;
  Method *meth_meth_collectionsPrelude__apply5283 = addmethod2pos(block5282, "_apply", &meth_collectionsPrelude__apply5283, 0);
  int argcv_meth_collectionsPrelude__apply5283[] = {1};
  meth_meth_collectionsPrelude__apply5283->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5283);
meth_meth_collectionsPrelude__apply5283->type->types[0] = type_Number;
meth_meth_collectionsPrelude__apply5283->type->names[0] = "__26";
  meth_meth_collectionsPrelude__apply5283->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5283->definitionLine = 1962;
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5285 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe5286 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5287 == NULL) {
    strlit5287 = alloc_String("__26");
    gc_root(strlit5287);
  }
// compiled string node returning strlit5287 (depth = 6)
  gc_frame_newslot(strlit5287);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5288 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5289 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5288);
// compiled call node returning call5289 (depth = 7)
// compiled member node returning call5289 (depth = 6)
  params[0] = strlit5287;
  partcv[0] = 1;
  Object call5290 = callmethod(call5289, "new",
    1, partcv, params);
  gc_frame_end(callframe5286);
// compiled call node returning call5290 (depth = 5)
  gc_frame_newslot(call5290);
// Begin line 1967
  setline(1967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other member request
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5291 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5292 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5291);
// compiled call node returning call5292 (depth = 6)
// compiled member node returning call5292 (depth = 5)
  params[0] = call5290;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call5293 = callmethod(call5292, "new",
    1, partcv, params);
  gc_frame_end(callframe5285);
// compiled call node returning call5293 (depth = 4)
((struct UserObject *)block5282)->data[1] = call5293;
// compiled block node returning block5282 (depth = 3)
  gc_frame_newslot(block5282);
// Begin line 1968
  setline(1968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5294 = alloc_Block(NULL, NULL, "collectionsPrelude", 1968);
  gc_frame_newslot(block5294);
// method "_apply"
  block_savedest(block5294);
  Object closure5295 = createclosure(4, "_apply");
  setclosureframe(closure5295, stackframe);
  addtoclosure(closure5295, var_lower);
  addtoclosure(closure5295, var_upper);
  addtoclosure(closure5295, var_RequestError);
  addtoclosure(closure5295, selfslot);
  struct UserObject *uo5295 = (struct UserObject*)block5294;
  uo5295->data[0] = (Object)closure5295;
  Method *meth_meth_collectionsPrelude__apply5295 = addmethod2pos(block5294, "_apply", &meth_collectionsPrelude__apply5295, 0);
  int argcv_meth_collectionsPrelude__apply5295[] = {1};
  meth_meth_collectionsPrelude__apply5295->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5295);
  meth_meth_collectionsPrelude__apply5295->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5295->definitionLine = 1903;
// compiled block node returning block5294 (depth = 3)
  gc_frame_newslot(block5294);
  params[0] = block5282;
  params[1] = block5294;
  Object matchres5281 = matchCase(*var_lower, params, 2,NULL);
  gc_frame_end(frame5281);
// compiled matchcase node returning matchres5281 (depth = 2)
  sourceObject = obj4917;
// Begin line 1970
  setline(1970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5325 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  partcv[0] = 0;
  Object call5326 = callmethod(*var_lower, "truncated",
    1, partcv, params);
  gc_frame_end(callframe5325);
// compiled call node returning call5326 (depth = 3)
// compiled member node returning call5326 (depth = 2)
  adddatum2(obj4917, call5326, 2);
  sourceObject = obj4917;
// Begin line 1971
  setline(1971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  int op_slot_right_5328 = gc_frame_newslot(*var_lower);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5330 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5331 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5330);
// compiled call node returning call5331 (depth = 5)
// compiled member node returning call5331 (depth = 4)
  int op_slot_left_5328 = gc_frame_newslot(call5331);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5332 = callmethod(call5331, "≠", 1, partcv, params);
// compiled op node returning opresult5332 (depth = 3)
  Object if5327 = done;
struct StackFrameObject *iftmpstackframe5327 = stackframe;
  if (istrue(opresult5332)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5327);
gc_frame_newslot((Object)stackframe);
// Begin line 1972
  setline(1972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5333 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1973
  setline(1973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5336 == NULL) {
    strlit5336 = alloc_String(") is not an integer");
    gc_root(strlit5336);
  }
// compiled string node returning strlit5336 (depth = 6)
  int op_slot_right_5335 = gc_frame_newslot(strlit5336);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5338 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5341 == NULL) {
    strlit5341 = alloc_String(")downTo(");
    gc_root(strlit5341);
  }
// compiled string node returning strlit5341 (depth = 8)
  int op_slot_right_5340 = gc_frame_newslot(strlit5341);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_upper (depth = 9)
  int op_slot_right_5343 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 9)
  if (strlit5345 == NULL) {
    strlit5345 = alloc_String(" in range.from(");
    gc_root(strlit5345);
  }
// compiled string node returning strlit5345 (depth = 9)
  int op_slot_left_5343 = gc_frame_newslot(strlit5345);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5346 = callmethod(strlit5345, "++", 1, partcv, params);
// compiled op node returning opresult5346 (depth = 8)
  int op_slot_left_5340 = gc_frame_newslot(opresult5346);
  params[0] = strlit5341;
  partcv[0] = 1;
  Object opresult5347 = callmethod(opresult5346, "++", 1, partcv, params);
// compiled op node returning opresult5347 (depth = 7)
  int op_slot_left_5338 = gc_frame_newslot(opresult5347);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5348 = callmethod(opresult5347, "++", 1, partcv, params);
// compiled op node returning opresult5348 (depth = 6)
  int op_slot_left_5335 = gc_frame_newslot(opresult5348);
  params[0] = strlit5336;
  partcv[0] = 1;
  Object opresult5349 = callmethod(opresult5348, "++", 1, partcv, params);
// compiled op node returning opresult5349 (depth = 5)
  int op_slot_right_5334 = gc_frame_newslot(opresult5349);
// Begin line 1972
  setline(1972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5352 == NULL) {
    strlit5352 = alloc_String("");
    gc_root(strlit5352);
  }
// compiled string node returning strlit5352 (depth = 6)
  int op_slot_right_5351 = gc_frame_newslot(strlit5352);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5354 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 7)
  if (strlit5356 == NULL) {
    strlit5356 = alloc_String("lower bound ");
    gc_root(strlit5356);
  }
// compiled string node returning strlit5356 (depth = 7)
  int op_slot_left_5354 = gc_frame_newslot(strlit5356);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5357 = callmethod(strlit5356, "++", 1, partcv, params);
// compiled op node returning opresult5357 (depth = 6)
  int op_slot_left_5351 = gc_frame_newslot(opresult5357);
  params[0] = strlit5352;
  partcv[0] = 1;
  Object opresult5358 = callmethod(opresult5357, "++", 1, partcv, params);
// compiled op node returning opresult5358 (depth = 5)
  int op_slot_left_5334 = gc_frame_newslot(opresult5358);
  params[0] = opresult5349;
  partcv[0] = 1;
  Object opresult5359 = callmethod(opresult5358, "++", 1, partcv, params);
// compiled op node returning opresult5359 (depth = 4)
  gc_frame_newslot(opresult5359);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_RequestError (depth = 4)
  params[0] = opresult5359;
  partcv[0] = 1;
  Object call5360 = callmethod(*var_RequestError, "raise",
    1, partcv, params);
  gc_frame_end(callframe5333);
// compiled call node returning call5360 (depth = 3)
    gc_frame_newslot(call5360);
    if5327 = call5360;
  } else {
  }
stackframe = iftmpstackframe5327;
// compiled if node returning if5327 (depth = 2)
  sourceObject = obj4917;
// Begin line 1976
  setline(1976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5363 = alloc_Float64(0);
// compiled num node returning num5363 (depth = 4)
  int op_slot_right_5362 = gc_frame_newslot(num5363);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5366 = alloc_Float64(1);
// compiled num node returning num5366 (depth = 5)
  int op_slot_right_5365 = gc_frame_newslot(num5366);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_5368 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_left_5368 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff5370 = callmethod(*var_upper, "-", 1, partcv, params);
// compiled op node returning diff5370 (depth = 5)
  int op_slot_left_5365 = gc_frame_newslot(diff5370);
  params[0] = num5366;
  partcv[0] = 1;
  Object sum5371 = callmethod(diff5370, "+", 1, partcv, params);
// compiled op node returning sum5371 (depth = 4)
  int op_slot_left_5362 = gc_frame_newslot(sum5371);
  params[0] = num5363;
  partcv[0] = 1;
  Object opresult5372 = callmethod(sum5371, "<", 1, partcv, params);
// compiled op node returning opresult5372 (depth = 3)
  Object if5361 = done;
struct StackFrameObject *iftmpstackframe5361 = stackframe;
  if (istrue(opresult5372)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5361);
gc_frame_newslot((Object)stackframe);
// starting to compile num node (depth = 3)
  Object num5373 = alloc_Float64(0);
// compiled num node returning num5373 (depth = 3)
    gc_frame_newslot(num5373);
    if5361 = num5373;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe5361);
  gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5375 = alloc_Float64(1);
// compiled num node returning num5375 (depth = 4)
  int op_slot_right_5374 = gc_frame_newslot(num5375);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lower (depth = 5)
  int op_slot_right_5377 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_upper (depth = 5)
  int op_slot_left_5377 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff5379 = callmethod(*var_upper, "-", 1, partcv, params);
// compiled op node returning diff5379 (depth = 4)
  int op_slot_left_5374 = gc_frame_newslot(diff5379);
  params[0] = num5375;
  partcv[0] = 1;
  Object sum5380 = callmethod(diff5379, "+", 1, partcv, params);
// compiled op node returning sum5380 (depth = 3)
    gc_frame_newslot(sum5380);
    if5361 = sum5380;
  }
stackframe = iftmpstackframe5361;
// compiled if node returning if5361 (depth = 2)
  adddatum2(obj4917, if5361, 3);
  sourceObject = obj4917;
  sourceObject = obj4917;
  sourceObject = obj4917;
  sourceObject = obj4917;
  sourceObject = obj4917;
  sourceObject = obj4917;
  sourceObject = obj4917;
  sourceObject = obj4917;
  sourceObject = obj4917;
  sourceObject = obj4917;
  sourceObject = obj4917;
  sourceObject = obj4917;
  sourceObject = obj4917;
  sourceObject = obj4917;
  objclass4917 = obj4917->class;
  objclass4917->definitionModule = modulename;
  objclass4917->definitionLine = 1955;
  (*(struct UserObject *)self).data[0] = lowerouter4917;
  self = oldself4917;
  selfslot = oldselfslot4917;
  stackframe = oldstackframe4917;
  gc_frame_end(frame);
  return obj4917;
}
Object meth_collectionsPrelude_from_40__41_downTo4916_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "from()downTo()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method from()downTo()object");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method from()downTo()object");
  Object params[2];
  int partcv[2];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  Object *var__prelude = getfromclosure(closure, 2);
  Object *var_indexable = getfromclosure(closure, 3);
  Object *var_Number = getfromclosure(closure, 4);
  Object *var_RequestError = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for from()downTo (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_upper = &(stackframe->slots[0]);
  *var_upper = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for from");
  Object *var_lower = &(stackframe->slots[1]);
  *var_lower = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for downTo");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4917 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4917 = alloc_userobj2(22,23, objclass4917);
  gc_frame_newslot(obj4917);
if (objclass4917 == NULL) {
  glfree(obj4917->class->name);
  obj4917->class->name = "collectionsPrelude.range.object";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4917, self, 0);
  addmethodreal(obj4917,"outer", &reader_collectionsPrelude_outer_4918);
  Object oldself4917 = self;
  struct StackFrameObject *oldstackframe4917 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4917);
  gc_frame_newslot((Object)stackframe);
  self = obj4917;
  Object *oldselfslot4917 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4917 = (*(struct UserObject *)self).data[0], lowerouter4917 = thisouter4917;
  if (inheritingObject4917) {
    struct UserObject *inho4917 = (struct UserObject *)inheritingObject4917;
    while (inho4917->super != GraceDefaultObject) inho4917 = (struct UserObject *)inho4917->super;
    inho4917->super = obj4917;
    self = inheritingObject4917;
    *selfslot = self;
    lowerouter4917 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4917;
  }
if (objclass4917 == NULL) {
  Method *reader4919 = addmethodrealflags(obj4917, "start",&reader_collectionsPrelude_start_4919, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4919->definitionModule = modulename;
  reader4919->definitionLine = 1961;
}
adddatum2(obj4917, alloc_Undefined(), 1);
if (objclass4917 == NULL) {
  Method *reader4920 = addmethodrealflags(obj4917, "stop",&reader_collectionsPrelude_stop_4920, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader4920->definitionModule = modulename;
  reader4920->definitionLine = 1970;
}
adddatum2(obj4917, alloc_Undefined(), 2);
if (objclass4917 == NULL) {
  Method *reader4921 = addmethodrealflags(obj4917, "size",&reader_collectionsPrelude_size_4921, MFLAG_DEF);
  reader4921->definitionModule = modulename;
  reader4921->definitionLine = 1975;
}
adddatum2(obj4917, alloc_Undefined(), 3);
// method "iterator"
  block_savedest(obj4917);
  Object closure4922 = createclosure(1, "iterator");
  setclosureframe(closure4922, stackframe);
  addtoclosure(closure4922, var_IteratorExhausted);
  struct UserObject *uo4922 = (struct UserObject*)obj4917;
  uo4922->data[4] = (Object)closure4922;
  Method *meth_meth_collectionsPrelude_iterator4922 = addmethod2pos(obj4917, "iterator", &meth_collectionsPrelude_iterator4922, 4);
  int argcv_meth_collectionsPrelude_iterator4922[] = {0};
  meth_meth_collectionsPrelude_iterator4922->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator4922);
  meth_meth_collectionsPrelude_iterator4922->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4922->definitionLine = 1977;
  block_savedest(obj4917);
  Object closure4990 = createclosure(1, "iterator()object");
  setclosureframe(closure4990, stackframe);
  addtoclosure(closure4990, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator4922_object = addmethod2pos(obj4917, "iterator()object", &meth_collectionsPrelude_iterator4922_object, 4);
  meth_meth_collectionsPrelude_iterator4922_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator4922_object->definitionLine = 1977;
// method "at"
  block_savedest(obj4917);
  Object closure4991 = createclosure(1, "at");
  setclosureframe(closure4991, stackframe);
  addtoclosure(closure4991, var_BoundsError);
  struct UserObject *uo4991 = (struct UserObject*)obj4917;
  uo4991->data[5] = (Object)closure4991;
  Method *meth_meth_collectionsPrelude_at4991 = addmethod2pos(obj4917, "at", &meth_collectionsPrelude_at4991, 5);
  int argcv_meth_collectionsPrelude_at4991[] = {1};
  meth_meth_collectionsPrelude_at4991->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at4991);
meth_meth_collectionsPrelude_at4991->type->types[0] = type_Number;
meth_meth_collectionsPrelude_at4991->type->names[0] = "ix";
  meth_meth_collectionsPrelude_at4991->definitionModule = modulename;
  meth_meth_collectionsPrelude_at4991->definitionLine = 1989;
// method "contains"
  block_savedest(obj4917);
  Object closure5045 = createclosure(1, "contains");
  setclosureframe(closure5045, stackframe);
  addtoclosure(closure5045, var__prelude);
  struct UserObject *uo5045 = (struct UserObject*)obj4917;
  uo5045->data[6] = (Object)closure5045;
  Method *meth_meth_collectionsPrelude_contains5045 = addmethod2pos(obj4917, "contains", &meth_collectionsPrelude_contains5045, 6);
  int argcv_meth_collectionsPrelude_contains5045[] = {1};
  meth_meth_collectionsPrelude_contains5045->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains5045);
  meth_meth_collectionsPrelude_contains5045->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains5045->definitionLine = 1998;
// method "do"
  struct UserObject *uo5087 = (struct UserObject*)obj4917;
  uo5087->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do5087 = addmethod2pos(obj4917, "do", &meth_collectionsPrelude_do5087, 7);
  int argcv_meth_collectionsPrelude_do5087[] = {1};
  meth_meth_collectionsPrelude_do5087->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do5087);
  meth_meth_collectionsPrelude_do5087->definitionModule = modulename;
  meth_meth_collectionsPrelude_do5087->definitionLine = 2007;
// method "keysAndValuesDo"
  struct UserObject *uo5110 = (struct UserObject*)obj4917;
  uo5110->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo5110 = addmethod2pos(obj4917, "keysAndValuesDo", &meth_collectionsPrelude_keysAndValuesDo5110, 8);
  int argcv_meth_collectionsPrelude_keysAndValuesDo5110[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo5110->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo5110);
  meth_meth_collectionsPrelude_keysAndValuesDo5110->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo5110->definitionLine = 2014;
// method "reversed"
  block_savedest(obj4917);
  Object closure5139 = createclosure(2, "reversed");
  setclosureframe(closure5139, stackframe);
  addtoclosure(closure5139, var_lower);
  addtoclosure(closure5139, var_upper);
  struct UserObject *uo5139 = (struct UserObject*)obj4917;
  uo5139->data[9] = (Object)closure5139;
  Method *meth_meth_collectionsPrelude_reversed5139 = addmethod2pos(obj4917, "reversed", &meth_collectionsPrelude_reversed5139, 9);
  int argcv_meth_collectionsPrelude_reversed5139[] = {0};
  meth_meth_collectionsPrelude_reversed5139->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed5139);
  meth_meth_collectionsPrelude_reversed5139->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed5139->definitionLine = 2023;
// method "++"
  struct UserObject *uo5144 = (struct UserObject*)obj4917;
  uo5144->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_5144 = addmethod2pos(obj4917, "++", &meth_collectionsPrelude__43__43_5144, 10);
  int argcv_meth_collectionsPrelude__43__43_5144[] = {1};
  meth_meth_collectionsPrelude__43__43_5144->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_5144);
  meth_meth_collectionsPrelude__43__43_5144->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_5144->definitionLine = 2026;
// method "=="
  struct UserObject *uo5159 = (struct UserObject*)obj4917;
  uo5159->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61_5159 = addmethod2pos(obj4917, "==", &meth_collectionsPrelude__61__61_5159, 11);
  int argcv_meth_collectionsPrelude__61__61_5159[] = {1};
  meth_meth_collectionsPrelude__61__61_5159->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_5159);
  meth_meth_collectionsPrelude__61__61_5159->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_5159->definitionLine = 2029;
// method "sorted"
  struct UserObject *uo5166 = (struct UserObject*)obj4917;
  uo5166->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted5166 = addmethod2pos(obj4917, "sorted", &meth_collectionsPrelude_sorted5166, 12);
  int argcv_meth_collectionsPrelude_sorted5166[] = {0};
  meth_meth_collectionsPrelude_sorted5166->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted5166);
  meth_meth_collectionsPrelude_sorted5166->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted5166->definitionLine = 2032;
// method "sortedBy"
  struct UserObject *uo5169 = (struct UserObject*)obj4917;
  uo5169->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy5169 = addmethod2pos(obj4917, "sortedBy", &meth_collectionsPrelude_sortedBy5169, 13);
  int argcv_meth_collectionsPrelude_sortedBy5169[] = {1};
  meth_meth_collectionsPrelude_sortedBy5169->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy5169);
  meth_meth_collectionsPrelude_sortedBy5169->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy5169->definitionLine = 2034;
// method "keys"
  struct UserObject *uo5174 = (struct UserObject*)obj4917;
  uo5174->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys5174 = addmethod2pos(obj4917, "keys", &meth_collectionsPrelude_keys5174, 14);
  int argcv_meth_collectionsPrelude_keys5174[] = {0};
  meth_meth_collectionsPrelude_keys5174->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys5174);
  meth_meth_collectionsPrelude_keys5174->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys5174->definitionLine = 2036;
// method "values"
  struct UserObject *uo5181 = (struct UserObject*)obj4917;
  uo5181->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values5181 = addmethod2pos(obj4917, "values", &meth_collectionsPrelude_values5181, 15);
  int argcv_meth_collectionsPrelude_values5181[] = {0};
  meth_meth_collectionsPrelude_values5181->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values5181);
  meth_meth_collectionsPrelude_values5181->definitionModule = modulename;
  meth_meth_collectionsPrelude_values5181->definitionLine = 2038;
// method "asString"
  block_savedest(obj4917);
  Object closure5182 = createclosure(2, "asString");
  setclosureframe(closure5182, stackframe);
  addtoclosure(closure5182, var_lower);
  addtoclosure(closure5182, var_upper);
  struct UserObject *uo5182 = (struct UserObject*)obj4917;
  uo5182->data[16] = (Object)closure5182;
  Method *meth_meth_collectionsPrelude_asString5182 = addmethod2pos(obj4917, "asString", &meth_collectionsPrelude_asString5182, 16);
  int argcv_meth_collectionsPrelude_asString5182[] = {0};
  meth_meth_collectionsPrelude_asString5182->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5182);
  meth_meth_collectionsPrelude_asString5182->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5182->definitionLine = 2040;
// method "asSequence"
  struct UserObject *uo5198 = (struct UserObject*)obj4917;
  uo5198->data[17] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSequence5198 = addmethod2pos(obj4917, "asSequence", &meth_collectionsPrelude_asSequence5198, 17);
  int argcv_meth_collectionsPrelude_asSequence5198[] = {0};
  meth_meth_collectionsPrelude_asSequence5198->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSequence5198);
  meth_meth_collectionsPrelude_asSequence5198->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSequence5198->definitionLine = 2043;
  sourceObject = obj4917;
// Begin line 1956
  setline(1956);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe5199 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5200 = callmethod(*var_indexable, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe5199);
// compiled call node returning call5200 (depth = 2)
  struct UserObject *obj4917_uo = (struct UserObject *)obj4917;
  obj4917_uo->super = call5200;
  sourceObject = obj4917;
// Begin line 1957
  setline(1957);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_upper (depth = 3)
  int frame5201 = gc_frame_new();
  gc_frame_newslot(*var_upper);
// Begin line 1958
  setline(1958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5202 = alloc_Block(NULL, NULL, "collectionsPrelude", 1958);
  gc_frame_newslot(block5202);
// method "_apply"
  block_savedest(block5202);
  Object closure5203 = createclosure(1, "_apply");
  setclosureframe(closure5203, stackframe);
  addtoclosure(closure5203, selfslot);
  struct UserObject *uo5203 = (struct UserObject*)block5202;
  uo5203->data[0] = (Object)closure5203;
  Method *meth_meth_collectionsPrelude__apply5203 = addmethod2pos(block5202, "_apply", &meth_collectionsPrelude__apply5203, 0);
  int argcv_meth_collectionsPrelude__apply5203[] = {1};
  meth_meth_collectionsPrelude__apply5203->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5203);
meth_meth_collectionsPrelude__apply5203->type->types[0] = type_Number;
meth_meth_collectionsPrelude__apply5203->type->names[0] = "__24";
  meth_meth_collectionsPrelude__apply5203->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5203->definitionLine = 2036;
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5205 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe5206 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5207 == NULL) {
    strlit5207 = alloc_String("__24");
    gc_root(strlit5207);
  }
// compiled string node returning strlit5207 (depth = 6)
  gc_frame_newslot(strlit5207);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5208 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5209 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5208);
// compiled call node returning call5209 (depth = 7)
// compiled member node returning call5209 (depth = 6)
  params[0] = strlit5207;
  partcv[0] = 1;
  Object call5210 = callmethod(call5209, "new",
    1, partcv, params);
  gc_frame_end(callframe5206);
// compiled call node returning call5210 (depth = 5)
  gc_frame_newslot(call5210);
// Begin line 1958
  setline(1958);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other member request
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5211 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5212 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5211);
// compiled call node returning call5212 (depth = 6)
// compiled member node returning call5212 (depth = 5)
  params[0] = call5210;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call5213 = callmethod(call5212, "new",
    1, partcv, params);
  gc_frame_end(callframe5205);
// compiled call node returning call5213 (depth = 4)
((struct UserObject *)block5202)->data[1] = call5213;
// compiled block node returning block5202 (depth = 3)
  gc_frame_newslot(block5202);
// Begin line 1959
  setline(1959);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5214 = alloc_Block(NULL, NULL, "collectionsPrelude", 1959);
  gc_frame_newslot(block5214);
// method "_apply"
  block_savedest(block5214);
  Object closure5215 = createclosure(4, "_apply");
  setclosureframe(closure5215, stackframe);
  addtoclosure(closure5215, var_lower);
  addtoclosure(closure5215, var_upper);
  addtoclosure(closure5215, var_RequestError);
  addtoclosure(closure5215, selfslot);
  struct UserObject *uo5215 = (struct UserObject*)block5214;
  uo5215->data[0] = (Object)closure5215;
  Method *meth_meth_collectionsPrelude__apply5215 = addmethod2pos(block5214, "_apply", &meth_collectionsPrelude__apply5215, 0);
  int argcv_meth_collectionsPrelude__apply5215[] = {1};
  meth_meth_collectionsPrelude__apply5215->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5215);
  meth_meth_collectionsPrelude__apply5215->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5215->definitionLine = 1903;
// compiled block node returning block5214 (depth = 3)
  gc_frame_newslot(block5214);
  params[0] = block5202;
  params[1] = block5214;
  Object matchres5201 = matchCase(*var_upper, params, 2,NULL);
  gc_frame_end(frame5201);
// compiled matchcase node returning matchres5201 (depth = 2)
  sourceObject = obj4917;
// Begin line 1961
  setline(1961);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5245 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  partcv[0] = 0;
  Object call5246 = callmethod(*var_upper, "truncated",
    1, partcv, params);
  gc_frame_end(callframe5245);
// compiled call node returning call5246 (depth = 3)
// compiled member node returning call5246 (depth = 2)
  adddatum2(obj4917, call5246, 1);
  sourceObject = obj4917;
// Begin line 1962
  setline(1962);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_upper (depth = 4)
  int op_slot_right_5248 = gc_frame_newslot(*var_upper);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5250 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5251 = callmethodflags(self, "start", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5250);
// compiled call node returning call5251 (depth = 5)
// compiled member node returning call5251 (depth = 4)
  int op_slot_left_5248 = gc_frame_newslot(call5251);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5252 = callmethod(call5251, "≠", 1, partcv, params);
// compiled op node returning opresult5252 (depth = 3)
  Object if5247 = done;
struct StackFrameObject *iftmpstackframe5247 = stackframe;
  if (istrue(opresult5252)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5247);
gc_frame_newslot((Object)stackframe);
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5253 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1964
  setline(1964);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5256 == NULL) {
    strlit5256 = alloc_String(") is not an integer");
    gc_root(strlit5256);
  }
// compiled string node returning strlit5256 (depth = 6)
  int op_slot_right_5255 = gc_frame_newslot(strlit5256);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5258 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5261 == NULL) {
    strlit5261 = alloc_String(")downTo(");
    gc_root(strlit5261);
  }
// compiled string node returning strlit5261 (depth = 8)
  int op_slot_right_5260 = gc_frame_newslot(strlit5261);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_upper (depth = 9)
  int op_slot_right_5263 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 9)
  if (strlit5265 == NULL) {
    strlit5265 = alloc_String(" in range.from(");
    gc_root(strlit5265);
  }
// compiled string node returning strlit5265 (depth = 9)
  int op_slot_left_5263 = gc_frame_newslot(strlit5265);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5266 = callmethod(strlit5265, "++", 1, partcv, params);
// compiled op node returning opresult5266 (depth = 8)
  int op_slot_left_5260 = gc_frame_newslot(opresult5266);
  params[0] = strlit5261;
  partcv[0] = 1;
  Object opresult5267 = callmethod(opresult5266, "++", 1, partcv, params);
// compiled op node returning opresult5267 (depth = 7)
  int op_slot_left_5258 = gc_frame_newslot(opresult5267);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5268 = callmethod(opresult5267, "++", 1, partcv, params);
// compiled op node returning opresult5268 (depth = 6)
  int op_slot_left_5255 = gc_frame_newslot(opresult5268);
  params[0] = strlit5256;
  partcv[0] = 1;
  Object opresult5269 = callmethod(opresult5268, "++", 1, partcv, params);
// compiled op node returning opresult5269 (depth = 5)
  int op_slot_right_5254 = gc_frame_newslot(opresult5269);
// Begin line 1963
  setline(1963);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5272 == NULL) {
    strlit5272 = alloc_String("");
    gc_root(strlit5272);
  }
// compiled string node returning strlit5272 (depth = 6)
  int op_slot_right_5271 = gc_frame_newslot(strlit5272);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_upper (depth = 7)
  int op_slot_right_5274 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 7)
  if (strlit5276 == NULL) {
    strlit5276 = alloc_String("upper bound ");
    gc_root(strlit5276);
  }
// compiled string node returning strlit5276 (depth = 7)
  int op_slot_left_5274 = gc_frame_newslot(strlit5276);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5277 = callmethod(strlit5276, "++", 1, partcv, params);
// compiled op node returning opresult5277 (depth = 6)
  int op_slot_left_5271 = gc_frame_newslot(opresult5277);
  params[0] = strlit5272;
  partcv[0] = 1;
  Object opresult5278 = callmethod(opresult5277, "++", 1, partcv, params);
// compiled op node returning opresult5278 (depth = 5)
  int op_slot_left_5254 = gc_frame_newslot(opresult5278);
  params[0] = opresult5269;
  partcv[0] = 1;
  Object opresult5279 = callmethod(opresult5278, "++", 1, partcv, params);
// compiled op node returning opresult5279 (depth = 4)
  gc_frame_newslot(opresult5279);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_RequestError (depth = 4)
  params[0] = opresult5279;
  partcv[0] = 1;
  Object call5280 = callmethod(*var_RequestError, "raise",
    1, partcv, params);
  gc_frame_end(callframe5253);
// compiled call node returning call5280 (depth = 3)
    gc_frame_newslot(call5280);
    if5247 = call5280;
  } else {
  }
stackframe = iftmpstackframe5247;
// compiled if node returning if5247 (depth = 2)
  sourceObject = obj4917;
// Begin line 1966
  setline(1966);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 2)
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_lower (depth = 3)
  int frame5281 = gc_frame_new();
  gc_frame_newslot(*var_lower);
// Begin line 1967
  setline(1967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5282 = alloc_Block(NULL, NULL, "collectionsPrelude", 1967);
  gc_frame_newslot(block5282);
// method "_apply"
  block_savedest(block5282);
  Object closure5283 = createclosure(1, "_apply");
  setclosureframe(closure5283, stackframe);
  addtoclosure(closure5283, selfslot);
  struct UserObject *uo5283 = (struct UserObject*)block5282;
  uo5283->data[0] = (Object)closure5283;
  Method *meth_meth_collectionsPrelude__apply5283 = addmethod2pos(block5282, "_apply", &meth_collectionsPrelude__apply5283, 0);
  int argcv_meth_collectionsPrelude__apply5283[] = {1};
  meth_meth_collectionsPrelude__apply5283->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5283);
meth_meth_collectionsPrelude__apply5283->type->types[0] = type_Number;
meth_meth_collectionsPrelude__apply5283->type->names[0] = "__26";
  meth_meth_collectionsPrelude__apply5283->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5283->definitionLine = 1962;
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5285 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe5286 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit5287 == NULL) {
    strlit5287 = alloc_String("__26");
    gc_root(strlit5287);
  }
// compiled string node returning strlit5287 (depth = 6)
  gc_frame_newslot(strlit5287);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5288 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5289 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5288);
// compiled call node returning call5289 (depth = 7)
// compiled member node returning call5289 (depth = 6)
  params[0] = strlit5287;
  partcv[0] = 1;
  Object call5290 = callmethod(call5289, "new",
    1, partcv, params);
  gc_frame_end(callframe5286);
// compiled call node returning call5290 (depth = 5)
  gc_frame_newslot(call5290);
// Begin line 1967
  setline(1967);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_Number (depth = 5)
  gc_frame_newslot(*var_Number);
// call case 6: other member request
// Begin line 1903
  setline(1903);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5291 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5292 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5291);
// compiled call node returning call5292 (depth = 6)
// compiled member node returning call5292 (depth = 5)
  params[0] = call5290;
  params[1] = *var_Number;
  partcv[0] = 2;
  Object call5293 = callmethod(call5292, "new",
    1, partcv, params);
  gc_frame_end(callframe5285);
// compiled call node returning call5293 (depth = 4)
((struct UserObject *)block5282)->data[1] = call5293;
// compiled block node returning block5282 (depth = 3)
  gc_frame_newslot(block5282);
// Begin line 1968
  setline(1968);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block5294 = alloc_Block(NULL, NULL, "collectionsPrelude", 1968);
  gc_frame_newslot(block5294);
// method "_apply"
  block_savedest(block5294);
  Object closure5295 = createclosure(4, "_apply");
  setclosureframe(closure5295, stackframe);
  addtoclosure(closure5295, var_lower);
  addtoclosure(closure5295, var_upper);
  addtoclosure(closure5295, var_RequestError);
  addtoclosure(closure5295, selfslot);
  struct UserObject *uo5295 = (struct UserObject*)block5294;
  uo5295->data[0] = (Object)closure5295;
  Method *meth_meth_collectionsPrelude__apply5295 = addmethod2pos(block5294, "_apply", &meth_collectionsPrelude__apply5295, 0);
  int argcv_meth_collectionsPrelude__apply5295[] = {1};
  meth_meth_collectionsPrelude__apply5295->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5295);
  meth_meth_collectionsPrelude__apply5295->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5295->definitionLine = 1903;
// compiled block node returning block5294 (depth = 3)
  gc_frame_newslot(block5294);
  params[0] = block5282;
  params[1] = block5294;
  Object matchres5281 = matchCase(*var_lower, params, 2,NULL);
  gc_frame_end(frame5281);
// compiled matchcase node returning matchres5281 (depth = 2)
  sourceObject = obj4917;
// Begin line 1970
  setline(1970);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe5325 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  partcv[0] = 0;
  Object call5326 = callmethod(*var_lower, "truncated",
    1, partcv, params);
  gc_frame_end(callframe5325);
// compiled call node returning call5326 (depth = 3)
// compiled member node returning call5326 (depth = 2)
  adddatum2(obj4917, call5326, 2);
  sourceObject = obj4917;
// Begin line 1971
  setline(1971);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lower (depth = 4)
  int op_slot_right_5328 = gc_frame_newslot(*var_lower);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5330 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5331 = callmethodflags(self, "stop", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5330);
// compiled call node returning call5331 (depth = 5)
// compiled member node returning call5331 (depth = 4)
  int op_slot_left_5328 = gc_frame_newslot(call5331);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5332 = callmethod(call5331, "≠", 1, partcv, params);
// compiled op node returning opresult5332 (depth = 3)
  Object if5327 = done;
struct StackFrameObject *iftmpstackframe5327 = stackframe;
  if (istrue(opresult5332)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5327);
gc_frame_newslot((Object)stackframe);
// Begin line 1972
  setline(1972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5333 = gc_frame_new();
// starting to compile op node (depth = 4)
// Begin line 1973
  setline(1973);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5336 == NULL) {
    strlit5336 = alloc_String(") is not an integer");
    gc_root(strlit5336);
  }
// compiled string node returning strlit5336 (depth = 6)
  int op_slot_right_5335 = gc_frame_newslot(strlit5336);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5338 = gc_frame_newslot(*var_lower);
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit5341 == NULL) {
    strlit5341 = alloc_String(")downTo(");
    gc_root(strlit5341);
  }
// compiled string node returning strlit5341 (depth = 8)
  int op_slot_right_5340 = gc_frame_newslot(strlit5341);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_upper (depth = 9)
  int op_slot_right_5343 = gc_frame_newslot(*var_upper);
// starting to compile string node (depth = 9)
  if (strlit5345 == NULL) {
    strlit5345 = alloc_String(" in range.from(");
    gc_root(strlit5345);
  }
// compiled string node returning strlit5345 (depth = 9)
  int op_slot_left_5343 = gc_frame_newslot(strlit5345);
  params[0] = *var_upper;
  partcv[0] = 1;
  Object opresult5346 = callmethod(strlit5345, "++", 1, partcv, params);
// compiled op node returning opresult5346 (depth = 8)
  int op_slot_left_5340 = gc_frame_newslot(opresult5346);
  params[0] = strlit5341;
  partcv[0] = 1;
  Object opresult5347 = callmethod(opresult5346, "++", 1, partcv, params);
// compiled op node returning opresult5347 (depth = 7)
  int op_slot_left_5338 = gc_frame_newslot(opresult5347);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5348 = callmethod(opresult5347, "++", 1, partcv, params);
// compiled op node returning opresult5348 (depth = 6)
  int op_slot_left_5335 = gc_frame_newslot(opresult5348);
  params[0] = strlit5336;
  partcv[0] = 1;
  Object opresult5349 = callmethod(opresult5348, "++", 1, partcv, params);
// compiled op node returning opresult5349 (depth = 5)
  int op_slot_right_5334 = gc_frame_newslot(opresult5349);
// Begin line 1972
  setline(1972);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5352 == NULL) {
    strlit5352 = alloc_String("");
    gc_root(strlit5352);
  }
// compiled string node returning strlit5352 (depth = 6)
  int op_slot_right_5351 = gc_frame_newslot(strlit5352);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lower (depth = 7)
  int op_slot_right_5354 = gc_frame_newslot(*var_lower);
// starting to compile string node (depth = 7)
  if (strlit5356 == NULL) {
    strlit5356 = alloc_String("lower bound ");
    gc_root(strlit5356);
  }
// compiled string node returning strlit5356 (depth = 7)
  int op_slot_left_5354 = gc_frame_newslot(strlit5356);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object opresult5357 = callmethod(strlit5356, "++", 1, partcv, params);
// compiled op node returning opresult5357 (depth = 6)
  int op_slot_left_5351 = gc_frame_newslot(opresult5357);
  params[0] = strlit5352;
  partcv[0] = 1;
  Object opresult5358 = callmethod(opresult5357, "++", 1, partcv, params);
// compiled op node returning opresult5358 (depth = 5)
  int op_slot_left_5334 = gc_frame_newslot(opresult5358);
  params[0] = opresult5349;
  partcv[0] = 1;
  Object opresult5359 = callmethod(opresult5358, "++", 1, partcv, params);
// compiled op node returning opresult5359 (depth = 4)
  gc_frame_newslot(opresult5359);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_RequestError (depth = 4)
  params[0] = opresult5359;
  partcv[0] = 1;
  Object call5360 = callmethod(*var_RequestError, "raise",
    1, partcv, params);
  gc_frame_end(callframe5333);
// compiled call node returning call5360 (depth = 3)
    gc_frame_newslot(call5360);
    if5327 = call5360;
  } else {
  }
stackframe = iftmpstackframe5327;
// compiled if node returning if5327 (depth = 2)
  sourceObject = obj4917;
// Begin line 1976
  setline(1976);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5363 = alloc_Float64(0);
// compiled num node returning num5363 (depth = 4)
  int op_slot_right_5362 = gc_frame_newslot(num5363);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num5366 = alloc_Float64(1);
// compiled num node returning num5366 (depth = 5)
  int op_slot_right_5365 = gc_frame_newslot(num5366);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lower (depth = 6)
  int op_slot_right_5368 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_upper (depth = 6)
  int op_slot_left_5368 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff5370 = callmethod(*var_upper, "-", 1, partcv, params);
// compiled op node returning diff5370 (depth = 5)
  int op_slot_left_5365 = gc_frame_newslot(diff5370);
  params[0] = num5366;
  partcv[0] = 1;
  Object sum5371 = callmethod(diff5370, "+", 1, partcv, params);
// compiled op node returning sum5371 (depth = 4)
  int op_slot_left_5362 = gc_frame_newslot(sum5371);
  params[0] = num5363;
  partcv[0] = 1;
  Object opresult5372 = callmethod(sum5371, "<", 1, partcv, params);
// compiled op node returning opresult5372 (depth = 3)
  Object if5361 = done;
struct StackFrameObject *iftmpstackframe5361 = stackframe;
  if (istrue(opresult5372)) {
stackframe = alloc_StackFrame(0, iftmpstackframe5361);
gc_frame_newslot((Object)stackframe);
// starting to compile num node (depth = 3)
  Object num5373 = alloc_Float64(0);
// compiled num node returning num5373 (depth = 3)
    gc_frame_newslot(num5373);
    if5361 = num5373;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe5361);
  gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5375 = alloc_Float64(1);
// compiled num node returning num5375 (depth = 4)
  int op_slot_right_5374 = gc_frame_newslot(num5375);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lower (depth = 5)
  int op_slot_right_5377 = gc_frame_newslot(*var_lower);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_upper (depth = 5)
  int op_slot_left_5377 = gc_frame_newslot(*var_upper);
  params[0] = *var_lower;
  partcv[0] = 1;
  Object diff5379 = callmethod(*var_upper, "-", 1, partcv, params);
// compiled op node returning diff5379 (depth = 4)
  int op_slot_left_5374 = gc_frame_newslot(diff5379);
  params[0] = num5375;
  partcv[0] = 1;
  Object sum5380 = callmethod(diff5379, "+", 1, partcv, params);
// compiled op node returning sum5380 (depth = 3)
    gc_frame_newslot(sum5380);
    if5361 = sum5380;
  }
stackframe = iftmpstackframe5361;
// compiled if node returning if5361 (depth = 2)
  adddatum2(obj4917, if5361, 3);
  sourceObject = obj4917;
  sourceObject = obj4917;
  sourceObject = obj4917;
  sourceObject = obj4917;
  sourceObject = obj4917;
  sourceObject = obj4917;
  sourceObject = obj4917;
  sourceObject = obj4917;
  sourceObject = obj4917;
  sourceObject = obj4917;
  sourceObject = obj4917;
  sourceObject = obj4917;
  sourceObject = obj4917;
  sourceObject = obj4917;
  objclass4917 = obj4917->class;
  objclass4917->definitionModule = modulename;
  objclass4917->definitionLine = 1955;
  (*(struct UserObject *)self).data[0] = lowerouter4917;
  self = oldself4917;
  selfslot = oldselfslot4917;
  stackframe = oldstackframe4917;
  gc_frame_end(frame);
  return obj4917;
}
Object meth_collectionsPrelude_range4411(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "range");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Number = getfromclosure(closure, 0);
  Object *var_RequestError = getfromclosure(closure, 1);
  Object *var_IteratorExhausted = getfromclosure(closure, 2);
  Object *var_BoundsError = getfromclosure(closure, 3);
  Object *var__prelude = getfromclosure(closure, 4);
  Object *var_indexable = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for range (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for range");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4412 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4412 = alloc_userobj2(5,6, objclass4412);
  gc_frame_newslot(obj4412);
if (objclass4412 == NULL) {
  glfree(obj4412->class->name);
  obj4412->class->name = "collectionsPrelude.range";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4412, self, 0);
  addmethodreal(obj4412,"outer", &reader_collectionsPrelude_outer_4413);
  Object oldself4412 = self;
  struct StackFrameObject *oldstackframe4412 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4412);
  gc_frame_newslot((Object)stackframe);
  self = obj4412;
  Object *oldselfslot4412 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4412 = (*(struct UserObject *)self).data[0], lowerouter4412 = thisouter4412;
  if (inheritingObject4412) {
    struct UserObject *inho4412 = (struct UserObject *)inheritingObject4412;
    while (inho4412->super != GraceDefaultObject) inho4412 = (struct UserObject *)inho4412->super;
    inho4412->super = obj4412;
    self = inheritingObject4412;
    *selfslot = self;
    lowerouter4412 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4412;
  }
// method "from()to"
  block_savedest(obj4412);
  Object closure4414 = createclosure(2, "from()to");
  setclosureframe(closure4414, stackframe);
  addtoclosure(closure4414, var_Number);
  addtoclosure(closure4414, var_RequestError);
  struct UserObject *uo4414 = (struct UserObject*)obj4412;
  uo4414->data[1] = (Object)closure4414;
  Method *meth_meth_collectionsPrelude_from_40__41_to4414 = addmethod2pos(obj4412, "from()to", &meth_collectionsPrelude_from_40__41_to4414, 1);
  int argcv_meth_collectionsPrelude_from_40__41_to4414[] = {1, 1};
  meth_meth_collectionsPrelude_from_40__41_to4414->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_from_40__41_to4414);
  meth_meth_collectionsPrelude_from_40__41_to4414->definitionModule = modulename;
  meth_meth_collectionsPrelude_from_40__41_to4414->definitionLine = 1841;
// method "uncheckedFrom()to"
  block_savedest(obj4412);
  Object closure4559 = createclosure(4, "uncheckedFrom()to");
  setclosureframe(closure4559, stackframe);
  addtoclosure(closure4559, var_IteratorExhausted);
  addtoclosure(closure4559, var_BoundsError);
  addtoclosure(closure4559, var__prelude);
  addtoclosure(closure4559, var_indexable);
  struct UserObject *uo4559 = (struct UserObject*)obj4412;
  uo4559->data[2] = (Object)closure4559;
  Method *meth_meth_collectionsPrelude_uncheckedFrom_40__41_to4559 = addmethod2pos(obj4412, "uncheckedFrom()to", &meth_collectionsPrelude_uncheckedFrom_40__41_to4559, 2);
  int argcv_meth_collectionsPrelude_uncheckedFrom_40__41_to4559[] = {1, 1};
  meth_meth_collectionsPrelude_uncheckedFrom_40__41_to4559->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_uncheckedFrom_40__41_to4559);
  meth_meth_collectionsPrelude_uncheckedFrom_40__41_to4559->definitionModule = modulename;
  meth_meth_collectionsPrelude_uncheckedFrom_40__41_to4559->definitionLine = 1864;
  block_savedest(obj4412);
  Object closure4915 = createclosure(4, "uncheckedFrom()to()object");
  setclosureframe(closure4915, stackframe);
  addtoclosure(closure4915, var_IteratorExhausted);
  addtoclosure(closure4915, var_BoundsError);
  addtoclosure(closure4915, var__prelude);
  addtoclosure(closure4915, var_indexable);
  Method *meth_meth_collectionsPrelude_uncheckedFrom_40__41_to4559_object = addmethod2pos(obj4412, "uncheckedFrom()to()object", &meth_collectionsPrelude_uncheckedFrom_40__41_to4559_object, 2);
  meth_meth_collectionsPrelude_uncheckedFrom_40__41_to4559_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_uncheckedFrom_40__41_to4559_object->definitionLine = 1864;
// method "from()downTo"
  block_savedest(obj4412);
  Object closure4916 = createclosure(6, "from()downTo");
  setclosureframe(closure4916, stackframe);
  addtoclosure(closure4916, var_IteratorExhausted);
  addtoclosure(closure4916, var_BoundsError);
  addtoclosure(closure4916, var__prelude);
  addtoclosure(closure4916, var_indexable);
  addtoclosure(closure4916, var_Number);
  addtoclosure(closure4916, var_RequestError);
  struct UserObject *uo4916 = (struct UserObject*)obj4412;
  uo4916->data[3] = (Object)closure4916;
  Method *meth_meth_collectionsPrelude_from_40__41_downTo4916 = addmethod2pos(obj4412, "from()downTo", &meth_collectionsPrelude_from_40__41_downTo4916, 3);
  int argcv_meth_collectionsPrelude_from_40__41_downTo4916[] = {1, 1};
  meth_meth_collectionsPrelude_from_40__41_downTo4916->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_from_40__41_downTo4916);
  meth_meth_collectionsPrelude_from_40__41_downTo4916->definitionModule = modulename;
  meth_meth_collectionsPrelude_from_40__41_downTo4916->definitionLine = 1954;
  block_savedest(obj4412);
  Object closure5381 = createclosure(6, "from()downTo()object");
  setclosureframe(closure5381, stackframe);
  addtoclosure(closure5381, var_IteratorExhausted);
  addtoclosure(closure5381, var_BoundsError);
  addtoclosure(closure5381, var__prelude);
  addtoclosure(closure5381, var_indexable);
  addtoclosure(closure5381, var_Number);
  addtoclosure(closure5381, var_RequestError);
  Method *meth_meth_collectionsPrelude_from_40__41_downTo4916_object = addmethod2pos(obj4412, "from()downTo()object", &meth_collectionsPrelude_from_40__41_downTo4916_object, 3);
  meth_meth_collectionsPrelude_from_40__41_downTo4916_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_from_40__41_downTo4916_object->definitionLine = 1954;
  sourceObject = obj4412;
  sourceObject = obj4412;
  sourceObject = obj4412;
  objclass4412 = obj4412->class;
  objclass4412->definitionModule = modulename;
  objclass4412->definitionLine = 1840;
  (*(struct UserObject *)self).data[0] = lowerouter4412;
  self = oldself4412;
  selfslot = oldselfslot4412;
  stackframe = oldstackframe4412;
  gc_frame_end(frame);
  return obj4412;
}
Object meth_collectionsPrelude_range4411_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "range()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_Number = getfromclosure(closure, 0);
  Object *var_RequestError = getfromclosure(closure, 1);
  Object *var_IteratorExhausted = getfromclosure(closure, 2);
  Object *var_BoundsError = getfromclosure(closure, 3);
  Object *var__prelude = getfromclosure(closure, 4);
  Object *var_indexable = getfromclosure(closure, 5);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for range (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for range");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject4412 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj4412 = alloc_userobj2(5,6, objclass4412);
  gc_frame_newslot(obj4412);
if (objclass4412 == NULL) {
  glfree(obj4412->class->name);
  obj4412->class->name = "collectionsPrelude.range";
}
// OBJECT OUTER DEC outer
  adddatum2(obj4412, self, 0);
  addmethodreal(obj4412,"outer", &reader_collectionsPrelude_outer_4413);
  Object oldself4412 = self;
  struct StackFrameObject *oldstackframe4412 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe4412);
  gc_frame_newslot((Object)stackframe);
  self = obj4412;
  Object *oldselfslot4412 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter4412 = (*(struct UserObject *)self).data[0], lowerouter4412 = thisouter4412;
  if (inheritingObject4412) {
    struct UserObject *inho4412 = (struct UserObject *)inheritingObject4412;
    while (inho4412->super != GraceDefaultObject) inho4412 = (struct UserObject *)inho4412->super;
    inho4412->super = obj4412;
    self = inheritingObject4412;
    *selfslot = self;
    lowerouter4412 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter4412;
  }
// method "from()to"
  block_savedest(obj4412);
  Object closure4414 = createclosure(2, "from()to");
  setclosureframe(closure4414, stackframe);
  addtoclosure(closure4414, var_Number);
  addtoclosure(closure4414, var_RequestError);
  struct UserObject *uo4414 = (struct UserObject*)obj4412;
  uo4414->data[1] = (Object)closure4414;
  Method *meth_meth_collectionsPrelude_from_40__41_to4414 = addmethod2pos(obj4412, "from()to", &meth_collectionsPrelude_from_40__41_to4414, 1);
  int argcv_meth_collectionsPrelude_from_40__41_to4414[] = {1, 1};
  meth_meth_collectionsPrelude_from_40__41_to4414->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_from_40__41_to4414);
  meth_meth_collectionsPrelude_from_40__41_to4414->definitionModule = modulename;
  meth_meth_collectionsPrelude_from_40__41_to4414->definitionLine = 1841;
// method "uncheckedFrom()to"
  block_savedest(obj4412);
  Object closure4559 = createclosure(4, "uncheckedFrom()to");
  setclosureframe(closure4559, stackframe);
  addtoclosure(closure4559, var_IteratorExhausted);
  addtoclosure(closure4559, var_BoundsError);
  addtoclosure(closure4559, var__prelude);
  addtoclosure(closure4559, var_indexable);
  struct UserObject *uo4559 = (struct UserObject*)obj4412;
  uo4559->data[2] = (Object)closure4559;
  Method *meth_meth_collectionsPrelude_uncheckedFrom_40__41_to4559 = addmethod2pos(obj4412, "uncheckedFrom()to", &meth_collectionsPrelude_uncheckedFrom_40__41_to4559, 2);
  int argcv_meth_collectionsPrelude_uncheckedFrom_40__41_to4559[] = {1, 1};
  meth_meth_collectionsPrelude_uncheckedFrom_40__41_to4559->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_uncheckedFrom_40__41_to4559);
  meth_meth_collectionsPrelude_uncheckedFrom_40__41_to4559->definitionModule = modulename;
  meth_meth_collectionsPrelude_uncheckedFrom_40__41_to4559->definitionLine = 1864;
  block_savedest(obj4412);
  Object closure4915 = createclosure(4, "uncheckedFrom()to()object");
  setclosureframe(closure4915, stackframe);
  addtoclosure(closure4915, var_IteratorExhausted);
  addtoclosure(closure4915, var_BoundsError);
  addtoclosure(closure4915, var__prelude);
  addtoclosure(closure4915, var_indexable);
  Method *meth_meth_collectionsPrelude_uncheckedFrom_40__41_to4559_object = addmethod2pos(obj4412, "uncheckedFrom()to()object", &meth_collectionsPrelude_uncheckedFrom_40__41_to4559_object, 2);
  meth_meth_collectionsPrelude_uncheckedFrom_40__41_to4559_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_uncheckedFrom_40__41_to4559_object->definitionLine = 1864;
// method "from()downTo"
  block_savedest(obj4412);
  Object closure4916 = createclosure(6, "from()downTo");
  setclosureframe(closure4916, stackframe);
  addtoclosure(closure4916, var_IteratorExhausted);
  addtoclosure(closure4916, var_BoundsError);
  addtoclosure(closure4916, var__prelude);
  addtoclosure(closure4916, var_indexable);
  addtoclosure(closure4916, var_Number);
  addtoclosure(closure4916, var_RequestError);
  struct UserObject *uo4916 = (struct UserObject*)obj4412;
  uo4916->data[3] = (Object)closure4916;
  Method *meth_meth_collectionsPrelude_from_40__41_downTo4916 = addmethod2pos(obj4412, "from()downTo", &meth_collectionsPrelude_from_40__41_downTo4916, 3);
  int argcv_meth_collectionsPrelude_from_40__41_downTo4916[] = {1, 1};
  meth_meth_collectionsPrelude_from_40__41_downTo4916->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_from_40__41_downTo4916);
  meth_meth_collectionsPrelude_from_40__41_downTo4916->definitionModule = modulename;
  meth_meth_collectionsPrelude_from_40__41_downTo4916->definitionLine = 1954;
  block_savedest(obj4412);
  Object closure5381 = createclosure(6, "from()downTo()object");
  setclosureframe(closure5381, stackframe);
  addtoclosure(closure5381, var_IteratorExhausted);
  addtoclosure(closure5381, var_BoundsError);
  addtoclosure(closure5381, var__prelude);
  addtoclosure(closure5381, var_indexable);
  addtoclosure(closure5381, var_Number);
  addtoclosure(closure5381, var_RequestError);
  Method *meth_meth_collectionsPrelude_from_40__41_downTo4916_object = addmethod2pos(obj4412, "from()downTo()object", &meth_collectionsPrelude_from_40__41_downTo4916_object, 3);
  meth_meth_collectionsPrelude_from_40__41_downTo4916_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_from_40__41_downTo4916_object->definitionLine = 1954;
  sourceObject = obj4412;
  sourceObject = obj4412;
  sourceObject = obj4412;
  objclass4412 = obj4412->class;
  objclass4412->definitionModule = modulename;
  objclass4412->definitionLine = 1840;
  (*(struct UserObject *)self).data[0] = lowerouter4412;
  self = oldself4412;
  selfslot = oldselfslot4412;
  stackframe = oldstackframe4412;
  gc_frame_end(frame);
  return obj4412;
}
Object meth_collectionsPrelude_BoundsError5388(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "BoundsError");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for BoundsError (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for BoundsError");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_BoundsError (depth = 3)
  gc_frame_end(frame);
  return *var_BoundsError;
}
Object meth_collectionsPrelude_IteratorExhausted5394(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "IteratorExhausted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for IteratorExhausted (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for IteratorExhausted");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_IteratorExhausted (depth = 3)
  gc_frame_end(frame);
  return *var_IteratorExhausted;
}
Object meth_collectionsPrelude_SubobjectResponsibility5400(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 15, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "SubobjectResponsibility");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SubobjectResponsibility = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for SubobjectResponsibility (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for SubobjectResponsibility");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SubobjectResponsibility (depth = 3)
  gc_frame_end(frame);
  return *var_SubobjectResponsibility;
}
Object meth_collectionsPrelude_NoSuchObject5406(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 16, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "NoSuchObject");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for NoSuchObject (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for NoSuchObject");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_NoSuchObject (depth = 3)
  gc_frame_end(frame);
  return *var_NoSuchObject;
}
Object meth_collectionsPrelude_RequestError5412(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 17, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "RequestError");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_RequestError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for RequestError (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for RequestError");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_RequestError (depth = 3)
  gc_frame_end(frame);
  return *var_RequestError;
}
Object meth_collectionsPrelude_ConcurrentModification5418(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ConcurrentModification");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ConcurrentModification = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ConcurrentModification (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for ConcurrentModification");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ConcurrentModification (depth = 3)
  gc_frame_end(frame);
  return *var_ConcurrentModification;
}
Object meth_collectionsPrelude_SizeUnknown5424(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "SizeUnknown");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for SizeUnknown (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for SizeUnknown");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SizeUnknown (depth = 3)
  gc_frame_end(frame);
  return *var_SizeUnknown;
}
Object meth_collectionsPrelude_Block05427(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 20, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Block0");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Block0 = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for Block0 (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for Block0");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Block0 (depth = 3)
  gc_frame_end(frame);
  return *var_Block0;
}
Object meth_collectionsPrelude_Block15430(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 21, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Block1");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Block1 = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for Block1 (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for Block1");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Block1 (depth = 3)
  gc_frame_end(frame);
  return *var_Block1;
}
Object meth_collectionsPrelude_Block25433(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 22, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Block2");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Block2 = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for Block2 (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for Block2");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Block2 (depth = 3)
  gc_frame_end(frame);
  return *var_Block2;
}
Object meth_collectionsPrelude_SelfType5435(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 23, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "SelfType");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SelfType = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for SelfType (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for SelfType");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_SelfType (depth = 3)
  gc_frame_end(frame);
  return *var_SelfType;
}
Object meth_collectionsPrelude_Iterable5441(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 24, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Iterable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Iterable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for Iterable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for Iterable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Iterable (depth = 3)
  gc_frame_end(frame);
  return *var_Iterable;
}
Object meth_collectionsPrelude_Expandable5447(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 25, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Expandable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Expandable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for Expandable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for Expandable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Expandable (depth = 3)
  gc_frame_end(frame);
  return *var_Expandable;
}
Object meth_collectionsPrelude_Collection5453(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 26, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Collection");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Collection = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for Collection (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for Collection");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Collection (depth = 3)
  gc_frame_end(frame);
  return *var_Collection;
}
Object meth_collectionsPrelude_Enumerable5459(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Enumerable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for Enumerable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for Enumerable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Enumerable (depth = 3)
  gc_frame_end(frame);
  return *var_Enumerable;
}
Object meth_collectionsPrelude_Sequence5465(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Sequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Sequence = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for Sequence (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for Sequence");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Sequence (depth = 3)
  gc_frame_end(frame);
  return *var_Sequence;
}
Object meth_collectionsPrelude_List5471(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 29, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "List");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_List = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for List (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for List");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_List (depth = 3)
  gc_frame_end(frame);
  return *var_List;
}
Object meth_collectionsPrelude_Set5477(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 30, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Set");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Set = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for Set (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for Set");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 116
  setline(116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Set (depth = 3)
  gc_frame_end(frame);
  return *var_Set;
}
Object meth_collectionsPrelude_Dictionary5483(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 31, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Dictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Dictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for Dictionary (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for Dictionary");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Dictionary (depth = 3)
  gc_frame_end(frame);
  return *var_Dictionary;
}
Object meth_collectionsPrelude_Iterator5486(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 32, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Iterator = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for Iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for Iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 161
  setline(161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Iterator (depth = 3)
  gc_frame_end(frame);
  return *var_Iterator;
}
Object meth_collectionsPrelude_asString5492(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5493 == NULL) {
    strlit5493 = alloc_String("a collection TRAIT");
    gc_root(strlit5493);
  }
// compiled string node returning strlit5493 (depth = 3)
  gc_frame_end(frame);
  return strlit5493;
}
Object meth_collectionsPrelude_sizeIfUnknown5494(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sizeIfUnknown");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sizeIfUnknown");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sizeIfUnknown (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for sizeIfUnknown");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 245
  setline(245);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5495 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_action (depth = 5)
  partcv[0] = 0;
  Object call5496 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe5495);
// compiled call node returning call5496 (depth = 4)
// compiled member node returning call5496 (depth = 3)
  gc_frame_end(frame);
  return call5496;
}
Object meth_collectionsPrelude_size5497(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for size (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for size");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 248
  setline(248);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5498 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit5499 == NULL) {
    strlit5499 = alloc_String("this collection does not know its size");
    gc_root(strlit5499);
  }
// compiled string node returning strlit5499 (depth = 4)
  gc_frame_newslot(strlit5499);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_SizeUnknown (depth = 4)
  params[0] = strlit5499;
  partcv[0] = 1;
  Object call5500 = callmethod(*var_SizeUnknown, "raise",
    1, partcv, params);
  gc_frame_end(callframe5498);
// compiled call node returning call5500 (depth = 3)
  gc_frame_end(frame);
  return call5500;
}
Object meth_collectionsPrelude_do5501(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for do");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 250
  setline(250);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5502 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5503 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5504 = gc_frame_new();
// call case 3: self.outer request
  Object call5505 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5504);
// compiled call node returning call5505 (depth = 8)
// compiled member node returning call5505 (depth = 7)
  partcv[0] = 0;
  Object call5506 = callmethodflags(call5505, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5503);
// compiled call node returning call5506 (depth = 6)
// compiled member node returning call5506 (depth = 5)
  partcv[0] = 0;
  Object call5507 = callmethodflags(call5506, "abstract", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5502);
// compiled call node returning call5507 (depth = 4)
// compiled member node returning call5507 (depth = 3)
  gc_frame_end(frame);
  return call5507;
}
Object meth_collectionsPrelude_iterator5508(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 251
  setline(251);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5509 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5510 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5511 = gc_frame_new();
// call case 3: self.outer request
  Object call5512 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5511);
// compiled call node returning call5512 (depth = 8)
// compiled member node returning call5512 (depth = 7)
  partcv[0] = 0;
  Object call5513 = callmethodflags(call5512, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5510);
// compiled call node returning call5513 (depth = 6)
// compiled member node returning call5513 (depth = 5)
  partcv[0] = 0;
  Object call5514 = callmethodflags(call5513, "abstract", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5509);
// compiled call node returning call5514 (depth = 4)
// compiled member node returning call5514 (depth = 3)
  gc_frame_end(frame);
  return call5514;
}
Object meth_collectionsPrelude_isEmpty5515(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isEmpty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isEmpty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5516 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5517 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5518 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5519 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5518);
// compiled call node returning call5519 (depth = 8)
// compiled member node returning call5519 (depth = 7)
  partcv[0] = 0;
  Object call5520 = callmethod(call5519, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe5517);
// compiled call node returning call5520 (depth = 6)
// compiled member node returning call5520 (depth = 5)
  partcv[0] = 0;
  Object call5521 = callmethod(call5520, "not",
    1, partcv, params);
  gc_frame_end(callframe5516);
// compiled call node returning call5521 (depth = 4)
// compiled member node returning call5521 (depth = 3)
  gc_frame_end(frame);
  return call5521;
}
Object meth_collectionsPrelude_first5522(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 7, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "first");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for first (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for first");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_it = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "it");
// Begin line 257
  setline(257);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5523 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5524 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5523);
// compiled call node returning call5524 (depth = 5)
// compiled member node returning call5524 (depth = 4)
  *var_it = call5524;
  if (call5524 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 258
  setline(258);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5526 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_it (depth = 6)
  partcv[0] = 0;
  Object call5527 = callmethod(*var_it, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe5526);
// compiled call node returning call5527 (depth = 5)
// compiled member node returning call5527 (depth = 4)
  Object if5525 = done;
  if (istrue(call5527)) {
// Begin line 259
  setline(259);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5528 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_it (depth = 6)
  partcv[0] = 0;
  Object call5529 = callmethod(*var_it, "next",
    1, partcv, params);
  gc_frame_end(callframe5528);
// compiled call node returning call5529 (depth = 5)
// compiled member node returning call5529 (depth = 4)
    gc_frame_newslot(call5529);
    if5525 = call5529;
  } else {
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe5530 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit5532 == NULL) {
    strlit5532 = alloc_String("");
    gc_root(strlit5532);
  }
// compiled string node returning strlit5532 (depth = 6)
  int op_slot_right_5531 = gc_frame_newslot(strlit5532);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning self (depth = 7)
  int op_slot_right_5534 = gc_frame_newslot(self);
// starting to compile string node (depth = 7)
  if (strlit5536 == NULL) {
    strlit5536 = alloc_String("no first element in ");
    gc_root(strlit5536);
  }
// compiled string node returning strlit5536 (depth = 7)
  int op_slot_left_5534 = gc_frame_newslot(strlit5536);
  params[0] = self;
  partcv[0] = 1;
  Object opresult5537 = callmethod(strlit5536, "++", 1, partcv, params);
// compiled op node returning opresult5537 (depth = 6)
  int op_slot_left_5531 = gc_frame_newslot(opresult5537);
  params[0] = strlit5532;
  partcv[0] = 1;
  Object opresult5538 = callmethod(opresult5537, "++", 1, partcv, params);
// compiled op node returning opresult5538 (depth = 5)
  gc_frame_newslot(opresult5538);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_BoundsError (depth = 5)
  params[0] = opresult5538;
  partcv[0] = 1;
  Object call5539 = callmethod(*var_BoundsError, "raise",
    1, partcv, params);
  gc_frame_end(callframe5530);
// compiled call node returning call5539 (depth = 4)
    gc_frame_newslot(call5539);
    if5525 = call5539;
  }
// compiled if node returning if5525 (depth = 3)
  gc_frame_end(frame);
  return if5525;
}
Object meth_collectionsPrelude__apply5545(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_firstTime = getfromclosure(closure, 0);
  Object *var_block0 = getfromclosure(closure, 1);
  Object *var_block1 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 268
  setline(268);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_firstTime (depth = 6)
  Object if5546 = done;
  if (istrue(*var_firstTime)) {
// Begin line 269
  setline(269);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool5547 = alloc_Boolean(0);
// compiled identifier node returning bool5547 (depth = 7)
  *var_firstTime = bool5547;
  if (bool5547 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
    gc_frame_newslot(done);
    if5546 = done;
  } else {
// Begin line 271
  setline(271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5549 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_block0 (depth = 8)
  partcv[0] = 0;
  Object call5550 = callmethod(*var_block0, "apply",
    1, partcv, params);
  gc_frame_end(callframe5549);
// compiled call node returning call5550 (depth = 7)
// compiled member node returning call5550 (depth = 6)
    gc_frame_newslot(call5550);
    if5546 = call5550;
  }
// compiled if node returning if5546 (depth = 5)
// Begin line 273
  setline(273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5551 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_each (depth = 6)
  gc_frame_newslot(*var_each);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block1 (depth = 6)
  params[0] = *var_each;
  partcv[0] = 1;
  Object call5552 = callmethod(*var_block1, "apply",
    1, partcv, params);
  gc_frame_end(callframe5551);
// compiled call node returning call5552 (depth = 5)
  gc_frame_end(frame);
  return call5552;
}
Object meth_collectionsPrelude_do_40__41_separatedBy5540(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do()separatedBy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do()separatedBy");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do()separatedBy");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for do()separatedBy (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for do");
  Object *var_block0 = &(stackframe->slots[1]);
  *var_block0 = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for separatedBy");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_firstTime = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "firstTime");
  Object *var_i = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "i");
// Begin line 265
  setline(265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool5541 = alloc_Boolean(1);
// compiled identifier node returning bool5541 (depth = 4)
  *var_firstTime = bool5541;
  if (bool5541 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 266
  setline(266);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5542 = alloc_Float64(0);
// compiled num node returning num5542 (depth = 4)
  *var_i = num5542;
  if (num5542 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 267
  setline(267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5543 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5544 = alloc_Block(NULL, NULL, "collectionsPrelude", 267);
  gc_frame_newslot(block5544);
// method "_apply"
  block_savedest(block5544);
  Object closure5545 = createclosure(4, "_apply");
  setclosureframe(closure5545, stackframe);
  addtoclosure(closure5545, var_firstTime);
  addtoclosure(closure5545, var_block0);
  addtoclosure(closure5545, var_block1);
  addtoclosure(closure5545, selfslot);
  struct UserObject *uo5545 = (struct UserObject*)block5544;
  uo5545->data[0] = (Object)closure5545;
  Method *meth_meth_collectionsPrelude__apply5545 = addmethod2pos(block5544, "_apply", &meth_collectionsPrelude__apply5545, 0);
  int argcv_meth_collectionsPrelude__apply5545[] = {1};
  meth_meth_collectionsPrelude__apply5545->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5545);
  meth_meth_collectionsPrelude__apply5545->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5545->definitionLine = 259;
// compiled block node returning block5544 (depth = 4)
  gc_frame_newslot(block5544);
// call case 4: self request
  params[0] = block5544;
  partcv[0] = 1;
  Object call5554 = callmethodflags(self, "do", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5543);
// compiled call node returning call5554 (depth = 3)
// Begin line 275
  setline(275);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  return self;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_reduce5555(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reduce");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method reduce");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for reduce (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_initial = &(stackframe->slots[0]);
  *var_initial = args[curarg];
  curarg++;
  Object *var_blk = &(stackframe->slots[1]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for reduce");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 279
  setline(279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5556 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_blk (depth = 4)
  gc_frame_newslot(*var_blk);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_initial (depth = 4)
  gc_frame_newslot(*var_initial);
// call case 4: self request
  params[0] = *var_blk;
  params[1] = *var_initial;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5557 = callmethodflags(self, "fold()startingWith", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5556);
// compiled call node returning call5557 (depth = 3)
  gc_frame_end(frame);
  return call5557;
}
Object meth_collectionsPrelude__apply5561(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[1];
  Object *var_result = getfromclosure(closure, 0);
  Object *var_blk = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_it = &(stackframe->slots[0]);
  *var_it = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 284
  setline(284);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5562 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_result (depth = 7)
  gc_frame_newslot(*var_result);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_it (depth = 7)
  gc_frame_newslot(*var_it);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_blk (depth = 7)
  params[0] = *var_result;
  params[1] = *var_it;
  partcv[0] = 2;
  Object call5563 = callmethod(*var_blk, "apply",
    1, partcv, params);
  gc_frame_end(callframe5562);
// compiled call node returning call5563 (depth = 6)
  *var_result = call5563;
  if (call5563 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_fold_40__41_startingWith5558(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "fold()startingWith");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method fold()startingWith");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method fold()startingWith");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for fold()startingWith (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_blk = &(stackframe->slots[0]);
  *var_blk = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for fold");
  Object *var_initial = &(stackframe->slots[1]);
  *var_initial = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for startingWith");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "result");
// Begin line 282
  setline(282);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_initial (depth = 4)
  *var_result = *var_initial;
  if (*var_initial == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 283
  setline(283);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5559 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5560 = alloc_Block(NULL, NULL, "collectionsPrelude", 283);
  gc_frame_newslot(block5560);
// method "_apply"
  block_savedest(block5560);
  Object closure5561 = createclosure(3, "_apply");
  setclosureframe(closure5561, stackframe);
  addtoclosure(closure5561, var_result);
  addtoclosure(closure5561, var_blk);
  addtoclosure(closure5561, selfslot);
  struct UserObject *uo5561 = (struct UserObject*)block5560;
  uo5561->data[0] = (Object)closure5561;
  Method *meth_meth_collectionsPrelude__apply5561 = addmethod2pos(block5560, "_apply", &meth_collectionsPrelude__apply5561, 0);
  int argcv_meth_collectionsPrelude__apply5561[] = {1};
  meth_meth_collectionsPrelude__apply5561->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5561);
  meth_meth_collectionsPrelude__apply5561->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5561->definitionLine = 271;
// compiled block node returning block5560 (depth = 4)
  gc_frame_newslot(block5560);
// call case 4: self request
  params[0] = block5560;
  partcv[0] = 1;
  Object call5566 = callmethodflags(self, "do", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5559);
// compiled call node returning call5566 (depth = 3)
// Begin line 286
  setline(286);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  return *var_result;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude_map5567(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "map");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method map");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for map (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for map");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_R = &(stackframe->slots[2]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_R = args[curarg++];
  } else {
    *var_R = Unknown;
  }
// End typeParams
// Begin line 289
  setline(289);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5568 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_block1 (depth = 4)
  gc_frame_newslot(*var_block1);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5569 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5570 = gc_frame_new();
// call case 3: self.outer request
  Object call5571 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5570);
// compiled call node returning call5571 (depth = 7)
// compiled member node returning call5571 (depth = 6)
  partcv[0] = 0;
  Object call5572 = callmethodflags(call5571, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5569);
// compiled call node returning call5572 (depth = 5)
// compiled member node returning call5572 (depth = 4)
  params[0] = self;
  params[1] = *var_block1;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5573 = callmethodflags(call5572, "lazySequenceOver()mappedBy", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5568);
// compiled call node returning call5573 (depth = 3)
  gc_frame_end(frame);
  return call5573;
}
Object meth_collectionsPrelude_filter5574(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "filter");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method filter");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for filter (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_selectionCondition = &(stackframe->slots[0]);
  *var_selectionCondition = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for filter");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 292
  setline(292);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5575 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_selectionCondition (depth = 4)
  gc_frame_newslot(*var_selectionCondition);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5576 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5577 = gc_frame_new();
// call case 3: self.outer request
  Object call5578 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5577);
// compiled call node returning call5578 (depth = 7)
// compiled member node returning call5578 (depth = 6)
  partcv[0] = 0;
  Object call5579 = callmethodflags(call5578, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5576);
// compiled call node returning call5579 (depth = 5)
// compiled member node returning call5579 (depth = 4)
  params[0] = self;
  params[1] = *var_selectionCondition;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5580 = callmethodflags(call5579, "lazySequenceOver()filteredBy", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5575);
// compiled call node returning call5580 (depth = 3)
  gc_frame_end(frame);
  return call5580;
}
Object meth_collectionsPrelude_iter5581(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iter");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iter (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iter");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 295
  setline(295);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5582 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5583 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5582);
// compiled call node returning call5583 (depth = 4)
// compiled member node returning call5583 (depth = 3)
  gc_frame_end(frame);
  return call5583;
}
Object meth_collectionsPrelude_asSequence5584(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asSequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asSequence (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asSequence");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 298
  setline(298);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5585 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5586 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5587 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5588 = gc_frame_new();
// call case 3: self.outer request
  Object call5589 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5588);
// compiled call node returning call5589 (depth = 9)
// compiled member node returning call5589 (depth = 8)
  partcv[0] = 0;
  Object call5590 = callmethodflags(call5589, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5587);
// compiled call node returning call5590 (depth = 7)
// compiled member node returning call5590 (depth = 6)
  partcv[0] = 0;
  Object call5591 = callmethodflags(call5590, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5586);
// compiled call node returning call5591 (depth = 5)
// compiled member node returning call5591 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5592 = callmethod(call5591, "withAll",
    1, partcv, params);
  gc_frame_end(callframe5585);
// compiled call node returning call5592 (depth = 3)
  gc_frame_end(frame);
  return call5592;
}
Object meth_collectionsPrelude_asList5593(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asList");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asList (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asList");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 301
  setline(301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5594 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5595 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5596 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5597 = gc_frame_new();
// call case 3: self.outer request
  Object call5598 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5597);
// compiled call node returning call5598 (depth = 9)
// compiled member node returning call5598 (depth = 8)
  partcv[0] = 0;
  Object call5599 = callmethodflags(call5598, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5596);
// compiled call node returning call5599 (depth = 7)
// compiled member node returning call5599 (depth = 6)
  partcv[0] = 0;
  Object call5600 = callmethodflags(call5599, "list", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5595);
// compiled call node returning call5600 (depth = 5)
// compiled member node returning call5600 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5601 = callmethod(call5600, "withAll",
    1, partcv, params);
  gc_frame_end(callframe5594);
// compiled call node returning call5601 (depth = 3)
  gc_frame_end(frame);
  return call5601;
}
Object meth_collectionsPrelude_asSet5602(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asSet");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asSet (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asSet");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 304
  setline(304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5603 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5604 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5605 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5606 = gc_frame_new();
// call case 3: self.outer request
  Object call5607 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5606);
// compiled call node returning call5607 (depth = 9)
// compiled member node returning call5607 (depth = 8)
  partcv[0] = 0;
  Object call5608 = callmethodflags(call5607, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5605);
// compiled call node returning call5608 (depth = 7)
// compiled member node returning call5608 (depth = 6)
  partcv[0] = 0;
  Object call5609 = callmethodflags(call5608, "set", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5604);
// compiled call node returning call5609 (depth = 5)
// compiled member node returning call5609 (depth = 4)
  params[0] = self;
  partcv[0] = 1;
  Object call5610 = callmethod(call5609, "withAll",
    1, partcv, params);
  gc_frame_end(callframe5603);
// compiled call node returning call5610 (depth = 3)
  gc_frame_end(frame);
  return call5610;
}
Object meth_collectionsPrelude_TRAIT5489(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "TRAIT");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for TRAIT (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for TRAIT");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5490 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5490 = alloc_userobj2(16,17, objclass5490);
  gc_frame_newslot(obj5490);
if (objclass5490 == NULL) {
  glfree(obj5490->class->name);
  obj5490->class->name = "collection.collection.TRAIT";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5490, self, 0);
  addmethodreal(obj5490,"outer", &reader_collectionsPrelude_outer_5491);
  Object oldself5490 = self;
  struct StackFrameObject *oldstackframe5490 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5490);
  gc_frame_newslot((Object)stackframe);
  self = obj5490;
  Object *oldselfslot5490 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5490 = (*(struct UserObject *)self).data[0], lowerouter5490 = thisouter5490;
  if (inheritingObject5490) {
    struct UserObject *inho5490 = (struct UserObject *)inheritingObject5490;
    while (inho5490->super != GraceDefaultObject) inho5490 = (struct UserObject *)inho5490->super;
    inho5490->super = obj5490;
    self = inheritingObject5490;
    *selfslot = self;
    lowerouter5490 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5490;
  }
// method "asString"
  struct UserObject *uo5492 = (struct UserObject*)obj5490;
  uo5492->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5492 = addmethod2pos(obj5490, "asString", &meth_collectionsPrelude_asString5492, 1);
  int argcv_meth_collectionsPrelude_asString5492[] = {0};
  meth_meth_collectionsPrelude_asString5492->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5492);
  meth_meth_collectionsPrelude_asString5492->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5492->definitionLine = 243;
// method "sizeIfUnknown"
  struct UserObject *uo5494 = (struct UserObject*)obj5490;
  uo5494->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sizeIfUnknown5494 = addmethod2pos(obj5490, "sizeIfUnknown", &meth_collectionsPrelude_sizeIfUnknown5494, 2);
  int argcv_meth_collectionsPrelude_sizeIfUnknown5494[] = {1};
  meth_meth_collectionsPrelude_sizeIfUnknown5494->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sizeIfUnknown5494);
  meth_meth_collectionsPrelude_sizeIfUnknown5494->definitionModule = modulename;
  meth_meth_collectionsPrelude_sizeIfUnknown5494->definitionLine = 244;
// method "size"
  block_savedest(obj5490);
  Object closure5497 = createclosure(1, "size");
  setclosureframe(closure5497, stackframe);
  addtoclosure(closure5497, var_SizeUnknown);
  struct UserObject *uo5497 = (struct UserObject*)obj5490;
  uo5497->data[3] = (Object)closure5497;
  Method *meth_meth_collectionsPrelude_size5497 = addmethod2pos(obj5490, "size", &meth_collectionsPrelude_size5497, 3);
  int argcv_meth_collectionsPrelude_size5497[] = {0};
  meth_meth_collectionsPrelude_size5497->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size5497);
  meth_meth_collectionsPrelude_size5497->definitionModule = modulename;
  meth_meth_collectionsPrelude_size5497->definitionLine = 247;
// method "do"
  struct UserObject *uo5501 = (struct UserObject*)obj5490;
  uo5501->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do5501 = addmethod2pos(obj5490, "do", &meth_collectionsPrelude_do5501, 4);
  int argcv_meth_collectionsPrelude_do5501[] = {0};
  meth_meth_collectionsPrelude_do5501->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do5501);
  meth_meth_collectionsPrelude_do5501->definitionModule = modulename;
  meth_meth_collectionsPrelude_do5501->definitionLine = 250;
// method "iterator"
  struct UserObject *uo5508 = (struct UserObject*)obj5490;
  uo5508->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iterator5508 = addmethod2pos(obj5490, "iterator", &meth_collectionsPrelude_iterator5508, 5);
  int argcv_meth_collectionsPrelude_iterator5508[] = {0};
  meth_meth_collectionsPrelude_iterator5508->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator5508);
  meth_meth_collectionsPrelude_iterator5508->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator5508->definitionLine = 251;
// method "isEmpty"
  struct UserObject *uo5515 = (struct UserObject*)obj5490;
  uo5515->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isEmpty5515 = addmethod2pos(obj5490, "isEmpty", &meth_collectionsPrelude_isEmpty5515, 6);
  int argcv_meth_collectionsPrelude_isEmpty5515[] = {0};
  meth_meth_collectionsPrelude_isEmpty5515->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty5515);
  meth_meth_collectionsPrelude_isEmpty5515->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty5515->definitionLine = 252;
// method "first"
  block_savedest(obj5490);
  Object closure5522 = createclosure(1, "first");
  setclosureframe(closure5522, stackframe);
  addtoclosure(closure5522, var_BoundsError);
  struct UserObject *uo5522 = (struct UserObject*)obj5490;
  uo5522->data[7] = (Object)closure5522;
  Method *meth_meth_collectionsPrelude_first5522 = addmethod2pos(obj5490, "first", &meth_collectionsPrelude_first5522, 7);
  int argcv_meth_collectionsPrelude_first5522[] = {0};
  meth_meth_collectionsPrelude_first5522->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_first5522);
  meth_meth_collectionsPrelude_first5522->definitionModule = modulename;
  meth_meth_collectionsPrelude_first5522->definitionLine = 256;
// method "do()separatedBy"
  struct UserObject *uo5540 = (struct UserObject*)obj5490;
  uo5540->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40__41_separatedBy5540 = addmethod2pos(obj5490, "do()separatedBy", &meth_collectionsPrelude_do_40__41_separatedBy5540, 8);
  int argcv_meth_collectionsPrelude_do_40__41_separatedBy5540[] = {1, 1};
  meth_meth_collectionsPrelude_do_40__41_separatedBy5540->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_do_40__41_separatedBy5540);
  meth_meth_collectionsPrelude_do_40__41_separatedBy5540->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40__41_separatedBy5540->definitionLine = 264;
// method "reduce"
  struct UserObject *uo5555 = (struct UserObject*)obj5490;
  uo5555->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reduce5555 = addmethod2pos(obj5490, "reduce", &meth_collectionsPrelude_reduce5555, 9);
  int argcv_meth_collectionsPrelude_reduce5555[] = {2};
  meth_meth_collectionsPrelude_reduce5555->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reduce5555);
  meth_meth_collectionsPrelude_reduce5555->definitionModule = modulename;
  meth_meth_collectionsPrelude_reduce5555->definitionLine = 277;
// method "fold()startingWith"
  struct UserObject *uo5558 = (struct UserObject*)obj5490;
  uo5558->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fold_40__41_startingWith5558 = addmethod2pos(obj5490, "fold()startingWith", &meth_collectionsPrelude_fold_40__41_startingWith5558, 10);
  int argcv_meth_collectionsPrelude_fold_40__41_startingWith5558[] = {1, 1};
  meth_meth_collectionsPrelude_fold_40__41_startingWith5558->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_fold_40__41_startingWith5558);
  meth_meth_collectionsPrelude_fold_40__41_startingWith5558->definitionModule = modulename;
  meth_meth_collectionsPrelude_fold_40__41_startingWith5558->definitionLine = 281;
// method "map"
  struct UserObject *uo5567 = (struct UserObject*)obj5490;
  uo5567->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_map5567 = addmethod2pos(obj5490, "map", &meth_collectionsPrelude_map5567, 11);
  int argcv_meth_collectionsPrelude_map5567[] = {1};
  meth_meth_collectionsPrelude_map5567->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_map5567);
  meth_meth_collectionsPrelude_map5567->definitionModule = modulename;
  meth_meth_collectionsPrelude_map5567->definitionLine = 288;
// method "filter"
  struct UserObject *uo5574 = (struct UserObject*)obj5490;
  uo5574->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_filter5574 = addmethod2pos(obj5490, "filter", &meth_collectionsPrelude_filter5574, 12);
  int argcv_meth_collectionsPrelude_filter5574[] = {1};
  meth_meth_collectionsPrelude_filter5574->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_filter5574);
  meth_meth_collectionsPrelude_filter5574->definitionModule = modulename;
  meth_meth_collectionsPrelude_filter5574->definitionLine = 291;
// method "iter"
  struct UserObject *uo5581 = (struct UserObject*)obj5490;
  uo5581->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iter5581 = addmethod2pos(obj5490, "iter", &meth_collectionsPrelude_iter5581, 13);
  int argcv_meth_collectionsPrelude_iter5581[] = {0};
  meth_meth_collectionsPrelude_iter5581->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iter5581);
  meth_meth_collectionsPrelude_iter5581->definitionModule = modulename;
  meth_meth_collectionsPrelude_iter5581->definitionLine = 295;
// method "asSequence"
  struct UserObject *uo5584 = (struct UserObject*)obj5490;
  uo5584->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSequence5584 = addmethod2pos(obj5490, "asSequence", &meth_collectionsPrelude_asSequence5584, 14);
  int argcv_meth_collectionsPrelude_asSequence5584[] = {0};
  meth_meth_collectionsPrelude_asSequence5584->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSequence5584);
  meth_meth_collectionsPrelude_asSequence5584->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSequence5584->definitionLine = 297;
// method "asList"
  struct UserObject *uo5593 = (struct UserObject*)obj5490;
  uo5593->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asList5593 = addmethod2pos(obj5490, "asList", &meth_collectionsPrelude_asList5593, 15);
  int argcv_meth_collectionsPrelude_asList5593[] = {0};
  meth_meth_collectionsPrelude_asList5593->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asList5593);
  meth_meth_collectionsPrelude_asList5593->definitionModule = modulename;
  meth_meth_collectionsPrelude_asList5593->definitionLine = 300;
// method "asSet"
  struct UserObject *uo5602 = (struct UserObject*)obj5490;
  uo5602->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSet5602 = addmethod2pos(obj5490, "asSet", &meth_collectionsPrelude_asSet5602, 16);
  int argcv_meth_collectionsPrelude_asSet5602[] = {0};
  meth_meth_collectionsPrelude_asSet5602->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSet5602);
  meth_meth_collectionsPrelude_asSet5602->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSet5602->definitionLine = 303;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  objclass5490 = obj5490->class;
  objclass5490->definitionModule = modulename;
  objclass5490->definitionLine = 241;
  (*(struct UserObject *)self).data[0] = lowerouter5490;
  self = oldself5490;
  selfslot = oldselfslot5490;
  stackframe = oldstackframe5490;
  gc_frame_end(frame);
  return obj5490;
}
Object meth_collectionsPrelude_TRAIT5489_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "TRAIT()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  Object *var_BoundsError = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for TRAIT (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for TRAIT");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5490 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5490 = alloc_userobj2(16,17, objclass5490);
  gc_frame_newslot(obj5490);
if (objclass5490 == NULL) {
  glfree(obj5490->class->name);
  obj5490->class->name = "collection.collection.TRAIT";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5490, self, 0);
  addmethodreal(obj5490,"outer", &reader_collectionsPrelude_outer_5491);
  Object oldself5490 = self;
  struct StackFrameObject *oldstackframe5490 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5490);
  gc_frame_newslot((Object)stackframe);
  self = obj5490;
  Object *oldselfslot5490 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5490 = (*(struct UserObject *)self).data[0], lowerouter5490 = thisouter5490;
  if (inheritingObject5490) {
    struct UserObject *inho5490 = (struct UserObject *)inheritingObject5490;
    while (inho5490->super != GraceDefaultObject) inho5490 = (struct UserObject *)inho5490->super;
    inho5490->super = obj5490;
    self = inheritingObject5490;
    *selfslot = self;
    lowerouter5490 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5490;
  }
// method "asString"
  struct UserObject *uo5492 = (struct UserObject*)obj5490;
  uo5492->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5492 = addmethod2pos(obj5490, "asString", &meth_collectionsPrelude_asString5492, 1);
  int argcv_meth_collectionsPrelude_asString5492[] = {0};
  meth_meth_collectionsPrelude_asString5492->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5492);
  meth_meth_collectionsPrelude_asString5492->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5492->definitionLine = 243;
// method "sizeIfUnknown"
  struct UserObject *uo5494 = (struct UserObject*)obj5490;
  uo5494->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sizeIfUnknown5494 = addmethod2pos(obj5490, "sizeIfUnknown", &meth_collectionsPrelude_sizeIfUnknown5494, 2);
  int argcv_meth_collectionsPrelude_sizeIfUnknown5494[] = {1};
  meth_meth_collectionsPrelude_sizeIfUnknown5494->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sizeIfUnknown5494);
  meth_meth_collectionsPrelude_sizeIfUnknown5494->definitionModule = modulename;
  meth_meth_collectionsPrelude_sizeIfUnknown5494->definitionLine = 244;
// method "size"
  block_savedest(obj5490);
  Object closure5497 = createclosure(1, "size");
  setclosureframe(closure5497, stackframe);
  addtoclosure(closure5497, var_SizeUnknown);
  struct UserObject *uo5497 = (struct UserObject*)obj5490;
  uo5497->data[3] = (Object)closure5497;
  Method *meth_meth_collectionsPrelude_size5497 = addmethod2pos(obj5490, "size", &meth_collectionsPrelude_size5497, 3);
  int argcv_meth_collectionsPrelude_size5497[] = {0};
  meth_meth_collectionsPrelude_size5497->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size5497);
  meth_meth_collectionsPrelude_size5497->definitionModule = modulename;
  meth_meth_collectionsPrelude_size5497->definitionLine = 247;
// method "do"
  struct UserObject *uo5501 = (struct UserObject*)obj5490;
  uo5501->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do5501 = addmethod2pos(obj5490, "do", &meth_collectionsPrelude_do5501, 4);
  int argcv_meth_collectionsPrelude_do5501[] = {0};
  meth_meth_collectionsPrelude_do5501->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do5501);
  meth_meth_collectionsPrelude_do5501->definitionModule = modulename;
  meth_meth_collectionsPrelude_do5501->definitionLine = 250;
// method "iterator"
  struct UserObject *uo5508 = (struct UserObject*)obj5490;
  uo5508->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iterator5508 = addmethod2pos(obj5490, "iterator", &meth_collectionsPrelude_iterator5508, 5);
  int argcv_meth_collectionsPrelude_iterator5508[] = {0};
  meth_meth_collectionsPrelude_iterator5508->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator5508);
  meth_meth_collectionsPrelude_iterator5508->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator5508->definitionLine = 251;
// method "isEmpty"
  struct UserObject *uo5515 = (struct UserObject*)obj5490;
  uo5515->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isEmpty5515 = addmethod2pos(obj5490, "isEmpty", &meth_collectionsPrelude_isEmpty5515, 6);
  int argcv_meth_collectionsPrelude_isEmpty5515[] = {0};
  meth_meth_collectionsPrelude_isEmpty5515->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty5515);
  meth_meth_collectionsPrelude_isEmpty5515->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty5515->definitionLine = 252;
// method "first"
  block_savedest(obj5490);
  Object closure5522 = createclosure(1, "first");
  setclosureframe(closure5522, stackframe);
  addtoclosure(closure5522, var_BoundsError);
  struct UserObject *uo5522 = (struct UserObject*)obj5490;
  uo5522->data[7] = (Object)closure5522;
  Method *meth_meth_collectionsPrelude_first5522 = addmethod2pos(obj5490, "first", &meth_collectionsPrelude_first5522, 7);
  int argcv_meth_collectionsPrelude_first5522[] = {0};
  meth_meth_collectionsPrelude_first5522->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_first5522);
  meth_meth_collectionsPrelude_first5522->definitionModule = modulename;
  meth_meth_collectionsPrelude_first5522->definitionLine = 256;
// method "do()separatedBy"
  struct UserObject *uo5540 = (struct UserObject*)obj5490;
  uo5540->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do_40__41_separatedBy5540 = addmethod2pos(obj5490, "do()separatedBy", &meth_collectionsPrelude_do_40__41_separatedBy5540, 8);
  int argcv_meth_collectionsPrelude_do_40__41_separatedBy5540[] = {1, 1};
  meth_meth_collectionsPrelude_do_40__41_separatedBy5540->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_do_40__41_separatedBy5540);
  meth_meth_collectionsPrelude_do_40__41_separatedBy5540->definitionModule = modulename;
  meth_meth_collectionsPrelude_do_40__41_separatedBy5540->definitionLine = 264;
// method "reduce"
  struct UserObject *uo5555 = (struct UserObject*)obj5490;
  uo5555->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reduce5555 = addmethod2pos(obj5490, "reduce", &meth_collectionsPrelude_reduce5555, 9);
  int argcv_meth_collectionsPrelude_reduce5555[] = {2};
  meth_meth_collectionsPrelude_reduce5555->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reduce5555);
  meth_meth_collectionsPrelude_reduce5555->definitionModule = modulename;
  meth_meth_collectionsPrelude_reduce5555->definitionLine = 277;
// method "fold()startingWith"
  struct UserObject *uo5558 = (struct UserObject*)obj5490;
  uo5558->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fold_40__41_startingWith5558 = addmethod2pos(obj5490, "fold()startingWith", &meth_collectionsPrelude_fold_40__41_startingWith5558, 10);
  int argcv_meth_collectionsPrelude_fold_40__41_startingWith5558[] = {1, 1};
  meth_meth_collectionsPrelude_fold_40__41_startingWith5558->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_fold_40__41_startingWith5558);
  meth_meth_collectionsPrelude_fold_40__41_startingWith5558->definitionModule = modulename;
  meth_meth_collectionsPrelude_fold_40__41_startingWith5558->definitionLine = 281;
// method "map"
  struct UserObject *uo5567 = (struct UserObject*)obj5490;
  uo5567->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_map5567 = addmethod2pos(obj5490, "map", &meth_collectionsPrelude_map5567, 11);
  int argcv_meth_collectionsPrelude_map5567[] = {1};
  meth_meth_collectionsPrelude_map5567->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_map5567);
  meth_meth_collectionsPrelude_map5567->definitionModule = modulename;
  meth_meth_collectionsPrelude_map5567->definitionLine = 288;
// method "filter"
  struct UserObject *uo5574 = (struct UserObject*)obj5490;
  uo5574->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_filter5574 = addmethod2pos(obj5490, "filter", &meth_collectionsPrelude_filter5574, 12);
  int argcv_meth_collectionsPrelude_filter5574[] = {1};
  meth_meth_collectionsPrelude_filter5574->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_filter5574);
  meth_meth_collectionsPrelude_filter5574->definitionModule = modulename;
  meth_meth_collectionsPrelude_filter5574->definitionLine = 291;
// method "iter"
  struct UserObject *uo5581 = (struct UserObject*)obj5490;
  uo5581->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iter5581 = addmethod2pos(obj5490, "iter", &meth_collectionsPrelude_iter5581, 13);
  int argcv_meth_collectionsPrelude_iter5581[] = {0};
  meth_meth_collectionsPrelude_iter5581->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iter5581);
  meth_meth_collectionsPrelude_iter5581->definitionModule = modulename;
  meth_meth_collectionsPrelude_iter5581->definitionLine = 295;
// method "asSequence"
  struct UserObject *uo5584 = (struct UserObject*)obj5490;
  uo5584->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSequence5584 = addmethod2pos(obj5490, "asSequence", &meth_collectionsPrelude_asSequence5584, 14);
  int argcv_meth_collectionsPrelude_asSequence5584[] = {0};
  meth_meth_collectionsPrelude_asSequence5584->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSequence5584);
  meth_meth_collectionsPrelude_asSequence5584->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSequence5584->definitionLine = 297;
// method "asList"
  struct UserObject *uo5593 = (struct UserObject*)obj5490;
  uo5593->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asList5593 = addmethod2pos(obj5490, "asList", &meth_collectionsPrelude_asList5593, 15);
  int argcv_meth_collectionsPrelude_asList5593[] = {0};
  meth_meth_collectionsPrelude_asList5593->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asList5593);
  meth_meth_collectionsPrelude_asList5593->definitionModule = modulename;
  meth_meth_collectionsPrelude_asList5593->definitionLine = 300;
// method "asSet"
  struct UserObject *uo5602 = (struct UserObject*)obj5490;
  uo5602->data[16] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asSet5602 = addmethod2pos(obj5490, "asSet", &meth_collectionsPrelude_asSet5602, 16);
  int argcv_meth_collectionsPrelude_asSet5602[] = {0};
  meth_meth_collectionsPrelude_asSet5602->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asSet5602);
  meth_meth_collectionsPrelude_asSet5602->definitionModule = modulename;
  meth_meth_collectionsPrelude_asSet5602->definitionLine = 303;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  sourceObject = obj5490;
  objclass5490 = obj5490->class;
  objclass5490->definitionModule = modulename;
  objclass5490->definitionLine = 241;
  (*(struct UserObject *)self).data[0] = lowerouter5490;
  self = oldself5490;
  selfslot = oldselfslot5490;
  stackframe = oldstackframe5490;
  gc_frame_end(frame);
  return obj5490;
}
Object meth_collectionsPrelude_asString5612(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 0 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 0.", nparts);
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5613 == NULL) {
    strlit5613 = alloc_String("class collection");
    gc_root(strlit5613);
  }
// compiled string node returning strlit5613 (depth = 3)
  gc_frame_end(frame);
  return strlit5613;
}
Object meth_collectionsPrelude_collection5614(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 33, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "collection");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_collection = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for collection (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for collection");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_collection (depth = 3)
  gc_frame_end(frame);
  return *var_collection;
}
Object meth_collectionsPrelude_iterator5620(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 310
  setline(310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5621 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5622 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5623 = gc_frame_new();
// call case 3: self.outer request
  Object call5624 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5623);
// compiled call node returning call5624 (depth = 8)
// compiled member node returning call5624 (depth = 7)
  partcv[0] = 0;
  Object call5625 = callmethodflags(call5624, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5622);
// compiled call node returning call5625 (depth = 6)
// compiled member node returning call5625 (depth = 5)
  partcv[0] = 0;
  Object call5626 = callmethodflags(call5625, "abstract", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5621);
// compiled call node returning call5626 (depth = 4)
// compiled member node returning call5626 (depth = 3)
  gc_frame_end(frame);
  return call5626;
}
Object meth_collectionsPrelude_size5627(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for size (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for size");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5628 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5630 == NULL) {
    strlit5630 = alloc_String("");
    gc_root(strlit5630);
  }
// compiled string node returning strlit5630 (depth = 5)
  int op_slot_right_5629 = gc_frame_newslot(strlit5630);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5633 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5634 = callmethodflags(self, "asDebugString", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5633);
// compiled call node returning call5634 (depth = 7)
// compiled member node returning call5634 (depth = 6)
  int op_slot_right_5632 = gc_frame_newslot(call5634);
// starting to compile string node (depth = 6)
  if (strlit5636 == NULL) {
    strlit5636 = alloc_String("size requested on ");
    gc_root(strlit5636);
  }
// compiled string node returning strlit5636 (depth = 6)
  int op_slot_left_5632 = gc_frame_newslot(strlit5636);
  params[0] = call5634;
  partcv[0] = 1;
  Object opresult5637 = callmethod(strlit5636, "++", 1, partcv, params);
// compiled op node returning opresult5637 (depth = 5)
  int op_slot_left_5629 = gc_frame_newslot(opresult5637);
  params[0] = strlit5630;
  partcv[0] = 1;
  Object opresult5638 = callmethod(opresult5637, "++", 1, partcv, params);
// compiled op node returning opresult5638 (depth = 4)
  gc_frame_newslot(opresult5638);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_SizeUnknown (depth = 4)
  params[0] = opresult5638;
  partcv[0] = 1;
  Object call5639 = callmethod(*var_SizeUnknown, "raise",
    1, partcv, params);
  gc_frame_end(callframe5628);
// compiled call node returning call5639 (depth = 3)
  gc_frame_end(frame);
  return call5639;
}
Object meth_collectionsPrelude__apply5651(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 318
  setline(318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5652 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_result (depth = 6)
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5653 = callmethod(*var_result, "at()put",
    2, partcv, params);
  gc_frame_end(callframe5652);
// compiled call node returning call5653 (depth = 5)
  gc_frame_end(frame);
  return call5653;
}
Object meth_collectionsPrelude_asDictionary5640(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asDictionary (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asDictionary");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 316
  setline(316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5641 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5642 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5643 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5644 = gc_frame_new();
// call case 3: self.outer request
  Object call5645 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5644);
// compiled call node returning call5645 (depth = 11)
// compiled member node returning call5645 (depth = 10)
  partcv[0] = 0;
  Object call5646 = callmethodflags(call5645, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5643);
// compiled call node returning call5646 (depth = 9)
// compiled member node returning call5646 (depth = 8)
  partcv[0] = 0;
  Object call5647 = callmethodflags(call5646, "dictionary", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5642);
// compiled call node returning call5647 (depth = 7)
// compiled member node returning call5647 (depth = 6)
  partcv[0] = 0;
  Object call5648 = callmethod(call5647, "empty",
    1, partcv, params);
  gc_frame_end(callframe5641);
// compiled call node returning call5648 (depth = 5)
// compiled member node returning call5648 (depth = 4)
  *var_result = call5648;
  if (call5648 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 317
  setline(317);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5649 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5650 = alloc_Block(NULL, NULL, "collectionsPrelude", 317);
  gc_frame_newslot(block5650);
// method "_apply"
  block_savedest(block5650);
  Object closure5651 = createclosure(2, "_apply");
  setclosureframe(closure5651, stackframe);
  addtoclosure(closure5651, var_result);
  addtoclosure(closure5651, selfslot);
  struct UserObject *uo5651 = (struct UserObject*)block5650;
  uo5651->data[0] = (Object)closure5651;
  Method *meth_meth_collectionsPrelude__apply5651 = addmethod2pos(block5650, "_apply", &meth_collectionsPrelude__apply5651, 0);
  int argcv_meth_collectionsPrelude__apply5651[] = {2};
  meth_meth_collectionsPrelude__apply5651->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5651);
  meth_meth_collectionsPrelude__apply5651->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5651->definitionLine = 316;
// compiled block node returning block5650 (depth = 4)
  gc_frame_newslot(block5650);
// call case 4: self request
  params[0] = block5650;
  partcv[0] = 1;
  Object call5655 = callmethodflags(self, "keysAndValuesDo", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5649);
// compiled call node returning call5655 (depth = 3)
// Begin line 320
  setline(320);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  return *var_result;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply5661(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5662 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_selfIterator (depth = 7)
  partcv[0] = 0;
  Object call5663 = callmethod(*var_selfIterator, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe5662);
// compiled call node returning call5663 (depth = 6)
// compiled member node returning call5663 (depth = 5)
  gc_frame_end(frame);
  return call5663;
}
Object meth_collectionsPrelude__apply5666(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object *var_existing = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 325
  setline(325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5667 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5668 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_selfIterator (depth = 8)
  partcv[0] = 0;
  Object call5669 = callmethod(*var_selfIterator, "next",
    1, partcv, params);
  gc_frame_end(callframe5668);
// compiled call node returning call5669 (depth = 7)
// compiled member node returning call5669 (depth = 6)
  gc_frame_newslot(call5669);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_existing (depth = 6)
  params[0] = call5669;
  partcv[0] = 1;
  Object call5670 = callmethod(*var_existing, "add",
    1, partcv, params);
  gc_frame_end(callframe5667);
// compiled call node returning call5670 (depth = 5)
  gc_frame_end(frame);
  return call5670;
}
Object meth_collectionsPrelude_into5656(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "into");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method into");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for into (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_existing = &(stackframe->slots[0]);
  *var_existing = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for into");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_selfIterator = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "selfIterator");
// Begin line 323
  setline(323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5657 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5658 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5657);
// compiled call node returning call5658 (depth = 5)
// compiled member node returning call5658 (depth = 4)
  *var_selfIterator = call5658;
  if (call5658 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 324
  setline(324);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5659 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5660 = alloc_Block(NULL, NULL, "collectionsPrelude", 324);
  gc_frame_newslot(block5660);
// method "_apply"
  block_savedest(block5660);
  Object closure5661 = createclosure(2, "_apply");
  setclosureframe(closure5661, stackframe);
  addtoclosure(closure5661, var_selfIterator);
  addtoclosure(closure5661, selfslot);
  struct UserObject *uo5661 = (struct UserObject*)block5660;
  uo5661->data[0] = (Object)closure5661;
  Method *meth_meth_collectionsPrelude__apply5661 = addmethod2pos(block5660, "_apply", &meth_collectionsPrelude__apply5661, 0);
  int argcv_meth_collectionsPrelude__apply5661[] = {0};
  meth_meth_collectionsPrelude__apply5661->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5661);
  meth_meth_collectionsPrelude__apply5661->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5661->definitionLine = 323;
// compiled block node returning block5660 (depth = 4)
  gc_frame_newslot(block5660);
// starting to compile block node (depth = 4)
  Object block5665 = alloc_Block(NULL, NULL, "collectionsPrelude", 324);
  gc_frame_newslot(block5665);
// method "_apply"
  block_savedest(block5665);
  Object closure5666 = createclosure(3, "_apply");
  setclosureframe(closure5666, stackframe);
  addtoclosure(closure5666, var_selfIterator);
  addtoclosure(closure5666, var_existing);
  addtoclosure(closure5666, selfslot);
  struct UserObject *uo5666 = (struct UserObject*)block5665;
  uo5666->data[0] = (Object)closure5666;
  Method *meth_meth_collectionsPrelude__apply5666 = addmethod2pos(block5665, "_apply", &meth_collectionsPrelude__apply5666, 0);
  int argcv_meth_collectionsPrelude__apply5666[] = {0};
  meth_meth_collectionsPrelude__apply5666->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5666);
  meth_meth_collectionsPrelude__apply5666->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5666->definitionLine = 324;
// compiled block node returning block5665 (depth = 4)
  gc_frame_newslot(block5665);
// call case 5: prelude request
  params[0] = block5660;
  params[1] = block5665;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5672 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5659);
// compiled call node returning call5672 (depth = 3)
// Begin line 327
  setline(327);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_existing (depth = 3)
  gc_frame_end(frame);
  return *var_existing;
}
Object meth_collectionsPrelude__61__61_5673(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 330
  setline(330);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5674 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5675 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5676 = gc_frame_new();
// call case 3: self.outer request
  Object call5677 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5676);
// compiled call node returning call5677 (depth = 7)
// compiled member node returning call5677 (depth = 6)
  partcv[0] = 0;
  Object call5678 = callmethodflags(call5677, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5675);
// compiled call node returning call5678 (depth = 5)
// compiled member node returning call5678 (depth = 4)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5679 = callmethodflags(call5678, "isEqual()toIterable", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5674);
// compiled call node returning call5679 (depth = 3)
  gc_frame_end(frame);
  return call5679;
}
Object meth_collectionsPrelude__apply5685(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5686 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_selfIterator (depth = 7)
  partcv[0] = 0;
  Object call5687 = callmethod(*var_selfIterator, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe5686);
// compiled call node returning call5687 (depth = 6)
// compiled member node returning call5687 (depth = 5)
  gc_frame_end(frame);
  return call5687;
}
Object meth_collectionsPrelude__apply5690(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object *var_block1 = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 335
  setline(335);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5691 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5692 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_selfIterator (depth = 8)
  partcv[0] = 0;
  Object call5693 = callmethod(*var_selfIterator, "next",
    1, partcv, params);
  gc_frame_end(callframe5692);
// compiled call node returning call5693 (depth = 7)
// compiled member node returning call5693 (depth = 6)
  gc_frame_newslot(call5693);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block1 (depth = 6)
  params[0] = call5693;
  partcv[0] = 1;
  Object call5694 = callmethod(*var_block1, "apply",
    1, partcv, params);
  gc_frame_end(callframe5691);
// compiled call node returning call5694 (depth = 5)
  gc_frame_end(frame);
  return call5694;
}
Object meth_collectionsPrelude_do5680(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "do");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for do");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_selfIterator = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "selfIterator");
// Begin line 333
  setline(333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5681 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5682 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5681);
// compiled call node returning call5682 (depth = 5)
// compiled member node returning call5682 (depth = 4)
  *var_selfIterator = call5682;
  if (call5682 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5683 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5684 = alloc_Block(NULL, NULL, "collectionsPrelude", 334);
  gc_frame_newslot(block5684);
// method "_apply"
  block_savedest(block5684);
  Object closure5685 = createclosure(2, "_apply");
  setclosureframe(closure5685, stackframe);
  addtoclosure(closure5685, var_selfIterator);
  addtoclosure(closure5685, selfslot);
  struct UserObject *uo5685 = (struct UserObject*)block5684;
  uo5685->data[0] = (Object)closure5685;
  Method *meth_meth_collectionsPrelude__apply5685 = addmethod2pos(block5684, "_apply", &meth_collectionsPrelude__apply5685, 0);
  int argcv_meth_collectionsPrelude__apply5685[] = {0};
  meth_meth_collectionsPrelude__apply5685->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5685);
  meth_meth_collectionsPrelude__apply5685->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5685->definitionLine = 333;
// compiled block node returning block5684 (depth = 4)
  gc_frame_newslot(block5684);
// starting to compile block node (depth = 4)
  Object block5689 = alloc_Block(NULL, NULL, "collectionsPrelude", 334);
  gc_frame_newslot(block5689);
// method "_apply"
  block_savedest(block5689);
  Object closure5690 = createclosure(3, "_apply");
  setclosureframe(closure5690, stackframe);
  addtoclosure(closure5690, var_selfIterator);
  addtoclosure(closure5690, var_block1);
  addtoclosure(closure5690, selfslot);
  struct UserObject *uo5690 = (struct UserObject*)block5689;
  uo5690->data[0] = (Object)closure5690;
  Method *meth_meth_collectionsPrelude__apply5690 = addmethod2pos(block5689, "_apply", &meth_collectionsPrelude__apply5690, 0);
  int argcv_meth_collectionsPrelude__apply5690[] = {0};
  meth_meth_collectionsPrelude__apply5690->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5690);
  meth_meth_collectionsPrelude__apply5690->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5690->definitionLine = 334;
// compiled block node returning block5689 (depth = 4)
  gc_frame_newslot(block5689);
// call case 5: prelude request
  params[0] = block5684;
  params[1] = block5689;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5696 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5683);
// compiled call node returning call5696 (depth = 3)
  gc_frame_end(frame);
  return call5696;
}
Object meth_collectionsPrelude__apply5703(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5704 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_selfIterator (depth = 7)
  partcv[0] = 0;
  Object call5705 = callmethod(*var_selfIterator, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe5704);
// compiled call node returning call5705 (depth = 6)
// compiled member node returning call5705 (depth = 5)
  gc_frame_end(frame);
  return call5705;
}
Object meth_collectionsPrelude__apply5708(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_ix = getfromclosure(closure, 0);
  Object *var_selfIterator = getfromclosure(closure, 1);
  Object *var_block2 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num5710 = alloc_Float64(1);
// compiled num node returning num5710 (depth = 7)
  int op_slot_right_5709 = gc_frame_newslot(num5710);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  int op_slot_left_5709 = gc_frame_newslot(*var_ix);
  params[0] = num5710;
  partcv[0] = 1;
  Object sum5712 = callmethod(*var_ix, "+", 1, partcv, params);
// compiled op node returning sum5712 (depth = 6)
  *var_ix = sum5712;
  if (sum5712 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5714 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_ix (depth = 6)
  gc_frame_newslot(*var_ix);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5715 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_selfIterator (depth = 8)
  partcv[0] = 0;
  Object call5716 = callmethod(*var_selfIterator, "next",
    1, partcv, params);
  gc_frame_end(callframe5715);
// compiled call node returning call5716 (depth = 7)
// compiled member node returning call5716 (depth = 6)
  gc_frame_newslot(call5716);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_block2 (depth = 6)
  params[0] = *var_ix;
  params[1] = call5716;
  partcv[0] = 2;
  Object call5717 = callmethod(*var_block2, "apply",
    1, partcv, params);
  gc_frame_end(callframe5714);
// compiled call node returning call5717 (depth = 5)
  gc_frame_end(frame);
  return call5717;
}
Object meth_collectionsPrelude_keysAndValuesDo5697(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysAndValuesDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for keysAndValuesDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_ix = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "ix");
  Object *var_selfIterator = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "selfIterator");
// Begin line 339
  setline(339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5698 = alloc_Float64(0);
// compiled num node returning num5698 (depth = 4)
  *var_ix = num5698;
  if (num5698 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 340
  setline(340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5699 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5700 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5699);
// compiled call node returning call5700 (depth = 5)
// compiled member node returning call5700 (depth = 4)
  *var_selfIterator = call5700;
  if (call5700 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 341
  setline(341);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5701 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5702 = alloc_Block(NULL, NULL, "collectionsPrelude", 341);
  gc_frame_newslot(block5702);
// method "_apply"
  block_savedest(block5702);
  Object closure5703 = createclosure(2, "_apply");
  setclosureframe(closure5703, stackframe);
  addtoclosure(closure5703, var_selfIterator);
  addtoclosure(closure5703, selfslot);
  struct UserObject *uo5703 = (struct UserObject*)block5702;
  uo5703->data[0] = (Object)closure5703;
  Method *meth_meth_collectionsPrelude__apply5703 = addmethod2pos(block5702, "_apply", &meth_collectionsPrelude__apply5703, 0);
  int argcv_meth_collectionsPrelude__apply5703[] = {0};
  meth_meth_collectionsPrelude__apply5703->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5703);
  meth_meth_collectionsPrelude__apply5703->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5703->definitionLine = 340;
// compiled block node returning block5702 (depth = 4)
  gc_frame_newslot(block5702);
// starting to compile block node (depth = 4)
  Object block5707 = alloc_Block(NULL, NULL, "collectionsPrelude", 341);
  gc_frame_newslot(block5707);
// method "_apply"
  block_savedest(block5707);
  Object closure5708 = createclosure(4, "_apply");
  setclosureframe(closure5708, stackframe);
  addtoclosure(closure5708, var_ix);
  addtoclosure(closure5708, var_selfIterator);
  addtoclosure(closure5708, var_block2);
  addtoclosure(closure5708, selfslot);
  struct UserObject *uo5708 = (struct UserObject*)block5707;
  uo5708->data[0] = (Object)closure5708;
  Method *meth_meth_collectionsPrelude__apply5708 = addmethod2pos(block5707, "_apply", &meth_collectionsPrelude__apply5708, 0);
  int argcv_meth_collectionsPrelude__apply5708[] = {0};
  meth_meth_collectionsPrelude__apply5708->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5708);
  meth_meth_collectionsPrelude__apply5708->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5708->definitionLine = 341;
// compiled block node returning block5707 (depth = 4)
  gc_frame_newslot(block5707);
// call case 5: prelude request
  params[0] = block5702;
  params[1] = block5707;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5719 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5701);
// compiled call node returning call5719 (depth = 3)
  gc_frame_end(frame);
  return call5719;
}
Object meth_collectionsPrelude_values5720(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for values (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for values");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 347
  setline(347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__apply5726(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5727 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_selfIterator (depth = 7)
  partcv[0] = 0;
  Object call5728 = callmethod(*var_selfIterator, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe5727);
// compiled call node returning call5728 (depth = 6)
// compiled member node returning call5728 (depth = 5)
  gc_frame_end(frame);
  return call5728;
}
Object meth_collectionsPrelude__apply5731(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_res = getfromclosure(closure, 0);
  Object *var_selfIterator = getfromclosure(closure, 1);
  Object *var_block2 = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// Begin line 353
  setline(353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe5732 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_res (depth = 7)
  gc_frame_newslot(*var_res);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5733 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_selfIterator (depth = 9)
  partcv[0] = 0;
  Object call5734 = callmethod(*var_selfIterator, "next",
    1, partcv, params);
  gc_frame_end(callframe5733);
// compiled call node returning call5734 (depth = 8)
// compiled member node returning call5734 (depth = 7)
  gc_frame_newslot(call5734);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_block2 (depth = 7)
  params[0] = *var_res;
  params[1] = call5734;
  partcv[0] = 2;
  Object call5735 = callmethod(*var_block2, "apply",
    1, partcv, params);
  gc_frame_end(callframe5732);
// compiled call node returning call5735 (depth = 6)
  *var_res = call5735;
  if (call5735 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_fold_40__41_startingWith5721(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "fold()startingWith");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method fold()startingWith");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method fold()startingWith");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for fold()startingWith (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for fold");
  Object *var_initial = &(stackframe->slots[1]);
  *var_initial = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for startingWith");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_R = &(stackframe->slots[3]);
  if (nparts == 1 + 2 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_R = args[curarg++];
  } else {
    *var_R = Unknown;
  }
// End typeParams
  Object *var_res = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "res");
  Object *var_selfIterator = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "selfIterator");
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_initial (depth = 4)
  *var_res = *var_initial;
  if (*var_initial == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 351
  setline(351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5722 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5723 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5722);
// compiled call node returning call5723 (depth = 5)
// compiled member node returning call5723 (depth = 4)
  *var_selfIterator = call5723;
  if (call5723 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 352
  setline(352);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5724 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5725 = alloc_Block(NULL, NULL, "collectionsPrelude", 352);
  gc_frame_newslot(block5725);
// method "_apply"
  block_savedest(block5725);
  Object closure5726 = createclosure(2, "_apply");
  setclosureframe(closure5726, stackframe);
  addtoclosure(closure5726, var_selfIterator);
  addtoclosure(closure5726, selfslot);
  struct UserObject *uo5726 = (struct UserObject*)block5725;
  uo5726->data[0] = (Object)closure5726;
  Method *meth_meth_collectionsPrelude__apply5726 = addmethod2pos(block5725, "_apply", &meth_collectionsPrelude__apply5726, 0);
  int argcv_meth_collectionsPrelude__apply5726[] = {0};
  meth_meth_collectionsPrelude__apply5726->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5726);
  meth_meth_collectionsPrelude__apply5726->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5726->definitionLine = 351;
// compiled block node returning block5725 (depth = 4)
  gc_frame_newslot(block5725);
// starting to compile block node (depth = 4)
  Object block5730 = alloc_Block(NULL, NULL, "collectionsPrelude", 352);
  gc_frame_newslot(block5730);
// method "_apply"
  block_savedest(block5730);
  Object closure5731 = createclosure(4, "_apply");
  setclosureframe(closure5731, stackframe);
  addtoclosure(closure5731, var_res);
  addtoclosure(closure5731, var_selfIterator);
  addtoclosure(closure5731, var_block2);
  addtoclosure(closure5731, selfslot);
  struct UserObject *uo5731 = (struct UserObject*)block5730;
  uo5731->data[0] = (Object)closure5731;
  Method *meth_meth_collectionsPrelude__apply5731 = addmethod2pos(block5730, "_apply", &meth_collectionsPrelude__apply5731, 0);
  int argcv_meth_collectionsPrelude__apply5731[] = {0};
  meth_meth_collectionsPrelude__apply5731->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5731);
  meth_meth_collectionsPrelude__apply5731->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5731->definitionLine = 352;
// compiled block node returning block5730 (depth = 4)
  gc_frame_newslot(block5730);
// call case 5: prelude request
  params[0] = block5725;
  params[1] = block5730;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5738 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5724);
// compiled call node returning call5738 (depth = 3)
// Begin line 355
  setline(355);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_res (depth = 4)
  return *var_res;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__43__43_5739(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++ (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ++");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 358
  setline(358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5740 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 2: outer request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5741 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5742 = gc_frame_new();
// call case 3: self.outer request
  Object call5743 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5742);
// compiled call node returning call5743 (depth = 7)
// compiled member node returning call5743 (depth = 6)
  partcv[0] = 0;
  Object call5744 = callmethodflags(call5743, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5741);
// compiled call node returning call5744 (depth = 5)
// compiled member node returning call5744 (depth = 4)
  params[0] = self;
  params[1] = *var_other;
  partcv[0] = 2;
  Object call5745 = callmethodflags(call5744, "lazyConcatenation", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5740);
// compiled call node returning call5745 (depth = 3)
  gc_frame_end(frame);
  return call5745;
}
Object meth_collectionsPrelude_sortedBy5746(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for sortedBy");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 361
  setline(361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5747 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sortBlock (depth = 4)
  gc_frame_newslot(*var_sortBlock);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5748 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5749 = callmethodflags(self, "asList", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5748);
// compiled call node returning call5749 (depth = 5)
// compiled member node returning call5749 (depth = 4)
  params[0] = *var_sortBlock;
  partcv[0] = 1;
  Object call5750 = callmethod(call5749, "sortBy",
    1, partcv, params);
  gc_frame_end(callframe5747);
// compiled call node returning call5750 (depth = 3)
  gc_frame_end(frame);
  return call5750;
}
Object meth_collectionsPrelude_sorted5751(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sorted (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for sorted");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 364
  setline(364);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5752 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5753 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5754 = callmethodflags(self, "asList", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5753);
// compiled call node returning call5754 (depth = 6)
// compiled member node returning call5754 (depth = 5)
  partcv[0] = 0;
  Object call5755 = callmethod(call5754, "sort",
    1, partcv, params);
  gc_frame_end(callframe5752);
// compiled call node returning call5755 (depth = 4)
// compiled member node returning call5755 (depth = 3)
  gc_frame_end(frame);
  return call5755;
}
Object meth_collectionsPrelude__apply5760(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_each = &(stackframe->slots[0]);
  *var_each = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5762 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_each (depth = 9)
  partcv[0] = 0;
  Object call5763 = callmethod(*var_each, "asString",
    1, partcv, params);
  gc_frame_end(callframe5762);
// compiled call node returning call5763 (depth = 8)
// compiled member node returning call5763 (depth = 7)
  int op_slot_right_5761 = gc_frame_newslot(call5763);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5761 = gc_frame_newslot(*var_s);
  params[0] = call5763;
  partcv[0] = 1;
  Object opresult5765 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5765 (depth = 6)
  *var_s = opresult5765;
  if (opresult5765 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude__apply5769(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5771 == NULL) {
    strlit5771 = alloc_String(", ");
    gc_root(strlit5771);
  }
// compiled string node returning strlit5771 (depth = 7)
  int op_slot_right_5770 = gc_frame_newslot(strlit5771);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_left_5770 = gc_frame_newslot(*var_s);
  params[0] = strlit5771;
  partcv[0] = 1;
  Object opresult5773 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5773 (depth = 6)
  *var_s = opresult5773;
  if (opresult5773 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_asString5756(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "s");
// Begin line 367
  setline(367);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5757 == NULL) {
    strlit5757 = alloc_String("""\xe2""""\x9f""""\xa8""");
    gc_root(strlit5757);
  }
// compiled string node returning strlit5757 (depth = 4)
  *var_s = strlit5757;
  if (strlit5757 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 368
  setline(368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5758 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5759 = alloc_Block(NULL, NULL, "collectionsPrelude", 368);
  gc_frame_newslot(block5759);
// method "_apply"
  block_savedest(block5759);
  Object closure5760 = createclosure(2, "_apply");
  setclosureframe(closure5760, stackframe);
  addtoclosure(closure5760, var_s);
  addtoclosure(closure5760, selfslot);
  struct UserObject *uo5760 = (struct UserObject*)block5759;
  uo5760->data[0] = (Object)closure5760;
  Method *meth_meth_collectionsPrelude__apply5760 = addmethod2pos(block5759, "_apply", &meth_collectionsPrelude__apply5760, 0);
  int argcv_meth_collectionsPrelude__apply5760[] = {1};
  meth_meth_collectionsPrelude__apply5760->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5760);
  meth_meth_collectionsPrelude__apply5760->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5760->definitionLine = 364;
// compiled block node returning block5759 (depth = 4)
  gc_frame_newslot(block5759);
// starting to compile block node (depth = 4)
  Object block5768 = alloc_Block(NULL, NULL, "collectionsPrelude", 368);
  gc_frame_newslot(block5768);
// method "_apply"
  block_savedest(block5768);
  Object closure5769 = createclosure(2, "_apply");
  setclosureframe(closure5769, stackframe);
  addtoclosure(closure5769, var_s);
  addtoclosure(closure5769, selfslot);
  struct UserObject *uo5769 = (struct UserObject*)block5768;
  uo5769->data[0] = (Object)closure5769;
  Method *meth_meth_collectionsPrelude__apply5769 = addmethod2pos(block5768, "_apply", &meth_collectionsPrelude__apply5769, 0);
  int argcv_meth_collectionsPrelude__apply5769[] = {0};
  meth_meth_collectionsPrelude__apply5769->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5769);
  meth_meth_collectionsPrelude__apply5769->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5769->definitionLine = 368;
// compiled block node returning block5768 (depth = 4)
  gc_frame_newslot(block5768);
// call case 4: self request
  params[0] = block5759;
  params[1] = block5768;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5776 = callmethodflags(self, "do()separatedBy", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5758);
// compiled call node returning call5776 (depth = 3)
// Begin line 369
  setline(369);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit5778 == NULL) {
    strlit5778 = alloc_String("""\xe2""""\x9f""""\xa9""");
    gc_root(strlit5778);
  }
// compiled string node returning strlit5778 (depth = 4)
  int op_slot_right_5777 = gc_frame_newslot(strlit5778);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  int op_slot_left_5777 = gc_frame_newslot(*var_s);
  params[0] = strlit5778;
  partcv[0] = 1;
  Object opresult5780 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult5780 (depth = 3)
  gc_frame_end(frame);
  return opresult5780;
}
Object meth_collectionsPrelude_TRAIT5617(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "TRAIT");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  Object *var_collection = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for TRAIT (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for TRAIT");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5618 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5618 = alloc_userobj2(13,14, objclass5618);
  gc_frame_newslot(obj5618);
if (objclass5618 == NULL) {
  glfree(obj5618->class->name);
  obj5618->class->name = "enumerable.enumerable.TRAIT";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5618, self, 0);
  addmethodreal(obj5618,"outer", &reader_collectionsPrelude_outer_5619);
  Object oldself5618 = self;
  struct StackFrameObject *oldstackframe5618 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5618);
  gc_frame_newslot((Object)stackframe);
  self = obj5618;
  Object *oldselfslot5618 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5618 = (*(struct UserObject *)self).data[0], lowerouter5618 = thisouter5618;
  if (inheritingObject5618) {
    struct UserObject *inho5618 = (struct UserObject *)inheritingObject5618;
    while (inho5618->super != GraceDefaultObject) inho5618 = (struct UserObject *)inho5618->super;
    inho5618->super = obj5618;
    self = inheritingObject5618;
    *selfslot = self;
    lowerouter5618 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5618;
  }
// method "iterator"
  struct UserObject *uo5620 = (struct UserObject*)obj5618;
  uo5620->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iterator5620 = addmethod2pos(obj5618, "iterator", &meth_collectionsPrelude_iterator5620, 1);
  int argcv_meth_collectionsPrelude_iterator5620[] = {0};
  meth_meth_collectionsPrelude_iterator5620->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator5620);
  meth_meth_collectionsPrelude_iterator5620->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator5620->definitionLine = 310;
// method "size"
  block_savedest(obj5618);
  Object closure5627 = createclosure(1, "size");
  setclosureframe(closure5627, stackframe);
  addtoclosure(closure5627, var_SizeUnknown);
  struct UserObject *uo5627 = (struct UserObject*)obj5618;
  uo5627->data[2] = (Object)closure5627;
  Method *meth_meth_collectionsPrelude_size5627 = addmethod2pos(obj5618, "size", &meth_collectionsPrelude_size5627, 2);
  int argcv_meth_collectionsPrelude_size5627[] = {0};
  meth_meth_collectionsPrelude_size5627->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size5627);
  meth_meth_collectionsPrelude_size5627->definitionModule = modulename;
  meth_meth_collectionsPrelude_size5627->definitionLine = 311;
// method "asDictionary"
  struct UserObject *uo5640 = (struct UserObject*)obj5618;
  uo5640->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDictionary5640 = addmethod2pos(obj5618, "asDictionary", &meth_collectionsPrelude_asDictionary5640, 3);
  int argcv_meth_collectionsPrelude_asDictionary5640[] = {0};
  meth_meth_collectionsPrelude_asDictionary5640->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDictionary5640);
  meth_meth_collectionsPrelude_asDictionary5640->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDictionary5640->definitionLine = 315;
// method "into"
  struct UserObject *uo5656 = (struct UserObject*)obj5618;
  uo5656->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_into5656 = addmethod2pos(obj5618, "into", &meth_collectionsPrelude_into5656, 4);
  int argcv_meth_collectionsPrelude_into5656[] = {1};
  meth_meth_collectionsPrelude_into5656->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_into5656);
  meth_meth_collectionsPrelude_into5656->definitionModule = modulename;
  meth_meth_collectionsPrelude_into5656->definitionLine = 322;
// method "=="
  struct UserObject *uo5673 = (struct UserObject*)obj5618;
  uo5673->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61_5673 = addmethod2pos(obj5618, "==", &meth_collectionsPrelude__61__61_5673, 5);
  int argcv_meth_collectionsPrelude__61__61_5673[] = {1};
  meth_meth_collectionsPrelude__61__61_5673->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_5673);
  meth_meth_collectionsPrelude__61__61_5673->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_5673->definitionLine = 329;
// method "do"
  struct UserObject *uo5680 = (struct UserObject*)obj5618;
  uo5680->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do5680 = addmethod2pos(obj5618, "do", &meth_collectionsPrelude_do5680, 6);
  int argcv_meth_collectionsPrelude_do5680[] = {1};
  meth_meth_collectionsPrelude_do5680->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do5680);
  meth_meth_collectionsPrelude_do5680->definitionModule = modulename;
  meth_meth_collectionsPrelude_do5680->definitionLine = 332;
// method "keysAndValuesDo"
  struct UserObject *uo5697 = (struct UserObject*)obj5618;
  uo5697->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo5697 = addmethod2pos(obj5618, "keysAndValuesDo", &meth_collectionsPrelude_keysAndValuesDo5697, 7);
  int argcv_meth_collectionsPrelude_keysAndValuesDo5697[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo5697->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo5697);
  meth_meth_collectionsPrelude_keysAndValuesDo5697->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo5697->definitionLine = 338;
// method "values"
  struct UserObject *uo5720 = (struct UserObject*)obj5618;
  uo5720->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values5720 = addmethod2pos(obj5618, "values", &meth_collectionsPrelude_values5720, 8);
  int argcv_meth_collectionsPrelude_values5720[] = {0};
  meth_meth_collectionsPrelude_values5720->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values5720);
  meth_meth_collectionsPrelude_values5720->definitionModule = modulename;
  meth_meth_collectionsPrelude_values5720->definitionLine = 346;
// method "fold()startingWith"
  struct UserObject *uo5721 = (struct UserObject*)obj5618;
  uo5721->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fold_40__41_startingWith5721 = addmethod2pos(obj5618, "fold()startingWith", &meth_collectionsPrelude_fold_40__41_startingWith5721, 9);
  int argcv_meth_collectionsPrelude_fold_40__41_startingWith5721[] = {1, 1};
  meth_meth_collectionsPrelude_fold_40__41_startingWith5721->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_fold_40__41_startingWith5721);
  meth_meth_collectionsPrelude_fold_40__41_startingWith5721->definitionModule = modulename;
  meth_meth_collectionsPrelude_fold_40__41_startingWith5721->definitionLine = 349;
// method "++"
  struct UserObject *uo5739 = (struct UserObject*)obj5618;
  uo5739->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_5739 = addmethod2pos(obj5618, "++", &meth_collectionsPrelude__43__43_5739, 10);
  int argcv_meth_collectionsPrelude__43__43_5739[] = {1};
  meth_meth_collectionsPrelude__43__43_5739->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_5739);
  meth_meth_collectionsPrelude__43__43_5739->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_5739->definitionLine = 357;
// method "sortedBy"
  struct UserObject *uo5746 = (struct UserObject*)obj5618;
  uo5746->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy5746 = addmethod2pos(obj5618, "sortedBy", &meth_collectionsPrelude_sortedBy5746, 11);
  int argcv_meth_collectionsPrelude_sortedBy5746[] = {1};
  meth_meth_collectionsPrelude_sortedBy5746->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy5746);
  meth_meth_collectionsPrelude_sortedBy5746->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy5746->definitionLine = 360;
// method "sorted"
  struct UserObject *uo5751 = (struct UserObject*)obj5618;
  uo5751->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted5751 = addmethod2pos(obj5618, "sorted", &meth_collectionsPrelude_sorted5751, 12);
  int argcv_meth_collectionsPrelude_sorted5751[] = {0};
  meth_meth_collectionsPrelude_sorted5751->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted5751);
  meth_meth_collectionsPrelude_sorted5751->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted5751->definitionLine = 363;
// method "asString"
  struct UserObject *uo5756 = (struct UserObject*)obj5618;
  uo5756->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5756 = addmethod2pos(obj5618, "asString", &meth_collectionsPrelude_asString5756, 13);
  int argcv_meth_collectionsPrelude_asString5756[] = {0};
  meth_meth_collectionsPrelude_asString5756->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5756);
  meth_meth_collectionsPrelude_asString5756->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5756->definitionLine = 366;
  sourceObject = obj5618;
// Begin line 309
  setline(309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5781 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_collection (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5782 = callmethod(*var_collection, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe5781);
// compiled call node returning call5782 (depth = 3)
  struct UserObject *obj5618_uo = (struct UserObject *)obj5618;
  obj5618_uo->super = call5782;
  sourceObject = obj5618;
  sourceObject = obj5618;
  sourceObject = obj5618;
  sourceObject = obj5618;
  sourceObject = obj5618;
  sourceObject = obj5618;
  sourceObject = obj5618;
  sourceObject = obj5618;
  sourceObject = obj5618;
  sourceObject = obj5618;
  sourceObject = obj5618;
  sourceObject = obj5618;
  sourceObject = obj5618;
  objclass5618 = obj5618->class;
  objclass5618->definitionModule = modulename;
  objclass5618->definitionLine = 308;
  (*(struct UserObject *)self).data[0] = lowerouter5618;
  self = oldself5618;
  selfslot = oldselfslot5618;
  stackframe = oldstackframe5618;
  gc_frame_end(frame);
  return obj5618;
}
Object meth_collectionsPrelude_TRAIT5617_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "TRAIT()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_SizeUnknown = getfromclosure(closure, 0);
  Object *var_collection = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for TRAIT (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for TRAIT");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5618 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5618 = alloc_userobj2(13,14, objclass5618);
  gc_frame_newslot(obj5618);
if (objclass5618 == NULL) {
  glfree(obj5618->class->name);
  obj5618->class->name = "enumerable.enumerable.TRAIT";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5618, self, 0);
  addmethodreal(obj5618,"outer", &reader_collectionsPrelude_outer_5619);
  Object oldself5618 = self;
  struct StackFrameObject *oldstackframe5618 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5618);
  gc_frame_newslot((Object)stackframe);
  self = obj5618;
  Object *oldselfslot5618 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5618 = (*(struct UserObject *)self).data[0], lowerouter5618 = thisouter5618;
  if (inheritingObject5618) {
    struct UserObject *inho5618 = (struct UserObject *)inheritingObject5618;
    while (inho5618->super != GraceDefaultObject) inho5618 = (struct UserObject *)inho5618->super;
    inho5618->super = obj5618;
    self = inheritingObject5618;
    *selfslot = self;
    lowerouter5618 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5618;
  }
// method "iterator"
  struct UserObject *uo5620 = (struct UserObject*)obj5618;
  uo5620->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iterator5620 = addmethod2pos(obj5618, "iterator", &meth_collectionsPrelude_iterator5620, 1);
  int argcv_meth_collectionsPrelude_iterator5620[] = {0};
  meth_meth_collectionsPrelude_iterator5620->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator5620);
  meth_meth_collectionsPrelude_iterator5620->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator5620->definitionLine = 310;
// method "size"
  block_savedest(obj5618);
  Object closure5627 = createclosure(1, "size");
  setclosureframe(closure5627, stackframe);
  addtoclosure(closure5627, var_SizeUnknown);
  struct UserObject *uo5627 = (struct UserObject*)obj5618;
  uo5627->data[2] = (Object)closure5627;
  Method *meth_meth_collectionsPrelude_size5627 = addmethod2pos(obj5618, "size", &meth_collectionsPrelude_size5627, 2);
  int argcv_meth_collectionsPrelude_size5627[] = {0};
  meth_meth_collectionsPrelude_size5627->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size5627);
  meth_meth_collectionsPrelude_size5627->definitionModule = modulename;
  meth_meth_collectionsPrelude_size5627->definitionLine = 311;
// method "asDictionary"
  struct UserObject *uo5640 = (struct UserObject*)obj5618;
  uo5640->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDictionary5640 = addmethod2pos(obj5618, "asDictionary", &meth_collectionsPrelude_asDictionary5640, 3);
  int argcv_meth_collectionsPrelude_asDictionary5640[] = {0};
  meth_meth_collectionsPrelude_asDictionary5640->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDictionary5640);
  meth_meth_collectionsPrelude_asDictionary5640->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDictionary5640->definitionLine = 315;
// method "into"
  struct UserObject *uo5656 = (struct UserObject*)obj5618;
  uo5656->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_into5656 = addmethod2pos(obj5618, "into", &meth_collectionsPrelude_into5656, 4);
  int argcv_meth_collectionsPrelude_into5656[] = {1};
  meth_meth_collectionsPrelude_into5656->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_into5656);
  meth_meth_collectionsPrelude_into5656->definitionModule = modulename;
  meth_meth_collectionsPrelude_into5656->definitionLine = 322;
// method "=="
  struct UserObject *uo5673 = (struct UserObject*)obj5618;
  uo5673->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61_5673 = addmethod2pos(obj5618, "==", &meth_collectionsPrelude__61__61_5673, 5);
  int argcv_meth_collectionsPrelude__61__61_5673[] = {1};
  meth_meth_collectionsPrelude__61__61_5673->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_5673);
  meth_meth_collectionsPrelude__61__61_5673->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_5673->definitionLine = 329;
// method "do"
  struct UserObject *uo5680 = (struct UserObject*)obj5618;
  uo5680->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_do5680 = addmethod2pos(obj5618, "do", &meth_collectionsPrelude_do5680, 6);
  int argcv_meth_collectionsPrelude_do5680[] = {1};
  meth_meth_collectionsPrelude_do5680->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do5680);
  meth_meth_collectionsPrelude_do5680->definitionModule = modulename;
  meth_meth_collectionsPrelude_do5680->definitionLine = 332;
// method "keysAndValuesDo"
  struct UserObject *uo5697 = (struct UserObject*)obj5618;
  uo5697->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo5697 = addmethod2pos(obj5618, "keysAndValuesDo", &meth_collectionsPrelude_keysAndValuesDo5697, 7);
  int argcv_meth_collectionsPrelude_keysAndValuesDo5697[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo5697->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo5697);
  meth_meth_collectionsPrelude_keysAndValuesDo5697->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo5697->definitionLine = 338;
// method "values"
  struct UserObject *uo5720 = (struct UserObject*)obj5618;
  uo5720->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values5720 = addmethod2pos(obj5618, "values", &meth_collectionsPrelude_values5720, 8);
  int argcv_meth_collectionsPrelude_values5720[] = {0};
  meth_meth_collectionsPrelude_values5720->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values5720);
  meth_meth_collectionsPrelude_values5720->definitionModule = modulename;
  meth_meth_collectionsPrelude_values5720->definitionLine = 346;
// method "fold()startingWith"
  struct UserObject *uo5721 = (struct UserObject*)obj5618;
  uo5721->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fold_40__41_startingWith5721 = addmethod2pos(obj5618, "fold()startingWith", &meth_collectionsPrelude_fold_40__41_startingWith5721, 9);
  int argcv_meth_collectionsPrelude_fold_40__41_startingWith5721[] = {1, 1};
  meth_meth_collectionsPrelude_fold_40__41_startingWith5721->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_fold_40__41_startingWith5721);
  meth_meth_collectionsPrelude_fold_40__41_startingWith5721->definitionModule = modulename;
  meth_meth_collectionsPrelude_fold_40__41_startingWith5721->definitionLine = 349;
// method "++"
  struct UserObject *uo5739 = (struct UserObject*)obj5618;
  uo5739->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_5739 = addmethod2pos(obj5618, "++", &meth_collectionsPrelude__43__43_5739, 10);
  int argcv_meth_collectionsPrelude__43__43_5739[] = {1};
  meth_meth_collectionsPrelude__43__43_5739->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_5739);
  meth_meth_collectionsPrelude__43__43_5739->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_5739->definitionLine = 357;
// method "sortedBy"
  struct UserObject *uo5746 = (struct UserObject*)obj5618;
  uo5746->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy5746 = addmethod2pos(obj5618, "sortedBy", &meth_collectionsPrelude_sortedBy5746, 11);
  int argcv_meth_collectionsPrelude_sortedBy5746[] = {1};
  meth_meth_collectionsPrelude_sortedBy5746->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy5746);
  meth_meth_collectionsPrelude_sortedBy5746->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy5746->definitionLine = 360;
// method "sorted"
  struct UserObject *uo5751 = (struct UserObject*)obj5618;
  uo5751->data[12] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted5751 = addmethod2pos(obj5618, "sorted", &meth_collectionsPrelude_sorted5751, 12);
  int argcv_meth_collectionsPrelude_sorted5751[] = {0};
  meth_meth_collectionsPrelude_sorted5751->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted5751);
  meth_meth_collectionsPrelude_sorted5751->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted5751->definitionLine = 363;
// method "asString"
  struct UserObject *uo5756 = (struct UserObject*)obj5618;
  uo5756->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5756 = addmethod2pos(obj5618, "asString", &meth_collectionsPrelude_asString5756, 13);
  int argcv_meth_collectionsPrelude_asString5756[] = {0};
  meth_meth_collectionsPrelude_asString5756->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5756);
  meth_meth_collectionsPrelude_asString5756->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5756->definitionLine = 366;
  sourceObject = obj5618;
// Begin line 309
  setline(309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5781 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_collection (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5782 = callmethod(*var_collection, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe5781);
// compiled call node returning call5782 (depth = 3)
  struct UserObject *obj5618_uo = (struct UserObject *)obj5618;
  obj5618_uo->super = call5782;
  sourceObject = obj5618;
  sourceObject = obj5618;
  sourceObject = obj5618;
  sourceObject = obj5618;
  sourceObject = obj5618;
  sourceObject = obj5618;
  sourceObject = obj5618;
  sourceObject = obj5618;
  sourceObject = obj5618;
  sourceObject = obj5618;
  sourceObject = obj5618;
  sourceObject = obj5618;
  sourceObject = obj5618;
  objclass5618 = obj5618->class;
  objclass5618->definitionModule = modulename;
  objclass5618->definitionLine = 308;
  (*(struct UserObject *)self).data[0] = lowerouter5618;
  self = oldself5618;
  selfslot = oldselfslot5618;
  stackframe = oldstackframe5618;
  gc_frame_end(frame);
  return obj5618;
}
Object meth_collectionsPrelude_asString5784(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 0 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 0.", nparts);
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 308
  setline(308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5785 == NULL) {
    strlit5785 = alloc_String("class enumerable");
    gc_root(strlit5785);
  }
// compiled string node returning strlit5785 (depth = 3)
  gc_frame_end(frame);
  return strlit5785;
}
Object meth_collectionsPrelude_enumerable5786(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 34, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "enumerable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_enumerable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for enumerable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for enumerable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 308
  setline(308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_enumerable (depth = 3)
  gc_frame_end(frame);
  return *var_enumerable;
}
Object meth_collectionsPrelude_at5792(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "at");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for at");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 375
  setline(375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5793 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5794 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5795 = gc_frame_new();
// call case 3: self.outer request
  Object call5796 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5795);
// compiled call node returning call5796 (depth = 8)
// compiled member node returning call5796 (depth = 7)
  partcv[0] = 0;
  Object call5797 = callmethodflags(call5796, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5794);
// compiled call node returning call5797 (depth = 6)
// compiled member node returning call5797 (depth = 5)
  partcv[0] = 0;
  Object call5798 = callmethodflags(call5797, "abstract", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5793);
// compiled call node returning call5798 (depth = 4)
// compiled member node returning call5798 (depth = 3)
  gc_frame_end(frame);
  return call5798;
}
Object meth_collectionsPrelude_size5799(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for size (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for size");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 376
  setline(376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5800 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5801 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5802 = gc_frame_new();
// call case 3: self.outer request
  Object call5803 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5802);
// compiled call node returning call5803 (depth = 8)
// compiled member node returning call5803 (depth = 7)
  partcv[0] = 0;
  Object call5804 = callmethodflags(call5803, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5801);
// compiled call node returning call5804 (depth = 6)
// compiled member node returning call5804 (depth = 5)
  partcv[0] = 0;
  Object call5805 = callmethodflags(call5804, "abstract", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5800);
// compiled call node returning call5805 (depth = 4)
// compiled member node returning call5805 (depth = 3)
  gc_frame_end(frame);
  return call5805;
}
Object meth_collectionsPrelude_isEmpty5806(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isEmpty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isEmpty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 377
  setline(377);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5808 = alloc_Float64(0);
// compiled num node returning num5808 (depth = 4)
  int op_slot_right_5807 = gc_frame_newslot(num5808);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5810 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5811 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5810);
// compiled call node returning call5811 (depth = 5)
// compiled member node returning call5811 (depth = 4)
  int op_slot_left_5807 = gc_frame_newslot(call5811);
  params[0] = num5808;
  partcv[0] = 1;
  Object opresult5812 = callmethod(call5811, "==", 1, partcv, params);
// compiled op node returning opresult5812 (depth = 3)
  gc_frame_end(frame);
  return opresult5812;
}
Object meth_collectionsPrelude__apply5819(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_curSize = getfromclosure(closure, 0);
  Object *var_i = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_curSize (depth = 6)
  int op_slot_right_5820 = gc_frame_newslot(*var_curSize);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_5820 = gc_frame_newslot(*var_i);
  params[0] = *var_curSize;
  partcv[0] = 1;
  Object opresult5822 = callmethod(*var_i, "≤", 1, partcv, params);
// compiled op node returning opresult5822 (depth = 5)
  gc_frame_end(frame);
  return opresult5822;
}
Object meth_collectionsPrelude__apply5825(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_action = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 382
  setline(382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5826 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// starting to compile call node (depth = 6)
  int callframe5827 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  gc_frame_newslot(*var_i);
// call case 4: self request
  params[0] = *var_i;
  partcv[0] = 1;
  Object call5828 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5827);
// compiled call node returning call5828 (depth = 6)
  gc_frame_newslot(call5828);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_action (depth = 6)
  params[0] = *var_i;
  params[1] = call5828;
  partcv[0] = 2;
  Object call5829 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe5826);
// compiled call node returning call5829 (depth = 5)
// Begin line 383
  setline(383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num5831 = alloc_Float64(1);
// compiled num node returning num5831 (depth = 7)
  int op_slot_right_5830 = gc_frame_newslot(num5831);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  int op_slot_left_5830 = gc_frame_newslot(*var_i);
  params[0] = num5831;
  partcv[0] = 1;
  Object sum5833 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum5833 (depth = 6)
  *var_i = sum5833;
  if (sum5833 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
  gc_frame_end(frame);
  return done;
}
Object meth_collectionsPrelude_keysAndValuesDo5813(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keysAndValuesDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_action = &(stackframe->slots[0]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for keysAndValuesDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_curSize = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "curSize");
  Object *var_i = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "i");
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5814 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5815 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5814);
// compiled call node returning call5815 (depth = 5)
// compiled member node returning call5815 (depth = 4)
  *var_curSize = call5815;
  if (call5815 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile num node (depth = 4)
  Object num5816 = alloc_Float64(1);
// compiled num node returning num5816 (depth = 4)
  *var_i = num5816;
  if (num5816 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 381
  setline(381);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5817 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5818 = alloc_Block(NULL, NULL, "collectionsPrelude", 381);
  gc_frame_newslot(block5818);
// method "_apply"
  block_savedest(block5818);
  Object closure5819 = createclosure(3, "_apply");
  setclosureframe(closure5819, stackframe);
  addtoclosure(closure5819, var_curSize);
  addtoclosure(closure5819, var_i);
  addtoclosure(closure5819, selfslot);
  struct UserObject *uo5819 = (struct UserObject*)block5818;
  uo5819->data[0] = (Object)closure5819;
  Method *meth_meth_collectionsPrelude__apply5819 = addmethod2pos(block5818, "_apply", &meth_collectionsPrelude__apply5819, 0);
  int argcv_meth_collectionsPrelude__apply5819[] = {0};
  meth_meth_collectionsPrelude__apply5819->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5819);
  meth_meth_collectionsPrelude__apply5819->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5819->definitionLine = 379;
// compiled block node returning block5818 (depth = 4)
  gc_frame_newslot(block5818);
// starting to compile block node (depth = 4)
  Object block5824 = alloc_Block(NULL, NULL, "collectionsPrelude", 381);
  gc_frame_newslot(block5824);
// method "_apply"
  block_savedest(block5824);
  Object closure5825 = createclosure(3, "_apply");
  setclosureframe(closure5825, stackframe);
  addtoclosure(closure5825, var_i);
  addtoclosure(closure5825, var_action);
  addtoclosure(closure5825, selfslot);
  struct UserObject *uo5825 = (struct UserObject*)block5824;
  uo5825->data[0] = (Object)closure5825;
  Method *meth_meth_collectionsPrelude__apply5825 = addmethod2pos(block5824, "_apply", &meth_collectionsPrelude__apply5825, 0);
  int argcv_meth_collectionsPrelude__apply5825[] = {0};
  meth_meth_collectionsPrelude__apply5825->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5825);
  meth_meth_collectionsPrelude__apply5825->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5825->definitionLine = 379;
// compiled block node returning block5824 (depth = 4)
  gc_frame_newslot(block5824);
// call case 5: prelude request
  params[0] = block5818;
  params[1] = block5824;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5836 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5817);
// compiled call node returning call5836 (depth = 3)
  gc_frame_end(frame);
  return call5836;
}
Object meth_collectionsPrelude_first5837(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "first");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for first (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for first");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5838 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5839 = alloc_Float64(1);
// compiled num node returning num5839 (depth = 4)
  gc_frame_newslot(num5839);
// call case 4: self request
  params[0] = num5839;
  partcv[0] = 1;
  Object call5840 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5838);
// compiled call node returning call5840 (depth = 3)
  gc_frame_end(frame);
  return call5840;
}
Object meth_collectionsPrelude_second5841(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "second");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for second (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for second");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5842 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5843 = alloc_Float64(2);
// compiled num node returning num5843 (depth = 4)
  gc_frame_newslot(num5843);
// call case 4: self request
  params[0] = num5843;
  partcv[0] = 1;
  Object call5844 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5842);
// compiled call node returning call5844 (depth = 3)
  gc_frame_end(frame);
  return call5844;
}
Object meth_collectionsPrelude_third5845(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "third");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for third (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for third");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 388
  setline(388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5846 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5847 = alloc_Float64(3);
// compiled num node returning num5847 (depth = 4)
  gc_frame_newslot(num5847);
// call case 4: self request
  params[0] = num5847;
  partcv[0] = 1;
  Object call5848 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5846);
// compiled call node returning call5848 (depth = 3)
  gc_frame_end(frame);
  return call5848;
}
Object meth_collectionsPrelude_fourth5849(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "fourth");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for fourth (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for fourth");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5850 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5851 = alloc_Float64(4);
// compiled num node returning num5851 (depth = 4)
  gc_frame_newslot(num5851);
// call case 4: self request
  params[0] = num5851;
  partcv[0] = 1;
  Object call5852 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5850);
// compiled call node returning call5852 (depth = 3)
  gc_frame_end(frame);
  return call5852;
}
Object meth_collectionsPrelude_fifth5853(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "fifth");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for fifth (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for fifth");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5854 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5855 = alloc_Float64(5);
// compiled num node returning num5855 (depth = 4)
  gc_frame_newslot(num5855);
// call case 4: self request
  params[0] = num5855;
  partcv[0] = 1;
  Object call5856 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5854);
// compiled call node returning call5856 (depth = 3)
  gc_frame_end(frame);
  return call5856;
}
Object meth_collectionsPrelude_last5857(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "last");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for last (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for last");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 391
  setline(391);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5858 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5859 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5860 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5859);
// compiled call node returning call5860 (depth = 5)
// compiled member node returning call5860 (depth = 4)
  gc_frame_newslot(call5860);
// call case 4: self request
  params[0] = call5860;
  partcv[0] = 1;
  Object call5861 = callmethodflags(self, "at", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5858);
// compiled call node returning call5861 (depth = 3)
  gc_frame_end(frame);
  return call5861;
}
Object meth_collectionsPrelude_indices5862(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "indices");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for indices (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for indices");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5863 = gc_frame_new();
// starting to compile num node (depth = 4)
  Object num5864 = alloc_Float64(1);
// compiled num node returning num5864 (depth = 4)
  gc_frame_newslot(num5864);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5865 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5866 = callmethodflags(self, "size", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5865);
// compiled call node returning call5866 (depth = 5)
// compiled member node returning call5866 (depth = 4)
  gc_frame_newslot(call5866);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5867 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5868 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5869 = gc_frame_new();
// call case 3: self.outer request
  Object call5870 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5869);
// compiled call node returning call5870 (depth = 9)
// compiled member node returning call5870 (depth = 8)
  partcv[0] = 0;
  Object call5871 = callmethodflags(call5870, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5868);
// compiled call node returning call5871 (depth = 7)
// compiled member node returning call5871 (depth = 6)
  partcv[0] = 0;
  Object call5872 = callmethodflags(call5871, "range", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5867);
// compiled call node returning call5872 (depth = 5)
// compiled member node returning call5872 (depth = 4)
  params[0] = num5864;
  params[1] = call5866;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5873 = callmethod(call5872, "from()to",
    2, partcv, params);
  gc_frame_end(callframe5863);
// compiled call node returning call5873 (depth = 3)
  gc_frame_end(frame);
  return call5873;
}
Object meth_collectionsPrelude__apply5877(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_sought = getfromclosure(closure, 0);
  Object *var_NoSuchObject = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 5)
  int callframe5878 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit5880 == NULL) {
    strlit5880 = alloc_String("");
    gc_root(strlit5880);
  }
// compiled string node returning strlit5880 (depth = 7)
  int op_slot_right_5879 = gc_frame_newslot(strlit5880);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_sought (depth = 8)
  int op_slot_right_5882 = gc_frame_newslot(*var_sought);
// starting to compile string node (depth = 8)
  if (strlit5884 == NULL) {
    strlit5884 = alloc_String("collection does not contain ");
    gc_root(strlit5884);
  }
// compiled string node returning strlit5884 (depth = 8)
  int op_slot_left_5882 = gc_frame_newslot(strlit5884);
  params[0] = *var_sought;
  partcv[0] = 1;
  Object opresult5885 = callmethod(strlit5884, "++", 1, partcv, params);
// compiled op node returning opresult5885 (depth = 7)
  int op_slot_left_5879 = gc_frame_newslot(opresult5885);
  params[0] = strlit5880;
  partcv[0] = 1;
  Object opresult5886 = callmethod(opresult5885, "++", 1, partcv, params);
// compiled op node returning opresult5886 (depth = 6)
  gc_frame_newslot(opresult5886);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_NoSuchObject (depth = 6)
  params[0] = opresult5886;
  partcv[0] = 1;
  Object call5887 = callmethod(*var_NoSuchObject, "raise",
    1, partcv, params);
  gc_frame_end(callframe5878);
// compiled call node returning call5887 (depth = 5)
  gc_frame_end(frame);
  return call5887;
}
Object meth_collectionsPrelude_indexOf5874(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indexOf");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method indexOf");
  Object params[2];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for indexOf (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sought = &(stackframe->slots[0]);
  *var_sought = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for indexOf");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 394
  setline(394);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5875 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sought (depth = 4)
  gc_frame_newslot(*var_sought);
// starting to compile block node (depth = 4)
  Object block5876 = alloc_Block(NULL, NULL, "collectionsPrelude", 394);
  gc_frame_newslot(block5876);
// method "_apply"
  block_savedest(block5876);
  Object closure5877 = createclosure(3, "_apply");
  setclosureframe(closure5877, stackframe);
  addtoclosure(closure5877, var_sought);
  addtoclosure(closure5877, var_NoSuchObject);
  addtoclosure(closure5877, selfslot);
  struct UserObject *uo5877 = (struct UserObject*)block5876;
  uo5877->data[0] = (Object)closure5877;
  Method *meth_meth_collectionsPrelude__apply5877 = addmethod2pos(block5876, "_apply", &meth_collectionsPrelude__apply5877, 0);
  int argcv_meth_collectionsPrelude__apply5877[] = {0};
  meth_meth_collectionsPrelude__apply5877->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5877);
  meth_meth_collectionsPrelude__apply5877->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5877->definitionLine = 392;
// compiled block node returning block5876 (depth = 4)
  gc_frame_newslot(block5876);
// call case 4: self request
  params[0] = *var_sought;
  params[1] = block5876;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5889 = callmethodflags(self, "indexOf()ifAbsent", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5875);
// compiled call node returning call5889 (depth = 3)
  gc_frame_end(frame);
  return call5889;
}
Object meth_collectionsPrelude__apply5893(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_sought = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_ix = &(stackframe->slots[0]);
  *var_ix = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_sought (depth = 7)
  int op_slot_right_5895 = gc_frame_newslot(*var_sought);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  int op_slot_left_5895 = gc_frame_newslot(*var_v);
  params[0] = *var_sought;
  partcv[0] = 1;
  Object opresult5897 = callmethod(*var_v, "==", 1, partcv, params);
// compiled op node returning opresult5897 (depth = 6)
  Object if5894 = done;
  if (istrue(opresult5897)) {
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_ix (depth = 7)
  block_return(realself, *var_ix);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if5894 = undefined;
  } else {
  }
// compiled if node returning if5894 (depth = 5)
  gc_frame_end(frame);
  return if5894;
}
Object meth_collectionsPrelude_indexOf_40__41_ifAbsent5890(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "indexOf()ifAbsent");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method indexOf()ifAbsent");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method indexOf()ifAbsent");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for indexOf()ifAbsent (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_sought = &(stackframe->slots[0]);
  *var_sought = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for indexOf");
  Object *var_action = &(stackframe->slots[1]);
  *var_action = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ifAbsent");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 397
  setline(397);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5891 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5892 = alloc_Block(NULL, NULL, "collectionsPrelude", 397);
  gc_frame_newslot(block5892);
// method "_apply"
  block_savedest(block5892);
  Object closure5893 = createclosure(2, "_apply");
  setclosureframe(closure5893, stackframe);
  addtoclosure(closure5893, var_sought);
  addtoclosure(closure5893, selfslot);
  struct UserObject *uo5893 = (struct UserObject*)block5892;
  uo5893->data[0] = (Object)closure5893;
  Method *meth_meth_collectionsPrelude__apply5893 = addmethod2pos(block5892, "_apply", &meth_collectionsPrelude__apply5893, 0);
  int argcv_meth_collectionsPrelude__apply5893[] = {2};
  meth_meth_collectionsPrelude__apply5893->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5893);
  meth_meth_collectionsPrelude__apply5893->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5893->definitionLine = 392;
// compiled block node returning block5892 (depth = 4)
  gc_frame_newslot(block5892);
// call case 4: self request
  params[0] = block5892;
  partcv[0] = 1;
  Object call5899 = callmethodflags(self, "keysAndValuesDo", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5891);
// compiled call node returning call5899 (depth = 3)
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5900 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_action (depth = 5)
  partcv[0] = 0;
  Object call5901 = callmethod(*var_action, "apply",
    1, partcv, params);
  gc_frame_end(callframe5900);
// compiled call node returning call5901 (depth = 4)
// compiled member node returning call5901 (depth = 3)
  gc_frame_end(frame);
  return call5901;
}
Object meth_collectionsPrelude__apply5913(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_result = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5914 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_k (depth = 6)
  gc_frame_newslot(*var_k);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  gc_frame_newslot(*var_v);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_result (depth = 6)
  params[0] = *var_k;
  params[1] = *var_v;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5915 = callmethod(*var_result, "at()put",
    2, partcv, params);
  gc_frame_end(callframe5914);
// compiled call node returning call5915 (depth = 5)
  gc_frame_end(frame);
  return call5915;
}
Object meth_collectionsPrelude_asDictionary5902(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asDictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asDictionary (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asDictionary");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_result = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "result");
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5903 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5904 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe5905 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe5906 = gc_frame_new();
// call case 3: self.outer request
  Object call5907 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5906);
// compiled call node returning call5907 (depth = 11)
// compiled member node returning call5907 (depth = 10)
  partcv[0] = 0;
  Object call5908 = callmethodflags(call5907, "outer", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5905);
// compiled call node returning call5908 (depth = 9)
// compiled member node returning call5908 (depth = 8)
  partcv[0] = 0;
  Object call5909 = callmethodflags(call5908, "dictionary", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5904);
// compiled call node returning call5909 (depth = 7)
// compiled member node returning call5909 (depth = 6)
  partcv[0] = 0;
  Object call5910 = callmethod(call5909, "empty",
    1, partcv, params);
  gc_frame_end(callframe5903);
// compiled call node returning call5910 (depth = 5)
// compiled member node returning call5910 (depth = 4)
  *var_result = call5910;
  if (call5910 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 404
  setline(404);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5911 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5912 = alloc_Block(NULL, NULL, "collectionsPrelude", 404);
  gc_frame_newslot(block5912);
// method "_apply"
  block_savedest(block5912);
  Object closure5913 = createclosure(2, "_apply");
  setclosureframe(closure5913, stackframe);
  addtoclosure(closure5913, var_result);
  addtoclosure(closure5913, selfslot);
  struct UserObject *uo5913 = (struct UserObject*)block5912;
  uo5913->data[0] = (Object)closure5913;
  Method *meth_meth_collectionsPrelude__apply5913 = addmethod2pos(block5912, "_apply", &meth_collectionsPrelude__apply5913, 0);
  int argcv_meth_collectionsPrelude__apply5913[] = {2};
  meth_meth_collectionsPrelude__apply5913->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5913);
  meth_meth_collectionsPrelude__apply5913->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5913->definitionLine = 403;
// compiled block node returning block5912 (depth = 4)
  gc_frame_newslot(block5912);
// call case 4: self request
  params[0] = block5912;
  partcv[0] = 1;
  Object call5917 = callmethodflags(self, "keysAndValuesDo", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5911);
// compiled call node returning call5917 (depth = 3)
// Begin line 407
  setline(407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_result (depth = 4)
  return *var_result;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__apply5923(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5924 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_selfIterator (depth = 7)
  partcv[0] = 0;
  Object call5925 = callmethod(*var_selfIterator, "hasNext",
    1, partcv, params);
  gc_frame_end(callframe5924);
// compiled call node returning call5925 (depth = 6)
// compiled member node returning call5925 (depth = 5)
  gc_frame_end(frame);
  return call5925;
}
Object meth_collectionsPrelude__apply5928(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_selfIterator = getfromclosure(closure, 0);
  Object *var_existing = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 412
  setline(412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5929 = gc_frame_new();
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5930 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_selfIterator (depth = 8)
  partcv[0] = 0;
  Object call5931 = callmethod(*var_selfIterator, "next",
    1, partcv, params);
  gc_frame_end(callframe5930);
// compiled call node returning call5931 (depth = 7)
// compiled member node returning call5931 (depth = 6)
  gc_frame_newslot(call5931);
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_existing (depth = 6)
  params[0] = call5931;
  partcv[0] = 1;
  Object call5932 = callmethod(*var_existing, "add",
    1, partcv, params);
  gc_frame_end(callframe5929);
// compiled call node returning call5932 (depth = 5)
  gc_frame_end(frame);
  return call5932;
}
Object meth_collectionsPrelude_into5918(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "into");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method into");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for into (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_existing = &(stackframe->slots[0]);
  *var_existing = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for into");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_selfIterator = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "selfIterator");
// Begin line 410
  setline(410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5919 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call5920 = callmethodflags(self, "iterator", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5919);
// compiled call node returning call5920 (depth = 5)
// compiled member node returning call5920 (depth = 4)
  *var_selfIterator = call5920;
  if (call5920 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 411
  setline(411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5921 = gc_frame_new();
// starting to compile block node (depth = 4)
  Object block5922 = alloc_Block(NULL, NULL, "collectionsPrelude", 411);
  gc_frame_newslot(block5922);
// method "_apply"
  block_savedest(block5922);
  Object closure5923 = createclosure(2, "_apply");
  setclosureframe(closure5923, stackframe);
  addtoclosure(closure5923, var_selfIterator);
  addtoclosure(closure5923, selfslot);
  struct UserObject *uo5923 = (struct UserObject*)block5922;
  uo5923->data[0] = (Object)closure5923;
  Method *meth_meth_collectionsPrelude__apply5923 = addmethod2pos(block5922, "_apply", &meth_collectionsPrelude__apply5923, 0);
  int argcv_meth_collectionsPrelude__apply5923[] = {0};
  meth_meth_collectionsPrelude__apply5923->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5923);
  meth_meth_collectionsPrelude__apply5923->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5923->definitionLine = 410;
// compiled block node returning block5922 (depth = 4)
  gc_frame_newslot(block5922);
// starting to compile block node (depth = 4)
  Object block5927 = alloc_Block(NULL, NULL, "collectionsPrelude", 411);
  gc_frame_newslot(block5927);
// method "_apply"
  block_savedest(block5927);
  Object closure5928 = createclosure(3, "_apply");
  setclosureframe(closure5928, stackframe);
  addtoclosure(closure5928, var_selfIterator);
  addtoclosure(closure5928, var_existing);
  addtoclosure(closure5928, selfslot);
  struct UserObject *uo5928 = (struct UserObject*)block5927;
  uo5928->data[0] = (Object)closure5928;
  Method *meth_meth_collectionsPrelude__apply5928 = addmethod2pos(block5927, "_apply", &meth_collectionsPrelude__apply5928, 0);
  int argcv_meth_collectionsPrelude__apply5928[] = {0};
  meth_meth_collectionsPrelude__apply5928->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5928);
  meth_meth_collectionsPrelude__apply5928->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5928->definitionLine = 411;
// compiled block node returning block5927 (depth = 4)
  gc_frame_newslot(block5927);
// call case 5: prelude request
  params[0] = block5922;
  params[1] = block5927;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call5934 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5921);
// compiled call node returning call5934 (depth = 3)
// Begin line 414
  setline(414);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_existing (depth = 3)
  gc_frame_end(frame);
  return *var_existing;
}
Object meth_collectionsPrelude_TRAIT5789(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "TRAIT");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_collection = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for TRAIT (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for TRAIT");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5790 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5790 = alloc_userobj2(15,16, objclass5790);
  gc_frame_newslot(obj5790);
if (objclass5790 == NULL) {
  glfree(obj5790->class->name);
  obj5790->class->name = "indexable.indexable.TRAIT";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5790, self, 0);
  addmethodreal(obj5790,"outer", &reader_collectionsPrelude_outer_5791);
  Object oldself5790 = self;
  struct StackFrameObject *oldstackframe5790 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5790);
  gc_frame_newslot((Object)stackframe);
  self = obj5790;
  Object *oldselfslot5790 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5790 = (*(struct UserObject *)self).data[0], lowerouter5790 = thisouter5790;
  if (inheritingObject5790) {
    struct UserObject *inho5790 = (struct UserObject *)inheritingObject5790;
    while (inho5790->super != GraceDefaultObject) inho5790 = (struct UserObject *)inho5790->super;
    inho5790->super = obj5790;
    self = inheritingObject5790;
    *selfslot = self;
    lowerouter5790 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5790;
  }
// method "at"
  struct UserObject *uo5792 = (struct UserObject*)obj5790;
  uo5792->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at5792 = addmethod2pos(obj5790, "at", &meth_collectionsPrelude_at5792, 1);
  int argcv_meth_collectionsPrelude_at5792[] = {0};
  meth_meth_collectionsPrelude_at5792->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at5792);
  meth_meth_collectionsPrelude_at5792->definitionModule = modulename;
  meth_meth_collectionsPrelude_at5792->definitionLine = 375;
// method "size"
  struct UserObject *uo5799 = (struct UserObject*)obj5790;
  uo5799->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size5799 = addmethod2pos(obj5790, "size", &meth_collectionsPrelude_size5799, 2);
  int argcv_meth_collectionsPrelude_size5799[] = {0};
  meth_meth_collectionsPrelude_size5799->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size5799);
  meth_meth_collectionsPrelude_size5799->definitionModule = modulename;
  meth_meth_collectionsPrelude_size5799->definitionLine = 376;
// method "isEmpty"
  struct UserObject *uo5806 = (struct UserObject*)obj5790;
  uo5806->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isEmpty5806 = addmethod2pos(obj5790, "isEmpty", &meth_collectionsPrelude_isEmpty5806, 3);
  int argcv_meth_collectionsPrelude_isEmpty5806[] = {0};
  meth_meth_collectionsPrelude_isEmpty5806->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty5806);
  meth_meth_collectionsPrelude_isEmpty5806->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty5806->definitionLine = 377;
// method "keysAndValuesDo"
  struct UserObject *uo5813 = (struct UserObject*)obj5790;
  uo5813->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo5813 = addmethod2pos(obj5790, "keysAndValuesDo", &meth_collectionsPrelude_keysAndValuesDo5813, 4);
  int argcv_meth_collectionsPrelude_keysAndValuesDo5813[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo5813->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo5813);
  meth_meth_collectionsPrelude_keysAndValuesDo5813->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo5813->definitionLine = 378;
// method "first"
  struct UserObject *uo5837 = (struct UserObject*)obj5790;
  uo5837->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_first5837 = addmethod2pos(obj5790, "first", &meth_collectionsPrelude_first5837, 5);
  int argcv_meth_collectionsPrelude_first5837[] = {0};
  meth_meth_collectionsPrelude_first5837->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_first5837);
  meth_meth_collectionsPrelude_first5837->definitionModule = modulename;
  meth_meth_collectionsPrelude_first5837->definitionLine = 386;
// method "second"
  struct UserObject *uo5841 = (struct UserObject*)obj5790;
  uo5841->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_second5841 = addmethod2pos(obj5790, "second", &meth_collectionsPrelude_second5841, 6);
  int argcv_meth_collectionsPrelude_second5841[] = {0};
  meth_meth_collectionsPrelude_second5841->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_second5841);
  meth_meth_collectionsPrelude_second5841->definitionModule = modulename;
  meth_meth_collectionsPrelude_second5841->definitionLine = 387;
// method "third"
  struct UserObject *uo5845 = (struct UserObject*)obj5790;
  uo5845->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_third5845 = addmethod2pos(obj5790, "third", &meth_collectionsPrelude_third5845, 7);
  int argcv_meth_collectionsPrelude_third5845[] = {0};
  meth_meth_collectionsPrelude_third5845->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_third5845);
  meth_meth_collectionsPrelude_third5845->definitionModule = modulename;
  meth_meth_collectionsPrelude_third5845->definitionLine = 388;
// method "fourth"
  struct UserObject *uo5849 = (struct UserObject*)obj5790;
  uo5849->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fourth5849 = addmethod2pos(obj5790, "fourth", &meth_collectionsPrelude_fourth5849, 8);
  int argcv_meth_collectionsPrelude_fourth5849[] = {0};
  meth_meth_collectionsPrelude_fourth5849->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_fourth5849);
  meth_meth_collectionsPrelude_fourth5849->definitionModule = modulename;
  meth_meth_collectionsPrelude_fourth5849->definitionLine = 389;
// method "fifth"
  struct UserObject *uo5853 = (struct UserObject*)obj5790;
  uo5853->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fifth5853 = addmethod2pos(obj5790, "fifth", &meth_collectionsPrelude_fifth5853, 9);
  int argcv_meth_collectionsPrelude_fifth5853[] = {0};
  meth_meth_collectionsPrelude_fifth5853->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_fifth5853);
  meth_meth_collectionsPrelude_fifth5853->definitionModule = modulename;
  meth_meth_collectionsPrelude_fifth5853->definitionLine = 390;
// method "last"
  struct UserObject *uo5857 = (struct UserObject*)obj5790;
  uo5857->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_last5857 = addmethod2pos(obj5790, "last", &meth_collectionsPrelude_last5857, 10);
  int argcv_meth_collectionsPrelude_last5857[] = {0};
  meth_meth_collectionsPrelude_last5857->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_last5857);
  meth_meth_collectionsPrelude_last5857->definitionModule = modulename;
  meth_meth_collectionsPrelude_last5857->definitionLine = 391;
// method "indices"
  struct UserObject *uo5862 = (struct UserObject*)obj5790;
  uo5862->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_indices5862 = addmethod2pos(obj5790, "indices", &meth_collectionsPrelude_indices5862, 11);
  int argcv_meth_collectionsPrelude_indices5862[] = {0};
  meth_meth_collectionsPrelude_indices5862->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_indices5862);
  meth_meth_collectionsPrelude_indices5862->definitionModule = modulename;
  meth_meth_collectionsPrelude_indices5862->definitionLine = 392;
// method "indexOf"
  block_savedest(obj5790);
  Object closure5874 = createclosure(1, "indexOf");
  setclosureframe(closure5874, stackframe);
  addtoclosure(closure5874, var_NoSuchObject);
  struct UserObject *uo5874 = (struct UserObject*)obj5790;
  uo5874->data[12] = (Object)closure5874;
  Method *meth_meth_collectionsPrelude_indexOf5874 = addmethod2pos(obj5790, "indexOf", &meth_collectionsPrelude_indexOf5874, 12);
  int argcv_meth_collectionsPrelude_indexOf5874[] = {1};
  meth_meth_collectionsPrelude_indexOf5874->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_indexOf5874);
  meth_meth_collectionsPrelude_indexOf5874->definitionModule = modulename;
  meth_meth_collectionsPrelude_indexOf5874->definitionLine = 393;
// method "indexOf()ifAbsent"
  struct UserObject *uo5890 = (struct UserObject*)obj5790;
  uo5890->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_indexOf_40__41_ifAbsent5890 = addmethod2pos(obj5790, "indexOf()ifAbsent", &meth_collectionsPrelude_indexOf_40__41_ifAbsent5890, 13);
  int argcv_meth_collectionsPrelude_indexOf_40__41_ifAbsent5890[] = {1, 1};
  meth_meth_collectionsPrelude_indexOf_40__41_ifAbsent5890->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_indexOf_40__41_ifAbsent5890);
  meth_meth_collectionsPrelude_indexOf_40__41_ifAbsent5890->definitionModule = modulename;
  meth_meth_collectionsPrelude_indexOf_40__41_ifAbsent5890->definitionLine = 396;
// method "asDictionary"
  struct UserObject *uo5902 = (struct UserObject*)obj5790;
  uo5902->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDictionary5902 = addmethod2pos(obj5790, "asDictionary", &meth_collectionsPrelude_asDictionary5902, 14);
  int argcv_meth_collectionsPrelude_asDictionary5902[] = {0};
  meth_meth_collectionsPrelude_asDictionary5902->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDictionary5902);
  meth_meth_collectionsPrelude_asDictionary5902->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDictionary5902->definitionLine = 402;
// method "into"
  struct UserObject *uo5918 = (struct UserObject*)obj5790;
  uo5918->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_into5918 = addmethod2pos(obj5790, "into", &meth_collectionsPrelude_into5918, 15);
  int argcv_meth_collectionsPrelude_into5918[] = {1};
  meth_meth_collectionsPrelude_into5918->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_into5918);
  meth_meth_collectionsPrelude_into5918->definitionModule = modulename;
  meth_meth_collectionsPrelude_into5918->definitionLine = 409;
  sourceObject = obj5790;
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5935 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_collection (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5936 = callmethod(*var_collection, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe5935);
// compiled call node returning call5936 (depth = 3)
  struct UserObject *obj5790_uo = (struct UserObject *)obj5790;
  obj5790_uo->super = call5936;
  sourceObject = obj5790;
  sourceObject = obj5790;
  sourceObject = obj5790;
  sourceObject = obj5790;
  sourceObject = obj5790;
  sourceObject = obj5790;
  sourceObject = obj5790;
  sourceObject = obj5790;
  sourceObject = obj5790;
  sourceObject = obj5790;
  sourceObject = obj5790;
  sourceObject = obj5790;
  sourceObject = obj5790;
  sourceObject = obj5790;
  sourceObject = obj5790;
  objclass5790 = obj5790->class;
  objclass5790->definitionModule = modulename;
  objclass5790->definitionLine = 373;
  (*(struct UserObject *)self).data[0] = lowerouter5790;
  self = oldself5790;
  selfslot = oldselfslot5790;
  stackframe = oldstackframe5790;
  gc_frame_end(frame);
  return obj5790;
}
Object meth_collectionsPrelude_TRAIT5789_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "TRAIT()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[2];
  Object *var_NoSuchObject = getfromclosure(closure, 0);
  Object *var_collection = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for TRAIT (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for TRAIT");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Start typeParams
  Object *var_T = &(stackframe->slots[1]);
  if (nparts == 1 + 1 + (methodInheritingObject != NULL)) {
    if (argcv[nparts-1] < 1) {
      graceRaise(RequestError(), "insufficient generic parameters");
    }
    *var_T = args[curarg++];
  } else {
    *var_T = Unknown;
  }
// End typeParams
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5790 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5790 = alloc_userobj2(15,16, objclass5790);
  gc_frame_newslot(obj5790);
if (objclass5790 == NULL) {
  glfree(obj5790->class->name);
  obj5790->class->name = "indexable.indexable.TRAIT";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5790, self, 0);
  addmethodreal(obj5790,"outer", &reader_collectionsPrelude_outer_5791);
  Object oldself5790 = self;
  struct StackFrameObject *oldstackframe5790 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5790);
  gc_frame_newslot((Object)stackframe);
  self = obj5790;
  Object *oldselfslot5790 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5790 = (*(struct UserObject *)self).data[0], lowerouter5790 = thisouter5790;
  if (inheritingObject5790) {
    struct UserObject *inho5790 = (struct UserObject *)inheritingObject5790;
    while (inho5790->super != GraceDefaultObject) inho5790 = (struct UserObject *)inho5790->super;
    inho5790->super = obj5790;
    self = inheritingObject5790;
    *selfslot = self;
    lowerouter5790 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5790;
  }
// method "at"
  struct UserObject *uo5792 = (struct UserObject*)obj5790;
  uo5792->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_at5792 = addmethod2pos(obj5790, "at", &meth_collectionsPrelude_at5792, 1);
  int argcv_meth_collectionsPrelude_at5792[] = {0};
  meth_meth_collectionsPrelude_at5792->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at5792);
  meth_meth_collectionsPrelude_at5792->definitionModule = modulename;
  meth_meth_collectionsPrelude_at5792->definitionLine = 375;
// method "size"
  struct UserObject *uo5799 = (struct UserObject*)obj5790;
  uo5799->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size5799 = addmethod2pos(obj5790, "size", &meth_collectionsPrelude_size5799, 2);
  int argcv_meth_collectionsPrelude_size5799[] = {0};
  meth_meth_collectionsPrelude_size5799->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size5799);
  meth_meth_collectionsPrelude_size5799->definitionModule = modulename;
  meth_meth_collectionsPrelude_size5799->definitionLine = 376;
// method "isEmpty"
  struct UserObject *uo5806 = (struct UserObject*)obj5790;
  uo5806->data[3] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isEmpty5806 = addmethod2pos(obj5790, "isEmpty", &meth_collectionsPrelude_isEmpty5806, 3);
  int argcv_meth_collectionsPrelude_isEmpty5806[] = {0};
  meth_meth_collectionsPrelude_isEmpty5806->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty5806);
  meth_meth_collectionsPrelude_isEmpty5806->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty5806->definitionLine = 377;
// method "keysAndValuesDo"
  struct UserObject *uo5813 = (struct UserObject*)obj5790;
  uo5813->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo5813 = addmethod2pos(obj5790, "keysAndValuesDo", &meth_collectionsPrelude_keysAndValuesDo5813, 4);
  int argcv_meth_collectionsPrelude_keysAndValuesDo5813[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo5813->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo5813);
  meth_meth_collectionsPrelude_keysAndValuesDo5813->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo5813->definitionLine = 378;
// method "first"
  struct UserObject *uo5837 = (struct UserObject*)obj5790;
  uo5837->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_first5837 = addmethod2pos(obj5790, "first", &meth_collectionsPrelude_first5837, 5);
  int argcv_meth_collectionsPrelude_first5837[] = {0};
  meth_meth_collectionsPrelude_first5837->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_first5837);
  meth_meth_collectionsPrelude_first5837->definitionModule = modulename;
  meth_meth_collectionsPrelude_first5837->definitionLine = 386;
// method "second"
  struct UserObject *uo5841 = (struct UserObject*)obj5790;
  uo5841->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_second5841 = addmethod2pos(obj5790, "second", &meth_collectionsPrelude_second5841, 6);
  int argcv_meth_collectionsPrelude_second5841[] = {0};
  meth_meth_collectionsPrelude_second5841->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_second5841);
  meth_meth_collectionsPrelude_second5841->definitionModule = modulename;
  meth_meth_collectionsPrelude_second5841->definitionLine = 387;
// method "third"
  struct UserObject *uo5845 = (struct UserObject*)obj5790;
  uo5845->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_third5845 = addmethod2pos(obj5790, "third", &meth_collectionsPrelude_third5845, 7);
  int argcv_meth_collectionsPrelude_third5845[] = {0};
  meth_meth_collectionsPrelude_third5845->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_third5845);
  meth_meth_collectionsPrelude_third5845->definitionModule = modulename;
  meth_meth_collectionsPrelude_third5845->definitionLine = 388;
// method "fourth"
  struct UserObject *uo5849 = (struct UserObject*)obj5790;
  uo5849->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fourth5849 = addmethod2pos(obj5790, "fourth", &meth_collectionsPrelude_fourth5849, 8);
  int argcv_meth_collectionsPrelude_fourth5849[] = {0};
  meth_meth_collectionsPrelude_fourth5849->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_fourth5849);
  meth_meth_collectionsPrelude_fourth5849->definitionModule = modulename;
  meth_meth_collectionsPrelude_fourth5849->definitionLine = 389;
// method "fifth"
  struct UserObject *uo5853 = (struct UserObject*)obj5790;
  uo5853->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_fifth5853 = addmethod2pos(obj5790, "fifth", &meth_collectionsPrelude_fifth5853, 9);
  int argcv_meth_collectionsPrelude_fifth5853[] = {0};
  meth_meth_collectionsPrelude_fifth5853->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_fifth5853);
  meth_meth_collectionsPrelude_fifth5853->definitionModule = modulename;
  meth_meth_collectionsPrelude_fifth5853->definitionLine = 390;
// method "last"
  struct UserObject *uo5857 = (struct UserObject*)obj5790;
  uo5857->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_last5857 = addmethod2pos(obj5790, "last", &meth_collectionsPrelude_last5857, 10);
  int argcv_meth_collectionsPrelude_last5857[] = {0};
  meth_meth_collectionsPrelude_last5857->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_last5857);
  meth_meth_collectionsPrelude_last5857->definitionModule = modulename;
  meth_meth_collectionsPrelude_last5857->definitionLine = 391;
// method "indices"
  struct UserObject *uo5862 = (struct UserObject*)obj5790;
  uo5862->data[11] = emptyclosure;
  Method *meth_meth_collectionsPrelude_indices5862 = addmethod2pos(obj5790, "indices", &meth_collectionsPrelude_indices5862, 11);
  int argcv_meth_collectionsPrelude_indices5862[] = {0};
  meth_meth_collectionsPrelude_indices5862->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_indices5862);
  meth_meth_collectionsPrelude_indices5862->definitionModule = modulename;
  meth_meth_collectionsPrelude_indices5862->definitionLine = 392;
// method "indexOf"
  block_savedest(obj5790);
  Object closure5874 = createclosure(1, "indexOf");
  setclosureframe(closure5874, stackframe);
  addtoclosure(closure5874, var_NoSuchObject);
  struct UserObject *uo5874 = (struct UserObject*)obj5790;
  uo5874->data[12] = (Object)closure5874;
  Method *meth_meth_collectionsPrelude_indexOf5874 = addmethod2pos(obj5790, "indexOf", &meth_collectionsPrelude_indexOf5874, 12);
  int argcv_meth_collectionsPrelude_indexOf5874[] = {1};
  meth_meth_collectionsPrelude_indexOf5874->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_indexOf5874);
  meth_meth_collectionsPrelude_indexOf5874->definitionModule = modulename;
  meth_meth_collectionsPrelude_indexOf5874->definitionLine = 393;
// method "indexOf()ifAbsent"
  struct UserObject *uo5890 = (struct UserObject*)obj5790;
  uo5890->data[13] = emptyclosure;
  Method *meth_meth_collectionsPrelude_indexOf_40__41_ifAbsent5890 = addmethod2pos(obj5790, "indexOf()ifAbsent", &meth_collectionsPrelude_indexOf_40__41_ifAbsent5890, 13);
  int argcv_meth_collectionsPrelude_indexOf_40__41_ifAbsent5890[] = {1, 1};
  meth_meth_collectionsPrelude_indexOf_40__41_ifAbsent5890->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_indexOf_40__41_ifAbsent5890);
  meth_meth_collectionsPrelude_indexOf_40__41_ifAbsent5890->definitionModule = modulename;
  meth_meth_collectionsPrelude_indexOf_40__41_ifAbsent5890->definitionLine = 396;
// method "asDictionary"
  struct UserObject *uo5902 = (struct UserObject*)obj5790;
  uo5902->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asDictionary5902 = addmethod2pos(obj5790, "asDictionary", &meth_collectionsPrelude_asDictionary5902, 14);
  int argcv_meth_collectionsPrelude_asDictionary5902[] = {0};
  meth_meth_collectionsPrelude_asDictionary5902->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asDictionary5902);
  meth_meth_collectionsPrelude_asDictionary5902->definitionModule = modulename;
  meth_meth_collectionsPrelude_asDictionary5902->definitionLine = 402;
// method "into"
  struct UserObject *uo5918 = (struct UserObject*)obj5790;
  uo5918->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_into5918 = addmethod2pos(obj5790, "into", &meth_collectionsPrelude_into5918, 15);
  int argcv_meth_collectionsPrelude_into5918[] = {1};
  meth_meth_collectionsPrelude_into5918->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_into5918);
  meth_meth_collectionsPrelude_into5918->definitionModule = modulename;
  meth_meth_collectionsPrelude_into5918->definitionLine = 409;
  sourceObject = obj5790;
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5935 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_collection (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call5936 = callmethod(*var_collection, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe5935);
// compiled call node returning call5936 (depth = 3)
  struct UserObject *obj5790_uo = (struct UserObject *)obj5790;
  obj5790_uo->super = call5936;
  sourceObject = obj5790;
  sourceObject = obj5790;
  sourceObject = obj5790;
  sourceObject = obj5790;
  sourceObject = obj5790;
  sourceObject = obj5790;
  sourceObject = obj5790;
  sourceObject = obj5790;
  sourceObject = obj5790;
  sourceObject = obj5790;
  sourceObject = obj5790;
  sourceObject = obj5790;
  sourceObject = obj5790;
  sourceObject = obj5790;
  sourceObject = obj5790;
  objclass5790 = obj5790->class;
  objclass5790->definitionModule = modulename;
  objclass5790->definitionLine = 373;
  (*(struct UserObject *)self).data[0] = lowerouter5790;
  self = oldself5790;
  selfslot = oldselfslot5790;
  stackframe = oldstackframe5790;
  gc_frame_end(frame);
  return obj5790;
}
Object meth_collectionsPrelude_asString5938(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 0 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 0.", nparts);
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 373
  setline(373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5939 == NULL) {
    strlit5939 = alloc_String("class indexable");
    gc_root(strlit5939);
  }
// compiled string node returning strlit5939 (depth = 3)
  gc_frame_end(frame);
  return strlit5939;
}
Object meth_collectionsPrelude_indexable5940(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 35, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "indexable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_indexable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for indexable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for indexable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 373
  setline(373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_indexable (depth = 3)
  gc_frame_end(frame);
  return *var_indexable;
}
Object meth_collectionsPrelude_size5943(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "size");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for size (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for size");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 424
  setline(424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile num node (depth = 3)
  Object num5944 = alloc_Float64(0);
// compiled num node returning num5944 (depth = 3)
  gc_frame_end(frame);
  return num5944;
}
Object meth_collectionsPrelude_isEmpty5945(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "isEmpty");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for isEmpty (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for isEmpty");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 425
  setline(425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5946 = alloc_Boolean(1);
// compiled identifier node returning bool5946 (depth = 3)
  gc_frame_end(frame);
  return bool5946;
}
Object meth_collectionsPrelude_at5947(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "at");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method at");
  Object params[1];
  int partcv[1];
  Object *var_BoundsError = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for at (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_n = &(stackframe->slots[0]);
  *var_n = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for at");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 426
  setline(426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5948 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit5950 == NULL) {
    strlit5950 = alloc_String(" of empty sequence");
    gc_root(strlit5950);
  }
// compiled string node returning strlit5950 (depth = 5)
  int op_slot_right_5949 = gc_frame_newslot(strlit5950);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_right_5952 = gc_frame_newslot(*var_n);
// starting to compile string node (depth = 6)
  if (strlit5954 == NULL) {
    strlit5954 = alloc_String("index ");
    gc_root(strlit5954);
  }
// compiled string node returning strlit5954 (depth = 6)
  int op_slot_left_5952 = gc_frame_newslot(strlit5954);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult5955 = callmethod(strlit5954, "++", 1, partcv, params);
// compiled op node returning opresult5955 (depth = 5)
  int op_slot_left_5949 = gc_frame_newslot(opresult5955);
  params[0] = strlit5950;
  partcv[0] = 1;
  Object opresult5956 = callmethod(opresult5955, "++", 1, partcv, params);
// compiled op node returning opresult5956 (depth = 4)
  gc_frame_newslot(opresult5956);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_BoundsError (depth = 4)
  params[0] = opresult5956;
  partcv[0] = 1;
  Object call5957 = callmethod(*var_BoundsError, "raise",
    1, partcv, params);
  gc_frame_end(callframe5948);
// compiled call node returning call5957 (depth = 3)
  gc_frame_end(frame);
  return call5957;
}
Object meth_collectionsPrelude_keys5958(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "keys");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keys (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for keys");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 427
  setline(427);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_values5959(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "values");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for values (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for values");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 428
  setline(428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_keysAndValuesDo5960(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "keysAndValuesDo");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method keysAndValuesDo");
  Object params[1];
  int partcv[1];
  Object *var_done = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for keysAndValuesDo (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block2 = &(stackframe->slots[0]);
  *var_block2 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for keysAndValuesDo");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 429
  setline(429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_done (depth = 3)
  gc_frame_end(frame);
  return *var_done;
}
Object meth_collectionsPrelude_reversed5961(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "reversed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for reversed (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for reversed");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 430
  setline(430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude__43__43_5962(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "++");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ++");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ++ (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ++");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 431
  setline(431);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe5963 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 6: other member request
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe5964 = gc_frame_new();
// call case 2: outer request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5965 = gc_frame_new();
// call case 3: self.outer request
  Object call5966 = callmethod3(self, "outer", 0, 0, NULL, ((flags >> 24) & 0xff));
  gc_frame_end(callframe5965);
// compiled call node returning call5966 (depth = 7)
// compiled member node returning call5966 (depth = 6)
  partcv[0] = 0;
  Object call5967 = callmethodflags(call5966, "sequence", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5964);
// compiled call node returning call5967 (depth = 5)
// compiled member node returning call5967 (depth = 4)
  params[0] = *var_other;
  partcv[0] = 1;
  Object call5968 = callmethod(call5967, "withAll",
    1, partcv, params);
  gc_frame_end(callframe5963);
// compiled call node returning call5968 (depth = 3)
  gc_frame_end(frame);
  return call5968;
}
Object meth_collectionsPrelude_asString5969(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 432
  setline(432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5970 == NULL) {
    strlit5970 = alloc_String("""\xe2""""\x9f""""\xa8""""\xe2""""\x9f""""\xa9""");
    gc_root(strlit5970);
  }
// compiled string node returning strlit5970 (depth = 3)
  gc_frame_end(frame);
  return strlit5970;
}
Object meth_collectionsPrelude_contains5971(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "contains");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method contains");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for contains (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_element = &(stackframe->slots[0]);
  *var_element = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for contains");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 433
  setline(433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool5972 = alloc_Boolean(0);
// compiled identifier node returning bool5972 (depth = 3)
  gc_frame_end(frame);
  return bool5972;
}
Object meth_collectionsPrelude_do5973(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "do");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method do");
  Object params[1];
  int partcv[1];
  Object *var_done = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for do (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_block1 = &(stackframe->slots[0]);
  *var_block1 = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for do");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 434
  setline(434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_done (depth = 3)
  gc_frame_end(frame);
  return *var_done;
}
Object meth_collectionsPrelude__apply5977(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 438
  setline(438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe5978 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_o (depth = 7)
  partcv[0] = 0;
  Object call5979 = callmethod(*var_o, "isEmpty",
    1, partcv, params);
  gc_frame_end(callframe5978);
// compiled call node returning call5979 (depth = 6)
// compiled member node returning call5979 (depth = 5)
  gc_frame_end(frame);
  return call5979;
}
Object meth_collectionsPrelude__apply5991(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___12 = &(stackframe->slots[0]);
  *var___12 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 441
  setline(441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 5)
  Object bool5992 = alloc_Boolean(0);
// compiled identifier node returning bool5992 (depth = 5)
  gc_frame_end(frame);
  return bool5992;
}
Object meth_collectionsPrelude__61__61_5974(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==");
  Object params[2];
  int partcv[1];
  Object *var_Iterable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 436
  setline(436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  int frame5975 = gc_frame_new();
  gc_frame_newslot(*var_other);
// Begin line 437
  setline(437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block5976 = alloc_Block(NULL, NULL, "collectionsPrelude", 437);
  gc_frame_newslot(block5976);
// method "_apply"
  block_savedest(block5976);
  Object closure5977 = createclosure(1, "_apply");
  setclosureframe(closure5977, stackframe);
  addtoclosure(closure5977, selfslot);
  struct UserObject *uo5977 = (struct UserObject*)block5976;
  uo5977->data[0] = (Object)closure5977;
  Method *meth_meth_collectionsPrelude__apply5977 = addmethod2pos(block5976, "_apply", &meth_collectionsPrelude__apply5977, 0);
  int argcv_meth_collectionsPrelude__apply5977[] = {1};
  meth_meth_collectionsPrelude__apply5977->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5977);
  meth_meth_collectionsPrelude__apply5977->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5977->definitionLine = 431;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe5981 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe5982 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit5983 == NULL) {
    strlit5983 = alloc_String("o");
    gc_root(strlit5983);
  }
// compiled string node returning strlit5983 (depth = 7)
  gc_frame_newslot(strlit5983);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe5984 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5985 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5984);
// compiled call node returning call5985 (depth = 8)
// compiled member node returning call5985 (depth = 7)
  params[0] = strlit5983;
  partcv[0] = 1;
  Object call5986 = callmethod(call5985, "new",
    1, partcv, params);
  gc_frame_end(callframe5982);
// compiled call node returning call5986 (depth = 6)
  gc_frame_newslot(call5986);
// Begin line 437
  setline(437);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Iterable (depth = 6)
  gc_frame_newslot(*var_Iterable);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe5987 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5988 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5987);
// compiled call node returning call5988 (depth = 7)
// compiled member node returning call5988 (depth = 6)
  params[0] = call5986;
  params[1] = *var_Iterable;
  partcv[0] = 2;
  Object call5989 = callmethod(call5988, "new",
    1, partcv, params);
  gc_frame_end(callframe5981);
// compiled call node returning call5989 (depth = 5)
((struct UserObject *)block5976)->data[1] = call5989;
// compiled block node returning block5976 (depth = 4)
  gc_frame_newslot(block5976);
// Begin line 440
  setline(440);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block5990 = alloc_Block(NULL, NULL, "collectionsPrelude", 440);
  gc_frame_newslot(block5990);
// method "_apply"
  block_savedest(block5990);
  Object closure5991 = createclosure(1, "_apply");
  setclosureframe(closure5991, stackframe);
  addtoclosure(closure5991, selfslot);
  struct UserObject *uo5991 = (struct UserObject*)block5990;
  uo5991->data[0] = (Object)closure5991;
  Method *meth_meth_collectionsPrelude__apply5991 = addmethod2pos(block5990, "_apply", &meth_collectionsPrelude__apply5991, 0);
  int argcv_meth_collectionsPrelude__apply5991[] = {1};
  meth_meth_collectionsPrelude__apply5991->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply5991);
  meth_meth_collectionsPrelude__apply5991->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply5991->definitionLine = 0;
// compiled block node returning block5990 (depth = 4)
  gc_frame_newslot(block5990);
  params[0] = block5976;
  params[1] = block5990;
  Object matchres5975 = matchCase(*var_other, params, 2,NULL);
  gc_frame_end(frame5975);
// compiled matchcase node returning matchres5975 (depth = 3)
  gc_frame_end(frame);
  return matchres5975;
}
Object meth_collectionsPrelude_asString5997(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 445
  setline(445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit5998 == NULL) {
    strlit5998 = alloc_String("emptySequenceIterator");
    gc_root(strlit5998);
  }
// compiled string node returning strlit5998 (depth = 3)
  gc_frame_end(frame);
  return strlit5998;
}
Object meth_collectionsPrelude_hasNext5999(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "hasNext");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for hasNext (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for hasNext");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 446
  setline(446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6000 = alloc_Boolean(0);
// compiled identifier node returning bool6000 (depth = 3)
  gc_frame_end(frame);
  return bool6000;
}
Object meth_collectionsPrelude_next6001(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "next");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for next (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for next");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 447
  setline(447);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6002 = gc_frame_new();
// starting to compile string node (depth = 4)
  if (strlit6003 == NULL) {
    strlit6003 = alloc_String("on empty sequence");
    gc_root(strlit6003);
  }
// compiled string node returning strlit6003 (depth = 4)
  gc_frame_newslot(strlit6003);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_IteratorExhausted (depth = 4)
  params[0] = strlit6003;
  partcv[0] = 1;
  Object call6004 = callmethod(*var_IteratorExhausted, "raise",
    1, partcv, params);
  gc_frame_end(callframe6002);
// compiled call node returning call6004 (depth = 3)
  gc_frame_end(frame);
  return call6004;
}
Object meth_collectionsPrelude_iterator5994(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5995 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5995 = alloc_userobj2(3,4, objclass5995);
  gc_frame_newslot(obj5995);
if (objclass5995 == NULL) {
  glfree(obj5995->class->name);
  obj5995->class->name = "emptySequence.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5995, self, 0);
  addmethodreal(obj5995,"outer", &reader_collectionsPrelude_outer_5996);
  Object oldself5995 = self;
  struct StackFrameObject *oldstackframe5995 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5995);
  gc_frame_newslot((Object)stackframe);
  self = obj5995;
  Object *oldselfslot5995 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5995 = (*(struct UserObject *)self).data[0], lowerouter5995 = thisouter5995;
  if (inheritingObject5995) {
    struct UserObject *inho5995 = (struct UserObject *)inheritingObject5995;
    while (inho5995->super != GraceDefaultObject) inho5995 = (struct UserObject *)inho5995->super;
    inho5995->super = obj5995;
    self = inheritingObject5995;
    *selfslot = self;
    lowerouter5995 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5995;
  }
// method "asString"
  struct UserObject *uo5997 = (struct UserObject*)obj5995;
  uo5997->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5997 = addmethod2pos(obj5995, "asString", &meth_collectionsPrelude_asString5997, 1);
  int argcv_meth_collectionsPrelude_asString5997[] = {0};
  meth_meth_collectionsPrelude_asString5997->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5997);
  meth_meth_collectionsPrelude_asString5997->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5997->definitionLine = 445;
// method "hasNext"
  struct UserObject *uo5999 = (struct UserObject*)obj5995;
  uo5999->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext5999 = addmethod2pos(obj5995, "hasNext", &meth_collectionsPrelude_hasNext5999, 2);
  int argcv_meth_collectionsPrelude_hasNext5999[] = {0};
  meth_meth_collectionsPrelude_hasNext5999->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext5999);
  meth_meth_collectionsPrelude_hasNext5999->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext5999->definitionLine = 446;
// method "next"
  block_savedest(obj5995);
  Object closure6001 = createclosure(1, "next");
  setclosureframe(closure6001, stackframe);
  addtoclosure(closure6001, var_IteratorExhausted);
  struct UserObject *uo6001 = (struct UserObject*)obj5995;
  uo6001->data[3] = (Object)closure6001;
  Method *meth_meth_collectionsPrelude_next6001 = addmethod2pos(obj5995, "next", &meth_collectionsPrelude_next6001, 3);
  int argcv_meth_collectionsPrelude_next6001[] = {0};
  meth_meth_collectionsPrelude_next6001->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next6001);
  meth_meth_collectionsPrelude_next6001->definitionModule = modulename;
  meth_meth_collectionsPrelude_next6001->definitionLine = 447;
  sourceObject = obj5995;
  sourceObject = obj5995;
  sourceObject = obj5995;
  objclass5995 = obj5995->class;
  objclass5995->definitionModule = modulename;
  objclass5995->definitionLine = 444;
  (*(struct UserObject *)self).data[0] = lowerouter5995;
  self = oldself5995;
  selfslot = oldselfslot5995;
  stackframe = oldstackframe5995;
  gc_frame_end(frame);
  return obj5995;
}
Object meth_collectionsPrelude_iterator5994_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "iterator()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_IteratorExhausted = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for iterator (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for iterator");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject5995 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5995 = alloc_userobj2(3,4, objclass5995);
  gc_frame_newslot(obj5995);
if (objclass5995 == NULL) {
  glfree(obj5995->class->name);
  obj5995->class->name = "emptySequence.iterator";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5995, self, 0);
  addmethodreal(obj5995,"outer", &reader_collectionsPrelude_outer_5996);
  Object oldself5995 = self;
  struct StackFrameObject *oldstackframe5995 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5995);
  gc_frame_newslot((Object)stackframe);
  self = obj5995;
  Object *oldselfslot5995 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5995 = (*(struct UserObject *)self).data[0], lowerouter5995 = thisouter5995;
  if (inheritingObject5995) {
    struct UserObject *inho5995 = (struct UserObject *)inheritingObject5995;
    while (inho5995->super != GraceDefaultObject) inho5995 = (struct UserObject *)inho5995->super;
    inho5995->super = obj5995;
    self = inheritingObject5995;
    *selfslot = self;
    lowerouter5995 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5995;
  }
// method "asString"
  struct UserObject *uo5997 = (struct UserObject*)obj5995;
  uo5997->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5997 = addmethod2pos(obj5995, "asString", &meth_collectionsPrelude_asString5997, 1);
  int argcv_meth_collectionsPrelude_asString5997[] = {0};
  meth_meth_collectionsPrelude_asString5997->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5997);
  meth_meth_collectionsPrelude_asString5997->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5997->definitionLine = 445;
// method "hasNext"
  struct UserObject *uo5999 = (struct UserObject*)obj5995;
  uo5999->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_hasNext5999 = addmethod2pos(obj5995, "hasNext", &meth_collectionsPrelude_hasNext5999, 2);
  int argcv_meth_collectionsPrelude_hasNext5999[] = {0};
  meth_meth_collectionsPrelude_hasNext5999->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hasNext5999);
  meth_meth_collectionsPrelude_hasNext5999->definitionModule = modulename;
  meth_meth_collectionsPrelude_hasNext5999->definitionLine = 446;
// method "next"
  block_savedest(obj5995);
  Object closure6001 = createclosure(1, "next");
  setclosureframe(closure6001, stackframe);
  addtoclosure(closure6001, var_IteratorExhausted);
  struct UserObject *uo6001 = (struct UserObject*)obj5995;
  uo6001->data[3] = (Object)closure6001;
  Method *meth_meth_collectionsPrelude_next6001 = addmethod2pos(obj5995, "next", &meth_collectionsPrelude_next6001, 3);
  int argcv_meth_collectionsPrelude_next6001[] = {0};
  meth_meth_collectionsPrelude_next6001->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_next6001);
  meth_meth_collectionsPrelude_next6001->definitionModule = modulename;
  meth_meth_collectionsPrelude_next6001->definitionLine = 447;
  sourceObject = obj5995;
  sourceObject = obj5995;
  sourceObject = obj5995;
  objclass5995 = obj5995->class;
  objclass5995->definitionModule = modulename;
  objclass5995->definitionLine = 444;
  (*(struct UserObject *)self).data[0] = lowerouter5995;
  self = oldself5995;
  selfslot = oldselfslot5995;
  stackframe = oldstackframe5995;
  gc_frame_end(frame);
  return obj5995;
}
Object meth_collectionsPrelude_sorted6006(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sorted");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sorted (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for sorted");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 449
  setline(449);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_sortedBy6007(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "sortedBy");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method sortedBy");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for sortedBy (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_sortBlock = &(stackframe->slots[0]);
  *var_sortBlock = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for sortedBy");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 450
  setline(450);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  gc_frame_end(frame);
  return self;
}
Object meth_collectionsPrelude_emptySequence6010(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 36, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "emptySequence");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_emptySequence = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for emptySequence (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for emptySequence");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_emptySequence (depth = 3)
  gc_frame_end(frame);
  return *var_emptySequence;
}
Object meth_collectionsPrelude_MinimalyIterable6013(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 37, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "MinimalyIterable");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_MinimalyIterable = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for MinimalyIterable (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for MinimalyIterable");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_MinimalyIterable (depth = 3)
  gc_frame_end(frame);
  return *var_MinimalyIterable;
}
Object meth_collectionsPrelude_asString6019(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1151
  setline(1151);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6020 == NULL) {
    strlit6020 = alloc_String("unused");
    gc_root(strlit6020);
  }
// compiled string node returning strlit6020 (depth = 3)
  gc_frame_end(frame);
  return strlit6020;
}
Object meth_collectionsPrelude__61__61_6021(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1152
  setline(1152);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6022 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 4: self request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call6023 = callmethodflags(self, "isMe", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6022);
// compiled call node returning call6023 (depth = 3)
  gc_frame_end(frame);
  return call6023;
}
Object meth_collectionsPrelude_unused6025(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 38, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "unused");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_unused = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for unused (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for unused");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1147
  setline(1147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_unused (depth = 3)
  gc_frame_end(frame);
  return *var_unused;
}
Object meth_collectionsPrelude_asString6031(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1159
  setline(1159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6032 == NULL) {
    strlit6032 = alloc_String("removed");
    gc_root(strlit6032);
  }
// compiled string node returning strlit6032 (depth = 3)
  gc_frame_end(frame);
  return strlit6032;
}
Object meth_collectionsPrelude__61__61_6033(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1160
  setline(1160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6034 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  gc_frame_newslot(*var_other);
// call case 4: self request
  params[0] = *var_other;
  partcv[0] = 1;
  Object call6035 = callmethodflags(self, "isMe", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6034);
// compiled call node returning call6035 (depth = 3)
  gc_frame_end(frame);
  return call6035;
}
Object meth_collectionsPrelude_removed6037(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 39, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "removed");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_removed = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for removed (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for removed");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1155
  setline(1155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_removed (depth = 3)
  gc_frame_end(frame);
  return *var_removed;
}
Object meth_collectionsPrelude_Binding6040(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 40, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "Binding");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_Binding = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for Binding (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for Binding");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1446
  setline(1446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Binding (depth = 3)
  gc_frame_end(frame);
  return *var_Binding;
}
Object meth_collectionsPrelude_asString6043(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(1, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1454
  setline(1454);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile string node (depth = 3)
  if (strlit6044 == NULL) {
    strlit6044 = alloc_String("binding class");
    gc_root(strlit6044);
  }
// compiled string node returning strlit6044 (depth = 3)
  gc_frame_end(frame);
  return strlit6044;
}
Object meth_collectionsPrelude_key6048(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "key");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_k = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for key (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for key");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1457
  setline(1457);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_k (depth = 3)
  gc_frame_end(frame);
  return *var_k;
}
Object meth_collectionsPrelude_value6049(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "value");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for value (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for value");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1458
  setline(1458);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_v (depth = 3)
  gc_frame_end(frame);
  return *var_v;
}
Object meth_collectionsPrelude_asString6050(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 3, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "asString");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_k = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for asString (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for asString");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1459
  setline(1459);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit6052 == NULL) {
    strlit6052 = alloc_String("");
    gc_root(strlit6052);
  }
// compiled string node returning strlit6052 (depth = 4)
  int op_slot_right_6051 = gc_frame_newslot(strlit6052);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_v (depth = 5)
  int op_slot_right_6054 = gc_frame_newslot(*var_v);
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit6057 == NULL) {
    strlit6057 = alloc_String("::");
    gc_root(strlit6057);
  }
// compiled string node returning strlit6057 (depth = 6)
  int op_slot_right_6056 = gc_frame_newslot(strlit6057);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_k (depth = 7)
  int op_slot_right_6059 = gc_frame_newslot(*var_k);
// starting to compile string node (depth = 7)
  if (strlit6061 == NULL) {
    strlit6061 = alloc_String("");
    gc_root(strlit6061);
  }
// compiled string node returning strlit6061 (depth = 7)
  int op_slot_left_6059 = gc_frame_newslot(strlit6061);
  params[0] = *var_k;
  partcv[0] = 1;
  Object opresult6062 = callmethod(strlit6061, "++", 1, partcv, params);
// compiled op node returning opresult6062 (depth = 6)
  int op_slot_left_6056 = gc_frame_newslot(opresult6062);
  params[0] = strlit6057;
  partcv[0] = 1;
  Object opresult6063 = callmethod(opresult6062, "++", 1, partcv, params);
// compiled op node returning opresult6063 (depth = 5)
  int op_slot_left_6054 = gc_frame_newslot(opresult6063);
  params[0] = *var_v;
  partcv[0] = 1;
  Object opresult6064 = callmethod(opresult6063, "++", 1, partcv, params);
// compiled op node returning opresult6064 (depth = 4)
  int op_slot_left_6051 = gc_frame_newslot(opresult6064);
  params[0] = strlit6052;
  partcv[0] = 1;
  Object opresult6065 = callmethod(opresult6064, "++", 1, partcv, params);
// compiled op node returning opresult6065 (depth = 3)
  gc_frame_end(frame);
  return opresult6065;
}
Object meth_collectionsPrelude_hashcode6066(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 4, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hashcode");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_k = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for hashcode (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for hashcode");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1460
  setline(1460);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6068 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  partcv[0] = 0;
  Object call6069 = callmethod(*var_v, "hashcode",
    1, partcv, params);
  gc_frame_end(callframe6068);
// compiled call node returning call6069 (depth = 5)
// compiled member node returning call6069 (depth = 4)
  int op_slot_right_6067 = gc_frame_newslot(call6069);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num6072 = alloc_Float64(1021);
// compiled num node returning num6072 (depth = 5)
  int op_slot_right_6071 = gc_frame_newslot(num6072);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6074 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_k (depth = 7)
  partcv[0] = 0;
  Object call6075 = callmethod(*var_k, "hashcode",
    1, partcv, params);
  gc_frame_end(callframe6074);
// compiled call node returning call6075 (depth = 6)
// compiled member node returning call6075 (depth = 5)
  int op_slot_left_6071 = gc_frame_newslot(call6075);
  params[0] = num6072;
  partcv[0] = 1;
  Object prod6076 = callmethod(call6075, "*", 1, partcv, params);
// compiled op node returning prod6076 (depth = 4)
  int op_slot_left_6067 = gc_frame_newslot(prod6076);
  params[0] = call6069;
  partcv[0] = 1;
  Object sum6077 = callmethod(prod6076, "+", 1, partcv, params);
// compiled op node returning sum6077 (depth = 3)
  gc_frame_end(frame);
  return sum6077;
}
Object meth_collectionsPrelude_hash6078(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "hash");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_k = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for hash (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for hash");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1461
  setline(1461);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe6080 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_v (depth = 6)
  partcv[0] = 0;
  Object call6081 = callmethod(*var_v, "hash",
    1, partcv, params);
  gc_frame_end(callframe6080);
// compiled call node returning call6081 (depth = 5)
// compiled member node returning call6081 (depth = 4)
  int op_slot_right_6079 = gc_frame_newslot(call6081);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num6084 = alloc_Float64(1021);
// compiled num node returning num6084 (depth = 5)
  int op_slot_right_6083 = gc_frame_newslot(num6084);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe6086 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_k (depth = 7)
  partcv[0] = 0;
  Object call6087 = callmethod(*var_k, "hash",
    1, partcv, params);
  gc_frame_end(callframe6086);
// compiled call node returning call6087 (depth = 6)
// compiled member node returning call6087 (depth = 5)
  int op_slot_left_6083 = gc_frame_newslot(call6087);
  params[0] = num6084;
  partcv[0] = 1;
  Object prod6088 = callmethod(call6087, "*", 1, partcv, params);
// compiled op node returning prod6088 (depth = 4)
  int op_slot_left_6079 = gc_frame_newslot(prod6088);
  params[0] = call6081;
  partcv[0] = 1;
  Object sum6089 = callmethod(prod6088, "+", 1, partcv, params);
// compiled op node returning sum6089 (depth = 3)
  gc_frame_end(frame);
  return sum6089;
}
Object meth_collectionsPrelude__apply6093(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_k = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_o = &(stackframe->slots[0]);
  *var_o = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6096 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_o (depth = 9)
  partcv[0] = 0;
  Object call6097 = callmethod(*var_o, "value",
    1, partcv, params);
  gc_frame_end(callframe6096);
// compiled call node returning call6097 (depth = 8)
// compiled member node returning call6097 (depth = 7)
  int op_slot_right_6095 = gc_frame_newslot(call6097);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_v (depth = 7)
  int op_slot_left_6095 = gc_frame_newslot(*var_v);
  params[0] = call6097;
  partcv[0] = 1;
  Object opresult6099 = callmethod(*var_v, "==", 1, partcv, params);
// compiled op node returning opresult6099 (depth = 6)
  int op_slot_right_6094 = gc_frame_newslot(opresult6099);
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6102 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_o (depth = 9)
  partcv[0] = 0;
  Object call6103 = callmethod(*var_o, "key",
    1, partcv, params);
  gc_frame_end(callframe6102);
// compiled call node returning call6103 (depth = 8)
// compiled member node returning call6103 (depth = 7)
  int op_slot_right_6101 = gc_frame_newslot(call6103);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_k (depth = 7)
  int op_slot_left_6101 = gc_frame_newslot(*var_k);
  params[0] = call6103;
  partcv[0] = 1;
  Object opresult6105 = callmethod(*var_k, "==", 1, partcv, params);
// compiled op node returning opresult6105 (depth = 6)
  int op_slot_left_6094 = gc_frame_newslot(opresult6105);
  params[0] = opresult6099;
  partcv[0] = 1;
  Object opresult6106 = callmethod(opresult6105, "&&", 1, partcv, params);
// compiled op node returning opresult6106 (depth = 5)
  gc_frame_end(frame);
  return opresult6106;
}
Object meth_collectionsPrelude__apply6118(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___15 = &(stackframe->slots[0]);
  *var___15 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile return node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool6119 = alloc_Boolean(0);
// compiled identifier node returning bool6119 (depth = 6)
  block_return(realself, bool6119);
// compiled return node returning undefined (depth = 5)
  gc_frame_end(frame);
  return undefined;
}
Object meth_collectionsPrelude__61__61_6090(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "==");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method ==");
  Object params[2];
  int partcv[1];
  Object *var_v = getfromclosure(closure, 0);
  Object *var_k = getfromclosure(closure, 1);
  Object *var_Binding = getfromclosure(closure, 2);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for == (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_other = &(stackframe->slots[0]);
  *var_other = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for ==");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1463
  setline(1463);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile matchcase node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_other (depth = 4)
  int frame6091 = gc_frame_new();
  gc_frame_newslot(*var_other);
// Begin line 1464
  setline(1464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6092 = alloc_Block(NULL, NULL, "collectionsPrelude", 1464);
  gc_frame_newslot(block6092);
// method "_apply"
  block_savedest(block6092);
  Object closure6093 = createclosure(3, "_apply");
  setclosureframe(closure6093, stackframe);
  addtoclosure(closure6093, var_v);
  addtoclosure(closure6093, var_k);
  addtoclosure(closure6093, selfslot);
  struct UserObject *uo6093 = (struct UserObject*)block6092;
  uo6093->data[0] = (Object)closure6093;
  Method *meth_meth_collectionsPrelude__apply6093 = addmethod2pos(block6092, "_apply", &meth_collectionsPrelude__apply6093, 0);
  int argcv_meth_collectionsPrelude__apply6093[] = {1};
  meth_meth_collectionsPrelude__apply6093->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply6093);
  meth_meth_collectionsPrelude__apply6093->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply6093->definitionLine = 1461;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe6108 = gc_frame_new();
// starting to compile call node (depth = 6)
  int callframe6109 = gc_frame_new();
// starting to compile string node (depth = 7)
  if (strlit6110 == NULL) {
    strlit6110 = alloc_String("o");
    gc_root(strlit6110);
  }
// compiled string node returning strlit6110 (depth = 7)
  gc_frame_newslot(strlit6110);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe6111 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call6112 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6111);
// compiled call node returning call6112 (depth = 8)
// compiled member node returning call6112 (depth = 7)
  params[0] = strlit6110;
  partcv[0] = 1;
  Object call6113 = callmethod(call6112, "new",
    1, partcv, params);
  gc_frame_end(callframe6109);
// compiled call node returning call6113 (depth = 6)
  gc_frame_newslot(call6113);
// Begin line 1464
  setline(1464);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_Binding (depth = 6)
  gc_frame_newslot(*var_Binding);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe6114 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call6115 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe6114);
// compiled call node returning call6115 (depth = 7)
// compiled member node returning call6115 (depth = 6)
  params[0] = call6113;
  params[1] = *var_Binding;
  partcv[0] = 2;
  Object call6116 = callmethod(call6115, "new",
    1, partcv, params);
  gc_frame_end(callframe6108);
// compiled call node returning call6116 (depth = 5)
((struct UserObject *)block6092)->data[1] = call6116;
// compiled block node returning block6092 (depth = 4)
  gc_frame_newslot(block6092);
// Begin line 1465
  setline(1465);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 4)
  Object block6117 = alloc_Block(NULL, NULL, "collectionsPrelude", 1465);
  gc_frame_newslot(block6117);
// method "_apply"
  block_savedest(block6117);
  Object closure6118 = createclosure(1, "_apply");
  setclosureframe(closure6118, stackframe);
  addtoclosure(closure6118, selfslot);
  struct UserObject *uo6118 = (struct UserObject*)block6117;
  uo6118->data[0] = (Object)closure6118;
  Method *meth_meth_collectionsPrelude__apply6118 = addmethod2pos(block6117, "_apply", &meth_collectionsPrelude__apply6118, 0);
  int argcv_meth_collectionsPrelude__apply6118[] = {1};
  meth_meth_collectionsPrelude__apply6118->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__apply6118);
  meth_meth_collectionsPrelude__apply6118->definitionModule = modulename;
  meth_meth_collectionsPrelude__apply6118->definitionLine = 0;
// compiled block node returning block6117 (depth = 4)
  gc_frame_newslot(block6117);
  params[0] = block6092;
  params[1] = block6117;
  Object matchres6091 = matchCase(*var_other, params, 2,NULL);
  gc_frame_end(frame6091);
// compiled matchcase node returning matchres6091 (depth = 3)
  gc_frame_end(frame);
  return matchres6091;
}
Object meth_collectionsPrelude_key_40__41_value6045(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "key()value");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method key()value");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method key()value");
  Object params[1];
  int partcv[1];
  Object *var_Binding = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for key()value (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for key");
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for value");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6046 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6046 = alloc_userobj2(6,7, objclass6046);
  gc_frame_newslot(obj6046);
if (objclass6046 == NULL) {
  glfree(obj6046->class->name);
  obj6046->class->name = "binding.key()value";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6046, self, 0);
  addmethodreal(obj6046,"outer", &reader_collectionsPrelude_outer_6047);
  Object oldself6046 = self;
  struct StackFrameObject *oldstackframe6046 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6046);
  gc_frame_newslot((Object)stackframe);
  self = obj6046;
  Object *oldselfslot6046 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6046 = (*(struct UserObject *)self).data[0], lowerouter6046 = thisouter6046;
  if (inheritingObject6046) {
    struct UserObject *inho6046 = (struct UserObject *)inheritingObject6046;
    while (inho6046->super != GraceDefaultObject) inho6046 = (struct UserObject *)inho6046->super;
    inho6046->super = obj6046;
    self = inheritingObject6046;
    *selfslot = self;
    lowerouter6046 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6046;
  }
// method "key"
  block_savedest(obj6046);
  Object closure6048 = createclosure(1, "key");
  setclosureframe(closure6048, stackframe);
  addtoclosure(closure6048, var_k);
  struct UserObject *uo6048 = (struct UserObject*)obj6046;
  uo6048->data[1] = (Object)closure6048;
  Method *meth_meth_collectionsPrelude_key6048 = addmethod2pos(obj6046, "key", &meth_collectionsPrelude_key6048, 1);
  int argcv_meth_collectionsPrelude_key6048[] = {0};
  meth_meth_collectionsPrelude_key6048->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_key6048);
  meth_meth_collectionsPrelude_key6048->definitionModule = modulename;
  meth_meth_collectionsPrelude_key6048->definitionLine = 1457;
// method "value"
  block_savedest(obj6046);
  Object closure6049 = createclosure(1, "value");
  setclosureframe(closure6049, stackframe);
  addtoclosure(closure6049, var_v);
  struct UserObject *uo6049 = (struct UserObject*)obj6046;
  uo6049->data[2] = (Object)closure6049;
  Method *meth_meth_collectionsPrelude_value6049 = addmethod2pos(obj6046, "value", &meth_collectionsPrelude_value6049, 2);
  int argcv_meth_collectionsPrelude_value6049[] = {0};
  meth_meth_collectionsPrelude_value6049->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_value6049);
  meth_meth_collectionsPrelude_value6049->definitionModule = modulename;
  meth_meth_collectionsPrelude_value6049->definitionLine = 1458;
// method "asString"
  block_savedest(obj6046);
  Object closure6050 = createclosure(2, "asString");
  setclosureframe(closure6050, stackframe);
  addtoclosure(closure6050, var_v);
  addtoclosure(closure6050, var_k);
  struct UserObject *uo6050 = (struct UserObject*)obj6046;
  uo6050->data[3] = (Object)closure6050;
  Method *meth_meth_collectionsPrelude_asString6050 = addmethod2pos(obj6046, "asString", &meth_collectionsPrelude_asString6050, 3);
  int argcv_meth_collectionsPrelude_asString6050[] = {0};
  meth_meth_collectionsPrelude_asString6050->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString6050);
  meth_meth_collectionsPrelude_asString6050->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString6050->definitionLine = 1459;
// method "hashcode"
  block_savedest(obj6046);
  Object closure6066 = createclosure(2, "hashcode");
  setclosureframe(closure6066, stackframe);
  addtoclosure(closure6066, var_v);
  addtoclosure(closure6066, var_k);
  struct UserObject *uo6066 = (struct UserObject*)obj6046;
  uo6066->data[4] = (Object)closure6066;
  Method *meth_meth_collectionsPrelude_hashcode6066 = addmethod2pos(obj6046, "hashcode", &meth_collectionsPrelude_hashcode6066, 4);
  int argcv_meth_collectionsPrelude_hashcode6066[] = {0};
  meth_meth_collectionsPrelude_hashcode6066->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hashcode6066);
  meth_meth_collectionsPrelude_hashcode6066->definitionModule = modulename;
  meth_meth_collectionsPrelude_hashcode6066->definitionLine = 1460;
// method "hash"
  block_savedest(obj6046);
  Object closure6078 = createclosure(2, "hash");
  setclosureframe(closure6078, stackframe);
  addtoclosure(closure6078, var_v);
  addtoclosure(closure6078, var_k);
  struct UserObject *uo6078 = (struct UserObject*)obj6046;
  uo6078->data[5] = (Object)closure6078;
  Method *meth_meth_collectionsPrelude_hash6078 = addmethod2pos(obj6046, "hash", &meth_collectionsPrelude_hash6078, 5);
  int argcv_meth_collectionsPrelude_hash6078[] = {0};
  meth_meth_collectionsPrelude_hash6078->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hash6078);
  meth_meth_collectionsPrelude_hash6078->definitionModule = modulename;
  meth_meth_collectionsPrelude_hash6078->definitionLine = 1461;
// method "=="
  block_savedest(obj6046);
  Object closure6090 = createclosure(3, "==");
  setclosureframe(closure6090, stackframe);
  addtoclosure(closure6090, var_v);
  addtoclosure(closure6090, var_k);
  addtoclosure(closure6090, var_Binding);
  struct UserObject *uo6090 = (struct UserObject*)obj6046;
  uo6090->data[6] = (Object)closure6090;
  Method *meth_meth_collectionsPrelude__61__61_6090 = addmethod2pos(obj6046, "==", &meth_collectionsPrelude__61__61_6090, 6);
  int argcv_meth_collectionsPrelude__61__61_6090[] = {1};
  meth_meth_collectionsPrelude__61__61_6090->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_6090);
  meth_meth_collectionsPrelude__61__61_6090->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_6090->definitionLine = 1462;
  sourceObject = obj6046;
  sourceObject = obj6046;
  sourceObject = obj6046;
  sourceObject = obj6046;
  sourceObject = obj6046;
  sourceObject = obj6046;
  objclass6046 = obj6046->class;
  objclass6046->definitionModule = modulename;
  objclass6046->definitionLine = 1456;
  (*(struct UserObject *)self).data[0] = lowerouter6046;
  self = oldself6046;
  selfslot = oldselfslot6046;
  stackframe = oldstackframe6046;
  gc_frame_end(frame);
  return obj6046;
}
Object meth_collectionsPrelude_key_40__41_value6045_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 2, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "key()value()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0] + argcv[1]];
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method key()value()object");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method key()value()object");
  Object params[1];
  int partcv[1];
  Object *var_Binding = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for key()value (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_k = &(stackframe->slots[0]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for key");
  Object *var_v = &(stackframe->slots[1]);
  *var_v = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for value");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject6046 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6046 = alloc_userobj2(6,7, objclass6046);
  gc_frame_newslot(obj6046);
if (objclass6046 == NULL) {
  glfree(obj6046->class->name);
  obj6046->class->name = "binding.key()value";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6046, self, 0);
  addmethodreal(obj6046,"outer", &reader_collectionsPrelude_outer_6047);
  Object oldself6046 = self;
  struct StackFrameObject *oldstackframe6046 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6046);
  gc_frame_newslot((Object)stackframe);
  self = obj6046;
  Object *oldselfslot6046 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6046 = (*(struct UserObject *)self).data[0], lowerouter6046 = thisouter6046;
  if (inheritingObject6046) {
    struct UserObject *inho6046 = (struct UserObject *)inheritingObject6046;
    while (inho6046->super != GraceDefaultObject) inho6046 = (struct UserObject *)inho6046->super;
    inho6046->super = obj6046;
    self = inheritingObject6046;
    *selfslot = self;
    lowerouter6046 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6046;
  }
// method "key"
  block_savedest(obj6046);
  Object closure6048 = createclosure(1, "key");
  setclosureframe(closure6048, stackframe);
  addtoclosure(closure6048, var_k);
  struct UserObject *uo6048 = (struct UserObject*)obj6046;
  uo6048->data[1] = (Object)closure6048;
  Method *meth_meth_collectionsPrelude_key6048 = addmethod2pos(obj6046, "key", &meth_collectionsPrelude_key6048, 1);
  int argcv_meth_collectionsPrelude_key6048[] = {0};
  meth_meth_collectionsPrelude_key6048->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_key6048);
  meth_meth_collectionsPrelude_key6048->definitionModule = modulename;
  meth_meth_collectionsPrelude_key6048->definitionLine = 1457;
// method "value"
  block_savedest(obj6046);
  Object closure6049 = createclosure(1, "value");
  setclosureframe(closure6049, stackframe);
  addtoclosure(closure6049, var_v);
  struct UserObject *uo6049 = (struct UserObject*)obj6046;
  uo6049->data[2] = (Object)closure6049;
  Method *meth_meth_collectionsPrelude_value6049 = addmethod2pos(obj6046, "value", &meth_collectionsPrelude_value6049, 2);
  int argcv_meth_collectionsPrelude_value6049[] = {0};
  meth_meth_collectionsPrelude_value6049->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_value6049);
  meth_meth_collectionsPrelude_value6049->definitionModule = modulename;
  meth_meth_collectionsPrelude_value6049->definitionLine = 1458;
// method "asString"
  block_savedest(obj6046);
  Object closure6050 = createclosure(2, "asString");
  setclosureframe(closure6050, stackframe);
  addtoclosure(closure6050, var_v);
  addtoclosure(closure6050, var_k);
  struct UserObject *uo6050 = (struct UserObject*)obj6046;
  uo6050->data[3] = (Object)closure6050;
  Method *meth_meth_collectionsPrelude_asString6050 = addmethod2pos(obj6046, "asString", &meth_collectionsPrelude_asString6050, 3);
  int argcv_meth_collectionsPrelude_asString6050[] = {0};
  meth_meth_collectionsPrelude_asString6050->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString6050);
  meth_meth_collectionsPrelude_asString6050->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString6050->definitionLine = 1459;
// method "hashcode"
  block_savedest(obj6046);
  Object closure6066 = createclosure(2, "hashcode");
  setclosureframe(closure6066, stackframe);
  addtoclosure(closure6066, var_v);
  addtoclosure(closure6066, var_k);
  struct UserObject *uo6066 = (struct UserObject*)obj6046;
  uo6066->data[4] = (Object)closure6066;
  Method *meth_meth_collectionsPrelude_hashcode6066 = addmethod2pos(obj6046, "hashcode", &meth_collectionsPrelude_hashcode6066, 4);
  int argcv_meth_collectionsPrelude_hashcode6066[] = {0};
  meth_meth_collectionsPrelude_hashcode6066->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hashcode6066);
  meth_meth_collectionsPrelude_hashcode6066->definitionModule = modulename;
  meth_meth_collectionsPrelude_hashcode6066->definitionLine = 1460;
// method "hash"
  block_savedest(obj6046);
  Object closure6078 = createclosure(2, "hash");
  setclosureframe(closure6078, stackframe);
  addtoclosure(closure6078, var_v);
  addtoclosure(closure6078, var_k);
  struct UserObject *uo6078 = (struct UserObject*)obj6046;
  uo6078->data[5] = (Object)closure6078;
  Method *meth_meth_collectionsPrelude_hash6078 = addmethod2pos(obj6046, "hash", &meth_collectionsPrelude_hash6078, 5);
  int argcv_meth_collectionsPrelude_hash6078[] = {0};
  meth_meth_collectionsPrelude_hash6078->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_hash6078);
  meth_meth_collectionsPrelude_hash6078->definitionModule = modulename;
  meth_meth_collectionsPrelude_hash6078->definitionLine = 1461;
// method "=="
  block_savedest(obj6046);
  Object closure6090 = createclosure(3, "==");
  setclosureframe(closure6090, stackframe);
  addtoclosure(closure6090, var_v);
  addtoclosure(closure6090, var_k);
  addtoclosure(closure6090, var_Binding);
  struct UserObject *uo6090 = (struct UserObject*)obj6046;
  uo6090->data[6] = (Object)closure6090;
  Method *meth_meth_collectionsPrelude__61__61_6090 = addmethod2pos(obj6046, "==", &meth_collectionsPrelude__61__61_6090, 6);
  int argcv_meth_collectionsPrelude__61__61_6090[] = {1};
  meth_meth_collectionsPrelude__61__61_6090->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_6090);
  meth_meth_collectionsPrelude__61__61_6090->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_6090->definitionLine = 1462;
  sourceObject = obj6046;
  sourceObject = obj6046;
  sourceObject = obj6046;
  sourceObject = obj6046;
  sourceObject = obj6046;
  sourceObject = obj6046;
  objclass6046 = obj6046->class;
  objclass6046->definitionModule = modulename;
  objclass6046->definitionLine = 1456;
  (*(struct UserObject *)self).data[0] = lowerouter6046;
  self = oldself6046;
  selfslot = oldselfslot6046;
  stackframe = oldstackframe6046;
  gc_frame_end(frame);
  return obj6046;
}
Object meth_collectionsPrelude_binding6122(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 41, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "binding");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_binding = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for binding (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for binding");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1453
  setline(1453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_binding (depth = 3)
  gc_frame_end(frame);
  return *var_binding;
}
Object meth_collectionsPrelude_ComparableToDictionary6125(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 42, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "ComparableToDictionary");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_ComparableToDictionary = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for ComparableToDictionary (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for ComparableToDictionary");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 1470
  setline(1470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_ComparableToDictionary (depth = 3)
  gc_frame_end(frame);
  return *var_ComparableToDictionary;
}
Object module_collectionsPrelude_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(53, 53);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = grace_prelude();
  adddatum2(self, grace_prelude(), 0);
  Object ObjectType = alloc_ObjectType();
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<collectionsPrelude>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = prelude;
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(53, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
// end of preamble
  Object params[1];
  int partcv[2];
  Object *var_BoundsError = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "BoundsError");
  Object *var_IteratorExhausted = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "IteratorExhausted");
  Object *var_SubobjectResponsibility = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "SubobjectResponsibility");
  Object *var_NoSuchObject = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "NoSuchObject");
  Object *var_RequestError = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "RequestError");
  Object *var_ConcurrentModification = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "ConcurrentModification");
  Object *var_SizeUnknown = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "SizeUnknown");
  Object *var_Block0 = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "Block0");
  Object *var_Block1 = &(stackframe->slots[9]);
  setframeelementname(stackframe, 9, "Block1");
  Object *var_Block2 = &(stackframe->slots[10]);
  setframeelementname(stackframe, 10, "Block2");
  Object *var_SelfType = &(stackframe->slots[11]);
  setframeelementname(stackframe, 11, "SelfType");
  Object *var_Iterable = &(stackframe->slots[12]);
  setframeelementname(stackframe, 12, "Iterable");
  Object *var_Expandable = &(stackframe->slots[13]);
  setframeelementname(stackframe, 13, "Expandable");
  Object *var_Collection = &(stackframe->slots[14]);
  setframeelementname(stackframe, 14, "Collection");
  Object *var_Enumerable = &(stackframe->slots[15]);
  setframeelementname(stackframe, 15, "Enumerable");
  Object *var_Sequence = &(stackframe->slots[16]);
  setframeelementname(stackframe, 16, "Sequence");
  Object *var_List = &(stackframe->slots[17]);
  setframeelementname(stackframe, 17, "List");
  Object *var_Set = &(stackframe->slots[18]);
  setframeelementname(stackframe, 18, "Set");
  Object *var_Dictionary = &(stackframe->slots[19]);
  setframeelementname(stackframe, 19, "Dictionary");
  Object *var_Iterator = &(stackframe->slots[20]);
  setframeelementname(stackframe, 20, "Iterator");
  Object *var_collection = &(stackframe->slots[21]);
  setframeelementname(stackframe, 21, "collection");
  Object *var_enumerable = &(stackframe->slots[22]);
  setframeelementname(stackframe, 22, "enumerable");
  Object *var_indexable = &(stackframe->slots[23]);
  setframeelementname(stackframe, 23, "indexable");
  Object *var_emptySequence = &(stackframe->slots[24]);
  setframeelementname(stackframe, 24, "emptySequence");
  Object *var_MinimalyIterable = &(stackframe->slots[25]);
  setframeelementname(stackframe, 25, "MinimalyIterable");
  Object *var_unused = &(stackframe->slots[26]);
  setframeelementname(stackframe, 26, "unused");
  Object *var_removed = &(stackframe->slots[27]);
  setframeelementname(stackframe, 27, "removed");
  Object *var_Binding = &(stackframe->slots[28]);
  setframeelementname(stackframe, 28, "Binding");
  Object *var_binding = &(stackframe->slots[29]);
  setframeelementname(stackframe, 29, "binding");
  Object *var_ComparableToDictionary = &(stackframe->slots[30]);
  setframeelementname(stackframe, 30, "ComparableToDictionary");
// Begin line 11
  setline(11);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "abstract"
  block_savedest(self);
  Object closure1 = createclosure(1, "abstract");
  setclosureframe(closure1, stackframe);
  addtoclosure(closure1, var_SubobjectResponsibility);
  struct UserObject *uo1 = (struct UserObject*)self;
  uo1->data[1] = (Object)closure1;
  Method *meth_meth_collectionsPrelude_abstract1 = addmethod2pos(self, "abstract", &meth_collectionsPrelude_abstract1, 1);
  int argcv_meth_collectionsPrelude_abstract1[] = {0};
  meth_meth_collectionsPrelude_abstract1->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_abstract1);
  meth_meth_collectionsPrelude_abstract1->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_abstract1->definitionModule = modulename;
  meth_meth_collectionsPrelude_abstract1->definitionLine = 11;
// compiled method node returning  (depth = 1)
// Begin line 166
  setline(166);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "lazySequenceOver()mappedBy"
  block_savedest(self);
  Object closure5 = createclosure(1, "lazySequenceOver()mappedBy");
  setclosureframe(closure5, stackframe);
  addtoclosure(closure5, var_enumerable);
  struct UserObject *uo5 = (struct UserObject*)self;
  uo5->data[2] = (Object)closure5;
  Method *meth_meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy5 = addmethod2pos(self, "lazySequenceOver()mappedBy", &meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy5, 2);
  int argcv_meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy5[] = {1, 1};
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy5->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy5);
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy5->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy5->definitionModule = modulename;
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy5->definitionLine = 166;
  block_savedest(self);
  Object closure46 = createclosure(1, "lazySequenceOver()mappedBy()object");
  setclosureframe(closure46, stackframe);
  addtoclosure(closure46, var_enumerable);
  Method *meth_meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy5_object = addmethod2pos(self, "lazySequenceOver()mappedBy()object", &meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy5_object, 2);
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy5_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy5_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_mappedBy5_object->definitionLine = 166;
// compiled method node returning  (depth = 1)
// Begin line 180
  setline(180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "lazySequenceOver()filteredBy"
  block_savedest(self);
  Object closure47 = createclosure(2, "lazySequenceOver()filteredBy");
  setclosureframe(closure47, stackframe);
  addtoclosure(closure47, var_IteratorExhausted);
  addtoclosure(closure47, var_enumerable);
  struct UserObject *uo47 = (struct UserObject*)self;
  uo47->data[3] = (Object)closure47;
  Method *meth_meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy47 = addmethod2pos(self, "lazySequenceOver()filteredBy", &meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy47, 3);
  int argcv_meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy47[] = {1, 1};
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy47->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy47);
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy47->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy47->definitionModule = modulename;
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy47->definitionLine = 180;
  block_savedest(self);
  Object closure142 = createclosure(2, "lazySequenceOver()filteredBy()object");
  setclosureframe(closure142, stackframe);
  addtoclosure(closure142, var_IteratorExhausted);
  addtoclosure(closure142, var_enumerable);
  Method *meth_meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy47_object = addmethod2pos(self, "lazySequenceOver()filteredBy()object", &meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy47_object, 3);
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy47_object->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy47_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_lazySequenceOver_40__41_filteredBy47_object->definitionLine = 180;
// compiled method node returning  (depth = 1)
// Begin line 216
  setline(216);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "iteratorConcat"
  struct UserObject *uo143 = (struct UserObject*)self;
  uo143->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_iteratorConcat143 = addmethod2pos(self, "iteratorConcat", &meth_collectionsPrelude_iteratorConcat143, 4);
  int argcv_meth_collectionsPrelude_iteratorConcat143[] = {2};
  meth_meth_collectionsPrelude_iteratorConcat143->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iteratorConcat143);
  meth_meth_collectionsPrelude_iteratorConcat143->definitionModule = modulename;
  meth_meth_collectionsPrelude_iteratorConcat143->definitionLine = 216;
  Method *meth_meth_collectionsPrelude_iteratorConcat143_object = addmethod2pos(self, "iteratorConcat()object", &meth_collectionsPrelude_iteratorConcat143_object, 4);
  int argcv_meth_collectionsPrelude_iteratorConcat143_object[] = {2};
  meth_meth_collectionsPrelude_iteratorConcat143_object->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iteratorConcat143_object);
  meth_meth_collectionsPrelude_iteratorConcat143_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iteratorConcat143_object->definitionLine = 216;
// compiled method node returning  (depth = 1)
// Begin line 231
  setline(231);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "lazyConcatenation"
  block_savedest(self);
  Object closure180 = createclosure(1, "lazyConcatenation");
  setclosureframe(closure180, stackframe);
  addtoclosure(closure180, var_enumerable);
  struct UserObject *uo180 = (struct UserObject*)self;
  uo180->data[5] = (Object)closure180;
  Method *meth_meth_collectionsPrelude_lazyConcatenation180 = addmethod2pos(self, "lazyConcatenation", &meth_collectionsPrelude_lazyConcatenation180, 5);
  int argcv_meth_collectionsPrelude_lazyConcatenation180[] = {2};
  meth_meth_collectionsPrelude_lazyConcatenation180->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_lazyConcatenation180);
  meth_meth_collectionsPrelude_lazyConcatenation180->definitionModule = modulename;
  meth_meth_collectionsPrelude_lazyConcatenation180->definitionLine = 231;
  block_savedest(self);
  Object closure221 = createclosure(1, "lazyConcatenation()object");
  setclosureframe(closure221, stackframe);
  addtoclosure(closure221, var_enumerable);
  Method *meth_meth_collectionsPrelude_lazyConcatenation180_object = addmethod2pos(self, "lazyConcatenation()object", &meth_collectionsPrelude_lazyConcatenation180_object, 5);
  meth_meth_collectionsPrelude_lazyConcatenation180_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_lazyConcatenation180_object->definitionLine = 231;
// compiled method node returning  (depth = 1)
// Begin line 418
  setline(418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "max"
  struct UserObject *uo222 = (struct UserObject*)self;
  uo222->data[6] = emptyclosure;
  Method *meth_meth_collectionsPrelude_max222 = addmethod2pos(self, "max", &meth_collectionsPrelude_max222, 6);
  int argcv_meth_collectionsPrelude_max222[] = {2};
  meth_meth_collectionsPrelude_max222->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_max222);
  meth_meth_collectionsPrelude_max222->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_collectionsPrelude_max222->definitionModule = modulename;
  meth_meth_collectionsPrelude_max222->definitionLine = 418;
// compiled method node returning  (depth = 1)
// Begin line 453
  setline(453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "sequence"
  block_savedest(self);
  Object closure227 = createclosure(5, "sequence");
  setclosureframe(closure227, stackframe);
  addtoclosure(closure227, var_emptySequence);
  addtoclosure(closure227, var__prelude);
  addtoclosure(closure227, var_BoundsError);
  addtoclosure(closure227, var_IteratorExhausted);
  addtoclosure(closure227, var_indexable);
  struct UserObject *uo227 = (struct UserObject*)self;
  uo227->data[7] = (Object)closure227;
  Method *meth_meth_collectionsPrelude_sequence227 = addmethod2pos(self, "sequence", &meth_collectionsPrelude_sequence227, 7);
  int argcv_meth_collectionsPrelude_sequence227[] = {0};
  meth_meth_collectionsPrelude_sequence227->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sequence227);
  meth_meth_collectionsPrelude_sequence227->definitionModule = modulename;
  meth_meth_collectionsPrelude_sequence227->definitionLine = 453;
  block_savedest(self);
  Object closure657 = createclosure(5, "sequence()object");
  setclosureframe(closure657, stackframe);
  addtoclosure(closure657, var_emptySequence);
  addtoclosure(closure657, var__prelude);
  addtoclosure(closure657, var_BoundsError);
  addtoclosure(closure657, var_IteratorExhausted);
  addtoclosure(closure657, var_indexable);
  Method *meth_meth_collectionsPrelude_sequence227_object = addmethod2pos(self, "sequence()object", &meth_collectionsPrelude_sequence227_object, 7);
  meth_meth_collectionsPrelude_sequence227_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_sequence227_object->definitionLine = 453;
// compiled method node returning  (depth = 1)
// Begin line 594
  setline(594);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "isEqual()toIterable"
  block_savedest(self);
  Object closure658 = createclosure(1, "isEqual()toIterable");
  setclosureframe(closure658, stackframe);
  addtoclosure(closure658, var_MinimalyIterable);
  struct UserObject *uo658 = (struct UserObject*)self;
  uo658->data[8] = (Object)closure658;
  Method *meth_meth_collectionsPrelude_isEqual_40__41_toIterable658 = addmethod2pos(self, "isEqual()toIterable", &meth_collectionsPrelude_isEqual_40__41_toIterable658, 8);
  int argcv_meth_collectionsPrelude_isEqual_40__41_toIterable658[] = {1, 1};
  meth_meth_collectionsPrelude_isEqual_40__41_toIterable658->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_isEqual_40__41_toIterable658);
  meth_meth_collectionsPrelude_isEqual_40__41_toIterable658->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEqual_40__41_toIterable658->definitionLine = 594;
// compiled method node returning  (depth = 1)
// Begin line 609
  setline(609);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "list"
  block_savedest(self);
  Object closure698 = createclosure(8, "list");
  setclosureframe(closure698, stackframe);
  addtoclosure(closure698, var_emptySequence);
  addtoclosure(closure698, var_NoSuchObject);
  addtoclosure(closure698, var_done);
  addtoclosure(closure698, var_ConcurrentModification);
  addtoclosure(closure698, var_IteratorExhausted);
  addtoclosure(closure698, var_indexable);
  addtoclosure(closure698, var_BoundsError);
  addtoclosure(closure698, var__prelude);
  struct UserObject *uo698 = (struct UserObject*)self;
  uo698->data[9] = (Object)closure698;
  Method *meth_meth_collectionsPrelude_list698 = addmethod2pos(self, "list", &meth_collectionsPrelude_list698, 9);
  int argcv_meth_collectionsPrelude_list698[] = {0};
  meth_meth_collectionsPrelude_list698->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_list698);
  meth_meth_collectionsPrelude_list698->definitionModule = modulename;
  meth_meth_collectionsPrelude_list698->definitionLine = 609;
  block_savedest(self);
  Object closure2256 = createclosure(8, "list()object");
  setclosureframe(closure2256, stackframe);
  addtoclosure(closure2256, var_emptySequence);
  addtoclosure(closure2256, var_NoSuchObject);
  addtoclosure(closure2256, var_done);
  addtoclosure(closure2256, var_ConcurrentModification);
  addtoclosure(closure2256, var_IteratorExhausted);
  addtoclosure(closure2256, var_indexable);
  addtoclosure(closure2256, var_BoundsError);
  addtoclosure(closure2256, var__prelude);
  Method *meth_meth_collectionsPrelude_list698_object = addmethod2pos(self, "list()object", &meth_collectionsPrelude_list698_object, 9);
  meth_meth_collectionsPrelude_list698_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_list698_object->definitionLine = 609;
// compiled method node returning  (depth = 1)
// Begin line 1163
  setline(1163);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "set"
  block_savedest(self);
  Object closure2257 = createclosure(8, "set");
  setclosureframe(closure2257, stackframe);
  addtoclosure(closure2257, var_NoSuchObject);
  addtoclosure(closure2257, var_removed);
  addtoclosure(closure2257, var_unused);
  addtoclosure(closure2257, var_ConcurrentModification);
  addtoclosure(closure2257, var_IteratorExhausted);
  addtoclosure(closure2257, var__prelude);
  addtoclosure(closure2257, var_Iterable);
  addtoclosure(closure2257, var_collection);
  struct UserObject *uo2257 = (struct UserObject*)self;
  uo2257->data[10] = (Object)closure2257;
  Method *meth_meth_collectionsPrelude_set2257 = addmethod2pos(self, "set", &meth_collectionsPrelude_set2257, 10);
  int argcv_meth_collectionsPrelude_set2257[] = {0};
  meth_meth_collectionsPrelude_set2257->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_set2257);
  meth_meth_collectionsPrelude_set2257->definitionModule = modulename;
  meth_meth_collectionsPrelude_set2257->definitionLine = 1163;
  block_savedest(self);
  Object closure3078 = createclosure(8, "set()object");
  setclosureframe(closure3078, stackframe);
  addtoclosure(closure3078, var_NoSuchObject);
  addtoclosure(closure3078, var_removed);
  addtoclosure(closure3078, var_unused);
  addtoclosure(closure3078, var_ConcurrentModification);
  addtoclosure(closure3078, var_IteratorExhausted);
  addtoclosure(closure3078, var__prelude);
  addtoclosure(closure3078, var_Iterable);
  addtoclosure(closure3078, var_collection);
  Method *meth_meth_collectionsPrelude_set2257_object = addmethod2pos(self, "set()object", &meth_collectionsPrelude_set2257_object, 10);
  meth_meth_collectionsPrelude_set2257_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_set2257_object->definitionLine = 1163;
// compiled method node returning  (depth = 1)
// Begin line 1475
  setline(1475);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "dictionary"
  block_savedest(self);
  Object closure3079 = createclosure(10, "dictionary");
  setclosureframe(closure3079, stackframe);
  addtoclosure(closure3079, var_removed);
  addtoclosure(closure3079, var_unused);
  addtoclosure(closure3079, var_binding);
  addtoclosure(closure3079, var_NoSuchObject);
  addtoclosure(closure3079, var_enumerable);
  addtoclosure(closure3079, var_ConcurrentModification);
  addtoclosure(closure3079, var_IteratorExhausted);
  addtoclosure(closure3079, var__prelude);
  addtoclosure(closure3079, var_ComparableToDictionary);
  addtoclosure(closure3079, var_collection);
  struct UserObject *uo3079 = (struct UserObject*)self;
  uo3079->data[11] = (Object)closure3079;
  Method *meth_meth_collectionsPrelude_dictionary3079 = addmethod2pos(self, "dictionary", &meth_collectionsPrelude_dictionary3079, 11);
  int argcv_meth_collectionsPrelude_dictionary3079[] = {0};
  meth_meth_collectionsPrelude_dictionary3079->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_dictionary3079);
  meth_meth_collectionsPrelude_dictionary3079->definitionModule = modulename;
  meth_meth_collectionsPrelude_dictionary3079->definitionLine = 1475;
  block_savedest(self);
  Object closure4410 = createclosure(10, "dictionary()object");
  setclosureframe(closure4410, stackframe);
  addtoclosure(closure4410, var_removed);
  addtoclosure(closure4410, var_unused);
  addtoclosure(closure4410, var_binding);
  addtoclosure(closure4410, var_NoSuchObject);
  addtoclosure(closure4410, var_enumerable);
  addtoclosure(closure4410, var_ConcurrentModification);
  addtoclosure(closure4410, var_IteratorExhausted);
  addtoclosure(closure4410, var__prelude);
  addtoclosure(closure4410, var_ComparableToDictionary);
  addtoclosure(closure4410, var_collection);
  Method *meth_meth_collectionsPrelude_dictionary3079_object = addmethod2pos(self, "dictionary()object", &meth_collectionsPrelude_dictionary3079_object, 11);
  meth_meth_collectionsPrelude_dictionary3079_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_dictionary3079_object->definitionLine = 1475;
// compiled method node returning  (depth = 1)
// Begin line 1840
  setline(1840);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "range"
  block_savedest(self);
  Object closure4411 = createclosure(6, "range");
  setclosureframe(closure4411, stackframe);
  addtoclosure(closure4411, var_Number);
  addtoclosure(closure4411, var_RequestError);
  addtoclosure(closure4411, var_IteratorExhausted);
  addtoclosure(closure4411, var_BoundsError);
  addtoclosure(closure4411, var__prelude);
  addtoclosure(closure4411, var_indexable);
  struct UserObject *uo4411 = (struct UserObject*)self;
  uo4411->data[12] = (Object)closure4411;
  Method *meth_meth_collectionsPrelude_range4411 = addmethod2pos(self, "range", &meth_collectionsPrelude_range4411, 12);
  int argcv_meth_collectionsPrelude_range4411[] = {0};
  meth_meth_collectionsPrelude_range4411->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_range4411);
  meth_meth_collectionsPrelude_range4411->definitionModule = modulename;
  meth_meth_collectionsPrelude_range4411->definitionLine = 1840;
  block_savedest(self);
  Object closure5382 = createclosure(6, "range()object");
  setclosureframe(closure5382, stackframe);
  addtoclosure(closure5382, var_Number);
  addtoclosure(closure5382, var_RequestError);
  addtoclosure(closure5382, var_IteratorExhausted);
  addtoclosure(closure5382, var_BoundsError);
  addtoclosure(closure5382, var__prelude);
  addtoclosure(closure5382, var_indexable);
  Method *meth_meth_collectionsPrelude_range4411_object = addmethod2pos(self, "range()object", &meth_collectionsPrelude_range4411_object, 12);
  meth_meth_collectionsPrelude_range4411_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_range4411_object->definitionLine = 1840;
// compiled method node returning  (depth = 1)
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5383 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5384 == NULL) {
    strlit5384 = alloc_String("BoundsError");
    gc_root(strlit5384);
  }
// compiled string node returning strlit5384 (depth = 3)
  gc_frame_newslot(strlit5384);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5385 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5386 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5385);
// compiled call node returning call5386 (depth = 4)
// compiled member node returning call5386 (depth = 3)
  params[0] = strlit5384;
  partcv[0] = 1;
  Object call5387 = callmethod(call5386, "refine",
    1, partcv, params);
  gc_frame_end(callframe5383);
// compiled call node returning call5387 (depth = 2)
  *var_BoundsError = call5387;
  if (call5387 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method "BoundsError"
  block_savedest(self);
  Object closure5388 = createclosure(1, "BoundsError");
  setclosureframe(closure5388, stackframe);
  addtoclosure(closure5388, var_BoundsError);
  struct UserObject *uo5388 = (struct UserObject*)self;
  uo5388->data[13] = (Object)closure5388;
  Method *meth_meth_collectionsPrelude_BoundsError5388 = addmethod2pos(self, "BoundsError", &meth_collectionsPrelude_BoundsError5388, 13);
  int argcv_meth_collectionsPrelude_BoundsError5388[] = {0};
  meth_meth_collectionsPrelude_BoundsError5388->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_BoundsError5388);
  meth_meth_collectionsPrelude_BoundsError5388->definitionModule = modulename;
  meth_meth_collectionsPrelude_BoundsError5388->definitionLine = 3;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5389 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5390 == NULL) {
    strlit5390 = alloc_String("IteratorExhausted");
    gc_root(strlit5390);
  }
// compiled string node returning strlit5390 (depth = 3)
  gc_frame_newslot(strlit5390);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5391 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5392 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5391);
// compiled call node returning call5392 (depth = 4)
// compiled member node returning call5392 (depth = 3)
  params[0] = strlit5390;
  partcv[0] = 1;
  Object call5393 = callmethod(call5392, "refine",
    1, partcv, params);
  gc_frame_end(callframe5389);
// compiled call node returning call5393 (depth = 2)
  *var_IteratorExhausted = call5393;
  if (call5393 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method "IteratorExhausted"
  block_savedest(self);
  Object closure5394 = createclosure(1, "IteratorExhausted");
  setclosureframe(closure5394, stackframe);
  addtoclosure(closure5394, var_IteratorExhausted);
  struct UserObject *uo5394 = (struct UserObject*)self;
  uo5394->data[14] = (Object)closure5394;
  Method *meth_meth_collectionsPrelude_IteratorExhausted5394 = addmethod2pos(self, "IteratorExhausted", &meth_collectionsPrelude_IteratorExhausted5394, 14);
  int argcv_meth_collectionsPrelude_IteratorExhausted5394[] = {0};
  meth_meth_collectionsPrelude_IteratorExhausted5394->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_IteratorExhausted5394);
  meth_meth_collectionsPrelude_IteratorExhausted5394->definitionModule = modulename;
  meth_meth_collectionsPrelude_IteratorExhausted5394->definitionLine = 4;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 5
  setline(5);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5395 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5396 == NULL) {
    strlit5396 = alloc_String("SubobjectResponsibility");
    gc_root(strlit5396);
  }
// compiled string node returning strlit5396 (depth = 3)
  gc_frame_newslot(strlit5396);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5397 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5398 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5397);
// compiled call node returning call5398 (depth = 4)
// compiled member node returning call5398 (depth = 3)
  params[0] = strlit5396;
  partcv[0] = 1;
  Object call5399 = callmethod(call5398, "refine",
    1, partcv, params);
  gc_frame_end(callframe5395);
// compiled call node returning call5399 (depth = 2)
  *var_SubobjectResponsibility = call5399;
  if (call5399 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method "SubobjectResponsibility"
  block_savedest(self);
  Object closure5400 = createclosure(1, "SubobjectResponsibility");
  setclosureframe(closure5400, stackframe);
  addtoclosure(closure5400, var_SubobjectResponsibility);
  struct UserObject *uo5400 = (struct UserObject*)self;
  uo5400->data[15] = (Object)closure5400;
  Method *meth_meth_collectionsPrelude_SubobjectResponsibility5400 = addmethod2pos(self, "SubobjectResponsibility", &meth_collectionsPrelude_SubobjectResponsibility5400, 15);
  int argcv_meth_collectionsPrelude_SubobjectResponsibility5400[] = {0};
  meth_meth_collectionsPrelude_SubobjectResponsibility5400->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_SubobjectResponsibility5400);
  meth_meth_collectionsPrelude_SubobjectResponsibility5400->definitionModule = modulename;
  meth_meth_collectionsPrelude_SubobjectResponsibility5400->definitionLine = 5;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 6
  setline(6);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5401 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5402 == NULL) {
    strlit5402 = alloc_String("NoSuchObject");
    gc_root(strlit5402);
  }
// compiled string node returning strlit5402 (depth = 3)
  gc_frame_newslot(strlit5402);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5403 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5404 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5403);
// compiled call node returning call5404 (depth = 4)
// compiled member node returning call5404 (depth = 3)
  params[0] = strlit5402;
  partcv[0] = 1;
  Object call5405 = callmethod(call5404, "refine",
    1, partcv, params);
  gc_frame_end(callframe5401);
// compiled call node returning call5405 (depth = 2)
  *var_NoSuchObject = call5405;
  if (call5405 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method "NoSuchObject"
  block_savedest(self);
  Object closure5406 = createclosure(1, "NoSuchObject");
  setclosureframe(closure5406, stackframe);
  addtoclosure(closure5406, var_NoSuchObject);
  struct UserObject *uo5406 = (struct UserObject*)self;
  uo5406->data[16] = (Object)closure5406;
  Method *meth_meth_collectionsPrelude_NoSuchObject5406 = addmethod2pos(self, "NoSuchObject", &meth_collectionsPrelude_NoSuchObject5406, 16);
  int argcv_meth_collectionsPrelude_NoSuchObject5406[] = {0};
  meth_meth_collectionsPrelude_NoSuchObject5406->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_NoSuchObject5406);
  meth_meth_collectionsPrelude_NoSuchObject5406->definitionModule = modulename;
  meth_meth_collectionsPrelude_NoSuchObject5406->definitionLine = 6;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 7
  setline(7);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5407 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5408 == NULL) {
    strlit5408 = alloc_String("RequestError");
    gc_root(strlit5408);
  }
// compiled string node returning strlit5408 (depth = 3)
  gc_frame_newslot(strlit5408);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5409 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5410 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5409);
// compiled call node returning call5410 (depth = 4)
// compiled member node returning call5410 (depth = 3)
  params[0] = strlit5408;
  partcv[0] = 1;
  Object call5411 = callmethod(call5410, "refine",
    1, partcv, params);
  gc_frame_end(callframe5407);
// compiled call node returning call5411 (depth = 2)
  *var_RequestError = call5411;
  if (call5411 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method "RequestError"
  block_savedest(self);
  Object closure5412 = createclosure(1, "RequestError");
  setclosureframe(closure5412, stackframe);
  addtoclosure(closure5412, var_RequestError);
  struct UserObject *uo5412 = (struct UserObject*)self;
  uo5412->data[17] = (Object)closure5412;
  Method *meth_meth_collectionsPrelude_RequestError5412 = addmethod2pos(self, "RequestError", &meth_collectionsPrelude_RequestError5412, 17);
  int argcv_meth_collectionsPrelude_RequestError5412[] = {0};
  meth_meth_collectionsPrelude_RequestError5412->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_RequestError5412);
  meth_meth_collectionsPrelude_RequestError5412->definitionModule = modulename;
  meth_meth_collectionsPrelude_RequestError5412->definitionLine = 7;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 8
  setline(8);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5413 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5414 == NULL) {
    strlit5414 = alloc_String("ConcurrentModification");
    gc_root(strlit5414);
  }
// compiled string node returning strlit5414 (depth = 3)
  gc_frame_newslot(strlit5414);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5415 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5416 = callmethodflags(prelude, "ProgrammingError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5415);
// compiled call node returning call5416 (depth = 4)
// compiled member node returning call5416 (depth = 3)
  params[0] = strlit5414;
  partcv[0] = 1;
  Object call5417 = callmethod(call5416, "refine",
    1, partcv, params);
  gc_frame_end(callframe5413);
// compiled call node returning call5417 (depth = 2)
  *var_ConcurrentModification = call5417;
  if (call5417 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method "ConcurrentModification"
  block_savedest(self);
  Object closure5418 = createclosure(1, "ConcurrentModification");
  setclosureframe(closure5418, stackframe);
  addtoclosure(closure5418, var_ConcurrentModification);
  struct UserObject *uo5418 = (struct UserObject*)self;
  uo5418->data[18] = (Object)closure5418;
  Method *meth_meth_collectionsPrelude_ConcurrentModification5418 = addmethod2pos(self, "ConcurrentModification", &meth_collectionsPrelude_ConcurrentModification5418, 18);
  int argcv_meth_collectionsPrelude_ConcurrentModification5418[] = {0};
  meth_meth_collectionsPrelude_ConcurrentModification5418->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_ConcurrentModification5418);
  meth_meth_collectionsPrelude_ConcurrentModification5418->definitionModule = modulename;
  meth_meth_collectionsPrelude_ConcurrentModification5418->definitionLine = 8;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile call node (depth = 2)
  int callframe5419 = gc_frame_new();
// starting to compile string node (depth = 3)
  if (strlit5420 == NULL) {
    strlit5420 = alloc_String("SizeUnknown");
    gc_root(strlit5420);
  }
// compiled string node returning strlit5420 (depth = 3)
  gc_frame_newslot(strlit5420);
// call case 6: other member request
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe5421 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call5422 = callmethodflags(prelude, "Exception", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe5421);
// compiled call node returning call5422 (depth = 4)
// compiled member node returning call5422 (depth = 3)
  params[0] = strlit5420;
  partcv[0] = 1;
  Object call5423 = callmethod(call5422, "refine",
    1, partcv, params);
  gc_frame_end(callframe5419);
// compiled call node returning call5423 (depth = 2)
  *var_SizeUnknown = call5423;
  if (call5423 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// starting to compile method node (depth = 2)
// method "SizeUnknown"
  block_savedest(self);
  Object closure5424 = createclosure(1, "SizeUnknown");
  setclosureframe(closure5424, stackframe);
  addtoclosure(closure5424, var_SizeUnknown);
  struct UserObject *uo5424 = (struct UserObject*)self;
  uo5424->data[19] = (Object)closure5424;
  Method *meth_meth_collectionsPrelude_SizeUnknown5424 = addmethod2pos(self, "SizeUnknown", &meth_collectionsPrelude_SizeUnknown5424, 19);
  int argcv_meth_collectionsPrelude_SizeUnknown5424[] = {0};
  meth_meth_collectionsPrelude_SizeUnknown5424->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_SizeUnknown5424);
  meth_meth_collectionsPrelude_SizeUnknown5424->definitionModule = modulename;
  meth_meth_collectionsPrelude_SizeUnknown5424->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 10
  setline(10);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Block0
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type5426 = alloc_Type("Block0", 1);
    add_Method((ClassData)type5426, "apply", NULL);
// compiled typeliteral node returning type5426 (depth = 2)
  *var_Block0 = type5426;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Block0"
  block_savedest(self);
  Object closure5427 = createclosure(1, "Block0");
  setclosureframe(closure5427, stackframe);
  addtoclosure(closure5427, var_Block0);
  struct UserObject *uo5427 = (struct UserObject*)self;
  uo5427->data[20] = (Object)closure5427;
  Method *meth_meth_collectionsPrelude_Block05427 = addmethod2pos(self, "Block0", &meth_collectionsPrelude_Block05427, 20);
  int argcv_meth_collectionsPrelude_Block05427[] = {0};
  meth_meth_collectionsPrelude_Block05427->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Block05427);
  meth_meth_collectionsPrelude_Block05427->definitionModule = modulename;
  meth_meth_collectionsPrelude_Block05427->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 19
  setline(19);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 20
  setline(20);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Block1
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type5429 = alloc_Type("Block1", 1);
    add_Method((ClassData)type5429, "apply", NULL);
// compiled typeliteral node returning type5429 (depth = 2)
  *var_Block1 = type5429;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Block1"
  block_savedest(self);
  Object closure5430 = createclosure(1, "Block1");
  setclosureframe(closure5430, stackframe);
  addtoclosure(closure5430, var_Block1);
  struct UserObject *uo5430 = (struct UserObject*)self;
  uo5430->data[21] = (Object)closure5430;
  Method *meth_meth_collectionsPrelude_Block15430 = addmethod2pos(self, "Block1", &meth_collectionsPrelude_Block15430, 21);
  int argcv_meth_collectionsPrelude_Block15430[] = {0};
  meth_meth_collectionsPrelude_Block15430->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Block15430);
  meth_meth_collectionsPrelude_Block15430->definitionModule = modulename;
  meth_meth_collectionsPrelude_Block15430->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 23
  setline(23);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Block2
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type5432 = alloc_Type("Block2", 1);
    add_Method((ClassData)type5432, "apply", NULL);
// compiled typeliteral node returning type5432 (depth = 2)
  *var_Block2 = type5432;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Block2"
  block_savedest(self);
  Object closure5433 = createclosure(1, "Block2");
  setclosureframe(closure5433, stackframe);
  addtoclosure(closure5433, var_Block2);
  struct UserObject *uo5433 = (struct UserObject*)self;
  uo5433->data[22] = (Object)closure5433;
  Method *meth_meth_collectionsPrelude_Block25433 = addmethod2pos(self, "Block2", &meth_collectionsPrelude_Block25433, 22);
  int argcv_meth_collectionsPrelude_Block25433[] = {0};
  meth_meth_collectionsPrelude_Block25433->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Block25433);
  meth_meth_collectionsPrelude_Block25433->definitionModule = modulename;
  meth_meth_collectionsPrelude_Block25433->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 27
  setline(27);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl SelfType
// starting to compile identifier node (depth = 2)
// compiled identifier node returning *var_Unknown (depth = 2)
  *var_SelfType = *var_Unknown;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "SelfType"
  block_savedest(self);
  Object closure5435 = createclosure(1, "SelfType");
  setclosureframe(closure5435, stackframe);
  addtoclosure(closure5435, var_SelfType);
  struct UserObject *uo5435 = (struct UserObject*)self;
  uo5435->data[23] = (Object)closure5435;
  Method *meth_meth_collectionsPrelude_SelfType5435 = addmethod2pos(self, "SelfType", &meth_collectionsPrelude_SelfType5435, 23);
  int argcv_meth_collectionsPrelude_SelfType5435[] = {0};
  meth_meth_collectionsPrelude_SelfType5435->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_SelfType5435);
  meth_meth_collectionsPrelude_SelfType5435->definitionModule = modulename;
  meth_meth_collectionsPrelude_SelfType5435->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 29
  setline(29);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 30
  setline(30);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Iterable
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5438 = alloc_Type("‹anon›", 11);
    add_Method((ClassData)type5438, "iterator", NULL);
    add_Method((ClassData)type5438, "isEmpty", NULL);
    add_Method((ClassData)type5438, "size", NULL);
    add_Method((ClassData)type5438, "sizeIfUnknown", NULL);
    add_Method((ClassData)type5438, "first", NULL);
    add_Method((ClassData)type5438, "do", NULL);
    add_Method((ClassData)type5438, "do()separatedBy", NULL);
    add_Method((ClassData)type5438, "++", NULL);
    add_Method((ClassData)type5438, "fold()startingWith", NULL);
    add_Method((ClassData)type5438, "map", NULL);
    add_Method((ClassData)type5438, "filter", NULL);
// compiled typeliteral node returning type5438 (depth = 3)
  int op_slot_right_5437 = gc_frame_newslot(type5438);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Object (depth = 3)
  int op_slot_left_5437 = gc_frame_newslot(*var_Object);
  params[0] = type5438;
  partcv[0] = 1;
  Object opresult5440 = callmethod(*var_Object, "&", 1, partcv, params);
// compiled op node returning opresult5440 (depth = 2)
  *var_Iterable = opresult5440;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Iterable"
  block_savedest(self);
  Object closure5441 = createclosure(1, "Iterable");
  setclosureframe(closure5441, stackframe);
  addtoclosure(closure5441, var_Iterable);
  struct UserObject *uo5441 = (struct UserObject*)self;
  uo5441->data[24] = (Object)closure5441;
  Method *meth_meth_collectionsPrelude_Iterable5441 = addmethod2pos(self, "Iterable", &meth_collectionsPrelude_Iterable5441, 24);
  int argcv_meth_collectionsPrelude_Iterable5441[] = {0};
  meth_meth_collectionsPrelude_Iterable5441->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Iterable5441);
  meth_meth_collectionsPrelude_Iterable5441->definitionModule = modulename;
  meth_meth_collectionsPrelude_Iterable5441->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Expandable
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5444 = alloc_Type("‹anon›", 2);
    add_Method((ClassData)type5444, "add", NULL);
    add_Method((ClassData)type5444, "addAll", NULL);
// compiled typeliteral node returning type5444 (depth = 3)
  int op_slot_right_5443 = gc_frame_newslot(type5444);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Iterable (depth = 3)
  int op_slot_left_5443 = gc_frame_newslot(*var_Iterable);
  params[0] = type5444;
  partcv[0] = 1;
  Object opresult5446 = callmethod(*var_Iterable, "&", 1, partcv, params);
// compiled op node returning opresult5446 (depth = 2)
  *var_Expandable = opresult5446;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Expandable"
  block_savedest(self);
  Object closure5447 = createclosure(1, "Expandable");
  setclosureframe(closure5447, stackframe);
  addtoclosure(closure5447, var_Expandable);
  struct UserObject *uo5447 = (struct UserObject*)self;
  uo5447->data[25] = (Object)closure5447;
  Method *meth_meth_collectionsPrelude_Expandable5447 = addmethod2pos(self, "Expandable", &meth_collectionsPrelude_Expandable5447, 25);
  int argcv_meth_collectionsPrelude_Expandable5447[] = {0};
  meth_meth_collectionsPrelude_Expandable5447->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Expandable5447);
  meth_meth_collectionsPrelude_Expandable5447->definitionModule = modulename;
  meth_meth_collectionsPrelude_Expandable5447->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Collection
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5450 = alloc_Type("‹anon›", 3);
    add_Method((ClassData)type5450, "asList", NULL);
    add_Method((ClassData)type5450, "asSequence", NULL);
    add_Method((ClassData)type5450, "asSet", NULL);
// compiled typeliteral node returning type5450 (depth = 3)
  int op_slot_right_5449 = gc_frame_newslot(type5450);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Iterable (depth = 3)
  int op_slot_left_5449 = gc_frame_newslot(*var_Iterable);
  params[0] = type5450;
  partcv[0] = 1;
  Object opresult5452 = callmethod(*var_Iterable, "&", 1, partcv, params);
// compiled op node returning opresult5452 (depth = 2)
  *var_Collection = opresult5452;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Collection"
  block_savedest(self);
  Object closure5453 = createclosure(1, "Collection");
  setclosureframe(closure5453, stackframe);
  addtoclosure(closure5453, var_Collection);
  struct UserObject *uo5453 = (struct UserObject*)self;
  uo5453->data[26] = (Object)closure5453;
  Method *meth_meth_collectionsPrelude_Collection5453 = addmethod2pos(self, "Collection", &meth_collectionsPrelude_Collection5453, 26);
  int argcv_meth_collectionsPrelude_Collection5453[] = {0};
  meth_meth_collectionsPrelude_Collection5453->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Collection5453);
  meth_meth_collectionsPrelude_Collection5453->definitionModule = modulename;
  meth_meth_collectionsPrelude_Collection5453->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 66
  setline(66);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 67
  setline(67);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Enumerable
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5456 = alloc_Type("‹anon›", 6);
    add_Method((ClassData)type5456, "values", NULL);
    add_Method((ClassData)type5456, "asDictionary", NULL);
    add_Method((ClassData)type5456, "keysAndValuesDo", NULL);
    add_Method((ClassData)type5456, "into", NULL);
    add_Method((ClassData)type5456, "sortedBy", NULL);
    add_Method((ClassData)type5456, "sorted", NULL);
// compiled typeliteral node returning type5456 (depth = 3)
  int op_slot_right_5455 = gc_frame_newslot(type5456);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Collection (depth = 3)
  int op_slot_left_5455 = gc_frame_newslot(*var_Collection);
  params[0] = type5456;
  partcv[0] = 1;
  Object opresult5458 = callmethod(*var_Collection, "&", 1, partcv, params);
// compiled op node returning opresult5458 (depth = 2)
  *var_Enumerable = opresult5458;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Enumerable"
  block_savedest(self);
  Object closure5459 = createclosure(1, "Enumerable");
  setclosureframe(closure5459, stackframe);
  addtoclosure(closure5459, var_Enumerable);
  struct UserObject *uo5459 = (struct UserObject*)self;
  uo5459->data[27] = (Object)closure5459;
  Method *meth_meth_collectionsPrelude_Enumerable5459 = addmethod2pos(self, "Enumerable", &meth_collectionsPrelude_Enumerable5459, 27);
  int argcv_meth_collectionsPrelude_Enumerable5459[] = {0};
  meth_meth_collectionsPrelude_Enumerable5459->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Enumerable5459);
  meth_meth_collectionsPrelude_Enumerable5459->definitionModule = modulename;
  meth_meth_collectionsPrelude_Enumerable5459->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 75
  setline(75);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 76
  setline(76);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Sequence
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5462 = alloc_Type("‹anon›", 13);
    add_Method((ClassData)type5462, "size", NULL);
    add_Method((ClassData)type5462, "at", NULL);
    add_Method((ClassData)type5462, "indices", NULL);
    add_Method((ClassData)type5462, "keys", NULL);
    add_Method((ClassData)type5462, "second", NULL);
    add_Method((ClassData)type5462, "third", NULL);
    add_Method((ClassData)type5462, "fourth", NULL);
    add_Method((ClassData)type5462, "fifth", NULL);
    add_Method((ClassData)type5462, "last", NULL);
    add_Method((ClassData)type5462, "indexOf()ifAbsent", NULL);
    add_Method((ClassData)type5462, "indexOf", NULL);
    add_Method((ClassData)type5462, "contains", NULL);
    add_Method((ClassData)type5462, "reversed", NULL);
// compiled typeliteral node returning type5462 (depth = 3)
  int op_slot_right_5461 = gc_frame_newslot(type5462);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Enumerable (depth = 3)
  int op_slot_left_5461 = gc_frame_newslot(*var_Enumerable);
  params[0] = type5462;
  partcv[0] = 1;
  Object opresult5464 = callmethod(*var_Enumerable, "&", 1, partcv, params);
// compiled op node returning opresult5464 (depth = 2)
  *var_Sequence = opresult5464;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Sequence"
  block_savedest(self);
  Object closure5465 = createclosure(1, "Sequence");
  setclosureframe(closure5465, stackframe);
  addtoclosure(closure5465, var_Sequence);
  struct UserObject *uo5465 = (struct UserObject*)self;
  uo5465->data[28] = (Object)closure5465;
  Method *meth_meth_collectionsPrelude_Sequence5465 = addmethod2pos(self, "Sequence", &meth_collectionsPrelude_Sequence5465, 28);
  int argcv_meth_collectionsPrelude_Sequence5465[] = {0};
  meth_meth_collectionsPrelude_Sequence5465->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Sequence5465);
  meth_meth_collectionsPrelude_Sequence5465->definitionModule = modulename;
  meth_meth_collectionsPrelude_Sequence5465->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 92
  setline(92);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl List
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5468 = alloc_Type("‹anon›", 21);
    add_Method((ClassData)type5468, "add", NULL);
    add_Method((ClassData)type5468, "addAll", NULL);
    add_Method((ClassData)type5468, "addFirst", NULL);
    add_Method((ClassData)type5468, "addAllFirst", NULL);
    add_Method((ClassData)type5468, "addLast", NULL);
    add_Method((ClassData)type5468, "at()put", NULL);
    add_Method((ClassData)type5468, "removeFirst", NULL);
    add_Method((ClassData)type5468, "removeAt", NULL);
    add_Method((ClassData)type5468, "removeLast", NULL);
    add_Method((ClassData)type5468, "remove", NULL);
    add_Method((ClassData)type5468, "remove()ifAbsent", NULL);
    add_Method((ClassData)type5468, "removeAll", NULL);
    add_Method((ClassData)type5468, "removeAll()ifAbsent", NULL);
    add_Method((ClassData)type5468, "pop", NULL);
    add_Method((ClassData)type5468, "++", NULL);
    add_Method((ClassData)type5468, "addAll", NULL);
    add_Method((ClassData)type5468, "copy", NULL);
    add_Method((ClassData)type5468, "sort", NULL);
    add_Method((ClassData)type5468, "sortBy", NULL);
    add_Method((ClassData)type5468, "reverse", NULL);
    add_Method((ClassData)type5468, "reversed", NULL);
// compiled typeliteral node returning type5468 (depth = 3)
  int op_slot_right_5467 = gc_frame_newslot(type5468);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Sequence (depth = 3)
  int op_slot_left_5467 = gc_frame_newslot(*var_Sequence);
  params[0] = type5468;
  partcv[0] = 1;
  Object opresult5470 = callmethod(*var_Sequence, "&", 1, partcv, params);
// compiled op node returning opresult5470 (depth = 2)
  *var_List = opresult5470;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "List"
  block_savedest(self);
  Object closure5471 = createclosure(1, "List");
  setclosureframe(closure5471, stackframe);
  addtoclosure(closure5471, var_List);
  struct UserObject *uo5471 = (struct UserObject*)self;
  uo5471->data[29] = (Object)closure5471;
  Method *meth_meth_collectionsPrelude_List5471 = addmethod2pos(self, "List", &meth_collectionsPrelude_List5471, 29);
  int argcv_meth_collectionsPrelude_List5471[] = {0};
  meth_meth_collectionsPrelude_List5471->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_List5471);
  meth_meth_collectionsPrelude_List5471->definitionModule = modulename;
  meth_meth_collectionsPrelude_List5471->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 115
  setline(115);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 116
  setline(116);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Set
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5474 = alloc_Type("‹anon›", 17);
    add_Method((ClassData)type5474, "size", NULL);
    add_Method((ClassData)type5474, "add", NULL);
    add_Method((ClassData)type5474, "addAll", NULL);
    add_Method((ClassData)type5474, "remove", NULL);
    add_Method((ClassData)type5474, "remove()ifAbsent", NULL);
    add_Method((ClassData)type5474, "includes", NULL);
    add_Method((ClassData)type5474, "find()ifNone", NULL);
    add_Method((ClassData)type5474, "copy", NULL);
    add_Method((ClassData)type5474, "contains", NULL);
    add_Method((ClassData)type5474, "**", NULL);
    add_Method((ClassData)type5474, "--", NULL);
    add_Method((ClassData)type5474, "++", NULL);
    add_Method((ClassData)type5474, "isSubset", NULL);
    add_Method((ClassData)type5474, "isSuperset", NULL);
    add_Method((ClassData)type5474, "removeAll", NULL);
    add_Method((ClassData)type5474, "removeAll()ifAbsent", NULL);
    add_Method((ClassData)type5474, "into", NULL);
// compiled typeliteral node returning type5474 (depth = 3)
  int op_slot_right_5473 = gc_frame_newslot(type5474);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Collection (depth = 3)
  int op_slot_left_5473 = gc_frame_newslot(*var_Collection);
  params[0] = type5474;
  partcv[0] = 1;
  Object opresult5476 = callmethod(*var_Collection, "&", 1, partcv, params);
// compiled op node returning opresult5476 (depth = 2)
  *var_Set = opresult5476;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Set"
  block_savedest(self);
  Object closure5477 = createclosure(1, "Set");
  setclosureframe(closure5477, stackframe);
  addtoclosure(closure5477, var_Set);
  struct UserObject *uo5477 = (struct UserObject*)self;
  uo5477->data[30] = (Object)closure5477;
  Method *meth_meth_collectionsPrelude_Set5477 = addmethod2pos(self, "Set", &meth_collectionsPrelude_Set5477, 30);
  int argcv_meth_collectionsPrelude_Set5477[] = {0};
  meth_meth_collectionsPrelude_Set5477->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Set5477);
  meth_meth_collectionsPrelude_Set5477->definitionModule = modulename;
  meth_meth_collectionsPrelude_Set5477->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Dictionary
// starting to compile op node (depth = 2)
// starting to compile typeliteral node (depth = 3)
//   Type literal 
    Object type5480 = alloc_Type("‹anon›", 22);
    add_Method((ClassData)type5480, "size", NULL);
    add_Method((ClassData)type5480, "containsKey", NULL);
    add_Method((ClassData)type5480, "containsValue", NULL);
    add_Method((ClassData)type5480, "contains", NULL);
    add_Method((ClassData)type5480, "at()ifAbsent", NULL);
    add_Method((ClassData)type5480, "at()put", NULL);
    add_Method((ClassData)type5480, "at", NULL);
    add_Method((ClassData)type5480, "removeAllKeys", NULL);
    add_Method((ClassData)type5480, "removeKey", NULL);
    add_Method((ClassData)type5480, "removeAllValues", NULL);
    add_Method((ClassData)type5480, "removeValue", NULL);
    add_Method((ClassData)type5480, "keys", NULL);
    add_Method((ClassData)type5480, "values", NULL);
    add_Method((ClassData)type5480, "bindings", NULL);
    add_Method((ClassData)type5480, "keysAndValuesDo", NULL);
    add_Method((ClassData)type5480, "keysDo", NULL);
    add_Method((ClassData)type5480, "valuesDo", NULL);
    add_Method((ClassData)type5480, "==", NULL);
    add_Method((ClassData)type5480, "copy", NULL);
    add_Method((ClassData)type5480, "++", NULL);
    add_Method((ClassData)type5480, "--", NULL);
    add_Method((ClassData)type5480, "asDictionary", NULL);
// compiled typeliteral node returning type5480 (depth = 3)
  int op_slot_right_5479 = gc_frame_newslot(type5480);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_Collection (depth = 3)
  int op_slot_left_5479 = gc_frame_newslot(*var_Collection);
  params[0] = type5480;
  partcv[0] = 1;
  Object opresult5482 = callmethod(*var_Collection, "&", 1, partcv, params);
// compiled op node returning opresult5482 (depth = 2)
  *var_Dictionary = opresult5482;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Dictionary"
  block_savedest(self);
  Object closure5483 = createclosure(1, "Dictionary");
  setclosureframe(closure5483, stackframe);
  addtoclosure(closure5483, var_Dictionary);
  struct UserObject *uo5483 = (struct UserObject*)self;
  uo5483->data[31] = (Object)closure5483;
  Method *meth_meth_collectionsPrelude_Dictionary5483 = addmethod2pos(self, "Dictionary", &meth_collectionsPrelude_Dictionary5483, 31);
  int argcv_meth_collectionsPrelude_Dictionary5483[] = {0};
  meth_meth_collectionsPrelude_Dictionary5483->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Dictionary5483);
  meth_meth_collectionsPrelude_Dictionary5483->definitionModule = modulename;
  meth_meth_collectionsPrelude_Dictionary5483->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 160
  setline(160);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 161
  setline(161);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Iterator
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type5485 = alloc_Type("Iterator", 2);
    add_Method((ClassData)type5485, "hasNext", NULL);
    add_Method((ClassData)type5485, "next", NULL);
// compiled typeliteral node returning type5485 (depth = 2)
  *var_Iterator = type5485;
// Begin line 9
  setline(9);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Iterator"
  block_savedest(self);
  Object closure5486 = createclosure(1, "Iterator");
  setclosureframe(closure5486, stackframe);
  addtoclosure(closure5486, var_Iterator);
  struct UserObject *uo5486 = (struct UserObject*)self;
  uo5486->data[32] = (Object)closure5486;
  Method *meth_meth_collectionsPrelude_Iterator5486 = addmethod2pos(self, "Iterator", &meth_collectionsPrelude_Iterator5486, 32);
  int argcv_meth_collectionsPrelude_Iterator5486[] = {0};
  meth_meth_collectionsPrelude_Iterator5486->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Iterator5486);
  meth_meth_collectionsPrelude_Iterator5486->definitionModule = modulename;
  meth_meth_collectionsPrelude_Iterator5486->definitionLine = 9;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 165
  setline(165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 179
  setline(179);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 215
  setline(215);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 240
  setline(240);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5487 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5487 = alloc_userobj2(3,4, objclass5487);
  gc_frame_newslot(obj5487);
if (objclass5487 == NULL) {
  glfree(obj5487->class->name);
  obj5487->class->name = "collection";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5487, self, 0);
  addmethodreal(obj5487,"outer", &reader_collectionsPrelude_outer_5488);
  Object oldself5487 = self;
  struct StackFrameObject *oldstackframe5487 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5487);
  gc_frame_newslot((Object)stackframe);
  self = obj5487;
  Object *oldselfslot5487 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5487 = (*(struct UserObject *)self).data[0], lowerouter5487 = thisouter5487;
  if (inheritingObject5487) {
    struct UserObject *inho5487 = (struct UserObject *)inheritingObject5487;
    while (inho5487->super != GraceDefaultObject) inho5487 = (struct UserObject *)inho5487->super;
    inho5487->super = obj5487;
    self = inheritingObject5487;
    *selfslot = self;
    lowerouter5487 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5487;
  }
// method "TRAIT"
  block_savedest(obj5487);
  Object closure5489 = createclosure(2, "TRAIT");
  setclosureframe(closure5489, stackframe);
  addtoclosure(closure5489, var_SizeUnknown);
  addtoclosure(closure5489, var_BoundsError);
  struct UserObject *uo5489 = (struct UserObject*)obj5487;
  uo5489->data[1] = (Object)closure5489;
  Method *meth_meth_collectionsPrelude_TRAIT5489 = addmethod2pos(obj5487, "TRAIT", &meth_collectionsPrelude_TRAIT5489, 1);
  int argcv_meth_collectionsPrelude_TRAIT5489[] = {0};
  meth_meth_collectionsPrelude_TRAIT5489->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_TRAIT5489);
  meth_meth_collectionsPrelude_TRAIT5489->definitionModule = modulename;
  meth_meth_collectionsPrelude_TRAIT5489->definitionLine = 241;
  block_savedest(obj5487);
  Object closure5611 = createclosure(2, "TRAIT()object");
  setclosureframe(closure5611, stackframe);
  addtoclosure(closure5611, var_SizeUnknown);
  addtoclosure(closure5611, var_BoundsError);
  Method *meth_meth_collectionsPrelude_TRAIT5489_object = addmethod2pos(obj5487, "TRAIT()object", &meth_collectionsPrelude_TRAIT5489_object, 1);
  meth_meth_collectionsPrelude_TRAIT5489_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_TRAIT5489_object->definitionLine = 241;
// method "asString"
  struct UserObject *uo5612 = (struct UserObject*)obj5487;
  uo5612->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5612 = addmethod2pos(obj5487, "asString", &meth_collectionsPrelude_asString5612, 2);
  int argcv_meth_collectionsPrelude_asString5612[] = {};
  meth_meth_collectionsPrelude_asString5612->type = alloc_MethodType(0, argcv_meth_collectionsPrelude_asString5612);
  meth_meth_collectionsPrelude_asString5612->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5612->definitionLine = 241;
  sourceObject = obj5487;
  sourceObject = obj5487;
  objclass5487 = obj5487->class;
  objclass5487->definitionModule = modulename;
  objclass5487->definitionLine = 241;
  (*(struct UserObject *)self).data[0] = lowerouter5487;
  self = oldself5487;
  selfslot = oldselfslot5487;
  stackframe = oldstackframe5487;
// compiled object node returning obj5487 (depth = 2)
  *var_collection = obj5487;
  if (obj5487 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 304
  setline(304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "collection"
  block_savedest(self);
  Object closure5614 = createclosure(1, "collection");
  setclosureframe(closure5614, stackframe);
  addtoclosure(closure5614, var_collection);
  struct UserObject *uo5614 = (struct UserObject*)self;
  uo5614->data[33] = (Object)closure5614;
  Method *meth_meth_collectionsPrelude_collection5614 = addmethod2pos(self, "collection", &meth_collectionsPrelude_collection5614, 33);
  int argcv_meth_collectionsPrelude_collection5614[] = {0};
  meth_meth_collectionsPrelude_collection5614->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_collection5614);
  meth_meth_collectionsPrelude_collection5614->definitionModule = modulename;
  meth_meth_collectionsPrelude_collection5614->definitionLine = 304;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 307
  setline(307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 308
  setline(308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5615 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5615 = alloc_userobj2(3,4, objclass5615);
  gc_frame_newslot(obj5615);
if (objclass5615 == NULL) {
  glfree(obj5615->class->name);
  obj5615->class->name = "enumerable";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5615, self, 0);
  addmethodreal(obj5615,"outer", &reader_collectionsPrelude_outer_5616);
  Object oldself5615 = self;
  struct StackFrameObject *oldstackframe5615 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5615);
  gc_frame_newslot((Object)stackframe);
  self = obj5615;
  Object *oldselfslot5615 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5615 = (*(struct UserObject *)self).data[0], lowerouter5615 = thisouter5615;
  if (inheritingObject5615) {
    struct UserObject *inho5615 = (struct UserObject *)inheritingObject5615;
    while (inho5615->super != GraceDefaultObject) inho5615 = (struct UserObject *)inho5615->super;
    inho5615->super = obj5615;
    self = inheritingObject5615;
    *selfslot = self;
    lowerouter5615 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5615;
  }
// method "TRAIT"
  block_savedest(obj5615);
  Object closure5617 = createclosure(2, "TRAIT");
  setclosureframe(closure5617, stackframe);
  addtoclosure(closure5617, var_SizeUnknown);
  addtoclosure(closure5617, var_collection);
  struct UserObject *uo5617 = (struct UserObject*)obj5615;
  uo5617->data[1] = (Object)closure5617;
  Method *meth_meth_collectionsPrelude_TRAIT5617 = addmethod2pos(obj5615, "TRAIT", &meth_collectionsPrelude_TRAIT5617, 1);
  int argcv_meth_collectionsPrelude_TRAIT5617[] = {0};
  meth_meth_collectionsPrelude_TRAIT5617->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_TRAIT5617);
  meth_meth_collectionsPrelude_TRAIT5617->definitionModule = modulename;
  meth_meth_collectionsPrelude_TRAIT5617->definitionLine = 308;
  block_savedest(obj5615);
  Object closure5783 = createclosure(2, "TRAIT()object");
  setclosureframe(closure5783, stackframe);
  addtoclosure(closure5783, var_SizeUnknown);
  addtoclosure(closure5783, var_collection);
  Method *meth_meth_collectionsPrelude_TRAIT5617_object = addmethod2pos(obj5615, "TRAIT()object", &meth_collectionsPrelude_TRAIT5617_object, 1);
  meth_meth_collectionsPrelude_TRAIT5617_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_TRAIT5617_object->definitionLine = 308;
// method "asString"
  struct UserObject *uo5784 = (struct UserObject*)obj5615;
  uo5784->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5784 = addmethod2pos(obj5615, "asString", &meth_collectionsPrelude_asString5784, 2);
  int argcv_meth_collectionsPrelude_asString5784[] = {};
  meth_meth_collectionsPrelude_asString5784->type = alloc_MethodType(0, argcv_meth_collectionsPrelude_asString5784);
  meth_meth_collectionsPrelude_asString5784->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5784->definitionLine = 308;
  sourceObject = obj5615;
  sourceObject = obj5615;
  objclass5615 = obj5615->class;
  objclass5615->definitionModule = modulename;
  objclass5615->definitionLine = 308;
  (*(struct UserObject *)self).data[0] = lowerouter5615;
  self = oldself5615;
  selfslot = oldselfslot5615;
  stackframe = oldstackframe5615;
// compiled object node returning obj5615 (depth = 2)
  *var_enumerable = obj5615;
  if (obj5615 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 368
  setline(368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "enumerable"
  block_savedest(self);
  Object closure5786 = createclosure(1, "enumerable");
  setclosureframe(closure5786, stackframe);
  addtoclosure(closure5786, var_enumerable);
  struct UserObject *uo5786 = (struct UserObject*)self;
  uo5786->data[34] = (Object)closure5786;
  Method *meth_meth_collectionsPrelude_enumerable5786 = addmethod2pos(self, "enumerable", &meth_collectionsPrelude_enumerable5786, 34);
  int argcv_meth_collectionsPrelude_enumerable5786[] = {0};
  meth_meth_collectionsPrelude_enumerable5786->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_enumerable5786);
  meth_meth_collectionsPrelude_enumerable5786->definitionModule = modulename;
  meth_meth_collectionsPrelude_enumerable5786->definitionLine = 368;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 372
  setline(372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 373
  setline(373);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5787 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5787 = alloc_userobj2(3,4, objclass5787);
  gc_frame_newslot(obj5787);
if (objclass5787 == NULL) {
  glfree(obj5787->class->name);
  obj5787->class->name = "indexable";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5787, self, 0);
  addmethodreal(obj5787,"outer", &reader_collectionsPrelude_outer_5788);
  Object oldself5787 = self;
  struct StackFrameObject *oldstackframe5787 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5787);
  gc_frame_newslot((Object)stackframe);
  self = obj5787;
  Object *oldselfslot5787 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5787 = (*(struct UserObject *)self).data[0], lowerouter5787 = thisouter5787;
  if (inheritingObject5787) {
    struct UserObject *inho5787 = (struct UserObject *)inheritingObject5787;
    while (inho5787->super != GraceDefaultObject) inho5787 = (struct UserObject *)inho5787->super;
    inho5787->super = obj5787;
    self = inheritingObject5787;
    *selfslot = self;
    lowerouter5787 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5787;
  }
// method "TRAIT"
  block_savedest(obj5787);
  Object closure5789 = createclosure(2, "TRAIT");
  setclosureframe(closure5789, stackframe);
  addtoclosure(closure5789, var_NoSuchObject);
  addtoclosure(closure5789, var_collection);
  struct UserObject *uo5789 = (struct UserObject*)obj5787;
  uo5789->data[1] = (Object)closure5789;
  Method *meth_meth_collectionsPrelude_TRAIT5789 = addmethod2pos(obj5787, "TRAIT", &meth_collectionsPrelude_TRAIT5789, 1);
  int argcv_meth_collectionsPrelude_TRAIT5789[] = {0};
  meth_meth_collectionsPrelude_TRAIT5789->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_TRAIT5789);
  meth_meth_collectionsPrelude_TRAIT5789->definitionModule = modulename;
  meth_meth_collectionsPrelude_TRAIT5789->definitionLine = 373;
  block_savedest(obj5787);
  Object closure5937 = createclosure(2, "TRAIT()object");
  setclosureframe(closure5937, stackframe);
  addtoclosure(closure5937, var_NoSuchObject);
  addtoclosure(closure5937, var_collection);
  Method *meth_meth_collectionsPrelude_TRAIT5789_object = addmethod2pos(obj5787, "TRAIT()object", &meth_collectionsPrelude_TRAIT5789_object, 1);
  meth_meth_collectionsPrelude_TRAIT5789_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_TRAIT5789_object->definitionLine = 373;
// method "asString"
  struct UserObject *uo5938 = (struct UserObject*)obj5787;
  uo5938->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5938 = addmethod2pos(obj5787, "asString", &meth_collectionsPrelude_asString5938, 2);
  int argcv_meth_collectionsPrelude_asString5938[] = {};
  meth_meth_collectionsPrelude_asString5938->type = alloc_MethodType(0, argcv_meth_collectionsPrelude_asString5938);
  meth_meth_collectionsPrelude_asString5938->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5938->definitionLine = 373;
  sourceObject = obj5787;
  sourceObject = obj5787;
  objclass5787 = obj5787->class;
  objclass5787->definitionModule = modulename;
  objclass5787->definitionLine = 373;
  (*(struct UserObject *)self).data[0] = lowerouter5787;
  self = oldself5787;
  selfslot = oldselfslot5787;
  stackframe = oldstackframe5787;
// compiled object node returning obj5787 (depth = 2)
  *var_indexable = obj5787;
  if (obj5787 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 412
  setline(412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "indexable"
  block_savedest(self);
  Object closure5940 = createclosure(1, "indexable");
  setclosureframe(closure5940, stackframe);
  addtoclosure(closure5940, var_indexable);
  struct UserObject *uo5940 = (struct UserObject*)self;
  uo5940->data[35] = (Object)closure5940;
  Method *meth_meth_collectionsPrelude_indexable5940 = addmethod2pos(self, "indexable", &meth_collectionsPrelude_indexable5940, 35);
  int argcv_meth_collectionsPrelude_indexable5940[] = {0};
  meth_meth_collectionsPrelude_indexable5940->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_indexable5940);
  meth_meth_collectionsPrelude_indexable5940->definitionModule = modulename;
  meth_meth_collectionsPrelude_indexable5940->definitionLine = 412;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 417
  setline(417);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject5941 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj5941 = alloc_userobj2(16,17, objclass5941);
  gc_frame_newslot(obj5941);
if (objclass5941 == NULL) {
  glfree(obj5941->class->name);
  obj5941->class->name = "emptySequence";
}
// OBJECT OUTER DEC outer
  adddatum2(obj5941, self, 0);
  addmethodreal(obj5941,"outer", &reader_collectionsPrelude_outer_5942);
  Object oldself5941 = self;
  struct StackFrameObject *oldstackframe5941 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe5941);
  gc_frame_newslot((Object)stackframe);
  self = obj5941;
  Object *oldselfslot5941 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter5941 = (*(struct UserObject *)self).data[0], lowerouter5941 = thisouter5941;
  if (inheritingObject5941) {
    struct UserObject *inho5941 = (struct UserObject *)inheritingObject5941;
    while (inho5941->super != GraceDefaultObject) inho5941 = (struct UserObject *)inho5941->super;
    inho5941->super = obj5941;
    self = inheritingObject5941;
    *selfslot = self;
    lowerouter5941 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter5941;
  }
// method "size"
  struct UserObject *uo5943 = (struct UserObject*)obj5941;
  uo5943->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_size5943 = addmethod2pos(obj5941, "size", &meth_collectionsPrelude_size5943, 1);
  int argcv_meth_collectionsPrelude_size5943[] = {0};
  meth_meth_collectionsPrelude_size5943->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_size5943);
  meth_meth_collectionsPrelude_size5943->definitionModule = modulename;
  meth_meth_collectionsPrelude_size5943->definitionLine = 424;
// method "isEmpty"
  struct UserObject *uo5945 = (struct UserObject*)obj5941;
  uo5945->data[2] = emptyclosure;
  Method *meth_meth_collectionsPrelude_isEmpty5945 = addmethod2pos(obj5941, "isEmpty", &meth_collectionsPrelude_isEmpty5945, 2);
  int argcv_meth_collectionsPrelude_isEmpty5945[] = {0};
  meth_meth_collectionsPrelude_isEmpty5945->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_isEmpty5945);
  meth_meth_collectionsPrelude_isEmpty5945->definitionModule = modulename;
  meth_meth_collectionsPrelude_isEmpty5945->definitionLine = 425;
// method "at"
  block_savedest(obj5941);
  Object closure5947 = createclosure(1, "at");
  setclosureframe(closure5947, stackframe);
  addtoclosure(closure5947, var_BoundsError);
  struct UserObject *uo5947 = (struct UserObject*)obj5941;
  uo5947->data[3] = (Object)closure5947;
  Method *meth_meth_collectionsPrelude_at5947 = addmethod2pos(obj5941, "at", &meth_collectionsPrelude_at5947, 3);
  int argcv_meth_collectionsPrelude_at5947[] = {1};
  meth_meth_collectionsPrelude_at5947->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_at5947);
  meth_meth_collectionsPrelude_at5947->definitionModule = modulename;
  meth_meth_collectionsPrelude_at5947->definitionLine = 426;
// method "keys"
  struct UserObject *uo5958 = (struct UserObject*)obj5941;
  uo5958->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_keys5958 = addmethod2pos(obj5941, "keys", &meth_collectionsPrelude_keys5958, 4);
  int argcv_meth_collectionsPrelude_keys5958[] = {0};
  meth_meth_collectionsPrelude_keys5958->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keys5958);
  meth_meth_collectionsPrelude_keys5958->definitionModule = modulename;
  meth_meth_collectionsPrelude_keys5958->definitionLine = 427;
// method "values"
  struct UserObject *uo5959 = (struct UserObject*)obj5941;
  uo5959->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude_values5959 = addmethod2pos(obj5941, "values", &meth_collectionsPrelude_values5959, 5);
  int argcv_meth_collectionsPrelude_values5959[] = {0};
  meth_meth_collectionsPrelude_values5959->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_values5959);
  meth_meth_collectionsPrelude_values5959->definitionModule = modulename;
  meth_meth_collectionsPrelude_values5959->definitionLine = 428;
// method "keysAndValuesDo"
  block_savedest(obj5941);
  Object closure5960 = createclosure(1, "keysAndValuesDo");
  setclosureframe(closure5960, stackframe);
  addtoclosure(closure5960, var_done);
  struct UserObject *uo5960 = (struct UserObject*)obj5941;
  uo5960->data[6] = (Object)closure5960;
  Method *meth_meth_collectionsPrelude_keysAndValuesDo5960 = addmethod2pos(obj5941, "keysAndValuesDo", &meth_collectionsPrelude_keysAndValuesDo5960, 6);
  int argcv_meth_collectionsPrelude_keysAndValuesDo5960[] = {1};
  meth_meth_collectionsPrelude_keysAndValuesDo5960->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_keysAndValuesDo5960);
  meth_meth_collectionsPrelude_keysAndValuesDo5960->definitionModule = modulename;
  meth_meth_collectionsPrelude_keysAndValuesDo5960->definitionLine = 429;
// method "reversed"
  struct UserObject *uo5961 = (struct UserObject*)obj5941;
  uo5961->data[7] = emptyclosure;
  Method *meth_meth_collectionsPrelude_reversed5961 = addmethod2pos(obj5941, "reversed", &meth_collectionsPrelude_reversed5961, 7);
  int argcv_meth_collectionsPrelude_reversed5961[] = {0};
  meth_meth_collectionsPrelude_reversed5961->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_reversed5961);
  meth_meth_collectionsPrelude_reversed5961->definitionModule = modulename;
  meth_meth_collectionsPrelude_reversed5961->definitionLine = 430;
// method "++"
  struct UserObject *uo5962 = (struct UserObject*)obj5941;
  uo5962->data[8] = emptyclosure;
  Method *meth_meth_collectionsPrelude__43__43_5962 = addmethod2pos(obj5941, "++", &meth_collectionsPrelude__43__43_5962, 8);
  int argcv_meth_collectionsPrelude__43__43_5962[] = {1};
  meth_meth_collectionsPrelude__43__43_5962->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__43__43_5962);
  meth_meth_collectionsPrelude__43__43_5962->definitionModule = modulename;
  meth_meth_collectionsPrelude__43__43_5962->definitionLine = 431;
// method "asString"
  struct UserObject *uo5969 = (struct UserObject*)obj5941;
  uo5969->data[9] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString5969 = addmethod2pos(obj5941, "asString", &meth_collectionsPrelude_asString5969, 9);
  int argcv_meth_collectionsPrelude_asString5969[] = {0};
  meth_meth_collectionsPrelude_asString5969->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString5969);
  meth_meth_collectionsPrelude_asString5969->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString5969->definitionLine = 432;
// method "contains"
  struct UserObject *uo5971 = (struct UserObject*)obj5941;
  uo5971->data[10] = emptyclosure;
  Method *meth_meth_collectionsPrelude_contains5971 = addmethod2pos(obj5941, "contains", &meth_collectionsPrelude_contains5971, 10);
  int argcv_meth_collectionsPrelude_contains5971[] = {1};
  meth_meth_collectionsPrelude_contains5971->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_contains5971);
  meth_meth_collectionsPrelude_contains5971->definitionModule = modulename;
  meth_meth_collectionsPrelude_contains5971->definitionLine = 433;
// method "do"
  block_savedest(obj5941);
  Object closure5973 = createclosure(1, "do");
  setclosureframe(closure5973, stackframe);
  addtoclosure(closure5973, var_done);
  struct UserObject *uo5973 = (struct UserObject*)obj5941;
  uo5973->data[11] = (Object)closure5973;
  Method *meth_meth_collectionsPrelude_do5973 = addmethod2pos(obj5941, "do", &meth_collectionsPrelude_do5973, 11);
  int argcv_meth_collectionsPrelude_do5973[] = {1};
  meth_meth_collectionsPrelude_do5973->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_do5973);
  meth_meth_collectionsPrelude_do5973->definitionModule = modulename;
  meth_meth_collectionsPrelude_do5973->definitionLine = 434;
// method "=="
  block_savedest(obj5941);
  Object closure5974 = createclosure(1, "==");
  setclosureframe(closure5974, stackframe);
  addtoclosure(closure5974, var_Iterable);
  struct UserObject *uo5974 = (struct UserObject*)obj5941;
  uo5974->data[12] = (Object)closure5974;
  Method *meth_meth_collectionsPrelude__61__61_5974 = addmethod2pos(obj5941, "==", &meth_collectionsPrelude__61__61_5974, 12);
  int argcv_meth_collectionsPrelude__61__61_5974[] = {1};
  meth_meth_collectionsPrelude__61__61_5974->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_5974);
  meth_meth_collectionsPrelude__61__61_5974->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_5974->definitionLine = 435;
// method "iterator"
  block_savedest(obj5941);
  Object closure5994 = createclosure(1, "iterator");
  setclosureframe(closure5994, stackframe);
  addtoclosure(closure5994, var_IteratorExhausted);
  struct UserObject *uo5994 = (struct UserObject*)obj5941;
  uo5994->data[13] = (Object)closure5994;
  Method *meth_meth_collectionsPrelude_iterator5994 = addmethod2pos(obj5941, "iterator", &meth_collectionsPrelude_iterator5994, 13);
  int argcv_meth_collectionsPrelude_iterator5994[] = {0};
  meth_meth_collectionsPrelude_iterator5994->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_iterator5994);
  meth_meth_collectionsPrelude_iterator5994->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator5994->definitionLine = 444;
  block_savedest(obj5941);
  Object closure6005 = createclosure(1, "iterator()object");
  setclosureframe(closure6005, stackframe);
  addtoclosure(closure6005, var_IteratorExhausted);
  Method *meth_meth_collectionsPrelude_iterator5994_object = addmethod2pos(obj5941, "iterator()object", &meth_collectionsPrelude_iterator5994_object, 13);
  meth_meth_collectionsPrelude_iterator5994_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_iterator5994_object->definitionLine = 444;
// method "sorted"
  struct UserObject *uo6006 = (struct UserObject*)obj5941;
  uo6006->data[14] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sorted6006 = addmethod2pos(obj5941, "sorted", &meth_collectionsPrelude_sorted6006, 14);
  int argcv_meth_collectionsPrelude_sorted6006[] = {0};
  meth_meth_collectionsPrelude_sorted6006->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sorted6006);
  meth_meth_collectionsPrelude_sorted6006->definitionModule = modulename;
  meth_meth_collectionsPrelude_sorted6006->definitionLine = 449;
// method "sortedBy"
  struct UserObject *uo6007 = (struct UserObject*)obj5941;
  uo6007->data[15] = emptyclosure;
  Method *meth_meth_collectionsPrelude_sortedBy6007 = addmethod2pos(obj5941, "sortedBy", &meth_collectionsPrelude_sortedBy6007, 15);
  int argcv_meth_collectionsPrelude_sortedBy6007[] = {1};
  meth_meth_collectionsPrelude_sortedBy6007->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_sortedBy6007);
  meth_meth_collectionsPrelude_sortedBy6007->definitionModule = modulename;
  meth_meth_collectionsPrelude_sortedBy6007->definitionLine = 450;
  sourceObject = obj5941;
// Begin line 423
  setline(423);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe6008 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning self (depth = 4)
  gc_frame_newslot(self);
// call case 6: other member request
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_indexable (depth = 4)
  params[0] = self;
  partcv[0] = 0;
  partcv[1] = 1;
  Object call6009 = callmethod(*var_indexable, "TRAIT()object",
    2, partcv, params);
  gc_frame_end(callframe6008);
// compiled call node returning call6009 (depth = 3)
  struct UserObject *obj5941_uo = (struct UserObject *)obj5941;
  obj5941_uo->super = call6009;
  sourceObject = obj5941;
  sourceObject = obj5941;
  sourceObject = obj5941;
  sourceObject = obj5941;
  sourceObject = obj5941;
  sourceObject = obj5941;
  sourceObject = obj5941;
  sourceObject = obj5941;
  sourceObject = obj5941;
  sourceObject = obj5941;
  sourceObject = obj5941;
  sourceObject = obj5941;
  sourceObject = obj5941;
  sourceObject = obj5941;
  sourceObject = obj5941;
  objclass5941 = obj5941->class;
  objclass5941->definitionModule = modulename;
  objclass5941->definitionLine = 422;
  (*(struct UserObject *)self).data[0] = lowerouter5941;
  self = oldself5941;
  selfslot = oldselfslot5941;
  stackframe = oldstackframe5941;
// compiled object node returning obj5941 (depth = 2)
  *var_emptySequence = obj5941;
  if (obj5941 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "emptySequence"
  block_savedest(self);
  Object closure6010 = createclosure(1, "emptySequence");
  setclosureframe(closure6010, stackframe);
  addtoclosure(closure6010, var_emptySequence);
  struct UserObject *uo6010 = (struct UserObject*)self;
  uo6010->data[36] = (Object)closure6010;
  Method *meth_meth_collectionsPrelude_emptySequence6010 = addmethod2pos(self, "emptySequence", &meth_collectionsPrelude_emptySequence6010, 36);
  int argcv_meth_collectionsPrelude_emptySequence6010[] = {0};
  meth_meth_collectionsPrelude_emptySequence6010->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_emptySequence6010);
  meth_meth_collectionsPrelude_emptySequence6010->definitionModule = modulename;
  meth_meth_collectionsPrelude_emptySequence6010->definitionLine = 0;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 452
  setline(452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 589
  setline(589);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 590
  setline(590);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl MinimalyIterable
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type6012 = alloc_Type("MinimalyIterable", 1);
    add_Method((ClassData)type6012, "iterator", NULL);
// compiled typeliteral node returning type6012 (depth = 2)
  *var_MinimalyIterable = type6012;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "MinimalyIterable"
  block_savedest(self);
  Object closure6013 = createclosure(1, "MinimalyIterable");
  setclosureframe(closure6013, stackframe);
  addtoclosure(closure6013, var_MinimalyIterable);
  struct UserObject *uo6013 = (struct UserObject*)self;
  uo6013->data[37] = (Object)closure6013;
  Method *meth_meth_collectionsPrelude_MinimalyIterable6013 = addmethod2pos(self, "MinimalyIterable", &meth_collectionsPrelude_MinimalyIterable6013, 37);
  int argcv_meth_collectionsPrelude_MinimalyIterable6013[] = {0};
  meth_meth_collectionsPrelude_MinimalyIterable6013->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_MinimalyIterable6013);
  meth_meth_collectionsPrelude_MinimalyIterable6013->definitionModule = modulename;
  meth_meth_collectionsPrelude_MinimalyIterable6013->definitionLine = 0;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 593
  setline(593);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 608
  setline(608);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1146
  setline(1146);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1147
  setline(1147);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6014 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6014 = alloc_userobj2(6,6, objclass6014);
  gc_frame_newslot(obj6014);
if (objclass6014 == NULL) {
  glfree(obj6014->class->name);
  obj6014->class->name = "unused";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6014, self, 0);
  addmethodreal(obj6014,"outer", &reader_collectionsPrelude_outer_6015);
  Object oldself6014 = self;
  struct StackFrameObject *oldstackframe6014 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6014);
  gc_frame_newslot((Object)stackframe);
  self = obj6014;
  Object *oldselfslot6014 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6014 = (*(struct UserObject *)self).data[0], lowerouter6014 = thisouter6014;
  if (inheritingObject6014) {
    struct UserObject *inho6014 = (struct UserObject *)inheritingObject6014;
    while (inho6014->super != GraceDefaultObject) inho6014 = (struct UserObject *)inho6014->super;
    inho6014->super = obj6014;
    self = inheritingObject6014;
    *selfslot = self;
    lowerouter6014 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6014;
  }
if (objclass6014 == NULL) {
  Method *reader6016 = addmethodrealflags(obj6014, "unused",&reader_collectionsPrelude_unused_6016, MFLAG_CONFIDENTIAL);
  Method *writer6016 = addmethodrealflags(obj6014, "unused:=",&writer_collectionsPrelude_unused_6016, MFLAG_CONFIDENTIAL);
  reader6016->definitionModule = modulename;
  writer6016->definitionModule = modulename;
  reader6016->definitionLine = 1148;
  writer6016->definitionLine = 1148;
}
obj6014->flags |= OFLAG_MUTABLE;
adddatum2(obj6014, alloc_Undefined(), 1);
if (objclass6014 == NULL) {
  Method *reader6017 = addmethodrealflags(obj6014, "key",&reader_collectionsPrelude_key_6017, MFLAG_DEF);
  reader6017->definitionModule = modulename;
  reader6017->definitionLine = 1149;
}
adddatum2(obj6014, alloc_Undefined(), 2);
if (objclass6014 == NULL) {
  Method *reader6018 = addmethodrealflags(obj6014, "value",&reader_collectionsPrelude_value_6018, MFLAG_DEF);
  reader6018->definitionModule = modulename;
  reader6018->definitionLine = 1150;
}
adddatum2(obj6014, alloc_Undefined(), 3);
// method "asString"
  struct UserObject *uo6019 = (struct UserObject*)obj6014;
  uo6019->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString6019 = addmethod2pos(obj6014, "asString", &meth_collectionsPrelude_asString6019, 4);
  int argcv_meth_collectionsPrelude_asString6019[] = {0};
  meth_meth_collectionsPrelude_asString6019->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString6019);
  meth_meth_collectionsPrelude_asString6019->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString6019->definitionLine = 1151;
// method "=="
  struct UserObject *uo6021 = (struct UserObject*)obj6014;
  uo6021->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61_6021 = addmethod2pos(obj6014, "==", &meth_collectionsPrelude__61__61_6021, 5);
  int argcv_meth_collectionsPrelude__61__61_6021[] = {1};
  meth_meth_collectionsPrelude__61__61_6021->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_6021);
  meth_meth_collectionsPrelude__61__61_6021->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_6021->definitionLine = 1152;
  sourceObject = obj6014;
// Begin line 1148
  setline(1148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6024 = alloc_Boolean(1);
// compiled identifier node returning bool6024 (depth = 3)
  adddatum2(obj6014, bool6024, 1);
  sourceObject = obj6014;
// Begin line 1149
  setline(1149);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  adddatum2(obj6014, self, 2);
  sourceObject = obj6014;
// Begin line 1150
  setline(1150);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  adddatum2(obj6014, self, 3);
  sourceObject = obj6014;
  sourceObject = obj6014;
  objclass6014 = obj6014->class;
  objclass6014->definitionModule = modulename;
  objclass6014->definitionLine = 1147;
  (*(struct UserObject *)self).data[0] = lowerouter6014;
  self = oldself6014;
  selfslot = oldselfslot6014;
  stackframe = oldstackframe6014;
// compiled object node returning obj6014 (depth = 2)
  *var_unused = obj6014;
  if (obj6014 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "unused"
  block_savedest(self);
  Object closure6025 = createclosure(1, "unused");
  setclosureframe(closure6025, stackframe);
  addtoclosure(closure6025, var_unused);
  struct UserObject *uo6025 = (struct UserObject*)self;
  uo6025->data[38] = (Object)closure6025;
  Method *meth_meth_collectionsPrelude_unused6025 = addmethod2pos(self, "unused", &meth_collectionsPrelude_unused6025, 38);
  int argcv_meth_collectionsPrelude_unused6025[] = {0};
  meth_meth_collectionsPrelude_unused6025->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_unused6025);
  meth_meth_collectionsPrelude_unused6025->definitionModule = modulename;
  meth_meth_collectionsPrelude_unused6025->definitionLine = 0;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1154
  setline(1154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1155
  setline(1155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6026 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6026 = alloc_userobj2(6,6, objclass6026);
  gc_frame_newslot(obj6026);
if (objclass6026 == NULL) {
  glfree(obj6026->class->name);
  obj6026->class->name = "removed";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6026, self, 0);
  addmethodreal(obj6026,"outer", &reader_collectionsPrelude_outer_6027);
  Object oldself6026 = self;
  struct StackFrameObject *oldstackframe6026 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6026);
  gc_frame_newslot((Object)stackframe);
  self = obj6026;
  Object *oldselfslot6026 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6026 = (*(struct UserObject *)self).data[0], lowerouter6026 = thisouter6026;
  if (inheritingObject6026) {
    struct UserObject *inho6026 = (struct UserObject *)inheritingObject6026;
    while (inho6026->super != GraceDefaultObject) inho6026 = (struct UserObject *)inho6026->super;
    inho6026->super = obj6026;
    self = inheritingObject6026;
    *selfslot = self;
    lowerouter6026 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6026;
  }
if (objclass6026 == NULL) {
  Method *reader6028 = addmethodrealflags(obj6026, "removed",&reader_collectionsPrelude_removed_6028, MFLAG_CONFIDENTIAL);
  Method *writer6028 = addmethodrealflags(obj6026, "removed:=",&writer_collectionsPrelude_removed_6028, MFLAG_CONFIDENTIAL);
  reader6028->definitionModule = modulename;
  writer6028->definitionModule = modulename;
  reader6028->definitionLine = 1156;
  writer6028->definitionLine = 1156;
}
obj6026->flags |= OFLAG_MUTABLE;
adddatum2(obj6026, alloc_Undefined(), 1);
if (objclass6026 == NULL) {
  Method *reader6029 = addmethodrealflags(obj6026, "key",&reader_collectionsPrelude_key_6029, MFLAG_DEF);
  reader6029->definitionModule = modulename;
  reader6029->definitionLine = 1157;
}
adddatum2(obj6026, alloc_Undefined(), 2);
if (objclass6026 == NULL) {
  Method *reader6030 = addmethodrealflags(obj6026, "value",&reader_collectionsPrelude_value_6030, MFLAG_DEF);
  reader6030->definitionModule = modulename;
  reader6030->definitionLine = 1158;
}
adddatum2(obj6026, alloc_Undefined(), 3);
// method "asString"
  struct UserObject *uo6031 = (struct UserObject*)obj6026;
  uo6031->data[4] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString6031 = addmethod2pos(obj6026, "asString", &meth_collectionsPrelude_asString6031, 4);
  int argcv_meth_collectionsPrelude_asString6031[] = {0};
  meth_meth_collectionsPrelude_asString6031->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString6031);
  meth_meth_collectionsPrelude_asString6031->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString6031->definitionLine = 1159;
// method "=="
  struct UserObject *uo6033 = (struct UserObject*)obj6026;
  uo6033->data[5] = emptyclosure;
  Method *meth_meth_collectionsPrelude__61__61_6033 = addmethod2pos(obj6026, "==", &meth_collectionsPrelude__61__61_6033, 5);
  int argcv_meth_collectionsPrelude__61__61_6033[] = {1};
  meth_meth_collectionsPrelude__61__61_6033->type = alloc_MethodType(1, argcv_meth_collectionsPrelude__61__61_6033);
  meth_meth_collectionsPrelude__61__61_6033->definitionModule = modulename;
  meth_meth_collectionsPrelude__61__61_6033->definitionLine = 1160;
  sourceObject = obj6026;
// Begin line 1156
  setline(1156);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool6036 = alloc_Boolean(1);
// compiled identifier node returning bool6036 (depth = 3)
  adddatum2(obj6026, bool6036, 1);
  sourceObject = obj6026;
// Begin line 1157
  setline(1157);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  adddatum2(obj6026, self, 2);
  sourceObject = obj6026;
// Begin line 1158
  setline(1158);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning self (depth = 3)
  adddatum2(obj6026, self, 3);
  sourceObject = obj6026;
  sourceObject = obj6026;
  objclass6026 = obj6026->class;
  objclass6026->definitionModule = modulename;
  objclass6026->definitionLine = 1155;
  (*(struct UserObject *)self).data[0] = lowerouter6026;
  self = oldself6026;
  selfslot = oldselfslot6026;
  stackframe = oldstackframe6026;
// compiled object node returning obj6026 (depth = 2)
  *var_removed = obj6026;
  if (obj6026 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "removed"
  block_savedest(self);
  Object closure6037 = createclosure(1, "removed");
  setclosureframe(closure6037, stackframe);
  addtoclosure(closure6037, var_removed);
  struct UserObject *uo6037 = (struct UserObject*)self;
  uo6037->data[39] = (Object)closure6037;
  Method *meth_meth_collectionsPrelude_removed6037 = addmethod2pos(self, "removed", &meth_collectionsPrelude_removed6037, 39);
  int argcv_meth_collectionsPrelude_removed6037[] = {0};
  meth_meth_collectionsPrelude_removed6037->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_removed6037);
  meth_meth_collectionsPrelude_removed6037->definitionModule = modulename;
  meth_meth_collectionsPrelude_removed6037->definitionLine = 0;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1162
  setline(1162);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1445
  setline(1445);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1446
  setline(1446);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl Binding
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type6039 = alloc_Type("Binding", 4);
    add_Method((ClassData)type6039, "key", NULL);
    add_Method((ClassData)type6039, "value", NULL);
    add_Method((ClassData)type6039, "hash", NULL);
    add_Method((ClassData)type6039, "==", NULL);
// compiled typeliteral node returning type6039 (depth = 2)
  *var_Binding = type6039;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "Binding"
  block_savedest(self);
  Object closure6040 = createclosure(1, "Binding");
  setclosureframe(closure6040, stackframe);
  addtoclosure(closure6040, var_Binding);
  struct UserObject *uo6040 = (struct UserObject*)self;
  uo6040->data[40] = (Object)closure6040;
  Method *meth_meth_collectionsPrelude_Binding6040 = addmethod2pos(self, "Binding", &meth_collectionsPrelude_Binding6040, 40);
  int argcv_meth_collectionsPrelude_Binding6040[] = {0};
  meth_meth_collectionsPrelude_Binding6040->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_Binding6040);
  meth_meth_collectionsPrelude_Binding6040->definitionModule = modulename;
  meth_meth_collectionsPrelude_Binding6040->definitionLine = 0;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 1452
  setline(1452);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1453
  setline(1453);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject6041 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj6041 = alloc_userobj2(3,4, objclass6041);
  gc_frame_newslot(obj6041);
if (objclass6041 == NULL) {
  glfree(obj6041->class->name);
  obj6041->class->name = "binding";
}
// OBJECT OUTER DEC outer
  adddatum2(obj6041, self, 0);
  addmethodreal(obj6041,"outer", &reader_collectionsPrelude_outer_6042);
  Object oldself6041 = self;
  struct StackFrameObject *oldstackframe6041 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe6041);
  gc_frame_newslot((Object)stackframe);
  self = obj6041;
  Object *oldselfslot6041 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter6041 = (*(struct UserObject *)self).data[0], lowerouter6041 = thisouter6041;
  if (inheritingObject6041) {
    struct UserObject *inho6041 = (struct UserObject *)inheritingObject6041;
    while (inho6041->super != GraceDefaultObject) inho6041 = (struct UserObject *)inho6041->super;
    inho6041->super = obj6041;
    self = inheritingObject6041;
    *selfslot = self;
    lowerouter6041 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter6041;
  }
// method "asString"
  struct UserObject *uo6043 = (struct UserObject*)obj6041;
  uo6043->data[1] = emptyclosure;
  Method *meth_meth_collectionsPrelude_asString6043 = addmethod2pos(obj6041, "asString", &meth_collectionsPrelude_asString6043, 1);
  int argcv_meth_collectionsPrelude_asString6043[] = {0};
  meth_meth_collectionsPrelude_asString6043->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_asString6043);
  meth_meth_collectionsPrelude_asString6043->definitionModule = modulename;
  meth_meth_collectionsPrelude_asString6043->definitionLine = 1454;
// method "key()value"
  block_savedest(obj6041);
  Object closure6045 = createclosure(1, "key()value");
  setclosureframe(closure6045, stackframe);
  addtoclosure(closure6045, var_Binding);
  struct UserObject *uo6045 = (struct UserObject*)obj6041;
  uo6045->data[2] = (Object)closure6045;
  Method *meth_meth_collectionsPrelude_key_40__41_value6045 = addmethod2pos(obj6041, "key()value", &meth_collectionsPrelude_key_40__41_value6045, 2);
  int argcv_meth_collectionsPrelude_key_40__41_value6045[] = {1, 1};
  meth_meth_collectionsPrelude_key_40__41_value6045->type = alloc_MethodType(2, argcv_meth_collectionsPrelude_key_40__41_value6045);
  meth_meth_collectionsPrelude_key_40__41_value6045->definitionModule = modulename;
  meth_meth_collectionsPrelude_key_40__41_value6045->definitionLine = 1456;
  block_savedest(obj6041);
  Object closure6121 = createclosure(1, "key()value()object");
  setclosureframe(closure6121, stackframe);
  addtoclosure(closure6121, var_Binding);
  Method *meth_meth_collectionsPrelude_key_40__41_value6045_object = addmethod2pos(obj6041, "key()value()object", &meth_collectionsPrelude_key_40__41_value6045_object, 2);
  meth_meth_collectionsPrelude_key_40__41_value6045_object->definitionModule = modulename;
  meth_meth_collectionsPrelude_key_40__41_value6045_object->definitionLine = 1456;
  sourceObject = obj6041;
  sourceObject = obj6041;
  objclass6041 = obj6041->class;
  objclass6041->definitionModule = modulename;
  objclass6041->definitionLine = 1453;
  (*(struct UserObject *)self).data[0] = lowerouter6041;
  self = oldself6041;
  selfslot = oldselfslot6041;
  stackframe = oldstackframe6041;
// compiled object node returning obj6041 (depth = 2)
  *var_binding = obj6041;
  if (obj6041 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "binding"
  block_savedest(self);
  Object closure6122 = createclosure(1, "binding");
  setclosureframe(closure6122, stackframe);
  addtoclosure(closure6122, var_binding);
  struct UserObject *uo6122 = (struct UserObject*)self;
  uo6122->data[41] = (Object)closure6122;
  Method *meth_meth_collectionsPrelude_binding6122 = addmethod2pos(self, "binding", &meth_collectionsPrelude_binding6122, 41);
  int argcv_meth_collectionsPrelude_binding6122[] = {0};
  meth_meth_collectionsPrelude_binding6122->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_binding6122);
  meth_meth_collectionsPrelude_binding6122->definitionModule = modulename;
  meth_meth_collectionsPrelude_binding6122->definitionLine = 0;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 1469
  setline(1469);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1470
  setline(1470);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile typedec node (depth = 1)
// Type decl ComparableToDictionary
// starting to compile typeliteral node (depth = 2)
//   Type literal 
    Object type6124 = alloc_Type("ComparableToDictionary", 2);
    add_Method((ClassData)type6124, "size", NULL);
    add_Method((ClassData)type6124, "at()ifAbsent", NULL);
// compiled typeliteral node returning type6124 (depth = 2)
  *var_ComparableToDictionary = type6124;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "ComparableToDictionary"
  block_savedest(self);
  Object closure6125 = createclosure(1, "ComparableToDictionary");
  setclosureframe(closure6125, stackframe);
  addtoclosure(closure6125, var_ComparableToDictionary);
  struct UserObject *uo6125 = (struct UserObject*)self;
  uo6125->data[42] = (Object)closure6125;
  Method *meth_meth_collectionsPrelude_ComparableToDictionary6125 = addmethod2pos(self, "ComparableToDictionary", &meth_collectionsPrelude_ComparableToDictionary6125, 42);
  int argcv_meth_collectionsPrelude_ComparableToDictionary6125[] = {0};
  meth_meth_collectionsPrelude_ComparableToDictionary6125->type = alloc_MethodType(1, argcv_meth_collectionsPrelude_ComparableToDictionary6125);
  meth_meth_collectionsPrelude_ComparableToDictionary6125->definitionModule = modulename;
  meth_meth_collectionsPrelude_ComparableToDictionary6125->definitionLine = 0;
// compiled method node returning  (depth = 2)
// compiled typedec node returning done (depth = 1)
// Begin line 1474
  setline(1474);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 1839
  setline(1839);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 2039
  setline(2039);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
  gc_frame_end(frame);
  return self;
}
