#include <gracelib.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
static char compilerRevision[] = "653ff9a8a5366672bab39af399602aa02fe18768";
static Object undefined;
extern Object done;
extern Object _prelude;
extern Object ObjectType;
extern Object String;
extern Object Number;
extern Object Boolean;
extern Object Dynamic;
extern Object Unknown;
extern Object Block;
extern Object Done;
extern Object Type;
extern Object GraceDefaultObject;
extern Object sourceObject;
static Object type_Object;
static Object type_String;
static Object type_Number;
static Object type_Boolean;
static Object type_Block;
static Object type_Done;
static Object type_Type;
static Object argv;
static Object emptyclosure;
static Object prelude;
static int isTailObject = 0;
static Object inheritingObject = NULL;
static const char modulename[] = "errormessages";
Object module_StandardPrelude_init();
static char *originalSourceLines[] = {
  "#pragma ExtendedLineups",
  "import \"io\" as io",
  "import \"sys\" as sys",
  "import \"util\" as util",
  "",
  "// Contains modified lines used as suggestions for error messages.",
  "// When a line is added using one of the utility methods such as",
  "// insert()afterToken()onLine(), the line is copied from util.lines to the",
  "// internal lines array in the suggestion, and when a line that is already in",
  "// the array is modified, the internal lines array is updated.",
  "// There is no sorting of the order of the lines at any point, so",
  "// lines must be added in ascending order.",
  "def suggestion is public = object {",
  "  class new {",
  "    def lineNumbers is confidential = []",
  "    def lines is confidential = []",
  "",
  "    // Methods that deal with inserting/replacing/deleting character positions",
  "    // and ranges. These methods are usually called by lexing error messages",
  "    // due to lack of access to tokens, and by insert/replace/delete methods",
  "    // that operate on tokens.",
  "",
  "    method replaceRange(start, end)with(s)onLine(lineNumber) {",
  "        def line = getLine(lineNumber)",
  "        if(start == 1) then {",
  "            addLine(lineNumber, s ++ line.substringFrom(end + 1)to(line.size))",
  "        } else {",
  "            addLine(lineNumber, line.substringFrom(1)to(start - 1)",
  "                ++ s ++ line.substringFrom(end + 1)to(line.size))",
  "        }",
  "    }",
  "",
  "    method replaceChar(pos)with(s)onLine(lineNumber) {",
  "        replaceRange(pos, pos)with(s)onLine(lineNumber)",
  "    }",
  "",
  "    method replaceUntil(until)with(s)onLine(lineNumber) {",
  "        def line = getLine(lineNumber)",
  "        def len = until.size",
  "        for (1..line.size) do {i->",
  "            if (line.substringFrom(i)to(i + len - 1) == until) then {",
  "                replaceRange(1, i + len - 1)with(s)onLine(lineNumber)",
  "                return true",
  "            }",
  "        }",
  "        return false",
  "    }",
  "",
  "    method deleteRange(start, end)onLine(lineNumber) {",
  "        var start' := start",
  "        def line = getLine(lineNumber)",
  "        if((start' > 1) && (end == line.size)) then {",
  "            // Check for removing the whole line, then remove the indent also.",
  "            var indent := true",
  "            for(1..(start'-1)) do { i ->",
  "                if(line.at(i) != \" \") then {",
  "                    indent := false",
  "                }",
  "            }",
  "            if(indent == true) then {",
  "                start' := 1",
  "            }",
  "        }",
  "        replaceRange(start', end)with(\"\")onLine(lineNumber)",
  "    }",
  "",
  "    method deleteChar(pos)onLine(lineNumber) {",
  "        replaceRange(pos, pos)with(\"\")onLine(lineNumber)",
  "    }",
  "",
  "    method append(s)onLine(lineNumber) {",
  "        def line = getLine(lineNumber)",
  "        addLine(lineNumber, line ++ s)",
  "    }",
  "",
  "    method insert(s)atPosition(pos)onLine(lineNumber) {",
  "        def line = getLine(lineNumber)",
  "        if(pos == 1) then {",
  "            addLine(lineNumber, s ++ line)",
  "        } else {",
  "            addLine(lineNumber, line.substringFrom(1)to(pos - 1) ++ s",
  "                ++ line.substringFrom(pos)to(line.size))",
  "        }",
  "    }",
  "",
  "    // Methods that deal with inserting/replacing/deleteing tokens or ranges of",
  "    // tokens. These methods call the underlying methods that operate on",
  "    // characters.",
  "",
  "    method getTokenStart(token)includeLeadingSpace(includeLeading) {",
  "        var start := token.linePos",
  "        // Include leading whitespace.",
  "        if(includeLeading == true) then {",
  "            if((token.prev != false) && ({token.prev.line == token.line})) then {",
  "                start := token.prev.linePos + token.prev.size",
  "            }",
  "        }",
  "        // Include indentation if this is the only token on the line.",
  "        if(token.linePos == (token.indent + 1)) then {",
  "            if ((token.next == false) || {token.next.line != token.line}) then {",
  "                start := 1",
  "            }",
  "        }",
  "        start",
  "    }",
  "",
  "    method getTokenEnd(token)includeTrailingSpace(includeTrailing) {",
  "        var end := token.linePos + token.size - 1",
  "        // Include trailing space.",
  "        if(includeTrailing == true) then {",
  "            if((token.next != false) && ({token.next.line == token.line})) then {",
  "                end := token.next.linePos - 1;",
  "            } else {",
  "                end := getLine(token.line).size",
  "            }",
  "        }",
  "        end",
  "    }",
  "",
  "    method replaceToken(token)leading(replaceLeading)trailing(replaceTrailing)with(s) {",
  "        def start = getTokenStart(token)includeLeadingSpace(replaceLeading)",
  "        def end = getTokenEnd(token)includeTrailingSpace(replaceTrailing)",
  "        replaceRange(start, end)with(s)onLine(token.line)",
  "    }",
  "",
  "    method replaceToken(token)with(s) {",
  "        replaceToken(token)leading(false)trailing(false)with(s)",
  "    }",
  "",
  "    method replaceTokenRange(start, end)leading(replaceLeading)trailing(replaceTrailing)with(s) {",
  "        if(start == end) then {",
  "            replaceToken(start)leading(replaceLeading)trailing(replaceTrailing)with(s)",
  "        } else {",
  "            // Get the ident and position now in case deleteTokenRange changes it.",
  "            def insertPos = getTokenStart(start)includeLeadingSpace(replaceLeading)",
  "            def indent = getLine(start.line).substringFrom(1)to(start.indent)",
  "            deleteTokenRange(start, end)leading(replaceLeading)trailing(replaceTrailing)",
  "            // If delete token range deleted the indent, then add it back.",
  "            if(getLine(start.line) == \"\") then {",
  "                insert(indent ++ s)atPosition(insertPos)onLine(start.line)",
  "            } else {",
  "                insert(s)atPosition(insertPos)onLine(start.line)",
  "            }",
  "        }",
  "    }",
  "",
  "    method replaceTokenRange(start, end)with(s) {",
  "        replaceTokenRange(start, end)leading(false)trailing(false)with(s)",
  "    }",
  "",
  "    // Deletes a token, and optionally leading and/or trailing spaces.",
  "    method deleteToken(token)leading(deleteLeading)trailing(deleteTrailing) {",
  "        def start = getTokenStart(token)includeLeadingSpace(deleteLeading)",
  "        def end = getTokenEnd(token)includeTrailingSpace(deleteTrailing)",
  "        deleteRange(start, end)onLine(token.line)",
  "    }",
  "",
  "    method deleteToken(token) {",
  "        deleteToken(token)leading(false)trailing(false)",
  "    }",
  "",
  "    // Deletes a range of tokens, and optionally leading and/or trailing spaces.",
  "    method deleteTokenRange(start, end)leading(deleteLeading)trailing(deleteTrailing) {",
  "        if(start == end) then {",
  "            deleteToken(start)leading(deleteLeading)trailing(deleteTrailing)",
  "        } else {",
  "            var line := start.line",
  "            var startPos := getTokenStart(start)includeLeadingSpace(deleteLeading)",
  "            var endPos := getTokenEnd(start)includeTrailingSpace(deleteTrailing)",
  "            var tok := start.next",
  "            while {tok != end} do {",
  "                if(tok.line != line) then {",
  "                    deleteRange(startPos, endPos)onLine(line)",
  "                    line := tok.line",
  "                    startPos := getTokenStart(tok)includeLeadingSpace(deleteLeading)",
  "                }",
  "                endPos := getTokenEnd(tok)includeTrailingSpace(deleteTrailing)",
  "                tok := tok.next",
  "            }",
  "            if(end.line != line) then {",
  "                deleteRange(startPos, endPos)onLine(line)",
  "            }",
  "            endPos := getTokenEnd(end)includeTrailingSpace(deleteTrailing)",
  "            deleteRange(startPos, endPos)onLine(end.line)",
  "        }",
  "    }",
  "",
  "    method deleteTokenRange(start, end) {",
  "        deleteTokenRange(start, end)leading(false)trailing(false)",
  "    }",
  "",
  "    method deleteLine(lineNumber) {",
  "        addLine(lineNumber, \"\")",
  "    }",
  "",
  "    method insert(s)afterToken(token)andTrailingSpace(afterTrailing) {",
  "        def pos = getTokenEnd(token)includeTrailingSpace(afterTrailing) + 1",
  "        insert(s)atPosition(pos)onLine(token.line)",
  "    }",
  "",
  "    method insert(s)afterToken(token) {",
  "        insert(s)afterToken(token)andTrailingSpace(false)",
  "    }",
  "",
  "    method insert(s)beforeToken(token) {",
  "        insert(s)atPosition(token.linePos)onLine(token.line)",
  "    }",
  "",
  "    // Insert a new line. This stores the line with the same number as the line it comes after.",
  "    method insertNewLine(line)after(lineNumber) {",
  "        addLine(lineNumber, line)",
  "    }",
  "",
  "    // Manually add a line to the suggestion. This will overwrite any previous",
  "    // changes that may have been made to this line.",
  "    method addLine(lineNumber, line) {",
  "        var i := findLine(lineNumber)",
  "        if(i != false) then {",
  "            lines.at(i)put(line)",
  "        } else {",
  "            // Add new lines to make the list big enough.",
  "            lineNumbers.push(lineNumber)",
  "            lines.push(line)",
  "            if (lines.size > 1) then {",
  "                // Re-order the list.",
  "                i := lines.size",
  "                while {(i > 1) && {lineNumber < lineNumbers.at(i - 1)}} do {",
  "                    lineNumbers.at(i) put(lineNumbers.at(i - 1))",
  "                    lines.at(i) put (lines.at(i - 1))",
  "                    i := i - 1",
  "                }",
  "                lineNumbers.at(i) put (lineNumber)",
  "                lines.at(i) put (line)",
  "            }",
  "        }",
  "    }",
  "",
  "    // Internal method used to find the index of a line in the lines array.",
  "    // Returns false if the line is not found.",
  "    method findLine(lineNumber) is confidential {",
  "        for(lineNumbers.indices) do { i ->",
  "            if(lineNumbers.at(i) == lineNumber) then {",
  "                return i",
  "            }",
  "        }",
  "        false",
  "    }",
  "",
  "    // Internal method used to get the contents of a line so far.",
  "    // If the line is not part of this suggestion then it gets the unmodified line.",
  "    method getLine(lineNumber) is confidential {",
  "        def i = findLine(lineNumber)",
  "        if(i == false) then {",
  "            util.lines.at(lineNumber)",
  "        } else {",
  "            lines.at(i)",
  "        }",
  "    }",
  "",
  "    method print {",
  "        for(1..lines.size) do { i ->",
  "            if((i > 1) && {(lineNumbers.at(i) > (lineNumbers.at(i-1) + 1))}) then {",
  "                var s := \"\"",
  "                for(1..lineNumbers.at(i-1).asString.size) do {",
  "                    s := s ++ \" \"",
  "                }",
  "                io.error.write(\"    {s}...\\n\")",
  "            }",
  "            // Handle insertion of new lines.",
  "            if(lineNumbers.at(i).truncated != lineNumbers.at(i)) then {",
  "                io.error.write(\" *{lineNumbers.at(i).truncated}: {lines.at(i)}\\n\")",
  "            } else {",
  "                io.error.write(\"  {lineNumbers.at(i)}: {lines.at(i)}\\n\")",
  "            }",
  "        }",
  "    }",
  "  }",
  "}",
  "",
  "method name (p:String) matches (t:String) within (k:Number) {",
  "    // This is algorithm EDP from Jokinen, Jorma, Tarhio and Ukkinen:",
  "    // \"A comparison of Approximate String Matching Algorithms\"",
  "    // Software—Practice and Experience Vol 1(1), January 1988, pp.1–19",
  "    //",
  "    // Implements the \"Enhanced Dynamic Programming\" (EDP) algorithm for",
  "    // approximate string matching.  If pattern p matches text t within",
  "    // an edit distance ≤ k, this method returns j, the index of the highest",
  "    // character of t involved in the match.  Its time compelxity is O(k*|p|).",
  "    //",
  "    // The algorithm builds a dynamic progarmming table D such that",
  "    // D[i,j] is the minimum edit distance between p[1] p[2] ... p[i]",
  "    // and any substring of t ending at t[j].   However, it isn't necessary",
  "    // to store the whole table D.  Because D[i,j] depends on only D[i-1, j],",
  "    // D[i-1, j-1] and D[i, j-1], we can store only the current",
  "    // column, which we do in h, and the value of D[i-1,j-1], which is",
  "    // cached in c.  Moreover, since we are not interested in edit",
  "    // distances > k, it's only necessary to evalue the elments of the table",
  "    // around the diagonal.",
  "",
  "",
  "    def m = p.size",
  "    def n = t.size",
  "    if (k >= m) then { return m }  // trivial case",
  "    def k' = min3(k, n-1, m-1)",
  "    var top := k' + 1  // the location where the topmost diagonal under",
  "                       // threshold intersects the current column",
  "    def h = emptyList",
  "    for (0..m) do { i -> h.at(i+1) put(i+1) }",
  "    try {",
  "        for (1..n) do { j ->",
  "            var c := 0",
  "            for (1..top) do { i ->",
  "                def e = if (p.at(i) == t.at(j)) then {",
  "                    c",
  "                } else {",
  "                    min3(h.at(i), h.at(i+1), c) + 1",
  "                }",
  "                c := h.at(i+1)",
  "                h.at(i+1) put (e)",
  "            }",
  "            while { (top >= 0) && {h.at(top+1) > k'} } do { top := top - 1 }",
  "            if (top == m) then {",
  "                return j    // the last character of t that was used in the match",
  "            } else {",
  "                top := top + 1",
  "            }",
  "        }",
  "    } catch { e:BoundsError -> return 0 }   // if the code is buggy, don't crash",
  "    return 0            // there was no match",
  "}",
  "",
  "method min3(a, b, c) is confidential {",
  "    def sf = if (a < b) then { a } else { b }",
  "    if (sf < c) then { sf } else { c }",
  "}",
  "",
  "",
  "// Methods to actually display an error message and suggestions, then exit.",
  "method syntaxError(message)atRange(errlinenum, startpos, endpos) {",
  "    syntaxError(message)atRange(errlinenum, startpos, endpos)withSuggestions([])",
  "}",
  "",
  "method syntaxError(message)atRange(errlinenum, startpos, endpos)withSuggestion(suggestion') {",
  "    syntaxError(message)atRange(errlinenum, startpos, endpos)withSuggestions([suggestion'])",
  "}",
  "",
  "method syntaxError(message)atRange(errlinenum, startpos, endpos)withSuggestions(suggestions) {",
  "    var loc := if(startpos == endpos) then {startpos.asString} else { \"{startpos}-{endpos}\" }",
  "    var arr := \"----\"",
  "    for (2..(startpos + errlinenum.asString.size)) do { _ ->",
  "        arr := arr ++ \"-\"",
  "    }",
  "    for (startpos..endpos) do { _ ->",
  "        arr := arr ++ \"^\"",
  "    }",
  "    util.syntaxError(message, errlinenum, \":{loc}\", arr, false, suggestions)",
  "}",
  "",
  "method error(message)atRange(errlinenum, startpos, endpos)withSuggestions(suggestions) {",
  "    var loc := if(startpos == endpos) then {startpos.asString} else { \"{startpos}-{endpos}\" }",
  "    var arr := \"----\"",
  "    for (2..(startpos + errlinenum.asString.size)) do { _ ->",
  "        arr := arr ++ \"-\"",
  "    }",
  "    for (startpos..endpos) do { _ ->",
  "        arr := arr ++ \"^\"",
  "    }",
  "    util.generalError(message, errlinenum, \":{loc}\", arr, false, suggestions)",
  "}",
  "",
  "method error(message) atRange(errlinenum, startpos, endpos) {",
  "    error (message) atRange(errlinenum, startpos, endpos) withSuggestions([])",
  "}",
  "",
  "method syntaxError(message)atPosition(errlinenum, errpos) {",
  "    syntaxError(message)atPosition(errlinenum, errpos)withSuggestions([])",
  "}",
  "",
  "method error(message) atPosition(errlinenum, errpos) {",
  "    error(message) atPosition(errlinenum, errpos) withSuggestions([])",
  "}",
  "",
  "method syntaxError(message)atPosition(errlinenum, errpos)withSuggestion(suggestion') {",
  "    syntaxError(message)atPosition(errlinenum, errpos)withSuggestions([suggestion'])",
  "}",
  "",
  "method syntaxError(message)atPosition(errlinenum, errpos)withSuggestions(suggestions) {",
  "    var arr := \"----\"",
  "    for (2..(errpos + errlinenum.asString.size)) do { _ ->",
  "        arr := arr ++ \"-\"",
  "    }",
  "    arr := arr ++ \"^\"",
  "    util.syntaxError(message, errlinenum, \":({errpos})\", arr, false, suggestions)",
  "}",
  "",
  "method error(message) atPosition(errlinenum, errpos)",
  "        withSuggestions(suggestions) {",
  "    var arr := \"----\"",
  "    for (2..(errpos + errlinenum.asString.size)) do { _ ->",
  "        arr := arr ++ \"-\"",
  "    }",
  "    arr := arr ++ \"^\"",
  "    util.generalError(message, errlinenum, \":({errpos})\", arr, false, suggestions)",
  "}",
  "",
  "method error(message) {",
  "    util.generalError(message, 0, \"\", \"\", false, [])",
  "}",
  "",
  "method error(message)atLine(errlinenum)withSuggestions(suggestions) {",
  "    var arr := \"----\"",
  "    for (1..errlinenum.asString.size) do { _ ->",
  "        arr := arr ++ \"-\"",
  "    }",
  "    for (1..util.lines.at(errlinenum).size) do { _ ->",
  "        arr := arr ++ \"^\"",
  "    }",
  "    util.generalError(message, errlinenum, \"\", arr, false, suggestions)",
  "}",
  "",
  "method error(message)atLine(errlinenum) {",
  "    error(message)atLine(errlinenum)withSuggestions([])",
  "}",
  "",
  "method syntaxError(message)atLine(errlinenum) {",
  "    syntaxError(message)atLine(errlinenum)withSuggestions([])",
  "}",
  "",
  "method syntaxError(message)atLine(errlinenum)withSuggestion(suggestion') {",
  "    syntaxError(message)atLine(errlinenum)withSuggestions([suggestion'])",
  "}",
  "",
  "method syntaxError(message)atLine(errlinenum)withSuggestions(suggestions) {",
  "    var arr := \"----\"",
  "    for (1..errlinenum.asString.size) do { _ ->",
  "        arr := arr ++ \"-\"",
  "    }",
  "    for (1..util.lines.at(errlinenum).size) do { _ ->",
  "        arr := arr ++ \"^\"",
  "    }",
  "    util.syntaxError(message, errlinenum, \"\", arr, false, suggestions)",
  "}",
  NULL
};
Object reader_errormessages_outer_516(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_errormessages_outer_519(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject*)self;
  return uo->data[0];
}
Object reader_errormessages_lineNumbers_520(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[1];
}
Object reader_errormessages_lines_521(Object self, int nparams, int *argcv, Object* args, int flags) {
  struct UserObject *uo = (struct UserObject *)self;
  return uo->data[2];
}
static Object strlit150;
static Object strlit185;
static Object strlit190;
static Object strlit194;
static Object strlit199;
static Object strlit215;
static Object strlit228;
static Object strlit236;
static Object strlit240;
static Object strlit253;
static Object strlit258;
static Object strlit262;
static Object strlit267;
static Object strlit283;
static Object strlit296;
static Object strlit304;
static Object strlit308;
static Object strlit330;
static Object strlit346;
static Object strlit353;
static Object strlit359;
static Object strlit363;
static Object strlit369;
static Object strlit385;
static Object strlit392;
static Object strlit398;
static Object strlit402;
static Object strlit410;
static Object strlit411;
static Object strlit416;
static Object strlit429;
static Object strlit449;
static Object strlit456;
static Object strlit472;
static Object strlit485;
static Object strlit505;
static Object strlit512;
Object module_io;
Object module_io_init();
Object module_sys;
Object module_sys_init();
Object module_util;
Object module_util_init();
static ClassData objclass515;
static ClassData objclass518;
static Object strlit640;
static Object strlit657;
static Object strlit661;
static Object strlit872;
static Object strlit977;
static Object strlit1181;
static Object strlit1202;
static Object strlit1210;
static Object strlit1214;
static Object strlit1236;
static Object strlit1245;
static Object strlit1255;
static Object strlit1265;
static Object strlit1274;
static Object strlit1282;
Object meth_errormessages__apply32(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_h = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile call node (depth = 4)
  int callframe33 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num35 = alloc_Float64(1);
// compiled num node returning num35 (depth = 6)
  int op_slot_right_34 = gc_frame_newslot(num35);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_34 = gc_frame_newslot(*var_i);
  params[0] = num35;
  partcv[0] = 1;
  Object sum37 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum37 (depth = 5)
  gc_frame_newslot(sum37);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num39 = alloc_Float64(1);
// compiled num node returning num39 (depth = 6)
  int op_slot_right_38 = gc_frame_newslot(num39);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  int op_slot_left_38 = gc_frame_newslot(*var_i);
  params[0] = num39;
  partcv[0] = 1;
  Object sum41 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum41 (depth = 5)
  gc_frame_newslot(sum41);
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_h (depth = 5)
  params[0] = sum37;
  params[1] = sum41;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call42 = callmethod(*var_h, "at()put",
    2, partcv, params);
  gc_frame_end(callframe33);
// compiled call node returning call42 (depth = 4)
  gc_frame_end(frame);
  return call42;
}
Object meth_errormessages__apply62(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[3];
  int partcv[2];
  Object *var_j = getfromclosure(closure, 0);
  Object *var_t = getfromclosure(closure, 1);
  Object *var_p = getfromclosure(closure, 2);
  Object *var_c = getfromclosure(closure, 3);
  Object *var_h = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_e = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "e");
// Begin line 313
  setline(313);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 8)
// starting to compile if node (depth = 9)
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe65 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_j (depth = 12)
  gc_frame_newslot(*var_j);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_t (depth = 12)
  params[0] = *var_j;
  partcv[0] = 1;
  Object call66 = callmethod(*var_t, "at",
    1, partcv, params);
  gc_frame_end(callframe65);
// compiled call node returning call66 (depth = 11)
  int op_slot_right_64 = gc_frame_newslot(call66);
// starting to compile call node (depth = 11)
  int callframe68 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_p (depth = 12)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call69 = callmethod(*var_p, "at",
    1, partcv, params);
  gc_frame_end(callframe68);
// compiled call node returning call69 (depth = 11)
  int op_slot_left_64 = gc_frame_newslot(call69);
  params[0] = call66;
  partcv[0] = 1;
  Object opresult70 = callmethod(call69, "==", 1, partcv, params);
// compiled op node returning opresult70 (depth = 10)
  Object if63 = done;
struct StackFrameObject *iftmpstackframe63 = stackframe;
  if (istrue(opresult70)) {
stackframe = alloc_StackFrame(0, iftmpstackframe63);
gc_frame_newslot((Object)stackframe);
// Begin line 314
  setline(314);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_c (depth = 10)
    gc_frame_newslot(*var_c);
    if63 = *var_c;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe63);
  gc_frame_newslot((Object)stackframe);
// Begin line 316
  setline(316);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num72 = alloc_Float64(1);
// compiled num node returning num72 (depth = 11)
  int op_slot_right_71 = gc_frame_newslot(num72);
// starting to compile call node (depth = 11)
  int callframe74 = gc_frame_new();
// starting to compile call node (depth = 12)
  int callframe75 = gc_frame_new();
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_i (depth = 13)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_h (depth = 13)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call76 = callmethod(*var_h, "at",
    1, partcv, params);
  gc_frame_end(callframe75);
// compiled call node returning call76 (depth = 12)
  gc_frame_newslot(call76);
// starting to compile call node (depth = 12)
  int callframe77 = gc_frame_new();
// starting to compile op node (depth = 13)
// starting to compile num node (depth = 14)
  Object num79 = alloc_Float64(1);
// compiled num node returning num79 (depth = 14)
  int op_slot_right_78 = gc_frame_newslot(num79);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_i (depth = 14)
  int op_slot_left_78 = gc_frame_newslot(*var_i);
  params[0] = num79;
  partcv[0] = 1;
  Object sum81 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum81 (depth = 13)
  gc_frame_newslot(sum81);
// call case 6: other member request
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_h (depth = 13)
  params[0] = sum81;
  partcv[0] = 1;
  Object call82 = callmethod(*var_h, "at",
    1, partcv, params);
  gc_frame_end(callframe77);
// compiled call node returning call82 (depth = 12)
  gc_frame_newslot(call82);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_c (depth = 12)
  gc_frame_newslot(*var_c);
// call case 4: self request
  params[0] = call76;
  params[1] = call82;
  params[2] = *var_c;
  partcv[0] = 3;
  Object call83 = callmethodflags(self, "min3", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe74);
// compiled call node returning call83 (depth = 11)
  int op_slot_left_71 = gc_frame_newslot(call83);
  params[0] = num72;
  partcv[0] = 1;
  Object sum84 = callmethod(call83, "+", 1, partcv, params);
// compiled op node returning sum84 (depth = 10)
    gc_frame_newslot(sum84);
    if63 = sum84;
  }
stackframe = iftmpstackframe63;
// compiled if node returning if63 (depth = 9)
  *var_e = if63;
  if (if63 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 8)
// Begin line 318
  setline(318);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe85 = gc_frame_new();
// starting to compile op node (depth = 10)
// starting to compile num node (depth = 11)
  Object num87 = alloc_Float64(1);
// compiled num node returning num87 (depth = 11)
  int op_slot_right_86 = gc_frame_newslot(num87);
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_i (depth = 11)
  int op_slot_left_86 = gc_frame_newslot(*var_i);
  params[0] = num87;
  partcv[0] = 1;
  Object sum89 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum89 (depth = 10)
  gc_frame_newslot(sum89);
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_h (depth = 10)
  params[0] = sum89;
  partcv[0] = 1;
  Object call90 = callmethod(*var_h, "at",
    1, partcv, params);
  gc_frame_end(callframe85);
// compiled call node returning call90 (depth = 9)
  *var_c = call90;
  if (call90 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
// Begin line 319
  setline(319);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 8)
  int callframe92 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num94 = alloc_Float64(1);
// compiled num node returning num94 (depth = 10)
  int op_slot_right_93 = gc_frame_newslot(num94);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  int op_slot_left_93 = gc_frame_newslot(*var_i);
  params[0] = num94;
  partcv[0] = 1;
  Object sum96 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum96 (depth = 9)
  gc_frame_newslot(sum96);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_e (depth = 9)
  gc_frame_newslot(*var_e);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_h (depth = 9)
  params[0] = sum96;
  params[1] = *var_e;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call97 = callmethod(*var_h, "at()put",
    2, partcv, params);
  gc_frame_end(callframe92);
// compiled call node returning call97 (depth = 8)
  gc_frame_end(frame);
  return call97;
}
Object meth_errormessages__apply105(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_k_39_ = getfromclosure(closure, 0);
  Object *var_top = getfromclosure(closure, 1);
  Object *var_h = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 10)
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_k_39_ (depth = 11)
  int op_slot_right_106 = gc_frame_newslot(*var_k_39_);
// starting to compile call node (depth = 11)
  int callframe108 = gc_frame_new();
// starting to compile op node (depth = 12)
// starting to compile num node (depth = 13)
  Object num110 = alloc_Float64(1);
// compiled num node returning num110 (depth = 13)
  int op_slot_right_109 = gc_frame_newslot(num110);
// starting to compile identifier node (depth = 13)
// compiled identifier node returning *var_top (depth = 13)
  int op_slot_left_109 = gc_frame_newslot(*var_top);
  params[0] = num110;
  partcv[0] = 1;
  Object sum112 = callmethod(*var_top, "+", 1, partcv, params);
// compiled op node returning sum112 (depth = 12)
  gc_frame_newslot(sum112);
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_h (depth = 12)
  params[0] = sum112;
  partcv[0] = 1;
  Object call113 = callmethod(*var_h, "at",
    1, partcv, params);
  gc_frame_end(callframe108);
// compiled call node returning call113 (depth = 11)
  int op_slot_left_106 = gc_frame_newslot(call113);
  params[0] = *var_k_39_;
  partcv[0] = 1;
  Object opresult114 = callmethod(call113, ">", 1, partcv, params);
// compiled op node returning opresult114 (depth = 10)
  gc_frame_end(frame);
  return opresult114;
}
Object meth_errormessages__apply102(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_k_39_ = getfromclosure(closure, 0);
  Object *var_top = getfromclosure(closure, 1);
  Object *var_h = getfromclosure(closure, 2);
  Object self = *(getfromclosure(closure, 3));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile block node (depth = 9)
  Object block104 = alloc_Block(NULL, NULL, "errormessages", 321);
  gc_frame_newslot(block104);
// method "_apply"
  block_savedest(block104);
  Object closure105 = createclosure(4, "_apply");
  setclosureframe(closure105, stackframe);
  addtoclosure(closure105, var_k_39_);
  addtoclosure(closure105, var_top);
  addtoclosure(closure105, var_h);
  addtoclosure(closure105, selfslot);
  struct UserObject *uo105 = (struct UserObject*)block104;
  uo105->data[0] = (Object)closure105;
  Method *meth_meth_errormessages__apply105 = addmethod2pos(block104, "_apply", &meth_errormessages__apply105, 0);
  int argcv_meth_errormessages__apply105[] = {0};
  meth_meth_errormessages__apply105->type = alloc_MethodType(1, argcv_meth_errormessages__apply105);
  meth_meth_errormessages__apply105->definitionModule = modulename;
  meth_meth_errormessages__apply105->definitionLine = 307;
// compiled block node returning block104 (depth = 9)
  int op_slot_right_103 = gc_frame_newslot(block104);
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num118 = alloc_Float64(0);
// compiled num node returning num118 (depth = 10)
  int op_slot_right_117 = gc_frame_newslot(num118);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_top (depth = 10)
  int op_slot_left_117 = gc_frame_newslot(*var_top);
  params[0] = num118;
  partcv[0] = 1;
  Object opresult120 = callmethod(*var_top, "≥", 1, partcv, params);
// compiled op node returning opresult120 (depth = 9)
  int op_slot_left_103 = gc_frame_newslot(opresult120);
  params[0] = block104;
  partcv[0] = 1;
  Object opresult121 = callmethod(opresult120, "&&", 1, partcv, params);
// compiled op node returning opresult121 (depth = 8)
  gc_frame_end(frame);
  return opresult121;
}
Object meth_errormessages__apply124(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_top = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num126 = alloc_Float64(1);
// compiled num node returning num126 (depth = 10)
  int op_slot_right_125 = gc_frame_newslot(num126);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_top (depth = 10)
  int op_slot_left_125 = gc_frame_newslot(*var_top);
  params[0] = num126;
  partcv[0] = 1;
  Object diff128 = callmethod(*var_top, "-", 1, partcv, params);
// compiled op node returning diff128 (depth = 9)
  *var_top = diff128;
  if (diff128 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages__apply54(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_top = getfromclosure(closure, 0);
  Object *var_t = getfromclosure(closure, 1);
  Object *var_p = getfromclosure(closure, 2);
  Object *var_h = getfromclosure(closure, 3);
  Object *var_k_39_ = getfromclosure(closure, 4);
  Object *var_m = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_j = &(stackframe->slots[0]);
  *var_j = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_c = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "c");
// Begin line 311
  setline(311);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile num node (depth = 7)
  Object num55 = alloc_Float64(0);
// compiled num node returning num55 (depth = 7)
  *var_c = num55;
  if (num55 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 312
  setline(312);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe56 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_top (depth = 8)
  int op_slot_right_57 = gc_frame_newslot(*var_top);
// starting to compile num node (depth = 8)
  Object num59 = alloc_Float64(1);
// compiled num node returning num59 (depth = 8)
  int op_slot_left_57 = gc_frame_newslot(num59);
  params[0] = *var_top;
  partcv[0] = 1;
  Object opresult60 = callmethod(num59, "..", 1, partcv, params);
// compiled op node returning opresult60 (depth = 7)
  gc_frame_newslot(opresult60);
// starting to compile block node (depth = 7)
  Object block61 = alloc_Block(NULL, NULL, "errormessages", 312);
  gc_frame_newslot(block61);
// method "_apply"
  block_savedest(block61);
  Object closure62 = createclosure(6, "_apply");
  setclosureframe(closure62, stackframe);
  addtoclosure(closure62, var_j);
  addtoclosure(closure62, var_t);
  addtoclosure(closure62, var_p);
  addtoclosure(closure62, var_c);
  addtoclosure(closure62, var_h);
  addtoclosure(closure62, selfslot);
  struct UserObject *uo62 = (struct UserObject*)block61;
  uo62->data[0] = (Object)closure62;
  Method *meth_meth_errormessages__apply62 = addmethod2pos(block61, "_apply", &meth_errormessages__apply62, 0);
  int argcv_meth_errormessages__apply62[] = {1};
  meth_meth_errormessages__apply62->type = alloc_MethodType(1, argcv_meth_errormessages__apply62);
  meth_meth_errormessages__apply62->definitionModule = modulename;
  meth_meth_errormessages__apply62->definitionLine = 307;
// compiled block node returning block61 (depth = 7)
  gc_frame_newslot(block61);
// call case 5: prelude request
  params[0] = opresult60;
  params[1] = block61;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call99 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe56);
// compiled call node returning call99 (depth = 6)
// Begin line 321
  setline(321);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe100 = gc_frame_new();
// starting to compile block node (depth = 7)
  Object block101 = alloc_Block(NULL, NULL, "errormessages", 321);
  gc_frame_newslot(block101);
// method "_apply"
  block_savedest(block101);
  Object closure102 = createclosure(4, "_apply");
  setclosureframe(closure102, stackframe);
  addtoclosure(closure102, var_k_39_);
  addtoclosure(closure102, var_top);
  addtoclosure(closure102, var_h);
  addtoclosure(closure102, selfslot);
  struct UserObject *uo102 = (struct UserObject*)block101;
  uo102->data[0] = (Object)closure102;
  Method *meth_meth_errormessages__apply102 = addmethod2pos(block101, "_apply", &meth_errormessages__apply102, 0);
  int argcv_meth_errormessages__apply102[] = {0};
  meth_meth_errormessages__apply102->type = alloc_MethodType(1, argcv_meth_errormessages__apply102);
  meth_meth_errormessages__apply102->definitionModule = modulename;
  meth_meth_errormessages__apply102->definitionLine = 307;
// compiled block node returning block101 (depth = 7)
  gc_frame_newslot(block101);
// starting to compile block node (depth = 7)
  Object block123 = alloc_Block(NULL, NULL, "errormessages", 321);
  gc_frame_newslot(block123);
// method "_apply"
  block_savedest(block123);
  Object closure124 = createclosure(2, "_apply");
  setclosureframe(closure124, stackframe);
  addtoclosure(closure124, var_top);
  addtoclosure(closure124, selfslot);
  struct UserObject *uo124 = (struct UserObject*)block123;
  uo124->data[0] = (Object)closure124;
  Method *meth_meth_errormessages__apply124 = addmethod2pos(block123, "_apply", &meth_errormessages__apply124, 0);
  int argcv_meth_errormessages__apply124[] = {0};
  meth_meth_errormessages__apply124->type = alloc_MethodType(1, argcv_meth_errormessages__apply124);
  meth_meth_errormessages__apply124->definitionModule = modulename;
  meth_meth_errormessages__apply124->definitionLine = 307;
// compiled block node returning block123 (depth = 7)
  gc_frame_newslot(block123);
// call case 5: prelude request
  params[0] = block101;
  params[1] = block123;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call131 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe100);
// compiled call node returning call131 (depth = 6)
// Begin line 322
  setline(322);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_m (depth = 8)
  int op_slot_right_133 = gc_frame_newslot(*var_m);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_top (depth = 8)
  int op_slot_left_133 = gc_frame_newslot(*var_top);
  params[0] = *var_m;
  partcv[0] = 1;
  Object opresult135 = callmethod(*var_top, "==", 1, partcv, params);
// compiled op node returning opresult135 (depth = 7)
  Object if132 = done;
  if (istrue(opresult135)) {
// Begin line 323
  setline(323);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_j (depth = 8)
  block_return(realself, *var_j);
// compiled return node returning undefined (depth = 7)
    gc_frame_newslot(undefined);
    if132 = undefined;
  } else {
// Begin line 325
  setline(325);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num137 = alloc_Float64(1);
// compiled num node returning num137 (depth = 9)
  int op_slot_right_136 = gc_frame_newslot(num137);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_top (depth = 9)
  int op_slot_left_136 = gc_frame_newslot(*var_top);
  params[0] = num137;
  partcv[0] = 1;
  Object sum139 = callmethod(*var_top, "+", 1, partcv, params);
// compiled op node returning sum139 (depth = 8)
  *var_top = sum139;
  if (sum139 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if132 = done;
  }
// compiled if node returning if132 (depth = 6)
  gc_frame_end(frame);
  return if132;
}
Object meth_errormessages__apply47(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_n = getfromclosure(closure, 0);
  Object *var_top = getfromclosure(closure, 1);
  Object *var_t = getfromclosure(closure, 2);
  Object *var_p = getfromclosure(closure, 3);
  Object *var_h = getfromclosure(closure, 4);
  Object *var_k_39_ = getfromclosure(closure, 5);
  Object *var_m = getfromclosure(closure, 6);
  Object self = *(getfromclosure(closure, 7));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 310
  setline(310);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe48 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_n (depth = 6)
  int op_slot_right_49 = gc_frame_newslot(*var_n);
// starting to compile num node (depth = 6)
  Object num51 = alloc_Float64(1);
// compiled num node returning num51 (depth = 6)
  int op_slot_left_49 = gc_frame_newslot(num51);
  params[0] = *var_n;
  partcv[0] = 1;
  Object opresult52 = callmethod(num51, "..", 1, partcv, params);
// compiled op node returning opresult52 (depth = 5)
  gc_frame_newslot(opresult52);
// starting to compile block node (depth = 5)
  Object block53 = alloc_Block(NULL, NULL, "errormessages", 310);
  gc_frame_newslot(block53);
// method "_apply"
  block_savedest(block53);
  Object closure54 = createclosure(7, "_apply");
  setclosureframe(closure54, stackframe);
  addtoclosure(closure54, var_top);
  addtoclosure(closure54, var_t);
  addtoclosure(closure54, var_p);
  addtoclosure(closure54, var_h);
  addtoclosure(closure54, var_k_39_);
  addtoclosure(closure54, var_m);
  addtoclosure(closure54, selfslot);
  struct UserObject *uo54 = (struct UserObject*)block53;
  uo54->data[0] = (Object)closure54;
  Method *meth_meth_errormessages__apply54 = addmethod2pos(block53, "_apply", &meth_errormessages__apply54, 0);
  int argcv_meth_errormessages__apply54[] = {1};
  meth_meth_errormessages__apply54->type = alloc_MethodType(1, argcv_meth_errormessages__apply54);
  meth_meth_errormessages__apply54->definitionModule = modulename;
  meth_meth_errormessages__apply54->definitionLine = 307;
// compiled block node returning block53 (depth = 5)
  gc_frame_newslot(block53);
// call case 5: prelude request
  params[0] = opresult52;
  params[1] = block53;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call142 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe48);
// compiled call node returning call142 (depth = 4)
  gc_frame_end(frame);
  return call142;
}
Object meth_errormessages__apply145(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object self = *(getfromclosure(closure, 0));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_e = &(stackframe->slots[0]);
  *var_e = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile return node (depth = 4)
// starting to compile num node (depth = 5)
  Object num146 = alloc_Float64(0);
// compiled num node returning num146 (depth = 5)
  block_return(realself, num146);
// compiled return node returning undefined (depth = 4)
  gc_frame_end(frame);
  return undefined;
}
Object meth_errormessages_name_40__41_matches_40__41_within1(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(9, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "name()matches()within");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method name()matches()within");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method name()matches()within");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method name()matches()within");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for name()matches()within (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_p = &(stackframe->slots[0]);
  *var_p = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for name");
  Object *var_t = &(stackframe->slots[1]);
  *var_t = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for matches");
  Object *var_k = &(stackframe->slots[2]);
  *var_k = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for within");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_m = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "m");
  Object *var_n = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "n");
  Object *var_k_39_ = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "k'");
  Object *var_top = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "top");
  Object *var_h = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "h");
// Begin line 301
  setline(301);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe2 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_p (depth = 5)
  partcv[0] = 0;
  Object call3 = callmethod(*var_p, "size",
    1, partcv, params);
  gc_frame_end(callframe2);
// compiled call node returning call3 (depth = 4)
// compiled member node returning call3 (depth = 3)
  *var_m = call3;
  if (call3 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 302
  setline(302);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe4 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_t (depth = 5)
  partcv[0] = 0;
  Object call5 = callmethod(*var_t, "size",
    1, partcv, params);
  gc_frame_end(callframe4);
// compiled call node returning call5 (depth = 4)
// compiled member node returning call5 (depth = 3)
  *var_n = call5;
  if (call5 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 303
  setline(303);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_m (depth = 4)
  int op_slot_right_7 = gc_frame_newslot(*var_m);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  int op_slot_left_7 = gc_frame_newslot(*var_k);
  params[0] = *var_m;
  partcv[0] = 1;
  Object opresult9 = callmethod(*var_k, "≥", 1, partcv, params);
// compiled op node returning opresult9 (depth = 3)
  Object if6 = done;
  if (istrue(opresult9)) {
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_m (depth = 4)
  return *var_m;
// compiled return node returning undefined (depth = 3)
    gc_frame_newslot(undefined);
    if6 = undefined;
  } else {
  }
// compiled if node returning if6 (depth = 2)
// Begin line 304
  setline(304);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile call node (depth = 3)
  int callframe10 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k (depth = 4)
  gc_frame_newslot(*var_k);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num12 = alloc_Float64(1);
// compiled num node returning num12 (depth = 5)
  int op_slot_right_11 = gc_frame_newslot(num12);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_n (depth = 5)
  int op_slot_left_11 = gc_frame_newslot(*var_n);
  params[0] = num12;
  partcv[0] = 1;
  Object diff14 = callmethod(*var_n, "-", 1, partcv, params);
// compiled op node returning diff14 (depth = 4)
  gc_frame_newslot(diff14);
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num16 = alloc_Float64(1);
// compiled num node returning num16 (depth = 5)
  int op_slot_right_15 = gc_frame_newslot(num16);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_m (depth = 5)
  int op_slot_left_15 = gc_frame_newslot(*var_m);
  params[0] = num16;
  partcv[0] = 1;
  Object diff18 = callmethod(*var_m, "-", 1, partcv, params);
// compiled op node returning diff18 (depth = 4)
  gc_frame_newslot(diff18);
// call case 4: self request
  params[0] = *var_k;
  params[1] = diff14;
  params[2] = diff18;
  partcv[0] = 3;
  Object call19 = callmethodflags(self, "min3", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe10);
// compiled call node returning call19 (depth = 3)
  *var_k_39_ = call19;
  if (call19 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 305
  setline(305);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile num node (depth = 4)
  Object num21 = alloc_Float64(1);
// compiled num node returning num21 (depth = 4)
  int op_slot_right_20 = gc_frame_newslot(num21);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_k_39_ (depth = 4)
  int op_slot_left_20 = gc_frame_newslot(*var_k_39_);
  params[0] = num21;
  partcv[0] = 1;
  Object sum23 = callmethod(*var_k_39_, "+", 1, partcv, params);
// compiled op node returning sum23 (depth = 3)
  *var_top = sum23;
  if (sum23 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 307
  setline(307);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile member node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe24 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call25 = callmethodflags(prelude, "emptyList", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe24);
// compiled call node returning call25 (depth = 4)
// compiled member node returning call25 (depth = 3)
  *var_h = call25;
  if (call25 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 308
  setline(308);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe26 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_m (depth = 4)
  int op_slot_right_27 = gc_frame_newslot(*var_m);
// starting to compile num node (depth = 4)
  Object num29 = alloc_Float64(0);
// compiled num node returning num29 (depth = 4)
  int op_slot_left_27 = gc_frame_newslot(num29);
  params[0] = *var_m;
  partcv[0] = 1;
  Object opresult30 = callmethod(num29, "..", 1, partcv, params);
// compiled op node returning opresult30 (depth = 3)
  gc_frame_newslot(opresult30);
// starting to compile block node (depth = 3)
  Object block31 = alloc_Block(NULL, NULL, "errormessages", 308);
  gc_frame_newslot(block31);
// method "_apply"
  block_savedest(block31);
  Object closure32 = createclosure(2, "_apply");
  setclosureframe(closure32, stackframe);
  addtoclosure(closure32, var_h);
  addtoclosure(closure32, selfslot);
  struct UserObject *uo32 = (struct UserObject*)block31;
  uo32->data[0] = (Object)closure32;
  Method *meth_meth_errormessages__apply32 = addmethod2pos(block31, "_apply", &meth_errormessages__apply32, 0);
  int argcv_meth_errormessages__apply32[] = {1};
  meth_meth_errormessages__apply32->type = alloc_MethodType(1, argcv_meth_errormessages__apply32);
  meth_meth_errormessages__apply32->definitionModule = modulename;
  meth_meth_errormessages__apply32->definitionLine = 307;
// compiled block node returning block31 (depth = 3)
  gc_frame_newslot(block31);
// call case 5: prelude request
  params[0] = opresult30;
  params[1] = block31;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call44 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe26);
// compiled call node returning call44 (depth = 2)
// Begin line 309
  setline(309);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile trycatch node (depth = 2)
// starting to compile block node (depth = 3)
  Object block46 = alloc_Block(NULL, NULL, "errormessages", 309);
  gc_frame_newslot(block46);
// method "_apply"
  block_savedest(block46);
  Object closure47 = createclosure(8, "_apply");
  setclosureframe(closure47, stackframe);
  addtoclosure(closure47, var_n);
  addtoclosure(closure47, var_top);
  addtoclosure(closure47, var_t);
  addtoclosure(closure47, var_p);
  addtoclosure(closure47, var_h);
  addtoclosure(closure47, var_k_39_);
  addtoclosure(closure47, var_m);
  addtoclosure(closure47, selfslot);
  struct UserObject *uo47 = (struct UserObject*)block46;
  uo47->data[0] = (Object)closure47;
  Method *meth_meth_errormessages__apply47 = addmethod2pos(block46, "_apply", &meth_errormessages__apply47, 0);
  int argcv_meth_errormessages__apply47[] = {0};
  meth_meth_errormessages__apply47->type = alloc_MethodType(1, argcv_meth_errormessages__apply47);
  meth_meth_errormessages__apply47->definitionModule = modulename;
  meth_meth_errormessages__apply47->definitionLine = 307;
// compiled block node returning block46 (depth = 3)
  int frame45 = gc_frame_new();
  gc_frame_newslot(block46);
// Begin line 328
  setline(328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile block node (depth = 3)
  Object block144 = alloc_Block(NULL, NULL, "errormessages", 328);
  gc_frame_newslot(block144);
// method "_apply"
  block_savedest(block144);
  Object closure145 = createclosure(1, "_apply");
  setclosureframe(closure145, stackframe);
  addtoclosure(closure145, selfslot);
  struct UserObject *uo145 = (struct UserObject*)block144;
  uo145->data[0] = (Object)closure145;
  Method *meth_meth_errormessages__apply145 = addmethod2pos(block144, "_apply", &meth_errormessages__apply145, 0);
  int argcv_meth_errormessages__apply145[] = {1};
  meth_meth_errormessages__apply145->type = alloc_MethodType(1, argcv_meth_errormessages__apply145);
  meth_meth_errormessages__apply145->definitionModule = modulename;
  meth_meth_errormessages__apply145->definitionLine = 307;
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe148 = gc_frame_new();
// starting to compile call node (depth = 5)
  int callframe149 = gc_frame_new();
// starting to compile string node (depth = 6)
  if (strlit150 == NULL) {
    strlit150 = alloc_String("e");
    gc_root(strlit150);
  }
// compiled string node returning strlit150 (depth = 6)
  gc_frame_newslot(strlit150);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe151 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call152 = callmethodflags(prelude, "VariablePattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe151);
// compiled call node returning call152 (depth = 7)
// compiled member node returning call152 (depth = 6)
  params[0] = strlit150;
  partcv[0] = 1;
  Object call153 = callmethod(call152, "new",
    1, partcv, params);
  gc_frame_end(callframe149);
// compiled call node returning call153 (depth = 5)
  gc_frame_newslot(call153);
// Begin line 328
  setline(328);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe154 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call155 = callmethodflags(prelude, "BoundsError", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe154);
// compiled call node returning call155 (depth = 6)
// compiled member node returning call155 (depth = 5)
  gc_frame_newslot(call155);
// call case 6: other member request
// Begin line 0
  setline(0);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe156 = gc_frame_new();
// call case 5: prelude request
  partcv[0] = 0;
  Object call157 = callmethodflags(prelude, "AndPattern", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe156);
// compiled call node returning call157 (depth = 6)
// compiled member node returning call157 (depth = 5)
  params[0] = call153;
  params[1] = call155;
  partcv[0] = 2;
  Object call158 = callmethod(call157, "new",
    1, partcv, params);
  gc_frame_end(callframe148);
// compiled call node returning call158 (depth = 4)
((struct UserObject *)block144)->data[1] = call158;
// compiled block node returning block144 (depth = 3)
  gc_frame_newslot(block144);
  params[0] = block144;
  setline(309);
  Object catchres45 = tryCatch(block46, params, 1,NULL);
  gc_frame_end(frame45);
// compiled trycatch node returning catchres45 (depth = 2)
// Begin line 329
  setline(329);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 2)
// starting to compile num node (depth = 3)
  Object num159 = alloc_Float64(0);
// compiled num node returning num159 (depth = 3)
  return num159;
// compiled return node returning undefined (depth = 2)
  gc_frame_end(frame);
  return undefined;
}
Object meth_errormessages_min3160(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "min3");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 3)
    graceRaise(RequestError(), "insufficient arguments to method min3");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for min3 (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_a = &(stackframe->slots[0]);
  *var_a = args[curarg];
  curarg++;
  Object *var_b = &(stackframe->slots[1]);
  *var_b = args[curarg];
  curarg++;
  Object *var_c = &(stackframe->slots[2]);
  *var_c = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 3)
    graceRaise(RequestError(), "wrong number of arguments for min3");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_sf = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "sf");
// Begin line 333
  setline(333);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 2)
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_b (depth = 5)
  int op_slot_right_162 = gc_frame_newslot(*var_b);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_a (depth = 5)
  int op_slot_left_162 = gc_frame_newslot(*var_a);
  params[0] = *var_b;
  partcv[0] = 1;
  Object opresult164 = callmethod(*var_a, "<", 1, partcv, params);
// compiled op node returning opresult164 (depth = 4)
  Object if161 = done;
struct StackFrameObject *iftmpstackframe161 = stackframe;
  if (istrue(opresult164)) {
stackframe = alloc_StackFrame(0, iftmpstackframe161);
gc_frame_newslot((Object)stackframe);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_a (depth = 4)
    gc_frame_newslot(*var_a);
    if161 = *var_a;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe161);
  gc_frame_newslot((Object)stackframe);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_b (depth = 4)
    gc_frame_newslot(*var_b);
    if161 = *var_b;
  }
stackframe = iftmpstackframe161;
// compiled if node returning if161 (depth = 3)
  *var_sf = if161;
  if (if161 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 2)
// Begin line 334
  setline(334);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_c (depth = 4)
  int op_slot_right_166 = gc_frame_newslot(*var_c);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_sf (depth = 4)
  int op_slot_left_166 = gc_frame_newslot(*var_sf);
  params[0] = *var_c;
  partcv[0] = 1;
  Object opresult168 = callmethod(*var_sf, "<", 1, partcv, params);
// compiled op node returning opresult168 (depth = 3)
  Object if165 = done;
  if (istrue(opresult168)) {
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_sf (depth = 3)
    gc_frame_newslot(*var_sf);
    if165 = *var_sf;
  } else {
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_c (depth = 3)
    gc_frame_newslot(*var_c);
    if165 = *var_c;
  }
// compiled if node returning if165 (depth = 2)
  gc_frame_end(frame);
  return if165;
}
Object meth_errormessages_syntaxError_40__41_atRange169(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "syntaxError()atRange");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError()atRange");
  if (nparts > 0 && argcv[1] < 3)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError()atRange");
  Object params[5];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError()atRange (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for syntaxError");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_startpos = &(stackframe->slots[2]);
  *var_startpos = args[curarg];
  curarg++;
  Object *var_endpos = &(stackframe->slots[3]);
  *var_endpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 3)
    graceRaise(RequestError(), "wrong number of arguments for atRange");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 340
  setline(340);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe170 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_startpos (depth = 3)
  gc_frame_newslot(*var_startpos);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_endpos (depth = 3)
  gc_frame_newslot(*var_endpos);
// starting to compile array node (depth = 3)
  Object array171 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array171 (depth = 3)
  gc_frame_newslot(array171);
// call case 4: self request
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = *var_startpos;
  params[3] = *var_endpos;
  params[4] = array171;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call172 = callmethodflags(self, "syntaxError()atRange()withSuggestions", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe170);
// compiled call node returning call172 (depth = 2)
  gc_frame_end(frame);
  return call172;
}
Object meth_errormessages_syntaxError_40__41_atRange_40__41_withSuggestion173(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "syntaxError()atRange()withSuggestion");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError()atRange()withSuggestion");
  if (nparts > 0 && argcv[1] < 3)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError()atRange()withSuggestion");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError()atRange()withSuggestion");
  Object params[5];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError()atRange()withSuggestion (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for syntaxError");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_startpos = &(stackframe->slots[2]);
  *var_startpos = args[curarg];
  curarg++;
  Object *var_endpos = &(stackframe->slots[3]);
  *var_endpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 3)
    graceRaise(RequestError(), "wrong number of arguments for atRange");
  Object *var_suggestion_39_ = &(stackframe->slots[4]);
  *var_suggestion_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for withSuggestion");
  Object *selfslot = &(stackframe->slots[5]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 344
  setline(344);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe174 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_startpos (depth = 3)
  gc_frame_newslot(*var_startpos);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_endpos (depth = 3)
  gc_frame_newslot(*var_endpos);
// starting to compile array node (depth = 3)
  Object array175 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion_39_ (depth = 4)
  params[0] = *var_suggestion_39_;
  partcv[0] = 1;
  callmethodflags(array175, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array175 (depth = 3)
  gc_frame_newslot(array175);
// call case 4: self request
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = *var_startpos;
  params[3] = *var_endpos;
  params[4] = array175;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call176 = callmethodflags(self, "syntaxError()atRange()withSuggestions", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe174);
// compiled call node returning call176 (depth = 2)
  gc_frame_end(frame);
  return call176;
}
Object meth_errormessages__apply213(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___0 = &(stackframe->slots[0]);
  *var___0 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 351
  setline(351);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit215 == NULL) {
    strlit215 = alloc_String("-");
    gc_root(strlit215);
  }
// compiled string node returning strlit215 (depth = 6)
  int op_slot_right_214 = gc_frame_newslot(strlit215);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_214 = gc_frame_newslot(*var_arr);
  params[0] = strlit215;
  partcv[0] = 1;
  Object opresult217 = callmethod(*var_arr, "++", 1, partcv, params);
// compiled op node returning opresult217 (depth = 5)
  *var_arr = opresult217;
  if (opresult217 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages__apply226(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___1 = &(stackframe->slots[0]);
  *var___1 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 354
  setline(354);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit228 == NULL) {
    strlit228 = alloc_String("^");
    gc_root(strlit228);
  }
// compiled string node returning strlit228 (depth = 6)
  int op_slot_right_227 = gc_frame_newslot(strlit228);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_227 = gc_frame_newslot(*var_arr);
  params[0] = strlit228;
  partcv[0] = 1;
  Object opresult230 = callmethod(*var_arr, "++", 1, partcv, params);
// compiled op node returning opresult230 (depth = 5)
  *var_arr = opresult230;
  if (opresult230 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_syntaxError_40__41_atRange_40__41_withSuggestions177(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 5, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "syntaxError()atRange()withSuggestions");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError()atRange()withSuggestions");
  if (nparts > 0 && argcv[1] < 3)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError()atRange()withSuggestions");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError()atRange()withSuggestions");
  Object params[6];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError()atRange()withSuggestions (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for syntaxError");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_startpos = &(stackframe->slots[2]);
  *var_startpos = args[curarg];
  curarg++;
  Object *var_endpos = &(stackframe->slots[3]);
  *var_endpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 3)
    graceRaise(RequestError(), "wrong number of arguments for atRange");
  Object *var_suggestions = &(stackframe->slots[4]);
  *var_suggestions = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for withSuggestions");
  Object *selfslot = &(stackframe->slots[5]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_loc = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "loc");
  Object *var_arr = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "arr");
// Begin line 348
  setline(348);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_endpos (depth = 5)
  int op_slot_right_179 = gc_frame_newslot(*var_endpos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startpos (depth = 5)
  int op_slot_left_179 = gc_frame_newslot(*var_startpos);
  params[0] = *var_endpos;
  partcv[0] = 1;
  Object opresult181 = callmethod(*var_startpos, "==", 1, partcv, params);
// compiled op node returning opresult181 (depth = 4)
  Object if178 = done;
struct StackFrameObject *iftmpstackframe178 = stackframe;
  if (istrue(opresult181)) {
stackframe = alloc_StackFrame(0, iftmpstackframe178);
gc_frame_newslot((Object)stackframe);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe182 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_startpos (depth = 6)
  partcv[0] = 0;
  Object call183 = callmethod(*var_startpos, "asString",
    1, partcv, params);
  gc_frame_end(callframe182);
// compiled call node returning call183 (depth = 5)
// compiled member node returning call183 (depth = 4)
    gc_frame_newslot(call183);
    if178 = call183;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe178);
  gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit185 == NULL) {
    strlit185 = alloc_String("");
    gc_root(strlit185);
  }
// compiled string node returning strlit185 (depth = 5)
  int op_slot_right_184 = gc_frame_newslot(strlit185);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_endpos (depth = 6)
  int op_slot_right_187 = gc_frame_newslot(*var_endpos);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit190 == NULL) {
    strlit190 = alloc_String("-");
    gc_root(strlit190);
  }
// compiled string node returning strlit190 (depth = 7)
  int op_slot_right_189 = gc_frame_newslot(strlit190);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_startpos (depth = 8)
  int op_slot_right_192 = gc_frame_newslot(*var_startpos);
// starting to compile string node (depth = 8)
  if (strlit194 == NULL) {
    strlit194 = alloc_String("");
    gc_root(strlit194);
  }
// compiled string node returning strlit194 (depth = 8)
  int op_slot_left_192 = gc_frame_newslot(strlit194);
  params[0] = *var_startpos;
  partcv[0] = 1;
  Object opresult195 = callmethod(strlit194, "++", 1, partcv, params);
// compiled op node returning opresult195 (depth = 7)
  int op_slot_left_189 = gc_frame_newslot(opresult195);
  params[0] = strlit190;
  partcv[0] = 1;
  Object opresult196 = callmethod(opresult195, "++", 1, partcv, params);
// compiled op node returning opresult196 (depth = 6)
  int op_slot_left_187 = gc_frame_newslot(opresult196);
  params[0] = *var_endpos;
  partcv[0] = 1;
  Object opresult197 = callmethod(opresult196, "++", 1, partcv, params);
// compiled op node returning opresult197 (depth = 5)
  int op_slot_left_184 = gc_frame_newslot(opresult197);
  params[0] = strlit185;
  partcv[0] = 1;
  Object opresult198 = callmethod(opresult197, "++", 1, partcv, params);
// compiled op node returning opresult198 (depth = 4)
    gc_frame_newslot(opresult198);
    if178 = opresult198;
  }
stackframe = iftmpstackframe178;
// compiled if node returning if178 (depth = 3)
  *var_loc = if178;
  if (if178 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 349
  setline(349);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit199 == NULL) {
    strlit199 = alloc_String("----");
    gc_root(strlit199);
  }
// compiled string node returning strlit199 (depth = 3)
  *var_arr = strlit199;
  if (strlit199 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 350
  setline(350);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe200 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe203 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe204 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errlinenum (depth = 9)
  partcv[0] = 0;
  Object call205 = callmethod(*var_errlinenum, "asString",
    1, partcv, params);
  gc_frame_end(callframe204);
// compiled call node returning call205 (depth = 8)
// compiled member node returning call205 (depth = 7)
  partcv[0] = 0;
  Object call206 = callmethod(call205, "size",
    1, partcv, params);
  gc_frame_end(callframe203);
// compiled call node returning call206 (depth = 6)
// compiled member node returning call206 (depth = 5)
  int op_slot_right_202 = gc_frame_newslot(call206);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startpos (depth = 5)
  int op_slot_left_202 = gc_frame_newslot(*var_startpos);
  params[0] = call206;
  partcv[0] = 1;
  Object sum208 = callmethod(*var_startpos, "+", 1, partcv, params);
// compiled op node returning sum208 (depth = 4)
  int op_slot_right_201 = gc_frame_newslot(sum208);
// starting to compile num node (depth = 4)
  Object num210 = alloc_Float64(2);
// compiled num node returning num210 (depth = 4)
  int op_slot_left_201 = gc_frame_newslot(num210);
  params[0] = sum208;
  partcv[0] = 1;
  Object opresult211 = callmethod(num210, "..", 1, partcv, params);
// compiled op node returning opresult211 (depth = 3)
  gc_frame_newslot(opresult211);
// starting to compile block node (depth = 3)
  Object block212 = alloc_Block(NULL, NULL, "errormessages", 350);
  gc_frame_newslot(block212);
// method "_apply"
  block_savedest(block212);
  Object closure213 = createclosure(2, "_apply");
  setclosureframe(closure213, stackframe);
  addtoclosure(closure213, var_arr);
  addtoclosure(closure213, selfslot);
  struct UserObject *uo213 = (struct UserObject*)block212;
  uo213->data[0] = (Object)closure213;
  Method *meth_meth_errormessages__apply213 = addmethod2pos(block212, "_apply", &meth_errormessages__apply213, 0);
  int argcv_meth_errormessages__apply213[] = {1};
  meth_meth_errormessages__apply213->type = alloc_MethodType(1, argcv_meth_errormessages__apply213);
  meth_meth_errormessages__apply213->definitionModule = modulename;
  meth_meth_errormessages__apply213->definitionLine = 350;
// compiled block node returning block212 (depth = 3)
  gc_frame_newslot(block212);
// call case 5: prelude request
  params[0] = opresult211;
  params[1] = block212;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call220 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe200);
// compiled call node returning call220 (depth = 2)
// Begin line 353
  setline(353);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe221 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_endpos (depth = 4)
  int op_slot_right_222 = gc_frame_newslot(*var_endpos);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startpos (depth = 4)
  int op_slot_left_222 = gc_frame_newslot(*var_startpos);
  params[0] = *var_endpos;
  partcv[0] = 1;
  Object opresult224 = callmethod(*var_startpos, "..", 1, partcv, params);
// compiled op node returning opresult224 (depth = 3)
  gc_frame_newslot(opresult224);
// starting to compile block node (depth = 3)
  Object block225 = alloc_Block(NULL, NULL, "errormessages", 353);
  gc_frame_newslot(block225);
// method "_apply"
  block_savedest(block225);
  Object closure226 = createclosure(2, "_apply");
  setclosureframe(closure226, stackframe);
  addtoclosure(closure226, var_arr);
  addtoclosure(closure226, selfslot);
  struct UserObject *uo226 = (struct UserObject*)block225;
  uo226->data[0] = (Object)closure226;
  Method *meth_meth_errormessages__apply226 = addmethod2pos(block225, "_apply", &meth_errormessages__apply226, 0);
  int argcv_meth_errormessages__apply226[] = {1};
  meth_meth_errormessages__apply226->type = alloc_MethodType(1, argcv_meth_errormessages__apply226);
  meth_meth_errormessages__apply226->definitionModule = modulename;
  meth_meth_errormessages__apply226->definitionLine = 350;
// compiled block node returning block225 (depth = 3)
  gc_frame_newslot(block225);
// call case 5: prelude request
  params[0] = opresult224;
  params[1] = block225;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call233 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe221);
// compiled call node returning call233 (depth = 2)
// Begin line 356
  setline(356);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe234 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit236 == NULL) {
    strlit236 = alloc_String("");
    gc_root(strlit236);
  }
// compiled string node returning strlit236 (depth = 4)
  int op_slot_right_235 = gc_frame_newslot(strlit236);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_loc (depth = 5)
  int op_slot_right_238 = gc_frame_newslot(*var_loc);
// starting to compile string node (depth = 5)
  if (strlit240 == NULL) {
    strlit240 = alloc_String(":");
    gc_root(strlit240);
  }
// compiled string node returning strlit240 (depth = 5)
  int op_slot_left_238 = gc_frame_newslot(strlit240);
  params[0] = *var_loc;
  partcv[0] = 1;
  Object opresult241 = callmethod(strlit240, "++", 1, partcv, params);
// compiled op node returning opresult241 (depth = 4)
  int op_slot_left_235 = gc_frame_newslot(opresult241);
  params[0] = strlit236;
  partcv[0] = 1;
  Object opresult242 = callmethod(opresult241, "++", 1, partcv, params);
// compiled op node returning opresult242 (depth = 3)
  gc_frame_newslot(opresult242);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arr (depth = 3)
  gc_frame_newslot(*var_arr);
// starting to compile identifier node (depth = 3)
  Object bool243 = alloc_Boolean(0);
// compiled identifier node returning bool243 (depth = 3)
  gc_frame_newslot(bool243);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = opresult242;
  params[3] = *var_arr;
  params[4] = bool243;
  params[5] = *var_suggestions;
  partcv[0] = 6;
  Object call244 = callmethod(*var_util, "syntaxError",
    1, partcv, params);
  gc_frame_end(callframe234);
// compiled call node returning call244 (depth = 2)
  gc_frame_end(frame);
  return call244;
}
Object meth_errormessages__apply281(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___2 = &(stackframe->slots[0]);
  *var___2 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 363
  setline(363);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit283 == NULL) {
    strlit283 = alloc_String("-");
    gc_root(strlit283);
  }
// compiled string node returning strlit283 (depth = 6)
  int op_slot_right_282 = gc_frame_newslot(strlit283);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_282 = gc_frame_newslot(*var_arr);
  params[0] = strlit283;
  partcv[0] = 1;
  Object opresult285 = callmethod(*var_arr, "++", 1, partcv, params);
// compiled op node returning opresult285 (depth = 5)
  *var_arr = opresult285;
  if (opresult285 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages__apply294(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___3 = &(stackframe->slots[0]);
  *var___3 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 366
  setline(366);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit296 == NULL) {
    strlit296 = alloc_String("^");
    gc_root(strlit296);
  }
// compiled string node returning strlit296 (depth = 6)
  int op_slot_right_295 = gc_frame_newslot(strlit296);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_295 = gc_frame_newslot(*var_arr);
  params[0] = strlit296;
  partcv[0] = 1;
  Object opresult298 = callmethod(*var_arr, "++", 1, partcv, params);
// compiled op node returning opresult298 (depth = 5)
  *var_arr = opresult298;
  if (opresult298 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_error_40__41_atRange_40__41_withSuggestions245(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 6, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(8, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "error()atRange()withSuggestions");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error()atRange()withSuggestions");
  if (nparts > 0 && argcv[1] < 3)
    graceRaise(RequestError(), "insufficient arguments to method error()atRange()withSuggestions");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error()atRange()withSuggestions");
  Object params[6];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for error()atRange()withSuggestions (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for error");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_startpos = &(stackframe->slots[2]);
  *var_startpos = args[curarg];
  curarg++;
  Object *var_endpos = &(stackframe->slots[3]);
  *var_endpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 3)
    graceRaise(RequestError(), "wrong number of arguments for atRange");
  Object *var_suggestions = &(stackframe->slots[4]);
  *var_suggestions = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for withSuggestions");
  Object *selfslot = &(stackframe->slots[5]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_loc = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "loc");
  Object *var_arr = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "arr");
// Begin line 360
  setline(360);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_endpos (depth = 5)
  int op_slot_right_247 = gc_frame_newslot(*var_endpos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startpos (depth = 5)
  int op_slot_left_247 = gc_frame_newslot(*var_startpos);
  params[0] = *var_endpos;
  partcv[0] = 1;
  Object opresult249 = callmethod(*var_startpos, "==", 1, partcv, params);
// compiled op node returning opresult249 (depth = 4)
  Object if246 = done;
struct StackFrameObject *iftmpstackframe246 = stackframe;
  if (istrue(opresult249)) {
stackframe = alloc_StackFrame(0, iftmpstackframe246);
gc_frame_newslot((Object)stackframe);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe250 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_startpos (depth = 6)
  partcv[0] = 0;
  Object call251 = callmethod(*var_startpos, "asString",
    1, partcv, params);
  gc_frame_end(callframe250);
// compiled call node returning call251 (depth = 5)
// compiled member node returning call251 (depth = 4)
    gc_frame_newslot(call251);
    if246 = call251;
  } else {
  stackframe = alloc_StackFrame(0, iftmpstackframe246);
  gc_frame_newslot((Object)stackframe);
// starting to compile op node (depth = 4)
// starting to compile string node (depth = 5)
  if (strlit253 == NULL) {
    strlit253 = alloc_String("");
    gc_root(strlit253);
  }
// compiled string node returning strlit253 (depth = 5)
  int op_slot_right_252 = gc_frame_newslot(strlit253);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_endpos (depth = 6)
  int op_slot_right_255 = gc_frame_newslot(*var_endpos);
// starting to compile op node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit258 == NULL) {
    strlit258 = alloc_String("-");
    gc_root(strlit258);
  }
// compiled string node returning strlit258 (depth = 7)
  int op_slot_right_257 = gc_frame_newslot(strlit258);
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_startpos (depth = 8)
  int op_slot_right_260 = gc_frame_newslot(*var_startpos);
// starting to compile string node (depth = 8)
  if (strlit262 == NULL) {
    strlit262 = alloc_String("");
    gc_root(strlit262);
  }
// compiled string node returning strlit262 (depth = 8)
  int op_slot_left_260 = gc_frame_newslot(strlit262);
  params[0] = *var_startpos;
  partcv[0] = 1;
  Object opresult263 = callmethod(strlit262, "++", 1, partcv, params);
// compiled op node returning opresult263 (depth = 7)
  int op_slot_left_257 = gc_frame_newslot(opresult263);
  params[0] = strlit258;
  partcv[0] = 1;
  Object opresult264 = callmethod(opresult263, "++", 1, partcv, params);
// compiled op node returning opresult264 (depth = 6)
  int op_slot_left_255 = gc_frame_newslot(opresult264);
  params[0] = *var_endpos;
  partcv[0] = 1;
  Object opresult265 = callmethod(opresult264, "++", 1, partcv, params);
// compiled op node returning opresult265 (depth = 5)
  int op_slot_left_252 = gc_frame_newslot(opresult265);
  params[0] = strlit253;
  partcv[0] = 1;
  Object opresult266 = callmethod(opresult265, "++", 1, partcv, params);
// compiled op node returning opresult266 (depth = 4)
    gc_frame_newslot(opresult266);
    if246 = opresult266;
  }
stackframe = iftmpstackframe246;
// compiled if node returning if246 (depth = 3)
  *var_loc = if246;
  if (if246 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 361
  setline(361);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit267 == NULL) {
    strlit267 = alloc_String("----");
    gc_root(strlit267);
  }
// compiled string node returning strlit267 (depth = 3)
  *var_arr = strlit267;
  if (strlit267 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 362
  setline(362);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe268 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe271 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe272 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errlinenum (depth = 9)
  partcv[0] = 0;
  Object call273 = callmethod(*var_errlinenum, "asString",
    1, partcv, params);
  gc_frame_end(callframe272);
// compiled call node returning call273 (depth = 8)
// compiled member node returning call273 (depth = 7)
  partcv[0] = 0;
  Object call274 = callmethod(call273, "size",
    1, partcv, params);
  gc_frame_end(callframe271);
// compiled call node returning call274 (depth = 6)
// compiled member node returning call274 (depth = 5)
  int op_slot_right_270 = gc_frame_newslot(call274);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startpos (depth = 5)
  int op_slot_left_270 = gc_frame_newslot(*var_startpos);
  params[0] = call274;
  partcv[0] = 1;
  Object sum276 = callmethod(*var_startpos, "+", 1, partcv, params);
// compiled op node returning sum276 (depth = 4)
  int op_slot_right_269 = gc_frame_newslot(sum276);
// starting to compile num node (depth = 4)
  Object num278 = alloc_Float64(2);
// compiled num node returning num278 (depth = 4)
  int op_slot_left_269 = gc_frame_newslot(num278);
  params[0] = sum276;
  partcv[0] = 1;
  Object opresult279 = callmethod(num278, "..", 1, partcv, params);
// compiled op node returning opresult279 (depth = 3)
  gc_frame_newslot(opresult279);
// starting to compile block node (depth = 3)
  Object block280 = alloc_Block(NULL, NULL, "errormessages", 362);
  gc_frame_newslot(block280);
// method "_apply"
  block_savedest(block280);
  Object closure281 = createclosure(2, "_apply");
  setclosureframe(closure281, stackframe);
  addtoclosure(closure281, var_arr);
  addtoclosure(closure281, selfslot);
  struct UserObject *uo281 = (struct UserObject*)block280;
  uo281->data[0] = (Object)closure281;
  Method *meth_meth_errormessages__apply281 = addmethod2pos(block280, "_apply", &meth_errormessages__apply281, 0);
  int argcv_meth_errormessages__apply281[] = {1};
  meth_meth_errormessages__apply281->type = alloc_MethodType(1, argcv_meth_errormessages__apply281);
  meth_meth_errormessages__apply281->definitionModule = modulename;
  meth_meth_errormessages__apply281->definitionLine = 362;
// compiled block node returning block280 (depth = 3)
  gc_frame_newslot(block280);
// call case 5: prelude request
  params[0] = opresult279;
  params[1] = block280;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call288 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe268);
// compiled call node returning call288 (depth = 2)
// Begin line 365
  setline(365);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe289 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_endpos (depth = 4)
  int op_slot_right_290 = gc_frame_newslot(*var_endpos);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_startpos (depth = 4)
  int op_slot_left_290 = gc_frame_newslot(*var_startpos);
  params[0] = *var_endpos;
  partcv[0] = 1;
  Object opresult292 = callmethod(*var_startpos, "..", 1, partcv, params);
// compiled op node returning opresult292 (depth = 3)
  gc_frame_newslot(opresult292);
// starting to compile block node (depth = 3)
  Object block293 = alloc_Block(NULL, NULL, "errormessages", 365);
  gc_frame_newslot(block293);
// method "_apply"
  block_savedest(block293);
  Object closure294 = createclosure(2, "_apply");
  setclosureframe(closure294, stackframe);
  addtoclosure(closure294, var_arr);
  addtoclosure(closure294, selfslot);
  struct UserObject *uo294 = (struct UserObject*)block293;
  uo294->data[0] = (Object)closure294;
  Method *meth_meth_errormessages__apply294 = addmethod2pos(block293, "_apply", &meth_errormessages__apply294, 0);
  int argcv_meth_errormessages__apply294[] = {1};
  meth_meth_errormessages__apply294->type = alloc_MethodType(1, argcv_meth_errormessages__apply294);
  meth_meth_errormessages__apply294->definitionModule = modulename;
  meth_meth_errormessages__apply294->definitionLine = 362;
// compiled block node returning block293 (depth = 3)
  gc_frame_newslot(block293);
// call case 5: prelude request
  params[0] = opresult292;
  params[1] = block293;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call301 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe289);
// compiled call node returning call301 (depth = 2)
// Begin line 368
  setline(368);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe302 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit304 == NULL) {
    strlit304 = alloc_String("");
    gc_root(strlit304);
  }
// compiled string node returning strlit304 (depth = 4)
  int op_slot_right_303 = gc_frame_newslot(strlit304);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_loc (depth = 5)
  int op_slot_right_306 = gc_frame_newslot(*var_loc);
// starting to compile string node (depth = 5)
  if (strlit308 == NULL) {
    strlit308 = alloc_String(":");
    gc_root(strlit308);
  }
// compiled string node returning strlit308 (depth = 5)
  int op_slot_left_306 = gc_frame_newslot(strlit308);
  params[0] = *var_loc;
  partcv[0] = 1;
  Object opresult309 = callmethod(strlit308, "++", 1, partcv, params);
// compiled op node returning opresult309 (depth = 4)
  int op_slot_left_303 = gc_frame_newslot(opresult309);
  params[0] = strlit304;
  partcv[0] = 1;
  Object opresult310 = callmethod(opresult309, "++", 1, partcv, params);
// compiled op node returning opresult310 (depth = 3)
  gc_frame_newslot(opresult310);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arr (depth = 3)
  gc_frame_newslot(*var_arr);
// starting to compile identifier node (depth = 3)
  Object bool311 = alloc_Boolean(0);
// compiled identifier node returning bool311 (depth = 3)
  gc_frame_newslot(bool311);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = opresult310;
  params[3] = *var_arr;
  params[4] = bool311;
  params[5] = *var_suggestions;
  partcv[0] = 6;
  Object call312 = callmethod(*var_util, "generalError",
    1, partcv, params);
  gc_frame_end(callframe302);
// compiled call node returning call312 (depth = 2)
  gc_frame_end(frame);
  return call312;
}
Object meth_errormessages_error_40__41_atRange313(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "error()atRange");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error()atRange");
  if (nparts > 0 && argcv[1] < 3)
    graceRaise(RequestError(), "insufficient arguments to method error()atRange");
  Object params[5];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for error()atRange (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for error");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_startpos = &(stackframe->slots[2]);
  *var_startpos = args[curarg];
  curarg++;
  Object *var_endpos = &(stackframe->slots[3]);
  *var_endpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 3)
    graceRaise(RequestError(), "wrong number of arguments for atRange");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 372
  setline(372);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe314 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_startpos (depth = 3)
  gc_frame_newslot(*var_startpos);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_endpos (depth = 3)
  gc_frame_newslot(*var_endpos);
// starting to compile array node (depth = 3)
  Object array315 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array315 (depth = 3)
  gc_frame_newslot(array315);
// call case 4: self request
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = *var_startpos;
  params[3] = *var_endpos;
  params[4] = array315;
  partcv[0] = 1;
  partcv[1] = 3;
  partcv[2] = 1;
  Object call316 = callmethodflags(self, "error()atRange()withSuggestions", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe314);
// compiled call node returning call316 (depth = 2)
  gc_frame_end(frame);
  return call316;
}
Object meth_errormessages_syntaxError_40__41_atPosition317(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "syntaxError()atPosition");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError()atPosition");
  if (nparts > 0 && argcv[1] < 2)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError()atPosition");
  Object params[4];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError()atPosition (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for syntaxError");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_errpos = &(stackframe->slots[2]);
  *var_errpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 2)
    graceRaise(RequestError(), "wrong number of arguments for atPosition");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 376
  setline(376);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe318 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errpos (depth = 3)
  gc_frame_newslot(*var_errpos);
// starting to compile array node (depth = 3)
  Object array319 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array319 (depth = 3)
  gc_frame_newslot(array319);
// call case 4: self request
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = *var_errpos;
  params[3] = array319;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call320 = callmethodflags(self, "syntaxError()atPosition()withSuggestions", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe318);
// compiled call node returning call320 (depth = 2)
  gc_frame_end(frame);
  return call320;
}
Object meth_errormessages_error_40__41_atPosition321(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "error()atPosition");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error()atPosition");
  if (nparts > 0 && argcv[1] < 2)
    graceRaise(RequestError(), "insufficient arguments to method error()atPosition");
  Object params[4];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for error()atPosition (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for error");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_errpos = &(stackframe->slots[2]);
  *var_errpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 2)
    graceRaise(RequestError(), "wrong number of arguments for atPosition");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 380
  setline(380);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe322 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errpos (depth = 3)
  gc_frame_newslot(*var_errpos);
// starting to compile array node (depth = 3)
  Object array323 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array323 (depth = 3)
  gc_frame_newslot(array323);
// call case 4: self request
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = *var_errpos;
  params[3] = array323;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call324 = callmethodflags(self, "error()atPosition()withSuggestions", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe322);
// compiled call node returning call324 (depth = 2)
  gc_frame_end(frame);
  return call324;
}
Object meth_errormessages_syntaxError_40__41_atPosition_40__41_withSuggestion325(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "syntaxError()atPosition()withSuggestion");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError()atPosition()withSuggestion");
  if (nparts > 0 && argcv[1] < 2)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError()atPosition()withSuggestion");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError()atPosition()withSuggestion");
  Object params[4];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError()atPosition()withSuggestion (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for syntaxError");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_errpos = &(stackframe->slots[2]);
  *var_errpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 2)
    graceRaise(RequestError(), "wrong number of arguments for atPosition");
  Object *var_suggestion_39_ = &(stackframe->slots[3]);
  *var_suggestion_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for withSuggestion");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 384
  setline(384);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe326 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errpos (depth = 3)
  gc_frame_newslot(*var_errpos);
// starting to compile array node (depth = 3)
  Object array327 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion_39_ (depth = 4)
  params[0] = *var_suggestion_39_;
  partcv[0] = 1;
  callmethodflags(array327, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array327 (depth = 3)
  gc_frame_newslot(array327);
// call case 4: self request
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = *var_errpos;
  params[3] = array327;
  partcv[0] = 1;
  partcv[1] = 2;
  partcv[2] = 1;
  Object call328 = callmethodflags(self, "syntaxError()atPosition()withSuggestions", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe326);
// compiled call node returning call328 (depth = 2)
  gc_frame_end(frame);
  return call328;
}
Object meth_errormessages__apply344(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___4 = &(stackframe->slots[0]);
  *var___4 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 390
  setline(390);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit346 == NULL) {
    strlit346 = alloc_String("-");
    gc_root(strlit346);
  }
// compiled string node returning strlit346 (depth = 6)
  int op_slot_right_345 = gc_frame_newslot(strlit346);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_345 = gc_frame_newslot(*var_arr);
  params[0] = strlit346;
  partcv[0] = 1;
  Object opresult348 = callmethod(*var_arr, "++", 1, partcv, params);
// compiled op node returning opresult348 (depth = 5)
  *var_arr = opresult348;
  if (opresult348 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_syntaxError_40__41_atPosition_40__41_withSuggestions329(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 11, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "syntaxError()atPosition()withSuggestions");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError()atPosition()withSuggestions");
  if (nparts > 0 && argcv[1] < 2)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError()atPosition()withSuggestions");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError()atPosition()withSuggestions");
  Object params[6];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError()atPosition()withSuggestions (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for syntaxError");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_errpos = &(stackframe->slots[2]);
  *var_errpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 2)
    graceRaise(RequestError(), "wrong number of arguments for atPosition");
  Object *var_suggestions = &(stackframe->slots[3]);
  *var_suggestions = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for withSuggestions");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_arr = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "arr");
// Begin line 388
  setline(388);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit330 == NULL) {
    strlit330 = alloc_String("----");
    gc_root(strlit330);
  }
// compiled string node returning strlit330 (depth = 3)
  *var_arr = strlit330;
  if (strlit330 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 389
  setline(389);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe331 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe334 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe335 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errlinenum (depth = 9)
  partcv[0] = 0;
  Object call336 = callmethod(*var_errlinenum, "asString",
    1, partcv, params);
  gc_frame_end(callframe335);
// compiled call node returning call336 (depth = 8)
// compiled member node returning call336 (depth = 7)
  partcv[0] = 0;
  Object call337 = callmethod(call336, "size",
    1, partcv, params);
  gc_frame_end(callframe334);
// compiled call node returning call337 (depth = 6)
// compiled member node returning call337 (depth = 5)
  int op_slot_right_333 = gc_frame_newslot(call337);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errpos (depth = 5)
  int op_slot_left_333 = gc_frame_newslot(*var_errpos);
  params[0] = call337;
  partcv[0] = 1;
  Object sum339 = callmethod(*var_errpos, "+", 1, partcv, params);
// compiled op node returning sum339 (depth = 4)
  int op_slot_right_332 = gc_frame_newslot(sum339);
// starting to compile num node (depth = 4)
  Object num341 = alloc_Float64(2);
// compiled num node returning num341 (depth = 4)
  int op_slot_left_332 = gc_frame_newslot(num341);
  params[0] = sum339;
  partcv[0] = 1;
  Object opresult342 = callmethod(num341, "..", 1, partcv, params);
// compiled op node returning opresult342 (depth = 3)
  gc_frame_newslot(opresult342);
// starting to compile block node (depth = 3)
  Object block343 = alloc_Block(NULL, NULL, "errormessages", 389);
  gc_frame_newslot(block343);
// method "_apply"
  block_savedest(block343);
  Object closure344 = createclosure(2, "_apply");
  setclosureframe(closure344, stackframe);
  addtoclosure(closure344, var_arr);
  addtoclosure(closure344, selfslot);
  struct UserObject *uo344 = (struct UserObject*)block343;
  uo344->data[0] = (Object)closure344;
  Method *meth_meth_errormessages__apply344 = addmethod2pos(block343, "_apply", &meth_errormessages__apply344, 0);
  int argcv_meth_errormessages__apply344[] = {1};
  meth_meth_errormessages__apply344->type = alloc_MethodType(1, argcv_meth_errormessages__apply344);
  meth_meth_errormessages__apply344->definitionModule = modulename;
  meth_meth_errormessages__apply344->definitionLine = 389;
// compiled block node returning block343 (depth = 3)
  gc_frame_newslot(block343);
// call case 5: prelude request
  params[0] = opresult342;
  params[1] = block343;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call351 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe331);
// compiled call node returning call351 (depth = 2)
// Begin line 392
  setline(392);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit353 == NULL) {
    strlit353 = alloc_String("^");
    gc_root(strlit353);
  }
// compiled string node returning strlit353 (depth = 4)
  int op_slot_right_352 = gc_frame_newslot(strlit353);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_arr (depth = 4)
  int op_slot_left_352 = gc_frame_newslot(*var_arr);
  params[0] = strlit353;
  partcv[0] = 1;
  Object opresult355 = callmethod(*var_arr, "++", 1, partcv, params);
// compiled op node returning opresult355 (depth = 3)
  *var_arr = opresult355;
  if (opresult355 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 393
  setline(393);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe357 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit359 == NULL) {
    strlit359 = alloc_String(")");
    gc_root(strlit359);
  }
// compiled string node returning strlit359 (depth = 4)
  int op_slot_right_358 = gc_frame_newslot(strlit359);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errpos (depth = 5)
  int op_slot_right_361 = gc_frame_newslot(*var_errpos);
// starting to compile string node (depth = 5)
  if (strlit363 == NULL) {
    strlit363 = alloc_String(":(");
    gc_root(strlit363);
  }
// compiled string node returning strlit363 (depth = 5)
  int op_slot_left_361 = gc_frame_newslot(strlit363);
  params[0] = *var_errpos;
  partcv[0] = 1;
  Object opresult364 = callmethod(strlit363, "++", 1, partcv, params);
// compiled op node returning opresult364 (depth = 4)
  int op_slot_left_358 = gc_frame_newslot(opresult364);
  params[0] = strlit359;
  partcv[0] = 1;
  Object opresult365 = callmethod(opresult364, "++", 1, partcv, params);
// compiled op node returning opresult365 (depth = 3)
  gc_frame_newslot(opresult365);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arr (depth = 3)
  gc_frame_newslot(*var_arr);
// starting to compile identifier node (depth = 3)
  Object bool366 = alloc_Boolean(0);
// compiled identifier node returning bool366 (depth = 3)
  gc_frame_newslot(bool366);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = opresult365;
  params[3] = *var_arr;
  params[4] = bool366;
  params[5] = *var_suggestions;
  partcv[0] = 6;
  Object call367 = callmethod(*var_util, "syntaxError",
    1, partcv, params);
  gc_frame_end(callframe357);
// compiled call node returning call367 (depth = 2)
  gc_frame_end(frame);
  return call367;
}
Object meth_errormessages__apply383(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___5 = &(stackframe->slots[0]);
  *var___5 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 400
  setline(400);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit385 == NULL) {
    strlit385 = alloc_String("-");
    gc_root(strlit385);
  }
// compiled string node returning strlit385 (depth = 6)
  int op_slot_right_384 = gc_frame_newslot(strlit385);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_384 = gc_frame_newslot(*var_arr);
  params[0] = strlit385;
  partcv[0] = 1;
  Object opresult387 = callmethod(*var_arr, "++", 1, partcv, params);
// compiled op node returning opresult387 (depth = 5)
  *var_arr = opresult387;
  if (opresult387 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_error_40__41_atPosition_40__41_withSuggestions368(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 12, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(6, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "error()atPosition()withSuggestions");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error()atPosition()withSuggestions");
  if (nparts > 0 && argcv[1] < 2)
    graceRaise(RequestError(), "insufficient arguments to method error()atPosition()withSuggestions");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error()atPosition()withSuggestions");
  Object params[6];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for error()atPosition()withSuggestions (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for error");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  Object *var_errpos = &(stackframe->slots[2]);
  *var_errpos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 2)
    graceRaise(RequestError(), "wrong number of arguments for atPosition");
  Object *var_suggestions = &(stackframe->slots[3]);
  *var_suggestions = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for withSuggestions");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_arr = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "arr");
// Begin line 398
  setline(398);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit369 == NULL) {
    strlit369 = alloc_String("----");
    gc_root(strlit369);
  }
// compiled string node returning strlit369 (depth = 3)
  *var_arr = strlit369;
  if (strlit369 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 399
  setline(399);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe370 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe373 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe374 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_errlinenum (depth = 9)
  partcv[0] = 0;
  Object call375 = callmethod(*var_errlinenum, "asString",
    1, partcv, params);
  gc_frame_end(callframe374);
// compiled call node returning call375 (depth = 8)
// compiled member node returning call375 (depth = 7)
  partcv[0] = 0;
  Object call376 = callmethod(call375, "size",
    1, partcv, params);
  gc_frame_end(callframe373);
// compiled call node returning call376 (depth = 6)
// compiled member node returning call376 (depth = 5)
  int op_slot_right_372 = gc_frame_newslot(call376);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errpos (depth = 5)
  int op_slot_left_372 = gc_frame_newslot(*var_errpos);
  params[0] = call376;
  partcv[0] = 1;
  Object sum378 = callmethod(*var_errpos, "+", 1, partcv, params);
// compiled op node returning sum378 (depth = 4)
  int op_slot_right_371 = gc_frame_newslot(sum378);
// starting to compile num node (depth = 4)
  Object num380 = alloc_Float64(2);
// compiled num node returning num380 (depth = 4)
  int op_slot_left_371 = gc_frame_newslot(num380);
  params[0] = sum378;
  partcv[0] = 1;
  Object opresult381 = callmethod(num380, "..", 1, partcv, params);
// compiled op node returning opresult381 (depth = 3)
  gc_frame_newslot(opresult381);
// starting to compile block node (depth = 3)
  Object block382 = alloc_Block(NULL, NULL, "errormessages", 399);
  gc_frame_newslot(block382);
// method "_apply"
  block_savedest(block382);
  Object closure383 = createclosure(2, "_apply");
  setclosureframe(closure383, stackframe);
  addtoclosure(closure383, var_arr);
  addtoclosure(closure383, selfslot);
  struct UserObject *uo383 = (struct UserObject*)block382;
  uo383->data[0] = (Object)closure383;
  Method *meth_meth_errormessages__apply383 = addmethod2pos(block382, "_apply", &meth_errormessages__apply383, 0);
  int argcv_meth_errormessages__apply383[] = {1};
  meth_meth_errormessages__apply383->type = alloc_MethodType(1, argcv_meth_errormessages__apply383);
  meth_meth_errormessages__apply383->definitionModule = modulename;
  meth_meth_errormessages__apply383->definitionLine = 399;
// compiled block node returning block382 (depth = 3)
  gc_frame_newslot(block382);
// call case 5: prelude request
  params[0] = opresult381;
  params[1] = block382;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call390 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe370);
// compiled call node returning call390 (depth = 2)
// Begin line 402
  setline(402);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 2)
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit392 == NULL) {
    strlit392 = alloc_String("^");
    gc_root(strlit392);
  }
// compiled string node returning strlit392 (depth = 4)
  int op_slot_right_391 = gc_frame_newslot(strlit392);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_arr (depth = 4)
  int op_slot_left_391 = gc_frame_newslot(*var_arr);
  params[0] = strlit392;
  partcv[0] = 1;
  Object opresult394 = callmethod(*var_arr, "++", 1, partcv, params);
// compiled op node returning opresult394 (depth = 3)
  *var_arr = opresult394;
  if (opresult394 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 2)
// Begin line 403
  setline(403);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe396 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile op node (depth = 3)
// starting to compile string node (depth = 4)
  if (strlit398 == NULL) {
    strlit398 = alloc_String(")");
    gc_root(strlit398);
  }
// compiled string node returning strlit398 (depth = 4)
  int op_slot_right_397 = gc_frame_newslot(strlit398);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_errpos (depth = 5)
  int op_slot_right_400 = gc_frame_newslot(*var_errpos);
// starting to compile string node (depth = 5)
  if (strlit402 == NULL) {
    strlit402 = alloc_String(":(");
    gc_root(strlit402);
  }
// compiled string node returning strlit402 (depth = 5)
  int op_slot_left_400 = gc_frame_newslot(strlit402);
  params[0] = *var_errpos;
  partcv[0] = 1;
  Object opresult403 = callmethod(strlit402, "++", 1, partcv, params);
// compiled op node returning opresult403 (depth = 4)
  int op_slot_left_397 = gc_frame_newslot(opresult403);
  params[0] = strlit398;
  partcv[0] = 1;
  Object opresult404 = callmethod(opresult403, "++", 1, partcv, params);
// compiled op node returning opresult404 (depth = 3)
  gc_frame_newslot(opresult404);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arr (depth = 3)
  gc_frame_newslot(*var_arr);
// starting to compile identifier node (depth = 3)
  Object bool405 = alloc_Boolean(0);
// compiled identifier node returning bool405 (depth = 3)
  gc_frame_newslot(bool405);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = opresult404;
  params[3] = *var_arr;
  params[4] = bool405;
  params[5] = *var_suggestions;
  partcv[0] = 6;
  Object call406 = callmethod(*var_util, "generalError",
    1, partcv, params);
  gc_frame_end(callframe396);
// compiled call node returning call406 (depth = 2)
  gc_frame_end(frame);
  return call406;
}
Object meth_errormessages_error407(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 13, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "error");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error");
  Object params[6];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for error (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for error");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 407
  setline(407);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe408 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile num node (depth = 3)
  Object num409 = alloc_Float64(0);
// compiled num node returning num409 (depth = 3)
  gc_frame_newslot(num409);
// starting to compile string node (depth = 3)
  if (strlit410 == NULL) {
    strlit410 = alloc_String("");
    gc_root(strlit410);
  }
// compiled string node returning strlit410 (depth = 3)
  gc_frame_newslot(strlit410);
// starting to compile string node (depth = 3)
  if (strlit411 == NULL) {
    strlit411 = alloc_String("");
    gc_root(strlit411);
  }
// compiled string node returning strlit411 (depth = 3)
  gc_frame_newslot(strlit411);
// starting to compile identifier node (depth = 3)
  Object bool412 = alloc_Boolean(0);
// compiled identifier node returning bool412 (depth = 3)
  gc_frame_newslot(bool412);
// starting to compile array node (depth = 3)
  Object array413 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array413 (depth = 3)
  gc_frame_newslot(array413);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = *var_message;
  params[1] = num409;
  params[2] = strlit410;
  params[3] = strlit411;
  params[4] = bool412;
  params[5] = array413;
  partcv[0] = 6;
  Object call414 = callmethod(*var_util, "generalError",
    1, partcv, params);
  gc_frame_end(callframe408);
// compiled call node returning call414 (depth = 2)
  gc_frame_end(frame);
  return call414;
}
Object meth_errormessages__apply427(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___6 = &(stackframe->slots[0]);
  *var___6 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 413
  setline(413);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit429 == NULL) {
    strlit429 = alloc_String("-");
    gc_root(strlit429);
  }
// compiled string node returning strlit429 (depth = 6)
  int op_slot_right_428 = gc_frame_newslot(strlit429);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_428 = gc_frame_newslot(*var_arr);
  params[0] = strlit429;
  partcv[0] = 1;
  Object opresult431 = callmethod(*var_arr, "++", 1, partcv, params);
// compiled op node returning opresult431 (depth = 5)
  *var_arr = opresult431;
  if (opresult431 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages__apply447(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___7 = &(stackframe->slots[0]);
  *var___7 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 416
  setline(416);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit449 == NULL) {
    strlit449 = alloc_String("^");
    gc_root(strlit449);
  }
// compiled string node returning strlit449 (depth = 6)
  int op_slot_right_448 = gc_frame_newslot(strlit449);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_448 = gc_frame_newslot(*var_arr);
  params[0] = strlit449;
  partcv[0] = 1;
  Object opresult451 = callmethod(*var_arr, "++", 1, partcv, params);
// compiled op node returning opresult451 (depth = 5)
  *var_arr = opresult451;
  if (opresult451 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_error_40__41_atLine_40__41_withSuggestions415(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 14, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "error()atLine()withSuggestions");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error()atLine()withSuggestions");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error()atLine()withSuggestions");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error()atLine()withSuggestions");
  Object params[6];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for error()atLine()withSuggestions (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for error");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for atLine");
  Object *var_suggestions = &(stackframe->slots[2]);
  *var_suggestions = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for withSuggestions");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_arr = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "arr");
// Begin line 411
  setline(411);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit416 == NULL) {
    strlit416 = alloc_String("----");
    gc_root(strlit416);
  }
// compiled string node returning strlit416 (depth = 3)
  *var_arr = strlit416;
  if (strlit416 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 412
  setline(412);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe417 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe419 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe420 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errlinenum (depth = 8)
  partcv[0] = 0;
  Object call421 = callmethod(*var_errlinenum, "asString",
    1, partcv, params);
  gc_frame_end(callframe420);
// compiled call node returning call421 (depth = 7)
// compiled member node returning call421 (depth = 6)
  partcv[0] = 0;
  Object call422 = callmethod(call421, "size",
    1, partcv, params);
  gc_frame_end(callframe419);
// compiled call node returning call422 (depth = 5)
// compiled member node returning call422 (depth = 4)
  int op_slot_right_418 = gc_frame_newslot(call422);
// starting to compile num node (depth = 4)
  Object num424 = alloc_Float64(1);
// compiled num node returning num424 (depth = 4)
  int op_slot_left_418 = gc_frame_newslot(num424);
  params[0] = call422;
  partcv[0] = 1;
  Object opresult425 = callmethod(num424, "..", 1, partcv, params);
// compiled op node returning opresult425 (depth = 3)
  gc_frame_newslot(opresult425);
// starting to compile block node (depth = 3)
  Object block426 = alloc_Block(NULL, NULL, "errormessages", 412);
  gc_frame_newslot(block426);
// method "_apply"
  block_savedest(block426);
  Object closure427 = createclosure(2, "_apply");
  setclosureframe(closure427, stackframe);
  addtoclosure(closure427, var_arr);
  addtoclosure(closure427, selfslot);
  struct UserObject *uo427 = (struct UserObject*)block426;
  uo427->data[0] = (Object)closure427;
  Method *meth_meth_errormessages__apply427 = addmethod2pos(block426, "_apply", &meth_errormessages__apply427, 0);
  int argcv_meth_errormessages__apply427[] = {1};
  meth_meth_errormessages__apply427->type = alloc_MethodType(1, argcv_meth_errormessages__apply427);
  meth_meth_errormessages__apply427->definitionModule = modulename;
  meth_meth_errormessages__apply427->definitionLine = 412;
// compiled block node returning block426 (depth = 3)
  gc_frame_newslot(block426);
// call case 5: prelude request
  params[0] = opresult425;
  params[1] = block426;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call434 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe417);
// compiled call node returning call434 (depth = 2)
// Begin line 415
  setline(415);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe435 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe437 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe438 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errlinenum (depth = 7)
  gc_frame_newslot(*var_errlinenum);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe439 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_util (depth = 9)
  partcv[0] = 0;
  Object call440 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe439);
// compiled call node returning call440 (depth = 8)
// compiled member node returning call440 (depth = 7)
  params[0] = *var_errlinenum;
  partcv[0] = 1;
  Object call441 = callmethod(call440, "at",
    1, partcv, params);
  gc_frame_end(callframe438);
// compiled call node returning call441 (depth = 6)
  partcv[0] = 0;
  Object call442 = callmethod(call441, "size",
    1, partcv, params);
  gc_frame_end(callframe437);
// compiled call node returning call442 (depth = 5)
// compiled member node returning call442 (depth = 4)
  int op_slot_right_436 = gc_frame_newslot(call442);
// starting to compile num node (depth = 4)
  Object num444 = alloc_Float64(1);
// compiled num node returning num444 (depth = 4)
  int op_slot_left_436 = gc_frame_newslot(num444);
  params[0] = call442;
  partcv[0] = 1;
  Object opresult445 = callmethod(num444, "..", 1, partcv, params);
// compiled op node returning opresult445 (depth = 3)
  gc_frame_newslot(opresult445);
// starting to compile block node (depth = 3)
  Object block446 = alloc_Block(NULL, NULL, "errormessages", 415);
  gc_frame_newslot(block446);
// method "_apply"
  block_savedest(block446);
  Object closure447 = createclosure(2, "_apply");
  setclosureframe(closure447, stackframe);
  addtoclosure(closure447, var_arr);
  addtoclosure(closure447, selfslot);
  struct UserObject *uo447 = (struct UserObject*)block446;
  uo447->data[0] = (Object)closure447;
  Method *meth_meth_errormessages__apply447 = addmethod2pos(block446, "_apply", &meth_errormessages__apply447, 0);
  int argcv_meth_errormessages__apply447[] = {1};
  meth_meth_errormessages__apply447->type = alloc_MethodType(1, argcv_meth_errormessages__apply447);
  meth_meth_errormessages__apply447->definitionModule = modulename;
  meth_meth_errormessages__apply447->definitionLine = 415;
// compiled block node returning block446 (depth = 3)
  gc_frame_newslot(block446);
// call case 5: prelude request
  params[0] = opresult445;
  params[1] = block446;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call454 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe435);
// compiled call node returning call454 (depth = 2)
// Begin line 418
  setline(418);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe455 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile string node (depth = 3)
  if (strlit456 == NULL) {
    strlit456 = alloc_String("");
    gc_root(strlit456);
  }
// compiled string node returning strlit456 (depth = 3)
  gc_frame_newslot(strlit456);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arr (depth = 3)
  gc_frame_newslot(*var_arr);
// starting to compile identifier node (depth = 3)
  Object bool457 = alloc_Boolean(0);
// compiled identifier node returning bool457 (depth = 3)
  gc_frame_newslot(bool457);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = strlit456;
  params[3] = *var_arr;
  params[4] = bool457;
  params[5] = *var_suggestions;
  partcv[0] = 6;
  Object call458 = callmethod(*var_util, "generalError",
    1, partcv, params);
  gc_frame_end(callframe455);
// compiled call node returning call458 (depth = 2)
  gc_frame_end(frame);
  return call458;
}
Object meth_errormessages_error_40__41_atLine459(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "error()atLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error()atLine");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method error()atLine");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for error()atLine (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for error");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for atLine");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 422
  setline(422);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe460 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile array node (depth = 3)
  Object array461 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array461 (depth = 3)
  gc_frame_newslot(array461);
// call case 4: self request
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = array461;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call462 = callmethodflags(self, "error()atLine()withSuggestions", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe460);
// compiled call node returning call462 (depth = 2)
  gc_frame_end(frame);
  return call462;
}
Object meth_errormessages_syntaxError_40__41_atLine463(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "syntaxError()atLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError()atLine");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError()atLine");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError()atLine (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for syntaxError");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for atLine");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 426
  setline(426);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe464 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile array node (depth = 3)
  Object array465 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array465 (depth = 3)
  gc_frame_newslot(array465);
// call case 4: self request
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = array465;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call466 = callmethodflags(self, "syntaxError()atLine()withSuggestions", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe464);
// compiled call node returning call466 (depth = 2)
  gc_frame_end(frame);
  return call466;
}
Object meth_errormessages_syntaxError_40__41_atLine_40__41_withSuggestion467(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "syntaxError()atLine()withSuggestion");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError()atLine()withSuggestion");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError()atLine()withSuggestion");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError()atLine()withSuggestion");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError()atLine()withSuggestion (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for syntaxError");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for atLine");
  Object *var_suggestion_39_ = &(stackframe->slots[2]);
  *var_suggestion_39_ = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for withSuggestion");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 430
  setline(430);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe468 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile array node (depth = 3)
  Object array469 = alloc_BuiltinList();
  gc_pause();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_suggestion_39_ (depth = 4)
  params[0] = *var_suggestion_39_;
  partcv[0] = 1;
  callmethodflags(array469, "push", 1, partcv, params, CFLAG_SELF);
  gc_unpause();
// compiled array node returning array469 (depth = 3)
  gc_frame_newslot(array469);
// call case 4: self request
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = array469;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call470 = callmethodflags(self, "syntaxError()atLine()withSuggestions", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe468);
// compiled call node returning call470 (depth = 2)
  gc_frame_end(frame);
  return call470;
}
Object meth_errormessages__apply483(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___8 = &(stackframe->slots[0]);
  *var___8 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 436
  setline(436);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit485 == NULL) {
    strlit485 = alloc_String("-");
    gc_root(strlit485);
  }
// compiled string node returning strlit485 (depth = 6)
  int op_slot_right_484 = gc_frame_newslot(strlit485);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_484 = gc_frame_newslot(*var_arr);
  params[0] = strlit485;
  partcv[0] = 1;
  Object opresult487 = callmethod(*var_arr, "++", 1, partcv, params);
// compiled op node returning opresult487 (depth = 5)
  *var_arr = opresult487;
  if (opresult487 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages__apply503(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_arr = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var___9 = &(stackframe->slots[0]);
  *var___9 = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 439
  setline(439);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit505 == NULL) {
    strlit505 = alloc_String("^");
    gc_root(strlit505);
  }
// compiled string node returning strlit505 (depth = 6)
  int op_slot_right_504 = gc_frame_newslot(strlit505);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_arr (depth = 6)
  int op_slot_left_504 = gc_frame_newslot(*var_arr);
  params[0] = strlit505;
  partcv[0] = 1;
  Object opresult507 = callmethod(*var_arr, "++", 1, partcv, params);
// compiled op node returning opresult507 (depth = 5)
  *var_arr = opresult507;
  if (opresult507 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_syntaxError_40__41_atLine_40__41_withSuggestions471(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 18, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(5, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "syntaxError()atLine()withSuggestions");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError()atLine()withSuggestions");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError()atLine()withSuggestions");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method syntaxError()atLine()withSuggestions");
  Object params[6];
  int partcv[2];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for syntaxError()atLine()withSuggestions (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_message = &(stackframe->slots[0]);
  *var_message = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for syntaxError");
  Object *var_errlinenum = &(stackframe->slots[1]);
  *var_errlinenum = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for atLine");
  Object *var_suggestions = &(stackframe->slots[2]);
  *var_suggestions = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for withSuggestions");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_arr = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "arr");
// Begin line 434
  setline(434);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 2)
// starting to compile string node (depth = 3)
  if (strlit472 == NULL) {
    strlit472 = alloc_String("----");
    gc_root(strlit472);
  }
// compiled string node returning strlit472 (depth = 3)
  *var_arr = strlit472;
  if (strlit472 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 2)
// Begin line 435
  setline(435);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe473 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe475 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe476 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_errlinenum (depth = 8)
  partcv[0] = 0;
  Object call477 = callmethod(*var_errlinenum, "asString",
    1, partcv, params);
  gc_frame_end(callframe476);
// compiled call node returning call477 (depth = 7)
// compiled member node returning call477 (depth = 6)
  partcv[0] = 0;
  Object call478 = callmethod(call477, "size",
    1, partcv, params);
  gc_frame_end(callframe475);
// compiled call node returning call478 (depth = 5)
// compiled member node returning call478 (depth = 4)
  int op_slot_right_474 = gc_frame_newslot(call478);
// starting to compile num node (depth = 4)
  Object num480 = alloc_Float64(1);
// compiled num node returning num480 (depth = 4)
  int op_slot_left_474 = gc_frame_newslot(num480);
  params[0] = call478;
  partcv[0] = 1;
  Object opresult481 = callmethod(num480, "..", 1, partcv, params);
// compiled op node returning opresult481 (depth = 3)
  gc_frame_newslot(opresult481);
// starting to compile block node (depth = 3)
  Object block482 = alloc_Block(NULL, NULL, "errormessages", 435);
  gc_frame_newslot(block482);
// method "_apply"
  block_savedest(block482);
  Object closure483 = createclosure(2, "_apply");
  setclosureframe(closure483, stackframe);
  addtoclosure(closure483, var_arr);
  addtoclosure(closure483, selfslot);
  struct UserObject *uo483 = (struct UserObject*)block482;
  uo483->data[0] = (Object)closure483;
  Method *meth_meth_errormessages__apply483 = addmethod2pos(block482, "_apply", &meth_errormessages__apply483, 0);
  int argcv_meth_errormessages__apply483[] = {1};
  meth_meth_errormessages__apply483->type = alloc_MethodType(1, argcv_meth_errormessages__apply483);
  meth_meth_errormessages__apply483->definitionModule = modulename;
  meth_meth_errormessages__apply483->definitionLine = 435;
// compiled block node returning block482 (depth = 3)
  gc_frame_newslot(block482);
// call case 5: prelude request
  params[0] = opresult481;
  params[1] = block482;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call490 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe473);
// compiled call node returning call490 (depth = 2)
// Begin line 438
  setline(438);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe491 = gc_frame_new();
// starting to compile op node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe493 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe494 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_errlinenum (depth = 7)
  gc_frame_newslot(*var_errlinenum);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe495 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_util (depth = 9)
  partcv[0] = 0;
  Object call496 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe495);
// compiled call node returning call496 (depth = 8)
// compiled member node returning call496 (depth = 7)
  params[0] = *var_errlinenum;
  partcv[0] = 1;
  Object call497 = callmethod(call496, "at",
    1, partcv, params);
  gc_frame_end(callframe494);
// compiled call node returning call497 (depth = 6)
  partcv[0] = 0;
  Object call498 = callmethod(call497, "size",
    1, partcv, params);
  gc_frame_end(callframe493);
// compiled call node returning call498 (depth = 5)
// compiled member node returning call498 (depth = 4)
  int op_slot_right_492 = gc_frame_newslot(call498);
// starting to compile num node (depth = 4)
  Object num500 = alloc_Float64(1);
// compiled num node returning num500 (depth = 4)
  int op_slot_left_492 = gc_frame_newslot(num500);
  params[0] = call498;
  partcv[0] = 1;
  Object opresult501 = callmethod(num500, "..", 1, partcv, params);
// compiled op node returning opresult501 (depth = 3)
  gc_frame_newslot(opresult501);
// starting to compile block node (depth = 3)
  Object block502 = alloc_Block(NULL, NULL, "errormessages", 438);
  gc_frame_newslot(block502);
// method "_apply"
  block_savedest(block502);
  Object closure503 = createclosure(2, "_apply");
  setclosureframe(closure503, stackframe);
  addtoclosure(closure503, var_arr);
  addtoclosure(closure503, selfslot);
  struct UserObject *uo503 = (struct UserObject*)block502;
  uo503->data[0] = (Object)closure503;
  Method *meth_meth_errormessages__apply503 = addmethod2pos(block502, "_apply", &meth_errormessages__apply503, 0);
  int argcv_meth_errormessages__apply503[] = {1};
  meth_meth_errormessages__apply503->type = alloc_MethodType(1, argcv_meth_errormessages__apply503);
  meth_meth_errormessages__apply503->definitionModule = modulename;
  meth_meth_errormessages__apply503->definitionLine = 438;
// compiled block node returning block502 (depth = 3)
  gc_frame_newslot(block502);
// call case 5: prelude request
  params[0] = opresult501;
  params[1] = block502;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call510 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe491);
// compiled call node returning call510 (depth = 2)
// Begin line 441
  setline(441);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 2)
  int callframe511 = gc_frame_new();
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_message (depth = 3)
  gc_frame_newslot(*var_message);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_errlinenum (depth = 3)
  gc_frame_newslot(*var_errlinenum);
// starting to compile string node (depth = 3)
  if (strlit512 == NULL) {
    strlit512 = alloc_String("");
    gc_root(strlit512);
  }
// compiled string node returning strlit512 (depth = 3)
  gc_frame_newslot(strlit512);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_arr (depth = 3)
  gc_frame_newslot(*var_arr);
// starting to compile identifier node (depth = 3)
  Object bool513 = alloc_Boolean(0);
// compiled identifier node returning bool513 (depth = 3)
  gc_frame_newslot(bool513);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestions (depth = 3)
  gc_frame_newslot(*var_suggestions);
// call case 6: other member request
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_util (depth = 3)
  params[0] = *var_message;
  params[1] = *var_errlinenum;
  params[2] = strlit512;
  params[3] = *var_arr;
  params[4] = bool513;
  params[5] = *var_suggestions;
  partcv[0] = 6;
  Object call514 = callmethod(*var_util, "syntaxError",
    1, partcv, params);
  gc_frame_end(callframe511);
// compiled call node returning call514 (depth = 2)
  gc_frame_end(frame);
  return call514;
}
Object meth_errormessages_replaceRange_40__41_with_40__41_onLine522(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "replaceRange()with()onLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method replaceRange()with()onLine");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceRange()with()onLine");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceRange()with()onLine");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for replaceRange()with()onLine (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_start = &(stackframe->slots[0]);
  *var_start = args[curarg];
  curarg++;
  Object *var_end = &(stackframe->slots[1]);
  *var_end = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for replaceRange");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for with");
  Object *var_lineNumber = &(stackframe->slots[3]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for onLine");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_line = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "line");
// Begin line 24
  setline(24);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe523 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call524 = callmethodflags(self, "getLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe523);
// compiled call node returning call524 (depth = 4)
  *var_line = call524;
  if (call524 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 25
  setline(25);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num527 = alloc_Float64(1);
// compiled num node returning num527 (depth = 5)
  int op_slot_right_526 = gc_frame_newslot(num527);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_start (depth = 5)
  int op_slot_left_526 = gc_frame_newslot(*var_start);
  params[0] = num527;
  partcv[0] = 1;
  Object opresult529 = callmethod(*var_start, "==", 1, partcv, params);
// compiled op node returning opresult529 (depth = 4)
  Object if525 = done;
  if (istrue(opresult529)) {
// Begin line 26
  setline(26);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe530 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe532 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num534 = alloc_Float64(1);
// compiled num node returning num534 (depth = 8)
  int op_slot_right_533 = gc_frame_newslot(num534);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_end (depth = 8)
  int op_slot_left_533 = gc_frame_newslot(*var_end);
  params[0] = num534;
  partcv[0] = 1;
  Object sum536 = callmethod(*var_end, "+", 1, partcv, params);
// compiled op node returning sum536 (depth = 7)
  gc_frame_newslot(sum536);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe537 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_line (depth = 9)
  partcv[0] = 0;
  Object call538 = callmethod(*var_line, "size",
    1, partcv, params);
  gc_frame_end(callframe537);
// compiled call node returning call538 (depth = 8)
// compiled member node returning call538 (depth = 7)
  gc_frame_newslot(call538);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_line (depth = 7)
  params[0] = sum536;
  params[1] = call538;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call539 = callmethod(*var_line, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe532);
// compiled call node returning call539 (depth = 6)
  int op_slot_right_531 = gc_frame_newslot(call539);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_531 = gc_frame_newslot(*var_s);
  params[0] = call539;
  partcv[0] = 1;
  Object opresult541 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult541 (depth = 5)
  gc_frame_newslot(opresult541);
// call case 4: self request
  params[0] = *var_lineNumber;
  params[1] = opresult541;
  partcv[0] = 2;
  Object call542 = callmethodflags(self, "addLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe530);
// compiled call node returning call542 (depth = 4)
    gc_frame_newslot(call542);
    if525 = call542;
  } else {
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe543 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 5)
// Begin line 29
  setline(29);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe545 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num547 = alloc_Float64(1);
// compiled num node returning num547 (depth = 8)
  int op_slot_right_546 = gc_frame_newslot(num547);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_end (depth = 8)
  int op_slot_left_546 = gc_frame_newslot(*var_end);
  params[0] = num547;
  partcv[0] = 1;
  Object sum549 = callmethod(*var_end, "+", 1, partcv, params);
// compiled op node returning sum549 (depth = 7)
  gc_frame_newslot(sum549);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe550 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_line (depth = 9)
  partcv[0] = 0;
  Object call551 = callmethod(*var_line, "size",
    1, partcv, params);
  gc_frame_end(callframe550);
// compiled call node returning call551 (depth = 8)
// compiled member node returning call551 (depth = 7)
  gc_frame_newslot(call551);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_line (depth = 7)
  params[0] = sum549;
  params[1] = call551;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call552 = callmethod(*var_line, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe545);
// compiled call node returning call552 (depth = 6)
  int op_slot_right_544 = gc_frame_newslot(call552);
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// Begin line 29
  setline(29);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_554 = gc_frame_newslot(*var_s);
// Begin line 28
  setline(28);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe556 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num557 = alloc_Float64(1);
// compiled num node returning num557 (depth = 8)
  gc_frame_newslot(num557);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num559 = alloc_Float64(1);
// compiled num node returning num559 (depth = 9)
  int op_slot_right_558 = gc_frame_newslot(num559);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_start (depth = 9)
  int op_slot_left_558 = gc_frame_newslot(*var_start);
  params[0] = num559;
  partcv[0] = 1;
  Object diff561 = callmethod(*var_start, "-", 1, partcv, params);
// compiled op node returning diff561 (depth = 8)
  gc_frame_newslot(diff561);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  params[0] = num557;
  params[1] = diff561;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call562 = callmethod(*var_line, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe556);
// compiled call node returning call562 (depth = 7)
  int op_slot_left_554 = gc_frame_newslot(call562);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult563 = callmethod(call562, "++", 1, partcv, params);
// compiled op node returning opresult563 (depth = 6)
  int op_slot_left_544 = gc_frame_newslot(opresult563);
  params[0] = call552;
  partcv[0] = 1;
  Object opresult564 = callmethod(opresult563, "++", 1, partcv, params);
// compiled op node returning opresult564 (depth = 5)
  gc_frame_newslot(opresult564);
// call case 4: self request
  params[0] = *var_lineNumber;
  params[1] = opresult564;
  partcv[0] = 2;
  Object call565 = callmethodflags(self, "addLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe543);
// compiled call node returning call565 (depth = 4)
    gc_frame_newslot(call565);
    if525 = call565;
  }
// compiled if node returning if525 (depth = 3)
  gc_frame_end(frame);
  return if525;
}
Object meth_errormessages_replaceChar_40__41_with_40__41_onLine566(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "replaceChar()with()onLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceChar()with()onLine");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceChar()with()onLine");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceChar()with()onLine");
  Object params[4];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for replaceChar()with()onLine (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_pos = &(stackframe->slots[0]);
  *var_pos = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for replaceChar");
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for with");
  Object *var_lineNumber = &(stackframe->slots[2]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for onLine");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 34
  setline(34);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe567 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lineNumber (depth = 4)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_pos;
  params[1] = *var_pos;
  params[2] = *var_s;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call568 = callmethodflags(self, "replaceRange()with()onLine", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe567);
// compiled call node returning call568 (depth = 3)
  gc_frame_end(frame);
  return call568;
}
Object meth_errormessages__apply582(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[4];
  int partcv[3];
  Object *var_until = getfromclosure(closure, 0);
  Object *var_len = getfromclosure(closure, 1);
  Object *var_line = getfromclosure(closure, 2);
  Object *var_s = getfromclosure(closure, 3);
  Object *var_lineNumber = getfromclosure(closure, 4);
  Object self = *(getfromclosure(closure, 5));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 41
  setline(41);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_until (depth = 7)
  int op_slot_right_584 = gc_frame_newslot(*var_until);
// starting to compile call node (depth = 7)
  int callframe586 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num588 = alloc_Float64(1);
// compiled num node returning num588 (depth = 9)
  int op_slot_right_587 = gc_frame_newslot(num588);
// starting to compile op node (depth = 9)
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_len (depth = 10)
  int op_slot_right_590 = gc_frame_newslot(*var_len);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  int op_slot_left_590 = gc_frame_newslot(*var_i);
  params[0] = *var_len;
  partcv[0] = 1;
  Object sum592 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum592 (depth = 9)
  int op_slot_left_587 = gc_frame_newslot(sum592);
  params[0] = num588;
  partcv[0] = 1;
  Object diff593 = callmethod(sum592, "-", 1, partcv, params);
// compiled op node returning diff593 (depth = 8)
  gc_frame_newslot(diff593);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  params[0] = *var_i;
  params[1] = diff593;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call594 = callmethod(*var_line, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe586);
// compiled call node returning call594 (depth = 7)
  int op_slot_left_584 = gc_frame_newslot(call594);
  params[0] = *var_until;
  partcv[0] = 1;
  Object opresult595 = callmethod(call594, "==", 1, partcv, params);
// compiled op node returning opresult595 (depth = 6)
  Object if583 = done;
  if (istrue(opresult595)) {
// Begin line 42
  setline(42);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe596 = gc_frame_new();
// starting to compile num node (depth = 7)
  Object num597 = alloc_Float64(1);
// compiled num node returning num597 (depth = 7)
  gc_frame_newslot(num597);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num599 = alloc_Float64(1);
// compiled num node returning num599 (depth = 8)
  int op_slot_right_598 = gc_frame_newslot(num599);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_len (depth = 9)
  int op_slot_right_601 = gc_frame_newslot(*var_len);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_left_601 = gc_frame_newslot(*var_i);
  params[0] = *var_len;
  partcv[0] = 1;
  Object sum603 = callmethod(*var_i, "+", 1, partcv, params);
// compiled op node returning sum603 (depth = 8)
  int op_slot_left_598 = gc_frame_newslot(sum603);
  params[0] = num599;
  partcv[0] = 1;
  Object diff604 = callmethod(sum603, "-", 1, partcv, params);
// compiled op node returning diff604 (depth = 7)
  gc_frame_newslot(diff604);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lineNumber (depth = 7)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = num597;
  params[1] = diff604;
  params[2] = *var_s;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call605 = callmethodflags(self, "replaceRange()with()onLine", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe596);
// compiled call node returning call605 (depth = 6)
// Begin line 43
  setline(43);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool606 = alloc_Boolean(1);
// compiled identifier node returning bool606 (depth = 7)
  block_return(realself, bool606);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if583 = undefined;
  } else {
  }
// compiled if node returning if583 (depth = 5)
  gc_frame_end(frame);
  return if583;
}
Object meth_errormessages_replaceUntil_40__41_with_40__41_onLine569(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "replaceUntil()with()onLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceUntil()with()onLine");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceUntil()with()onLine");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceUntil()with()onLine");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for replaceUntil()with()onLine (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_until = &(stackframe->slots[0]);
  *var_until = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for replaceUntil");
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for with");
  Object *var_lineNumber = &(stackframe->slots[2]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for onLine");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_line = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "line");
  Object *var_len = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "len");
// Begin line 38
  setline(38);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe570 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call571 = callmethodflags(self, "getLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe570);
// compiled call node returning call571 (depth = 4)
  *var_line = call571;
  if (call571 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 39
  setline(39);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe572 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_until (depth = 6)
  partcv[0] = 0;
  Object call573 = callmethod(*var_until, "size",
    1, partcv, params);
  gc_frame_end(callframe572);
// compiled call node returning call573 (depth = 5)
// compiled member node returning call573 (depth = 4)
  *var_len = call573;
  if (call573 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 40
  setline(40);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe574 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe576 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_line (depth = 7)
  partcv[0] = 0;
  Object call577 = callmethod(*var_line, "size",
    1, partcv, params);
  gc_frame_end(callframe576);
// compiled call node returning call577 (depth = 6)
// compiled member node returning call577 (depth = 5)
  int op_slot_right_575 = gc_frame_newslot(call577);
// starting to compile num node (depth = 5)
  Object num579 = alloc_Float64(1);
// compiled num node returning num579 (depth = 5)
  int op_slot_left_575 = gc_frame_newslot(num579);
  params[0] = call577;
  partcv[0] = 1;
  Object opresult580 = callmethod(num579, "..", 1, partcv, params);
// compiled op node returning opresult580 (depth = 4)
  gc_frame_newslot(opresult580);
// starting to compile block node (depth = 4)
  Object block581 = alloc_Block(NULL, NULL, "errormessages", 40);
  gc_frame_newslot(block581);
// method "_apply"
  block_savedest(block581);
  Object closure582 = createclosure(6, "_apply");
  setclosureframe(closure582, stackframe);
  addtoclosure(closure582, var_until);
  addtoclosure(closure582, var_len);
  addtoclosure(closure582, var_line);
  addtoclosure(closure582, var_s);
  addtoclosure(closure582, var_lineNumber);
  addtoclosure(closure582, selfslot);
  struct UserObject *uo582 = (struct UserObject*)block581;
  uo582->data[0] = (Object)closure582;
  Method *meth_meth_errormessages__apply582 = addmethod2pos(block581, "_apply", &meth_errormessages__apply582, 0);
  int argcv_meth_errormessages__apply582[] = {1};
  meth_meth_errormessages__apply582->type = alloc_MethodType(1, argcv_meth_errormessages__apply582);
  meth_meth_errormessages__apply582->definitionModule = modulename;
  meth_meth_errormessages__apply582->definitionLine = 40;
// compiled block node returning block581 (depth = 4)
  gc_frame_newslot(block581);
// call case 5: prelude request
  params[0] = opresult580;
  params[1] = block581;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call608 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe574);
// compiled call node returning call608 (depth = 3)
// Begin line 46
  setline(46);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 3)
// starting to compile identifier node (depth = 4)
  Object bool609 = alloc_Boolean(0);
// compiled identifier node returning bool609 (depth = 4)
  return bool609;
// compiled return node returning undefined (depth = 3)
  gc_frame_end(frame);
  return undefined;
}
Object meth_errormessages__apply637(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_line = getfromclosure(closure, 0);
  Object *var_indent = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 56
  setline(56);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit640 == NULL) {
    strlit640 = alloc_String(" ");
    gc_root(strlit640);
  }
// compiled string node returning strlit640 (depth = 8)
  int op_slot_right_639 = gc_frame_newslot(strlit640);
// starting to compile call node (depth = 8)
  int callframe642 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_line (depth = 9)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call643 = callmethod(*var_line, "at",
    1, partcv, params);
  gc_frame_end(callframe642);
// compiled call node returning call643 (depth = 8)
  int op_slot_left_639 = gc_frame_newslot(call643);
  params[0] = strlit640;
  partcv[0] = 1;
  Object opresult644 = callmethod(call643, "≠", 1, partcv, params);
// compiled op node returning opresult644 (depth = 7)
  Object if638 = done;
  if (istrue(opresult644)) {
// Begin line 57
  setline(57);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile identifier node (depth = 8)
  Object bool645 = alloc_Boolean(0);
// compiled identifier node returning bool645 (depth = 8)
  *var_indent = bool645;
  if (bool645 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if638 = done;
  } else {
  }
// compiled if node returning if638 (depth = 6)
  gc_frame_end(frame);
  return if638;
}
Object meth_errormessages_deleteRange_40__41_onLine610(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(7, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "deleteRange()onLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method deleteRange()onLine");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteRange()onLine");
  Object params[4];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for deleteRange()onLine (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_start = &(stackframe->slots[0]);
  *var_start = args[curarg];
  curarg++;
  Object *var_end = &(stackframe->slots[1]);
  *var_end = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for deleteRange");
  Object *var_lineNumber = &(stackframe->slots[2]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for onLine");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_start_39_ = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "start'");
  Object *var_line = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "line");
  Object *var_indent = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "indent");
// Begin line 50
  setline(50);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_start (depth = 4)
  *var_start_39_ = *var_start;
  if (*var_start == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 51
  setline(51);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe611 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call612 = callmethodflags(self, "getLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe611);
// compiled call node returning call612 (depth = 4)
  *var_line = call612;
  if (call612 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 52
  setline(52);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe616 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  partcv[0] = 0;
  Object call617 = callmethod(*var_line, "size",
    1, partcv, params);
  gc_frame_end(callframe616);
// compiled call node returning call617 (depth = 7)
// compiled member node returning call617 (depth = 6)
  int op_slot_right_615 = gc_frame_newslot(call617);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_end (depth = 6)
  int op_slot_left_615 = gc_frame_newslot(*var_end);
  params[0] = call617;
  partcv[0] = 1;
  Object opresult619 = callmethod(*var_end, "==", 1, partcv, params);
// compiled op node returning opresult619 (depth = 5)
  int op_slot_right_614 = gc_frame_newslot(opresult619);
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num622 = alloc_Float64(1);
// compiled num node returning num622 (depth = 6)
  int op_slot_right_621 = gc_frame_newslot(num622);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_start_39_ (depth = 6)
  int op_slot_left_621 = gc_frame_newslot(*var_start_39_);
  params[0] = num622;
  partcv[0] = 1;
  Object opresult624 = callmethod(*var_start_39_, ">", 1, partcv, params);
// compiled op node returning opresult624 (depth = 5)
  int op_slot_left_614 = gc_frame_newslot(opresult624);
  params[0] = opresult619;
  partcv[0] = 1;
  Object opresult625 = callmethod(opresult624, "&&", 1, partcv, params);
// compiled op node returning opresult625 (depth = 4)
  Object if613 = done;
  if (istrue(opresult625)) {
// Begin line 54
  setline(54);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool626 = alloc_Boolean(1);
// compiled identifier node returning bool626 (depth = 5)
  *var_indent = bool626;
  if (bool626 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 55
  setline(55);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe627 = gc_frame_new();
// starting to compile op node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num630 = alloc_Float64(1);
// compiled num node returning num630 (depth = 7)
  int op_slot_right_629 = gc_frame_newslot(num630);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_start_39_ (depth = 7)
  int op_slot_left_629 = gc_frame_newslot(*var_start_39_);
  params[0] = num630;
  partcv[0] = 1;
  Object diff632 = callmethod(*var_start_39_, "-", 1, partcv, params);
// compiled op node returning diff632 (depth = 6)
  int op_slot_right_628 = gc_frame_newslot(diff632);
// starting to compile num node (depth = 6)
  Object num634 = alloc_Float64(1);
// compiled num node returning num634 (depth = 6)
  int op_slot_left_628 = gc_frame_newslot(num634);
  params[0] = diff632;
  partcv[0] = 1;
  Object opresult635 = callmethod(num634, "..", 1, partcv, params);
// compiled op node returning opresult635 (depth = 5)
  gc_frame_newslot(opresult635);
// starting to compile block node (depth = 5)
  Object block636 = alloc_Block(NULL, NULL, "errormessages", 55);
  gc_frame_newslot(block636);
// method "_apply"
  block_savedest(block636);
  Object closure637 = createclosure(3, "_apply");
  setclosureframe(closure637, stackframe);
  addtoclosure(closure637, var_line);
  addtoclosure(closure637, var_indent);
  addtoclosure(closure637, selfslot);
  struct UserObject *uo637 = (struct UserObject*)block636;
  uo637->data[0] = (Object)closure637;
  Method *meth_meth_errormessages__apply637 = addmethod2pos(block636, "_apply", &meth_errormessages__apply637, 0);
  int argcv_meth_errormessages__apply637[] = {1};
  meth_meth_errormessages__apply637->type = alloc_MethodType(1, argcv_meth_errormessages__apply637);
  meth_meth_errormessages__apply637->definitionModule = modulename;
  meth_meth_errormessages__apply637->definitionLine = 52;
// compiled block node returning block636 (depth = 5)
  gc_frame_newslot(block636);
// call case 5: prelude request
  params[0] = opresult635;
  params[1] = block636;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call648 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe627);
// compiled call node returning call648 (depth = 4)
// Begin line 60
  setline(60);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
  Object bool651 = alloc_Boolean(1);
// compiled identifier node returning bool651 (depth = 6)
  int op_slot_right_650 = gc_frame_newslot(bool651);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_indent (depth = 6)
  int op_slot_left_650 = gc_frame_newslot(*var_indent);
  params[0] = bool651;
  partcv[0] = 1;
  Object opresult653 = callmethod(*var_indent, "==", 1, partcv, params);
// compiled op node returning opresult653 (depth = 5)
  Object if649 = done;
  if (istrue(opresult653)) {
// Begin line 61
  setline(61);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile num node (depth = 6)
  Object num654 = alloc_Float64(1);
// compiled num node returning num654 (depth = 6)
  *var_start_39_ = num654;
  if (num654 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if649 = done;
  } else {
  }
// compiled if node returning if649 (depth = 4)
    gc_frame_newslot(if649);
    if613 = if649;
  } else {
  }
// compiled if node returning if613 (depth = 3)
// Begin line 64
  setline(64);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe656 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_start_39_ (depth = 4)
  gc_frame_newslot(*var_start_39_);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_end (depth = 4)
  gc_frame_newslot(*var_end);
// starting to compile string node (depth = 4)
  if (strlit657 == NULL) {
    strlit657 = alloc_String("");
    gc_root(strlit657);
  }
// compiled string node returning strlit657 (depth = 4)
  gc_frame_newslot(strlit657);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lineNumber (depth = 4)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_start_39_;
  params[1] = *var_end;
  params[2] = strlit657;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call658 = callmethodflags(self, "replaceRange()with()onLine", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe656);
// compiled call node returning call658 (depth = 3)
  gc_frame_end(frame);
  return call658;
}
Object meth_errormessages_deleteChar_40__41_onLine659(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "deleteChar()onLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteChar()onLine");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteChar()onLine");
  Object params[4];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for deleteChar()onLine (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_pos = &(stackframe->slots[0]);
  *var_pos = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for deleteChar");
  Object *var_lineNumber = &(stackframe->slots[1]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for onLine");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 68
  setline(68);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe660 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// starting to compile string node (depth = 4)
  if (strlit661 == NULL) {
    strlit661 = alloc_String("");
    gc_root(strlit661);
  }
// compiled string node returning strlit661 (depth = 4)
  gc_frame_newslot(strlit661);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lineNumber (depth = 4)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_pos;
  params[1] = *var_pos;
  params[2] = strlit661;
  params[3] = *var_lineNumber;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call662 = callmethodflags(self, "replaceRange()with()onLine", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe660);
// compiled call node returning call662 (depth = 3)
  gc_frame_end(frame);
  return call662;
}
Object meth_errormessages_append_40__41_onLine663(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "append()onLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method append()onLine");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method append()onLine");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for append()onLine (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for append");
  Object *var_lineNumber = &(stackframe->slots[1]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for onLine");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_line = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "line");
// Begin line 72
  setline(72);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe664 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call665 = callmethodflags(self, "getLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe664);
// compiled call node returning call665 (depth = 4)
  *var_line = call665;
  if (call665 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 73
  setline(73);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe666 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lineNumber (depth = 4)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  int op_slot_right_667 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_line (depth = 5)
  int op_slot_left_667 = gc_frame_newslot(*var_line);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult669 = callmethod(*var_line, "++", 1, partcv, params);
// compiled op node returning opresult669 (depth = 4)
  gc_frame_newslot(opresult669);
// call case 4: self request
  params[0] = *var_lineNumber;
  params[1] = opresult669;
  partcv[0] = 2;
  Object call670 = callmethodflags(self, "addLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe666);
// compiled call node returning call670 (depth = 3)
  gc_frame_end(frame);
  return call670;
}
Object meth_errormessages_insert_40__41_atPosition_40__41_onLine671(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "insert()atPosition()onLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert()atPosition()onLine");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert()atPosition()onLine");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert()atPosition()onLine");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for insert()atPosition()onLine (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for insert");
  Object *var_pos = &(stackframe->slots[1]);
  *var_pos = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for atPosition");
  Object *var_lineNumber = &(stackframe->slots[2]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for onLine");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_line = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "line");
// Begin line 77
  setline(77);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe672 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call673 = callmethodflags(self, "getLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe672);
// compiled call node returning call673 (depth = 4)
  *var_line = call673;
  if (call673 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 78
  setline(78);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num676 = alloc_Float64(1);
// compiled num node returning num676 (depth = 5)
  int op_slot_right_675 = gc_frame_newslot(num676);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_pos (depth = 5)
  int op_slot_left_675 = gc_frame_newslot(*var_pos);
  params[0] = num676;
  partcv[0] = 1;
  Object opresult678 = callmethod(*var_pos, "==", 1, partcv, params);
// compiled op node returning opresult678 (depth = 4)
  Object if674 = done;
  if (istrue(opresult678)) {
// Begin line 79
  setline(79);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe679 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_line (depth = 6)
  int op_slot_right_680 = gc_frame_newslot(*var_line);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  int op_slot_left_680 = gc_frame_newslot(*var_s);
  params[0] = *var_line;
  partcv[0] = 1;
  Object opresult682 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult682 (depth = 5)
  gc_frame_newslot(opresult682);
// call case 4: self request
  params[0] = *var_lineNumber;
  params[1] = opresult682;
  partcv[0] = 2;
  Object call683 = callmethodflags(self, "addLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe679);
// compiled call node returning call683 (depth = 4)
    gc_frame_newslot(call683);
    if674 = call683;
  } else {
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe684 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// starting to compile op node (depth = 5)
// Begin line 82
  setline(82);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe686 = gc_frame_new();
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_pos (depth = 7)
  gc_frame_newslot(*var_pos);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe687 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_line (depth = 9)
  partcv[0] = 0;
  Object call688 = callmethod(*var_line, "size",
    1, partcv, params);
  gc_frame_end(callframe687);
// compiled call node returning call688 (depth = 8)
// compiled member node returning call688 (depth = 7)
  gc_frame_newslot(call688);
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_line (depth = 7)
  params[0] = *var_pos;
  params[1] = call688;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call689 = callmethod(*var_line, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe686);
// compiled call node returning call689 (depth = 6)
  int op_slot_right_685 = gc_frame_newslot(call689);
// Begin line 81
  setline(81);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_691 = gc_frame_newslot(*var_s);
// starting to compile call node (depth = 7)
  int callframe693 = gc_frame_new();
// starting to compile num node (depth = 8)
  Object num694 = alloc_Float64(1);
// compiled num node returning num694 (depth = 8)
  gc_frame_newslot(num694);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num696 = alloc_Float64(1);
// compiled num node returning num696 (depth = 9)
  int op_slot_right_695 = gc_frame_newslot(num696);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_pos (depth = 9)
  int op_slot_left_695 = gc_frame_newslot(*var_pos);
  params[0] = num696;
  partcv[0] = 1;
  Object diff698 = callmethod(*var_pos, "-", 1, partcv, params);
// compiled op node returning diff698 (depth = 8)
  gc_frame_newslot(diff698);
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  params[0] = num694;
  params[1] = diff698;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call699 = callmethod(*var_line, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe693);
// compiled call node returning call699 (depth = 7)
  int op_slot_left_691 = gc_frame_newslot(call699);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult700 = callmethod(call699, "++", 1, partcv, params);
// compiled op node returning opresult700 (depth = 6)
  int op_slot_left_685 = gc_frame_newslot(opresult700);
  params[0] = call689;
  partcv[0] = 1;
  Object opresult701 = callmethod(opresult700, "++", 1, partcv, params);
// compiled op node returning opresult701 (depth = 5)
  gc_frame_newslot(opresult701);
// call case 4: self request
  params[0] = *var_lineNumber;
  params[1] = opresult701;
  partcv[0] = 2;
  Object call702 = callmethodflags(self, "addLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe684);
// compiled call node returning call702 (depth = 4)
    gc_frame_newslot(call702);
    if674 = call702;
  }
// compiled if node returning if674 (depth = 3)
  gc_frame_end(frame);
  return if674;
}
Object meth_errormessages__apply714(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_token = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe716 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_token (depth = 10)
  partcv[0] = 0;
  Object call717 = callmethod(*var_token, "line",
    1, partcv, params);
  gc_frame_end(callframe716);
// compiled call node returning call717 (depth = 9)
// compiled member node returning call717 (depth = 8)
  int op_slot_right_715 = gc_frame_newslot(call717);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe719 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe720 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_token (depth = 12)
  partcv[0] = 0;
  Object call721 = callmethod(*var_token, "prev",
    1, partcv, params);
  gc_frame_end(callframe720);
// compiled call node returning call721 (depth = 11)
// compiled member node returning call721 (depth = 10)
  partcv[0] = 0;
  Object call722 = callmethod(call721, "line",
    1, partcv, params);
  gc_frame_end(callframe719);
// compiled call node returning call722 (depth = 9)
// compiled member node returning call722 (depth = 8)
  int op_slot_left_715 = gc_frame_newslot(call722);
  params[0] = call717;
  partcv[0] = 1;
  Object opresult723 = callmethod(call722, "==", 1, partcv, params);
// compiled op node returning opresult723 (depth = 7)
  gc_frame_end(frame);
  return opresult723;
}
Object meth_errormessages__apply760(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_token = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe762 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_token (depth = 10)
  partcv[0] = 0;
  Object call763 = callmethod(*var_token, "line",
    1, partcv, params);
  gc_frame_end(callframe762);
// compiled call node returning call763 (depth = 9)
// compiled member node returning call763 (depth = 8)
  int op_slot_right_761 = gc_frame_newslot(call763);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe765 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe766 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_token (depth = 12)
  partcv[0] = 0;
  Object call767 = callmethod(*var_token, "next",
    1, partcv, params);
  gc_frame_end(callframe766);
// compiled call node returning call767 (depth = 11)
// compiled member node returning call767 (depth = 10)
  partcv[0] = 0;
  Object call768 = callmethod(call767, "line",
    1, partcv, params);
  gc_frame_end(callframe765);
// compiled call node returning call768 (depth = 9)
// compiled member node returning call768 (depth = 8)
  int op_slot_left_761 = gc_frame_newslot(call768);
  params[0] = call763;
  partcv[0] = 1;
  Object opresult769 = callmethod(call768, "≠", 1, partcv, params);
// compiled op node returning opresult769 (depth = 7)
  gc_frame_end(frame);
  return opresult769;
}
Object meth_errormessages_getTokenStart_40__41_includeLeadingSpace703(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "getTokenStart()includeLeadingSpace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method getTokenStart()includeLeadingSpace");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method getTokenStart()includeLeadingSpace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for getTokenStart()includeLeadingSpace (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for getTokenStart");
  Object *var_includeLeading = &(stackframe->slots[1]);
  *var_includeLeading = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for includeLeadingSpace");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_start = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "start");
// Begin line 91
  setline(91);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe704 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_token (depth = 6)
  partcv[0] = 0;
  Object call705 = callmethod(*var_token, "linePos",
    1, partcv, params);
  gc_frame_end(callframe704);
// compiled call node returning call705 (depth = 5)
// compiled member node returning call705 (depth = 4)
  *var_start = call705;
  if (call705 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 93
  setline(93);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool708 = alloc_Boolean(1);
// compiled identifier node returning bool708 (depth = 5)
  int op_slot_right_707 = gc_frame_newslot(bool708);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_includeLeading (depth = 5)
  int op_slot_left_707 = gc_frame_newslot(*var_includeLeading);
  params[0] = bool708;
  partcv[0] = 1;
  Object opresult710 = callmethod(*var_includeLeading, "==", 1, partcv, params);
// compiled op node returning opresult710 (depth = 4)
  Object if706 = done;
  if (istrue(opresult710)) {
// Begin line 94
  setline(94);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block713 = alloc_Block(NULL, NULL, "errormessages", 94);
  gc_frame_newslot(block713);
// method "_apply"
  block_savedest(block713);
  Object closure714 = createclosure(2, "_apply");
  setclosureframe(closure714, stackframe);
  addtoclosure(closure714, var_token);
  addtoclosure(closure714, selfslot);
  struct UserObject *uo714 = (struct UserObject*)block713;
  uo714->data[0] = (Object)closure714;
  Method *meth_meth_errormessages__apply714 = addmethod2pos(block713, "_apply", &meth_errormessages__apply714, 0);
  int argcv_meth_errormessages__apply714[] = {0};
  meth_meth_errormessages__apply714->type = alloc_MethodType(1, argcv_meth_errormessages__apply714);
  meth_meth_errormessages__apply714->definitionModule = modulename;
  meth_meth_errormessages__apply714->definitionLine = 91;
// compiled block node returning block713 (depth = 6)
  int op_slot_right_712 = gc_frame_newslot(block713);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool727 = alloc_Boolean(0);
// compiled identifier node returning bool727 (depth = 7)
  int op_slot_right_726 = gc_frame_newslot(bool727);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe729 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_token (depth = 9)
  partcv[0] = 0;
  Object call730 = callmethod(*var_token, "prev",
    1, partcv, params);
  gc_frame_end(callframe729);
// compiled call node returning call730 (depth = 8)
// compiled member node returning call730 (depth = 7)
  int op_slot_left_726 = gc_frame_newslot(call730);
  params[0] = bool727;
  partcv[0] = 1;
  Object opresult731 = callmethod(call730, "≠", 1, partcv, params);
// compiled op node returning opresult731 (depth = 6)
  int op_slot_left_712 = gc_frame_newslot(opresult731);
  params[0] = block713;
  partcv[0] = 1;
  Object opresult732 = callmethod(opresult731, "&&", 1, partcv, params);
// compiled op node returning opresult732 (depth = 5)
  Object if711 = done;
  if (istrue(opresult732)) {
// Begin line 95
  setline(95);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe734 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe735 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_token (depth = 11)
  partcv[0] = 0;
  Object call736 = callmethod(*var_token, "prev",
    1, partcv, params);
  gc_frame_end(callframe735);
// compiled call node returning call736 (depth = 10)
// compiled member node returning call736 (depth = 9)
  partcv[0] = 0;
  Object call737 = callmethod(call736, "size",
    1, partcv, params);
  gc_frame_end(callframe734);
// compiled call node returning call737 (depth = 8)
// compiled member node returning call737 (depth = 7)
  int op_slot_right_733 = gc_frame_newslot(call737);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe739 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe740 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_token (depth = 11)
  partcv[0] = 0;
  Object call741 = callmethod(*var_token, "prev",
    1, partcv, params);
  gc_frame_end(callframe740);
// compiled call node returning call741 (depth = 10)
// compiled member node returning call741 (depth = 9)
  partcv[0] = 0;
  Object call742 = callmethod(call741, "linePos",
    1, partcv, params);
  gc_frame_end(callframe739);
// compiled call node returning call742 (depth = 8)
// compiled member node returning call742 (depth = 7)
  int op_slot_left_733 = gc_frame_newslot(call742);
  params[0] = call737;
  partcv[0] = 1;
  Object sum743 = callmethod(call742, "+", 1, partcv, params);
// compiled op node returning sum743 (depth = 6)
  *var_start = sum743;
  if (sum743 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if711 = done;
  } else {
  }
// compiled if node returning if711 (depth = 4)
    gc_frame_newslot(if711);
    if706 = if711;
  } else {
  }
// compiled if node returning if706 (depth = 3)
// Begin line 99
  setline(99);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num748 = alloc_Float64(1);
// compiled num node returning num748 (depth = 6)
  int op_slot_right_747 = gc_frame_newslot(num748);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe750 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_token (depth = 8)
  partcv[0] = 0;
  Object call751 = callmethod(*var_token, "indent",
    1, partcv, params);
  gc_frame_end(callframe750);
// compiled call node returning call751 (depth = 7)
// compiled member node returning call751 (depth = 6)
  int op_slot_left_747 = gc_frame_newslot(call751);
  params[0] = num748;
  partcv[0] = 1;
  Object sum752 = callmethod(call751, "+", 1, partcv, params);
// compiled op node returning sum752 (depth = 5)
  int op_slot_right_746 = gc_frame_newslot(sum752);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe754 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_token (depth = 7)
  partcv[0] = 0;
  Object call755 = callmethod(*var_token, "linePos",
    1, partcv, params);
  gc_frame_end(callframe754);
// compiled call node returning call755 (depth = 6)
// compiled member node returning call755 (depth = 5)
  int op_slot_left_746 = gc_frame_newslot(call755);
  params[0] = sum752;
  partcv[0] = 1;
  Object opresult756 = callmethod(call755, "==", 1, partcv, params);
// compiled op node returning opresult756 (depth = 4)
  Object if745 = done;
  if (istrue(opresult756)) {
// Begin line 100
  setline(100);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block759 = alloc_Block(NULL, NULL, "errormessages", 100);
  gc_frame_newslot(block759);
// method "_apply"
  block_savedest(block759);
  Object closure760 = createclosure(2, "_apply");
  setclosureframe(closure760, stackframe);
  addtoclosure(closure760, var_token);
  addtoclosure(closure760, selfslot);
  struct UserObject *uo760 = (struct UserObject*)block759;
  uo760->data[0] = (Object)closure760;
  Method *meth_meth_errormessages__apply760 = addmethod2pos(block759, "_apply", &meth_errormessages__apply760, 0);
  int argcv_meth_errormessages__apply760[] = {0};
  meth_meth_errormessages__apply760->type = alloc_MethodType(1, argcv_meth_errormessages__apply760);
  meth_meth_errormessages__apply760->definitionModule = modulename;
  meth_meth_errormessages__apply760->definitionLine = 99;
// compiled block node returning block759 (depth = 6)
  int op_slot_right_758 = gc_frame_newslot(block759);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool773 = alloc_Boolean(0);
// compiled identifier node returning bool773 (depth = 7)
  int op_slot_right_772 = gc_frame_newslot(bool773);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe775 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_token (depth = 9)
  partcv[0] = 0;
  Object call776 = callmethod(*var_token, "next",
    1, partcv, params);
  gc_frame_end(callframe775);
// compiled call node returning call776 (depth = 8)
// compiled member node returning call776 (depth = 7)
  int op_slot_left_772 = gc_frame_newslot(call776);
  params[0] = bool773;
  partcv[0] = 1;
  Object opresult777 = callmethod(call776, "==", 1, partcv, params);
// compiled op node returning opresult777 (depth = 6)
  int op_slot_left_758 = gc_frame_newslot(opresult777);
  params[0] = block759;
  partcv[0] = 1;
  Object opresult778 = callmethod(opresult777, "||", 1, partcv, params);
// compiled op node returning opresult778 (depth = 5)
  Object if757 = done;
  if (istrue(opresult778)) {
// Begin line 101
  setline(101);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile num node (depth = 6)
  Object num779 = alloc_Float64(1);
// compiled num node returning num779 (depth = 6)
  *var_start = num779;
  if (num779 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if757 = done;
  } else {
  }
// compiled if node returning if757 (depth = 4)
    gc_frame_newslot(if757);
    if745 = if757;
  } else {
  }
// compiled if node returning if745 (depth = 3)
// Begin line 104
  setline(104);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_start (depth = 3)
  gc_frame_end(frame);
  return *var_start;
}
Object meth_errormessages__apply801(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_token = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe803 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_token (depth = 10)
  partcv[0] = 0;
  Object call804 = callmethod(*var_token, "line",
    1, partcv, params);
  gc_frame_end(callframe803);
// compiled call node returning call804 (depth = 9)
// compiled member node returning call804 (depth = 8)
  int op_slot_right_802 = gc_frame_newslot(call804);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe806 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe807 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_token (depth = 12)
  partcv[0] = 0;
  Object call808 = callmethod(*var_token, "next",
    1, partcv, params);
  gc_frame_end(callframe807);
// compiled call node returning call808 (depth = 11)
// compiled member node returning call808 (depth = 10)
  partcv[0] = 0;
  Object call809 = callmethod(call808, "line",
    1, partcv, params);
  gc_frame_end(callframe806);
// compiled call node returning call809 (depth = 9)
// compiled member node returning call809 (depth = 8)
  int op_slot_left_802 = gc_frame_newslot(call809);
  params[0] = call804;
  partcv[0] = 1;
  Object opresult810 = callmethod(call809, "==", 1, partcv, params);
// compiled op node returning opresult810 (depth = 7)
  gc_frame_end(frame);
  return opresult810;
}
Object meth_errormessages_getTokenEnd_40__41_includeTrailingSpace781(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "getTokenEnd()includeTrailingSpace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method getTokenEnd()includeTrailingSpace");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method getTokenEnd()includeTrailingSpace");
  Object params[1];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for getTokenEnd()includeTrailingSpace (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for getTokenEnd");
  Object *var_includeTrailing = &(stackframe->slots[1]);
  *var_includeTrailing = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for includeTrailingSpace");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_end = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "end");
// Begin line 108
  setline(108);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num783 = alloc_Float64(1);
// compiled num node returning num783 (depth = 5)
  int op_slot_right_782 = gc_frame_newslot(num783);
// starting to compile op node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe786 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_token (depth = 8)
  partcv[0] = 0;
  Object call787 = callmethod(*var_token, "size",
    1, partcv, params);
  gc_frame_end(callframe786);
// compiled call node returning call787 (depth = 7)
// compiled member node returning call787 (depth = 6)
  int op_slot_right_785 = gc_frame_newslot(call787);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe789 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_token (depth = 8)
  partcv[0] = 0;
  Object call790 = callmethod(*var_token, "linePos",
    1, partcv, params);
  gc_frame_end(callframe789);
// compiled call node returning call790 (depth = 7)
// compiled member node returning call790 (depth = 6)
  int op_slot_left_785 = gc_frame_newslot(call790);
  params[0] = call787;
  partcv[0] = 1;
  Object sum791 = callmethod(call790, "+", 1, partcv, params);
// compiled op node returning sum791 (depth = 5)
  int op_slot_left_782 = gc_frame_newslot(sum791);
  params[0] = num783;
  partcv[0] = 1;
  Object diff792 = callmethod(sum791, "-", 1, partcv, params);
// compiled op node returning diff792 (depth = 4)
  *var_end = diff792;
  if (diff792 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 110
  setline(110);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool795 = alloc_Boolean(1);
// compiled identifier node returning bool795 (depth = 5)
  int op_slot_right_794 = gc_frame_newslot(bool795);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_includeTrailing (depth = 5)
  int op_slot_left_794 = gc_frame_newslot(*var_includeTrailing);
  params[0] = bool795;
  partcv[0] = 1;
  Object opresult797 = callmethod(*var_includeTrailing, "==", 1, partcv, params);
// compiled op node returning opresult797 (depth = 4)
  Object if793 = done;
  if (istrue(opresult797)) {
// Begin line 111
  setline(111);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile block node (depth = 6)
  Object block800 = alloc_Block(NULL, NULL, "errormessages", 111);
  gc_frame_newslot(block800);
// method "_apply"
  block_savedest(block800);
  Object closure801 = createclosure(2, "_apply");
  setclosureframe(closure801, stackframe);
  addtoclosure(closure801, var_token);
  addtoclosure(closure801, selfslot);
  struct UserObject *uo801 = (struct UserObject*)block800;
  uo801->data[0] = (Object)closure801;
  Method *meth_meth_errormessages__apply801 = addmethod2pos(block800, "_apply", &meth_errormessages__apply801, 0);
  int argcv_meth_errormessages__apply801[] = {0};
  meth_meth_errormessages__apply801->type = alloc_MethodType(1, argcv_meth_errormessages__apply801);
  meth_meth_errormessages__apply801->definitionModule = modulename;
  meth_meth_errormessages__apply801->definitionLine = 108;
// compiled block node returning block800 (depth = 6)
  int op_slot_right_799 = gc_frame_newslot(block800);
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
  Object bool814 = alloc_Boolean(0);
// compiled identifier node returning bool814 (depth = 7)
  int op_slot_right_813 = gc_frame_newslot(bool814);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe816 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_token (depth = 9)
  partcv[0] = 0;
  Object call817 = callmethod(*var_token, "next",
    1, partcv, params);
  gc_frame_end(callframe816);
// compiled call node returning call817 (depth = 8)
// compiled member node returning call817 (depth = 7)
  int op_slot_left_813 = gc_frame_newslot(call817);
  params[0] = bool814;
  partcv[0] = 1;
  Object opresult818 = callmethod(call817, "≠", 1, partcv, params);
// compiled op node returning opresult818 (depth = 6)
  int op_slot_left_799 = gc_frame_newslot(opresult818);
  params[0] = block800;
  partcv[0] = 1;
  Object opresult819 = callmethod(opresult818, "&&", 1, partcv, params);
// compiled op node returning opresult819 (depth = 5)
  Object if798 = done;
  if (istrue(opresult819)) {
// Begin line 112
  setline(112);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile num node (depth = 7)
  Object num821 = alloc_Float64(1);
// compiled num node returning num821 (depth = 7)
  int op_slot_right_820 = gc_frame_newslot(num821);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe823 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe824 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_token (depth = 11)
  partcv[0] = 0;
  Object call825 = callmethod(*var_token, "next",
    1, partcv, params);
  gc_frame_end(callframe824);
// compiled call node returning call825 (depth = 10)
// compiled member node returning call825 (depth = 9)
  partcv[0] = 0;
  Object call826 = callmethod(call825, "linePos",
    1, partcv, params);
  gc_frame_end(callframe823);
// compiled call node returning call826 (depth = 8)
// compiled member node returning call826 (depth = 7)
  int op_slot_left_820 = gc_frame_newslot(call826);
  params[0] = num821;
  partcv[0] = 1;
  Object diff827 = callmethod(call826, "-", 1, partcv, params);
// compiled op node returning diff827 (depth = 6)
  *var_end = diff827;
  if (diff827 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if798 = done;
  } else {
// Begin line 114
  setline(114);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe829 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 8)
  int callframe830 = gc_frame_new();
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe831 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 11)
// compiled identifier node returning *var_token (depth = 11)
  partcv[0] = 0;
  Object call832 = callmethod(*var_token, "line",
    1, partcv, params);
  gc_frame_end(callframe831);
// compiled call node returning call832 (depth = 10)
// compiled member node returning call832 (depth = 9)
  gc_frame_newslot(call832);
// call case 4: self request
  params[0] = call832;
  partcv[0] = 1;
  Object call833 = callmethodflags(self, "getLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe830);
// compiled call node returning call833 (depth = 8)
  partcv[0] = 0;
  Object call834 = callmethod(call833, "size",
    1, partcv, params);
  gc_frame_end(callframe829);
// compiled call node returning call834 (depth = 7)
// compiled member node returning call834 (depth = 6)
  *var_end = call834;
  if (call834 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
    gc_frame_newslot(done);
    if798 = done;
  }
// compiled if node returning if798 (depth = 4)
    gc_frame_newslot(if798);
    if793 = if798;
  } else {
  }
// compiled if node returning if793 (depth = 3)
// Begin line 117
  setline(117);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_end (depth = 3)
  gc_frame_end(frame);
  return *var_end;
}
Object meth_errormessages_replaceToken_40__41_leading_40__41_trailing_40__41_with836(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(7, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "replaceToken()leading()trailing()with");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceToken()leading()trailing()with");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceToken()leading()trailing()with");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceToken()leading()trailing()with");
  if (nparts > 0 && argcv[3] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceToken()leading()trailing()with");
  Object params[4];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 4 && args)
    graceRaise(RequestError(), "missing argument list for replaceToken()leading()trailing()with (probably reflection error): got %i lists, expected 4.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for replaceToken");
  Object *var_replaceLeading = &(stackframe->slots[1]);
  *var_replaceLeading = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for leading");
  Object *var_replaceTrailing = &(stackframe->slots[2]);
  *var_replaceTrailing = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for trailing");
  Object *var_s = &(stackframe->slots[3]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[3] != 1)
    graceRaise(RequestError(), "wrong number of arguments for with");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_start = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "start");
  Object *var_end = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "end");
// Begin line 121
  setline(121);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe837 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_token (depth = 5)
  gc_frame_newslot(*var_token);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_replaceLeading (depth = 5)
  gc_frame_newslot(*var_replaceLeading);
// call case 4: self request
  params[0] = *var_token;
  params[1] = *var_replaceLeading;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call838 = callmethodflags(self, "getTokenStart()includeLeadingSpace", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe837);
// compiled call node returning call838 (depth = 4)
  *var_start = call838;
  if (call838 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 122
  setline(122);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe839 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_token (depth = 5)
  gc_frame_newslot(*var_token);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_replaceTrailing (depth = 5)
  gc_frame_newslot(*var_replaceTrailing);
// call case 4: self request
  params[0] = *var_token;
  params[1] = *var_replaceTrailing;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call840 = callmethodflags(self, "getTokenEnd()includeTrailingSpace", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe839);
// compiled call node returning call840 (depth = 4)
  *var_end = call840;
  if (call840 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 123
  setline(123);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe841 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_start (depth = 4)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_end (depth = 4)
  gc_frame_newslot(*var_end);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe842 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_token (depth = 6)
  partcv[0] = 0;
  Object call843 = callmethod(*var_token, "line",
    1, partcv, params);
  gc_frame_end(callframe842);
// compiled call node returning call843 (depth = 5)
// compiled member node returning call843 (depth = 4)
  gc_frame_newslot(call843);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_end;
  params[2] = *var_s;
  params[3] = call843;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call844 = callmethodflags(self, "replaceRange()with()onLine", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe841);
// compiled call node returning call844 (depth = 3)
  gc_frame_end(frame);
  return call844;
}
Object meth_errormessages_replaceToken_40__41_with845(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "replaceToken()with");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceToken()with");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceToken()with");
  Object params[4];
  int partcv[4];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for replaceToken()with (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for replaceToken");
  Object *var_s = &(stackframe->slots[1]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for with");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 127
  setline(127);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe846 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_token (depth = 4)
  gc_frame_newslot(*var_token);
// starting to compile identifier node (depth = 4)
  Object bool847 = alloc_Boolean(0);
// compiled identifier node returning bool847 (depth = 4)
  gc_frame_newslot(bool847);
// starting to compile identifier node (depth = 4)
  Object bool848 = alloc_Boolean(0);
// compiled identifier node returning bool848 (depth = 4)
  gc_frame_newslot(bool848);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 4: self request
  params[0] = *var_token;
  params[1] = bool847;
  params[2] = bool848;
  params[3] = *var_s;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call849 = callmethodflags(self, "replaceToken()leading()trailing()with", 4, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe846);
// compiled call node returning call849 (depth = 3)
  gc_frame_end(frame);
  return call849;
}
Object meth_errormessages_replaceTokenRange_40__41_leading_40__41_trailing_40__41_with850(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(8, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "replaceTokenRange()leading()trailing()with");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method replaceTokenRange()leading()trailing()with");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceTokenRange()leading()trailing()with");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceTokenRange()leading()trailing()with");
  if (nparts > 0 && argcv[3] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceTokenRange()leading()trailing()with");
  Object params[4];
  int partcv[4];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 4 && args)
    graceRaise(RequestError(), "missing argument list for replaceTokenRange()leading()trailing()with (probably reflection error): got %i lists, expected 4.", nparts);
  Object *var_start = &(stackframe->slots[0]);
  *var_start = args[curarg];
  curarg++;
  Object *var_end = &(stackframe->slots[1]);
  *var_end = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for replaceTokenRange");
  Object *var_replaceLeading = &(stackframe->slots[2]);
  *var_replaceLeading = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for leading");
  Object *var_replaceTrailing = &(stackframe->slots[3]);
  *var_replaceTrailing = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for trailing");
  Object *var_s = &(stackframe->slots[4]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[3] != 1)
    graceRaise(RequestError(), "wrong number of arguments for with");
  Object *selfslot = &(stackframe->slots[5]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_insertPos = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "insertPos");
  Object *var_indent = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "indent");
// Begin line 131
  setline(131);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_end (depth = 5)
  int op_slot_right_852 = gc_frame_newslot(*var_end);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_start (depth = 5)
  int op_slot_left_852 = gc_frame_newslot(*var_start);
  params[0] = *var_end;
  partcv[0] = 1;
  Object opresult854 = callmethod(*var_start, "==", 1, partcv, params);
// compiled op node returning opresult854 (depth = 4)
  Object if851 = done;
  if (istrue(opresult854)) {
// Begin line 132
  setline(132);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe855 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_start (depth = 5)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_replaceLeading (depth = 5)
  gc_frame_newslot(*var_replaceLeading);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_replaceTrailing (depth = 5)
  gc_frame_newslot(*var_replaceTrailing);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_s (depth = 5)
  gc_frame_newslot(*var_s);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_replaceLeading;
  params[2] = *var_replaceTrailing;
  params[3] = *var_s;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call856 = callmethodflags(self, "replaceToken()leading()trailing()with", 4, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe855);
// compiled call node returning call856 (depth = 4)
    gc_frame_newslot(call856);
    if851 = call856;
  } else {
// Begin line 135
  setline(135);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe857 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_start (depth = 6)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_replaceLeading (depth = 6)
  gc_frame_newslot(*var_replaceLeading);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_replaceLeading;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call858 = callmethodflags(self, "getTokenStart()includeLeadingSpace", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe857);
// compiled call node returning call858 (depth = 5)
  *var_insertPos = call858;
  if (call858 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 136
  setline(136);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe859 = gc_frame_new();
// starting to compile num node (depth = 6)
  Object num860 = alloc_Float64(1);
// compiled num node returning num860 (depth = 6)
  gc_frame_newslot(num860);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe861 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_start (depth = 8)
  partcv[0] = 0;
  Object call862 = callmethod(*var_start, "indent",
    1, partcv, params);
  gc_frame_end(callframe861);
// compiled call node returning call862 (depth = 7)
// compiled member node returning call862 (depth = 6)
  gc_frame_newslot(call862);
// call case 6: other member request
// starting to compile call node (depth = 6)
  int callframe863 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe864 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_start (depth = 9)
  partcv[0] = 0;
  Object call865 = callmethod(*var_start, "line",
    1, partcv, params);
  gc_frame_end(callframe864);
// compiled call node returning call865 (depth = 8)
// compiled member node returning call865 (depth = 7)
  gc_frame_newslot(call865);
// call case 4: self request
  params[0] = call865;
  partcv[0] = 1;
  Object call866 = callmethodflags(self, "getLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe863);
// compiled call node returning call866 (depth = 6)
  params[0] = num860;
  params[1] = call862;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call867 = callmethod(call866, "substringFrom()to",
    2, partcv, params);
  gc_frame_end(callframe859);
// compiled call node returning call867 (depth = 5)
  *var_indent = call867;
  if (call867 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 4)
// Begin line 137
  setline(137);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe868 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_start (depth = 5)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_end (depth = 5)
  gc_frame_newslot(*var_end);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_replaceLeading (depth = 5)
  gc_frame_newslot(*var_replaceLeading);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_replaceTrailing (depth = 5)
  gc_frame_newslot(*var_replaceTrailing);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_end;
  params[2] = *var_replaceLeading;
  params[3] = *var_replaceTrailing;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call869 = callmethodflags(self, "deleteTokenRange()leading()trailing", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe868);
// compiled call node returning call869 (depth = 4)
// Begin line 139
  setline(139);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile string node (depth = 6)
  if (strlit872 == NULL) {
    strlit872 = alloc_String("");
    gc_root(strlit872);
  }
// compiled string node returning strlit872 (depth = 6)
  int op_slot_right_871 = gc_frame_newslot(strlit872);
// starting to compile call node (depth = 6)
  int callframe874 = gc_frame_new();
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe875 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_start (depth = 9)
  partcv[0] = 0;
  Object call876 = callmethod(*var_start, "line",
    1, partcv, params);
  gc_frame_end(callframe875);
// compiled call node returning call876 (depth = 8)
// compiled member node returning call876 (depth = 7)
  gc_frame_newslot(call876);
// call case 4: self request
  params[0] = call876;
  partcv[0] = 1;
  Object call877 = callmethodflags(self, "getLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe874);
// compiled call node returning call877 (depth = 6)
  int op_slot_left_871 = gc_frame_newslot(call877);
  params[0] = strlit872;
  partcv[0] = 1;
  Object opresult878 = callmethod(call877, "==", 1, partcv, params);
// compiled op node returning opresult878 (depth = 5)
  Object if870 = done;
  if (istrue(opresult878)) {
// Begin line 140
  setline(140);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe879 = gc_frame_new();
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_s (depth = 7)
  int op_slot_right_880 = gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_indent (depth = 7)
  int op_slot_left_880 = gc_frame_newslot(*var_indent);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult882 = callmethod(*var_indent, "++", 1, partcv, params);
// compiled op node returning opresult882 (depth = 6)
  gc_frame_newslot(opresult882);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_insertPos (depth = 6)
  gc_frame_newslot(*var_insertPos);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe883 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_start (depth = 8)
  partcv[0] = 0;
  Object call884 = callmethod(*var_start, "line",
    1, partcv, params);
  gc_frame_end(callframe883);
// compiled call node returning call884 (depth = 7)
// compiled member node returning call884 (depth = 6)
  gc_frame_newslot(call884);
// call case 4: self request
  params[0] = opresult882;
  params[1] = *var_insertPos;
  params[2] = call884;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call885 = callmethodflags(self, "insert()atPosition()onLine", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe879);
// compiled call node returning call885 (depth = 5)
    gc_frame_newslot(call885);
    if870 = call885;
  } else {
// Begin line 142
  setline(142);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe886 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_s (depth = 6)
  gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_insertPos (depth = 6)
  gc_frame_newslot(*var_insertPos);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe887 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_start (depth = 8)
  partcv[0] = 0;
  Object call888 = callmethod(*var_start, "line",
    1, partcv, params);
  gc_frame_end(callframe887);
// compiled call node returning call888 (depth = 7)
// compiled member node returning call888 (depth = 6)
  gc_frame_newslot(call888);
// call case 4: self request
  params[0] = *var_s;
  params[1] = *var_insertPos;
  params[2] = call888;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call889 = callmethodflags(self, "insert()atPosition()onLine", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe886);
// compiled call node returning call889 (depth = 5)
    gc_frame_newslot(call889);
    if870 = call889;
  }
// compiled if node returning if870 (depth = 4)
    gc_frame_newslot(if870);
    if851 = if870;
  }
// compiled if node returning if851 (depth = 3)
  gc_frame_end(frame);
  return if851;
}
Object meth_errormessages_replaceTokenRange_40__41_with890(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "replaceTokenRange()with");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method replaceTokenRange()with");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method replaceTokenRange()with");
  Object params[5];
  int partcv[4];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for replaceTokenRange()with (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_start = &(stackframe->slots[0]);
  *var_start = args[curarg];
  curarg++;
  Object *var_end = &(stackframe->slots[1]);
  *var_end = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for replaceTokenRange");
  Object *var_s = &(stackframe->slots[2]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for with");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 148
  setline(148);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe891 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_start (depth = 4)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_end (depth = 4)
  gc_frame_newslot(*var_end);
// starting to compile identifier node (depth = 4)
  Object bool892 = alloc_Boolean(0);
// compiled identifier node returning bool892 (depth = 4)
  gc_frame_newslot(bool892);
// starting to compile identifier node (depth = 4)
  Object bool893 = alloc_Boolean(0);
// compiled identifier node returning bool893 (depth = 4)
  gc_frame_newslot(bool893);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_end;
  params[2] = bool892;
  params[3] = bool893;
  params[4] = *var_s;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  partcv[3] = 1;
  Object call894 = callmethodflags(self, "replaceTokenRange()leading()trailing()with", 4, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe891);
// compiled call node returning call894 (depth = 3)
  gc_frame_end(frame);
  return call894;
}
Object meth_errormessages_deleteToken_40__41_leading_40__41_trailing895(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(6, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "deleteToken()leading()trailing");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteToken()leading()trailing");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteToken()leading()trailing");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteToken()leading()trailing");
  Object params[3];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for deleteToken()leading()trailing (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for deleteToken");
  Object *var_deleteLeading = &(stackframe->slots[1]);
  *var_deleteLeading = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for leading");
  Object *var_deleteTrailing = &(stackframe->slots[2]);
  *var_deleteTrailing = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for trailing");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_start = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "start");
  Object *var_end = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "end");
// Begin line 153
  setline(153);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe896 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_token (depth = 5)
  gc_frame_newslot(*var_token);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_deleteLeading (depth = 5)
  gc_frame_newslot(*var_deleteLeading);
// call case 4: self request
  params[0] = *var_token;
  params[1] = *var_deleteLeading;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call897 = callmethodflags(self, "getTokenStart()includeLeadingSpace", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe896);
// compiled call node returning call897 (depth = 4)
  *var_start = call897;
  if (call897 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 154
  setline(154);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe898 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_token (depth = 5)
  gc_frame_newslot(*var_token);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_deleteTrailing (depth = 5)
  gc_frame_newslot(*var_deleteTrailing);
// call case 4: self request
  params[0] = *var_token;
  params[1] = *var_deleteTrailing;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call899 = callmethodflags(self, "getTokenEnd()includeTrailingSpace", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe898);
// compiled call node returning call899 (depth = 4)
  *var_end = call899;
  if (call899 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 155
  setline(155);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe900 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_start (depth = 4)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_end (depth = 4)
  gc_frame_newslot(*var_end);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe901 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_token (depth = 6)
  partcv[0] = 0;
  Object call902 = callmethod(*var_token, "line",
    1, partcv, params);
  gc_frame_end(callframe901);
// compiled call node returning call902 (depth = 5)
// compiled member node returning call902 (depth = 4)
  gc_frame_newslot(call902);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_end;
  params[2] = call902;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call903 = callmethodflags(self, "deleteRange()onLine", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe900);
// compiled call node returning call903 (depth = 3)
  gc_frame_end(frame);
  return call903;
}
Object meth_errormessages_deleteToken904(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "deleteToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteToken");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for deleteToken (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_token = &(stackframe->slots[0]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for deleteToken");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 159
  setline(159);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe905 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_token (depth = 4)
  gc_frame_newslot(*var_token);
// starting to compile identifier node (depth = 4)
  Object bool906 = alloc_Boolean(0);
// compiled identifier node returning bool906 (depth = 4)
  gc_frame_newslot(bool906);
// starting to compile identifier node (depth = 4)
  Object bool907 = alloc_Boolean(0);
// compiled identifier node returning bool907 (depth = 4)
  gc_frame_newslot(bool907);
// call case 4: self request
  params[0] = *var_token;
  params[1] = bool906;
  params[2] = bool907;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call908 = callmethodflags(self, "deleteToken()leading()trailing", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe905);
// compiled call node returning call908 (depth = 3)
  gc_frame_end(frame);
  return call908;
}
Object meth_errormessages__apply926(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_end = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_end (depth = 7)
  int op_slot_right_927 = gc_frame_newslot(*var_end);
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_tok (depth = 7)
  int op_slot_left_927 = gc_frame_newslot(*var_tok);
  params[0] = *var_end;
  partcv[0] = 1;
  Object opresult929 = callmethod(*var_tok, "≠", 1, partcv, params);
// compiled op node returning opresult929 (depth = 6)
  gc_frame_end(frame);
  return opresult929;
}
Object meth_errormessages__apply932(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[3];
  int partcv[2];
  Object *var_line = getfromclosure(closure, 0);
  Object *var_tok = getfromclosure(closure, 1);
  Object *var_startPos = getfromclosure(closure, 2);
  Object *var_endPos = getfromclosure(closure, 3);
  Object *var_deleteLeading = getfromclosure(closure, 4);
  Object *var_deleteTrailing = getfromclosure(closure, 5);
  Object self = *(getfromclosure(closure, 6));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 172
  setline(172);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 6)
// starting to compile op node (depth = 7)
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  int op_slot_right_934 = gc_frame_newslot(*var_line);
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe936 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tok (depth = 10)
  partcv[0] = 0;
  Object call937 = callmethod(*var_tok, "line",
    1, partcv, params);
  gc_frame_end(callframe936);
// compiled call node returning call937 (depth = 9)
// compiled member node returning call937 (depth = 8)
  int op_slot_left_934 = gc_frame_newslot(call937);
  params[0] = *var_line;
  partcv[0] = 1;
  Object opresult938 = callmethod(call937, "≠", 1, partcv, params);
// compiled op node returning opresult938 (depth = 7)
  Object if933 = done;
  if (istrue(opresult938)) {
// Begin line 173
  setline(173);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe939 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_startPos (depth = 8)
  gc_frame_newslot(*var_startPos);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_endPos (depth = 8)
  gc_frame_newslot(*var_endPos);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_line (depth = 8)
  gc_frame_newslot(*var_line);
// call case 4: self request
  params[0] = *var_startPos;
  params[1] = *var_endPos;
  params[2] = *var_line;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call940 = callmethodflags(self, "deleteRange()onLine", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe939);
// compiled call node returning call940 (depth = 7)
// Begin line 174
  setline(174);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe941 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_tok (depth = 10)
  partcv[0] = 0;
  Object call942 = callmethod(*var_tok, "line",
    1, partcv, params);
  gc_frame_end(callframe941);
// compiled call node returning call942 (depth = 9)
// compiled member node returning call942 (depth = 8)
  *var_line = call942;
  if (call942 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
// Begin line 175
  setline(175);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe944 = gc_frame_new();
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  gc_frame_newslot(*var_tok);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_deleteLeading (depth = 9)
  gc_frame_newslot(*var_deleteLeading);
// call case 4: self request
  params[0] = *var_tok;
  params[1] = *var_deleteLeading;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call945 = callmethodflags(self, "getTokenStart()includeLeadingSpace", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe944);
// compiled call node returning call945 (depth = 8)
  *var_startPos = call945;
  if (call945 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
    gc_frame_newslot(done);
    if933 = done;
  } else {
  }
// compiled if node returning if933 (depth = 6)
// Begin line 177
  setline(177);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe947 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_tok (depth = 8)
  gc_frame_newslot(*var_tok);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_deleteTrailing (depth = 8)
  gc_frame_newslot(*var_deleteTrailing);
// call case 4: self request
  params[0] = *var_tok;
  params[1] = *var_deleteTrailing;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call948 = callmethodflags(self, "getTokenEnd()includeTrailingSpace", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe947);
// compiled call node returning call948 (depth = 7)
  *var_endPos = call948;
  if (call948 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
// Begin line 178
  setline(178);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 6)
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe950 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_tok (depth = 9)
  partcv[0] = 0;
  Object call951 = callmethod(*var_tok, "next",
    1, partcv, params);
  gc_frame_end(callframe950);
// compiled call node returning call951 (depth = 8)
// compiled member node returning call951 (depth = 7)
  *var_tok = call951;
  if (call951 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 6)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_deleteTokenRange_40__41_leading_40__41_trailing909(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(9, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "deleteTokenRange()leading()trailing");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method deleteTokenRange()leading()trailing");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteTokenRange()leading()trailing");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteTokenRange()leading()trailing");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for deleteTokenRange()leading()trailing (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_start = &(stackframe->slots[0]);
  *var_start = args[curarg];
  curarg++;
  Object *var_end = &(stackframe->slots[1]);
  *var_end = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for deleteTokenRange");
  Object *var_deleteLeading = &(stackframe->slots[2]);
  *var_deleteLeading = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for leading");
  Object *var_deleteTrailing = &(stackframe->slots[3]);
  *var_deleteTrailing = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for trailing");
  Object *selfslot = &(stackframe->slots[4]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_line = &(stackframe->slots[5]);
  setframeelementname(stackframe, 5, "line");
  Object *var_startPos = &(stackframe->slots[6]);
  setframeelementname(stackframe, 6, "startPos");
  Object *var_endPos = &(stackframe->slots[7]);
  setframeelementname(stackframe, 7, "endPos");
  Object *var_tok = &(stackframe->slots[8]);
  setframeelementname(stackframe, 8, "tok");
// Begin line 164
  setline(164);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_end (depth = 5)
  int op_slot_right_911 = gc_frame_newslot(*var_end);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_start (depth = 5)
  int op_slot_left_911 = gc_frame_newslot(*var_start);
  params[0] = *var_end;
  partcv[0] = 1;
  Object opresult913 = callmethod(*var_start, "==", 1, partcv, params);
// compiled op node returning opresult913 (depth = 4)
  Object if910 = done;
  if (istrue(opresult913)) {
// Begin line 165
  setline(165);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe914 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_start (depth = 5)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_deleteLeading (depth = 5)
  gc_frame_newslot(*var_deleteLeading);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_deleteTrailing (depth = 5)
  gc_frame_newslot(*var_deleteTrailing);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_deleteLeading;
  params[2] = *var_deleteTrailing;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call915 = callmethodflags(self, "deleteToken()leading()trailing", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe914);
// compiled call node returning call915 (depth = 4)
    gc_frame_newslot(call915);
    if910 = call915;
  } else {
// Begin line 167
  setline(167);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe916 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_start (depth = 7)
  partcv[0] = 0;
  Object call917 = callmethod(*var_start, "line",
    1, partcv, params);
  gc_frame_end(callframe916);
// compiled call node returning call917 (depth = 6)
// compiled member node returning call917 (depth = 5)
  *var_line = call917;
  if (call917 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 168
  setline(168);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe918 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_start (depth = 6)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_deleteLeading (depth = 6)
  gc_frame_newslot(*var_deleteLeading);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_deleteLeading;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call919 = callmethodflags(self, "getTokenStart()includeLeadingSpace", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe918);
// compiled call node returning call919 (depth = 5)
  *var_startPos = call919;
  if (call919 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 169
  setline(169);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe920 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_start (depth = 6)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_deleteTrailing (depth = 6)
  gc_frame_newslot(*var_deleteTrailing);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_deleteTrailing;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call921 = callmethodflags(self, "getTokenEnd()includeTrailingSpace", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe920);
// compiled call node returning call921 (depth = 5)
  *var_endPos = call921;
  if (call921 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 170
  setline(170);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe922 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_start (depth = 7)
  partcv[0] = 0;
  Object call923 = callmethod(*var_start, "next",
    1, partcv, params);
  gc_frame_end(callframe922);
// compiled call node returning call923 (depth = 6)
// compiled member node returning call923 (depth = 5)
  *var_tok = call923;
  if (call923 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 4)
// Begin line 171
  setline(171);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe924 = gc_frame_new();
// starting to compile block node (depth = 5)
  Object block925 = alloc_Block(NULL, NULL, "errormessages", 171);
  gc_frame_newslot(block925);
// method "_apply"
  block_savedest(block925);
  Object closure926 = createclosure(3, "_apply");
  setclosureframe(closure926, stackframe);
  addtoclosure(closure926, var_end);
  addtoclosure(closure926, var_tok);
  addtoclosure(closure926, selfslot);
  struct UserObject *uo926 = (struct UserObject*)block925;
  uo926->data[0] = (Object)closure926;
  Method *meth_meth_errormessages__apply926 = addmethod2pos(block925, "_apply", &meth_errormessages__apply926, 0);
  int argcv_meth_errormessages__apply926[] = {0};
  meth_meth_errormessages__apply926->type = alloc_MethodType(1, argcv_meth_errormessages__apply926);
  meth_meth_errormessages__apply926->definitionModule = modulename;
  meth_meth_errormessages__apply926->definitionLine = 170;
// compiled block node returning block925 (depth = 5)
  gc_frame_newslot(block925);
// starting to compile block node (depth = 5)
  Object block931 = alloc_Block(NULL, NULL, "errormessages", 171);
  gc_frame_newslot(block931);
// method "_apply"
  block_savedest(block931);
  Object closure932 = createclosure(7, "_apply");
  setclosureframe(closure932, stackframe);
  addtoclosure(closure932, var_line);
  addtoclosure(closure932, var_tok);
  addtoclosure(closure932, var_startPos);
  addtoclosure(closure932, var_endPos);
  addtoclosure(closure932, var_deleteLeading);
  addtoclosure(closure932, var_deleteTrailing);
  addtoclosure(closure932, selfslot);
  struct UserObject *uo932 = (struct UserObject*)block931;
  uo932->data[0] = (Object)closure932;
  Method *meth_meth_errormessages__apply932 = addmethod2pos(block931, "_apply", &meth_errormessages__apply932, 0);
  int argcv_meth_errormessages__apply932[] = {0};
  meth_meth_errormessages__apply932->type = alloc_MethodType(1, argcv_meth_errormessages__apply932);
  meth_meth_errormessages__apply932->definitionModule = modulename;
  meth_meth_errormessages__apply932->definitionLine = 170;
// compiled block node returning block931 (depth = 5)
  gc_frame_newslot(block931);
// call case 5: prelude request
  params[0] = block925;
  params[1] = block931;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call954 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe924);
// compiled call node returning call954 (depth = 4)
// Begin line 180
  setline(180);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_line (depth = 6)
  int op_slot_right_956 = gc_frame_newslot(*var_line);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe958 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_end (depth = 8)
  partcv[0] = 0;
  Object call959 = callmethod(*var_end, "line",
    1, partcv, params);
  gc_frame_end(callframe958);
// compiled call node returning call959 (depth = 7)
// compiled member node returning call959 (depth = 6)
  int op_slot_left_956 = gc_frame_newslot(call959);
  params[0] = *var_line;
  partcv[0] = 1;
  Object opresult960 = callmethod(call959, "≠", 1, partcv, params);
// compiled op node returning opresult960 (depth = 5)
  Object if955 = done;
  if (istrue(opresult960)) {
// Begin line 181
  setline(181);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe961 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_startPos (depth = 6)
  gc_frame_newslot(*var_startPos);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_endPos (depth = 6)
  gc_frame_newslot(*var_endPos);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_line (depth = 6)
  gc_frame_newslot(*var_line);
// call case 4: self request
  params[0] = *var_startPos;
  params[1] = *var_endPos;
  params[2] = *var_line;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call962 = callmethodflags(self, "deleteRange()onLine", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe961);
// compiled call node returning call962 (depth = 5)
    gc_frame_newslot(call962);
    if955 = call962;
  } else {
  }
// compiled if node returning if955 (depth = 4)
// Begin line 183
  setline(183);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe963 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_end (depth = 6)
  gc_frame_newslot(*var_end);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_deleteTrailing (depth = 6)
  gc_frame_newslot(*var_deleteTrailing);
// call case 4: self request
  params[0] = *var_end;
  params[1] = *var_deleteTrailing;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call964 = callmethodflags(self, "getTokenEnd()includeTrailingSpace", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe963);
// compiled call node returning call964 (depth = 5)
  *var_endPos = call964;
  if (call964 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 4)
// Begin line 184
  setline(184);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe966 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_startPos (depth = 5)
  gc_frame_newslot(*var_startPos);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_endPos (depth = 5)
  gc_frame_newslot(*var_endPos);
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe967 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_end (depth = 7)
  partcv[0] = 0;
  Object call968 = callmethod(*var_end, "line",
    1, partcv, params);
  gc_frame_end(callframe967);
// compiled call node returning call968 (depth = 6)
// compiled member node returning call968 (depth = 5)
  gc_frame_newslot(call968);
// call case 4: self request
  params[0] = *var_startPos;
  params[1] = *var_endPos;
  params[2] = call968;
  partcv[0] = 2;
  partcv[1] = 1;
  Object call969 = callmethodflags(self, "deleteRange()onLine", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe966);
// compiled call node returning call969 (depth = 4)
    gc_frame_newslot(call969);
    if910 = call969;
  }
// compiled if node returning if910 (depth = 3)
  gc_frame_end(frame);
  return if910;
}
Object meth_errormessages_deleteTokenRange970(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "deleteTokenRange");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method deleteTokenRange");
  Object params[4];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for deleteTokenRange (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_start = &(stackframe->slots[0]);
  *var_start = args[curarg];
  curarg++;
  Object *var_end = &(stackframe->slots[1]);
  *var_end = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for deleteTokenRange");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 189
  setline(189);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe971 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_start (depth = 4)
  gc_frame_newslot(*var_start);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_end (depth = 4)
  gc_frame_newslot(*var_end);
// starting to compile identifier node (depth = 4)
  Object bool972 = alloc_Boolean(0);
// compiled identifier node returning bool972 (depth = 4)
  gc_frame_newslot(bool972);
// starting to compile identifier node (depth = 4)
  Object bool973 = alloc_Boolean(0);
// compiled identifier node returning bool973 (depth = 4)
  gc_frame_newslot(bool973);
// call case 4: self request
  params[0] = *var_start;
  params[1] = *var_end;
  params[2] = bool972;
  params[3] = bool973;
  partcv[0] = 2;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call974 = callmethodflags(self, "deleteTokenRange()leading()trailing", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe971);
// compiled call node returning call974 (depth = 3)
  gc_frame_end(frame);
  return call974;
}
Object meth_errormessages_deleteLine975(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "deleteLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method deleteLine");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for deleteLine (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_lineNumber = &(stackframe->slots[0]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for deleteLine");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 193
  setline(193);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe976 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lineNumber (depth = 4)
  gc_frame_newslot(*var_lineNumber);
// starting to compile string node (depth = 4)
  if (strlit977 == NULL) {
    strlit977 = alloc_String("");
    gc_root(strlit977);
  }
// compiled string node returning strlit977 (depth = 4)
  gc_frame_newslot(strlit977);
// call case 4: self request
  params[0] = *var_lineNumber;
  params[1] = strlit977;
  partcv[0] = 2;
  Object call978 = callmethodflags(self, "addLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe976);
// compiled call node returning call978 (depth = 3)
  gc_frame_end(frame);
  return call978;
}
Object meth_errormessages_insert_40__41_afterToken_40__41_andTrailingSpace979(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(5, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "insert()afterToken()andTrailingSpace");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert()afterToken()andTrailingSpace");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert()afterToken()andTrailingSpace");
  if (nparts > 0 && argcv[2] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert()afterToken()andTrailingSpace");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 3 && args)
    graceRaise(RequestError(), "missing argument list for insert()afterToken()andTrailingSpace (probably reflection error): got %i lists, expected 3.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for insert");
  Object *var_token = &(stackframe->slots[1]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for afterToken");
  Object *var_afterTrailing = &(stackframe->slots[2]);
  *var_afterTrailing = args[curarg];
  curarg++;
  if (argcv && argcv[2] != 1)
    graceRaise(RequestError(), "wrong number of arguments for andTrailingSpace");
  Object *selfslot = &(stackframe->slots[3]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_pos = &(stackframe->slots[4]);
  setframeelementname(stackframe, 4, "pos");
// Begin line 197
  setline(197);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile num node (depth = 5)
  Object num981 = alloc_Float64(1);
// compiled num node returning num981 (depth = 5)
  int op_slot_right_980 = gc_frame_newslot(num981);
// starting to compile call node (depth = 5)
  int callframe983 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_token (depth = 6)
  gc_frame_newslot(*var_token);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_afterTrailing (depth = 6)
  gc_frame_newslot(*var_afterTrailing);
// call case 4: self request
  params[0] = *var_token;
  params[1] = *var_afterTrailing;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call984 = callmethodflags(self, "getTokenEnd()includeTrailingSpace", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe983);
// compiled call node returning call984 (depth = 5)
  int op_slot_left_980 = gc_frame_newslot(call984);
  params[0] = num981;
  partcv[0] = 1;
  Object sum985 = callmethod(call984, "+", 1, partcv, params);
// compiled op node returning sum985 (depth = 4)
  *var_pos = sum985;
  if (sum985 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 198
  setline(198);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe986 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_pos (depth = 4)
  gc_frame_newslot(*var_pos);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe987 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_token (depth = 6)
  partcv[0] = 0;
  Object call988 = callmethod(*var_token, "line",
    1, partcv, params);
  gc_frame_end(callframe987);
// compiled call node returning call988 (depth = 5)
// compiled member node returning call988 (depth = 4)
  gc_frame_newslot(call988);
// call case 4: self request
  params[0] = *var_s;
  params[1] = *var_pos;
  params[2] = call988;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call989 = callmethodflags(self, "insert()atPosition()onLine", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe986);
// compiled call node returning call989 (depth = 3)
  gc_frame_end(frame);
  return call989;
}
Object meth_errormessages_insert_40__41_afterToken990(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "insert()afterToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert()afterToken");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert()afterToken");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for insert()afterToken (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for insert");
  Object *var_token = &(stackframe->slots[1]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for afterToken");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 202
  setline(202);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe991 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_token (depth = 4)
  gc_frame_newslot(*var_token);
// starting to compile identifier node (depth = 4)
  Object bool992 = alloc_Boolean(0);
// compiled identifier node returning bool992 (depth = 4)
  gc_frame_newslot(bool992);
// call case 4: self request
  params[0] = *var_s;
  params[1] = *var_token;
  params[2] = bool992;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call993 = callmethodflags(self, "insert()afterToken()andTrailingSpace", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe991);
// compiled call node returning call993 (depth = 3)
  gc_frame_end(frame);
  return call993;
}
Object meth_errormessages_insert_40__41_beforeToken994(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "insert()beforeToken");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert()beforeToken");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insert()beforeToken");
  Object params[3];
  int partcv[3];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for insert()beforeToken (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_s = &(stackframe->slots[0]);
  *var_s = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for insert");
  Object *var_token = &(stackframe->slots[1]);
  *var_token = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for beforeToken");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 206
  setline(206);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe995 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_s (depth = 4)
  gc_frame_newslot(*var_s);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe996 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_token (depth = 6)
  partcv[0] = 0;
  Object call997 = callmethod(*var_token, "linePos",
    1, partcv, params);
  gc_frame_end(callframe996);
// compiled call node returning call997 (depth = 5)
// compiled member node returning call997 (depth = 4)
  gc_frame_newslot(call997);
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe998 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_token (depth = 6)
  partcv[0] = 0;
  Object call999 = callmethod(*var_token, "line",
    1, partcv, params);
  gc_frame_end(callframe998);
// compiled call node returning call999 (depth = 5)
// compiled member node returning call999 (depth = 4)
  gc_frame_newslot(call999);
// call case 4: self request
  params[0] = *var_s;
  params[1] = call997;
  params[2] = call999;
  partcv[0] = 1;
  partcv[1] = 1;
  partcv[2] = 1;
  Object call1000 = callmethodflags(self, "insert()atPosition()onLine", 3, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe995);
// compiled call node returning call1000 (depth = 3)
  gc_frame_end(frame);
  return call1000;
}
Object meth_errormessages_insertNewLine_40__41_after1001(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(3, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "insertNewLine()after");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insertNewLine()after");
  if (nparts > 0 && argcv[1] < 1)
    graceRaise(RequestError(), "insufficient arguments to method insertNewLine()after");
  Object params[2];
  int partcv[1];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 2 && args)
    graceRaise(RequestError(), "missing argument list for insertNewLine()after (probably reflection error): got %i lists, expected 2.", nparts);
  Object *var_line = &(stackframe->slots[0]);
  *var_line = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for insertNewLine");
  Object *var_lineNumber = &(stackframe->slots[1]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[1] != 1)
    graceRaise(RequestError(), "wrong number of arguments for after");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 211
  setline(211);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1002 = gc_frame_new();
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_lineNumber (depth = 4)
  gc_frame_newslot(*var_lineNumber);
// starting to compile identifier node (depth = 4)
// compiled identifier node returning *var_line (depth = 4)
  gc_frame_newslot(*var_line);
// call case 4: self request
  params[0] = *var_lineNumber;
  params[1] = *var_line;
  partcv[0] = 2;
  Object call1003 = callmethodflags(self, "addLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1002);
// compiled call node returning call1003 (depth = 3)
  gc_frame_end(frame);
  return call1003;
}
Object meth_errormessages__apply1043(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_lineNumber = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1045 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num1047 = alloc_Float64(1);
// compiled num node returning num1047 (depth = 12)
  int op_slot_right_1046 = gc_frame_newslot(num1047);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  int op_slot_left_1046 = gc_frame_newslot(*var_i);
  params[0] = num1047;
  partcv[0] = 1;
  Object diff1049 = callmethod(*var_i, "-", 1, partcv, params);
// compiled op node returning diff1049 (depth = 11)
  gc_frame_newslot(diff1049);
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1050 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1051 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1050);
// compiled call node returning call1051 (depth = 12)
// compiled member node returning call1051 (depth = 11)
  params[0] = diff1049;
  partcv[0] = 1;
  Object call1052 = callmethod(call1051, "at",
    1, partcv, params);
  gc_frame_end(callframe1045);
// compiled call node returning call1052 (depth = 10)
  int op_slot_right_1044 = gc_frame_newslot(call1052);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_lineNumber (depth = 10)
  int op_slot_left_1044 = gc_frame_newslot(*var_lineNumber);
  params[0] = call1052;
  partcv[0] = 1;
  Object opresult1054 = callmethod(*var_lineNumber, "<", 1, partcv, params);
// compiled op node returning opresult1054 (depth = 9)
  gc_frame_end(frame);
  return opresult1054;
}
Object meth_errormessages__apply1040(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object *var_lineNumber = getfromclosure(closure, 1);
  Object self = *(getfromclosure(closure, 2));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 7)
// starting to compile block node (depth = 8)
  Object block1042 = alloc_Block(NULL, NULL, "errormessages", 227);
  gc_frame_newslot(block1042);
// method "_apply"
  block_savedest(block1042);
  Object closure1043 = createclosure(3, "_apply");
  setclosureframe(closure1043, stackframe);
  addtoclosure(closure1043, var_i);
  addtoclosure(closure1043, var_lineNumber);
  addtoclosure(closure1043, selfslot);
  struct UserObject *uo1043 = (struct UserObject*)block1042;
  uo1043->data[0] = (Object)closure1043;
  Method *meth_meth_errormessages__apply1043 = addmethod2pos(block1042, "_apply", &meth_errormessages__apply1043, 0);
  int argcv_meth_errormessages__apply1043[] = {0};
  meth_meth_errormessages__apply1043->type = alloc_MethodType(1, argcv_meth_errormessages__apply1043);
  meth_meth_errormessages__apply1043->definitionModule = modulename;
  meth_meth_errormessages__apply1043->definitionLine = 226;
// compiled block node returning block1042 (depth = 8)
  int op_slot_right_1041 = gc_frame_newslot(block1042);
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1058 = alloc_Float64(1);
// compiled num node returning num1058 (depth = 9)
  int op_slot_right_1057 = gc_frame_newslot(num1058);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_left_1057 = gc_frame_newslot(*var_i);
  params[0] = num1058;
  partcv[0] = 1;
  Object opresult1060 = callmethod(*var_i, ">", 1, partcv, params);
// compiled op node returning opresult1060 (depth = 8)
  int op_slot_left_1041 = gc_frame_newslot(opresult1060);
  params[0] = block1042;
  partcv[0] = 1;
  Object opresult1061 = callmethod(opresult1060, "&&", 1, partcv, params);
// compiled op node returning opresult1061 (depth = 7)
  gc_frame_end(frame);
  return opresult1061;
}
Object meth_errormessages__apply1064(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_i = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 228
  setline(228);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1065 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// starting to compile call node (depth = 8)
  int callframe1066 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1068 = alloc_Float64(1);
// compiled num node returning num1068 (depth = 10)
  int op_slot_right_1067 = gc_frame_newslot(num1068);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  int op_slot_left_1067 = gc_frame_newslot(*var_i);
  params[0] = num1068;
  partcv[0] = 1;
  Object diff1070 = callmethod(*var_i, "-", 1, partcv, params);
// compiled op node returning diff1070 (depth = 9)
  gc_frame_newslot(diff1070);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1071 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1072 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1071);
// compiled call node returning call1072 (depth = 10)
// compiled member node returning call1072 (depth = 9)
  params[0] = diff1070;
  partcv[0] = 1;
  Object call1073 = callmethod(call1072, "at",
    1, partcv, params);
  gc_frame_end(callframe1066);
// compiled call node returning call1073 (depth = 8)
  gc_frame_newslot(call1073);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1074 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1075 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1074);
// compiled call node returning call1075 (depth = 9)
// compiled member node returning call1075 (depth = 8)
  params[0] = *var_i;
  params[1] = call1073;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1076 = callmethod(call1075, "at()put",
    2, partcv, params);
  gc_frame_end(callframe1065);
// compiled call node returning call1076 (depth = 7)
// Begin line 229
  setline(229);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 7)
  int callframe1077 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// starting to compile call node (depth = 8)
  int callframe1078 = gc_frame_new();
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1080 = alloc_Float64(1);
// compiled num node returning num1080 (depth = 10)
  int op_slot_right_1079 = gc_frame_newslot(num1080);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  int op_slot_left_1079 = gc_frame_newslot(*var_i);
  params[0] = num1080;
  partcv[0] = 1;
  Object diff1082 = callmethod(*var_i, "-", 1, partcv, params);
// compiled op node returning diff1082 (depth = 9)
  gc_frame_newslot(diff1082);
// call case 6: other member request
// starting to compile member node (depth = 9)
// starting to compile call node (depth = 10)
  int callframe1083 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1084 = callmethodflags(self, "lines", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1083);
// compiled call node returning call1084 (depth = 10)
// compiled member node returning call1084 (depth = 9)
  params[0] = diff1082;
  partcv[0] = 1;
  Object call1085 = callmethod(call1084, "at",
    1, partcv, params);
  gc_frame_end(callframe1078);
// compiled call node returning call1085 (depth = 8)
  gc_frame_newslot(call1085);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1086 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1087 = callmethodflags(self, "lines", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1086);
// compiled call node returning call1087 (depth = 9)
// compiled member node returning call1087 (depth = 8)
  params[0] = *var_i;
  params[1] = call1085;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1088 = callmethod(call1087, "at()put",
    2, partcv, params);
  gc_frame_end(callframe1077);
// compiled call node returning call1088 (depth = 7)
// Begin line 230
  setline(230);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 7)
// starting to compile op node (depth = 8)
// starting to compile num node (depth = 9)
  Object num1090 = alloc_Float64(1);
// compiled num node returning num1090 (depth = 9)
  int op_slot_right_1089 = gc_frame_newslot(num1090);
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_i (depth = 9)
  int op_slot_left_1089 = gc_frame_newslot(*var_i);
  params[0] = num1090;
  partcv[0] = 1;
  Object diff1092 = callmethod(*var_i, "-", 1, partcv, params);
// compiled op node returning diff1092 (depth = 8)
  *var_i = diff1092;
  if (diff1092 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 7)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages_addLine1004(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(4, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "addLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 2)
    graceRaise(RequestError(), "insufficient arguments to method addLine");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for addLine (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_lineNumber = &(stackframe->slots[0]);
  *var_lineNumber = args[curarg];
  curarg++;
  Object *var_line = &(stackframe->slots[1]);
  *var_line = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 2)
    graceRaise(RequestError(), "wrong number of arguments for addLine");
  Object *selfslot = &(stackframe->slots[2]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_i = &(stackframe->slots[3]);
  setframeelementname(stackframe, 3, "i");
// Begin line 217
  setline(217);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1005 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call1006 = callmethodflags(self, "findLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1005);
// compiled call node returning call1006 (depth = 4)
  *var_i = call1006;
  if (call1006 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 3)
// Begin line 218
  setline(218);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool1009 = alloc_Boolean(0);
// compiled identifier node returning bool1009 (depth = 5)
  int op_slot_right_1008 = gc_frame_newslot(bool1009);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  int op_slot_left_1008 = gc_frame_newslot(*var_i);
  params[0] = bool1009;
  partcv[0] = 1;
  Object opresult1011 = callmethod(*var_i, "≠", 1, partcv, params);
// compiled op node returning opresult1011 (depth = 4)
  Object if1007 = done;
  if (istrue(opresult1011)) {
// Begin line 219
  setline(219);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1012 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_line (depth = 5)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1013 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1014 = callmethodflags(self, "lines", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1013);
// compiled call node returning call1014 (depth = 6)
// compiled member node returning call1014 (depth = 5)
  params[0] = *var_i;
  params[1] = *var_line;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1015 = callmethod(call1014, "at()put",
    2, partcv, params);
  gc_frame_end(callframe1012);
// compiled call node returning call1015 (depth = 4)
    gc_frame_newslot(call1015);
    if1007 = call1015;
  } else {
// Begin line 222
  setline(222);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1016 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1017 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1018 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1017);
// compiled call node returning call1018 (depth = 6)
// compiled member node returning call1018 (depth = 5)
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call1019 = callmethod(call1018, "push",
    1, partcv, params);
  gc_frame_end(callframe1016);
// compiled call node returning call1019 (depth = 4)
// Begin line 223
  setline(223);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1020 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_line (depth = 5)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1021 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1022 = callmethodflags(self, "lines", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1021);
// compiled call node returning call1022 (depth = 6)
// compiled member node returning call1022 (depth = 5)
  params[0] = *var_line;
  partcv[0] = 1;
  Object call1023 = callmethod(call1022, "push",
    1, partcv, params);
  gc_frame_end(callframe1020);
// compiled call node returning call1023 (depth = 4)
// Begin line 224
  setline(224);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 4)
// starting to compile op node (depth = 5)
// starting to compile num node (depth = 6)
  Object num1026 = alloc_Float64(1);
// compiled num node returning num1026 (depth = 6)
  int op_slot_right_1025 = gc_frame_newslot(num1026);
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1028 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1029 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1030 = callmethodflags(self, "lines", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1029);
// compiled call node returning call1030 (depth = 9)
// compiled member node returning call1030 (depth = 8)
  partcv[0] = 0;
  Object call1031 = callmethod(call1030, "size",
    1, partcv, params);
  gc_frame_end(callframe1028);
// compiled call node returning call1031 (depth = 7)
// compiled member node returning call1031 (depth = 6)
  int op_slot_left_1025 = gc_frame_newslot(call1031);
  params[0] = num1026;
  partcv[0] = 1;
  Object opresult1032 = callmethod(call1031, ">", 1, partcv, params);
// compiled op node returning opresult1032 (depth = 5)
  Object if1024 = done;
  if (istrue(opresult1032)) {
// Begin line 226
  setline(226);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile bind node (depth = 5)
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1033 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1034 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1035 = callmethodflags(self, "lines", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1034);
// compiled call node returning call1035 (depth = 9)
// compiled member node returning call1035 (depth = 8)
  partcv[0] = 0;
  Object call1036 = callmethod(call1035, "size",
    1, partcv, params);
  gc_frame_end(callframe1033);
// compiled call node returning call1036 (depth = 7)
// compiled member node returning call1036 (depth = 6)
  *var_i = call1036;
  if (call1036 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 5)
// Begin line 227
  setline(227);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1038 = gc_frame_new();
// starting to compile block node (depth = 6)
  Object block1039 = alloc_Block(NULL, NULL, "errormessages", 227);
  gc_frame_newslot(block1039);
// method "_apply"
  block_savedest(block1039);
  Object closure1040 = createclosure(3, "_apply");
  setclosureframe(closure1040, stackframe);
  addtoclosure(closure1040, var_i);
  addtoclosure(closure1040, var_lineNumber);
  addtoclosure(closure1040, selfslot);
  struct UserObject *uo1040 = (struct UserObject*)block1039;
  uo1040->data[0] = (Object)closure1040;
  Method *meth_meth_errormessages__apply1040 = addmethod2pos(block1039, "_apply", &meth_errormessages__apply1040, 0);
  int argcv_meth_errormessages__apply1040[] = {0};
  meth_meth_errormessages__apply1040->type = alloc_MethodType(1, argcv_meth_errormessages__apply1040);
  meth_meth_errormessages__apply1040->definitionModule = modulename;
  meth_meth_errormessages__apply1040->definitionLine = 226;
// compiled block node returning block1039 (depth = 6)
  gc_frame_newslot(block1039);
// starting to compile block node (depth = 6)
  Object block1063 = alloc_Block(NULL, NULL, "errormessages", 227);
  gc_frame_newslot(block1063);
// method "_apply"
  block_savedest(block1063);
  Object closure1064 = createclosure(2, "_apply");
  setclosureframe(closure1064, stackframe);
  addtoclosure(closure1064, var_i);
  addtoclosure(closure1064, selfslot);
  struct UserObject *uo1064 = (struct UserObject*)block1063;
  uo1064->data[0] = (Object)closure1064;
  Method *meth_meth_errormessages__apply1064 = addmethod2pos(block1063, "_apply", &meth_errormessages__apply1064, 0);
  int argcv_meth_errormessages__apply1064[] = {0};
  meth_meth_errormessages__apply1064->type = alloc_MethodType(1, argcv_meth_errormessages__apply1064);
  meth_meth_errormessages__apply1064->definitionModule = modulename;
  meth_meth_errormessages__apply1064->definitionLine = 227;
// compiled block node returning block1063 (depth = 6)
  gc_frame_newslot(block1063);
// call case 5: prelude request
  params[0] = block1039;
  params[1] = block1063;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1095 = callmethodflags(prelude, "while()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1038);
// compiled call node returning call1095 (depth = 5)
// Begin line 232
  setline(232);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1096 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_lineNumber (depth = 6)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1097 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1098 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1097);
// compiled call node returning call1098 (depth = 7)
// compiled member node returning call1098 (depth = 6)
  params[0] = *var_i;
  params[1] = *var_lineNumber;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1099 = callmethod(call1098, "at()put",
    2, partcv, params);
  gc_frame_end(callframe1096);
// compiled call node returning call1099 (depth = 5)
// Begin line 233
  setline(233);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 5)
  int callframe1100 = gc_frame_new();
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_i (depth = 6)
  gc_frame_newslot(*var_i);
// starting to compile identifier node (depth = 6)
// compiled identifier node returning *var_line (depth = 6)
  gc_frame_newslot(*var_line);
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1101 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1102 = callmethodflags(self, "lines", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1101);
// compiled call node returning call1102 (depth = 7)
// compiled member node returning call1102 (depth = 6)
  params[0] = *var_i;
  params[1] = *var_line;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1103 = callmethod(call1102, "at()put",
    2, partcv, params);
  gc_frame_end(callframe1100);
// compiled call node returning call1103 (depth = 5)
    gc_frame_newslot(call1103);
    if1024 = call1103;
  } else {
  }
// compiled if node returning if1024 (depth = 4)
    gc_frame_newslot(if1024);
    if1007 = if1024;
  }
// compiled if node returning if1007 (depth = 3)
  gc_frame_end(frame);
  return if1007;
}
Object meth_errormessages__apply1111(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(2, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[1];
  int partcv[1];
  Object *var_lineNumber = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 242
  setline(242);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_lineNumber (depth = 7)
  int op_slot_right_1113 = gc_frame_newslot(*var_lineNumber);
// starting to compile call node (depth = 7)
  int callframe1115 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1116 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1117 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1116);
// compiled call node returning call1117 (depth = 9)
// compiled member node returning call1117 (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1118 = callmethod(call1117, "at",
    1, partcv, params);
  gc_frame_end(callframe1115);
// compiled call node returning call1118 (depth = 7)
  int op_slot_left_1113 = gc_frame_newslot(call1118);
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object opresult1119 = callmethod(call1118, "==", 1, partcv, params);
// compiled op node returning opresult1119 (depth = 6)
  Object if1112 = done;
  if (istrue(opresult1119)) {
// Begin line 243
  setline(243);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile return node (depth = 6)
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_i (depth = 7)
  block_return(realself, *var_i);
// compiled return node returning undefined (depth = 6)
    gc_frame_newslot(undefined);
    if1112 = undefined;
  } else {
  }
// compiled if node returning if1112 (depth = 5)
  gc_frame_end(frame);
  return if1112;
}
Object meth_errormessages_findLine1104(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct StackFrameObject *stackframe = alloc_StackFrame(2, NULL);
  pushclosure(NULL);
  pushstackframe(stackframe, "findLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method findLine");
  Object params[2];
  int partcv[2];
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for findLine (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_lineNumber = &(stackframe->slots[0]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for findLine");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 241
  setline(241);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1105 = gc_frame_new();
// starting to compile member node (depth = 4)
// starting to compile call node (depth = 5)
  int callframe1106 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1107 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1108 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1107);
// compiled call node returning call1108 (depth = 7)
// compiled member node returning call1108 (depth = 6)
  partcv[0] = 0;
  Object call1109 = callmethod(call1108, "indices",
    1, partcv, params);
  gc_frame_end(callframe1106);
// compiled call node returning call1109 (depth = 5)
// compiled member node returning call1109 (depth = 4)
  gc_frame_newslot(call1109);
// starting to compile block node (depth = 4)
  Object block1110 = alloc_Block(NULL, NULL, "errormessages", 241);
  gc_frame_newslot(block1110);
// method "_apply"
  block_savedest(block1110);
  Object closure1111 = createclosure(2, "_apply");
  setclosureframe(closure1111, stackframe);
  addtoclosure(closure1111, var_lineNumber);
  addtoclosure(closure1111, selfslot);
  struct UserObject *uo1111 = (struct UserObject*)block1110;
  uo1111->data[0] = (Object)closure1111;
  Method *meth_meth_errormessages__apply1111 = addmethod2pos(block1110, "_apply", &meth_errormessages__apply1111, 0);
  int argcv_meth_errormessages__apply1111[] = {1};
  meth_meth_errormessages__apply1111->type = alloc_MethodType(1, argcv_meth_errormessages__apply1111);
  meth_meth_errormessages__apply1111->definitionModule = modulename;
  meth_meth_errormessages__apply1111->definitionLine = 241;
// compiled block node returning block1110 (depth = 4)
  gc_frame_newslot(block1110);
// call case 5: prelude request
  params[0] = call1109;
  params[1] = block1110;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1121 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1105);
// compiled call node returning call1121 (depth = 3)
// Begin line 246
  setline(246);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
  Object bool1122 = alloc_Boolean(0);
// compiled identifier node returning bool1122 (depth = 3)
  gc_frame_end(frame);
  return bool1122;
}
Object meth_errormessages_getLine1123(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 27, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "getLine");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method getLine");
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for getLine (probably reflection error): got %i lists, expected 1.", nparts);
  Object *var_lineNumber = &(stackframe->slots[0]);
  *var_lineNumber = args[curarg];
  curarg++;
  if (argcv && argcv[0] != 1)
    graceRaise(RequestError(), "wrong number of arguments for getLine");
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_i = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "i");
// Begin line 252
  setline(252);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 3)
// starting to compile call node (depth = 4)
  int callframe1124 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 4: self request
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call1125 = callmethodflags(self, "findLine", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1124);
// compiled call node returning call1125 (depth = 4)
  *var_i = call1125;
  if (call1125 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled defdec node returning done (depth = 3)
// Begin line 253
  setline(253);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 3)
// starting to compile op node (depth = 4)
// starting to compile identifier node (depth = 5)
  Object bool1128 = alloc_Boolean(0);
// compiled identifier node returning bool1128 (depth = 5)
  int op_slot_right_1127 = gc_frame_newslot(bool1128);
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  int op_slot_left_1127 = gc_frame_newslot(*var_i);
  params[0] = bool1128;
  partcv[0] = 1;
  Object opresult1130 = callmethod(*var_i, "==", 1, partcv, params);
// compiled op node returning opresult1130 (depth = 4)
  Object if1126 = done;
  if (istrue(opresult1130)) {
// Begin line 254
  setline(254);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1131 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_lineNumber (depth = 5)
  gc_frame_newslot(*var_lineNumber);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1132 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 7)
// compiled identifier node returning *var_util (depth = 7)
  partcv[0] = 0;
  Object call1133 = callmethod(*var_util, "lines",
    1, partcv, params);
  gc_frame_end(callframe1132);
// compiled call node returning call1133 (depth = 6)
// compiled member node returning call1133 (depth = 5)
  params[0] = *var_lineNumber;
  partcv[0] = 1;
  Object call1134 = callmethod(call1133, "at",
    1, partcv, params);
  gc_frame_end(callframe1131);
// compiled call node returning call1134 (depth = 4)
    gc_frame_newslot(call1134);
    if1126 = call1134;
  } else {
// Begin line 256
  setline(256);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 4)
  int callframe1135 = gc_frame_new();
// starting to compile identifier node (depth = 5)
// compiled identifier node returning *var_i (depth = 5)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1136 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1137 = callmethodflags(self, "lines", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1136);
// compiled call node returning call1137 (depth = 6)
// compiled member node returning call1137 (depth = 5)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1138 = callmethod(call1137, "at",
    1, partcv, params);
  gc_frame_end(callframe1135);
// compiled call node returning call1138 (depth = 4)
    gc_frame_newslot(call1138);
    if1126 = call1138;
  }
// compiled if node returning if1126 (depth = 3)
  gc_frame_end(frame);
  return if1126;
}
Object meth_errormessages__apply1154(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_i = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile op node (depth = 8)
// starting to compile op node (depth = 9)
// starting to compile num node (depth = 10)
  Object num1157 = alloc_Float64(1);
// compiled num node returning num1157 (depth = 10)
  int op_slot_right_1156 = gc_frame_newslot(num1157);
// starting to compile call node (depth = 10)
  int callframe1159 = gc_frame_new();
// starting to compile op node (depth = 11)
// starting to compile num node (depth = 12)
  Object num1161 = alloc_Float64(1);
// compiled num node returning num1161 (depth = 12)
  int op_slot_right_1160 = gc_frame_newslot(num1161);
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  int op_slot_left_1160 = gc_frame_newslot(*var_i);
  params[0] = num1161;
  partcv[0] = 1;
  Object diff1163 = callmethod(*var_i, "-", 1, partcv, params);
// compiled op node returning diff1163 (depth = 11)
  gc_frame_newslot(diff1163);
// call case 6: other member request
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1164 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1165 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1164);
// compiled call node returning call1165 (depth = 12)
// compiled member node returning call1165 (depth = 11)
  params[0] = diff1163;
  partcv[0] = 1;
  Object call1166 = callmethod(call1165, "at",
    1, partcv, params);
  gc_frame_end(callframe1159);
// compiled call node returning call1166 (depth = 10)
  int op_slot_left_1156 = gc_frame_newslot(call1166);
  params[0] = num1157;
  partcv[0] = 1;
  Object sum1167 = callmethod(call1166, "+", 1, partcv, params);
// compiled op node returning sum1167 (depth = 9)
  int op_slot_right_1155 = gc_frame_newslot(sum1167);
// starting to compile call node (depth = 9)
  int callframe1169 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1170 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1171 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1170);
// compiled call node returning call1171 (depth = 11)
// compiled member node returning call1171 (depth = 10)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1172 = callmethod(call1171, "at",
    1, partcv, params);
  gc_frame_end(callframe1169);
// compiled call node returning call1172 (depth = 9)
  int op_slot_left_1155 = gc_frame_newslot(call1172);
  params[0] = sum1167;
  partcv[0] = 1;
  Object opresult1173 = callmethod(call1172, ">", 1, partcv, params);
// compiled op node returning opresult1173 (depth = 8)
  gc_frame_end(frame);
  return opresult1173;
}
Object meth_errormessages__apply1200(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_s = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// starting to compile bind node (depth = 8)
// Begin line 265
  setline(265);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1202 == NULL) {
    strlit1202 = alloc_String(" ");
    gc_root(strlit1202);
  }
// compiled string node returning strlit1202 (depth = 10)
  int op_slot_right_1201 = gc_frame_newslot(strlit1202);
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_s (depth = 10)
  int op_slot_left_1201 = gc_frame_newslot(*var_s);
  params[0] = strlit1202;
  partcv[0] = 1;
  Object opresult1204 = callmethod(*var_s, "++", 1, partcv, params);
// compiled op node returning opresult1204 (depth = 9)
  *var_s = opresult1204;
  if (opresult1204 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled bind node returning done (depth = 8)
  gc_frame_end(frame);
  return done;
}
Object meth_errormessages__apply1150(Object realself, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)realself;
  Object closure = getdatum((Object)uo, 0, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(3, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "_apply");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  if (nparts > 0 && argcv[0] < 1)
    graceRaise(RequestError(), "insufficient arguments to method _apply");
  Object params[2];
  int partcv[2];
  Object *var_io = getfromclosure(closure, 0);
  Object self = *(getfromclosure(closure, 1));
  sourceObject = self;
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  Object *var_i = &(stackframe->slots[0]);
  *var_i = args[curarg];
  curarg++;
  Object *selfslot = &(stackframe->slots[1]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  Object *var_s = &(stackframe->slots[2]);
  setframeelementname(stackframe, 2, "s");
// Begin line 262
  setline(262);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile block node (depth = 7)
  Object block1153 = alloc_Block(NULL, NULL, "errormessages", 262);
  gc_frame_newslot(block1153);
// method "_apply"
  block_savedest(block1153);
  Object closure1154 = createclosure(2, "_apply");
  setclosureframe(closure1154, stackframe);
  addtoclosure(closure1154, var_i);
  addtoclosure(closure1154, selfslot);
  struct UserObject *uo1154 = (struct UserObject*)block1153;
  uo1154->data[0] = (Object)closure1154;
  Method *meth_meth_errormessages__apply1154 = addmethod2pos(block1153, "_apply", &meth_errormessages__apply1154, 0);
  int argcv_meth_errormessages__apply1154[] = {0};
  meth_meth_errormessages__apply1154->type = alloc_MethodType(1, argcv_meth_errormessages__apply1154);
  meth_meth_errormessages__apply1154->definitionModule = modulename;
  meth_meth_errormessages__apply1154->definitionLine = 261;
// compiled block node returning block1153 (depth = 7)
  int op_slot_right_1152 = gc_frame_newslot(block1153);
// starting to compile op node (depth = 7)
// starting to compile num node (depth = 8)
  Object num1177 = alloc_Float64(1);
// compiled num node returning num1177 (depth = 8)
  int op_slot_right_1176 = gc_frame_newslot(num1177);
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  int op_slot_left_1176 = gc_frame_newslot(*var_i);
  params[0] = num1177;
  partcv[0] = 1;
  Object opresult1179 = callmethod(*var_i, ">", 1, partcv, params);
// compiled op node returning opresult1179 (depth = 7)
  int op_slot_left_1152 = gc_frame_newslot(opresult1179);
  params[0] = block1153;
  partcv[0] = 1;
  Object opresult1180 = callmethod(opresult1179, "&&", 1, partcv, params);
// compiled op node returning opresult1180 (depth = 6)
  Object if1151 = done;
  if (istrue(opresult1180)) {
// Begin line 263
  setline(263);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile vardec node (depth = 6)
// starting to compile string node (depth = 7)
  if (strlit1181 == NULL) {
    strlit1181 = alloc_String("");
    gc_root(strlit1181);
  }
// compiled string node returning strlit1181 (depth = 7)
  *var_s = strlit1181;
  if (strlit1181 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// compiled vardec node returning done (depth = 6)
// Begin line 264
  setline(264);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1182 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1184 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1185 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 12)
  int callframe1186 = gc_frame_new();
// starting to compile op node (depth = 13)
// starting to compile num node (depth = 14)
  Object num1188 = alloc_Float64(1);
// compiled num node returning num1188 (depth = 14)
  int op_slot_right_1187 = gc_frame_newslot(num1188);
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_i (depth = 14)
  int op_slot_left_1187 = gc_frame_newslot(*var_i);
  params[0] = num1188;
  partcv[0] = 1;
  Object diff1190 = callmethod(*var_i, "-", 1, partcv, params);
// compiled op node returning diff1190 (depth = 13)
  gc_frame_newslot(diff1190);
// call case 6: other member request
// starting to compile member node (depth = 13)
// starting to compile call node (depth = 14)
  int callframe1191 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1192 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1191);
// compiled call node returning call1192 (depth = 14)
// compiled member node returning call1192 (depth = 13)
  params[0] = diff1190;
  partcv[0] = 1;
  Object call1193 = callmethod(call1192, "at",
    1, partcv, params);
  gc_frame_end(callframe1186);
// compiled call node returning call1193 (depth = 12)
  partcv[0] = 0;
  Object call1194 = callmethod(call1193, "asString",
    1, partcv, params);
  gc_frame_end(callframe1185);
// compiled call node returning call1194 (depth = 11)
// compiled member node returning call1194 (depth = 10)
  partcv[0] = 0;
  Object call1195 = callmethod(call1194, "size",
    1, partcv, params);
  gc_frame_end(callframe1184);
// compiled call node returning call1195 (depth = 9)
// compiled member node returning call1195 (depth = 8)
  int op_slot_right_1183 = gc_frame_newslot(call1195);
// starting to compile num node (depth = 8)
  Object num1197 = alloc_Float64(1);
// compiled num node returning num1197 (depth = 8)
  int op_slot_left_1183 = gc_frame_newslot(num1197);
  params[0] = call1195;
  partcv[0] = 1;
  Object opresult1198 = callmethod(num1197, "..", 1, partcv, params);
// compiled op node returning opresult1198 (depth = 7)
  gc_frame_newslot(opresult1198);
// starting to compile block node (depth = 7)
  Object block1199 = alloc_Block(NULL, NULL, "errormessages", 264);
  gc_frame_newslot(block1199);
// method "_apply"
  block_savedest(block1199);
  Object closure1200 = createclosure(2, "_apply");
  setclosureframe(closure1200, stackframe);
  addtoclosure(closure1200, var_s);
  addtoclosure(closure1200, selfslot);
  struct UserObject *uo1200 = (struct UserObject*)block1199;
  uo1200->data[0] = (Object)closure1200;
  Method *meth_meth_errormessages__apply1200 = addmethod2pos(block1199, "_apply", &meth_errormessages__apply1200, 0);
  int argcv_meth_errormessages__apply1200[] = {0};
  meth_meth_errormessages__apply1200->type = alloc_MethodType(1, argcv_meth_errormessages__apply1200);
  meth_meth_errormessages__apply1200->definitionModule = modulename;
  meth_meth_errormessages__apply1200->definitionLine = 264;
// compiled block node returning block1199 (depth = 7)
  gc_frame_newslot(block1199);
// call case 5: prelude request
  params[0] = opresult1198;
  params[1] = block1199;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1207 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1182);
// compiled call node returning call1207 (depth = 6)
// Begin line 267
  setline(267);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1208 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1210 == NULL) {
    strlit1210 = alloc_String("...""\x0a""");
    gc_root(strlit1210);
  }
// compiled string node returning strlit1210 (depth = 8)
  int op_slot_right_1209 = gc_frame_newslot(strlit1210);
// starting to compile op node (depth = 8)
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_s (depth = 9)
  int op_slot_right_1212 = gc_frame_newslot(*var_s);
// starting to compile string node (depth = 9)
  if (strlit1214 == NULL) {
    strlit1214 = alloc_String("    ");
    gc_root(strlit1214);
  }
// compiled string node returning strlit1214 (depth = 9)
  int op_slot_left_1212 = gc_frame_newslot(strlit1214);
  params[0] = *var_s;
  partcv[0] = 1;
  Object opresult1215 = callmethod(strlit1214, "++", 1, partcv, params);
// compiled op node returning opresult1215 (depth = 8)
  int op_slot_left_1209 = gc_frame_newslot(opresult1215);
  params[0] = strlit1210;
  partcv[0] = 1;
  Object opresult1216 = callmethod(opresult1215, "++", 1, partcv, params);
// compiled op node returning opresult1216 (depth = 7)
  gc_frame_newslot(opresult1216);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1217 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_io (depth = 9)
  partcv[0] = 0;
  Object call1218 = callmethod(*var_io, "error",
    1, partcv, params);
  gc_frame_end(callframe1217);
// compiled call node returning call1218 (depth = 8)
// compiled member node returning call1218 (depth = 7)
  params[0] = opresult1216;
  partcv[0] = 1;
  Object call1219 = callmethod(call1218, "write",
    1, partcv, params);
  gc_frame_end(callframe1208);
// compiled call node returning call1219 (depth = 6)
    gc_frame_newslot(call1219);
    if1151 = call1219;
  } else {
  }
// compiled if node returning if1151 (depth = 5)
// Begin line 270
  setline(270);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile if node (depth = 5)
// starting to compile op node (depth = 6)
// starting to compile call node (depth = 7)
  int callframe1222 = gc_frame_new();
// starting to compile identifier node (depth = 8)
// compiled identifier node returning *var_i (depth = 8)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1223 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1224 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1223);
// compiled call node returning call1224 (depth = 9)
// compiled member node returning call1224 (depth = 8)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1225 = callmethod(call1224, "at",
    1, partcv, params);
  gc_frame_end(callframe1222);
// compiled call node returning call1225 (depth = 7)
  int op_slot_right_1221 = gc_frame_newslot(call1225);
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1227 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 9)
  int callframe1228 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1229 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1230 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1229);
// compiled call node returning call1230 (depth = 11)
// compiled member node returning call1230 (depth = 10)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1231 = callmethod(call1230, "at",
    1, partcv, params);
  gc_frame_end(callframe1228);
// compiled call node returning call1231 (depth = 9)
  partcv[0] = 0;
  Object call1232 = callmethod(call1231, "truncated",
    1, partcv, params);
  gc_frame_end(callframe1227);
// compiled call node returning call1232 (depth = 8)
// compiled member node returning call1232 (depth = 7)
  int op_slot_left_1221 = gc_frame_newslot(call1232);
  params[0] = call1225;
  partcv[0] = 1;
  Object opresult1233 = callmethod(call1232, "≠", 1, partcv, params);
// compiled op node returning opresult1233 (depth = 6)
  Object if1220 = done;
  if (istrue(opresult1233)) {
// Begin line 271
  setline(271);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1234 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1236 == NULL) {
    strlit1236 = alloc_String("""\x0a""");
    gc_root(strlit1236);
  }
// compiled string node returning strlit1236 (depth = 8)
  int op_slot_right_1235 = gc_frame_newslot(strlit1236);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1239 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1240 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1241 = callmethodflags(self, "lines", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1240);
// compiled call node returning call1241 (depth = 11)
// compiled member node returning call1241 (depth = 10)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1242 = callmethod(call1241, "at",
    1, partcv, params);
  gc_frame_end(callframe1239);
// compiled call node returning call1242 (depth = 9)
  int op_slot_right_1238 = gc_frame_newslot(call1242);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1245 == NULL) {
    strlit1245 = alloc_String(": ");
    gc_root(strlit1245);
  }
// compiled string node returning strlit1245 (depth = 10)
  int op_slot_right_1244 = gc_frame_newslot(strlit1245);
// starting to compile op node (depth = 10)
// starting to compile member node (depth = 11)
// starting to compile call node (depth = 12)
  int callframe1248 = gc_frame_new();
// call case 6: other member request
// starting to compile call node (depth = 13)
  int callframe1249 = gc_frame_new();
// starting to compile identifier node (depth = 14)
// compiled identifier node returning *var_i (depth = 14)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 14)
// starting to compile call node (depth = 15)
  int callframe1250 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1251 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1250);
// compiled call node returning call1251 (depth = 15)
// compiled member node returning call1251 (depth = 14)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1252 = callmethod(call1251, "at",
    1, partcv, params);
  gc_frame_end(callframe1249);
// compiled call node returning call1252 (depth = 13)
  partcv[0] = 0;
  Object call1253 = callmethod(call1252, "truncated",
    1, partcv, params);
  gc_frame_end(callframe1248);
// compiled call node returning call1253 (depth = 12)
// compiled member node returning call1253 (depth = 11)
  int op_slot_right_1247 = gc_frame_newslot(call1253);
// starting to compile string node (depth = 11)
  if (strlit1255 == NULL) {
    strlit1255 = alloc_String(" *");
    gc_root(strlit1255);
  }
// compiled string node returning strlit1255 (depth = 11)
  int op_slot_left_1247 = gc_frame_newslot(strlit1255);
  params[0] = call1253;
  partcv[0] = 1;
  Object opresult1256 = callmethod(strlit1255, "++", 1, partcv, params);
// compiled op node returning opresult1256 (depth = 10)
  int op_slot_left_1244 = gc_frame_newslot(opresult1256);
  params[0] = strlit1245;
  partcv[0] = 1;
  Object opresult1257 = callmethod(opresult1256, "++", 1, partcv, params);
// compiled op node returning opresult1257 (depth = 9)
  int op_slot_left_1238 = gc_frame_newslot(opresult1257);
  params[0] = call1242;
  partcv[0] = 1;
  Object opresult1258 = callmethod(opresult1257, "++", 1, partcv, params);
// compiled op node returning opresult1258 (depth = 8)
  int op_slot_left_1235 = gc_frame_newslot(opresult1258);
  params[0] = strlit1236;
  partcv[0] = 1;
  Object opresult1259 = callmethod(opresult1258, "++", 1, partcv, params);
// compiled op node returning opresult1259 (depth = 7)
  gc_frame_newslot(opresult1259);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1260 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_io (depth = 9)
  partcv[0] = 0;
  Object call1261 = callmethod(*var_io, "error",
    1, partcv, params);
  gc_frame_end(callframe1260);
// compiled call node returning call1261 (depth = 8)
// compiled member node returning call1261 (depth = 7)
  params[0] = opresult1259;
  partcv[0] = 1;
  Object call1262 = callmethod(call1261, "write",
    1, partcv, params);
  gc_frame_end(callframe1234);
// compiled call node returning call1262 (depth = 6)
    gc_frame_newslot(call1262);
    if1220 = call1262;
  } else {
// Begin line 273
  setline(273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 6)
  int callframe1263 = gc_frame_new();
// starting to compile op node (depth = 7)
// starting to compile string node (depth = 8)
  if (strlit1265 == NULL) {
    strlit1265 = alloc_String("""\x0a""");
    gc_root(strlit1265);
  }
// compiled string node returning strlit1265 (depth = 8)
  int op_slot_right_1264 = gc_frame_newslot(strlit1265);
// starting to compile op node (depth = 8)
// starting to compile call node (depth = 9)
  int callframe1268 = gc_frame_new();
// starting to compile identifier node (depth = 10)
// compiled identifier node returning *var_i (depth = 10)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1269 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1270 = callmethodflags(self, "lines", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1269);
// compiled call node returning call1270 (depth = 11)
// compiled member node returning call1270 (depth = 10)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1271 = callmethod(call1270, "at",
    1, partcv, params);
  gc_frame_end(callframe1268);
// compiled call node returning call1271 (depth = 9)
  int op_slot_right_1267 = gc_frame_newslot(call1271);
// starting to compile op node (depth = 9)
// starting to compile string node (depth = 10)
  if (strlit1274 == NULL) {
    strlit1274 = alloc_String(": ");
    gc_root(strlit1274);
  }
// compiled string node returning strlit1274 (depth = 10)
  int op_slot_right_1273 = gc_frame_newslot(strlit1274);
// starting to compile op node (depth = 10)
// starting to compile call node (depth = 11)
  int callframe1277 = gc_frame_new();
// starting to compile identifier node (depth = 12)
// compiled identifier node returning *var_i (depth = 12)
  gc_frame_newslot(*var_i);
// call case 6: other member request
// starting to compile member node (depth = 12)
// starting to compile call node (depth = 13)
  int callframe1278 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1279 = callmethodflags(self, "lineNumbers", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1278);
// compiled call node returning call1279 (depth = 13)
// compiled member node returning call1279 (depth = 12)
  params[0] = *var_i;
  partcv[0] = 1;
  Object call1280 = callmethod(call1279, "at",
    1, partcv, params);
  gc_frame_end(callframe1277);
// compiled call node returning call1280 (depth = 11)
  int op_slot_right_1276 = gc_frame_newslot(call1280);
// starting to compile string node (depth = 11)
  if (strlit1282 == NULL) {
    strlit1282 = alloc_String("  ");
    gc_root(strlit1282);
  }
// compiled string node returning strlit1282 (depth = 11)
  int op_slot_left_1276 = gc_frame_newslot(strlit1282);
  params[0] = call1280;
  partcv[0] = 1;
  Object opresult1283 = callmethod(strlit1282, "++", 1, partcv, params);
// compiled op node returning opresult1283 (depth = 10)
  int op_slot_left_1273 = gc_frame_newslot(opresult1283);
  params[0] = strlit1274;
  partcv[0] = 1;
  Object opresult1284 = callmethod(opresult1283, "++", 1, partcv, params);
// compiled op node returning opresult1284 (depth = 9)
  int op_slot_left_1267 = gc_frame_newslot(opresult1284);
  params[0] = call1271;
  partcv[0] = 1;
  Object opresult1285 = callmethod(opresult1284, "++", 1, partcv, params);
// compiled op node returning opresult1285 (depth = 8)
  int op_slot_left_1264 = gc_frame_newslot(opresult1285);
  params[0] = strlit1265;
  partcv[0] = 1;
  Object opresult1286 = callmethod(opresult1285, "++", 1, partcv, params);
// compiled op node returning opresult1286 (depth = 7)
  gc_frame_newslot(opresult1286);
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1287 = gc_frame_new();
// call case 6: other member request
// starting to compile identifier node (depth = 9)
// compiled identifier node returning *var_io (depth = 9)
  partcv[0] = 0;
  Object call1288 = callmethod(*var_io, "error",
    1, partcv, params);
  gc_frame_end(callframe1287);
// compiled call node returning call1288 (depth = 8)
// compiled member node returning call1288 (depth = 7)
  params[0] = opresult1286;
  partcv[0] = 1;
  Object call1289 = callmethod(call1288, "write",
    1, partcv, params);
  gc_frame_end(callframe1263);
// compiled call node returning call1289 (depth = 6)
    gc_frame_newslot(call1289);
    if1220 = call1289;
  }
// compiled if node returning if1220 (depth = 5)
  gc_frame_end(frame);
  return if1220;
}
Object meth_errormessages_print1139(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 28, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "print");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[2];
  int partcv[2];
  Object *var_io = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for print (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for print");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 261
  setline(261);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile call node (depth = 3)
  int callframe1140 = gc_frame_new();
// starting to compile op node (depth = 4)
// starting to compile member node (depth = 5)
// starting to compile call node (depth = 6)
  int callframe1142 = gc_frame_new();
// call case 6: other member request
// starting to compile member node (depth = 7)
// starting to compile call node (depth = 8)
  int callframe1143 = gc_frame_new();
// call case 4: self request
  partcv[0] = 0;
  Object call1144 = callmethodflags(self, "lines", 1, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1143);
// compiled call node returning call1144 (depth = 8)
// compiled member node returning call1144 (depth = 7)
  partcv[0] = 0;
  Object call1145 = callmethod(call1144, "size",
    1, partcv, params);
  gc_frame_end(callframe1142);
// compiled call node returning call1145 (depth = 6)
// compiled member node returning call1145 (depth = 5)
  int op_slot_right_1141 = gc_frame_newslot(call1145);
// starting to compile num node (depth = 5)
  Object num1147 = alloc_Float64(1);
// compiled num node returning num1147 (depth = 5)
  int op_slot_left_1141 = gc_frame_newslot(num1147);
  params[0] = call1145;
  partcv[0] = 1;
  Object opresult1148 = callmethod(num1147, "..", 1, partcv, params);
// compiled op node returning opresult1148 (depth = 4)
  gc_frame_newslot(opresult1148);
// starting to compile block node (depth = 4)
  Object block1149 = alloc_Block(NULL, NULL, "errormessages", 261);
  gc_frame_newslot(block1149);
// method "_apply"
  block_savedest(block1149);
  Object closure1150 = createclosure(2, "_apply");
  setclosureframe(closure1150, stackframe);
  addtoclosure(closure1150, var_io);
  addtoclosure(closure1150, selfslot);
  struct UserObject *uo1150 = (struct UserObject*)block1149;
  uo1150->data[0] = (Object)closure1150;
  Method *meth_meth_errormessages__apply1150 = addmethod2pos(block1149, "_apply", &meth_errormessages__apply1150, 0);
  int argcv_meth_errormessages__apply1150[] = {1};
  meth_meth_errormessages__apply1150->type = alloc_MethodType(1, argcv_meth_errormessages__apply1150);
  meth_meth_errormessages__apply1150->definitionModule = modulename;
  meth_meth_errormessages__apply1150->definitionLine = 261;
// compiled block node returning block1149 (depth = 4)
  gc_frame_newslot(block1149);
// call case 5: prelude request
  params[0] = opresult1148;
  params[1] = block1149;
  partcv[0] = 1;
  partcv[1] = 1;
  Object call1291 = callmethodflags(prelude, "for()do", 2, partcv, params, CFLAG_SELF);
  gc_frame_end(callframe1140);
// compiled call node returning call1291 (depth = 3)
  gc_frame_end(frame);
  return call1291;
}
Object meth_errormessages_new517(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_io = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject518 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj518 = alloc_userobj2(28,29, objclass518);
  gc_frame_newslot(obj518);
if (objclass518 == NULL) {
  glfree(obj518->class->name);
  obj518->class->name = "suggestion.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj518, self, 0);
  addmethodreal(obj518,"outer", &reader_errormessages_outer_519);
  Object oldself518 = self;
  struct StackFrameObject *oldstackframe518 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe518);
  gc_frame_newslot((Object)stackframe);
  self = obj518;
  Object *oldselfslot518 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter518 = (*(struct UserObject *)self).data[0], lowerouter518 = thisouter518;
  if (inheritingObject518) {
    struct UserObject *inho518 = (struct UserObject *)inheritingObject518;
    while (inho518->super != GraceDefaultObject) inho518 = (struct UserObject *)inho518->super;
    inho518->super = obj518;
    self = inheritingObject518;
    *selfslot = self;
    lowerouter518 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter518;
  }
if (objclass518 == NULL) {
  Method *reader520 = addmethodrealflags(obj518, "lineNumbers",&reader_errormessages_lineNumbers_520, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader520->definitionModule = modulename;
  reader520->definitionLine = 15;
}
adddatum2(obj518, alloc_Undefined(), 1);
if (objclass518 == NULL) {
  Method *reader521 = addmethodrealflags(obj518, "lines",&reader_errormessages_lines_521, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader521->definitionModule = modulename;
  reader521->definitionLine = 16;
}
adddatum2(obj518, alloc_Undefined(), 2);
// method "replaceRange()with()onLine"
  struct UserObject *uo522 = (struct UserObject*)obj518;
  uo522->data[3] = emptyclosure;
  Method *meth_meth_errormessages_replaceRange_40__41_with_40__41_onLine522 = addmethod2pos(obj518, "replaceRange()with()onLine", &meth_errormessages_replaceRange_40__41_with_40__41_onLine522, 3);
  int argcv_meth_errormessages_replaceRange_40__41_with_40__41_onLine522[] = {2, 1, 1};
  meth_meth_errormessages_replaceRange_40__41_with_40__41_onLine522->type = alloc_MethodType(3, argcv_meth_errormessages_replaceRange_40__41_with_40__41_onLine522);
  meth_meth_errormessages_replaceRange_40__41_with_40__41_onLine522->definitionModule = modulename;
  meth_meth_errormessages_replaceRange_40__41_with_40__41_onLine522->definitionLine = 23;
// method "replaceChar()with()onLine"
  struct UserObject *uo566 = (struct UserObject*)obj518;
  uo566->data[4] = emptyclosure;
  Method *meth_meth_errormessages_replaceChar_40__41_with_40__41_onLine566 = addmethod2pos(obj518, "replaceChar()with()onLine", &meth_errormessages_replaceChar_40__41_with_40__41_onLine566, 4);
  int argcv_meth_errormessages_replaceChar_40__41_with_40__41_onLine566[] = {1, 1, 1};
  meth_meth_errormessages_replaceChar_40__41_with_40__41_onLine566->type = alloc_MethodType(3, argcv_meth_errormessages_replaceChar_40__41_with_40__41_onLine566);
  meth_meth_errormessages_replaceChar_40__41_with_40__41_onLine566->definitionModule = modulename;
  meth_meth_errormessages_replaceChar_40__41_with_40__41_onLine566->definitionLine = 33;
// method "replaceUntil()with()onLine"
  struct UserObject *uo569 = (struct UserObject*)obj518;
  uo569->data[5] = emptyclosure;
  Method *meth_meth_errormessages_replaceUntil_40__41_with_40__41_onLine569 = addmethod2pos(obj518, "replaceUntil()with()onLine", &meth_errormessages_replaceUntil_40__41_with_40__41_onLine569, 5);
  int argcv_meth_errormessages_replaceUntil_40__41_with_40__41_onLine569[] = {1, 1, 1};
  meth_meth_errormessages_replaceUntil_40__41_with_40__41_onLine569->type = alloc_MethodType(3, argcv_meth_errormessages_replaceUntil_40__41_with_40__41_onLine569);
  meth_meth_errormessages_replaceUntil_40__41_with_40__41_onLine569->definitionModule = modulename;
  meth_meth_errormessages_replaceUntil_40__41_with_40__41_onLine569->definitionLine = 37;
// method "deleteRange()onLine"
  struct UserObject *uo610 = (struct UserObject*)obj518;
  uo610->data[6] = emptyclosure;
  Method *meth_meth_errormessages_deleteRange_40__41_onLine610 = addmethod2pos(obj518, "deleteRange()onLine", &meth_errormessages_deleteRange_40__41_onLine610, 6);
  int argcv_meth_errormessages_deleteRange_40__41_onLine610[] = {2, 1};
  meth_meth_errormessages_deleteRange_40__41_onLine610->type = alloc_MethodType(2, argcv_meth_errormessages_deleteRange_40__41_onLine610);
  meth_meth_errormessages_deleteRange_40__41_onLine610->definitionModule = modulename;
  meth_meth_errormessages_deleteRange_40__41_onLine610->definitionLine = 49;
// method "deleteChar()onLine"
  struct UserObject *uo659 = (struct UserObject*)obj518;
  uo659->data[7] = emptyclosure;
  Method *meth_meth_errormessages_deleteChar_40__41_onLine659 = addmethod2pos(obj518, "deleteChar()onLine", &meth_errormessages_deleteChar_40__41_onLine659, 7);
  int argcv_meth_errormessages_deleteChar_40__41_onLine659[] = {1, 1};
  meth_meth_errormessages_deleteChar_40__41_onLine659->type = alloc_MethodType(2, argcv_meth_errormessages_deleteChar_40__41_onLine659);
  meth_meth_errormessages_deleteChar_40__41_onLine659->definitionModule = modulename;
  meth_meth_errormessages_deleteChar_40__41_onLine659->definitionLine = 67;
// method "append()onLine"
  struct UserObject *uo663 = (struct UserObject*)obj518;
  uo663->data[8] = emptyclosure;
  Method *meth_meth_errormessages_append_40__41_onLine663 = addmethod2pos(obj518, "append()onLine", &meth_errormessages_append_40__41_onLine663, 8);
  int argcv_meth_errormessages_append_40__41_onLine663[] = {1, 1};
  meth_meth_errormessages_append_40__41_onLine663->type = alloc_MethodType(2, argcv_meth_errormessages_append_40__41_onLine663);
  meth_meth_errormessages_append_40__41_onLine663->definitionModule = modulename;
  meth_meth_errormessages_append_40__41_onLine663->definitionLine = 71;
// method "insert()atPosition()onLine"
  struct UserObject *uo671 = (struct UserObject*)obj518;
  uo671->data[9] = emptyclosure;
  Method *meth_meth_errormessages_insert_40__41_atPosition_40__41_onLine671 = addmethod2pos(obj518, "insert()atPosition()onLine", &meth_errormessages_insert_40__41_atPosition_40__41_onLine671, 9);
  int argcv_meth_errormessages_insert_40__41_atPosition_40__41_onLine671[] = {1, 1, 1};
  meth_meth_errormessages_insert_40__41_atPosition_40__41_onLine671->type = alloc_MethodType(3, argcv_meth_errormessages_insert_40__41_atPosition_40__41_onLine671);
  meth_meth_errormessages_insert_40__41_atPosition_40__41_onLine671->definitionModule = modulename;
  meth_meth_errormessages_insert_40__41_atPosition_40__41_onLine671->definitionLine = 76;
// method "getTokenStart()includeLeadingSpace"
  struct UserObject *uo703 = (struct UserObject*)obj518;
  uo703->data[10] = emptyclosure;
  Method *meth_meth_errormessages_getTokenStart_40__41_includeLeadingSpace703 = addmethod2pos(obj518, "getTokenStart()includeLeadingSpace", &meth_errormessages_getTokenStart_40__41_includeLeadingSpace703, 10);
  int argcv_meth_errormessages_getTokenStart_40__41_includeLeadingSpace703[] = {1, 1};
  meth_meth_errormessages_getTokenStart_40__41_includeLeadingSpace703->type = alloc_MethodType(2, argcv_meth_errormessages_getTokenStart_40__41_includeLeadingSpace703);
  meth_meth_errormessages_getTokenStart_40__41_includeLeadingSpace703->definitionModule = modulename;
  meth_meth_errormessages_getTokenStart_40__41_includeLeadingSpace703->definitionLine = 90;
// method "getTokenEnd()includeTrailingSpace"
  struct UserObject *uo781 = (struct UserObject*)obj518;
  uo781->data[11] = emptyclosure;
  Method *meth_meth_errormessages_getTokenEnd_40__41_includeTrailingSpace781 = addmethod2pos(obj518, "getTokenEnd()includeTrailingSpace", &meth_errormessages_getTokenEnd_40__41_includeTrailingSpace781, 11);
  int argcv_meth_errormessages_getTokenEnd_40__41_includeTrailingSpace781[] = {1, 1};
  meth_meth_errormessages_getTokenEnd_40__41_includeTrailingSpace781->type = alloc_MethodType(2, argcv_meth_errormessages_getTokenEnd_40__41_includeTrailingSpace781);
  meth_meth_errormessages_getTokenEnd_40__41_includeTrailingSpace781->definitionModule = modulename;
  meth_meth_errormessages_getTokenEnd_40__41_includeTrailingSpace781->definitionLine = 107;
// method "replaceToken()leading()trailing()with"
  struct UserObject *uo836 = (struct UserObject*)obj518;
  uo836->data[12] = emptyclosure;
  Method *meth_meth_errormessages_replaceToken_40__41_leading_40__41_trailing_40__41_with836 = addmethod2pos(obj518, "replaceToken()leading()trailing()with", &meth_errormessages_replaceToken_40__41_leading_40__41_trailing_40__41_with836, 12);
  int argcv_meth_errormessages_replaceToken_40__41_leading_40__41_trailing_40__41_with836[] = {1, 1, 1, 1};
  meth_meth_errormessages_replaceToken_40__41_leading_40__41_trailing_40__41_with836->type = alloc_MethodType(4, argcv_meth_errormessages_replaceToken_40__41_leading_40__41_trailing_40__41_with836);
  meth_meth_errormessages_replaceToken_40__41_leading_40__41_trailing_40__41_with836->definitionModule = modulename;
  meth_meth_errormessages_replaceToken_40__41_leading_40__41_trailing_40__41_with836->definitionLine = 120;
// method "replaceToken()with"
  struct UserObject *uo845 = (struct UserObject*)obj518;
  uo845->data[13] = emptyclosure;
  Method *meth_meth_errormessages_replaceToken_40__41_with845 = addmethod2pos(obj518, "replaceToken()with", &meth_errormessages_replaceToken_40__41_with845, 13);
  int argcv_meth_errormessages_replaceToken_40__41_with845[] = {1, 1};
  meth_meth_errormessages_replaceToken_40__41_with845->type = alloc_MethodType(2, argcv_meth_errormessages_replaceToken_40__41_with845);
  meth_meth_errormessages_replaceToken_40__41_with845->definitionModule = modulename;
  meth_meth_errormessages_replaceToken_40__41_with845->definitionLine = 126;
// method "replaceTokenRange()leading()trailing()with"
  struct UserObject *uo850 = (struct UserObject*)obj518;
  uo850->data[14] = emptyclosure;
  Method *meth_meth_errormessages_replaceTokenRange_40__41_leading_40__41_trailing_40__41_with850 = addmethod2pos(obj518, "replaceTokenRange()leading()trailing()with", &meth_errormessages_replaceTokenRange_40__41_leading_40__41_trailing_40__41_with850, 14);
  int argcv_meth_errormessages_replaceTokenRange_40__41_leading_40__41_trailing_40__41_with850[] = {2, 1, 1, 1};
  meth_meth_errormessages_replaceTokenRange_40__41_leading_40__41_trailing_40__41_with850->type = alloc_MethodType(4, argcv_meth_errormessages_replaceTokenRange_40__41_leading_40__41_trailing_40__41_with850);
  meth_meth_errormessages_replaceTokenRange_40__41_leading_40__41_trailing_40__41_with850->definitionModule = modulename;
  meth_meth_errormessages_replaceTokenRange_40__41_leading_40__41_trailing_40__41_with850->definitionLine = 130;
// method "replaceTokenRange()with"
  struct UserObject *uo890 = (struct UserObject*)obj518;
  uo890->data[15] = emptyclosure;
  Method *meth_meth_errormessages_replaceTokenRange_40__41_with890 = addmethod2pos(obj518, "replaceTokenRange()with", &meth_errormessages_replaceTokenRange_40__41_with890, 15);
  int argcv_meth_errormessages_replaceTokenRange_40__41_with890[] = {2, 1};
  meth_meth_errormessages_replaceTokenRange_40__41_with890->type = alloc_MethodType(2, argcv_meth_errormessages_replaceTokenRange_40__41_with890);
  meth_meth_errormessages_replaceTokenRange_40__41_with890->definitionModule = modulename;
  meth_meth_errormessages_replaceTokenRange_40__41_with890->definitionLine = 147;
// method "deleteToken()leading()trailing"
  struct UserObject *uo895 = (struct UserObject*)obj518;
  uo895->data[16] = emptyclosure;
  Method *meth_meth_errormessages_deleteToken_40__41_leading_40__41_trailing895 = addmethod2pos(obj518, "deleteToken()leading()trailing", &meth_errormessages_deleteToken_40__41_leading_40__41_trailing895, 16);
  int argcv_meth_errormessages_deleteToken_40__41_leading_40__41_trailing895[] = {1, 1, 1};
  meth_meth_errormessages_deleteToken_40__41_leading_40__41_trailing895->type = alloc_MethodType(3, argcv_meth_errormessages_deleteToken_40__41_leading_40__41_trailing895);
  meth_meth_errormessages_deleteToken_40__41_leading_40__41_trailing895->definitionModule = modulename;
  meth_meth_errormessages_deleteToken_40__41_leading_40__41_trailing895->definitionLine = 152;
// method "deleteToken"
  struct UserObject *uo904 = (struct UserObject*)obj518;
  uo904->data[17] = emptyclosure;
  Method *meth_meth_errormessages_deleteToken904 = addmethod2pos(obj518, "deleteToken", &meth_errormessages_deleteToken904, 17);
  int argcv_meth_errormessages_deleteToken904[] = {1};
  meth_meth_errormessages_deleteToken904->type = alloc_MethodType(1, argcv_meth_errormessages_deleteToken904);
  meth_meth_errormessages_deleteToken904->definitionModule = modulename;
  meth_meth_errormessages_deleteToken904->definitionLine = 158;
// method "deleteTokenRange()leading()trailing"
  struct UserObject *uo909 = (struct UserObject*)obj518;
  uo909->data[18] = emptyclosure;
  Method *meth_meth_errormessages_deleteTokenRange_40__41_leading_40__41_trailing909 = addmethod2pos(obj518, "deleteTokenRange()leading()trailing", &meth_errormessages_deleteTokenRange_40__41_leading_40__41_trailing909, 18);
  int argcv_meth_errormessages_deleteTokenRange_40__41_leading_40__41_trailing909[] = {2, 1, 1};
  meth_meth_errormessages_deleteTokenRange_40__41_leading_40__41_trailing909->type = alloc_MethodType(3, argcv_meth_errormessages_deleteTokenRange_40__41_leading_40__41_trailing909);
  meth_meth_errormessages_deleteTokenRange_40__41_leading_40__41_trailing909->definitionModule = modulename;
  meth_meth_errormessages_deleteTokenRange_40__41_leading_40__41_trailing909->definitionLine = 163;
// method "deleteTokenRange"
  struct UserObject *uo970 = (struct UserObject*)obj518;
  uo970->data[19] = emptyclosure;
  Method *meth_meth_errormessages_deleteTokenRange970 = addmethod2pos(obj518, "deleteTokenRange", &meth_errormessages_deleteTokenRange970, 19);
  int argcv_meth_errormessages_deleteTokenRange970[] = {2};
  meth_meth_errormessages_deleteTokenRange970->type = alloc_MethodType(1, argcv_meth_errormessages_deleteTokenRange970);
  meth_meth_errormessages_deleteTokenRange970->definitionModule = modulename;
  meth_meth_errormessages_deleteTokenRange970->definitionLine = 188;
// method "deleteLine"
  struct UserObject *uo975 = (struct UserObject*)obj518;
  uo975->data[20] = emptyclosure;
  Method *meth_meth_errormessages_deleteLine975 = addmethod2pos(obj518, "deleteLine", &meth_errormessages_deleteLine975, 20);
  int argcv_meth_errormessages_deleteLine975[] = {1};
  meth_meth_errormessages_deleteLine975->type = alloc_MethodType(1, argcv_meth_errormessages_deleteLine975);
  meth_meth_errormessages_deleteLine975->definitionModule = modulename;
  meth_meth_errormessages_deleteLine975->definitionLine = 192;
// method "insert()afterToken()andTrailingSpace"
  struct UserObject *uo979 = (struct UserObject*)obj518;
  uo979->data[21] = emptyclosure;
  Method *meth_meth_errormessages_insert_40__41_afterToken_40__41_andTrailingSpace979 = addmethod2pos(obj518, "insert()afterToken()andTrailingSpace", &meth_errormessages_insert_40__41_afterToken_40__41_andTrailingSpace979, 21);
  int argcv_meth_errormessages_insert_40__41_afterToken_40__41_andTrailingSpace979[] = {1, 1, 1};
  meth_meth_errormessages_insert_40__41_afterToken_40__41_andTrailingSpace979->type = alloc_MethodType(3, argcv_meth_errormessages_insert_40__41_afterToken_40__41_andTrailingSpace979);
  meth_meth_errormessages_insert_40__41_afterToken_40__41_andTrailingSpace979->definitionModule = modulename;
  meth_meth_errormessages_insert_40__41_afterToken_40__41_andTrailingSpace979->definitionLine = 196;
// method "insert()afterToken"
  struct UserObject *uo990 = (struct UserObject*)obj518;
  uo990->data[22] = emptyclosure;
  Method *meth_meth_errormessages_insert_40__41_afterToken990 = addmethod2pos(obj518, "insert()afterToken", &meth_errormessages_insert_40__41_afterToken990, 22);
  int argcv_meth_errormessages_insert_40__41_afterToken990[] = {1, 1};
  meth_meth_errormessages_insert_40__41_afterToken990->type = alloc_MethodType(2, argcv_meth_errormessages_insert_40__41_afterToken990);
  meth_meth_errormessages_insert_40__41_afterToken990->definitionModule = modulename;
  meth_meth_errormessages_insert_40__41_afterToken990->definitionLine = 201;
// method "insert()beforeToken"
  struct UserObject *uo994 = (struct UserObject*)obj518;
  uo994->data[23] = emptyclosure;
  Method *meth_meth_errormessages_insert_40__41_beforeToken994 = addmethod2pos(obj518, "insert()beforeToken", &meth_errormessages_insert_40__41_beforeToken994, 23);
  int argcv_meth_errormessages_insert_40__41_beforeToken994[] = {1, 1};
  meth_meth_errormessages_insert_40__41_beforeToken994->type = alloc_MethodType(2, argcv_meth_errormessages_insert_40__41_beforeToken994);
  meth_meth_errormessages_insert_40__41_beforeToken994->definitionModule = modulename;
  meth_meth_errormessages_insert_40__41_beforeToken994->definitionLine = 205;
// method "insertNewLine()after"
  struct UserObject *uo1001 = (struct UserObject*)obj518;
  uo1001->data[24] = emptyclosure;
  Method *meth_meth_errormessages_insertNewLine_40__41_after1001 = addmethod2pos(obj518, "insertNewLine()after", &meth_errormessages_insertNewLine_40__41_after1001, 24);
  int argcv_meth_errormessages_insertNewLine_40__41_after1001[] = {1, 1};
  meth_meth_errormessages_insertNewLine_40__41_after1001->type = alloc_MethodType(2, argcv_meth_errormessages_insertNewLine_40__41_after1001);
  meth_meth_errormessages_insertNewLine_40__41_after1001->definitionModule = modulename;
  meth_meth_errormessages_insertNewLine_40__41_after1001->definitionLine = 210;
// method "addLine"
  struct UserObject *uo1004 = (struct UserObject*)obj518;
  uo1004->data[25] = emptyclosure;
  Method *meth_meth_errormessages_addLine1004 = addmethod2pos(obj518, "addLine", &meth_errormessages_addLine1004, 25);
  int argcv_meth_errormessages_addLine1004[] = {2};
  meth_meth_errormessages_addLine1004->type = alloc_MethodType(1, argcv_meth_errormessages_addLine1004);
  meth_meth_errormessages_addLine1004->definitionModule = modulename;
  meth_meth_errormessages_addLine1004->definitionLine = 216;
// method "findLine"
  struct UserObject *uo1104 = (struct UserObject*)obj518;
  uo1104->data[26] = emptyclosure;
  Method *meth_meth_errormessages_findLine1104 = addmethod2pos(obj518, "findLine", &meth_errormessages_findLine1104, 26);
  int argcv_meth_errormessages_findLine1104[] = {1};
  meth_meth_errormessages_findLine1104->type = alloc_MethodType(1, argcv_meth_errormessages_findLine1104);
  meth_meth_errormessages_findLine1104->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_errormessages_findLine1104->definitionModule = modulename;
  meth_meth_errormessages_findLine1104->definitionLine = 240;
// method "getLine"
  block_savedest(obj518);
  Object closure1123 = createclosure(1, "getLine");
  setclosureframe(closure1123, stackframe);
  addtoclosure(closure1123, var_util);
  struct UserObject *uo1123 = (struct UserObject*)obj518;
  uo1123->data[27] = (Object)closure1123;
  Method *meth_meth_errormessages_getLine1123 = addmethod2pos(obj518, "getLine", &meth_errormessages_getLine1123, 27);
  int argcv_meth_errormessages_getLine1123[] = {1};
  meth_meth_errormessages_getLine1123->type = alloc_MethodType(1, argcv_meth_errormessages_getLine1123);
  meth_meth_errormessages_getLine1123->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_errormessages_getLine1123->definitionModule = modulename;
  meth_meth_errormessages_getLine1123->definitionLine = 251;
// method "print"
  block_savedest(obj518);
  Object closure1139 = createclosure(1, "print");
  setclosureframe(closure1139, stackframe);
  addtoclosure(closure1139, var_io);
  struct UserObject *uo1139 = (struct UserObject*)obj518;
  uo1139->data[28] = (Object)closure1139;
  Method *meth_meth_errormessages_print1139 = addmethod2pos(obj518, "print", &meth_errormessages_print1139, 28);
  int argcv_meth_errormessages_print1139[] = {0};
  meth_meth_errormessages_print1139->type = alloc_MethodType(1, argcv_meth_errormessages_print1139);
  meth_meth_errormessages_print1139->definitionModule = modulename;
  meth_meth_errormessages_print1139->definitionLine = 260;
  sourceObject = obj518;
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array1292 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1292 (depth = 3)
  adddatum2(obj518, array1292, 1);
  sourceObject = obj518;
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array1293 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1293 (depth = 3)
  adddatum2(obj518, array1293, 2);
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  objclass518 = obj518->class;
  objclass518->definitionModule = modulename;
  objclass518->definitionLine = 14;
  (*(struct UserObject *)self).data[0] = lowerouter518;
  self = oldself518;
  selfslot = oldselfslot518;
  stackframe = oldstackframe518;
  gc_frame_end(frame);
  return obj518;
}
Object meth_errormessages_new517_object(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 1, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "new()object");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = args[0 + argcv[0]];
  Object params[1];
  int partcv[1];
  Object *var_util = getfromclosure(closure, 0);
  Object *var_io = getfromclosure(closure, 1);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for new (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for new");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
  isTailObject = 1;
  inheritingObject = methodInheritingObject;
  Object inheritingObject518 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj518 = alloc_userobj2(28,29, objclass518);
  gc_frame_newslot(obj518);
if (objclass518 == NULL) {
  glfree(obj518->class->name);
  obj518->class->name = "suggestion.new";
}
// OBJECT OUTER DEC outer
  adddatum2(obj518, self, 0);
  addmethodreal(obj518,"outer", &reader_errormessages_outer_519);
  Object oldself518 = self;
  struct StackFrameObject *oldstackframe518 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe518);
  gc_frame_newslot((Object)stackframe);
  self = obj518;
  Object *oldselfslot518 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter518 = (*(struct UserObject *)self).data[0], lowerouter518 = thisouter518;
  if (inheritingObject518) {
    struct UserObject *inho518 = (struct UserObject *)inheritingObject518;
    while (inho518->super != GraceDefaultObject) inho518 = (struct UserObject *)inho518->super;
    inho518->super = obj518;
    self = inheritingObject518;
    *selfslot = self;
    lowerouter518 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter518;
  }
if (objclass518 == NULL) {
  Method *reader520 = addmethodrealflags(obj518, "lineNumbers",&reader_errormessages_lineNumbers_520, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader520->definitionModule = modulename;
  reader520->definitionLine = 15;
}
adddatum2(obj518, alloc_Undefined(), 1);
if (objclass518 == NULL) {
  Method *reader521 = addmethodrealflags(obj518, "lines",&reader_errormessages_lines_521, MFLAG_DEF | MFLAG_CONFIDENTIAL);
  reader521->definitionModule = modulename;
  reader521->definitionLine = 16;
}
adddatum2(obj518, alloc_Undefined(), 2);
// method "replaceRange()with()onLine"
  struct UserObject *uo522 = (struct UserObject*)obj518;
  uo522->data[3] = emptyclosure;
  Method *meth_meth_errormessages_replaceRange_40__41_with_40__41_onLine522 = addmethod2pos(obj518, "replaceRange()with()onLine", &meth_errormessages_replaceRange_40__41_with_40__41_onLine522, 3);
  int argcv_meth_errormessages_replaceRange_40__41_with_40__41_onLine522[] = {2, 1, 1};
  meth_meth_errormessages_replaceRange_40__41_with_40__41_onLine522->type = alloc_MethodType(3, argcv_meth_errormessages_replaceRange_40__41_with_40__41_onLine522);
  meth_meth_errormessages_replaceRange_40__41_with_40__41_onLine522->definitionModule = modulename;
  meth_meth_errormessages_replaceRange_40__41_with_40__41_onLine522->definitionLine = 23;
// method "replaceChar()with()onLine"
  struct UserObject *uo566 = (struct UserObject*)obj518;
  uo566->data[4] = emptyclosure;
  Method *meth_meth_errormessages_replaceChar_40__41_with_40__41_onLine566 = addmethod2pos(obj518, "replaceChar()with()onLine", &meth_errormessages_replaceChar_40__41_with_40__41_onLine566, 4);
  int argcv_meth_errormessages_replaceChar_40__41_with_40__41_onLine566[] = {1, 1, 1};
  meth_meth_errormessages_replaceChar_40__41_with_40__41_onLine566->type = alloc_MethodType(3, argcv_meth_errormessages_replaceChar_40__41_with_40__41_onLine566);
  meth_meth_errormessages_replaceChar_40__41_with_40__41_onLine566->definitionModule = modulename;
  meth_meth_errormessages_replaceChar_40__41_with_40__41_onLine566->definitionLine = 33;
// method "replaceUntil()with()onLine"
  struct UserObject *uo569 = (struct UserObject*)obj518;
  uo569->data[5] = emptyclosure;
  Method *meth_meth_errormessages_replaceUntil_40__41_with_40__41_onLine569 = addmethod2pos(obj518, "replaceUntil()with()onLine", &meth_errormessages_replaceUntil_40__41_with_40__41_onLine569, 5);
  int argcv_meth_errormessages_replaceUntil_40__41_with_40__41_onLine569[] = {1, 1, 1};
  meth_meth_errormessages_replaceUntil_40__41_with_40__41_onLine569->type = alloc_MethodType(3, argcv_meth_errormessages_replaceUntil_40__41_with_40__41_onLine569);
  meth_meth_errormessages_replaceUntil_40__41_with_40__41_onLine569->definitionModule = modulename;
  meth_meth_errormessages_replaceUntil_40__41_with_40__41_onLine569->definitionLine = 37;
// method "deleteRange()onLine"
  struct UserObject *uo610 = (struct UserObject*)obj518;
  uo610->data[6] = emptyclosure;
  Method *meth_meth_errormessages_deleteRange_40__41_onLine610 = addmethod2pos(obj518, "deleteRange()onLine", &meth_errormessages_deleteRange_40__41_onLine610, 6);
  int argcv_meth_errormessages_deleteRange_40__41_onLine610[] = {2, 1};
  meth_meth_errormessages_deleteRange_40__41_onLine610->type = alloc_MethodType(2, argcv_meth_errormessages_deleteRange_40__41_onLine610);
  meth_meth_errormessages_deleteRange_40__41_onLine610->definitionModule = modulename;
  meth_meth_errormessages_deleteRange_40__41_onLine610->definitionLine = 49;
// method "deleteChar()onLine"
  struct UserObject *uo659 = (struct UserObject*)obj518;
  uo659->data[7] = emptyclosure;
  Method *meth_meth_errormessages_deleteChar_40__41_onLine659 = addmethod2pos(obj518, "deleteChar()onLine", &meth_errormessages_deleteChar_40__41_onLine659, 7);
  int argcv_meth_errormessages_deleteChar_40__41_onLine659[] = {1, 1};
  meth_meth_errormessages_deleteChar_40__41_onLine659->type = alloc_MethodType(2, argcv_meth_errormessages_deleteChar_40__41_onLine659);
  meth_meth_errormessages_deleteChar_40__41_onLine659->definitionModule = modulename;
  meth_meth_errormessages_deleteChar_40__41_onLine659->definitionLine = 67;
// method "append()onLine"
  struct UserObject *uo663 = (struct UserObject*)obj518;
  uo663->data[8] = emptyclosure;
  Method *meth_meth_errormessages_append_40__41_onLine663 = addmethod2pos(obj518, "append()onLine", &meth_errormessages_append_40__41_onLine663, 8);
  int argcv_meth_errormessages_append_40__41_onLine663[] = {1, 1};
  meth_meth_errormessages_append_40__41_onLine663->type = alloc_MethodType(2, argcv_meth_errormessages_append_40__41_onLine663);
  meth_meth_errormessages_append_40__41_onLine663->definitionModule = modulename;
  meth_meth_errormessages_append_40__41_onLine663->definitionLine = 71;
// method "insert()atPosition()onLine"
  struct UserObject *uo671 = (struct UserObject*)obj518;
  uo671->data[9] = emptyclosure;
  Method *meth_meth_errormessages_insert_40__41_atPosition_40__41_onLine671 = addmethod2pos(obj518, "insert()atPosition()onLine", &meth_errormessages_insert_40__41_atPosition_40__41_onLine671, 9);
  int argcv_meth_errormessages_insert_40__41_atPosition_40__41_onLine671[] = {1, 1, 1};
  meth_meth_errormessages_insert_40__41_atPosition_40__41_onLine671->type = alloc_MethodType(3, argcv_meth_errormessages_insert_40__41_atPosition_40__41_onLine671);
  meth_meth_errormessages_insert_40__41_atPosition_40__41_onLine671->definitionModule = modulename;
  meth_meth_errormessages_insert_40__41_atPosition_40__41_onLine671->definitionLine = 76;
// method "getTokenStart()includeLeadingSpace"
  struct UserObject *uo703 = (struct UserObject*)obj518;
  uo703->data[10] = emptyclosure;
  Method *meth_meth_errormessages_getTokenStart_40__41_includeLeadingSpace703 = addmethod2pos(obj518, "getTokenStart()includeLeadingSpace", &meth_errormessages_getTokenStart_40__41_includeLeadingSpace703, 10);
  int argcv_meth_errormessages_getTokenStart_40__41_includeLeadingSpace703[] = {1, 1};
  meth_meth_errormessages_getTokenStart_40__41_includeLeadingSpace703->type = alloc_MethodType(2, argcv_meth_errormessages_getTokenStart_40__41_includeLeadingSpace703);
  meth_meth_errormessages_getTokenStart_40__41_includeLeadingSpace703->definitionModule = modulename;
  meth_meth_errormessages_getTokenStart_40__41_includeLeadingSpace703->definitionLine = 90;
// method "getTokenEnd()includeTrailingSpace"
  struct UserObject *uo781 = (struct UserObject*)obj518;
  uo781->data[11] = emptyclosure;
  Method *meth_meth_errormessages_getTokenEnd_40__41_includeTrailingSpace781 = addmethod2pos(obj518, "getTokenEnd()includeTrailingSpace", &meth_errormessages_getTokenEnd_40__41_includeTrailingSpace781, 11);
  int argcv_meth_errormessages_getTokenEnd_40__41_includeTrailingSpace781[] = {1, 1};
  meth_meth_errormessages_getTokenEnd_40__41_includeTrailingSpace781->type = alloc_MethodType(2, argcv_meth_errormessages_getTokenEnd_40__41_includeTrailingSpace781);
  meth_meth_errormessages_getTokenEnd_40__41_includeTrailingSpace781->definitionModule = modulename;
  meth_meth_errormessages_getTokenEnd_40__41_includeTrailingSpace781->definitionLine = 107;
// method "replaceToken()leading()trailing()with"
  struct UserObject *uo836 = (struct UserObject*)obj518;
  uo836->data[12] = emptyclosure;
  Method *meth_meth_errormessages_replaceToken_40__41_leading_40__41_trailing_40__41_with836 = addmethod2pos(obj518, "replaceToken()leading()trailing()with", &meth_errormessages_replaceToken_40__41_leading_40__41_trailing_40__41_with836, 12);
  int argcv_meth_errormessages_replaceToken_40__41_leading_40__41_trailing_40__41_with836[] = {1, 1, 1, 1};
  meth_meth_errormessages_replaceToken_40__41_leading_40__41_trailing_40__41_with836->type = alloc_MethodType(4, argcv_meth_errormessages_replaceToken_40__41_leading_40__41_trailing_40__41_with836);
  meth_meth_errormessages_replaceToken_40__41_leading_40__41_trailing_40__41_with836->definitionModule = modulename;
  meth_meth_errormessages_replaceToken_40__41_leading_40__41_trailing_40__41_with836->definitionLine = 120;
// method "replaceToken()with"
  struct UserObject *uo845 = (struct UserObject*)obj518;
  uo845->data[13] = emptyclosure;
  Method *meth_meth_errormessages_replaceToken_40__41_with845 = addmethod2pos(obj518, "replaceToken()with", &meth_errormessages_replaceToken_40__41_with845, 13);
  int argcv_meth_errormessages_replaceToken_40__41_with845[] = {1, 1};
  meth_meth_errormessages_replaceToken_40__41_with845->type = alloc_MethodType(2, argcv_meth_errormessages_replaceToken_40__41_with845);
  meth_meth_errormessages_replaceToken_40__41_with845->definitionModule = modulename;
  meth_meth_errormessages_replaceToken_40__41_with845->definitionLine = 126;
// method "replaceTokenRange()leading()trailing()with"
  struct UserObject *uo850 = (struct UserObject*)obj518;
  uo850->data[14] = emptyclosure;
  Method *meth_meth_errormessages_replaceTokenRange_40__41_leading_40__41_trailing_40__41_with850 = addmethod2pos(obj518, "replaceTokenRange()leading()trailing()with", &meth_errormessages_replaceTokenRange_40__41_leading_40__41_trailing_40__41_with850, 14);
  int argcv_meth_errormessages_replaceTokenRange_40__41_leading_40__41_trailing_40__41_with850[] = {2, 1, 1, 1};
  meth_meth_errormessages_replaceTokenRange_40__41_leading_40__41_trailing_40__41_with850->type = alloc_MethodType(4, argcv_meth_errormessages_replaceTokenRange_40__41_leading_40__41_trailing_40__41_with850);
  meth_meth_errormessages_replaceTokenRange_40__41_leading_40__41_trailing_40__41_with850->definitionModule = modulename;
  meth_meth_errormessages_replaceTokenRange_40__41_leading_40__41_trailing_40__41_with850->definitionLine = 130;
// method "replaceTokenRange()with"
  struct UserObject *uo890 = (struct UserObject*)obj518;
  uo890->data[15] = emptyclosure;
  Method *meth_meth_errormessages_replaceTokenRange_40__41_with890 = addmethod2pos(obj518, "replaceTokenRange()with", &meth_errormessages_replaceTokenRange_40__41_with890, 15);
  int argcv_meth_errormessages_replaceTokenRange_40__41_with890[] = {2, 1};
  meth_meth_errormessages_replaceTokenRange_40__41_with890->type = alloc_MethodType(2, argcv_meth_errormessages_replaceTokenRange_40__41_with890);
  meth_meth_errormessages_replaceTokenRange_40__41_with890->definitionModule = modulename;
  meth_meth_errormessages_replaceTokenRange_40__41_with890->definitionLine = 147;
// method "deleteToken()leading()trailing"
  struct UserObject *uo895 = (struct UserObject*)obj518;
  uo895->data[16] = emptyclosure;
  Method *meth_meth_errormessages_deleteToken_40__41_leading_40__41_trailing895 = addmethod2pos(obj518, "deleteToken()leading()trailing", &meth_errormessages_deleteToken_40__41_leading_40__41_trailing895, 16);
  int argcv_meth_errormessages_deleteToken_40__41_leading_40__41_trailing895[] = {1, 1, 1};
  meth_meth_errormessages_deleteToken_40__41_leading_40__41_trailing895->type = alloc_MethodType(3, argcv_meth_errormessages_deleteToken_40__41_leading_40__41_trailing895);
  meth_meth_errormessages_deleteToken_40__41_leading_40__41_trailing895->definitionModule = modulename;
  meth_meth_errormessages_deleteToken_40__41_leading_40__41_trailing895->definitionLine = 152;
// method "deleteToken"
  struct UserObject *uo904 = (struct UserObject*)obj518;
  uo904->data[17] = emptyclosure;
  Method *meth_meth_errormessages_deleteToken904 = addmethod2pos(obj518, "deleteToken", &meth_errormessages_deleteToken904, 17);
  int argcv_meth_errormessages_deleteToken904[] = {1};
  meth_meth_errormessages_deleteToken904->type = alloc_MethodType(1, argcv_meth_errormessages_deleteToken904);
  meth_meth_errormessages_deleteToken904->definitionModule = modulename;
  meth_meth_errormessages_deleteToken904->definitionLine = 158;
// method "deleteTokenRange()leading()trailing"
  struct UserObject *uo909 = (struct UserObject*)obj518;
  uo909->data[18] = emptyclosure;
  Method *meth_meth_errormessages_deleteTokenRange_40__41_leading_40__41_trailing909 = addmethod2pos(obj518, "deleteTokenRange()leading()trailing", &meth_errormessages_deleteTokenRange_40__41_leading_40__41_trailing909, 18);
  int argcv_meth_errormessages_deleteTokenRange_40__41_leading_40__41_trailing909[] = {2, 1, 1};
  meth_meth_errormessages_deleteTokenRange_40__41_leading_40__41_trailing909->type = alloc_MethodType(3, argcv_meth_errormessages_deleteTokenRange_40__41_leading_40__41_trailing909);
  meth_meth_errormessages_deleteTokenRange_40__41_leading_40__41_trailing909->definitionModule = modulename;
  meth_meth_errormessages_deleteTokenRange_40__41_leading_40__41_trailing909->definitionLine = 163;
// method "deleteTokenRange"
  struct UserObject *uo970 = (struct UserObject*)obj518;
  uo970->data[19] = emptyclosure;
  Method *meth_meth_errormessages_deleteTokenRange970 = addmethod2pos(obj518, "deleteTokenRange", &meth_errormessages_deleteTokenRange970, 19);
  int argcv_meth_errormessages_deleteTokenRange970[] = {2};
  meth_meth_errormessages_deleteTokenRange970->type = alloc_MethodType(1, argcv_meth_errormessages_deleteTokenRange970);
  meth_meth_errormessages_deleteTokenRange970->definitionModule = modulename;
  meth_meth_errormessages_deleteTokenRange970->definitionLine = 188;
// method "deleteLine"
  struct UserObject *uo975 = (struct UserObject*)obj518;
  uo975->data[20] = emptyclosure;
  Method *meth_meth_errormessages_deleteLine975 = addmethod2pos(obj518, "deleteLine", &meth_errormessages_deleteLine975, 20);
  int argcv_meth_errormessages_deleteLine975[] = {1};
  meth_meth_errormessages_deleteLine975->type = alloc_MethodType(1, argcv_meth_errormessages_deleteLine975);
  meth_meth_errormessages_deleteLine975->definitionModule = modulename;
  meth_meth_errormessages_deleteLine975->definitionLine = 192;
// method "insert()afterToken()andTrailingSpace"
  struct UserObject *uo979 = (struct UserObject*)obj518;
  uo979->data[21] = emptyclosure;
  Method *meth_meth_errormessages_insert_40__41_afterToken_40__41_andTrailingSpace979 = addmethod2pos(obj518, "insert()afterToken()andTrailingSpace", &meth_errormessages_insert_40__41_afterToken_40__41_andTrailingSpace979, 21);
  int argcv_meth_errormessages_insert_40__41_afterToken_40__41_andTrailingSpace979[] = {1, 1, 1};
  meth_meth_errormessages_insert_40__41_afterToken_40__41_andTrailingSpace979->type = alloc_MethodType(3, argcv_meth_errormessages_insert_40__41_afterToken_40__41_andTrailingSpace979);
  meth_meth_errormessages_insert_40__41_afterToken_40__41_andTrailingSpace979->definitionModule = modulename;
  meth_meth_errormessages_insert_40__41_afterToken_40__41_andTrailingSpace979->definitionLine = 196;
// method "insert()afterToken"
  struct UserObject *uo990 = (struct UserObject*)obj518;
  uo990->data[22] = emptyclosure;
  Method *meth_meth_errormessages_insert_40__41_afterToken990 = addmethod2pos(obj518, "insert()afterToken", &meth_errormessages_insert_40__41_afterToken990, 22);
  int argcv_meth_errormessages_insert_40__41_afterToken990[] = {1, 1};
  meth_meth_errormessages_insert_40__41_afterToken990->type = alloc_MethodType(2, argcv_meth_errormessages_insert_40__41_afterToken990);
  meth_meth_errormessages_insert_40__41_afterToken990->definitionModule = modulename;
  meth_meth_errormessages_insert_40__41_afterToken990->definitionLine = 201;
// method "insert()beforeToken"
  struct UserObject *uo994 = (struct UserObject*)obj518;
  uo994->data[23] = emptyclosure;
  Method *meth_meth_errormessages_insert_40__41_beforeToken994 = addmethod2pos(obj518, "insert()beforeToken", &meth_errormessages_insert_40__41_beforeToken994, 23);
  int argcv_meth_errormessages_insert_40__41_beforeToken994[] = {1, 1};
  meth_meth_errormessages_insert_40__41_beforeToken994->type = alloc_MethodType(2, argcv_meth_errormessages_insert_40__41_beforeToken994);
  meth_meth_errormessages_insert_40__41_beforeToken994->definitionModule = modulename;
  meth_meth_errormessages_insert_40__41_beforeToken994->definitionLine = 205;
// method "insertNewLine()after"
  struct UserObject *uo1001 = (struct UserObject*)obj518;
  uo1001->data[24] = emptyclosure;
  Method *meth_meth_errormessages_insertNewLine_40__41_after1001 = addmethod2pos(obj518, "insertNewLine()after", &meth_errormessages_insertNewLine_40__41_after1001, 24);
  int argcv_meth_errormessages_insertNewLine_40__41_after1001[] = {1, 1};
  meth_meth_errormessages_insertNewLine_40__41_after1001->type = alloc_MethodType(2, argcv_meth_errormessages_insertNewLine_40__41_after1001);
  meth_meth_errormessages_insertNewLine_40__41_after1001->definitionModule = modulename;
  meth_meth_errormessages_insertNewLine_40__41_after1001->definitionLine = 210;
// method "addLine"
  struct UserObject *uo1004 = (struct UserObject*)obj518;
  uo1004->data[25] = emptyclosure;
  Method *meth_meth_errormessages_addLine1004 = addmethod2pos(obj518, "addLine", &meth_errormessages_addLine1004, 25);
  int argcv_meth_errormessages_addLine1004[] = {2};
  meth_meth_errormessages_addLine1004->type = alloc_MethodType(1, argcv_meth_errormessages_addLine1004);
  meth_meth_errormessages_addLine1004->definitionModule = modulename;
  meth_meth_errormessages_addLine1004->definitionLine = 216;
// method "findLine"
  struct UserObject *uo1104 = (struct UserObject*)obj518;
  uo1104->data[26] = emptyclosure;
  Method *meth_meth_errormessages_findLine1104 = addmethod2pos(obj518, "findLine", &meth_errormessages_findLine1104, 26);
  int argcv_meth_errormessages_findLine1104[] = {1};
  meth_meth_errormessages_findLine1104->type = alloc_MethodType(1, argcv_meth_errormessages_findLine1104);
  meth_meth_errormessages_findLine1104->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_errormessages_findLine1104->definitionModule = modulename;
  meth_meth_errormessages_findLine1104->definitionLine = 240;
// method "getLine"
  block_savedest(obj518);
  Object closure1123 = createclosure(1, "getLine");
  setclosureframe(closure1123, stackframe);
  addtoclosure(closure1123, var_util);
  struct UserObject *uo1123 = (struct UserObject*)obj518;
  uo1123->data[27] = (Object)closure1123;
  Method *meth_meth_errormessages_getLine1123 = addmethod2pos(obj518, "getLine", &meth_errormessages_getLine1123, 27);
  int argcv_meth_errormessages_getLine1123[] = {1};
  meth_meth_errormessages_getLine1123->type = alloc_MethodType(1, argcv_meth_errormessages_getLine1123);
  meth_meth_errormessages_getLine1123->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_errormessages_getLine1123->definitionModule = modulename;
  meth_meth_errormessages_getLine1123->definitionLine = 251;
// method "print"
  block_savedest(obj518);
  Object closure1139 = createclosure(1, "print");
  setclosureframe(closure1139, stackframe);
  addtoclosure(closure1139, var_io);
  struct UserObject *uo1139 = (struct UserObject*)obj518;
  uo1139->data[28] = (Object)closure1139;
  Method *meth_meth_errormessages_print1139 = addmethod2pos(obj518, "print", &meth_errormessages_print1139, 28);
  int argcv_meth_errormessages_print1139[] = {0};
  meth_meth_errormessages_print1139->type = alloc_MethodType(1, argcv_meth_errormessages_print1139);
  meth_meth_errormessages_print1139->definitionModule = modulename;
  meth_meth_errormessages_print1139->definitionLine = 260;
  sourceObject = obj518;
// Begin line 15
  setline(15);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array1292 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1292 (depth = 3)
  adddatum2(obj518, array1292, 1);
  sourceObject = obj518;
// Begin line 16
  setline(16);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile array node (depth = 3)
  Object array1293 = alloc_BuiltinList();
  gc_pause();
  gc_unpause();
// compiled array node returning array1293 (depth = 3)
  adddatum2(obj518, array1293, 2);
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  sourceObject = obj518;
  objclass518 = obj518->class;
  objclass518->definitionModule = modulename;
  objclass518->definitionLine = 14;
  (*(struct UserObject *)self).data[0] = lowerouter518;
  self = oldself518;
  selfslot = oldselfslot518;
  stackframe = oldstackframe518;
  gc_frame_end(frame);
  return obj518;
}
Object meth_errormessages_suggestion1295(Object self, int nparts, int *argcv, Object *args, int32_t flags) {
  struct UserObject *uo = (struct UserObject*)self;
  Object closure = getdatum((Object)uo, 19, (flags>>24)&0xff);
  struct StackFrameObject *stackframe = alloc_StackFrame(1, getclosureframe(closure));
  pushclosure(closure);
  pushstackframe(stackframe, "suggestion");
  int frame = gc_frame_new();
  gc_frame_newslot((Object)stackframe);
  Object methodInheritingObject = NULL;
  Object params[1];
  int partcv[1];
  Object *var_suggestion = getfromclosure(closure, 0);
  int i;
  int curarg = 0;
  int pushcv[] = {1};
  if (nparts < 1 && args)
    graceRaise(RequestError(), "missing argument list for suggestion (probably reflection error): got %i lists, expected 1.", nparts);
  if (argcv && argcv[0] != 0)
    graceRaise(RequestError(), "wrong number of arguments for suggestion");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  if (methodInheritingObject) curarg++;
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile identifier node (depth = 3)
// compiled identifier node returning *var_suggestion (depth = 3)
  gc_frame_end(frame);
  return *var_suggestion;
}
Object module_errormessages_init() {
  int flags = 0;
  int frame = gc_frame_new();
  Object self = alloc_obj2(21, 21);
  self->class->definitionModule = modulename;
  gc_root(self);
  prelude = module_StandardPrelude_init();
  adddatum2(self, prelude, 0);
  addmethod2(self, "outer", &grace_userobj_outer);
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
  setclassname(self, "Module<errormessages>");
  Object *var_MatchFailed = alloc_var();
  *var_MatchFailed = alloc_MatchFailed();
  Object *var_noSuchValue = alloc_var();
  *var_noSuchValue = done;
  Object *var_done = alloc_var();
  *var_done = done;
  Object *var_Object = alloc_var();
  *var_Object = ObjectType;
  type_Object = ObjectType;
  Object *var_String = alloc_var();
  *var_String = String;
  type_String = String;
  Object *var_Block = alloc_var();
  *var_Block = Block;
  type_Block = Block;
  Object *var_Done = alloc_var();
  *var_Done = Done;
  type_Done = Done;
  Object *var_Number = alloc_var();
  *var_Number = Number;
  type_Number = Number;
  Object *var_Boolean = alloc_var();
  *var_Boolean = Boolean;
  type_Boolean = Boolean;
  Object *var_Dynamic = alloc_var();
  *var_Dynamic = Dynamic;
  Object *var_Unknown = alloc_var();
  *var_Unknown= Unknown;
  Object *var_Type = alloc_var();
  *var_Type = Type;
  type_Done = Type;
  Object *var__prelude = alloc_var();
  *var__prelude = grace_prelude();
  Object *var_prelude = alloc_var();
  *var_prelude = prelude;
  gc_root(*var_MatchFailed);
  emptyclosure = createclosure(0, "empty");
  gc_root(emptyclosure);
  struct StackFrameObject *stackframe = alloc_StackFrame(21, NULL);
  gc_root((Object)stackframe);
  pushstackframe(stackframe, "module scope");
  Object *selfslot = &(stackframe->slots[0]);
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
// end of preamble
  Object params[1];
  int partcv[1];
  Object *var_io = alloc_var();
  Object *var_sys = alloc_var();
  Object *var_util = alloc_var();
  Object *var_suggestion = &(stackframe->slots[1]);
  setframeelementname(stackframe, 1, "suggestion");
// Begin line 280
  setline(280);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "name()matches()within"
  struct UserObject *uo1 = (struct UserObject*)self;
  uo1->data[1] = emptyclosure;
  Method *meth_meth_errormessages_name_40__41_matches_40__41_within1 = addmethod2pos(self, "name()matches()within", &meth_errormessages_name_40__41_matches_40__41_within1, 1);
  int argcv_meth_errormessages_name_40__41_matches_40__41_within1[] = {1, 1, 1};
  meth_meth_errormessages_name_40__41_matches_40__41_within1->type = alloc_MethodType(3, argcv_meth_errormessages_name_40__41_matches_40__41_within1);
meth_meth_errormessages_name_40__41_matches_40__41_within1->type->types[0] = type_String;
meth_meth_errormessages_name_40__41_matches_40__41_within1->type->names[0] = "p";
meth_meth_errormessages_name_40__41_matches_40__41_within1->type->types[1] = type_String;
meth_meth_errormessages_name_40__41_matches_40__41_within1->type->names[1] = "t";
meth_meth_errormessages_name_40__41_matches_40__41_within1->type->types[2] = type_Number;
meth_meth_errormessages_name_40__41_matches_40__41_within1->type->names[2] = "k";
  meth_meth_errormessages_name_40__41_matches_40__41_within1->definitionModule = modulename;
  meth_meth_errormessages_name_40__41_matches_40__41_within1->definitionLine = 280;
// compiled method node returning  (depth = 1)
// Begin line 332
  setline(332);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "min3"
  struct UserObject *uo160 = (struct UserObject*)self;
  uo160->data[2] = emptyclosure;
  Method *meth_meth_errormessages_min3160 = addmethod2pos(self, "min3", &meth_errormessages_min3160, 2);
  int argcv_meth_errormessages_min3160[] = {3};
  meth_meth_errormessages_min3160->type = alloc_MethodType(1, argcv_meth_errormessages_min3160);
  meth_meth_errormessages_min3160->flags |= MFLAG_CONFIDENTIAL;
  meth_meth_errormessages_min3160->definitionModule = modulename;
  meth_meth_errormessages_min3160->definitionLine = 332;
// compiled method node returning  (depth = 1)
// Begin line 339
  setline(339);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError()atRange"
  struct UserObject *uo169 = (struct UserObject*)self;
  uo169->data[3] = emptyclosure;
  Method *meth_meth_errormessages_syntaxError_40__41_atRange169 = addmethod2pos(self, "syntaxError()atRange", &meth_errormessages_syntaxError_40__41_atRange169, 3);
  int argcv_meth_errormessages_syntaxError_40__41_atRange169[] = {1, 3};
  meth_meth_errormessages_syntaxError_40__41_atRange169->type = alloc_MethodType(2, argcv_meth_errormessages_syntaxError_40__41_atRange169);
  meth_meth_errormessages_syntaxError_40__41_atRange169->definitionModule = modulename;
  meth_meth_errormessages_syntaxError_40__41_atRange169->definitionLine = 339;
// compiled method node returning  (depth = 1)
// Begin line 343
  setline(343);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError()atRange()withSuggestion"
  struct UserObject *uo173 = (struct UserObject*)self;
  uo173->data[4] = emptyclosure;
  Method *meth_meth_errormessages_syntaxError_40__41_atRange_40__41_withSuggestion173 = addmethod2pos(self, "syntaxError()atRange()withSuggestion", &meth_errormessages_syntaxError_40__41_atRange_40__41_withSuggestion173, 4);
  int argcv_meth_errormessages_syntaxError_40__41_atRange_40__41_withSuggestion173[] = {1, 3, 1};
  meth_meth_errormessages_syntaxError_40__41_atRange_40__41_withSuggestion173->type = alloc_MethodType(3, argcv_meth_errormessages_syntaxError_40__41_atRange_40__41_withSuggestion173);
  meth_meth_errormessages_syntaxError_40__41_atRange_40__41_withSuggestion173->definitionModule = modulename;
  meth_meth_errormessages_syntaxError_40__41_atRange_40__41_withSuggestion173->definitionLine = 343;
// compiled method node returning  (depth = 1)
// Begin line 347
  setline(347);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError()atRange()withSuggestions"
  block_savedest(self);
  Object closure177 = createclosure(1, "syntaxError()atRange()withSuggestions");
  setclosureframe(closure177, stackframe);
  addtoclosure(closure177, var_util);
  struct UserObject *uo177 = (struct UserObject*)self;
  uo177->data[5] = (Object)closure177;
  Method *meth_meth_errormessages_syntaxError_40__41_atRange_40__41_withSuggestions177 = addmethod2pos(self, "syntaxError()atRange()withSuggestions", &meth_errormessages_syntaxError_40__41_atRange_40__41_withSuggestions177, 5);
  int argcv_meth_errormessages_syntaxError_40__41_atRange_40__41_withSuggestions177[] = {1, 3, 1};
  meth_meth_errormessages_syntaxError_40__41_atRange_40__41_withSuggestions177->type = alloc_MethodType(3, argcv_meth_errormessages_syntaxError_40__41_atRange_40__41_withSuggestions177);
  meth_meth_errormessages_syntaxError_40__41_atRange_40__41_withSuggestions177->definitionModule = modulename;
  meth_meth_errormessages_syntaxError_40__41_atRange_40__41_withSuggestions177->definitionLine = 347;
// compiled method node returning  (depth = 1)
// Begin line 359
  setline(359);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "error()atRange()withSuggestions"
  block_savedest(self);
  Object closure245 = createclosure(1, "error()atRange()withSuggestions");
  setclosureframe(closure245, stackframe);
  addtoclosure(closure245, var_util);
  struct UserObject *uo245 = (struct UserObject*)self;
  uo245->data[6] = (Object)closure245;
  Method *meth_meth_errormessages_error_40__41_atRange_40__41_withSuggestions245 = addmethod2pos(self, "error()atRange()withSuggestions", &meth_errormessages_error_40__41_atRange_40__41_withSuggestions245, 6);
  int argcv_meth_errormessages_error_40__41_atRange_40__41_withSuggestions245[] = {1, 3, 1};
  meth_meth_errormessages_error_40__41_atRange_40__41_withSuggestions245->type = alloc_MethodType(3, argcv_meth_errormessages_error_40__41_atRange_40__41_withSuggestions245);
  meth_meth_errormessages_error_40__41_atRange_40__41_withSuggestions245->definitionModule = modulename;
  meth_meth_errormessages_error_40__41_atRange_40__41_withSuggestions245->definitionLine = 359;
// compiled method node returning  (depth = 1)
// Begin line 371
  setline(371);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "error()atRange"
  struct UserObject *uo313 = (struct UserObject*)self;
  uo313->data[7] = emptyclosure;
  Method *meth_meth_errormessages_error_40__41_atRange313 = addmethod2pos(self, "error()atRange", &meth_errormessages_error_40__41_atRange313, 7);
  int argcv_meth_errormessages_error_40__41_atRange313[] = {1, 3};
  meth_meth_errormessages_error_40__41_atRange313->type = alloc_MethodType(2, argcv_meth_errormessages_error_40__41_atRange313);
  meth_meth_errormessages_error_40__41_atRange313->definitionModule = modulename;
  meth_meth_errormessages_error_40__41_atRange313->definitionLine = 371;
// compiled method node returning  (depth = 1)
// Begin line 375
  setline(375);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError()atPosition"
  struct UserObject *uo317 = (struct UserObject*)self;
  uo317->data[8] = emptyclosure;
  Method *meth_meth_errormessages_syntaxError_40__41_atPosition317 = addmethod2pos(self, "syntaxError()atPosition", &meth_errormessages_syntaxError_40__41_atPosition317, 8);
  int argcv_meth_errormessages_syntaxError_40__41_atPosition317[] = {1, 2};
  meth_meth_errormessages_syntaxError_40__41_atPosition317->type = alloc_MethodType(2, argcv_meth_errormessages_syntaxError_40__41_atPosition317);
  meth_meth_errormessages_syntaxError_40__41_atPosition317->definitionModule = modulename;
  meth_meth_errormessages_syntaxError_40__41_atPosition317->definitionLine = 375;
// compiled method node returning  (depth = 1)
// Begin line 379
  setline(379);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "error()atPosition"
  struct UserObject *uo321 = (struct UserObject*)self;
  uo321->data[9] = emptyclosure;
  Method *meth_meth_errormessages_error_40__41_atPosition321 = addmethod2pos(self, "error()atPosition", &meth_errormessages_error_40__41_atPosition321, 9);
  int argcv_meth_errormessages_error_40__41_atPosition321[] = {1, 2};
  meth_meth_errormessages_error_40__41_atPosition321->type = alloc_MethodType(2, argcv_meth_errormessages_error_40__41_atPosition321);
  meth_meth_errormessages_error_40__41_atPosition321->definitionModule = modulename;
  meth_meth_errormessages_error_40__41_atPosition321->definitionLine = 379;
// compiled method node returning  (depth = 1)
// Begin line 383
  setline(383);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError()atPosition()withSuggestion"
  struct UserObject *uo325 = (struct UserObject*)self;
  uo325->data[10] = emptyclosure;
  Method *meth_meth_errormessages_syntaxError_40__41_atPosition_40__41_withSuggestion325 = addmethod2pos(self, "syntaxError()atPosition()withSuggestion", &meth_errormessages_syntaxError_40__41_atPosition_40__41_withSuggestion325, 10);
  int argcv_meth_errormessages_syntaxError_40__41_atPosition_40__41_withSuggestion325[] = {1, 2, 1};
  meth_meth_errormessages_syntaxError_40__41_atPosition_40__41_withSuggestion325->type = alloc_MethodType(3, argcv_meth_errormessages_syntaxError_40__41_atPosition_40__41_withSuggestion325);
  meth_meth_errormessages_syntaxError_40__41_atPosition_40__41_withSuggestion325->definitionModule = modulename;
  meth_meth_errormessages_syntaxError_40__41_atPosition_40__41_withSuggestion325->definitionLine = 383;
// compiled method node returning  (depth = 1)
// Begin line 387
  setline(387);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError()atPosition()withSuggestions"
  block_savedest(self);
  Object closure329 = createclosure(1, "syntaxError()atPosition()withSuggestions");
  setclosureframe(closure329, stackframe);
  addtoclosure(closure329, var_util);
  struct UserObject *uo329 = (struct UserObject*)self;
  uo329->data[11] = (Object)closure329;
  Method *meth_meth_errormessages_syntaxError_40__41_atPosition_40__41_withSuggestions329 = addmethod2pos(self, "syntaxError()atPosition()withSuggestions", &meth_errormessages_syntaxError_40__41_atPosition_40__41_withSuggestions329, 11);
  int argcv_meth_errormessages_syntaxError_40__41_atPosition_40__41_withSuggestions329[] = {1, 2, 1};
  meth_meth_errormessages_syntaxError_40__41_atPosition_40__41_withSuggestions329->type = alloc_MethodType(3, argcv_meth_errormessages_syntaxError_40__41_atPosition_40__41_withSuggestions329);
  meth_meth_errormessages_syntaxError_40__41_atPosition_40__41_withSuggestions329->definitionModule = modulename;
  meth_meth_errormessages_syntaxError_40__41_atPosition_40__41_withSuggestions329->definitionLine = 387;
// compiled method node returning  (depth = 1)
// Begin line 396
  setline(396);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "error()atPosition()withSuggestions"
  block_savedest(self);
  Object closure368 = createclosure(1, "error()atPosition()withSuggestions");
  setclosureframe(closure368, stackframe);
  addtoclosure(closure368, var_util);
  struct UserObject *uo368 = (struct UserObject*)self;
  uo368->data[12] = (Object)closure368;
  Method *meth_meth_errormessages_error_40__41_atPosition_40__41_withSuggestions368 = addmethod2pos(self, "error()atPosition()withSuggestions", &meth_errormessages_error_40__41_atPosition_40__41_withSuggestions368, 12);
  int argcv_meth_errormessages_error_40__41_atPosition_40__41_withSuggestions368[] = {1, 2, 1};
  meth_meth_errormessages_error_40__41_atPosition_40__41_withSuggestions368->type = alloc_MethodType(3, argcv_meth_errormessages_error_40__41_atPosition_40__41_withSuggestions368);
  meth_meth_errormessages_error_40__41_atPosition_40__41_withSuggestions368->definitionModule = modulename;
  meth_meth_errormessages_error_40__41_atPosition_40__41_withSuggestions368->definitionLine = 396;
// compiled method node returning  (depth = 1)
// Begin line 406
  setline(406);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "error"
  block_savedest(self);
  Object closure407 = createclosure(1, "error");
  setclosureframe(closure407, stackframe);
  addtoclosure(closure407, var_util);
  struct UserObject *uo407 = (struct UserObject*)self;
  uo407->data[13] = (Object)closure407;
  Method *meth_meth_errormessages_error407 = addmethod2pos(self, "error", &meth_errormessages_error407, 13);
  int argcv_meth_errormessages_error407[] = {1};
  meth_meth_errormessages_error407->type = alloc_MethodType(1, argcv_meth_errormessages_error407);
  meth_meth_errormessages_error407->definitionModule = modulename;
  meth_meth_errormessages_error407->definitionLine = 406;
// compiled method node returning  (depth = 1)
// Begin line 410
  setline(410);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "error()atLine()withSuggestions"
  block_savedest(self);
  Object closure415 = createclosure(1, "error()atLine()withSuggestions");
  setclosureframe(closure415, stackframe);
  addtoclosure(closure415, var_util);
  struct UserObject *uo415 = (struct UserObject*)self;
  uo415->data[14] = (Object)closure415;
  Method *meth_meth_errormessages_error_40__41_atLine_40__41_withSuggestions415 = addmethod2pos(self, "error()atLine()withSuggestions", &meth_errormessages_error_40__41_atLine_40__41_withSuggestions415, 14);
  int argcv_meth_errormessages_error_40__41_atLine_40__41_withSuggestions415[] = {1, 1, 1};
  meth_meth_errormessages_error_40__41_atLine_40__41_withSuggestions415->type = alloc_MethodType(3, argcv_meth_errormessages_error_40__41_atLine_40__41_withSuggestions415);
  meth_meth_errormessages_error_40__41_atLine_40__41_withSuggestions415->definitionModule = modulename;
  meth_meth_errormessages_error_40__41_atLine_40__41_withSuggestions415->definitionLine = 410;
// compiled method node returning  (depth = 1)
// Begin line 421
  setline(421);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "error()atLine"
  struct UserObject *uo459 = (struct UserObject*)self;
  uo459->data[15] = emptyclosure;
  Method *meth_meth_errormessages_error_40__41_atLine459 = addmethod2pos(self, "error()atLine", &meth_errormessages_error_40__41_atLine459, 15);
  int argcv_meth_errormessages_error_40__41_atLine459[] = {1, 1};
  meth_meth_errormessages_error_40__41_atLine459->type = alloc_MethodType(2, argcv_meth_errormessages_error_40__41_atLine459);
  meth_meth_errormessages_error_40__41_atLine459->definitionModule = modulename;
  meth_meth_errormessages_error_40__41_atLine459->definitionLine = 421;
// compiled method node returning  (depth = 1)
// Begin line 425
  setline(425);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError()atLine"
  struct UserObject *uo463 = (struct UserObject*)self;
  uo463->data[16] = emptyclosure;
  Method *meth_meth_errormessages_syntaxError_40__41_atLine463 = addmethod2pos(self, "syntaxError()atLine", &meth_errormessages_syntaxError_40__41_atLine463, 16);
  int argcv_meth_errormessages_syntaxError_40__41_atLine463[] = {1, 1};
  meth_meth_errormessages_syntaxError_40__41_atLine463->type = alloc_MethodType(2, argcv_meth_errormessages_syntaxError_40__41_atLine463);
  meth_meth_errormessages_syntaxError_40__41_atLine463->definitionModule = modulename;
  meth_meth_errormessages_syntaxError_40__41_atLine463->definitionLine = 425;
// compiled method node returning  (depth = 1)
// Begin line 429
  setline(429);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError()atLine()withSuggestion"
  struct UserObject *uo467 = (struct UserObject*)self;
  uo467->data[17] = emptyclosure;
  Method *meth_meth_errormessages_syntaxError_40__41_atLine_40__41_withSuggestion467 = addmethod2pos(self, "syntaxError()atLine()withSuggestion", &meth_errormessages_syntaxError_40__41_atLine_40__41_withSuggestion467, 17);
  int argcv_meth_errormessages_syntaxError_40__41_atLine_40__41_withSuggestion467[] = {1, 1, 1};
  meth_meth_errormessages_syntaxError_40__41_atLine_40__41_withSuggestion467->type = alloc_MethodType(3, argcv_meth_errormessages_syntaxError_40__41_atLine_40__41_withSuggestion467);
  meth_meth_errormessages_syntaxError_40__41_atLine_40__41_withSuggestion467->definitionModule = modulename;
  meth_meth_errormessages_syntaxError_40__41_atLine_40__41_withSuggestion467->definitionLine = 429;
// compiled method node returning  (depth = 1)
// Begin line 433
  setline(433);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 1)
// method "syntaxError()atLine()withSuggestions"
  block_savedest(self);
  Object closure471 = createclosure(1, "syntaxError()atLine()withSuggestions");
  setclosureframe(closure471, stackframe);
  addtoclosure(closure471, var_util);
  struct UserObject *uo471 = (struct UserObject*)self;
  uo471->data[18] = (Object)closure471;
  Method *meth_meth_errormessages_syntaxError_40__41_atLine_40__41_withSuggestions471 = addmethod2pos(self, "syntaxError()atLine()withSuggestions", &meth_errormessages_syntaxError_40__41_atLine_40__41_withSuggestions471, 18);
  int argcv_meth_errormessages_syntaxError_40__41_atLine_40__41_withSuggestions471[] = {1, 1, 1};
  meth_meth_errormessages_syntaxError_40__41_atLine_40__41_withSuggestions471->type = alloc_MethodType(3, argcv_meth_errormessages_syntaxError_40__41_atLine_40__41_withSuggestions471);
  meth_meth_errormessages_syntaxError_40__41_atLine_40__41_withSuggestions471->definitionModule = modulename;
  meth_meth_errormessages_syntaxError_40__41_atLine_40__41_withSuggestions471->definitionLine = 433;
// compiled method node returning  (depth = 1)
// Begin line 2
  setline(2);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of io as io
  if (module_io == NULL)
    module_io = module_io_init();
  *var_io = module_io;
// compiled import node returning done (depth = 1)
// Begin line 3
  setline(3);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of sys as sys
  if (module_sys == NULL)
    module_sys = module_sys_init();
  *var_sys = module_sys;
// compiled import node returning done (depth = 1)
// Begin line 4
  setline(4);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile import node (depth = 1)
// Import of util as util
  if (module_util == NULL)
    module_util = LOAD_MODULE(util);
  *var_util = module_util;
// compiled import node returning done (depth = 1)
// Begin line 1
  setline(1);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 5
  setline(5);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 13
  setline(13);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile defdec node (depth = 1)
// starting to compile object node (depth = 2)
  Object inheritingObject515 = inheritingObject;
  if (isTailObject) {
    isTailObject = 0;
    inheritingObject = NULL;
  }
  Object obj515 = alloc_userobj2(2,4, objclass515);
  gc_frame_newslot(obj515);
if (objclass515 == NULL) {
  glfree(obj515->class->name);
  obj515->class->name = "suggestion";
}
// OBJECT OUTER DEC outer
  adddatum2(obj515, self, 0);
  addmethodreal(obj515,"outer", &reader_errormessages_outer_516);
  Object oldself515 = self;
  struct StackFrameObject *oldstackframe515 = stackframe;
  stackframe = alloc_StackFrame(1, oldstackframe515);
  gc_frame_newslot((Object)stackframe);
  self = obj515;
  Object *oldselfslot515 = selfslot;
  selfslot = &stackframe->slots[0];
  *selfslot = self;
  setframeelementname(stackframe, 0, "self");
  Object thisouter515 = (*(struct UserObject *)self).data[0], lowerouter515 = thisouter515;
  if (inheritingObject515) {
    struct UserObject *inho515 = (struct UserObject *)inheritingObject515;
    while (inho515->super != GraceDefaultObject) inho515 = (struct UserObject *)inho515->super;
    inho515->super = obj515;
    self = inheritingObject515;
    *selfslot = self;
    lowerouter515 = (*(struct UserObject *)self).data[0];
    (*(struct UserObject *)self).data[0] = thisouter515;
  }
// method "new"
  block_savedest(obj515);
  Object closure517 = createclosure(2, "new");
  setclosureframe(closure517, stackframe);
  addtoclosure(closure517, var_util);
  addtoclosure(closure517, var_io);
  struct UserObject *uo517 = (struct UserObject*)obj515;
  uo517->data[1] = (Object)closure517;
  Method *meth_meth_errormessages_new517 = addmethod2pos(obj515, "new", &meth_errormessages_new517, 1);
  int argcv_meth_errormessages_new517[] = {0};
  meth_meth_errormessages_new517->type = alloc_MethodType(1, argcv_meth_errormessages_new517);
  meth_meth_errormessages_new517->definitionModule = modulename;
  meth_meth_errormessages_new517->definitionLine = 14;
  block_savedest(obj515);
  Object closure1294 = createclosure(2, "new()object");
  setclosureframe(closure1294, stackframe);
  addtoclosure(closure1294, var_util);
  addtoclosure(closure1294, var_io);
  Method *meth_meth_errormessages_new517_object = addmethod2pos(obj515, "new()object", &meth_errormessages_new517_object, 1);
  meth_meth_errormessages_new517_object->definitionModule = modulename;
  meth_meth_errormessages_new517_object->definitionLine = 14;
  sourceObject = obj515;
  objclass515 = obj515->class;
  objclass515->definitionModule = modulename;
  objclass515->definitionLine = 13;
  (*(struct UserObject *)self).data[0] = lowerouter515;
  self = oldself515;
  selfslot = oldselfslot515;
  stackframe = oldstackframe515;
// compiled object node returning obj515 (depth = 2)
  *var_suggestion = obj515;
  if (obj515 == undefined)
    callmethod(done, "assignment", 0, NULL, NULL);
// Begin line 273
  setline(273);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile method node (depth = 2)
// method "suggestion"
  block_savedest(self);
  Object closure1295 = createclosure(1, "suggestion");
  setclosureframe(closure1295, stackframe);
  addtoclosure(closure1295, var_suggestion);
  struct UserObject *uo1295 = (struct UserObject*)self;
  uo1295->data[19] = (Object)closure1295;
  Method *meth_meth_errormessages_suggestion1295 = addmethod2pos(self, "suggestion", &meth_errormessages_suggestion1295, 19);
  int argcv_meth_errormessages_suggestion1295[] = {0};
  meth_meth_errormessages_suggestion1295->type = alloc_MethodType(1, argcv_meth_errormessages_suggestion1295);
  meth_meth_errormessages_suggestion1295->definitionModule = modulename;
  meth_meth_errormessages_suggestion1295->definitionLine = 273;
// compiled method node returning  (depth = 2)
// compiled defdec node returning done (depth = 1)
// Begin line 279
  setline(279);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 331
  setline(331);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 337
  setline(337);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 342
  setline(342);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 346
  setline(346);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 358
  setline(358);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 370
  setline(370);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 374
  setline(374);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 378
  setline(378);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 382
  setline(382);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 386
  setline(386);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 395
  setline(395);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 405
  setline(405);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 409
  setline(409);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 420
  setline(420);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 424
  setline(424);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 428
  setline(428);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
// Begin line 432
  setline(432);
  setmodule(modulename);
  setsource(originalSourceLines);
// starting to compile blank node (depth = 1)
// compiled blank node returning  (depth = 1)
  gc_frame_end(frame);
  return self;
}
